SystemOrganization addCategory: #'Zenna-Animation3D'!
SystemOrganization addCategory: #'Zenna-Appearance3D'!
SystemOrganization addCategory: #'Zenna-Collections3D'!
SystemOrganization addCategory: #'Zenna-Core2D'!
SystemOrganization addCategory: #'Zenna-Dominos'!
SystemOrganization addCategory: #'Zenna-Extensions'!
SystemOrganization addCategory: #'Zenna-FileIO'!
SystemOrganization addCategory: #'Zenna-FormatDirectX'!
SystemOrganization addCategory: #'Zenna-FormatM3D'!
SystemOrganization addCategory: #'Zenna-FormatMaxScript'!
SystemOrganization addCategory: #'Zenna-FormatPOVRay'!
SystemOrganization addCategory: #'Zenna-FormatSVG'!
SystemOrganization addCategory: #'Zenna-FormatThreeJS'!
SystemOrganization addCategory: #'Zenna-FormatVRML'!
SystemOrganization addCategory: #'Zenna-Lindenmayer'!
SystemOrganization addCategory: #'Zenna-Modelling2D'!
SystemOrganization addCategory: #'Zenna-Modelling3D'!
SystemOrganization addCategory: #'Zenna-Operators3D'!
SystemOrganization addCategory: #'Zenna-OperatorsCSG'!
SystemOrganization addCategory: #'Zenna-Primitives3D'!
SystemOrganization addCategory: #'Zenna-SceneBuilding2D'!
SystemOrganization addCategory: #'Zenna-SceneBuilding3D'!
SystemOrganization addCategory: #'Zenna-ShapeGallery'!
SystemOrganization addCategory: #'Zenna-Shapes3D'!
SystemOrganization addCategory: #'Zenna-Structures3D'!
SystemOrganization addCategory: #'Zenna-TaggedData'!
SystemOrganization addCategory: #'Zenna-Tests'!
SystemOrganization addCategory: #'Zenna-Wrappers3D'!

!Rectangle class methodsFor: '*Zenna-TaggedData' stamp: 'emm 27/11/2002 16:14'!
readFromTagValueString: aString
	"Format:   left, top, right, bottom"
	
	"self readFromTagValueString: ' 1 2 3 4 '
	"
	
	| inStream  left top right bottom|
	inStream := ReadStream on:aString trimBlanks.
	left := Number readFromTagValueString:(inStream upTo: $ ).
	top := Number readFromTagValueString:(inStream upTo: $ ).
	right := Number readFromTagValueString:(inStream upTo: $ ).
	bottom := Number readFromTagValueString: inStream upToEnd .			
	^self left: left right: right top: top bottom: bottom! !

!Rectangle methodsFor: '*Zenna-Extensions' stamp: 'emm 10/18/2012 16:28'!
areaIncludesPoint: aPoint 
	^self containsPoint: aPoint! !

!Rectangle methodsFor: '*Zenna-Collections3D' stamp: 'emm 02/09/2012 23:43'!
asPolygon3D

	^Polygon3D fromRectangle: self! !

!Rectangle methodsFor: '*Zenna-Core2D' stamp: 'emm 02/09/2012 22:51'!
asPolyline
	"Answer an approximation of the receiver as a Polyline."

	^Polyline2D vertices: self vertices! !

!Rectangle methodsFor: '*Zenna-Core2D' stamp: 'emm 02/09/2012 22:51'!
asSegments
	"Answer a collection of line segments"
	
	^Array 
		with: (LineSegment2D from: self topLeft to: self topRight)
		with: (LineSegment2D from: self topRight to: self bottomRight)
		with: (LineSegment2D from: self bottomLeft to: self bottomRight)
		with: (LineSegment2D from: self topLeft to: self bottomLeft)		! !

!Rectangle methodsFor: '*Zenna-Core2D' stamp: 'emm 02/09/2012 22:51'!
encompass: aPoint 
	"Answer a Rectangle that contains both the receiver and aPoint.  5/30/96 sw"

	^ Rectangle 
		origin: (self origin min: aPoint)
		corner: (self corner max:  aPoint)! !

!Rectangle methodsFor: '*Zenna-Extensions' stamp: 'emm 9/23/2012 22:43'!
includesPoint: aPoint 

	^aPoint >= self origin
		and: [ aPoint <= self corner ]! !

!Rectangle methodsFor: '*Zenna-TaggedData' stamp: 'emm 10/03/2003 12:44'!
printTaggedWith: aWriter
	"Space separated numbers"
	
	self left printOn: aWriter stream.
	self top printOn: aWriter stream space.
	self right printOn: aWriter stream space.	
	self bottom printOn: aWriter stream space.	! !

!Rectangle methodsFor: '*Zenna-Core2D' stamp: 'emm 02/09/2012 22:51'!
vertices
	^Array with: self leftTop with: self rightTop with: self rightBottom with: self leftBottom! !

Rectangle subclass: #RoundedRectangle2D
	instanceVariableNames: 'xRadius yRadius'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Core2D'!

!RoundedRectangle2D methodsFor: 'overrides' stamp: 'emm 9/23/2012 22:42'!
expandBy: delta
	| rect  roundedrect|
	rect := super expandBy: delta.
	roundedrect := self copy.
	roundedrect setOrigin: rect origin corner: rect corner.
	^roundedrect! !

!RoundedRectangle2D methodsFor: 'overrides' stamp: 'emm 02/09/2012 22:51'!
insetBy: delta
	| rect  roundedrect|
	rect := super insetBy: delta.
	roundedrect := self copy.
	roundedrect origin: rect origin.
	roundedrect corner: rect corner.
	^roundedrect! !

!RoundedRectangle2D methodsFor: 'dispatching' stamp: 'emm 02/09/2012 22:51'!
kindDo: aRequestor
	^aRequestor doRoundedRectangle2D: self! !

!RoundedRectangle2D methodsFor: 'accessing' stamp: 'emm 02/09/2012 22:51'!
radius: aNumberOrPoint
	self xRadius: aNumberOrPoint asPoint x.
	self yRadius: aNumberOrPoint asPoint y.	
	! !

!RoundedRectangle2D methodsFor: 'accessing' stamp: 'emm 02/09/2012 22:51'!
xRadius
	^xRadius ifNil:[0]! !

!RoundedRectangle2D methodsFor: 'accessing' stamp: 'emm 02/09/2012 22:51'!
xRadius: anObject
	xRadius := anObject! !

!RoundedRectangle2D methodsFor: 'accessing' stamp: 'emm 02/09/2012 22:51'!
yRadius
	^yRadius ifNil:[0]! !

!RoundedRectangle2D methodsFor: 'accessing' stamp: 'emm 02/09/2012 22:51'!
yRadius: anObject
	yRadius := anObject! !

!OrderedCollection methodsFor: '*Zenna-Extensions' stamp: 'emm 9/22/2012 22:42'!
add: obj1 add: obj2 add: obj3
	"This message has been added for Zenna"

	^self add: obj1 ;add: obj2  ;add: obj3 ! !

!OrderedCollection methodsFor: '*Zenna-Extensions' stamp: 'emm 9/23/2012 00:13'!
addNext: howMany from: otherCollection startingAt: index 
	"This message has been added for Zenna"

	index to: index + howMany -1 do:[ :i | self add: (otherCollection at: i)]! !

!OrderedCollection methodsFor: '*Zenna-Extensions' stamp: 'emm 9/22/2012 22:00'!
noCheckAt: anInteger 
	"Answer the element at index anInteger. at: is used by a knowledgeable client 
	to access an existing element"
	"This message has been added for Zenna"
	
	^array at: firstIndex + anInteger - 1! !

!OrderedCollection methodsFor: '*Zenna-Extensions' stamp: 'emm 9/22/2012 22:00'!
noCheckAt: anInteger put: anObject
	"This message has been added for Zenna"
	
	^array at: firstIndex + anInteger - 1 put: anObject! !

!OrderedCollection methodsFor: '*Zenna-Extensions' stamp: 'emm 10/18/2012 16:29'!
removeAtIndex: aSmallInteger
	"VA compat"
	^self removeAt:aSmallInteger! !

!Interval methodsFor: '*Zenna-Core2D' stamp: 'emm 02/09/2012 22:51'!
includesInterval: anInterval
	
	"Answer whether all elements of @anInterval are included in the receiver"

	^( self increment = anInterval increment
		or:[ self size = 1 and:[ anInterval size = 1] ] )
			and:[ self first <= anInterval first
					and:[ self last >= anInterval last ] ]! !

!Interval methodsFor: '*Zenna-Core2D' stamp: 'emm 02/09/2012 22:51'!
quadrantIndices

	"Answer with a collection of quadrant indices (2D) which are completely visited by the receiver.
	Pre: Element are in degrees"

	| indices start offset stop testInterval |
	indices := OrderedCollection new.
	start := self first.	
	offset := 0.
	[ ( start + offset ) < 0 ] whileTrue:[ offset := offset + 360 ].
	testInterval := start + offset to: self last + offset.

	( testInterval includesInterval: ( offset to: offset + 90 ) )
		ifTrue: [ indices add: 1 ].
	( testInterval includesInterval: ( offset + 90 to: offset + 180 ) )
		ifTrue: [ indices add: 2 ].
	( testInterval includesInterval: ( offset + 180 to: offset + 270 ) )
		ifTrue: [ indices add: 3 ].
	( testInterval includesInterval: ( offset + 270 to: offset + 360 ) )
		ifTrue: [ indices add: 4 ].
	
	^indices
! !

!Integer class methodsFor: '*Zenna-TaggedData' stamp: 'emm 11/10/2003 23:51'!
readFromTagValueString: aString
	aString isEmpty ifTrue: [ ^0 ].
	^(Integer newFromString: aString trimBlanks) asInteger! !

!String class methodsFor: '*Zenna-TaggedData' stamp: 'emm 29/09/2003 14:02'!
readFromTagValueString: aString
	^aString! !

!String methodsFor: '*Zenna-Primitives3D' stamp: 'emm 02/09/2012 23:36'!
asText3D

	^Text3D fromString: self! !

!String methodsFor: '*Zenna-Modelling3D' stamp: 'emm 02/09/2012 23:50'!
asVariable
	^Variable named: self! !

!Date class methodsFor: '*Zenna-TaggedData' stamp: 'emm 17/08/2003 13:31'!
readFromTagValueString: aString
	"Format:  yyyy-mm-dd"
	
	| in  y m d|
	in := aString readStream.
	y := Integer readFromTagValueString: (in upTo: $-).
	m := Integer readFromTagValueString: (in upTo: $-).	
	d := Integer readFromTagValueString: in upToEnd.
	^self newDay: d monthIndex: m year: y! !

!Date methodsFor: '*Zenna-TaggedData' stamp: 'emm 17/08/2003 13:33'!
printTaggedWith: aWriter

	self year printOn: aWriter stream.
	aWriter stream nextPut: $-.
	self monthIndex printOn: aWriter stream.
	aWriter stream nextPut: $-.
	self dayOfMonth printOn: aWriter stream.	! !

SharedPool subclass: #Math3DConstants
	instanceVariableNames: ''
	classVariableNames: 'Epsilon HalfPi Pi Sqrt2 Sqrt3 Sqrt6 ThirdPi TwoPi'
	poolDictionaries: ''
	category: 'Zenna-Structures3D'!

!Math3DConstants class methodsFor: 'as yet unclassified' stamp: 'emm 10/2/2012 21:23'!
initializeAfterLoad
	HalfPi := Float pi / 2.
	TwoPi := Float pi * 2.
	Sqrt3 := 3 sqrt.
	Sqrt2 := 2 sqrt.
	Sqrt6 := 6 sqrt.
	Epsilon := 1.0e-8.
	Pi := Float pi.
	ThirdPi := Float pi / 3! !

!SequenceableCollection methodsFor: '*Zenna-Extensions' stamp: 'emm 02/09/2012 23:29'!
computeAtFraction: fraction

	"fraction = [0..1]"

	| indexEstimate lowIndex highIndex lowFraction lowValue highValue highFraction |
	indexEstimate := 1 + ( self size - 1 * fraction).
	lowIndex := indexEstimate truncated.
	highIndex := indexEstimate ceiling.
	lowIndex = highIndex
		ifTrue: [ ^self at: lowIndex ].
	lowFraction := lowIndex - 1 / ( self size - 1).
	highFraction := highIndex - 1 / ( self size - 1).
	lowValue := self at: lowIndex.
	highValue := self at: highIndex.
	^(fraction - lowFraction) * (highValue - lowValue) / (highFraction - lowFraction) + lowValue! !

!SequenceableCollection methodsFor: '*Zenna-Extensions' stamp: 'emm 9/22/2012 22:05'!
isSequenceable
	^true! !

!Collection methodsFor: '*Zenna-SceneBuilding2D' stamp: 'emm 02/09/2012 23:02'!
addTo: aContainer

	^ aContainer addAll: self! !

!Collection methodsFor: '*Zenna-Collections3D' stamp: 'emm 02/09/2012 23:20'!
addX: x y: y z: z 

	^self add: (Point3D
			x: x
			y: y
			z: z)! !

!Collection methodsFor: '*Zenna-Collections3D' stamp: 'emm 02/09/2012 23:20'!
asPoint3DCollection

	^OrderedPoint3DCollection withAll: self! !

!Collection methodsFor: '*Zenna-Collections3D' stamp: 'emm 02/09/2012 23:20'!
decomposedSolidsDo: aBlock
	
	"Let the receiver act as a CompositeGeometric3D"

	self do:[ :each | each decomposedSolidsDo: aBlock ]! !

!Collection methodsFor: '*Zenna-Collections3D' stamp: 'emm 02/09/2012 23:20'!
facesDo: aBlock
	
	"Let the receiver act as a CompositeGeometric3D"

	self do:[ :each | 
		each decomposedSolidsDo: [ :other |
			other facesDo: aBlock ] ]! !

!Collection methodsFor: '*Zenna-Collections3D' stamp: 'emm 02/09/2012 23:20'!
segmentsDo: aBlock
	
	"Let the receiver act as a CompositeGeometric3D"

	self do:[ :each | 
		each decomposedSolidsDo: [ :other |
			other segmentsDo: aBlock ] ]! !

!Collection methodsFor: '*Zenna-Collections3D' stamp: 'emm 02/09/2012 23:20'!
solidsDo: aBlock
	
	"Let the receiver act as a CompositeGeometric3D"

	self do:[ :each | each decomposedSolidsDo: aBlock ]! !

!Collection methodsFor: '*Zenna-Collections3D' stamp: 'emm 02/09/2012 23:20'!
verticesDo: aBlock
	
	"Let the receiver act as a CompositeGeometric3D"

	self do:[ :each | 
		each decomposedSolidsDo: [ :other |
			other verticesDo: aBlock ] ]! !

ProtoObject subclass: #Core2D
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Core2D'!

ProtoObject subclass: #ShapeGallery
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-ShapeGallery'!

ProtoObject subclass: #Wrappers3D
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Wrappers3D'!

!Random class methodsFor: '*Zenna-Extensions' stamp: 'emm 10/18/2012 19:17'!
between: aFloat and: aFloat2 
	^TransformedRandom new block: [ :r | r * (aFloat2 - aFloat) + aFloat ] ;random: self new! !

!PositionableStream methodsFor: '*Zenna-Extensions' stamp: 'emm 9/23/2012 22:35'!
skipToAll: aSequentialCollection

	"Advance the receiver position beyond the next occurrence
	 of the elements of aSequentialCollection or if none,
	 to the end of stream.  Answer true if the elements of aSequentialCollection
	 occurred, else answer false."

	| index collectionSize originalPos size first |

	(collectionSize := aSequentialCollection size) = 0 ifTrue: [^true].

	collectionSize > ((size := self size) - position) ifTrue: [
		" no need for comparing if the actual number of "
		" characters in aSequentialCollection is greater "
		position := size.
		^false].

	first := aSequentialCollection at: 1.
	[self skipTo: first] whileTrue: [
		index := 1.
		originalPos := position.
		[
			(index := index + 1) > collectionSize ifTrue: [^true].
			position >= size ifTrue: [^false].
			position := position + 1.
			(collection at: position) = (aSequentialCollection at: index)]
		whileTrue: [].
		collectionSize > (size - originalPos) ifTrue: [
			position := size.
			^ false]
		ifFalse: [position := originalPos].
	].
	^ false
! !

!Fraction methodsFor: '*Zenna-TaggedData' stamp: 'emm 24/11/2003 12:13'!
printTaggedWith: aWriter
	self asFloat printOn: aWriter stream! !

!Number class methodsFor: '*Zenna-Extensions' stamp: 'emm 9/23/2012 22:36'!
fromString: aString
	^aString asNumber! !

!Number class methodsFor: '*Zenna-TaggedData' stamp: 'emm 31/08/2003 09:36'!
readFromTagValueString: aString

	^Number newFromString: aString trimBlanks! !

!Number methodsFor: '*Zenna-Structures3D' stamp: 'emm 02/09/2012 23:11'!
, aNumber 

	^Point x: self y: aNumber! !

!Number methodsFor: '*Zenna-Extensions' stamp: 'emm 9/28/2012 00:07'!
,- aSmallInteger 
	^Point x: self y: aSmallInteger negated ! !

!Number methodsFor: '*Zenna-Structures3D' stamp: 'emm 02/09/2012 23:11'!
asPoint3D

	^Point3D
		x: self
		y: self
		z: self! !

!Number methodsFor: '*Zenna-Extensions' stamp: 'emm 9/23/2012 22:09'!
deg
	^self radiansToDegrees ! !

!Number methodsFor: '*Zenna-Structures3D' stamp: 'emm 02/09/2012 23:11'!
productFromPoint3D: aPoint3D 

	^aPoint3D scaledBy: self! !

!Number methodsFor: '*Zenna-Structures3D' stamp: 'emm 02/09/2012 23:11'!
quadrantIndex

	"The receiver is an angle (in degrees!!) for a 2D-coordinate system.
	Answer the index of the quadrant in which the point ( 1, 0 )
	can be found after rotating that point towards positive y
	using the receiver"

	| reduced |
	reduced := self \\ 360.
	reduced < 90
		ifTrue: [ ^1 ].
	reduced < 180
		ifTrue: [ ^2 ].
	reduced < 270
		ifTrue: [ ^3 ].
	^4
	


	! !

!Number methodsFor: '*Zenna-Extensions' stamp: 'emm 9/22/2012 22:24'!
rad
	^self degreesToRadians! !

!Number methodsFor: '*Zenna-TaggedData' stamp: 'emm 24/10/2002 14:06'!
tagValueReaderClass
	"Answer the class that can read the string representation of the receiver
	using the method MyClass class>>readFromTagValueString: "
	
	^Number! !

!Number methodsFor: '*Zenna-Extensions' stamp: 'emm 9/28/2012 00:10'!
to: aNumber steps: steps 
	^self to: aNumber by: (aNumber - self) / steps! !

TestCase subclass: #TestCollections3D
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Tests'!

!TestCollections3D methodsFor: 'tests-LineSegment3DComposite' stamp: 'emm 03/09/2012 20:59'!
testLS1
	| col |
	col := LineSegment3DComposite new.
	col add: (0 , 0 , 0 lineSegmentTo: 1 , 1 , 1).
	self assert: col size = 1.
	self assert: col first start = (0 , 0 , 0)! !

TestCase subclass: #TestCursor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Tests'!

!TestCursor methodsFor: 'tests' stamp: 'emm 03/09/2012 21:00'!
testPen

	| pen |
	pen := Pen2D new.
	pen moveTo: 100 @ 100.
	pen upWhile: [ pen moveTo: 100 @ 200 ].
	pen moveTo: 0 @ 200! !

TestCase subclass: #TestExtensions
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Tests'!

!TestExtensions methodsFor: 'as yet unclassified' stamp: 'emm 9/23/2012 22:52'!
testCreate
	| r |
	r := Color redByte: 255 greenByte: 0 blueByte: 0.
	self assert: r = Color red! !

!TestExtensions methodsFor: 'as yet unclassified' stamp: 'emm 9/23/2012 22:53'!
testPurple
	self assert: Color purple notNil! !

TestCase subclass: #TestMaxScenes
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Tests'!

!TestMaxScenes methodsFor: 'setrup' stamp: 'emm 03/09/2012 21:00'!
path
	^'c:\temp'! !

!TestMaxScenes methodsFor: 'setrup' stamp: 'emm 03/09/2012 21:00'!
setUp
	MaxScriptWriter path: self path! !

!TestMaxScenes methodsFor: 'tests' stamp: 'emm 03/09/2012 21:00'!
testBoxFaces

	| b |
	b := SceneBuilder max.
	b color: Color yellow.
	b addAll: Box new faces.
	b writeToFile: 'faces'! !

!TestMaxScenes methodsFor: 'tests' stamp: 'emm 03/09/2012 21:00'!
testBoxFaces_Textured

	| b |
	b := SceneBuilder max.
	b texture:self path , '/rgb128.bmp'.	
	b addAll: Box new faces.
	b writeToFile: 'faces_textured'! !

!TestMaxScenes methodsFor: 'tests' stamp: 'emm 03/09/2012 21:00'!
testBoxRotateX

	| b |
	b := SceneBuilder max.
	b color: Color yellow.
	b add: (( Box origin: 0 , 0 , 0 extent: 10 , 40 , 80 ) rotateBy: 45 rad,0,0).
	b color: Color blue.
	b add: (Box origin: 0 , 0 , 0 extent: 10 , 40 , 80 ).
	b writeToFile: 'boxrotatex'! !

!TestMaxScenes methodsFor: 'tests' stamp: 'emm 03/09/2012 21:00'!
testBoxRotateZ

	| b |
	b := SceneBuilder max.
	b color: Color yellow.
	b add: (( Box origin: 0 , 0 , 0 extent: 10 , 40 , 80 ) rotateBy: 0,0,45 rad).
	b color: Color blue.
	b add: ( Box origin: 0 , 0 , 0 extent: 10 , 40 , 80 ).
	b writeToFile: 'boxrotatez'! !

!TestMaxScenes methodsFor: 'tests' stamp: 'emm 03/09/2012 21:00'!
testBoxTranslateXRotateZ
	
	| b |
	b := SceneBuilder max.
	b color: Color yellow.
	b add: ( ( ( Box origin: 0 , 0 , 0 extent: 10 , 40 , 80 ) wrapTranslateBy: 30 , 0 , 0 ) rotateBy: 0 , 0 , 45 rad ).
	b writeToFile: 'boxtranslatexrotatez'! !

!TestMaxScenes methodsFor: 'test-the cube' stamp: 'emm 03/09/2012 21:00'!
testCube

	| b  pen|
	b := SceneBuilder max.
	pen := WallPen new.
	pen colorRight: Color red.
	pen down.
	pen height: 10.
	pen width: 2.
	pen dy: 16.
	pen doorwayHeight: 6 while:[pen dy: 8].
	pen dy: 16.
	pen dx: 16.
	pen doorwayHeight: 6 while:[pen dx: 8].
	pen dx: 16.
	pen dy: -16.
	pen doorwayHeight: 6 while:[pen dy: -8].
	pen dy: -16.
	pen dx: -3.
	pen windowOffset: 2 height: 6 while: [ pen dx: -10 ].	
	pen dx: -3.
	pen doorwayHeight: 6 while:[pen dx: -8].
	pen dx: -16.
	b addAll: pen objects.
	b writeToFile: 'thecube'
	! !

!TestMaxScenes methodsFor: 'tests' stamp: 'emm 03/09/2012 21:00'!
testFrontRightTop

	| b  box|
	b := SceneBuilder max.
	b addAxis.
	box := Box origin: 0,0,0 extent: 5,5,5.
	b color: Color blue.
	b add: box top.
	b color: Color green.
	b add: box right.
	b color: Color red.
	b add: box front.
	b writeToFile: 'frontrighttop'.
	
	self assert: b materials size = 3! !

!TestMaxScenes methodsFor: 'tests' stamp: 'emm 03/09/2012 21:00'!
testGroup

	| b  group|
	b := SceneBuilder max.
	b scale: 10.
	group := Group3D new.
	group add: Box new.
	group add: (Sphere center: 3,0,0).
	b add: (group translateBy: 0,1,0).
	b writeToFile: 'group'

	! !

!TestMaxScenes methodsFor: 'tests' stamp: 'emm 03/09/2012 21:00'!
testInnerCube

	| pen  b|
	b := SceneBuilder max.	
	pen := WallPen new.
	pen height: 100.
	pen textureLeft: 'rgb128.bmp'.
	pen down.
	pen dx: 100.
	pen dy: 100.
	pen dx: -100.
	pen dy: -100.
	b add: pen objects.
	b writeToFile: 'innercube'! !

!TestMaxScenes methodsFor: 'tests' stamp: 'emm 03/09/2012 21:00'!
testMaterials

	| pen  b  mat2 mat3|
	b := SceneBuilder max.	
	mat2 := MaxMaterial new bitmapFilename: self path , '/rgb128.bmp'.
	mat2 index: 2.
	b add: mat2.
	mat3 := MaxMaterial new bitmapFilename: self path , '/rg128.bmp'.
	mat3 index: 3.
		b add: mat3.	
	b writeToFile: 'materials'! !

!TestMaxScenes methodsFor: 'tests' stamp: 'emm 9/22/2012 22:36'!
testQuats

	| q |
	q := (0,0,90 rad) asQuaternion.
	self assert: (q x = 0 and:[q y = 0 and:[q z > 0 and:[ q d > 0 ]]]).
	q := (0,90 rad,0) asQuaternion.
	self assert: (q x = 0 and:[q y > 0 and:[q z = 0 and:[ q d > 0 ]]]).
	q := (90 rad,0,0) asQuaternion.
	self assert: (q x > 0 and:[q y = 0 and:[q z = 0 and:[ q d > 0 ]]]).
	q := (-90 rad,0,0) asQuaternion.
	self assert: (q x < 0 and:[q y = 0 and:[q z = 0 and:[ q d > 0 ]]]).
	q := (0, -90 rad,0) asQuaternion.
	self assert: (q x = 0 and:[q y < 0 and:[q z = 0 and:[ q d > 0 ]]]).
	q := (0,0, -90 rad) asQuaternion.
	self assert: (q x = 0 and:[q y = 0 and:[q z < 0 and:[ q d > 0 ]]]).! !

!TestMaxScenes methodsFor: 'tests' stamp: 'emm 03/09/2012 21:00'!
testText

	| b  box  txt|
	b := SceneBuilder max.
	b texture: self path , '/rgb128.bmp'.	
	txt := Text3D new string: 'Philemon'.
	b add: ( txt rotateBy: 90 rad,0,0).
	b writeToFile: 'text_map'

	! !

!TestMaxScenes methodsFor: 'tests' stamp: 'emm 03/09/2012 21:00'!
testTextureMappingBox

	| b  box |
	b := SceneBuilder max.
	b texture:self path , '/rgb128.bmp'.	
	b add: (Box new scaleBy: 100).	
	b writeToFile: 'box_map'

	! !

!TestMaxScenes methodsFor: 'tests' stamp: 'emm 03/09/2012 21:00'!
testTextureMappingCylinder

	| b  box |
	b := SceneBuilder max.
	b texture: self path , '/rgb128.bmp'.	
	b add: (Cylinder center: 0,0,0 radius: 100 height: 10).	
	b writeToFile: 'cylinder_map'

	! !

!TestMaxScenes methodsFor: 'tests' stamp: 'emm 03/09/2012 21:00'!
testTextureMappingRectangle

	| b  box |
	b := SceneBuilder max.
	b texture: self path , '/rgb128.bmp'.	
	b add: (Box new scaleBy: 100) left.	
	b writeToFile: 'rect_map'

	! !

!TestMaxScenes methodsFor: 'tests' stamp: 'emm 03/09/2012 21:00'!
testTextureMappingSphere

	| b  box |
	b := SceneBuilder max.
	b texture: self path , '/rgb128.bmp'.	
	b add: (Sphere center: 0,0,0 radius: 100).	
	b writeToFile: 'sphere_map'

	! !

!TestMaxScenes methodsFor: 'tests' stamp: 'emm 03/09/2012 21:00'!
testTextureMappingTriangle

	| b  box |
	b := SceneBuilder max.
	b texture: self path , '/rgb128.bmp'.	
	b add: (Triangle3D with: 0,0,0 with: 0,0,100 with: 100,0,0).
	
	b writeToFile: 'triangle_map'

	! !

!TestMaxScenes methodsFor: 'tests' stamp: 'emm 03/09/2012 21:00'!
testTextureMappingWrappedObject1

	| b  box |
	b := SceneBuilder max.
	b texture:self path , '/rgb128.bmp'.	
	b add: (Box new wrapTranslateBy: 10@10@10).	
	b writeToFile: 'box_wrap_map1'

	! !

!TestMaxScenes methodsFor: 'tests' stamp: 'emm 03/09/2012 21:00'!
testTextureMappingWrappedObject2

	| b  box |
	b := SceneBuilder max.
	b texture:self path , '/rgb128.bmp'.	
	b add: (((Box new wrapTranslateBy: 10@10@10) rotateBy: 0,0,90 rad) scaleBy: 2,2,2).
	b writeToFile: 'box_wrap_map2'

	! !

!TestMaxScenes methodsFor: 'tests' stamp: 'emm 03/09/2012 21:00'!
testTextureWrapPolygonU2V4

	| b box wrap poly|
	b := SceneBuilder max.
	poly := (Box new scaleBy: 100) left asPolygon3D.	
	wrap := poly texturedWith: self path , '/rgb128.bmp'.	
	wrap uv: 2@4.
	b add: wrap.
	b writeToFile: 'poly24_map'

	! !

!TestMaxScenes methodsFor: 'tests' stamp: 'emm 03/09/2012 21:00'!
testTextureWrapRectangleU2V4

	| b  box  rectangle wrap|
	b := SceneBuilder max.
	rectangle := (Box new scaleBy: 100) left.	
	wrap := rectangle wrapTexturedWith: self path , '/rgb128.bmp'.	
	wrap uv: 2@4.
	b add: wrap.
	b writeToFile: 'rect24_map'

	! !

!TestMaxScenes methodsFor: 'tests' stamp: 'emm 03/09/2012 21:00'!
testTextureWrapRectangleU2V4_translated

	| b  box  rectangle wrap|
	b := SceneBuilder max.
	rectangle := (Box new scaleBy: 100) left.	
	wrap := rectangle wrapTexturedWith: self path , '/rgb128.bmp'.	
	wrap uv: 2@4.
	b add: (wrap translateBy: 0,0,100).
	b writeToFile: 'rect24_map_translated'

	! !

!TestMaxScenes methodsFor: 'tests' stamp: 'emm 03/09/2012 21:00'!
testTextureWrapTranslated_RectangleU2V4

	| b  box  rectangle wrap|
	b := SceneBuilder max.
	rectangle := (Box new scaleBy: 100) left.	
	wrap := rectangle wrapTexturedWith: self path , '/rgb128.bmp'.	
	wrap uv: 2@4.
	b add: (wrap translateBy: 0,0,100).
	b writeToFile: 'rect24_translated_map'

	! !

TestCase subclass: #TestOperators
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Tests'!

!TestOperators methodsFor: 'test - TriangleApproximator' stamp: 'emm 9/22/2012 23:56'!
_testVerticesDo_Rectangle3D_Translated_Scaled_Rotated

	| face  points|
	face := Box new front wrapRotateBy: 1,1,1.
	face := face wrapScaleBy: 1,1,1.
	face := face wrapTranslateBy: 1,1,1.
	points := OrderedCollection new.
	face verticesDo: [ :v | points add: v].
	self assert: points size = 4.! !

!TestOperators methodsFor: 'test - TriangleApproximator' stamp: 'emm 03/09/2012 20:59'!
testFacesDo_Rectangle3D

	| face  faces|
	face := Box new front.
	faces := OrderedCollection new.
	face facesDo: [ :f | faces add: f].
	self assert: faces size = 1.! !

!TestOperators methodsFor: 'test - TriangleApproximator' stamp: 'emm 03/09/2012 20:59'!
testFacesDo_Rectangle3D_Rotated

	| face  faces|
	face := Box new front wrapRotateBy: 1,1,1.
	faces := OrderedCollection new.
	face facesDo: [ :f | faces add: f].
	self assert: faces size = 1.! !

!TestOperators methodsFor: 'test - TriangleApproximator' stamp: 'emm 03/09/2012 20:59'!
testFacesDo_Rectangle3D_Scaled

	| face  faces|
	face := Box new front wrapScaleBy: 1,1,1.
	faces := OrderedCollection new.
	face facesDo: [ :f | faces add: f].
	self assert: faces size = 1.! !

!TestOperators methodsFor: 'test - TriangleApproximator' stamp: 'emm 03/09/2012 20:59'!
testFacesDo_Rectangle3D_Translated

	| face  faces|
	face := Box new front wrapTranslateBy: 1,1,1.
	faces := OrderedCollection new.
	face facesDo: [ :f | faces add: f].
	self assert: faces size = 1.! !

!TestOperators methodsFor: 'test - TriangleApproximator' stamp: 'emm 03/09/2012 20:59'!
testFacesDo_Rectangle3D_Translated_Scaled_Rotated

	| face  faces|
	face := Box new front wrapRotateBy: 1,1,1.
	face := face wrapScaleBy: 1,1,1.
	face := face wrapTranslateBy: 1,1,1.
	faces := OrderedCollection new.
	face facesDo: [ :f | faces add: f].
	self assert: faces size = 1.! !

!TestOperators methodsFor: 'test - TriangleApproximator' stamp: 'emm 03/09/2012 20:59'!
testTriangleApproximator
	| ta mesh |
	ta := Triangle3DApproximator new.
	mesh := ta approximate: Box new front.
	self assert: mesh indexedFaces size = 2! !

!TestOperators methodsFor: 'test - TriangleApproximator' stamp: 'emm 03/09/2012 20:59'!
testTriangleApproximator2
	| ta triangles |
	ta := Triangle3DApproximator new.
	triangles := ta approximate: Box new front asPolygon3D.
	self assert: triangles size = 2! !

!TestOperators methodsFor: 'test - TriangleApproximator' stamp: 'emm 03/09/2012 20:59'!
testVerticesDo_Rectangle3D

	| face  points|
	face := Box new front.
	points := OrderedCollection new.
	face verticesDo: [ :v | points add: v].
	self assert: points size = 4.! !

!TestOperators methodsFor: 'test - TriangleApproximator' stamp: 'emm 03/09/2012 20:59'!
testVerticesDo_Rectangle3D_Rotated

	| face  points|
	face := Box new front.
	face := face wrapRotateBy: 2,2,2.
	points := OrderedCollection new.
	face verticesDo: [ :v | points add: v].
	self assert: points size = 4.! !

!TestOperators methodsFor: 'test - TriangleApproximator' stamp: 'emm 03/09/2012 20:59'!
testVerticesDo_Rectangle3D_Scaled

	| face  points|
	face := Box new front.
	face := face wrapScaleBy: 2,2,2.
	points := OrderedCollection new.
	face verticesDo: [ :v | points add: v].
	self assert: points size = 4.! !

!TestOperators methodsFor: 'test - TriangleApproximator' stamp: 'emm 03/09/2012 20:59'!
testVerticesDo_Rectangle3D_Translated

	| face  points|
	face := Box new front.
	face := face wrapTranslateBy: 2,2,2.
	points := OrderedCollection new.
	face verticesDo: [ :v | points add: v].
	self assert: points size = 4.! !

!TestOperators methodsFor: 'test - TriangleApproximator' stamp: 'emm 03/09/2012 20:59'!
testVerticesDo_Rectangle3D_Translated_Scaled_Rotated

	| face  points|
	face := Box new front wrapRotateBy: 1,1,1.
	face := face wrapScaleBy: 1,1,1.
	face := face wrapTranslateBy: 1,1,1.
	points := OrderedCollection new.
	face verticesDo: [ :v | points add: v].
	self assert: points size = 4.! !

TestCase subclass: #TestPOVRayScenes
	instanceVariableNames: 'builder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Tests'!

!TestPOVRayScenes methodsFor: 'knots' stamp: 'emm 03/09/2012 20:59'!
curve_knot3

	^Curve3D
	expression: '[ :angle |  | phased z |
	phased := angle  + (Float pi / 6).
	z := (67.5 degreesToRadians + (3 * angle)) sin.

	(3 * angle ) sin *
	(angle cos @ angle sin @ z ) -

	((3 * phased ) sin *
	(phased cos @ phased sin @ z))
]'! !

!TestPOVRayScenes methodsFor: 'knots' stamp: 'emm 03/09/2012 20:59'!
curve_knot8

	^Curve3D
	expression: '[ :angle |  | phased z |
	phased := angle  + (Float pi / 6).
	z := (45 degreesToRadians + (4 * angle)) sin.

	(4 * angle ) sin *
	(angle cos @ angle sin @ z ) -

	((4 * phased ) sin *
	(phased cos @ phased sin @ z))
]'! !

!TestPOVRayScenes methodsFor: 'tests-primitives' stamp: 'emm 03/09/2012 20:59'!
testBox

	| b |
	b := SceneBuilder povray.
	b color: Color yellow.
	b add: Box new.
	b writeToFile: 'test_box'! !

!TestPOVRayScenes methodsFor: 'tests-primitives' stamp: 'emm 03/09/2012 20:59'!
testBoxColored

	| b |
	b := SceneBuilder povray.
	b color: Color yellow.
	b add: (Box new coloredWith: Color red).
	b writeToFile: 'test_box_red'! !

!TestPOVRayScenes methodsFor: 'tests-primitives' stamp: 'emm 03/09/2012 20:59'!
testBoxRotated

	| b |
	b := SceneBuilder povray.
	b color: Color yellow.
	b add: (Box new rotateBy: 45 rad,0,0).
	b writeToFile: 'test_box_rotated'! !

!TestPOVRayScenes methodsFor: 'tests-primitives' stamp: 'emm 03/09/2012 20:59'!
testBoxScaled

	| b |
	b := SceneBuilder povray.
	b color: Color yellow.
	b add: (Box new wrapScaleBy: 1,2,3).
	b writeToFile: 'test_box_scaled'! !

!TestPOVRayScenes methodsFor: 'tests-primitives' stamp: 'emm 03/09/2012 20:59'!
testBoxTranslated

	| b |
	b := SceneBuilder povray.
	b color: Color yellow.
	b add: (Box new wrapTranslateBy: 45 rad,0,0).
	b writeToFile: 'test_box_translated'! !

!TestPOVRayScenes methodsFor: 'test-complex' stamp: 'emm 03/09/2012 20:59'!
testCSD

	| b |
	b := SceneBuilder povray.
	b color: Color yellow.
	b add: (( CubicSpaceDivider size: 10 ) barExtent: 1 asPoint3D).
	b add: ((Camera at: 10,20,30 lookingAt: 0,0,0) name: 'cubicspacedivision').
	b add: (Light at: 10,20,30).
	b writeToFile: 'test_csd'! !

!TestPOVRayScenes methodsFor: 'tests-primitives' stamp: 'emm 03/09/2012 20:59'!
testCamera

	| b |
	b := SceneBuilder povray.
	b color: Color yellow.
	b texture: 'rgb.bmp'.
	b add: ((Camera at: 1,2,3 lookingAt: 0,0,0) name: 'enter').
	b writeToFile: 'test_cam'! !

!TestPOVRayScenes methodsFor: 'tests-primitives' stamp: 'emm 03/09/2012 20:59'!
testGroup

	| b  g|
	b := SceneBuilder povray.
	b color: Color yellow.
	g := Group3D new.
	g add: Box new.
	g add: Sphere new.
	
	b add: g.
	b writeToFile: 'test_group1'! !

!TestPOVRayScenes methodsFor: 'tests-primitives' stamp: 'emm 03/09/2012 20:59'!
testGroup2

	| b  g|
	b := SceneBuilder povray.
	b color: Color yellow.
	b beginGroup.
	
	b add: Box new.
	b add: Sphere new.
	
	b add: b endGroup.
	b writeToFile: 'test_group2'! !

!TestPOVRayScenes methodsFor: 'tests-primitives' stamp: 'emm 03/09/2012 20:59'!
testGroup3

	| b  g|
	b := SceneBuilder povray.
	b color: Color yellow.
	b group:[
	
	b add: Box new.
	b add: Sphere new.
	
	].
	b writeToFile: 'test_group3'! !

!TestPOVRayScenes methodsFor: 'knots' stamp: 'emm 03/09/2012 20:59'!
testKnot3


	| b  knot sphere|
	b := SceneBuilder povray.
	knot :=self  curve_knot3.
	knot := knot interpolatorUsingAll: (0 to: 180 by: 0.3).
	knot verticesDo:[ :each |
		sphere := Sphere center: each radius: 0.2.
		b texture: '{T_Wood5}'.
		b add: sphere ].
	b add: ((Camera at: 4,0,0 lookingAt: 0,0,0) label: 'cam').
	b add: (Light at: 5,0,5).
	b include: 'woods.inc'.
	b include: 'colors.inc'.
	b include: 'skies.inc'.
	b add:  (SceneElementWithSource new source: 'sky_sphere { S_Cloud2 }' ).	
	b writeToFile: 'knot3'.


"
[ :angle |  | phased z |
	phased := angle  + (Float pi / 6).
	z := (67.5 degreesToRadians + (3 * angle)) sin.

	(3 * angle ) sin *
	(angle cos @ angle sin @ z ) -

	((3 * phased ) sin *
	(phased cos @ phased sin @ z))
]"! !

!TestPOVRayScenes methodsFor: 'knots' stamp: 'emm 03/09/2012 20:59'!
testKnot8


	| b  knot sphere|
	b := SceneBuilder povray.
	b include: 'colors.inc'.
	knot := self curve_knot8.
	knot := knot interpolatorUsingAll: (0 to: 360 by: 0.3).
	knot segmentsDo:[ :each |
		sphere := Torus center: 0,0,0 majorRadius: 0.1 minorRadius: 0.02.
		sphere := sphere wrapRotateBy: -90 rad @ 0 @ 0.
		(each end - each start) rotationPointsFromZ do:[ :rotation |
			sphere := sphere wrapRotateBy: rotation].
		sphere := sphere wrapTranslateBy: each start.
		b texture: '{T_Stone41}' from: 'stones.inc'. 
		b add: sphere ].

	b add: ((Camera at: 0.0001,0,5 lookingAt: 0,0,0) label: 'cam').
	b add: (Light at: 0,0,3).
	b include: 'skies.inc'.
	b add:  (SceneElementWithSource new source: 'sky_sphere { S_Cloud2 }' ).	
	b writeToFile: 'knot8'.
! !

!TestPOVRayScenes methodsFor: 'tests-primitives' stamp: 'emm 03/09/2012 20:59'!
testRectangle

	| b |
	b := SceneBuilder povray.
	b color: Color yellow.
	b add: Rectangle3D new.
	b writeToFile: 'test_rectangle'! !

!TestPOVRayScenes methodsFor: 'tests-primitives' stamp: 'emm 03/09/2012 20:59'!
testSphere

	| b |
	b := SceneBuilder povray.
	b color: Color yellow.
	b add: Sphere new.
	b writeToFile: 'test_sphere'! !

!TestPOVRayScenes methodsFor: 'tests-primitives' stamp: 'emm 03/09/2012 20:59'!
testTorusSegment

	| b |
	b := SceneBuilder povray.
	b color: Color yellow.
	b add: Torus new.
	b writeToFile: 'test_torussegment'! !

TestCase subclass: #TestPrimitives3D
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Tests'!

!TestPrimitives3D methodsFor: 'test-Torus' stamp: 'emm 03/09/2012 20:59'!
testTorus1

	| torus |
	torus := Torus center: 1,2,3 majorRadius: 10 minorRadius: 4. ! !

!TestPrimitives3D methodsFor: 'test-TorusArc' stamp: 'emm 03/09/2012 20:59'!
testTorusArc1

	| arc |
	arc := TorusArc center: 1,2,3 majorRadius: 8 minorRadius: 4.
	arc startAngle: 45 rad.
	arc stopAngle: 180 rad.
	self assert: arc sweepAngle = (180 - 45) rad! !

TestCase subclass: #TestSVG
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Tests'!

!TestSVG methodsFor: 'tests' stamp: 'emm 03/09/2012 21:01'!
testCircle

	| builder |
	builder := SVGSceneBuilder new.
	builder add: (Circle2D center: 100@120 radius: 34).
	builder writeToFile: 'testcircle'! !

!TestSVG methodsFor: 'tests' stamp: 'emm 03/09/2012 21:01'!
testCirclePainted

	| builder  circle painted|
	builder := SVGSceneBuilder new.
	circle := Circle2D center: 100@120 radius: 34.
	builder fillColor: Color red.
	builder strokeColor: Color blue.
	builder strokeWidth: 1 .
	builder add: circle.
	builder writeToFile: 'testcirclepainted'! !

!TestSVG methodsFor: 'tests' stamp: 'emm 03/09/2012 21:01'!
testEllipse

	| builder |
	builder := SVGSceneBuilder new.
	builder add: (EllipticalArc2D boundingBox: (Rectangle origin: 5@10 extent: 20@40)).
	builder writeToFile: 'testellipse'! !

!TestSVG methodsFor: 'tests' stamp: 'emm 03/09/2012 21:01'!
testGroup

	| builder |
	builder := SVGSceneBuilder new.
	builder group:[
		builder add: (5@10 corner: 25@55).
		builder add: (Circle2D center: 100@100 radius: 45)].
	builder writeToFile: 'testgroup'! !

!TestSVG methodsFor: 'tests' stamp: 'emm 03/09/2012 21:01'!
testLine

	| builder |
	builder := SVGSceneBuilder new.
	builder add: (LineSegment2D from: 1@1 to: 100@100).
	builder writeToFile: 'testline'! !

!TestSVG methodsFor: 'tests' stamp: 'emm 03/09/2012 21:01'!
testLink

	| builder  link|
	builder := SVGSceneBuilder new.
	link := builder newLink.
	link  href: 'http://www.philemonworks.com'.
	builder push: link.
	builder add: ((VisualText on: 'www.philemonworks.com') origin: 100@100).
	builder add: builder pop.
	builder writeToFile: 'testlink'! !

!TestSVG methodsFor: 'tests' stamp: 'emm 03/09/2012 21:01'!
testMultilineText

	| builder |
	builder := SVGSceneBuilder new.
	builder add: ((VisualText on: 'This is a multi-line text
to show that can handle carriage returns') origin: 20@20).
	builder writeToFile: 'testmultilinetext'! !

!TestSVG methodsFor: 'tests' stamp: 'emm 03/09/2012 21:01'!
testPainting

	| builder  geo wrapper|
	builder := SVGSceneBuilder new.
	geo := 5@10 corner: 25@55.
	builder fillColor: Color red.
	builder strokeColor: Color black.
	builder add: geo.
	builder writeToFile: 'testpainting'! !

!TestSVG methodsFor: 'tests' stamp: 'emm 03/09/2012 21:01'!
testPolygon

	| builder |
	builder := SVGSceneBuilder new.
	builder add: (Polygon2D withAll: (Array with: 0@0 with: 50@100 with: 100@50)).
	builder writeToFile: 'testpolygon'! !

!TestSVG methodsFor: 'tests' stamp: 'emm 03/09/2012 21:01'!
testPolyline

	| builder |
	builder := SVGSceneBuilder new.
	builder add: (Polyline2D withAll: (Array with: 0@0 with: 50@100 with: 100@50)).
	builder writeToFile: 'testpolyline'! !

!TestSVG methodsFor: 'tests' stamp: 'emm 03/09/2012 21:01'!
testRectangle

	| builder |
	builder := SVGSceneBuilder new.
	builder add: (5@10 corner: 25@55).
	builder writeToFile: 'testrectangle'! !

!TestSVG methodsFor: 'tests' stamp: 'emm 03/09/2012 21:01'!
testRoundedRectangle

	| builder |
	builder := SVGSceneBuilder new.
	builder add: ((RoundedRectangle2D origin: 50@100 corner: 250@150)
		xRadius: 20
		;yRadius: 40).
	builder writeToFile: 'testroundedrectangle'! !

!TestSVG methodsFor: 'tests' stamp: 'emm 03/09/2012 21:01'!
testText

	| builder |
	builder := SVGSceneBuilder new.
	builder add: ((VisualText on: 'Hello World') origin: 100@100).
	builder writeToFile: 'testtext'! !

!TestSVG methodsFor: 'tests' stamp: 'emm 9/23/2012 22:40'!
testTextBoxed

	| builder  width height string box|

	builder := SVGSceneBuilder new.
	string := 'String World'.
	width := string size * 12.
	height := 12.
	box := RoundedRectangle2D origin: 100@(100 - height + 10) extent: width@height.
	box xRadius: 10 ;yRadius: 10.
	box := box expandBy: 5@5.
	builder add: box.
	builder add: ((VisualText on: string) origin: 100@100).
	builder writeToFile: 'testtextboxed'! !

TestCase subclass: #TestStructures
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Tests'!

!TestStructures methodsFor: 'Rectangle3D' stamp: 'emm 03/09/2012 20:59'!
does: aCollection hasSameElementsAs: otherCollection
	aCollection size = otherCollection size
		ifFalse: [^false].
	1 to: aCollection size do:[ :i |
		((aCollection at: i) = (otherCollection at: i))
			ifFalse: [^false]].
	^true! !

!TestStructures methodsFor: 'Rectangle3D' stamp: 'emm 03/09/2012 20:59'!
testRectangle3D_polygons

	| left |
	left := Polygon3D new.
	left add: 0,0,0.
	left add: 0,0,1000.
	left add: 0,1000,1000.
	left add: 0,1000,0.
	self should:[self does: (Rectangle3D origin: 0,0,0 corner: 0,1000,1000) asPolygon3D hasSameElementsAs: left ]! !

!TestStructures methodsFor: 'Rectangle3D' stamp: 'emm 03/09/2012 20:59'!
testRectangle3D_subtract
	
	| r1 r2  result|
	r1 := Rectangle3D origin: 0 , 0 , 0 corner: 10 , 10 , 0.
	r2 := Rectangle3D origin: 1 , 1 , 0 corner: 9 , 9 , 0.
	result := r1 subtract: r2.
	self assert: result notNil.! !

!TestStructures methodsFor: 'Point3D' stamp: 'emm 03/09/2012 20:59'!
testRotationPointsFromZ

	| resultBlock |
	resultBlock := [ :vertex | ( vertex rotationPointsFromZ 
		inject: 0 , 0 , 1 
		into: [ :v :r | v rotatedBy: r ] ) rounded ].
	self assert: ( resultBlock value: 1 , 1 , 1 ) = ( 1 , 1 , 1 )! !

TestCase subclass: #TestThreeJSScenes
	instanceVariableNames: 'builder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Tests'!

!TestThreeJSScenes methodsFor: 'as yet unclassified' stamp: 'emm 9/29/2012 19:46'!
setUp
	builder := SceneBuilder threeJS ! !

!TestThreeJSScenes methodsFor: 'as yet unclassified' stamp: 'emm 10/7/2012 21:39'!
testBox
	"	self new testBox
	"
	| s |
	s := SceneBuilder threeJS.
	s add: Box new.
	s writeToFile: 'box'! !

TestCase subclass: #TestVRMLScenes
	instanceVariableNames: 'builder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Tests'!

!TestVRMLScenes methodsFor: 'tests' stamp: 'emm 03/09/2012 20:59'!
addAxisTo: b

	b color: Color blue ;add: (Box origin: 0,0,1 corner: 1,1,10).
	b color: Color red ;add: (Box origin: 0,1,0 corner: 1,10,1).
	b color: Color green ;add: (Box origin: 1,0,0 corner: 10,1,1).! !

!TestVRMLScenes methodsFor: 'tests' stamp: 'emm 03/09/2012 20:59'!
addBallTo: b startAt: where withSpeed: speed in: sizePoint
	"self new testBouncer"

	| clock script ball sourceStream |
	b add: ( clock := b newTimeSensor ).
	clock loop: true.
	clock cycleInterval: 0.05.
	b add: ( script := b newScript ).
	b add: ( ball := b newTransformOn: ( b newElementFrom: (Sphere new radius: 0.5))).
	b route: #cycleTime of: clock to: #tick of: script.
	script
		declare: #tick as: 'eventIn SFTime'
		;declare: #position as: 'eventOut SFVec3f'
		;declare: #velocity as: 'eventOut SFVec3f'
		;declare: #maxX as: 'field SFInt32' value: sizePoint x
		;declare: #maxY as: 'field SFInt32' value: sizePoint y
		;declare: #maxZ as: 'field SFInt32' value: sizePoint z.
	sourceStream := WriteStream on: (String new: 32).
	sourceStream 
		nextPutAll: '
function initialize() {
	position = new SFVec3f ('.
	sourceStream 
		print:  where 
		; nextPutAll: ');
	velocity = new SFVec3f ('.
	sourceStream 
		print: speed
		; nextPutAll: ');
}
function tick (value,timestamp) {
	position = position.add( velocity );
	if ( position.x > maxX ) {
		position.x = maxX;
		velocity.x = velocity.x * -1;
	}
	if ( position.x < 0 ) {
		position.x = 0;
		velocity.x = velocity.x * -1;
	}
	if ( position.y > maxY ) {
		position.y = maxY;
		velocity.y = velocity.y * -1;
	}
	if ( position.y < 0 ) {
		position.y = 0;
		velocity.y = velocity.y * -1;
	}
	if ( position.z > maxZ ) {
		position.z = maxZ;
		velocity.z= velocity.z * -1;
	}
	if ( position.z < 0 ) {
		position.z = 0;
		velocity.z = velocity.z * -1;
	}
}'
.
	script source: sourceStream contents.
	b route: #position of: script to: #translation of: ball.! !

!TestVRMLScenes methodsFor: 'tests' stamp: 'emm 03/09/2012 20:59'!
axis
		"X-axis in Green
		 Y-axis in Red
		 Z-axis in Blue"

	| b |
	b := self newBuilder.
	b beginGroup.

	b color: Color blue ;add: (Box origin: 0,0,0.5 corner: 0.5,0.5,2.5).
	b color: Color red ;add: (Box origin: 0,0.5,0 corner: 0.5,2.5,0.5).
	b color: Color green ;add: (Box origin: 0.5,0,0 corner: 2.5,0.5,0.5).
	b color: Color white.
	b add: ( b newLabel: 'X' at: 3,0,0 axis: 0,0,0).
	b add: ( b newLabel: 'Y' at: 0,3,0 axis: 0,0,0).
	b add: ( b newLabel: 'Z' at: 0,0,3 axis: 0,0,0).

	^b add: b endGroup! !

!TestVRMLScenes methodsFor: 'building' stamp: 'emm 03/09/2012 20:59'!
builder
	^builder! !

!TestVRMLScenes methodsFor: 'building ( ISceneDefiner )' stamp: 'emm 03/09/2012 20:59'!
builderClass

	^VRMLSceneBuilder! !

!TestVRMLScenes methodsFor: 'tests' stamp: 'emm 03/09/2012 20:59'!
cameraPath

	"Answer two collections.
	The first contains origins, the seconds contains focusPoints"

	| origins  points circle |
	origins := OrderedPoint3DCollection new.
	points := OrderedPoint3DCollection new.
	origins addAll: ( 100,2.5,0 to: 5,2.5,0 steps: 20 ).
	points addAll: ( Array new: 20 withAll: 5,0,0 ).
	
	circle := Circle3D center: 5,0,0 radius: 2.5.
	origins addAll: ( circle interpolatorUsingAll: ( 120 rad to: 330 rad by: 30 rad )).
	points addAll: ( Array new: 8 withAll: 5,0,0 ).

	origins addAll: ( 7.5 ,0 ,0 to: 7.5 ,5 ,0 steps: 10).
	points addAll:  ( 5,0,0 to: 5,5,0 steps: 10).

	circle := Circle3D center: 5,5,0 radius: 2.5.
	origins addAll: ( circle interpolatorUsingAll: ( 30 rad to: 60 rad by: 30 rad )).
	points addAll: ( Array new: 2 withAll: 5,5,0 ).

	origins addAll: ( 5,7.5,0 to: 0,7.5,0 steps: 10).
	points addAll: ( 5,5,0 to: 0,5,0 steps: 10).

	circle := Circle3D center: 0,5,0 radius: 2.5.
	origins addAll: ( circle interpolatorUsingAll: ( 120 rad to: 150 rad by: 30 rad )).
	points addAll: ( Array new: 2 withAll: 0,5,0 ).

	origins addAll: ( -2.5,5,0 to: -2.5,0,0 steps: 10).
	points addAll: ( 0,5,0 to: 0,0,0 steps: 10).

	circle := Circle3D center: 0,0,0 radius: 2.5.
	origins addAll: ( circle interpolatorUsingAll: ( 210 rad to: 240 rad steps: 2 )).
	points addAll: ( Array new: 2 withAll: 0,0,0 ).

	origins addAll: ( 0,-2.5,0 to: 100,2.5,0 steps: 20).
	points addAll: ( Array new: 20 withAll: 0,0,0).

	^Array 
		with: origins
		with: points
	! !

!TestVRMLScenes methodsFor: 'tests' stamp: 'emm 03/09/2012 20:59'!
giveTranslationXRotationZRotationForZNormalToGetAlong: linesegment

	| direction theta |
	direction := linesegment direction.
	"assume on xy plane for now"
	theta := direction xy theta.
	^Array
		with: linesegment start
		with: 0
		with: theta! !

!TestVRMLScenes methodsFor: 'spherical rings' stamp: 'emm 03/09/2012 20:59'!
makeSphericalRings
	"self new makeSphericalRings"

	| b torus sr tr tz sc dt mat looper t |
	b := SceneBuilder vrml.
	b color: Color lightblue.
	b appearance material transparency: 0.7.
	b add: (Sphere center: 0,0,0 radius: 2).

"	b add: (Light at: 10,0,0 lookingAt: 0,0,0).
"
	b add: ((looper := b newTimeSensor) loop: true).
	sc := b newScheduler.
	b route: #cycleTime of: looper to: #startTime of: sc.
	sr := 2.
	t := 0.
	dt := 0.1.

	(-80 to: 80 by: 10) do:[ :degs |
		b color: Color lightblue.
		mat := b appearance material.
		sc at: t send: 'transparency' with: 0 to: mat.
		sc at: t + dt send: 'transparency' with: 1 to: mat.
		t := t + dt.
		mat transparency: 1.

		tr := degs rad cos * sr.
		tz := degs rad sin * sr.
		torus := Torus center: 0,0,tz majorRadius: tr minorRadius: 0.05.
		b add: torus ].

	sc cycleInterval: dt.
	looper cycleInterval: t + (5 * dt).
	b add: sc.
	b add: ((Camera at: 5,0,2 lookingAt: 0,0,0) label: 'front' ).
	b writeToFile: 'rings'! !

!TestVRMLScenes methodsFor: 'building' stamp: 'emm 03/09/2012 20:59'!
newBuilder
	^builder! !

!TestVRMLScenes methodsFor: 'building' stamp: 'emm 03/09/2012 20:59'!
preBuildWith: aBuilder

	aBuilder add:( aBuilder newDirectionalLight ;color: Color green)! !

!TestVRMLScenes methodsFor: 'roller-coaster' stamp: 'emm 03/09/2012 20:59'!
rollerCoasterPoints
	"self new testSolidString"

	| curve pen |
	curve := CompositeCurve new.
	pen := Pen3D new.
	pen down.
 	pen dy: 10.
	pen dy: 10 dz: 5.
	pen dy: 20 dz: 20.
	pen dy: 10 dz: 5.
	pen follow: (EllipticalArc3D
		from: 0,0,0
		to: 10,0,0
		center: 5,0,0
		clockwise: true ).
	pen dy: -5.
	pen dy: -10 dz: 5.
	pen dy: -20 dz: 20.
	pen dy: -10 dz: 5.
	pen objects do:[ :each | curve add: each ].
	^curve computeVerticesWithEquidistance: 3.! !

!TestVRMLScenes methodsFor: 'building' stamp: 'emm 03/09/2012 20:59'!
setUp

	builder := VRMLSceneBuilder new! !

!TestVRMLScenes methodsFor: 'tests' stamp: 'emm 03/09/2012 20:59'!
template
	"self new template"

	| b |
	b := SceneBuilder vrml.
	b color: Color green.

	b add: ((Camera at: 10,0,0 lookingAt: 0,0,0) label: 'front' ).
	b writeToFile: 'template'! !

!TestVRMLScenes methodsFor: 'tests' stamp: 'emm 03/09/2012 20:59'!
test2

	"self test2"
	
	| b grid |
	b := VRMLSceneBuilder new. 
	b add: b newDirectionalLight ;color: Color green.
	b texture: 'brick1_1.gif '.
	grid := TetrahedronGrid3D new layers: ( 1 to: 8 ) ; delta: 1.5.
	grid verticesDo: [ :each | b add: ( Cone new origin: each ) ].
	b writeToFile: 'test0.wrl'! !

!TestVRMLScenes methodsFor: 'tests' stamp: 'emm 03/09/2012 20:59'!
testAnchor0
	
	"self new anchor0"
	
	| a b |
	b := builder.

	a := b anchor:[
		b add: Box new ].
	a description: 'Axis0'.
	a url: 'axis0.wrl'.
		
	self writeToFile: 'anchor0'! !

!TestVRMLScenes methodsFor: 'tests' stamp: 'emm 10/7/2012 19:53'!
testAxis
	"self new testAxis"

	| b |
	b := SceneBuilder vrml.
	b color: Color blue.
	b add: (Box origin: 0,0,0.5 corner: 0.5,0.5,2.5).
	b color: Color red.
	b add: (Box origin: 0,0.5,0 corner: 0.5,2.5,0.5).
	b color: Color green.
	b add: (Box origin: 0.5,0,0 corner: 2.5,0.5,0.5).
	b writeToFile: 'testAxis' useIndentation: true! !

!TestVRMLScenes methodsFor: 'tests' stamp: 'emm 9/23/2012 22:57'!
testAxisWithCameras
	"self new testAxisWithCameras"

	| b vp |
	b := SceneBuilder vrml.
	b color: Color blue.
	b add: (Box origin: 0,0,0.5 corner: 0.5,0.5,2.5).
	b color: Color red.
	b add: (Box origin: 0,0.5,0 corner: 0.5,2.5,0.5).
	b color: Color green.
	b add: (Box origin: 0.5,0,0 corner: 2.5,0.5,0.5).

	b add: ((Camera at: 10,0,0 lookingAt: 0,0,0) label: 'towards negative x').
	b add: ((Camera at: -10,0,0 lookingAt: 0,0,0) label: 'towards positive x').
	b add: ((Camera at: 0,10,0 lookingAt: 0,0,0) label: 'towards negative y').
	b add: ((Camera at: 0, -10,0 lookingAt: 0,0,0) label: 'towards positive y').
	b add: ((Camera at: 10,10,10 lookingAt: 0,0,0) label: 'from 10,10,10 to 0,0,0').

	b writeToFile: 'testAxisWithCameras'! !

!TestVRMLScenes methodsFor: 'tests' stamp: 'emm 9/23/2012 23:34'!
testBouncer
	"self new testBouncer"

	| b clock script ball timer interpolator camera group |
	b := SceneBuilder vrml.
	b add: (( b newBackground) skyColor: (Color grey:40)).
	b add: ( timer := b newTimeSensor loop: true ;cycleInterval: 10 ;yourself).
	b add: ( interpolator := b 
		newOrientationInterpolatorFrom: ( 0 to: 360 rad by: 5 rad )
		axis: (1,1,1) normalized).

	b beginGroup.
	b color: Color white.
	self addBallTo: b startAt: 10,0,0 withSpeed: 0.1,0.3,0.2 in: 10,10,10.
	b color: Color red.
	self addBallTo: b startAt: 0,0,0 withSpeed: 0.3,0.5,0.1 in: 10,10,10.
	b color: Color green.
	self addBallTo: b startAt: 0,0,0 withSpeed: 0.6,0.2, -0.5 in: 10,10,10.
	b color: Color blue.
	self addBallTo: b startAt: 5,5,5 withSpeed: -0.3,0.8,0.1 in: 10,10,10.
	b color: Color pink.
	self addBallTo: b startAt: 7,5,2 withSpeed: 0.3, -0.8,0.1 in: 10,10,10.
	b color: Color yellow.
	self addBallTo: b startAt: 5,1,3 withSpeed: 0.3, -0.8,0.4 in: 10,10,10.
	b color: (Color white withTransparency: 0.8).
	b add: (Box origin: -0.5 asPoint3D  corner: 10.5,10.5,10.5).
	b add: ( group := b newTransformOn: b endGroup).

	b whenFractionChanging: timer rotate: group using: interpolator.

	b add: ( Camera at: 30,0,5 lookingAt: 5,5,5).
	b writeToFile: 'bouncer'! !

!TestVRMLScenes methodsFor: 'tests' stamp: 'emm 10/7/2012 19:08'!
testBoxesGrid

	"self new testBoxesGrid"
	
	| b grid |
	b := VRMLSceneBuilder new. 
	b add: b newDirectionalLight ;color: Color green.
	grid := ( Grid3D origin: 0 , 0 , 0 corner: 6 , 6 , 6 ) delta: 2 , 2 , 2.
	grid verticesDo: [ :each | b add: ( ( Box new wrapColoredWith: Color purple ) wrapTranslateBy: each ) ].
	b writeToFile: 'testBoxesGrid'! !

!TestVRMLScenes methodsFor: 'tests' stamp: 'emm 03/09/2012 20:59'!
testButton0
	"self new button0"

	| b |
	b := self builder.
	b add: Box new.
	b addWhenTouchingLoad: 'test.wrl'.
	b writeToFile: 'button0'
	! !

!TestVRMLScenes methodsFor: 'tests' stamp: 'emm 03/09/2012 20:59'!
testButton1
	"self new testButton1"

	| b c |
	b := self builder.
	c := (Box size: 5) centered.
	b add: ( c scaledBy: 0.9 ).
	b color: Color white.
	c faceNames do:[ :each |
		b add: ( b newLabel: each asString on: (c perform: each) ) ].
	b writeToFile: 'testButton1'
	! !

!TestVRMLScenes methodsFor: 'tests' stamp: 'emm 03/09/2012 20:59'!
testButton10
	"self new button10"

	| b |
	b := self builder.
	b add: Sphere new.
	b addWhenTouchingReplaceWorldBy: 'button9.wrl'.
	b writeToFile: 'testButton10'
	! !

!TestVRMLScenes methodsFor: 'tests' stamp: 'emm 9/28/2012 00:03'!
testButton2
	"self new button2"

	| b c sw |
	b := self builder.
	sw := b switch:[
		b add: Sphere new.
		b add: Cone new ].
	b 
		color: Color red
		; add: ( b whenPointingAt: (Box new translateBy: 0,0,2) 
		choose: 0 
		in: sw ).
	b 
		color: Color blue
		; add: ( b whenPointingAt: (Box new translateBy: 0,0, -2) 
		choose: 1 
		in: sw).
	self writeToFile: 'button2'
	! !

!TestVRMLScenes methodsFor: 'tests' stamp: 'emm 9/28/2012 00:03'!
testButton3
	"self new button3"

	| b c sw |
	b := self builder.
	sw := b switch:[
		b add: ( b newInlineURL: 'testSS3D.wrl') .
		b add: ( b newInlineURL: 'http://127.0.0.1:7000/whatever.wrl') ].
	b 
		color: Color red
		; add: ( b whenPointingAt: (Box new translateBy: 0,0,2) 
		choose: 0 
		in: sw).
	b 
		color: Color blue
		; add: ( b whenPointingAt: (Box new translateBy: 0,0, -2) 
		choose: 1 
		in: sw).
	b writeToFile: 'button3'
	! !

!TestVRMLScenes methodsFor: 'tests' stamp: 'emm 03/09/2012 20:59'!
testButton4
	"self new button4"

	| b c sw scr |
	b := self builder.
	sw := b switch:[
		b add: ( b newInlineURL: 'testSS3D.wrl') .
		b add: ( b newInlineURL: 'http://127.0.0.1:7000/whatever.wrl') ].
	scr := b newScriptForNavigatingChoiceIn: sw.
	b add: scr.

	b 	color: Color red.
	b 
		whenTouching: (b add: (b newElementFrom: (Box new translateBy: 0,0,2)))
		send: #increaseChoice
		to: scr.

	b color: Color blue.
	b
		whenTouching: (b add: (b newElementFrom: (Box new translateBy: 0,0,-2)))
		send: #decreaseChoice
		to: scr.

	self writeToFile: 'button4'
	! !

!TestVRMLScenes methodsFor: 'tests' stamp: 'emm 03/09/2012 20:59'!
testButton5
	"self new button5"

	| b c sw scr |
	b := self builder.
	sw := b switch:[
		b add: ( b newInlineURL: 'testSS3D.wrl') .
		b add: ( b newInlineURL: 'http://127.0.0.1:7000/whatever.wrl') ].

	scr := b newScriptForNavigatingChoiceIn: sw.
	b add: scr.

	b 	color: Color red.
	b 
		whenPointingAt: (b add: (b newElementFrom: (Box new translateBy: 0,0,2)))
		send: #increaseChoice
		to: scr.

	b color: Color blue.
	b
		whenPointingAt: (b add: (b newElementFrom: (Box new translateBy: 0,0,-2)))
		send: #decreaseChoice
		to: scr.

	b color: Color purple.
	b
		whenPointingAt: (b add: (b newElementFrom: (Box new translateBy: 0,-2,0)))
		send: #noChoice
		to: scr.

	b writeToFile: 'button5'
	! !

!TestVRMLScenes methodsFor: 'tests' stamp: 'emm 03/09/2012 20:59'!
testButton9
	"self new button9"

	| b |
	b := self builder.
	b add: Box new.
	b addWhenTouchingReplaceWorldBy: 'button10.wrl'.
	b writeToFile: 'button9'
	! !

!TestVRMLScenes methodsFor: 'tests' stamp: 'emm 03/09/2012 20:59'!
testCam0
	"self new testCam0"

	| b vp |
	b := SceneBuilder vrml.
	b add: (Camera at: -10,0,0 lookingAt: 0,0,0).
	b add: ( b newViewpointBack: 10).
	b addAxis.
	b writeToFile: 'testCam0'! !

!TestVRMLScenes methodsFor: 'tests' stamp: 'emm 03/09/2012 20:59'!
testCameraPath
	
	"self new testCameraPath"
	
	| b cam timer points interpolator translations zRotations interpolatorZ tz path |
	b := SceneBuilder vrml.
	b addAxis.
	b color: Color cyan.
	b add: Pyramid new.
	b color: Color orange.
	b add: (Sphere center: 5,0,0 radius: 0.5).
	b color: Color navy.
	b add: (Box origin: 0,5,0 centerExtent: 1 asPoint3D).
	b color: Color darkgreen.
	b add: (Tetrahedron new origin: 5,5,0.5).
 	cam := (Camera at: 10,0,0 lookingAt: 10,0,0) label: 'gogo'.
"	cam := (Cylinder center: 0,0,0 radius: 0.1 height: 4) rotatedBy: 0,-90 rad,0."
	b add: ( cam  :=  b newTransformOn: ( b newElementFrom: cam )).

	b add: ( timer := b newTimeSensor ).
	timer cycleInterval: 30.
	timer loop: true.

	translations := OrderedCollection new.
	zRotations := OrderedCollection new.
	path := self cameraPath.

	path first with: path last do:[ :one :two |
		tz := (self giveTranslationXRotationZRotationForZNormalToGetAlong: (LineSegment3D from: one to: two)).
		translations add: tz first.
		zRotations add: tz last ].

	b add: ( interpolator := b newPositionInterpolatorFrom: translations ).
	b whenFractionChanging: timer translate: cam using: interpolator.
	b add: ( interpolatorZ := b newRotationInterpolatorFrom: zRotations axis: 0,0,1 ).
	b whenFractionChanging: timer rotate: cam using: interpolatorZ.

	b add: ( b newBackground skyColor: 0.9,1,1  ).
	b writeToFile: 'testCameraPath' 
! !

!TestVRMLScenes methodsFor: 'tests' stamp: 'emm 03/09/2012 20:59'!
testCameraPath0
	"self new testCameraPath0"
	
	| b path cam camElement camTransform fractions mover looper 
	yTransform zTransform moveTransform yRotations zRotations origin focus 
	viewvector rotationpoints rotationspoints yRotator zRotator rotation random |
	b := SceneBuilder vrml.
	
	path := CameraPath new.
	path originPath: (Circle3D center: 0,0,-1 radius: 30).
	path focusPath: (LineSegment3D between: 0,0,0 and: 0,0,0).
	path duration: 10.
	path frameCount: 30.
	path label: 'gogo'.
	b add: path.

	random := Color random.
	(0 to: 1 steps: path frameCount) do:[ :f |
		b color: random.
		b add: (((LineSegment3D between: (path originAtFraction: f) - (0,0,10) and: (path focusPointAtFraction: f) - (0,0,10))
			asCylinderWithRadius: 0.5) )].


	b add: ((Camera at: 0,0,-30 lookingAt: 0,0.01,0) label: 'topje').
	b addAxis.
	b navigationInfo examine.
	b writeToFile: 'testCameraPath0'! !

!TestVRMLScenes methodsFor: 'tests' stamp: 'emm 03/09/2012 20:59'!
testCameraPath1
	"self new testCameraPath1"
	
	| b path cam camElement camTransform fractions mover looper 
	yTransform zTransform moveTransform yRotations zRotations origin focus 
	viewvector rotationpoints rotationspoints yRotator zRotator rotation random |
	b := SceneBuilder vrml.
	
	path := CameraPath new.
	path originPath: (Circle3D center: 0,0,-1 radius: 30).
	path focusPath: (LineSegment3D between: 0,0,0 and: 0,0,0).
	path duration: 10.
	path frameCount: 30.
	path label: 'gogo'.
	path rollAngles: (Array with: 0 with: 89 rad with: 0).
	b add: path.

	random := Color random.
	(0 to: 1 steps: path frameCount) do:[ :f |
		b color: random.
		b add: (((LineSegment3D between: (path originAtFraction: f) - (0,0,10) and: (path focusPointAtFraction: f) - (0,0,10))
			asCylinderWithRadius: 0.5) )].


	b add: ((Camera at: 0,0,-30 lookingAt: 0,0.01,0) label: 'topje').
	b addAxis.
	b navigationInfo examine.
	b writeToFile: 'testCameraPath1'! !

!TestVRMLScenes methodsFor: 'tests' stamp: 'emm 03/09/2012 20:59'!
testControls3D1
	"self new testControls3D1"

		"X-axis in Green
		 Y-axis in Red
		 Z-axis in Blue"

	| b c |
	b := SceneBuilder vrml.
	b texture: 'arrow.jpg'.
	c := Box origin: 1,0,0 corner: 2,1,1.
	b add: c.
"
	#(top right bottom left ) do:[ :each |
		b add: (c perform: each) reverse ]."
	

	b writeToFile: 'controls3D1'! !

!TestVRMLScenes methodsFor: 'tests' stamp: 'emm 03/09/2012 20:59'!
testGlow

	"self new testGlow"

	| b timer interpolator mat box |
	b := SceneBuilder vrml.
	b add: ( timer := b newTimeSensor ).

	timer loop: true.
	timer cycleInterval: 10.

	b add: ( interpolator := b newScalarInterpolatorFrom: ( 0 to: 1 by: 0.1 )).
	mat := b newMaterial.
	mat at: 'diffuseColor' put: Color white.
	box := b add: ( Box origin: 0,0,0 centerExtent: 10,10,10 ).

	b whenFractionChanging: timer send: #transparency to: mat using: interpolator.
	b add: (Camera at: 20 ,0,0 lookingAt: 0,0,0).
	b navigationInfo examine.
	b writeToFile: 'Glower'.

	! !

!TestVRMLScenes methodsFor: 'tests' stamp: 'emm 03/09/2012 20:59'!
testHUD
	"self new testHUD"

	| b ttf prox transf touch box |
	b := SceneBuilder vrml.
	b color: Color red.
	b add: Sphere new.

	b beginGroup.
		b beginCollision collide: false.
			b add: ( prox := b newProximitySensor size: 10000 asPoint3D ).
			transf := b beginTransform.
				b beginTransform translation: 10,-5,0.
					b add: ( touch := b newTouchSensor ).
					b color: Color yellow.
					b add: ( box := Box new ).
				b add: b endTransform.
			b add: b endTransform.
		b add: b endCollision.
	b add: b endGroup.

	b route: #orientation_changed of: prox to: #rotation of: transf.
	b route: #position_changed of: prox to: #position of: transf.

	b add: ( Camera at: 10,0,0 lookingAt: 0,0,0 ).
	b writeToFile: 'testHUD'
	! !

!TestVRMLScenes methodsFor: 'tests' stamp: 'emm 03/09/2012 20:59'!
testHyperLink0
	"self new hyperLink0"

	| b |
	b := self builder.
	b addWhenTouchingLoad: 'test.wrl' .
	b writeToFile: 'testHyperLink0'
	! !

!TestVRMLScenes methodsFor: 'tests' stamp: 'emm 03/09/2012 20:59'!
testHyperLink1
	"self new hyperLink1"

	| b offsetY |
	b := self builder.
	offsetY := 0.
	(WRLWriter workingDirectoryName asFilename filesMatching: '*.wrl') do:[ :each |
		b addWhenTouching: (each asText3D translatedBy: 0@offsetY@0) load: each.
		offsetY := offsetY + 1].
	b writeToFile: 'hyperLink1'
	! !

!TestVRMLScenes methodsFor: 'tests' stamp: 'emm 03/09/2012 20:59'!
testInline0
	
	"self new inline0"
	
	| b |
	b := self builder.
	b add: ( b newInline: 'http://127.0.0.1:7000/whatever.wrl' ).
	
	self writeToFile: 'inline0'! !

!TestVRMLScenes methodsFor: 'tests' stamp: 'emm 03/09/2012 20:59'!
testInsideOutside

	" self new testInsideOutside "

	| b |
	b := SceneBuilder vrml.
	b color: Color blue.
	b add: (( HollowBox origin: 0,0,0 centerExtent: 10,10,10 ) thickness: 0.5).
	b color: Color yellow.
	b add: (Sphere new radius: 0.5).
	b color: Color red.
	b add: ( Pyramid new origin: 10, 0 ,0).
	b navigationInfo type: 'EXAMINE WALK'.
	b writeToFile: 'testInsideOutside'
	! !

!TestVRMLScenes methodsFor: 'tests' stamp: 'emm 03/09/2012 20:59'!
testLOD
	"self new testLOD"

	| b lod |
	b := SceneBuilder vrml.
	b beginLOD.
	b add: Sphere new.
	b add: Box new.
	b add: b newGroup.
	b add: ( lod := b endLOD ).
	lod range: #( 10 100 200 ).
	b add: (Camera at: 10,0,0 lookingAt: 0,0,0).
	b writeToFile: 'testLOD' useIndentation: true.! !

!TestVRMLScenes methodsFor: 'tests' stamp: 'emm 03/09/2012 20:59'!
testLabel0
	
	"self new testLabel0"
	
	| b text |
	b := self builder.
	b fontStyle size: 10.
	b color: Color red.
	text := 'Long' asText3D.
	b add: text.
	b color: Color black.
	text := ('John' asText3D) translatedBy: 0,20,0.
	b add: text.
	b color: Color white.
	text := ('Witman' asText3D) translatedBy: 0,40,0.
	b add: text.		
	self addAxisTo: b.
	b add: (Camera at: 10,0,0 lookingAt: 0,0,0).
	b add: ( b newBackground skyColor: (Color grey:40) ).
	b writeToFile: 'testlabel0'! !

!TestVRMLScenes methodsFor: 'tests' stamp: 'emm 03/09/2012 20:59'!
testLargeText0
	
	"self new largeText0"
	
	| b |
	b := self builder.
	b add: self axis.
	b add: 'Geometric3DScenes subclass: #VRMLScenes
	interfaceNames: ''''
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: '''' ' asText3D.
	self writeToFile: 'testLargeText0'! !

!TestVRMLScenes methodsFor: 'tests' stamp: 'emm 03/09/2012 20:59'!
testOrientation

	builder color: (Color red01: 1 green01: 1 blue01: 1).
	builder addAll: Box new faces.
	builder writeToFile: 'orientation'! !

!TestVRMLScenes methodsFor: 'tests' stamp: 'emm 03/09/2012 20:59'!
testPositions0
	
	"self new positions0"
	
	| b |
	b := self builder.
	b add:
		(b whenPointingAt: Sphere new
		translate: Box new 
		along: ( 0,0,0 to: 0,0,10 )
		within: 3 ).
	b writeToFile: 'testPositions0'! !

!TestVRMLScenes methodsFor: 'tests' stamp: 'emm 03/09/2012 20:59'!
testProto
	"self new testProto"

	| b |
	b := SceneBuilder vrml.

	b beginProto: 'TESTPROTO'.
	b color: ( b newVariable: 'kleur' type: 'SFColor' default: Color red ).
	b add: Box new.
	b add: b endProto.

	b add: ( b newInstanceOfProto: 'TESTPROTO' ).

	b add: Camera new.
	b writeToFile: 'testProto'.! !

!TestVRMLScenes methodsFor: 'tests' stamp: 'emm 03/09/2012 20:59'!
testProximity

	"self new testProximity"

	| b ps riX tis rotX element |
	b := SceneBuilder vrml.

	element := b newElementFrom: Box new.
	rotX := b newTransformOn: element.

	b add: rotX.
	b add: ( ps := b newProximitySensor ).
	b add: ( riX := b newRotationInterpolatorFrom: (0 to: 90 rad by: 10 rad) axis: 1,0,0 ).
	b add: ( tis :=  b newTimeSensor cycleInterval: 3 ).
	b whenFractionChanging: tis rotate: rotX using: riX.
	b 
		route: #enterTime 
		of: ps 
		to: #startTime 
		of: tis.
	ps center: 0@0@0.
	ps size: 14@14@14.

	b writeToFile: 'testProximity'! !

!TestVRMLScenes methodsFor: 'tests' stamp: 'emm 03/09/2012 20:59'!
testRedGreen

	"self new testRedGreen"

	| b red1 green1 blueGrid redGrid offset redColor greenColor |
	b := SceneBuilder vrml.
	redColor := (Color redByte: 255 greenByte: 70 blueByte: 70 ).
	greenColor := Color cyan. "(Color redByte: 29 greenByte: 189 blueByte: 241 )."
	b add: ( b newBackground skyColor: Color white).
	b color: (Color black).
	b add: ( Box origin: 0,3,0 corner: 20,23,40).
	b color: redColor.
	b add: ( Box origin: 0,1.9,0 corner: 20,3,40).
	b color: greenColor.
	b add: ( Box origin: 0,23,0 corner: 20,24.1,40).
"
	b color: (Color gray).
	b add: ( Box origin: 10,6,5 corner: 30,18,20).
	b color: greenColor.
	b add: ( Box origin: 10,5.5,5 corner: 30,6,20).
	b color: redColor.
	b add: ( Box origin: 10,18,5 corner: 30,18.5,20).
"
	b color: Color yellow.
	b add: ( Box origin: 10,5,6 corner: 30,19,19).

	b color: Color black.
	b fontStyle size: 10.
	b add: ( '3D' asText3D translatedBy: 30.2, 6, 10).
	b color: greenColor.
	b add: ( '3D' asText3D translatedBy: 30.1, 5.8, 10).
	b color: redColor.
	b add: ( '3D' asText3D translatedBy: 30.1, 6.2, 10).

	b add: (Camera at: 55,5,5 lookingAt: 0,5,5).
	b navigationInfo examine.
	b writeToFile: 'testGridRedBlue'! !

!TestVRMLScenes methodsFor: 'tests' stamp: 'emm 9/29/2012 17:20'!
testRollingText
	
	"( self new testRollingText )"
	
	| b box1 toucher timer1 rotator1 char1 char2 timer2 rotator2 previousTimer|
	b := self builder.
	b add: (Camera at: 150,0,50 lookingAt: 0,0,50).
	box1 := Box origin: -5, -5,0 corner: 5,5,200.

	'PhilemonWorks' doWithIndex:[ :each :index |
		| timer rotator char |
		b beginGroup.
		b color: (Color grey: 40).
		b add: ( b newElementFrom: box1).
		index = 1
			ifTrue: [ b add: (toucher := b newTouchSensor) ].
		b color: Color yellow.
		b fontStyle size: 12.
		b add: ((( each asString asText3D ) rotatedBy: 0,0,-90 rad) translatedBy: -4,-5.1,100).
		char := b newTransformOn: b endGroup.
		b add: (char translateBy: 0,(index-1*10-0.1),0).
		b add: (timer := b newTimeSensor).
		timer stopTime: 1.
		b add: (rotator := b newRotationInterpolatorFrom: (0 to: 90 rad by: 5 rad) axis: 0,0,1).
	
		"events"
		index = 1
			ifTrue: [ b whenTouching: toucher start: timer ].
		b whenFractionChanging: timer rotate: char using: rotator.
		index = 1
			ifFalse: [ b whenStopped: previousTimer start: timer ].	
		previousTimer := timer ].
	
	b navigationInfo examine.
	b writeToFile: 'testRollingText'! !

!TestVRMLScenes methodsFor: 'tests' stamp: 'emm 9/29/2012 17:26'!
testRotX
	"self new testRotX"

	| b approx face surface randomColor |
	b := SceneBuilder vrml.
	randomColor := RandomColor new.
	face := ((Polygon3D new) add: 0,1,1 ;add: 0,-1,1 ;add: 0,-1,-1 ;add: 0,1,-1; yourself).
	b color: Color white.
	b add: face.
	approx := DoubleCollectionBasedInterpolator on: (Sphere center: 4,4,4 radius: 4).
	approx collection: (0 to: 345 rad by: 45 rad).
	approx secondCollection: (0 to: 0 "345 rad by: 45 rad").
	approx verticesDo:[ :v |
		surface := (v - (4,4,4)) rotationPointsFromZ
			inject: face copy
			into:[ :hereFace :rotation | hereFace rotateBy: rotation ].
		b color: randomColor next.
		b add: (surface translatedBy: v).
		b add: (surface translatedBy: v) reverseOriented.
		b add: (LineSegment3D between: 4,4,4 and: v) ].
	

	b add: ((Camera at: 20,4,4 lookingAt: 0,4,4) label: 'front' ).
	b writeToFile: 'testRotX'! !

!TestVRMLScenes methodsFor: 'tests' stamp: 'emm 9/29/2012 17:27'!
testRotZ
	"self new testRotZ"

	| b approx face surface randomColor |
	b := SceneBuilder vrml.
	randomColor := RandomColor new.
	face := (Box origin: 0,0,0 centerExtent: 2,2,2) bottom.
	approx := DoubleCollectionBasedInterpolator on: (Sphere center: 4,4,4 radius: 4).
	approx collection: (0 to: 345 rad by: 45 rad).
	approx secondCollection: (0 to: 345 rad by: 45 rad).
	approx verticesDo:[ :v |
		surface := (v - (4,4,4)) rotationPointsFromZ
			inject: face copy
			into:[ :hereFace :rotation | hereFace rotateBy: rotation ].
		b color: randomColor next.
		b add: (surface translateBy: v).
		b add: (LineSegment3D between: 4,4,4 and: v) ].
	

	b add: ((Camera at: 40,4,4 lookingAt: 0,4,4) label: 'front' ).
	b writeToFile: 'testRotZ'! !

!TestVRMLScenes methodsFor: 'tests' stamp: 'emm 03/09/2012 20:59'!
testScheduledSound

	"self new testScheduledSound"
	
	| b toucher clip sound s clip2 sound2 |
	b := SceneBuilder vrml.
	s := b newScheduler.
	s cycleInterval: 0.1.
	b add: Sphere new.
	b add: ( toucher := b newTouchSensor ).
	b add: ( clip := b newAudioClip: 'default.wav' ).
	b add: ( clip2 := b newAudioClip: 'exclame.wav' ).
	b add: ( sound := b newSound: clip ).
	sound minFront: 20.
	sound minBack: 20.
	b add: ( sound2 := b newSound: clip2 ).
	sound2 minFront: 20.
	sound2 minBack: 20.
	s at: 0 start: clip.
	s at: 0 start: clip2.
	b add: s.
	b whenTouching: toucher start: s script.
	b writeToFile: 'testScheduledSound'.! !

!TestVRMLScenes methodsFor: 'tests' stamp: 'emm 03/09/2012 20:59'!
testScheduler
	
	"self new testScheduler"
	
	| b s t1 t2 up right upMover rightMover toucher |
	b := SceneBuilder vrml.
	b color: Color cyan.
	s := VRMLScheduler new.
	s cycleInterval: 1.
	b add: ( t1 := b newTimeSensor ).
	t1 cycleInterval: 2.
	b add: ( t2 := b newTimeSensor ).
	t2 cycleInterval: 3.
	up := b newTransformOn: ( b newElementFrom: Sphere new).
	right := b newTransformOn: up.
	b add: right.
	b add: ( upMover := b newPositionInterpolatorFrom: ( 0,0,0 to: 0,0,10 steps: 2)).
	b add: ( rightMover := b newPositionInterpolatorFrom: ( 0,0,0 to: 0,10,0 steps: 2)).
	b whenFractionChanging: t1 translate: up using: upMover.
	b whenFractionChanging: t2 translate: right using: rightMover.
	b add: ( toucher := b newTouchSensor ).	

	s at: 0 start: t1.
	s at: 5 start: t2.	
	b add: s.
	b whenTouching: toucher start: s script.	

	b add: (Camera origin: 50,0,0 ).
	b writeToFile: 'testScheduler' 
! !

!TestVRMLScenes methodsFor: 'roller-coaster' stamp: 'emm 03/09/2012 20:59'!
testSolidString
	"self new testSolidString"

	| b intersection points pointStream previous this next v1 v2 v3 poly 
	thisPoly polyCompute previousPoly randomColor random faceComposite |

	b := SceneBuilder vrml.
	intersection := Polygon3D withAll: (((Circle3D center: 0,0,0 radius: 0.5) 
		interpolatorUsingAll: (0 to: 330 rad by: 30 rad)) vertices).

	points := self rollerCoasterPoints.
		
	polyCompute := [ :where :direction |
		( direction rotationPointsFromZ 
			inject: intersection copy
			into: [ :inter :rotation | inter rotateBy: rotation ]) translateBy: where ].

	faceComposite := FaceComposite new.
"	b texture: 'images/green.jpg'.
"
	b color: Color yellow.
	pointStream := points readStream.
	previous := pointStream next.
	this := pointStream next.
	previousPoly := polyCompute value: previous value: this - previous.
	faceComposite add: ( previousPoly ).
	[pointStream atEnd]
		whileFalse:
			[next := pointStream next.
			v1 := (this - previous) normalized.
			v2 := (next - this) normalized.
		thisPoly := polyCompute value: this value: v1 + v2.
		Helper3D
			simpleFacesForSolidBetween: thisPoly reverseOriented
			and: previousPoly
			do: [ :face | faceComposite add:face].
		previousPoly := thisPoly.
		this := next].
	thisPoly := polyCompute value: next value: v1.
		Helper3D
			simpleFacesForSolidBetween: thisPoly reverseOriented
			and: previousPoly
			do: [ :face | faceComposite add: face ].
	faceComposite add: thisPoly reverseOriented.

	b add: faceComposite.
	b addAxis.
	b add: ((Camera at: 60,30,30 lookingAt: 0,30,30) label: 'front').
	b writeToFile: 'solidString'! !

!TestVRMLScenes methodsFor: 'tests' stamp: 'emm 03/09/2012 20:59'!
testSound

	"self new testSound"
	
	| b toucher clip sound |
	b := SceneBuilder vrml.
	b add: Sphere new.
	b add: ( toucher := b newTouchSensor ).
	b add: ( clip := b newAudioClip: 'default.wav' ).
	b add: ( sound := b newSound: clip ).
	sound minFront: 20.
	sound minBack: 20.
	b whenTouching: toucher start: clip.
	b writeToFile: 'testSound'.! !

!TestVRMLScenes methodsFor: 'tests' stamp: 'emm 03/09/2012 20:59'!
testStartTime

	"self new testStartTime"

	| b move1 move2 int1 int2 t1 t2 s touch |
	b := SceneBuilder vrml.
	b color: Color red.
	b add: ( move1 := b newTransformOn: ( b newElementFrom: Sphere new )).

	b color: Color blue.
	b add: ( move2 := b newTransformOn: ( b newElementFrom: Sphere new )).
	b add: ( int1 := b newPositionInterpolatorFrom: ( 0,0,0 to: 0,0,10 steps: 2) ).
	b add: ( int2 := b newPositionInterpolatorFrom: ( 0,0,0 to: 0,10,0 steps: 2) ).
	b add: ( t1 := b newTimeSensor ).
	b add: ( t2 := b newTimeSensor ).	
	b whenFractionChanging: t1 translate: move1 using: int1.
	b whenFractionChanging: t2 translate: move2 using: int2.

	s := VRMLScheduler new.
	s at: 1 start: t1.
	s at: 2 start: t2.
	
	b add: s.
	b color: Color yellow.
	b beginGroup.
	b add: ( Sphere center: 0,-10,0).
	b add: ( touch := b newTouchSensor ).
	b add: ( b endGroup ).

	b whenTouching: touch start: s clock.
	b add: (Camera at: 30,0,0 lookingAt: 0,0,0).
	b writeToFile: 'testStartTime'.! !

!TestVRMLScenes methodsFor: 'tests' stamp: 'emm 03/09/2012 20:59'!
testSwitch0
	
	"self new switch0"
	
	| b sw ts scr |
	b := self builder.
	sw := b beginSwitch.
	b add: Box new.
	b add: Sphere new.
	b endSwitch.
	b add: ( ts := b newTouchSensor ).
	b add: ((scr := b newScript) 
			at: 'eventIn SFTime' put: #touchTime
			;at: 'eventOut SFInt32' put: #whichChoice
			;at: 'url' put: 'javascript:
	  function initialize() {
		whichChoice = 0;
	  }
	  function touchTime( value, time) {
		if ( whichChoice == 1 ) whichChoice = 0;
		else ++whichChoice;
	  }' ;yourself).
	b route: #touchTime of: ts to: #touchTime of: scr.
	b route: #whichChoice of: scr to:  #whichChoice of: sw.
	self writeToFile: 'switch0'! !

!TestVRMLScenes methodsFor: 'tests' stamp: 'emm 03/09/2012 20:59'!
testSwitch1
	
	"self new switch1"
	
	| b |
	b := self builder.
	b add: ( b whenTouching: b newTouchSensor switchBetween: (Array with: Box new with: Sphere new)). 
	self writeToFile: 'switch1'! !

!TestVRMLScenes methodsFor: 'texture' stamp: 'emm 03/09/2012 20:59'!
testTextureBox
	"DoitTool open: 'TestVRMLScenes new testTextureBox'
	"

	| tw |
	tw := TextureWrapper on: Box new front.
	tw texture: 'top.jpg'.
	tw scale: 2@2.
	builder add: tw.
	builder writeToFile: 'texturedbox'! !

!TestVRMLScenes methodsFor: 'texture' stamp: 'emm 03/09/2012 20:59'!
testTexturePolygon
	"DoitTool open: 'TestVRMLScenes new testTexturePolygon'
	"

	| tw  p poly|
	p := DotPen new.
	p down.
	p dx: 100 dy: 10.
	p dx: -10 dy: 50.
	poly := Polygon3D withAll: p objects.
	tw := TextureWrapper on: poly.
	tw texture: 'top.jpg'.
	tw scale: 2@2.
	builder add: tw.
	builder writeToFile: 'texturedpoly'! !

!TestVRMLScenes methodsFor: 'tests' stamp: 'emm 03/09/2012 20:59'!
testTextures0
	"self new testTextures0"

	| b ttf |
	b := SceneBuilder vrml.
	b texture: 'brick1_1.gif'.
	ttf := b newTextureTransform.
	ttf scale: 2 asPoint.
	ttf rotation: 45 rad.
	b appearance textureTransform:ttf.
	b appearance texture name: 'BrickImage'.
	b add: ( Box origin: 0,0,0 centerExtent: 100 asPoint3D ) front.
	b add: ( Box origin: 0,160,0 centerExtent: 100 asPoint3D ) front.
	b add: ( Camera at: 200,0,0 lookingAt: 0,0,0 ).
	b writeToFile: 'testTextures0'
	! !

!TestVRMLScenes methodsFor: 'tests' stamp: 'emm 03/09/2012 20:59'!
testTimer0
	"( self new testTimer0 )"

	| b box1T box2T translator1 timer1 timer2 translator2 touch delay |
	b := self newBuilder.
	b add: (Camera at: 10,0,0 lookingAt: 0,0,0).

	b add: (box1T := b newTransformOn: (b newElementFrom: Box new)).
	box1T add:( touch := b newTouchSensor ).
	b add: (box2T := b newTransformOn: (b newElementFrom: (Box new origin: 0,10,0))).
	b add: (translator1 := b newPositionInterpolatorFrom: (0,0,0 to: 0,0,5)).
	b add: (translator2 := b newPositionInterpolatorFrom: (0,0,0 to: 0,0,-5 by: 0,0,-1)).
	b add: (timer1 := b newTimeSensor).
	b add: (timer2 := b newTimeSensor).
	b add: (delay := b newTimeSensor).
	delay cycleInterval: 5. "seconds"

	b whenFractionChanging: timer1 translate: box1T using: translator1.
	b whenFractionChanging: timer2 translate: box2T using: translator2.

	b route: #cycleTime of: delay to: #startTime of: timer2.
	b whenTouching: touch start: delay.
	b navigationInfo examine.
	b writeToFile: 'testTimer0'! !

!TestVRMLScenes methodsFor: 'tests' stamp: 'emm 03/09/2012 20:59'!
testTranslateAndRotate1
	
	"self new testTranslateAndRotate1"
	
	| b c ts element rotX rotZ transX tos tis pi riZ riX |
	b := self builder.
	element := b newElementFrom: Box new.
	rotX := b newTransformOn: element.
	rotZ := b newTransformOn: rotX.
	transX := b newTransformOn: rotZ.
	b add: transX.
	b add: ( tos := b newTouchSensor ).
	b add: ( tis :=  b newTimeSensor cycleInterval: 3 ).
	b add: ( pi := b newPositionInterpolatorFrom: ( 0,0,0 to: 4.5,0,0 by: 0.5,0,0) ).
	b add: ( riZ := b newRotationInterpolatorFrom: (0 to: 90 rad by: 10 rad) axis: 0,0,1 ).
	b add: ( riX := b newRotationInterpolatorFrom: (0 to: 90 rad by: 10 rad) axis: 1,0,0 ).

	b whenTouching: tos start: tis.
	b whenFractionChanging: tis translate: transX using: pi.
	b whenFractionChanging: tis rotate: rotZ using: riZ.
	b whenFractionChanging: tis rotate: rotX using: riX.

	b writeToFile: 'translateAndRotate1'! !

!TestVRMLScenes methodsFor: 'tests' stamp: 'emm 9/29/2012 17:34'!
testTrueType1
	"self new testTrueType1"

"
	| b arial char zPoints |
	b := SceneBuilder vrml.

	arial := TTFontReader parseFileNamed:'c:\windows\fonts\arial.ttf'.
	char := arial at: $P.
	 b color: Color red.
	char contours do: [ :each |
		zPoints := each collect:[ :other | other , 0 ].
		b add: (Polyline3D withAll: zPoints) ].

	b add: (Camera at: 100,0,0 lookingAt: 0,0,0).
	b writeToFile: 'testTrueType1'
"! !

!TestVRMLScenes methodsFor: 'building' stamp: 'emm 03/09/2012 20:59'!
writeToFile: aString
	builder writeToFile: aString! !

!Point class methodsFor: '*Zenna-Structures3D' stamp: 'emm 02/09/2012 23:11'!
quadrantNameForX: x y: y

	^x < 0
		ifTrue: [ y < 0
			ifTrue: [ #backLeft ]
			ifFalse: [ #backRight ] 
		ifFalse: [ y < 0
			ifTrue: [ #frontLeft ] 
			ifFalse: [ #frontRight ]]]! !

!Point class methodsFor: '*Zenna-TaggedData' stamp: 'emm 24/10/2002 14:22'!
readFromTagValueString: pointString
	"self readFromTagValueString: '123.12@ -45'
	"
	
	| at |
	at := pointString indexOf: $@.
	^self 
		x: (Number readFromTagValueString:(pointString copyFrom: 1 to: at - 1))
		y: (Number readFromTagValueString:(pointString copyFrom: at+1 to: pointString size))! !

!Point class methodsFor: '*Zenna-Extensions' stamp: 'emm 9/22/2012 21:28'!
zero
	^Point x:0 y:0! !

!Point methodsFor: '*Zenna-Extensions' stamp: 'emm 02/09/2012 23:11'!
, aNumber 

	^Point3D
		x: x
		y: y
		z: aNumber! !

!Point methodsFor: '*Zenna-Extensions' stamp: 'emm 9/28/2012 00:06'!
,- aSmallInteger 
	"Because scanner incompat"
	^Point3D x: x y: y z: aSmallInteger negated! !

!Point methodsFor: '*Zenna-Extensions' stamp: 'emm 02/09/2012 23:11'!
@ aNumber 

	^Point3D
		x: x
		y: y
		z: aNumber! !

!Point methodsFor: '*Zenna-Extensions' stamp: 'emm 02/09/2012 22:51'!
asIntegerPoint
	^ x asInteger @ y asInteger! !

!Point methodsFor: '*Zenna-Extensions' stamp: 'emm 02/09/2012 23:11'!
asPoint3D

	^self @ 0 ! !

!Point methodsFor: '*Zenna-Extensions' stamp: 'emm 02/09/2012 23:50'!
canBeLabeled
	^false! !

!Point methodsFor: '*Zenna-TaggedData' stamp: 'emm 09/07/2003 14:53'!
printTaggedWith: aWriter

	self x printOn: aWriter stream.
	aWriter stream space; nextPut: $@; space.
	self y printOn: aWriter stream.! !

!Point methodsFor: '*Zenna-Extensions' stamp: 'emm 02/09/2012 23:11'!
productFromPoint3D: aPoint 

	^self @ 1 * aPoint! !

!Point methodsFor: '*Zenna-Extensions' stamp: 'emm 02/09/2012 23:11'!
quadrantName

	^self class quadrantNameForX: x y: y! !

!Point methodsFor: '*Zenna-Extensions' stamp: 'emm 9/22/2012 23:16'!
rotatedBy: radians 
	"From PhilemonKernelExtensions"
	
	| sinVal cosVal |
	sinVal := radians negated sin.
	cosVal := radians negated cos.
	^self class x: cosVal * ( self x ) + ( sinVal * ( self y ) ) y: ( cosVal * ( self y ) - ( sinVal * ( self x ) ) )! !

!Point methodsFor: '*Zenna-Extensions' stamp: 'emm 10/18/2012 16:15'!
x: num
	"modifies the receiver"
	x := num! !

!Point methodsFor: '*Zenna-Extensions' stamp: 'emm 10/18/2012 16:15'!
y: num
	"modifies the receiver"
	y := num! !

!TranslucentColor methodsFor: '*Zenna-Extensions' stamp: 'emm 9/23/2012 22:47'!
transparency
	^alpha 
	! !

!Boolean class methodsFor: '*Zenna-Extensions' stamp: 'emm 12/12/2002 22:32'!
fromString: aString
	^aString first asLowercase = $t! !

!Boolean methodsFor: '*Zenna-Extensions' stamp: 'emm 21/02/2003 14:45'!
tagValueReaderClass
	"Answer the class that can read the string representation of the receiver
	using the method MyClass class>>readFromTagValueString: "
	
	^Boolean! !

!BlockClosure methodsFor: '*Zenna-Extensions' stamp: 'emm 9/22/2012 22:25'!
whenErrorDo: oneArgBlock
	"TODO: change senders of this"
	^self on: Error do: oneArgBlock ! !

Object subclass: #AnimationEngine
	instanceVariableNames: 'timeSensors timeInterval'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Animation3D'!

!AnimationEngine class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:29'!
new

	"Answer a new instance of the receiver and initialize it"

	^super new initialize! !

!AnimationEngine methodsFor: 'adding' stamp: 'emm 02/09/2012 23:29'!
addTimeSensor: aTimeSensor

	^ timeSensors add: aTimeSensor! !

!AnimationEngine methodsFor: 'initialize-release' stamp: 'emm 02/09/2012 23:29'!
initialize
	
	timeSensors := OrderedCollection new.
	timeInterval := 0 to: 1 by: 0.1 "seconds"! !

!AnimationEngine methodsFor: 'control' stamp: 'emm 02/09/2012 23:29'!
run

	self simulateTimeInterval: self timeInterval! !

!AnimationEngine methodsFor: 'private' stamp: 'emm 02/09/2012 23:29'!
simulateTimeInterval: anInterval

	anInterval do:[ :time | self timeSensors do:[ :each | each handleTickAt: time ]]! !

!AnimationEngine methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:29'!
timeInterval

	"Answer the value of timeInterval"

	^timeInterval! !

!AnimationEngine methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:29'!
timeInterval: aValue

	"Set the value of timeInterval"

	timeInterval := aValue! !

!AnimationEngine methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:29'!
timeSensors

	"Answer the value of timeSensors"

	^timeSensors! !

!AnimationEngine methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:29'!
timeSensors: aValue

	"Set the value of timeSensors"

	timeSensors := aValue! !

Object subclass: #AnimationTaskScheduler
	instanceVariableNames: 'tasks'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Animation3D'!

!AnimationTaskScheduler methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:29'!
addTo: aContainer! !

!AnimationTaskScheduler methodsFor: 'obsolete' stamp: 'emm 02/09/2012 23:29'!
at: when send: how with: what to: whom! !

!AnimationTaskScheduler methodsFor: 'obsolete' stamp: 'emm 02/09/2012 23:29'!
at: when start: what! !

!AnimationTaskScheduler methodsFor: 'obsolete' stamp: 'emm 02/09/2012 23:29'!
cycleInterval: aTime

	"This value should be computed from the list of tasks of the receiver"! !

Object subclass: #BinarySearchNode
	instanceVariableNames: 'left right value key'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-FormatVRML'!

!BinarySearchNode class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:54'!
fromSortedCollection: aCollection

	| root |
	root := nil.
	aCollection binaryOrderDo:[ :i |
		root isNil
			ifTrue: [ root := self new key: i ]
			ifFalse: [ root insert: ( self new key: i) ]].
	^root! !

!BinarySearchNode class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:54'!
withAll: aCollection

	^self fromSortedCollection: aCollection asSortedCollection! !

!BinarySearchNode methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:54'!
at: aKey
	
	^self at: aKey ifAbsent: [ self error: 'absent key' ]! !

!BinarySearchNode methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:54'!
at: aKey ifAbsent: aBlock

	^(self nodeAt: aKey ifAbsent:[ ^aBlock value] ) value
! !

!BinarySearchNode methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:54'!
at: aKey put: aValue

	(self nodeAt: aKey ifAbsent:[^nil]) value: aValue.
	^aValue
! !

!BinarySearchNode methodsFor: 'inserting' stamp: 'emm 02/09/2012 23:54'!
insert: aNode

		aNode key = key
			ifTrue: [ ^self ].
		aNode key < key
			ifTrue: 	
				[ left isNil
					ifTrue: [ left := aNode ]
					ifFalse: [ left := left insert: aNode ] ]
			ifFalse: 
				[ right isNil
					ifTrue: [ right := aNode ]
					ifFalse: [ right := right insert: aNode ] ]! !

!BinarySearchNode methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:54'!
key

	"Answer the value of key"

	^key! !

!BinarySearchNode methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:54'!
key: aValue

	"Set the value of key"

	key := aValue! !

!BinarySearchNode methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:54'!
left

	"Answer the value of left"

	^left! !

!BinarySearchNode methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:54'!
left: aValue

	"Set the value of left"

	left := aValue.
	aValue isNil
		ifFalse: [ aValue top: self ]! !

!BinarySearchNode methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:54'!
nodeAt: aKey ifAbsent: aBlock

	aKey = key
		ifTrue: [ ^self ].
	aKey < key
		ifTrue: 
			[ left isNil
				ifTrue: [ ^aBlock value ] 
				ifFalse: [ ^left nodeAt: aKey ifAbsent: aBlock ] ].
	"aKey > key"
	right isNil
		ifTrue: [ ^aBlock value ].
	^right nodeAt: aKey ifAbsent: aBlock
! !

!BinarySearchNode methodsFor: 'printing' stamp: 'emm 02/09/2012 23:54'!
printOn: aStream

	self printSourceOn: aStream indent: 0! !

!BinarySearchNode methodsFor: 'printing' stamp: 'emm 02/09/2012 23:54'!
printSourceOn: aStream indent: level 
	
	self 
		printSourceOn: aStream 
		indent: level 
		valuePrintBlock: [ :stream :v | v printOn: stream ]! !

!BinarySearchNode methodsFor: 'printing' stamp: 'emm 02/09/2012 23:54'!
printSourceOn: aStream indent: level valuePrintBlock: printBlock
	
	level timesRepeat: [ aStream tab ]. 
	
	left isNil
		ifTrue:
			[ aStream nextPutAll: 'if ( key = '
				; print: key
				; nextPutAll: ') {'
				; cr.
			printBlock value: key value: value ]
		ifFalse:
			[ aStream nextPutAll: 'if ( key < '
				; print: key
				; nextPutAll: ') {'
				; cr.
			left printSourceOn: aStream indent: level + 1 valuePrintBlock: printBlock ]. 
	
	level timesRepeat: [ aStream tab ].
	aStream nextPut: $}. 

	right isNil
		ifTrue:
			[ left isNil 
				ifFalse:
					[ aStream nextPutAll: ' else if ( key = '
						; print: key
						; nextPutAll: ') {'
						; cr.
					printBlock value: key value: value.
					level timesRepeat: [ aStream tab ].
					aStream nextPut: $} ] ]
		ifFalse:
			[ aStream nextPutAll: ' else if ( key > '
				; print: key
				; nextPutAll: ') {'
				; cr.
			right printSourceOn: aStream indent: level + 1 valuePrintBlock: printBlock.
			level timesRepeat: [ aStream tab ].
			aStream nextPut: $} ]. 
	
	( left notNil
		and: [ right notNil ] ) 
		ifTrue:
			[ aStream nextPutAll: ' else {' ;cr.
			printBlock value: key value: value.
			level timesRepeat: [ aStream tab ].
			aStream nextPut: $} ].

	aStream cr.! !

!BinarySearchNode methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:54'!
right

	"Answer the value of right"

	^right! !

!BinarySearchNode methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:54'!
right: aValue

	"Set the value of right"

	right := aValue.
	aValue isNil
		ifFalse: [ aValue top: self ]! !

!BinarySearchNode methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:54'!
value

	"Answer the value of value"

	^value! !

!BinarySearchNode methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:54'!
value: aValue

	"Set the value of value"

	value := aValue! !

BinarySearchNode subclass: #VRMLTaskControlNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-FormatVRML'!

!VRMLTaskControlNode class methodsFor: 'examples' stamp: 'emm 02/09/2012 23:54'!
example0
	"self example0"

	^self testFromSortedCollection: ( 0 to: 10 by: 2) asSortedCollection! !

!VRMLTaskControlNode class methodsFor: 'examples' stamp: 'emm 02/09/2012 23:54'!
testFromSortedCollection: aCollection

	| root |
	root := nil.
	aCollection binaryOrderDo:[ :i |
		root isNil
			ifTrue: [ root := self new key: i  ;value: (Array with: (VRMLTask new actionSource: i printString))]
			ifFalse: [ root insert: ( self new key: i ;value: (Array with: (VRMLTask new actionSource: i printString))) ]].
	^root! !

!VRMLTaskControlNode methodsFor: 'printing' stamp: 'emm 02/09/2012 23:54'!
printEndIfOn: aStream indent: level
	
	level timesRepeat: [ aStream tab ].
	aStream nextPut: $}.! !

!VRMLTaskControlNode methodsFor: 'printing' stamp: 'emm 02/09/2012 23:54'!
printEqualsTicksOn: aStream

	aStream nextPutAll: 'if (ticks=='
		; print: key
		; nextPutAll: '){'
		; cr.! !

!VRMLTaskControlNode methodsFor: 'printing' stamp: 'emm 02/09/2012 23:54'!
printFlatSourceOn: aStream 

	self printEqualsTicksOn: aStream.
	self printValueOn: aStream indent: 0.
	aStream nextPutAll: 'return(0); ' ;cr.
	self printEndIfOn: aStream indent: 0.
	
	left isNil 
		ifFalse:
			[ left printFlatSourceOn: aStream ].
	right isNil 
		ifFalse:
			[ right printFlatSourceOn: aStream ]. 
	
	aStream cr! !

!VRMLTaskControlNode methodsFor: 'printing' stamp: 'emm 02/09/2012 23:54'!
printGreaterThanTicksOn: aStream

	aStream nextPutAll: 'if (ticks>'
		; print: key
		; nextPutAll: '){'
		; cr.! !

!VRMLTaskControlNode methodsFor: 'printing' stamp: 'emm 02/09/2012 23:54'!
printLessThanTicksOn: aStream

	aStream nextPutAll: 'if (ticks<'
		; print: key
		; nextPutAll: '){'
		; cr.! !

!VRMLTaskControlNode methodsFor: 'printing' stamp: 'emm 02/09/2012 23:54'!
printSourceOn: aStream indent: level

	| needElse |	
	needElse := false.
	level timesRepeat: [ aStream tab ]. 
	
	" < "
	left isNil
		ifFalse:
			[ self printLessThanTicksOn: aStream.
			left printSourceOn: aStream indent: level + 1.
			self printEndIfOn: aStream indent: level.
			needElse := true ]. 
	" > "
	right isNil
		ifFalse:
			[ needElse ifTrue: [ aStream nextPutAll: ' else '].
			self printGreaterThanTicksOn: aStream.
			right printSourceOn: aStream indent: level + 1.
			self printEndIfOn: aStream indent: level.
			needElse := true ]. 
	" = "
	needElse 
		ifTrue: [ aStream nextPutAll: ' else '].
	self printEqualsTicksOn: aStream.
	self printValueOn: aStream indent: level + 1.
	self printEndIfOn: aStream indent: level.

	aStream cr.! !

!VRMLTaskControlNode methodsFor: 'printing' stamp: 'emm 02/09/2012 23:54'!
printValueOn: aStream indent: level 
	
	self value isNil ifTrue: [ ^aStream nextPutAll: '" empty "' ].
	self value 
		do: [ :task | 
			level timesRepeat: [ aStream tab ].
			task printSourceOn: aStream.
			aStream nextPut: $; ;cr ]! !

Object subclass: #BitPattern2D
	instanceVariableNames: 'points bounds'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Core2D'!

!BitPattern2D class methodsFor: 'examples' stamp: 'emm 04/08/2002 13:28'!
example0
	"self example0"

	^( self fromBitString: 
'0001
1111' ) rotatedBy: -90! !

!BitPattern2D class methodsFor: 'examples' stamp: 'emm 04/08/2002 13:28'!
example1
	"self example1"

	 | p |
	p := self fromBitString: 
'0001
1111'.
	p coversPattern: ( p rotatedBy: -90 ).
	^p subtract: p copy! !

!BitPattern2D class methodsFor: 'examples' stamp: 'emm 04/08/2002 13:28'!
fromBitString: aStringWithSeparators

	| strings inStream |
	strings := OrderedCollection new.
	inStream := ReadStream on: aStringWithSeparators.
	[inStream atEnd]
		whileFalse:
			[strings add: inStream nextLine].
	^self fromBitStrings: strings
	
			! !

!BitPattern2D class methodsFor: 'examples' stamp: 'emm 10/18/2012 16:26'!
fromBitStrings: aZeroOneStringCollection

	"self fromBitStrings: #( '1001' '' '' '1001' )"

	| points zeroOneString |
	points := OrderedPoint2DCollection new.
	0 to: aZeroOneStringCollection size - 1 do:[ :y |
		zeroOneString :=  aZeroOneStringCollection at: y + 1.
		0 to: zeroOneString size - 1 do:[ :x |
			 ( zeroOneString at: x + 1) == $1
					ifTrue: [ points add: x  @ (aZeroOneStringCollection size - y - 1 )  ]]].
	^self new points: points
			

			! !

!BitPattern2D methodsFor: 'testing' stamp: 'emm 08/10/1999 21:27'!
bitSetAt: aPoint

	^points includes: aPoint! !

!BitPattern2D methodsFor: 'accessing' stamp: 'emm 08/10/1999 21:27'!
bounds

	bounds isNil
		ifTrue: [ bounds := self computeBounds ].
	^bounds! !

!BitPattern2D methodsFor: 'computing' stamp: 'emm 08/10/1999 21:27'!
computeBounds
	
	| corner origin |
	corner := self points 
		inject: ( SmallInteger minVal @ SmallInteger minVal ) 
		into: [ :max :each | max max: each ].
	origin := self points 
		inject: corner 
		into: [ :min :each | min min: each ].
	^Rectangle origin: origin corner: corner! !

!BitPattern2D methodsFor: 'copying' stamp: 'emm 08/10/1999 21:27'!
copy

	^super copy points: points copy! !

!BitPattern2D methodsFor: 'testing' stamp: 'emm 08/10/1999 21:27'!
coversPattern: aPattern

	^( self bounds areaIncludesPoint: aPattern bounds origin )
		and:[self bounds areaIncludesPoint: aPattern bounds corner]! !

!BitPattern2D methodsFor: 'testing' stamp: 'emm 08/10/1999 21:27'!
coversPattern: aPattern offset: offset

	^( self bounds areaIncludesPoint: ( aPattern bounds origin + offset ) )
		and:[self bounds areaIncludesPoint: ( aPattern bounds corner + offset ) ]! !

!BitPattern2D methodsFor: 'testing' stamp: 'emm 08/10/1999 21:27'!
insideSubstract: aPattern offset: offset

	aPattern points xyDo:[ :x :y  |
		points removeX: x + offset x y: y + offset y ]
		! !

!BitPattern2D methodsFor: 'computing' stamp: 'emm 08/10/1999 21:27'!
intersect: aBitPattern2D

	^self collection intersect: aBitPattern2D collection
		! !

!BitPattern2D methodsFor: 'testing' stamp: 'emm 08/10/1999 21:27'!
intersects: aBitPattern2D

	^self points intersects: aBitPattern2D points
		! !

!BitPattern2D methodsFor: 'testing' stamp: 'emm 08/10/1999 21:27'!
intersects: aBitPattern2D offset: offset

	^self points intersects: aBitPattern2D points offsetX: offset x y: offset y
		! !

!BitPattern2D methodsFor: 'testing' stamp: 'emm 08/10/1999 21:27'!
merge: aPattern

	bounds := nil.
	points addAll: aPattern points! !

!BitPattern2D methodsFor: 'testing' stamp: 'emm 08/10/1999 21:27'!
merge: aPattern offset: offset 
	
	| newOrigin newCorner newPoint |
	( ( self bounds origin <= ( aPattern bounds origin + offset ) )
		and: [ ( aPattern bounds corner + offset ) <= self bounds corner ] )
		ifTrue: 
			[ aPattern points xyDo: [ :x :y | points addX: x + offset x y: y + offset y ] ]
		ifFalse: 
			[ newOrigin := self bounds origin.
			newCorner := self bounds corner.
			aPattern points xyDo: [ :x :y | 
				newPoint := x + offset @ ( y + offset y ).
				newOrigin := newOrigin min: newPoint.
				newCorner := newCorner max: newPoint.
				points add: newPoint ].
			bounds := newOrigin corner: newCorner ]! !

!BitPattern2D methodsFor: 'enumerating' stamp: 'emm 16/01/2000 12:08'!
onesDo: aBlock

	self points do: aBlock! !

!BitPattern2D methodsFor: 'accessing' stamp: 'emm 08/10/1999 21:27'!
points

	"Answer the value of points"

	^points! !

!BitPattern2D methodsFor: 'accessing' stamp: 'emm 08/10/1999 21:27'!
points: aValue

	"Set the value of points"

	points := aValue. 
	bounds := nil! !

!BitPattern2D methodsFor: 'converting' stamp: 'emm 08/10/1999 21:27'!
rotatedBy90

	^self class new
		points: ( self points collect:[ :each | each y negated , each x  ] )! !

!BitPattern2D methodsFor: 'converting' stamp: 'emm 08/10/1999 21:27'!
rotatedBy: degrees

	"Degrees must be multiple of 90"

	| positiveDegrees result |
	positiveDegrees := degrees.
	[ positiveDegrees < 0 ]
		whileTrue:[ positiveDegrees := positiveDegrees + 360 ].
	positiveDegrees = 0
		ifTrue: [ ^self copy ].
	result := self.
	[ result := result rotatedBy90.
	positiveDegrees := positiveDegrees - 90.
	positiveDegrees = 0 ] 
		whileFalse:[].
	^result! !

!BitPattern2D methodsFor: 'testing' stamp: 'emm 08/10/1999 21:27'!
substract: aPattern offset: offset

	bounds := nil.
	aPattern points xyDo:[ :x :y  |
		points removeX: x + offset x y: y + offset y ]
		! !

!BitPattern2D methodsFor: 'testing' stamp: 'emm 20/02/2001 11:51'!
subtract: aPattern

	bounds := nil.
	points removeAll: aPattern points! !

!BitPattern2D methodsFor: 'enumerating' stamp: 'emm 08/10/1999 21:27'!
unsetPositionsXYDo: xyBlock startingAtX: x y: y

	| thisX thisY maxX maxY |
	thisX := x.
	thisY := y.
	maxX := self bounds corner x.
	maxY := self bounds corner y.
	[ thisY <= maxY ]
		whileTrue:
			[ [ thisX <= maxX ]
				whileTrue:
					[ ( points includesX: thisX y: thisY )
						ifFalse: [ xyBlock value: thisX value: thisY ].
					thisX := thisX + 1 ].
			thisX := self bounds origin x.
			thisY := thisY + 1]! !

!BitPattern2D methodsFor: 'enumerating' stamp: 'emm 16/01/2000 12:09'!
zerosDo: aBlock

	self 
		unsetPositionsXYDo:[ :x :y | aBlock value: x @ y ]
		startingAtX: 0 y: 0! !

Object subclass: #CameraPath
	instanceVariableNames: 'originPath focusPath rollAngles label frameCount duration'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Appearance3D'!

!CameraPath class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:44'!
new

	"Answer a new instance of the receiver and initialize it"

	^super new initialize! !

!CameraPath methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:44'!
duration

	"Answer the value of duration"

	^duration! !

!CameraPath methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:44'!
duration: aValue

	"Set the value of duration"

	duration := aValue! !

!CameraPath methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:44'!
focusPath

	"Answer the value of focusPath"

	^focusPath! !

!CameraPath methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:44'!
focusPath: aValue

	"Set the value of focusPath"

	focusPath := aValue! !

!CameraPath methodsFor: 'computing' stamp: 'emm 02/09/2012 23:44'!
focusPointAtFraction: fraction

	^self focusPath computeVertexAtFraction: fraction! !

!CameraPath methodsFor: 'computing' stamp: 'emm 02/09/2012 23:44'!
focusPointsFromFractions: aFractionCollection

	^aFractionCollection collect:[ :fraction | self focusPath computeVertexAtFraction: fraction ]! !

!CameraPath methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:44'!
frameCount

	"Answer the value of frameCount"

	^frameCount! !

!CameraPath methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:44'!
frameCount: aValue

	"Set the value of frameCount"

	frameCount := aValue! !

!CameraPath methodsFor: 'initialize-release' stamp: 'emm 02/09/2012 23:44'!
initialize
	
	self label: 'circling around zero'.
	self originPath: (Circle3D center: 0,0,0 radius: 10).
	self focusPath: (LineSegment3D between: 0,0,0 and: 0,0,0).
	self rollAngles: #(0).
	self duration: 10.
	self frameCount: 30.! !

!CameraPath methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:44'!
kindDo: aRequestor
	
	^aRequestor doCameraPath: self! !

!CameraPath methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:44'!
label

	"Answer the value of label"

	^label! !

!CameraPath methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:44'!
label: aValue

	"Set the value of label"

	label := aValue! !

!CameraPath methodsFor: 'computing' stamp: 'emm 02/09/2012 23:44'!
originAtFraction: fraction

	^self originPath computeVertexAtFraction: fraction! !

!CameraPath methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:44'!
originPath

	"Answer the value of originPath"

	^originPath! !

!CameraPath methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:44'!
originPath: aValue

	"Set the value of originPath"

	originPath := aValue! !

!CameraPath methodsFor: 'computing' stamp: 'emm 02/09/2012 23:44'!
originsFromFractions: aFractionCollection

	^aFractionCollection collect:[ :fraction | self originPath computeVertexAtFraction: fraction ]! !

!CameraPath methodsFor: 'computing' stamp: 'emm 02/09/2012 23:44'!
rollAngleAtFraction: fraction

	"fraction = [0..1]"

	^self rollAngles computeAtFraction: fraction! !

!CameraPath methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:44'!
rollAngles

	"Answer the value of rollAngles"

	^rollAngles! !

!CameraPath methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:44'!
rollAngles: aValue

	"Set the value of rollAngles"

	rollAngles := aValue! !

!CameraPath methodsFor: 'computing' stamp: 'emm 02/09/2012 23:44'!
rollAnglesFromFractions: aFractionCollection

	^aFractionCollection collect:[ :fraction | self rollAngleAtFraction: fraction ]! !

Object subclass: #CollectionBasedInterpolator
	instanceVariableNames: 'geometric collection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Operators3D'!

!CollectionBasedInterpolator class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:47'!
on: aGeometric
	^self new geometric: aGeometric! !

!CollectionBasedInterpolator methodsFor: 'collection-API' stamp: 'emm 02/09/2012 23:47'!
at: index

	^geometric computeVertexAt: ( self collection at: index )! !

!CollectionBasedInterpolator methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:47'!
collection

	"Answer the value of collection"

	^collection! !

!CollectionBasedInterpolator methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:47'!
collection: aValue

	"Set the value of collection"

	collection := aValue! !

!CollectionBasedInterpolator methodsFor: 'collection-API' stamp: 'emm 02/09/2012 23:47'!
do: aBlock

	self verticesDo: aBlock! !

!CollectionBasedInterpolator methodsFor: 'computing' stamp: 'emm 02/09/2012 23:47'!
facesDo: aBlock

	| paramStream lastParam nextParam |
	paramStream := ReadStream on: self collection.
	lastParam := paramStream next.
	[paramStream atEnd]
		whileFalse:
			[ nextParam := paramStream next.
			aBlock value: (geometric computeFaceBetween: lastParam and: nextParam ).
			lastParam := nextParam].! !

!CollectionBasedInterpolator methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:47'!
geometric
	^geometric! !

!CollectionBasedInterpolator methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:47'!
geometric: aGeometric
	geometric := aGeometric! !

!CollectionBasedInterpolator methodsFor: 'inspecting' stamp: 'emm 02/09/2012 23:47'!
inspectActions

	^#(vertices)! !

!CollectionBasedInterpolator methodsFor: 'computing' stamp: 'emm 02/09/2012 23:47'!
pairsDo: twoArgBlock

	self pairIterator do: twoArgBlock! !

!CollectionBasedInterpolator methodsFor: 'computing' stamp: 'emm 02/09/2012 23:47'!
segmentsDo: aBlock 

	"Do not assume that the geometric is closed ;i.e do not include an edge 
	between the first and the last point"
	
	| angleStream last next |
	angleStream := self collection readStream.
	last := self geometric computeVertexAt: angleStream next.
	[ angleStream atEnd ]
		whileFalse: 
			[ next := self geometric computeVertexAt: angleStream next.
			aBlock value: ( LineSegment3D from: last to: next ).
			last := next ]! !

!CollectionBasedInterpolator methodsFor: 'collection-API' stamp: 'emm 02/09/2012 23:47'!
size

	^self collection size! !

!CollectionBasedInterpolator methodsFor: 'computing' stamp: 'emm 02/09/2012 23:47'!
solidsDo: aBlock

	| paramStream lastParam nextParam |
	paramStream := ReadStream on: self collection.
	lastParam := paramStream next.
	[paramStream atEnd]
		whileFalse:
			[ nextParam := paramStream next.
			aBlock value: (geometric computeSolidBetween: lastParam and: nextParam ).
			lastParam := nextParam].! !

!CollectionBasedInterpolator methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:47'!
step: incrementValue

	self collection: ( self collection first to: self collection last by: incrementValue )! !

!CollectionBasedInterpolator methodsFor: 'computing' stamp: 'emm 02/09/2012 23:47'!
vertices
	| points |
	points := OrderedPoint3DCollection new.
	self verticesDo:[ :p | points add: p ].
	^points! !

!CollectionBasedInterpolator methodsFor: 'computing' stamp: 'emm 02/09/2012 23:47'!
verticesDo: aBlock

	self collection do:[ :param | aBlock value: (geometric computeVertexAt: param ) ]! !

!CollectionBasedInterpolator methodsFor: 'computing' stamp: 'emm 02/09/2012 23:47'!
verticesDoWithParameter: aBlock

	self collection do:[ :param | aBlock value: (geometric computeVertexAt: param ) value: param ]! !

CollectionBasedInterpolator subclass: #DoubleCollectionBasedInterpolator
	instanceVariableNames: 'secondCollection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Operators3D'!

!DoubleCollectionBasedInterpolator methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:48'!
addVerticesTo: aVertexCollection 

	collection do: [:param1 | 
		secondCollection do: [:param2 | 
			geometric
				addVertexAt: param1
				at: param2
				to: aVertexCollection]]! !

!DoubleCollectionBasedInterpolator methodsFor: 'computing' stamp: 'emm 02/09/2012 23:48'!
facesDo: aBlock

	 '>> facesDo: - missing' echo! !

!DoubleCollectionBasedInterpolator methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:48'!
secondCollection

	"Answer the value of secondCollection"

	^secondCollection! !

!DoubleCollectionBasedInterpolator methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:48'!
secondCollection: aValue

	"Set the value of secondCollection"

	secondCollection := aValue! !

!DoubleCollectionBasedInterpolator methodsFor: 'computing' stamp: 'emm 02/09/2012 23:48'!
segmentsDo: aBlock 

	| inStream fromVertex toVertex |
	self collection do: [:param1 | 
		inStream := secondCollection readStream.
		inStream atEnd
			ifFalse: [fromVertex := geometric computeVertexAt: param1 at: inStream next].
		[inStream atEnd]
			whileFalse: 
				[toVertex := geometric computeVertexAt: param1 at: inStream next.
				(fromVertex coincidesWith: toVertex)
					ifFalse: [aBlock value: (LineSegment3D from: fromVertex to: toVertex)].
				fromVertex := toVertex]]! !

!DoubleCollectionBasedInterpolator methodsFor: 'computing' stamp: 'emm 02/09/2012 23:48'!
trianglesDo: aBlock! !

!DoubleCollectionBasedInterpolator methodsFor: 'computing' stamp: 'emm 02/09/2012 23:48'!
verticesDo: aBlock

	self collection do:[ :param1 |
		secondCollection do:[ :param2 |
			aBlock value: (geometric computeVertexAt: param1 at: param2) ]]! !

Object subclass: #CollectionFilter3D
	instanceVariableNames: 'collection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Operators3D'!

!CollectionFilter3D class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:47'!
on: aCollection

	^self new initialize collection: aCollection! !

!CollectionFilter3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:47'!
collection

	"Answer the value of collection"

	^collection! !

!CollectionFilter3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:47'!
collection: aValue

	"Set the value of collection"

	collection := aValue! !

!CollectionFilter3D methodsFor: 'initialize-release' stamp: 'emm 02/09/2012 23:47'!
initialize

	collection := OrderedCollection new! !

CollectionFilter3D subclass: #OctantsContainmentFilter
	instanceVariableNames: 'octantNames'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Operators3D'!

!OctantsContainmentFilter methodsFor: 'adding' stamp: 'emm 02/09/2012 23:48'!
add: aPoint 
	"Add <aPoint> to the receiver's collection if it is contained
	by one of the receiver's octants"

	(octantNames includes: aPoint octantName)
		ifTrue: [self collection add: aPoint].
	^aPoint! !

!OctantsContainmentFilter methodsFor: 'adding' stamp: 'emm 02/09/2012 23:48'!
addX: x y: y z: z 
	"Add <x,y,z> to the receiver's collection if it is contained
	by one of the receiver's octants"

	(octantNames includes: (Point3D
			octantNameForX: x
			y: y
			z: z))
		ifTrue: [self collection
				addX: x
				y: y
				z: z]! !

!OctantsContainmentFilter methodsFor: 'initialize-release' stamp: 'emm 02/09/2012 23:48'!
initialize

	super initialize.
	self rejectNone! !

!OctantsContainmentFilter methodsFor: 'properties' stamp: 'emm 02/09/2012 23:48'!
passOctant: aName 

	octantNames := octantNames copyWith: aName! !

!OctantsContainmentFilter methodsFor: 'properties' stamp: 'emm 02/09/2012 23:48'!
rejectAll

	octantNames := #()! !

!OctantsContainmentFilter methodsFor: 'properties' stamp: 'emm 02/09/2012 23:48'!
rejectNone

	octantNames := BoundingBox new centering vertices collect: [:each | each octantName]! !

!OctantsContainmentFilter methodsFor: 'properties' stamp: 'emm 02/09/2012 23:48'!
rejectOctant: aName 

	octantNames := octantNames copyWithout: aName! !

CollectionFilter3D subclass: #SingleOccurrencePoint3DFilter
	instanceVariableNames: 'set'
	classVariableNames: 'Point3DPrototype'
	poolDictionaries: ''
	category: 'Zenna-Operators3D'!

!SingleOccurrencePoint3DFilter class methodsFor: 'class-initialization' stamp: 'emm 02/09/2012 23:48'!
initialize

	Point3DPrototype := Point3D zero! !

!SingleOccurrencePoint3DFilter class methodsFor: 'class-initialization' stamp: 'emm 02/09/2012 23:48'!
release

	Point3DPrototype := nil! !

!SingleOccurrencePoint3DFilter methodsFor: 'adding-removing' stamp: 'emm 02/09/2012 23:48'!
add: aPoint 

	(set includes: aPoint)
		ifFalse: 
			[set add: aPoint.
			collection add: aPoint]! !

!SingleOccurrencePoint3DFilter methodsFor: 'adding-removing' stamp: 'emm 02/09/2012 23:48'!
addX: x y: y z: z 

	(set includes: (Point3DPrototype
			 x: x; y: y; z: z))
		ifFalse: 
			[set add: Point3DPrototype copy.
			collection
				addX: x
				y: y
				z: z]! !

!SingleOccurrencePoint3DFilter methodsFor: 'initialize-release' stamp: 'emm 02/09/2012 23:48'!
initialize

	super initialize.
	set := Set new! !

!SingleOccurrencePoint3DFilter methodsFor: 'evaluating' stamp: 'emm 02/09/2012 23:48'!
value: aPoint3D 

	self add: aPoint3D! !

Object subclass: #CompositeCurve
	instanceVariableNames: 'segments cachedLength'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Core2D'!

!CompositeCurve class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 22:51'!
new

	"Answer a new instance of the receiver and initialize it"

	^super new initialize! !

!CompositeCurve class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 22:51'!
withAll: aSegmentCollection

	"@aSegmentCollection may contain
		LineSegment2D
		EllipticalArc2D
		Bezier2Segment2D
		Polyline2D
	objects"

	^self new segments: aSegmentCollection! !

!CompositeCurve methodsFor: 'adding' stamp: 'emm 02/09/2012 22:51'!
add: aSegment
	
	"flush"
	cachedLength := nil.
	^ segments add: aSegment! !

!CompositeCurve methodsFor: 'adding' stamp: 'emm 02/09/2012 22:51'!
addAll: aSegmentCollection
	
	"flush"
	cachedLength := nil.
	^ segments addAll: aSegmentCollection! !

!CompositeCurve methodsFor: 'computing' stamp: 'emm 02/09/2012 22:51'!
computeVertexAtFraction: fraction

	"fraction [0..1]"
	"Pre: non empty segments"

	| totalLength segmentStream currentSegment sumSegmentLength fractionStart fractionEnd localFraction |
	fraction = 0
		ifTrue: [ ^self segments first computeVertexAtFraction: 0 ].
	fraction = 1
		ifTrue: [ ^self segments last computeVertexAtFraction: 1 ].
	"fraction = <0..1>"

	totalLength := self length.
	segmentStream := ReadStream on: self segments.
	currentSegment := segmentStream next.
	sumSegmentLength := 0.
	
	[ fractionStart := sumSegmentLength / totalLength.
	fractionEnd := ( sumSegmentLength + currentSegment length ) / totalLength.
	fraction > fractionEnd ]
		whileTrue: 
				[ sumSegmentLength := sumSegmentLength + currentSegment length.
				currentSegment := segmentStream next ].
	localFraction := ( fraction - fractionStart ) / ( fractionEnd - fractionStart ).
	^currentSegment computeVertexAtFraction: localFraction! !

!CompositeCurve methodsFor: 'computing' stamp: 'emm 02/09/2012 22:51'!
computeVerticesWithEquidistance: distanceBetweenVertices

	"Answer an interpolator that provides points
	on the receiver with equal distance @distanceBetweenVertices"
	"Pre: non empty segments"

	|  totalLength segmentStream currentSegment sumSegmentLength
	 fractionIncrement fraction fractionStart fractionEnd localFraction vertices |

	vertices := self segments first pointCollectionClass new.
	totalLength := self length.
	segmentStream := ReadStream on: self segments.
	currentSegment := segmentStream next.
	sumSegmentLength := 0.
	fractionIncrement := distanceBetweenVertices / totalLength.
	fraction := 0.

	"At least add the first point, localFraction = 0"
	vertices add: ( currentSegment computeVertexAtFraction: 0 ).

	[ fraction := fraction + fractionIncrement..
	fraction > 1]
		whileFalse:
			[ 
			[ fractionStart := sumSegmentLength / totalLength.
			fractionEnd := ( sumSegmentLength + currentSegment length ) / totalLength.
			fraction > fractionEnd ]
				whileTrue: 
					[ sumSegmentLength := sumSegmentLength + currentSegment length.
					currentSegment := segmentStream next ].
			localFraction := ( fraction - fractionStart ) / ( fractionEnd - fractionStart ).
			vertices add: ( currentSegment computeVertexAtFraction: localFraction ) ].

	^vertices! !

!CompositeCurve methodsFor: 'initialize-release' stamp: 'emm 02/09/2012 22:51'!
initialize
	
	segments := OrderedCollection new! !

!CompositeCurve methodsFor: 'computing' stamp: 'emm 02/09/2012 22:51'!
length
	
	cachedLength == nil 
		ifTrue:
			[ cachedLength := self segments 
				inject: 0 
				into: [ :sum :each | sum + each length ] ].
	^ cachedLength! !

!CompositeCurve methodsFor: 'accessing' stamp: 'emm 02/09/2012 22:51'!
segments

	"Answer the value of segments"

	^segments! !

!CompositeCurve methodsFor: 'accessing' stamp: 'emm 02/09/2012 22:51'!
segments: aValue

	"Set the value of segments"

	segments := aValue! !

Object subclass: #Cursor2DInterface
	instanceVariableNames: 'stateStack objects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Modelling2D'!

!Cursor2DInterface class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 22:52'!
new

	^super new initialize! !

!Cursor2DInterface methodsFor: 'private-inc-dec' stamp: 'emm 02/09/2012 22:52'!
arcFrom: startPoint to: endPoint around: centerPoint clockwise: isCW
	
	self subclassResponsibility! !

!Cursor2DInterface methodsFor: 'API-arcs' stamp: 'emm 02/09/2012 22:52'!
arcTo: endPoint
	"Add a non-elliptical arc reaching <otherPoint>"

	^self rotatesClockwise
		ifTrue:[ self cwArcTo: endPoint ]
		ifFalse:[ self ccwArcTo: endPoint ]! !

!Cursor2DInterface methodsFor: 'API-relative' stamp: 'emm 02/09/2012 22:52'!
backward: howMuch
	self forward: howMuch negated! !

!Cursor2DInterface methodsFor: 'private' stamp: 'emm 02/09/2012 22:52'!
ccwArcTo: endPoint 
	"Add a non-elliptical arc clockwise to <endPoint>"
	
	| fromX fromY toX toY center |
	fromX := self position x.
	fromY := self position y.
	toX := endPoint x.
	toY := endPoint y.
	toX > fromX
		ifTrue: 
			[ toY > fromY
				ifTrue: [ center := fromX @ toY]
				ifFalse: [ center := toX @ fromY ] ]
		ifFalse: 
			[ toY > fromY
				ifTrue: [ center := toX @ fromY ]
				ifFalse: [ center := fromX @ toY ] ].
	^self 
		arcFrom: self position 
		to: endPoint 
		around: center 
		clockwise: false! !

!Cursor2DInterface methodsFor: 'private' stamp: 'emm 02/09/2012 22:52'!
ccwArcWithX: x y: y
	"Arc counter-clockwise by <x@y>"

	self ccwArcTo: (( self position copy ) incX: x ;incY: y)! !

!Cursor2DInterface methodsFor: 'API-control' stamp: 'emm 02/09/2012 22:52'!
clockwise

	self clockwise: true! !

!Cursor2DInterface methodsFor: 'accessing-state' stamp: 'emm 02/09/2012 22:52'!
clockwise: aBoolean
	self state rotatesClockwise: aBoolean! !

!Cursor2DInterface methodsFor: 'API-control' stamp: 'emm 02/09/2012 22:52'!
counterclockwise

	self clockwise: false! !

!Cursor2DInterface methodsFor: 'private' stamp: 'emm 02/09/2012 22:52'!
cwArcWithX: x y: y
	"Arc clockwise by <x , y>"

	self cwArcTo: ( ( self position copy ) incX: x ;incY: y )! !

!Cursor2DInterface methodsFor: 'private-inc-dec' stamp: 'emm 02/09/2012 22:52'!
decX: aNumber 

	self moveTo: (self position copy decX: aNumber)! !

!Cursor2DInterface methodsFor: 'private-inc-dec' stamp: 'emm 02/09/2012 22:52'!
decX: x decY: y

	self moveTo: ((self position copy) decX: x ;decY: y)! !

!Cursor2DInterface methodsFor: 'private-inc-dec' stamp: 'emm 02/09/2012 22:52'!
decX: x incY: y

	self moveTo: ((self position copy) decX: x ;incY: y)! !

!Cursor2DInterface methodsFor: 'private-inc-dec' stamp: 'emm 02/09/2012 22:52'!
decY: aNumber 

	self moveTo: (self position copy decY: aNumber)! !

!Cursor2DInterface methodsFor: 'accessing-state' stamp: 'emm 02/09/2012 22:52'!
direction

	"Answer the value of direction"

	^self state direction! !

!Cursor2DInterface methodsFor: 'accessing-state' stamp: 'emm 02/09/2012 22:52'!
direction: aValue

	"Set the value of direction"

	self state direction: aValue! !

!Cursor2DInterface methodsFor: 'API-control' stamp: 'emm 02/09/2012 22:52'!
do: zeroBlock
	zeroBlock value! !

!Cursor2DInterface methodsFor: 'API-control' stamp: 'emm 02/09/2012 22:52'!
down
	self visible: true! !

!Cursor2DInterface methodsFor: 'API-control' stamp: 'emm 02/09/2012 22:52'!
downWhile: aBlock

	self down.
	aBlock value.
	self up! !

!Cursor2DInterface methodsFor: 'API-r-theta' stamp: 'emm 02/09/2012 22:52'!
dr: radius dtheta: theta
	
	self dx: theta cos * radius dy: theta sin * radius! !

!Cursor2DInterface methodsFor: 'API-xyz' stamp: 'emm 02/09/2012 22:52'!
dx: aNumber

	aNumber < 0
		ifTrue: [ self decX: aNumber negated * self scale]
		ifFalse: [ self incX: aNumber * self scale]! !

!Cursor2DInterface methodsFor: 'API-xyz' stamp: 'emm 02/09/2012 22:52'!
dx: xNumber dy: yNumber

	xNumber < 0
		ifTrue: [ yNumber < 0
			ifTrue: [ self decX: xNumber negated  * self scale decY: yNumber negated * self scale ] 			
			ifFalse: [ self decX: xNumber negated * self scale  incY: yNumber * self scale ] ]
		ifFalse: [ yNumber < 0
			ifTrue: [ self incX: xNumber * self scale  decY: yNumber negated * self scale  ] 
			ifFalse: [ self incX: xNumber * self scale  incY: yNumber * self scale  ] ]
			! !

!Cursor2DInterface methodsFor: 'API-xyz' stamp: 'emm 02/09/2012 22:52'!
dy: aNumber

	aNumber < 0
		ifTrue: [ self decY: aNumber negated * self scale ]
		ifFalse: [ self incY: aNumber * self scale ]! !

!Cursor2DInterface methodsFor: 'API-control' stamp: 'emm 02/09/2012 22:52'!
follow: aSegment

	| toAdd |
	toAdd := aSegment translatedBy: self position.
	self objects add: toAdd.
	self position: (toAdd computeVertexAtFraction: 1).! !

!Cursor2DInterface methodsFor: 'API-relative' stamp: 'emm 02/09/2012 22:52'!
forward: howMuch

	self direction = #posX
		ifTrue: [^self dx: howMuch].
	self direction = #negX
		ifTrue: [^self dx: howMuch negated].	
	self direction = #posY
		ifTrue: [^self dy: howMuch].		
	self direction = #negY
		ifTrue: [^self dy: howMuch negated].	! !

!Cursor2DInterface methodsFor: 'API-control' stamp: 'emm 02/09/2012 22:52'!
gotoAll: aCollection

	aCollection do:[ :each | self moveTo: each ]! !

!Cursor2DInterface methodsFor: 'private-inc-dec' stamp: 'emm 02/09/2012 22:52'!
incX: aNumber 

	self moveTo: (self position copy incX: aNumber)! !

!Cursor2DInterface methodsFor: 'private-inc-dec' stamp: 'emm 02/09/2012 22:52'!
incX: x decY: y

	self moveTo: ((self position copy) incX: x ;decY: y)! !

!Cursor2DInterface methodsFor: 'private-inc-dec' stamp: 'emm 02/09/2012 22:52'!
incX: x incY: y

	self moveTo: ((self position copy) incX: x ;incY: y)! !

!Cursor2DInterface methodsFor: 'private-inc-dec' stamp: 'emm 02/09/2012 22:52'!
incY: aNumber 

	self moveTo: (self position copy incY: aNumber)! !

!Cursor2DInterface methodsFor: 'initialize-release' stamp: 'emm 02/09/2012 22:52'!
initialize

	objects := OrderedCollection new.
	self stateStack: (OrderedCollection with: self stateClass new).

	"Initialize state"
	self position: self newPointZero.
	self clockwise: true.
	self visible: true "ready to draw"! !

!Cursor2DInterface methodsFor: 'operations' stamp: 'emm 02/09/2012 22:52'!
moveBy: aPoint

	self moveTo: self position + aPoint! !

!Cursor2DInterface methodsFor: 'API-control' stamp: 'emm 02/09/2012 22:52'!
moveTo: aPoint
	
	self position: aPoint! !

!Cursor2DInterface methodsFor: 'resources' stamp: 'emm 02/09/2012 22:52'!
newPointZero
	^0@0! !

!Cursor2DInterface methodsFor: 'accessing' stamp: 'emm 02/09/2012 22:52'!
objects

	"Answer the value of objects"

	^objects! !

!Cursor2DInterface methodsFor: 'accessing' stamp: 'emm 02/09/2012 22:52'!
objects: aValue

	"Set the value of objects"

	objects := aValue! !

!Cursor2DInterface methodsFor: 'accessing-state' stamp: 'emm 02/09/2012 22:52'!
position

	^self state position! !

!Cursor2DInterface methodsFor: 'accessing-state' stamp: 'emm 02/09/2012 22:52'!
position: aPoint

	self state position: aPoint! !

!Cursor2DInterface methodsFor: 'API-control' stamp: 'emm 02/09/2012 22:52'!
returnAfter: aBlock

	stateStack add: self state copy.
	aBlock value.
	stateStack removeLast.! !

!Cursor2DInterface methodsFor: 'accessing-state' stamp: 'emm 02/09/2012 22:52'!
rotatesClockwise
	^self state rotatesClockwise! !

!Cursor2DInterface methodsFor: 'accessing-state' stamp: 'emm 02/09/2012 22:52'!
scale

	"Answer the value of scale"

	^self state scale! !

!Cursor2DInterface methodsFor: 'accessing-state' stamp: 'emm 02/09/2012 22:52'!
scale: aValue

	"Set the value of scale"

	self state scale:  aValue! !

!Cursor2DInterface methodsFor: 'accessing' stamp: 'emm 02/09/2012 22:52'!
state

	"Answer the value of state"

	^self stateStack last! !

!Cursor2DInterface methodsFor: 'accessing' stamp: 'emm 02/09/2012 22:52'!
state: aValue

	"Set the value of state"

	self stateStack addLast: aValue! !

!Cursor2DInterface methodsFor: 'resources' stamp: 'emm 02/09/2012 22:52'!
stateClass

	^Cursor2DState! !

!Cursor2DInterface methodsFor: 'private' stamp: 'emm 02/09/2012 22:52'!
stateStack
	^stateStack! !

!Cursor2DInterface methodsFor: 'private' stamp: 'emm 02/09/2012 22:52'!
stateStack: aCollection
	stateStack := aCollection! !

!Cursor2DInterface methodsFor: 'API-relative' stamp: 'emm 02/09/2012 22:52'!
towardsNegativeX
	self direction: #negX.! !

!Cursor2DInterface methodsFor: 'API-relative' stamp: 'emm 02/09/2012 22:52'!
towardsNegativeY
	self direction: #negY.! !

!Cursor2DInterface methodsFor: 'API-relative' stamp: 'emm 02/09/2012 22:52'!
towardsX
	self direction: #posX.! !

!Cursor2DInterface methodsFor: 'API-relative' stamp: 'emm 02/09/2012 22:52'!
towardsY
	self direction: #posY.! !

!Cursor2DInterface methodsFor: 'API-xyz' stamp: 'emm 02/09/2012 22:52'!
tox: newX

	self dx: newX - (self position x)! !

!Cursor2DInterface methodsFor: 'API-xyz' stamp: 'emm 02/09/2012 22:52'!
toy: newY

	self dy: newY - (self position y)! !

!Cursor2DInterface methodsFor: 'API-control' stamp: 'emm 02/09/2012 22:52'!
up

	self visible: false! !

!Cursor2DInterface methodsFor: 'API-control' stamp: 'emm 02/09/2012 22:52'!
upWhile: aBlock

	self up.
	aBlock value.
	self down! !

!Cursor2DInterface methodsFor: 'accessing-state' stamp: 'emm 02/09/2012 22:52'!
visible

	"Answer the value of visible"

	^self state visible! !

!Cursor2DInterface methodsFor: 'accessing-state' stamp: 'emm 02/09/2012 22:52'!
visible: aValue

	"Set the value of visible"

	self state visible:  aValue! !

Cursor2DInterface subclass: #Cursor3DInterface
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Modelling3D'!

Cursor3DInterface subclass: #BoxPen
	instanceVariableNames: 'connectionPolicy objectCreationBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Modelling3D'!

!BoxPen class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:50'!
new

	"Answer a new instance of the receiver and initialize it"

	^super new initialize! !

!BoxPen methodsFor: 'API' stamp: 'emm 02/09/2012 23:50'!
arcFrom: startPoint to: endPoint around: centerPoint clockwise: isCW

	 self arcClass 
		from: self position 
		to: endPoint 
		center: centerPoint 
		clockwise: isCW! !

!BoxPen methodsFor: 'private' stamp: 'emm 02/09/2012 23:50'!
decX: amount 
	"Pre: amount >= 0"

	| newOrigin newExtent newObject |
	( self visible
		and: [ self direction == #posX ] ) 
		ifTrue: [ ^self error: 'collision' ].
	newExtent := amount negated , self width , self height.
	self direction == #none 
		ifTrue: [ newOrigin := self position ].
	self direction == #negX
		ifTrue: [ newOrigin := self objects last backLeftBottom ].
	 self direction == #negY
		ifTrue: [ newOrigin := self objects last backLeftBottom decY: self width ].
	self direction == #posX
		ifTrue:[ newOrigin := self objects last frontLeftBottom ].
	self direction == #posY 
		ifTrue: [ newOrigin := self objects last backRightBottom ].	
	newObject := self newObjectBoundedBy: (newOrigin extent: newExtent) normalize.
	self objects add: newObject.
	self direction: #negX! !

!BoxPen methodsFor: 'private' stamp: 'emm 02/09/2012 23:50'!
decY: amount 
	"Pre: amount >= 0"

	| newOrigin newExtent newObject |
"	( self visible
		and: [ self direction == #posY ] ) 
		ifTrue: [ ^self error: 'collision' ].
"
	newExtent := self width , amount negated , self height.
	self direction == #none 
		ifTrue: [ newOrigin := self position ].
	self direction == #negX
		ifTrue: [ newOrigin := self objects last backLeftBottom decX: self width ].
	self direction == #posX 
		ifTrue: [ newOrigin := self objects last frontLeftBottom ].	
	 self direction == #negY
		ifTrue: [ newOrigin := self objects last backLeftBottom ].
	self direction == #posY
		ifTrue:[ newOrigin := self objects last backRightBottom ].
	newObject := self newObjectBoundedBy: (newOrigin extent: newExtent) normalize.
	self objects add: newObject.
	self direction: #negY! !

!BoxPen methodsFor: 'resources' stamp: 'emm 02/09/2012 23:50'!
elementClass

	^self visible
		ifTrue: [ Box ]
		ifFalse: [ BoundingBox ]! !

!BoxPen methodsFor: 'API' stamp: 'emm 02/09/2012 23:50'!
height

	"Answer the value of height"

	^self state height! !

!BoxPen methodsFor: 'API' stamp: 'emm 02/09/2012 23:50'!
height: aValue

	"Set the value of height"

	self state height: aValue! !

!BoxPen methodsFor: 'private' stamp: 'emm 02/09/2012 23:50'!
incX: amount 
	
	| newOrigin newExtent newObject |
	( self visible
		and: [ self direction == #negX ] ) 
		ifTrue: [ ^self error: 'collision' ].
	newExtent := amount , self width , self height.
	self direction == #none 
		ifTrue: [ newOrigin := self position ].
	self direction == #posX
		ifTrue: [ newOrigin := self objects last frontLeftBottom ].
	self direction == #posY 
		ifTrue: [ newOrigin := self objects last frontRightBottom ].	
	 self direction == #negY
		ifTrue: [ newOrigin := self objects last frontLeftBottom decY: self width  ].
	newObject := self newObjectBoundedBy: (newOrigin extent: newExtent) normalize.
	self objects add: newObject.
	self direction: #posX! !

!BoxPen methodsFor: 'private' stamp: 'emm 02/09/2012 23:50'!
incY: amount 

	| newOrigin newExtent newObject |
	( self visible
		and: [ self direction == #negY ] ) 
		ifTrue: [ ^self error: 'collision' ].
	newExtent := self width , amount , self height.
	self direction == #none 
		ifTrue: [ newOrigin := self position ].
	self direction == #posY
		ifTrue: [ newOrigin := self objects last backRightBottom ].
	self direction == #posX 
		ifTrue: [ newOrigin := self objects last frontRightBottom ].	
	 self direction == #negX
		ifTrue: [ newOrigin := self objects last backRightBottom decX: self width ].
	newObject := self newObjectBoundedBy: (newOrigin extent: newExtent) normalize.
	self objects add: newObject.
	self direction: #posY! !

!BoxPen methodsFor: 'private' stamp: 'emm 02/09/2012 23:50'!
newObjectBoundedBy: aBoundingBox

	^ self objectCreationBlock isNil
		ifTrue:[ self elementClass origin: aBoundingBox origin extent: aBoundingBox extent]
		ifFalse:[ self objectCreationBlock value: aBoundingBox ]! !

!BoxPen methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:50'!
objectCreationBlock

	"Answer the value of objectCreationBlock"

	^objectCreationBlock! !

!BoxPen methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:50'!
objectCreationBlock: aValue

	"Set the value of objectCreationBlock"

	objectCreationBlock := aValue! !

!BoxPen methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:50'!
position

	^objects isEmpty
		ifTrue: [ super position ]
		ifFalse: 
			[ self direction == #posX
				ifTrue: [ ^objects last frontCenterBottom ]. 
			self direction == #negX
				ifTrue: [ ^objects last backCenterBottom ].
			self direction == #posY
				ifTrue: [ ^objects last centerRightBottom ]. 
			self direction == #negY
				ifTrue: [ ^objects last centerLeftBottom ]. ]! !

!BoxPen methodsFor: 'resources' stamp: 'emm 02/09/2012 23:50'!
stateClass

	^BoxPenState! !

!BoxPen methodsFor: 'API' stamp: 'emm 02/09/2012 23:50'!
width

	"Answer the value of width"

	^self state width! !

!BoxPen methodsFor: 'API' stamp: 'emm 02/09/2012 23:50'!
width: aValue

	"Set the value of width"

	self state width: aValue! !

!Cursor3DInterface methodsFor: 'resources' stamp: 'emm 02/09/2012 23:49'!
arcClass

	^EllipticalArc3D! !

!Cursor3DInterface methodsFor: 'API-arcs' stamp: 'emm 02/09/2012 23:49'!
arcWithDx: x dy: y dz: z
	"Arc by <dx , dy, dz>"

	self rotatesClockwise
		ifTrue:[ self cwArcWithX: x y: y z: z]
		ifFalse:[ self ccwArcWithX: x y: y z: z]! !

!Cursor3DInterface methodsFor: 'API-arcs' stamp: 'emm 02/09/2012 23:49'!
arcWithX: x y: y
	"Arc by <x , y>"

	self rotatesClockwise
		ifTrue:[ self cwArcWithX: x y: y]
		ifFalse:[ self ccwArcWithX: x y: y ]! !

!Cursor3DInterface methodsFor: 'private' stamp: 'emm 02/09/2012 23:49'!
ccwArcWithX: x y: y z: z! !

!Cursor3DInterface methodsFor: 'private' stamp: 'emm 02/09/2012 23:49'!
ccwArcWithY: y z: z
	"Arc clockwise by <deltaPoint>"

	self ccwArcTo: self position + (0@ y @ z)! !

!Cursor3DInterface methodsFor: 'private' stamp: 'emm 02/09/2012 23:49'!
cwArcTo: endPoint 
	"Add an clockwise arc to <endPoint>"
	
	"FIX: 3D en 2D support"
	
	| fromX fromY toX toY center |
	fromX := self position x.
	fromY := self position y.
	toX := endPoint x.
	toY := endPoint y.
	toX > fromX
		ifTrue: 
			[ toY > fromY
				ifTrue: [ center := toX @ fromY ]
				ifFalse: [ center := fromX @ toY  ] ]
		ifFalse: 
			[ toY > fromY
				ifTrue: [ center := fromX @ toY  ]
				ifFalse: [ center := toX @ fromY  ] ].
	^self 
		arcFrom: self position 
		to: endPoint
		around: center @ endPoint z
		clockwise: true! !

!Cursor3DInterface methodsFor: 'private' stamp: 'emm 02/09/2012 23:49'!
cwArcWithX: x y: y z: z
	"Arc clockwise by <x , y>"

	self cwArcTo: self position + (x , y , z )! !

!Cursor3DInterface methodsFor: 'private' stamp: 'emm 02/09/2012 23:49'!
cwArcWithY: y z: z
	"Arc clockwise by <deltaPoint>"

	self cwArcTo: self position + (0@ y @ z)! !

!Cursor3DInterface methodsFor: 'private-inc-dec' stamp: 'emm 02/09/2012 23:49'!
decX: x decZ: z

	self moveTo: ((self position copy) decX: x ;decZ: z)! !

!Cursor3DInterface methodsFor: 'private-inc-dec' stamp: 'emm 02/09/2012 23:49'!
decX: x incZ: z

	self moveTo: ((self position copy) decX: x ;incZ: z)! !

!Cursor3DInterface methodsFor: 'private-inc-dec' stamp: 'emm 02/09/2012 23:49'!
decY: y decZ: z

	self moveTo: ((self position copy) decY: y ;decZ: z)! !

!Cursor3DInterface methodsFor: 'private-inc-dec' stamp: 'emm 02/09/2012 23:49'!
decY: y incZ: z

	self moveTo: ((self position copy) decY: y ;incZ: z)! !

!Cursor3DInterface methodsFor: 'private-inc-dec' stamp: 'emm 02/09/2012 23:49'!
decZ: aNumber 

	self moveTo: (self position copy decZ: aNumber)! !

!Cursor3DInterface methodsFor: 'API-xyz' stamp: 'emm 02/09/2012 23:49'!
dx: dx dy: dy dz: dz
	
	self moveTo: (self position + ((dx, dy, dz) * self scale)).! !

!Cursor3DInterface methodsFor: 'API-xyz' stamp: 'emm 02/09/2012 23:49'!
dx: xNumber dz: zNumber

	xNumber < 0
		ifTrue: [ zNumber < 0
			ifTrue: [ self decX: xNumber negated * self scale decZ: zNumber negated * self scale ] 			
			ifFalse: [ self decX: xNumber negated * self scale incZ: zNumber * self scale ] ]
		ifFalse: [ zNumber < 0
			ifTrue: [ self incX: xNumber * self scale decZ: zNumber negated * self scale ] 
			ifFalse: [ self incX: xNumber * self scale incZ: zNumber * self scale ] ]
			! !

!Cursor3DInterface methodsFor: 'API-xyz' stamp: 'emm 02/09/2012 23:49'!
dy: yNumber dz: zNumber 
	
	yNumber < 0
		ifTrue:
			[ zNumber < 0
				ifTrue:[ self decY: yNumber negated * self scale decZ: zNumber negated * self scale ]
				ifFalse:[ self decY: yNumber negated * self scale incZ: zNumber * self scale ] ]
		ifFalse:
			[ zNumber < 0
				ifTrue:[ self incY: yNumber * self scale decZ: zNumber negated * self scale ]
				ifFalse:[ self incY: yNumber * self scale incZ: zNumber * self scale ] ]! !

!Cursor3DInterface methodsFor: 'API-xyz' stamp: 'emm 02/09/2012 23:49'!
dz: aNumber 
	
	aNumber < 0
		ifTrue:[ self decZ: aNumber negated * self scale ]
		ifFalse:[ self incZ: aNumber * self scale ]! !

!Cursor3DInterface methodsFor: 'API-relative' stamp: 'emm 02/09/2012 23:49'!
forward: howMuch

	super forward: howMuch.
	self direction = #posZ
		ifTrue: [^self dz: howMuch].		
	self direction = #negZ
		ifTrue: [^self dz: howMuch negated].		
			
			! !

!Cursor3DInterface methodsFor: 'private-inc-dec' stamp: 'emm 02/09/2012 23:49'!
incX: x decZ: z

	self moveTo: ((self position copy) incX: x ;decZ: z)! !

!Cursor3DInterface methodsFor: 'private-inc-dec' stamp: 'emm 02/09/2012 23:49'!
incX: x incZ: z

	self moveTo: ((self position copy) incX: x ;incZ: z)! !

!Cursor3DInterface methodsFor: 'private-inc-dec' stamp: 'emm 02/09/2012 23:49'!
incY: y decZ: z

	self moveTo: ((self position copy) incY: y ;decZ: z)! !

!Cursor3DInterface methodsFor: 'private-inc-dec' stamp: 'emm 02/09/2012 23:49'!
incY: y incZ: z

	self moveTo: ((self position copy) incY: y ;incZ: z)! !

!Cursor3DInterface methodsFor: 'private-inc-dec' stamp: 'emm 02/09/2012 23:49'!
incZ: aNumber 

	self moveTo: (self position copy incZ: aNumber)! !

!Cursor3DInterface methodsFor: 'resources' stamp: 'emm 02/09/2012 23:49'!
newPointZero

	^0@0@0! !

!Cursor3DInterface methodsFor: 'resources' stamp: 'emm 02/09/2012 23:49'!
stateClass

	^Cursor3DState! !

!Cursor3DInterface methodsFor: 'API-relative' stamp: 'emm 02/09/2012 23:49'!
towardsNegativeZ
	self direction: #negZ.! !

!Cursor3DInterface methodsFor: 'API-relative' stamp: 'emm 02/09/2012 23:49'!
towardsZ
	self direction: #posZ.! !

!Cursor3DInterface methodsFor: 'API-xyz' stamp: 'emm 02/09/2012 23:49'!
toz: newZ

	self dz: newZ - (self position z)! !

Cursor3DInterface subclass: #DominoPlacer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'Math3DConstants'
	category: 'Zenna-Dominos'!

!DominoPlacer methodsFor: 'private' stamp: 'emm 03/09/2012 20:19'!
arcFrom: startPoint to: endPoint around: centerPoint clockwise: isCW 
	
	| circle interval startAngle stopAngle delta |
	circle := Circle3D center: centerPoint asPoint3D radius: ( endPoint dist: centerPoint asPoint3D ).
	startAngle := circle computeAngleFor: startPoint.
	stopAngle := circle computeAngleFor: endPoint.
	delta := ( 4 / circle radius ) arcTan.
	isCW
		ifTrue:
			[ stopAngle > startAngle
				ifTrue: [ stopAngle := stopAngle - TwoPi ].
			interval := self nearestIntervalFrom: startAngle to: stopAngle by: delta negated.
			interval :=  interval asOrderedCollection removeFirst ;removeLast ;yourself]
		ifFalse:
			[ stopAngle < startAngle
				ifTrue:[ stopAngle := stopAngle + TwoPi ].
			interval := self nearestIntervalFrom: startAngle to: stopAngle by: delta.
			interval :=  interval asOrderedCollection removeFirst ;removeLast ;yourself].

	
	((circle interpolatorUsingAngleIncrement: delta) collection: interval) verticesDoWithParameter: [ :where :angle |  
		| domino yaw | 
		domino := self newDominoAt: where.
		yaw := isCW ifTrue: [ angle - HalfPi] ifFalse: [ angle + HalfPi].
		domino yawAngle: yaw.
		self objects isEmpty 
			ifFalse:[ self objects last addHead: domino ].
		self objects add: domino.
		super	moveTo: where ].

	! !

!DominoPlacer methodsFor: 'accessing-state' stamp: 'emm 03/09/2012 20:19'!
color
	^self state color! !

!DominoPlacer methodsFor: 'accessing-state' stamp: 'emm 03/09/2012 20:19'!
color: aColor
	self state color: aColor! !

!DominoPlacer methodsFor: 'accessing-state' stamp: 'emm 03/09/2012 20:19'!
delta
	^self state delta! !

!DominoPlacer methodsFor: 'accessing-state' stamp: 'emm 03/09/2012 20:19'!
delta: aPoint
	self state delta: aPoint! !

!DominoPlacer methodsFor: 'API-placing' stamp: 'emm 03/09/2012 20:19'!
doDivergePatternFrom: columnsToStart 
	to: columnsToStop
	rowOffset: rowOffset
	columnOffset: columnOffset
	direction: directionPoint! !

!DominoPlacer methodsFor: 'API-control' stamp: 'emm 03/09/2012 20:19'!
down

	super down.
	self moveTo: self position! !

!DominoPlacer methodsFor: 'private' stamp: 'emm 03/09/2012 20:19'!
moveTo: newPosition

	| newHead |
	newHead := self newDominoAt: newPosition.
	self objects isEmpty
		ifFalse:[ self objects last addHead: newHead ].
	self objects add: newHead.
	super	moveTo: newPosition! !

!DominoPlacer methodsFor: 'private' stamp: 'emm 03/09/2012 20:19'!
nearestIntervalFrom: start to: stop by: by

	"Answer a new interval for which the by
	value is the nearest to @by"

	| maxDelta steps delta lastDiff |
	maxDelta := stop - start.
	steps := 1.
	[delta := maxDelta / steps.
	delta abs <= by abs]
		whileFalse:
			[ steps := steps + 1.
			lastDiff := (delta - by) abs ].
	(delta - by) abs > lastDiff
		ifTrue:[ delta := maxDelta / (steps - 1)].
	^start to: stop by: delta! !

!DominoPlacer methodsFor: 'private' stamp: 'emm 03/09/2012 20:19'!
newDominoAt: aPoint

	^Domino new 
		bottomCenter: aPoint  
		;sizePoint: self sizePoint
		;yawAngle: self yawAngle
		;color: self color! !

!DominoPlacer methodsFor: 'API-placing' stamp: 'emm 03/09/2012 20:19'!
placeDominoAt: newPosition

	| domino |
	self objects add: (domino := self newDominoAt: newPosition).
	self position: newPosition.
	^domino! !

!DominoPlacer methodsFor: 'API-placing' stamp: 'emm 03/09/2012 20:19'!
placeJunctionAt: aPoint3D
"
	^ objects add: ((DominoJunction new) bottomCenter: aPoint3D)
"! !

!DominoPlacer methodsFor: 'API-placing' stamp: 'emm 03/09/2012 20:19'!
placeSwivel180At: aPoint3D rotatedBy: angle clockwise: isCW

	^ objects add: ((DominoSwivel180 new) 
		bottomCenter: aPoint3D 
		;yawAngle: angle
		; isClockwise: isCW)! !

!DominoPlacer methodsFor: 'API-placing' stamp: 'emm 03/09/2012 20:19'!
placeWideAt: aPoint3D

	| domino |
	self objects add: (domino := self newDominoAt: aPoint3D).
	self position: aPoint3D.
	^domino! !

!DominoPlacer methodsFor: 'accessing-state' stamp: 'emm 03/09/2012 20:19'!
restoreSizePointAfter: aBlock

	| oldSizePoint |
	oldSizePoint := self sizePoint.
	aBlock value.
	self sizePoint: oldSizePoint.! !

!DominoPlacer methodsFor: 'accessing-state' stamp: 'emm 03/09/2012 20:19'!
sizePoint
	^self state sizePoint! !

!DominoPlacer methodsFor: 'accessing-state' stamp: 'emm 03/09/2012 20:19'!
sizePoint: aPoint
	self state sizePoint: aPoint! !

!DominoPlacer methodsFor: 'resources' stamp: 'emm 03/09/2012 20:19'!
stateClass

	^DominoPlacingState! !

!DominoPlacer methodsFor: 'API-control' stamp: 'emm 03/09/2012 20:19'!
step
	
	self moveTo: self position + self delta! !

!DominoPlacer methodsFor: 'accessing-state' stamp: 'emm 03/09/2012 20:19'!
yawAngle
	^self state yawAngle! !

!DominoPlacer methodsFor: 'accessing-state' stamp: 'emm 03/09/2012 20:19'!
yawAngle: angleInRad
	self state yawAngle: angleInRad! !

Cursor3DInterface subclass: #DominoSceneBuilder
	instanceVariableNames: 'matrix placer turnDirection colorMap turnStart questionReplacement'
	classVariableNames: ''
	poolDictionaries: 'Math3DConstants'
	category: 'Zenna-Dominos'!

!DominoSceneBuilder methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
bounds
	
	^ self objects 
		inject: self objects first bounds 
		into: [ :bbox :each | bbox merge: each bounds ]! !

!DominoSceneBuilder methodsFor: 'building' stamp: 'emm 03/09/2012 20:19'!
buildSceneFromDominoMap: aMatrix colorMap: aDictionary startingAt: rowColomnPoint

	self where: rowColomnPoint.
	matrix := aMatrix.
	colorMap := aDictionary.
	self direction: #unknown.
	[[ self direction = #none ]
		whileFalse:
			[ self dispatch: (self charOrNilAt: self where) ].
	self stateStack removeLast.
	self stateStack isEmpty]
		whileFalse:
			[ "restore character input map to continue"
			self objectAt: self where put: self state character]

	! !

!DominoSceneBuilder methodsFor: 'testing' stamp: 'emm 03/09/2012 20:19'!
canFollowBy: turnStep andExitBy: exitStep

	"Follow locations by incrementing the current where with 
	the argument turnStep. If no more turn symbol is found
	detect an exit point that can be found with the argument exitStep"

	| localWhere ch|
	localWhere := self where + turnStep. 
	[ch := self charOrNilAt: localWhere.
	ch == $?] 
		whileTrue:
			[localWhere := localWhere + turnStep].
	"ch ~= $?"
	^(self charOrNilAt: localWhere + exitStep) notNil! !

!DominoSceneBuilder methodsFor: 'testing' stamp: 'emm 03/09/2012 20:19'!
canGoto: aPoint

	"Answer whether the receiver can continue
	building by dispatching the next symbol at @aPoint"
	
	| char state |
	"is there a character on the map?"
	char := self objectOrNilAt: aPoint.
	char isCharacter
		ifFalse: [ ^false ].
	"is there a pending state for this position?"
	state := self stateStack detect:[ :each | each position = aPoint ] ifNone:[].
	^state isNil


	! !

!DominoSceneBuilder methodsFor: 'building' stamp: 'emm 03/09/2012 20:19'!
centerDistance

	^5! !

!DominoSceneBuilder methodsFor: 'dispatching' stamp: 'emm 03/09/2012 20:19'!
charOrNilAt: aPoint 
	
	| ch |
	aPoint x < 1 
		ifTrue:[ ^ nil ].
	aPoint x > matrix maxRows 
		ifTrue:[ ^ nil ].
	aPoint y < 1 
		ifTrue:[ ^ nil ].
	aPoint y > matrix maxColumns
		ifTrue:[ ^ nil ].
	ch := matrix atRow: aPoint x column: aPoint y.
	(( ch isNil	
		or:[ ch class == Character and: [ ch isSeparator ]]) 
		or:[ ch isKindOf: Domino ] ) 
		ifTrue:[ ^ nil ].
	^ ch! !

!DominoSceneBuilder methodsFor: 'dispatching' stamp: 'emm 03/09/2012 20:19'!
dispatch: ch 
	
	ch = $@ 
		ifTrue:[ ^ self doEntry ].
	( ch = $# or: [ ch isNil ] ) 
		ifTrue:[ ^ self doExit ].
	ch = $> 
		ifTrue:[ ^ self do180Right ].
	ch = $< 
		ifTrue:[ ^ self do180Left ].
	ch = $- 
		ifTrue:[ ^ self doCounterClockWiseTurn ].
	ch = $+ 
		ifTrue:[ ^ self doClockWiseTurn ].
	ch = $&
		ifTrue: [ ^ self doWide ].
	ch = $%
		ifTrue: [ ^ self doJunction ].
	ch = $?
		ifTrue: [ ^ self doSelfExploringTurn ].
	ch = $=
		ifTrue: [ ^ self doSelfExploring180 ].
	^ self doDomino: ch! !

!DominoSceneBuilder methodsFor: 'tag-handling' stamp: 'emm 03/09/2012 20:19'!
do180Left
	"<=counterclockwise"

	self direction = #west
		ifTrue:[ ^self do180ViaSouthToEast ].
	self direction = #east
		ifTrue:[ ^self do180ViaNorthToWest ].
	self direction = #north
		ifTrue:[ ^self do180ViaWestToSouth].
	self direction = #south
		ifTrue:[ ^self do180ViaEastToNorth ].
	self direction: #none! !

!DominoSceneBuilder methodsFor: 'tag-handling' stamp: 'emm 03/09/2012 20:19'!
do180Right
	">=clockwise"

	self direction = #east
		ifTrue:[ ^self do180ViaSouthToWest ].
	self direction = #west
		ifTrue:[ ^self do180ViaNorthToEast ].		
	self direction = #north
		ifTrue:[ ^self do180ViaEastToSouth ].
	self direction = #south
		ifTrue:[ ^self do180ViaWestToNorth ].
	self direction: #none! !

!DominoSceneBuilder methodsFor: 'tag-handling' stamp: 'emm 03/09/2012 20:19'!
do180ViaEastToNorth
	
	^ self 
		doSwivelTo: self where + ( -1 @ 2 ) 
		placeAt: self where + ( -0.5 @ 1 ) 
		rotatedBy: 0 
		withDirection: #north 
		clockwise: false
		! !

!DominoSceneBuilder methodsFor: 'tag-handling' stamp: 'emm 03/09/2012 20:19'!
do180ViaEastToSouth
	
	^ self 
		doSwivelTo: self where + ( 1 @ 2 ) 
		placeAt: self where + ( 0.5 @ 1 ) 
		rotatedBy: Pi 
		withDirection: #south
		clockwise: true! !

!DominoSceneBuilder methodsFor: 'tag-handling' stamp: 'emm 03/09/2012 20:19'!
do180ViaNorthToEast
	
	^ self 
		doSwivelTo: self where + ( -2 @ 1 ) 
		placeAt: self where + ( -1 @ 0.5 ) 
		rotatedBy: HalfPi negated 
		withDirection: #east
		clockwise: true! !

!DominoSceneBuilder methodsFor: 'tag-handling' stamp: 'emm 03/09/2012 20:19'!
do180ViaNorthToWest
	
	^ self 
		doSwivelTo: self where - ( 2 @ 1 ) 
		placeAt: self where - ( 1 @ 0.5 ) 
		rotatedBy: HalfPi 
		withDirection: #west
		clockwise: false! !

!DominoSceneBuilder methodsFor: 'tag-handling' stamp: 'emm 03/09/2012 20:19'!
do180ViaSouthToEast
	
	^ self 
		doSwivelTo: self where + ( 2 @ 1 ) 
		placeAt: self where + ( 1 @ 0.5 ) 
		rotatedBy: HalfPi negated 
		withDirection: #east
		clockwise: false		! !

!DominoSceneBuilder methodsFor: 'tag-handling' stamp: 'emm 03/09/2012 20:19'!
do180ViaSouthToWest
	
	^ self 
		doSwivelTo: self where + ( 2 @ -1 ) 
		placeAt: self where + ( 1 @ -0.5 ) 
		rotatedBy: HalfPi 
		withDirection: #west
		clockwise: true! !

!DominoSceneBuilder methodsFor: 'tag-handling' stamp: 'emm 03/09/2012 20:19'!
do180ViaWestToNorth
	
	^ self 
		doSwivelTo: self where + ( -1 @ -2 ) 
		placeAt: self where - ( 0.5 @ 1 ) 
		rotatedBy: 0 
		withDirection: #north
		clockwise: true! !

!DominoSceneBuilder methodsFor: 'tag-handling' stamp: 'emm 03/09/2012 20:19'!
do180ViaWestToSouth
	
	^ self 
		doSwivelTo: self where + ( 1 @ -2 ) 
		placeAt: self where + ( 0.5 @ -1 ) 
		rotatedBy: Pi 
		withDirection: #south
		clockwise: false! !

!DominoSceneBuilder methodsFor: 'tag-handling' stamp: 'emm 03/09/2012 20:19'!
doClockWiseTurn
	
	"+"
	
	| peek char |
	turnDirection isNil
		ifTrue:
			[ turnDirection := #clockwise.
			turnStart := self where ]
		ifFalse:
			[ turnDirection = #counterclockwise 
				ifTrue:[ self error: 'expecting domino at ' , self where printString ] ]. 
	
	self direction = #north 
		ifTrue:
			[ ^ self 
				doTurnTo: self where + ( -1 @ 1 ) 
				orStraightTo: self where - ( 1 @ 0 ) 
				orExitTo: #east 
				at: self where + ( 0 @ 1 ) ].
	self direction = #south 
		ifTrue:
			[ ^ self 
				doTurnTo: self where + ( 1 @ -1 ) 
				orStraightTo: self where + ( 1 @ 0 ) 
				orExitTo: #west 
				at: self where - ( 0 @ 1 ) ].
	self direction = #east 
		ifTrue:
			[ ^ self 
				doTurnTo: self where + ( 1 @ 1 ) 
				orStraightTo: self where + ( 0 @ 1 ) 
				orExitTo: #south 
				at: self where + ( 1 @ 0 ) ].
	self direction = #west 
		ifTrue:
			[ ^ self 
				doTurnTo: self where - ( 1 @ 1 ) 
				orStraightTo: self where - ( 0 @ 1 ) 
				orExitTo: #north 
				at: self where - ( 1 @ 0 ) ]! !

!DominoSceneBuilder methodsFor: 'private' stamp: 'emm 03/09/2012 20:19'!
doCompleteAnyTurn
	
	"If a turn was pending complete it.
	Answer with the last domino placed"

	| tail |
	turnDirection isNil
		ifTrue: 
			[ tail := self objectOrNilAt: self lastPosition.
			tail isCharacter "special chars are not replaced"
				ifTrue: [ tail := placer objects last ]]
		ifFalse:
			[self doCompleteTurn.
			tail := placer objects last ].
	^tail! !

!DominoSceneBuilder methodsFor: 'private' stamp: 'emm 03/09/2012 20:19'!
doCompleteTurn
	
	turnDirection = #clockwise
		ifTrue:[ placer clockwise ]
		ifFalse:[ placer counterclockwise ].
	placer arcTo: ( self point3DFrom: self where ).
	turnDirection := nil! !

!DominoSceneBuilder methodsFor: 'tag-handling' stamp: 'emm 03/09/2012 20:19'!
doCounterClockWiseTurn
	
	"-"
	| peek char |
	turnDirection isNil
		ifTrue:
			[ turnDirection := #counterclockwise.
			turnStart := self where ]
		ifFalse:
			[ turnDirection = #clockwise 
				ifTrue:[ self error: 'expecting domino at ' , self where printString ] ]. 
	
	self direction = #north 
		ifTrue:
			[ ^ self 
				doTurnTo: self where - ( 1 @ 1 ) 
				orStraightTo: self where - ( 1 @ 0 ) 
				orExitTo: #west 
				at: self where - ( 0 @ 1 ) ].
	self direction = #south 
		ifTrue:
			[ ^ self 
				doTurnTo: self where + ( 1 @ 1 ) 
				orStraightTo: self where + ( 1 @ 0 ) 
				orExitTo: #east 
				at: self where + ( 0 @ 1 ) ].
	self direction = #east 
		ifTrue:
			[ ^ self 
				doTurnTo: self where + ( -1 @ 1 ) 
				orStraightTo: self where + ( 0 @ 1 ) 
				orExitTo: #north 
				at: self where - ( 1 @ 0 ) ].
	self direction = #west 
		ifTrue:
			[ ^ self 
				doTurnTo: self where + ( 1 @ -1 ) 
				orStraightTo: self where - ( 0 @ 1 ) 
				orExitTo: #south 
				at: self where + ( 1 @ 0 ) ]! !

!DominoSceneBuilder methodsFor: 'private' stamp: 'emm 03/09/2012 20:19'!
doDispatchAfterDomino
	
	self direction = #north 
		ifTrue:
			[ ^ self 
				doLeft: self where - ( 1 @ -1 ) 
				straight: self where - ( 1 @ 0 ) 
				orRight: self where - ( 1 @ 1 ) ]. 
	
	self direction = #south 
		ifTrue:
			[ ^ self 
				doLeft: self where + ( 1 @ -1 ) 
				straight: self where + ( 1 @ 0 ) 
				orRight: self where + ( 1 @ 1 ) ]. 
	
	self direction = #east 
		ifTrue:
			[ ^ self 
				doLeft: self where + ( -1 @ 1 ) 
				straight: self where + ( 0 @ 1 ) 
				orRight: self where + ( 1 @ 1 ) ]. 
	
	self direction = #west 
		ifTrue:
			[ ^ self 
				doLeft: self where + ( 1 @ -1 ) 
				straight: self where - ( 0 @ 1 ) 
				orRight: self where - ( 1 @ 1 ) ]! !

!DominoSceneBuilder methodsFor: 'tag-handling' stamp: 'emm 03/09/2012 20:19'!
doDomino: ch 
	
	| tail domino |
	tail := self doCompleteAnyTurn.
	self updatePlacerYawAngle.
	self updatePlacerColorWith: ch.
	domino := self doPlaceDominoFor: ch.
	tail isNil
		ifFalse:[tail addHead: domino].
	self doDispatchAfterDomino! !

!DominoSceneBuilder methodsFor: 'tag-handling' stamp: 'emm 03/09/2012 20:19'!
doEntry

	"Find a character in the neighborhood"

	"Erase the entry"
	self objectAt: self where put: nil.
	"check south"
	(self tryStartAt: self where + (1@0) withDirection: #south)
		ifTrue: [ ^self ].
	"check north"
	(self tryStartAt: self where - (1@0) withDirection: #north)
		ifTrue: [ ^self ].
	"check east"
	(self tryStartAt: self where + (0@1) withDirection: #east)
		ifTrue: [ ^self ].
	"check west"
	(self tryStartAt: self where - (0@1) withDirection: #west)
		ifTrue: [ ^self ].
	"missing domino"	
	self direction:#none.
	! !

!DominoSceneBuilder methodsFor: 'tag-handling' stamp: 'emm 03/09/2012 20:19'!
doExit

	self direction: #none! !

!DominoSceneBuilder methodsFor: 'tag-handling' stamp: 'emm 03/09/2012 20:19'!
doJunction! !

!DominoSceneBuilder methodsFor: 'private' stamp: 'emm 03/09/2012 20:19'!
doLeft: leftPoint straight: straightPoint orRight: rightPoint

	"check straight again"
	(self canGoto: straightPoint) 
		ifTrue:[ ^ self where: straightPoint ].

	"check sidestep left"
	( self canGoto: leftPoint )
		ifTrue: 
			["remember to come back later"
			self rememberToGoto: leftPoint ]
		ifFalse: 
			["already visited leftPoint?"
			( self hasDominoAt: leftPoint ) 
				ifTrue:[(self objectOrNilAt: self where) addHead: (self objectOrNilAt: leftPoint) ]].		

	"check sidestep right"				
	(self canGoto: rightPoint)
		ifTrue:
			["continue now"
			^ self where: rightPoint ]
		ifFalse: 
			["already visited rightPoint?"
			( self hasDominoAt: rightPoint ) 
				ifTrue: [(self objectOrNilAt: self where) addHead: (self objectOrNilAt: rightPoint) ]].
					
	self direction: #none! !

!DominoSceneBuilder methodsFor: 'private' stamp: 'emm 03/09/2012 20:19'!
doPlaceDominoFor: ch 
	
	"handle case of junction"
	
	| domino |
	ch == $%
		ifTrue:
			[ domino := placer placeJunctionAt: ( self point3DFrom: self where ) ]
		ifFalse:
			[ domino := placer placeDominoAt: ( self point3DFrom: self where ).
			self objectAt: self where put: domino ].
	^ domino! !

!DominoSceneBuilder methodsFor: 'tag-handling' stamp: 'emm 03/09/2012 20:19'!
doSelfExploring180
	
	"find out whether it is a left< or right> turn"
	
	| ch |
	self direction = #west 
		ifTrue:
			[ ch := self charOrNilAt: self where + ( -1 @ 0 ).
			^ ( ch == $= )
				ifTrue:[ self do180ViaNorthToEast ]
				ifFalse:[ self do180ViaSouthToEast ] ].
	self direction = #east 
		ifTrue:
			[ ch := self charOrNilAt: self where + ( -1 @ 0 ).
			^ ( ch == $= )
				ifTrue:[ self do180ViaNorthToWest ]
				ifFalse:[ self do180ViaSouthToWest ] ].
	self direction = #north 
		ifTrue:
			[ ch := self charOrNilAt: self where + ( 0 @ -1 ).
			^ ( ch == $= )
				ifTrue:[ self do180ViaWestToSouth ]
				ifFalse:[ self do180ViaEastToSouth ] ].
	self direction = #south 
		ifTrue:
			[ ch := self charOrNilAt: self where + ( 0 @ -1 ).
			^ ( ch == $= )
				ifTrue:[ self do180ViaWestToNorth ]
				ifFalse:[ self do180ViaEastToNorth ] ]! !

!DominoSceneBuilder methodsFor: 'tag-handling' stamp: 'emm 03/09/2012 20:19'!
doSelfExploringTurn
	"
	questionReplacement = nil
		we are at the beginning of a turn but 
		we don't know whether it is clockwise or counterclockwise.
	questionReplacement ~= nil
		dispatch to one of the turn methods
	"
	| ch |
	questionReplacement ~~ nil
		ifTrue: [ ^ questionReplacement == $+ 
				ifTrue: [ self doClockWiseTurn ]
				ifFalse: [ self doCounterClockWiseTurn ]].

	self direction = #north 
		ifTrue: 
			[ ch := self charOrNilAt: self where + ( -1 @ 1 ).
			(ch == $? and:[self canFollowBy: -1 @ 1 andExitBy: 1@0])
				ifTrue: 
					[ "clockwise turn" 
					questionReplacement := $+.
					^ self doClockWiseTurn ].
			ch := self charOrNilAt: self where + ( -1 @ -1 ).
			(ch == $? and:[self canFollowBy: -1 @ -1 andExitBy: 1@0])
				ifTrue: 
					[ "counterclockwise turn" 
					questionReplacement := $-.
					^ self doCounterClockWiseTurn ].
			^self doExit].

	self direction = #east
		ifTrue: 
			[ ch := self charOrNilAt: self where + ( -1 @ 1 ).
			(ch == $? and:[self canFollowBy: -1 @ 1 andExitBy: 0@-1])
				ifTrue: 
					[ "counterclockwise turn" 
					questionReplacement := $-.
					^ self doCounterClockWiseTurn ].
			ch := self charOrNilAt: self where + ( 1 @ 1 ).
			(ch == $? and:[self canFollowBy: 1 @ 1 andExitBy: 0@-1])
				ifTrue: 
					[ "clockwise turn" 
					questionReplacement := $+.
					^ self doClockWiseTurn ].
			^self doExit].

	self direction = #south
		ifTrue: 
			[ ch := self charOrNilAt: self where + ( 1 @ 1 ).
			(ch == $? and:[self canFollowBy: 1 @ 1 andExitBy: -1@0])
				ifTrue: 
					[ "counterclockwise turn" 
					questionReplacement := $-.
					^ self doCounterClockWiseTurn ].
			ch := self charOrNilAt: self where + ( 1 @ -1 ).
			(ch == $? and:[self canFollowBy: 1 @ -1 andExitBy: -1@0])
				ifTrue: 
					[ "clockwise turn" 
					questionReplacement := $+.
					^ self doClockWiseTurn ].
			^self doExit].

	self direction = #west
		ifTrue: 
			[ ch := self charOrNilAt: self where + ( 1 @ -1 ).
			(ch == $? and:[self canFollowBy: 1 @ -1 andExitBy: 0@1])
				ifTrue: 
					[ "counterclockwise turn" 
					questionReplacement := $-.
					^ self doCounterClockWiseTurn ].
			ch := self charOrNilAt: self where + ( -1 @ -1 ).
			(ch == $? and:[self canFollowBy: -1 @ -1 andExitBy: 0@1])
				ifTrue: 
					[ "clockwise turn" 
					questionReplacement := $+.
					^ self doClockWiseTurn ].
			^self doExit].
! !

!DominoSceneBuilder methodsFor: 'private' stamp: 'emm 03/09/2012 20:19'!
doSwivelTo: nextWhere placeAt: center rotatedBy: rotation withDirection: newDirection clockwise: isCW
	
	| swivel tail |
	"check path missing"
	self direction: newDirection.	
	"assume we did not start with a swivel"
	tail := placer objects last.
	swivel := placer 
		placeSwivel180At: (self point3DFrom: center) 
		rotatedBy: rotation 
		clockwise: isCW.
	swivel color: tail color.
	tail addHead: swivel.
	self objectAt: self where put: swivel.
	self where: nextWhere! !

!DominoSceneBuilder methodsFor: 'private' stamp: 'emm 03/09/2012 20:19'!
doTurnTo: nextPoint orStraightTo: straightPoint orExitTo: newDirection at: exitPoint
	
	"are we exiting the turn?"
	(self hasCharAt: exitPoint)
		ifTrue:
			[ questionReplacement := nil.
			self direction: newDirection.
			^ self where: exitPoint ]. 

	 "check keep turning"
	(self hasCharAt: nextPoint)
		ifTrue:[ ^ self where: nextPoint ].
		
	(self hasCharAt: straightPoint)
		ifTrue:[ ^ self where: straightPoint ].
		
	^self error: 'turn expected'! !

!DominoSceneBuilder methodsFor: 'tag-handling' stamp: 'emm 03/09/2012 20:19'!
doWide

	"&"
	
	self direction = #south 
		ifTrue: [ 
			self doWideSouth.
			self doExit ].
	self direction = #north
		ifTrue: [ 
			self doWideNorth.
			self doExit ].
	self direction = #west
		ifTrue: [ 
			self doWideWest.
			self doExit ].
	self direction = #east
		ifTrue: [ 
			self doWideEast.
			self doExit ]! !

!DominoSceneBuilder methodsFor: 'tag-handling' stamp: 'emm 03/09/2012 20:19'!
doWideEast

	"&+east"
	
	| wy minX maxX  tail domino center |
	wy := self where y.
	minX := self where x.
	self rememberToGoto: self where x  @ (wy + 1).
	[ ( self charOrNilAt: ( minX - 1 ) @ wy ) = $& ]
		whileTrue: [ 
			self rememberToGoto: ( minX - 1@ ( wy + 1 ) ).
			minX := minX - 1 ].
	maxX := self where x.
	[ ( self charOrNilAt: ( maxX + 1 ) @ wy ) = $& ]
		whileTrue: [ 
			self rememberToGoto: ( maxX + 1 ) @ ( wy + 1 ).
			maxX := maxX + 1 ].

	tail := self doCompleteAnyTurn.
	self updatePlacerYawAngle.
	center := (minX + maxX) / 2 @ wy.
	placer restoreSizePointAfter:[
		placer sizePoint: 1, (self centerDistance * (maxX - minX ) + self dominoWidth), 10.
		domino := placer placeWideAt: ( self point3DFrom: center ) ].
	tail addHead: domino.
	minX to: maxX do: [ :x | self objectAt: x @ wy put: domino ].! !

!DominoSceneBuilder methodsFor: 'tag-handling' stamp: 'emm 03/09/2012 20:19'!
doWideNorth

	"&+north"
	
	| wx minY maxY domino tail center |
	wx := self where x.
	minY := self where y.
	self rememberToGoto: ( wx - 1 ) @ self where y.
	[ ( self charOrNilAt: wx @ ( minY - 1 ) ) = $& ]
		whileTrue: [ 
			self rememberToGoto: ( wx - 1 ) @ ( minY - 1 ).
			minY := minY - 1 ].
	maxY := self where y.
	[ ( self charOrNilAt: wx @ ( maxY + 1 ) ) = $& ]
		whileTrue: [ 
			self rememberToGoto: ( wx - 1 ) @ ( maxY + 1 ).
			maxY := maxY + 1 ].

	tail := self doCompleteAnyTurn.
	self updatePlacerYawAngle.
	center := wx @ ((minY + maxY) / 2).
	placer restoreSizePointAfter:[
		placer sizePoint: 1, (self centerDistance * (maxY - minY ) + self dominoWidth), 10.
		domino := placer placeWideAt: ( self point3DFrom: center ) ].
	tail addHead: domino.
	minY to: maxY do: [ :y | self objectAt: wx @ y put: domino ].! !

!DominoSceneBuilder methodsFor: 'tag-handling' stamp: 'emm 03/09/2012 20:19'!
doWideSouth

	"&+south"
	
	| wx minY maxY domino tail center |
	wx := self where x.
	minY := self where y.
	self rememberToGoto: ( wx + 1 ) @ self where y.
	[ ( self charOrNilAt: wx @ ( minY - 1 ) ) = $& ]
		whileTrue: [ 
			self rememberToGoto: ( wx + 1 ) @ ( minY - 1 ).
			minY := minY - 1 ].
	maxY := self where y.
	[ ( self charOrNilAt: wx @ ( maxY + 1 ) ) = $& ]
		whileTrue: [ 
			self rememberToGoto: ( wx + 1 ) @ ( maxY + 1 ).
			maxY := maxY + 1 ].

	tail := self doCompleteAnyTurn.
	self updatePlacerYawAngle.
	center := wx @ ((minY + maxY) / 2).
	placer restoreSizePointAfter:[
		placer sizePoint: 1, (self centerDistance * (maxY - minY ) + self dominoWidth), 10.
		domino := placer placeWideAt: ( self point3DFrom: center ) ].
	tail addHead: domino.
	minY to: maxY do: [ :y | self objectAt: wx @ y put: domino ].! !

!DominoSceneBuilder methodsFor: 'tag-handling' stamp: 'emm 03/09/2012 20:19'!
doWideWest

	"&+west"
	
	| wy minX maxX  tail domino center |
	wy := self where y.
	minX := self where x.
	self rememberToGoto: self where x  @ (wy - 1).
	[ ( self charOrNilAt: ( minX - 1 ) @ wy ) = $& ]
		whileTrue: [ 
			self rememberToGoto: ( minX - 1@ ( wy - 1 ) ).
			minX := minX - 1 ].
	maxX := self where x.
	[ ( self charOrNilAt: ( maxX + 1 ) @ wy ) = $& ]
		whileTrue: [ 
			self rememberToGoto: ( maxX + 1 ) @ ( wy - 1 ).
			maxX := maxX + 1 ].

	tail := self doCompleteAnyTurn.
	self updatePlacerYawAngle.
	center := (minX + maxX) / 2 @ wy.
	placer restoreSizePointAfter:[
		placer sizePoint: 1, (self centerDistance * (maxX - minX ) + self dominoWidth), 10.
		domino := placer placeWideAt: ( self point3DFrom: center ) ].
	tail addHead: domino.
	minX to: maxX do: [ :x | self objectAt: x @ wy put: domino ].! !

!DominoSceneBuilder methodsFor: 'initialize-release' stamp: 'emm 03/09/2012 20:19'!
dominoWidth

	^6! !

!DominoSceneBuilder methodsFor: 'testing' stamp: 'emm 03/09/2012 20:19'!
hasCharAt: aPosition

	^ (self charOrNilAt: aPosition ) notNil! !

!DominoSceneBuilder methodsFor: 'testing' stamp: 'emm 03/09/2012 20:19'!
hasDominoAt: aPosition

	^(self objectOrNilAt: aPosition) class == Domino! !

!DominoSceneBuilder methodsFor: 'testing' stamp: 'emm 03/09/2012 20:19'!
hasDominoCharAt: aPosition

	| char |
	^ (( char := self charOrNilAt: aPosition ) notNil 
		and:[ (self isSpecialChar: char) not ])! !

!DominoSceneBuilder methodsFor: 'initialize-release' stamp: 'emm 03/09/2012 20:19'!
initialize

	super initialize.
	placer := DominoPlacer new.
	placer sizePoint: 1, self dominoWidth, 10.! !

!DominoSceneBuilder methodsFor: 'testing' stamp: 'emm 03/09/2012 20:19'!
isSpecialChar: aChar
	
	^'@#-+><?=' includes: aChar! !

!DominoSceneBuilder methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
lastPosition

	^self state lastPosition! !

!DominoSceneBuilder methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
lastPosition: aPoint

	self state lastPosition: aPoint! !

!DominoSceneBuilder methodsFor: 'dispatching' stamp: 'emm 03/09/2012 20:19'!
objectAt: aPoint put: anObject
	
	matrix atRow: aPoint x column: aPoint y put: anObject! !

!DominoSceneBuilder methodsFor: 'dispatching' stamp: 'emm 03/09/2012 20:19'!
objectOrNilAt: aPoint 
	
	| obj |
	aPoint x < 1 
		ifTrue:[ ^ nil ].
	aPoint x > matrix maxRows 
		ifTrue:[ ^ nil ].
	aPoint y < 1 
		ifTrue:[ ^ nil ].
	aPoint y > matrix maxColumns
		ifTrue:[ ^ nil ].
	obj := matrix atRow: aPoint x column: aPoint y.
	obj isNil
		ifTrue:[ ^ nil ].
	^ obj! !

!DominoSceneBuilder methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
objects

	^placer objects! !

!DominoSceneBuilder methodsFor: 'building' stamp: 'emm 03/09/2012 20:19'!
point3DFrom: aPoint

	"Answer the 3D mapping of @aPoint"

	^(aPoint - (1@1)) * self centerDistance , 0
	! !

!DominoSceneBuilder methodsFor: 'printing' stamp: 'emm 03/09/2012 20:19'!
printOn: aStream
	
	| row |
	aStream nextPutAll: 'Excel position:'.
	row := self where y.
	(row // 26) = 0
		ifFalse: [ aStream nextPut: (Character value: $A asInteger - 1 + (row // 26)) ].
	aStream nextPut: (Character value: $A asInteger - 1 + (row \\ 26)).
	self where x printOn: aStream
! !

!DominoSceneBuilder methodsFor: 'private' stamp: 'emm 03/09/2012 20:19'!
rememberToGoto: aPoint 
	
	| char |
	char := self objectOrNilAt: aPoint.
	self objectAt: aPoint put: nil.	"make sure we do not encounter it twice"
	self stateStack addFirst: ( 
		( self state copy ) 
			position: aPoint
			; lastPosition: self position
			; character: char ) ! !

!DominoSceneBuilder methodsFor: 'resources' stamp: 'emm 03/09/2012 20:19'!
stateClass

	^DominoSceneBuildingState! !

!DominoSceneBuilder methodsFor: 'private' stamp: 'emm 03/09/2012 20:19'!
tryStartAt: startPoint withDirection: aSymbol
	
	( self hasDominoCharAt: startPoint )
		ifTrue:
			[ self where: startPoint.
			self direction: aSymbol.
			^true].
	^false! !

!DominoSceneBuilder methodsFor: 'private' stamp: 'emm 03/09/2012 20:19'!
updatePlacerColorWith: ch

	placer color: ( colorMap 
		at: ch 
		ifAbsent: [ Color white ] )! !

!DominoSceneBuilder methodsFor: 'private' stamp: 'emm 03/09/2012 20:19'!
updatePlacerYawAngle
	
	placer yawAngle: HalfPi * ((#(#south #east #north #west) indexOf: self direction) - 1).! !

!DominoSceneBuilder methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
where

	"Answer the value of where"

	^self position! !

!DominoSceneBuilder methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
where: aPoint

	"Remember where we came from.
	Answer the value of where"

	self lastPosition: self position.
	self position: aPoint! !

Cursor3DInterface subclass: #DotPen
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Modelling3D'!

!DotPen methodsFor: 'control' stamp: 'emm 02/09/2012 23:49'!
down

	super down.
	self objects add: self position
! !

!DotPen methodsFor: 'API' stamp: 'emm 02/09/2012 23:49'!
initializeFor2D

	self position: 0,0! !

!DotPen methodsFor: 'API' stamp: 'emm 02/09/2012 23:49'!
initializeFor3D

	self position: 0,0,0! !

!DotPen methodsFor: 'private' stamp: 'emm 02/09/2012 23:49'!
moveTo: aPoint
	
	self visible
		ifTrue:[ self objects add: aPoint].
	super moveTo: aPoint! !

Cursor3DInterface subclass: #Pen3D
	instanceVariableNames: 'segmentClass arcClass pointClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Modelling3D'!

!Pen3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:50'!
arcClass

	"Answer the value of arcClass"

	^arcClass! !

!Pen3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:50'!
arcClass: aValue

	"Set the value of arcClass"

	arcClass := aValue! !

!Pen3D methodsFor: 'operations-arcs' stamp: 'emm 02/09/2012 23:50'!
arcFrom: startPoint to: endPoint around: centerPoint clockwise: isCW

	self visible
		ifTrue: [ self segments add: ( self arcClass 
			from: self position 
			to: endPoint 
			center: centerPoint 
			clockwise: isCW ) ].
	self position: endPoint! !

!Pen3D methodsFor: 'operations' stamp: 'emm 02/09/2012 23:50'!
back

	self back: 1! !

!Pen3D methodsFor: 'operations' stamp: 'emm 02/09/2012 23:50'!
back: howMany! !

!Pen3D methodsFor: 'initialize-release' stamp: 'emm 02/09/2012 23:50'!
initialize

	self initializeFor3D.
	super initialize.! !

!Pen3D methodsFor: 'initialize-release' stamp: 'emm 02/09/2012 23:50'!
initializeFor2D

	self pointClass: Point.
	self arcClass: EllipticalArc2D.
	self segmentClass: LineSegment2D.
	super initialize.! !

!Pen3D methodsFor: 'initialize-release' stamp: 'emm 02/09/2012 23:50'!
initializeFor3D

	self pointClass: Point3D.
	self arcClass: EllipticalArc3D.
	self segmentClass: LineSegment3D.! !

!Pen3D methodsFor: 'inspecting' stamp: 'emm 02/09/2012 23:50'!
inspectActions
	"self new"

	^#(up down)! !

!Pen3D methodsFor: 'operations' stamp: 'emm 02/09/2012 23:50'!
moveTo: aPoint3D 
	
	self visible
		ifTrue:[ self segments add: ( self segmentClass from: self position to: aPoint3D )].
	super moveTo: aPoint3D! !

!Pen3D methodsFor: 'resources' stamp: 'emm 02/09/2012 23:50'!
newPointZero

	^(self pointClass ifNil:[ Point3D] ) zero! !

!Pen3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:50'!
pointClass

	"Answer the value of pointClass"

	^pointClass! !

!Pen3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:50'!
pointClass: aValue

	"Set the value of pointClass"

	pointClass := aValue! !

!Pen3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:50'!
segmentClass

	"Answer the value of segmentClass"

	^segmentClass! !

!Pen3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:50'!
segmentClass: aValue

	"Set the value of segmentClass"

	segmentClass := aValue! !

!Pen3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:50'!
segments

	"Answer the value of segments"

	^self objects! !

!Pen3D methodsFor: 'operations' stamp: 'emm 02/09/2012 23:50'!
upBackDown

	self upBackDown: 1! !

!Pen3D methodsFor: 'operations' stamp: 'emm 02/09/2012 23:50'!
upBackDown: howMany 

	| which |
	howMany = 0
		ifTrue: [ ^self ].
	self up.
	which := self segments at: (self segments size - ( howMany // 2)).
	self position: ( howMany even
		ifTrue: [ which end ]
		ifFalse: [ which start ] ).
	self down! !

!Pen3D methodsFor: 'computing' stamp: 'emm 02/09/2012 23:50'!
vertices

	| vertices |
	vertices := OrderedCollection new.
	self segments do:[ :each | vertices add: each from ].
	self segments last to = vertices first
		ifFalse: [ vertices add: self segments last to ].
	^vertices! !

Cursor3DInterface subclass: #WallPen
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Modelling3D'!

WallPen subclass: #TunnelPen
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Modelling3D'!

!TunnelPen methodsFor: 'private' stamp: 'emm 02/09/2012 23:50'!
addBackFace: face fromState: aState to: aCollection 

	super addBackFace: face reverseOriented fromState: aState to: aCollection ! !

!TunnelPen methodsFor: 'private' stamp: 'emm 02/09/2012 23:50'!
addBottomFace: face fromState: aState to: aCollection 

	super addBottomFace: face reverseOriented fromState: aState to: aCollection ! !

!TunnelPen methodsFor: 'private' stamp: 'emm 02/09/2012 23:50'!
addFrontFace: face fromState: aState to: aCollection 

	super addFrontFace: face reverseOriented fromState: aState to: aCollection ! !

!TunnelPen methodsFor: 'private' stamp: 'emm 02/09/2012 23:50'!
addLeftFace: face fromState: aState to: aCollection 
	
	super addLeftFace: face reverseOriented fromState: aState to: aCollection ! !

!TunnelPen methodsFor: 'private' stamp: 'emm 02/09/2012 23:50'!
addRightFace: face fromState: aState to: aCollection 

	super addRightFace: face reverseOriented fromState: aState to: aCollection ! !

!TunnelPen methodsFor: 'private' stamp: 'emm 02/09/2012 23:50'!
addTopFace: face fromState: aState to: aCollection 

	super addTopFace: face reverseOriented fromState: aState to: aCollection ! !

!WallPen methodsFor: 'private' stamp: 'emm 02/09/2012 23:50'!
addBackFace: face fromState: aState to: aCollection 
	aState width = 0 ifTrue: [^self].
	aState textureBack isNil 
		ifTrue: 
			[aState colorBack isNil 
				ifFalse: [aCollection add: (face coloredWith: aState colorBack)]]
		ifFalse: 
			[aCollection add: ((TextureWrapper on: face)
						texture: aState textureBack;
						color: aState colorBack;
						uv: aState uvBack)]! !

!WallPen methodsFor: 'private' stamp: 'emm 02/09/2012 23:50'!
addBottomFace: face fromState: aState to: aCollection 
	aState width = 0 ifTrue: [^self].
	aState textureBottom isNil 
		ifTrue: 
			[aState colorBottom isNil 
				ifFalse: [aCollection add: (face coloredWith: aState colorBottom)]]
		ifFalse: 
			[aCollection add: ((TextureWrapper on: face)
						texture: aState textureBottom;
						color: aState colorBottom;
						uv: aState uvBottom transpose)]! !

!WallPen methodsFor: 'private' stamp: 'emm 02/09/2012 23:50'!
addFrontFace: face fromState: aState to: aCollection 
	aState width = 0 ifTrue: [^self].
	aState textureFront isNil 
		ifTrue: 
			[aState colorFront isNil 
				ifFalse: [aCollection add: (face coloredWith: aState colorFront)]]
		ifFalse: 
			[aCollection add: ((TextureWrapper on: face)
						texture: aState textureFront;
						color: aState colorFront;
						uv: aState uvFront)]! !

!WallPen methodsFor: 'private' stamp: 'emm 02/09/2012 23:50'!
addLeftFace: face fromState: aState to: aCollection 
	aState textureLeft isNil 
		ifTrue: 
			[aState colorLeft isNil 
				ifFalse: [aCollection add: (face coloredWith: aState colorLeft)]]
		ifFalse: 
			[aCollection add: ((TextureWrapper on: face)
						texture: aState textureLeft;
						color: aState colorLeft;
						uv: aState uvLeft)]! !

!WallPen methodsFor: 'private' stamp: 'emm 02/09/2012 23:50'!
addRightFace: face fromState: aState to: aCollection 
	aState textureRight isNil 
		ifTrue: 
			[aState colorRight isNil 
				ifFalse: [aCollection add: (face coloredWith: aState colorRight)]]
		ifFalse: 
			[aCollection add: ((TextureWrapper on: face)
						texture: aState textureRight;
						color: aState colorRight;
						uv: aState uvRight)]! !

!WallPen methodsFor: 'private' stamp: 'emm 02/09/2012 23:50'!
addTopFace: face fromState: aState to: aCollection 
	aState width = 0 ifTrue: [^self].
	aState textureTop isNil 
		ifTrue: 
			[aState colorTop isNil 
				ifFalse: [aCollection add: (face coloredWith: aState colorTop)]]
		ifFalse: 
			[aCollection add: ((TextureWrapper on: face)
						texture: aState textureTop;
						color: aState colorTop;
						uv: aState uvTop transpose)]! !

!WallPen methodsFor: 'private-subclassResponsibility' stamp: 'emm 02/09/2012 23:50'!
arcFrom: startPoint to: endPoint around: centerPoint clockwise: isCW

	| arc |
	arc := self arcClass 
			from: self position 
			to: endPoint 
			center: centerPoint 
			clockwise: isCW ! !

!WallPen methodsFor: 'accessing-angles' stamp: 'emm 02/09/2012 23:50'!
backAngle: angle

	self state backAngle: angle! !

!WallPen methodsFor: 'accessing-color' stamp: 'emm 02/09/2012 23:50'!
color: aColor

	self colorLeft: aColor.
	self colorRight: aColor.
	self colorBack: aColor.
	self colorFront: aColor.
	self colorTop: aColor.
	self colorBottom: aColor.! !

!WallPen methodsFor: 'accessing-color' stamp: 'emm 02/09/2012 23:50'!
colorBack: aColor

	self state colorBack: aColor.! !

!WallPen methodsFor: 'accessing-color' stamp: 'emm 02/09/2012 23:50'!
colorBottom: aColor

	self state colorBottom: aColor.! !

!WallPen methodsFor: 'accessing-color' stamp: 'emm 02/09/2012 23:50'!
colorFront: aColor

	self state colorFront: aColor.! !

!WallPen methodsFor: 'accessing-color' stamp: 'emm 02/09/2012 23:50'!
colorLeft: aColor

	self state colorLeft: aColor.! !

!WallPen methodsFor: 'accessing-color' stamp: 'emm 02/09/2012 23:50'!
colorRight: aColor

	self state colorRight: aColor.! !

!WallPen methodsFor: 'accessing-color' stamp: 'emm 02/09/2012 23:50'!
colorTop: aColor

	self state colorTop: aColor.! !

!WallPen methodsFor: 'private' stamp: 'emm 02/09/2012 23:50'!
computeFacesFromSpec: aSpec polygon: topPolygon 

	| faces translation p1 p2 p3 p4 p5 p6 p7 p8  face|
	faces := OrderedCollection new.
	translation := 0 , 0 , aSpec height.
	p1 := topPolygon at: 1.
	p2 := topPolygon at: 2.
	p3 := topPolygon at: 3.
	p4 := topPolygon at: 4.
	p5 := p1 + translation.
	p6 := p2 + translation.
	p7 := p3 + translation.
	p8 := p4 + translation. 
	
	face := Polygon3D with: p1 with: p5 with: p8 with: p4.
	self addRightFace: face fromState: aSpec to: faces.
	face := Polygon3D with: p3 with: p7 with: p6 with: p2.
	self addLeftFace: face fromState: aSpec to: faces.
	face := Polygon3D with: p5  with: p6 with: p7 with: p8.
	self addTopFace: face fromState: aSpec to: faces.
	face := Polygon3D with: p2 with: p1 with: p4 with: p3.
	self addBottomFace: face fromState: aSpec to: faces.
	face := Polygon3D with: p2 with: p6 with: p5 with: p1.
	self addBackFace: face fromState: aSpec to: faces.
	face := Polygon3D with: p4 with: p8 with: p7 with: p3.
	self addFrontFace: face fromState: aSpec to: faces.

	^faces! !

!WallPen methodsFor: 'private' stamp: 'emm 02/09/2012 23:50'!
computeFacesFromSpecs: specs 

	"Pre: specs not empty, equal width"

	| expander topPolygons faces |
	faces := OrderedCollection new.
	specs first width = 0
		ifTrue: 
			[ "compute left and right face only"
			specs do:[ :each |
				| leftFace |
				leftFace := ((Polygon3D new) 
					add: each segment to
					;add: each segment to + (0,0,each height)
					;add: each segment from + (0,0,each height)
					;add: each segment from
					;yourself).
				self addLeftFace: leftFace fromState: each to: faces.
				self addRightFace: leftFace reverseOriented fromState: each to: faces ]. ]
		ifFalse: 
			[ expander := LineSegmentsExpander new.
			expander width: specs first width.
			expander startAngle: specs last frontAngle.
			expander stopAngle: specs last backAngle.
			topPolygons := expander expandAll: ( specs collect: [ :each | each segment ] ). 
			topPolygons 
				with: specs 
				do: [ :each :spec | faces addAll: ( self computeFacesFromSpec: spec polygon: each ) ] ].
	^faces! !

!WallPen methodsFor: 'utilities' stamp: 'emm 02/09/2012 23:50'!
doorwayHeight: height while: zeroBlock
	| oldHeight |
	oldHeight := self state height.
	self
		up
		;dz: height
		;height: oldHeight - height
		;down.
	zeroBlock value.
	self
		up
		;dz: height negated
		;height: oldHeight
		;down.! !

!WallPen methodsFor: 'accessing-angles' stamp: 'emm 02/09/2012 23:50'!
frontAngle: angle

	self state frontAngle: angle! !

!WallPen methodsFor: 'accessing-dimension' stamp: 'emm 02/09/2012 23:50'!
height

	^self state height! !

!WallPen methodsFor: 'accessing-dimension' stamp: 'emm 02/09/2012 23:50'!
height: posNum

	self state height: posNum! !

!WallPen methodsFor: 'private-subclassResponsibility' stamp: 'emm 02/09/2012 23:50'!
moveTo: aPoint 

	self visible 
		ifTrue: 
			[ 
			 | spec | 
			spec := self state copy.
			spec segment: ( self position lineSegmentTo: aPoint ).
			objects add: spec ].
	super moveTo: aPoint! !

!WallPen methodsFor: 'private' stamp: 'emm 02/09/2012 23:50'!
objects

	"compute faces based on specs stored by the receiver"

	"collect groups of specs that represent a continous wall"
	| groups  group last computedObjects|
	groups := OrderedCollection new.
	group := nil.
	last := nil.
	super objects do:[ :each |
		each segment from = last
			ifFalse: 
				[ group isNil 
					ifFalse: [ groups add: group ].
				group := OrderedCollection new ].
		group add: each. 
		last := each segment to].
	groups add: group.
	
	computedObjects := OrderedCollection new.
	groups do:[ :each |
		computedObjects addAll: (self computeFacesFromSpecs: each) ].
	^computedObjects! !

!WallPen methodsFor: 'private-subclassResponsibility' stamp: 'emm 02/09/2012 23:50'!
stateClass

	^WallPenState! !

!WallPen methodsFor: 'accessing-texture' stamp: 'emm 02/09/2012 23:50'!
texture: aString

	self texture: aString uv: 1,1! !

!WallPen methodsFor: 'accessing-texture' stamp: 'emm 02/09/2012 23:50'!
texture: aString color: aColor

	self texture: aString color: aColor uv: 1,1! !

!WallPen methodsFor: 'accessing-texture' stamp: 'emm 02/09/2012 23:50'!
texture: aString color: aColor uv: aPoint

	"Apply a texture identified by @aString. Can be a filename or url or some id"

	self color: aColor.
	self texture: aString uv: aPoint.! !

!WallPen methodsFor: 'accessing-texture' stamp: 'emm 02/09/2012 23:50'!
texture: aString uv: xyPoint

	self textureLeft: aString uv: xyPoint.
	self textureRight: aString uv: xyPoint.
	self textureFront: aString uv: xyPoint.
	self textureBack: aString uv: xyPoint.
	self textureTop: aString uv: xyPoint.
	self textureBottom: aString uv: xyPoint.! !

!WallPen methodsFor: 'accessing-texture' stamp: 'emm 02/09/2012 23:50'!
textureBack: aString

	self textureBack: aString uv: 1,1! !

!WallPen methodsFor: 'accessing-texture' stamp: 'emm 02/09/2012 23:50'!
textureBack: aString uv: xyPoint 
	(self state)
		textureBack: aString;
		uvBack: xyPoint! !

!WallPen methodsFor: 'accessing-texture' stamp: 'emm 02/09/2012 23:50'!
textureBottom: aString

	self textureBottom: aString uv: 1,1! !

!WallPen methodsFor: 'accessing-texture' stamp: 'emm 02/09/2012 23:50'!
textureBottom: aString uv: xyPoint 
	(self state)
		textureBottom: aString;
		uvBottom: xyPoint! !

!WallPen methodsFor: 'accessing-texture' stamp: 'emm 02/09/2012 23:50'!
textureFront: aString

	self textureFront: aString uv: 1,1! !

!WallPen methodsFor: 'accessing-texture' stamp: 'emm 02/09/2012 23:50'!
textureFront: aString uv: xyPoint 
	(self state)
		textureFront: aString;
		uvFront: xyPoint! !

!WallPen methodsFor: 'accessing-texture' stamp: 'emm 02/09/2012 23:50'!
textureLeft: aString

	self textureLeft: aString uv: 1,1! !

!WallPen methodsFor: 'accessing-texture' stamp: 'emm 02/09/2012 23:50'!
textureLeft: aString uv: xyPoint 
	(self state)
		textureLeft: aString;
		uvLeft: xyPoint! !

!WallPen methodsFor: 'accessing-texture' stamp: 'emm 02/09/2012 23:50'!
textureRight: aString

	self textureRight: aString uv: 1,1! !

!WallPen methodsFor: 'accessing-texture' stamp: 'emm 02/09/2012 23:50'!
textureRight: aString uv: xyPoint 
	(self state)
		textureRight: aString;
		uvRight: xyPoint! !

!WallPen methodsFor: 'accessing-texture' stamp: 'emm 02/09/2012 23:50'!
textureTop: aString

	self textureTop: aString uv: 1,1! !

!WallPen methodsFor: 'accessing-texture' stamp: 'emm 02/09/2012 23:50'!
textureTop: aString uv: xyPoint 
	(self state)
		textureTop: aString;
		uvTop: xyPoint! !

!WallPen methodsFor: 'accessing-texture' stamp: 'emm 02/09/2012 23:50'!
uv: xyPoint

	self uvBack: xyPoint.
	self uvFront: xyPoint.
	self uvLeft: xyPoint.
	self uvRight: xyPoint.
	self uvBottom: xyPoint.
	self uvTop: xyPoint.! !

!WallPen methodsFor: 'accessing-uv' stamp: 'emm 02/09/2012 23:50'!
uvBack: aPoint 
	self state uvBack: aPoint! !

!WallPen methodsFor: 'accessing-uv' stamp: 'emm 02/09/2012 23:50'!
uvBottom: aPoint 
	self state uvBottom: aPoint! !

!WallPen methodsFor: 'accessing-uv' stamp: 'emm 02/09/2012 23:50'!
uvFront: aPoint 
	self state uvFront: aPoint! !

!WallPen methodsFor: 'accessing-uv' stamp: 'emm 02/09/2012 23:50'!
uvLeft: xyPoint 
	self state uvLeft: xyPoint! !

!WallPen methodsFor: 'accessing-uv' stamp: 'emm 02/09/2012 23:50'!
uvRight: xyPoint 
	self state uvRight: xyPoint! !

!WallPen methodsFor: 'accessing-uv' stamp: 'emm 02/09/2012 23:50'!
uvTop: aPoint 
	self state uvTop: aPoint! !

!WallPen methodsFor: 'accessing-dimension' stamp: 'emm 02/09/2012 23:50'!
width

	^self state width! !

!WallPen methodsFor: 'accessing-dimension' stamp: 'emm 02/09/2012 23:50'!
width: posNum

	self state width: posNum! !

!WallPen methodsFor: 'utilities' stamp: 'emm 02/09/2012 23:50'!
windowOffset: dz height: height while: zeroBlock
	| oldHeight |
	oldHeight := self state height.
	self returnAfter:[
		self height: dz.
		zeroBlock value].
	self doorwayHeight: dz + height while: zeroBlock! !

Cursor2DInterface subclass: #Pen2D
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Modelling2D'!

!Pen2D methodsFor: 'operations-arcs' stamp: 'emm 02/09/2012 22:52'!
arcFrom: startPoint to: endPoint around: centerPoint clockwise: isCW

	self visible
		ifTrue: [ self segments add: ( EllipticalArc2D 
			from: self position 
			to: endPoint 
			center: centerPoint 
			clockwise: isCW ) ].
	self position: endPoint! !

!Pen2D methodsFor: 'inspecting' stamp: 'emm 02/09/2012 22:52'!
inspectActions
	"self new"

	^#(up down)! !

!Pen2D methodsFor: 'operations' stamp: 'emm 02/09/2012 22:52'!
moveTo: aPoint
	
	self visible
		ifTrue:[ self segments add: ( LineSegment2D from: self position to: aPoint )].
	super moveTo: aPoint! !

!Pen2D methodsFor: 'accessing' stamp: 'emm 02/09/2012 22:52'!
segments

	"Answer the value of segments"

	^self objects! !

!Pen2D methodsFor: 'operations' stamp: 'emm 02/09/2012 22:52'!
upBackDown

	self upBackDown: 1! !

!Pen2D methodsFor: 'operations' stamp: 'emm 02/09/2012 22:52'!
upBackDown: howMany 

	| which |
	howMany = 0
		ifTrue: [ ^self ].
	self up.
	which := self segments at: (self segments size - ( howMany // 2)).
	self position: ( howMany even
		ifTrue: [ which end ]
		ifFalse: [ which start ] ).
	self down! !

!Pen2D methodsFor: 'computing' stamp: 'emm 02/09/2012 22:52'!
vertices

	| vertices |
	vertices := OrderedCollection new.
	self segments do:[ :each | vertices add: each from ].
	self segments last to = vertices first
		ifFalse: [ vertices add: self segments last to ].
	^vertices! !

Object subclass: #Cursor2DState
	instanceVariableNames: 'position direction visible rotatesClockwise scale'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Modelling2D'!

!Cursor2DState class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 22:52'!
new

	^super new initialize! !

!Cursor2DState methodsFor: 'accessing' stamp: 'emm 02/09/2012 22:52'!
direction

	"Answer the value of direction"

	^direction! !

!Cursor2DState methodsFor: 'accessing' stamp: 'emm 02/09/2012 22:52'!
direction: aValue

	"Set the value of direction"

	direction := aValue! !

!Cursor2DState methodsFor: 'initialize-release' stamp: 'emm 02/09/2012 22:52'!
initialize

	direction := #none.
	visible := false.
	rotatesClockwise := true.
	self initializePosition.
	scale := 1.! !

!Cursor2DState methodsFor: 'initialize-release' stamp: 'emm 02/09/2012 22:52'!
initializePosition

	position := Point zero.
! !

!Cursor2DState methodsFor: 'accessing' stamp: 'emm 02/09/2012 22:52'!
position

	"Answer the value of position"

	^position! !

!Cursor2DState methodsFor: 'accessing' stamp: 'emm 02/09/2012 22:52'!
position: aValue

	"Set the value of position"

	position := aValue! !

!Cursor2DState methodsFor: 'printing' stamp: 'emm 02/09/2012 22:52'!
printOn: aStream

	super printOn: aStream.
	aStream cr.
	self printableInstanceVariablesNames
		do:[ :each | aStream tab ;nextPutAll: each ; nextPut: $: ;print: (self perform: each) ]
		separatedBy: [ aStream cr ]! !

!Cursor2DState methodsFor: 'printing' stamp: 'emm 02/09/2012 22:52'!
printableInstanceVariablesNames

	^self class allInstVarNames collect:[ :each | each asSymbol ]! !

!Cursor2DState methodsFor: 'accessing' stamp: 'emm 02/09/2012 22:52'!
rotatesClockwise

	"Answer the value of rotatesClockwise"

	^rotatesClockwise! !

!Cursor2DState methodsFor: 'accessing' stamp: 'emm 02/09/2012 22:52'!
rotatesClockwise: aValue

	"Set the value of rotatesClockwise"

	rotatesClockwise := aValue! !

!Cursor2DState methodsFor: 'accessing' stamp: 'emm 02/09/2012 22:52'!
scale

	"Answer the value of scale"

	^scale! !

!Cursor2DState methodsFor: 'accessing' stamp: 'emm 02/09/2012 22:52'!
scale: aValue

	"Set the value of scale"

	scale := aValue! !

!Cursor2DState methodsFor: 'accessing' stamp: 'emm 02/09/2012 22:52'!
visible

	"Answer the value of visible"

	^visible! !

!Cursor2DState methodsFor: 'accessing' stamp: 'emm 02/09/2012 22:52'!
visible: aValue

	"Set the value of visible"

	visible := aValue! !

Cursor2DState subclass: #Cursor3DState
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Modelling3D'!

Cursor3DState subclass: #BoxPenState
	instanceVariableNames: 'width height lastBounds'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Modelling3D'!

!BoxPenState methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:50'!
height

	"Answer the value of height"

	^height! !

!BoxPenState methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:50'!
height: aValue

	"Set the value of height"

	height := aValue! !

!BoxPenState methodsFor: 'initialize-release' stamp: 'emm 02/09/2012 23:50'!
initialize

	super initialize.
	width := 1.
	height := 1.! !

!BoxPenState methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:50'!
lastBounds

	"Answer the value of lastBounds"

	^lastBounds! !

!BoxPenState methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:50'!
lastBounds: aValue

	"Set the value of lastBounds"

	lastBounds := aValue! !

!BoxPenState methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:50'!
width

	"Answer the value of width"

	^width! !

!BoxPenState methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:50'!
width: aValue

	"Set the value of width"

	width := aValue! !

!Cursor3DState methodsFor: 'initialize-release' stamp: 'emm 02/09/2012 23:49'!
initializePosition

	position := Point3D zero.! !

Cursor3DState subclass: #DominoPlacingState
	instanceVariableNames: 'delta sizePoint yawAngle color'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Dominos'!

!DominoPlacingState methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
color

	"Answer the value of color"

	^color! !

!DominoPlacingState methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
color: aValue

	"Set the value of color"

	color := aValue! !

!DominoPlacingState methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
delta
	^delta! !

!DominoPlacingState methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
delta: aPoint
	delta := aPoint! !

!DominoPlacingState methodsFor: 'initialize-release' stamp: 'emm 03/09/2012 20:19'!
initialize

	super initialize.
	self yawAngle: 0.
	self sizePoint: 1,4,10.
	self color: Color yellow.! !

!DominoPlacingState methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
sizePoint

	"Answer the value of sizePoint"

	^sizePoint! !

!DominoPlacingState methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
sizePoint: aValue

	"Set the value of sizePoint"

	sizePoint := aValue! !

!DominoPlacingState methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
yawAngle

	"Answer the value of yawAngle"

	^yawAngle! !

!DominoPlacingState methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
yawAngle: aValue

	"Set the value of yawAngle"

	yawAngle := aValue! !

Cursor3DState subclass: #DominoSceneBuildingState
	instanceVariableNames: 'character lastPosition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Dominos'!

!DominoSceneBuildingState methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
character

	"Answer the value of character"

	^character! !

!DominoSceneBuildingState methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
character: aValue

	"Set the value of character"

	character := aValue! !

!DominoSceneBuildingState methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
lastPosition

	"Answer the value of lastPosition"

	^lastPosition! !

!DominoSceneBuildingState methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
lastPosition: aValue

	"Set the value of lastPosition"

	lastPosition := aValue! !

!DominoSceneBuildingState methodsFor: 'printing' stamp: 'emm 03/09/2012 20:19'!
printableInstanceVariablesNames

	^super printableInstanceVariablesNames , #( character lastPosition )! !

Cursor3DState subclass: #WallPenState
	instanceVariableNames: 'width height segment frontAngle backAngle textureLeft textureRight colorLeft colorRight colorFront colorBack colorTop colorBottom textureTop textureBottom textureFront textureBack uvLeft uvRight uvBottom uvTop uvFront uvBack'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Modelling3D'!

!WallPenState methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:50'!
backAngle

	"Answer the value of backAngle"

	^backAngle! !

!WallPenState methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:50'!
backAngle: aValue

	"Set the value of backAngle"

	backAngle := aValue! !

!WallPenState methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:50'!
colorBack

	"Answer the value of colorBack"

	^colorBack! !

!WallPenState methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:50'!
colorBack: aValue

	"Set the value of colorBack"

	colorBack := aValue! !

!WallPenState methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:50'!
colorBottom

	"Answer the value of colorBottom"

	^colorBottom! !

!WallPenState methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:50'!
colorBottom: aValue

	"Set the value of colorBottom"

	colorBottom := aValue! !

!WallPenState methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:50'!
colorFront

	"Answer the value of colorFront"

	^colorFront! !

!WallPenState methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:50'!
colorFront: aValue

	"Set the value of colorFront"

	colorFront := aValue! !

!WallPenState methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:50'!
colorLeft

	"Answer the value of colorLeft"

	^colorLeft! !

!WallPenState methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:50'!
colorLeft: aValue

	"Set the value of colorLeft"

	colorLeft := aValue! !

!WallPenState methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:50'!
colorRight

	"Answer the value of colorRight"

	^colorRight! !

!WallPenState methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:50'!
colorRight: aValue

	"Set the value of colorRight"

	colorRight := aValue! !

!WallPenState methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:50'!
colorTop

	"Answer the value of colorTop"

	^colorTop! !

!WallPenState methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:50'!
colorTop: aValue

	"Set the value of colorTop"

	colorTop := aValue! !

!WallPenState methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:50'!
frontAngle

	"Answer the value of frontAngle"

	^frontAngle! !

!WallPenState methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:50'!
frontAngle: aValue

	"Set the value of frontAngle"

	frontAngle := aValue! !

!WallPenState methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:50'!
height

	"Answer the value of height"

	^height! !

!WallPenState methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:50'!
height: aValue

	"Set the value of height"

	height := aValue! !

!WallPenState methodsFor: 'initialize-release' stamp: 'emm 02/09/2012 23:50'!
initialize
	super initialize.
	width := 0.
	height := 10.
	uvLeft := uvRight := uvTop := uvBottom := uvFront := uvBack := 1 , 1! !

!WallPenState methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:50'!
segment

	"Answer the value of segment"

	^segment! !

!WallPenState methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:50'!
segment: aValue

	"Set the value of segment"

	segment := aValue! !

!WallPenState methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:50'!
textureBack

	"Answer the value of textureBack"

	^textureBack! !

!WallPenState methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:50'!
textureBack: aValue

	"Set the value of textureBack"

	textureBack := aValue! !

!WallPenState methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:50'!
textureBottom

	"Answer the value of textureBottom"

	^textureBottom! !

!WallPenState methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:50'!
textureBottom: aValue

	"Set the value of textureBottom"

	textureBottom := aValue! !

!WallPenState methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:50'!
textureFront

	"Answer the value of textureFront"

	^textureFront! !

!WallPenState methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:50'!
textureFront: aValue

	"Set the value of textureFront"

	textureFront := aValue! !

!WallPenState methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:50'!
textureLeft

	"Answer the value of textureLeft"

	^textureLeft! !

!WallPenState methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:50'!
textureLeft: aValue

	"Set the value of textureLeft"

	textureLeft := aValue! !

!WallPenState methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:50'!
textureRight

	"Answer the value of textureRight"

	^textureRight! !

!WallPenState methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:50'!
textureRight: aValue

	"Set the value of textureRight"

	textureRight := aValue! !

!WallPenState methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:50'!
textureTop

	"Answer the value of textureTop"

	^textureTop! !

!WallPenState methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:50'!
textureTop: aValue

	"Set the value of textureTop"

	textureTop := aValue! !

!WallPenState methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:50'!
uvBack
	"Answer the value of scaleBack"

	^uvBack! !

!WallPenState methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:50'!
uvBack: aValue 
	"Set the value of scaleBack"

	uvBack := aValue! !

!WallPenState methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:50'!
uvBottom
	"Answer the value of scaleBottom"

	^uvBottom! !

!WallPenState methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:50'!
uvBottom: aValue 
	"Set the value of scaleBottom"

	uvBottom := aValue! !

!WallPenState methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:50'!
uvFront
	"Answer the value of scaleFront"

	^uvFront! !

!WallPenState methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:50'!
uvFront: aValue 
	"Set the value of scaleFront"

	uvFront := aValue! !

!WallPenState methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:50'!
uvLeft
	"Answer the value of scaleLeft"

	^uvLeft! !

!WallPenState methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:50'!
uvLeft: aValue 
	"Set the value of scaleLeft"

	uvLeft := aValue! !

!WallPenState methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:50'!
uvRight
	"Answer the value of scaleRight"

	^uvRight! !

!WallPenState methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:50'!
uvRight: aValue 
	"Set the value of scaleRight"

	uvRight := aValue! !

!WallPenState methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:50'!
uvTop
	"Answer the value of scaleTop"

	^uvTop! !

!WallPenState methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:50'!
uvTop: aValue 
	"Set the value of scaleTop"

	uvTop := aValue! !

!WallPenState methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:50'!
width

	"Answer the value of width"

	^width! !

!WallPenState methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:50'!
width: aValue

	"Set the value of width"

	width := aValue! !

Object subclass: #CurvedArrow
	instanceVariableNames: 'start via end head bounds flags'
	classVariableNames: 'ArrowPoints TriangleHead'
	poolDictionaries: ''
	category: 'Zenna-Core2D'!

!CurvedArrow class methodsFor: 'initialization' stamp: 'emm 02/09/2012 22:51'!
arrowHeadInset

	^5! !

!CurvedArrow class methodsFor: 'initialization' stamp: 'emm 02/09/2012 22:51'!
arrowHeadLength

	^18! !

!CurvedArrow class methodsFor: 'initialization' stamp: 'emm 02/09/2012 22:51'!
arrowHeadWidth

	^10! !

!CurvedArrow class methodsFor: 'initialization' stamp: 'emm 02/09/2012 22:51'!
defaultArrowPoints
	"horizontal to the left"
	"self initialize"

	| points |
	points := Array new: 5.
	points
		 at: 1 put: 0 @ 0
		; at: 2 put: self arrowHeadWidth // 2 @ self arrowHeadLength
		; at: 3 put: 0 @ (self arrowHeadLength - self arrowHeadInset)
		; at: 4 put: self arrowHeadWidth // 2 negated @ self arrowHeadLength
		; at: 5 put: 0 @ 0.
	^points collect: [:each | (each rotatedBy: Float pi / 2) rounded]! !

!CurvedArrow class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 22:51'!
from: startPoint to: endPoint via: viaPoint
	^self new from: startPoint to: endPoint via: viaPoint! !

!CurvedArrow class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 22:51'!
from: startPoint to: endPoint withMidPoint: pointOnCurve
	^self new from: startPoint to: endPoint withMidPoint: pointOnCurve! !

!CurvedArrow class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 22:51'!
from: startPoint to: endPoint withMidPoint: pointOnCurve at: parameter
	^self new from: startPoint to: endPoint withMidPoint: pointOnCurve at: parameter! !

!CurvedArrow class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 22:51'!
from: startPoint via: viaPoint to: endPoint 
	^self new from: startPoint to: endPoint via: viaPoint! !

!CurvedArrow class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 22:51'!
from: startPoint withMidPoint: pointOnCurve at: parameter to: endPoint 
	^self new from: startPoint to: endPoint withMidPoint: pointOnCurve at: parameter! !

!CurvedArrow class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 22:51'!
from: startPoint withMidPoint: pointOnCurve to: endPoint 
	^self new from: startPoint to: endPoint withMidPoint: pointOnCurve! !

!CurvedArrow class methodsFor: 'initialization' stamp: 'emm 10/2/2012 21:23'!
initializeAfterLoad

	ArrowPoints := self defaultArrowPoints.
	TriangleHead := self triangleArrowPoints.! !

!CurvedArrow class methodsFor: 'initialization' stamp: 'emm 02/09/2012 22:51'!
new
	^super new initialize! !

!CurvedArrow class methodsFor: 'initialization' stamp: 'emm 02/09/2012 22:51'!
triangleArrowPoints
	"horizontal to the left"
	"self initialize"

	| points |
	points := Array new: 4.
	points
		  at: 1 put: 0 @ 0
		; at: 2 put: self arrowHeadWidth // 2 @ (self arrowHeadLength - self arrowHeadInset)
		; at: 3 put: self arrowHeadWidth // 2 negated @ (self arrowHeadLength - self arrowHeadInset)
		; at: 4 put: 0 @ 0.
	^points collect: [:each | (each rotatedBy: Float pi / 2) rounded]! !

!CurvedArrow methodsFor: 'displaying' stamp: 'emm 02/09/2012 22:51'!
bounds
	"Return the bounds containing the receiver"
	
	bounds isNil ifTrue: [bounds := self computeBounds].
	^bounds! !

!CurvedArrow methodsFor: 'displaying' stamp: 'emm 02/09/2012 22:51'!
computeBounds

	"Return the bounds containing the receiver"

	| min max |
	min := start min: end.
	max := start max: end.
	via isNil 
		ifFalse: 
			[ min := min min: via.
			max := max max: via ].
	flags > 0 ifTrue:[
	self head do:[ :each |
		min := min min: each.
		max := max max: each ]].
	^Rectangle origin: min truncated corner: max ceiling! !

!CurvedArrow methodsFor: 'displaying' stamp: 'emm 02/09/2012 22:51'!
computeHead

	| angle |
	angle := self tangentAtEnd theta.
	^(flags = 2
		ifTrue:[ArrowPoints]
		ifFalse:[TriangleHead]) collect: [ :each | ( ( each rotatedBy: angle ) + self end ) rounded ]! !

!CurvedArrow methodsFor: 'accessing' stamp: 'emm 02/09/2012 22:51'!
end
	^end! !

!CurvedArrow methodsFor: 'accessing' stamp: 'emm 02/09/2012 22:51'!
end: anObject
	end := anObject! !

!CurvedArrow methodsFor: 'initialize-release' stamp: 'emm 02/09/2012 22:51'!
flush
	head := bounds := nil! !

!CurvedArrow methodsFor: 'accessing' stamp: 'emm 02/09/2012 22:51'!
from: startPoint to: endPoint
	"Initialize the receiver as straight line"
	start := startPoint.
	end := endPoint.
	via := (start + end) // 2.! !

!CurvedArrow methodsFor: 'accessing' stamp: 'emm 02/09/2012 22:51'!
from: startPoint to: endPoint via: viaPoint
	"Initialize the receiver"
	start := startPoint.
	end := endPoint.
	via := viaPoint.! !

!CurvedArrow methodsFor: 'accessing' stamp: 'emm 02/09/2012 22:51'!
from: startPoint to: endPoint withMidPoint: pointOnCurve
	"Initialize the receiver with the pointOnCurve assumed at the parametric value 0.5"
	start := startPoint.
	end := endPoint.
	"Compute via"
	via := (pointOnCurve * 2) - ((start+end) // 2).! !

!CurvedArrow methodsFor: 'accessing' stamp: 'emm 02/09/2012 22:51'!
from: startPoint to: endPoint withMidPoint: pointOnCurve at: parameter
	"Initialize the receiver with the pointOnCurve at the given parametric value"
	| t1 t2 t3 |
	start := startPoint.
	end := endPoint.
	"Compute via"
	t1 := (1.0 - parameter) squared.
	t2 := 2 * parameter * (1.0 - parameter).
	t3 := parameter squared.
	via := (pointOnCurve * t2) - (start * t1)  - (end * t3)! !

!CurvedArrow methodsFor: 'testing' stamp: 'emm 02/09/2012 22:51'!
hasZeroLength
	"Return true if the receiver has zero length"
	^start = end and:[start = via]! !

!CurvedArrow methodsFor: 'accessing' stamp: 'emm 02/09/2012 22:51'!
head 
	head isNil ifTrue: [head := self computeHead].
	^head! !

!CurvedArrow methodsFor: 'initialize-release' stamp: 'emm 02/09/2012 22:51'!
initialize
	flags := 2.! !

!CurvedArrow methodsFor: 'testing' stamp: 'emm 02/09/2012 22:51'!
isDashed
	^(flags bitAnd: 4) = 4! !

!CurvedArrow methodsFor: 'testing' stamp: 'emm 02/09/2012 22:51'!
isDistanceTo: aPoint lessThan: distance 

	^self isStraight
		ifTrue: 
			[ self isLineDistanceTo: aPoint lessThan: distance ]
		ifFalse: 
			[ self lineSegmentPointsDo: [ :each :other | ( each dist: aPoint ) < distance 
				ifTrue: [ ^true ] ].
			false ]! !

!CurvedArrow methodsFor: 'testing' stamp: 'emm 02/09/2012 22:51'!
isLineDistanceTo: aPoint lessThan: distance

	| fromPoint  toPoint a b c a2plusb2sqrt|
	"may want to cache"
	fromPoint := self  start.
	toPoint := self  end.
	a := toPoint y - fromPoint y.
	b := fromPoint x - toPoint x.
	c := (fromPoint y * toPoint x) - (fromPoint x * toPoint y).
	a2plusb2sqrt := (a squared + b squared) sqrt.
	^(((a * aPoint x) + (b * aPoint y) + c) / a2plusb2sqrt) abs <= distance! !

!CurvedArrow methodsFor: 'testing' stamp: 'emm 02/09/2012 22:51'!
isStraight
	^self via isNil! !

!CurvedArrow methodsFor: 'dispatching' stamp: 'emm 02/09/2012 22:51'!
kindDo: aRequestor
	^aRequestor doCurvedArrow: self! !

!CurvedArrow methodsFor: 'accessing' stamp: 'emm 02/09/2012 22:51'!
length
	"Return the length of the receiver"
	"Note: Overestimates the length"
	^(start dist: via) + (via dist: end)! !

!CurvedArrow methodsFor: 'enumerating' stamp: 'emm 02/09/2012 22:51'!
lineSegmentPointsDo: aBlock
	"Evaluate aBlock with the receiver's line segments"
	"Note: We could use forward differencing here."
	
	| steps last deltaStep t next |
	self isStraight ifTrue: [^aBlock value: start value: end ].
	
	steps := 1 max: (self length // 10). "Assume 10 pixels per step"
	last := start.
	deltaStep := 1.0 / steps asFloat.
	t := deltaStep.
	1 to: steps do:[:i|
		next := self valueAt: t.
		aBlock value: last value: next.
		last := next.
		t := t + deltaStep].! !

!CurvedArrow methodsFor: 'displaying' stamp: 'emm 02/09/2012 22:51'!
primitiveDrawOn: aDrawable gc: gc 

	self isDashed 
		ifTrue: 
			[ gc 
				setLineAttributes: 1 
				lineStyle: 1 
				capStyle: 3 
				joinStyle: 0.
			gc setDashes: 0 dashList: #(10 10) ].
	self lineSegmentPointsDo: [ :from :to | 
		aDrawable 
			drawLine: gc 
			x1: from x rounded 
			y1: from y rounded 
			x2: to x rounded 
			y2: to y rounded ].
	self isDashed 
		ifTrue: 
			[ gc 
				setLineAttributes: 1 
				lineStyle: 0 
				capStyle: 3 
				joinStyle: 0 ].
	flags = 0 
		ifTrue: [ ^self ].
	aDrawable 
		fillPolygon: gc 
		points: self head 
		shape: 2 
		mode: 0! !

!CurvedArrow methodsFor: 'printing' stamp: 'emm 02/09/2012 22:51'!
printOn: aStream
	"Print the receiver on aStream"
	aStream 
		nextPutAll: self class name;
		nextPutAll:' from: ';
		print: start;
		nextPutAll: ' via: ';
		print: via;
		nextPutAll: ' to: ';
		print: end;
		space.! !

!CurvedArrow methodsFor: 'accessing' stamp: 'emm 02/09/2012 22:51'!
showDashed
	flags := flags bitOr: 4.
	self flush! !

!CurvedArrow methodsFor: 'accessing' stamp: 'emm 02/09/2012 22:51'!
showInsetHead
	flags := flags bitOr: 2.
	self flush! !

!CurvedArrow methodsFor: 'accessing' stamp: 'emm 02/09/2012 22:51'!
showTriangleHead
	flags := flags bitOr: 1.
	self flush! !

!CurvedArrow methodsFor: 'accessing' stamp: 'emm 02/09/2012 22:51'!
start
	^start! !

!CurvedArrow methodsFor: 'accessing' stamp: 'emm 02/09/2012 22:51'!
start: anObject
	start := anObject! !

!CurvedArrow methodsFor: 'accessing' stamp: 'emm 02/09/2012 22:51'!
tangentAt: parameter
	"Return the tangent at the given parametric value along the receiver"
	| in out |
	in := self tangentAtStart.
	out := self tangentAtEnd.
	^in + (out - in * parameter)! !

!CurvedArrow methodsFor: 'accessing' stamp: 'emm 02/09/2012 22:51'!
tangentAtEnd
	"Return the tangent for the last point"

	^via isNil
		ifTrue: [end - start]
		ifFalse: [end - via]! !

!CurvedArrow methodsFor: 'accessing' stamp: 'emm 02/09/2012 22:51'!
tangentAtStart
	"Return the tangent for the first point"
	^via - start! !

!CurvedArrow methodsFor: 'accessing' stamp: 'emm 02/09/2012 22:51'!
valueAt: parameter
	"Evaluate the receiver at the given parametric value"
	"Return the point at the parametric value t:
		p(t) =	(1-t)^2 * p1 + 
				2*t*(1-t) * p2 + 
				t^2 * p3.
	"
	| t1 t2 t3 |
	t1 := (1.0 - parameter) squared.
	t2 := 2 * parameter * (1.0 - parameter).
	t3 := parameter squared.
	^(start * t1) + (via * t2) + (end * t3)! !

!CurvedArrow methodsFor: 'accessing' stamp: 'emm 02/09/2012 22:51'!
via
	"Return the control point"
	^via! !

Object subclass: #D3DMesh
	instanceVariableNames: 'faces materials textureCoords'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-FormatDirectX'!

!D3DMesh class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:26'!
fromGeometric: aGeometric

	^self new
			initializeWithGeometric: aGeometric! !

!D3DMesh class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:26'!
new
	^super new initialize! !

!D3DMesh methodsFor: 'building' stamp: 'emm 02/09/2012 23:26'!
addFace: aFace withMaterial: aMaterial 

	faces add: aFace.
	materials add: aMaterial! !

!D3DMesh methodsFor: 'converting' stamp: 'emm 02/09/2012 23:26'!
asMeshD3D! !

!D3DMesh methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:26'!
faces

	"Answer the value of faces"

	^faces! !

!D3DMesh methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:26'!
faces: aValue

	"Set the value of faces"

	faces := aValue! !

!D3DMesh methodsFor: 'testing' stamp: 'emm 02/09/2012 23:26'!
hasTexture
	
	"Answer whether at least one material specifies a texture filename"
	
	self materials do: [ :each | each textureFilename notNil 
		ifTrue: [ ^true ] ].
	^false! !

!D3DMesh methodsFor: 'initialize-release' stamp: 'emm 02/09/2012 23:26'!
initialize

	faces := OrderedCollection new.
	materials := OrderedCollection new.! !

!D3DMesh methodsFor: 'private' stamp: 'emm 02/09/2012 23:26'!
initializeWithGeometric: aGeometric

	aGeometric facesDo:[ :each |
		self addFace: each withMaterial: nil ]
! !

!D3DMesh methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:26'!
kindDo: aRequestor
	^aRequestor doD3DMesh: self! !

!D3DMesh methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:26'!
materials

	"Answer the value of materials"

	^materials! !

!D3DMesh methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:26'!
textureCoords

	"Answer the value of textureCoords"

	^textureCoords! !

!D3DMesh methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:26'!
textureCoords: aValue

	"Set the value of textureCoords"

	textureCoords := aValue! !

Object subclass: #D3DMeshMaterial
	instanceVariableNames: 'name faceColor power specularColor emissiveColor textureFilename'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-FormatDirectX'!

!D3DMeshMaterial class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:26'!
colored: aColor

	^( self new )
			name: aColor name asUppercase , 'Material'
			; faceColor: aColor! !

!D3DMeshMaterial class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:26'!
new
	^super new initialize! !

!D3DMeshMaterial methodsFor: 'comparing' stamp: 'emm 02/09/2012 23:26'!
= aMaterial

	^ aMaterial class = self class
		and:[ self name = aMaterial name]! !

!D3DMeshMaterial methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:26'!
emissiveColor

	"Answer the value of emissiveColor"

	^emissiveColor! !

!D3DMeshMaterial methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:26'!
emissiveColor: aValue

	"Set the value of emissiveColor"

	emissiveColor := aValue! !

!D3DMeshMaterial methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:26'!
faceColor

	"Answer the value of faceColor"

	^faceColor! !

!D3DMeshMaterial methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:26'!
faceColor: aValue

	"Set the value of faceColor"

	faceColor := aValue! !

!D3DMeshMaterial methodsFor: 'comparing' stamp: 'emm 02/09/2012 23:26'!
hash

	^self name hash! !

!D3DMeshMaterial methodsFor: 'initialize-release' stamp: 'emm 02/09/2012 23:26'!
initialize
	"Initialize to black"

	self name: 'BlackMaterial'.
	self faceColor: Color black.
	self power: 0.0.
	self specularColor: Color black.
	self emissiveColor: Color black.! !

!D3DMeshMaterial methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:26'!
kindDo: aRequestor
	^aRequestor doD3DMeshMaterial: self! !

!D3DMeshMaterial methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:26'!
name

	"Answer the value of name"

	^name! !

!D3DMeshMaterial methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:26'!
name: aValue

	"Set the value of name"

	name := aValue! !

!D3DMeshMaterial methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:26'!
power

	"Answer the value of power"

	^power! !

!D3DMeshMaterial methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:26'!
power: aValue

	"Set the value of power"

	power := aValue! !

!D3DMeshMaterial methodsFor: 'printing' stamp: 'emm 02/09/2012 23:26'!
printOn: aStream

	super printOn: aStream.
	name isNil
		ifFalse:[ aStream space ;nextPut: $" ;nextPutAll: name ;nextPut: $" ].! !

!D3DMeshMaterial methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:26'!
specularColor

	"Answer the value of specularColor"

	^specularColor! !

!D3DMeshMaterial methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:26'!
specularColor: aValue

	"Set the value of specularColor"

	specularColor := aValue! !

!D3DMeshMaterial methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:26'!
textureFilename

	"Answer the value of textureFilename"

	^textureFilename! !

!D3DMeshMaterial methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:26'!
textureFilename: aValue

	"Set the value of textureFilename"

	textureFilename := aValue! !

Object subclass: #Diamond
	instanceVariableNames: 'bounds'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Core2D'!

!Diamond class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 22:51'!
center: aPoint width: width height: height

	| halfExtent |
	halfExtent := (width@height) / 2.
	^self new bounds: (aPoint - halfExtent corner: aPoint + halfExtent)! !

!Diamond methodsFor: 'accessing' stamp: 'emm 02/09/2012 22:51'!
bounds
	^bounds! !

!Diamond methodsFor: 'accessing' stamp: 'emm 02/09/2012 22:51'!
bounds: anObject
	bounds := anObject! !

!Diamond methodsFor: 'displaying' stamp: 'emm 02/09/2012 22:51'!
drawOn: aDrawable gc: gc 

	| openShape closeShape |
	openShape := self shape.
	closeShape := WriteStream on: ( Array new: 5 ).
	closeShape nextPut: openShape first.
	2 to: openShape size do: [ :i | closeShape nextPut: ( openShape at: i ) - ( openShape at: i - 1 ) ].
	closeShape nextPut: ( openShape at: 1 ) - ( openShape at: openShape size ).
	aDrawable 
		drawLines: gc 
		points: closeShape contents 
		mode: 1! !

!Diamond methodsFor: 'displaying' stamp: 'emm 02/09/2012 22:51'!
fillOn: aDrawable gc: gc 
	
	aDrawable 
		fillPolygon: gc 
		points: self shape
		shape: 2 
		mode: 0! !

!Diamond methodsFor: 'displaying' stamp: 'emm 02/09/2012 22:51'!
shape

	^(Array new: 4)
		at: 1 put: self bounds leftCenter rounded
		;at: 2 put: self bounds topCenter rounded
		;at: 3 put: self bounds rightCenter rounded
		;at: 4 put: self bounds bottomCenter rounded
		;yourself						! !

Object subclass: #DominoColorManager
	instanceVariableNames: 'colorMap'
	classVariableNames: ''
	poolDictionaries: 'Math3DConstants'
	category: 'Zenna-Dominos'!

!DominoColorManager class methodsFor: 'instance-creation' stamp: 'emm 03/09/2012 20:19'!
new

	^super new initialize.! !

!DominoColorManager methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
colorMap

	"Answer the value of colorMap"

	^colorMap! !

!DominoColorManager methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
colorMap: aValue

	"Set the value of colorMap"

	colorMap := aValue! !

!DominoColorManager methodsFor: 'initialize' stamp: 'emm 03/09/2012 20:19'!
initialize

	colorMap := Dictionary new.
	colorMap at: $a put: Color white.! !

!DominoColorManager methodsFor: 'enumerate' stamp: 'emm 03/09/2012 20:19'!
nextColorKeyValue

	| keys |

	keys := self returnKeys.
	keys do:[:key | (colorMap includesKey: key)
							ifFalse: [^key]].! !

!DominoColorManager methodsFor: 'enumerate' stamp: 'emm 03/09/2012 20:19'!
returnColorKeyFromColor: aColor

	"returns the colorKeyValue of @aColor"

	|  ncv |

	(self colorMap includes: aColor)
	ifTrue:[ ^colorMap keyAtValue: aColor]
	ifFalse:[	ncv := self nextColorKeyValue.
					self colorMap at: ncv put: aColor.
					^ncv]
! !

!DominoColorManager methodsFor: 'enumerate' stamp: 'emm 03/09/2012 20:19'!
returnColorKeyFromR: r g: g b: b

	"returns the colorKeyValue of Byte:rgbvalue"

	| color ncv |

	color := Color redByte: r greenByte: g blueByte: b.
	(self colorMap includes: color)
	ifTrue:[ ^colorMap keyAtValue: color]
	ifFalse:[	ncv := self nextColorKeyValue.
					self colorMap at: ncv put: color.
					^ncv]

! !

!DominoColorManager methodsFor: 'enumerate' stamp: 'emm 03/09/2012 20:19'!
returnKeys

	| keys |

	keys := OrderedCollection new.
	$a asInteger to: $z asInteger do: [: i | keys add: i asCharacter]. 
	^keys

! !

Object subclass: #DominoDesignerElement
	instanceVariableNames: 'id x y transformId colorKey matrix'
	classVariableNames: ''
	poolDictionaries: 'Math3DConstants'
	category: 'Zenna-Dominos'!

!DominoDesignerElement methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
colorKey

	"Answer the value of colorKey"

	^colorKey! !

!DominoDesignerElement methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
colorKey: aValue

	"Set the value of colorKey"

	colorKey := aValue! !

!DominoDesignerElement methodsFor: 'initialize' stamp: 'emm 03/09/2012 20:19'!
fillMatrix

	| mat xt yt |

	self fillMultipliers.				"vlakstarters"
	self fillPatterns.				
	self fillSimpleElements.	"start, stop, enkele stenen en swivel"
	self fillTurns.

	(self transformId = 0)
	ifFalse:[ 1 to: self transformId do: [: k | self matrix: self matrix rotated]]! !

!DominoDesignerElement methodsFor: 'initialize' stamp: 'emm 03/09/2012 20:19'!
fillMultipliers

	| mat xt yt |

	self id = 12  "mutipier 1 - 2"
		ifTrue: [self matrix: (MatrixNxM new: 3 by: 3).
							matrix atRow: 1 column: 1 put: self colorKey.
							matrix atRow: 1 column: 3 put: self colorKey.	
							matrix atRow: 2 column: 1 put: $&.	
							matrix atRow: 2 column: 2 put: $&.	
							matrix atRow: 2 column: 3 put: $&.	
							matrix atRow: 3 column: 1 put: self colorKey].

	self id = 13  "mutipier 1 - 2"
		ifTrue: [self matrix: (MatrixNxM new: 3 by: 3).
							matrix atRow: 1 column: 1 put: self colorKey.
							matrix atRow: 1 column: 3 put: self colorKey.	
							matrix atRow: 2 column: 1 put: $&.	
							matrix atRow: 2 column: 2 put: $&.	
							matrix atRow: 2 column: 3 put: $&.	
							matrix atRow: 3 column: 2 put: self colorKey].

	self id = 15  "mutipier 1 - 2"
		ifTrue: [self matrix: (MatrixNxM new: 3 by: 5).
							matrix atRow: 1 column: 1 put: self colorKey.
							matrix atRow: 1 column: 3 put: self colorKey.
							matrix atRow: 1 column: 5 put: self colorKey.	
							matrix atRow: 2 column: 1 put: $&.	
							matrix atRow: 2 column: 2 put: $&.	
							matrix atRow: 2 column: 3 put: $&.	
							matrix atRow: 2 column: 4 put: $&.	
							matrix atRow: 2 column: 5 put: $&.	
							matrix atRow: 3 column: 1 put: self colorKey].

	self id = 16  "mutipier 1 - 2"
		ifTrue: [self matrix: (MatrixNxM new: 3 by: 5).
							matrix atRow: 1 column: 1 put: self colorKey.
							matrix atRow: 1 column: 3 put: self colorKey.
							matrix atRow: 1 column: 5 put: self colorKey.	
							matrix atRow: 2 column: 1 put: $&.	
							matrix atRow: 2 column: 2 put: $&.	
							matrix atRow: 2 column: 3 put: $&.	
							matrix atRow: 2 column: 4 put: $&.	
							matrix atRow: 2 column: 5 put: $&.	
							matrix atRow: 3 column: 2 put: self colorKey].

	self id = 17  "mutipier 1 - 2"
		ifTrue: [self matrix: (MatrixNxM new: 3 by: 5).
							matrix atRow: 1 column: 1 put: self colorKey.
							matrix atRow: 1 column: 3 put: self colorKey.
							matrix atRow: 1 column: 5 put: self colorKey.	
							matrix atRow: 2 column: 1 put: $&.	
							matrix atRow: 2 column: 2 put: $&.	
							matrix atRow: 2 column: 3 put: $&.	
							matrix atRow: 2 column: 4 put: $&.	
							matrix atRow: 2 column: 5 put: $&.	
							matrix atRow: 3 column: 3 put: self colorKey].

	self id = 21  "mutipier 1 - 2"
		ifTrue: [self matrix: (MatrixNxM new: 3 by: 3).
							matrix atRow: 1 column: 1 put: self colorKey.
							matrix atRow: 1 column: 3 put: self colorKey.	
							matrix atRow: 2 column: 1 put: $&.	
							matrix atRow: 2 column: 2 put: $&.	
							matrix atRow: 2 column: 3 put: $&.	
							matrix atRow: 3 column: 3 put: self colorKey].

	self id = 22  "mutipier 1 - 2"
		ifTrue: [self matrix: (MatrixNxM new: 3 by: 5).
							matrix atRow: 1 column: 1 put: self colorKey.
							matrix atRow: 1 column: 3 put: self colorKey.
							matrix atRow: 1 column: 5 put: self colorKey.	
							matrix atRow: 2 column: 1 put: $&.	
							matrix atRow: 2 column: 2 put: $&.	
							matrix atRow: 2 column: 3 put: $&.	
							matrix atRow: 2 column: 4 put: $&.	
							matrix atRow: 2 column: 5 put: $&.	
							matrix atRow: 3 column: 4 put: self colorKey].

	self id = 23  "mutipier 1 - 2"
		ifTrue: [self matrix: (MatrixNxM new: 3 by: 5).
							matrix atRow: 1 column: 1 put: self colorKey.
							matrix atRow: 1 column: 3 put: self colorKey.
							matrix atRow: 1 column: 5 put: self colorKey.	
							matrix atRow: 2 column: 1 put: $&.	
							matrix atRow: 2 column: 2 put: $&.	
							matrix atRow: 2 column: 3 put: $&.	
							matrix atRow: 2 column: 4 put: $&.	
							matrix atRow: 2 column: 5 put: $&.	
							matrix atRow: 3 column: 5 put: self colorKey].! !

!DominoDesignerElement methodsFor: 'initialize' stamp: 'emm 03/09/2012 20:19'!
fillPatterns

	| mat xt yt |

	self id = 2  "pattern 1-2"
		ifTrue: [self matrix: (MatrixNxM new: 2 by: 3).
							matrix atRow: 1 column: 1 put: self colorKey.
							matrix atRow: 1 column: 3 put: self colorKey.	
							matrix atRow: 2 column: 2 put: self colorKey].

	self id = 8 "pattern 2 - 3"
		ifTrue: [self matrix: (MatrixNxM new: 2 by: 5).
							matrix atRow: 1 column: 1 put: self colorKey.
							matrix atRow: 1 column: 3 put: self colorKey.	
							matrix atRow: 1 column: 5 put: self colorKey.	
							matrix atRow: 2 column: 2 put: self colorKey.	
							matrix atRow: 2 column: 4 put: self colorKey].

! !

!DominoDesignerElement methodsFor: 'initialize' stamp: 'emm 03/09/2012 20:19'!
fillSimpleElements

	| mat xt yt |
	self id = 1 "swivel"
		ifTrue: [self matrix: (MatrixNxM new: 3 by: 3).
							matrix atRow: 1 column: 1 put: self colorKey.
							matrix atRow: 1 column: 3 put: self colorKey.	
							matrix atRow: 2 column: 1 put: $=.
							matrix atRow: 2 column: 2 put: $=.
							matrix atRow: 2 column: 3 put: $=].

	self id = 18  "stop element"
		ifTrue: [self matrix: (MatrixNxM new: 1 by: 1).
							matrix atRow: 1 column: 1 put: $#].

	self id = 19  "single stone"
		ifTrue: [self matrix: (MatrixNxM new: 1 by: 1).
							matrix atRow: 1 column: 1 put: self colorKey].

	self id = 20  "start element"
		ifTrue: [self matrix: (MatrixNxM new: 1 by: 1).
							matrix atRow: 1 column: 1 put: $@].

	self id = 24  "row"
		ifTrue: [self matrix: (MatrixNxM new: 3 by: 1).
							matrix atRow: 1 column: 1 put: self colorKey.
							matrix atRow: 2 column: 1 put: self colorKey.
							matrix atRow: 3 column: 1 put: self colorKey].
! !

!DominoDesignerElement methodsFor: 'initialize' stamp: 'emm 03/09/2012 20:19'!
fillTurns

	| mat xt yt |

	self id = 3 "single turn 3x3"
		ifTrue: [self matrix: (MatrixNxM new: 3 by: 3).
							matrix atRow: 1 column: 3 put: self colorKey.
							matrix atRow: 3 column: 1 put: self colorKey.	
							matrix atRow: 1 column: 2 put: $?.	
							matrix atRow: 2 column: 1 put: $?.].

	self id = 4 "single turn 4x4"
		ifTrue: [self matrix: (MatrixNxM new: 4 by: 4).
							matrix atRow: 1 column: 4 put: self colorKey.
							matrix atRow: 4 column: 1 put: self colorKey.	
							matrix atRow: 1 column: 3 put: $?.	
							matrix atRow: 2 column: 2 put: $?.	
							matrix atRow: 3 column: 1 put: $?.].

	(self id = 5) | (self id = 9) "single turn 5x5"
		ifTrue: [self matrix: (MatrixNxM new: 5 by: 5).
							matrix atRow: 1 column: 5 put: self colorKey.
							matrix atRow: 5 column: 1 put: self colorKey.	
							matrix atRow: 1 column: 4 put: $?.	
							matrix atRow: 2 column: 3 put: $?.	
							matrix atRow: 3 column: 2 put: $?.	
							matrix atRow: 4 column: 1 put: $?.].

	(self id = 6) | (self id =10) "single turn 6x6"
		ifTrue: [self matrix: (MatrixNxM new: 6 by: 6).
							matrix atRow: 1 column: 6 put: self colorKey.
							matrix atRow: 6 column: 1 put: self colorKey.	
							matrix atRow: 1 column: 5 put: $?.	
							matrix atRow: 2 column: 4 put: $?.	
							matrix atRow: 3 column: 3 put: $?.	
							matrix atRow: 4 column: 2 put: $?.	
							matrix atRow: 5 column: 1 put: $?].

	(self id = 7) | (self id = 11) | (self id = 14) "single turn 7x7"
		ifTrue: [self matrix: (MatrixNxM new: 7 by: 7).
							matrix atRow: 1 column: 7 put: self colorKey.
							matrix atRow: 7 column: 1 put: self colorKey.	
							matrix atRow: 1 column: 6 put: $?.	
							matrix atRow: 2 column: 5 put: $?.	
							matrix atRow: 3 column: 4 put: $?.	
							matrix atRow: 4 column: 3 put: $?.	
							matrix atRow: 5 column: 2 put: $?.	
							matrix atRow: 6 column: 1 put: $?.].

	self id = 9 "double turn 5x5"
		ifTrue: [		matrix atRow: 3 column: 5 put: self colorKey.
							matrix atRow: 5 column: 3 put: self colorKey.	
							matrix atRow: 3 column: 4 put: $?.	
							matrix atRow: 4 column: 3 put: $?].

	self id = 10 "double turn 6x6"
		ifTrue: [		matrix atRow: 3 column: 6 put: self colorKey.
							matrix atRow: 6 column: 3 put: self colorKey.	
							matrix atRow: 3 column: 5 put: $?.	
							matrix atRow: 4 column: 4 put: $?.	
							matrix atRow: 5 column: 3 put: $?].

	(self id = 11) | (self id =14) "double turn 7x7"
		ifTrue: [		matrix atRow: 3 column: 7 put: self colorKey.
							matrix atRow: 7 column: 3 put: self colorKey.	
							matrix atRow: 3 column: 6 put: $?.	
							matrix atRow: 4 column: 5 put: $?.	
							matrix atRow: 5 column: 4 put: $?.	
							matrix atRow: 6 column: 3 put: $?].

	self id = 14 "tripple turn 7x7"
		ifTrue: [		matrix atRow: 5 column: 7 put: self colorKey.
							matrix atRow: 7 column: 5 put: self colorKey.	
							matrix atRow: 5 column: 6 put: $?.	
							matrix atRow: 6 column: 5 put: $?].
! !

!DominoDesignerElement methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
id

	"Answer the value of id"

	^id! !

!DominoDesignerElement methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
id: aValue

	"Set the value of id <1-21 value --> type ID>"

	id := aValue! !

!DominoDesignerElement methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
matrix

	"Answer the value of matrix"

	^matrix! !

!DominoDesignerElement methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
matrix: aValue

	"Set the value of matrix"

	matrix := aValue! !

!DominoDesignerElement methodsFor: 'API' stamp: 'emm 03/09/2012 20:19'!
size

	^matrix xySize! !

!DominoDesignerElement methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
transformId

	"Answer the value of transformId"

	^transformId! !

!DominoDesignerElement methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
transformId: aValue

	"Set the value of transformId <1-8>"

	transformId := aValue! !

!DominoDesignerElement methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
x

	"Answer the value of x"

	^x! !

!DominoDesignerElement methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
x: aValue

	"Set the value of x"

	x := aValue! !

!DominoDesignerElement methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
y

	"Answer the value of y"

	^y! !

!DominoDesignerElement methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
y: aValue

	"Set the value of y"

	y := aValue! !

Object subclass: #DominoMapFromTextBuilder
	instanceVariableNames: 'matrix where end'
	classVariableNames: 'CharacterTable'
	poolDictionaries: ''
	category: 'Zenna-Dominos'!

!DominoMapFromTextBuilder class methodsFor: 'resources' stamp: 'emm 03/09/2012 20:19'!
characterTable

	CharacterTable isNil
		ifTrue: [ CharacterTable := Dictionary new ].
	^CharacterTable! !

!DominoMapFromTextBuilder class methodsFor: 'resources' stamp: 'emm 03/09/2012 20:19'!
characterTable: aDictionary

	CharacterTable := aDictionary.
! !

!DominoMapFromTextBuilder class methodsFor: 'resources' stamp: 'emm 03/09/2012 20:19'!
data_0

	^
'01110
10001
10001
10001
10001
10001
10001
10001
01110'! !

!DominoMapFromTextBuilder class methodsFor: 'resources' stamp: 'emm 03/09/2012 20:19'!
data_1

	^
'00100
01100
10100
00100
00100
00100
00100
00100
11111'! !

!DominoMapFromTextBuilder class methodsFor: 'resources' stamp: 'emm 03/09/2012 20:19'!
data_2

	^
'01110
10001
00001
00010
00100
01000
10000
10000
11111'! !

!DominoMapFromTextBuilder class methodsFor: 'resources' stamp: 'emm 03/09/2012 20:19'!
data_3

	^
'01110
10001
00001
00001
01110
00001
00001
10001
01110'! !

!DominoMapFromTextBuilder class methodsFor: 'resources' stamp: 'emm 03/09/2012 20:19'!
data_4

	^
'10000
10000
10001
10001
10001
11111
00001
00001
00001'! !

!DominoMapFromTextBuilder class methodsFor: 'resources' stamp: 'emm 03/09/2012 20:19'!
data_5

	^
'11111
10000
10000
10000
11110
00001
00001
10001
01110'! !

!DominoMapFromTextBuilder class methodsFor: 'resources' stamp: 'emm 03/09/2012 20:19'!
data_6

	^
'01110
10001
10000
10000
11110
10001
10001
10001
01110'! !

!DominoMapFromTextBuilder class methodsFor: 'resources' stamp: 'emm 03/09/2012 20:19'!
data_7

	^
'11111
10001
00001
00010
00010
00100
00100
01000
01000'! !

!DominoMapFromTextBuilder class methodsFor: 'resources' stamp: 'emm 03/09/2012 20:19'!
data_8

	^
'01110
10001
10001
10001
01110
10001
10001
10001
01110'! !

!DominoMapFromTextBuilder class methodsFor: 'resources' stamp: 'emm 03/09/2012 20:19'!
data_9

	^
'01110
10001
10001
10001
01111
00001
00001
10001
01110'! !

!DominoMapFromTextBuilder class methodsFor: 'resources' stamp: 'emm 03/09/2012 20:19'!
data_A

	^
'01110
10001
10001
10001
11111
10001
10001
10001
10001'! !

!DominoMapFromTextBuilder class methodsFor: 'resources' stamp: 'emm 03/09/2012 20:19'!
data_B

	^
'11110
10001
10001
10001
11110
10001
10001
10001
11110'! !

!DominoMapFromTextBuilder class methodsFor: 'resources' stamp: 'emm 03/09/2012 20:19'!
data_C

	^
'01110
10001
10000
10000
10000
10000
10000
10001
01110'! !

!DominoMapFromTextBuilder class methodsFor: 'resources' stamp: 'emm 03/09/2012 20:19'!
data_D

	^
'11110
10001
10001
10001
10001
10001
10001
10001
11110'! !

!DominoMapFromTextBuilder class methodsFor: 'resources' stamp: 'emm 03/09/2012 20:19'!
data_E

	^
'11111
10000
10000
10000
11110
10000
10000
10000
11111'! !

!DominoMapFromTextBuilder class methodsFor: 'resources' stamp: 'emm 03/09/2012 20:19'!
data_F

	^
'11111
10000
10000
10000
11110
10000
10000
10000
10000'! !

!DominoMapFromTextBuilder class methodsFor: 'resources' stamp: 'emm 03/09/2012 20:19'!
data_G

	^
'01111
10000
10000
10000
10111
10001
10001
10001
01110'! !

!DominoMapFromTextBuilder class methodsFor: 'resources' stamp: 'emm 03/09/2012 20:19'!
data_H

	^
'10001
10001
10001
10001
11111
10001
10001
10001
10001'
! !

!DominoMapFromTextBuilder class methodsFor: 'resources' stamp: 'emm 03/09/2012 20:19'!
data_I

	^
'111
010
010
010
010
010
010
010
111'
! !

!DominoMapFromTextBuilder class methodsFor: 'resources' stamp: 'emm 03/09/2012 20:19'!
data_J

	^
'01111
00001
00001
00001
00001
00001
00001
10001
01110'
! !

!DominoMapFromTextBuilder class methodsFor: 'resources' stamp: 'emm 03/09/2012 20:19'!
data_K

	^
'10001
10001
10001
10010
11100
10010
10001
10001
10001'
! !

!DominoMapFromTextBuilder class methodsFor: 'resources' stamp: 'emm 03/09/2012 20:19'!
data_L

	^
'10000
10000
10000
10000
10000
10000
10000
10000
11111'! !

!DominoMapFromTextBuilder class methodsFor: 'resources' stamp: 'emm 03/09/2012 20:19'!
data_M

	^
'10001
10001
11011
10101
10101
10001
10001
10001
10001'
! !

!DominoMapFromTextBuilder class methodsFor: 'resources' stamp: 'emm 03/09/2012 20:19'!
data_N

	^
'10001
10001
11001
10101
10101
10101
10011
10001
10001'
! !

!DominoMapFromTextBuilder class methodsFor: 'resources' stamp: 'emm 03/09/2012 20:19'!
data_O

	^
'01110
10001
10001
10001
10001
10001
10001
10001
01110'! !

!DominoMapFromTextBuilder class methodsFor: 'resources' stamp: 'emm 03/09/2012 20:19'!
data_P

	^
'11110
10001
10001
10001
11110
10000
10000
10000
10000'! !

!DominoMapFromTextBuilder class methodsFor: 'resources' stamp: 'emm 03/09/2012 20:19'!
data_Q

	^
'01110
10001
10001
10001
10001
10001
10101
10011
01110'! !

!DominoMapFromTextBuilder class methodsFor: 'resources' stamp: 'emm 03/09/2012 20:19'!
data_R

	^
'11110
10001
10001
10001
11110
10001
10001
10001
10001'
! !

!DominoMapFromTextBuilder class methodsFor: 'resources' stamp: 'emm 03/09/2012 20:19'!
data_S

	^
'01110
10001
10000
10000
01110
00001
00001
10001
01110'! !

!DominoMapFromTextBuilder class methodsFor: 'resources' stamp: 'emm 03/09/2012 20:19'!
data_T

	^
'11111
00100
00100
00100
00100
00100
00100
00100
00100'
! !

!DominoMapFromTextBuilder class methodsFor: 'resources' stamp: 'emm 03/09/2012 20:19'!
data_U

	^
'10001
10001
10001
10001
10001
10001
10001
10001
01110'! !

!DominoMapFromTextBuilder class methodsFor: 'resources' stamp: 'emm 03/09/2012 20:19'!
data_V

	^
'10001
10001
10001
10001
10001
01010
01010
01010
00100'! !

!DominoMapFromTextBuilder class methodsFor: 'resources' stamp: 'emm 03/09/2012 20:19'!
data_W

	^
'1000001
1000001
1000001
1000001
1001001
0101010
0101010
0101010
0010100'! !

!DominoMapFromTextBuilder class methodsFor: 'resources' stamp: 'emm 03/09/2012 20:19'!
data_X

	^
'1000001
1000001
0100010
0010100
0001000
0010100
0100010
1000001
1000001'! !

!DominoMapFromTextBuilder class methodsFor: 'resources' stamp: 'emm 03/09/2012 20:19'!
data_Y

	^
'1000001
1000001
0100010
0010100
0001000
0001000
0001000
0001000
0001000'! !

!DominoMapFromTextBuilder class methodsFor: 'resources' stamp: 'emm 03/09/2012 20:19'!
data_Z

	^
'1111111
1000001
0000010
0000100
0001000
0010000
0100000
1000001
1111111'! !

!DominoMapFromTextBuilder class methodsFor: 'examples' stamp: 'emm 03/09/2012 20:19'!
example0
	"self example0"

	| b |
	b := self new.
	b buildFromText: 'ABCDEFGHIJ'.
	^b dominoMap! !

!DominoMapFromTextBuilder class methodsFor: 'examples' stamp: 'emm 03/09/2012 20:19'!
example1
	"self example1"

	| b |
	b := self new.
	b buildFromText: 'A B'.
	^b dominoMap! !

!DominoMapFromTextBuilder class methodsFor: 'examples' stamp: 'emm 03/09/2012 20:19'!
example2
	"self example2"

	| b |
	b := self new.
	b buildFromText: 'A B' withText: $a withBack: $b.
	^b ! !

!DominoMapFromTextBuilder class methodsFor: 'resources' stamp: 'emm 10/18/2012 16:13'!
patternAt: aChar

	"self patternAt: $A"

	^self characterTable 
		at: aChar 
		ifAbsentPutUsing:[ ( BitPattern2D fromBitString: (self perform: ( 'data_' , (String with: aChar )) asSymbol ))]! !

!DominoMapFromTextBuilder methodsFor: 'building' stamp: 'emm 03/09/2012 20:19'!
buildFromText: aString 
	
	| column row hSpace pattern |
	matrix := ExpandableMatrix new.
	where := 6 , 1. 
	
	self setupStart.
	column := 4.
	row := 2.
	hSpace := 1. 
	"left space"
	hSpace timesRepeat: [ 
		-1 to: 9 do: [ :i | 
			matrix 
				atRow: row + i 
				column: column 
				put: $~ ].
		column := column + 1 ].
	aString do: [ :eachChar | 
		eachChar == $ 
			ifTrue:
				[ 3 timesRepeat: [ 
					-1 to: 9 do: [ :i | 
						matrix 
							atRow: row + i 
							column: column 
							put: $~ ].
					column := column + 1 ] ]
			ifFalse:
				[ pattern := self class patternAt: eachChar.
				pattern onesDo: [ :eachPoint | 
					matrix 
						atRow: row + 8 - eachPoint y 
						column: column + eachPoint x 
						put: eachChar ].
				pattern zerosDo: [ :eachPoint | 
					matrix 
						atRow: row + 8 - eachPoint y 
						column: column + eachPoint x 
						put: $~ ]. "top and bottom space"
				0 to: pattern bounds width do: [ :j | 
					matrix 
						atRow: row - 1 
						column: column + j 
						put: $~.
					matrix 
						atRow: row + 9 
						column: column + j 
						put: $~ ].
				column := column + pattern bounds width + 1 ]. 
		"right space"
		hSpace timesRepeat: [ 
			-1 to: 9 do: [ :i | 
				matrix 
					atRow: row + i 
					column: column 
					put: $~ ].
			column := column + 1 ] ].
	end := 6, (column - 1).! !

!DominoMapFromTextBuilder methodsFor: 'building' stamp: 'emm 03/09/2012 20:19'!
buildFromText: aString withText: charT withBack: charB

	| column row hSpace pattern |

	matrix := ExpandableMatrix new.
	where := 6 , 1. 
	
	self setupStartWithText: charT withBack: charB.
	column := 4.
	row := 2.
	hSpace := 1. 
	"left space"
	hSpace timesRepeat: [ 
		-1 to: 9 do: [ :i | 
			matrix 
				atRow: row + i 
				column: column 
				put: charB ].
		column := column + 1 ].
	aString do: [ :eachChar | 
		(self defined includes: eachChar) not
			ifTrue:
				[ 3 timesRepeat: [ 
					-1 to: 9 do: [ :i | 
						matrix  
							atRow: row + i 
							column: column 
							put: charB].
					column := column + 1 ] ]
			ifFalse:
				[ pattern := self class patternAt: eachChar.
				pattern onesDo: [ :eachPoint | 
					matrix 
						atRow: row + 8 - eachPoint y 
						column: column + eachPoint x 
						put: charT ].
				pattern zerosDo: [ :eachPoint | 
					matrix 
						atRow: row + 8 - eachPoint y 
						column: column + eachPoint x 
						put: charB]. "top and bottom space"
				0 to: pattern bounds width do: [ :j | 
					matrix 
						atRow: row - 1 
						column: column + j 
						put: charB.
					matrix 
						atRow: row + 9 
						column: column + j 
						put: charB].
				column := column + pattern bounds width + 1 ]. 
		"right space"
		hSpace timesRepeat: [ 
			-1 to: 9 do: [ :i | 
				matrix 
					atRow: row + i 
					column: column 
					put: charB].
			column := column + 1 ] ].
	self setupEndAt: column.
	end := 6,column.! !

!DominoMapFromTextBuilder methodsFor: 'private' stamp: 'emm 03/09/2012 20:19'!
defined

	^'ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789'.! !

!DominoMapFromTextBuilder methodsFor: 'API' stamp: 'emm 03/09/2012 20:19'!
dominoMap

	"Answer the value of matrix"

	^matrix! !

!DominoMapFromTextBuilder methodsFor: 'API' stamp: 'emm 03/09/2012 20:19'!
endPoint
	^end! !

!DominoMapFromTextBuilder methodsFor: 'private' stamp: 'emm 03/09/2012 20:19'!
setupEndAt: column
	
	matrix 
		atRow: 6 
		column: column 
		put: $#.! !

!DominoMapFromTextBuilder methodsFor: 'private' stamp: 'emm 03/09/2012 20:19'!
setupStart
	
	matrix 
		atRow: 6 
		column: 1 
		put: $@.
	matrix 
		atRow: 6 
		column: 2 
		put: $~.
	1 to: 11 do: [ :i | 
		matrix 
			atRow: i 
			column: 3 
			put: $& ]! !

!DominoMapFromTextBuilder methodsFor: 'private' stamp: 'emm 03/09/2012 20:19'!
setupStartWithText: charT withBack: charB
	
	matrix 
		atRow: 6 
		column: 1 
		put: $@.
	matrix 
		atRow: 6 
		column: 2 
		put: charB.
	1 to: 11 do: [ :i | 
		matrix 
			atRow: i 
			column: 3 
			put: $& ]! !

!DominoMapFromTextBuilder methodsFor: 'API' stamp: 'emm 03/09/2012 20:19'!
startPoint
	^where! !

Object subclass: #DominoSceneFromBitmapBuilder
	instanceVariableNames: 'dominos backColor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Dominos'!

!DominoSceneFromBitmapBuilder methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
backColor

	"Answer the value of backColor"

	^backColor! !

!DominoSceneFromBitmapBuilder methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
backColor: aValue

	"Set the value of backColor"

	backColor := aValue! !

!DominoSceneFromBitmapBuilder methodsFor: 'API' stamp: 'emm 03/09/2012 20:19'!
bounds

	^dominos 
		inject: dominos first bounds
		into:[ :box :each | box merge: each bounds ]! !

!DominoSceneFromBitmapBuilder methodsFor: 'API' stamp: 'emm 03/09/2012 20:19'!
buildFromFile1: aString 
	
	| image  rand|
	image := CgWinBMPFileFormat new loadFromFile: aString.
	dominos := OrderedCollection new.
	rand := Color random.
	0 to: image width - 1 do: [ :x | 0 to: image height - 1 do: [ :y |  | domino cgColor | 
		cgColor := image getColor: x y: y.
		( cgColor red = 0
			and: [ cgColor green = 0
				and: [ cgColor blue = 0 ] ] ) 
			ifFalse:
				[ domino := Domino new.
				domino bottomCenter: y * 3 @ ( x * 5 ) @ 0. 
				"domino color: ( Color 
					red: cgColor red 
					green: cgColor green 
					blue: cgColor blue )."
				domino color: rand next.
				dominos add: domino ] ] ].
	dominos size echo: 'number of dominos'.
	^ dominos! !

!DominoSceneFromBitmapBuilder methodsFor: 'API' stamp: 'emm 03/09/2012 20:19'!
buildFromFile: aString 
	
	| image |
	image := CgWinBMPFileFormat new loadFromFile: aString.
	dominos := OrderedCollection new.
	0 to: image width - 1 do: [ :x | 0 to: image height - 1 do: [ :y |  | domino cgColor | 
		cgColor := image getColor: x y: y.
		( cgColor red = backColor red
			and: [ cgColor green = backColor green
				and: [ cgColor blue = backColor blue ] ] ) 
			ifFalse:
				[ domino := Domino new.
				domino bottomCenter: y * 3 @ ( x * 5 ) @ 0. 
				domino color: ( Color 
					red: cgColor red 
					green: cgColor green 
					blue: cgColor blue ).
				dominos add: domino ] ] ].
	dominos size echo: 'number of dominos'.
	^ dominos! !

!DominoSceneFromBitmapBuilder methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
dominos

	"Answer the value of dominos"

	^dominos! !

!DominoSceneFromBitmapBuilder methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
dominos: aValue

	"Set the value of dominos"

	dominos := aValue! !

Object subclass: #DominoToppling
	instanceVariableNames: 'start stop values count'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Dominos'!

!DominoToppling class methodsFor: 'testing' stamp: 'emm 03/09/2012 20:19'!
test0

	"self test0"

	| dt |
	dt := self new.
	dt add: 0.
	dt add: 0.
	dt add: 0.
	dt add: 1.
	dt add: 2.
	dt add: 3.
	dt add: 3.
	dt add: 3.
	^dt 
! !

!DominoToppling methodsFor: 'adding' stamp: 'emm 03/09/2012 20:19'!
add: aValue
	
	values isNil
		ifTrue: 
			[ count := 0.
			values := OrderedCollection new ].
	count := count + 1.

	start isNil
		ifTrue: 
			[ start := 1.
			^values add: aValue ].

	stop isNil
		ifTrue: 
			[ self lastValue = aValue
				ifTrue: 
					[ start := start + 1.
					^aValue ]
				ifFalse: 
					[ values add: aValue.
					stop := start + 1.
					^aValue ] ].

	self lastValue ~= aValue
		ifTrue: 
			[stop := stop + 1.
			 ^ values add: aValue ]
		! !

!DominoToppling methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
asArray

	| array |
	array := Array new: self size.
	1 to: self size do:[ :i | array at: i put: (self at: i) ].
	^array! !

!DominoToppling methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
at: anIndex

	anIndex <= start 
		ifTrue: [ ^values first ].
	anIndex >= stop
		ifTrue: [ ^values last ].
	"start < anIndex < stop"
	^values at: 1 + anIndex - start
! !

!DominoToppling methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
elapsed

	^stop isNil
		ifTrue: [ 1 ]
		ifFalse: [ stop - start ]! !

!DominoToppling methodsFor: 'adding' stamp: 'emm 03/09/2012 20:19'!
firstValue
	
	^values isNil
		ifTrue: [ nil ]
		ifFalse: [ values first ]! !

!DominoToppling methodsFor: 'adding' stamp: 'emm 03/09/2012 20:19'!
lastValue
	
	^values isNil
		ifTrue: [ nil ]
		ifFalse: [ values last ]! !

!DominoToppling methodsFor: 'printing' stamp: 'emm 03/09/2012 20:19'!
printOn: aStream

	aStream print: start.
	aStream nextPut: $= .
	aStream print: values first.
	aStream nextPut: $: .
	aStream print: stop.
	aStream nextPut: $= .
	aStream print: values last.! !

!DominoToppling methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
size

	^count! !

!DominoToppling methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
start

	"Answer the value of start"

	^start! !

!DominoToppling methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
start: aValue

	"Set the value of start"

	start := aValue! !

!DominoToppling methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
stop

	"Answer the value of stop"

	^stop! !

!DominoToppling methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
stop: aValue

	"Set the value of stop"

	stop := aValue! !

!DominoToppling methodsFor: 'test' stamp: 'emm 03/09/2012 20:19'!
test

| t |
t := DominoToppling new.
t add: 0.
t add: 0.
t add: 0.
t add: 1.
t add: 2.
t add: 3.
t add: 3.
t add: 3.
t add: 3.
t asArray ! !

!DominoToppling methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
values

	"Answer the value of values"

	^values! !

!DominoToppling methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
values: aValue

	"Set the value of values"

	values := aValue! !

Object subclass: #DominoTopplingPovraySceneBuilder
	instanceVariableNames: 'frameCount builder filename processor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Dominos'!

!DominoTopplingPovraySceneBuilder class methodsFor: 'instance-creation' stamp: 'emm 31/01/2003 07:53'!
new

	"Answer a new instance of the receiver and initialize it"

	^super new initialize! !

!DominoTopplingPovraySceneBuilder methodsFor: 'building' stamp: 'emm 31/01/2003 07:53'!
addBannerFor: b at: aPoint withName: aPerson

	"add Banner"

	| textHeight textWidth c|

	textHeight := 0.66 * ((CgDisplay default loadQueryFont:   '-microsoft-arial-medium-r-normal-sans serif-13-100-96-96-p-0-iso8859-1') height).
	textWidth := 0.66 *((CgDisplay default loadQueryFont:  '-microsoft-arial-medium-r-normal-sans serif-13-100-96-96-p-0-iso8859-1') textWidth: aPerson).

	"other Fonts     CwFontPrompter new prompt
	 '-microsoft-arial-medium-r-normal-sans serif-16-120-96-96-p-0-iso8859-1'
	 '-microsoft-arial-medium-r-normal-sans serif-11-80-96-96-p-0-iso8859-1'"

	b color: Color yellow.
	b add: (c := Cylinder center: aPoint - (0,5,0)+ (textWidth/1.9,0,0) radius: 0.8 height: 26).
	b color: Color red.
	b add: (Sphere center: c topCenter radius: 1.5).

	b color: Color yellow.
	b add: (c := Cylinder center: aPoint - (0,5,0) -(textWidth/1.9,0,0) radius: 0.8 height: 26).
	b color: Color red.
	b add: (Sphere center: c topCenter radius: 1.5).

	b color: Color white.
	b add: (Box origin: aPoint - (0,5.5,-15) - (textWidth/1.9,0,0) extent: textWidth/0.95,1,10).

	b color: Color black.
	b fontStyle: (b newFontStyle size:10).
	b add: (aPerson asText3D rotateBy: 0, 0, -90 rad  translateBy: (textWidth/2 negated,-0.55,17)+aPoint - (0,5,0)).
	b add: (aPerson asText3D rotateBy: 0, 0, 90 rad  translateBy: (textWidth/2,0.55,17)+aPoint - (0,5,0)).! !

!DominoTopplingPovraySceneBuilder methodsFor: 'building' stamp: 'emm 31/01/2003 07:53'!
addBanners: nameCollection atAll: pointCollection 
	
	pointCollection doWithIndex: [ :each :index | 
		self 
			addBannerFor: self povrayBuilder 
			at: ( each - ( 1 , 1 ) ) * 5 , 0 
			withName: ( nameCollection at: index ) ]! !

!DominoTopplingPovraySceneBuilder methodsFor: 'building' stamp: 'emm 31/01/2003 07:53'!
addLightsOn: aBox 
	
	| yy xfactor yfactor grid lightBox lightFactor |
	lightFactor := 1.
	lightBox := (aBox expandedBy: 0,-300,0) normalize. 
	grid := Grid3D origin: lightBox backLeftTop corner: lightBox frontRightTop.
	yfactor := (lightBox extent y / lightFactor).
	yy :=( yfactor/400) rounded.
	xfactor := (lightBox extent x / lightFactor).
	yfactor > 400 ifTrue: [yfactor := yfactor/yy].
	grid delta: xfactor,yfactor,0.
	grid verticesDo: [ :from | builder add: ( SpotLight at: from + ( 0 , 0 , 125 )  lookingAt: from ) ]! !

!DominoTopplingPovraySceneBuilder methodsFor: 'building' stamp: 'emm 31/01/2003 07:53'!
addSloganLightsOn: aBox 
	
	|lightBox vertices |
	lightBox := (aBox expandedBy: 0,50,0) normalize. 
	vertices := lightBox left center to: lightBox right center by: 0,100,0.
	vertices do: [ :from | builder add: ( SpotLight at: from + ( 0 , 0 , 100 )  lookingAt: from ) ]! !

!DominoTopplingPovraySceneBuilder methodsFor: 'processing' stamp: 'emm 31/01/2003 07:53'!
buildFromProcessor: aProcessor usingPath: aCameraPath beforeWriteDo: zeroBlock
	"Make an animation"
	
	| fraction |
	processor := aProcessor.

	1 to: frameCount do:[ :fileIndex |
		| rotationIndex  camera cameraName cameraWriter |
		Transcript show: 'Writing file: '.
		fileIndex printOn: Transcript.
		Transcript show:'/'.
		frameCount printOn: Transcript.
		Transcript cr.
		rotationIndex := (aProcessor rotations first size / frameCount * fileIndex) rounded.
		fraction := fileIndex - 1 / (frameCount - 1).
"		fileIndex = frameCount ifTrue: [ "
		"write camera"
		camera := Camera 
			at: (aCameraPath originAtFraction: fraction)
			lookingAt: (aCameraPath focusPointAtFraction: fraction).
		cameraName :=  filename , '_camera' , (fileIndex printStringRadix: 10 padTo: 4) ,'.inc'.
		cameraWriter := POVWriter on: cameraName asFilename writeStream.
		cameraWriter changeCoordinateSystem: true.
		cameraWriter add: camera.
		cameraWriter close.

		"write main scene"
		builder := SceneBuilder povray.
		builder include: (self stripShortFilenameFrom: cameraName).
		aProcessor dominos doWithIndex:[ :each :index |
			each transformRotation: ((aProcessor rotations at: index) at: rotationIndex) ].
		builder addAll: aProcessor dominos.
		zeroBlock value.
		builder writeToFile: filename index: fileIndex padTo: 4 useIndentation: false.
		].

"		]"! !

!DominoTopplingPovraySceneBuilder methodsFor: 'processing' stamp: 'emm 31/01/2003 07:53'!
buildFromSceneBuilder: aSceneBuilder beforeWriteDo: zeroBlock
	
	"Make a still image"	

	builder addAll: aSceneBuilder objects.
	zeroBlock value.
	builder writeToFile: filename! !

!DominoTopplingPovraySceneBuilder methodsFor: 'accessing' stamp: 'emm 31/01/2003 07:53'!
builder

	"Answer the value of builder"

	^builder! !

!DominoTopplingPovraySceneBuilder methodsFor: 'accessing' stamp: 'emm 31/01/2003 07:53'!
builder: aValue

	"Set the value of builder"

	builder := aValue! !

!DominoTopplingPovraySceneBuilder methodsFor: 'accessing' stamp: 'emm 31/01/2003 07:53'!
filename

	"Answer the value of filename"

	^filename! !

!DominoTopplingPovraySceneBuilder methodsFor: 'accessing' stamp: 'emm 31/01/2003 07:53'!
filename: aValue

	"Set the value of filename"

	filename := aValue! !

!DominoTopplingPovraySceneBuilder methodsFor: 'accessing' stamp: 'emm 31/01/2003 07:53'!
frameCount

	"Answer the value of frameCount"

	^frameCount! !

!DominoTopplingPovraySceneBuilder methodsFor: 'accessing' stamp: 'emm 31/01/2003 07:53'!
frameCount: aValue

	"Set the value of frameCount"

	frameCount := aValue! !

!DominoTopplingPovraySceneBuilder methodsFor: 'initialize-release' stamp: 'emm 31/01/2003 07:53'!
initialize
	builder := SceneBuilder povray! !

!DominoTopplingPovraySceneBuilder methodsFor: 'include-generation' stamp: 'emm 31/01/2003 07:53'!
makeEnvironment

	builder := SceneBuilder povray.
	builder include: 'colors.inc'.
	builder include: 'skies.inc'.
	builder add: ((GenericSceneElement new className: 'sky_sphere') at: 'S_Cloud1' put: '' ;yourself).
	builder writeToFile: 'environment'
! !

!DominoTopplingPovraySceneBuilder methodsFor: 'building' stamp: 'emm 31/01/2003 07:53'!
povrayBuilder

	^builder! !

!DominoTopplingPovraySceneBuilder methodsFor: 'accessing' stamp: 'emm 31/01/2003 07:53'!
processor

	"Answer the value of processor"

	^processor! !

!DominoTopplingPovraySceneBuilder methodsFor: 'accessing' stamp: 'emm 31/01/2003 07:53'!
processor: aValue

	"Set the value of processor"

	processor := aValue! !

!DominoTopplingPovraySceneBuilder methodsFor: 'accessing' stamp: 'emm 31/01/2003 07:53'!
stripShortFilenameFrom: aFilename 
	
	"returns the filename without path and without extension"
	
	( aFilename includes: $. )
		ifTrue:[ ^ aFilename copyFrom: ( aFilename lastIndexOf: $\ ) + 1 to: ( aFilename lastIndexOf: $. ) - 1 ]
		ifFalse:[ ^ aFilename copyFrom: ( aFilename lastIndexOf: $\ ) + 1 to: ( aFilename size ) ]! !

Object subclass: #DominoTopplingProcessor
	instanceVariableNames: 'dominos rotations angleRandom bounds angleIncrement compressAngles focusPoints'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Dominos'!

!DominoTopplingProcessor class methodsFor: 'instance-creation' stamp: 'emm 03/09/2012 20:19'!
new

	"Answer a new instance of the receiver and initialize it"

	^super new initialize! !

!DominoTopplingProcessor methodsFor: 'processing' stamp: 'emm 03/09/2012 20:19'!
addFocusPointFromDominos: aCollection

	"Add an average point"

	aCollection isEmpty ifTrue: [ ^self ].
	focusPoints add: (aCollection 
		inject: Point3D zero
		into:[ :sum :eachDomino | sum + eachDomino bottomCenter ] ) / aCollection size! !

!DominoTopplingProcessor methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
angleIncrement: aValue

	"Set the value of angleIncrement"

	angleIncrement := aValue! !

!DominoTopplingProcessor methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
angleRandom: aValue

	"Set the value of angleRandom"

	angleRandom := aValue! !

!DominoTopplingProcessor methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
bounds

	"Answer the value of bounds"

	^bounds! !

!DominoTopplingProcessor methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
compressAngles

	"Answer the value of compressAngles"

	^compressAngles! !

!DominoTopplingProcessor methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
compressAngles: aValue

	"Set the value of compressAngles"

	compressAngles := aValue! !

!DominoTopplingProcessor methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
dominos

	"Answer the value of dominos"

	^dominos! !

!DominoTopplingProcessor methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
focusPoints

	"Answer the value of focusPoints"

	^focusPoints! !

!DominoTopplingProcessor methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
focusPoints: aValue

	"Set the value of focusPoints"

	focusPoints := aValue! !

!DominoTopplingProcessor methodsFor: 'initialize-release' stamp: 'emm 03/09/2012 20:19'!
initialize

	angleIncrement := 10 rad.
	compressAngles := false.
	focusPoints := OrderedPoint3DCollection new.! !

!DominoTopplingProcessor methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
noOfStones

	"Answer the number of stones"

	^dominos size! !

!DominoTopplingProcessor methodsFor: 'processing' stamp: 'emm 03/09/2012 20:19'!
process: aDominoCollection
	
	| fronts  |
	dominos := aDominoCollection.
	rotations := Array new: aDominoCollection size.
	bounds := aDominoCollection first bounds.

	"Initialize dominos, rotations and bounds"
	1 to: aDominoCollection size do:[ :i | 
		bounds := bounds merge: ( aDominoCollection at: i ) bounds.
		rotations at: i put: DominoToppling new].

	"topple all"
	fronts := Array with: aDominoCollection first.
	self addFocusPointFromDominos:fronts.
	[ 1 to: aDominoCollection size do:[:i | 
		(rotations at: i) add: (aDominoCollection at: i) transformRotation ].
	fronts isEmpty not ]
		whileTrue: 
			[ fronts := fronts 
				inject: Set new 
				into: [ :newFronts :each |  
					angleRandom notNil
						ifTrue: [ angleIncrement := angleRandom next ].
					newFronts 
						addAll: ( each frontsAfterTopplingBy: angleIncrement ) 
						; yourself ].
			self addFocusPointFromDominos: fronts.
			].

	"reset dominos"
	dominos do:[ :each | each transformRotation: 0].! !

!DominoTopplingProcessor methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
rotations

	"Answer the value of rotations"

	^rotations! !

Object subclass: #DominoTopplingVRMLSceneBuilder
	instanceVariableNames: 'frameCount builder filename processor startSensor resetSensor rewinder scheduler ticker useTextures useButtons cycleFactor'
	classVariableNames: 'RandomTextures Textures'
	poolDictionaries: ''
	category: 'Zenna-Dominos'!

!DominoTopplingVRMLSceneBuilder class methodsFor: 'instance-creation' stamp: 'emm 31/01/2003 07:52'!
new

	"Answer a new instance of the receiver and initialize it"

	^super new initialize! !

!DominoTopplingVRMLSceneBuilder class methodsFor: 'resources' stamp: 'emm 31/01/2003 07:52'!
randomTextures
	
	RandomTextures isNil 
		ifTrue:[ RandomTextures := RepeatingReadStream on: 
#('images/dominostone13.gif' 'images/dominostone53.gif' 'images/dominostone42.gif' 'images/dominostone31.gif' ) ].
	^RandomTextures! !

!DominoTopplingVRMLSceneBuilder methodsFor: 'building' stamp: 'emm 31/01/2003 07:52'!
addBackground

	builder add: ( ( builder newBackground )
		skyColor: (Array with: Color navy with: Color aliceblue )
		; skyAngle: 1.6
		; groundColor: ( Array 
			with: (Color red01: 0.5078125 green01: 0.7890625 blue01: 0.5078125)
			with: (Color red01: 0.5078125 green01: 0.7890625 blue01: 0.5078125)
			with: (Color black)) 
		; groundAngle: #( 1.2 1.57 ))! !

!DominoTopplingVRMLSceneBuilder methodsFor: 'building' stamp: 'emm 31/01/2003 07:52'!
addBackgroundGrey40

	builder add: (( builder newBackground) skyColor: (Color grey: 40)).! !

!DominoTopplingVRMLSceneBuilder methodsFor: 'building' stamp: 'emm 31/01/2003 07:52'!
addBannerFor: b at: aPoint withName: aPerson

	"add Banner"

	| textHeight textWidth font  c|
	font := CgDisplay default loadQueryFont: '-microsoft-arial-medium-r-normal-sans serif-13-100-96-96-p-0-iso8859-1'.
	textHeight := 0.66 * font height.
	textWidth := 0.66 * (font textWidth: aPerson).

	"other Fonts     CwFontPrompter new prompt
	 '-microsoft-verdana-medium-r-normal-sans serif-15-110-96-96-p-0-iso8859-1'
	 '-microsoft-arial-medium-r-normal-sans serif-13-100-96-96-p-0-iso8859-1'
	 '-microsoft-arial-medium-r-normal-sans serif-16-120-96-96-p-0-iso8859-1'
	 '-microsoft-arial-medium-r-normal-sans serif-11-80-96-96-p-0-iso8859-1'"


	b color: Color yellow.
	b add: (c := Cylinder center: aPoint - (0,5,0)+ (textWidth/1.9,0,0) radius: 0.8 height: 26).
	b color: Color red.
	b add: (Sphere center: c topCenter radius: 1.5).

	b color: Color yellow.
	b add: (c := Cylinder center: aPoint - (0,5,0) -(textWidth/1.9,0,0) radius: 0.8 height: 26).
	b color: Color red.
	b add: (Sphere center: c topCenter radius: 1.5).

	" adding a secret goodie: selecting the billboard will reset the stones"
	b color: Color white.
	b group:[
		b add: (Box origin: aPoint - (0,5.5,-15) - (textWidth/1.9,0,0) extent: textWidth/0.95,1,10).
		b add: resetSensor].

	b color: Color black.
	b fontStyle: (b newFontStyle size:10).
	b add: (aPerson asText3D rotateBy: 0, 0, -90 rad  translateBy: (textWidth/2 negated,-0.55,17)+aPoint - (0,5,0)).! !

!DominoTopplingVRMLSceneBuilder methodsFor: 'building' stamp: 'emm 31/01/2003 07:52'!
addBanners: nameCollection atAll: pointCollection 
	
	pointCollection doWithIndex: [ :each :index | 
		self 
			addBannerFor: self vrmlBuilder 
			at: ( each - ( 1 , 1 ) ) * 5 , 0 
			withName: ( nameCollection at: index ) ]! !

!DominoTopplingVRMLSceneBuilder methodsFor: 'building' stamp: 'emm 31/01/2003 07:52'!
addCameraAt: aPoint lookingAt: anotherPoint

	builder add: ((Camera at: aPoint	lookingAt: anotherPoint) label: 'Stilstaand').! !

!DominoTopplingVRMLSceneBuilder methodsFor: 'processing' stamp: 'emm 31/01/2003 08:01'!
addCameraPath: aPath 

	aPath label: 'flyover'.
	aPath duration: scheduler tasks last startTime.
	aPath frameCount: frameCount.
	builder add: aPath.
	
	"hook start to fly"
	builder
		whenTouching: startSensor
		send: 'set_bind'
		with: true
		to: builder routes last source.! !

!DominoTopplingVRMLSceneBuilder methodsFor: 'building' stamp: 'emm 31/01/2003 07:52'!
addColoredSkyTo: b

	b add: ( ( b newBackground )
		skyColor: ((Array with: Color navy with: Color maroon4 with: Color coral with: Color coral3 ) ,( Array with: Color red))
		; skyAngle: #( 1.3 1.4 1.5 1.65 )
		; groundColor: ( Array 
			with:Color aquamarine 
			with: (Color seashell3 )
			with: (Color lightskyblue3 )) 
		; groundAngle: #( 1.2 1.57 )).! !

!DominoTopplingVRMLSceneBuilder methodsFor: 'building' stamp: 'emm 31/01/2003 08:06'!
addDominos
	
	| tt rotations clock  sideColor |
	tt := self cycleFactor.
	rotations := processor rotations.
	ticker := clock := builder newTimeSensor.
	clock cycleInterval: ((processor dominos size * cycleFactor) max: 1).
	builder add: clock.
	sideColor := Color redByte: 255 greenByte: 255 blueByte: 222.
	1 to: processor dominos size do: [ :i |  | interpolator domino stone | 
		domino := processor dominos at: i.
		useTextures 
			ifTrue: 
				[ domino color: sideColor.
				domino texture: self class randomTextures next ].
		builder add: ( stone := domino buildElementWith: builder ).
		useButtons 	ifFalse: [ 
				i = 1 
					ifTrue: [ stone add: (startSensor := builder newTouchSensor) ].
				i = processor dominos size
					ifTrue: [ stone add: (resetSensor := builder newTouchSensor) ]].
		interpolator := builder newRotationInterpolatorFrom: ( rotations at: i ) values axis: domino rotationAxis.
		builder add: interpolator.
		builder 
			whenFractionChanging: clock 
			rotate: ( domino rotationTransformIn: stone ) 
			using: interpolator.
		rewinder 
			at: 0 
			send: #set_fraction 
			with: 0 
			to: interpolator ].! !

!DominoTopplingVRMLSceneBuilder methodsFor: 'building' stamp: 'emm 31/01/2003 07:52'!
addDominosUsingCompressAngles
	
	| tt rotations sideColor |
	tt := self cycleFactor.
	rotations := processor rotations.
	sideColor := Color redByte: 255 greenByte: 255 blueByte: 222.
	1 to: processor dominos size do: [ :i |  | clock interpolator domino stone | 
		domino := processor dominos at: i.
		useTextures 
			ifTrue:
				[domino color: sideColor.
			 	domino texture: self class randomTextures next ].
		builder add: ( stone := domino buildElementWith: builder ).
		useButtons 	ifFalse: [ 
				i = 1 
					ifTrue: [ stone add: (startSensor := builder newTouchSensor) ].
				i = processor dominos size
					ifTrue: [ stone add: (resetSensor := builder newTouchSensor) ]].
		clock := ( builder newTimeSensor ) cycleInterval: ( rotations at: i ) elapsed * tt.
		builder add: clock.
		builder add: ( interpolator := builder newRotationInterpolatorFrom: 
			( ( rotations at: i ) values collect: [ :e | e roundTo: 0.01 ] ) axis: domino rotationAxis ).
		builder 
			whenFractionChanging: clock 
			rotate: ( domino rotationTransformIn: stone ) 
			using: interpolator.
		rewinder 
			at: 0 
			send: #set_fraction 
			with: 0 
			to: interpolator.
		scheduler at: ( ( rotations at: i ) start * tt roundTo: scheduler cycleInterval ) start: clock ].
		builder add: scheduler.! !

!DominoTopplingVRMLSceneBuilder methodsFor: 'building' stamp: 'emm 31/01/2003 07:52'!
addGreenFloor: aPoly

	| box  ttf bottom|
	builder color: Color white. "(Color red01: 0.5078125 green01: 0.7890625 blue01: 0.5078125)."
	"builder texture: 'grass.gif'."
	builder add: aPoly.

	bottom := (aPoly expandedBy: 10,10,0) translateBy: 0,0,-10.
	builder color: Color brown.
	builder add: (TwoFacedExtrudedPolygon 
		between: bottom reverseOriented 
		and: (aPoly translatedBy: 0,0,-1))! !

!DominoTopplingVRMLSceneBuilder methodsFor: 'building' stamp: 'emm 31/01/2003 07:52'!
addLightsOn: bbox

	|lightBox vertices |
	lightBox := (bbox expandedBy: 0,50,0) normalize. 
	vertices := lightBox left center to: lightBox right center by: 0,100,0.
	vertices do: [ :from | builder add: ( Light at: from + ( 0 , 0 , 15 )) ]! !

!DominoTopplingVRMLSceneBuilder methodsFor: 'building' stamp: 'emm 31/01/2003 07:52'!
addLightsOnAll: aPointCollection

	aPointCollection do:[ :each |
		builder add: (Light at: each)].! !

!DominoTopplingVRMLSceneBuilder methodsFor: 'building' stamp: 'emm 31/01/2003 07:52'!
addStartAndStopButtons

	startSensor := builder newTouchSensor.
	resetSensor := builder newTouchSensor.

	processor compressAngles
		ifTrue: 
			[builder whenTouching:  startSensor start: scheduler script.
			builder whenTouching: resetSensor stop: scheduler script]
		ifFalse: 
			[ builder whenTouching:  startSensor start: ticker.
			builder whenTouching: resetSensor stop: ticker].
	builder whenTouching: resetSensor start: rewinder script.

	builder group:[
		builder color: Color green.
		builder add: (((Pyramid origin: 0,0,0 centerExtent: 10,10,10 ) rotateBy: -90 rad,0,0) translateBy: processor bounds frontLeftBottom + (10,-10,0)).
		builder add: startSensor ].
	
	builder group:[
		builder color: Color red.
		builder add: (Box origin:  (processor bounds frontLeftBottom + (10,10,0)) centerExtent: 10,10,10 ).
		builder add: resetSensor ].
	
	processor compressAngles
		ifTrue: [ builder add: scheduler ].
	builder add: rewinder! !

!DominoTopplingVRMLSceneBuilder methodsFor: 'building' stamp: 'emm 31/01/2003 07:52'!
addTouchToDomino

	builder add: rewinder.
	builder whenTouching: resetSensor start: rewinder script.	
	builder whenTouching: startSensor start: (ticker ifNil:[scheduler]).
! !

!DominoTopplingVRMLSceneBuilder methodsFor: 'processing' stamp: 'emm 10/6/2012 21:49'!
buildFromProcessor: aDominoTopplingProcessor

	processor := aDominoTopplingProcessor.
	builder 
		add: builder newDirectionalLight 
		;color: Color green.
	builder
		navigationInfo type: 'EXAMINE'
		;headlight: true
		;speed: 25.0.
	processor compressAngles
		ifTrue: [ self addDominosUsingCompressAngles ]
		ifFalse: [ self addDominos ].
	useButtons
		ifTrue: [ self addStartAndStopButtons ]
		ifFalse: [ self addTouchToDomino ].

	"add initial viewpoint"
	builder add: ((Camera 
		at: (aDominoTopplingProcessor dominos first origin + (-5, -100,70)) 
		lookingAt: aDominoTopplingProcessor bounds center) label: 'Start').
	
	"add second viewpoint"
	builder add: ((Camera 
		at: 0,0,0 "(DominoSceneGenerator new staticOrigin)" 
		lookingAt: (aDominoTopplingProcessor bounds center - (0,40,0))) label: 'End').	
! !

!DominoTopplingVRMLSceneBuilder methodsFor: 'processing' stamp: 'emm 31/01/2003 08:11'!
buildFromProcessor: aDominoTopplingProcessor usingPath: camPath  beforeWriteDo: zeroBlock

	self buildFromProcessor: aDominoTopplingProcessor.
	self addCameraPath: camPath.
	self writeToFile: filename.
	
! !

!DominoTopplingVRMLSceneBuilder methodsFor: 'accessing' stamp: 'emm 31/01/2003 07:52'!
cycleFactor

	"Answer the value of cycleFactor"

	^cycleFactor! !

!DominoTopplingVRMLSceneBuilder methodsFor: 'accessing' stamp: 'emm 31/01/2003 07:52'!
cycleFactor: aValue

	"Set the value of cycleFactor"

	cycleFactor := aValue! !

!DominoTopplingVRMLSceneBuilder methodsFor: 'accessing' stamp: 'emm 31/01/2003 07:52'!
filename

	"Answer the value of filename"

	^filename! !

!DominoTopplingVRMLSceneBuilder methodsFor: 'accessing' stamp: 'emm 31/01/2003 07:52'!
filename: aValue

	"Set the value of filename"

	filename := aValue! !

!DominoTopplingVRMLSceneBuilder methodsFor: 'accessing' stamp: 'emm 31/01/2003 07:52'!
frameCount

	"Answer the value of frameCount"

	^frameCount! !

!DominoTopplingVRMLSceneBuilder methodsFor: 'accessing' stamp: 'emm 31/01/2003 07:52'!
frameCount: aValue

	"Set the value of frameCount"

	frameCount := aValue! !

!DominoTopplingVRMLSceneBuilder methodsFor: 'initialize-release' stamp: 'emm 31/01/2003 07:52'!
initialize

	scheduler := VRMLScheduler new.
	rewinder := VRMLScheduler new.
	builder := SceneBuilder vrml.
	useTextures := false.
	useButtons := true.
	cycleFactor := 1 / 25! !

!DominoTopplingVRMLSceneBuilder methodsFor: 'accessing' stamp: 'emm 31/01/2003 07:52'!
useButtons: aValue

	"Set the value of useButtons"

	useButtons := aValue! !

!DominoTopplingVRMLSceneBuilder methodsFor: 'accessing' stamp: 'emm 31/01/2003 07:52'!
useTextures

	"Answer the value of useTextures"

	^useTextures! !

!DominoTopplingVRMLSceneBuilder methodsFor: 'accessing' stamp: 'emm 31/01/2003 07:52'!
useTextures: aValue

	"Set the value of useTextures"

	useTextures := aValue! !

!DominoTopplingVRMLSceneBuilder methodsFor: 'building' stamp: 'emm 31/01/2003 07:52'!
vrmlBuilder

	^builder! !

!DominoTopplingVRMLSceneBuilder methodsFor: 'processing' stamp: 'emm 31/01/2003 08:00'!
writeToFile: fullName
	builder writeToFile: fullName useIndentation: false
	
! !

Object subclass: #FaceApproximator
	instanceVariableNames: 'epsilon segmentCount'
	classVariableNames: ''
	poolDictionaries: 'Math3DConstants'
	category: 'Zenna-Operators3D'!

!FaceApproximator class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:46'!
new

	"Answer a new instance of the receiver and initialize it"

	^super new initialize! !

!FaceApproximator methodsFor: 'approximating' stamp: 'emm 02/09/2012 23:46'!
approximate: anObject

	^anObject kindDo: self.! !

!FaceApproximator methodsFor: 'private-approxi' stamp: 'emm 02/09/2012 23:46'!
approximateByTrianglesCircle3D: aCircle3D

	| howMany  faces fractionStep fraction poly|
	howMany := self segmentCountForRadius: aCircle3D radius.
	faces := FaceComposite new.
	fractionStep := 1 / ( howMany - 1 ).
	fraction := 0.
	howMany timesRepeat:[
		poly := Polygon3D new.
		poly add: aCircle3D center.
		poly add: (aCircle3D computeVertexAtFraction: 1-fraction).
		fraction := fraction + fractionStep.
		poly add: (aCircle3D computeVertexAtFraction: 1-fraction).
		faces add: poly].
	^faces! !

!FaceApproximator methodsFor: 'private-approxi' stamp: 'emm 02/09/2012 23:46'!
approximateCircle3D: aCircle3D

	"Approximate @aCircle3D by one polygon"

	| poly  howMany|
	poly := Polygon3D new.
	howMany := self segmentCountForRadius: aCircle3D radius.
	(0 to: 1 steps: howMany) do:[ :f |
		poly add: (aCircle3D computeVertexAtFraction: 1-f) ].
	^poly
! !

!FaceApproximator methodsFor: 'private-approxi' stamp: 'emm 02/09/2012 23:46'!
approximatedCylinder: aCylinder startAngle: startAngle sweepAngle: sweepAngle! !

!FaceApproximator methodsFor: 'private-approxi' stamp: 'emm 02/09/2012 23:46'!
approximatedTube: aTube startAngle: startAngle sweepAngle: sweepAngle 
	
	"Approximate @aTube by faces"
	
	| p alpha n ip lastAngle innerCylinder poly faces topFaces bottomFaces |
	faces := OrderedCollection new. 
	 "calculate increment angle to meet eps"
	alpha := 2 * ( 1 - epsilon ) arcCos.
	n := ( sweepAngle / alpha ) rounded + 1.
	ip := aTube interpolatorUsingAll: ( startAngle to: ( startAngle + sweepAngle ) by: ( sweepAngle / n ) ).
	innerCylinder := Cylinder new origin: aTube origin ; radius: aTube radius - aTube thickness ; zSize: aTube zSize. 
	
	topFaces := OrderedCollection new.
	bottomFaces := OrderedCollection new. 
	
	ip collection do: [ :eachAngle | 
		eachAngle = startAngle
			ifTrue:
				[ lastAngle := eachAngle ]
			ifFalse:
				[ faces add: ( aTube computeFaceBetween: eachAngle and: lastAngle ) reverseOriented. 
				
				aTube thickness > 0 
					ifTrue:
						[ faces add: ( innerCylinder computeFaceBetween: eachAngle and: lastAngle ). 
						 "calculate side faces"
						poly := Polygon3D new.
						poly add: ( aTube computeBottomVertexAt: lastAngle )
							; add: ( aTube computeBottomVertexAt: eachAngle )
							; add: ( innerCylinder computeBottomVertexAt: eachAngle )
							; add: ( innerCylinder computeBottomVertexAt: lastAngle ).
						bottomFaces add: poly. 
						
						poly := Polygon3D new.
						poly add: ( aTube computeTopVertexAt: eachAngle )
							; add: ( aTube computeTopVertexAt: lastAngle )
							; add: ( innerCylinder computeTopVertexAt: lastAngle )
							; add: ( innerCylinder computeTopVertexAt: eachAngle ).
						topFaces add: poly ].
				lastAngle := eachAngle ] ]. 
	 "calculate endfaces"
	sweepAngle < ( 2 * Float pi ) 
		ifTrue:
			[ poly := Polygon3D new.
			poly add: ( aTube computeTopVertexAt: startAngle )
				; add: ( innerCylinder computeTopVertexAt: startAngle )
				; add: ( innerCylinder computeBottomVertexAt: startAngle )
				; add: ( aTube computeBottomVertexAt: startAngle ).
			faces add: poly reverseOriented. 
			
			poly := Polygon3D new.
			poly add: ( aTube computeTopVertexAt: startAngle + sweepAngle )
				; add: ( innerCylinder computeTopVertexAt: startAngle + sweepAngle )
				; add: ( innerCylinder computeBottomVertexAt: startAngle + sweepAngle )
				; add: ( aTube computeBottomVertexAt: startAngle + sweepAngle ).
			faces add: poly ].
	^ ( CompositeGeometric3D new ) add: ( FaceComposite on: faces )
		; add: ( FaceComposite on: topFaces )
		; add: ( FaceComposite on: bottomFaces )
		; yourself! !

!FaceApproximator methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:46'!
doBox: aBox
	"@aBox knows how to compute faces"

	^Group3D withAll: aBox faces! !

!FaceApproximator methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:46'!
doCircle3D: aCircle3D
	
	"Approximate @aCircle3D by multiple triangles"

	^self approximateByTrianglesCircle3D: aCircle3D
"
	| howMany  faces fractionStep fraction poly|
	howMany := segmentCount isNil
		ifTrue: [24]
		ifFalse: [segmentCount].
	faces := FaceComposite new.
	fractionStep := 1 / ( howMany - 1 ).
	fraction := 0.
	howMany timesRepeat:[
		poly := Polygon3D new.
		poly add: aCircle3D center.
		poly add: (aCircle3D computeVertexAtFraction: 1-fraction).
		fraction := fraction + fractionStep.
		poly add: (aCircle3D computeVertexAtFraction: 1-fraction).
		faces add: poly].
	^faces
"
! !

!FaceApproximator methodsFor: 'dispatching-wrappers' stamp: 'emm 02/09/2012 23:46'!
doColorWrapper: aWrapper

	^(aWrapper component kindDo: self) coloredWith: aWrapper color! !

!FaceApproximator methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:46'!
doCone: aCone
	
	"Approximate @aCone by faces"

	| faces |
	faces := FaceComposite new.
	"top"
	faces addAll:(self approximate: aCone top).
	"bottom"
	faces addAll:(self approximate: aCone bottom).
	"side"
	Helper3D
		facesForSolidBetween: (self approximateCircle3D: aCone top)
		and: (self approximateCircle3D: aCone top) reverseOriented
		do: [ :each | faces add: each ].
	^faces
! !

!FaceApproximator methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:46'!
doConeSegment: aConeSegment
	
	"Approximate @aConeSegment by faces"! !

!FaceApproximator methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:46'!
doCylinder: aCylinder
	
	"Approximate @aCylinder by faces"

	| faces  top howMany fractionStep fraction|
	faces := FaceComposite new.
	"top"
	faces addAll:(top := self approximate: aCylinder top).
	"bottom"
	faces addAll:(top reverseOriented translateBy: aCylinder bottomCenter - aCylinder topCenter).
	"side"
	Helper3D
		facesForSolidBetween: (top := self approximateCircle3D: aCylinder top)
		and: (top reverseOriented translateBy: aCylinder bottomCenter - aCylinder topCenter)
		do: [ :each | faces add: each ].
	^faces
! !

!FaceApproximator methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:46'!
doCylinderSegment: aCylinderSegment
	
	"Approximate @aCylinderSegment by faces"! !

!FaceApproximator methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:46'!
doFaceComposite: aFaceComposite

	^aFaceComposite! !

!FaceApproximator methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:46'!
doPolygon3D: aPolygon3D

	^aPolygon3D
	! !

!FaceApproximator methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:46'!
doRectangle3D: aRectangle3D

	^self doPolygon3D: aRectangle3D
	! !

!FaceApproximator methodsFor: 'dispatching-wrappers' stamp: 'emm 02/09/2012 23:46'!
doRotating3DWrapper: aWrapper

	^(aWrapper component kindDo: self) rotateBy: aWrapper rotation! !

!FaceApproximator methodsFor: 'dispatching-wrappers' stamp: 'emm 02/09/2012 23:46'!
doScaling3DWrapper: aWrapper

	^(aWrapper component kindDo: self) scaleBy: aWrapper scale! !

!FaceApproximator methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:46'!
doSimpleExtrudedPolygon: aSEP

	| faces |
	faces := FaceComposite new.
	aSEP facesDo:[ :each | faces add: each ].
	^faces! !

!FaceApproximator methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:46'!
doSolidComposite: aComposite

	| group |
	group := CompositeGeometric3D new.
	aComposite do:[ :each | group add: (self approximate: each) ].
	^group! !

!FaceApproximator methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:46'!
doSphere: aSphere

	| numLat numLong points y r a x z composite|
	composite := FaceComposite new.
	numLat := 20.
	numLong := 20.
	points := OrderedPoint3DCollection new: numLat * numLong.
	0 to: numLat - 1 do:[ :i |
		y := 2 * ( i / (numLat-1) ) - 1.
		r := (1 - (y*y)) sqrt.
		0 to: numLong - 1 do:[ :j |
			a := 2 * Pi * j / numLong.
			x := a sin * r negated.
			z := a cos * r negated.
			points at: i * numLong + j + 1 putX: x y: y z: z]]. 
	0 to: numLat - 2 do:[ :i |
		0 to: numLong - 1 do:[ :j |
			composite add: (Polygon3D 
				with: aSphere center + (aSphere radius * (points at: i * numLong + j + 1))
				with: aSphere center + (aSphere radius * (points at: (i+1)*numLong + j + 1))
				with: aSphere center + (aSphere radius * (points at: (i+1)*numLong + (j+1 \\ numLong) + 1))
				with: aSphere center + (aSphere radius * (points at: i * numLong + (j+1 \\ numLong) + 1)))]].
	^composite! !

!FaceApproximator methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:46'!
doTorus: aTorus 
	
	"Approximate @aTorus by faces"! !

!FaceApproximator methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:46'!
doTorusArc: aTorusArc
	
	"Approximate @TorusArc by faces"! !

!FaceApproximator methodsFor: 'dispatching-wrappers' stamp: 'emm 02/09/2012 23:46'!
doTranslating3DWrapper: aWrapper

	^(aWrapper component kindDo: self) translateBy: aWrapper translation! !

!FaceApproximator methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:46'!
doTriangle3D: aTriangle3D

	^aTriangle3D
	! !

!FaceApproximator methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:46'!
doTriangle3DCollection: aCollection

	^FaceComposite on: aCollection! !

!FaceApproximator methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:46'!
doTube: aTube
	
	"Approximate @aTube by faces"

	^self approximatedTube: aTube startAngle: 0 sweepAngle: TwoPi! !

!FaceApproximator methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:46'!
doTubeSegment: aTubeSegment
	
	"Approximate @aTubeSegment by faces"

	^self approximatedTube: aTubeSegment startAngle: aTubeSegment startAngle sweepAngle: aTubeSegment sweepAngle! !

!FaceApproximator methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:46'!
doWedge3D: aWedge3D
	
	"Approximate @aWedge3D by faces"! !

!FaceApproximator methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:46'!
epsilon

	"Answer the value of epsilon"

	^epsilon! !

!FaceApproximator methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:46'!
epsilon: aValue

	"Set the value of epsilon"

	epsilon := aValue! !

!FaceApproximator methodsFor: 'initialize-release' stamp: 'emm 02/09/2012 23:46'!
initialize
	
	epsilon := 0.01! !

!FaceApproximator methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:46'!
segmentCount

	"Answer the value of segmentCount"

	^segmentCount ifNil:[24]! !

!FaceApproximator methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:46'!
segmentCount: aValue

	"Set the value of segmentCount"

	segmentCount := aValue! !

!FaceApproximator methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:46'!
segmentCountForRadius: radius
	"temp"

	^self segmentCount! !

FaceApproximator subclass: #Triangle3DApproximator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Operators3D'!

!Triangle3DApproximator methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:46'!
doColoredPolygon3D: aCP
	^(self doPolygon3D: aCP) wrapColoredWith: aCP color! !

!Triangle3DApproximator methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:46'!
doPolygon3D: aPolygon3D 
	"convert to a mesh of triangles"

	"assume convex for now"

	"use simple algoritm here"

	| triangles center |
	aPolygon3D size = 4 
		ifTrue: [^self trianglesFrom4Points: aPolygon3D asArray].
	triangles := Triangle3DComposite new.
	center := aPolygon3D center.
	1 to: aPolygon3D size
		by: 2
		do: 
			[:index | 
			triangles 
				addTriangleWith: (aPolygon3D at: index)
				with: center
				with: (aPolygon3D at: index + 1)].
	^triangles! !

!Triangle3DApproximator methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:46'!
doRectangle3D: aRect
	"should return trianglecollection"
	
	| poly  mesh|
	poly := aRect asPolygon3D.	
	mesh := Mesh new.
	mesh vertices: poly vertices.
	mesh indexedFaces: #( #(1 2 3) #(3 4 1) ).
	^mesh! !

!Triangle3DApproximator methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:46'!
doTriangle3D: aTriangle3D

	^Triangle3DComposite with: aTriangle3D! !

!Triangle3DApproximator methodsFor: 'converting' stamp: 'emm 02/09/2012 23:46'!
trianglesFrom4Points: anArray 
	| col |
	col := Triangle3DComposite new.
	col 
		addTriangleWith: (anArray at: 1)
		with: (anArray at: 2)
		with: (anArray at: 3).
	col 
		addTriangleWith: (anArray at: 3)
		with: (anArray at: 4)
		with: (anArray at: 1).
	^col! !

Object subclass: #Geometric2D
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Core2D'!

Geometric2D subclass: #Circle2D
	instanceVariableNames: 'center radius startAngle sweepAngle'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Core2D'!

!Circle2D class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 22:51'!
center: aPoint radius: aNumber

	^(self new) center: aPoint ;radius: aNumber! !

!Circle2D class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 22:51'!
new

	"Answer a new instance of the receiver and initialize it"

	^super new initialize! !

!Circle2D methodsFor: 'accessing' stamp: 'emm 02/09/2012 22:51'!
center

	"Answer the value of center"

	^center! !

!Circle2D methodsFor: 'accessing' stamp: 'emm 02/09/2012 22:51'!
center: aValue

	"Set the value of center"

	center := aValue! !

!Circle2D methodsFor: 'computing' stamp: 'emm 02/09/2012 22:51'!
computeVertexAtFraction: fraction

	"fraction = [ 0..1 ]"

	^( (self radius , 0 ) rotatedBy: self sweepAngle * fraction + self startAngle ) + self center! !

!Circle2D methodsFor: 'computing' stamp: 'emm 02/09/2012 22:51'!
endPoint

	^( (self radius @ 0 ) rotatedBy: self startAngle + self sweepAngle) + self center! !

!Circle2D methodsFor: 'initialize-release' stamp: 'emm 02/09/2012 22:51'!
initialize

	self center: 0@0.
	self radius: 1.
	self startAngle: 0.
	self sweepAngle: Float pi * 2.	! !

!Circle2D methodsFor: 'dispatching' stamp: 'emm 02/09/2012 22:51'!
kindDo: aRequestor
	^ aRequestor doCircle2D: self! !

!Circle2D methodsFor: 'computing' stamp: 'emm 02/09/2012 22:51'!
length

	^self sweepAngle abs * self radius! !

!Circle2D methodsFor: 'accessing' stamp: 'emm 02/09/2012 22:51'!
radius

	"Answer the value of radius"

	^radius! !

!Circle2D methodsFor: 'accessing' stamp: 'emm 02/09/2012 22:51'!
radius: aValue

	"Set the value of radius"

	radius := aValue! !

!Circle2D methodsFor: 'accessing' stamp: 'emm 02/09/2012 22:51'!
startAngle

	^startAngle! !

!Circle2D methodsFor: 'accessing' stamp: 'emm 02/09/2012 22:51'!
startAngle: rads

	startAngle := rads! !

!Circle2D methodsFor: 'computing' stamp: 'emm 02/09/2012 22:51'!
startPoint

	^( (self radius @ 0 ) rotatedBy: self startAngle ) + self center! !

!Circle2D methodsFor: 'accessing' stamp: 'emm 02/09/2012 22:51'!
sweepAngle

	^sweepAngle! !

!Circle2D methodsFor: 'accessing' stamp: 'emm 02/09/2012 22:51'!
sweepAngle: rads

	sweepAngle := rads! !

Geometric2D subclass: #Curve2D
	instanceVariableNames: 'parameterToPointBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Core2D'!

!Curve2D class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 22:51'!
circleAt: center radius: radius
	"(self circleAt: 2,2 radius: 1) interpolatedWithAll: (0 to: 360 rad by: 10 rad) "

	^self new
			parameterToPointBlock:[ :angle |
				Point
					x: ( angle cos * radius + center x )
					y: ( angle sin * radius + center y ) ]! !

!Curve2D class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 22:51'!
parabolaWith: squaredTerm with: linearTerm with: constant

	"(self parabolaWith: 2 with: 3 with: 4) interpolatedWithAll: (-5 to: 5)"

	^self new parameterToPointBlock:[ :x | 
			Point 
				x: x
				y: squaredTerm * x squared + ( linearTerm * x ) + constant ]! !

!Curve2D methodsFor: 'computing' stamp: 'emm 02/09/2012 22:51'!
computeVertexAt: param

	^parameterToPointBlock value: param! !

!Curve2D methodsFor: '*Zenna-Operators3D' stamp: 'emm 02/09/2012 23:47'!
interpolatedWithAll: parameters

	^(CollectionBasedInterpolator on: self)
		collection: parameters! !

!Curve2D methodsFor: 'accessing' stamp: 'emm 02/09/2012 22:51'!
parameterToPointBlock

	"Answer the value of parameterToPointBlock"

	^parameterToPointBlock! !

!Curve2D methodsFor: 'accessing' stamp: 'emm 02/09/2012 22:51'!
parameterToPointBlock: aValue

	"Set the value of parameterToPointBlock"

	parameterToPointBlock := aValue! !

Geometric2D subclass: #EllipticalArc2D
	instanceVariableNames: 'boundingBox startAngle sweepAngle'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Core2D'!

!EllipticalArc2D class methodsFor: 'instance creation' stamp: 'emm 02/09/2012 22:51'!
boundingBox: bbox

	^self basicNew setBoundingBox: bbox startAngle: 0.0 sweepAngle: 360.0! !

!EllipticalArc2D class methodsFor: 'instance creation' stamp: 'emm 02/09/2012 22:51'!
boundingBox: bbox startAngle: startAngle sweepAngle: sweepAngle

	^self basicNew setBoundingBox: bbox startAngle: startAngle sweepAngle: sweepAngle! !

!EllipticalArc2D class methodsFor: 'instance creation' stamp: 'emm 02/09/2012 22:51'!
center: aPoint radius: aNumber
	"Answer a circle (in EllipticalArc2D representation) with the supplied center and radius"

	^self boundingBox: (aPoint - aNumber asPoint extent: (aNumber + aNumber) asPoint).! !

!EllipticalArc2D class methodsFor: 'instance creation' stamp: 'emm 02/09/2012 22:51'!
from: startPoint to: endPoint center: centerPoint  clockwise: isCW
	"Pre: non-elliptical arc coordinates"
	
	^self basicNew
		setFrom: startPoint 
		to: endPoint 
		center: centerPoint 
		clockwise: isCW! !

!EllipticalArc2D methodsFor: 'converting' stamp: 'emm 02/09/2012 22:51'!
asEllipticalArc2D

	^self! !

!EllipticalArc2D methodsFor: 'converting' stamp: 'emm 02/09/2012 22:51'!
asPolyline
	"Answer an approximation of the receiver as a Polyline."

	^Polyline2D vertices: self computePoints! !

!EllipticalArc2D methodsFor: 'testing' stamp: 'emm 02/09/2012 22:51'!
canBeFilled
	"Answer whether filling makes sense for this Geometric"

	^true! !

!EllipticalArc2D methodsFor: 'accessing' stamp: 'emm 02/09/2012 22:51'!
center
	"Answer the coordinates of the receiver's center."

	^boundingBox center! !

!EllipticalArc2D methodsFor: 'private' stamp: 'emm 02/09/2012 22:51'!
computeBounds
	"Answer the Rectangle that minimally bounds the coordinate region used
	by the receiver, independent of considerations such as line width."

	(startAngle = 0 and: [sweepAngle = 360]) ifTrue: [^boundingBox copy].
	^self class boundingRectangleForPoints: self computePoints.! !

!EllipticalArc2D methodsFor: 'private' stamp: 'emm 02/09/2012 22:51'!
computePoints
	"Answer an array of points which are vertices of a polyline fitted to the 
	curve."

	| ws radStart radSweep pieces a b cx cy quadrants left right top bottom step |
	left := boundingBox left.
	right := boundingBox right.
	top := boundingBox top.
	bottom := boundingBox bottom.
	ws := WriteStream on: (Array new: 50).
	a := boundingBox width asFloat / 2.
	b := boundingBox height asFloat / 2.
	cx := boundingBox center x.
	cy := boundingBox center y.
	radStart := startAngle degreesToRadians negated.
	radSweep := ((sweepAngle min: 360.0) max: -360.0) degreesToRadians negated.
	quadrants := (radSweep abs / Float pi * 2.0) rounded max: 1.
	pieces := ((a + b) * radSweep abs / Float pi / 10.0) rounded * quadrants.
	step := radSweep / (pieces max: quadrants).
		"Overshoot the end of the arc to account for roundoff errors"
	(radStart to: radStart + radSweep + (step/10) by: step) do: [:theta |
		| x y |
		x := a * theta cos + cx.
		y := b * theta sin negated + cy.
		x < left ifTrue: [x := left].
		x > right ifTrue: [x := right].
		y < top ifTrue: [y := top].
		y > bottom ifTrue: [y := bottom].
		ws nextPut: x@y].
	^ws contents! !

!EllipticalArc2D methodsFor: 'private' stamp: 'emm 02/09/2012 22:51'!
computeVertexAtFraction: fraction

	"fraction = [ 0..1 ]"! !

!EllipticalArc2D methodsFor: 'accessing' stamp: 'emm 02/09/2012 22:51'!
end

	^self computePoints last! !

!EllipticalArc2D methodsFor: 'kind-dispatching' stamp: 'emm 02/09/2012 22:51'!
kindDo: aRequestor
	^aRequestor doEllipticalArc2D: self! !

!EllipticalArc2D methodsFor: 'testing' stamp: 'emm 02/09/2012 22:51'!
outlineIntersects: aRectangle
	"Answer whether the receiver's display area intersects aRectangle 
	under stroking."

	"Eliminate the trivial failures"
	(super outlineIntersects: aRectangle)
		ifFalse:	[^false].
	^self class vertices: self computePoints intersectsRectangle: aRectangle! !

!EllipticalArc2D methodsFor: 'accessing' stamp: 'emm 02/09/2012 22:51'!
radiusAsPoint
	"Answer the radius of the receiver as a point showing the radius on the x axis and the y axis."

	^boundingBox extent / 2! !

!EllipticalArc2D methodsFor: 'transforming' stamp: 'emm 02/09/2012 22:51'!
scaledBy: amount 
	"Answer a new object scaled by the argument amount, which can be
	a Point or a scalar value."

	^self species boundingBox: (boundingBox scaledBy: amount) startAngle: startAngle sweepAngle: sweepAngle! !

!EllipticalArc2D methodsFor: 'private' stamp: 'emm 02/09/2012 22:51'!
setBoundingBox: box startAngle: sta sweepAngle: swa
	"Initialize the boundingBox, start angle and sweep angle of the receiver."

	boundingBox := box.
	startAngle := sta.
	sweepAngle := swa! !

!EllipticalArc2D methodsFor: 'private' stamp: 'emm 02/09/2012 22:51'!
setFrom: startPoint to: endPoint center: centerPoint clockwise: isCW
	"Post: non-elliptical arc"
	"Compute the start- and sweep angle such that <startPoint> and <endPoint> are 
	the start and end of the receiver.If <isCW> then the sweep angle is negative"

	| radius stopAngle |
	radius := ( endPoint dist: centerPoint ) + ( startPoint dist: centerPoint ) / 2.
	startAngle := ( startPoint - centerPoint ) theta radiansToDegrees.  "0..360"
	stopAngle := ( endPoint - centerPoint ) theta radiansToDegrees.  "0..360"
	startAngle < stopAngle
		ifTrue:[ isCW
			ifTrue:[ sweepAngle := stopAngle - startAngle - 360]
			ifFalse:[ sweepAngle := stopAngle - startAngle ] ]
		ifFalse:[ isCW
			ifTrue:[ sweepAngle := stopAngle - startAngle ]
			ifFalse:[ sweepAngle := 360 - startAngle + stopAngle ] ].
	boundingBox := centerPoint centerExtent: radius.! !

!EllipticalArc2D methodsFor: 'accessing' stamp: 'emm 02/09/2012 22:51'!
start

	^self computePoints first! !

!EllipticalArc2D methodsFor: 'accessing' stamp: 'emm 02/09/2012 22:51'!
startAngle
	"Answer the start angle of the ellipse. This specifies the angle (from the 
	ellipse's center) of one end of the arc or wedge that is represented. The 
	other end is specified by adding the startAngle and sweepAngle."

	^startAngle! !

!EllipticalArc2D methodsFor: 'accessing' stamp: 'emm 02/09/2012 22:51'!
sweepAngle
	"Answer the sweep angle of the ellipse. This specifies the size of the arc, in 
	degrees. A positive sweepAngle is measured clockwise; otherwise, it's 
	measured counter-clockwise."

	^sweepAngle! !

!EllipticalArc2D methodsFor: 'transforming' stamp: 'emm 02/09/2012 22:51'!
translatedBy: amount 
	"Answer a new object translated by amount, which can be
	a Point or a scalar value."

	^self species boundingBox: (boundingBox translatedBy: amount) startAngle: startAngle sweepAngle: sweepAngle! !

!EllipticalArc2D methodsFor: 'accessing' stamp: 'emm 02/09/2012 22:51'!
vertices

	^self computePoints! !

!Geometric2D methodsFor: 'resources' stamp: 'emm 02/09/2012 22:51'!
pointCollectionClass
	^OrderedPoint2DCollection! !

Geometric2D subclass: #Line2D
	instanceVariableNames: 'a b c a2plusb2sqrt perpendicularUnitVector parallelUnitVector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Core2D'!

!Line2D class methodsFor: 'api' stamp: 'emm 02/09/2012 22:51'!
through: aPoint and: anotherPoint

	^self new through: aPoint and: anotherPoint! !

!Line2D methodsFor: 'api' stamp: 'emm 02/09/2012 22:51'!
< aPoint
	" all points on the line are less than aPoint "
	
	| intersection |

	a = 0 ifTrue: [^aPoint x > (b / c negated)].
	b = 0 ifTrue: [^aPoint y > (a / c negated)].
	intersection := self lineIntersection: (Line2D through: aPoint and: aPoint + (0@1)).
	intersection isNil 
		ifTrue: [self samplePoint y >= aPoint y ifTrue: [^false]]
		ifFalse: [intersection y >= aPoint y ifTrue: [^false]].
	intersection := self lineIntersection: (Line2D through: aPoint and: aPoint + (1@0)).
	intersection isNil 
		ifTrue: [self samplePoint x >= aPoint x ifTrue: [^false]]
		ifFalse: [intersection x >= aPoint x ifTrue: [^false]].
	^true! !

!Line2D methodsFor: 'api' stamp: 'emm 02/09/2012 22:51'!
a

	^a! !

!Line2D methodsFor: 'api' stamp: 'emm 02/09/2012 22:51'!
b

	^b! !

!Line2D methodsFor: 'api' stamp: 'emm 02/09/2012 22:51'!
c

	^c! !

!Line2D methodsFor: 'api' stamp: 'emm 02/09/2012 22:51'!
cOverA2plusb2sqrt
	
	^(a2plusb2sqrt == nil or: [a2plusb2sqrt = 0])
		ifTrue: [nil]
		ifFalse: [c / a2plusb2sqrt]! !

!Line2D methodsFor: 'api' stamp: 'emm 02/09/2012 22:51'!
distanceFrom: aPoint isLessThan: aNumber
	" return true if aPoint is less that aNumber from the receiver line segment "

	^(((a * aPoint x) + (b * aPoint y) + c) / a2plusb2sqrt) abs <= aNumber! !

!Line2D methodsFor: 'api' stamp: 'emm 02/09/2012 22:51'!
intersects: anObject

	^(anObject lineIntersection: self) notNil! !

!Line2D methodsFor: 'private' stamp: 'emm 02/09/2012 22:51'!
lineIntersection: aLine

	| det |
	(det := self b * aLine a - (self a * aLine b)) = 0 ifTrue: [^nil].
	^((aLine b * self c) - (self b * aLine c)) @ ((self a * aLine c) - (aLine a * self c)) / det! !

!Line2D methodsFor: 'api' stamp: 'emm 02/09/2012 22:51'!
nearestPointTo: aPoint

	| x y |
	y := (a squared *  aPoint y - (a * b * aPoint x) - (b * c)) / a2plusb2sqrt squared.
	x := (b squared * aPoint x - (a * b * aPoint y) - (a * c)) / a2plusb2sqrt squared.
	^x @ y! !

!Line2D methodsFor: 'api' stamp: 'emm 02/09/2012 22:51'!
parallelUnitVector

	^parallelUnitVector

	! !

!Line2D methodsFor: 'api' stamp: 'emm 02/09/2012 22:51'!
perpendicularUnitVector 

	^perpendicularUnitVector ! !

!Line2D methodsFor: 'private' stamp: 'emm 02/09/2012 22:51'!
samplePoint

	a = 0 
		ifTrue:	[^0 @ (c / b negated)]
		ifFalse: [^(c / a negated) @ 0]
		! !

!Line2D methodsFor: 'api' stamp: 'emm 02/09/2012 22:51'!
through: aPoint and: anotherPoint

	(aPoint isNil or: [anotherPoint isNil]) ifTrue: [^self].
	a := anotherPoint y - aPoint y.
	b := aPoint x - anotherPoint x.
	c := (aPoint y * anotherPoint x) - (aPoint x * anotherPoint y).

	a2plusb2sqrt := (a squared + b squared) sqrt.
	a2plusb2sqrt > 0 
		ifTrue: 
			[perpendicularUnitVector  := ((a / a2plusb2sqrt) @ (b / a2plusb2sqrt)).
			parallelUnitVector := ((b / a2plusb2sqrt negated) @ (a / a2plusb2sqrt))]
		ifFalse: 
			[perpendicularUnitVector := 0@0.
			parallelUnitVector := 0@0]! !

Line2D subclass: #LineSegment2D
	instanceVariableNames: 'start end'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Core2D'!

LineSegment2D subclass: #Bezier2Segment2D
	instanceVariableNames: 'via'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Core2D'!

!Bezier2Segment2D class methodsFor: 'Not categorized' stamp: 'emm 02/09/2012 22:51'!
from: startPoint to: endPoint via: viaPoint
	^self new from: startPoint to: endPoint via: viaPoint! !

!Bezier2Segment2D class methodsFor: 'Not categorized' stamp: 'emm 02/09/2012 22:51'!
from: startPoint to: endPoint withMidPoint: pointOnCurve
	^self new from: startPoint to: endPoint withMidPoint: pointOnCurve! !

!Bezier2Segment2D class methodsFor: 'Not categorized' stamp: 'emm 02/09/2012 22:51'!
from: startPoint to: endPoint withMidPoint: pointOnCurve at: parameter
	^self new from: startPoint to: endPoint withMidPoint: pointOnCurve at: parameter! !

!Bezier2Segment2D class methodsFor: 'Not categorized' stamp: 'emm 02/09/2012 22:51'!
from: startPoint via: viaPoint to: endPoint 
	^self new from: startPoint to: endPoint via: viaPoint! !

!Bezier2Segment2D class methodsFor: 'Not categorized' stamp: 'emm 02/09/2012 22:51'!
from: startPoint withMidPoint: pointOnCurve at: parameter to: endPoint 
	^self new from: startPoint to: endPoint withMidPoint: pointOnCurve at: parameter! !

!Bezier2Segment2D class methodsFor: 'Not categorized' stamp: 'emm 02/09/2012 22:51'!
from: startPoint withMidPoint: pointOnCurve to: endPoint 
	^self new from: startPoint to: endPoint withMidPoint: pointOnCurve! !

!Bezier2Segment2D methodsFor: 'converting' stamp: 'emm 02/09/2012 22:51'!
asBezier2Segment2D
	"Represent the receiver as quadratic bezier segment"
	^self! !

!Bezier2Segment2D methodsFor: 'converting' stamp: 'emm 02/09/2012 22:51'!
asIntegerSegment
	"Convert the receiver into integer representation"
	^self species 
			from: start asIntegerPoint 
			to: end asIntegerPoint 
			via: via asIntegerPoint! !

!Bezier2Segment2D methodsFor: 'displaying' stamp: 'emm 02/09/2012 22:51'!
bounds
	"Return the bounds containing the receiver"
	
	| min  max|
	min := (start min: end) min: via rounded.
	max := (start max: end) max: via rounded.
	^Rectangle origin: min corner: max! !

!Bezier2Segment2D methodsFor: 'accessing' stamp: 'emm 02/09/2012 22:51'!
from: startPoint to: endPoint
	"Initialize the receiver as straight line"
	start := startPoint.
	end := endPoint.
	via := (start + end) // 2.! !

!Bezier2Segment2D methodsFor: 'accessing' stamp: 'emm 02/09/2012 22:51'!
from: startPoint to: endPoint via: viaPoint
	"Initialize the receiver"
	start := startPoint.
	end := endPoint.
	via := viaPoint.! !

!Bezier2Segment2D methodsFor: 'accessing' stamp: 'emm 02/09/2012 22:51'!
from: startPoint to: endPoint withMidPoint: pointOnCurve
	"Initialize the receiver with the pointOnCurve assumed at the parametric value 0.5"
	start := startPoint.
	end := endPoint.
	"Compute via"
	via := (pointOnCurve * 2) - ((start+end) // 2).! !

!Bezier2Segment2D methodsFor: 'accessing' stamp: 'emm 02/09/2012 22:51'!
from: startPoint to: endPoint withMidPoint: pointOnCurve at: parameter
	"Initialize the receiver with the pointOnCurve at the given parametric value"
	| t1 t2 t3 |
	start := startPoint.
	end := endPoint.
	"Compute via"
	t1 := (1.0 - parameter) squared.
	t2 := 2 * parameter * (1.0 - parameter).
	t3 := parameter squared.
	via := (pointOnCurve * t2) - (start * t1)  - (end * t3)! !

!Bezier2Segment2D methodsFor: 'testing' stamp: 'emm 02/09/2012 22:51'!
hasZeroLength
	"Return true if the receiver has zero length"
	^start = end and:[start = via]! !

!Bezier2Segment2D methodsFor: 'testing' stamp: 'emm 02/09/2012 22:51'!
isBezier2Segment2D
	"Return true if the receiver is a quadratic bezier segment"
	^true! !

!Bezier2Segment2D methodsFor: 'testing' stamp: 'emm 02/09/2012 22:51'!
isStraight
	"Return true if the receiver represents a straight line"
	^(self tangentAtStart crossProduct: self tangentAtEnd) = 0! !

!Bezier2Segment2D methodsFor: 'accessing' stamp: 'emm 02/09/2012 22:51'!
length
	"Return the length of the receiver"
	"Note: Overestimates the length"
	^(start dist: via) + (via dist: end)! !

!Bezier2Segment2D methodsFor: 'enumerating' stamp: 'emm 02/09/2012 22:51'!
lineSegmentsDo: aBlock
	"Evaluate aBlock with the receiver's line segments"
	"Note: We could use forward differencing here."
	| steps last deltaStep t next |
	steps := 1 max: (self length // 10). "Assume 10 pixels per step"
	last := start.
	deltaStep := 1.0 / steps asFloat.
	t := deltaStep.
	1 to: steps do:[:i|
		next := self valueAt: t.
		aBlock value: last value: next.
		last := next.
		t := t + deltaStep].! !

!Bezier2Segment2D methodsFor: 'printing' stamp: 'emm 02/09/2012 22:51'!
printOn: aStream
	"Print the receiver on aStream"
	aStream 
		nextPutAll: self class name;
		nextPutAll:' from: ';
		print: start;
		nextPutAll: ' via: ';
		print: via;
		nextPutAll: ' to: ';
		print: end;
		space.! !

!Bezier2Segment2D methodsFor: 'accessing' stamp: 'emm 02/09/2012 22:51'!
tangentAt: parameter
	"Return the tangent at the given parametric value along the receiver"
	| in out |
	in := self tangentAtStart.
	out := self tangentAtEnd.
	^in + (out - in * parameter)! !

!Bezier2Segment2D methodsFor: 'accessing' stamp: 'emm 02/09/2012 22:51'!
tangentAtEnd
	"Return the tangent for the last point"
	^end - via! !

!Bezier2Segment2D methodsFor: 'accessing' stamp: 'emm 02/09/2012 22:51'!
tangentAtStart
	"Return the tangent for the first point"
	^via - start! !

!Bezier2Segment2D methodsFor: 'accessing' stamp: 'emm 02/09/2012 22:51'!
valueAt: parameter
	"Evaluate the receiver at the given parametric value"
	"Return the point at the parametric value t:
		p(t) =	(1-t)^2 * p1 + 
				2*t*(1-t) * p2 + 
				t^2 * p3.
	"
	| t1 t2 t3 |
	t1 := (1.0 - parameter) squared.
	t2 := 2 * parameter * (1.0 - parameter).
	t3 := parameter squared.
	^(start * t1) + (via * t2) + (end * t3)! !

!Bezier2Segment2D methodsFor: 'accessing' stamp: 'emm 02/09/2012 22:51'!
via
	"Return the control point"
	^via! !

!LineSegment2D class methodsFor: 'instance creation' stamp: 'emm 02/09/2012 22:51'!
from: start to: end
	"Answer a new LineSegment with the supplied start and end points."

	^self basicNew setStart: start end: end! !

!LineSegment2D methodsFor: 'accessing' stamp: 'emm 02/09/2012 22:51'!
bounds
	^Rectangle origin: self from corner: self end! !

!LineSegment2D methodsFor: 'computing' stamp: 'emm 02/09/2012 22:51'!
computeVertexAtFraction: fraction

	"fraction = [0..1]"

	fraction = 0
		ifTrue: [ ^start ].
	fraction = 1
		ifTrue: [ ^end ].
	"fraction = <0..1>"
	^( end - start ) * fraction + start! !

!LineSegment2D methodsFor: 'accessing' stamp: 'emm 02/09/2012 22:51'!
end
	^end! !

!LineSegment2D methodsFor: 'accessing' stamp: 'emm 02/09/2012 22:51'!
end: aPoint
	^end := aPoint! !

!LineSegment2D methodsFor: 'accessing' stamp: 'emm 02/09/2012 22:51'!
from

	^self start! !

!LineSegment2D methodsFor: 'testing' stamp: 'emm 02/09/2012 22:51'!
isBezier2Segment2D
	^false! !

!LineSegment2D methodsFor: 'reflection' stamp: 'emm 02/09/2012 22:51'!
kindDo: aRequestor
	^aRequestor doLineSegment2D: self! !

!LineSegment2D methodsFor: 'computing' stamp: 'emm 02/09/2012 22:51'!
length

	^self start dist: self end! !

!LineSegment2D methodsFor: 'computing' stamp: 'emm 02/09/2012 22:51'!
lineIntersection: aLineSegment2D
	
	| this  that|
	this := Line2D through: self start and: self end.
	that := Line2D through: aLineSegment2D start and: aLineSegment2D end.
	^this lineIntersection: that! !

!LineSegment2D methodsFor: 'printing' stamp: 'emm 02/09/2012 22:51'!
printOn: aStream

	aStream 
		print: start
		; nextPutAll: ' to: '
		; print: end! !

!LineSegment2D methodsFor: 'accessing' stamp: 'emm 02/09/2012 22:51'!
setStart: startValue end: endValue

	start := startValue.
	end := endValue! !

!LineSegment2D methodsFor: 'accessing' stamp: 'emm 02/09/2012 22:51'!
start
	^start! !

!LineSegment2D methodsFor: 'accessing' stamp: 'emm 02/09/2012 22:51'!
start: aPoint
	^start := aPoint! !

!LineSegment2D methodsFor: 'accessing' stamp: 'emm 02/09/2012 22:51'!
to

	^self end! !

!LineSegment2D methodsFor: 'accessing' stamp: 'emm 02/09/2012 22:51'!
vertices

	^Array with: start with: end! !

Geometric2D subclass: #Polyline2D
	instanceVariableNames: 'vertices'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Core2D'!

Polyline2D subclass: #Polygon2D
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Core2D'!

!Polygon2D methodsFor: 'dispatching' stamp: 'emm 02/09/2012 22:51'!
kindDo: aRequestor
	^ aRequestor doPolygon2D: self! !

!Polyline2D class methodsFor: 'instance creation' stamp: 'emm 02/09/2012 22:51'!
fromAll: arrayOfPoints

	^self basicNew setVertices: arrayOfPoints! !

!Polyline2D class methodsFor: 'instance creation' stamp: 'emm 02/09/2012 22:51'!
vertices: arrayOfPoints

	^self basicNew setVertices: arrayOfPoints! !

!Polyline2D class methodsFor: 'instance creation' stamp: 'emm 02/09/2012 22:51'!
withAll: arrayOfPoints
	"DEPRECATED"
	
	^self fromAll: arrayOfPoints! !

!Polyline2D methodsFor: 'comparing' stamp: 'emm 02/09/2012 22:51'!
= anObject 
	"Answer whether the receiver and the argument are equal."

	^self class = anObject class and: [vertices = anObject vertices]! !

!Polyline2D methodsFor: 'converting' stamp: 'emm 02/09/2012 22:51'!
asPolygon2D
	"Answer a point array representing myself as a polyline."

	^Polygon2D vertices: self vertices! !

!Polyline2D methodsFor: 'converting' stamp: 'emm 02/09/2012 22:51'!
asPolyline2D
	"Answer a point array representing myself as a polyline."

	^self! !

!Polyline2D methodsFor: 'testing' stamp: 'emm 02/09/2012 22:51'!
canBeFilled
	"Answer whether filling makes sense for this Geometric"

	^true! !

!Polyline2D methodsFor: 'private' stamp: 'emm 02/09/2012 22:51'!
computeBounds
	"Answer the Rectangle that minimally bounds the coordinate region used
	by the receiver, independent of considerations such as line width."

	^self class boundingRectangleForPoints: vertices! !

!Polyline2D methodsFor: 'private' stamp: 'emm 02/09/2012 22:51'!
computeVertexAtFraction: fraction

	"fraction = [ 0..1 ]"! !

!Polyline2D methodsFor: 'comparing' stamp: 'emm 02/09/2012 22:51'!
hash
	^vertices first hash + vertices last hash + vertices size! !

!Polyline2D methodsFor: 'dispatching' stamp: 'emm 02/09/2012 22:51'!
kindDo: aRequestor
	^aRequestor doPolyline2D: self! !

!Polyline2D methodsFor: 'testing' stamp: 'emm 02/09/2012 22:51'!
outlineIntersects: aRectangle
	"Answer whether the receiver's display area intersects aRectangle 
	under stroking."

	"Eliminate the trivial failures"
	(super outlineIntersects: aRectangle)
		ifFalse:	[^false].
	^self class vertices: vertices intersectsRectangle: aRectangle! !

!Polyline2D methodsFor: 'transforming' stamp: 'emm 02/09/2012 22:51'!
scaledBy: amount 
	"Answer a new object scaled by the argument amount, which can be
	a Point or a scalar value."

	| nv |
	nv := vertices collect: [:v | v * amount].
	^self species vertices: nv! !

!Polyline2D methodsFor: 'private' stamp: 'emm 02/09/2012 22:51'!
setVertices: pointArray
	"Initialize the vertices."

	vertices := pointArray asArray! !

!Polyline2D methodsFor: 'accessing' stamp: 'emm 9/23/2012 22:39'!
size
	^self vertices size! !

!Polyline2D methodsFor: 'transforming' stamp: 'emm 02/09/2012 22:51'!
translatedBy: amount 
	"Answer a new object translated by amount, which can be
	a Point or a scalar value."

	| nv |
	nv := vertices collect: [:v | v + amount].
	^self species vertices: nv! !

!Polyline2D methodsFor: 'accessing' stamp: 'emm 02/09/2012 22:51'!
vertices
	"Answer an Array of Points representing the vertices of the Polyline2D."

	^vertices! !

!Polyline2D methodsFor: 'enumerating' stamp: 'emm 02/09/2012 22:51'!
verticesDo: aBlock
	"Evaluate the supplied block for every vertex in the receiver."

	vertices do: aBlock! !

Geometric2D subclass: #VisualText
	instanceVariableNames: 'string origin style'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-FormatSVG'!

!VisualText class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:06'!
new
	^super new initialize! !

!VisualText class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:06'!
on: aText
	^self new text: aText! !

!VisualText methodsFor: 'initialize-release' stamp: 'emm 02/09/2012 23:06'!
initialize
	self text: ''.
	self style: 'font-family:Verdana; font-size:12; fill:black'.
	origin := 0@0! !

!VisualText methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:06'!
kindDo: aRequestor
	^aRequestor doVisualText: self! !

!VisualText methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:06'!
origin
	^origin! !

!VisualText methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:06'!
origin: anObject
	origin := anObject! !

!VisualText methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:06'!
pixelExtent
	
	| in  pt|
	in := self style readStream.
	in skipToAll: 'font-size:'.
	pt := Number fromString: (in upTo: Character space).
	^((string size max: 1) * pt @ pt ) rounded! !

!VisualText methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:06'!
string
	^string! !

!VisualText methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:06'!
string: anObject
	string := anObject! !

!VisualText methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:06'!
style
	^style! !

!VisualText methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:06'!
style: anObject
	style := anObject! !

!VisualText methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:06'!
text
	^string! !

!VisualText methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:06'!
text: aText
	string := aText! !

Object subclass: #Geometric2DWrapper
	instanceVariableNames: 'component'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Core2D'!

!Geometric2DWrapper class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 22:51'!
on: aGeometric
	^self new component: aGeometric! !

!Geometric2DWrapper methodsFor: 'accessing' stamp: 'emm 02/09/2012 22:51'!
component
	^component! !

!Geometric2DWrapper methodsFor: 'accessing' stamp: 'emm 02/09/2012 22:51'!
component: anObject
	component := anObject! !

Geometric2DWrapper subclass: #Translating2DWrapper
	instanceVariableNames: 'translation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-FormatSVG'!

!Translating2DWrapper methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:06'!
kindDo: aRequestor
	^ aRequestor doTranslating2DWrapper: self! !

!Translating2DWrapper methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:06'!
translation
	^translation! !

!Translating2DWrapper methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:06'!
translation: anObject
	translation := anObject! !

Object subclass: #Geometric3D
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'Math3DConstants'
	category: 'Zenna-Primitives3D'!

Geometric3D subclass: #Arrow
	instanceVariableNames: 'start end radius cone isTwoWay'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Shapes3D'!

!Arrow class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:39'!
between: fromPoint3D and: toPoint3D radius: radius

	^(self new)
		start: fromPoint3D
		;end: toPoint3D
		;radius: radius
		;isTwoWay: true! !

!Arrow class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:39'!
from: fromPoint3D to: toPoint3D radius: radius

	^(self new)
		start: fromPoint3D
		;end: toPoint3D
		;radius: radius
		;isTwoWay: false! !

!Arrow methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:39'!
cone

	"Answer the value of cone"

	^cone! !

!Arrow methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:39'!
cone: aValue

	"Set the value of cone"

	cone := aValue! !

!Arrow methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:39'!
end

	"Answer the value of end"

	^end! !

!Arrow methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:39'!
end: aValue

	"Set the value of end"

	end := aValue! !

!Arrow methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:39'!
isTwoWay

	"Answer the value of isTwoWay"

	^isTwoWay! !

!Arrow methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:39'!
isTwoWay: aValue

	"Set the value of isTwoWay"

	isTwoWay := aValue! !

!Arrow methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:39'!
kindDo: aRequestor

	^ aRequestor doSolidComposite: self! !

!Arrow methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:39'!
radius

	"Answer the value of radius"

	^radius! !

!Arrow methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:39'!
radius: aValue

	"Set the value of radius"

	radius := aValue! !

!Arrow methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:39'!
solidsDo: oneArgBlock

	"first test"

	| length composite coneLength |
	length := self end dist: self start.
	coneLength := self radius * 4.
	composite := CompositeGeometric3D new.
	composite add: (Cylinder center: 0,0,0 radius: self radius height: (length - coneLength)).
	composite add: (Cone center: 0,0,(length - coneLength) radius: self radius * 3 height: coneLength).
	composite := composite zAlignWith: self end - self start.
	composite := composite translateBy: self start.
	oneArgBlock value: composite.
! !

!Arrow methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:39'!
start

	"Answer the value of start"

	^start! !

!Arrow methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:39'!
start: aValue

	"Set the value of start"

	start := aValue! !

Geometric3D subclass: #BouncingBall
	instanceVariableNames: 'position velocity color minPosition maxPosition radius'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Shapes3D'!

!BouncingBall class methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:39'!
doVRMLSceneBuilder: aBuilder

	^ aBuilder addElement: self! !

!BouncingBall class methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:39'!
doWRLWriter: aWriter

	| protoName |
	protoName := 'PROTO BouncingBall'.
	( aWriter hasWrittenName: protoName )
		ifTrue: [ ^self ].

	aWriter nextPutAll: self vrmlProtoDefinition.
	aWriter wroteName: protoName
! !

!BouncingBall class methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:39'!
kindDo: aRequestor 

	^aRequestor doCallbackTo: self! !

!BouncingBall class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:39'!
new

	"Answer a new instance of the receiver and initialize it"

	^super new initialize! !

!BouncingBall class methodsFor: 'VRML' stamp: 'emm 02/09/2012 23:39'!
vrmlProtoDefinition

	^'PROTO BouncingBall [
	field SFColor color 1 0 0
	field SFFloat radius 0.5
	field SFVec3f position 0 0 0
	field SFVec3f velocity 0.1 0.1 0.1
	field SFVec3f minPosition 0 0 0
	field SFVec3f maxPosition 10 10 10
	field SFTime tickPeriod 0.01] {
DEF Ball Transform {
	children[
		Shape{
			appearance Appearance{
				material Material {diffuseColor IS color}
			}
			geometry Sphere {radius IS radius}
		}
	]
}
DEF Ticker TimeSensor {
	loop TRUE
	cycleInterval IS tickPeriod }
DEF MoveScript Script{
	eventIn SFTime tick
	field SFVec3f position IS position
	field SFVec3f velocity IS velocity
	field SFVec3f minPosition IS minPosition
	field SFVec3f maxPosition IS maxPosition
	eventOut SFVec3f location
	url "javascript:
function tick (value,timestamp) {
	position = position.add( velocity );
	if ( position.x > maxPosition.x ) {
		position.x = maxPosition.x;
		velocity.x = velocity.x * -1;
	}
	if ( position.x < minPosition.x ) {
		position.x = minPosition.x;
		velocity.x = velocity.x * -1;
	}
	if ( position.y > maxPosition.y ) {
		position.y = maxPosition.y;
		velocity.y = velocity.y * -1;
	}
	if ( position.y < minPosition.y ) {
		position.y = minPosition.y;
		velocity.y = velocity.y * -1;
	}
	if ( position.z > maxPosition.z ) {
		position.z = maxPosition.z;
		velocity.z= velocity.z * -1;
	}
	if ( position.z < minPosition.z ) {
		position.z = minPosition.z;
		velocity.z = velocity.z * -1;
	}
		location = new SFVec3f(position.x,position.y,position.z);
}"
} # end script
ROUTE Ticker.cycleTime TO MoveScript.tick
ROUTE MoveScript.location TO Ball.translation
} # end proto
'! !

!BouncingBall methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:39'!
color

	"Answer the value of color"

	^color! !

!BouncingBall methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:39'!
color: aValue

	"Set the value of color"

	color := aValue! !

!BouncingBall methodsFor: 'initialize-release' stamp: 'emm 02/09/2012 23:39'!
initialize

	self position: 0,0,0.
	self velocity: 0.1,0.1,0.1.
	self color: Color white.
	self minPosition: 0,0,0. 
	self maxPosition: 10,10,10.
	self radius: 0.5! !

!BouncingBall methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:39'!
kindDo: aRequestor

	^( ( GenericSceneElement new className: 'BouncingBall' )
		at: 'color' put: self color
		;at: 'radius' put: self radius
		;at: 'position' put: self position
		;at: 'velocity' put: self velocity
		;at: 'maxPosition' put: self maxPosition
		;at: 'minPosition' put: self minPosition
		;yourself
	) kindDo: aRequestor ! !

!BouncingBall methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:39'!
maxPosition

	"Answer the value of maxPosition"

	^maxPosition! !

!BouncingBall methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:39'!
maxPosition: aValue

	"Set the value of maxPosition"

	maxPosition := aValue! !

!BouncingBall methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:39'!
minPosition

	"Answer the value of minPosition"

	^minPosition! !

!BouncingBall methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:39'!
minPosition: aValue

	"Set the value of minPosition"

	minPosition := aValue! !

!BouncingBall methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:39'!
position

	"Answer the value of position"

	^position! !

!BouncingBall methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:39'!
position: aValue

	"Set the value of position"

	position := aValue! !

!BouncingBall methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:39'!
radius

	"Answer the value of radius"

	^radius! !

!BouncingBall methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:39'!
radius: aValue

	"Set the value of radius"

	radius := aValue! !

!BouncingBall methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:39'!
velocity

	"Answer the value of velocity"

	^velocity! !

!BouncingBall methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:39'!
velocity: aValue

	"Set the value of velocity"

	velocity := aValue! !

Geometric3D subclass: #CSGObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-OperatorsCSG'!

CSGObject subclass: #CSGOperation
	instanceVariableNames: 'components'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-OperatorsCSG'!

CSGOperation subclass: #CSGDifference
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-OperatorsCSG'!

!CSGDifference methodsFor: 'writing' stamp: 'emm 02/09/2012 23:44'!
kindDo: aRequestor

	^aRequestor doCSGDifference: self! !

!CSGDifference methodsFor: 'writing' stamp: 'emm 02/09/2012 23:44'!
solidsDo: aBlock

	| inStream solids next newSolids |
	self components isEmpty
		ifTrue: [ ^self ].
	inStream := self components readStream.
	solids := OrderedCollection with: inStream next.
	[inStream atEnd]
		whileFalse:
			[next := inStream next.
			newSolids := OrderedCollection new.
			solids do:[ :each |
				newSolids addAll: ( each subtract: next )].
			solids := newSolids].
	solids do: aBlock! !

CSGOperation subclass: #CSGIntersection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-OperatorsCSG'!

!CSGIntersection methodsFor: 'writing' stamp: 'emm 02/09/2012 23:44'!
kindDo: aRequestor

	^aRequestor doCSGIntersection: self! !

CSGOperation subclass: #CSGInverse
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-OperatorsCSG'!

CSGOperation subclass: #CSGMerge
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-OperatorsCSG'!

!CSGMerge methodsFor: 'writing' stamp: 'emm 02/09/2012 23:44'!
kindDo: aRequestor

	^aRequestor doCSGMerge: self! !

!CSGOperation class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:44'!
new
	^super new initialize! !

!CSGOperation methodsFor: 'adding-removing' stamp: 'emm 02/09/2012 23:44'!
add: aComponent

	^components add: aComponent! !

!CSGOperation methodsFor: 'adding-removing' stamp: 'emm 02/09/2012 23:44'!
addAll: aCollection
	aCollection do:[ :each | self add: each ]! !

!CSGOperation methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:44'!
components

	^components! !

!CSGOperation methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:44'!
components: aValue

	components := aValue! !

!CSGOperation methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:44'!
do: aBlock separatedBy: otherBlock

	components do: aBlock separatedBy: otherBlock! !

!CSGOperation methodsFor: 'initialize-release' stamp: 'emm 02/09/2012 23:44'!
initialize

	components := OrderedCollection new! !

!CSGOperation methodsFor: 'copying' stamp: 'emm 02/09/2012 23:44'!
postCopy
	"create copies of components too"
	super postCopy.
	components := components collect: #copy! !

!CSGOperation methodsFor: 'adding-removing' stamp: 'emm 02/09/2012 23:44'!
remove: aComponent

	^components remove: aComponent! !

!CSGOperation methodsFor: 'transforming' stamp: 'emm 02/09/2012 23:44'!
rotateBy: aPoint
	components := components collect:[ :each | each rotateBy: aPoint ]! !

!CSGOperation methodsFor: 'transforming' stamp: 'emm 02/09/2012 23:44'!
scaleBy: aPoint
	components := components collect:[ :each | each scaleBy: aPoint ]! !

!CSGOperation methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:44'!
size
	
	^self components size! !

!CSGOperation methodsFor: 'transforming' stamp: 'emm 02/09/2012 23:44'!
translateBy: aPoint
	components := components collect:[ :each | each translateBy: aPoint ]! !

!CSGOperation methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:44'!
with: aCollection do: aBlock

	components with: aCollection do: aBlock! !

CSGOperation subclass: #CSGUnion
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-OperatorsCSG'!

!CSGUnion methodsFor: 'double-dispatching' stamp: 'emm 02/09/2012 23:44'!
kindDo: aRequestor

	^aRequestor doCSGUnion: self! !

CSGObject subclass: #CSGPrimitive
	instanceVariableNames: 'geometric'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-OperatorsCSG'!

!CSGPrimitive methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:44'!
geometric

	^geometric! !

!CSGPrimitive methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:44'!
geometric: aValue

	geometric := aValue! !

Geometric3D subclass: #CompositeGeometric3D
	instanceVariableNames: 'collection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Collections3D'!

!CompositeGeometric3D class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:43'!
new

	^super new initialize! !

!CompositeGeometric3D class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:43'!
new: howMany

	^self on: (OrderedCollection new: howMany)! !

!CompositeGeometric3D class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:43'!
on: aCollection
	^self new components: aCollection! !

!CompositeGeometric3D class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:43'!
with: anObject

	"Answer a new instance of a Collection
	 containing anObject."

	^(self new: 1 )
		add: anObject;
		yourself! !

!CompositeGeometric3D class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:43'!
with: firstObject with: secondObject

	"Answer a new instance of a Collection
	 containing firstObject and secondObject
	 as elements."

	^(self new: 2 )
		add: firstObject;
		add: secondObject;
		yourself! !

!CompositeGeometric3D class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:43'!
with: firstObject with: secondObject with: thirdObject

	"Answer a new instance of a Collection
	 containing the three arguments as elements."

	^(self new: 3 )
		add: firstObject;
		add: secondObject;
		add: thirdObject;
		yourself! !

!CompositeGeometric3D class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:43'!
with: firstObject with: secondObject with: thirdObject with: fourthObject

	"Answer a new instance of a Collection
	 containing the four arguments as the elements."

	^(self new: 4 )
		add: firstObject;
		add: secondObject;
		add: thirdObject;
		add: fourthObject;
		yourself! !

!CompositeGeometric3D class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:43'!
withAll: col
	^self on: col! !

!CompositeGeometric3D methodsFor: 'Collection-API' stamp: 'emm 02/09/2012 23:43'!
add: aGeometric 
	^collection add: aGeometric! !

!CompositeGeometric3D methodsFor: 'Collection-API' stamp: 'emm 02/09/2012 23:43'!
addAll: aCollection 
	^collection addAll: aCollection! !

!CompositeGeometric3D methodsFor: 'converting' stamp: 'emm 02/09/2012 23:43'!
asArray

	| newArray |
	newArray := Array new: self size.
	1 to: self size do:[ :i |
		newArray at: i put: (self at: i) ].
	^newArray! !

!CompositeGeometric3D methodsFor: 'Collection-API' stamp: 'emm 02/09/2012 23:43'!
at: index 
	^collection at: index! !

!CompositeGeometric3D methodsFor: 'Collection-API' stamp: 'emm 02/09/2012 23:43'!
at: index put: value 
	^collection at: index put: value! !

!CompositeGeometric3D methodsFor: 'Collection-API' stamp: 'emm 02/09/2012 23:43'!
collect: aBlock 
	^self class new collection: (collection collect: aBlock)! !

!CompositeGeometric3D methodsFor: 'subclass responsibility' stamp: 'emm 02/09/2012 23:43'!
collectionClass
	^OrderedCollection! !

!CompositeGeometric3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:43'!
components
	^collection! !

!CompositeGeometric3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:43'!
components: aValue 
	collection := aValue! !

!CompositeGeometric3D methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:43'!
decomposedSolidsDo: aBlock

	self do: [:each | 
		each decomposedSolidsDo: aBlock ]! !

!CompositeGeometric3D methodsFor: 'Collection-API' stamp: 'emm 02/09/2012 23:43'!
do: aBlock
	collection do: aBlock! !

!CompositeGeometric3D methodsFor: 'Collection-API' stamp: 'emm 02/09/2012 23:43'!
do: elementBlock separatedBy: separatorBlock 
	self isEmpty
		ifTrue: [ ^self ].
	elementBlock value: ( self at: 1 ).
	2 to: self size do: [:i | 
		separatorBlock value.
		elementBlock value: ( self at: i )]! !

!CompositeGeometric3D methodsFor: 'Collection-API' stamp: 'emm 02/09/2012 23:43'!
doWithIndex: twoArgBlock
	1 to: self size do:[ :i | twoArgBlock value: (self at:i) value: i].! !

!CompositeGeometric3D methodsFor: 'Collection-API' stamp: 'emm 02/09/2012 23:43'!
first
	^self at: 1! !

!CompositeGeometric3D methodsFor: 'initialize-release' stamp: 'emm 02/09/2012 23:43'!
initialize
	collection := self collectionClass new! !

!CompositeGeometric3D methodsFor: 'Collection-API' stamp: 'emm 02/09/2012 23:43'!
isEmpty
	^collection isEmpty! !

!CompositeGeometric3D methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:43'!
kindDo: aRequestor

	^aRequestor doComposite: self! !

!CompositeGeometric3D methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:43'!
leafComponentsDo: aBlock 

	self do: [:each | 
		each leafComponentsDo: aBlock]! !

!CompositeGeometric3D methodsFor: 'transforming' stamp: 'emm 02/09/2012 23:43'!
mirrorInYZ
	collection := collection collect: [:each | each mirrorInYZ]! !

!CompositeGeometric3D methodsFor: 'copying' stamp: 'emm 02/09/2012 23:43'!
postCopy
	super postCopy.
	collection := collection collect: [:each | each copy]! !

!CompositeGeometric3D methodsFor: 'printing' stamp: 'emm 02/09/2012 23:43'!
printOn: aStream indent: level

	aStream nextPutAll: self class name ;nextPutAll: ' new'.
	aStream space ;nextPut:$" ;print: self components size ;nextPut: $".
	self components 
		do:[ :each |
			aStream crtab: level + 1; nextPutAll: 'add: ('.
			each printOn: aStream indent: level + 1.
			aStream nextPut: $) ]
		separatedBy:[ aStream nextPut: $; ].! !

!CompositeGeometric3D methodsFor: '*Zenna-FormatVRML' stamp: 'emm 02/09/2012 23:54'!
range: ignore
	"For LODs"! !

!CompositeGeometric3D methodsFor: 'converting' stamp: 'emm 02/09/2012 23:43'!
readStream

	^ReadStream on: self! !

!CompositeGeometric3D methodsFor: 'transforming' stamp: 'emm 02/09/2012 23:43'!
reverseOriented
	collection := collection collect: [:each | each reverseOriented]! !

!CompositeGeometric3D methodsFor: 'transforming' stamp: 'emm 02/09/2012 23:43'!
rotateBy: aPoint3D 
	collection := collection collect: [:each | each rotateBy: aPoint3D]! !

!CompositeGeometric3D methodsFor: 'transforming' stamp: 'emm 02/09/2012 23:43'!
scaleBy: aPoint3D 
	collection := collection collect: [:each | each scaleBy: aPoint3D]! !

!CompositeGeometric3D methodsFor: 'Collection-API' stamp: 'emm 02/09/2012 23:43'!
size
	^collection size! !

!CompositeGeometric3D methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:43'!
solidsDo: aBlock 

	self components do: aBlock! !

!CompositeGeometric3D methodsFor: 'transforming' stamp: 'emm 02/09/2012 23:43'!
translateBy: aPoint3D 
	collection := collection collect: [:each | each translateBy: aPoint3D]! !

!CompositeGeometric3D methodsFor: 'strange-api' stamp: 'emm 02/09/2012 23:43'!
translation: aPoint3D
	"for transforms"

	^self translateBy: aPoint3D! !

!CompositeGeometric3D methodsFor: 'converting' stamp: 'emm 02/09/2012 23:43'!
writeStream

	^WriteStream on: self! !

CompositeGeometric3D subclass: #FaceComposite
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Collections3D'!

!FaceComposite methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:43'!
facesDo: aBlock

	^collection do: aBlock! !

!FaceComposite methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:43'!
kindDo: aRequestor

	^ aRequestor doFaceComposite: self! !

FaceComposite subclass: #Triangle3DComposite
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Collections3D'!

!Triangle3DComposite methodsFor: 'Collection-API' stamp: 'emm 02/09/2012 23:43'!
add: aTriangle 

	collection
		add: aTriangle point1
		add: aTriangle point2
		add: aTriangle point3.
	^aTriangle! !

!Triangle3DComposite methodsFor: 'adding-removing' stamp: 'emm 02/09/2012 23:43'!
addTriangleWith: aPoint1 with: aPoint2 with: aPoint3 

	"Do not answer the point added"

	collection
		add: aPoint1
		add: aPoint2
		add: aPoint3! !

!Triangle3DComposite methodsFor: 'Collection-API' stamp: 'emm 02/09/2012 23:43'!
at: anIndex 

	| offset |
	offset := anIndex - 1 * 3 + 1.
	^Triangle3D
		with: (collection at: offset)
		with: (collection at: offset + 1)
		with: (collection at: offset + 2)! !

!Triangle3DComposite methodsFor: 'Collection-API' stamp: 'emm 02/09/2012 23:43'!
collect: oneArgBlock

	| result |
	result := OrderedCollection new.
	self do:[ :each | result add: (oneArgBlock value: each)].
	^result! !

!Triangle3DComposite methodsFor: 'private' stamp: 'emm 02/09/2012 23:43'!
collectionClass
	^OrderedPoint3DCollection! !

!Triangle3DComposite methodsFor: 'Collection-API' stamp: 'emm 02/09/2012 23:43'!
do: aBlock 

	| inStream |
	inStream := collection readStream.
	[inStream atEnd]
		whileFalse: [aBlock value: (Triangle3D
					with: inStream next
					with: inStream next
					with: inStream next)]! !

!Triangle3DComposite methodsFor: 'converting' stamp: 'emm 02/09/2012 23:43'!
faces
	^self! !

!Triangle3DComposite methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:43'!
facesDo: aBlock
	self do: aBlock! !

!Triangle3DComposite methodsFor: 'private' stamp: 'emm 02/09/2012 23:43'!
growToAtLeast: newSize 

	collection growToAtLeast: newSize * 3! !

!Triangle3DComposite methodsFor: 'initialize-release' stamp: 'emm 02/09/2012 23:43'!
initialize

	collection := OrderedPoint3DCollection new: 3! !

!Triangle3DComposite methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:43'!
kindDo: aRequestor

	^aRequestor doTriangle3DCollection: self! !

!Triangle3DComposite methodsFor: 'printing' stamp: 'emm 02/09/2012 23:43'!
printOn: aStream indent: level

	self printClassCreationOn: aStream indent: level.
	aStream
		 nextPut: $"
		; print: self size
		; nextPut: $"
		; cr ;tab.
	self do: [:each | aStream
			 nextPutAll: 'add: ('
			; print: each
			; nextPutAll: ')']
		separatedBy: [aStream crtab; nextPutAll: '; '].
	aStream cr ;tab; nextPutAll: '; yourself )'! !

!Triangle3DComposite methodsFor: 'transforming' stamp: 'emm 02/09/2012 23:43'!
reverseVertexOrder

	"1,2,3 -> 1,3,2"

	2 to: collection size by: 3 do:[ :index |
		collection swap: index with: index + 1 ]! !

!Triangle3DComposite methodsFor: 'transforming' stamp: 'emm 02/09/2012 23:43'!
scaleBy: factor 
	"Scale the receiver by factor (an instance of Point3D or scalar)."
	
	collection scaleBy: factor ! !

!Triangle3DComposite methodsFor: 'Collection-API' stamp: 'emm 02/09/2012 23:43'!
size

	^collection size / 3! !

!Triangle3DComposite methodsFor: 'transforming' stamp: 'emm 02/09/2012 23:43'!
translateBy: aPoint 
	"Translate the receiver by @aPoint"
	
	collection translateBy: aPoint ! !

!Triangle3DComposite methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:43'!
trianglesDo: aBlock
	self do: aBlock! !

!Triangle3DComposite methodsFor: '*Zenna-Operators3D' stamp: 'emm 02/09/2012 23:46'!
uniqueVerticesDo: aBlock

	| filter |
	filter := SingleOccurrencePoint3DFilter on: (AdditionToEvaluationAdaptor on: aBlock).
	self components verticesDo: filter! !

!Triangle3DComposite methodsFor: 'converting' stamp: 'emm 02/09/2012 23:43'!
vertices

	|vertices|
	vertices := Set new.
	self do:[ :each |
		each verticesDo: [ :other | vertices add: other ]].
	^vertices! !

CompositeGeometric3D subclass: #Group3D
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Collections3D'!

CompositeGeometric3D subclass: #LineSegment3DComposite
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Collections3D'!

!LineSegment3DComposite methodsFor: 'adding-removing' stamp: 'emm 02/09/2012 23:43'!
add: anEdge 

	collection add: anEdge start add: anEdge end! !

!LineSegment3DComposite methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:43'!
at: anIndex 

	| offset |
	offset := anIndex - 1 * 2 + 1.
	^LineSegment3D with: (collection at: offset)
		with: (collection at: offset + 1)! !

!LineSegment3DComposite methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:43'!
at: anIndex put: aPoint3D 

	| offset |
	offset := anIndex - 1 * 2 + 1.
	collection at: offset put: aPoint3D! !

!LineSegment3DComposite methodsFor: 'private' stamp: 'emm 02/09/2012 23:43'!
collectionClass
	^OrderedPoint3DCollection! !

!LineSegment3DComposite methodsFor: 'computing' stamp: 'emm 02/09/2012 23:43'!
computeVertexAtFraction: fraction

	"fraction [0..1]"
	
	self error! !

!LineSegment3DComposite methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:43'!
do: aBlock 

	1 to: collection size by: 2 do: [:index | 
		aBlock value: (LineSegment3D with: (collection at: index)
				with: (collection at: index + 1))]! !

!LineSegment3DComposite methodsFor: 'private' stamp: 'emm 02/09/2012 23:43'!
growToAtLeast: newSize 

	collection growToAtLeast: newSize * 2! !

!LineSegment3DComposite methodsFor: 'printing' stamp: 'emm 02/09/2012 23:43'!
printOn: aStream 

	aStream
		 nextPutAll: '((LineSegment3DCollection new) "'
		; print: self size
		; nextPut: $"
		; crtab.
	self do: [:each | aStream
			 nextPutAll: 'add: ('
			; print: each
			; nextPutAll: ')']
		separatedBy: [aStream crtab; nextPutAll: '; '].
	aStream crtab; nextPutAll: '; yourself )'! !

!LineSegment3DComposite methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:43'!
segmentsDo: aBlock
	self do: aBlock! !

!LineSegment3DComposite methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:43'!
size

	^collection size / 2! !

!LineSegment3DComposite methodsFor: '*Zenna-Operators3D' stamp: 'emm 02/09/2012 23:46'!
uniqueVerticesDo: aBlock

	| filter |
	filter := SingleOccurrencePoint3DFilter on: (AdditionToEvaluationAdaptor on: aBlock).
	self collection verticesDo: filter! !

Geometric3D subclass: #ComputedSolid
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Modelling3D'!

!ComputedSolid class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:50'!
base: aPolygon

	^self new base: aPolygon! !

!ComputedSolid methodsFor: 'testing' stamp: 'emm 02/09/2012 23:50'!
isComposed

	^true! !

!ComputedSolid methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:50'!
solidsDo: aBlock 

	^aBlock value: self! !

ComputedSolid subclass: #ExtrudedPolygon
	instanceVariableNames: 'base'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Modelling3D'!

ExtrudedPolygon subclass: #BeveledPolygon
	instanceVariableNames: 'rotationInterval'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Modelling3D'!

!BeveledPolygon class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:50'!
base: aPolygon interval: vectorInterval

	^(self base: aPolygon)
		rotationInterval: vectorInterval! !

!BeveledPolygon class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:50'!
base: aPolygon rotation: rotationVector rotationCount: rotationCount 

	^(self base: aPolygon)
		rotationInterval: (Point3D zero to: rotationVector * rotationCount by: rotationVector)! !

!BeveledPolygon methodsFor: 'computing' stamp: 'emm 02/09/2012 23:50'!
estimatedSolidsSize
	"Answer the computed number of solids"

	^self base size * self rotationCount! !

!BeveledPolygon methodsFor: 'computing' stamp: 'emm 02/09/2012 23:50'!
facesDo: aBlock

	| rotationMatrix top bottom isClosed |
	rotationMatrix := Matrix3x3 rotation: self rotationInterval increment.
	top := self base.
	isClosed := (self rotationInterval start - self rotationInterval stop) r = TwoPi.
	self rotationCount timesRepeat: [
		bottom := (rotationMatrix * top) reverseOriented.
		Helper3D
			facesForSolidBetween: top 
			and: bottom do: aBlock.
		top := bottom reverseOriented].
	isClosed
		ifFalse: 
			[ aBlock value: self base.
			aBlock value: bottom]! !

!BeveledPolygon methodsFor: 'computing' stamp: 'emm 02/09/2012 23:50'!
rotationCount

	^self rotationInterval size! !

!BeveledPolygon methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:50'!
rotationInterval

	^rotationInterval! !

!BeveledPolygon methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:50'!
rotationInterval: aValue

	rotationInterval := aValue! !

!ExtrudedPolygon class methodsFor: 'obsolete' stamp: 'emm 02/09/2012 23:50'!
base: topPolygon translation: aPoint

	^SimpleExtrudedPolygon new
		base: topPolygon 
		; translation: aPoint! !

!ExtrudedPolygon class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:50'!
between: topPolygon and: bottomPolygon
	
	^TwoFacedExtrudedPolygon between:topPolygon and: bottomPolygon! !

!ExtrudedPolygon class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:50'!
top: topPolygon translation: aPoint

	^SimpleExtrudedPolygon new
		top: topPolygon 
		; translation: aPoint! !

!ExtrudedPolygon methodsFor: 'obsolete' stamp: 'emm 02/09/2012 23:50'!
base
	
	^base! !

!ExtrudedPolygon methodsFor: 'obsolete' stamp: 'emm 02/09/2012 23:50'!
base: aPolygon
	
	base := aPolygon! !

!ExtrudedPolygon methodsFor: 'computing' stamp: 'emm 02/09/2012 23:50'!
estimatedSolidsSize
	"Answer the computed number of solids"

	^1! !

!ExtrudedPolygon methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:50'!
kindDo: aRequestor

	^aRequestor doFaceComposite: self! !

!ExtrudedPolygon methodsFor: 'copying' stamp: 'emm 02/09/2012 23:50'!
postCopy

	super postCopy.
	self top: self top copy! !

!ExtrudedPolygon methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:50'!
top

	^self base! !

!ExtrudedPolygon methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:50'!
top: aPolygon

	"The normal of @aPolygon points to negative z"

	^self base: aPolygon! !

!ExtrudedPolygon methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:50'!
verticesDo: aBlock 

	self facesDo:[ :each |
		each verticesDo: aBlock ]! !

ExtrudedPolygon subclass: #SimpleExtrudedPolygon
	instanceVariableNames: 'translation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Modelling3D'!

!SimpleExtrudedPolygon methodsFor: 'computing' stamp: 'emm 02/09/2012 23:50'!
bottom

	^base reverseOriented translateBy: self translation! !

!SimpleExtrudedPolygon methodsFor: 'computing' stamp: 'emm 02/09/2012 23:50'!
bounds

	^self base bounds merge: (self base translatedBy: self translation) bounds! !

!SimpleExtrudedPolygon methodsFor: 'computing' stamp: 'emm 02/09/2012 23:50'!
facesDo: aBlock

	aBlock value: self top.
	aBlock value: self bottom.
	Helper3D 
		simpleFacesForSolidBetween: self top 
		and: self bottom
		do: aBlock! !

!SimpleExtrudedPolygon methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:50'!
kindDo: aRequestor

	^aRequestor doSimpleExtrudedPolygon: self! !

!SimpleExtrudedPolygon methodsFor: 'copying' stamp: 'emm 02/09/2012 23:50'!
postCopy

	super postCopy.
	translation := translation copy! !

!SimpleExtrudedPolygon methodsFor: 'computing' stamp: 'emm 02/09/2012 23:50'!
productFromMatrix3x3: aMatrix3x3
	"must be tested"

	| clone |
	clone := self shallowCopy.
	clone base: (self base productFromMatrix3x3: aMatrix3x3).
	clone translation: (self translation productFromMatrix3x3: aMatrix3x3).
	^clone! !

!SimpleExtrudedPolygon methodsFor: 'transforming' stamp: 'emm 02/09/2012 23:50'!
rotateBy: aPoint

	| matrix |
	matrix := Matrix3x3 rotation: aPoint.
	base := matrix  * base asPolygon3D.! !

!SimpleExtrudedPolygon methodsFor: 'transforming' stamp: 'emm 02/09/2012 23:50'!
scaleBy: aPoint 

	base scaleBy: aPoint.
	translation scaleBy: aPoint! !

!SimpleExtrudedPolygon methodsFor: 'transforming' stamp: 'emm 02/09/2012 23:50'!
translateBy: aPoint 

	base translateBy: aPoint.! !

!SimpleExtrudedPolygon methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:50'!
translation

	^translation! !

!SimpleExtrudedPolygon methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:50'!
translation: aValue

	translation := aValue! !

ExtrudedPolygon subclass: #TransformedExtrudedPolygon
	instanceVariableNames: 'translation rotation scale'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Modelling3D'!

!TransformedExtrudedPolygon class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:50'!
new
	^super new initialize! !

!TransformedExtrudedPolygon methodsFor: 'initialize-release' stamp: 'emm 02/09/2012 23:50'!
facesDo: aBlock 
	
	| otherBase |
	self rotation isZero 
		ifTrue: 
			[ otherBase := ( ( self base scaledBy: self scale ) translatedBy: self translation ).
			^Helper3D
				simpleFacesForSolidBetween: self base 
				and: otherBase reverseOriented 
				do: aBlock ].
	otherBase := ( ( ( self base scaledBy: self scale ) rotatedBy: self rotation ) translatedBy: self translation ).
	Helper3D
		facesForTwistedSolidBetween: self base 
		and: otherBase reverseOriented 
		do: aBlock! !

!TransformedExtrudedPolygon methodsFor: 'initialize-release' stamp: 'emm 02/09/2012 23:50'!
initialize

	self translation: Point3D zero.
	self scale: Point3D unity.
	self rotation: Point3D zero! !

!TransformedExtrudedPolygon methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:50'!
rotation

	"Answer the value of rotation"

	^rotation! !

!TransformedExtrudedPolygon methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:50'!
rotation: aValue

	"Set the value of rotation"

	rotation := aValue! !

!TransformedExtrudedPolygon methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:50'!
scale

	"Answer the value of scale"

	^scale! !

!TransformedExtrudedPolygon methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:50'!
scale: aValue

	"Set the value of scale"

	scale := aValue! !

!TransformedExtrudedPolygon methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:50'!
translation

	"Answer the value of translation"

	^translation! !

!TransformedExtrudedPolygon methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:50'!
translation: aValue

	"Set the value of translation"

	translation := aValue! !

ExtrudedPolygon subclass: #TwoFacedExtrudedPolygon
	instanceVariableNames: 'otherBase'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Modelling3D'!

!TwoFacedExtrudedPolygon class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:50'!
between: basePolygon and: otherPolygon
	
	basePolygon size ~= otherPolygon size
		ifTrue: [self error: 'incompatible sizes of polygons'].
	^(self base: basePolygon) otherBase: otherPolygon! !

!TwoFacedExtrudedPolygon methodsFor: 'computing' stamp: 'emm 02/09/2012 23:50'!
facesDo: aBlock
	
	aBlock value: base.
	aBlock value: otherBase.
	Helper3D facesForSolidBetween: base and: otherBase do: aBlock! !

!TwoFacedExtrudedPolygon methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:50'!
otherBase

	^otherBase! !

!TwoFacedExtrudedPolygon methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:50'!
otherBase: aValue

	otherBase := aValue! !

!TwoFacedExtrudedPolygon methodsFor: 'printing' stamp: 'emm 02/09/2012 23:50'!
printOn: aStream indent: level

	super printOn: aStream indent: level.
	aStream
		crtab: level + 1
		; nextPutAll: 'otherBase: ('.
	self otherBase printOn: aStream indent: level + 1.
	aStream nextPut: $)! !

!TwoFacedExtrudedPolygon methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:50'!
top: topFace bottom: bottomFace

	base := topFace.
	otherBase := bottomFace.! !

ComputedSolid subclass: #Extrusion
	instanceVariableNames: 'intersectionPolygons translation rotation scale'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Modelling3D'!

!Extrusion class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:50'!
new
	^super new initialize! !

!Extrusion methodsFor: 'adding' stamp: 'emm 02/09/2012 23:50'!
addIntersection: aPolygon

	^intersectionPolygons add: aPolygon! !

!Extrusion methodsFor: 'initialize-release' stamp: 'emm 02/09/2012 23:50'!
initialize
	
	self intersectionPolygons: OrderedCollection new.
	self translation: 0@0@0.
	self scale: 1@1@1.
	self rotation: 0@0@0! !

!Extrusion methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:50'!
intersectionPolygons

	"Answer the value of intersectionPolygons"

	^intersectionPolygons! !

!Extrusion methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:50'!
intersectionPolygons: aValue

	"Set the value of intersectionPolygons"

	intersectionPolygons := aValue! !

!Extrusion methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:50'!
rotation

	"Answer the value of rotation"

	^rotation! !

!Extrusion methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:50'!
rotation: aValue

	"Set the value of rotation"

	rotation := aValue! !

!Extrusion methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:50'!
scale

	"Answer the value of scale"

	^scale! !

!Extrusion methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:50'!
scale: aValue

	"Set the value of scale"

	scale := aValue! !

!Extrusion methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:50'!
solidsDo: aBlock

	|  poly |
	self intersectionPolygons do:[ :eachPoly |
		poly := TransformedExtrudedPolygon new.
		poly 
			base: eachPoly
			; translation: self translation
			; rotation: self rotation
			; scale: self scale.
		aBlock value: poly ]! !

!Extrusion methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:50'!
translation

	"Answer the value of translation"

	^translation! !

!Extrusion methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:50'!
translation: aValue

	"Set the value of translation"

	translation := aValue! !

Geometric3D subclass: #Curve3D
	instanceVariableNames: 'parameterToPointBlock expression'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Primitives3D'!

!Curve3D class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:34'!
expression: aString

	^( self new ) expression: aString! !

!Curve3D class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:34'!
lissajousRadius: radius innerRadius: innerRadius phase: phase period: period at: center 

	"self lissajoussRadius: 10 innerRadius: 1 phase: 0 rad period: 2 at: 0,0,0" 
	
	| curve |
	curve := Curve3D new.
	curve parameterToPointBlock: [ :angle |  | r r2 p1 p2|
		r := (angle * period ) sin * radius.
		p1 := Point3D 
			x: ( angle cos * r ) 
			y: ( angle sin * r ) 
			z: 0.
		p2 := Point3D
			x: ( angle / period + phase ) cos * innerRadius
			y: ( angle / period + phase ) sin * innerRadius
			z: 0.
		p1 + p2 + center ].
	^curve! !

!Curve3D class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:34'!
sineSuperposedOn: aLine3D 
	phase: phaseNumber 
	amplitude: amplitudePoint 
	period: periodNumber

	"self sineSuperposedOn: (0,0,0 to: 1,0,0) phase: 0 amplitude: 0,0,1 period: 1"

	| curve |
	curve := self new.
	curve parameterToPointBlock: [ :angle |  ( angle * periodNumber + phaseNumber ) sin * amplitudePoint ].
	curve expression: '[ :angle |  ( angle * ' , 
		periodNumber printString , 
		' + ' , 
		phaseNumber printString ,
		' ) sin * ( ' ,
		amplitudePoint printString ,
		' ) ]'  .
	^curve! !

!Curve3D methodsFor: 'private' stamp: 'emm 9/23/2012 00:14'!
compileParameterToPointBlock

	self parameterToPointBlock: ( Compiler evaluate: self expression )! !

!Curve3D methodsFor: 'computing' stamp: 'emm 02/09/2012 23:34'!
computeVertexAt: param 

	^parameterToPointBlock value: param! !

!Curve3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:34'!
expression

	^expression! !

!Curve3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:34'!
expression: aValue 

	expression := aValue asString.
	self compileParameterToPointBlock! !

!Curve3D methodsFor: 'initialize-release' stamp: 'emm 02/09/2012 23:34'!
initialize

	expression := '[ :angle | 
	angle cos @ angle sin @  1
]'.
	parameterToPointBlock := [ :angle | angle cos @ angle sin @ 1 ].! !

!Curve3D methodsFor: '*Zenna-Operators3D' stamp: 'emm 02/09/2012 23:47'!
interpolatedWithAll: parameters

	self echo: 'DEPRECATED:Curve3D>>interpolatedWithAll:'.
	^self interpolatorUsingAll: parameters! !

!Curve3D methodsFor: '*Zenna-Operators3D' stamp: 'emm 02/09/2012 23:47'!
interpolatorUsingAll: parameters

	^(CollectionBasedInterpolator new geometric: self)
		collection: parameters! !

!Curve3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:34'!
parameterToPointBlock

	^parameterToPointBlock! !

!Curve3D methodsFor: 'private' stamp: 'emm 02/09/2012 23:34'!
parameterToPointBlock: aValue

	parameterToPointBlock := aValue! !

Geometric3D subclass: #Domino
	instanceVariableNames: 'bottomCenter sizePoint heads tails toppleAngle yawAngle color texture'
	classVariableNames: 'DefaultColorName PrototypeBox'
	poolDictionaries: ''
	category: 'Zenna-Dominos'!

!Domino class methodsFor: 'properties' stamp: 'emm 03/09/2012 20:19'!
defaultColorName: aSymbol

	^DefaultColorName := aSymbol! !

!Domino class methodsFor: 'instance-creation' stamp: 'emm 03/09/2012 20:19'!
new

	"Answer a new instance of the receiver and initialize it"

	^super new initialize! !

!Domino methodsFor: 'adding-removing' stamp: 'emm 03/09/2012 20:19'!
addHead: aDomino

	heads isNil
		ifTrue:[ heads := OrderedCollection new ].
	(heads includes: aDomino)
		ifFalse:
			[ heads add: aDomino.
			aDomino addTail: self ].
	^aDomino! !

!Domino methodsFor: 'adding-removing' stamp: 'emm 03/09/2012 20:19'!
addTail: aDomino 
	
	tails isNil 
		ifTrue:[ tails := OrderedCollection new ].
	( tails includes: aDomino ) 
		ifFalse:
			[ tails add: aDomino.
			aDomino addHead: self ].
	^ aDomino! !

!Domino methodsFor: 'dispatching' stamp: 'emm 03/09/2012 20:19'!
addTo: aBuilder

	| stone |
	stone := self buildStone.
	texture isNil
		ifTrue: [ aBuilder color: self color ]
		ifFalse: [ aBuilder texture: self texture ].
	^aBuilder add: stone! !

!Domino methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
bottomCenter

	"Answer the value of bottomCenter"

	^bottomCenter! !

!Domino methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
bottomCenter: aValue

	"Set the value of bottomCenter"

	bottomCenter := aValue! !

!Domino methodsFor: 'accessing-computed' stamp: 'emm 03/09/2012 20:19'!
bounds

	| origin corner |
	origin := self bottomCenter - (self sizePoint y / 2 asPoint , 0).
	corner := self bottomCenter + (self sizePoint y / 2 asPoint , self sizePoint z).
	^origin corner: corner! !

!Domino methodsFor: 'VRML' stamp: 'emm 03/09/2012 20:19'!
buildElementWith: aBuilder

	| cube element nameStream textureRandom |
	cube := self newBox.
	nameStream := WriteStream on: (String new: 16).
	nameStream nextPut: $D.
	texture isNil
		ifTrue: 
			[ aBuilder color: color.
			element := aBuilder newElementFrom: cube.
			nameStream nextPutAll: self color name]
		ifFalse: 
			[ | ttf |
			ttf := aBuilder newTextureTransform.
			ttf scale: (10.0/4)@1.
			ttf rotation: 90 rad.
			aBuilder beginGroup.
				aBuilder color: color.
				aBuilder add: cube left ;add: cube right ;add: cube top; add: cube bottom.
				aBuilder texture: texture.
				aBuilder appearance textureTransform:ttf.
				aBuilder add: cube front ;add: cube back.
			element := aBuilder endGroup.
			nameStream nextPutAll: ((texture copyFrom: 1 to: (texture indexOf: $.)-1) copyReplaceAll: '/' with: '_')].
	self sizePoint x rounded printOn: nameStream.
	nameStream nextPut: $_.
	self sizePoint y rounded printOn: nameStream.
	nameStream nextPut: $_.
	self sizePoint z rounded printOn: nameStream.
	element name: nameStream contents.

	element := aBuilder newTransformOn: element. "for rotation"
	element := (aBuilder newTransformOn: element) translation: (self sizePoint x/2),0,0.
	self yawAngle = 0
		ifFalse: [ element := (aBuilder newTransformOn: element) rotation: (aBuilder orientationFromPoint: 0,0,self yawAngle) ].
	element := "(aBuilder newTransformOn: "element translateBy: self bottomCenter.
	^element
	
	
	
	
	! !

!Domino methodsFor: 'dispatching' stamp: 'emm 03/09/2012 20:19'!
buildStone

	| cube |
	cube := self newBox.
	cube := cube wrapRotateBy: 0,self toppleAngle,0.
	cube := cube wrapTranslateBy: (self sizePoint x/2),0,0.
	cube := cube wrapRotateBy: 0,0,self yawAngle.
	cube := cube wrapTranslateBy: self bottomCenter.
	^ cube! !

!Domino methodsFor: 'testing' stamp: 'emm 03/09/2012 20:19'!
canBeTextureWrapped

	^false! !

!Domino methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
color

	"Answer the value of color"

	^color! !

!Domino methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
color: aValue

	"Set the value of color"

	color := aValue! !

!Domino methodsFor: 'computing' stamp: 'emm 03/09/2012 20:19'!
distanceToNonTopplingHead: aDomino

	^ aDomino nonTopplingDistanceFromTail: self! !

!Domino methodsFor: 'computing' stamp: 'emm 03/09/2012 20:19'!
distanceToTopplingHead: aDomino

	"Answer the distance between the rotation point
	of the receiver and the rotation point of @aDomino"

	^aDomino topplingDistanceFromTail: self! !

!Domino methodsFor: 'computing' stamp: 'emm 03/09/2012 20:19'!
frontsAfterTopplingBy: angleIncrement

	"Make the receiver topple more by @angleIncrement.
	If the receiver's topple angle is greater than the angle
	at which it hits the next domino then answer that domino"

	"am I flat?"
	| newToppleAngle maxToppleAngle |
	self toppleAngle = HalfPi
		ifTrue:[ ^#() "no fronts anymore" ].
	newToppleAngle := self toppleAngle + angleIncrement.

	"am I going to be flat?"
	newToppleAngle > (maxToppleAngle := self maximumAngle)
		ifTrue:
			[ self toppleAngle: maxToppleAngle.
			^ #() "no fronts anymore" ].

	"process toppling"
	self toppleAngle: newToppleAngle.
	self toppleAngle <= self hitAngleAgainstClosestHead
		ifTrue:
			[ self propagateChangeToTails.
			^ Set with: self	 ]
		ifFalse:
			[ | newFronts |
			newFronts := self propagateChangeToHeads.
			self propagateChangeToTails.
			^ newFronts]



! !

!Domino methodsFor: 'computing' stamp: 'emm 03/09/2012 20:19'!
frontsAfterUpdatingAngleForChangedTail: aDomino 

	"One of my dominos on my tail, @aDomino, has changed its topple angle.
	Recompute my topple angle accordingly. Answer which domino will be on front"

	| newToppleAngle newFronts |
	newToppleAngle := self hitAngleAgainstTail: aDomino.
	newToppleAngle < self toppleAngle
		ifTrue:[ ^Set with: aDomino ].
	newToppleAngle = self toppleAngle
		ifTrue:[ ^Set with: self ].		
	self toppleAngle: newToppleAngle.
	self toppleAngle <= self hitAngleAgainstClosestHead
		ifTrue: [ ^Set with: self ]
		ifFalse:
			[ newFronts := self propagateChangeToHeads.
			^ newFronts isEmpty
				ifTrue: [ Set with: self ]
				ifFalse: [ newFronts ]]
	! !

!Domino methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
heads

	"Answer the value of heads"

	^heads ifNil:[ #() ]! !

!Domino methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
heads: aValue

	"Set the value of heads"

	heads := aValue! !

!Domino methodsFor: 'accessing-computed' stamp: 'emm 03/09/2012 20:19'!
height

	^self sizePoint z! !

!Domino methodsFor: 'computing' stamp: 'emm 03/09/2012 20:19'!
hitAngleAgainstClosestHead

	"Answer the smallest topple for the receiver to hit one of the receiver's heads"

	^self heads inject: HalfPi into:[ :minAngle :each |
		minAngle min: ( self hitAngleAgainstHead: each )]! !

!Domino methodsFor: 'computing' stamp: 'emm 03/09/2012 20:19'!
hitAngleAgainstHead: aDomino

	"Answer the topple angle for the receiver when hitting head @aDomino"

	| cosTerm beta h l g  sinTerm rhs phi kappa newToppleAngle |
	aDomino toppleAngle = 0
		ifTrue:[ ^ aDomino minimumAngleFromTail: self ].
	l := self length.
	g := (self distanceToTopplingHead: aDomino)  - ( l / aDomino toppleAngleForHead cos ).
	h := aDomino tailToHeadHeight.
	beta := HalfPi + aDomino toppleAngleForHead.
	cosTerm := beta sin * h.
	sinTerm := beta cos  * h negated.
	rhs := beta sin * g.
	phi := (sinTerm / cosTerm ) arcTan.
	kappa := (rhs / (( cosTerm * cosTerm + (sinTerm * sinTerm)) sqrt)) arcCos.
	^HalfPi - kappa + phi! !

!Domino methodsFor: 'computing' stamp: 'emm 03/09/2012 20:19'!
hitAngleAgainstTail: aDomino

	"Answer the topple angle for the receiver when hitting tail @aDomino"

	| d h l alpha c e a beta phi |
	d := aDomino distanceToTopplingHead: self.
	h := aDomino tailToHeadHeight.
	l := self length.
	alpha := HalfPi - aDomino toppleAngleForTail.
	c := alpha sin * h.
	e := alpha cos * h - d.
	a := (e*e + (c*c)) sqrt.
	beta := (l / a) arcSin.
	 phi := (c / a) arcSin.
	^ e < 0
		ifTrue:[ phi - HalfPi + beta]
		ifFalse:[ HalfPi - phi + beta ]
	! !

!Domino methodsFor: 'initialize-release' stamp: 'emm 03/09/2012 20:19'!
initialize

	self bottomCenter: 0,0,0.
	self sizePoint: 1,4,10.
	self toppleAngle: 0.	
	self yawAngle: 0.
	self color: (DefaultColorName isNil ifTrue: [ Color green ] ifFalse: [ Color perform: DefaultColorName ] ).! !

!Domino methodsFor: 'inspecting' stamp: 'emm 03/09/2012 20:19'!
inspectActions

	^#()! !

!Domino methodsFor: 'accessing-computed' stamp: 'emm 03/09/2012 20:19'!
length

	^self sizePoint x! !

!Domino methodsFor: 'computing' stamp: 'emm 03/09/2012 20:19'!
maximumAngle

	^self heads inject: HalfPi into:[ :maxAngle :each |
		maxAngle min: ( self maximumAngleToHead: each ) ]! !

!Domino methodsFor: 'computing' stamp: 'emm 03/09/2012 20:19'!
maximumAngleFromTail: aDomino

	"Answer the maximum angle at which @aDomino can
	be rotated when toppling against the receiver"

	^ HalfPi - ( self length / (aDomino distanceToTopplingHead: self) ) arcSin

! !

!Domino methodsFor: 'computing' stamp: 'emm 03/09/2012 20:19'!
maximumAngleToHead: aDomino

	"Answer the maximum angle at which the receiver can
	be rotated when toppling against @aDomino"

	^aDomino maximumAngleFromTail: self

! !

!Domino methodsFor: 'computing' stamp: 'emm 03/09/2012 20:19'!
minimumAngleFromTail: aDomino

	"Answer minimum angle at which @aDomino must
	be rotated in order to make the receiver topple"

	"Two cases: @aDomino hits me below my top (1) or the other way around (2)"

	| nth minAngle1 minAngle2 |
	nth := aDomino distanceToNonTopplingHead: self.
	minAngle1 := HalfPi - ( nth / aDomino tailToHeadHeight ) arcCos.
	minAngle2 := HalfPi - ( self tailToHeadHeight / nth ) arcTan.

	^ self toppleAngle = 0
		ifTrue:[ minAngle1 max: minAngle2 ]
		ifFalse:[  ]! !

!Domino methodsFor: 'computing' stamp: 'emm 03/09/2012 20:19'!
minimumAngleToHead: aDomino

	"Answer minimum angle at which the receiver must
	be rotated in order to make @aDomino topple"

	^aDomino minimumAngleFromTail: self! !

!Domino methodsFor: 'private' stamp: 'emm 03/09/2012 20:19'!
newBox

	| origin |
	PrototypeBox isNil
		ifFalse: [ PrototypeBox extent = self sizePoint
			ifTrue: [ ^PrototypeBox ] ].
	origin := (self sizePoint x negated) ,(self sizePoint y / -2), 0.
	^PrototypeBox := Box origin: origin extent: self sizePoint.	
	
	
	! !

!Domino methodsFor: 'computing' stamp: 'emm 03/09/2012 20:19'!
nonTopplingDistanceFromTail: aDomino

	"The receiver is not toppled"

	^ ( aDomino distanceToTopplingHead: self ) - 
			( aDomino length / ( self yawAngle - aDomino yawAngle) cos )! !

!Domino methodsFor: 'copying' stamp: 'emm 03/09/2012 20:19'!
postCopy

	self bottomCenter: self bottomCenter copy.
	self sizePoint: self sizePoint copy.
	self heads: nil.
	self tails: nil.! !

!Domino methodsFor: 'printing' stamp: 'emm 03/09/2012 20:19'!
printOn: aStream 
	
	super printOn: aStream.
	aStream nextPut: $( ;print: self bottomCenter ;nextPut: $)! !

!Domino methodsFor: 'inspecting' stamp: 'emm 03/09/2012 20:19'!
printableInstanceVariablesNames
	
	^(super printableInstanceVariablesNames copyWithout: #tails) copyWithout: #heads! !

!Domino methodsFor: 'computing' stamp: 'emm 03/09/2012 20:19'!
propagateChangeToHeads

	| newFronts |
	newFronts := Set new.
	self heads do:[ :each | 
		newFronts addAll: (each frontsAfterUpdatingAngleForChangedTail: self ) ].
	^newFronts! !

!Domino methodsFor: 'computing' stamp: 'emm 03/09/2012 20:19'!
propagateChangeToTails
	
	"backward propagate new angle of the receiver"
	self tails do: [ :each | 
		(each updateAngleForChangedHead: self)
			ifTrue:[ each propagateChangeToTails ]]! !

!Domino methodsFor: 'adding-removing' stamp: 'emm 03/09/2012 20:19'!
removeHead: aDomino

	( heads includes: aDomino )
		ifTrue: 
			[ heads remove: aDomino.
			aDomino removeTail: self ]
! !

!Domino methodsFor: 'adding-removing' stamp: 'emm 03/09/2012 20:19'!
removeTail: aDomino

	( tails includes: aDomino )
		ifTrue:
			[ tails remove: aDomino.
			aDomino removeHead: self ]! !

!Domino methodsFor: 'VRML' stamp: 'emm 03/09/2012 20:19'!
rotationAxis

	^0,1,0! !

!Domino methodsFor: 'VRML' stamp: 'emm 03/09/2012 20:19'!
rotationTransformIn: anElement 
	
	^ self yawAngle = 0
		ifTrue:[ anElement elements first "elements first" ]
		ifFalse:[ anElement elements first elements first "elements first" ]! !

!Domino methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
sizePoint

	"Answer the value of sizePoint"

	^sizePoint! !

!Domino methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
sizePoint: aValue

	"Set the value of sizePoint"

	sizePoint := aValue! !

!Domino methodsFor: 'accessing-computed' stamp: 'emm 03/09/2012 20:19'!
tailToHeadHeight

	"Answer the z-offset from bottomCenter to the position
	where the receiver will hit its heads"

	^self height! !

!Domino methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
tails

	"Answer the value of tails"

	^tails ifNil:[ #() ]! !

!Domino methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
tails: aValue

	"Set the value of tails"

	tails := aValue! !

!Domino methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
texture

	"Answer the value of texture"

	^texture! !

!Domino methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
texture: aValue

	"Set the value of texture"

	texture := aValue! !

!Domino methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
toppleAngle

	"Answer the value of toppleAngle"

	^toppleAngle! !

!Domino methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
toppleAngle: aValue

	"Set the value of toppleAngle"

	aValue > HalfPi
		ifTrue: [ toppleAngle := HalfPi. ^self "1 halt" ].
	(toppleAngle notNil and:[aValue ~= 0 and:[aValue < toppleAngle]])
		ifTrue: [ ^self ].
	toppleAngle := aValue! !

!Domino methodsFor: 'accessing-computed' stamp: 'emm 03/09/2012 20:19'!
toppleAngleForHead

	"Answer the topple angle of the receiver
	as seen from one of my tails. The receiver
	being its head"
	
	^self toppleAngle! !

!Domino methodsFor: 'accessing-computed' stamp: 'emm 03/09/2012 20:19'!
toppleAngleForTail

	"Answer the topple angle of the receiver
	as seen from one of my heads. The receiver
	being its tail"
	
	^self toppleAngle! !

!Domino methodsFor: 'properties' stamp: 'emm 03/09/2012 20:19'!
toppleEpsilon

	^0.1 rad
	! !

!Domino methodsFor: 'computing' stamp: 'emm 03/09/2012 20:19'!
topplingDistanceFromTail: aDomino

	"Answer the distance between the rotation point
	of @aDomino and the rotation point of self"

	| yawDelta |
	( yawDelta := (self yawAngle - aDomino yawAngle) abs ) = 0
		ifTrue:
			[ aDomino yawAngle \\ Pi = 0
				ifTrue:[ ^ (self bottomCenter x - aDomino bottomCenter x) abs].
			aDomino yawAngle \\ HalfPi = 0
				ifTrue:[ ^ (self bottomCenter y - aDomino bottomCenter y) abs ].
			"0 < yawAngle < HalfPi"
			^ self bottomCenter dist: aDomino bottomCenter ]
		ifFalse:
			[ | xa ya xb yb alpha beta lambda xe ye e s ch |
			xa := aDomino bottomCenter x.
			ya := aDomino bottomCenter y.
			xb := self bottomCenter x.
			yb := self bottomCenter y.
			alpha := aDomino yawAngle - HalfPi.
			beta := self yawAngle - HalfPi.
			lambda :=  alpha sin * (xa -xb) - (alpha cos * (ya - yb)) / 
				(beta cos * alpha sin - (beta sin * alpha cos)).
			xe := beta cos * lambda + xb.
			ye := beta sin * lambda + yb.
			e := xe , ye , aDomino bottomCenter z.
			s := (e dist: aDomino bottomCenter) - (aDomino width / 2).
			ch := yawDelta tan * s - (aDomino length / 2) + (self length / 2 / yawDelta cos).
			^ch abs]! !

!Domino methodsFor: 'VRML' stamp: 'emm 03/09/2012 20:19'!
transformRotation

	^self toppleAngle! !

!Domino methodsFor: 'VRML' stamp: 'emm 03/09/2012 20:19'!
transformRotation: aValue

	toppleAngle := aValue! !

!Domino methodsFor: 'computing' stamp: 'emm 03/09/2012 20:19'!
updateAngleForChangedHead: aDomino 
	
	"One of my dominos ahead, @aDomino, has changed its topple angle.
	Recompute my topple angle accordingly.
	Answer whether the receiver's angle has changed signicifantly"
	
	| newToppleAngle |
	newToppleAngle := self hitAngleAgainstHead: aDomino.
	newToppleAngle <= self toppleAngle
		ifTrue: [ ^false ].
	self toppleAngle = 0
		ifTrue: [ ^false ].
	( newToppleAngle - self toppleAngle ) abs < self toppleEpsilon 
		ifTrue:[ ^ false ].
	self toppleAngle: newToppleAngle.
	^ true! !

!Domino methodsFor: 'accessing-computed' stamp: 'emm 03/09/2012 20:19'!
width

	^self sizePoint y! !

!Domino methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
yawAngle

	"Answer the value of yawAngle"

	^yawAngle! !

!Domino methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
yawAngle: aValue

	"Set the value of yawAngle"

	yawAngle := aValue! !

Domino subclass: #DominoSwivel180
	instanceVariableNames: 'isClockwise isPastHittingHead isPastHitByTail rotationAngle'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Dominos'!

!DominoSwivel180 methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
axisRadius

	^0.5! !

!DominoSwivel180 methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
bottomHeight

	"Answer the offset from the bottomCenter to the bottom
	of the actual swivel part"

	^4! !

!DominoSwivel180 methodsFor: 'VRML' stamp: 'emm 10/18/2012 19:18'!
buildElementWith: aBuilder

	| origin group cube element |
	aBuilder color: self color.
	origin := 0 ,(self sizePoint y / -2), self bottomHeight.
	group := CompositeGeometric3D new.
	group add: ((Cylinder radius: self axisRadius height: self sizePoint z + 2) coloredWith: Color gray).
	cube := Box origin: origin	extent: (self sizePoint x, self sizePoint y , (self topHeight - self bottomHeight)).
	group add: cube.
	
	aBuilder color: self color.
	element := aBuilder newElementFrom: group.
	element name: 'S' , self color name.
	element := aBuilder newTransformOn: element. "for rotation"
	element := (aBuilder newTransformOn: element) translation: (self sizePoint x/2),0,0.
	self yawAngle = 0
		ifFalse: [ element := (aBuilder newTransformOn: element) rotation: (aBuilder orientationFromPoint: 0,0,self yawAngle) ].
	element := (aBuilder newTransformOn: element) translation: self bottomCenter.
	^element
	! !

!DominoSwivel180 methodsFor: 'dispatching' stamp: 'emm 03/09/2012 20:19'!
buildStone

	| origin cube group zRotation |
	origin := 0 ,(self sizePoint y/-2), self bottomHeight.
	group := CompositeGeometric3D new.
	group add: ((Cylinder radius: self axisRadius height: self sizePoint z + 2) coloredWith: Color gray).
	cube := Box origin: origin	extent: (self sizePoint x, self sizePoint y , (self topHeight - self bottomHeight)).
	group add: cube.

	zRotation := self isClockwise
		ifTrue: [ self yawAngle - (self rotationAngle max: 0) ]
		ifFalse: [ self yawAngle + (self rotationAngle max: 0) ].
	group := group wrapRotateBy: 0,0,zRotation.
	group := group wrapTranslateBy: self bottomCenter.
	^group! !

!DominoSwivel180 methodsFor: 'computing' stamp: 'emm 03/09/2012 20:19'!
computeRotationAngle

	"Compute the rotation angle 
	based on the topple angle of my only tail"

	"Pre: tails not empty"

	| tail h k ntd angle |
	tail := self tails first.
	h := tail tailToHeadHeight.
	ntd := self nonTopplingDistanceFromTail: tail.
	angle := (((HalfPi - tail toppleAngle) cos * h - ntd ) / self lateralDistanceFromTail ) arcTan.
	^angle! !

!DominoSwivel180 methodsFor: 'computing' stamp: 'emm 03/09/2012 20:19'!
disconnectFromTailAndHead

	self removeTail: self tails first.
	self removeHead: self heads first.! !

!DominoSwivel180 methodsFor: 'computing' stamp: 'emm 03/09/2012 20:19'!
distanceToTopplingHead: aDomino

	"Answer the distance between the rotation point
	of the receiver and the rotation point of @aDomino"

	"Assume the receiver's length is equal to @aDomino's length"
	
	| yawDelta |
	yawDelta := (self yawAngle - aDomino yawAngle) abs.
	(self yawAngle \\ Pi) = 0
		ifTrue: [ ^ (self bottomCenter x - aDomino bottomCenter x) abs + (aDomino length/2) ].
	(self yawAngle \\ HalfPi) = 0
		ifTrue: [ ^ (self bottomCenter y - aDomino bottomCenter y) abs + (aDomino length/2) ].
	"0 < yawAngle < HalfPi"
	^ ( self bottomCenter dist: aDomino bottomCenter ) + (aDomino length/2)! !

!DominoSwivel180 methodsFor: 'computing' stamp: 'emm 03/09/2012 20:19'!
frontsAfterTopplingBy: angleIncrement

	"If I am on front that I did not hit my head.
	So pass this request to my tail so he will set
	my new virtual topple angle. Then I might hit 
	my head and he will be on front"

	^ self tails isEmpty
		ifTrue: [ #() ]
		ifFalse:[ self tails first frontsAfterTopplingBy: angleIncrement ]! !

!DominoSwivel180 methodsFor: 'computing' stamp: 'emm 03/09/2012 20:19'!
frontsAfterUpdatingAngleForChangedTail: aDomino 

	"One of my dominos on my tail, @aDomino, has changed its topple angle"

	| newToppleAngle ntd h alpha newFronts |
	self heads isEmpty
		ifTrue: [ ^Set with: self ].
	ntd := self nonTopplingDistanceFromTail: aDomino.
	h := aDomino tailToHeadHeight.
	alpha := HalfPi - aDomino toppleAngleForTail.
	newToppleAngle := HalfPi - (alpha sin * h / ( alpha cos * h - ntd )) arcTan.
	self toppleAngle: newToppleAngle.
	newFronts := self heads first frontsAfterUpdatingAngleForChangedTail: self.
	"check whether to disconnect"
	self rotationAngle > self maxRotationAngleFromTail
		ifTrue: 
			[self disconnectFromTailAndHead.
			newFronts remove: self ifAbsent:[] ].
	"my tails stays on front"
	newFronts add: aDomino.			
	^newFronts! !

!DominoSwivel180 methodsFor: 'computing' stamp: 'emm 03/09/2012 20:19'!
hitAngleAgainstTail: aDomino

	"Answer the VIRTUAL topple angle for the receiver when hitting tail @aDomino"

	| h d |
	h := aDomino tailToHeadHeight.
	d := self nonTopplingDistanceFromTail: aDomino.
	^( aDomino toppleAngleForTail sin * h / ( (HalfPi - aDomino toppleAngleForTail) cos * h - d )) arcTan
	! !

!DominoSwivel180 methodsFor: 'initialize-release' stamp: 'emm 03/09/2012 20:19'!
initialize

	super initialize.
	self sizePoint: 1,8,10.
	self isClockwise: false.
	self isPastHitByTail: false.
	self isPastHittingHead: false.! !

!DominoSwivel180 methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
isClockwise

	"Answer the value of isClockwise"

	^isClockwise! !

!DominoSwivel180 methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
isClockwise: aValue

	"Set the value of isClockwise"

	isClockwise := aValue! !

!DominoSwivel180 methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
isPastHitByTail

	"Answer the value of isPastHitByTail"

	^isPastHitByTail! !

!DominoSwivel180 methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
isPastHitByTail: aValue

	"Set the value of isPastHitByTail"

	isPastHitByTail := aValue! !

!DominoSwivel180 methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
isPastHittingHead

	"Answer the value of isPastHittingHead"

	^isPastHittingHead! !

!DominoSwivel180 methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
isPastHittingHead: aValue

	"Set the value of isPastHittingHead"

	isPastHittingHead := aValue! !

!DominoSwivel180 methodsFor: 'accessing-computed' stamp: 'emm 03/09/2012 20:19'!
lateralDistanceFromTail

	| tail |
	tail := self tails first.
	^self yawAngle \\ Pi = 0
		ifTrue: [ (self bottomCenter y - tail bottomCenter y) abs - (tail width / 2) ]
		ifFalse: [(self bottomCenter x - tail bottomCenter x) abs - (tail width / 2) ].! !

!DominoSwivel180 methodsFor: 'computing' stamp: 'emm 03/09/2012 20:19'!
maxRotationAngleFromTail
	"Answer the maximum rotation angle for the receiver
	while connected to the tail"
	
	^(self lateralDistanceFromTail / (self width / 2)) arcCos! !

!DominoSwivel180 methodsFor: 'computing' stamp: 'emm 03/09/2012 20:19'!
maximumAngleFromTail: aDomino

	"Answer the maximum angle at which @aDomino can
	be rotated when toppling against the receiver"
	
	"As long as the tail is still connected answer the maximum possible"

	^HalfPi! !

!DominoSwivel180 methodsFor: 'computing' stamp: 'emm 03/09/2012 20:19'!
minimumAngleFromTail: aDomino

	"Answer minimum angle at which @aDomino must
	be rotated in order to make the receiver topple"

	^HalfPi - (( self nonTopplingDistanceFromTail: aDomino) / aDomino tailToHeadHeight ) arcCos! !

!DominoSwivel180 methodsFor: 'computing' stamp: 'emm 03/09/2012 20:19'!
nonTopplingDistanceFromTail: aDomino

	"The receiver is not toppled"
	
	"Assume the receiver's length is equal to @aDomino's length"
	
	| yawDelta |
	yawDelta := (self yawAngle - aDomino yawAngle) abs.
	self yawAngle \\ Pi = 0
		ifTrue: [ ^ (self bottomCenter x - aDomino bottomCenter x) abs - (aDomino length/2) ].
	self yawAngle \\ HalfPi = 0
		ifTrue: [ ^ (self bottomCenter y - aDomino bottomCenter y) abs - (aDomino length/2) ].
	"0 < yawAngle < HalfPi"
	^ ( self bottomCenter dist: aDomino bottomCenter ) - (aDomino length/2).! !

!DominoSwivel180 methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
rotationAngle

	"Answer the rotation angle 
	based on the topple angle of my only tail"

	^ rotationAngle isNil
		ifTrue: 
			[ "should not happen"
			self tails isEmpty ifTrue: [ ^0 ].
			rotationAngle := self computeRotationAngle ]
		ifFalse: [ rotationAngle ]! !

!DominoSwivel180 methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
rotationAngle: aValue

	"Set the value of rotationAngle"

	rotationAngle := aValue! !

!DominoSwivel180 methodsFor: 'VRML' stamp: 'emm 03/09/2012 20:19'!
rotationAxis

	^0,0,1! !

!DominoSwivel180 methodsFor: 'accessing-computed' stamp: 'emm 03/09/2012 20:19'!
tailToHeadHeight

	"Answer virtual height of a domino toppling to a head"

	| topOffset bottomOffset |
	topOffset := self rotationAngle sin * self width / 2.
	bottomOffset := self bottomHeight.
	^(topOffset squared + bottomOffset squared) sqrt! !

!DominoSwivel180 methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
topHeight

	"Answer the offset from the bottomCenter to the top
	of the actual swivel part"

	^10! !

!DominoSwivel180 methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
toppleAngle: aValue

	self rotationAngle: nil. "flush the cache"
	super toppleAngle: aValue! !

!DominoSwivel180 methodsFor: 'accessing-computed' stamp: 'emm 03/09/2012 20:19'!
toppleAngleForHead

	"Answer the topple angle of the receiver
	as seen from one of my tails. The receiver
	being its head"
	
	^self toppleAngle! !

!DominoSwivel180 methodsFor: 'accessing-computed' stamp: 'emm 03/09/2012 20:19'!
toppleAngleForTail

	"Answer the topple angle of the receiver
	as seen from one of my heads. The receiver
	being its tail"
	
	^( self bottomHeight / self tailToHeadHeight ) arcCos! !

!DominoSwivel180 methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
transformRotation
	
	^ self isClockwise
		ifTrue: [ (self rotationAngle max: 0) negated ]
		ifFalse: [ self rotationAngle max: 0 ]! !

!DominoSwivel180 methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
transformRotation: aValue
	
	^ self isClockwise
		ifTrue: [ self rotationAngle: aValue negated ]
		ifFalse: [ self rotationAngle: aValue ]! !

!DominoSwivel180 methodsFor: 'computing' stamp: 'emm 03/09/2012 20:19'!
updateAngleForChangedHead: aDomino 
	
	"One of my dominos ahead, @aDomino, has changed its topple angle.
	Recompute my topple angle accordingly.
	Answer whether the receiver's angle has changed signicifantly"
	
	| hasChanged |
	hasChanged := super updateAngleForChangedHead: aDomino.
"	self rotationAngle > self maxRotationAngleFromTail
		ifTrue: [ self disconnectFromTailAndHead].
"	^hasChanged
			
		! !

Geometric3D subclass: #ExternalGeometric3D
	instanceVariableNames: 'resourceName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-SceneBuilding3D'!

!ExternalGeometric3D class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:37'!
fromFile: aString
	
	^self new resourceName: aString! !

!ExternalGeometric3D methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:37'!
kindDo: aRequestor
	^aRequestor doExternalGeometric3D: self! !

!ExternalGeometric3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:37'!
resourceName

	"Answer the value of resourceName"

	^resourceName! !

!ExternalGeometric3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:37'!
resourceName: aValue

	"Set the value of resourceName"

	resourceName := aValue! !

!Geometric3D methodsFor: 'component-adding' stamp: 'emm 02/09/2012 23:32'!
addFacesTo: aFaceCollection 

	self facesDo: [:each | 
		aFaceCollection add: each]! !

!Geometric3D methodsFor: 'component-adding' stamp: 'emm 02/09/2012 23:32'!
addVerticesTo: aVertexCollection 

	self verticesDo: [:each | 
		aVertexCollection add: each]! !

!Geometric3D methodsFor: '*Zenna-Wrappers3D' stamp: 'emm 02/09/2012 23:45'!
asWrapperOnDefault

	"Answer a new wrapper that when transforming a default instance results in the receiver"

	^self! !

!Geometric3D methodsFor: '*Zenna-Wrappers3D' stamp: 'emm 02/09/2012 23:45'!
backLeftBottom

	^self bounds backLeftBottom! !

!Geometric3D methodsFor: '*Zenna-Wrappers3D' stamp: 'emm 02/09/2012 23:45'!
backRightBottom

	^self bounds backRightBottom! !

!Geometric3D methodsFor: '*Zenna-Wrappers3D' stamp: 'emm 02/09/2012 23:45'!
backRightBottom: aPoint

	"Translate the receiver such that the value of backRightBottom equals @aPoint"

	^self translateBy: aPoint - self backRightBottom! !

!Geometric3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:32'!
bounds

	"Answer the bounding box for the receiver"

	self subclassResponsibility! !

!Geometric3D methodsFor: '*Zenna-FormatPOVRay' stamp: 'emm 02/09/2012 23:55'!
canBeTextureWrapped
	^true! !

!Geometric3D methodsFor: '*Zenna-Wrappers3D' stamp: 'emm 02/09/2012 23:45'!
center
	self subclassResponsibility! !

!Geometric3D methodsFor: '*Zenna-Wrappers3D' stamp: 'emm 02/09/2012 23:45'!
centerRotateBy: aPointOrScalar

	"Answer the receiver wrapped by transformations
	such that the receiver is rotated by <aPointOrScalar> with
	respect to its center"

	| myCenter |
	myCenter := self center.
	^( ( (self wrapTranslateBy: myCenter negated)
		rotateBy: aPointOrScalar )
			translateBy: myCenter )! !

!Geometric3D methodsFor: '*Zenna-Wrappers3D' stamp: 'emm 02/09/2012 23:45'!
centerScaleBy: aPointOrScalar

	"Answer the receiver wrapped by transformations
	such that the receiver is scaled by <aPointOrScalar> with
	respect to its center"

	| myCenter |
	myCenter := self center.
	^( ( (self wrapTranslateBy: myCenter negated)
		scaleBy: aPointOrScalar )
			translateBy: myCenter )! !

!Geometric3D methodsFor: '*Zenna-Wrappers3D' stamp: 'emm 02/09/2012 23:45'!
centerTo: aPoint3D 

	^self wrapCenterBy: aPoint3D! !

!Geometric3D methodsFor: '*Zenna-Wrappers3D' stamp: 'emm 02/09/2012 23:45'!
centered

	^self copy centering! !

!Geometric3D methodsFor: '*Zenna-Wrappers3D' stamp: 'emm 02/09/2012 23:45'!
centering

	^Geometric3DWrapper centering: self! !

!Geometric3D methodsFor: '*Zenna-Wrappers3D' stamp: 'emm 02/09/2012 23:45'!
collectWrappersInto: aCollection

	^aCollection! !

!Geometric3D methodsFor: '*Zenna-Appearance3D' stamp: 'emm 02/09/2012 23:44'!
coloredWith: aColor

	^self wrapColoredWith: aColor! !

!Geometric3D methodsFor: 'computing' stamp: 'emm 02/09/2012 23:32'!
computeSolidBetween: aParam and: secondParam 

	^Box size: 0! !

!Geometric3D methodsFor: 'copying' stamp: 'emm 02/09/2012 23:32'!
copy
	"Non-ANSI Smalltalk"
	" Answer another instance just like the receiver.
	Subclasses normally override the postCopy
	message, but some objects that should not be
	copied override copy. "

	^self shallowCopy postCopy! !

!Geometric3D methodsFor: '*Zenna-Wrappers3D' stamp: 'emm 02/09/2012 23:45'!
corner
	
	^self bounds corner! !

!Geometric3D methodsFor: '*Zenna-Wrappers3D' stamp: 'emm 02/09/2012 23:45'!
corner: newCorner

	"Answer "
	
	| oldCorner |
	oldCorner := self corner.
	oldCorner = newCorner
		ifTrue: [ ^self ].
	^self wrapTranslateBy: newCorner - oldCorner
! !

!Geometric3D methodsFor: 'computing' stamp: 'emm 02/09/2012 23:32'!
decomposedSolids

	"Decomposed here means wrapping all transformations found of each leaf solid
	referenced by the receiver. On default, the receiver is a leaf solid"

	| adaptor |
	adaptor := EvaluationToAdditionAdaptor on: OrderedCollection new.
	self decomposedSolidsDo: adaptor.
	^adaptor collection
	! !

!Geometric3D methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:32'!
decomposedSolidsDo: aBlock

	"Consolidations here means wrapping all transformations found of each leaf solid
	referenced by the receiver. On default, the receiver is a leaf solid"

	aBlock value: self! !

!Geometric3D methodsFor: '*Zenna-Wrappers3D' stamp: 'emm 02/09/2012 23:45'!
degeneralizedWrapBy: aWrapper

	"Until I find a better name..."

	"No further generalization"

	^self! !

!Geometric3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:32'!
estimatedFacesSize
	"Answer the estimated number of faces"

	^6! !

!Geometric3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:32'!
estimatedSegmentsSize
	"Answer the estimated number of edges"

	^12! !

!Geometric3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:32'!
estimatedSolidsSize

	^1! !

!Geometric3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:32'!
estimatedTrianglesSize

	^2! !

!Geometric3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:32'!
estimatedVerticesSize
	"Answer the estimated number of vertices"

	^24! !

!Geometric3D methodsFor: 'transforming' stamp: 'emm 02/09/2012 23:32'!
expandBy: aPointOrScalar

	self subclassResponsibility! !

!Geometric3D methodsFor: 'transforming' stamp: 'emm 02/09/2012 23:32'!
expandedBy: aPointOrScalar

	^self copy expandBy: aPointOrScalar! !

!Geometric3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:32'!
faces
	"Answer the collection of faces"

	| col |
	self addFacesTo: ( col := OrderedCollection new).
	^col! !

!Geometric3D methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:32'!
facesDo: aBlock
	"on default, the receiver has no faces"

	self solidsDo: [ :eachSolid | eachSolid facesDo: aBlock ]! !

!Geometric3D methodsFor: '*Zenna-Wrappers3D' stamp: 'emm 02/09/2012 23:45'!
frontRightBottom

	^self bounds frontRightBottom! !

!Geometric3D methodsFor: 'testing' stamp: 'emm 02/09/2012 23:32'!
hasVolume

	"On default I do"	

	^true! !

!Geometric3D methodsFor: '*Zenna-Wrappers3D' stamp: 'emm 02/09/2012 23:45'!
hollowWithThickness: thickness

	^self wrapHollowWithThickness: thickness! !

!Geometric3D methodsFor: '*Zenna-Collections3D' stamp: 'emm 02/09/2012 23:43'!
inCollectionWith: otherGeometric3D

	^CompositeGeometric3D with: self with: otherGeometric3D! !

!Geometric3D methodsFor: 'transforming' stamp: 'emm 02/09/2012 23:32'!
insetBy: aPointOrScalar

	self subclassResponsibility! !

!Geometric3D methodsFor: 'testing' stamp: 'emm 02/09/2012 23:32'!
isComposed
	"On default, the receiver is not composed of geometrics"

	^false! !

!Geometric3D methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:32'!
kindDo: aRequestor

	^aRequestor doGeometric3D: self! !

!Geometric3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:32'!
leafComponent
	
	^self! !

!Geometric3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:32'!
leafComponents

	| col |
	col := OrderedCollection new.
	self leafComponentsDo: [:each | 
		col add: each].
	^col! !

!Geometric3D methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:32'!
leafComponentsDo: aBlock 

	aBlock value: self! !

!Geometric3D methodsFor: 'transforming' stamp: 'emm 02/09/2012 23:32'!
mirrorInXY

	^self subclassResponsibility! !

!Geometric3D methodsFor: 'transforming' stamp: 'emm 02/09/2012 23:32'!
mirrorInXZAt: y

	^self subclassResponsibility! !

!Geometric3D methodsFor: 'transforming' stamp: 'emm 02/09/2012 23:32'!
mirrorInYZ

	^self subclassResponsibility! !

!Geometric3D methodsFor: 'transforming' stamp: 'emm 02/09/2012 23:32'!
mirroredInXY

	^self copy mirrorInXY! !

!Geometric3D methodsFor: 'transforming' stamp: 'emm 02/09/2012 23:32'!
mirroredInXZAt: y

	^self copy mirrorInXZAt: y! !

!Geometric3D methodsFor: 'transforming' stamp: 'emm 02/09/2012 23:32'!
mirroredInYZ

	^self copy mirrorInYZ! !

!Geometric3D methodsFor: '*Zenna-Wrappers3D' stamp: 'emm 02/09/2012 23:45'!
origin
	
	^self bounds origin! !

!Geometric3D methodsFor: '*Zenna-Wrappers3D' stamp: 'emm 02/09/2012 23:45'!
origin: newOrigin

	"Answer "
	
	| oldOrigin |
	oldOrigin := self origin.
	oldOrigin = newOrigin
		ifTrue: [ ^self ].
	^self wrapTranslateBy: newOrigin - oldOrigin
! !

!Geometric3D methodsFor: '*Zenna-Collections3D' stamp: 'emm 02/09/2012 23:43'!
pointCollectionClass
	^OrderedPoint3DCollection! !

!Geometric3D methodsFor: 'copying' stamp: 'emm 02/09/2012 23:32'!
postCopy
	" Finish doing whatever is required,
	beyond a shallowCopy, to implement 'copy'.
	Answer the receiver.
	This message is only intended to be sent
	to the newly created instance.
	Subclasses may add functionality,
	but they should always do super postCopy first. "
	" Note that any subclass that 'mixes in Modelness'
	(i.e., implements dependents with an instance
	variable) must include the equivalent of
	'self breakDependents' in its implementation
	of postCopy. "

	^self! !

!Geometric3D methodsFor: 'printing' stamp: 'emm 02/09/2012 23:32'!
printClassCreationOn: aStream indent: level

	aStream 
		nextPutAll: '('
		; nextPutAll: self class name
		; nextPutAll: ' new)'! !

!Geometric3D methodsFor: 'printing' stamp: 'emm 02/09/2012 23:32'!
printOn: aStream 

	[self printOn: aStream indent: 0] 
		whenErrorDo: [ :sig |
			aStream nextPutAll: '*** could not print receiver because: ' , sig printString , ' ***' ]! !

!Geometric3D methodsFor: 'printing' stamp: 'emm 02/09/2012 23:32'!
printOn: aStream indent: level 
	"Append to the argument aStream a sequence of characters
	that describes the receiver."

	self printClassCreationOn: aStream indent: level.
	aStream crtab: level + 1.
	self printableInstanceVariablesNames
		do:[ :each | | value |
			value := self perform: each.
			value notNil
				ifTrue: [ aStream nextPutAll: each ; nextPut: $: ;print: value ] ]
		separatedBy: [ aStream crtab: level + 1 ;nextPut: $; ]! !

!Geometric3D methodsFor: 'printing' stamp: 'emm 02/09/2012 23:32'!
printableInstanceVariablesNames

	^self class allInstVarNames collect:  #asSymbol! !

!Geometric3D methodsFor: 'computing' stamp: 'emm 02/09/2012 23:32'!
productFromMatrix3x3: aMatrix3x3

	self subclassResponsibility! !

!Geometric3D methodsFor: '*Zenna-Wrappers3D' stamp: 'emm 02/09/2012 23:45'!
propagatedTransformedPoint: aPoint

	"The receiver is not a transformer"

	^aPoint! !

!Geometric3D methodsFor: 'rendering' stamp: 'emm 02/09/2012 23:32'!
renderOn: aRenderContext
	"Subclasses should override if they can render themselves"! !

!Geometric3D methodsFor: '*Zenna-Wrappers3D' stamp: 'emm 02/09/2012 23:45'!
reverseOriented

	^Reversing3DWrapper on: self! !

!Geometric3D methodsFor: '*Zenna-Wrappers3D' stamp: 'emm 02/09/2012 23:45'!
rotateBy: aPoint

	^self wrapRotateBy: aPoint! !

!Geometric3D methodsFor: '*Zenna-Wrappers3D' stamp: 'emm 02/09/2012 23:45'!
rotateBy: rotation translateBy: translation
	self deprecated: #rotateBy:translateBy:.
	^(self rotateBy: rotation) translateBy: translation! !

!Geometric3D methodsFor: '*Zenna-Wrappers3D' stamp: 'emm 02/09/2012 23:45'!
rotatedBy: aPoint

	^self copy rotateBy: aPoint! !

!Geometric3D methodsFor: '*Zenna-Wrappers3D' stamp: 'emm 02/09/2012 23:45'!
scaleBy: aPoint 

	^self wrapScaleBy: aPoint! !

!Geometric3D methodsFor: '*Zenna-Wrappers3D' stamp: 'emm 02/09/2012 23:45'!
scaledBy: aPoint 

	^self copy scaleBy: aPoint! !

!Geometric3D methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:32'!
segmentsDo: aBlock! !

!Geometric3D methodsFor: 'transforming' stamp: 'emm 02/09/2012 23:32'!
shrinkBy: aPointOrScalar

	self expandBy: aPointOrScalar negated! !

!Geometric3D methodsFor: 'transforming' stamp: 'emm 02/09/2012 23:32'!
shrunkenBy: aPointOrScalar

	^self copy shrinkBy: aPointOrScalar! !

!Geometric3D methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:32'!
solidsDo: aBlock
	"on default, the receiver has no solids"! !

!Geometric3D methodsFor: '*Zenna-Appearance3D' stamp: 'emm 02/09/2012 23:44'!
texturedWith: aTexture

	^self wrapTexturedWith: aTexture! !

!Geometric3D methodsFor: '*Zenna-Wrappers3D' stamp: 'emm 02/09/2012 23:45'!
translateBy: aPoint 

	^self wrapTranslateBy: aPoint! !

!Geometric3D methodsFor: '*Zenna-Wrappers3D' stamp: 'emm 02/09/2012 23:45'!
translateBy: translation rotateBy: rotation
	self deprecated: #translateBy:rotateBy:.
	^(self translateBy: translation ) rotateBy: rotation! !

!Geometric3D methodsFor: '*Zenna-Wrappers3D' stamp: 'emm 02/09/2012 23:45'!
translatedBy: aPoint 

	^self copy translateBy: aPoint.! !

!Geometric3D methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:32'!
trianglesDo: aBlock 

	self facesDo: [:face | 
		face trianglesDo: aBlock]! !

!Geometric3D methodsFor: '*Zenna-Operators3D' stamp: 'emm 02/09/2012 23:46'!
uniqueVerticesDo: aBlock

	| filter |
	filter := SingleOccurrencePoint3DFilter on: (AdditionToEvaluationAdaptor on: aBlock).
	self facesDo:[ :each |
		each verticesDo: filter ]! !

!Geometric3D methodsFor: 'computing' stamp: 'emm 02/09/2012 23:32'!
valueFor: anAspect
	^self perform: anAspect! !

!Geometric3D methodsFor: 'computing' stamp: 'emm 02/09/2012 23:32'!
valueFor: anAspect is: newValue

	^self perform: ( anAspect copyWith: $: ) asSymbol with: newValue! !

!Geometric3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:32'!
vertices
	"Answer the collection of vertices"

	| col |
	col := self pointCollectionClass new.
	self addVerticesTo: col.
	^col! !

!Geometric3D methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:32'!
verticesDo: aBlock

	self uniqueVerticesDo: aBlock! !

!Geometric3D methodsFor: '*Zenna-Wrappers3D' stamp: 'emm 02/09/2012 23:45'!
wrapCenterBy: aPoint3D 

	^(Centering3DWrapper on: self)
		translateBy: aPoint3D! !

!Geometric3D methodsFor: '*Zenna-Wrappers3D' stamp: 'emm 02/09/2012 23:45'!
wrapColoredWith: aColor
	
	aColor isNil ifTrue: [ ^self ].
	^(ColorWrapper on: self)
		 color: aColor! !

!Geometric3D methodsFor: '*Zenna-Wrappers3D' stamp: 'emm 02/09/2012 23:45'!
wrapHollowWithThickness: thickness

	^(Hollowing3DWrapper on: self ) thickness: thickness! !

!Geometric3D methodsFor: '*Zenna-Wrappers3D' stamp: 'emm 02/09/2012 23:45'!
wrapRotateBy: aPoint

	^Geometric3DWrapper on: self rotateBy: aPoint! !

!Geometric3D methodsFor: '*Zenna-Wrappers3D' stamp: 'emm 02/09/2012 23:45'!
wrapScaleBy: aPoint 

	^Geometric3DWrapper on: self scaleBy: aPoint! !

!Geometric3D methodsFor: '*Zenna-Wrappers3D' stamp: 'emm 02/09/2012 23:45'!
wrapTexturedWith: aTexture

	^( TextureWrapper on: self ) texture: aTexture! !

!Geometric3D methodsFor: '*Zenna-Wrappers3D' stamp: 'emm 02/09/2012 23:45'!
wrapTranslateBy: aPoint 

	^Geometric3DWrapper on: self translateBy: aPoint! !

!Geometric3D methodsFor: '*Zenna-Wrappers3D' stamp: 'emm 02/09/2012 23:45'!
wrapWithMargins: aPoint 

	^Geometric3DWrapper on: self withMargins: aPoint! !

!Geometric3D methodsFor: 'transforming' stamp: 'emm 02/09/2012 23:32'!
zAlignWith: aPoint 

	"Answer the receiver transformed such that the receiver's z-axis is aligned along a line through Point3D zero and <aPoint>"
	
	^aPoint rotationPointsFromZ 
		inject: self 
		into: [ :geometric :rotation | geometric wrapRotateBy: rotation ]! !

Geometric3D subclass: #Geometric3DWrapper
	instanceVariableNames: 'geometric'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Appearance3D'!

Geometric3DWrapper subclass: #Centering3DWrapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Wrappers3D'!

!Centering3DWrapper methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:45'!
bounds

	^self component bounds translatedBy: self translation! !

!Centering3DWrapper methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:45'!
facesDo: aBlock 

	| t |
	( t := self translation ) isZero
		ifTrue: [ self component facesDo: aBlock ]
		ifFalse: [ self component facesDo: [:each | aBlock value: ( each translatedBy: t )] ]! !

!Centering3DWrapper methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:45'!
kindDo: aRequestor

	^aRequestor doTranslating3DWrapper: self! !

!Centering3DWrapper methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:45'!
solidsDo: aBlock 

	| t |
	( t := self translation ) isZero
		ifTrue: [ self component solidsDo: aBlock ]
		ifFalse: [ self component solidsDo: [:each | aBlock value: ( each translatedBy: t )] ]! !

!Centering3DWrapper methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:45'!
transformedPolygon: aPolygon

	| t |
	^(t := self translation) isZero
		ifTrue: [ aPolygon ]
		ifFalse: [ aPolygon translateBy: t ]! !

!Centering3DWrapper methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:45'!
translation

	^self component bounds center negated! !

!Centering3DWrapper methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:45'!
verticesDo: aBlock 

	| t |
	( t := self translation ) isZero
		ifTrue: [ self component verticesDo: aBlock ]
		ifFalse: [ self component verticesDo: [:each | aBlock value: each + t ] ]! !

Geometric3DWrapper subclass: #ColorWrapper
	instanceVariableNames: 'color'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Wrappers3D'!

!ColorWrapper methodsFor: 'testing' stamp: 'emm 02/09/2012 23:45'!
canBeTextureWrapped

	^false! !

!ColorWrapper methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:45'!
color

	"Answer the value of color"

	^color! !

!ColorWrapper methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:45'!
color: aValue

	"Set the value of color"

	color := aValue! !

!ColorWrapper methodsFor: 'copying' stamp: 'emm 02/09/2012 23:45'!
copyEmpty

	^super copyEmpty color: Color black! !

!ColorWrapper methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:45'!
facesDo: aBlock
	"on default, the request is send to the component"

	self component facesDo: [ :each |
		aBlock value: ((ColoredPolygon3D withAll: each asPolygon3D) color: self color)]! !

!ColorWrapper methodsFor: 'kind-dispatching' stamp: 'emm 02/09/2012 23:45'!
kindDo: aRequestor
	
	^aRequestor doColorWrapper: self! !

!ColorWrapper methodsFor: 'printing' stamp: 'emm 02/09/2012 23:45'!
printAttributesOn: aStream indent: level
	"Answer whether attributes were written"

	aStream crtab: level ;nextPutAll: 'color:' ;print: self color.
	^true! !

!ColorWrapper methodsFor: 'transforming' stamp: 'emm 02/09/2012 23:45'!
rotateBy: aPoint3D

	geometric := geometric rotateBy: aPoint3D! !

!ColorWrapper methodsFor: 'transforming' stamp: 'emm 02/09/2012 23:45'!
scaleBy: aPoint3D

	geometric := geometric scaleBy: aPoint3D! !

!ColorWrapper methodsFor: 'transforming' stamp: 'emm 02/09/2012 23:45'!
translateBy: aPoint3D

	geometric := geometric translateBy: aPoint3D! !

Geometric3DWrapper subclass: #FractionTransformationWrapper
	instanceVariableNames: 'fractionBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Wrappers3D'!

!FractionTransformationWrapper methodsFor: 'computing' stamp: 'emm 02/09/2012 23:45'!
computeVertexAtFraction: fraction

	^ self component computeVertexAtFraction: ( self fractionBlock value: fraction )! !

!FractionTransformationWrapper methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:45'!
fractionBlock

	"Answer the value of fractionBlock"

	^fractionBlock! !

!FractionTransformationWrapper methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:45'!
fractionBlock: aValue

	"Set the value of fractionBlock"

	fractionBlock := aValue! !

!Geometric3DWrapper class methodsFor: '*Zenna-Wrappers3D' stamp: 'emm 02/09/2012 23:45'!
centering: aGeometric 

	^Centering3DWrapper on: aGeometric! !

!Geometric3DWrapper class methodsFor: '*Zenna-Wrappers3D' stamp: 'emm 02/09/2012 23:45'!
on: aGeometric

	^self new component: aGeometric! !

!Geometric3DWrapper class methodsFor: '*Zenna-Wrappers3D' stamp: 'emm 02/09/2012 23:45'!
on: aGeometric rotateBy: aPoint

	^(Rotating3DWrapper on: aGeometric) rotation: aPoint! !

!Geometric3DWrapper class methodsFor: '*Zenna-Wrappers3D' stamp: 'emm 02/09/2012 23:45'!
on: aGeometric scaleBy: aPoint

	^(Scaling3DWrapper on: aGeometric) scale: aPoint! !

!Geometric3DWrapper class methodsFor: '*Zenna-Wrappers3D' stamp: 'emm 02/09/2012 23:45'!
on: aGeometric translateBy: aPoint

	^(Translating3DWrapper on: aGeometric) translation: aPoint! !

!Geometric3DWrapper class methodsFor: '*Zenna-Wrappers3D' stamp: 'emm 02/09/2012 23:45'!
on: aGeometric withMargins: aPoint

	^(Margin3DWrapper on: aGeometric) margin: aPoint! !

!Geometric3DWrapper methodsFor: '*Zenna-Wrappers3D' stamp: 'emm 02/09/2012 23:45'!
addTo: aContainer

	^aContainer addGeometric3DWrapper: self! !

!Geometric3DWrapper methodsFor: '*Zenna-Wrappers3D' stamp: 'emm 02/09/2012 23:45'!
asWrapperOnDefault

	"Answer a new wrapper that when transforming a default instance results in the receiver"

	^self component: ( self component asWrapperOnDefault )! !

!Geometric3DWrapper methodsFor: '*Zenna-Wrappers3D' stamp: 'emm 02/09/2012 23:45'!
canBeTextureWrapped

	^self component canBeTextureWrapped! !

!Geometric3DWrapper methodsFor: '*Zenna-Wrappers3D' stamp: 'emm 02/09/2012 23:45'!
collectWrappersInto: aCollection

	aCollection add: self.
	self component collectWrappersInto: aCollection.
	^aCollection! !

!Geometric3DWrapper methodsFor: '*Zenna-Wrappers3D' stamp: 'emm 02/09/2012 23:45'!
component
	"Adaptor message"
	^geometric! !

!Geometric3DWrapper methodsFor: '*Zenna-Wrappers3D' stamp: 'emm 02/09/2012 23:45'!
component: aValue
	"Adaptor message"
	geometric := aValue! !

!Geometric3DWrapper methodsFor: '*Zenna-Wrappers3D' stamp: 'emm 02/09/2012 23:45'!
computeSolidBetween: aParam and: secondParam 

	^self transformedSolid: ( self component computeSolidBetween: aParam and: secondParam  )! !

!Geometric3DWrapper methodsFor: '*Zenna-Wrappers3D' stamp: 'emm 02/09/2012 23:45'!
computeVertexAt: aParameter

	^self transformedPoint: ( self component computeVertexAt: aParameter )! !

!Geometric3DWrapper methodsFor: '*Zenna-Wrappers3D' stamp: 'emm 02/09/2012 23:45'!
computeVertexAt: aParameter at: secondParameter

	^self transformedPoint: ( self component computeVertexAt: aParameter at: secondParameter )! !

!Geometric3DWrapper methodsFor: '*Zenna-Wrappers3D' stamp: 'emm 02/09/2012 23:45'!
copyEmpty

	^self copy component: nil! !

!Geometric3DWrapper methodsFor: '*Zenna-Wrappers3D' stamp: 'emm 02/09/2012 23:45'!
decomposedSolidsDo: aBlock

	self component decomposedSolidsDo: [ :each |
		aBlock value: ( self shallowCopy component: each ) ]! !

!Geometric3DWrapper methodsFor: '*Zenna-Wrappers3D' stamp: 'emm 02/09/2012 23:45'!
degeneralized

	"Until I find a better name..."

	^self component degeneralizedWrapBy: self! !

!Geometric3DWrapper methodsFor: '*Zenna-Wrappers3D' stamp: 'emm 02/09/2012 23:45'!
degeneralizedWrapBy: aWrapper

	"Until I find a better name..."

	| newComponent |
	newComponent := self component degeneralizedWrapBy: self.
	self component: ( aWrapper shallowCopy component: newComponent ).
	^self ! !

!Geometric3DWrapper methodsFor: '*Zenna-Wrappers3D' stamp: 'emm 02/09/2012 23:45'!
facesDo: aBlock
	"on default, the request is send to the component"

	self component facesDo: aBlock! !

!Geometric3DWrapper methodsFor: '*Zenna-Wrappers3D' stamp: 'emm 02/09/2012 23:45'!
geometric

	^geometric! !

!Geometric3DWrapper methodsFor: '*Zenna-Wrappers3D' stamp: 'emm 02/09/2012 23:45'!
geometric: aValue

	geometric := aValue! !

!Geometric3DWrapper methodsFor: '*Zenna-Wrappers3D' stamp: 'emm 02/09/2012 23:45'!
interpolatorUsingAll: aParamterCollection
	
	| interpolator |
	interpolator := self leafComponent interpolatorUsingAll: aParamterCollection.
	interpolator component: self.
	^interpolator! !

!Geometric3DWrapper methodsFor: '*Zenna-Wrappers3D' stamp: 'emm 02/09/2012 23:45'!
interpolatorUsingAngleIncrement: stepAngle
	
	| interpolator |
	interpolator := self leafComponent interpolatorUsingAngleIncrement: stepAngle.
	interpolator component: self.
	^interpolator! !

!Geometric3DWrapper methodsFor: '*Zenna-Wrappers3D' stamp: 'emm 02/09/2012 23:45'!
interpolatorUsingEquidistance: distanceBetweenVertices 
	
	| interpolator |
	interpolator := self leafComponent interpolatorUsingEquidistance: distanceBetweenVertices .
	interpolator component: self.
	^interpolator! !

!Geometric3DWrapper methodsFor: '*Zenna-Wrappers3D' stamp: 'emm 02/09/2012 23:45'!
kindDo: aRequestor

	^aRequestor doGeometric3DWrapper: self! !

!Geometric3DWrapper methodsFor: '*Zenna-Wrappers3D' stamp: 'emm 02/09/2012 23:45'!
leafComponent
	
	^self component leafComponent! !

!Geometric3DWrapper methodsFor: '*Zenna-Wrappers3D' stamp: 'emm 02/09/2012 23:45'!
pointCollectionClass

	^self component pointCollectionClass! !

!Geometric3DWrapper methodsFor: '*Zenna-Wrappers3D' stamp: 'emm 02/09/2012 23:45'!
postCopy

	geometric := geometric copy! !

!Geometric3DWrapper methodsFor: '*Zenna-Wrappers3D' stamp: 'emm 02/09/2012 23:45'!
printAttributesOn: aStream indent: level
	"Answer whether attributes were written"

	^false! !

!Geometric3DWrapper methodsFor: '*Zenna-Wrappers3D' stamp: 'emm 02/09/2012 23:45'!
printOn: aStream indent: level 

	| hasAttributes |
	aStream nextPutAll: self class name ; nextPutAll: ' new '.
	hasAttributes := self printAttributesOn: aStream indent: level + 1.
	aStream 
		crtab: level + 1
		;nextPutAll: ( hasAttributes ifTrue:[ ';' ] ifFalse:[ '' ] )
		;nextPutAll: 'geometric:('.
	self component printOn: aStream indent: level + 2.
	aStream nextPut: $)! !

!Geometric3DWrapper methodsFor: '*Zenna-Wrappers3D' stamp: 'emm 02/09/2012 23:45'!
propagatedTransformedPoint: aPoint3D

	"Answer the result of transforming @aPoint3D
	all the way through the wrapper chain starting at its leaf"

	^self transformedPoint: ( self component propagatedTransformedPoint: aPoint3D )! !

!Geometric3DWrapper methodsFor: '*Zenna-Wrappers3D' stamp: 'emm 02/09/2012 23:45'!
rotateBy: aPoint
	"on default, answer a new wrapper"

	^self class on: self rotateBy: aPoint! !

!Geometric3DWrapper methodsFor: '*Zenna-Wrappers3D' stamp: 'emm 02/09/2012 23:45'!
scaleBy: aPoint
	"on default, answer a new wrapper"

	^self class on: self scaleBy: aPoint! !

!Geometric3DWrapper methodsFor: '*Zenna-Wrappers3D' stamp: 'emm 02/09/2012 23:45'!
transformFace: aFace
	"On default, the receiver does not apply a transformation"

	^aFace! !

!Geometric3DWrapper methodsFor: '*Zenna-Wrappers3D' stamp: 'emm 02/09/2012 23:45'!
transformedPoint: aPoint
	"Answer a new Point3D transformed by the receiver"

	^aPoint! !

!Geometric3DWrapper methodsFor: '*Zenna-Wrappers3D' stamp: 'emm 02/09/2012 23:45'!
transformedSolid: aSolid
	"On default, the receiver does not apply a transformation"

	^aSolid! !

Geometric3DWrapper subclass: #Hollowing3DWrapper
	instanceVariableNames: 'thickness'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Wrappers3D'!

!Hollowing3DWrapper methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:45'!
computeSolidBetween: aParam and: secondParam 

	^self component 
		computeHollowSolidBetween: aParam 
		and: secondParam
		thickness: self thickness! !

!Hollowing3DWrapper methodsFor: 'copying' stamp: 'emm 02/09/2012 23:45'!
copyEmpty

	^super copyEmpty thickness: 0! !

!Hollowing3DWrapper methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:45'!
kindDo: aRequestor

	^aRequestor doHollowing3DWrapper: self! !

!Hollowing3DWrapper methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:45'!
thickness

	"Answer the value of thickness"

	^thickness! !

!Hollowing3DWrapper methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:45'!
thickness: aValue

	"Set the value of thickness"

	thickness := aValue! !

Geometric3DWrapper subclass: #Margin3DWrapper
	instanceVariableNames: 'originMargin cornerMargin'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Wrappers3D'!

!Margin3DWrapper methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:45'!
bounds

	| geoBounds |
	geoBounds := self component bounds.
	^geoBounds origin - self originMargin corner: geoBounds corner + self cornerMargin! !

!Margin3DWrapper methodsFor: 'copying' stamp: 'emm 02/09/2012 23:45'!
copyEmpty

	^(super copyEmpty)
			originMargin: Point3D zero
			; cornerMargin: Point3D zero! !

!Margin3DWrapper methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:45'!
cornerMargin

	"Answer the value of cornerMargin"

	^cornerMargin! !

!Margin3DWrapper methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:45'!
cornerMargin: aValue

	"Set the value of cornerMargin"

	cornerMargin := aValue! !

!Margin3DWrapper methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:45'!
facesDo: aBlock 
	
	self component facesDo: aBlock! !

!Margin3DWrapper methodsFor: 'offsets' stamp: 'emm 02/09/2012 23:45'!
lefOffset: aNumber

	originMargin y: aNumber! !

!Margin3DWrapper methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:45'!
margin: aValue

	self originMargin: aValue asPoint3D.
	self cornerMargin: aValue asPoint3D! !

!Margin3DWrapper methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:45'!
originMargin

	"Answer the value of originMargin"

	^originMargin! !

!Margin3DWrapper methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:45'!
originMargin: aValue

	"Set the value of originMargin"

	originMargin := aValue! !

!Margin3DWrapper methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:45'!
solidsDo: aBlock 

	self component solidsDo:aBlock! !

!Margin3DWrapper methodsFor: 'offsets' stamp: 'emm 02/09/2012 23:45'!
topOffset: aNumber

	cornerMargin z: aNumber! !

Geometric3DWrapper subclass: #NamingWrapper
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Wrappers3D'!

!NamingWrapper methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:45'!
kindDo: aRequestor
	
	^aRequestor doNamingWrapper: self! !

!NamingWrapper methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:45'!
name

	"Answer the value of name"

	^name! !

!NamingWrapper methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:45'!
name: aValue

	"Set the value of name"

	name := aValue! !

Geometric3DWrapper subclass: #Reversing3DWrapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Wrappers3D'!

!Reversing3DWrapper methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:45'!
kindDo: aRequestor

	^aRequestor doReversing3DWrapper: self! !

Geometric3DWrapper subclass: #Rotating3DWrapper
	instanceVariableNames: 'rotation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Wrappers3D'!

Rotating3DWrapper subclass: #AutoRotationWrapper
	instanceVariableNames: 'speed'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-FormatVRML'!

!AutoRotationWrapper methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:54'!
kindDo: aRequestor

	^aRequestor doAutoRotationWrapper: self! !

!AutoRotationWrapper methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:54'!
rpm: rotationsPerMinute
	speed := rotationsPerMinute / 60! !

!AutoRotationWrapper methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:54'!
speed

	"Answer the value of speed"

	^speed! !

!AutoRotationWrapper methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:54'!
speed: aValue

	"Set the value of speed"

	self deprecated: #rpm:.
	speed := aValue! !

!Rotating3DWrapper methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:45'!
bounds
	"Answer the bounding box for the receiver"

	^self component bounds rotatedBy: self rotation! !

!Rotating3DWrapper methodsFor: 'copying' stamp: 'emm 02/09/2012 23:45'!
copyEmpty

	^super copyEmpty rotation: Point3D zero! !

!Rotating3DWrapper methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:45'!
decomposedSolidsDo: aBlock

	| r |
	r := self rotation.
	self component decomposedSolidsDo: [ :each |
		each class == self class "merge rotating wrappers"
			ifTrue: [ aBlock value: ( each rotateBy: r ) ]
			ifFalse: [ aBlock value: ( each wrapRotateBy: r ) ] ]! !

!Rotating3DWrapper methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:45'!
facesDo: aBlock 
	
	| r |
	r := self rotation.
	self component facesDo: [ :each | aBlock value: ( each rotatedBy: r ) ]! !

!Rotating3DWrapper methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:45'!
kindDo: aRequestor

	^aRequestor doRotating3DWrapper: self! !

!Rotating3DWrapper methodsFor: 'transforming' stamp: 'emm 02/09/2012 23:45'!
mirrorInYZ

	self component: self component mirroredInYZ! !

!Rotating3DWrapper methodsFor: 'copying' stamp: 'emm 02/09/2012 23:45'!
postCopy

	super postCopy.
	self rotation: self rotation copy! !

!Rotating3DWrapper methodsFor: 'printing' stamp: 'emm 02/09/2012 23:45'!
printAttributesOn: aStream indent: level 

	"Answer whether attributes were written"
	
	aStream crtab: level ; nextPutAll: 'rotation:' ; print: self rotation.
	self rotation isNil 
		ifFalse: [ aStream nextPutAll: ' "' ; print: self rotation deg ; nextPut: $" ].
	^true! !

!Rotating3DWrapper methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:45'!
rotation

	^rotation value! !

!Rotating3DWrapper methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:45'!
rotation: aValue

	rotation := aValue! !

!Rotating3DWrapper methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:45'!
solidsDo: aBlock 
	
	| r |
	r := self rotation.
	self component solidsDo: [ :each | aBlock value: ( each rotatedBy: r ) ]! !

!Rotating3DWrapper methodsFor: 'transforming' stamp: 'emm 02/09/2012 23:45'!
transformedPoint: aPoint
	"Answer a new Point3D transformed by the receiver"

	^aPoint rotatedBy: self rotation! !

!Rotating3DWrapper methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:45'!
verticesDo: aBlock 
	
	| r |
	r := self rotation.
	self component verticesDo: [ :each | aBlock value: ( each rotatedBy: r ) ]! !

Geometric3DWrapper subclass: #Scaling3DWrapper
	instanceVariableNames: 'scale'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Wrappers3D'!

!Scaling3DWrapper methodsFor: 'copying' stamp: 'emm 02/09/2012 23:45'!
copyEmpty

	^super copyEmpty scale: Point3D unity! !

!Scaling3DWrapper methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:45'!
facesDo: aBlock

	geometric facesDo: [:each | 
		aBlock value: (each scaledBy: scale)]! !

!Scaling3DWrapper methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:45'!
kindDo: aRequestor

	^aRequestor doScaling3DWrapper: self! !

!Scaling3DWrapper methodsFor: 'copying' stamp: 'emm 02/09/2012 23:45'!
postCopy

	super postCopy.
	scale := scale copy! !

!Scaling3DWrapper methodsFor: 'printing' stamp: 'emm 02/09/2012 23:45'!
printAttributesOn: aStream indent: level
	"Answer whether attributes were written"

	aStream crtab: level ;nextPutAll: 'scale:' ;print: self scale.
	^true! !

!Scaling3DWrapper methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:45'!
scale

	^scale! !

!Scaling3DWrapper methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:45'!
scale: aValue 

	scale := aValue asPoint3D! !

!Scaling3DWrapper methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:45'!
solidsDo: aBlock 

	self scale isZero
		ifTrue: [ self component solidsDo: aBlock ]
		ifFalse: [ self component solidsDo: [ :each | 
			aBlock value: ( each scaledBy: self scale ) ] ]! !

!Scaling3DWrapper methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:45'!
verticesDo: aBlock 

	geometric verticesDo: [:each | 
		aBlock value: (each scaledBy: scale)]! !

Geometric3DWrapper subclass: #TextureWrapper
	instanceVariableNames: 'texture bilinear translation rotation color uvw'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Wrappers3D'!

!TextureWrapper class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:45'!
new

	"Answer a new instance of the receiver and initialize it"

	^super new initialize! !

!TextureWrapper methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:45'!
bilinear

	"Answer the value of bilinear"

	^bilinear! !

!TextureWrapper methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:45'!
bilinear: aValue

	"Set the value of bilinear"

	bilinear := aValue! !

!TextureWrapper methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:45'!
color

	"Answer the value of color"

	^color! !

!TextureWrapper methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:45'!
color: aValue

	"Set the value of color"

	color := aValue! !

!TextureWrapper methodsFor: 'initialize' stamp: 'emm 02/09/2012 23:45'!
initialize

	bilinear := false.
	self uv: 1@1! !

!TextureWrapper methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:45'!
kindDo: aRequestor
	^aRequestor doTextureWrapper: self! !

!TextureWrapper methodsFor: 'transforming' stamp: 'emm 02/09/2012 23:45'!
mirrorInYZ

	self component: self component mirrorInYZ! !

!TextureWrapper methodsFor: 'transforming' stamp: 'emm 02/09/2012 23:45'!
mirroredInYZ

	self component: self component mirroredInYZ! !

!TextureWrapper methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:45'!
rotation

	"Answer the value of rotation"

	^rotation! !

!TextureWrapper methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:45'!
rotation: aValue

	"Set the value of rotation"

	rotation := aValue! !

!TextureWrapper methodsFor: 'aliasing' stamp: 'emm 02/09/2012 23:45'!
scale
	^uvw xy! !

!TextureWrapper methodsFor: 'aliasing' stamp: 'emm 02/09/2012 23:45'!
scale: uvPoint
	uvw := uvPoint @ 1.! !

!TextureWrapper methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:45'!
texture

	"Answer the value of texture"

	^texture! !

!TextureWrapper methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:45'!
texture: aValue

	"Set the value of texture"

	texture := aValue! !

!TextureWrapper methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:45'!
translation

	"Answer the value of translation"

	^translation! !

!TextureWrapper methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:45'!
translation: aValue

	"Set the value of translation"

	translation := aValue! !

!TextureWrapper methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:45'!
uv
	^uvw xy! !

!TextureWrapper methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:45'!
uv: uvPoint
	uvw := uvPoint @ 1! !

!TextureWrapper methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:45'!
uvw
	^uvw! !

Geometric3DWrapper subclass: #TransformingElementWrapper
	instanceVariableNames: 'transformation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Wrappers3D'!

!TransformingElementWrapper class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:45'!
new

	^super new initialize! !

!TransformingElementWrapper methodsFor: 'testing' stamp: 'emm 02/09/2012 23:45'!
canBeTextureWrapped

	^false! !

!TransformingElementWrapper methodsFor: 'initialize-release' stamp: 'emm 02/09/2012 23:45'!
initialize

	transformation := Transformation3D new! !

!TransformingElementWrapper methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:45'!
kindDo: aRequestor

	^aRequestor doTransformingElementWrapper: self! !

!TransformingElementWrapper methodsFor: 'delegating' stamp: 'emm 02/09/2012 23:45'!
name

	"Dispatch to the component"
	
	^self component name! !

!TransformingElementWrapper methodsFor: 'delegating' stamp: 'emm 02/09/2012 23:45'!
receiverForEventIn: aSymbol

	| variable selector |
	variable := Variable new name: self name , '_' , aSymbol.
	selector := super selectorForEventIn: aSymbol. "Use super because we want to set the property"
	self perform: selector with: variable.	
	^variable! !

!TransformingElementWrapper methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:45'!
rotation

	"Answer the value of rotation"

	^self transformation rotation! !

!TransformingElementWrapper methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:45'!
rotation: aValue

	"Set the value of rotation"

	self transformation rotation: aValue! !

!TransformingElementWrapper methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:45'!
scale

	"Answer the value of scale"

	^self transformation scale! !

!TransformingElementWrapper methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:45'!
scale: aValue

	"Set the value of scale"

	self transformation scale: aValue! !

!TransformingElementWrapper methodsFor: 'delegating' stamp: 'emm 02/09/2012 23:45'!
selectorForEventIn: aSymbol

	"Answer the selector to set the variable's value"
	
	^#value:! !

!TransformingElementWrapper methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:45'!
transformation

	"Answer the value of transformation"

	^transformation! !

!TransformingElementWrapper methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:45'!
transformation: aValue

	"Set the value of transformation"

	transformation := aValue! !

!TransformingElementWrapper methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:45'!
translation

	"Answer the value of translation"

	^self transformation translation! !

!TransformingElementWrapper methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:45'!
translation: aValue

	"Set the value of translation"

	self transformation translation: aValue! !

Geometric3DWrapper subclass: #Translating3DWrapper
	instanceVariableNames: 'translation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Wrappers3D'!

!Translating3DWrapper methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:45'!
bounds

	^self component bounds translatedBy: self translation! !

!Translating3DWrapper methodsFor: 'copying' stamp: 'emm 02/09/2012 23:45'!
copyEmpty

	^super copyEmpty translation: Point3D zero! !

!Translating3DWrapper methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:45'!
decomposedSolidsDo: aBlock

	| t |
	t := self translation.
	self component decomposedSolidsDo: [ :each |
		each class == self class "merge translating wrappers"
			ifTrue: [ aBlock value: ( each translateBy: t ) ]
			ifFalse: [ aBlock value: ( each wrapTranslateBy: t ) ] ]! !

!Translating3DWrapper methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:45'!
facesDo: aBlock 
	
	| t |
	t := self translation.
	t isZero
		ifTrue: [ self component facesDo: aBlock ]
		ifFalse: [ self component facesDo: [ :each | 
			aBlock value: ( each translatedBy: t ) ] ]! !

!Translating3DWrapper methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:45'!
kindDo: aRequestor

	^aRequestor doTranslating3DWrapper: self! !

!Translating3DWrapper methodsFor: 'transforming' stamp: 'emm 02/09/2012 23:45'!
mirrorInYZ

	translation := translation x negated, translation y , translation z.
	self component: self component mirroredInYZ! !

!Translating3DWrapper methodsFor: 'copying' stamp: 'emm 02/09/2012 23:45'!
postCopy

	super postCopy.
	self translation: self translation copy! !

!Translating3DWrapper methodsFor: 'printing' stamp: 'emm 02/09/2012 23:45'!
printAttributesOn: aStream indent: level
	"Answer whether attributes were written"

	aStream crtab: level ;nextPutAll: 'translation:' ;print: self translation.
	^true! !

!Translating3DWrapper methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:45'!
solidsDo: aBlock 

	| t |
	( t := self translation ) isZero
		ifTrue: [ self component solidsDo: aBlock ]
		ifFalse: [ self component solidsDo: [ :each | 
			aBlock value: ( each translatedBy: t ) ] ]! !

!Translating3DWrapper methodsFor: 'transforming' stamp: 'emm 02/09/2012 23:45'!
transformFace: aFace

	| t |
	^( t := self translation) isZero
		ifTrue: [ aFace ]
		ifFalse: [ aFace translateBy: t ]! !

!Translating3DWrapper methodsFor: 'transforming' stamp: 'emm 02/09/2012 23:45'!
transformedPoint: aPoint
	"Answer a new Point3D transformed by the receiver"

	^aPoint + self translation! !

!Translating3DWrapper methodsFor: 'transforming' stamp: 'emm 02/09/2012 23:45'!
translateBy: aPoint

	self translation: self translation + aPoint! !

!Translating3DWrapper methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:45'!
translation

	^translation value! !

!Translating3DWrapper methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:45'!
translation: aValue

	translation := aValue! !

!Translating3DWrapper methodsFor: 'enumerating' stamp: 'emm 9/23/2012 21:56'!
verticesDo: aBlock
	geometric verticesDo: [ :each | aBlock value: (each translatedBy: translation) ]! !

Geometric3D subclass: #HexahedronNode
	instanceVariableNames: 'neighbors vertices'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Shapes3D'!

!HexahedronNode class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:40'!
arcFromTop: startTopFace rotating: howMany by: rotationPoint

	| start node topFace |
	start := node := self new.
	topFace := startTopFace.
	node setTop: topFace.
	node setBottomToTopOf: node.
	howMany timesRepeat:
		[ node extendTopToFace: ( topFace := topFace rotatedBy: rotationPoint ).
		node := node topNode ].
	node topNode: start.
"	start setBottomToTopOf: node."
	^node! !

!HexahedronNode class methodsFor: 'examples' stamp: 'emm 02/09/2012 23:40'!
example0
	"self example0"

	^self fromCube: (Box size: 20).! !

!HexahedronNode class methodsFor: 'examples' stamp: 'emm 02/09/2012 23:40'!
example1
	"self example1"

	| start |
	start := self fromCube: ( Box size: 20 ).
	start extendTopBy: 0@0@5.
	^start extendBottomBy: 0@0@-25! !

!HexahedronNode class methodsFor: 'examples' stamp: 'emm 02/09/2012 23:40'!
example2
	"self example2"

	| bottom cube top |
	cube := Box size: 20.
	bottom := self fromCube: cube.
	top := self fromCube: cube.
	top bottomNode: bottom.
	top alignBottomToTopOf: bottom.
	^bottom! !

!HexahedronNode class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:40'!
fromCube: aCube

	^( self new )
		setTop: aCube top
		; setBottom: aCube bottom! !

!HexahedronNode class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:40'!
fromTorus: aTorus! !

!HexahedronNode class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:40'!
new
	^super new initialize! !

!HexahedronNode class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:40'!
ringFromBottom: startBottomFace rotatingBy: rotationPoint

	| start node topFace howMany  |
	rotationPoint isXRotation
		ifTrue: [ howMany := 360 rad / rotationPoint x ].
	rotationPoint isYRotation
		ifTrue: [ howMany := 360 rad / rotationPoint y ].
	rotationPoint isZRotation
		ifTrue: [ howMany := 360 rad / rotationPoint z ].

	"the order of the vertices for the two faces will initially be ignored.
	However, the topFace must have the correct order"

	start := node := self new.
	start setBottom: startBottomFace.
	start setTop: ( startBottomFace rotatedBy: rotationPoint ).
	topFace := start top.

	howMany - 1
	 	 timesRepeat:
			[ node extendTopToFace: ( topFace := topFace rotatedBy: rotationPoint ).
		node := node topNode ].
	node topNode: start.
	^start! !

!HexahedronNode methodsFor: 'accessing-faces' stamp: 'emm 02/09/2012 23:39'!
alignBottomToTopOf: aNode
	
	"Move the receiver such that its bottom
	coincides with the top of <aNode>"

	| delta |
	delta := aNode leftFrontTop - self leftFrontBottom.
	self leftFrontBottom: aNode leftFrontTop.
	self leftFrontTop: self leftFrontTop + delta.

	delta := aNode rightFrontTop - self rightFrontBottom.
	self rightFrontBottom: aNode rightFrontTop.
	self rightFrontTop: self rightFrontTop + delta.

	delta := aNode leftBackTop - self leftBackBottom.
	self leftBackBottom: aNode leftBackTop.
	self leftBackTop: self leftBackTop + delta.

	delta := aNode rightBackTop - self rightBackBottom.
	self rightBackBottom: aNode rightBackTop.
	self rightBackTop: self rightBackTop + delta.! !

!HexahedronNode methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:39'!
allFacesDo: aBlock
	
	self allSolidsDo:[ :each | each facesDo: aBlock ]! !

!HexahedronNode methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:39'!
allSolidsDo: aBlock

	self solidsDo: aBlock visited: Set new! !

!HexahedronNode methodsFor: 'accessing-faces' stamp: 'emm 02/09/2012 23:39'!
back
	"Answer the back face oriented towards negative X"

	^( Polygon3D new )
		add: self leftBackBottom
		; add: self leftBackTop
		; add: self rightBackTop
		; add: self rightBackBottom
		; reverseOriented! !

!HexahedronNode methodsFor: 'private' stamp: 'emm 02/09/2012 23:39'!
backIndices

	^#(5 6 7 8 )! !

!HexahedronNode methodsFor: 'accessing-nodes' stamp: 'emm 02/09/2012 23:39'!
backNode

	^neighbors at: 5! !

!HexahedronNode methodsFor: 'accessing-nodes' stamp: 'emm 02/09/2012 23:39'!
backNode: aNode

	( neighbors at: 5 ) == aNode
		ifFalse: 
			[ neighbors at: 5 put: aNode.
			aNode frontNode: ( aNode isNil
				ifTrue: [ nil ]
				ifFalse: [ self ] ) ]! !

!HexahedronNode methodsFor: 'accessing-faces' stamp: 'emm 02/09/2012 23:39'!
bottom
	"Answer the top face oriented towards negative Z"

	^( Polygon3D new )
		add: self leftFrontBottom
		; add: self leftBackBottom
		; add: self rightBackBottom
		; add: self rightFrontBottom
		; yourself! !

!HexahedronNode methodsFor: 'accessing-faces' stamp: 'emm 02/09/2012 23:39'!
bottom: aPoint3DCollection

	self setBottom: aPoint3DCollection.
	self bottomNode isNil
		ifFalse: [ self bottomNode setTop: aPoint3DCollection ]! !

!HexahedronNode methodsFor: 'private-extending' stamp: 'emm 02/09/2012 23:39'!
bottomExtent: aPoint3D

	"Compute the top of the receiver by calculating
	the vertices relatively to the receiver's bottom with <aPoint3D>"

	self leftFrontTop: self leftFrontBottom + aPoint3D.
	self rightFrontTop: self rightFrontBottom + aPoint3D.
	self leftBackTop: self leftBackBottom + aPoint3D.
	self rightBackTop: self rightBackBottom + aPoint3D.! !

!HexahedronNode methodsFor: 'private' stamp: 'emm 02/09/2012 23:39'!
bottomIndices

	^#(2 4 6 8)! !

!HexahedronNode methodsFor: 'accessing-nodes' stamp: 'emm 02/09/2012 23:39'!
bottomNode

	^neighbors at: 4! !

!HexahedronNode methodsFor: 'accessing-nodes' stamp: 'emm 02/09/2012 23:39'!
bottomNode: aNode

	( neighbors at: 4 ) == aNode
		ifFalse: 
			[ neighbors at: 4 put: aNode.
			aNode topNode: ( aNode isNil
				ifTrue: [ nil ]
				ifFalse: [ self ] ) ]! !

!HexahedronNode methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:39'!
bounds
	
	^self mergedBoundsWith: self localBounds visited: Set new! !

!HexahedronNode methodsFor: 'extending' stamp: 'emm 02/09/2012 23:39'!
extendBottomBy: deltaPoint

	| newNode |
	newNode := self class new.
	newNode setTopToBottomOf: self.
	newNode topExtent: deltaPoint.
	self bottomNode: newNode! !

!HexahedronNode methodsFor: 'extending' stamp: 'emm 02/09/2012 23:39'!
extendRotateTopBy: rotationPoint

	| newNode |
	newNode := self class new.
	newNode setBottomToTopOf: self.
	newNode setTop: (self top rotatedBy: rotationPoint).
	self topNode: newNode! !

!HexahedronNode methodsFor: 'extending' stamp: 'emm 02/09/2012 23:39'!
extendTopBy: deltaPoint

	| newNode |
	newNode := self class new.
	newNode setBottomToTopOf: self.
	newNode bottomExtent: deltaPoint.
	self topNode: newNode! !

!HexahedronNode methodsFor: 'extending' stamp: 'emm 02/09/2012 23:39'!
extendTopToFace: topFace

	| newNode |
	newNode := self class new.
	newNode setBottomToTopOf: self.
	newNode setTopFromPoints: topFace.
	self topNode: newNode! !

!HexahedronNode methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:39'!
facesDo: aBlock
	
	self facesDo: aBlock visited: Set new! !

!HexahedronNode methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:39'!
facesDo: aBlock visited: nodeSet
	
	"For every face of the receiver to which no
	neighboring node is connected, evaluate
	<aBlock>. The normal of such a face with
	point outside the receiver, marking it hollow"

	nodeSet add: self.
	self topNode isNil
		ifTrue: [ aBlock value: self top ]
		ifFalse:
			[ (nodeSet includes: self topNode)
				ifFalse: [ self topNode facesDo: aBlock visited: nodeSet ]].
	self bottomNode isNil
		ifTrue: [ aBlock value: self bottom ]
		ifFalse:
			[ (nodeSet includes: self bottomNode)
				ifFalse: [ self bottomNode facesDo: aBlock visited: nodeSet ]].
	self leftNode isNil
		ifTrue: [ aBlock value: self left ]
		ifFalse:
			[ (nodeSet includes: self leftNode)
				ifFalse: [ self leftNode facesDo: aBlock visited: nodeSet ]].
	self rightNode isNil
		ifTrue: [ aBlock value: self right ]
		ifFalse:
			[ (nodeSet includes: self rightNode)
				ifFalse: [ self rightNode facesDo: aBlock visited: nodeSet ]].
	self frontNode isNil
		ifTrue: [ aBlock value: self front ]
		ifFalse:
			[ (nodeSet includes: self frontNode)
				ifFalse: [ self frontNode facesDo: aBlock visited: nodeSet ]].
	self backNode isNil
		ifTrue: [ aBlock value: self back ]
		ifFalse:
			[ (nodeSet includes: self backNode)
				ifFalse: [ self backNode facesDo: aBlock visited: nodeSet ]].! !

!HexahedronNode methodsFor: 'accessing-faces' stamp: 'emm 02/09/2012 23:39'!
front
	"Answer the front face oriented towards positive X"

	^( Polygon3D new )
		add: self leftFrontBottom
		; add: self rightFrontBottom
		; add: self rightFrontTop
		; add: self leftFrontTop
		; reverseOriented! !

!HexahedronNode methodsFor: 'private' stamp: 'emm 02/09/2012 23:39'!
frontIndices

	^#(1 2 3 4)! !

!HexahedronNode methodsFor: 'accessing-nodes' stamp: 'emm 02/09/2012 23:40'!
frontNode

	^neighbors at: 6! !

!HexahedronNode methodsFor: 'accessing-nodes' stamp: 'emm 02/09/2012 23:39'!
frontNode: aNode

	( neighbors at: 6 ) == aNode
		ifFalse: 
			[ neighbors at: 6 put: aNode.
			aNode backNode: ( aNode isNil
				ifTrue: [ nil ]
				ifFalse: [ self ] ) ]! !

!HexahedronNode methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:39'!
indexOfFace: faceName
	"See class comment"

	^#(left top right bottom back front) indexOf: faceName! !

!HexahedronNode methodsFor: 'initialize-release' stamp: 'emm 02/09/2012 23:39'!
initialize
	
	| unitCube |
	neighbors := Array new: 6.
	vertices := Array new: 8.
	unitCube := Box new centered.
	self setTop: unitCube top.
	self setBottom: unitCube bottom! !

!HexahedronNode methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:39'!
kindDo: aRequestor

	^aRequestor doFaceComposite: self! !

!HexahedronNode methodsFor: 'accessing-faces' stamp: 'emm 02/09/2012 23:39'!
left
	"Answer the left face oriented towards negative Y"

	"^Polygon3D withAll: ( self leftIndices collect:[ :each | vertices at: each ] )"
	^( Polygon3D new )
		add: self leftFrontBottom
		; add: self leftFrontTop
		; add: self leftBackTop
		; add: self leftBackBottom
		; yourself
		; reverseOriented! !

!HexahedronNode methodsFor: 'accessing-vertices' stamp: 'emm 02/09/2012 23:39'!
leftBackBottom
	
	^vertices at: 6! !

!HexahedronNode methodsFor: 'accessing-vertices' stamp: 'emm 02/09/2012 23:39'!
leftBackBottom: aPoint3D

	self verticesAt: 6 put: aPoint3D! !

!HexahedronNode methodsFor: 'accessing-vertices' stamp: 'emm 02/09/2012 23:39'!
leftBackTop

	^vertices at: 5! !

!HexahedronNode methodsFor: 'accessing-vertices' stamp: 'emm 02/09/2012 23:39'!
leftBackTop: aPoint3D

	self verticesAt: 5 put: aPoint3D! !

!HexahedronNode methodsFor: 'accessing-vertices' stamp: 'emm 02/09/2012 23:39'!
leftFrontBottom

	^vertices at: 2! !

!HexahedronNode methodsFor: 'accessing-vertices' stamp: 'emm 02/09/2012 23:39'!
leftFrontBottom: aPoint3D

	self verticesAt: 2 put: aPoint3D! !

!HexahedronNode methodsFor: 'accessing-vertices' stamp: 'emm 02/09/2012 23:39'!
leftFrontTop

	^vertices at: 1! !

!HexahedronNode methodsFor: 'accessing-vertices' stamp: 'emm 02/09/2012 23:39'!
leftFrontTop: aPoint3D

	self verticesAt: 1 put: aPoint3D! !

!HexahedronNode methodsFor: 'private' stamp: 'emm 02/09/2012 23:39'!
leftIndices

	^#(1 2 5 6)! !

!HexahedronNode methodsFor: 'accessing-nodes' stamp: 'emm 02/09/2012 23:39'!
leftNode

	^neighbors at: 1! !

!HexahedronNode methodsFor: 'accessing-nodes' stamp: 'emm 02/09/2012 23:39'!
leftNode: aNode

	( neighbors at: 1 ) == aNode
		ifFalse: 
			[ neighbors at: 1 put: aNode.
			aNode rightNode: ( aNode isNil
				ifTrue: [ nil ]
				ifFalse: [ self ] ) ]! !

!HexahedronNode methodsFor: 'computing' stamp: 'emm 02/09/2012 23:39'!
localBounds

	^self leftBackBottom corner: self rightFrontTop! !

!HexahedronNode methodsFor: 'computing' stamp: 'emm 02/09/2012 23:39'!
mergedBoundsWith: bounds visited: aNodeCollection 
	
	| mergedBounds |
	mergedBounds := bounds.
	aNodeCollection add: self.
	self 
		neighborsDo: [ :each | mergedBounds := each 	
			mergedBoundsWith: mergedBounds 
			visited: aNodeCollection ] 
		visited: aNodeCollection.
	^self localBounds merge: mergedBounds! !

!HexahedronNode methodsFor: 'private' stamp: 'emm 02/09/2012 23:39'!
neighborsDo: aBlock visited: aNodeCollection 
	
	neighbors do: [ :each | 
		( each notNil
			and: [ ( aNodeCollection includes: each ) not ] ) 
				ifTrue: [ aBlock value: each ] ]! !

!HexahedronNode methodsFor: 'accessing-faces' stamp: 'emm 02/09/2012 23:40'!
right
	"Answer the right face oriented towards positive Y"

	^( Polygon3D new )
		add: self rightFrontBottom
		; add: self rightBackBottom
		; add: self rightBackTop
		; add: self rightFrontTop
		; reverseOriented! !

!HexahedronNode methodsFor: 'accessing-vertices' stamp: 'emm 02/09/2012 23:39'!
rightBackBottom

	^vertices at: 8! !

!HexahedronNode methodsFor: 'accessing-vertices' stamp: 'emm 02/09/2012 23:39'!
rightBackBottom: aPoint3D

	self verticesAt: 8 put: aPoint3D! !

!HexahedronNode methodsFor: 'accessing-vertices' stamp: 'emm 02/09/2012 23:39'!
rightBackTop

	^vertices at: 7! !

!HexahedronNode methodsFor: 'accessing-vertices' stamp: 'emm 02/09/2012 23:39'!
rightBackTop: aPoint3D

	self verticesAt: 7 put: aPoint3D! !

!HexahedronNode methodsFor: 'accessing-vertices' stamp: 'emm 02/09/2012 23:39'!
rightFrontBottom

	^vertices at: 4! !

!HexahedronNode methodsFor: 'accessing-vertices' stamp: 'emm 02/09/2012 23:39'!
rightFrontBottom: aPoint3D

	self verticesAt: 4 put: aPoint3D! !

!HexahedronNode methodsFor: 'accessing-vertices' stamp: 'emm 02/09/2012 23:39'!
rightFrontTop

	^vertices at: 3! !

!HexahedronNode methodsFor: 'accessing-vertices' stamp: 'emm 02/09/2012 23:39'!
rightFrontTop: aPoint3D

	self verticesAt: 3 put: aPoint3D! !

!HexahedronNode methodsFor: 'private' stamp: 'emm 02/09/2012 23:39'!
rightIndices

	^#(3 4 7 8)! !

!HexahedronNode methodsFor: 'accessing-nodes' stamp: 'emm 02/09/2012 23:39'!
rightNode

	^neighbors at: 3! !

!HexahedronNode methodsFor: 'accessing-nodes' stamp: 'emm 02/09/2012 23:39'!
rightNode: aNode

	( neighbors at: 3 ) == aNode
		ifFalse: 
			[ neighbors at: 3 put: aNode.
			aNode leftNode: ( aNode isNil
				ifTrue: [ nil ]
				ifFalse: [ self ] ) ]! !

!HexahedronNode methodsFor: 'accessing-faces' stamp: 'emm 02/09/2012 23:39'!
setBottom: aFace 
	
	self leftFrontBottom: aFace leftFront.
	self rightFrontBottom: aFace rightFront.
	self leftBackBottom: aFace leftBack.
	self rightBackBottom: aFace rightBack! !

!HexahedronNode methodsFor: 'accessing-faces' stamp: 'emm 02/09/2012 23:39'!
setBottomToTopOf: aNode
	
	self leftFrontBottom: aNode leftFrontTop.
	self rightFrontBottom: aNode rightFrontTop.
	self leftBackBottom: aNode leftBackTop.
	self rightBackBottom: aNode rightBackTop.! !

!HexahedronNode methodsFor: 'accessing-faces' stamp: 'emm 02/09/2012 23:39'!
setTop: aFace 
	
	self leftFrontTop: aFace leftFront.
	self rightFrontTop: aFace rightFront.
	self rightBackTop: aFace rightBack.
	self leftBackTop: aFace leftBack.! !

!HexahedronNode methodsFor: 'accessing-faces' stamp: 'emm 02/09/2012 23:39'!
setTopFromPoints: aPoint3DCollection 
	
	self leftFrontTop: ( aPoint3DCollection at: 1 ).
	self rightFrontTop: ( aPoint3DCollection at: 2 ).
	self rightBackTop: ( aPoint3DCollection at: 3 ).
	self leftBackTop: ( aPoint3DCollection at: 4 )! !

!HexahedronNode methodsFor: 'accessing-faces' stamp: 'emm 02/09/2012 23:39'!
setTopToBottomOf: aNode
	
	self leftFrontTop: aNode leftFrontBottom.
	self rightFrontTop: aNode rightFrontBottom.
	self leftBackTop: aNode leftBackBottom.
	self rightBackTop: aNode rightBackBottom.! !

!HexahedronNode methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:39'!
solidsDo: aBlock
	aBlock value: self! !

!HexahedronNode methodsFor: 'private' stamp: 'emm 02/09/2012 23:39'!
solidsDo: aBlock visited: aNodeCollection

	aBlock value: self.
	aNodeCollection add: self.
	self 
		neighborsDo: [ :each | each solidsDo: aBlock visited: aNodeCollection ]
		visited: aNodeCollection! !

!HexahedronNode methodsFor: 'accessing-faces' stamp: 'emm 02/09/2012 23:39'!
strectchBottomToTopOf: aNode
	
	"Strecth the receiver such that its bottom
	coincides with the top of <aNode>"! !

!HexahedronNode methodsFor: 'accessing-faces' stamp: 'emm 02/09/2012 23:39'!
top
	
	"Answer the top face oriented towards positive Z"
	
	^( Polygon3D new ) 
		add: self leftFrontTop
		; add: self rightFrontTop
		; add: self rightBackTop
		; add: self leftBackTop
		; yourself! !

!HexahedronNode methodsFor: 'accessing-faces' stamp: 'emm 02/09/2012 23:40'!
top: aPoint3DCollection

	self setTop: aPoint3DCollection.
	self topNode isNil
		ifFalse: [ self topNode setBottom: aPoint3DCollection ]! !

!HexahedronNode methodsFor: 'private-extending' stamp: 'emm 02/09/2012 23:39'!
topExtent: aPoint3D

	"Compute the bottom of the receiver by calculating
	the vertices relatively to the receiver's top with <aPoint3D>"

	self leftFrontBottom: self leftFrontTop + aPoint3D.
	self rightFrontBottom: self rightFrontTop + aPoint3D.
	self leftBackBottom: self leftBackTop + aPoint3D.
	self rightBackBottom: self rightBackTop + aPoint3D.! !

!HexahedronNode methodsFor: 'private' stamp: 'emm 02/09/2012 23:39'!
topIndices

	^#(1 3 5 7)! !

!HexahedronNode methodsFor: 'accessing-nodes' stamp: 'emm 02/09/2012 23:39'!
topNode

	^neighbors at: 2! !

!HexahedronNode methodsFor: 'accessing-nodes' stamp: 'emm 02/09/2012 23:39'!
topNode: aNode

	( neighbors at: 2 ) == aNode
		ifFalse: 
			[ neighbors at: 2 put: aNode.
			aNode bottomNode: ( aNode isNil
				ifTrue: [ nil ]
				ifFalse: [ self ] ) ]! !

!HexahedronNode methodsFor: 'accessing-faces' stamp: 'emm 02/09/2012 23:39'!
translateBottomBy: aPoint3D

	self leftFrontBottom: self leftFrontBottom + aPoint3D.
	self rightFrontBottom: self rightFrontBottom + aPoint3D.
	self leftBackBottom: self rightFrontBottom + aPoint3D.
	self rightBackBottom: self rightFrontBottom + aPoint3D.! !

!HexahedronNode methodsFor: 'accessing-faces' stamp: 'emm 02/09/2012 23:40'!
translateTopBy: aPoint3D

	self leftFrontTop: self leftFrontTop + aPoint3D.
	self rightFrontTop: self rightFrontTop + aPoint3D.
	self leftBackTop: self rightFrontTop + aPoint3D.
	self rightBackTop: self rightFrontTop + aPoint3D.! !

!HexahedronNode methodsFor: 'private' stamp: 'emm 02/09/2012 23:39'!
vertexShareMap

	"<my vertex> <shared by neighbor> <with vertex>"

	^#(
	1 1 3	"left-front-top	leftNode	right-front-top"
	)! !

!HexahedronNode methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:39'!
vertices
	^vertices! !

!HexahedronNode methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:39'!
vertices: aPoint3DCollection

	vertices := aPoint3DCollection collect:[ :each | each asPoint3D ]! !

!HexahedronNode methodsFor: 'private' stamp: 'emm 02/09/2012 23:40'!
verticesAt: index put: aPoint3D 
	
	| thePoint |
	vertices at: index put: ( ( thePoint := vertices at: index ) == nil
		ifTrue: [ aPoint3D ]
		ifFalse: [ thePoint value: aPoint3D ] )! !

Geometric3D subclass: #LineSegment3D
	instanceVariableNames: 'start end'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Primitives3D'!

!LineSegment3D class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:36'!
between: fromPoint and: toPoint 

	^(self new) start: fromPoint; end: toPoint! !

!LineSegment3D class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:36'!
from: fromPoint to: toPoint 

	^(self new) start: fromPoint; end: toPoint! !

!LineSegment3D class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:36'!
with: aPoint with: otherPoint
	^self from: aPoint to: otherPoint! !

!LineSegment3D methodsFor: 'comparing' stamp: 'emm 02/09/2012 23:36'!
= otherSegment

	^self class == otherSegment class
		and:[ ( self start = otherSegment start
			and:[ self end = otherSegment end ] ) 
				or:[ self start = otherSegment end
					and:[ self end = otherSegment start]]]! !

!LineSegment3D methodsFor: 'Not categorized' stamp: 'emm 02/09/2012 23:36'!
asBoxWithExtent: extent
	
	| box |
	box := ( Box origin: ( extent x / -2 ) , ( extent y / -2 ) , 0 extent: extent x , extent y , self distance ) zAlignWith: self end - self start.
	^ start isZero
		ifTrue:[ box ]
		ifFalse:[ box translateBy: self start ]! !

!LineSegment3D methodsFor: 'converting' stamp: 'emm 02/09/2012 23:36'!
asCylinderWithRadius: radius 

	| cylinder |
	cylinder := (Cylinder radius: radius height: self distance)
				zAlignWith: self end - self start.
	^start isZero
		ifTrue: [cylinder]
		ifFalse: [cylinder wrapTranslateBy: self start]! !

!LineSegment3D methodsFor: '*Zenna-Collections3D' stamp: 'emm 02/09/2012 23:42'!
asPolygonTo: otherEdge
	"should make sure points are in clockwise order"

	| polygon |
	polygon := Polygon3D new.
	polygon add: start ; add: end.
	polygon add: otherEdge start ; add: otherEdge end.
	^polygon! !

!LineSegment3D methodsFor: 'converting' stamp: 'emm 02/09/2012 23:36'!
asSolidWithCenterExtentX: x y: y 
	
	| box alignedbox |
	box := Box origin: ( x @ y @ 0 ) / 2 negated corner: ( x @ y ) / 2 @ self distance.
	alignedbox := box zAlignWith: self end - self start.
	^ start isZero
		ifTrue:[ alignedbox ]
		ifFalse:[ alignedbox wrapTranslateBy: start ]! !

!LineSegment3D methodsFor: 'converting' stamp: 'emm 02/09/2012 23:36'!
asSolidWithIntersection: aPolygon

	^(aPolygon translatedBy: end) extrudedBy: start - end! !

!LineSegment3D methodsFor: 'computing' stamp: 'emm 02/09/2012 23:36'!
bounds

	^BoundingBox origin: start corner: end! !

!LineSegment3D methodsFor: 'computing' stamp: 'emm 02/09/2012 23:36'!
center

	^(start + end) / 2! !

!LineSegment3D methodsFor: 'computing' stamp: 'emm 02/09/2012 23:36'!
computeVertexAtFraction: fraction

	"fraction = [0..1]"

	fraction = 0
		ifTrue: [ ^start ].
	fraction = 1
		ifTrue: [ ^end ].
	"fraction = <0..1>"
	^( end - start ) * fraction + start! !

!LineSegment3D methodsFor: 'computing' stamp: 'emm 02/09/2012 23:36'!
direction

	^ start = end
		ifTrue: [ nil "undefined" ]
		ifFalse: [ ( end - start ) normalized ]! !

!LineSegment3D methodsFor: 'computing' stamp: 'emm 02/09/2012 23:36'!
distance

	^(end - start) r! !

!LineSegment3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:36'!
end

	^end! !

!LineSegment3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:36'!
end: aValue

	end := aValue! !

!LineSegment3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:36'!
from

	^self start! !

!LineSegment3D methodsFor: 'comparing' stamp: 'emm 02/09/2012 23:36'!
hash

	^self start hash bitOr: self end hash! !

!LineSegment3D methodsFor: 'computing' stamp: 'emm 02/09/2012 23:36'!
intersection: aGeometric

	^aGeometric intersectionWithLineSegment3D: self! !

!LineSegment3D methodsFor: 'computing' stamp: 'emm 02/09/2012 23:36'!
intersectionWithLineSegment3D: aSegment

	"Answer the point of intersection (if any) between @aSegment and the receiver"

	^self error: 'not yet implemented'! !

!LineSegment3D methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:36'!
kindDo: aRequestor

	^aRequestor doLineSegment3D: self! !

!LineSegment3D methodsFor: 'computing' stamp: 'emm 02/09/2012 23:36'!
length

	^end dist: start! !

!LineSegment3D methodsFor: 'printing' stamp: 'emm 02/09/2012 23:36'!
printOn: aStream indent: level 

	aStream
		print: start
		; nextPutAll: ' lineSegmentTo: '
		; print: end! !

!LineSegment3D methodsFor: 'transforming' stamp: 'emm 02/09/2012 23:36'!
scaleBy: aNumber

	start := start scaledBy: aNumber.
	end := end scaledBy: aNumber! !

!LineSegment3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:36'!
size
	self error: 'should not send'! !

!LineSegment3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:36'!
start

	^start! !

!LineSegment3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:36'!
start: aValue

	start := aValue! !

!LineSegment3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:36'!
to

	^self end! !

!LineSegment3D methodsFor: 'transforming' stamp: 'emm 02/09/2012 23:36'!
translateBy: aPoint3D

	start := start + aPoint3D.
	end := end + aPoint3D! !

Geometric3D subclass: #Plane3D
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Primitives3D'!

Plane3D subclass: #GenericPlane3D
	instanceVariableNames: 'origin normal1 normal2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Primitives3D'!

!GenericPlane3D class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:36'!
fromColineairPoints: threeElementArray 

	^(self new)
		 point1: (threeElementArray at: 1)
		; point2: (threeElementArray at: 2)
		; point3: (threeElementArray at: 3)! !

!GenericPlane3D methodsFor: 'computing' stamp: 'emm 02/09/2012 23:36'!
baseRotatedBy: angle ! !

!GenericPlane3D methodsFor: 'computing' stamp: 'emm 02/09/2012 23:36'!
baseTangentAt: angle! !

!GenericPlane3D methodsFor: 'computing' stamp: 'emm 02/09/2012 23:36'!
computeVertexAt: parameter1 at: parameter2 

	^self origin + ( normal1 * parameter1 ) + ( normal2 * parameter2 )! !

!GenericPlane3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:36'!
defaultParameterInterval

	^-10 to: 10! !

!GenericPlane3D methodsFor: 'initialize-release' stamp: 'emm 02/09/2012 23:36'!
initialize

	self origin: Point3D zero! !

!GenericPlane3D methodsFor: '*Zenna-Operators3D' stamp: 'emm 02/09/2012 23:46'!
interpolator

	^( DoubleCollectionBasedInterpolator on: self )
		collection: self defaultParameterInterval;
		secondCollection: self defaultParameterInterval! !

!GenericPlane3D methodsFor: 'reflection' stamp: 'emm 02/09/2012 23:36'!
kindDo: aRequestor

	^aRequestor doPlane3D: self! !

!GenericPlane3D methodsFor: 'computing' stamp: 'emm 02/09/2012 23:36'!
mirrored
	"Answer a new plane which has an opposite normal 	
	with respect to the receiver"

	^( self class new )
		point1: self point1 copy
		; point2: self point3 copy
		; point3: self point2 copy! !

!GenericPlane3D methodsFor: 'computing' stamp: 'emm 02/09/2012 23:36'!
normal! !

!GenericPlane3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:36'!
normal1

	^normal1! !

!GenericPlane3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:36'!
normal1: aValue

	normal1 := aValue! !

!GenericPlane3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:36'!
normal2

	^normal2! !

!GenericPlane3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:36'!
normal2: aValue

	normal2 := aValue! !

!GenericPlane3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:36'!
origin

	^origin! !

!GenericPlane3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:36'!
origin: aValue

	origin := aValue! !

!GenericPlane3D methodsFor: 'backward-compatibility' stamp: 'emm 02/09/2012 23:36'!
point1

	^self origin! !

!GenericPlane3D methodsFor: 'backward-compatibility' stamp: 'emm 02/09/2012 23:36'!
point1: aPoint 

	^self origin: aPoint! !

!GenericPlane3D methodsFor: 'backward-compatibility' stamp: 'emm 02/09/2012 23:36'!
point2

	^self origin + self normal1! !

!GenericPlane3D methodsFor: 'backward-compatibility' stamp: 'emm 02/09/2012 23:36'!
point2: aPoint 

	^self normal1: aPoint - self origin! !

!GenericPlane3D methodsFor: 'backward-compatibility' stamp: 'emm 02/09/2012 23:36'!
point3

	^self origin + self normal2! !

!GenericPlane3D methodsFor: 'backward-compatibility' stamp: 'emm 02/09/2012 23:36'!
point3: aPoint 

	^self normal2: aPoint - self origin! !

!GenericPlane3D methodsFor: 'computing' stamp: 'emm 02/09/2012 23:36'!
thetaFrom: startPoint to: stopPoint! !

!GenericPlane3D methodsFor: 'computing' stamp: 'emm 02/09/2012 23:36'!
unity! !

!Plane3D class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:36'!
fromColineairPoints: threeElementArray 

	^(GenericPlane3D new)
		 point1: (threeElementArray at: 1)
		; point2: (threeElementArray at: 2)
		; point3: (threeElementArray at: 3)! !

!Plane3D class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:36'!
xy

	^XYPlane3D new! !

!Plane3D class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:36'!
yz

	^YZPlane3D new! !

!Plane3D class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:36'!
zx

	^ZXPlane3D new! !

!Plane3D methodsFor: 'computing' stamp: 'emm 02/09/2012 23:36'!
baseRotatedBy: angle! !

!Plane3D methodsFor: 'computing' stamp: 'emm 02/09/2012 23:36'!
baseTangentAt: angle! !

!Plane3D methodsFor: 'computing' stamp: 'emm 02/09/2012 23:36'!
bounds

	self shouldNotImplement! !

!Plane3D methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:36'!
kindDo: aRequestor

	^aRequestor doPlane3D: self! !

!Plane3D methodsFor: 'computing' stamp: 'emm 02/09/2012 23:36'!
normal! !

!Plane3D methodsFor: 'computing' stamp: 'emm 02/09/2012 23:36'!
thetaFrom: onePoint to: otherPoint! !

!Plane3D methodsFor: 'transformation-dispatching' stamp: 'emm 02/09/2012 23:36'!
transformationBlockTo: otherPlane! !

!Plane3D methodsFor: 'computing' stamp: 'emm 02/09/2012 23:36'!
unity! !

Plane3D subclass: #XYPlane3D
	instanceVariableNames: ''
	classVariableNames: 'SoleInstance'
	poolDictionaries: ''
	category: 'Zenna-Primitives3D'!

!XYPlane3D class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:36'!
new

	SoleInstance isNil
		ifTrue:[ SoleInstance := super new ].
	^SoleInstance! !

!XYPlane3D methodsFor: 'computing' stamp: 'emm 02/09/2012 23:36'!
baseRotatedBy: angle 

	^angle cos @ angle sin @ 0! !

!XYPlane3D methodsFor: 'computing' stamp: 'emm 02/09/2012 23:36'!
baseTangentAt: angle

	^angle sin negated @ angle cos @ 0! !

!XYPlane3D methodsFor: 'computing' stamp: 'emm 02/09/2012 23:36'!
normal

	^0,0,1! !

!XYPlane3D methodsFor: 'computing' stamp: 'emm 02/09/2012 23:36'!
thetaFrom: startPoint to: stopPoint

	^( Point
		x: stopPoint x - startPoint x
		y: stopPoint y - startPoint y ) theta! !

!XYPlane3D methodsFor: 'transformation-dispatching' stamp: 'emm 02/09/2012 23:36'!
transformationBlockFromYZPlane: aPlane! !

!XYPlane3D methodsFor: 'transformation-dispatching' stamp: 'emm 02/09/2012 23:36'!
transformationBlockFromZXPlane: aPlane! !

!XYPlane3D methodsFor: 'transformation-dispatching' stamp: 'emm 02/09/2012 23:36'!
transformationBlockTo: otherPlane

	^otherPlane transformationBlockFromXYPlane: self! !

!XYPlane3D methodsFor: 'computing' stamp: 'emm 02/09/2012 23:36'!
unity

	^1,1,0! !

Plane3D subclass: #YZPlane3D
	instanceVariableNames: ''
	classVariableNames: 'SoleInstance'
	poolDictionaries: ''
	category: 'Zenna-Primitives3D'!

!YZPlane3D class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:36'!
new

	SoleInstance isNil
		ifTrue:[ SoleInstance := super new ].
	^SoleInstance! !

!YZPlane3D methodsFor: 'computing' stamp: 'emm 02/09/2012 23:36'!
baseRotatedBy: angle 

	^0 @ angle cos @ angle sin! !

!YZPlane3D methodsFor: 'computing' stamp: 'emm 02/09/2012 23:36'!
baseTangentAt: angle

	^0 @ angle sin negated @ angle cos! !

!YZPlane3D methodsFor: 'computing' stamp: 'emm 02/09/2012 23:36'!
normal

	 ^1,0,0! !

!YZPlane3D methodsFor: 'computing' stamp: 'emm 02/09/2012 23:36'!
thetaFrom: startPoint to: stopPoint

	^( Point
		x: stopPoint y - startPoint y
		y: stopPoint z - startPoint z ) theta! !

!YZPlane3D methodsFor: 'transformation-dispatching' stamp: 'emm 02/09/2012 23:36'!
transformationBlockFromXYPlane: aPlane

	^[ :pointInXY | 0 @ pointInXY x @ pointInXY y ]! !

!YZPlane3D methodsFor: 'transformation-dispatching' stamp: 'emm 02/09/2012 23:36'!
transformationBlockFromZXPlane: aPlane! !

!YZPlane3D methodsFor: 'transformation-dispatching' stamp: 'emm 02/09/2012 23:36'!
transformationBlockTo: otherPlane

	^otherPlane transformationBlockFromYZPlane: self! !

!YZPlane3D methodsFor: 'computing' stamp: 'emm 02/09/2012 23:36'!
unity

	^0,1,1! !

Plane3D subclass: #ZXPlane3D
	instanceVariableNames: ''
	classVariableNames: 'SoleInstance'
	poolDictionaries: ''
	category: 'Zenna-Primitives3D'!

!ZXPlane3D class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:36'!
new

	SoleInstance isNil
		ifTrue:[ SoleInstance := super new ].
	^SoleInstance! !

!ZXPlane3D methodsFor: 'computing' stamp: 'emm 02/09/2012 23:36'!
baseRotatedBy: angle 

	^angle sin @ 0 @ angle cos! !

!ZXPlane3D methodsFor: 'computing' stamp: 'emm 02/09/2012 23:36'!
baseTangentAt: angle
	
	^angle cos @ 0 @ angle sin negated! !

!ZXPlane3D methodsFor: 'computing' stamp: 'emm 02/09/2012 23:36'!
normal

	 ^0,1,0! !

!ZXPlane3D methodsFor: 'computing' stamp: 'emm 02/09/2012 23:36'!
thetaFrom: startPoint to: stopPoint

	^( Point
		x: stopPoint z - startPoint z
		y: stopPoint x - startPoint x ) theta! !

!ZXPlane3D methodsFor: 'transformation-dispatching' stamp: 'emm 02/09/2012 23:36'!
transformationBlockFromXYPlane: aPlane! !

!ZXPlane3D methodsFor: 'transformation-dispatching' stamp: 'emm 02/09/2012 23:36'!
transformationBlockFromYZPlane: aPlane! !

!ZXPlane3D methodsFor: 'transformation-dispatching' stamp: 'emm 02/09/2012 23:36'!
transformationBlockTo: otherPlane

	^otherPlane transformationBlockFromZXPlane: self! !

!ZXPlane3D methodsFor: 'computing' stamp: 'emm 02/09/2012 23:36'!
unity

	 ^1,0,1! !

Geometric3D subclass: #Polyhedron
	instanceVariableNames: ''
	classVariableNames: 'GoldenRatio'
	poolDictionaries: ''
	category: 'Zenna-Shapes3D'!

!Polyhedron class methodsFor: 'factory-dodecahedron' stamp: 'emm 02/09/2012 23:40'!
augmentedDodecahedron
	"self augmentedDodecahedron"

	^(Triangle3DComposite new)
		add: (Triangle3D 
					with: 0.394538 , 0.20622 , -0.26487
					with: 0.510044 , -0.108159 , -0.120991
					with: 0.294018 , -0.3746 , -0.244358);
		add: (Triangle3D 
					with: 0.394538 , 0.20622 , -0.26487
					with: 0.294018 , -0.3746 , -0.244358
					with: 0.0450005 , -0.224889 , -0.464481);
		add: (Triangle3D 
					with: 0.394538 , 0.20622 , -0.26487
					with: 0.0450005 , -0.224889 , -0.464481
					with: 0.107125 , 0.134077 , -0.477158);
		add: (Triangle3D 
					with: -0.237301 , -0.459193 , -0.00265444
					with: -0.283373 , -0.277171 , -0.3151
					with: 0.0450005 , -0.224889 , -0.464481);
		add: (Triangle3D 
					with: -0.237301 , -0.459193 , -0.00265444
					with: 0.0450005 , -0.224889 , -0.464481
					with: 0.294018 , -0.3746 , -0.244358);
		add: (Triangle3D 
					with: -0.237301 , -0.459193 , -0.00265444
					with: 0.294018 , -0.3746 , -0.244358
					with: 0.119546 , -0.519407 , 0.0410665);
		add: (Triangle3D 
					with: -0.424193 , 0.0494832 , -0.235454
					with: -0.182853 , 0.303649 , -0.335612
					with: 0.107125 , 0.134077 , -0.477158);
		add: (Triangle3D 
					with: -0.424193 , 0.0494832 , -0.235454
					with: 0.107125 , 0.134077 , -0.477158
					with: 0.0450005 , -0.224889 , -0.464481);
		add: (Triangle3D 
					with: -0.424193 , 0.0494832 , -0.235454
					with: 0.0450005 , -0.224889 , -0.464481
					with: -0.283373 , -0.277171 , -0.3151);
		add: (Triangle3D 
					with: -0.0746561 , 0.480593 , -0.0358428
					with: 0.282191 , 0.420379 , 0.00787815
					with: 0.394538 , 0.20622 , -0.26487);
		add: (Triangle3D 
					with: -0.0746561 , 0.480593 , -0.0358428
					with: 0.394538 , 0.20622 , -0.26487
					with: 0.107125 , 0.134077 , -0.477158);
		add: (Triangle3D 
					with: -0.0746561 , 0.480593 , -0.0358428
					with: 0.107125 , 0.134077 , -0.477158
					with: -0.182853 , 0.303649 , -0.335612);
		add: (Triangle3D 
					with: 0.328263 , 0.238356 , 0.320324
					with: 0.469083 , -0.0882982 , 0.240678
					with: 0.510044 , -0.108159 , -0.120991);
		add: (Triangle3D 
					with: 0.328263 , 0.238356 , 0.320324
					with: 0.510044 , -0.108159 , -0.120991
					with: 0.394538 , 0.20622 , -0.26487);
		add: (Triangle3D 
					with: 0.328263 , 0.238356 , 0.320324
					with: 0.394538 , 0.20622 , -0.26487
					with: 0.282191 , 0.420379 , 0.00787815);
		add: (Triangle3D 
					with: 0.227743 , -0.342464 , 0.340835
					with: 0.119546 , -0.519407 , 0.0410665
					with: 0.294018 , -0.3746 , -0.244358);
		add: (Triangle3D 
					with: 0.227743 , -0.342464 , 0.340835
					with: 0.294018 , -0.3746 , -0.244358
					with: 0.510044 , -0.108159 , -0.120991);
		add: (Triangle3D 
					with: 0.227743 , -0.342464 , 0.340835
					with: 0.510044 , -0.108159 , -0.120991
					with: 0.469083 , -0.0882982 , 0.240678);
		add: (Triangle3D 
					with: 0.469083 , -0.0882982 , 0.240678
					with: 0.328263 , 0.238356 , 0.320324
					with: -0.000110506 , 0.186074 , 0.469705);
		add: (Triangle3D 
					with: 0.469083 , -0.0882982 , 0.240678
					with: -0.000110506 , 0.186074 , 0.469705
					with: -0.0622354 , -0.172892 , 0.482382);
		add: (Triangle3D 
					with: 0.469083 , -0.0882982 , 0.240678
					with: -0.0622354 , -0.172892 , 0.482382
					with: 0.227743 , -0.342464 , 0.340835);
		add: (Triangle3D 
					with: 0.282191 , 0.420379 , 0.00787815
					with: -0.0746561 , 0.480593 , -0.0358428
					with: -0.249128 , 0.335785 , 0.249582);
		add: (Triangle3D 
					with: 0.282191 , 0.420379 , 0.00787815
					with: -0.249128 , 0.335785 , 0.249582
					with: -0.000110506 , 0.186074 , 0.469705);
		add: (Triangle3D 
					with: 0.282191 , 0.420379 , 0.00787815
					with: -0.000110506 , 0.186074 , 0.469705
					with: 0.328263 , 0.238356 , 0.320324);
		add: (Triangle3D 
					with: -0.283373 , -0.277171 , -0.3151
					with: -0.237301 , -0.459193 , -0.00265444
					with: -0.349648 , -0.245035 , 0.270093);
		add: (Triangle3D 
					with: -0.283373 , -0.277171 , -0.3151
					with: -0.349648 , -0.245035 , 0.270093
					with: -0.465154 , 0.0693443 , 0.126215);
		add: (Triangle3D 
					with: -0.283373 , -0.277171 , -0.3151
					with: -0.465154 , 0.0693443 , 0.126215
					with: -0.424193 , 0.0494832 , -0.235454);
		add: (Triangle3D 
					with: 0.119546 , -0.519407 , 0.0410665
					with: 0.227743 , -0.342464 , 0.340835
					with: -0.0622354 , -0.172892 , 0.482382);
		add: (Triangle3D 
					with: 0.119546 , -0.519407 , 0.0410665
					with: -0.0622354 , -0.172892 , 0.482382
					with: -0.349648 , -0.245035 , 0.270093);
		add: (Triangle3D 
					with: 0.119546 , -0.519407 , 0.0410665
					with: -0.349648 , -0.245035 , 0.270093
					with: -0.237301 , -0.459193 , -0.00265444);
		add: (Triangle3D 
					with: -0.349648 , -0.245035 , 0.270093
					with: -0.0622354 , -0.172892 , 0.482382
					with: -0.000110506 , 0.186074 , 0.469705);
		add: (Triangle3D 
					with: -0.349648 , -0.245035 , 0.270093
					with: -0.000110506 , 0.186074 , 0.469705
					with: -0.249128 , 0.335785 , 0.249582);
		add: (Triangle3D 
					with: -0.349648 , -0.245035 , 0.270093
					with: -0.249128 , 0.335785 , 0.249582
					with: -0.465154 , 0.0693443 , 0.126215);
		add: (Triangle3D 
					with: -0.421613 , 0.373915 , -0.0692787
					with: -0.465154 , 0.0693443 , 0.126215
					with: -0.249128 , 0.335785 , 0.249582);
		add: (Triangle3D 
					with: -0.421613 , 0.373915 , -0.0692787
					with: -0.249128 , 0.335785 , 0.249582
					with: -0.0746561 , 0.480593 , -0.0358428);
		add: (Triangle3D 
					with: -0.421613 , 0.373915 , -0.0692787
					with: -0.424193 , 0.0494832 , -0.235454
					with: -0.465154 , 0.0693443 , 0.126215);
		add: (Triangle3D 
					with: -0.421613 , 0.373915 , -0.0692787
					with: -0.182853 , 0.303649 , -0.335612
					with: -0.424193 , 0.0494832 , -0.235454);
		add: (Triangle3D 
					with: -0.182853 , 0.303649 , -0.335612
					with: -0.421613 , 0.373915 , -0.0692787
					with: -0.0746561 , 0.480593 , -0.0358428);
		yourself! !

!Polyhedron class methodsFor: 'factory-hexagonal' stamp: 'emm 02/09/2012 23:40'!
augmentedHexagonalPrism
	"self augmentedHexagonalPrism"

	^(Triangle3DComposite new)
		add: (Triangle3D 
					with: -0.47548 , 0.183939 , -0.0500791
					with: -0.409024 , -0.233179 , -0.0910112
					with: -0.0861936 , -0.417675 , 0.113491);
		add: (Triangle3D 
					with: -0.47548 , 0.183939 , -0.0500791
					with: -0.0861936 , -0.417675 , 0.113491
					with: 0.170181 , -0.185052 , 0.358925);
		add: (Triangle3D 
					with: -0.47548 , 0.183939 , -0.0500791
					with: 0.170181 , -0.185052 , 0.358925
					with: 0.103725 , 0.232066 , 0.399857);
		add: (Triangle3D 
					with: -0.47548 , 0.183939 , -0.0500791
					with: 0.103725 , 0.232066 , 0.399857
					with: -0.219105 , 0.416561 , 0.195355);
		add: (Triangle3D 
					with: 0.356384 , 0.305002 , 0.0668066
					with: 0.42284 , -0.112116 , 0.0258746
					with: 0.166465 , -0.344738 , -0.21956);
		add: (Triangle3D 
					with: 0.356384 , 0.305002 , 0.0668066
					with: 0.166465 , -0.344738 , -0.21956
					with: -0.156365 , -0.160243 , -0.424062);
		add: (Triangle3D 
					with: 0.356384 , 0.305002 , 0.0668066
					with: -0.156365 , -0.160243 , -0.424062
					with: -0.22282 , 0.256875 , -0.38313);
		add: (Triangle3D 
					with: 0.356384 , 0.305002 , 0.0668066
					with: -0.22282 , 0.256875 , -0.38313
					with: 0.0335541 , 0.489497 , -0.137696);
		add: (Triangle3D 
					with: -0.409024 , -0.233179 , -0.0910112
					with: -0.47548 , 0.183939 , -0.0500791
					with: -0.22282 , 0.256875 , -0.38313);
		add: (Triangle3D 
					with: -0.409024 , -0.233179 , -0.0910112
					with: -0.22282 , 0.256875 , -0.38313
					with: -0.156365 , -0.160243 , -0.424062);
		add: (Triangle3D 
					with: -0.0861936 , -0.417675 , 0.113491
					with: -0.409024 , -0.233179 , -0.0910112
					with: -0.156365 , -0.160243 , -0.424062);
		add: (Triangle3D 
					with: -0.0861936 , -0.417675 , 0.113491
					with: -0.156365 , -0.160243 , -0.424062
					with: 0.166465 , -0.344738 , -0.21956);
		add: (Triangle3D 
					with: 0.103725 , 0.232066 , 0.399857
					with: 0.170181 , -0.185052 , 0.358925
					with: 0.42284 , -0.112116 , 0.0258746);
		add: (Triangle3D 
					with: 0.103725 , 0.232066 , 0.399857
					with: 0.42284 , -0.112116 , 0.0258746
					with: 0.356384 , 0.305002 , 0.0668066);
		add: (Triangle3D 
					with: -0.219105 , 0.416561 , 0.195355
					with: 0.103725 , 0.232066 , 0.399857
					with: 0.356384 , 0.305002 , 0.0668066);
		add: (Triangle3D 
					with: -0.219105 , 0.416561 , 0.195355
					with: 0.356384 , 0.305002 , 0.0668066
					with: 0.0335541 , 0.489497 , -0.137696);
		add: (Triangle3D 
					with: -0.47548 , 0.183939 , -0.0500791
					with: -0.219105 , 0.416561 , 0.195355
					with: 0.0335541 , 0.489497 , -0.137696);
		add: (Triangle3D 
					with: -0.47548 , 0.183939 , -0.0500791
					with: 0.0335541 , 0.489497 , -0.137696
					with: -0.22282 , 0.256875 , -0.38313);
		add: (Triangle3D 
					with: -0.0861936 , -0.417675 , 0.113491
					with: 0.327248 , -0.510503 , 0.13646
					with: 0.170181 , -0.185052 , 0.358925);
		add: (Triangle3D 
					with: -0.0861936 , -0.417675 , 0.113491
					with: 0.166465 , -0.344738 , -0.21956
					with: 0.327248 , -0.510503 , 0.13646);
		add: (Triangle3D 
					with: 0.170181 , -0.185052 , 0.358925
					with: 0.327248 , -0.510503 , 0.13646
					with: 0.42284 , -0.112116 , 0.0258746);
		add: (Triangle3D 
					with: 0.42284 , -0.112116 , 0.0258746
					with: 0.327248 , -0.510503 , 0.13646
					with: 0.166465 , -0.344738 , -0.21956);
		yourself! !

!Polyhedron class methodsFor: 'factory-pentagonal' stamp: 'emm 02/09/2012 23:40'!
augmentedPentagonalPrism
	"self augmentedPentagonalPrism"

	^(Triangle3DComposite new)
		add: (Triangle3D 
					with: -0.377807 , 0.099772 , -0.306246
					with: -0.306011 , -0.320768 , -0.150008
					with: -0.129636 , -0.287278 , 0.267352);
		add: (Triangle3D 
					with: -0.377807 , 0.099772 , -0.306246
					with: -0.129636 , -0.287278 , 0.267352
					with: -0.0924269 , 0.153959 , 0.369056);
		add: (Triangle3D 
					with: -0.377807 , 0.099772 , -0.306246
					with: -0.0924269 , 0.153959 , 0.369056
					with: -0.245805 , 0.39317 , 0.0145531);
		add: (Triangle3D 
					with: 0.172501 , 0.398744 , -0.162669
					with: 0.325879 , 0.159534 , 0.191834
					with: 0.28867 , -0.281704 , 0.0901297);
		add: (Triangle3D 
					with: 0.172501 , 0.398744 , -0.162669
					with: 0.28867 , -0.281704 , 0.0901297
					with: 0.112296 , -0.315194 , -0.32723);
		add: (Triangle3D 
					with: 0.172501 , 0.398744 , -0.162669
					with: 0.112296 , -0.315194 , -0.32723
					with: 0.0404991 , 0.105346 , -0.483468);
		add: (Triangle3D 
					with: -0.306011 , -0.320768 , -0.150008
					with: -0.377807 , 0.099772 , -0.306246
					with: 0.0404991 , 0.105346 , -0.483468);
		add: (Triangle3D 
					with: -0.306011 , -0.320768 , -0.150008
					with: 0.0404991 , 0.105346 , -0.483468
					with: 0.112296 , -0.315194 , -0.32723);
		add: (Triangle3D 
					with: -0.129636 , -0.287278 , 0.267352
					with: -0.306011 , -0.320768 , -0.150008
					with: 0.112296 , -0.315194 , -0.32723);
		add: (Triangle3D 
					with: -0.129636 , -0.287278 , 0.267352
					with: 0.112296 , -0.315194 , -0.32723
					with: 0.28867 , -0.281704 , 0.0901297);
		add: (Triangle3D 
					with: -0.245805 , 0.39317 , 0.0145531
					with: -0.0924269 , 0.153959 , 0.369056
					with: 0.325879 , 0.159534 , 0.191834);
		add: (Triangle3D 
					with: -0.245805 , 0.39317 , 0.0145531
					with: 0.325879 , 0.159534 , 0.191834
					with: 0.172501 , 0.398744 , -0.162669);
		add: (Triangle3D 
					with: -0.377807 , 0.099772 , -0.306246
					with: -0.245805 , 0.39317 , 0.0145531
					with: 0.172501 , 0.398744 , -0.162669);
		add: (Triangle3D 
					with: -0.377807 , 0.099772 , -0.306246
					with: 0.172501 , 0.398744 , -0.162669
					with: 0.0404991 , 0.105346 , -0.483468);
		add: (Triangle3D 
					with: -0.129636 , -0.287278 , 0.267352
					with: 0.220707 , -0.140349 , 0.516532
					with: -0.0924269 , 0.153959 , 0.369056);
		add: (Triangle3D 
					with: -0.129636 , -0.287278 , 0.267352
					with: 0.28867 , -0.281704 , 0.0901297
					with: 0.220707 , -0.140349 , 0.516532);
		add: (Triangle3D 
					with: -0.0924269 , 0.153959 , 0.369056
					with: 0.220707 , -0.140349 , 0.516532
					with: 0.325879 , 0.159534 , 0.191834);
		add: (Triangle3D 
					with: 0.325879 , 0.159534 , 0.191834
					with: 0.220707 , -0.140349 , 0.516532
					with: 0.28867 , -0.281704 , 0.0901297);
		yourself! !

!Polyhedron class methodsFor: 'factory' stamp: 'emm 02/09/2012 23:40'!
augmentedSphenocorona
	"self augmentedSphenocorona"

	^(Triangle3DComposite new)
		addTriangleWith: -0.052753 , -0.412066 , -0.172734
			with: -0.47281 , -0.436093 , 0.234229
			with: -0.433084 , 0.02955 , -0.118251;
		addTriangleWith: -0.052753 , -0.412066 , -0.172734
			with: -0.433084 , 0.02955 , -0.118251
			with: -0.119158 , 0.346653 , -0.49712;
		addTriangleWith: -0.052753 , -0.412066 , -0.172734
			with: -0.119158 , 0.346653 , -0.49712
			with: 0.261172 , -0.0949635 , -0.551603;
		addTriangleWith: 0.377074 , 0.347772 , -0.186641
			with: -0.128804 , 0.492997 , 0.0695672
			with: 0.274104 , 0.190694 , 0.367766;
		addTriangleWith: 0.274104 , 0.190694 , 0.367766
			with: 0.0855638 , -0.362852 , 0.393915
			with: 0.471685 , -0.204252 , -0.0164531;
		addTriangleWith: 0.274104 , 0.190694 , 0.367766
			with: -0.128804 , 0.492997 , 0.0695672
			with: -0.294768 , 0.0787642 , 0.448397;
		addTriangleWith: 0.274104 , 0.190694 , 0.367766
			with: -0.294768 , 0.0787642 , 0.448397
			with: 0.0855638 , -0.362852 , 0.393915;
		addTriangleWith: 0.0855638 , -0.362852 , 0.393915
			with: -0.052753 , -0.412066 , -0.172734
			with: 0.471685 , -0.204252 , -0.0164531;
		addTriangleWith: 0.471685 , -0.204252 , -0.0164531
			with: -0.052753 , -0.412066 , -0.172734
			with: 0.261172 , -0.0949635 , -0.551603;
		addTriangleWith: -0.128804 , 0.492997 , 0.0695672
			with: -0.433084 , 0.02955 , -0.118251
			with: -0.294768 , 0.0787642 , 0.448397;
		addTriangleWith: -0.433084 , 0.02955 , -0.118251
			with: -0.128804 , 0.492997 , 0.0695672
			with: -0.119158 , 0.346653 , -0.49712;
		addTriangleWith: 0.261172 , -0.0949635 , -0.551603
			with: 0.377074 , 0.347772 , -0.186641
			with: 0.471685 , -0.204252 , -0.0164531;
		addTriangleWith: 0.261172 , -0.0949635 , -0.551603
			with: -0.119158 , 0.346653 , -0.49712
			with: 0.377074 , 0.347772 , -0.186641;
		addTriangleWith: 0.377074 , 0.347772 , -0.186641
			with: -0.119158 , 0.346653 , -0.49712
			with: -0.128804 , 0.492997 , 0.0695672;
		addTriangleWith: 0.471685 , -0.204252 , -0.0164531
			with: 0.377074 , 0.347772 , -0.186641
			with: 0.274104 , 0.190694 , 0.367766;
		addTriangleWith: 0.0855638 , -0.362852 , 0.393915
			with: -0.47281 , -0.436093 , 0.234229
			with: -0.052753 , -0.412066 , -0.172734;
		addTriangleWith: 0.0855638 , -0.362852 , 0.393915
			with: -0.294768 , 0.0787642 , 0.448397
			with: -0.47281 , -0.436093 , 0.234229;
		addTriangleWith: -0.47281 , -0.436093 , 0.234229
			with: -0.294768 , 0.0787642 , 0.448397
			with: -0.433084 , 0.02955 , -0.118251! !

!Polyhedron class methodsFor: 'factory-triangular' stamp: 'emm 02/09/2012 23:40'!
augmentedTriangularPrism
	"self augmentedTriangularPrism"

	^(Triangle3DComposite new)
		add: (Triangle3D 
					with: -0.113144 , 0.386759 , -0.174233
					with: -0.420419 , -0.121234 , -0.0359324
					with: -0.132643 , -0.1492 , 0.500729);
		add: (Triangle3D 
					with: -0.113144 , 0.386759 , -0.174233
					with: -0.132643 , -0.1492 , 0.500729
					with: 0.174633 , 0.358794 , 0.362429);
		add: (Triangle3D 
					with: 0.174633 , 0.358794 , 0.362429
					with: -0.132643 , -0.1492 , 0.500729
					with: 0.105276 , -0.42603 , 0.0125054);
		add: (Triangle3D 
					with: 0.174633 , 0.358794 , 0.362429
					with: 0.105276 , -0.42603 , 0.0125054
					with: 0.412552 , 0.0819632 , -0.125795);
		add: (Triangle3D 
					with: 0.412552 , 0.0819632 , -0.125795
					with: -0.0242881 , -0.121234 , -0.499271
					with: -0.113144 , 0.386759 , -0.174233);
		add: (Triangle3D 
					with: -0.0242881 , -0.121234 , -0.499271
					with: -0.420419 , -0.121234 , -0.0359324
					with: -0.113144 , 0.386759 , -0.174233);
		add: (Triangle3D 
					with: -0.420419 , -0.121234 , -0.0359324
					with: -0.0242881 , -0.121234 , -0.499271
					with: 0.105276 , -0.42603 , 0.0125054);
		add: (Triangle3D 
					with: -0.113144 , 0.386759 , -0.174233
					with: 0.174633 , 0.358794 , 0.362429
					with: 0.412552 , 0.0819632 , -0.125795);
		add: (Triangle3D 
					with: -0.132643 , -0.1492 , 0.500729
					with: -0.420419 , -0.121234 , -0.0359324
					with: 0.105276 , -0.42603 , 0.0125054);
		add: (Triangle3D 
					with: 0.412552 , 0.0819632 , -0.125795
					with: 0.105276 , -0.42603 , 0.0125054
					with: -0.0242881 , -0.121234 , -0.499271);
		yourself! !

!Polyhedron class methodsFor: 'factory-icosahedron' stamp: 'emm 02/09/2012 23:40'!
augmentedTridiminishedIcosahedron
	"self augmentedTridiminishedIcosahedron"

	^(Triangle3DComposite new)
		addTriangleWith: 0.47123 , 0.14716 , 0.142353
			with: 0.0432529 , 0.221932 , 0.454738
			with: -0.303338 , -0.174105 , 0.357944;
		addTriangleWith: 0.47123 , 0.14716 , 0.142353
			with: -0.303338 , -0.174105 , 0.357944
			with: -0.089566 , -0.493641 , -0.0142628;
		addTriangleWith: 0.47123 , 0.14716 , 0.142353
			with: -0.089566 , -0.493641 , -0.0142628
			with: 0.389144 , -0.295088 , -0.147506;
		addTriangleWith: 0.312934 , 0.186823 , -0.367264
			with: 0.389144 , -0.295088 , -0.147506
			with: -0.089566 , -0.493641 , -0.0142628;
		addTriangleWith: 0.312934 , 0.186823 , -0.367264
			with: -0.089566 , -0.493641 , -0.0142628
			with: -0.461634 , -0.134442 , -0.151673;
		addTriangleWith: 0.312934 , 0.186823 , -0.367264
			with: -0.461634 , -0.134442 , -0.151673
			with: -0.212875 , 0.286107 , -0.369839;
		addTriangleWith: 0.489921 , 0.381146 , -0.338523
			with: 0.0991621 , 0.506359 , 0.00494265
			with: 0.47123 , 0.14716 , 0.142353;
		addTriangleWith: 0.0991621 , 0.506359 , 0.00494265
			with: 0.0432529 , 0.221932 , 0.454738
			with: 0.47123 , 0.14716 , 0.142353;
		addTriangleWith: 0.47123 , 0.14716 , 0.142353
			with: 0.389144 , -0.295088 , -0.147506
			with: 0.312934 , 0.186823 , -0.367264;
		addTriangleWith: 0.312934 , 0.186823 , -0.367264
			with: -0.212875 , 0.286107 , -0.369839
			with: 0.0991621 , 0.506359 , 0.00494265;
		addTriangleWith: -0.303338 , -0.174105 , 0.357944
			with: 0.0432529 , 0.221932 , 0.454738
			with: 0.0991621 , 0.506359 , 0.00494265;
		addTriangleWith: -0.303338 , -0.174105 , 0.357944
			with: 0.0991621 , 0.506359 , 0.00494265
			with: -0.212875 , 0.286107 , -0.369839;
		addTriangleWith: -0.303338 , -0.174105 , 0.357944
			with: -0.212875 , 0.286107 , -0.369839
			with: -0.461634 , -0.134442 , -0.151673;
		addTriangleWith: -0.089566 , -0.493641 , -0.0142628
			with: -0.303338 , -0.174105 , 0.357944
			with: -0.461634 , -0.134442 , -0.151673;
		addTriangleWith: -0.303338 , -0.174105 , 0.357944
			with: -0.461634 , -0.134442 , -0.151673
			with: -0.089566 , -0.493641 , -0.0142628;
		addTriangleWith: -0.461634 , -0.134442 , -0.151673
			with: -0.089566 , -0.493641 , -0.0142628
			with: -0.303338 , -0.174105 , 0.357944! !

!Polyhedron class methodsFor: 'factory-hexagonal' stamp: 'emm 02/09/2012 23:40'!
augmentedTruncatedCube
	"self augmentedTruncatedCube"

	^(Triangle3DComposite new)
		addTriangleWith: 0.438667 , 0.0684533 , -0.220462
			with: 0.41061 , 0.282836 , -0.0233704
			with: 0.453234 , 0.0899875 , 0.192465;
		addTriangleWith: 0.438667 , 0.0684533 , -0.220462
			with: 0.453234 , 0.0899875 , 0.192465
			with: 0.481291 , -0.124395 , -0.00462666;
		addTriangleWith: 0.41061 , 0.282836 , -0.0233704
			with: 0.438667 , 0.0684533 , -0.220462
			with: 0.204826 , 0.169877 , -0.364072;
		addTriangleWith: 0.41061 , 0.282836 , -0.0233704
			with: 0.204826 , 0.169877 , -0.364072
			with: 0.17677 , 0.38426 , -0.16698;
		addTriangleWith: 0.41061 , 0.282836 , -0.0233704
			with: 0.17677 , 0.38426 , -0.16698
			with: 0.18707 , 0.399487 , 0.125003;
		addTriangleWith: 0.453234 , 0.0899875 , 0.192465
			with: 0.41061 , 0.282836 , -0.0233704
			with: 0.18707 , 0.399487 , 0.125003;
		addTriangleWith: 0.453234 , 0.0899875 , 0.192465
			with: 0.18707 , 0.399487 , 0.125003
			with: 0.229694 , 0.206638 , 0.340838;
		addTriangleWith: 0.453234 , 0.0899875 , 0.192465
			with: 0.229694 , 0.206638 , 0.340838
			with: 0.279673 , -0.0813176 , 0.354092;
		addTriangleWith: 0.481291 , -0.124395 , -0.00462666
			with: 0.453234 , 0.0899875 , 0.192465
			with: 0.279673 , -0.0813176 , 0.354092;
		addTriangleWith: 0.481291 , -0.124395 , -0.00462666
			with: 0.279673 , -0.0813176 , 0.354092
			with: 0.30773 , -0.2957 , 0.157;
		addTriangleWith: 0.481291 , -0.124395 , -0.00462666
			with: 0.30773 , -0.2957 , 0.157
			with: 0.297429 , -0.310927 , -0.134983;
		addTriangleWith: 0.438667 , 0.0684533 , -0.220462
			with: 0.481291 , -0.124395 , -0.00462666
			with: 0.297429 , -0.310927 , -0.134983;
		addTriangleWith: 0.438667 , 0.0684533 , -0.220462
			with: 0.297429 , -0.310927 , -0.134983
			with: 0.254805 , -0.118079 , -0.350818;
		addTriangleWith: 0.438667 , 0.0684533 , -0.220462
			with: 0.254805 , -0.118079 , -0.350818
			with: 0.204826 , 0.169877 , -0.364072;
		addTriangleWith: 0.30773 , -0.2957 , 0.157
			with: 0.111313 , -0.319874 , 0.372472
			with: -0.176764 , -0.369287 , 0.385212;
		addTriangleWith: 0.30773 , -0.2957 , 0.157
			with: -0.176764 , -0.369287 , 0.385212
			with: -0.387748 , -0.414995 , 0.187757;
		addTriangleWith: 0.30773 , -0.2957 , 0.157
			with: -0.387748 , -0.414995 , 0.187757
			with: -0.398049 , -0.430222 , -0.104226;
		addTriangleWith: 0.30773 , -0.2957 , 0.157
			with: -0.398049 , -0.430222 , -0.104226
			with: -0.201632 , -0.406048 , -0.319698;
		addTriangleWith: 0.30773 , -0.2957 , 0.157
			with: -0.201632 , -0.406048 , -0.319698
			with: 0.0864447 , -0.356635 , -0.332438;
		addTriangleWith: 0.30773 , -0.2957 , 0.157
			with: 0.0864447 , -0.356635 , -0.332438
			with: 0.297429 , -0.310927 , -0.134983;
		addTriangleWith: 0.254805 , -0.118079 , -0.350818
			with: 0.0864447 , -0.356635 , -0.332438
			with: -0.201632 , -0.406048 , -0.319698;
		addTriangleWith: 0.254805 , -0.118079 , -0.350818
			with: -0.201632 , -0.406048 , -0.319698
			with: -0.440673 , -0.237374 , -0.320061;
		addTriangleWith: 0.254805 , -0.118079 , -0.350818
			with: -0.440673 , -0.237374 , -0.320061
			with: -0.490652 , 0.0505823 , -0.333315;
		addTriangleWith: 0.254805 , -0.118079 , -0.350818
			with: -0.490652 , 0.0505823 , -0.333315
			with: -0.322292 , 0.289139 , -0.351695;
		addTriangleWith: 0.254805 , -0.118079 , -0.350818
			with: -0.322292 , 0.289139 , -0.351695
			with: -0.0342151 , 0.338552 , -0.364435;
		addTriangleWith: 0.254805 , -0.118079 , -0.350818
			with: -0.0342151 , 0.338552 , -0.364435
			with: 0.204826 , 0.169877 , -0.364072;
		addTriangleWith: 0.17677 , 0.38426 , -0.16698
			with: -0.0342151 , 0.338552 , -0.364435
			with: -0.322292 , 0.289139 , -0.351695;
		addTriangleWith: 0.17677 , 0.38426 , -0.16698
			with: -0.322292 , 0.289139 , -0.351695
			with: -0.518709 , 0.264965 , -0.136224;
		addTriangleWith: 0.17677 , 0.38426 , -0.16698
			with: -0.518709 , 0.264965 , -0.136224
			with: -0.508408 , 0.280192 , 0.155759;
		addTriangleWith: 0.17677 , 0.38426 , -0.16698
			with: -0.508408 , 0.280192 , 0.155759
			with: -0.297424 , 0.3259 , 0.353214;
		addTriangleWith: 0.17677 , 0.38426 , -0.16698
			with: -0.297424 , 0.3259 , 0.353214
			with: -0.00934695 , 0.375313 , 0.340474;
		addTriangleWith: 0.17677 , 0.38426 , -0.16698
			with: -0.00934695 , 0.375313 , 0.340474
			with: 0.18707 , 0.399487 , 0.125003;
		addTriangleWith: 0.229694 , 0.206638 , 0.340838
			with: -0.00934695 , 0.375313 , 0.340474
			with: -0.297424 , 0.3259 , 0.353214;
		addTriangleWith: 0.229694 , 0.206638 , 0.340838
			with: -0.297424 , 0.3259 , 0.353214
			with: -0.465784 , 0.0873436 , 0.371595;
		addTriangleWith: 0.229694 , 0.206638 , 0.340838
			with: -0.465784 , 0.0873436 , 0.371595
			with: -0.415805 , -0.200612 , 0.384848;
		addTriangleWith: 0.229694 , 0.206638 , 0.340838
			with: -0.415805 , -0.200612 , 0.384848
			with: -0.176764 , -0.369287 , 0.385212;
		addTriangleWith: 0.229694 , 0.206638 , 0.340838
			with: -0.176764 , -0.369287 , 0.385212
			with: 0.111313 , -0.319874 , 0.372472;
		addTriangleWith: 0.229694 , 0.206638 , 0.340838
			with: 0.111313 , -0.319874 , 0.372472
			with: 0.279673 , -0.0813176 , 0.354092;
		addTriangleWith: -0.440673 , -0.237374 , -0.320061
			with: -0.398049 , -0.430222 , -0.104226
			with: -0.387748 , -0.414995 , 0.187757;
		addTriangleWith: -0.440673 , -0.237374 , -0.320061
			with: -0.387748 , -0.414995 , 0.187757
			with: -0.415805 , -0.200612 , 0.384848;
		addTriangleWith: -0.440673 , -0.237374 , -0.320061
			with: -0.415805 , -0.200612 , 0.384848
			with: -0.465784 , 0.0873436 , 0.371595;
		addTriangleWith: -0.440673 , -0.237374 , -0.320061
			with: -0.465784 , 0.0873436 , 0.371595
			with: -0.508408 , 0.280192 , 0.155759;
		addTriangleWith: -0.440673 , -0.237374 , -0.320061
			with: -0.508408 , 0.280192 , 0.155759
			with: -0.518709 , 0.264965 , -0.136224;
		addTriangleWith: -0.440673 , -0.237374 , -0.320061
			with: -0.518709 , 0.264965 , -0.136224
			with: -0.490652 , 0.0505823 , -0.333315;
		addTriangleWith: 0.279673 , -0.0813176 , 0.354092
			with: 0.111313 , -0.319874 , 0.372472
			with: 0.30773 , -0.2957 , 0.157;
		addTriangleWith: -0.415805 , -0.200612 , 0.384848
			with: -0.387748 , -0.414995 , 0.187757
			with: -0.176764 , -0.369287 , 0.385212;
		addTriangleWith: 0.18707 , 0.399487 , 0.125003
			with: -0.00934695 , 0.375313 , 0.340474
			with: 0.229694 , 0.206638 , 0.340838;
		addTriangleWith: -0.508408 , 0.280192 , 0.155759
			with: -0.465784 , 0.0873436 , 0.371595
			with: -0.297424 , 0.3259 , 0.353214;
		addTriangleWith: 0.204826 , 0.169877 , -0.364072
			with: -0.0342151 , 0.338552 , -0.364435
			with: 0.17677 , 0.38426 , -0.16698;
		addTriangleWith: -0.490652 , 0.0505823 , -0.333315
			with: -0.518709 , 0.264965 , -0.136224
			with: -0.322292 , 0.289139 , -0.351695;
		addTriangleWith: 0.297429 , -0.310927 , -0.134983
			with: 0.0864447 , -0.356635 , -0.332438
			with: 0.254805 , -0.118079 , -0.350818;
		addTriangleWith: -0.398049 , -0.430222 , -0.104226
			with: -0.440673 , -0.237374 , -0.320061
			with: -0.201632 , -0.406048 , -0.319698! !

!Polyhedron class methodsFor: 'factory-dodecahedron' stamp: 'emm 02/09/2012 23:40'!
augmentedTruncatedDodecahedron
	"self augmentedTruncatedDodecahedron"

	^(Triangle3DComposite new)
		addTriangleWith: -0.0242005 , 0.0158714 , -0.493729
			with: -0.0980836 , -0.131383 , -0.467726
			with: -0.230213 , -0.20563 , -0.398098;
		addTriangleWith: -0.0242005 , 0.0158714 , -0.493729
			with: -0.230213 , -0.20563 , -0.398098
			with: -0.370119 , -0.17851 , -0.31144;
		addTriangleWith: -0.0242005 , 0.0158714 , -0.493729
			with: -0.370119 , -0.17851 , -0.31144
			with: -0.464363 , -0.0603812 , -0.240854;
		addTriangleWith: -0.0242005 , 0.0158714 , -0.493729
			with: -0.464363 , -0.0603812 , -0.240854
			with: -0.476947 , 0.103635 , -0.2133;
		addTriangleWith: -0.0242005 , 0.0158714 , -0.493729
			with: -0.476947 , 0.103635 , -0.2133
			with: -0.403063 , 0.250889 , -0.239303;
		addTriangleWith: -0.0242005 , 0.0158714 , -0.493729
			with: -0.403063 , 0.250889 , -0.239303
			with: -0.270934 , 0.325136 , -0.308931;
		addTriangleWith: -0.0242005 , 0.0158714 , -0.493729
			with: -0.270934 , 0.325136 , -0.308931
			with: -0.131028 , 0.298016 , -0.395588;
		addTriangleWith: -0.0242005 , 0.0158714 , -0.493729
			with: -0.131028 , 0.298016 , -0.395588
			with: -0.0367842 , 0.179887 , -0.466175;
		addTriangleWith: 0.0352595 , 0.309929 , -0.39056
			with: -0.0367842 , 0.179887 , -0.466175
			with: -0.131028 , 0.298016 , -0.395588;
		addTriangleWith: 0.40633 , 0.00199761 , -0.214526
			with: 0.334287 , -0.128044 , -0.290141
			with: 0.205134 , -0.174441 , -0.384934;
		addTriangleWith: 0.40633 , 0.00199761 , -0.214526
			with: 0.205134 , -0.174441 , -0.384934
			with: 0.068204 , -0.11947 , -0.462698;
		addTriangleWith: 0.40633 , 0.00199761 , -0.214526
			with: 0.068204 , -0.11947 , -0.462698
			with: -0.0242005 , 0.0158714 , -0.493729;
		addTriangleWith: 0.40633 , 0.00199761 , -0.214526
			with: -0.0242005 , 0.0158714 , -0.493729
			with: -0.0367842 , 0.179887 , -0.466175;
		addTriangleWith: 0.40633 , 0.00199761 , -0.214526
			with: -0.0367842 , 0.179887 , -0.466175
			with: 0.0352595 , 0.309929 , -0.39056;
		addTriangleWith: 0.40633 , 0.00199761 , -0.214526
			with: 0.0352595 , 0.309929 , -0.39056
			with: 0.164412 , 0.356326 , -0.295767;
		addTriangleWith: 0.40633 , 0.00199761 , -0.214526
			with: 0.164412 , 0.356326 , -0.295767
			with: 0.301342 , 0.301355 , -0.218003;
		addTriangleWith: 0.40633 , 0.00199761 , -0.214526
			with: 0.301342 , 0.301355 , -0.218003
			with: 0.393747 , 0.166013 , -0.186972;
		addTriangleWith: 0.207098 , 0.419483 , -0.147417
			with: 0.301342 , 0.301355 , -0.218003
			with: 0.164412 , 0.356326 , -0.295767;
		addTriangleWith: 0.068204 , -0.11947 , -0.462698
			with: -0.0980836 , -0.131383 , -0.467726
			with: -0.0242005 , 0.0158714 , -0.493729;
		addTriangleWith: 0.0807726 , -0.457767 , -0.0768214
			with: -0.0855149 , -0.46968 , -0.0818495
			with: -0.222445 , -0.414709 , -0.159613;
		addTriangleWith: 0.0807726 , -0.457767 , -0.0768214
			with: -0.222445 , -0.414709 , -0.159613
			with: -0.277714 , -0.313851 , -0.280409;
		addTriangleWith: 0.0807726 , -0.457767 , -0.0768214
			with: -0.277714 , -0.313851 , -0.280409
			with: -0.230213 , -0.20563 , -0.398098;
		addTriangleWith: 0.0807726 , -0.457767 , -0.0768214
			with: -0.230213 , -0.20563 , -0.398098
			with: -0.0980836 , -0.131383 , -0.467726;
		addTriangleWith: 0.0807726 , -0.457767 , -0.0768214
			with: -0.0980836 , -0.131383 , -0.467726
			with: 0.068204 , -0.11947 , -0.462698;
		addTriangleWith: 0.0807726 , -0.457767 , -0.0768214
			with: 0.068204 , -0.11947 , -0.462698
			with: 0.205134 , -0.174441 , -0.384934;
		addTriangleWith: 0.0807726 , -0.457767 , -0.0768214
			with: 0.205134 , -0.174441 , -0.384934
			with: 0.260403 , -0.275299 , -0.264138;
		addTriangleWith: 0.0807726 , -0.457767 , -0.0768214
			with: 0.260403 , -0.275299 , -0.264138
			with: 0.212902 , -0.38352 , -0.146449;
		addTriangleWith: 0.334287 , -0.128044 , -0.290141
			with: 0.260403 , -0.275299 , -0.264138
			with: 0.205134 , -0.174441 , -0.384934;
		addTriangleWith: -0.277714 , -0.313851 , -0.280409
			with: -0.370119 , -0.17851 , -0.31144
			with: -0.230213 , -0.20563 , -0.398098;
		addTriangleWith: -0.379751 , -0.268636 , 0.220637
			with: -0.472155 , -0.133295 , 0.189606
			with: -0.527425 , -0.0324367 , 0.06881;
		addTriangleWith: -0.379751 , -0.268636 , 0.220637
			with: -0.527425 , -0.0324367 , 0.06881
			with: -0.524448 , -0.00458633 , -0.095611;
		addTriangleWith: -0.379751 , -0.268636 , 0.220637
			with: -0.524448 , -0.00458633 , -0.095611
			with: -0.464363 , -0.0603812 , -0.240854;
		addTriangleWith: -0.379751 , -0.268636 , 0.220637
			with: -0.464363 , -0.0603812 , -0.240854
			with: -0.370119 , -0.17851 , -0.31144;
		addTriangleWith: -0.379751 , -0.268636 , 0.220637
			with: -0.370119 , -0.17851 , -0.31144
			with: -0.277714 , -0.313851 , -0.280409;
		addTriangleWith: -0.379751 , -0.268636 , 0.220637
			with: -0.277714 , -0.313851 , -0.280409
			with: -0.222445 , -0.414709 , -0.159613;
		addTriangleWith: -0.379751 , -0.268636 , 0.220637
			with: -0.222445 , -0.414709 , -0.159613
			with: -0.225421 , -0.44256 , 0.004808;
		addTriangleWith: -0.379751 , -0.268636 , 0.220637
			with: -0.225421 , -0.44256 , 0.004808
			with: -0.285507 , -0.386765 , 0.150051;
		addTriangleWith: -0.0855149 , -0.46968 , -0.0818495
			with: -0.225421 , -0.44256 , 0.004808
			with: -0.222445 , -0.414709 , -0.159613;
		addTriangleWith: -0.524448 , -0.00458633 , -0.095611
			with: -0.476947 , 0.103635 , -0.2133
			with: -0.464363 , -0.0603812 , -0.240854;
		addTriangleWith: -0.338812 , 0.308018 , 0.266772
			with: -0.29131 , 0.416238 , 0.149083
			with: -0.288334 , 0.444089 , -0.0153378;
		addTriangleWith: -0.338812 , 0.308018 , 0.266772
			with: -0.288334 , 0.444089 , -0.0153378
			with: -0.33102 , 0.380931 , -0.163688;
		addTriangleWith: -0.338812 , 0.308018 , 0.266772
			with: -0.33102 , 0.380931 , -0.163688
			with: -0.403063 , 0.250889 , -0.239303;
		addTriangleWith: -0.338812 , 0.308018 , 0.266772
			with: -0.403063 , 0.250889 , -0.239303
			with: -0.476947 , 0.103635 , -0.2133;
		addTriangleWith: -0.338812 , 0.308018 , 0.266772
			with: -0.476947 , 0.103635 , -0.2133
			with: -0.524448 , -0.00458633 , -0.095611;
		addTriangleWith: -0.338812 , 0.308018 , 0.266772
			with: -0.524448 , -0.00458633 , -0.095611
			with: -0.527425 , -0.0324367 , 0.06881;
		addTriangleWith: -0.338812 , 0.308018 , 0.266772
			with: -0.527425 , -0.0324367 , 0.06881
			with: -0.484739 , 0.0307209 , 0.21716;
		addTriangleWith: -0.338812 , 0.308018 , 0.266772
			with: -0.484739 , 0.0307209 , 0.21716
			with: -0.412695 , 0.160763 , 0.292775;
		addTriangleWith: -0.472155 , -0.133295 , 0.189606
			with: -0.484739 , 0.0307209 , 0.21716
			with: -0.527425 , -0.0324367 , 0.06881;
		addTriangleWith: -0.33102 , 0.380931 , -0.163688
			with: -0.270934 , 0.325136 , -0.308931
			with: -0.403063 , 0.250889 , -0.239303;
		addTriangleWith: 0.147013 , 0.475278 , -0.00217407
			with: 0.207098 , 0.419483 , -0.147417
			with: 0.164412 , 0.356326 , -0.295767;
		addTriangleWith: 0.147013 , 0.475278 , -0.00217407
			with: 0.164412 , 0.356326 , -0.295767
			with: 0.0352595 , 0.309929 , -0.39056;
		addTriangleWith: 0.147013 , 0.475278 , -0.00217407
			with: 0.0352595 , 0.309929 , -0.39056
			with: -0.131028 , 0.298016 , -0.395588;
		addTriangleWith: 0.147013 , 0.475278 , -0.00217407
			with: -0.131028 , 0.298016 , -0.395588
			with: -0.270934 , 0.325136 , -0.308931;
		addTriangleWith: 0.147013 , 0.475278 , -0.00217407
			with: -0.270934 , 0.325136 , -0.308931
			with: -0.33102 , 0.380931 , -0.163688;
		addTriangleWith: 0.147013 , 0.475278 , -0.00217407
			with: -0.33102 , 0.380931 , -0.163688
			with: -0.288334 , 0.444089 , -0.0153378;
		addTriangleWith: 0.147013 , 0.475278 , -0.00217407
			with: -0.288334 , 0.444089 , -0.0153378
			with: -0.159181 , 0.490485 , 0.0794553;
		addTriangleWith: 0.147013 , 0.475278 , -0.00217407
			with: -0.159181 , 0.490485 , 0.0794553
			with: 0.00710647 , 0.502398 , 0.0844833;
		addTriangleWith: -0.29131 , 0.416238 , 0.149083
			with: -0.159181 , 0.490485 , 0.0794553
			with: -0.288334 , 0.444089 , -0.0153378;
		addTriangleWith: 0.29171 , 0.211228 , 0.314074
			with: 0.151804 , 0.238349 , 0.400731
			with: 0.0196751 , 0.164102 , 0.470359;
		addTriangleWith: 0.29171 , 0.211228 , 0.314074
			with: 0.0196751 , 0.164102 , 0.470359
			with: -0.0542081 , 0.0168471 , 0.496363;
		addTriangleWith: 0.29171 , 0.211228 , 0.314074
			with: -0.0542081 , 0.0168471 , 0.496363
			with: -0.0416244 , -0.147168 , 0.468808;
		addTriangleWith: 0.29171 , 0.211228 , 0.314074
			with: -0.0416244 , -0.147168 , 0.468808
			with: 0.0526195 , -0.265297 , 0.398222;
		addTriangleWith: 0.29171 , 0.211228 , 0.314074
			with: 0.0526195 , -0.265297 , 0.398222
			with: 0.192526 , -0.292418 , 0.311565;
		addTriangleWith: 0.29171 , 0.211228 , 0.314074
			with: 0.192526 , -0.292418 , 0.311565
			with: 0.324655 , -0.218171 , 0.241936;
		addTriangleWith: 0.29171 , 0.211228 , 0.314074
			with: 0.324655 , -0.218171 , 0.241936
			with: 0.398538 , -0.0709162 , 0.215933;
		addTriangleWith: 0.29171 , 0.211228 , 0.314074
			with: 0.398538 , -0.0709162 , 0.215933
			with: 0.385954 , 0.0930996 , 0.243488;
		addTriangleWith: 0.44604 , 0.0373048 , 0.0982449
			with: 0.385954 , 0.0930996 , 0.243488
			with: 0.398538 , -0.0709162 , 0.215933;
		addTriangleWith: 0.207098 , 0.419483 , -0.147417
			with: 0.147013 , 0.475278 , -0.00217407
			with: 0.144036 , 0.447428 , 0.162247;
		addTriangleWith: 0.207098 , 0.419483 , -0.147417
			with: 0.144036 , 0.447428 , 0.162247
			with: 0.199306 , 0.34657 , 0.283043;
		addTriangleWith: 0.207098 , 0.419483 , -0.147417
			with: 0.199306 , 0.34657 , 0.283043
			with: 0.29171 , 0.211228 , 0.314074;
		addTriangleWith: 0.207098 , 0.419483 , -0.147417
			with: 0.29171 , 0.211228 , 0.314074
			with: 0.385954 , 0.0930996 , 0.243488;
		addTriangleWith: 0.207098 , 0.419483 , -0.147417
			with: 0.385954 , 0.0930996 , 0.243488
			with: 0.44604 , 0.0373048 , 0.0982449;
		addTriangleWith: 0.207098 , 0.419483 , -0.147417
			with: 0.44604 , 0.0373048 , 0.0982449
			with: 0.449016 , 0.0651551 , -0.0661761;
		addTriangleWith: 0.207098 , 0.419483 , -0.147417
			with: 0.449016 , 0.0651551 , -0.0661761
			with: 0.393747 , 0.166013 , -0.186972;
		addTriangleWith: 0.207098 , 0.419483 , -0.147417
			with: 0.393747 , 0.166013 , -0.186972
			with: 0.301342 , 0.301355 , -0.218003;
		addTriangleWith: 0.40633 , 0.00199761 , -0.214526
			with: 0.393747 , 0.166013 , -0.186972
			with: 0.449016 , 0.0651551 , -0.0661761;
		addTriangleWith: 0.199306 , 0.34657 , 0.283043
			with: 0.151804 , 0.238349 , 0.400731
			with: 0.29171 , 0.211228 , 0.314074;
		addTriangleWith: -0.29131 , 0.416238 , 0.149083
			with: -0.338812 , 0.308018 , 0.266772
			with: -0.283542 , 0.20716 , 0.387568;
		addTriangleWith: -0.29131 , 0.416238 , 0.149083
			with: -0.283542 , 0.20716 , 0.387568
			with: -0.146612 , 0.152188 , 0.465331;
		addTriangleWith: -0.29131 , 0.416238 , 0.149083
			with: -0.146612 , 0.152188 , 0.465331
			with: 0.0196751 , 0.164102 , 0.470359;
		addTriangleWith: -0.29131 , 0.416238 , 0.149083
			with: 0.0196751 , 0.164102 , 0.470359
			with: 0.151804 , 0.238349 , 0.400731;
		addTriangleWith: -0.29131 , 0.416238 , 0.149083
			with: 0.151804 , 0.238349 , 0.400731
			with: 0.199306 , 0.34657 , 0.283043;
		addTriangleWith: -0.29131 , 0.416238 , 0.149083
			with: 0.199306 , 0.34657 , 0.283043
			with: 0.144036 , 0.447428 , 0.162247;
		addTriangleWith: -0.29131 , 0.416238 , 0.149083
			with: 0.144036 , 0.447428 , 0.162247
			with: 0.00710647 , 0.502398 , 0.0844833;
		addTriangleWith: -0.29131 , 0.416238 , 0.149083
			with: 0.00710647 , 0.502398 , 0.0844833
			with: -0.159181 , 0.490485 , 0.0794553;
		addTriangleWith: 0.147013 , 0.475278 , -0.00217407
			with: 0.00710647 , 0.502398 , 0.0844833
			with: 0.144036 , 0.447428 , 0.162247;
		addTriangleWith: -0.146612 , 0.152188 , 0.465331
			with: -0.0542081 , 0.0168471 , 0.496363
			with: 0.0196751 , 0.164102 , 0.470359;
		addTriangleWith: -0.472155 , -0.133295 , 0.189606
			with: -0.379751 , -0.268636 , 0.220637
			with: -0.242821 , -0.323607 , 0.298401;
		addTriangleWith: -0.472155 , -0.133295 , 0.189606
			with: -0.242821 , -0.323607 , 0.298401
			with: -0.113668 , -0.27721 , 0.393194;
		addTriangleWith: -0.472155 , -0.133295 , 0.189606
			with: -0.113668 , -0.27721 , 0.393194
			with: -0.0416244 , -0.147168 , 0.468808;
		addTriangleWith: -0.472155 , -0.133295 , 0.189606
			with: -0.0416244 , -0.147168 , 0.468808
			with: -0.0542081 , 0.0168471 , 0.496363;
		addTriangleWith: -0.472155 , -0.133295 , 0.189606
			with: -0.0542081 , 0.0168471 , 0.496363
			with: -0.146612 , 0.152188 , 0.465331;
		addTriangleWith: -0.472155 , -0.133295 , 0.189606
			with: -0.146612 , 0.152188 , 0.465331
			with: -0.283542 , 0.20716 , 0.387568;
		addTriangleWith: -0.472155 , -0.133295 , 0.189606
			with: -0.283542 , 0.20716 , 0.387568
			with: -0.412695 , 0.160763 , 0.292775;
		addTriangleWith: -0.472155 , -0.133295 , 0.189606
			with: -0.412695 , 0.160763 , 0.292775
			with: -0.484739 , 0.0307209 , 0.21716;
		addTriangleWith: -0.338812 , 0.308018 , 0.266772
			with: -0.412695 , 0.160763 , 0.292775
			with: -0.283542 , 0.20716 , 0.387568;
		addTriangleWith: -0.113668 , -0.27721 , 0.393194
			with: 0.0526195 , -0.265297 , 0.398222
			with: -0.0416244 , -0.147168 , 0.468808;
		addTriangleWith: -0.0855149 , -0.46968 , -0.0818495
			with: 0.0807726 , -0.457767 , -0.0768214
			with: 0.209925 , -0.41137 , 0.0179716;
		addTriangleWith: -0.0855149 , -0.46968 , -0.0818495
			with: 0.209925 , -0.41137 , 0.0179716
			with: 0.252611 , -0.348213 , 0.166322;
		addTriangleWith: -0.0855149 , -0.46968 , -0.0818495
			with: 0.252611 , -0.348213 , 0.166322
			with: 0.192526 , -0.292418 , 0.311565;
		addTriangleWith: -0.0855149 , -0.46968 , -0.0818495
			with: 0.192526 , -0.292418 , 0.311565
			with: 0.0526195 , -0.265297 , 0.398222;
		addTriangleWith: -0.0855149 , -0.46968 , -0.0818495
			with: 0.0526195 , -0.265297 , 0.398222
			with: -0.113668 , -0.27721 , 0.393194;
		addTriangleWith: -0.0855149 , -0.46968 , -0.0818495
			with: -0.113668 , -0.27721 , 0.393194
			with: -0.242821 , -0.323607 , 0.298401;
		addTriangleWith: -0.0855149 , -0.46968 , -0.0818495
			with: -0.242821 , -0.323607 , 0.298401
			with: -0.285507 , -0.386765 , 0.150051;
		addTriangleWith: -0.0855149 , -0.46968 , -0.0818495
			with: -0.285507 , -0.386765 , 0.150051
			with: -0.225421 , -0.44256 , 0.004808;
		addTriangleWith: -0.379751 , -0.268636 , 0.220637
			with: -0.285507 , -0.386765 , 0.150051
			with: -0.242821 , -0.323607 , 0.298401;
		addTriangleWith: 0.252611 , -0.348213 , 0.166322
			with: 0.324655 , -0.218171 , 0.241936
			with: 0.192526 , -0.292418 , 0.311565;
		addTriangleWith: 0.212902 , -0.38352 , -0.146449
			with: 0.209925 , -0.41137 , 0.0179716
			with: 0.0807726 , -0.457767 , -0.0768214;
		addTriangleWith: 0.425073 , -0.197323 , 0.110406
			with: 0.35303 , -0.327365 , 0.0347915
			with: 0.356006 , -0.299514 , -0.129629;
		addTriangleWith: 0.425073 , -0.197323 , 0.110406
			with: 0.356006 , -0.299514 , -0.129629
			with: 0.429889 , -0.15226 , -0.155633;
		addTriangleWith: 0.425073 , -0.197323 , 0.110406
			with: 0.429889 , -0.15226 , -0.155633
			with: 0.472575 , -0.0891019 , -0.00728237;
		addTriangleWith: 0.35303 , -0.327365 , 0.0347915
			with: 0.425073 , -0.197323 , 0.110406
			with: 0.324655 , -0.218171 , 0.241936;
		addTriangleWith: 0.35303 , -0.327365 , 0.0347915
			with: 0.324655 , -0.218171 , 0.241936
			with: 0.252611 , -0.348213 , 0.166322;
		addTriangleWith: 0.35303 , -0.327365 , 0.0347915
			with: 0.252611 , -0.348213 , 0.166322
			with: 0.209925 , -0.41137 , 0.0179716;
		addTriangleWith: 0.356006 , -0.299514 , -0.129629
			with: 0.35303 , -0.327365 , 0.0347915
			with: 0.209925 , -0.41137 , 0.0179716;
		addTriangleWith: 0.356006 , -0.299514 , -0.129629
			with: 0.209925 , -0.41137 , 0.0179716
			with: 0.212902 , -0.38352 , -0.146449;
		addTriangleWith: 0.356006 , -0.299514 , -0.129629
			with: 0.212902 , -0.38352 , -0.146449
			with: 0.260403 , -0.275299 , -0.264138;
		addTriangleWith: 0.429889 , -0.15226 , -0.155633
			with: 0.356006 , -0.299514 , -0.129629
			with: 0.260403 , -0.275299 , -0.264138;
		addTriangleWith: 0.429889 , -0.15226 , -0.155633
			with: 0.260403 , -0.275299 , -0.264138
			with: 0.334287 , -0.128044 , -0.290141;
		addTriangleWith: 0.429889 , -0.15226 , -0.155633
			with: 0.334287 , -0.128044 , -0.290141
			with: 0.40633 , 0.00199761 , -0.214526;
		addTriangleWith: 0.472575 , -0.0891019 , -0.00728237
			with: 0.429889 , -0.15226 , -0.155633
			with: 0.40633 , 0.00199761 , -0.214526;
		addTriangleWith: 0.472575 , -0.0891019 , -0.00728237
			with: 0.40633 , 0.00199761 , -0.214526
			with: 0.449016 , 0.0651551 , -0.0661761;
		addTriangleWith: 0.44604 , 0.0373048 , 0.0982449
			with: 0.472575 , -0.0891019 , -0.00728237
			with: 0.449016 , 0.0651551 , -0.0661761;
		addTriangleWith: 0.425073 , -0.197323 , 0.110406
			with: 0.472575 , -0.0891019 , -0.00728237
			with: 0.44604 , 0.0373048 , 0.0982449;
		addTriangleWith: 0.425073 , -0.197323 , 0.110406
			with: 0.44604 , 0.0373048 , 0.0982449
			with: 0.398538 , -0.0709162 , 0.215933;
		addTriangleWith: 0.425073 , -0.197323 , 0.110406
			with: 0.398538 , -0.0709162 , 0.215933
			with: 0.324655 , -0.218171 , 0.241936! !

!Polyhedron class methodsFor: 'factory-tetrahedron' stamp: 'emm 02/09/2012 23:40'!
augmentedTruncatedTetrahedron
	"self augmentedTruncatedTetrahedron"

	^(Triangle3DComposite new)
		addTriangleWith: 0.380884 , -0.381 , -0.0843007
			with: 0.118976 , -0.47162 , 0.251374
			with: -0.22871 , -0.401018 , -0.000846017;
		addTriangleWith: 0.380884 , -0.381 , -0.0843007
			with: -0.22871 , -0.401018 , -0.000846017
			with: 0.033198 , -0.310398 , -0.336521;
		addTriangleWith: 0.380884 , -0.381 , -0.0843007
			with: 0.033198 , -0.310398 , -0.336521
			with: 0.339365 , -0.00349729 , -0.29703;
		addTriangleWith: 0.339365 , -0.00349729 , -0.29703
			with: 0.033198 , -0.310398 , -0.336521
			with: -0.387038 , -0.197909 , -0.351794;
		addTriangleWith: 0.339365 , -0.00349729 , -0.29703
			with: -0.387038 , -0.197909 , -0.351794
			with: -0.501108 , 0.22148 , -0.327576;
		addTriangleWith: 0.339365 , -0.00349729 , -0.29703
			with: -0.501108 , 0.22148 , -0.327576
			with: -0.194941 , 0.52838 , -0.288085;
		addTriangleWith: 0.339365 , -0.00349729 , -0.29703
			with: -0.194941 , 0.52838 , -0.288085
			with: 0.225295 , 0.415892 , -0.272812;
		addTriangleWith: 0.225295 , 0.415892 , -0.272812
			with: 0.383623 , 0.212783 , 0.0781363
			with: 0.339365 , -0.00349729 , -0.29703;
		addTriangleWith: 0.383623 , 0.212783 , 0.0781363
			with: 0.425143 , -0.164719 , 0.290865
			with: 0.380884 , -0.381 , -0.0843007;
		addTriangleWith: 0.383623 , 0.212783 , 0.0781363
			with: 0.380884 , -0.381 , -0.0843007
			with: 0.339365 , -0.00349729 , -0.29703;
		addTriangleWith: 0.425143 , -0.164719 , 0.290865
			with: 0.383623 , 0.212783 , 0.0781363
			with: 0.121715 , 0.122163 , 0.413811;
		addTriangleWith: 0.383623 , 0.212783 , 0.0781363
			with: 0.225295 , 0.415892 , -0.272812
			with: -0.194941 , 0.52838 , -0.288085;
		addTriangleWith: 0.383623 , 0.212783 , 0.0781363
			with: -0.194941 , 0.52838 , -0.288085
			with: -0.456849 , 0.43776 , 0.0475898;
		addTriangleWith: 0.383623 , 0.212783 , 0.0781363
			with: -0.456849 , 0.43776 , 0.0475898
			with: -0.298521 , 0.234651 , 0.398538;
		addTriangleWith: 0.383623 , 0.212783 , 0.0781363
			with: -0.298521 , 0.234651 , 0.398538
			with: 0.121715 , 0.122163 , 0.413811;
		addTriangleWith: 0.121715 , 0.122163 , 0.413811
			with: -0.298521 , 0.234651 , 0.398538
			with: -0.184452 , -0.184738 , 0.37432;
		addTriangleWith: -0.501108 , 0.22148 , -0.327576
			with: -0.456849 , 0.43776 , 0.0475898
			with: -0.194941 , 0.52838 , -0.288085;
		addTriangleWith: -0.298521 , 0.234651 , 0.398538
			with: -0.456849 , 0.43776 , 0.0475898
			with: -0.501108 , 0.22148 , -0.327576;
		addTriangleWith: -0.298521 , 0.234651 , 0.398538
			with: -0.501108 , 0.22148 , -0.327576
			with: -0.387038 , -0.197909 , -0.351794;
		addTriangleWith: -0.298521 , 0.234651 , 0.398538
			with: -0.387038 , -0.197909 , -0.351794
			with: -0.22871 , -0.401018 , -0.000846017;
		addTriangleWith: -0.298521 , 0.234651 , 0.398538
			with: -0.22871 , -0.401018 , -0.000846017
			with: -0.184452 , -0.184738 , 0.37432;
		addTriangleWith: -0.22871 , -0.401018 , -0.000846017
			with: -0.387038 , -0.197909 , -0.351794
			with: 0.033198 , -0.310398 , -0.336521;
		addTriangleWith: 0.425143 , -0.164719 , 0.290865
			with: 0.121715 , 0.122163 , 0.413811
			with: -0.184452 , -0.184738 , 0.37432;
		addTriangleWith: 0.425143 , -0.164719 , 0.290865
			with: -0.184452 , -0.184738 , 0.37432
			with: 0.118976 , -0.47162 , 0.251374;
		addTriangleWith: -0.184452 , -0.184738 , 0.37432
			with: -0.22871 , -0.401018 , -0.000846017
			with: 0.118976 , -0.47162 , 0.251374;
		addTriangleWith: 0.425143 , -0.164719 , 0.290865
			with: 0.118976 , -0.47162 , 0.251374
			with: 0.380884 , -0.381 , -0.0843007! !

!Polyhedron class methodsFor: 'factory-pentagonal' stamp: 'emm 02/09/2012 23:40'!
biaugmentedPentagonalPrism
	"self biaugmentedPentagonalPrism"

	^(Triangle3DComposite new)
		add: (Triangle3D 
					with: -0.0692074 , -0.277768 , 0.270396
					with: -0.032699 , 0.0906714 , 0.401672
					with: -0.180135 , 0.331888 , 0.128925);
		add: (Triangle3D 
					with: -0.0692074 , -0.277768 , 0.270396
					with: -0.180135 , 0.331888 , 0.128925
					with: -0.307764 , 0.112529 , -0.170919);
		add: (Triangle3D 
					with: -0.0692074 , -0.277768 , 0.270396
					with: -0.307764 , 0.112529 , -0.170919
					with: -0.239207 , -0.264259 , -0.0834849);
		add: (Triangle3D 
					with: 0.114531 , -0.239106 , -0.252455
					with: 0.0459735 , 0.137682 , -0.339889
					with: 0.173602 , 0.357041 , -0.0400453);
		add: (Triangle3D 
					with: 0.114531 , -0.239106 , -0.252455
					with: 0.173602 , 0.357041 , -0.0400453
					with: 0.321038 , 0.115825 , 0.232702);
		add: (Triangle3D 
					with: 0.114531 , -0.239106 , -0.252455
					with: 0.321038 , 0.115825 , 0.232702
					with: 0.28453 , -0.252614 , 0.101425);
		add: (Triangle3D 
					with: -0.032699 , 0.0906714 , 0.401672
					with: -0.0692074 , -0.277768 , 0.270396
					with: 0.28453 , -0.252614 , 0.101425);
		add: (Triangle3D 
					with: -0.032699 , 0.0906714 , 0.401672
					with: 0.28453 , -0.252614 , 0.101425
					with: 0.321038 , 0.115825 , 0.232702);
		add: (Triangle3D 
					with: -0.180135 , 0.331888 , 0.128925
					with: -0.032699 , 0.0906714 , 0.401672
					with: 0.321038 , 0.115825 , 0.232702);
		add: (Triangle3D 
					with: -0.180135 , 0.331888 , 0.128925
					with: 0.321038 , 0.115825 , 0.232702
					with: 0.173602 , 0.357041 , -0.0400453);
		add: (Triangle3D 
					with: -0.239207 , -0.264259 , -0.0834849
					with: -0.307764 , 0.112529 , -0.170919
					with: 0.0459735 , 0.137682 , -0.339889);
		add: (Triangle3D 
					with: -0.239207 , -0.264259 , -0.0834849
					with: 0.0459735 , 0.137682 , -0.339889
					with: 0.114531 , -0.239106 , -0.252455);
		add: (Triangle3D 
					with: -0.180135 , 0.331888 , 0.128925
					with: -0.147376 , 0.464527 , -0.239379
					with: -0.307764 , 0.112529 , -0.170919);
		add: (Triangle3D 
					with: -0.180135 , 0.331888 , 0.128925
					with: 0.173602 , 0.357041 , -0.0400453
					with: -0.147376 , 0.464527 , -0.239379);
		add: (Triangle3D 
					with: -0.307764 , 0.112529 , -0.170919
					with: -0.147376 , 0.464527 , -0.239379
					with: 0.0459735 , 0.137682 , -0.339889);
		add: (Triangle3D 
					with: 0.0459735 , 0.137682 , -0.339889
					with: -0.147376 , 0.464527 , -0.239379
					with: 0.173602 , 0.357041 , -0.0400453);
		add: (Triangle3D 
					with: -0.239207 , -0.264259 , -0.0834849
					with: 0.0345756 , -0.535473 , -0.0073283
					with: -0.0692074 , -0.277768 , 0.270396);
		add: (Triangle3D 
					with: -0.239207 , -0.264259 , -0.0834849
					with: 0.114531 , -0.239106 , -0.252455
					with: 0.0345756 , -0.535473 , -0.0073283);
		add: (Triangle3D 
					with: -0.0692074 , -0.277768 , 0.270396
					with: 0.0345756 , -0.535473 , -0.0073283
					with: 0.28453 , -0.252614 , 0.101425);
		add: (Triangle3D 
					with: 0.28453 , -0.252614 , 0.101425
					with: 0.0345756 , -0.535473 , -0.0073283
					with: 0.114531 , -0.239106 , -0.252455);
		yourself! !

!Polyhedron class methodsFor: 'factory-triangular' stamp: 'emm 02/09/2012 23:40'!
biaugmentedTriangularPrism
	"self biaugmentedTriangularPrism"

	^(Triangle3DComposite new)
		add: (Triangle3D 
					with: -0.450713 , -0.229267 , 0.091892
					with: 0.122699 , -0.473338 , 0.158258
					with: 0.328094 , 0.0719538 , 0.389007);
		add: (Triangle3D 
					with: -0.450713 , -0.229267 , 0.091892
					with: 0.328094 , 0.0719538 , 0.389007
					with: -0.245317 , 0.316025 , 0.322641);
		add: (Triangle3D 
					with: -0.0361757 , -0.187302 , -0.376268
					with: -0.450713 , -0.229267 , 0.091892
					with: -0.439701 , 0.280777 , -0.272126);
		add: (Triangle3D 
					with: -0.439701 , 0.280777 , -0.272126
					with: -0.450713 , -0.229267 , 0.091892
					with: -0.245317 , 0.316025 , 0.322641);
		add: (Triangle3D 
					with: -0.439701 , 0.280777 , -0.272126
					with: -0.245317 , 0.316025 , 0.322641
					with: 0.16922 , 0.35799 , -0.145519);
		add: (Triangle3D 
					with: 0.122699 , -0.473338 , 0.158258
					with: -0.450713 , -0.229267 , 0.091892
					with: -0.0361757 , -0.187302 , -0.376268);
		add: (Triangle3D 
					with: -0.245317 , 0.316025 , 0.322641
					with: 0.328094 , 0.0719538 , 0.389007
					with: 0.16922 , 0.35799 , -0.145519);
		add: (Triangle3D 
					with: 0.122699 , -0.473338 , 0.158258
					with: -0.0361757 , -0.187302 , -0.376268
					with: 0.549287 , -0.140183 , -0.157662);
		add: (Triangle3D 
					with: 0.122699 , -0.473338 , 0.158258
					with: 0.549287 , -0.140183 , -0.157662
					with: 0.328094 , 0.0719538 , 0.389007);
		add: (Triangle3D 
					with: 0.328094 , 0.0719538 , 0.389007
					with: 0.549287 , -0.140183 , -0.157662
					with: 0.16922 , 0.35799 , -0.145519);
		add: (Triangle3D 
					with: 0.549287 , -0.140183 , -0.157662
					with: -0.0361757 , -0.187302 , -0.376268
					with: 0.16922 , 0.35799 , -0.145519);
		add: (Triangle3D 
					with: -0.439701 , 0.280777 , -0.272126
					with: 0.16922 , 0.35799 , -0.145519
					with: -0.0361757 , -0.187302 , -0.376268);
		yourself! !

!Polyhedron class methodsFor: 'factory-hexagonal' stamp: 'emm 02/09/2012 23:40'!
biaugmentedTruncatedCube
	"self biaugmentedTruncatedCube"

	^(Triangle3DComposite new)
		addTriangleWith: 0.304946 , 0.363969 , -0.157129
			with: 0.170405 , 0.30026 , -0.361886
			with: -0.0307446 , 0.421525 , -0.267445;
		addTriangleWith: 0.304946 , 0.363969 , -0.157129
			with: -0.0307446 , 0.421525 , -0.267445
			with: 0.103796 , 0.485234 , -0.0626888;
		addTriangleWith: 0.170405 , 0.30026 , -0.361886
			with: 0.304946 , 0.363969 , -0.157129
			with: 0.394631 , 0.127688 , -0.142542;
		addTriangleWith: 0.170405 , 0.30026 , -0.361886
			with: 0.394631 , 0.127688 , -0.142542
			with: 0.260091 , 0.0639786 , -0.347298;
		addTriangleWith: 0.170405 , 0.30026 , -0.361886
			with: 0.260091 , 0.0639786 , -0.347298
			with: 0.0227214 , 0.104676 , -0.425303;
		addTriangleWith: -0.0307446 , 0.421525 , -0.267445
			with: 0.170405 , 0.30026 , -0.361886
			with: 0.0227214 , 0.104676 , -0.425303;
		addTriangleWith: -0.0307446 , 0.421525 , -0.267445
			with: 0.0227214 , 0.104676 , -0.425303
			with: -0.178428 , 0.225941 , -0.330863;
		addTriangleWith: -0.0307446 , 0.421525 , -0.267445
			with: -0.178428 , 0.225941 , -0.330863
			with: -0.225528 , 0.356737 , -0.119299;
		addTriangleWith: 0.103796 , 0.485234 , -0.0626888
			with: -0.0307446 , 0.421525 , -0.267445
			with: -0.225528 , 0.356737 , -0.119299;
		addTriangleWith: 0.103796 , 0.485234 , -0.0626888
			with: -0.225528 , 0.356737 , -0.119299
			with: -0.0909869 , 0.420446 , 0.0854572;
		addTriangleWith: 0.103796 , 0.485234 , -0.0626888
			with: -0.0909869 , 0.420446 , 0.0854572
			with: 0.146382 , 0.379748 , 0.163463;
		addTriangleWith: 0.304946 , 0.363969 , -0.157129
			with: 0.103796 , 0.485234 , -0.0626888
			with: 0.146382 , 0.379748 , 0.163463;
		addTriangleWith: 0.304946 , 0.363969 , -0.157129
			with: 0.146382 , 0.379748 , 0.163463
			with: 0.347532 , 0.258483 , 0.0690224;
		addTriangleWith: 0.304946 , 0.363969 , -0.157129
			with: 0.347532 , 0.258483 , 0.0690224
			with: 0.394631 , 0.127688 , -0.142542;
		addTriangleWith: 0.0204352 , -0.451058 , 0.283408
			with: -0.180715 , -0.329793 , 0.377849
			with: -0.315255 , -0.393502 , 0.173092;
		addTriangleWith: 0.0204352 , -0.451058 , 0.283408
			with: -0.315255 , -0.393502 , 0.173092
			with: -0.114106 , -0.514766 , 0.078652;
		addTriangleWith: -0.180715 , -0.329793 , 0.377849
			with: 0.0204352 , -0.451058 , 0.283408
			with: 0.168119 , -0.255474 , 0.346826;
		addTriangleWith: -0.180715 , -0.329793 , 0.377849
			with: 0.168119 , -0.255474 , 0.346826
			with: -0.0330308 , -0.134209 , 0.441266;
		addTriangleWith: -0.180715 , -0.329793 , 0.377849
			with: -0.0330308 , -0.134209 , 0.441266
			with: -0.2704 , -0.0935116 , 0.363261;
		addTriangleWith: -0.315255 , -0.393502 , 0.173092
			with: -0.180715 , -0.329793 , 0.377849
			with: -0.2704 , -0.0935116 , 0.363261;
		addTriangleWith: -0.315255 , -0.393502 , 0.173092
			with: -0.2704 , -0.0935116 , 0.363261
			with: -0.404941 , -0.15722 , 0.158505;
		addTriangleWith: -0.315255 , -0.393502 , 0.173092
			with: -0.404941 , -0.15722 , 0.158505
			with: -0.357841 , -0.288016 , -0.0530591;
		addTriangleWith: -0.114106 , -0.514766 , 0.078652
			with: -0.315255 , -0.393502 , 0.173092
			with: -0.357841 , -0.288016 , -0.0530591;
		addTriangleWith: -0.114106 , -0.514766 , 0.078652
			with: -0.357841 , -0.288016 , -0.0530591
			with: -0.156692 , -0.409281 , -0.147499;
		addTriangleWith: -0.114106 , -0.514766 , 0.078652
			with: -0.156692 , -0.409281 , -0.147499
			with: 0.0806775 , -0.449979 , -0.069494;
		addTriangleWith: 0.0204352 , -0.451058 , 0.283408
			with: -0.114106 , -0.514766 , 0.078652
			with: 0.0806775 , -0.449979 , -0.069494;
		addTriangleWith: 0.0204352 , -0.451058 , 0.283408
			with: 0.0806775 , -0.449979 , -0.069494
			with: 0.215218 , -0.38627 , 0.135262;
		addTriangleWith: 0.0204352 , -0.451058 , 0.283408
			with: 0.215218 , -0.38627 , 0.135262
			with: 0.168119 , -0.255474 , 0.346826;
		addTriangleWith: -0.0909869 , 0.420446 , 0.0854572
			with: -0.311381 , 0.298689 , 0.111666
			with: -0.385696 , 0.0858008 , 0.226736;
		addTriangleWith: -0.0909869 , 0.420446 , 0.0854572
			with: -0.385696 , 0.0858008 , 0.226736
			with: -0.2704 , -0.0935116 , 0.363261;
		addTriangleWith: -0.0909869 , 0.420446 , 0.0854572
			with: -0.2704 , -0.0935116 , 0.363261
			with: -0.0330308 , -0.134209 , 0.441266;
		addTriangleWith: -0.0909869 , 0.420446 , 0.0854572
			with: -0.0330308 , -0.134209 , 0.441266
			with: 0.187363 , -0.0124525 , 0.415057;
		addTriangleWith: -0.0909869 , 0.420446 , 0.0854572
			with: 0.187363 , -0.0124525 , 0.415057
			with: 0.261679 , 0.200436 , 0.299987;
		addTriangleWith: -0.0909869 , 0.420446 , 0.0854572
			with: 0.261679 , 0.200436 , 0.299987
			with: 0.146382 , 0.379748 , 0.163463;
		addTriangleWith: 0.347532 , 0.258483 , 0.0690224
			with: 0.261679 , 0.200436 , 0.299987
			with: 0.187363 , -0.0124525 , 0.415057;
		addTriangleWith: 0.347532 , 0.258483 , 0.0690224
			with: 0.187363 , -0.0124525 , 0.415057
			with: 0.168119 , -0.255474 , 0.346826;
		addTriangleWith: 0.347532 , 0.258483 , 0.0690224
			with: 0.168119 , -0.255474 , 0.346826
			with: 0.215218 , -0.38627 , 0.135262;
		addTriangleWith: 0.347532 , 0.258483 , 0.0690224
			with: 0.215218 , -0.38627 , 0.135262
			with: 0.301072 , -0.328222 , -0.0957029;
		addTriangleWith: 0.347532 , 0.258483 , 0.0690224
			with: 0.301072 , -0.328222 , -0.0957029
			with: 0.375387 , -0.115334 , -0.210773;
		addTriangleWith: 0.347532 , 0.258483 , 0.0690224
			with: 0.375387 , -0.115334 , -0.210773
			with: 0.394631 , 0.127688 , -0.142542;
		addTriangleWith: 0.260091 , 0.0639786 , -0.347298
			with: 0.375387 , -0.115334 , -0.210773
			with: 0.301072 , -0.328222 , -0.0957029;
		addTriangleWith: 0.260091 , 0.0639786 , -0.347298
			with: 0.301072 , -0.328222 , -0.0957029
			with: 0.0806775 , -0.449979 , -0.069494;
		addTriangleWith: 0.260091 , 0.0639786 , -0.347298
			with: 0.0806775 , -0.449979 , -0.069494
			with: -0.156692 , -0.409281 , -0.147499;
		addTriangleWith: 0.260091 , 0.0639786 , -0.347298
			with: -0.156692 , -0.409281 , -0.147499
			with: -0.271988 , -0.229969 , -0.284024;
		addTriangleWith: 0.260091 , 0.0639786 , -0.347298
			with: -0.271988 , -0.229969 , -0.284024
			with: -0.197673 , -0.0170804 , -0.399094;
		addTriangleWith: 0.260091 , 0.0639786 , -0.347298
			with: -0.197673 , -0.0170804 , -0.399094
			with: 0.0227214 , 0.104676 , -0.425303;
		addTriangleWith: -0.178428 , 0.225941 , -0.330863
			with: -0.197673 , -0.0170804 , -0.399094
			with: -0.271988 , -0.229969 , -0.284024;
		addTriangleWith: -0.178428 , 0.225941 , -0.330863
			with: -0.271988 , -0.229969 , -0.284024
			with: -0.357841 , -0.288016 , -0.0530591;
		addTriangleWith: -0.178428 , 0.225941 , -0.330863
			with: -0.357841 , -0.288016 , -0.0530591
			with: -0.404941 , -0.15722 , 0.158505;
		addTriangleWith: -0.178428 , 0.225941 , -0.330863
			with: -0.404941 , -0.15722 , 0.158505
			with: -0.385696 , 0.0858008 , 0.226736;
		addTriangleWith: -0.178428 , 0.225941 , -0.330863
			with: -0.385696 , 0.0858008 , 0.226736
			with: -0.311381 , 0.298689 , 0.111666;
		addTriangleWith: -0.178428 , 0.225941 , -0.330863
			with: -0.311381 , 0.298689 , 0.111666
			with: -0.225528 , 0.356737 , -0.119299;
		addTriangleWith: -0.225528 , 0.356737 , -0.119299
			with: -0.311381 , 0.298689 , 0.111666
			with: -0.0909869 , 0.420446 , 0.0854572;
		addTriangleWith: -0.404941 , -0.15722 , 0.158505
			with: -0.2704 , -0.0935116 , 0.363261
			with: -0.385696 , 0.0858008 , 0.226736;
		addTriangleWith: 0.0227214 , 0.104676 , -0.425303
			with: -0.197673 , -0.0170804 , -0.399094
			with: -0.178428 , 0.225941 , -0.330863;
		addTriangleWith: -0.156692 , -0.409281 , -0.147499
			with: -0.357841 , -0.288016 , -0.0530591
			with: -0.271988 , -0.229969 , -0.284024;
		addTriangleWith: 0.394631 , 0.127688 , -0.142542
			with: 0.375387 , -0.115334 , -0.210773
			with: 0.260091 , 0.0639786 , -0.347298;
		addTriangleWith: 0.215218 , -0.38627 , 0.135262
			with: 0.0806775 , -0.449979 , -0.069494
			with: 0.301072 , -0.328222 , -0.0957029;
		addTriangleWith: 0.146382 , 0.379748 , 0.163463
			with: 0.261679 , 0.200436 , 0.299987
			with: 0.347532 , 0.258483 , 0.0690224;
		addTriangleWith: -0.0330308 , -0.134209 , 0.441266
			with: 0.168119 , -0.255474 , 0.346826
			with: 0.187363 , -0.0124525 , 0.415057! !

!Polyhedron class methodsFor: 'factory-dodecahedron' stamp: 'emm 02/09/2012 23:40'!
bigyrateDiminishedRhombicosidodecahedron
	"self bigyrateDiminishedRhombicosidodecahedron"

	^(Triangle3DComposite new)
		addTriangleWith: -0.520361 , 0.0866397 , 0.0840177
			with: -0.447365 , 0.0358035 , 0.292816
			with: -0.345234 , 0.23803 , 0.306347;
		addTriangleWith: -0.520361 , 0.0866397 , 0.0840177
			with: -0.345234 , 0.23803 , 0.306347
			with: -0.41823 , 0.288866 , 0.0975489;
		addTriangleWith: -0.345234 , 0.23803 , 0.306347
			with: -0.16008 , 0.214591 , 0.435491
			with: -0.169328 , 0.378834 , 0.279132;
		addTriangleWith: -0.16008 , 0.214591 , 0.435491
			with: 0.0665089 , 0.227501 , 0.435651
			with: 0.0572616 , 0.391744 , 0.279292;
		addTriangleWith: -0.16008 , 0.214591 , 0.435491
			with: 0.0572616 , 0.391744 , 0.279292
			with: -0.169328 , 0.378834 , 0.279132;
		addTriangleWith: -0.447365 , 0.0358035 , 0.292816
			with: -0.325331 , -0.112619 , 0.413597
			with: -0.14778 , -0.00212229 , 0.501775;
		addTriangleWith: -0.447365 , 0.0358035 , 0.292816
			with: -0.14778 , -0.00212229 , 0.501775
			with: -0.16008 , 0.214591 , 0.435491;
		addTriangleWith: -0.447365 , 0.0358035 , 0.292816
			with: -0.16008 , 0.214591 , 0.435491
			with: -0.345234 , 0.23803 , 0.306347;
		addTriangleWith: 0.0665089 , 0.227501 , 0.435651
			with: 0.247984 , 0.27183 , 0.306767
			with: 0.0572616 , 0.391744 , 0.279292;
		addTriangleWith: 0.0572616 , 0.391744 , 0.279292
			with: 0.247984 , 0.27183 , 0.306767
			with: 0.315028 , 0.330645 , 0.098068;
		addTriangleWith: 0.0572616 , 0.391744 , 0.279292
			with: 0.315028 , 0.330645 , 0.098068
			with: 0.124306 , 0.450559 , 0.0705929;
		addTriangleWith: -0.14778 , -0.00212229 , 0.501775
			with: 0.0788096 , 0.0107881 , 0.501935
			with: 0.0665089 , 0.227501 , 0.435651;
		addTriangleWith: -0.14778 , -0.00212229 , 0.501775
			with: 0.0665089 , 0.227501 , 0.435651
			with: -0.16008 , 0.214591 , 0.435491;
		addTriangleWith: -0.14778 , -0.00212229 , 0.501775
			with: -0.0233212 , -0.191439 , 0.488404
			with: 0.0788096 , 0.0107881 , 0.501935;
		addTriangleWith: -0.0233212 , -0.191439 , 0.488404
			with: 0.165757 , -0.281046 , 0.400485
			with: 0.267887 , -0.0788192 , 0.414017;
		addTriangleWith: -0.0233212 , -0.191439 , 0.488404
			with: 0.267887 , -0.0788192 , 0.414017
			with: 0.0788096 , 0.0107881 , 0.501935;
		addTriangleWith: 0.0788096 , 0.0107881 , 0.501935
			with: 0.267887 , -0.0788192 , 0.414017
			with: 0.372443 , 0.0825136 , 0.293396;
		addTriangleWith: 0.0788096 , 0.0107881 , 0.501935
			with: 0.372443 , 0.0825136 , 0.293396
			with: 0.247984 , 0.27183 , 0.306767;
		addTriangleWith: 0.0788096 , 0.0107881 , 0.501935
			with: 0.247984 , 0.27183 , 0.306767
			with: 0.0665089 , 0.227501 , 0.435651;
		addTriangleWith: 0.165757 , -0.281046 , 0.400485
			with: 0.347232 , -0.236717 , 0.271601
			with: 0.267887 , -0.0788192 , 0.414017;
		addTriangleWith: 0.267887 , -0.0788192 , 0.414017
			with: 0.347232 , -0.236717 , 0.271601
			with: 0.451788 , -0.0753843 , 0.150981;
		addTriangleWith: 0.267887 , -0.0788192 , 0.414017
			with: 0.451788 , -0.0753843 , 0.150981
			with: 0.372443 , 0.0825136 , 0.293396;
		addTriangleWith: -0.345234 , 0.23803 , 0.306347
			with: -0.169328 , 0.378834 , 0.279132
			with: -0.242324 , 0.42967 , 0.0703333;
		addTriangleWith: -0.345234 , 0.23803 , 0.306347
			with: -0.242324 , 0.42967 , 0.0703333
			with: -0.41823 , 0.288866 , 0.0975489;
		addTriangleWith: -0.41823 , 0.288866 , 0.0975489
			with: -0.242324 , 0.42967 , 0.0703333
			with: -0.351186 , 0.347682 , -0.11115;
		addTriangleWith: -0.242324 , 0.42967 , 0.0703333
			with: -0.0608485 , 0.473999 , -0.0585507
			with: -0.169711 , 0.392011 , -0.240034;
		addTriangleWith: -0.242324 , 0.42967 , 0.0703333
			with: -0.169711 , 0.392011 , -0.240034
			with: -0.351186 , 0.347682 , -0.11115;
		addTriangleWith: -0.169328 , 0.378834 , 0.279132
			with: 0.0572616 , 0.391744 , 0.279292
			with: 0.124306 , 0.450559 , 0.0705929;
		addTriangleWith: -0.169328 , 0.378834 , 0.279132
			with: 0.124306 , 0.450559 , 0.0705929
			with: -0.0608485 , 0.473999 , -0.0585507;
		addTriangleWith: -0.169328 , 0.378834 , 0.279132
			with: -0.0608485 , 0.473999 , -0.0585507
			with: -0.242324 , 0.42967 , 0.0703333;
		addTriangleWith: -0.0608485 , 0.473999 , -0.0585507
			with: 0.0568783 , 0.404921 , -0.239874
			with: -0.169711 , 0.392011 , -0.240034;
		addTriangleWith: 0.0568783 , 0.404921 , -0.239874
			with: 0.242032 , 0.381481 , -0.11073
			with: 0.321377 , 0.223583 , -0.253146;
		addTriangleWith: 0.0568783 , 0.404921 , -0.239874
			with: 0.321377 , 0.223583 , -0.253146
			with: 0.136223 , 0.247023 , -0.382289;
		addTriangleWith: 0.124306 , 0.450559 , 0.0705929
			with: 0.242032 , 0.381481 , -0.11073
			with: 0.0568783 , 0.404921 , -0.239874;
		addTriangleWith: 0.124306 , 0.450559 , 0.0705929
			with: 0.0568783 , 0.404921 , -0.239874
			with: -0.0608485 , 0.473999 , -0.0585507;
		addTriangleWith: 0.124306 , 0.450559 , 0.0705929
			with: 0.315028 , 0.330645 , 0.098068
			with: 0.242032 , 0.381481 , -0.11073;
		addTriangleWith: 0.247984 , 0.27183 , 0.306767
			with: 0.372443 , 0.0825136 , 0.293396
			with: 0.439487 , 0.141329 , 0.0846971;
		addTriangleWith: 0.247984 , 0.27183 , 0.306767
			with: 0.439487 , 0.141329 , 0.0846971
			with: 0.315028 , 0.330645 , 0.098068;
		addTriangleWith: 0.315028 , 0.330645 , 0.098068
			with: 0.439487 , 0.141329 , 0.0846971
			with: 0.443411 , 0.0751611 , -0.132365;
		addTriangleWith: 0.315028 , 0.330645 , 0.098068
			with: 0.443411 , 0.0751611 , -0.132365
			with: 0.321377 , 0.223583 , -0.253146;
		addTriangleWith: 0.315028 , 0.330645 , 0.098068
			with: 0.321377 , 0.223583 , -0.253146
			with: 0.242032 , 0.381481 , -0.11073;
		addTriangleWith: 0.372443 , 0.0825136 , 0.293396
			with: 0.451788 , -0.0753843 , 0.150981
			with: 0.439487 , 0.141329 , 0.0846971;
		addTriangleWith: 0.439487 , 0.141329 , 0.0846971
			with: 0.451788 , -0.0753843 , 0.150981
			with: 0.455711 , -0.141552 , -0.066081;
		addTriangleWith: 0.439487 , 0.141329 , 0.0846971
			with: 0.455711 , -0.141552 , -0.066081
			with: 0.443411 , 0.0751611 , -0.132365;
		addTriangleWith: -0.351186 , 0.347682 , -0.11115
			with: -0.169711 , 0.392011 , -0.240034
			with: -0.230406 , 0.226134 , -0.382549;
		addTriangleWith: -0.351186 , 0.347682 , -0.11115
			with: -0.230406 , 0.226134 , -0.382549
			with: -0.411882 , 0.181805 , -0.253665;
		addTriangleWith: -0.411882 , 0.181805 , -0.253665
			with: -0.230406 , 0.226134 , -0.382549
			with: -0.332537 , 0.0239068 , -0.39608;
		addTriangleWith: -0.230406 , 0.226134 , -0.382549
			with: -0.0413288 , 0.136526 , -0.470467
			with: -0.143459 , -0.0657005 , -0.483998;
		addTriangleWith: -0.230406 , 0.226134 , -0.382549
			with: -0.143459 , -0.0657005 , -0.483998
			with: -0.332537 , 0.0239068 , -0.39608;
		addTriangleWith: -0.169711 , 0.392011 , -0.240034
			with: 0.0568783 , 0.404921 , -0.239874
			with: 0.136223 , 0.247023 , -0.382289;
		addTriangleWith: -0.169711 , 0.392011 , -0.240034
			with: 0.136223 , 0.247023 , -0.382289
			with: -0.0413288 , 0.136526 , -0.470467;
		addTriangleWith: -0.169711 , 0.392011 , -0.240034
			with: -0.0413288 , 0.136526 , -0.470467
			with: -0.230406 , 0.226134 , -0.382549;
		addTriangleWith: 0.136223 , 0.247023 , -0.382289
			with: 0.160432 , 0.0336445 , -0.455726
			with: -0.0413288 , 0.136526 , -0.470467;
		addTriangleWith: -0.0413288 , 0.136526 , -0.470467
			with: 0.160432 , 0.0336445 , -0.455726
			with: 0.0583016 , -0.168582 , -0.469257;
		addTriangleWith: -0.0413288 , 0.136526 , -0.470467
			with: 0.0583016 , -0.168582 , -0.469257
			with: -0.143459 , -0.0657005 , -0.483998;
		addTriangleWith: 0.321377 , 0.223583 , -0.253146
			with: 0.345586 , 0.010205 , -0.326583
			with: 0.160432 , 0.0336445 , -0.455726;
		addTriangleWith: 0.321377 , 0.223583 , -0.253146
			with: 0.160432 , 0.0336445 , -0.455726
			with: 0.136223 , 0.247023 , -0.382289;
		addTriangleWith: 0.321377 , 0.223583 , -0.253146
			with: 0.443411 , 0.0751611 , -0.132365
			with: 0.345586 , 0.010205 , -0.326583;
		addTriangleWith: 0.443411 , 0.0751611 , -0.132365
			with: 0.455711 , -0.141552 , -0.066081
			with: 0.357887 , -0.206508 , -0.260299;
		addTriangleWith: 0.443411 , 0.0751611 , -0.132365
			with: 0.357887 , -0.206508 , -0.260299
			with: 0.345586 , 0.010205 , -0.326583;
		addTriangleWith: 0.345586 , 0.010205 , -0.326583
			with: 0.357887 , -0.206508 , -0.260299
			with: 0.180335 , -0.317005 , -0.348477;
		addTriangleWith: 0.345586 , 0.010205 , -0.326583
			with: 0.180335 , -0.317005 , -0.348477
			with: 0.0583016 , -0.168582 , -0.469257;
		addTriangleWith: 0.345586 , 0.010205 , -0.326583
			with: 0.0583016 , -0.168582 , -0.469257
			with: 0.160432 , 0.0336445 , -0.455726;
		addTriangleWith: 0.455711 , -0.141552 , -0.066081
			with: 0.353581 , -0.343779 , -0.0796122
			with: 0.357887 , -0.206508 , -0.260299;
		addTriangleWith: 0.357887 , -0.206508 , -0.260299
			with: 0.353581 , -0.343779 , -0.0796122
			with: 0.176029 , -0.454276 , -0.16779;
		addTriangleWith: 0.357887 , -0.206508 , -0.260299
			with: 0.176029 , -0.454276 , -0.16779
			with: 0.180335 , -0.317005 , -0.348477;
		addTriangleWith: -0.411882 , 0.181805 , -0.253665
			with: -0.332537 , 0.0239068 , -0.39608
			with: -0.437093 , -0.137426 , -0.27546;
		addTriangleWith: -0.411882 , 0.181805 , -0.253665
			with: -0.437093 , -0.137426 , -0.27546
			with: -0.516437 , 0.0204719 , -0.133044;
		addTriangleWith: -0.516437 , 0.0204719 , -0.133044
			with: -0.437093 , -0.137426 , -0.27546
			with: -0.312634 , -0.326743 , -0.28883;
		addTriangleWith: -0.516437 , 0.0204719 , -0.133044
			with: -0.312634 , -0.326743 , -0.28883
			with: -0.1906 , -0.475165 , -0.16805;
		addTriangleWith: -0.516437 , 0.0204719 , -0.133044
			with: -0.1906 , -0.475165 , -0.16805
			with: -0.117604 , -0.526001 , 0.0407487;
		addTriangleWith: -0.516437 , 0.0204719 , -0.133044
			with: -0.117604 , -0.526001 , 0.0407487
			with: -0.121528 , -0.459833 , 0.257811;
		addTriangleWith: -0.516437 , 0.0204719 , -0.133044
			with: -0.121528 , -0.459833 , 0.257811
			with: -0.200873 , -0.301935 , 0.400226;
		addTriangleWith: -0.516437 , 0.0204719 , -0.133044
			with: -0.200873 , -0.301935 , 0.400226
			with: -0.325331 , -0.112619 , 0.413597;
		addTriangleWith: -0.516437 , 0.0204719 , -0.133044
			with: -0.325331 , -0.112619 , 0.413597
			with: -0.447365 , 0.0358035 , 0.292816;
		addTriangleWith: -0.516437 , 0.0204719 , -0.133044
			with: -0.447365 , 0.0358035 , 0.292816
			with: -0.520361 , 0.0866397 , 0.0840177;
		addTriangleWith: -0.332537 , 0.0239068 , -0.39608
			with: -0.143459 , -0.0657005 , -0.483998
			with: -0.131159 , -0.282414 , -0.417714;
		addTriangleWith: -0.332537 , 0.0239068 , -0.39608
			with: -0.131159 , -0.282414 , -0.417714
			with: -0.312634 , -0.326743 , -0.28883;
		addTriangleWith: -0.332537 , 0.0239068 , -0.39608
			with: -0.312634 , -0.326743 , -0.28883
			with: -0.437093 , -0.137426 , -0.27546;
		addTriangleWith: -0.131159 , -0.282414 , -0.417714
			with: -0.00912511 , -0.430836 , -0.296934
			with: -0.1906 , -0.475165 , -0.16805;
		addTriangleWith: -0.131159 , -0.282414 , -0.417714
			with: -0.1906 , -0.475165 , -0.16805
			with: -0.312634 , -0.326743 , -0.28883;
		addTriangleWith: -0.143459 , -0.0657005 , -0.483998
			with: 0.0583016 , -0.168582 , -0.469257
			with: -0.131159 , -0.282414 , -0.417714;
		addTriangleWith: 0.0583016 , -0.168582 , -0.469257
			with: 0.180335 , -0.317005 , -0.348477
			with: -0.00912511 , -0.430836 , -0.296934;
		addTriangleWith: 0.0583016 , -0.168582 , -0.469257
			with: -0.00912511 , -0.430836 , -0.296934
			with: -0.131159 , -0.282414 , -0.417714;
		addTriangleWith: -0.00912511 , -0.430836 , -0.296934
			with: 0.176029 , -0.454276 , -0.16779
			with: 0.108985 , -0.513091 , 0.040909;
		addTriangleWith: -0.00912511 , -0.430836 , -0.296934
			with: 0.108985 , -0.513091 , 0.040909
			with: -0.117604 , -0.526001 , 0.0407487;
		addTriangleWith: -0.00912511 , -0.430836 , -0.296934
			with: -0.117604 , -0.526001 , 0.0407487
			with: -0.1906 , -0.475165 , -0.16805;
		addTriangleWith: 0.180335 , -0.317005 , -0.348477
			with: 0.176029 , -0.454276 , -0.16779
			with: -0.00912511 , -0.430836 , -0.296934;
		addTriangleWith: 0.176029 , -0.454276 , -0.16779
			with: 0.353581 , -0.343779 , -0.0796122
			with: 0.286537 , -0.402594 , 0.129087;
		addTriangleWith: 0.176029 , -0.454276 , -0.16779
			with: 0.286537 , -0.402594 , 0.129087
			with: 0.108985 , -0.513091 , 0.040909;
		addTriangleWith: -0.325331 , -0.112619 , 0.413597
			with: -0.200873 , -0.301935 , 0.400226
			with: -0.0233212 , -0.191439 , 0.488404;
		addTriangleWith: -0.325331 , -0.112619 , 0.413597
			with: -0.0233212 , -0.191439 , 0.488404
			with: -0.14778 , -0.00212229 , 0.501775;
		addTriangleWith: -0.117604 , -0.526001 , 0.0407487
			with: 0.108985 , -0.513091 , 0.040909
			with: 0.105061 , -0.446923 , 0.257971;
		addTriangleWith: -0.117604 , -0.526001 , 0.0407487
			with: 0.105061 , -0.446923 , 0.257971
			with: -0.121528 , -0.459833 , 0.257811;
		addTriangleWith: -0.121528 , -0.459833 , 0.257811
			with: 0.105061 , -0.446923 , 0.257971
			with: 0.165757 , -0.281046 , 0.400485;
		addTriangleWith: -0.121528 , -0.459833 , 0.257811
			with: 0.165757 , -0.281046 , 0.400485
			with: -0.0233212 , -0.191439 , 0.488404;
		addTriangleWith: -0.121528 , -0.459833 , 0.257811
			with: -0.0233212 , -0.191439 , 0.488404
			with: -0.200873 , -0.301935 , 0.400226;
		addTriangleWith: 0.108985 , -0.513091 , 0.040909
			with: 0.286537 , -0.402594 , 0.129087
			with: 0.105061 , -0.446923 , 0.257971;
		addTriangleWith: 0.105061 , -0.446923 , 0.257971
			with: 0.286537 , -0.402594 , 0.129087
			with: 0.347232 , -0.236717 , 0.271601;
		addTriangleWith: 0.105061 , -0.446923 , 0.257971
			with: 0.347232 , -0.236717 , 0.271601
			with: 0.165757 , -0.281046 , 0.400485;
		addTriangleWith: -0.520361 , 0.0866397 , 0.0840177
			with: -0.41823 , 0.288866 , 0.0975489
			with: -0.351186 , 0.347682 , -0.11115;
		addTriangleWith: -0.520361 , 0.0866397 , 0.0840177
			with: -0.351186 , 0.347682 , -0.11115
			with: -0.411882 , 0.181805 , -0.253665;
		addTriangleWith: -0.520361 , 0.0866397 , 0.0840177
			with: -0.411882 , 0.181805 , -0.253665
			with: -0.516437 , 0.0204719 , -0.133044;
		addTriangleWith: 0.286537 , -0.402594 , 0.129087
			with: 0.353581 , -0.343779 , -0.0796122
			with: 0.455711 , -0.141552 , -0.066081;
		addTriangleWith: 0.286537 , -0.402594 , 0.129087
			with: 0.455711 , -0.141552 , -0.066081
			with: 0.451788 , -0.0753843 , 0.150981;
		addTriangleWith: 0.286537 , -0.402594 , 0.129087
			with: 0.451788 , -0.0753843 , 0.150981
			with: 0.347232 , -0.236717 , 0.271601! !

!Polyhedron class methodsFor: 'factory' stamp: 'emm 02/09/2012 23:40'!
bilunabirotunda
	"self bilunabirotunda"

	^(Triangle3DComposite new)
		addTriangleWith: 0.389544 , 0.0273921 , -0.0237898
			with: 0.200239 , -0.0188687 , -0.335573
			with: 0.0094775 , 0.28747 , -0.265202;
		addTriangleWith: 0.389544 , 0.0273921 , -0.0237898
			with: 0.0094775 , 0.28747 , -0.265202
			with: 0.198783 , 0.333731 , 0.0465819;
		addTriangleWith: 0.200239 , -0.0188687 , -0.335573
			with: 0.389544 , 0.0273921 , -0.0237898
			with: 0.371682 , -0.304756 , -0.180456;
		addTriangleWith: 0.0094775 , 0.28747 , -0.265202
			with: 0.200239 , -0.0188687 , -0.335573
			with: -0.156636 , -0.0401752 , -0.249714;
		addTriangleWith: 0.198783 , 0.333731 , 0.0465819
			with: 0.0094775 , 0.28747 , -0.265202
			with: -0.127737 , 0.49725 , 0.00377867;
		addTriangleWith: 0.389544 , 0.0273921 , -0.0237898
			with: 0.198783 , 0.333731 , 0.0465819
			with: 0.149667 , 0.0346758 , 0.254762;
		addTriangleWith: 0.371682 , -0.304756 , -0.180456
			with: 0.389544 , 0.0273921 , -0.0237898
			with: 0.149667 , 0.0346758 , 0.254762;
		addTriangleWith: 0.371682 , -0.304756 , -0.180456
			with: 0.149667 , 0.0346758 , 0.254762
			with: -0.0164473 , -0.29297 , 0.270249;
		addTriangleWith: 0.371682 , -0.304756 , -0.180456
			with: -0.0164473 , -0.29297 , 0.270249
			with: 0.120765 , -0.50275 , 0.00127052;
		addTriangleWith: 0.200239 , -0.0188687 , -0.335573
			with: 0.371682 , -0.304756 , -0.180456
			with: 0.120765 , -0.50275 , 0.00127052;
		addTriangleWith: 0.200239 , -0.0188687 , -0.335573
			with: 0.120765 , -0.50275 , 0.00127052
			with: -0.205753 , -0.33923 , -0.0415334;
		addTriangleWith: 0.200239 , -0.0188687 , -0.335573
			with: -0.205753 , -0.33923 , -0.0415334
			with: -0.156636 , -0.0401752 , -0.249714;
		addTriangleWith: -0.127737 , 0.49725 , 0.00377867
			with: 0.0094775 , 0.28747 , -0.265202
			with: -0.156636 , -0.0401752 , -0.249714;
		addTriangleWith: -0.127737 , 0.49725 , 0.00377867
			with: -0.156636 , -0.0401752 , -0.249714
			with: -0.396513 , -0.0328919 , 0.0288377;
		addTriangleWith: -0.127737 , 0.49725 , 0.00377867
			with: -0.396513 , -0.0328919 , 0.0288377
			with: -0.378653 , 0.299255 , 0.185505;
		addTriangleWith: 0.198783 , 0.333731 , 0.0465819
			with: -0.127737 , 0.49725 , 0.00377867
			with: -0.378653 , 0.299255 , 0.185505;
		addTriangleWith: 0.198783 , 0.333731 , 0.0465819
			with: -0.378653 , 0.299255 , 0.185505
			with: -0.207208 , 0.0133675 , 0.340621;
		addTriangleWith: 0.198783 , 0.333731 , 0.0465819
			with: -0.207208 , 0.0133675 , 0.340621
			with: 0.149667 , 0.0346758 , 0.254762;
		addTriangleWith: -0.205753 , -0.33923 , -0.0415334
			with: 0.120765 , -0.50275 , 0.00127052
			with: -0.0164473 , -0.29297 , 0.270249;
		addTriangleWith: -0.156636 , -0.0401752 , -0.249714
			with: -0.205753 , -0.33923 , -0.0415334
			with: -0.396513 , -0.0328919 , 0.0288377;
		addTriangleWith: -0.207208 , 0.0133675 , 0.340621
			with: -0.378653 , 0.299255 , 0.185505
			with: -0.396513 , -0.0328919 , 0.0288377;
		addTriangleWith: 0.149667 , 0.0346758 , 0.254762
			with: -0.207208 , 0.0133675 , 0.340621
			with: -0.0164473 , -0.29297 , 0.270249;
		addTriangleWith: -0.0164473 , -0.29297 , 0.270249
			with: -0.207208 , 0.0133675 , 0.340621
			with: -0.396513 , -0.0328919 , 0.0288377;
		addTriangleWith: -0.0164473 , -0.29297 , 0.270249
			with: -0.396513 , -0.0328919 , 0.0288377
			with: -0.205753 , -0.33923 , -0.0415334! !

!Polyhedron class methodsFor: 'factory-hexagonal' stamp: 'emm 02/09/2012 23:40'!
cube
	"self cube"

	^(Triangle3DComposite new)
		add: (Triangle3D 
					with: -0.5 , -0.5 , 0.5
					with: -0.5 , -0.5 , -0.5
					with: 0.5 , -0.5 , -0.5);
		add: (Triangle3D 
					with: -0.5 , -0.5 , 0.5
					with: 0.5 , -0.5 , -0.5
					with: 0.5 , -0.5 , 0.5);
		add: (Triangle3D 
					with: -0.5 , 0.5 , 0.5
					with: -0.5 , -0.5 , 0.5
					with: 0.5 , -0.5 , 0.5);
		add: (Triangle3D 
					with: -0.5 , 0.5 , 0.5
					with: 0.5 , -0.5 , 0.5
					with: 0.5 , 0.5 , 0.5);
		add: (Triangle3D 
					with: -0.5 , 0.5 , 0.5
					with: -0.5 , 0.5 , -0.5
					with: -0.5 , -0.5 , -0.5);
		add: (Triangle3D 
					with: -0.5 , 0.5 , 0.5
					with: -0.5 , -0.5 , -0.5
					with: -0.5 , -0.5 , 0.5);
		add: (Triangle3D 
					with: -0.5 , -0.5 , -0.5
					with: -0.5 , 0.5 , -0.5
					with: 0.5 , 0.5 , -0.5);
		add: (Triangle3D 
					with: -0.5 , -0.5 , -0.5
					with: 0.5 , 0.5 , -0.5
					with: 0.5 , -0.5 , -0.5);
		add: (Triangle3D 
					with: 0.5 , -0.5 , 0.5
					with: 0.5 , -0.5 , -0.5
					with: 0.5 , 0.5 , -0.5);
		add: (Triangle3D 
					with: 0.5 , -0.5 , 0.5
					with: 0.5 , 0.5 , -0.5
					with: 0.5 , 0.5 , 0.5);
		add: (Triangle3D 
					with: 0.5 , 0.5 , 0.5
					with: 0.5 , 0.5 , -0.5
					with: -0.5 , 0.5 , -0.5);
		add: (Triangle3D 
					with: 0.5 , 0.5 , 0.5
					with: -0.5 , 0.5 , -0.5
					with: -0.5 , 0.5 , 0.5);
		yourself! !

!Polyhedron class methodsFor: 'factory' stamp: 'emm 02/09/2012 23:40'!
decagonalAntiprism
	"self decagonalAntiprism"

	^(Triangle3DComposite new)
		add: (Triangle3D 
					with: 0.00626902 , -0.460419 , -0.133248
					with: -0.287624 , -0.364928 , -0.133248
					with: -0.469259 , -0.114928 , -0.133248);
		add: (Triangle3D 
					with: 0.00626902 , -0.460419 , -0.133248
					with: -0.469259 , -0.114928 , -0.133248
					with: -0.469259 , 0.194089 , -0.133248);
		add: (Triangle3D 
					with: 0.00626902 , -0.460419 , -0.133248
					with: -0.469259 , 0.194089 , -0.133248
					with: -0.287624 , 0.444089 , -0.133248);
		add: (Triangle3D 
					with: 0.00626902 , -0.460419 , -0.133248
					with: -0.287624 , 0.444089 , -0.133248
					with: 0.00626902 , 0.539581 , -0.133248);
		add: (Triangle3D 
					with: 0.00626902 , -0.460419 , -0.133248
					with: 0.00626902 , 0.539581 , -0.133248
					with: 0.300162 , 0.444089 , -0.133248);
		add: (Triangle3D 
					with: 0.00626902 , -0.460419 , -0.133248
					with: 0.300162 , 0.444089 , -0.133248
					with: 0.481797 , 0.194089 , -0.133248);
		add: (Triangle3D 
					with: 0.00626902 , -0.460419 , -0.133248
					with: 0.481797 , 0.194089 , -0.133248
					with: 0.481797 , -0.114928 , -0.133248);
		add: (Triangle3D 
					with: 0.00626902 , -0.460419 , -0.133248
					with: 0.481797 , -0.114928 , -0.133248
					with: 0.300162 , -0.364928 , -0.133248);
		add: (Triangle3D 
					with: -0.148239 , -0.435947 , 0.133248
					with: 0.160778 , -0.435947 , 0.133248
					with: 0.410777 , -0.254312 , 0.133248);
		add: (Triangle3D 
					with: -0.148239 , -0.435947 , 0.133248
					with: 0.410777 , -0.254312 , 0.133248
					with: 0.506269 , 0.0395809 , 0.133248);
		add: (Triangle3D 
					with: -0.148239 , -0.435947 , 0.133248
					with: 0.506269 , 0.0395809 , 0.133248
					with: 0.410777 , 0.333473 , 0.133248);
		add: (Triangle3D 
					with: -0.148239 , -0.435947 , 0.133248
					with: 0.410777 , 0.333473 , 0.133248
					with: 0.160778 , 0.515109 , 0.133248);
		add: (Triangle3D 
					with: -0.148239 , -0.435947 , 0.133248
					with: 0.160778 , 0.515109 , 0.133248
					with: -0.148239 , 0.515109 , 0.133248);
		add: (Triangle3D 
					with: -0.148239 , -0.435947 , 0.133248
					with: -0.148239 , 0.515109 , 0.133248
					with: -0.398239 , 0.333473 , 0.133248);
		add: (Triangle3D 
					with: -0.148239 , -0.435947 , 0.133248
					with: -0.398239 , 0.333473 , 0.133248
					with: -0.493731 , 0.0395809 , 0.133248);
		add: (Triangle3D 
					with: -0.148239 , -0.435947 , 0.133248
					with: -0.493731 , 0.0395809 , 0.133248
					with: -0.398239 , -0.254312 , 0.133248);
		add: (Triangle3D 
					with: 0.160778 , 0.515109 , 0.133248
					with: 0.00626902 , 0.539581 , -0.133248
					with: -0.148239 , 0.515109 , 0.133248);
		add: (Triangle3D 
					with: -0.148239 , 0.515109 , 0.133248
					with: 0.00626902 , 0.539581 , -0.133248
					with: -0.287624 , 0.444089 , -0.133248);
		add: (Triangle3D 
					with: -0.148239 , 0.515109 , 0.133248
					with: -0.287624 , 0.444089 , -0.133248
					with: -0.398239 , 0.333473 , 0.133248);
		add: (Triangle3D 
					with: -0.398239 , 0.333473 , 0.133248
					with: -0.287624 , 0.444089 , -0.133248
					with: -0.469259 , 0.194089 , -0.133248);
		add: (Triangle3D 
					with: -0.398239 , 0.333473 , 0.133248
					with: -0.469259 , 0.194089 , -0.133248
					with: -0.493731 , 0.0395809 , 0.133248);
		add: (Triangle3D 
					with: -0.493731 , 0.0395809 , 0.133248
					with: -0.469259 , 0.194089 , -0.133248
					with: -0.469259 , -0.114928 , -0.133248);
		add: (Triangle3D 
					with: -0.493731 , 0.0395809 , 0.133248
					with: -0.469259 , -0.114928 , -0.133248
					with: -0.398239 , -0.254312 , 0.133248);
		add: (Triangle3D 
					with: -0.398239 , -0.254312 , 0.133248
					with: -0.469259 , -0.114928 , -0.133248
					with: -0.287624 , -0.364928 , -0.133248);
		add: (Triangle3D 
					with: -0.398239 , -0.254312 , 0.133248
					with: -0.287624 , -0.364928 , -0.133248
					with: -0.148239 , -0.435947 , 0.133248);
		add: (Triangle3D 
					with: -0.148239 , -0.435947 , 0.133248
					with: -0.287624 , -0.364928 , -0.133248
					with: 0.00626902 , -0.460419 , -0.133248);
		add: (Triangle3D 
					with: -0.148239 , -0.435947 , 0.133248
					with: 0.00626902 , -0.460419 , -0.133248
					with: 0.160778 , -0.435947 , 0.133248);
		add: (Triangle3D 
					with: 0.160778 , -0.435947 , 0.133248
					with: 0.00626902 , -0.460419 , -0.133248
					with: 0.300162 , -0.364928 , -0.133248);
		add: (Triangle3D 
					with: 0.160778 , -0.435947 , 0.133248
					with: 0.300162 , -0.364928 , -0.133248
					with: 0.410777 , -0.254312 , 0.133248);
		add: (Triangle3D 
					with: 0.410777 , -0.254312 , 0.133248
					with: 0.300162 , -0.364928 , -0.133248
					with: 0.481797 , -0.114928 , -0.133248);
		add: (Triangle3D 
					with: 0.410777 , -0.254312 , 0.133248
					with: 0.481797 , -0.114928 , -0.133248
					with: 0.506269 , 0.0395809 , 0.133248);
		add: (Triangle3D 
					with: 0.506269 , 0.0395809 , 0.133248
					with: 0.481797 , -0.114928 , -0.133248
					with: 0.481797 , 0.194089 , -0.133248);
		add: (Triangle3D 
					with: 0.506269 , 0.0395809 , 0.133248
					with: 0.481797 , 0.194089 , -0.133248
					with: 0.410777 , 0.333473 , 0.133248);
		add: (Triangle3D 
					with: 0.410777 , 0.333473 , 0.133248
					with: 0.481797 , 0.194089 , -0.133248
					with: 0.300162 , 0.444089 , -0.133248);
		add: (Triangle3D 
					with: 0.410777 , 0.333473 , 0.133248
					with: 0.300162 , 0.444089 , -0.133248
					with: 0.160778 , 0.515109 , 0.133248);
		add: (Triangle3D 
					with: 0.160778 , 0.515109 , 0.133248
					with: 0.300162 , 0.444089 , -0.133248
					with: 0.00626902 , 0.539581 , -0.133248);
		yourself! !

!Polyhedron class methodsFor: 'factory' stamp: 'emm 02/09/2012 23:40'!
decagonalPrism
	"self decagonalPrism"

	^(Triangle3DComposite new)
		add: (Triangle3D 
					with: 0.217854 , -0.441063 , -0.0345047
					with: -0.0345048 , -0.441063 , -0.217854
					with: -0.238667 , -0.257714 , -0.366187);
		add: (Triangle3D 
					with: 0.217854 , -0.441063 , -0.0345047
					with: -0.238667 , -0.257714 , -0.366187
					with: -0.31665 , 0.038952 , -0.422845);
		add: (Triangle3D 
					with: 0.217854 , -0.441063 , -0.0345047
					with: -0.31665 , 0.038952 , -0.422845
					with: -0.238667 , 0.335618 , -0.366187);
		add: (Triangle3D 
					with: 0.217854 , -0.441063 , -0.0345047
					with: -0.238667 , 0.335618 , -0.366187
					with: -0.0345048 , 0.518967 , -0.217854);
		add: (Triangle3D 
					with: 0.217854 , -0.441063 , -0.0345047
					with: -0.0345048 , 0.518967 , -0.217854
					with: 0.217854 , 0.518967 , -0.0345047);
		add: (Triangle3D 
					with: 0.217854 , -0.441063 , -0.0345047
					with: 0.217854 , 0.518967 , -0.0345047
					with: 0.422017 , 0.335618 , 0.113828);
		add: (Triangle3D 
					with: 0.217854 , -0.441063 , -0.0345047
					with: 0.422017 , 0.335618 , 0.113828
					with: 0.5 , 0.038952 , 0.170486);
		add: (Triangle3D 
					with: 0.217854 , -0.441063 , -0.0345047
					with: 0.5 , 0.038952 , 0.170486
					with: 0.422017 , -0.257714 , 0.113828);
		add: (Triangle3D 
					with: -0.217854 , -0.441063 , 0.0345047
					with: 0.0345047 , -0.441063 , 0.217854
					with: 0.238667 , -0.257714 , 0.366187);
		add: (Triangle3D 
					with: -0.217854 , -0.441063 , 0.0345047
					with: 0.238667 , -0.257714 , 0.366187
					with: 0.316651 , 0.038952 , 0.422845);
		add: (Triangle3D 
					with: -0.217854 , -0.441063 , 0.0345047
					with: 0.316651 , 0.038952 , 0.422845
					with: 0.238667 , 0.335618 , 0.366187);
		add: (Triangle3D 
					with: -0.217854 , -0.441063 , 0.0345047
					with: 0.238667 , 0.335618 , 0.366187
					with: 0.0345047 , 0.518967 , 0.217854);
		add: (Triangle3D 
					with: -0.217854 , -0.441063 , 0.0345047
					with: 0.0345047 , 0.518967 , 0.217854
					with: -0.217854 , 0.518967 , 0.0345047);
		add: (Triangle3D 
					with: -0.217854 , -0.441063 , 0.0345047
					with: -0.217854 , 0.518967 , 0.0345047
					with: -0.422017 , 0.335618 , -0.113828);
		add: (Triangle3D 
					with: -0.217854 , -0.441063 , 0.0345047
					with: -0.422017 , 0.335618 , -0.113828
					with: -0.5 , 0.038952 , -0.170486);
		add: (Triangle3D 
					with: -0.217854 , -0.441063 , 0.0345047
					with: -0.5 , 0.038952 , -0.170486
					with: -0.422017 , -0.257714 , -0.113828);
		add: (Triangle3D 
					with: -0.217854 , 0.518967 , 0.0345047
					with: -0.0345048 , 0.518967 , -0.217854
					with: -0.238667 , 0.335618 , -0.366187);
		add: (Triangle3D 
					with: -0.217854 , 0.518967 , 0.0345047
					with: -0.238667 , 0.335618 , -0.366187
					with: -0.422017 , 0.335618 , -0.113828);
		add: (Triangle3D 
					with: -0.422017 , 0.335618 , -0.113828
					with: -0.238667 , 0.335618 , -0.366187
					with: -0.31665 , 0.038952 , -0.422845);
		add: (Triangle3D 
					with: -0.422017 , 0.335618 , -0.113828
					with: -0.31665 , 0.038952 , -0.422845
					with: -0.5 , 0.038952 , -0.170486);
		add: (Triangle3D 
					with: -0.5 , 0.038952 , -0.170486
					with: -0.31665 , 0.038952 , -0.422845
					with: -0.238667 , -0.257714 , -0.366187);
		add: (Triangle3D 
					with: -0.5 , 0.038952 , -0.170486
					with: -0.238667 , -0.257714 , -0.366187
					with: -0.422017 , -0.257714 , -0.113828);
		add: (Triangle3D 
					with: -0.422017 , -0.257714 , -0.113828
					with: -0.238667 , -0.257714 , -0.366187
					with: -0.0345048 , -0.441063 , -0.217854);
		add: (Triangle3D 
					with: -0.422017 , -0.257714 , -0.113828
					with: -0.0345048 , -0.441063 , -0.217854
					with: -0.217854 , -0.441063 , 0.0345047);
		add: (Triangle3D 
					with: -0.217854 , -0.441063 , 0.0345047
					with: -0.0345048 , -0.441063 , -0.217854
					with: 0.217854 , -0.441063 , -0.0345047);
		add: (Triangle3D 
					with: -0.217854 , -0.441063 , 0.0345047
					with: 0.217854 , -0.441063 , -0.0345047
					with: 0.0345047 , -0.441063 , 0.217854);
		add: (Triangle3D 
					with: 0.0345047 , -0.441063 , 0.217854
					with: 0.217854 , -0.441063 , -0.0345047
					with: 0.422017 , -0.257714 , 0.113828);
		add: (Triangle3D 
					with: 0.0345047 , -0.441063 , 0.217854
					with: 0.422017 , -0.257714 , 0.113828
					with: 0.238667 , -0.257714 , 0.366187);
		add: (Triangle3D 
					with: 0.238667 , -0.257714 , 0.366187
					with: 0.422017 , -0.257714 , 0.113828
					with: 0.5 , 0.038952 , 0.170486);
		add: (Triangle3D 
					with: 0.238667 , -0.257714 , 0.366187
					with: 0.5 , 0.038952 , 0.170486
					with: 0.316651 , 0.038952 , 0.422845);
		add: (Triangle3D 
					with: 0.316651 , 0.038952 , 0.422845
					with: 0.5 , 0.038952 , 0.170486
					with: 0.422017 , 0.335618 , 0.113828);
		add: (Triangle3D 
					with: 0.316651 , 0.038952 , 0.422845
					with: 0.422017 , 0.335618 , 0.113828
					with: 0.238667 , 0.335618 , 0.366187);
		add: (Triangle3D 
					with: 0.238667 , 0.335618 , 0.366187
					with: 0.422017 , 0.335618 , 0.113828
					with: 0.217854 , 0.518967 , -0.0345047);
		add: (Triangle3D 
					with: 0.238667 , 0.335618 , 0.366187
					with: 0.217854 , 0.518967 , -0.0345047
					with: 0.0345047 , 0.518967 , 0.217854);
		add: (Triangle3D 
					with: 0.0345047 , 0.518967 , 0.217854
					with: 0.217854 , 0.518967 , -0.0345047
					with: -0.0345048 , 0.518967 , -0.217854);
		add: (Triangle3D 
					with: 0.0345047 , 0.518967 , 0.217854
					with: -0.0345048 , 0.518967 , -0.217854
					with: -0.217854 , 0.518967 , 0.0345047);
		yourself! !

!Polyhedron class methodsFor: 'factory-dodecahedron' stamp: 'emm 02/09/2012 23:40'!
diminishedRhombicosidodecahedron
	"self diminishedRhombicosidodecahedron"

	^(Triangle3DComposite new)
		addTriangleWith: 0.0545072 , 0.148516 , -0.50853
			with: -0.151484 , 0.0547126 , -0.509524
			with: -0.233677 , 0.234031 , -0.398521;
		addTriangleWith: 0.0545072 , 0.148516 , -0.50853
			with: -0.233677 , 0.234031 , -0.398521
			with: -0.0276862 , 0.327835 , -0.397527;
		addTriangleWith: -0.0276862 , 0.327835 , -0.397527
			with: -0.233677 , 0.234031 , -0.398521
			with: -0.183205 , 0.394676 , -0.247266;
		addTriangleWith: -0.233677 , 0.234031 , -0.398521
			with: -0.403119 , 0.162864 , -0.266396
			with: -0.352647 , 0.323509 , -0.115141;
		addTriangleWith: -0.233677 , 0.234031 , -0.398521
			with: -0.352647 , 0.323509 , -0.115141
			with: -0.183205 , 0.394676 , -0.247266;
		addTriangleWith: -0.151484 , 0.0547126 , -0.509524
			with: -0.270127 , -0.127279 , -0.446001
			with: -0.425646 , -0.0604379 , -0.29574;
		addTriangleWith: -0.151484 , 0.0547126 , -0.509524
			with: -0.425646 , -0.0604379 , -0.29574
			with: -0.403119 , 0.162864 , -0.266396;
		addTriangleWith: -0.151484 , 0.0547126 , -0.509524
			with: -0.403119 , 0.162864 , -0.266396
			with: -0.233677 , 0.234031 , -0.398521;
		addTriangleWith: -0.403119 , 0.162864 , -0.266396
			with: -0.47129 , 0.141518 , -0.0516181
			with: -0.352647 , 0.323509 , -0.115141;
		addTriangleWith: -0.352647 , 0.323509 , -0.115141
			with: -0.47129 , 0.141518 , -0.0516181
			with: -0.412153 , 0.178145 , 0.163774;
		addTriangleWith: -0.352647 , 0.323509 , -0.115141
			with: -0.412153 , 0.178145 , 0.163774
			with: -0.293509 , 0.360137 , 0.100251;
		addTriangleWith: -0.425646 , -0.0604379 , -0.29574
			with: -0.493818 , -0.0817846 , -0.0809624
			with: -0.47129 , 0.141518 , -0.0516181;
		addTriangleWith: -0.425646 , -0.0604379 , -0.29574
			with: -0.47129 , 0.141518 , -0.0516181
			with: -0.403119 , 0.162864 , -0.266396;
		addTriangleWith: -0.425646 , -0.0604379 , -0.29574
			with: -0.411624 , -0.261103 , -0.191965
			with: -0.493818 , -0.0817846 , -0.0809624;
		addTriangleWith: -0.411624 , -0.261103 , -0.191965
			with: -0.366409 , -0.362484 , 0.00529123
			with: -0.448603 , -0.183166 , 0.116294;
		addTriangleWith: -0.411624 , -0.261103 , -0.191965
			with: -0.448603 , -0.183166 , 0.116294
			with: -0.493818 , -0.0817846 , -0.0809624;
		addTriangleWith: -0.493818 , -0.0817846 , -0.0809624
			with: -0.448603 , -0.183166 , 0.116294
			with: -0.398131 , -0.0225203 , 0.267549;
		addTriangleWith: -0.493818 , -0.0817846 , -0.0809624
			with: -0.398131 , -0.0225203 , 0.267549
			with: -0.412153 , 0.178145 , 0.163774;
		addTriangleWith: -0.493818 , -0.0817846 , -0.0809624
			with: -0.412153 , 0.178145 , 0.163774
			with: -0.47129 , 0.141518 , -0.0516181;
		addTriangleWith: -0.366409 , -0.362484 , 0.00529123
			with: -0.307272 , -0.325857 , 0.220683
			with: -0.448603 , -0.183166 , 0.116294;
		addTriangleWith: -0.448603 , -0.183166 , 0.116294
			with: -0.307272 , -0.325857 , 0.220683
			with: -0.2568 , -0.165212 , 0.371938;
		addTriangleWith: -0.448603 , -0.183166 , 0.116294
			with: -0.2568 , -0.165212 , 0.371938
			with: -0.398131 , -0.0225203 , 0.267549;
		addTriangleWith: -0.0276862 , 0.327835 , -0.397527
			with: -0.183205 , 0.394676 , -0.247266
			with: -0.0193467 , 0.475287 , -0.113533;
		addTriangleWith: -0.0276862 , 0.327835 , -0.397527
			with: -0.0193467 , 0.475287 , -0.113533
			with: 0.136172 , 0.408446 , -0.263794;
		addTriangleWith: 0.136172 , 0.408446 , -0.263794
			with: -0.0193467 , 0.475287 , -0.113533
			with: 0.19531 , 0.445073 , -0.0484023;
		addTriangleWith: -0.0193467 , 0.475287 , -0.113533
			with: -0.0875182 , 0.453941 , 0.101245
			with: 0.127139 , 0.423727 , 0.166375;
		addTriangleWith: -0.0193467 , 0.475287 , -0.113533
			with: 0.127139 , 0.423727 , 0.166375
			with: 0.19531 , 0.445073 , -0.0484023;
		addTriangleWith: -0.183205 , 0.394676 , -0.247266
			with: -0.352647 , 0.323509 , -0.115141
			with: -0.293509 , 0.360137 , 0.100251;
		addTriangleWith: -0.183205 , 0.394676 , -0.247266
			with: -0.293509 , 0.360137 , 0.100251
			with: -0.0875182 , 0.453941 , 0.101245;
		addTriangleWith: -0.183205 , 0.394676 , -0.247266
			with: -0.0875182 , 0.453941 , 0.101245
			with: -0.0193467 , 0.475287 , -0.113533;
		addTriangleWith: -0.0875182 , 0.453941 , 0.101245
			with: -0.0423031 , 0.35256 , 0.298501
			with: 0.127139 , 0.423727 , 0.166375;
		addTriangleWith: 0.127139 , 0.423727 , 0.166375
			with: -0.0423031 , 0.35256 , 0.298501
			with: 0.0990281 , 0.209868 , 0.40289;
		addTriangleWith: 0.127139 , 0.423727 , 0.166375
			with: 0.0990281 , 0.209868 , 0.40289
			with: 0.26847 , 0.281035 , 0.270765;
		addTriangleWith: -0.293509 , 0.360137 , 0.100251
			with: -0.248294 , 0.258756 , 0.297507
			with: -0.0423031 , 0.35256 , 0.298501;
		addTriangleWith: -0.293509 , 0.360137 , 0.100251
			with: -0.0423031 , 0.35256 , 0.298501
			with: -0.0875182 , 0.453941 , 0.101245;
		addTriangleWith: -0.293509 , 0.360137 , 0.100251
			with: -0.412153 , 0.178145 , 0.163774
			with: -0.248294 , 0.258756 , 0.297507;
		addTriangleWith: -0.412153 , 0.178145 , 0.163774
			with: -0.398131 , -0.0225203 , 0.267549
			with: -0.234272 , 0.0580905 , 0.401282;
		addTriangleWith: -0.412153 , 0.178145 , 0.163774
			with: -0.234272 , 0.0580905 , 0.401282
			with: -0.248294 , 0.258756 , 0.297507;
		addTriangleWith: -0.248294 , 0.258756 , 0.297507
			with: -0.234272 , 0.0580905 , 0.401282
			with: -0.0196154 , 0.0278765 , 0.466413;
		addTriangleWith: -0.248294 , 0.258756 , 0.297507
			with: -0.0196154 , 0.0278765 , 0.466413
			with: 0.0990281 , 0.209868 , 0.40289;
		addTriangleWith: -0.248294 , 0.258756 , 0.297507
			with: 0.0990281 , 0.209868 , 0.40289
			with: -0.0423031 , 0.35256 , 0.298501;
		addTriangleWith: -0.398131 , -0.0225203 , 0.267549
			with: -0.2568 , -0.165212 , 0.371938
			with: -0.234272 , 0.0580905 , 0.401282;
		addTriangleWith: -0.234272 , 0.0580905 , 0.401282
			with: -0.2568 , -0.165212 , 0.371938
			with: -0.0421428 , -0.195426 , 0.437068;
		addTriangleWith: -0.234272 , 0.0580905 , 0.401282
			with: -0.0421428 , -0.195426 , 0.437068
			with: -0.0196154 , 0.0278765 , 0.466413;
		addTriangleWith: 0.136172 , 0.408446 , -0.263794
			with: 0.19531 , 0.445073 , -0.0484023
			with: 0.378774 , 0.315575 , -0.0767527;
		addTriangleWith: 0.136172 , 0.408446 , -0.263794
			with: 0.378774 , 0.315575 , -0.0767527
			with: 0.319636 , 0.278948 , -0.292144;
		addTriangleWith: 0.319636 , 0.278948 , -0.292144
			with: 0.378774 , 0.315575 , -0.0767527
			with: 0.460967 , 0.136256 , -0.187755;
		addTriangleWith: 0.378774 , 0.315575 , -0.0767527
			with: 0.423989 , 0.214194 , 0.120503
			with: 0.506182 , 0.0348755 , 0.00950082;
		addTriangleWith: 0.378774 , 0.315575 , -0.0767527
			with: 0.506182 , 0.0348755 , 0.00950082
			with: 0.460967 , 0.136256 , -0.187755;
		addTriangleWith: 0.19531 , 0.445073 , -0.0484023
			with: 0.127139 , 0.423727 , 0.166375
			with: 0.26847 , 0.281035 , 0.270765;
		addTriangleWith: 0.19531 , 0.445073 , -0.0484023
			with: 0.26847 , 0.281035 , 0.270765
			with: 0.423989 , 0.214194 , 0.120503;
		addTriangleWith: 0.19531 , 0.445073 , -0.0484023
			with: 0.423989 , 0.214194 , 0.120503
			with: 0.378774 , 0.315575 , -0.0767527;
		addTriangleWith: 0.423989 , 0.214194 , 0.120503
			with: 0.438011 , 0.0135288 , 0.224278
			with: 0.506182 , 0.0348755 , 0.00950082;
		addTriangleWith: 0.506182 , 0.0348755 , 0.00950082
			with: 0.438011 , 0.0135288 , 0.224278
			with: 0.415483 , -0.209773 , 0.194934;
		addTriangleWith: 0.506182 , 0.0348755 , 0.00950082
			with: 0.415483 , -0.209773 , 0.194934
			with: 0.483655 , -0.188427 , -0.0198434;
		addTriangleWith: 0.26847 , 0.281035 , 0.270765
			with: 0.282492 , 0.0803702 , 0.37454
			with: 0.438011 , 0.0135288 , 0.224278;
		addTriangleWith: 0.26847 , 0.281035 , 0.270765
			with: 0.438011 , 0.0135288 , 0.224278
			with: 0.423989 , 0.214194 , 0.120503;
		addTriangleWith: 0.26847 , 0.281035 , 0.270765
			with: 0.0990281 , 0.209868 , 0.40289
			with: 0.282492 , 0.0803702 , 0.37454;
		addTriangleWith: 0.0990281 , 0.209868 , 0.40289
			with: -0.0196154 , 0.0278765 , 0.466413
			with: 0.163848 , -0.101622 , 0.438062;
		addTriangleWith: 0.0990281 , 0.209868 , 0.40289
			with: 0.163848 , -0.101622 , 0.438062
			with: 0.282492 , 0.0803702 , 0.37454;
		addTriangleWith: 0.282492 , 0.0803702 , 0.37454
			with: 0.163848 , -0.101622 , 0.438062
			with: 0.246042 , -0.28094 , 0.32706;
		addTriangleWith: 0.282492 , 0.0803702 , 0.37454
			with: 0.246042 , -0.28094 , 0.32706
			with: 0.415483 , -0.209773 , 0.194934;
		addTriangleWith: 0.282492 , 0.0803702 , 0.37454
			with: 0.415483 , -0.209773 , 0.194934
			with: 0.438011 , 0.0135288 , 0.224278;
		addTriangleWith: -0.0196154 , 0.0278765 , 0.466413
			with: -0.0421428 , -0.195426 , 0.437068
			with: 0.163848 , -0.101622 , 0.438062;
		addTriangleWith: 0.163848 , -0.101622 , 0.438062
			with: -0.0421428 , -0.195426 , 0.437068
			with: 0.0400506 , -0.374744 , 0.326066;
		addTriangleWith: 0.163848 , -0.101622 , 0.438062
			with: 0.0400506 , -0.374744 , 0.326066
			with: 0.246042 , -0.28094 , 0.32706;
		addTriangleWith: 0.319636 , 0.278948 , -0.292144
			with: 0.460967 , 0.136256 , -0.187755
			with: 0.410495 , -0.0243888 , -0.33901;
		addTriangleWith: 0.319636 , 0.278948 , -0.292144
			with: 0.410495 , -0.0243888 , -0.33901
			with: 0.269164 , 0.118302 , -0.443399;
		addTriangleWith: 0.269164 , 0.118302 , -0.443399
			with: 0.410495 , -0.0243888 , -0.33901
			with: 0.424517 , -0.225054 , -0.235235;
		addTriangleWith: 0.269164 , 0.118302 , -0.443399
			with: 0.424517 , -0.225054 , -0.235235
			with: 0.305874 , -0.407046 , -0.171713;
		addTriangleWith: 0.269164 , 0.118302 , -0.443399
			with: 0.305874 , -0.407046 , -0.171713
			with: 0.0998827 , -0.50085 , -0.172706;
		addTriangleWith: 0.269164 , 0.118302 , -0.443399
			with: 0.0998827 , -0.50085 , -0.172706
			with: -0.114774 , -0.470636 , -0.237837;
		addTriangleWith: 0.269164 , 0.118302 , -0.443399
			with: -0.114774 , -0.470636 , -0.237837
			with: -0.256105 , -0.327944 , -0.342226;
		addTriangleWith: 0.269164 , 0.118302 , -0.443399
			with: -0.256105 , -0.327944 , -0.342226
			with: -0.270127 , -0.127279 , -0.446001;
		addTriangleWith: 0.269164 , 0.118302 , -0.443399
			with: -0.270127 , -0.127279 , -0.446001
			with: -0.151484 , 0.0547126 , -0.509524;
		addTriangleWith: 0.269164 , 0.118302 , -0.443399
			with: -0.151484 , 0.0547126 , -0.509524
			with: 0.0545072 , 0.148516 , -0.50853;
		addTriangleWith: 0.460967 , 0.136256 , -0.187755
			with: 0.506182 , 0.0348755 , 0.00950082
			with: 0.483655 , -0.188427 , -0.0198434;
		addTriangleWith: 0.460967 , 0.136256 , -0.187755
			with: 0.483655 , -0.188427 , -0.0198434
			with: 0.424517 , -0.225054 , -0.235235;
		addTriangleWith: 0.460967 , 0.136256 , -0.187755
			with: 0.424517 , -0.225054 , -0.235235
			with: 0.410495 , -0.0243888 , -0.33901;
		addTriangleWith: 0.483655 , -0.188427 , -0.0198434
			with: 0.365011 , -0.370419 , 0.0436789
			with: 0.305874 , -0.407046 , -0.171713;
		addTriangleWith: 0.483655 , -0.188427 , -0.0198434
			with: 0.305874 , -0.407046 , -0.171713
			with: 0.424517 , -0.225054 , -0.235235;
		addTriangleWith: 0.483655 , -0.188427 , -0.0198434
			with: 0.415483 , -0.209773 , 0.194934
			with: 0.365011 , -0.370419 , 0.0436789;
		addTriangleWith: 0.415483 , -0.209773 , 0.194934
			with: 0.246042 , -0.28094 , 0.32706
			with: 0.19557 , -0.441585 , 0.175805;
		addTriangleWith: 0.415483 , -0.209773 , 0.194934
			with: 0.19557 , -0.441585 , 0.175805
			with: 0.365011 , -0.370419 , 0.0436789;
		addTriangleWith: 0.365011 , -0.370419 , 0.0436789
			with: 0.19557 , -0.441585 , 0.175805
			with: 0.031711 , -0.522196 , 0.042071;
		addTriangleWith: 0.365011 , -0.370419 , 0.0436789
			with: 0.031711 , -0.522196 , 0.042071
			with: 0.0998827 , -0.50085 , -0.172706;
		addTriangleWith: 0.365011 , -0.370419 , 0.0436789
			with: 0.0998827 , -0.50085 , -0.172706
			with: 0.305874 , -0.407046 , -0.171713;
		addTriangleWith: 0.246042 , -0.28094 , 0.32706
			with: 0.0400506 , -0.374744 , 0.326066
			with: 0.19557 , -0.441585 , 0.175805;
		addTriangleWith: 0.19557 , -0.441585 , 0.175805
			with: 0.0400506 , -0.374744 , 0.326066
			with: -0.123808 , -0.455355 , 0.192332;
		addTriangleWith: 0.19557 , -0.441585 , 0.175805
			with: -0.123808 , -0.455355 , 0.192332
			with: 0.031711 , -0.522196 , 0.042071;
		addTriangleWith: -0.270127 , -0.127279 , -0.446001
			with: -0.256105 , -0.327944 , -0.342226
			with: -0.411624 , -0.261103 , -0.191965;
		addTriangleWith: -0.270127 , -0.127279 , -0.446001
			with: -0.411624 , -0.261103 , -0.191965
			with: -0.425646 , -0.0604379 , -0.29574;
		addTriangleWith: 0.0998827 , -0.50085 , -0.172706
			with: 0.031711 , -0.522196 , 0.042071
			with: -0.182946 , -0.491982 , -0.0230593;
		addTriangleWith: 0.0998827 , -0.50085 , -0.172706
			with: -0.182946 , -0.491982 , -0.0230593
			with: -0.114774 , -0.470636 , -0.237837;
		addTriangleWith: -0.114774 , -0.470636 , -0.237837
			with: -0.182946 , -0.491982 , -0.0230593
			with: -0.366409 , -0.362484 , 0.00529123;
		addTriangleWith: -0.114774 , -0.470636 , -0.237837
			with: -0.366409 , -0.362484 , 0.00529123
			with: -0.411624 , -0.261103 , -0.191965;
		addTriangleWith: -0.114774 , -0.470636 , -0.237837
			with: -0.411624 , -0.261103 , -0.191965
			with: -0.256105 , -0.327944 , -0.342226;
		addTriangleWith: 0.031711 , -0.522196 , 0.042071
			with: -0.123808 , -0.455355 , 0.192332
			with: -0.182946 , -0.491982 , -0.0230593;
		addTriangleWith: -0.182946 , -0.491982 , -0.0230593
			with: -0.123808 , -0.455355 , 0.192332
			with: -0.307272 , -0.325857 , 0.220683;
		addTriangleWith: -0.182946 , -0.491982 , -0.0230593
			with: -0.307272 , -0.325857 , 0.220683
			with: -0.366409 , -0.362484 , 0.00529123;
		addTriangleWith: 0.0545072 , 0.148516 , -0.50853
			with: -0.0276862 , 0.327835 , -0.397527
			with: 0.136172 , 0.408446 , -0.263794;
		addTriangleWith: 0.0545072 , 0.148516 , -0.50853
			with: 0.136172 , 0.408446 , -0.263794
			with: 0.319636 , 0.278948 , -0.292144;
		addTriangleWith: 0.0545072 , 0.148516 , -0.50853
			with: 0.319636 , 0.278948 , -0.292144
			with: 0.269164 , 0.118302 , -0.443399;
		addTriangleWith: -0.123808 , -0.455355 , 0.192332
			with: 0.0400506 , -0.374744 , 0.326066
			with: -0.0421428 , -0.195426 , 0.437068;
		addTriangleWith: -0.123808 , -0.455355 , 0.192332
			with: -0.0421428 , -0.195426 , 0.437068
			with: -0.2568 , -0.165212 , 0.371938;
		addTriangleWith: -0.123808 , -0.455355 , 0.192332
			with: -0.2568 , -0.165212 , 0.371938
			with: -0.307272 , -0.325857 , 0.220683! !

!Polyhedron class methodsFor: 'factory' stamp: 'emm 02/09/2012 23:40'!
disphenocingulum
	"self disphenocingulum"

	^(Triangle3DComposite new)
		addTriangleWith: 0.364337 , -0.406689 , -0.0637061
			with: -0.0531733 , -0.449428 , 0.107943
			with: 0.00475311 , -0.408715 , -0.339934;
		addTriangleWith: 0.0514477 , -0.154295 , 0.435902
			with: -0.0531733 , -0.449428 , 0.107943
			with: 0.364337 , -0.406689 , -0.0637061;
		addTriangleWith: 0.0514477 , -0.154295 , 0.435902
			with: 0.364337 , -0.406689 , -0.0637061
			with: 0.468958 , -0.111556 , 0.264254;
		addTriangleWith: 0.0514477 , -0.154295 , 0.435902
			with: 0.468958 , -0.111556 , 0.264254
			with: 0.240461 , 0.256211 , 0.398948;
		addTriangleWith: 0.297846 , -0.0629383 , -0.351839
			with: 0.364337 , -0.406689 , -0.0637061
			with: 0.00475311 , -0.408715 , -0.339934;
		addTriangleWith: 0.468958 , -0.111556 , 0.264254
			with: 0.364337 , -0.406689 , -0.0637061
			with: 0.297846 , -0.0629383 , -0.351839;
		addTriangleWith: 0.468958 , -0.111556 , 0.264254
			with: 0.297846 , -0.0629383 , -0.351839
			with: 0.402467 , 0.232195 , -0.0238803;
		addTriangleWith: 0.468958 , -0.111556 , 0.264254
			with: 0.402467 , 0.232195 , -0.0238803
			with: 0.240461 , 0.256211 , 0.398948;
		addTriangleWith: 0.297846 , -0.0629383 , -0.351839
			with: 0.135118 , 0.36002 , -0.367089
			with: 0.402467 , 0.232195 , -0.0238803;
		addTriangleWith: 0.297846 , -0.0629383 , -0.351839
			with: 0.00475311 , -0.408715 , -0.339934
			with: -0.140511 , 0.00816355 , -0.443458;
		addTriangleWith: 0.297846 , -0.0629383 , -0.351839
			with: -0.140511 , 0.00816355 , -0.443458
			with: 0.135118 , 0.36002 , -0.367089;
		addTriangleWith: 0.135118 , 0.36002 , -0.367089
			with: -0.140511 , 0.00816355 , -0.443458
			with: -0.302255 , 0.385076 , -0.250111;
		addTriangleWith: -0.140511 , 0.00816355 , -0.443458
			with: -0.369298 , -0.243743 , -0.143781
			with: -0.531042 , 0.13317 , 0.0495661;
		addTriangleWith: -0.140511 , 0.00816355 , -0.443458
			with: -0.531042 , 0.13317 , 0.0495661
			with: -0.302255 , 0.385076 , -0.250111;
		addTriangleWith: 0.00475311 , -0.408715 , -0.339934
			with: -0.0531733 , -0.449428 , 0.107943
			with: -0.369298 , -0.243743 , -0.143781;
		addTriangleWith: -0.140511 , 0.00816355 , -0.443458
			with: 0.00475311 , -0.408715 , -0.339934
			with: -0.369298 , -0.243743 , -0.143781;
		addTriangleWith: -0.369298 , -0.243743 , -0.143781
			with: -0.0531733 , -0.449428 , 0.107943
			with: -0.380331 , -0.207516 , 0.308074;
		addTriangleWith: -0.369298 , -0.243743 , -0.143781
			with: -0.380331 , -0.207516 , 0.308074
			with: -0.531042 , 0.13317 , 0.0495661;
		addTriangleWith: -0.302255 , 0.385076 , -0.250111
			with: -0.531042 , 0.13317 , 0.0495661
			with: -0.208781 , 0.209069 , 0.359395;
		addTriangleWith: -0.302255 , 0.385076 , -0.250111
			with: -0.208781 , 0.209069 , 0.359395
			with: 0.0200054 , 0.460976 , 0.0597174;
		addTriangleWith: 0.135118 , 0.36002 , -0.367089
			with: -0.302255 , 0.385076 , -0.250111
			with: 0.0200054 , 0.460976 , 0.0597174;
		addTriangleWith: 0.135118 , 0.36002 , -0.367089
			with: 0.0200054 , 0.460976 , 0.0597174
			with: 0.402467 , 0.232195 , -0.0238803;
		addTriangleWith: 0.0200054 , 0.460976 , 0.0597174
			with: 0.240461 , 0.256211 , 0.398948
			with: 0.402467 , 0.232195 , -0.0238803;
		addTriangleWith: 0.0200054 , 0.460976 , 0.0597174
			with: -0.208781 , 0.209069 , 0.359395
			with: 0.240461 , 0.256211 , 0.398948;
		addTriangleWith: 0.240461 , 0.256211 , 0.398948
			with: -0.208781 , 0.209069 , 0.359395
			with: 0.0514477 , -0.154295 , 0.435902;
		addTriangleWith: 0.0514477 , -0.154295 , 0.435902
			with: -0.380331 , -0.207516 , 0.308074
			with: -0.0531733 , -0.449428 , 0.107943;
		addTriangleWith: -0.208781 , 0.209069 , 0.359395
			with: -0.380331 , -0.207516 , 0.308074
			with: 0.0514477 , -0.154295 , 0.435902;
		addTriangleWith: -0.531042 , 0.13317 , 0.0495661
			with: -0.380331 , -0.207516 , 0.308074
			with: -0.208781 , 0.209069 , 0.359395! !

!Polyhedron class methodsFor: 'factory-hexagonal' stamp: 'emm 9/22/2012 19:47'!
dodecadodecahedron

	"self dodecadodecahedron"


"
	^(Triangle3DComposite new)

		addTriangleWith: -0.136886 , -0.402926 , 0.124643

			with: -0.121706 , -0.490214 , -0.0479639

			with: -0.0214374 , -0.429996 , 0.106836;

		addTriangleWith: -0.323686 , -0.359126 , 0.153457

			with: -0.136886 , -0.402926 , 0.124643

			with: -0.0214374 , -0.429996 , 0.106836;

		addTriangleWith: -0.323686 , -0.359126 , 0.153457

			with: -0.0214374 , -0.429996 , 0.106836

			with: 0.165363 , -0.473796 , 0.078022;

		addTriangleWith: -0.323686 , -0.359126 , 0.153457

			with: 0.165363 , -0.473796 , 0.078022

			with: 0.040532 , -0.392779 , 0.202507;

		addTriangleWith: 0.040532 , -0.392779 , 0.202507

			with: 0.140801 , -0.332561 , 0.357306

			with: -0.0366175 , -0.342708 , 0.279443;

		addTriangleWith: -0.0366175 , -0.342708 , 0.279443

			with: -0.161448 , -0.261691 , 0.403928

			with: -0.146268 , -0.348979 , 0.23132;

		addTriangleWith: 0.040532 , -0.392779 , 0.202507

			with: -0.0366175 , -0.342708 , 0.279443

			with: -0.146268 , -0.348979 , 0.23132;

		addTriangleWith: -0.323686 , -0.359126 , 0.153457

			with: 0.040532 , -0.392779 , 0.202507

			with: -0.146268 , -0.348979 , 0.23132;

		addTriangleWith: -0.377179 , -0.231949 , 0.017047

			with: -0.190379 , -0.27575 , -0.0117665

			with: -0.136886 , -0.402926 , 0.124643;

		addTriangleWith: -0.377179 , -0.231949 , 0.017047

			with: -0.136886 , -0.402926 , 0.124643

			with: -0.323686 , -0.359126 , 0.153457;

		addTriangleWith: -0.0597499 , -0.390108 , -0.202181

			with: 0.0405188 , -0.32989 , -0.047382

			with: -0.0214374 , -0.429996 , 0.106836;

		addTriangleWith: -0.0597499 , -0.390108 , -0.202181

			with: -0.0214374 , -0.429996 , 0.106836

			with: -0.121706 , -0.490214 , -0.0479639;

		addTriangleWith: 0.289288 , -0.336473 , 0.0194757

			with: 0.164458 , -0.255456 , 0.143961

			with: 0.040532 , -0.392779 , 0.202507;

		addTriangleWith: 0.289288 , -0.336473 , 0.0194757

			with: 0.040532 , -0.392779 , 0.202507

			with: 0.165363 , -0.473796 , 0.078022;

		addTriangleWith: 0.187577 , -0.145166 , 0.375696

			with: 0.0101587 , -0.155313 , 0.297832

			with: -0.0366175 , -0.342708 , 0.279443;

		addTriangleWith: 0.187577 , -0.145166 , 0.375696

			with: -0.0366175 , -0.342708 , 0.279443

			with: 0.140801 , -0.332561 , 0.357306;

		addTriangleWith: -0.224322 , -0.0805672 , 0.374195

			with: -0.209142 , -0.167855 , 0.201588

			with: -0.146268 , -0.348979 , 0.23132;

		addTriangleWith: -0.224322 , -0.0805672 , 0.374195

			with: -0.146268 , -0.348979 , 0.23132

			with: -0.161448 , -0.261691 , 0.403928;

		addTriangleWith: -0.377179 , -0.231949 , 0.017047

			with: -0.323686 , -0.359126 , 0.153457

			with: -0.38656 , -0.178002 , 0.123724;

		addTriangleWith: -0.38656 , -0.178002 , 0.123724

			with: -0.40174 , -0.0907141 , 0.296331

			with: -0.425419 , -0.0660619 , 0.105348;

		addTriangleWith: -0.377179 , -0.231949 , 0.017047

			with: -0.38656 , -0.178002 , 0.123724

			with: -0.425419 , -0.0660619 , 0.105348;

		addTriangleWith: -0.361999 , -0.319238 , -0.15556

			with: -0.377179 , -0.231949 , 0.017047

			with: -0.425419 , -0.0660619 , 0.105348;

		addTriangleWith: -0.425419 , -0.0660619 , 0.105348

			with: -0.488293 , 0.115062 , 0.0756155

			with: -0.440053 , -0.050826 , -0.0126857;

		addTriangleWith: -0.440053 , -0.050826 , -0.0126857

			with: -0.463731 , -0.0261739 , -0.203669

			with: -0.410239 , -0.15335 , -0.0672589;

		addTriangleWith: -0.425419 , -0.0660619 , 0.105348

			with: -0.440053 , -0.050826 , -0.0126857

			with: -0.410239 , -0.15335 , -0.0672589;

		addTriangleWith: -0.361999 , -0.319238 , -0.15556

			with: -0.425419 , -0.0660619 , 0.105348

			with: -0.410239 , -0.15335 , -0.0672589;

		addTriangleWith: -0.175199 , -0.363038 , -0.184374

			with: -0.190379 , -0.27575 , -0.0117665

			with: -0.377179 , -0.231949 , 0.017047;

		addTriangleWith: -0.175199 , -0.363038 , -0.184374

			with: -0.377179 , -0.231949 , 0.017047

			with: -0.361999 , -0.319238 , -0.15556;

		addTriangleWith: -0.146268 , -0.348979 , 0.23132

			with: -0.209142 , -0.167855 , 0.201588

			with: -0.38656 , -0.178002 , 0.123724;

		addTriangleWith: -0.146268 , -0.348979 , 0.23132

			with: -0.38656 , -0.178002 , 0.123724

			with: -0.323686 , -0.359126 , 0.153457;

		addTriangleWith: -0.263181 , 0.0313732 , 0.355819

			with: -0.286859 , 0.0560254 , 0.164836

			with: -0.425419 , -0.0660619 , 0.105348;

		addTriangleWith: -0.263181 , 0.0313732 , 0.355819

			with: -0.425419 , -0.0660619 , 0.105348

			with: -0.40174 , -0.0907141 , 0.296331;

		addTriangleWith: -0.364367 , 0.252385 , 0.0170692

			with: -0.316127 , 0.0864972 , -0.071232

			with: -0.440053 , -0.050826 , -0.0126857;

		addTriangleWith: -0.364367 , 0.252385 , 0.0170692

			with: -0.440053 , -0.050826 , -0.0126857

			with: -0.488293 , 0.115062 , 0.0756155;

		addTriangleWith: -0.309992 , 0.0086252 , -0.316788

			with: -0.256499 , -0.118551 , -0.180378

			with: -0.410239 , -0.15335 , -0.0672589;

		addTriangleWith: -0.309992 , 0.0086252 , -0.316788

			with: -0.410239 , -0.15335 , -0.0672589

			with: -0.463731 , -0.0261739 , -0.203669;

		addTriangleWith: -0.0597499 , -0.390108 , -0.202181

			with: -0.121706 , -0.490214 , -0.0479639

			with: -0.175199 , -0.363038 , -0.184374;

		addTriangleWith: -0.175199 , -0.363038 , -0.184374

			with: -0.361999 , -0.319238 , -0.15556

			with: -0.208259 , -0.284439 , -0.26868;

		addTriangleWith: -0.0597499 , -0.390108 , -0.202181

			with: -0.175199 , -0.363038 , -0.184374

			with: -0.208259 , -0.284439 , -0.26868;

		addTriangleWith: 0.12705 , -0.433908 , -0.230995

			with: -0.0597499 , -0.390108 , -0.202181

			with: -0.208259 , -0.284439 , -0.26868;

		addTriangleWith: -0.208259 , -0.284439 , -0.26868

			with: -0.261751 , -0.157262 , -0.405089

			with: -0.113242 , -0.262932 , -0.338591;

		addTriangleWith: 0.12705 , -0.433908 , -0.230995

			with: -0.208259 , -0.284439 , -0.26868

			with: -0.113242 , -0.262932 , -0.338591;

		addTriangleWith: -0.113242 , -0.262932 , -0.338591

			with: 0.0404974 , -0.228133 , -0.451711

			with: -0.0214588 , -0.328239 , -0.297493;

		addTriangleWith: 0.12705 , -0.433908 , -0.230995

			with: -0.113242 , -0.262932 , -0.338591

			with: -0.0214588 , -0.328239 , -0.297493;

		addTriangleWith: 0.227319 , -0.37369 , -0.0761956

			with: 0.0405188 , -0.32989 , -0.047382

			with: -0.0597499 , -0.390108 , -0.202181;

		addTriangleWith: 0.227319 , -0.37369 , -0.0761956

			with: -0.0597499 , -0.390108 , -0.202181

			with: 0.12705 , -0.433908 , -0.230995;

		addTriangleWith: -0.136886 , -0.402926 , 0.124643

			with: -0.190379 , -0.27575 , -0.0117665

			with: -0.175199 , -0.363038 , -0.184374;

		addTriangleWith: -0.136886 , -0.402926 , 0.124643

			with: -0.175199 , -0.363038 , -0.184374

			with: -0.121706 , -0.490214 , -0.0479639;

		addTriangleWith: -0.410239 , -0.15335 , -0.0672589

			with: -0.256499 , -0.118551 , -0.180378

			with: -0.208259 , -0.284439 , -0.26868;

		addTriangleWith: -0.410239 , -0.15335 , -0.0672589

			with: -0.208259 , -0.284439 , -0.26868

			with: -0.361999 , -0.319238 , -0.15556;

		addTriangleWith: -0.214975 , 0.0301322 , -0.3867

			with: -0.0664662 , -0.0755371 , -0.320202

			with: -0.113242 , -0.262932 , -0.338591;

		addTriangleWith: -0.214975 , 0.0301322 , -0.3867

			with: -0.113242 , -0.262932 , -0.338591

			with: -0.261751 , -0.157262 , -0.405089;

		addTriangleWith: 0.179057 , -0.106045 , -0.392223

			with: 0.117101 , -0.206152 , -0.238005

			with: -0.0214588 , -0.328239 , -0.297493;

		addTriangleWith: 0.179057 , -0.106045 , -0.392223

			with: -0.0214588 , -0.328239 , -0.297493

			with: 0.0404974 , -0.228133 , -0.451711;

		addTriangleWith: 0.289288 , -0.336473 , 0.0194757

			with: 0.165363 , -0.473796 , 0.078022

			with: 0.227319 , -0.37369 , -0.0761956;

		addTriangleWith: 0.389557 , -0.276255 , 0.174275

			with: 0.289288 , -0.336473 , 0.0194757

			with: 0.227319 , -0.37369 , -0.0761956;

		addTriangleWith: 0.389557 , -0.276255 , 0.174275

			with: 0.227319 , -0.37369 , -0.0761956

			with: 0.12705 , -0.433908 , -0.230995;

		addTriangleWith: 0.389557 , -0.276255 , 0.174275

			with: 0.12705 , -0.433908 , -0.230995

			with: 0.26561 , -0.311821 , -0.171507;

		addTriangleWith: 0.26561 , -0.311821 , -0.171507

			with: 0.327566 , -0.211715 , -0.325725

			with: 0.351244 , -0.236367 , -0.134742;

		addTriangleWith: 0.26561 , -0.311821 , -0.171507

			with: 0.351244 , -0.236367 , -0.134742

			with: 0.489804 , -0.114279 , -0.0752541;

		addTriangleWith: 0.26561 , -0.311821 , -0.171507

			with: 0.489804 , -0.114279 , -0.0752541

			with: 0.365878 , -0.251603 , -0.0167079;

		addTriangleWith: 0.389557 , -0.276255 , 0.174275

			with: 0.26561 , -0.311821 , -0.171507

			with: 0.365878 , -0.251603 , -0.0167079;

		addTriangleWith: 0.264726 , -0.195238 , 0.29876

			with: 0.164458 , -0.255456 , 0.143961

			with: 0.289288 , -0.336473 , 0.0194757;

		addTriangleWith: 0.264726 , -0.195238 , 0.29876

			with: 0.289288 , -0.336473 , 0.0194757

			with: 0.389557 , -0.276255 , 0.174275;

		addTriangleWith: -0.0214374 , -0.429996 , 0.106836

			with: 0.0405188 , -0.32989 , -0.047382

			with: 0.227319 , -0.37369 , -0.0761956;

		addTriangleWith: -0.0214374 , -0.429996 , 0.106836

			with: 0.227319 , -0.37369 , -0.0761956

			with: 0.165363 , -0.473796 , 0.078022;

		addTriangleWith: -0.0214588 , -0.328239 , -0.297493

			with: 0.117101 , -0.206152 , -0.238005

			with: 0.26561 , -0.311821 , -0.171507;

		addTriangleWith: -0.0214588 , -0.328239 , -0.297493

			with: 0.26561 , -0.311821 , -0.171507

			with: 0.12705 , -0.433908 , -0.230995;

		addTriangleWith: 0.264692 , -0.0305911 , -0.355458

			with: 0.28837 , -0.0552433 , -0.164475

			with: 0.351244 , -0.236367 , -0.134742;

		addTriangleWith: 0.264692 , -0.0305911 , -0.355458

			with: 0.351244 , -0.236367 , -0.134742

			with: 0.327566 , -0.211715 , -0.325725;

		addTriangleWith: 0.441564 , 0.0516081 , 0.0130471

			with: 0.317638 , -0.0857151 , 0.0715934

			with: 0.365878 , -0.251603 , -0.0167079;

		addTriangleWith: 0.441564 , 0.0516081 , 0.0130471

			with: 0.365878 , -0.251603 , -0.0167079

			with: 0.489804 , -0.114279 , -0.0752541;

		addTriangleWith: 0.187577 , -0.145166 , 0.375696

			with: 0.140801 , -0.332561 , 0.357306

			with: 0.264726 , -0.195238 , 0.29876;

		addTriangleWith: 0.0627464 , -0.0641492 , 0.500181

			with: 0.187577 , -0.145166 , 0.375696

			with: 0.264726 , -0.195238 , 0.29876;

		addTriangleWith: 0.0627464 , -0.0641492 , 0.500181

			with: 0.264726 , -0.195238 , 0.29876

			with: 0.389557 , -0.276255 , 0.174275;

		addTriangleWith: 0.0627464 , -0.0641492 , 0.500181

			with: 0.389557 , -0.276255 , 0.174275

			with: 0.341317 , -0.110367 , 0.262576;

		addTriangleWith: 0.341317 , -0.110367 , 0.262576

			with: 0.465242 , 0.0269559 , 0.20403

			with: 0.311503 , -0.00784314 , 0.31715;

		addTriangleWith: 0.0627464 , -0.0641492 , 0.500181

			with: 0.341317 , -0.110367 , 0.262576

			with: 0.311503 , -0.00784314 , 0.31715;

		addTriangleWith: 0.311503 , -0.00784314 , 0.31715

			with: 0.263262 , 0.158044 , 0.405451

			with: 0.216486 , -0.0293501 , 0.387061;

		addTriangleWith: 0.0627464 , -0.0641492 , 0.500181

			with: 0.311503 , -0.00784314 , 0.31715

			with: 0.216486 , -0.0293501 , 0.387061;

		addTriangleWith: -0.114672 , -0.0742961 , 0.422317

			with: 0.0101587 , -0.155313 , 0.297832

			with: 0.187577 , -0.145166 , 0.375696;

		addTriangleWith: -0.114672 , -0.0742961 , 0.422317

			with: 0.187577 , -0.145166 , 0.375696

			with: 0.0627464 , -0.0641492 , 0.500181;

		addTriangleWith: 0.040532 , -0.392779 , 0.202507

			with: 0.164458 , -0.255456 , 0.143961

			with: 0.264726 , -0.195238 , 0.29876;

		addTriangleWith: 0.040532 , -0.392779 , 0.202507

			with: 0.264726 , -0.195238 , 0.29876

			with: 0.140801 , -0.332561 , 0.357306;

		addTriangleWith: 0.365878 , -0.251603 , -0.0167079

			with: 0.317638 , -0.0857151 , 0.0715934

			with: 0.341317 , -0.110367 , 0.262576;

		addTriangleWith: 0.365878 , -0.251603 , -0.0167079

			with: 0.341317 , -0.110367 , 0.262576

			with: 0.389557 , -0.276255 , 0.174275;

		addTriangleWith: 0.41175 , 0.154132 , 0.0676203

			with: 0.25801 , 0.119333 , 0.18074

			with: 0.311503 , -0.00784314 , 0.31715;

		addTriangleWith: 0.41175 , 0.154132 , 0.0676203

			with: 0.311503 , -0.00784314 , 0.31715

			with: 0.465242 , 0.0269559 , 0.20403;

		addTriangleWith: 0.114753 , 0.263714 , 0.338953

			with: 0.0679773 , 0.0763192 , 0.320563

			with: 0.216486 , -0.0293501 , 0.387061;

		addTriangleWith: 0.114753 , 0.263714 , 0.338953

			with: 0.216486 , -0.0293501 , 0.387061

			with: 0.263262 , 0.158044 , 0.405451;

		addTriangleWith: -0.224322 , -0.0805672 , 0.374195

			with: -0.161448 , -0.261691 , 0.403928

			with: -0.114672 , -0.0742961 , 0.422317;

		addTriangleWith: -0.40174 , -0.0907141 , 0.296331

			with: -0.224322 , -0.0805672 , 0.374195

			with: -0.114672 , -0.0742961 , 0.422317;

		addTriangleWith: -0.40174 , -0.0907141 , 0.296331

			with: -0.114672 , -0.0742961 , 0.422317

			with: 0.0627464 , -0.0641492 , 0.500181;

		addTriangleWith: -0.40174 , -0.0907141 , 0.296331

			with: 0.0627464 , -0.0641492 , 0.500181

			with: -0.0857625 , 0.0415201 , 0.433682;

		addTriangleWith: -0.0857625 , 0.0415201 , 0.433682

			with: -0.0389863 , 0.228915 , 0.452072

			with: -0.177546 , 0.106827 , 0.392584;

		addTriangleWith: -0.177546 , 0.106827 , 0.392584

			with: -0.326055 , 0.212497 , 0.326086

			with: -0.263181 , 0.0313732 , 0.355819;

		addTriangleWith: -0.0857625 , 0.0415201 , 0.433682

			with: -0.177546 , 0.106827 , 0.392584

			with: -0.263181 , 0.0313732 , 0.355819;

		addTriangleWith: -0.40174 , -0.0907141 , 0.296331

			with: -0.0857625 , 0.0415201 , 0.433682

			with: -0.263181 , 0.0313732 , 0.355819;

		addTriangleWith: -0.38656 , -0.178002 , 0.123724

			with: -0.209142 , -0.167855 , 0.201588

			with: -0.224322 , -0.0805672 , 0.374195;

		addTriangleWith: -0.38656 , -0.178002 , 0.123724

			with: -0.224322 , -0.0805672 , 0.374195

			with: -0.40174 , -0.0907141 , 0.296331;

		addTriangleWith: -0.0366175 , -0.342708 , 0.279443

			with: 0.0101587 , -0.155313 , 0.297832

			with: -0.114672 , -0.0742961 , 0.422317;

		addTriangleWith: -0.0366175 , -0.342708 , 0.279443

			with: -0.114672 , -0.0742961 , 0.422317

			with: -0.161448 , -0.261691 , 0.403928;

		addTriangleWith: 0.216486 , -0.0293501 , 0.387061

			with: 0.0679773 , 0.0763192 , 0.320563

			with: -0.0857625 , 0.0415201 , 0.433682;

		addTriangleWith: 0.216486 , -0.0293501 , 0.387061

			with: -0.0857625 , 0.0415201 , 0.433682

			with: 0.0627464 , -0.0641492 , 0.500181;

		addTriangleWith: 0.0229699 , 0.329021 , 0.297855

			with: -0.11559 , 0.206934 , 0.238367

			with: -0.177546 , 0.106827 , 0.392584;

		addTriangleWith: 0.0229699 , 0.329021 , 0.297855

			with: -0.177546 , 0.106827 , 0.392584

			with: -0.0389863 , 0.228915 , 0.452072;

		addTriangleWith: -0.349733 , 0.237149 , 0.135103

			with: -0.286859 , 0.0560254 , 0.164836

			with: -0.263181 , 0.0313732 , 0.355819;

		addTriangleWith: -0.349733 , 0.237149 , 0.135103

			with: -0.263181 , 0.0313732 , 0.355819

			with: -0.326055 , 0.212497 , 0.326086;

		addTriangleWith: 0.0229485 , 0.430778 , -0.106474

			with: 0.123217 , 0.490996 , 0.0483252

			with: 0.138397 , 0.403708 , -0.124282;

		addTriangleWith: 0.138397 , 0.403708 , -0.124282

			with: 0.325197 , 0.359908 , -0.153095

			with: 0.147779 , 0.349761 , -0.230959;

		addTriangleWith: 0.0229485 , 0.430778 , -0.106474

			with: 0.138397 , 0.403708 , -0.124282

			with: 0.147779 , 0.349761 , -0.230959;

		addTriangleWith: -0.163851 , 0.474578 , -0.0776606

			with: 0.0229485 , 0.430778 , -0.106474

			with: 0.147779 , 0.349761 , -0.230959;

		addTriangleWith: 0.147779 , 0.349761 , -0.230959

			with: 0.162959 , 0.262473 , -0.403566

			with: 0.0381286 , 0.34349 , -0.279081;

		addTriangleWith: -0.163851 , 0.474578 , -0.0776606

			with: 0.147779 , 0.349761 , -0.230959

			with: 0.0381286 , 0.34349 , -0.279081;

		addTriangleWith: 0.0381286 , 0.34349 , -0.279081

			with: -0.13929 , 0.333343 , -0.356945

			with: -0.039021 , 0.393561 , -0.202145;

		addTriangleWith: -0.163851 , 0.474578 , -0.0776606

			with: 0.0381286 , 0.34349 , -0.279081

			with: -0.039021 , 0.393561 , -0.202145;

		addTriangleWith: -0.225808 , 0.374472 , 0.0765569

			with: -0.0390077 , 0.330672 , 0.0477434

			with: 0.0229485 , 0.430778 , -0.106474;

		addTriangleWith: -0.225808 , 0.374472 , 0.0765569

			with: 0.0229485 , 0.430778 , -0.106474

			with: -0.163851 , 0.474578 , -0.0776606;

		addTriangleWith: 0.17671 , 0.36382 , 0.184735

			with: 0.19189 , 0.276532 , 0.0121279

			with: 0.138397 , 0.403708 , -0.124282;

		addTriangleWith: 0.17671 , 0.36382 , 0.184735

			with: 0.138397 , 0.403708 , -0.124282

			with: 0.123217 , 0.490996 , 0.0483252;

		addTriangleWith: 0.388072 , 0.178784 , -0.123363

			with: 0.210653 , 0.168638 , -0.201226

			with: 0.147779 , 0.349761 , -0.230959;

		addTriangleWith: 0.388072 , 0.178784 , -0.123363

			with: 0.147779 , 0.349761 , -0.230959

			with: 0.325197 , 0.359908 , -0.153095;

		addTriangleWith: 0.116183 , 0.0750782 , -0.421956

			with: -0.00864766 , 0.156095 , -0.297471

			with: 0.0381286 , 0.34349 , -0.279081;

		addTriangleWith: 0.116183 , 0.0750782 , -0.421956

			with: 0.0381286 , 0.34349 , -0.279081

			with: 0.162959 , 0.262473 , -0.403566;

		addTriangleWith: -0.263215 , 0.19602 , -0.298399

			with: -0.162947 , 0.256238 , -0.143599

			with: -0.039021 , 0.393561 , -0.202145;

		addTriangleWith: -0.263215 , 0.19602 , -0.298399

			with: -0.039021 , 0.393561 , -0.202145

			with: -0.13929 , 0.333343 , -0.356945;

		addTriangleWith: -0.225808 , 0.374472 , 0.0765569

			with: -0.163851 , 0.474578 , -0.0776606

			with: -0.287777 , 0.337255 , -0.0191144;

		addTriangleWith: -0.287777 , 0.337255 , -0.0191144

			with: -0.388046 , 0.277037 , -0.173914

			with: -0.364367 , 0.252385 , 0.0170692;

		addTriangleWith: -0.225808 , 0.374472 , 0.0765569

			with: -0.287777 , 0.337255 , -0.0191144

			with: -0.364367 , 0.252385 , 0.0170692;

		addTriangleWith: -0.125539 , 0.43469 , 0.231356

			with: -0.225808 , 0.374472 , 0.0765569

			with: -0.364367 , 0.252385 , 0.0170692;

		addTriangleWith: -0.364367 , 0.252385 , 0.0170692

			with: -0.488293 , 0.115062 , 0.0756155

			with: -0.349733 , 0.237149 , 0.135103;

		addTriangleWith: -0.364367 , 0.252385 , 0.0170692

			with: -0.349733 , 0.237149 , 0.135103

			with: -0.326055 , 0.212497 , 0.326086;

		addTriangleWith: -0.364367 , 0.252385 , 0.0170692

			with: -0.326055 , 0.212497 , 0.326086

			with: -0.264099 , 0.312603 , 0.171869;

		addTriangleWith: -0.125539 , 0.43469 , 0.231356

			with: -0.364367 , 0.252385 , 0.0170692

			with: -0.264099 , 0.312603 , 0.171869;

		addTriangleWith: 0.061261 , 0.39089 , 0.202543

			with: -0.0390077 , 0.330672 , 0.0477434

			with: -0.225808 , 0.374472 , 0.0765569;

		addTriangleWith: 0.061261 , 0.39089 , 0.202543

			with: -0.225808 , 0.374472 , 0.0765569

			with: -0.125539 , 0.43469 , 0.231356;

		addTriangleWith: -0.039021 , 0.393561 , -0.202145

			with: -0.162947 , 0.256238 , -0.143599

			with: -0.287777 , 0.337255 , -0.0191144;

		addTriangleWith: -0.039021 , 0.393561 , -0.202145

			with: -0.287777 , 0.337255 , -0.0191144

			with: -0.163851 , 0.474578 , -0.0776606;

		addTriangleWith: -0.339806 , 0.111149 , -0.262215

			with: -0.316127 , 0.0864972 , -0.071232

			with: -0.364367 , 0.252385 , 0.0170692;

		addTriangleWith: -0.339806 , 0.111149 , -0.262215

			with: -0.364367 , 0.252385 , 0.0170692

			with: -0.388046 , 0.277037 , -0.173914;

		addTriangleWith: -0.425419 , -0.0660619 , 0.105348

			with: -0.286859 , 0.0560254 , 0.164836

			with: -0.349733 , 0.237149 , 0.135103;

		addTriangleWith: -0.425419 , -0.0660619 , 0.105348

			with: -0.349733 , 0.237149 , 0.135103

			with: -0.488293 , 0.115062 , 0.0756155;

		addTriangleWith: -0.177546 , 0.106827 , 0.392584

			with: -0.11559 , 0.206934 , 0.238367

			with: -0.264099 , 0.312603 , 0.171869;

		addTriangleWith: -0.177546 , 0.106827 , 0.392584

			with: -0.264099 , 0.312603 , 0.171869

			with: -0.326055 , 0.212497 , 0.326086;

		addTriangleWith: 0.17671 , 0.36382 , 0.184735

			with: 0.123217 , 0.490996 , 0.0483252

			with: 0.061261 , 0.39089 , 0.202543;

		addTriangleWith: 0.36351 , 0.32002 , 0.155922

			with: 0.17671 , 0.36382 , 0.184735

			with: 0.061261 , 0.39089 , 0.202543;

		addTriangleWith: 0.36351 , 0.32002 , 0.155922

			with: 0.061261 , 0.39089 , 0.202543

			with: -0.125539 , 0.43469 , 0.231356;

		addTriangleWith: 0.36351 , 0.32002 , 0.155922

			with: -0.125539 , 0.43469 , 0.231356

			with: 0.0229699 , 0.329021 , 0.297855;

		addTriangleWith: 0.0229699 , 0.329021 , 0.297855

			with: -0.0389863 , 0.228915 , 0.452072

			with: 0.114753 , 0.263714 , 0.338953;

		addTriangleWith: 0.36351 , 0.32002 , 0.155922

			with: 0.0229699 , 0.329021 , 0.297855

			with: 0.114753 , 0.263714 , 0.338953;

		addTriangleWith: 0.114753 , 0.263714 , 0.338953

			with: 0.263262 , 0.158044 , 0.405451

			with: 0.20977 , 0.285221 , 0.269041;

		addTriangleWith: 0.36351 , 0.32002 , 0.155922

			with: 0.114753 , 0.263714 , 0.338953

			with: 0.20977 , 0.285221 , 0.269041;

		addTriangleWith: 0.37869 , 0.232732 , -0.0166856

			with: 0.19189 , 0.276532 , 0.0121279

			with: 0.17671 , 0.36382 , 0.184735;

		addTriangleWith: 0.37869 , 0.232732 , -0.0166856

			with: 0.17671 , 0.36382 , 0.184735

			with: 0.36351 , 0.32002 , 0.155922;

		addTriangleWith: 0.0229485 , 0.430778 , -0.106474

			with: -0.0390077 , 0.330672 , 0.0477434

			with: 0.061261 , 0.39089 , 0.202543;

		addTriangleWith: 0.0229485 , 0.430778 , -0.106474

			with: 0.061261 , 0.39089 , 0.202543

			with: 0.123217 , 0.490996 , 0.0483252;

		addTriangleWith: -0.264099 , 0.312603 , 0.171869

			with: -0.11559 , 0.206934 , 0.238367

			with: 0.0229699 , 0.329021 , 0.297855;

		addTriangleWith: -0.264099 , 0.312603 , 0.171869

			with: 0.0229699 , 0.329021 , 0.297855

			with: -0.125539 , 0.43469 , 0.231356;

		addTriangleWith: -0.0857625 , 0.0415201 , 0.433682

			with: 0.0679773 , 0.0763192 , 0.320563

			with: 0.114753 , 0.263714 , 0.338953;

		addTriangleWith: -0.0857625 , 0.0415201 , 0.433682

			with: 0.114753 , 0.263714 , 0.338953

			with: -0.0389863 , 0.228915 , 0.452072;

		addTriangleWith: 0.311503 , -0.00784314 , 0.31715

			with: 0.25801 , 0.119333 , 0.18074

			with: 0.20977 , 0.285221 , 0.269041;

		addTriangleWith: 0.311503 , -0.00784314 , 0.31715

			with: 0.20977 , 0.285221 , 0.269041

			with: 0.263262 , 0.158044 , 0.405451;

		addTriangleWith: 0.388072 , 0.178784 , -0.123363

			with: 0.325197 , 0.359908 , -0.153095

			with: 0.37869 , 0.232732 , -0.0166856;

		addTriangleWith: 0.403252 , 0.0914962 , -0.29597

			with: 0.388072 , 0.178784 , -0.123363

			with: 0.37869 , 0.232732 , -0.0166856;

		addTriangleWith: 0.403252 , 0.0914962 , -0.29597

			with: 0.37869 , 0.232732 , -0.0166856

			with: 0.36351 , 0.32002 , 0.155922;

		addTriangleWith: 0.403252 , 0.0914962 , -0.29597

			with: 0.36351 , 0.32002 , 0.155922

			with: 0.41175 , 0.154132 , 0.0676203;

		addTriangleWith: 0.41175 , 0.154132 , 0.0676203

			with: 0.465242 , 0.0269559 , 0.20403

			with: 0.441564 , 0.0516081 , 0.0130471;

		addTriangleWith: 0.41175 , 0.154132 , 0.0676203

			with: 0.441564 , 0.0516081 , 0.0130471

			with: 0.489804 , -0.114279 , -0.0752541;

		addTriangleWith: 0.41175 , 0.154132 , 0.0676203

			with: 0.489804 , -0.114279 , -0.0752541

			with: 0.42693 , 0.066844 , -0.104987;

		addTriangleWith: 0.403252 , 0.0914962 , -0.29597

			with: 0.41175 , 0.154132 , 0.0676203

			with: 0.42693 , 0.066844 , -0.104987;

		addTriangleWith: 0.225833 , 0.0813493 , -0.373833

			with: 0.210653 , 0.168638 , -0.201226

			with: 0.388072 , 0.178784 , -0.123363;

		addTriangleWith: 0.225833 , 0.0813493 , -0.373833

			with: 0.388072 , 0.178784 , -0.123363

			with: 0.403252 , 0.0914962 , -0.29597;

		addTriangleWith: 0.138397 , 0.403708 , -0.124282

			with: 0.19189 , 0.276532 , 0.0121279

			with: 0.37869 , 0.232732 , -0.0166856;

		addTriangleWith: 0.138397 , 0.403708 , -0.124282

			with: 0.37869 , 0.232732 , -0.0166856

			with: 0.325197 , 0.359908 , -0.153095;

		addTriangleWith: 0.20977 , 0.285221 , 0.269041

			with: 0.25801 , 0.119333 , 0.18074

			with: 0.41175 , 0.154132 , 0.0676203;

		addTriangleWith: 0.20977 , 0.285221 , 0.269041

			with: 0.41175 , 0.154132 , 0.0676203

			with: 0.36351 , 0.32002 , 0.155922;

		addTriangleWith: 0.341317 , -0.110367 , 0.262576

			with: 0.317638 , -0.0857151 , 0.0715934

			with: 0.441564 , 0.0516081 , 0.0130471;

		addTriangleWith: 0.341317 , -0.110367 , 0.262576

			with: 0.441564 , 0.0516081 , 0.0130471

			with: 0.465242 , 0.0269559 , 0.20403;

		addTriangleWith: 0.351244 , -0.236367 , -0.134742

			with: 0.28837 , -0.0552433 , -0.164475

			with: 0.42693 , 0.066844 , -0.104987;

		addTriangleWith: 0.351244 , -0.236367 , -0.134742

			with: 0.42693 , 0.066844 , -0.104987

			with: 0.489804 , -0.114279 , -0.0752541;

		addTriangleWith: 0.116183 , 0.0750782 , -0.421956

			with: 0.162959 , 0.262473 , -0.403566

			with: 0.225833 , 0.0813493 , -0.373833;

		addTriangleWith: 0.116183 , 0.0750782 , -0.421956

			with: 0.225833 , 0.0813493 , -0.373833

			with: 0.403252 , 0.0914962 , -0.29597;

		addTriangleWith: -0.0612353 , 0.0649313 , -0.499819

			with: 0.116183 , 0.0750782 , -0.421956

			with: 0.403252 , 0.0914962 , -0.29597;

		addTriangleWith: -0.0612353 , 0.0649313 , -0.499819

			with: 0.403252 , 0.0914962 , -0.29597

			with: 0.264692 , -0.0305911 , -0.355458;

		addTriangleWith: 0.264692 , -0.0305911 , -0.355458

			with: 0.327566 , -0.211715 , -0.325725

			with: 0.179057 , -0.106045 , -0.392223;

		addTriangleWith: 0.264692 , -0.0305911 , -0.355458

			with: 0.179057 , -0.106045 , -0.392223

			with: 0.0404974 , -0.228133 , -0.451711;

		addTriangleWith: 0.264692 , -0.0305911 , -0.355458

			with: 0.0404974 , -0.228133 , -0.451711

			with: 0.0872736 , -0.040738 , -0.433321;

		addTriangleWith: -0.0612353 , 0.0649313 , -0.499819

			with: 0.264692 , -0.0305911 , -0.355458

			with: 0.0872736 , -0.040738 , -0.433321;

		addTriangleWith: -0.186066 , 0.145948 , -0.375334

			with: -0.00864766 , 0.156095 , -0.297471

			with: 0.116183 , 0.0750782 , -0.421956;

		addTriangleWith: -0.186066 , 0.145948 , -0.375334

			with: 0.116183 , 0.0750782 , -0.421956

			with: -0.0612353 , 0.0649313 , -0.499819;

		addTriangleWith: 0.147779 , 0.349761 , -0.230959

			with: 0.210653 , 0.168638 , -0.201226

			with: 0.225833 , 0.0813493 , -0.373833;

		addTriangleWith: 0.147779 , 0.349761 , -0.230959

			with: 0.225833 , 0.0813493 , -0.373833

			with: 0.162959 , 0.262473 , -0.403566;

		addTriangleWith: 0.42693 , 0.066844 , -0.104987

			with: 0.28837 , -0.0552433 , -0.164475

			with: 0.264692 , -0.0305911 , -0.355458;

		addTriangleWith: 0.42693 , 0.066844 , -0.104987

			with: 0.264692 , -0.0305911 , -0.355458

			with: 0.403252 , 0.0914962 , -0.29597;

		addTriangleWith: 0.26561 , -0.311821 , -0.171507

			with: 0.117101 , -0.206152 , -0.238005

			with: 0.179057 , -0.106045 , -0.392223;

		addTriangleWith: 0.26561 , -0.311821 , -0.171507

			with: 0.179057 , -0.106045 , -0.392223

			with: 0.327566 , -0.211715 , -0.325725;

		addTriangleWith: -0.113242 , -0.262932 , -0.338591

			with: -0.0664662 , -0.0755371 , -0.320202

			with: 0.0872736 , -0.040738 , -0.433321;

		addTriangleWith: -0.113242 , -0.262932 , -0.338591

			with: 0.0872736 , -0.040738 , -0.433321

			with: 0.0404974 , -0.228133 , -0.451711;

		addTriangleWith: -0.263215 , 0.19602 , -0.298399

			with: -0.13929 , 0.333343 , -0.356945

			with: -0.186066 , 0.145948 , -0.375334;

		addTriangleWith: -0.263215 , 0.19602 , -0.298399

			with: -0.186066 , 0.145948 , -0.375334

			with: -0.0612353 , 0.0649313 , -0.499819;

		addTriangleWith: -0.263215 , 0.19602 , -0.298399

			with: -0.0612353 , 0.0649313 , -0.499819

			with: -0.214975 , 0.0301322 , -0.3867;

		addTriangleWith: -0.388046 , 0.277037 , -0.173914

			with: -0.263215 , 0.19602 , -0.298399

			with: -0.214975 , 0.0301322 , -0.3867;

		addTriangleWith: -0.214975 , 0.0301322 , -0.3867

			with: -0.261751 , -0.157262 , -0.405089

			with: -0.309992 , 0.0086252 , -0.316788;

		addTriangleWith: -0.214975 , 0.0301322 , -0.3867

			with: -0.309992 , 0.0086252 , -0.316788

			with: -0.463731 , -0.0261739 , -0.203669;

		addTriangleWith: -0.214975 , 0.0301322 , -0.3867

			with: -0.463731 , -0.0261739 , -0.203669

			with: -0.339806 , 0.111149 , -0.262215;

		addTriangleWith: -0.388046 , 0.277037 , -0.173914

			with: -0.214975 , 0.0301322 , -0.3867

			with: -0.339806 , 0.111149 , -0.262215;

		addTriangleWith: -0.287777 , 0.337255 , -0.0191144

			with: -0.162947 , 0.256238 , -0.143599

			with: -0.263215 , 0.19602 , -0.298399;

		addTriangleWith: -0.287777 , 0.337255 , -0.0191144

			with: -0.263215 , 0.19602 , -0.298399

			with: -0.388046 , 0.277037 , -0.173914;

		addTriangleWith: 0.0381286 , 0.34349 , -0.279081

			with: -0.00864766 , 0.156095 , -0.297471

			with: -0.186066 , 0.145948 , -0.375334;

		addTriangleWith: 0.0381286 , 0.34349 , -0.279081

			with: -0.186066 , 0.145948 , -0.375334

			with: -0.13929 , 0.333343 , -0.356945;

		addTriangleWith: 0.0872736 , -0.040738 , -0.433321

			with: -0.0664662 , -0.0755371 , -0.320202

			with: -0.214975 , 0.0301322 , -0.3867;

		addTriangleWith: 0.0872736 , -0.040738 , -0.433321

			with: -0.214975 , 0.0301322 , -0.3867

			with: -0.0612353 , 0.0649313 , -0.499819;

		addTriangleWith: -0.208259 , -0.284439 , -0.26868

			with: -0.256499 , -0.118551 , -0.180378

			with: -0.309992 , 0.0086252 , -0.316788;

		addTriangleWith: -0.208259 , -0.284439 , -0.26868

			with: -0.309992 , 0.0086252 , -0.316788

			with: -0.261751 , -0.157262 , -0.405089;

		addTriangleWith: -0.440053 , -0.050826 , -0.0126857

			with: -0.316127 , 0.0864972 , -0.071232

			with: -0.339806 , 0.111149 , -0.262215;

		addTriangleWith: -0.440053 , -0.050826 , -0.0126857

			with: -0.339806 , 0.111149 , -0.262215

			with: -0.463731 , -0.0261739 , -0.203669
			"! !

!Polyhedron class methodsFor: 'factory-dodecahedron' stamp: 'emm 02/09/2012 23:40'!
dodecahedron
	"self dodecahedron "

	^(FaceComposite on: ((Triangle3DComposite new)
				add: (Triangle3D 
							with: -0.370471 , -0.294886 , -0.18058
							with: -0.5 , -0.0573404 , 0.0593935
							with: -0.421407 , 0.275235 , -0.0589707);
				add: (Triangle3D 
							with: -0.370471 , -0.294886 , -0.18058
							with: -0.421407 , 0.275235 , -0.0589707
							with: -0.243305 , 0.243232 , -0.372098);
				add: (Triangle3D 
							with: -0.370471 , -0.294886 , -0.18058
							with: -0.243305 , 0.243232 , -0.372098
							with: -0.211825 , -0.109122 , -0.447256);
				add: (Triangle3D 
							with: 0.116573 , 0.492922 , 0.0159267
							with: 0.0891855 , 0.37777 , -0.325808
							with: -0.243305 , 0.243232 , -0.372098);
				add: (Triangle3D 
							with: 0.116573 , 0.492922 , 0.0159267
							with: -0.243305 , 0.243232 , -0.372098
							with: -0.421407 , 0.275235 , -0.0589707);
				add: (Triangle3D 
							with: 0.116573 , 0.492922 , 0.0159267
							with: -0.421407 , 0.275235 , -0.0589707
							with: -0.19899 , 0.429552 , 0.180842);
				add: (Triangle3D 
							with: 0.326156 , 0.108566 , -0.372359
							with: 0.140122 , -0.19235 , -0.447418
							with: -0.211825 , -0.109122 , -0.447256);
				add: (Triangle3D 
							with: 0.326156 , 0.108566 , -0.372359
							with: -0.211825 , -0.109122 , -0.447256
							with: -0.243305 , 0.243232 , -0.372098);
				add: (Triangle3D 
							with: 0.326156 , 0.108566 , -0.372359
							with: -0.243305 , 0.243232 , -0.372098
							with: 0.0891855 , 0.37777 , -0.325808);
				add: (Triangle3D 
							with: 0.19899 , -0.429552 , -0.180842
							with: -0.116573 , -0.492922 , -0.0159267
							with: -0.370471 , -0.294886 , -0.18058);
				add: (Triangle3D 
							with: 0.19899 , -0.429552 , -0.180842
							with: -0.370471 , -0.294886 , -0.18058
							with: -0.211825 , -0.109122 , -0.447256);
				add: (Triangle3D 
							with: 0.19899 , -0.429552 , -0.180842
							with: -0.211825 , -0.109122 , -0.447256
							with: 0.140122 , -0.19235 , -0.447418);
				add: (Triangle3D 
							with: -0.0891856 , -0.37777 , 0.325808
							with: -0.326156 , -0.108566 , 0.372359
							with: -0.5 , -0.0573404 , 0.0593935);
				add: (Triangle3D 
							with: -0.0891856 , -0.37777 , 0.325808
							with: -0.5 , -0.0573404 , 0.0593935
							with: -0.370471 , -0.294886 , -0.18058);
				add: (Triangle3D 
							with: -0.0891856 , -0.37777 , 0.325808
							with: -0.370471 , -0.294886 , -0.18058
							with: -0.116573 , -0.492922 , -0.0159267);
				add: (Triangle3D 
							with: -0.140122 , 0.19235 , 0.447418
							with: -0.19899 , 0.429552 , 0.180842
							with: -0.421407 , 0.275235 , -0.0589707);
				add: (Triangle3D 
							with: -0.140122 , 0.19235 , 0.447418
							with: -0.421407 , 0.275235 , -0.0589707
							with: -0.5 , -0.0573404 , 0.0593935);
				add: (Triangle3D 
							with: -0.140122 , 0.19235 , 0.447418
							with: -0.5 , -0.0573404 , 0.0593935
							with: -0.326156 , -0.108566 , 0.372359);
				add: (Triangle3D 
							with: -0.326156 , -0.108566 , 0.372359
							with: -0.0891856 , -0.37777 , 0.325808
							with: 0.243305 , -0.243232 , 0.372098);
				add: (Triangle3D 
							with: -0.326156 , -0.108566 , 0.372359
							with: 0.243305 , -0.243232 , 0.372098
							with: 0.211824 , 0.109122 , 0.447256);
				add: (Triangle3D 
							with: -0.326156 , -0.108566 , 0.372359
							with: 0.211824 , 0.109122 , 0.447256
							with: -0.140122 , 0.19235 , 0.447418);
				add: (Triangle3D 
							with: -0.116573 , -0.492922 , -0.0159267
							with: 0.19899 , -0.429552 , -0.180842
							with: 0.421407 , -0.275235 , 0.0589707);
				add: (Triangle3D 
							with: -0.116573 , -0.492922 , -0.0159267
							with: 0.421407 , -0.275235 , 0.0589707
							with: 0.243305 , -0.243232 , 0.372098);
				add: (Triangle3D 
							with: -0.116573 , -0.492922 , -0.0159267
							with: 0.243305 , -0.243232 , 0.372098
							with: -0.0891856 , -0.37777 , 0.325808);
				add: (Triangle3D 
							with: 0.140122 , -0.19235 , -0.447418
							with: 0.326156 , 0.108566 , -0.372359
							with: 0.5 , 0.0573403 , -0.0593935);
				add: (Triangle3D 
							with: 0.140122 , -0.19235 , -0.447418
							with: 0.5 , 0.0573403 , -0.0593935
							with: 0.421407 , -0.275235 , 0.0589707);
				add: (Triangle3D 
							with: 0.140122 , -0.19235 , -0.447418
							with: 0.421407 , -0.275235 , 0.0589707
							with: 0.19899 , -0.429552 , -0.180842);
				add: (Triangle3D 
							with: 0.0891855 , 0.37777 , -0.325808
							with: 0.116573 , 0.492922 , 0.0159267
							with: 0.370471 , 0.294886 , 0.18058);
				add: (Triangle3D 
							with: 0.0891855 , 0.37777 , -0.325808
							with: 0.370471 , 0.294886 , 0.18058
							with: 0.5 , 0.0573403 , -0.0593935);
				add: (Triangle3D 
							with: 0.0891855 , 0.37777 , -0.325808
							with: 0.5 , 0.0573403 , -0.0593935
							with: 0.326156 , 0.108566 , -0.372359);
				add: (Triangle3D 
							with: -0.19899 , 0.429552 , 0.180842
							with: -0.140122 , 0.19235 , 0.447418
							with: 0.211824 , 0.109122 , 0.447256);
				add: (Triangle3D 
							with: -0.19899 , 0.429552 , 0.180842
							with: 0.211824 , 0.109122 , 0.447256
							with: 0.370471 , 0.294886 , 0.18058);
				add: (Triangle3D 
							with: -0.19899 , 0.429552 , 0.180842
							with: 0.370471 , 0.294886 , 0.18058
							with: 0.116573 , 0.492922 , 0.0159267);
				add: (Triangle3D 
							with: 0.370471 , 0.294886 , 0.18058
							with: 0.211824 , 0.109122 , 0.447256
							with: 0.243305 , -0.243232 , 0.372098);
				add: (Triangle3D 
							with: 0.370471 , 0.294886 , 0.18058
							with: 0.243305 , -0.243232 , 0.372098
							with: 0.421407 , -0.275235 , 0.0589707);
				add: (Triangle3D 
							with: 0.370471 , 0.294886 , 0.18058
							with: 0.421407 , -0.275235 , 0.0589707
							with: 0.5 , 0.0573403 , -0.0593935);
				yourself)) 
		reverseOriented! !

!Polyhedron class methodsFor: 'factory-hexagonal' stamp: 'emm 9/22/2012 19:47'!
echidnahedron

	"self echidnahedron"


"
	^(Triangle3DComposite new)

		addTriangleWith: 0.127275 , -0.0483538 , 0.484401

			with: 0.125681 , 0.00550585 , 0.221777

			with: -0.0182816 , 0.0195928 , 0.140969;

		addTriangleWith: 0.127275 , -0.0483538 , 0.484401

			with: -0.0182816 , 0.0195928 , 0.140969

			with: 0.0198754 , -0.0734524 , 0.121655;

		addTriangleWith: 0.127275 , -0.0483538 , 0.484401

			with: 0.0198754 , -0.0734524 , 0.121655

			with: 0.125681 , 0.00550585 , 0.221777;

		addTriangleWith: 0.253796 , -0.129533 , 0.414717

			with: 0.125681 , 0.00550585 , 0.221777

			with: 0.0198754 , -0.0734524 , 0.121655;

		addTriangleWith: 0.253796 , -0.129533 , 0.414717

			with: 0.0198754 , -0.0734524 , 0.121655

			with: 0.10824 , -0.061586 , 0.0712843;

		addTriangleWith: 0.253796 , -0.129533 , 0.414717

			with: 0.10824 , -0.061586 , 0.0712843

			with: 0.125681 , 0.00550585 , 0.221777;

		addTriangleWith: 0.358617 , -0.0172873 , 0.352529

			with: 0.125681 , 0.00550585 , 0.221777

			with: 0.10824 , -0.061586 , 0.0712843;

		addTriangleWith: 0.358617 , -0.0172873 , 0.352529

			with: 0.10824 , -0.061586 , 0.0712843

			with: 0.124696 , 0.0387929 , 0.0594671;

		addTriangleWith: 0.358617 , -0.0172873 , 0.352529

			with: 0.124696 , 0.0387929 , 0.0594671

			with: 0.125681 , 0.00550585 , 0.221777;

		addTriangleWith: 0.296877 , 0.133263 , 0.383779

			with: 0.125681 , 0.00550585 , 0.221777

			with: 0.124696 , 0.0387929 , 0.0594671;

		addTriangleWith: 0.296877 , 0.133263 , 0.383779

			with: 0.124696 , 0.0387929 , 0.0594671

			with: 0.0465009 , 0.0889641 , 0.102534;

		addTriangleWith: 0.296877 , 0.133263 , 0.383779

			with: 0.0465009 , 0.0889641 , 0.102534

			with: 0.125681 , 0.00550585 , 0.221777;

		addTriangleWith: 0.1539 , 0.114063 , 0.46528

			with: 0.125681 , 0.00550585 , 0.221777

			with: 0.0465009 , 0.0889641 , 0.102534;

		addTriangleWith: 0.1539 , 0.114063 , 0.46528

			with: 0.0465009 , 0.0889641 , 0.102534

			with: -0.0182816 , 0.0195928 , 0.140969;

		addTriangleWith: 0.1539 , 0.114063 , 0.46528

			with: -0.0182816 , 0.0195928 , 0.140969

			with: 0.125681 , 0.00550585 , 0.221777;

		addTriangleWith: -0.121508 , -0.146512 , 0.46578

			with: -0.123102 , -0.0926525 , 0.203157

			with: 0.0198754 , -0.0734524 , 0.121655;

		addTriangleWith: -0.121508 , -0.146512 , 0.46578

			with: 0.0198754 , -0.0734524 , 0.121655

			with: -0.0182816 , 0.0195928 , 0.140969;

		addTriangleWith: -0.121508 , -0.146512 , 0.46578

			with: -0.0182816 , 0.0195928 , 0.140969

			with: -0.123102 , -0.0926525 , 0.203157;

		addTriangleWith: -0.248639 , -0.0447608 , 0.435151

			with: -0.123102 , -0.0926525 , 0.203157

			with: -0.0182816 , 0.0195928 , 0.140969;

		addTriangleWith: -0.248639 , -0.0447608 , 0.435151

			with: -0.0182816 , 0.0195928 , 0.140969

			with: -0.107255 , 0.028299 , 0.091026;

		addTriangleWith: -0.248639 , -0.0447608 , 0.435151

			with: -0.107255 , 0.028299 , 0.091026

			with: -0.123102 , -0.0926525 , 0.203157;

		addTriangleWith: -0.354444 , -0.123719 , 0.335029

			with: -0.123102 , -0.0926525 , 0.203157

			with: -0.107255 , 0.028299 , 0.091026;

		addTriangleWith: -0.354444 , -0.123719 , 0.335029

			with: -0.107255 , 0.028299 , 0.091026

			with: -0.124087 , -0.0593654 , 0.0408463;

		addTriangleWith: -0.354444 , -0.123719 , 0.335029

			with: -0.124087 , -0.0593654 , 0.0408463

			with: -0.123102 , -0.0926525 , 0.203157;

		addTriangleWith: -0.292705 , -0.274269 , 0.303779

			with: -0.123102 , -0.0926525 , 0.203157

			with: -0.124087 , -0.0593654 , 0.0408463;

		addTriangleWith: -0.292705 , -0.274269 , 0.303779

			with: -0.124087 , -0.0593654 , 0.0408463

			with: -0.0455159 , -0.122251 , 0.059776;

		addTriangleWith: -0.292705 , -0.274269 , 0.303779

			with: -0.0455159 , -0.122251 , 0.059776

			with: -0.123102 , -0.0926525 , 0.203157;

		addTriangleWith: -0.148742 , -0.288356 , 0.384588

			with: -0.123102 , -0.0926525 , 0.203157

			with: -0.0455159 , -0.122251 , 0.059776;

		addTriangleWith: -0.148742 , -0.288356 , 0.384588

			with: -0.0455159 , -0.122251 , 0.059776

			with: 0.0198754 , -0.0734524 , 0.121655;

		addTriangleWith: -0.148742 , -0.288356 , 0.384588

			with: 0.0198754 , -0.0734524 , 0.121655

			with: -0.123102 , -0.0926525 , 0.203157;

		addTriangleWith: 0.20973 , -0.359041 , 0.283345

			with: 0.0816146 , -0.224002 , 0.0904051

			with: 0.10824 , -0.061586 , 0.0712843;

		addTriangleWith: 0.20973 , -0.359041 , 0.283345

			with: 0.10824 , -0.061586 , 0.0712843

			with: 0.0198754 , -0.0734524 , 0.121655;

		addTriangleWith: 0.20973 , -0.359041 , 0.283345

			with: 0.0198754 , -0.0734524 , 0.121655

			with: 0.0816146 , -0.224002 , 0.0904051;

		addTriangleWith: 0.0559741 , -0.419706 , 0.271836

			with: 0.0816146 , -0.224002 , 0.0904051

			with: 0.0198754 , -0.0734524 , 0.121655;

		addTriangleWith: 0.0559741 , -0.419706 , 0.271836

			with: 0.0198754 , -0.0734524 , 0.121655

			with: -0.0455159 , -0.122251 , 0.059776;

		addTriangleWith: 0.0559741 , -0.419706 , 0.271836

			with: -0.0455159 , -0.122251 , 0.059776

			with: 0.0816146 , -0.224002 , 0.0904051;

		addTriangleWith: 0.0385335 , -0.486798 , 0.121343

			with: 0.0816146 , -0.224002 , 0.0904051

			with: -0.0455159 , -0.122251 , 0.059776;

		addTriangleWith: 0.0385335 , -0.486798 , 0.121343

			with: -0.0455159 , -0.122251 , 0.059776

			with: 0.00243484 , -0.140544 , -0.028838;

		addTriangleWith: 0.0385335 , -0.486798 , 0.121343

			with: 0.00243484 , -0.140544 , -0.028838

			with: 0.0816146 , -0.224002 , 0.0904051;

		addTriangleWith: 0.181511 , -0.467598 , 0.0398417

			with: 0.0816146 , -0.224002 , 0.0904051

			with: 0.00243484 , -0.140544 , -0.028838;

		addTriangleWith: 0.181511 , -0.467598 , 0.0398417

			with: 0.00243484 , -0.140544 , -0.028838

			with: 0.0974613 , -0.103051 , -0.0217255;

		addTriangleWith: 0.181511 , -0.467598 , 0.0398417

			with: 0.0974613 , -0.103051 , -0.0217255

			with: 0.0816146 , -0.224002 , 0.0904051;

		addTriangleWith: 0.287316 , -0.38864 , 0.139964

			with: 0.0816146 , -0.224002 , 0.0904051

			with: 0.0974613 , -0.103051 , -0.0217255;

		addTriangleWith: 0.287316 , -0.38864 , 0.139964

			with: 0.0974613 , -0.103051 , -0.0217255

			with: 0.10824 , -0.061586 , 0.0712843;

		addTriangleWith: 0.287316 , -0.38864 , 0.139964

			with: 0.10824 , -0.061586 , 0.0712843

			with: 0.0816146 , -0.224002 , 0.0904051;

		addTriangleWith: 0.484153 , -0.065179 , 0.120534

			with: 0.251217 , -0.0423859 , -0.0102173

			with: 0.124696 , 0.0387929 , 0.0594671;

		addTriangleWith: 0.484153 , -0.065179 , 0.120534

			with: 0.124696 , 0.0387929 , 0.0594671

			with: 0.10824 , -0.061586 , 0.0712843;

		addTriangleWith: 0.484153 , -0.065179 , 0.120534

			with: 0.10824 , -0.061586 , 0.0712843

			with: 0.251217 , -0.0423859 , -0.0102173;

		addTriangleWith: 0.456919 , -0.207023 , 0.0393417

			with: 0.251217 , -0.0423859 , -0.0102173

			with: 0.10824 , -0.061586 , 0.0712843;

		addTriangleWith: 0.456919 , -0.207023 , 0.0393417

			with: 0.10824 , -0.061586 , 0.0712843

			with: 0.0974613 , -0.103051 , -0.0217255;

		addTriangleWith: 0.456919 , -0.207023 , 0.0393417

			with: 0.0974613 , -0.103051 , -0.0217255

			with: 0.251217 , -0.0423859 , -0.0102173;

		addTriangleWith: 0.455934 , -0.173736 , -0.122969

			with: 0.251217 , -0.0423859 , -0.0102173

			with: 0.0974613 , -0.103051 , -0.0217255;

		addTriangleWith: 0.455934 , -0.173736 , -0.122969

			with: 0.0974613 , -0.103051 , -0.0217255

			with: 0.107255 , -0.028299 , -0.091026;

		addTriangleWith: 0.455934 , -0.173736 , -0.122969

			with: 0.107255 , -0.028299 , -0.091026

			with: 0.251217 , -0.0423859 , -0.0102173;

		addTriangleWith: 0.482559 , -0.0113194 , -0.142089

			with: 0.251217 , -0.0423859 , -0.0102173

			with: 0.107255 , -0.028299 , -0.091026;

		addTriangleWith: 0.482559 , -0.0113194 , -0.142089

			with: 0.107255 , -0.028299 , -0.091026

			with: 0.124087 , 0.0593654 , -0.0408463;

		addTriangleWith: 0.482559 , -0.0113194 , -0.142089

			with: 0.124087 , 0.0593654 , -0.0408463

			with: 0.251217 , -0.0423859 , -0.0102173;

		addTriangleWith: 0.5 , 0.0557724 , 0.00840358

			with: 0.251217 , -0.0423859 , -0.0102173

			with: 0.124087 , 0.0593654 , -0.0408463;

		addTriangleWith: 0.5 , 0.0557724 , 0.00840358

			with: 0.124087 , 0.0593654 , -0.0408463

			with: 0.124696 , 0.0387929 , 0.0594671;

		addTriangleWith: 0.5 , 0.0557724 , 0.00840358

			with: 0.124696 , 0.0387929 , 0.0594671

			with: 0.251217 , -0.0423859 , -0.0102173;

		addTriangleWith: 0.322518 , 0.328966 , 0.202348

			with: 0.151321 , 0.201209 , 0.0403463

			with: 0.0465009 , 0.0889641 , 0.102534;

		addTriangleWith: 0.322518 , 0.328966 , 0.202348

			with: 0.0465009 , 0.0889641 , 0.102534

			with: 0.124696 , 0.0387929 , 0.0594671;

		addTriangleWith: 0.322518 , 0.328966 , 0.202348

			with: 0.124696 , 0.0387929 , 0.0594671

			with: 0.151321 , 0.201209 , 0.0403463;

		addTriangleWith: 0.400104 , 0.299368 , 0.058967

			with: 0.151321 , 0.201209 , 0.0403463

			with: 0.124696 , 0.0387929 , 0.0594671;

		addTriangleWith: 0.400104 , 0.299368 , 0.058967

			with: 0.124696 , 0.0387929 , 0.0594671

			with: 0.124087 , 0.0593654 , -0.0408463;

		addTriangleWith: 0.400104 , 0.299368 , 0.058967

			with: 0.124087 , 0.0593654 , -0.0408463

			with: 0.151321 , 0.201209 , 0.0403463;

		addTriangleWith: 0.320924 , 0.382826 , -0.0602761

			with: 0.151321 , 0.201209 , 0.0403463

			with: 0.124087 , 0.0593654 , -0.0408463;

		addTriangleWith: 0.320924 , 0.382826 , -0.0602761

			with: 0.124087 , 0.0593654 , -0.0408463

			with: 0.0455159 , 0.122251 , -0.059776;

		addTriangleWith: 0.320924 , 0.382826 , -0.0602761

			with: 0.0455159 , 0.122251 , -0.059776

			with: 0.151321 , 0.201209 , 0.0403463;

		addTriangleWith: 0.194402 , 0.464005 , 0.0094082

			with: 0.151321 , 0.201209 , 0.0403463

			with: 0.0455159 , 0.122251 , -0.059776;

		addTriangleWith: 0.194402 , 0.464005 , 0.0094082

			with: 0.0455159 , 0.122251 , -0.059776

			with: -0.00243483 , 0.140544 , 0.028838;

		addTriangleWith: 0.194402 , 0.464005 , 0.0094082

			with: -0.00243483 , 0.140544 , 0.028838

			with: 0.151321 , 0.201209 , 0.0403463;

		addTriangleWith: 0.195387 , 0.430718 , 0.171718

			with: 0.151321 , 0.201209 , 0.0403463

			with: -0.00243483 , 0.140544 , 0.028838;

		addTriangleWith: 0.195387 , 0.430718 , 0.171718

			with: -0.00243483 , 0.140544 , 0.028838

			with: 0.0465009 , 0.0889641 , 0.102534;

		addTriangleWith: 0.195387 , 0.430718 , 0.171718

			with: 0.0465009 , 0.0889641 , 0.102534

			with: 0.151321 , 0.201209 , 0.0403463;

		addTriangleWith: -0.0518014 , 0.2787 , 0.415721

			with: -0.0800208 , 0.170143 , 0.172219

			with: -0.0182816 , 0.0195928 , 0.140969;

		addTriangleWith: -0.0518014 , 0.2787 , 0.415721

			with: -0.0182816 , 0.0195928 , 0.140969

			with: 0.0465009 , 0.0889641 , 0.102534;

		addTriangleWith: -0.0518014 , 0.2787 , 0.415721

			with: 0.0465009 , 0.0889641 , 0.102534

			with: -0.0800208 , 0.170143 , 0.172219;

		addTriangleWith: -0.0359547 , 0.399651 , 0.303591

			with: -0.0800208 , 0.170143 , 0.172219

			with: 0.0465009 , 0.0889641 , 0.102534;

		addTriangleWith: -0.0359547 , 0.399651 , 0.303591

			with: 0.0465009 , 0.0889641 , 0.102534

			with: -0.00243483 , 0.140544 , 0.028838;

		addTriangleWith: -0.0359547 , 0.399651 , 0.303591

			with: -0.00243483 , 0.140544 , 0.028838

			with: -0.0800208 , 0.170143 , 0.172219;

		addTriangleWith: -0.179917 , 0.413738 , 0.222782

			with: -0.0800208 , 0.170143 , 0.172219

			with: -0.00243483 , 0.140544 , 0.028838;

		addTriangleWith: -0.179917 , 0.413738 , 0.222782

			with: -0.00243483 , 0.140544 , 0.028838

			with: -0.0974613 , 0.103051 , 0.0217254;

		addTriangleWith: -0.179917 , 0.413738 , 0.222782

			with: -0.0974613 , 0.103051 , 0.0217254

			with: -0.0800208 , 0.170143 , 0.172219;

		addTriangleWith: -0.284737 , 0.301493 , 0.28497

			with: -0.0800208 , 0.170143 , 0.172219

			with: -0.0974613 , 0.103051 , 0.0217254;

		addTriangleWith: -0.284737 , 0.301493 , 0.28497

			with: -0.0974613 , 0.103051 , 0.0217254

			with: -0.107255 , 0.028299 , 0.091026;

		addTriangleWith: -0.284737 , 0.301493 , 0.28497

			with: -0.107255 , 0.028299 , 0.091026

			with: -0.0800208 , 0.170143 , 0.172219;

		addTriangleWith: -0.205558 , 0.218035 , 0.404213

			with: -0.0800208 , 0.170143 , 0.172219

			with: -0.107255 , 0.028299 , 0.091026;

		addTriangleWith: -0.205558 , 0.218035 , 0.404213

			with: -0.107255 , 0.028299 , 0.091026

			with: -0.0182816 , 0.0195928 , 0.140969;

		addTriangleWith: -0.205558 , 0.218035 , 0.404213

			with: -0.0182816 , 0.0195928 , 0.140969

			with: -0.0800208 , 0.170143 , 0.172219;

		addTriangleWith: -0.358617 , 0.0172873 , -0.352529

			with: -0.125681 , -0.00550584 , -0.221777

			with: -0.124696 , -0.0387929 , -0.059467;

		addTriangleWith: -0.358617 , 0.0172873 , -0.352529

			with: -0.124696 , -0.0387929 , -0.059467

			with: -0.10824 , 0.061586 , -0.0712843;

		addTriangleWith: -0.358617 , 0.0172873 , -0.352529

			with: -0.10824 , 0.061586 , -0.0712843

			with: -0.125681 , -0.00550584 , -0.221777;

		addTriangleWith: -0.253796 , 0.129533 , -0.414717

			with: -0.125681 , -0.00550584 , -0.221777

			with: -0.10824 , 0.061586 , -0.0712843;

		addTriangleWith: -0.253796 , 0.129533 , -0.414717

			with: -0.10824 , 0.061586 , -0.0712843

			with: -0.0198754 , 0.0734524 , -0.121655;

		addTriangleWith: -0.253796 , 0.129533 , -0.414717

			with: -0.0198754 , 0.0734524 , -0.121655

			with: -0.125681 , -0.00550584 , -0.221777;

		addTriangleWith: -0.127275 , 0.0483537 , -0.484401

			with: -0.125681 , -0.00550584 , -0.221777

			with: -0.0198754 , 0.0734524 , -0.121655;

		addTriangleWith: -0.127275 , 0.0483537 , -0.484401

			with: -0.0198754 , 0.0734524 , -0.121655

			with: 0.0182816 , -0.0195928 , -0.140969;

		addTriangleWith: -0.127275 , 0.0483537 , -0.484401

			with: 0.0182816 , -0.0195928 , -0.140969

			with: -0.125681 , -0.00550584 , -0.221777;

		addTriangleWith: -0.1539 , -0.114063 , -0.46528

			with: -0.125681 , -0.00550584 , -0.221777

			with: 0.0182816 , -0.0195928 , -0.140969;

		addTriangleWith: -0.1539 , -0.114063 , -0.46528

			with: 0.0182816 , -0.0195928 , -0.140969

			with: -0.046501 , -0.0889641 , -0.102534;

		addTriangleWith: -0.1539 , -0.114063 , -0.46528

			with: -0.046501 , -0.0889641 , -0.102534

			with: -0.125681 , -0.00550584 , -0.221777;

		addTriangleWith: -0.296877 , -0.133263 , -0.383779

			with: -0.125681 , -0.00550584 , -0.221777

			with: -0.046501 , -0.0889641 , -0.102534;

		addTriangleWith: -0.296877 , -0.133263 , -0.383779

			with: -0.046501 , -0.0889641 , -0.102534

			with: -0.124696 , -0.0387929 , -0.059467;

		addTriangleWith: -0.296877 , -0.133263 , -0.383779

			with: -0.124696 , -0.0387929 , -0.059467

			with: -0.125681 , -0.00550584 , -0.221777;

		addTriangleWith: -0.484153 , 0.065179 , -0.120534

			with: -0.251217 , 0.0423859 , 0.0102172

			with: -0.10824 , 0.061586 , -0.0712843;

		addTriangleWith: -0.484153 , 0.065179 , -0.120534

			with: -0.10824 , 0.061586 , -0.0712843

			with: -0.124696 , -0.0387929 , -0.059467;

		addTriangleWith: -0.484153 , 0.065179 , -0.120534

			with: -0.124696 , -0.0387929 , -0.059467

			with: -0.251217 , 0.0423859 , 0.0102172;

		addTriangleWith: -0.5 , -0.0557724 , -0.00840353

			with: -0.251217 , 0.0423859 , 0.0102172

			with: -0.124696 , -0.0387929 , -0.059467;

		addTriangleWith: -0.5 , -0.0557724 , -0.00840353

			with: -0.124696 , -0.0387929 , -0.059467

			with: -0.124087 , -0.0593654 , 0.0408463;

		addTriangleWith: -0.5 , -0.0557724 , -0.00840353

			with: -0.124087 , -0.0593654 , 0.0408463

			with: -0.251217 , 0.0423859 , 0.0102172;

		addTriangleWith: -0.482559 , 0.0113194 , 0.14209

			with: -0.251217 , 0.0423859 , 0.0102172

			with: -0.124087 , -0.0593654 , 0.0408463;

		addTriangleWith: -0.482559 , 0.0113194 , 0.14209

			with: -0.124087 , -0.0593654 , 0.0408463

			with: -0.107255 , 0.028299 , 0.091026;

		addTriangleWith: -0.482559 , 0.0113194 , 0.14209

			with: -0.107255 , 0.028299 , 0.091026

			with: -0.251217 , 0.0423859 , 0.0102172;

		addTriangleWith: -0.455934 , 0.173736 , 0.122969

			with: -0.251217 , 0.0423859 , 0.0102172

			with: -0.107255 , 0.028299 , 0.091026;

		addTriangleWith: -0.455934 , 0.173736 , 0.122969

			with: -0.107255 , 0.028299 , 0.091026

			with: -0.0974613 , 0.103051 , 0.0217254;

		addTriangleWith: -0.455934 , 0.173736 , 0.122969

			with: -0.0974613 , 0.103051 , 0.0217254

			with: -0.251217 , 0.0423859 , 0.0102172;

		addTriangleWith: -0.456919 , 0.207023 , -0.0393416

			with: -0.251217 , 0.0423859 , 0.0102172

			with: -0.0974613 , 0.103051 , 0.0217254;

		addTriangleWith: -0.456919 , 0.207023 , -0.0393416

			with: -0.0974613 , 0.103051 , 0.0217254

			with: -0.10824 , 0.061586 , -0.0712843;

		addTriangleWith: -0.456919 , 0.207023 , -0.0393416

			with: -0.10824 , 0.061586 , -0.0712843

			with: -0.251217 , 0.0423859 , 0.0102172;

		addTriangleWith: -0.20973 , 0.359041 , -0.283344

			with: -0.0816146 , 0.224002 , -0.0904051

			with: -0.0198754 , 0.0734524 , -0.121655;

		addTriangleWith: -0.20973 , 0.359041 , -0.283344

			with: -0.0198754 , 0.0734524 , -0.121655

			with: -0.10824 , 0.061586 , -0.0712843;

		addTriangleWith: -0.20973 , 0.359041 , -0.283344

			with: -0.10824 , 0.061586 , -0.0712843

			with: -0.0816146 , 0.224002 , -0.0904051;

		addTriangleWith: -0.287316 , 0.38864 , -0.139964

			with: -0.0816146 , 0.224002 , -0.0904051

			with: -0.10824 , 0.061586 , -0.0712843;

		addTriangleWith: -0.287316 , 0.38864 , -0.139964

			with: -0.10824 , 0.061586 , -0.0712843

			with: -0.0974613 , 0.103051 , 0.0217254;

		addTriangleWith: -0.287316 , 0.38864 , -0.139964

			with: -0.0974613 , 0.103051 , 0.0217254

			with: -0.0816146 , 0.224002 , -0.0904051;

		addTriangleWith: -0.181511 , 0.467598 , -0.0398416

			with: -0.0816146 , 0.224002 , -0.0904051

			with: -0.0974613 , 0.103051 , 0.0217254;

		addTriangleWith: -0.181511 , 0.467598 , -0.0398416

			with: -0.0974613 , 0.103051 , 0.0217254

			with: -0.00243483 , 0.140544 , 0.028838;

		addTriangleWith: -0.181511 , 0.467598 , -0.0398416

			with: -0.00243483 , 0.140544 , 0.028838

			with: -0.0816146 , 0.224002 , -0.0904051;

		addTriangleWith: -0.0385336 , 0.486798 , -0.121343

			with: -0.0816146 , 0.224002 , -0.0904051

			with: -0.00243483 , 0.140544 , 0.028838;

		addTriangleWith: -0.0385336 , 0.486798 , -0.121343

			with: -0.00243483 , 0.140544 , 0.028838

			with: 0.0455159 , 0.122251 , -0.059776;

		addTriangleWith: -0.0385336 , 0.486798 , -0.121343

			with: 0.0455159 , 0.122251 , -0.059776

			with: -0.0816146 , 0.224002 , -0.0904051;

		addTriangleWith: -0.0559741 , 0.419706 , -0.271836

			with: -0.0816146 , 0.224002 , -0.0904051

			with: 0.0455159 , 0.122251 , -0.059776;

		addTriangleWith: -0.0559741 , 0.419706 , -0.271836

			with: 0.0455159 , 0.122251 , -0.059776

			with: -0.0198754 , 0.0734524 , -0.121655;

		addTriangleWith: -0.0559741 , 0.419706 , -0.271836

			with: -0.0198754 , 0.0734524 , -0.121655

			with: -0.0816146 , 0.224002 , -0.0904051;

		addTriangleWith: 0.121508 , 0.146512 , -0.46578

			with: 0.123102 , 0.0926525 , -0.203157

			with: 0.0182816 , -0.0195928 , -0.140969;

		addTriangleWith: 0.121508 , 0.146512 , -0.46578

			with: 0.0182816 , -0.0195928 , -0.140969

			with: -0.0198754 , 0.0734524 , -0.121655;

		addTriangleWith: 0.121508 , 0.146512 , -0.46578

			with: -0.0198754 , 0.0734524 , -0.121655

			with: 0.123102 , 0.0926525 , -0.203157;

		addTriangleWith: 0.148742 , 0.288356 , -0.384588

			with: 0.123102 , 0.0926525 , -0.203157

			with: -0.0198754 , 0.0734524 , -0.121655;

		addTriangleWith: 0.148742 , 0.288356 , -0.384588

			with: -0.0198754 , 0.0734524 , -0.121655

			with: 0.0455159 , 0.122251 , -0.059776;

		addTriangleWith: 0.148742 , 0.288356 , -0.384588

			with: 0.0455159 , 0.122251 , -0.059776

			with: 0.123102 , 0.0926525 , -0.203157;

		addTriangleWith: 0.292705 , 0.274269 , -0.303779

			with: 0.123102 , 0.0926525 , -0.203157

			with: 0.0455159 , 0.122251 , -0.059776;

		addTriangleWith: 0.292705 , 0.274269 , -0.303779

			with: 0.0455159 , 0.122251 , -0.059776

			with: 0.124087 , 0.0593654 , -0.0408463;

		addTriangleWith: 0.292705 , 0.274269 , -0.303779

			with: 0.124087 , 0.0593654 , -0.0408463

			with: 0.123102 , 0.0926525 , -0.203157;

		addTriangleWith: 0.354444 , 0.123719 , -0.335029

			with: 0.123102 , 0.0926525 , -0.203157

			with: 0.124087 , 0.0593654 , -0.0408463;

		addTriangleWith: 0.354444 , 0.123719 , -0.335029

			with: 0.124087 , 0.0593654 , -0.0408463

			with: 0.107255 , -0.028299 , -0.091026;

		addTriangleWith: 0.354444 , 0.123719 , -0.335029

			with: 0.107255 , -0.028299 , -0.091026

			with: 0.123102 , 0.0926525 , -0.203157;

		addTriangleWith: 0.248639 , 0.0447608 , -0.435151

			with: 0.123102 , 0.0926525 , -0.203157

			with: 0.107255 , -0.028299 , -0.091026;

		addTriangleWith: 0.248639 , 0.0447608 , -0.435151

			with: 0.107255 , -0.028299 , -0.091026

			with: 0.0182816 , -0.0195928 , -0.140969;

		addTriangleWith: 0.248639 , 0.0447608 , -0.435151

			with: 0.0182816 , -0.0195928 , -0.140969

			with: 0.123102 , 0.0926525 , -0.203157;

		addTriangleWith: 0.0518014 , -0.2787 , -0.415721

			with: 0.0800208 , -0.170143 , -0.172219

			with: -0.046501 , -0.0889641 , -0.102534;

		addTriangleWith: 0.0518014 , -0.2787 , -0.415721

			with: -0.046501 , -0.0889641 , -0.102534

			with: 0.0182816 , -0.0195928 , -0.140969;

		addTriangleWith: 0.0518014 , -0.2787 , -0.415721

			with: 0.0182816 , -0.0195928 , -0.140969

			with: 0.0800208 , -0.170143 , -0.172219;

		addTriangleWith: 0.205558 , -0.218035 , -0.404213

			with: 0.0800208 , -0.170143 , -0.172219

			with: 0.0182816 , -0.0195928 , -0.140969;

		addTriangleWith: 0.205558 , -0.218035 , -0.404213

			with: 0.0182816 , -0.0195928 , -0.140969

			with: 0.107255 , -0.028299 , -0.091026;

		addTriangleWith: 0.205558 , -0.218035 , -0.404213

			with: 0.107255 , -0.028299 , -0.091026

			with: 0.0800208 , -0.170143 , -0.172219;

		addTriangleWith: 0.284737 , -0.301493 , -0.28497

			with: 0.0800208 , -0.170143 , -0.172219

			with: 0.107255 , -0.028299 , -0.091026;

		addTriangleWith: 0.284737 , -0.301493 , -0.28497

			with: 0.107255 , -0.028299 , -0.091026

			with: 0.0974613 , -0.103051 , -0.0217255;

		addTriangleWith: 0.284737 , -0.301493 , -0.28497

			with: 0.0974613 , -0.103051 , -0.0217255

			with: 0.0800208 , -0.170143 , -0.172219;

		addTriangleWith: 0.179917 , -0.413738 , -0.222782

			with: 0.0800208 , -0.170143 , -0.172219

			with: 0.0974613 , -0.103051 , -0.0217255;

		addTriangleWith: 0.179917 , -0.413738 , -0.222782

			with: 0.0974613 , -0.103051 , -0.0217255

			with: 0.00243484 , -0.140544 , -0.028838;

		addTriangleWith: 0.179917 , -0.413738 , -0.222782

			with: 0.00243484 , -0.140544 , -0.028838

			with: 0.0800208 , -0.170143 , -0.172219;

		addTriangleWith: 0.0359547 , -0.399651 , -0.303591

			with: 0.0800208 , -0.170143 , -0.172219

			with: 0.00243484 , -0.140544 , -0.028838;

		addTriangleWith: 0.0359547 , -0.399651 , -0.303591

			with: 0.00243484 , -0.140544 , -0.028838

			with: -0.046501 , -0.0889641 , -0.102534;

		addTriangleWith: 0.0359547 , -0.399651 , -0.303591

			with: -0.046501 , -0.0889641 , -0.102534

			with: 0.0800208 , -0.170143 , -0.172219;

		addTriangleWith: -0.322518 , -0.328966 , -0.202348

			with: -0.151321 , -0.201209 , -0.0403462

			with: -0.124696 , -0.0387929 , -0.059467;

		addTriangleWith: -0.322518 , -0.328966 , -0.202348

			with: -0.124696 , -0.0387929 , -0.059467

			with: -0.046501 , -0.0889641 , -0.102534;

		addTriangleWith: -0.322518 , -0.328966 , -0.202348

			with: -0.046501 , -0.0889641 , -0.102534

			with: -0.151321 , -0.201209 , -0.0403462;

		addTriangleWith: -0.195387 , -0.430718 , -0.171718

			with: -0.151321 , -0.201209 , -0.0403462

			with: -0.046501 , -0.0889641 , -0.102534;

		addTriangleWith: -0.195387 , -0.430718 , -0.171718

			with: -0.046501 , -0.0889641 , -0.102534

			with: 0.00243484 , -0.140544 , -0.028838;

		addTriangleWith: -0.195387 , -0.430718 , -0.171718

			with: 0.00243484 , -0.140544 , -0.028838

			with: -0.151321 , -0.201209 , -0.0403462;

		addTriangleWith: -0.194402 , -0.464005 , -0.00940815

			with: -0.151321 , -0.201209 , -0.0403462

			with: 0.00243484 , -0.140544 , -0.028838;

		addTriangleWith: -0.194402 , -0.464005 , -0.00940815

			with: 0.00243484 , -0.140544 , -0.028838

			with: -0.0455159 , -0.122251 , 0.059776;

		addTriangleWith: -0.194402 , -0.464005 , -0.00940815

			with: -0.0455159 , -0.122251 , 0.059776

			with: -0.151321 , -0.201209 , -0.0403462;

		addTriangleWith: -0.320924 , -0.382826 , 0.0602761

			with: -0.151321 , -0.201209 , -0.0403462

			with: -0.0455159 , -0.122251 , 0.059776;

		addTriangleWith: -0.320924 , -0.382826 , 0.0602761

			with: -0.0455159 , -0.122251 , 0.059776

			with: -0.124087 , -0.0593654 , 0.0408463;

		addTriangleWith: -0.320924 , -0.382826 , 0.0602761

			with: -0.124087 , -0.0593654 , 0.0408463

			with: -0.151321 , -0.201209 , -0.0403462;

		addTriangleWith: -0.400104 , -0.299368 , -0.058967

			with: -0.151321 , -0.201209 , -0.0403462

			with: -0.124087 , -0.0593654 , 0.0408463;

		addTriangleWith: -0.400104 , -0.299368 , -0.058967

			with: -0.124087 , -0.0593654 , 0.0408463

			with: -0.124696 , -0.0387929 , -0.059467;

		addTriangleWith: -0.400104 , -0.299368 , -0.058967

			with: -0.124696 , -0.0387929 , -0.059467

			with: -0.151321 , -0.201209 , -0.0403462"! !

!Polyhedron class methodsFor: 'factory-pentagonal' stamp: 'emm 02/09/2012 23:40'!
elongatedPentagonalGyrobicupola
	"self elongatedPentagonalGyrobicupola"

	^(Triangle3DComposite new)
		add: (Triangle3D 
					with: -0.270304 , -0.0278445 , -0.311041
					with: -0.113728 , 0.239822 , -0.316232
					with: 0.189153 , 0.173546 , -0.323895);
		add: (Triangle3D 
					with: -0.270304 , -0.0278445 , -0.311041
					with: 0.189153 , 0.173546 , -0.323895
					with: 0.219768 , -0.135081 , -0.323441);
		add: (Triangle3D 
					with: -0.270304 , -0.0278445 , -0.311041
					with: 0.219768 , -0.135081 , -0.323441
					with: -0.0641918 , -0.259547 , -0.315497);
		add: (Triangle3D 
					with: -0.113728 , 0.239822 , -0.316232
					with: -0.270304 , -0.0278445 , -0.311041
					with: -0.493663 , 0.106079 , -0.142628);
		add: (Triangle3D 
					with: -0.113728 , 0.239822 , -0.316232
					with: -0.493663 , 0.106079 , -0.142628
					with: -0.337088 , 0.373745 , -0.147818);
		add: (Triangle3D 
					with: -0.113728 , 0.239822 , -0.316232
					with: -0.337088 , 0.373745 , -0.147818
					with: -0.0531279 , 0.498211 , -0.155761);
		add: (Triangle3D 
					with: 0.189153 , 0.173546 , -0.323895
					with: -0.113728 , 0.239822 , -0.316232
					with: -0.0531279 , 0.498211 , -0.155761);
		add: (Triangle3D 
					with: 0.189153 , 0.173546 , -0.323895
					with: -0.0531279 , 0.498211 , -0.155761
					with: 0.249753 , 0.431936 , -0.163425);
		add: (Triangle3D 
					with: 0.189153 , 0.173546 , -0.323895
					with: 0.249753 , 0.431936 , -0.163425
					with: 0.455865 , 0.200233 , -0.16788);
		add: (Triangle3D 
					with: 0.219768 , -0.135081 , -0.323441
					with: 0.189153 , 0.173546 , -0.323895
					with: 0.455865 , 0.200233 , -0.16788);
		add: (Triangle3D 
					with: 0.219768 , -0.135081 , -0.323441
					with: 0.455865 , 0.200233 , -0.16788
					with: 0.486481 , -0.108394 , -0.167426);
		add: (Triangle3D 
					with: 0.219768 , -0.135081 , -0.323441
					with: 0.486481 , -0.108394 , -0.167426
					with: 0.329905 , -0.376061 , -0.162236);
		add: (Triangle3D 
					with: -0.0641918 , -0.259547 , -0.315497
					with: 0.219768 , -0.135081 , -0.323441
					with: 0.329905 , -0.376061 , -0.162236);
		add: (Triangle3D 
					with: -0.0641918 , -0.259547 , -0.315497
					with: 0.329905 , -0.376061 , -0.162236
					with: 0.0459449 , -0.500527 , -0.154292);
		add: (Triangle3D 
					with: -0.0641918 , -0.259547 , -0.315497
					with: 0.0459449 , -0.500527 , -0.154292
					with: -0.256936 , -0.434251 , -0.146629);
		add: (Triangle3D 
					with: -0.270304 , -0.0278445 , -0.311041
					with: -0.0641918 , -0.259547 , -0.315497
					with: -0.256936 , -0.434251 , -0.146629);
		add: (Triangle3D 
					with: -0.270304 , -0.0278445 , -0.311041
					with: -0.256936 , -0.434251 , -0.146629
					with: -0.463048 , -0.202548 , -0.142174);
		add: (Triangle3D 
					with: -0.270304 , -0.0278445 , -0.311041
					with: -0.463048 , -0.202548 , -0.142174
					with: -0.493663 , 0.106079 , -0.142628);
		add: (Triangle3D 
					with: 0.065129 , 0.258494 , 0.315476
					with: -0.218831 , 0.134027 , 0.32342
					with: -0.188216 , -0.1746 , 0.323874);
		add: (Triangle3D 
					with: 0.065129 , 0.258494 , 0.315476
					with: -0.188216 , -0.1746 , 0.323874
					with: 0.114665 , -0.240876 , 0.316211);
		add: (Triangle3D 
					with: 0.065129 , 0.258494 , 0.315476
					with: 0.114665 , -0.240876 , 0.316211
					with: 0.271241 , 0.026791 , 0.311021);
		add: (Triangle3D 
					with: -0.218831 , 0.134027 , 0.32342
					with: 0.065129 , 0.258494 , 0.315476
					with: -0.0450077 , 0.499473 , 0.154272);
		add: (Triangle3D 
					with: -0.218831 , 0.134027 , 0.32342
					with: -0.0450077 , 0.499473 , 0.154272
					with: -0.328968 , 0.375007 , 0.162216);
		add: (Triangle3D 
					with: -0.218831 , 0.134027 , 0.32342
					with: -0.328968 , 0.375007 , 0.162216
					with: -0.485543 , 0.107341 , 0.167406);
		add: (Triangle3D 
					with: -0.188216 , -0.1746 , 0.323874
					with: -0.218831 , 0.134027 , 0.32342
					with: -0.485543 , 0.107341 , 0.167406);
		add: (Triangle3D 
					with: -0.188216 , -0.1746 , 0.323874
					with: -0.485543 , 0.107341 , 0.167406
					with: -0.454928 , -0.201287 , 0.16786);
		add: (Triangle3D 
					with: -0.188216 , -0.1746 , 0.323874
					with: -0.454928 , -0.201287 , 0.16786
					with: -0.248816 , -0.432989 , 0.163405);
		add: (Triangle3D 
					with: 0.114665 , -0.240876 , 0.316211
					with: -0.188216 , -0.1746 , 0.323874
					with: -0.248816 , -0.432989 , 0.163405);
		add: (Triangle3D 
					with: 0.114665 , -0.240876 , 0.316211
					with: -0.248816 , -0.432989 , 0.163405
					with: 0.0540651 , -0.499265 , 0.155741);
		add: (Triangle3D 
					with: 0.114665 , -0.240876 , 0.316211
					with: 0.0540651 , -0.499265 , 0.155741
					with: 0.338025 , -0.374799 , 0.147798);
		add: (Triangle3D 
					with: 0.271241 , 0.026791 , 0.311021
					with: 0.114665 , -0.240876 , 0.316211
					with: 0.338025 , -0.374799 , 0.147798);
		add: (Triangle3D 
					with: 0.271241 , 0.026791 , 0.311021
					with: 0.338025 , -0.374799 , 0.147798
					with: 0.494601 , -0.107132 , 0.142607);
		add: (Triangle3D 
					with: 0.271241 , 0.026791 , 0.311021
					with: 0.494601 , -0.107132 , 0.142607
					with: 0.463986 , 0.201495 , 0.142153);
		add: (Triangle3D 
					with: 0.065129 , 0.258494 , 0.315476
					with: 0.271241 , 0.026791 , 0.311021
					with: 0.463986 , 0.201495 , 0.142153);
		add: (Triangle3D 
					with: 0.065129 , 0.258494 , 0.315476
					with: 0.463986 , 0.201495 , 0.142153
					with: 0.257873 , 0.433197 , 0.146609);
		add: (Triangle3D 
					with: 0.065129 , 0.258494 , 0.315476
					with: 0.257873 , 0.433197 , 0.146609
					with: -0.0450077 , 0.499473 , 0.154272);
		add: (Triangle3D 
					with: 0.329905 , -0.376061 , -0.162236
					with: 0.338025 , -0.374799 , 0.147798
					with: 0.0540651 , -0.499265 , 0.155741);
		add: (Triangle3D 
					with: 0.329905 , -0.376061 , -0.162236
					with: 0.0540651 , -0.499265 , 0.155741
					with: 0.0459449 , -0.500527 , -0.154292);
		add: (Triangle3D 
					with: 0.0459449 , -0.500527 , -0.154292
					with: 0.0540651 , -0.499265 , 0.155741
					with: -0.248816 , -0.432989 , 0.163405);
		add: (Triangle3D 
					with: 0.0459449 , -0.500527 , -0.154292
					with: -0.248816 , -0.432989 , 0.163405
					with: -0.256936 , -0.434251 , -0.146629);
		add: (Triangle3D 
					with: -0.256936 , -0.434251 , -0.146629
					with: -0.248816 , -0.432989 , 0.163405
					with: -0.454928 , -0.201287 , 0.16786);
		add: (Triangle3D 
					with: -0.256936 , -0.434251 , -0.146629
					with: -0.454928 , -0.201287 , 0.16786
					with: -0.463048 , -0.202548 , -0.142174);
		add: (Triangle3D 
					with: -0.463048 , -0.202548 , -0.142174
					with: -0.454928 , -0.201287 , 0.16786
					with: -0.485543 , 0.107341 , 0.167406);
		add: (Triangle3D 
					with: -0.463048 , -0.202548 , -0.142174
					with: -0.485543 , 0.107341 , 0.167406
					with: -0.493663 , 0.106079 , -0.142628);
		add: (Triangle3D 
					with: -0.493663 , 0.106079 , -0.142628
					with: -0.485543 , 0.107341 , 0.167406
					with: -0.328968 , 0.375007 , 0.162216);
		add: (Triangle3D 
					with: -0.493663 , 0.106079 , -0.142628
					with: -0.328968 , 0.375007 , 0.162216
					with: -0.337088 , 0.373745 , -0.147818);
		add: (Triangle3D 
					with: -0.337088 , 0.373745 , -0.147818
					with: -0.328968 , 0.375007 , 0.162216
					with: -0.0450077 , 0.499473 , 0.154272);
		add: (Triangle3D 
					with: -0.337088 , 0.373745 , -0.147818
					with: -0.0450077 , 0.499473 , 0.154272
					with: -0.0531279 , 0.498211 , -0.155761);
		add: (Triangle3D 
					with: -0.0531279 , 0.498211 , -0.155761
					with: -0.0450077 , 0.499473 , 0.154272
					with: 0.257873 , 0.433197 , 0.146609);
		add: (Triangle3D 
					with: -0.0531279 , 0.498211 , -0.155761
					with: 0.257873 , 0.433197 , 0.146609
					with: 0.249753 , 0.431936 , -0.163425);
		add: (Triangle3D 
					with: 0.249753 , 0.431936 , -0.163425
					with: 0.257873 , 0.433197 , 0.146609
					with: 0.463986 , 0.201495 , 0.142153);
		add: (Triangle3D 
					with: 0.249753 , 0.431936 , -0.163425
					with: 0.463986 , 0.201495 , 0.142153
					with: 0.455865 , 0.200233 , -0.16788);
		add: (Triangle3D 
					with: 0.455865 , 0.200233 , -0.16788
					with: 0.463986 , 0.201495 , 0.142153
					with: 0.494601 , -0.107132 , 0.142607);
		add: (Triangle3D 
					with: 0.455865 , 0.200233 , -0.16788
					with: 0.494601 , -0.107132 , 0.142607
					with: 0.486481 , -0.108394 , -0.167426);
		add: (Triangle3D 
					with: 0.486481 , -0.108394 , -0.167426
					with: 0.494601 , -0.107132 , 0.142607
					with: 0.338025 , -0.374799 , 0.147798);
		add: (Triangle3D 
					with: 0.486481 , -0.108394 , -0.167426
					with: 0.338025 , -0.374799 , 0.147798
					with: 0.329905 , -0.376061 , -0.162236);
		yourself! !

!Polyhedron class methodsFor: 'factory-pentagonal' stamp: 'emm 02/09/2012 23:40'!
elongatedPentagonalGyrobirotunda
	"self elongatedPentagonalGyrobirotunda"

	^(Triangle3DComposite new)
		add: (Triangle3D 
					with: -0.499678 , -0.0779348 , -0.00878307
					with: -0.461412 , 0.0835755 , -0.189854
					with: -0.342796 , -0.0322716 , -0.37109);
		add: (Triangle3D 
					with: -0.499678 , -0.0779348 , -0.00878307
					with: -0.342796 , -0.0322716 , -0.37109
					with: -0.307753 , -0.265379 , -0.302028);
		add: (Triangle3D 
					with: -0.499678 , -0.0779348 , -0.00878307
					with: -0.307753 , -0.265379 , -0.302028
					with: -0.404712 , -0.2936 , -0.0781103);
		add: (Triangle3D 
					with: -0.499678 , -0.0779348 , -0.00878307
					with: -0.38804 , -0.221686 , 0.156169
					with: -0.264107 , -0.0771032 , 0.311324);
		add: (Triangle3D 
					with: -0.499678 , -0.0779348 , -0.00878307
					with: -0.264107 , -0.0771032 , 0.311324
					with: -0.299149 , 0.156004 , 0.242262);
		add: (Triangle3D 
					with: -0.499678 , -0.0779348 , -0.00878307
					with: -0.299149 , 0.156004 , 0.242262
					with: -0.444741 , 0.15549 , 0.0444253);
		add: (Triangle3D 
					with: -0.499678 , -0.0779348 , -0.00878307
					with: -0.444741 , 0.15549 , 0.0444253
					with: -0.461412 , 0.0835755 , -0.189854);
		add: (Triangle3D 
					with: -0.444741 , 0.15549 , 0.0444253
					with: -0.299149 , 0.156004 , 0.242262
					with: -0.260883 , 0.317515 , 0.0611913);
		add: (Triangle3D 
					with: -0.461412 , 0.0835755 , -0.189854
					with: -0.444741 , 0.15549 , 0.0444253
					with: -0.260883 , 0.317515 , 0.0611913);
		add: (Triangle3D 
					with: -0.461412 , 0.0835755 , -0.189854
					with: -0.260883 , 0.317515 , 0.0611913
					with: -0.163924 , 0.345736 , -0.162726);
		add: (Triangle3D 
					with: -0.461412 , 0.0835755 , -0.189854
					with: -0.163924 , 0.345736 , -0.162726
					with: -0.287858 , 0.201154 , -0.317881);
		add: (Triangle3D 
					with: -0.461412 , 0.0835755 , -0.189854
					with: -0.287858 , 0.201154 , -0.317881
					with: -0.342796 , -0.0322716 , -0.37109);
		add: (Triangle3D 
					with: -0.287858 , 0.201154 , -0.317881
					with: -0.163924 , 0.345736 , -0.162726
					with: -0.0453074 , 0.229889 , -0.343962);
		add: (Triangle3D 
					with: -0.342796 , -0.0322716 , -0.37109
					with: -0.287858 , 0.201154 , -0.317881
					with: -0.0453074 , 0.229889 , -0.343962);
		add: (Triangle3D 
					with: -0.342796 , -0.0322716 , -0.37109
					with: -0.0453074 , 0.229889 , -0.343962
					with: 0.0496592 , 0.0142233 , -0.413289);
		add: (Triangle3D 
					with: -0.342796 , -0.0322716 , -0.37109
					with: 0.0496592 , 0.0142233 , -0.413289
					with: -0.134199 , -0.147801 , -0.430055);
		add: (Triangle3D 
					with: -0.342796 , -0.0322716 , -0.37109
					with: -0.134199 , -0.147801 , -0.430055
					with: -0.307753 , -0.265379 , -0.302028);
		add: (Triangle3D 
					with: -0.134199 , -0.147801 , -0.430055
					with: 0.0496592 , 0.0142233 , -0.413289
					with: 0.0847019 , -0.218884 , -0.344227);
		add: (Triangle3D 
					with: -0.307753 , -0.265379 , -0.302028
					with: -0.134199 , -0.147801 , -0.430055
					with: 0.0847019 , -0.218884 , -0.344227);
		add: (Triangle3D 
					with: -0.307753 , -0.265379 , -0.302028
					with: 0.0847019 , -0.218884 , -0.344227
					with: 0.0464355 , -0.380394 , -0.163156);
		add: (Triangle3D 
					with: -0.307753 , -0.265379 , -0.302028
					with: 0.0464355 , -0.380394 , -0.163156
					with: -0.196115 , -0.40913 , -0.137076);
		add: (Triangle3D 
					with: -0.307753 , -0.265379 , -0.302028
					with: -0.196115 , -0.40913 , -0.137076
					with: -0.404712 , -0.2936 , -0.0781103);
		add: (Triangle3D 
					with: -0.196115 , -0.40913 , -0.137076
					with: 0.0464355 , -0.380394 , -0.163156
					with: -0.0505234 , -0.408616 , 0.0607614);
		add: (Triangle3D 
					with: -0.404712 , -0.2936 , -0.0781103
					with: -0.196115 , -0.40913 , -0.137076
					with: -0.0505234 , -0.408616 , 0.0607614);
		add: (Triangle3D 
					with: -0.404712 , -0.2936 , -0.0781103
					with: -0.0505234 , -0.408616 , 0.0607614
					with: -0.16914 , -0.292769 , 0.241997);
		add: (Triangle3D 
					with: -0.404712 , -0.2936 , -0.0781103
					with: -0.16914 , -0.292769 , 0.241997
					with: -0.38804 , -0.221686 , 0.156169);
		add: (Triangle3D 
					with: -0.404712 , -0.2936 , -0.0781103
					with: -0.38804 , -0.221686 , 0.156169
					with: -0.499678 , -0.0779348 , -0.00878307);
		add: (Triangle3D 
					with: -0.38804 , -0.221686 , 0.156169
					with: -0.16914 , -0.292769 , 0.241997
					with: -0.264107 , -0.0771032 , 0.311324);
		add: (Triangle3D 
					with: 0.308396 , 0.264751 , 0.301045
					with: 0.343439 , 0.0316433 , 0.370107
					with: 0.462055 , -0.0842035 , 0.188872);
		add: (Triangle3D 
					with: 0.308396 , 0.264751 , 0.301045
					with: 0.462055 , -0.0842035 , 0.188872
					with: 0.500322 , 0.0773068 , 0.00780061);
		add: (Triangle3D 
					with: 0.308396 , 0.264751 , 0.301045
					with: 0.500322 , 0.0773068 , 0.00780061
					with: 0.405355 , 0.292972 , 0.0771277);
		add: (Triangle3D 
					with: 0.308396 , 0.264751 , 0.301045
					with: 0.196758 , 0.408502 , 0.136093
					with: -0.0457925 , 0.379766 , 0.162174);
		add: (Triangle3D 
					with: 0.308396 , 0.264751 , 0.301045
					with: -0.0457925 , 0.379766 , 0.162174
					with: -0.0840588 , 0.218256 , 0.343245);
		add: (Triangle3D 
					with: 0.308396 , 0.264751 , 0.301045
					with: -0.0840588 , 0.218256 , 0.343245
					with: 0.134842 , 0.147173 , 0.429072);
		add: (Triangle3D 
					with: 0.308396 , 0.264751 , 0.301045
					with: 0.134842 , 0.147173 , 0.429072
					with: 0.343439 , 0.0316433 , 0.370107);
		add: (Triangle3D 
					with: 0.134842 , 0.147173 , 0.429072
					with: -0.0840588 , 0.218256 , 0.343245
					with: -0.0490162 , -0.0148516 , 0.412306);
		add: (Triangle3D 
					with: 0.343439 , 0.0316433 , 0.370107
					with: 0.134842 , 0.147173 , 0.429072
					with: -0.0490162 , -0.0148516 , 0.412306);
		add: (Triangle3D 
					with: 0.343439 , 0.0316433 , 0.370107
					with: -0.0490162 , -0.0148516 , 0.412306
					with: 0.0459505 , -0.230517 , 0.342979);
		add: (Triangle3D 
					with: 0.343439 , 0.0316433 , 0.370107
					with: 0.0459505 , -0.230517 , 0.342979
					with: 0.288501 , -0.201782 , 0.316898);
		add: (Triangle3D 
					with: 0.343439 , 0.0316433 , 0.370107
					with: 0.288501 , -0.201782 , 0.316898
					with: 0.462055 , -0.0842035 , 0.188872);
		add: (Triangle3D 
					with: 0.288501 , -0.201782 , 0.316898
					with: 0.0459505 , -0.230517 , 0.342979
					with: 0.164567 , -0.346364 , 0.161744);
		add: (Triangle3D 
					with: 0.462055 , -0.0842035 , 0.188872
					with: 0.288501 , -0.201782 , 0.316898
					with: 0.164567 , -0.346364 , 0.161744);
		add: (Triangle3D 
					with: 0.462055 , -0.0842035 , 0.188872
					with: 0.164567 , -0.346364 , 0.161744
					with: 0.261526 , -0.318143 , -0.0621737);
		add: (Triangle3D 
					with: 0.462055 , -0.0842035 , 0.188872
					with: 0.261526 , -0.318143 , -0.0621737
					with: 0.445384 , -0.156118 , -0.0454079);
		add: (Triangle3D 
					with: 0.462055 , -0.0842035 , 0.188872
					with: 0.445384 , -0.156118 , -0.0454079
					with: 0.500322 , 0.0773068 , 0.00780061);
		add: (Triangle3D 
					with: 0.445384 , -0.156118 , -0.0454079
					with: 0.261526 , -0.318143 , -0.0621737
					with: 0.299792 , -0.156632 , -0.243245);
		add: (Triangle3D 
					with: 0.500322 , 0.0773068 , 0.00780061
					with: 0.445384 , -0.156118 , -0.0454079
					with: 0.299792 , -0.156632 , -0.243245);
		add: (Triangle3D 
					with: 0.500322 , 0.0773068 , 0.00780061
					with: 0.299792 , -0.156632 , -0.243245
					with: 0.26475 , 0.0764752 , -0.312306);
		add: (Triangle3D 
					with: 0.500322 , 0.0773068 , 0.00780061
					with: 0.26475 , 0.0764752 , -0.312306
					with: 0.388684 , 0.221057 , -0.157152);
		add: (Triangle3D 
					with: 0.500322 , 0.0773068 , 0.00780061
					with: 0.388684 , 0.221057 , -0.157152
					with: 0.405355 , 0.292972 , 0.0771277);
		add: (Triangle3D 
					with: 0.388684 , 0.221057 , -0.157152
					with: 0.26475 , 0.0764752 , -0.312306
					with: 0.169783 , 0.292141 , -0.242979);
		add: (Triangle3D 
					with: 0.405355 , 0.292972 , 0.0771277
					with: 0.388684 , 0.221057 , -0.157152
					with: 0.169783 , 0.292141 , -0.242979);
		add: (Triangle3D 
					with: 0.405355 , 0.292972 , 0.0771277
					with: 0.169783 , 0.292141 , -0.242979
					with: 0.0511665 , 0.407988 , -0.0617439);
		add: (Triangle3D 
					with: 0.405355 , 0.292972 , 0.0771277
					with: 0.0511665 , 0.407988 , -0.0617439
					with: 0.196758 , 0.408502 , 0.136093);
		add: (Triangle3D 
					with: 0.405355 , 0.292972 , 0.0771277
					with: 0.196758 , 0.408502 , 0.136093
					with: 0.308396 , 0.264751 , 0.301045);
		add: (Triangle3D 
					with: 0.196758 , 0.408502 , 0.136093
					with: 0.0511665 , 0.407988 , -0.0617439
					with: -0.0457925 , 0.379766 , 0.162174);
		add: (Triangle3D 
					with: 0.0847019 , -0.218884 , -0.344227
					with: 0.299792 , -0.156632 , -0.243245
					with: 0.261526 , -0.318143 , -0.0621737);
		add: (Triangle3D 
					with: 0.0847019 , -0.218884 , -0.344227
					with: 0.261526 , -0.318143 , -0.0621737
					with: 0.0464355 , -0.380394 , -0.163156);
		add: (Triangle3D 
					with: 0.0464355 , -0.380394 , -0.163156
					with: 0.261526 , -0.318143 , -0.0621737
					with: 0.164567 , -0.346364 , 0.161744);
		add: (Triangle3D 
					with: 0.0464355 , -0.380394 , -0.163156
					with: 0.164567 , -0.346364 , 0.161744
					with: -0.0505234 , -0.408616 , 0.0607614);
		add: (Triangle3D 
					with: -0.0505234 , -0.408616 , 0.0607614
					with: 0.164567 , -0.346364 , 0.161744
					with: 0.0459505 , -0.230517 , 0.342979);
		add: (Triangle3D 
					with: -0.0505234 , -0.408616 , 0.0607614
					with: 0.0459505 , -0.230517 , 0.342979
					with: -0.16914 , -0.292769 , 0.241997);
		add: (Triangle3D 
					with: -0.16914 , -0.292769 , 0.241997
					with: 0.0459505 , -0.230517 , 0.342979
					with: -0.0490162 , -0.0148516 , 0.412306);
		add: (Triangle3D 
					with: -0.16914 , -0.292769 , 0.241997
					with: -0.0490162 , -0.0148516 , 0.412306
					with: -0.264107 , -0.0771032 , 0.311324);
		add: (Triangle3D 
					with: -0.264107 , -0.0771032 , 0.311324
					with: -0.0490162 , -0.0148516 , 0.412306
					with: -0.0840588 , 0.218256 , 0.343245);
		add: (Triangle3D 
					with: -0.264107 , -0.0771032 , 0.311324
					with: -0.0840588 , 0.218256 , 0.343245
					with: -0.299149 , 0.156004 , 0.242262);
		add: (Triangle3D 
					with: -0.299149 , 0.156004 , 0.242262
					with: -0.0840588 , 0.218256 , 0.343245
					with: -0.0457925 , 0.379766 , 0.162174);
		add: (Triangle3D 
					with: -0.299149 , 0.156004 , 0.242262
					with: -0.0457925 , 0.379766 , 0.162174
					with: -0.260883 , 0.317515 , 0.0611913);
		add: (Triangle3D 
					with: -0.260883 , 0.317515 , 0.0611913
					with: -0.0457925 , 0.379766 , 0.162174
					with: 0.0511665 , 0.407988 , -0.0617439);
		add: (Triangle3D 
					with: -0.260883 , 0.317515 , 0.0611913
					with: 0.0511665 , 0.407988 , -0.0617439
					with: -0.163924 , 0.345736 , -0.162726);
		add: (Triangle3D 
					with: -0.163924 , 0.345736 , -0.162726
					with: 0.0511665 , 0.407988 , -0.0617439
					with: 0.169783 , 0.292141 , -0.242979);
		add: (Triangle3D 
					with: -0.163924 , 0.345736 , -0.162726
					with: 0.169783 , 0.292141 , -0.242979
					with: -0.0453074 , 0.229889 , -0.343962);
		add: (Triangle3D 
					with: -0.0453074 , 0.229889 , -0.343962
					with: 0.169783 , 0.292141 , -0.242979
					with: 0.26475 , 0.0764752 , -0.312306);
		add: (Triangle3D 
					with: -0.0453074 , 0.229889 , -0.343962
					with: 0.26475 , 0.0764752 , -0.312306
					with: 0.0496592 , 0.0142233 , -0.413289);
		add: (Triangle3D 
					with: 0.0496592 , 0.0142233 , -0.413289
					with: 0.26475 , 0.0764752 , -0.312306
					with: 0.299792 , -0.156632 , -0.243245);
		add: (Triangle3D 
					with: 0.0496592 , 0.0142233 , -0.413289
					with: 0.299792 , -0.156632 , -0.243245
					with: 0.0847019 , -0.218884 , -0.344227);
		yourself! !

!Polyhedron class methodsFor: 'factory-pentagonal' stamp: 'emm 02/09/2012 23:40'!
elongatedPentagonalGyrocupolarotunda
	"self elongatedPentagonalGyrocupolarotunda"

	^(Triangle3DComposite new)
		add: (Triangle3D 
					with: -0.360715 , 0.270392 , -0.1384
					with: -0.251835 , 0.382453 , 0.113403
					with: 0.0274991 , 0.467358 , 0.0626037);
		add: (Triangle3D 
					with: -0.360715 , 0.270392 , -0.1384
					with: 0.0274991 , 0.467358 , 0.0626037
					with: 0.0912572 , 0.407773 , -0.220595);
		add: (Triangle3D 
					with: -0.360715 , 0.270392 , -0.1384
					with: 0.0912572 , 0.407773 , -0.220595
					with: -0.148672 , 0.286041 , -0.344822);
		add: (Triangle3D 
					with: -0.251835 , 0.382453 , 0.113403
					with: -0.360715 , 0.270392 , -0.1384
					with: -0.529965 , 0.0838999 , 0.0177791);
		add: (Triangle3D 
					with: -0.251835 , 0.382453 , 0.113403
					with: -0.529965 , 0.0838999 , 0.0177791
					with: -0.421085 , 0.19596 , 0.269582);
		add: (Triangle3D 
					with: -0.251835 , 0.382453 , 0.113403
					with: -0.421085 , 0.19596 , 0.269582
					with: -0.181156 , 0.317692 , 0.393809);
		add: (Triangle3D 
					with: 0.0274991 , 0.467358 , 0.0626037
					with: -0.251835 , 0.382453 , 0.113403
					with: -0.181156 , 0.317692 , 0.393809);
		add: (Triangle3D 
					with: 0.0274991 , 0.467358 , 0.0626037
					with: -0.181156 , 0.317692 , 0.393809
					with: 0.0981779 , 0.402598 , 0.34301);
		add: (Triangle3D 
					with: 0.0274991 , 0.467358 , 0.0626037
					with: 0.0981779 , 0.402598 , 0.34301
					with: 0.31022 , 0.418246 , 0.136588);
		add: (Triangle3D 
					with: 0.0912572 , 0.407773 , -0.220595
					with: 0.0274991 , 0.467358 , 0.0626037
					with: 0.31022 , 0.418246 , 0.136588);
		add: (Triangle3D 
					with: 0.0912572 , 0.407773 , -0.220595
					with: 0.31022 , 0.418246 , 0.136588
					with: 0.373979 , 0.358661 , -0.146611);
		add: (Triangle3D 
					with: 0.0912572 , 0.407773 , -0.220595
					with: 0.373979 , 0.358661 , -0.146611
					with: 0.265099 , 0.2466 , -0.398414);
		add: (Triangle3D 
					with: -0.148672 , 0.286041 , -0.344822
					with: 0.0912572 , 0.407773 , -0.220595
					with: 0.265099 , 0.2466 , -0.398414);
		add: (Triangle3D 
					with: -0.148672 , 0.286041 , -0.344822
					with: 0.265099 , 0.2466 , -0.398414
					with: 0.0251697 , 0.124869 , -0.522641);
		add: (Triangle3D 
					with: -0.148672 , 0.286041 , -0.344822
					with: 0.0251697 , 0.124869 , -0.522641
					with: -0.254164 , 0.039963 , -0.471842);
		add: (Triangle3D 
					with: -0.360715 , 0.270392 , -0.1384
					with: -0.148672 , 0.286041 , -0.344822
					with: -0.254164 , 0.039963 , -0.471842);
		add: (Triangle3D 
					with: -0.360715 , 0.270392 , -0.1384
					with: -0.254164 , 0.039963 , -0.471842
					with: -0.466207 , 0.0243143 , -0.26542);
		add: (Triangle3D 
					with: -0.360715 , 0.270392 , -0.1384
					with: -0.466207 , 0.0243143 , -0.26542
					with: -0.529965 , 0.0838999 , 0.0177791);
		add: (Triangle3D 
					with: -0.0694768 , -0.463394 , 0.236603
					with: -0.00571861 , -0.52298 , -0.0465953
					with: 0.273615 , -0.438074 , -0.0973946);
		add: (Triangle3D 
					with: -0.0694768 , -0.463394 , 0.236603
					with: 0.273615 , -0.438074 , -0.0973946
					with: 0.382495 , -0.326014 , 0.154408);
		add: (Triangle3D 
					with: -0.0694768 , -0.463394 , 0.236603
					with: 0.382495 , -0.326014 , 0.154408
					with: 0.170452 , -0.341663 , 0.36083);
		add: (Triangle3D 
					with: -0.0694768 , -0.463394 , 0.236603
					with: -0.0997976 , -0.245109 , 0.434717
					with: -0.325029 , -0.0732328 , 0.347846);
		add: (Triangle3D 
					with: -0.0694768 , -0.463394 , 0.236603
					with: -0.325029 , -0.0732328 , 0.347846
					with: -0.433909 , -0.185293 , 0.0960434);
		add: (Triangle3D 
					with: -0.0694768 , -0.463394 , 0.236603
					with: -0.433909 , -0.185293 , 0.0960434
					with: -0.275969 , -0.426426 , 0.0272915);
		add: (Triangle3D 
					with: -0.0694768 , -0.463394 , 0.236603
					with: -0.275969 , -0.426426 , 0.0272915
					with: -0.00571861 , -0.52298 , -0.0465953);
		add: (Triangle3D 
					with: -0.275969 , -0.426426 , 0.0272915
					with: -0.433909 , -0.185293 , 0.0960434
					with: -0.37015 , -0.244879 , -0.187155);
		add: (Triangle3D 
					with: -0.00571861 , -0.52298 , -0.0465953
					with: -0.275969 , -0.426426 , 0.0272915
					with: -0.37015 , -0.244879 , -0.187155);
		add: (Triangle3D 
					with: -0.00571861 , -0.52298 , -0.0465953
					with: -0.37015 , -0.244879 , -0.187155
					with: -0.158108 , -0.22923 , -0.393577);
		add: (Triangle3D 
					with: -0.00571861 , -0.52298 , -0.0465953
					with: -0.158108 , -0.22923 , -0.393577
					with: 0.0671234 , -0.401106 , -0.306706);
		add: (Triangle3D 
					with: -0.00571861 , -0.52298 , -0.0465953
					with: 0.0671234 , -0.401106 , -0.306706
					with: 0.273615 , -0.438074 , -0.0973946);
		add: (Triangle3D 
					with: 0.0671234 , -0.401106 , -0.306706
					with: -0.158108 , -0.22923 , -0.393577
					with: 0.121226 , -0.144324 , -0.444377);
		add: (Triangle3D 
					with: 0.273615 , -0.438074 , -0.0973946
					with: 0.0671234 , -0.401106 , -0.306706
					with: 0.121226 , -0.144324 , -0.444377);
		add: (Triangle3D 
					with: 0.273615 , -0.438074 , -0.0973946
					with: 0.121226 , -0.144324 , -0.444377
					with: 0.361155 , -0.0225925 , -0.320149);
		add: (Triangle3D 
					with: 0.273615 , -0.438074 , -0.0973946
					with: 0.361155 , -0.0225925 , -0.320149
					with: 0.455337 , -0.20414 , -0.105703);
		add: (Triangle3D 
					with: 0.273615 , -0.438074 , -0.0973946
					with: 0.455337 , -0.20414 , -0.105703
					with: 0.382495 , -0.326014 , 0.154408);
		add: (Triangle3D 
					with: 0.455337 , -0.20414 , -0.105703
					with: 0.361155 , -0.0225925 , -0.320149
					with: 0.470035 , 0.0894678 , -0.0683464);
		add: (Triangle3D 
					with: 0.382495 , -0.326014 , 0.154408
					with: 0.455337 , -0.20414 , -0.105703
					with: 0.470035 , 0.0894678 , -0.0683464);
		add: (Triangle3D 
					with: 0.382495 , -0.326014 , 0.154408
					with: 0.470035 , 0.0894678 , -0.0683464
					with: 0.406277 , 0.149053 , 0.214852);
		add: (Triangle3D 
					with: 0.382495 , -0.326014 , 0.154408
					with: 0.406277 , 0.149053 , 0.214852
					with: 0.352174 , -0.107728 , 0.352522);
		add: (Triangle3D 
					with: 0.382495 , -0.326014 , 0.154408
					with: 0.352174 , -0.107728 , 0.352522
					with: 0.170452 , -0.341663 , 0.36083);
		add: (Triangle3D 
					with: 0.352174 , -0.107728 , 0.352522
					with: 0.406277 , 0.149053 , 0.214852
					with: 0.194234 , 0.133405 , 0.421274);
		add: (Triangle3D 
					with: 0.170452 , -0.341663 , 0.36083
					with: 0.352174 , -0.107728 , 0.352522
					with: 0.194234 , 0.133405 , 0.421274);
		add: (Triangle3D 
					with: 0.170452 , -0.341663 , 0.36083
					with: 0.194234 , 0.133405 , 0.421274
					with: -0.0850997 , 0.0484989 , 0.472074);
		add: (Triangle3D 
					with: 0.170452 , -0.341663 , 0.36083
					with: -0.0850997 , 0.0484989 , 0.472074
					with: -0.0997976 , -0.245109 , 0.434717);
		add: (Triangle3D 
					with: 0.170452 , -0.341663 , 0.36083
					with: -0.0997976 , -0.245109 , 0.434717
					with: -0.0694768 , -0.463394 , 0.236603);
		add: (Triangle3D 
					with: -0.0997976 , -0.245109 , 0.434717
					with: -0.0850997 , 0.0484989 , 0.472074
					with: -0.325029 , -0.0732328 , 0.347846);
		add: (Triangle3D 
					with: 0.265099 , 0.2466 , -0.398414
					with: 0.361155 , -0.0225925 , -0.320149
					with: 0.121226 , -0.144324 , -0.444377);
		add: (Triangle3D 
					with: 0.265099 , 0.2466 , -0.398414
					with: 0.121226 , -0.144324 , -0.444377
					with: 0.0251697 , 0.124869 , -0.522641);
		add: (Triangle3D 
					with: 0.0251697 , 0.124869 , -0.522641
					with: 0.121226 , -0.144324 , -0.444377
					with: -0.158108 , -0.22923 , -0.393577);
		add: (Triangle3D 
					with: 0.0251697 , 0.124869 , -0.522641
					with: -0.158108 , -0.22923 , -0.393577
					with: -0.254164 , 0.039963 , -0.471842);
		add: (Triangle3D 
					with: -0.254164 , 0.039963 , -0.471842
					with: -0.158108 , -0.22923 , -0.393577
					with: -0.37015 , -0.244879 , -0.187155);
		add: (Triangle3D 
					with: -0.254164 , 0.039963 , -0.471842
					with: -0.37015 , -0.244879 , -0.187155
					with: -0.466207 , 0.0243143 , -0.26542);
		add: (Triangle3D 
					with: -0.466207 , 0.0243143 , -0.26542
					with: -0.37015 , -0.244879 , -0.187155
					with: -0.433909 , -0.185293 , 0.0960434);
		add: (Triangle3D 
					with: -0.466207 , 0.0243143 , -0.26542
					with: -0.433909 , -0.185293 , 0.0960434
					with: -0.529965 , 0.0838999 , 0.0177791);
		add: (Triangle3D 
					with: -0.529965 , 0.0838999 , 0.0177791
					with: -0.433909 , -0.185293 , 0.0960434
					with: -0.325029 , -0.0732328 , 0.347846);
		add: (Triangle3D 
					with: -0.529965 , 0.0838999 , 0.0177791
					with: -0.325029 , -0.0732328 , 0.347846
					with: -0.421085 , 0.19596 , 0.269582);
		add: (Triangle3D 
					with: -0.421085 , 0.19596 , 0.269582
					with: -0.325029 , -0.0732328 , 0.347846
					with: -0.0850997 , 0.0484989 , 0.472074);
		add: (Triangle3D 
					with: -0.421085 , 0.19596 , 0.269582
					with: -0.0850997 , 0.0484989 , 0.472074
					with: -0.181156 , 0.317692 , 0.393809);
		add: (Triangle3D 
					with: -0.181156 , 0.317692 , 0.393809
					with: -0.0850997 , 0.0484989 , 0.472074
					with: 0.194234 , 0.133405 , 0.421274);
		add: (Triangle3D 
					with: -0.181156 , 0.317692 , 0.393809
					with: 0.194234 , 0.133405 , 0.421274
					with: 0.0981779 , 0.402598 , 0.34301);
		add: (Triangle3D 
					with: 0.0981779 , 0.402598 , 0.34301
					with: 0.194234 , 0.133405 , 0.421274
					with: 0.406277 , 0.149053 , 0.214852);
		add: (Triangle3D 
					with: 0.0981779 , 0.402598 , 0.34301
					with: 0.406277 , 0.149053 , 0.214852
					with: 0.31022 , 0.418246 , 0.136588);
		add: (Triangle3D 
					with: 0.31022 , 0.418246 , 0.136588
					with: 0.406277 , 0.149053 , 0.214852
					with: 0.470035 , 0.0894678 , -0.0683464);
		add: (Triangle3D 
					with: 0.31022 , 0.418246 , 0.136588
					with: 0.470035 , 0.0894678 , -0.0683464
					with: 0.373979 , 0.358661 , -0.146611);
		add: (Triangle3D 
					with: 0.373979 , 0.358661 , -0.146611
					with: 0.470035 , 0.0894678 , -0.0683464
					with: 0.361155 , -0.0225925 , -0.320149);
		add: (Triangle3D 
					with: 0.373979 , 0.358661 , -0.146611
					with: 0.361155 , -0.0225925 , -0.320149
					with: 0.265099 , 0.2466 , -0.398414);
		yourself! !

!Polyhedron class methodsFor: 'factory-pentagonal' stamp: 'emm 02/09/2012 23:40'!
elongatedPentagonalOrthobicupola
	"self elongatedPentagonalOrthobicupola"

	^(Triangle3DComposite new)
		add: (Triangle3D 
					with: -0.108404 , 0.146822 , -0.357586
					with: 0.0815705 , 0.330745 , -0.212438
					with: 0.331125 , 0.174369 , -0.147205);
		add: (Triangle3D 
					with: -0.108404 , 0.146822 , -0.357586
					with: 0.331125 , 0.174369 , -0.147205
					with: 0.295383 , -0.1062 , -0.252036);
		add: (Triangle3D 
					with: -0.108404 , 0.146822 , -0.357586
					with: 0.295383 , -0.1062 , -0.252036
					with: 0.0237397 , -0.123225 , -0.382059);
		add: (Triangle3D 
					with: 0.0815705 , 0.330745 , -0.212438
					with: -0.108404 , 0.146822 , -0.357586
					with: -0.342688 , 0.293853 , -0.237258);
		add: (Triangle3D 
					with: 0.0815705 , 0.330745 , -0.212438
					with: -0.342688 , 0.293853 , -0.237258
					with: -0.152713 , 0.477776 , -0.0921092);
		add: (Triangle3D 
					with: 0.0815705 , 0.330745 , -0.212438
					with: -0.152713 , 0.477776 , -0.0921092
					with: 0.11893 , 0.494801 , 0.0379135);
		add: (Triangle3D 
					with: 0.331125 , 0.174369 , -0.147205
					with: 0.0815705 , 0.330745 , -0.212438
					with: 0.11893 , 0.494801 , 0.0379135);
		add: (Triangle3D 
					with: 0.331125 , 0.174369 , -0.147205
					with: 0.11893 , 0.494801 , 0.0379135
					with: 0.368484 , 0.338426 , 0.103147);
		add: (Triangle3D 
					with: 0.331125 , 0.174369 , -0.147205
					with: 0.368484 , 0.338426 , 0.103147
					with: 0.500628 , 0.0683791 , 0.0786733);
		add: (Triangle3D 
					with: 0.295383 , -0.1062 , -0.252036
					with: 0.331125 , 0.174369 , -0.147205
					with: 0.500628 , 0.0683791 , 0.0786733);
		add: (Triangle3D 
					with: 0.295383 , -0.1062 , -0.252036
					with: 0.500628 , 0.0683791 , 0.0786733
					with: 0.464887 , -0.21219 , -0.0261588);
		add: (Triangle3D 
					with: 0.295383 , -0.1062 , -0.252036
					with: 0.464887 , -0.21219 , -0.0261588
					with: 0.274912 , -0.396113 , -0.171307);
		add: (Triangle3D 
					with: 0.0237397 , -0.123225 , -0.382059
					with: 0.295383 , -0.1062 , -0.252036
					with: 0.274912 , -0.396113 , -0.171307);
		add: (Triangle3D 
					with: 0.0237397 , -0.123225 , -0.382059
					with: 0.274912 , -0.396113 , -0.171307
					with: 0.00326855 , -0.413138 , -0.30133);
		add: (Triangle3D 
					with: 0.0237397 , -0.123225 , -0.382059
					with: 0.00326855 , -0.413138 , -0.30133
					with: -0.246286 , -0.256762 , -0.366563);
		add: (Triangle3D 
					with: -0.108404 , 0.146822 , -0.357586
					with: 0.0237397 , -0.123225 , -0.382059
					with: -0.246286 , -0.256762 , -0.366563);
		add: (Triangle3D 
					with: -0.108404 , 0.146822 , -0.357586
					with: -0.246286 , -0.256762 , -0.366563
					with: -0.378429 , 0.0132843 , -0.342089);
		add: (Triangle3D 
					with: -0.108404 , 0.146822 , -0.357586
					with: -0.378429 , 0.0132843 , -0.342089
					with: -0.342688 , 0.293853 , -0.237258);
		add: (Triangle3D 
					with: -0.166539 , 0.160337 , 0.328226
					with: -0.356514 , -0.0235859 , 0.183078
					with: -0.22437 , -0.293632 , 0.158604);
		add: (Triangle3D 
					with: -0.166539 , 0.160337 , 0.328226
					with: -0.22437 , -0.293632 , 0.158604
					with: 0.0472735 , -0.276607 , 0.288627);
		add: (Triangle3D 
					with: -0.166539 , 0.160337 , 0.328226
					with: 0.0472735 , -0.276607 , 0.288627
					with: 0.083015 , 0.00396148 , 0.393459);
		add: (Triangle3D 
					with: -0.356514 , -0.0235859 , 0.183078
					with: -0.166539 , 0.160337 , 0.328226
					with: -0.273656 , 0.39471 , 0.171441);
		add: (Triangle3D 
					with: -0.356514 , -0.0235859 , 0.183078
					with: -0.273656 , 0.39471 , 0.171441
					with: -0.463631 , 0.210786 , 0.026293);
		add: (Triangle3D 
					with: -0.356514 , -0.0235859 , 0.183078
					with: -0.463631 , 0.210786 , 0.026293
					with: -0.499372 , -0.0697822 , -0.0785392);
		add: (Triangle3D 
					with: -0.22437 , -0.293632 , 0.158604
					with: -0.356514 , -0.0235859 , 0.183078
					with: -0.499372 , -0.0697822 , -0.0785392);
		add: (Triangle3D 
					with: -0.22437 , -0.293632 , 0.158604
					with: -0.499372 , -0.0697822 , -0.0785392
					with: -0.367228 , -0.339829 , -0.103013);
		add: (Triangle3D 
					with: -0.22437 , -0.293632 , 0.158604
					with: -0.367228 , -0.339829 , -0.103013
					with: -0.117674 , -0.496205 , -0.0377793);
		add: (Triangle3D 
					with: 0.0472735 , -0.276607 , 0.288627
					with: -0.22437 , -0.293632 , 0.158604
					with: -0.117674 , -0.496205 , -0.0377793);
		add: (Triangle3D 
					with: 0.0472735 , -0.276607 , 0.288627
					with: -0.117674 , -0.496205 , -0.0377793
					with: 0.153969 , -0.479179 , 0.0922434);
		add: (Triangle3D 
					with: 0.0472735 , -0.276607 , 0.288627
					with: 0.153969 , -0.479179 , 0.0922434
					with: 0.343944 , -0.295256 , 0.237392);
		add: (Triangle3D 
					with: 0.083015 , 0.00396148 , 0.393459
					with: 0.0472735 , -0.276607 , 0.288627
					with: 0.343944 , -0.295256 , 0.237392);
		add: (Triangle3D 
					with: 0.083015 , 0.00396148 , 0.393459
					with: 0.343944 , -0.295256 , 0.237392
					with: 0.379685 , -0.0146873 , 0.342224);
		add: (Triangle3D 
					with: 0.083015 , 0.00396148 , 0.393459
					with: 0.379685 , -0.0146873 , 0.342224
					with: 0.247542 , 0.255359 , 0.366697);
		add: (Triangle3D 
					with: -0.166539 , 0.160337 , 0.328226
					with: 0.083015 , 0.00396148 , 0.393459
					with: 0.247542 , 0.255359 , 0.366697);
		add: (Triangle3D 
					with: -0.166539 , 0.160337 , 0.328226
					with: 0.247542 , 0.255359 , 0.366697
					with: -0.00201263 , 0.411735 , 0.301464);
		add: (Triangle3D 
					with: -0.166539 , 0.160337 , 0.328226
					with: -0.00201263 , 0.411735 , 0.301464
					with: -0.273656 , 0.39471 , 0.171441);
		add: (Triangle3D 
					with: 0.274912 , -0.396113 , -0.171307
					with: 0.153969 , -0.479179 , 0.0922434
					with: -0.117674 , -0.496205 , -0.0377793);
		add: (Triangle3D 
					with: 0.274912 , -0.396113 , -0.171307
					with: -0.117674 , -0.496205 , -0.0377793
					with: 0.00326855 , -0.413138 , -0.30133);
		add: (Triangle3D 
					with: 0.00326855 , -0.413138 , -0.30133
					with: -0.117674 , -0.496205 , -0.0377793
					with: -0.367228 , -0.339829 , -0.103013);
		add: (Triangle3D 
					with: 0.00326855 , -0.413138 , -0.30133
					with: -0.367228 , -0.339829 , -0.103013
					with: -0.246286 , -0.256762 , -0.366563);
		add: (Triangle3D 
					with: -0.246286 , -0.256762 , -0.366563
					with: -0.367228 , -0.339829 , -0.103013
					with: -0.499372 , -0.0697822 , -0.0785392);
		add: (Triangle3D 
					with: -0.246286 , -0.256762 , -0.366563
					with: -0.499372 , -0.0697822 , -0.0785392
					with: -0.378429 , 0.0132843 , -0.342089);
		add: (Triangle3D 
					with: -0.378429 , 0.0132843 , -0.342089
					with: -0.499372 , -0.0697822 , -0.0785392
					with: -0.463631 , 0.210786 , 0.026293);
		add: (Triangle3D 
					with: -0.378429 , 0.0132843 , -0.342089
					with: -0.463631 , 0.210786 , 0.026293
					with: -0.342688 , 0.293853 , -0.237258);
		add: (Triangle3D 
					with: -0.342688 , 0.293853 , -0.237258
					with: -0.463631 , 0.210786 , 0.026293
					with: -0.273656 , 0.39471 , 0.171441);
		add: (Triangle3D 
					with: -0.342688 , 0.293853 , -0.237258
					with: -0.273656 , 0.39471 , 0.171441
					with: -0.152713 , 0.477776 , -0.0921092);
		add: (Triangle3D 
					with: -0.152713 , 0.477776 , -0.0921092
					with: -0.273656 , 0.39471 , 0.171441
					with: -0.00201263 , 0.411735 , 0.301464);
		add: (Triangle3D 
					with: -0.152713 , 0.477776 , -0.0921092
					with: -0.00201263 , 0.411735 , 0.301464
					with: 0.11893 , 0.494801 , 0.0379135);
		add: (Triangle3D 
					with: 0.11893 , 0.494801 , 0.0379135
					with: -0.00201263 , 0.411735 , 0.301464
					with: 0.247542 , 0.255359 , 0.366697);
		add: (Triangle3D 
					with: 0.11893 , 0.494801 , 0.0379135
					with: 0.247542 , 0.255359 , 0.366697
					with: 0.368484 , 0.338426 , 0.103147);
		add: (Triangle3D 
					with: 0.368484 , 0.338426 , 0.103147
					with: 0.247542 , 0.255359 , 0.366697
					with: 0.379685 , -0.0146873 , 0.342224);
		add: (Triangle3D 
					with: 0.368484 , 0.338426 , 0.103147
					with: 0.379685 , -0.0146873 , 0.342224
					with: 0.500628 , 0.0683791 , 0.0786733);
		add: (Triangle3D 
					with: 0.500628 , 0.0683791 , 0.0786733
					with: 0.379685 , -0.0146873 , 0.342224
					with: 0.343944 , -0.295256 , 0.237392);
		add: (Triangle3D 
					with: 0.500628 , 0.0683791 , 0.0786733
					with: 0.343944 , -0.295256 , 0.237392
					with: 0.464887 , -0.21219 , -0.0261588);
		add: (Triangle3D 
					with: 0.464887 , -0.21219 , -0.0261588
					with: 0.343944 , -0.295256 , 0.237392
					with: 0.153969 , -0.479179 , 0.0922434);
		add: (Triangle3D 
					with: 0.464887 , -0.21219 , -0.0261588
					with: 0.153969 , -0.479179 , 0.0922434
					with: 0.274912 , -0.396113 , -0.171307);
		yourself! !

!Polyhedron class methodsFor: 'factory-pentagonal' stamp: 'emm 02/09/2012 23:40'!
elongatedPentagonalOrthobirotunda
	"self elongatedPentagonalOrthobirotunda"

	^(Triangle3DComposite new)
		add: (Triangle3D 
					with: -0.503245 , 0.0419821 , -0.0849384
					with: -0.401562 , 0.202959 , -0.24494
					with: -0.283668 , 0.0724465 , -0.420784);
		add: (Triangle3D 
					with: -0.503245 , 0.0419821 , -0.0849384
					with: -0.283668 , 0.0724465 , -0.420784
					with: -0.312488 , -0.169191 , -0.36946);
		add: (Triangle3D 
					with: -0.503245 , 0.0419821 , -0.0849384
					with: -0.312488 , -0.169191 , -0.36946
					with: -0.448194 , -0.188019 , -0.161896);
		add: (Triangle3D 
					with: -0.503245 , 0.0419821 , -0.0849384
					with: -0.452277 , -0.135888 , 0.0812486
					with: -0.323177 , -0.0327094 , 0.2671);
		add: (Triangle3D 
					with: -0.503245 , 0.0419821 , -0.0849384
					with: -0.323177 , -0.0327094 , 0.2671
					with: -0.294356 , 0.208928 , 0.215776);
		add: (Triangle3D 
					with: -0.503245 , 0.0419821 , -0.0849384
					with: -0.294356 , 0.208928 , 0.215776
					with: -0.405644 , 0.25509 , -0.00179582);
		add: (Triangle3D 
					with: -0.503245 , 0.0419821 , -0.0849384
					with: -0.405644 , 0.25509 , -0.00179582
					with: -0.401562 , 0.202959 , -0.24494);
		add: (Triangle3D 
					with: -0.405644 , 0.25509 , -0.00179582
					with: -0.294356 , 0.208928 , 0.215776
					with: -0.192673 , 0.369905 , 0.0557742);
		add: (Triangle3D 
					with: -0.401562 , 0.202959 , -0.24494
					with: -0.405644 , 0.25509 , -0.00179582
					with: -0.192673 , 0.369905 , 0.0557742);
		add: (Triangle3D 
					with: -0.401562 , 0.202959 , -0.24494
					with: -0.192673 , 0.369905 , 0.0557742
					with: -0.056967 , 0.388733 , -0.15179);
		add: (Triangle3D 
					with: -0.401562 , 0.202959 , -0.24494
					with: -0.056967 , 0.388733 , -0.15179
					with: -0.186067 , 0.285554 , -0.337641);
		add: (Triangle3D 
					with: -0.401562 , 0.202959 , -0.24494
					with: -0.186067 , 0.285554 , -0.337641
					with: -0.283668 , 0.0724465 , -0.420784);
		add: (Triangle3D 
					with: -0.186067 , 0.285554 , -0.337641
					with: -0.056967 , 0.388733 , -0.15179
					with: 0.060927 , 0.25822 , -0.327634);
		add: (Triangle3D 
					with: -0.283668 , 0.0724465 , -0.420784
					with: -0.186067 , 0.285554 , -0.337641
					with: 0.060927 , 0.25822 , -0.327634);
		add: (Triangle3D 
					with: -0.283668 , 0.0724465 , -0.420784
					with: 0.060927 , 0.25822 , -0.327634
					with: 0.115977 , 0.0282194 , -0.404591);
		add: (Triangle3D 
					with: -0.283668 , 0.0724465 , -0.420784
					with: 0.115977 , 0.0282194 , -0.404591
					with: -0.0969939 , -0.0865951 , -0.462161);
		add: (Triangle3D 
					with: -0.283668 , 0.0724465 , -0.420784
					with: -0.0969939 , -0.0865951 , -0.462161
					with: -0.312488 , -0.169191 , -0.36946);
		add: (Triangle3D 
					with: -0.0969939 , -0.0865951 , -0.462161
					with: 0.115977 , 0.0282194 , -0.404591
					with: 0.0871568 , -0.213418 , -0.353267);
		add: (Triangle3D 
					with: -0.312488 , -0.169191 , -0.36946
					with: -0.0969939 , -0.0865951 , -0.462161
					with: 0.0871568 , -0.213418 , -0.353267);
		add: (Triangle3D 
					with: -0.312488 , -0.169191 , -0.36946
					with: 0.0871568 , -0.213418 , -0.353267
					with: -0.0145264 , -0.374395 , -0.193265);
		add: (Triangle3D 
					with: -0.312488 , -0.169191 , -0.36946
					with: -0.0145264 , -0.374395 , -0.193265
					with: -0.261521 , -0.347061 , -0.203273);
		add: (Triangle3D 
					with: -0.312488 , -0.169191 , -0.36946
					with: -0.261521 , -0.347061 , -0.203273
					with: -0.448194 , -0.188019 , -0.161896);
		add: (Triangle3D 
					with: -0.261521 , -0.347061 , -0.203273
					with: -0.0145264 , -0.374395 , -0.193265
					with: -0.150232 , -0.393223 , 0.014299);
		add: (Triangle3D 
					with: -0.448194 , -0.188019 , -0.161896
					with: -0.261521 , -0.347061 , -0.203273
					with: -0.150232 , -0.393223 , 0.014299);
		add: (Triangle3D 
					with: -0.448194 , -0.188019 , -0.161896
					with: -0.150232 , -0.393223 , 0.014299
					with: -0.268127 , -0.262711 , 0.190143);
		add: (Triangle3D 
					with: -0.448194 , -0.188019 , -0.161896
					with: -0.268127 , -0.262711 , 0.190143
					with: -0.452277 , -0.135888 , 0.0812486);
		add: (Triangle3D 
					with: -0.448194 , -0.188019 , -0.161896
					with: -0.452277 , -0.135888 , 0.0812486
					with: -0.503245 , 0.0419821 , -0.0849384);
		add: (Triangle3D 
					with: -0.452277 , -0.135888 , 0.0812486
					with: -0.268127 , -0.262711 , 0.190143
					with: -0.323177 , -0.0327094 , 0.2671);
		add: (Triangle3D 
					with: 0.277178 , 0.0575764 , 0.42672
					with: 0.332228 , -0.172425 , 0.349762
					with: 0.467935 , -0.153597 , 0.142198);
		add: (Triangle3D 
					with: 0.277178 , 0.0575764 , 0.42672
					with: 0.467935 , -0.153597 , 0.142198
					with: 0.496755 , 0.0880408 , 0.0908741);
		add: (Triangle3D 
					with: 0.277178 , 0.0575764 , 0.42672
					with: 0.496755 , 0.0880408 , 0.0908741
					with: 0.378861 , 0.218553 , 0.266718);
		add: (Triangle3D 
					with: 0.277178 , 0.0575764 , 0.42672
					with: 0.156117 , 0.266315 , 0.366504
					with: -0.0863968 , 0.213083 , 0.352118);
		add: (Triangle3D 
					with: 0.277178 , 0.0575764 , 0.42672
					with: -0.0863968 , 0.213083 , 0.352118
					with: -0.115217 , -0.028554 , 0.403442);
		add: (Triangle3D 
					with: 0.277178 , 0.0575764 , 0.42672
					with: -0.115217 , -0.028554 , 0.403442
					with: 0.109484 , -0.124663 , 0.449549);
		add: (Triangle3D 
					with: 0.277178 , 0.0575764 , 0.42672
					with: 0.109484 , -0.124663 , 0.449549
					with: 0.332228 , -0.172425 , 0.349762);
		add: (Triangle3D 
					with: 0.109484 , -0.124663 , 0.449549
					with: -0.115217 , -0.028554 , 0.403442
					with: -0.0601671 , -0.258555 , 0.326485);
		add: (Triangle3D 
					with: 0.332228 , -0.172425 , 0.349762
					with: 0.109484 , -0.124663 , 0.449549
					with: -0.0601671 , -0.258555 , 0.326485);
		add: (Triangle3D 
					with: 0.332228 , -0.172425 , 0.349762
					with: -0.0601671 , -0.258555 , 0.326485
					with: 0.057727 , -0.389067 , 0.150641);
		add: (Triangle3D 
					with: 0.332228 , -0.172425 , 0.349762
					with: 0.057727 , -0.389067 , 0.150641
					with: 0.300241 , -0.335836 , 0.165027);
		add: (Triangle3D 
					with: 0.332228 , -0.172425 , 0.349762
					with: 0.300241 , -0.335836 , 0.165027
					with: 0.467935 , -0.153597 , 0.142198);
		add: (Triangle3D 
					with: 0.300241 , -0.335836 , 0.165027
					with: 0.057727 , -0.389067 , 0.150641
					with: 0.193433 , -0.370239 , -0.0569232);
		add: (Triangle3D 
					with: 0.467935 , -0.153597 , 0.142198
					with: 0.300241 , -0.335836 , 0.165027
					with: 0.193433 , -0.370239 , -0.0569232);
		add: (Triangle3D 
					with: 0.467935 , -0.153597 , 0.142198
					with: 0.193433 , -0.370239 , -0.0569232
					with: 0.295116 , -0.209263 , -0.216925);
		add: (Triangle3D 
					with: 0.467935 , -0.153597 , 0.142198
					with: 0.295116 , -0.209263 , -0.216925
					with: 0.464767 , -0.0753702 , -0.0938611);
		add: (Triangle3D 
					with: 0.467935 , -0.153597 , 0.142198
					with: 0.464767 , -0.0753702 , -0.0938611
					with: 0.496755 , 0.0880408 , 0.0908741);
		add: (Triangle3D 
					with: 0.464767 , -0.0753702 , -0.0938611
					with: 0.295116 , -0.209263 , -0.216925
					with: 0.323937 , 0.0323748 , -0.268249);
		add: (Triangle3D 
					with: 0.496755 , 0.0880408 , 0.0908741
					with: 0.464767 , -0.0753702 , -0.0938611
					with: 0.323937 , 0.0323748 , -0.268249);
		add: (Triangle3D 
					with: 0.496755 , 0.0880408 , 0.0908741
					with: 0.323937 , 0.0323748 , -0.268249
					with: 0.268886 , 0.262376 , -0.191292);
		add: (Triangle3D 
					with: 0.496755 , 0.0880408 , 0.0908741
					with: 0.268886 , 0.262376 , -0.191292
					with: 0.375694 , 0.296779 , 0.0306585);
		add: (Triangle3D 
					with: 0.496755 , 0.0880408 , 0.0908741
					with: 0.375694 , 0.296779 , 0.0306585
					with: 0.378861 , 0.218553 , 0.266718);
		add: (Triangle3D 
					with: 0.375694 , 0.296779 , 0.0306585
					with: 0.268886 , 0.262376 , -0.191292
					with: 0.150993 , 0.392888 , -0.015448);
		add: (Triangle3D 
					with: 0.378861 , 0.218553 , 0.266718
					with: 0.375694 , 0.296779 , 0.0306585
					with: 0.150993 , 0.392888 , -0.015448);
		add: (Triangle3D 
					with: 0.378861 , 0.218553 , 0.266718
					with: 0.150993 , 0.392888 , -0.015448
					with: 0.0152864 , 0.37406 , 0.192116);
		add: (Triangle3D 
					with: 0.378861 , 0.218553 , 0.266718
					with: 0.0152864 , 0.37406 , 0.192116
					with: 0.156117 , 0.266315 , 0.366504);
		add: (Triangle3D 
					with: 0.378861 , 0.218553 , 0.266718
					with: 0.156117 , 0.266315 , 0.366504
					with: 0.277178 , 0.0575764 , 0.42672);
		add: (Triangle3D 
					with: 0.156117 , 0.266315 , 0.366504
					with: 0.0152864 , 0.37406 , 0.192116
					with: -0.0863968 , 0.213083 , 0.352118);
		add: (Triangle3D 
					with: 0.0871568 , -0.213418 , -0.353267
					with: 0.295116 , -0.209263 , -0.216925
					with: 0.193433 , -0.370239 , -0.0569232);
		add: (Triangle3D 
					with: 0.0871568 , -0.213418 , -0.353267
					with: 0.193433 , -0.370239 , -0.0569232
					with: -0.0145264 , -0.374395 , -0.193265);
		add: (Triangle3D 
					with: -0.0145264 , -0.374395 , -0.193265
					with: 0.193433 , -0.370239 , -0.0569232
					with: 0.057727 , -0.389067 , 0.150641);
		add: (Triangle3D 
					with: -0.0145264 , -0.374395 , -0.193265
					with: 0.057727 , -0.389067 , 0.150641
					with: -0.150232 , -0.393223 , 0.014299);
		add: (Triangle3D 
					with: -0.150232 , -0.393223 , 0.014299
					with: 0.057727 , -0.389067 , 0.150641
					with: -0.0601671 , -0.258555 , 0.326485);
		add: (Triangle3D 
					with: -0.150232 , -0.393223 , 0.014299
					with: -0.0601671 , -0.258555 , 0.326485
					with: -0.268127 , -0.262711 , 0.190143);
		add: (Triangle3D 
					with: -0.268127 , -0.262711 , 0.190143
					with: -0.0601671 , -0.258555 , 0.326485
					with: -0.115217 , -0.028554 , 0.403442);
		add: (Triangle3D 
					with: -0.268127 , -0.262711 , 0.190143
					with: -0.115217 , -0.028554 , 0.403442
					with: -0.323177 , -0.0327094 , 0.2671);
		add: (Triangle3D 
					with: -0.323177 , -0.0327094 , 0.2671
					with: -0.115217 , -0.028554 , 0.403442
					with: -0.0863968 , 0.213083 , 0.352118);
		add: (Triangle3D 
					with: -0.323177 , -0.0327094 , 0.2671
					with: -0.0863968 , 0.213083 , 0.352118
					with: -0.294356 , 0.208928 , 0.215776);
		add: (Triangle3D 
					with: -0.294356 , 0.208928 , 0.215776
					with: -0.0863968 , 0.213083 , 0.352118
					with: 0.0152864 , 0.37406 , 0.192116);
		add: (Triangle3D 
					with: -0.294356 , 0.208928 , 0.215776
					with: 0.0152864 , 0.37406 , 0.192116
					with: -0.192673 , 0.369905 , 0.0557742);
		add: (Triangle3D 
					with: -0.192673 , 0.369905 , 0.0557742
					with: 0.0152864 , 0.37406 , 0.192116
					with: 0.150993 , 0.392888 , -0.015448);
		add: (Triangle3D 
					with: -0.192673 , 0.369905 , 0.0557742
					with: 0.150993 , 0.392888 , -0.015448
					with: -0.056967 , 0.388733 , -0.15179);
		add: (Triangle3D 
					with: -0.056967 , 0.388733 , -0.15179
					with: 0.150993 , 0.392888 , -0.015448
					with: 0.268886 , 0.262376 , -0.191292);
		add: (Triangle3D 
					with: -0.056967 , 0.388733 , -0.15179
					with: 0.268886 , 0.262376 , -0.191292
					with: 0.060927 , 0.25822 , -0.327634);
		add: (Triangle3D 
					with: 0.060927 , 0.25822 , -0.327634
					with: 0.268886 , 0.262376 , -0.191292
					with: 0.323937 , 0.0323748 , -0.268249);
		add: (Triangle3D 
					with: 0.060927 , 0.25822 , -0.327634
					with: 0.323937 , 0.0323748 , -0.268249
					with: 0.115977 , 0.0282194 , -0.404591);
		add: (Triangle3D 
					with: 0.115977 , 0.0282194 , -0.404591
					with: 0.323937 , 0.0323748 , -0.268249
					with: 0.295116 , -0.209263 , -0.216925);
		add: (Triangle3D 
					with: 0.115977 , 0.0282194 , -0.404591
					with: 0.295116 , -0.209263 , -0.216925
					with: 0.0871568 , -0.213418 , -0.353267);
		yourself! !

!Polyhedron class methodsFor: 'factory-pentagonal' stamp: 'emm 02/09/2012 23:40'!
elongatedPentagonalOrthocupolarotunda
	"self elongatedPentagonalOrthocupolarotunda"

	^(Triangle3DComposite new)
		add: (Triangle3D 
					with: -0.383083 , 0.155416 , -0.198595
					with: -0.323385 , 0.324077 , 0.0272547
					with: -0.0705666 , 0.453087 , -0.0223244);
		add: (Triangle3D 
					with: -0.383083 , 0.155416 , -0.198595
					with: -0.0705666 , 0.453087 , -0.0223244
					with: 0.025986 , 0.364158 , -0.278816);
		add: (Triangle3D 
					with: -0.383083 , 0.155416 , -0.198595
					with: 0.025986 , 0.364158 , -0.278816
					with: -0.167159 , 0.180187 , -0.387758);
		add: (Triangle3D 
					with: -0.323385 , 0.324077 , 0.0272547
					with: -0.383083 , 0.155416 , -0.198595
					with: -0.520767 , -0.0285823 , -0.0247956);
		add: (Triangle3D 
					with: -0.323385 , 0.324077 , 0.0272547
					with: -0.520767 , -0.0285823 , -0.0247956
					with: -0.461069 , 0.140079 , 0.201055);
		add: (Triangle3D 
					with: -0.323385 , 0.324077 , 0.0272547
					with: -0.461069 , 0.140079 , 0.201055
					with: -0.267924 , 0.32405 , 0.309996);
		add: (Triangle3D 
					with: -0.0705666 , 0.453087 , -0.0223244
					with: -0.323385 , 0.324077 , 0.0272547
					with: -0.267924 , 0.32405 , 0.309996);
		add: (Triangle3D 
					with: -0.0705666 , 0.453087 , -0.0223244
					with: -0.267924 , 0.32405 , 0.309996
					with: -0.0151056 , 0.45306 , 0.260417);
		add: (Triangle3D 
					with: -0.0705666 , 0.453087 , -0.0223244
					with: -0.0151056 , 0.45306 , 0.260417
					with: 0.200818 , 0.477832 , 0.071255);
		add: (Triangle3D 
					with: 0.025986 , 0.364158 , -0.278816
					with: -0.0705666 , 0.453087 , -0.0223244
					with: 0.200818 , 0.477832 , 0.071255);
		add: (Triangle3D 
					with: 0.025986 , 0.364158 , -0.278816
					with: 0.200818 , 0.477832 , 0.071255
					with: 0.29737 , 0.388903 , -0.185237);
		add: (Triangle3D 
					with: 0.025986 , 0.364158 , -0.278816
					with: 0.29737 , 0.388903 , -0.185237
					with: 0.237672 , 0.220241 , -0.411087);
		add: (Triangle3D 
					with: -0.167159 , 0.180187 , -0.387758
					with: 0.025986 , 0.364158 , -0.278816
					with: 0.237672 , 0.220241 , -0.411087);
		add: (Triangle3D 
					with: -0.167159 , 0.180187 , -0.387758
					with: 0.237672 , 0.220241 , -0.411087
					with: 0.0445269 , 0.0362705 , -0.520028);
		add: (Triangle3D 
					with: -0.167159 , 0.180187 , -0.387758
					with: 0.0445269 , 0.0362705 , -0.520028
					with: -0.208291 , -0.0927395 , -0.470449);
		add: (Triangle3D 
					with: -0.383083 , 0.155416 , -0.198595
					with: -0.167159 , 0.180187 , -0.387758
					with: -0.208291 , -0.0927395 , -0.470449);
		add: (Triangle3D 
					with: -0.383083 , 0.155416 , -0.198595
					with: -0.208291 , -0.0927395 , -0.470449
					with: -0.424215 , -0.117511 , -0.281287);
		add: (Triangle3D 
					with: -0.383083 , 0.155416 , -0.198595
					with: -0.424215 , -0.117511 , -0.281287
					with: -0.520767 , -0.0285823 , -0.0247956);
		add: (Triangle3D 
					with: 0.0737514 , -0.311981 , 0.39728
					with: 0.0140537 , -0.480642 , 0.17143
					with: 0.229977 , -0.455871 , -0.0177328);
		add: (Triangle3D 
					with: 0.0737514 , -0.311981 , 0.39728
					with: 0.229977 , -0.455871 , -0.0177328
					with: 0.423122 , -0.2719 , 0.0912089);
		add: (Triangle3D 
					with: 0.0737514 , -0.311981 , 0.39728
					with: 0.423122 , -0.2719 , 0.0912089
					with: 0.32657 , -0.182971 , 0.347701);
		add: (Triangle3D 
					with: 0.0737514 , -0.311981 , 0.39728
					with: 0.114883 , -0.0390543 , 0.479972
					with: -0.13108 , 0.104879 , 0.437498);
		add: (Triangle3D 
					with: 0.0737514 , -0.311981 , 0.39728
					with: -0.13108 , 0.104879 , 0.437498
					with: -0.324226 , -0.0790916 , 0.328557);
		add: (Triangle3D 
					with: 0.0737514 , -0.311981 , 0.39728
					with: -0.324226 , -0.0790916 , 0.328557
					with: -0.197633 , -0.336726 , 0.3037);
		add: (Triangle3D 
					with: 0.0737514 , -0.311981 , 0.39728
					with: -0.197633 , -0.336726 , 0.3037
					with: 0.0140537 , -0.480642 , 0.17143);
		add: (Triangle3D 
					with: -0.197633 , -0.336726 , 0.3037
					with: -0.324226 , -0.0790916 , 0.328557
					with: -0.383923 , -0.247753 , 0.102707);
		add: (Triangle3D 
					with: 0.0140537 , -0.480642 , 0.17143
					with: -0.197633 , -0.336726 , 0.3037
					with: -0.383923 , -0.247753 , 0.102707);
		add: (Triangle3D 
					with: 0.0140537 , -0.480642 , 0.17143
					with: -0.383923 , -0.247753 , 0.102707
					with: -0.287371 , -0.336682 , -0.153785);
		add: (Triangle3D 
					with: 0.0140537 , -0.480642 , 0.17143
					with: -0.287371 , -0.336682 , -0.153785
					with: -0.0414074 , -0.480615 , -0.111312);
		add: (Triangle3D 
					with: 0.0140537 , -0.480642 , 0.17143
					with: -0.0414074 , -0.480615 , -0.111312
					with: 0.229977 , -0.455871 , -0.0177328);
		add: (Triangle3D 
					with: -0.0414074 , -0.480615 , -0.111312
					with: -0.287371 , -0.336682 , -0.153785
					with: -0.0714476 , -0.31191 , -0.342947);
		add: (Triangle3D 
					with: 0.229977 , -0.455871 , -0.0177328
					with: -0.0414074 , -0.480615 , -0.111312
					with: -0.0714476 , -0.31191 , -0.342947);
		add: (Triangle3D 
					with: 0.229977 , -0.455871 , -0.0177328
					with: -0.0714476 , -0.31191 , -0.342947
					with: 0.181371 , -0.1829 , -0.392527);
		add: (Triangle3D 
					with: 0.229977 , -0.455871 , -0.0177328
					with: 0.181371 , -0.1829 , -0.392527
					with: 0.367661 , -0.271873 , -0.191533);
		add: (Triangle3D 
					with: 0.229977 , -0.455871 , -0.0177328
					with: 0.367661 , -0.271873 , -0.191533
					with: 0.423122 , -0.2719 , 0.0912089);
		add: (Triangle3D 
					with: 0.367661 , -0.271873 , -0.191533
					with: 0.181371 , -0.1829 , -0.392527
					with: 0.374516 , 0.00107078 , -0.283585);
		add: (Triangle3D 
					with: 0.423122 , -0.2719 , 0.0912089
					with: 0.367661 , -0.271873 , -0.191533
					with: 0.374516 , 0.00107078 , -0.283585);
		add: (Triangle3D 
					with: 0.423122 , -0.2719 , 0.0912089
					with: 0.374516 , 0.00107078 , -0.283585
					with: 0.434214 , 0.169732 , -0.0577348);
		add: (Triangle3D 
					with: 0.423122 , -0.2719 , 0.0912089
					with: 0.434214 , 0.169732 , -0.0577348
					with: 0.464254 , 0.00102695 , 0.173901);
		add: (Triangle3D 
					with: 0.423122 , -0.2719 , 0.0912089
					with: 0.464254 , 0.00102695 , 0.173901
					with: 0.32657 , -0.182971 , 0.347701);
		add: (Triangle3D 
					with: 0.464254 , 0.00102695 , 0.173901
					with: 0.434214 , 0.169732 , -0.0577348
					with: 0.337661 , 0.258661 , 0.198757);
		add: (Triangle3D 
					with: 0.32657 , -0.182971 , 0.347701
					with: 0.464254 , 0.00102695 , 0.173901
					with: 0.337661 , 0.258661 , 0.198757);
		add: (Triangle3D 
					with: 0.32657 , -0.182971 , 0.347701
					with: 0.337661 , 0.258661 , 0.198757
					with: 0.121738 , 0.233889 , 0.387919);
		add: (Triangle3D 
					with: 0.32657 , -0.182971 , 0.347701
					with: 0.121738 , 0.233889 , 0.387919
					with: 0.114883 , -0.0390543 , 0.479972);
		add: (Triangle3D 
					with: 0.32657 , -0.182971 , 0.347701
					with: 0.114883 , -0.0390543 , 0.479972
					with: 0.0737514 , -0.311981 , 0.39728);
		add: (Triangle3D 
					with: 0.114883 , -0.0390543 , 0.479972
					with: 0.121738 , 0.233889 , 0.387919
					with: -0.13108 , 0.104879 , 0.437498);
		add: (Triangle3D 
					with: 0.237672 , 0.220241 , -0.411087
					with: 0.374516 , 0.00107078 , -0.283585
					with: 0.181371 , -0.1829 , -0.392527);
		add: (Triangle3D 
					with: 0.237672 , 0.220241 , -0.411087
					with: 0.181371 , -0.1829 , -0.392527
					with: 0.0445269 , 0.0362705 , -0.520028);
		add: (Triangle3D 
					with: 0.0445269 , 0.0362705 , -0.520028
					with: 0.181371 , -0.1829 , -0.392527
					with: -0.0714476 , -0.31191 , -0.342947);
		add: (Triangle3D 
					with: 0.0445269 , 0.0362705 , -0.520028
					with: -0.0714476 , -0.31191 , -0.342947
					with: -0.208291 , -0.0927395 , -0.470449);
		add: (Triangle3D 
					with: -0.208291 , -0.0927395 , -0.470449
					with: -0.0714476 , -0.31191 , -0.342947
					with: -0.287371 , -0.336682 , -0.153785);
		add: (Triangle3D 
					with: -0.208291 , -0.0927395 , -0.470449
					with: -0.287371 , -0.336682 , -0.153785
					with: -0.424215 , -0.117511 , -0.281287);
		add: (Triangle3D 
					with: -0.424215 , -0.117511 , -0.281287
					with: -0.287371 , -0.336682 , -0.153785
					with: -0.383923 , -0.247753 , 0.102707);
		add: (Triangle3D 
					with: -0.424215 , -0.117511 , -0.281287
					with: -0.383923 , -0.247753 , 0.102707
					with: -0.520767 , -0.0285823 , -0.0247956);
		add: (Triangle3D 
					with: -0.520767 , -0.0285823 , -0.0247956
					with: -0.383923 , -0.247753 , 0.102707
					with: -0.324226 , -0.0790916 , 0.328557);
		add: (Triangle3D 
					with: -0.520767 , -0.0285823 , -0.0247956
					with: -0.324226 , -0.0790916 , 0.328557
					with: -0.461069 , 0.140079 , 0.201055);
		add: (Triangle3D 
					with: -0.461069 , 0.140079 , 0.201055
					with: -0.324226 , -0.0790916 , 0.328557
					with: -0.13108 , 0.104879 , 0.437498);
		add: (Triangle3D 
					with: -0.461069 , 0.140079 , 0.201055
					with: -0.13108 , 0.104879 , 0.437498
					with: -0.267924 , 0.32405 , 0.309996);
		add: (Triangle3D 
					with: -0.267924 , 0.32405 , 0.309996
					with: -0.13108 , 0.104879 , 0.437498
					with: 0.121738 , 0.233889 , 0.387919);
		add: (Triangle3D 
					with: -0.267924 , 0.32405 , 0.309996
					with: 0.121738 , 0.233889 , 0.387919
					with: -0.0151056 , 0.45306 , 0.260417);
		add: (Triangle3D 
					with: -0.0151056 , 0.45306 , 0.260417
					with: 0.121738 , 0.233889 , 0.387919
					with: 0.337661 , 0.258661 , 0.198757);
		add: (Triangle3D 
					with: -0.0151056 , 0.45306 , 0.260417
					with: 0.337661 , 0.258661 , 0.198757
					with: 0.200818 , 0.477832 , 0.071255);
		add: (Triangle3D 
					with: 0.200818 , 0.477832 , 0.071255
					with: 0.337661 , 0.258661 , 0.198757
					with: 0.434214 , 0.169732 , -0.0577348);
		add: (Triangle3D 
					with: 0.200818 , 0.477832 , 0.071255
					with: 0.434214 , 0.169732 , -0.0577348
					with: 0.29737 , 0.388903 , -0.185237);
		add: (Triangle3D 
					with: 0.29737 , 0.388903 , -0.185237
					with: 0.434214 , 0.169732 , -0.0577348
					with: 0.374516 , 0.00107078 , -0.283585);
		add: (Triangle3D 
					with: 0.29737 , 0.388903 , -0.185237
					with: 0.374516 , 0.00107078 , -0.283585
					with: 0.237672 , 0.220241 , -0.411087);
		yourself! !

!Polyhedron class methodsFor: 'factory-pentagonal' stamp: 'emm 02/09/2012 23:40'!
elongatedPentagonalPyramid
	"self elongatedPentagonalPyramid"

	^(Triangle3DComposite new)
		add: (Triangle3D 
					with: 0.31471 , -0.391889 , 0.285285
					with: -0.168647 , -0.22686 , 0.506251
					with: -0.542294 , -0.191209 , 0.0953851);
		add: (Triangle3D 
					with: 0.31471 , -0.391889 , 0.285285
					with: -0.542294 , -0.191209 , 0.0953851
					with: -0.289864 , -0.334205 , -0.379511);
		add: (Triangle3D 
					with: 0.31471 , -0.391889 , 0.285285
					with: -0.289864 , -0.334205 , -0.379511
					with: 0.239794 , -0.458232 , -0.262146);
		add: (Triangle3D 
					with: -0.399299 , 0.340015 , 0.0114374
					with: -0.542294 , -0.191209 , 0.0953851
					with: -0.168647 , -0.22686 , 0.506251);
		add: (Triangle3D 
					with: -0.399299 , 0.340015 , 0.0114374
					with: -0.168647 , -0.22686 , 0.506251
					with: -0.0256512 , 0.304365 , 0.422304);
		add: (Triangle3D 
					with: 0.128913 , 0.490027 , -0.0790285
					with: -0.399299 , 0.340015 , 0.0114374
					with: -0.0256512 , 0.304365 , 0.422304);
		add: (Triangle3D 
					with: -0.0256512 , 0.304365 , 0.422304
					with: -0.168647 , -0.22686 , 0.506251
					with: 0.31471 , -0.391889 , 0.285285);
		add: (Triangle3D 
					with: -0.0256512 , 0.304365 , 0.422304
					with: 0.31471 , -0.391889 , 0.285285
					with: 0.457706 , 0.139335 , 0.201338);
		add: (Triangle3D 
					with: 0.128913 , 0.490027 , -0.0790285
					with: -0.0256512 , 0.304365 , 0.422304
					with: 0.457706 , 0.139335 , 0.201338);
		add: (Triangle3D 
					with: 0.457706 , 0.139335 , 0.201338
					with: 0.31471 , -0.391889 , 0.285285
					with: 0.239794 , -0.458232 , -0.262146);
		add: (Triangle3D 
					with: 0.457706 , 0.139335 , 0.201338
					with: 0.239794 , -0.458232 , -0.262146
					with: 0.382789 , 0.0729927 , -0.346093);
		add: (Triangle3D 
					with: 0.128913 , 0.490027 , -0.0790285
					with: 0.457706 , 0.139335 , 0.201338
					with: 0.382789 , 0.0729927 , -0.346093);
		add: (Triangle3D 
					with: 0.382789 , 0.0729927 , -0.346093
					with: 0.239794 , -0.458232 , -0.262146
					with: -0.289864 , -0.334205 , -0.379511);
		add: (Triangle3D 
					with: 0.382789 , 0.0729927 , -0.346093
					with: -0.289864 , -0.334205 , -0.379511
					with: -0.146869 , 0.19702 , -0.463458);
		add: (Triangle3D 
					with: 0.128913 , 0.490027 , -0.0790285
					with: 0.382789 , 0.0729927 , -0.346093
					with: -0.146869 , 0.19702 , -0.463458);
		add: (Triangle3D 
					with: -0.146869 , 0.19702 , -0.463458
					with: -0.289864 , -0.334205 , -0.379511
					with: -0.542294 , -0.191209 , 0.0953851);
		add: (Triangle3D 
					with: -0.146869 , 0.19702 , -0.463458
					with: -0.542294 , -0.191209 , 0.0953851
					with: -0.399299 , 0.340015 , 0.0114374);
		add: (Triangle3D 
					with: 0.128913 , 0.490027 , -0.0790285
					with: -0.146869 , 0.19702 , -0.463458
					with: -0.399299 , 0.340015 , 0.0114374);
		yourself! !

!Polyhedron class methodsFor: 'factory-square' stamp: 'emm 02/09/2012 23:40'!
elongatedSquareGyrobicupola
	"self elongatedSquareGyrobicupola"

	^(Triangle3DComposite new)
		add: (Triangle3D 
					with: -0.00593298 , 0.130501 , -0.5
					with: 0.246996 , 0.326476 , -0.315392
					with: 0.445375 , 0.0195732 , -0.261388);
		add: (Triangle3D 
					with: -0.00593298 , 0.130501 , -0.5
					with: 0.445375 , 0.0195732 , -0.261388
					with: 0.192445 , -0.176402 , -0.445997);
		add: (Triangle3D 
					with: 0.246996 , 0.326476 , -0.315392
					with: -0.00593298 , 0.130501 , -0.5
					with: -0.274917 , 0.303558 , -0.315181);
		add: (Triangle3D 
					with: 0.246996 , 0.326476 , -0.315392
					with: -0.274917 , 0.303558 , -0.315181
					with: -0.021988 , 0.499533 , -0.130573);
		add: (Triangle3D 
					with: 0.246996 , 0.326476 , -0.315392
					with: -0.021988 , 0.499533 , -0.130573
					with: 0.297135 , 0.421095 , 0.038151);
		add: (Triangle3D 
					with: 0.445375 , 0.0195732 , -0.261388
					with: 0.246996 , 0.326476 , -0.315392
					with: 0.297135 , 0.421095 , 0.038151);
		add: (Triangle3D 
					with: 0.445375 , 0.0195732 , -0.261388
					with: 0.297135 , 0.421095 , 0.038151
					with: 0.495513 , 0.114193 , 0.0921544);
		add: (Triangle3D 
					with: 0.445375 , 0.0195732 , -0.261388
					with: 0.495513 , 0.114193 , 0.0921544
					with: 0.45694 , -0.241395 , -0.000196601);
		add: (Triangle3D 
					with: 0.192445 , -0.176402 , -0.445997
					with: 0.445375 , 0.0195732 , -0.261388
					with: 0.45694 , -0.241395 , -0.000196601);
		add: (Triangle3D 
					with: 0.192445 , -0.176402 , -0.445997
					with: 0.45694 , -0.241395 , -0.000196601
					with: 0.204011 , -0.43737 , -0.184805);
		add: (Triangle3D 
					with: 0.192445 , -0.176402 , -0.445997
					with: 0.204011 , -0.43737 , -0.184805
					with: -0.115112 , -0.358933 , -0.353529);
		add: (Triangle3D 
					with: -0.00593298 , 0.130501 , -0.5
					with: 0.192445 , -0.176402 , -0.445997
					with: -0.115112 , -0.358933 , -0.353529);
		add: (Triangle3D 
					with: -0.00593298 , 0.130501 , -0.5
					with: -0.115112 , -0.358933 , -0.353529
					with: -0.31349 , -0.0520303 , -0.407532);
		add: (Triangle3D 
					with: -0.00593298 , 0.130501 , -0.5
					with: -0.31349 , -0.0520303 , -0.407532
					with: -0.274917 , 0.303558 , -0.315181);
		add: (Triangle3D 
					with: -0.192445 , 0.176402 , 0.445996
					with: -0.445375 , -0.0195733 , 0.261388
					with: -0.246996 , -0.326476 , 0.315392);
		add: (Triangle3D 
					with: -0.192445 , 0.176402 , 0.445996
					with: -0.246996 , -0.326476 , 0.315392
					with: 0.00593298 , -0.130501 , 0.5);
		add: (Triangle3D 
					with: -0.445375 , -0.0195733 , 0.261388
					with: -0.192445 , 0.176402 , 0.445996
					with: -0.204011 , 0.43737 , 0.184805);
		add: (Triangle3D 
					with: -0.445375 , -0.0195733 , 0.261388
					with: -0.204011 , 0.43737 , 0.184805
					with: -0.45694 , 0.241395 , 0.000196556);
		add: (Triangle3D 
					with: -0.445375 , -0.0195733 , 0.261388
					with: -0.45694 , 0.241395 , 0.000196556
					with: -0.495513 , -0.114193 , -0.0921545);
		add: (Triangle3D 
					with: -0.246996 , -0.326476 , 0.315392
					with: -0.445375 , -0.0195733 , 0.261388
					with: -0.495513 , -0.114193 , -0.0921545);
		add: (Triangle3D 
					with: -0.246996 , -0.326476 , 0.315392
					with: -0.495513 , -0.114193 , -0.0921545
					with: -0.297135 , -0.421095 , -0.0381507);
		add: (Triangle3D 
					with: -0.246996 , -0.326476 , 0.315392
					with: -0.297135 , -0.421095 , -0.0381507
					with: 0.021988 , -0.499533 , 0.130573);
		add: (Triangle3D 
					with: 0.00593298 , -0.130501 , 0.5
					with: -0.246996 , -0.326476 , 0.315392
					with: 0.021988 , -0.499533 , 0.130573);
		add: (Triangle3D 
					with: 0.00593298 , -0.130501 , 0.5
					with: 0.021988 , -0.499533 , 0.130573
					with: 0.274917 , -0.303558 , 0.315181);
		add: (Triangle3D 
					with: 0.00593298 , -0.130501 , 0.5
					with: 0.274917 , -0.303558 , 0.315181
					with: 0.31349 , 0.0520303 , 0.407532);
		add: (Triangle3D 
					with: -0.192445 , 0.176402 , 0.445996
					with: 0.00593298 , -0.130501 , 0.5
					with: 0.31349 , 0.0520303 , 0.407532);
		add: (Triangle3D 
					with: -0.192445 , 0.176402 , 0.445996
					with: 0.31349 , 0.0520303 , 0.407532
					with: 0.115112 , 0.358933 , 0.353528);
		add: (Triangle3D 
					with: -0.192445 , 0.176402 , 0.445996
					with: 0.115112 , 0.358933 , 0.353528
					with: -0.204011 , 0.43737 , 0.184805);
		add: (Triangle3D 
					with: 0.204011 , -0.43737 , -0.184805
					with: 0.021988 , -0.499533 , 0.130573
					with: -0.297135 , -0.421095 , -0.0381507);
		add: (Triangle3D 
					with: 0.204011 , -0.43737 , -0.184805
					with: -0.297135 , -0.421095 , -0.0381507
					with: -0.115112 , -0.358933 , -0.353529);
		add: (Triangle3D 
					with: -0.115112 , -0.358933 , -0.353529
					with: -0.297135 , -0.421095 , -0.0381507
					with: -0.495513 , -0.114193 , -0.0921545);
		add: (Triangle3D 
					with: -0.115112 , -0.358933 , -0.353529
					with: -0.495513 , -0.114193 , -0.0921545
					with: -0.31349 , -0.0520303 , -0.407532);
		add: (Triangle3D 
					with: -0.31349 , -0.0520303 , -0.407532
					with: -0.495513 , -0.114193 , -0.0921545
					with: -0.45694 , 0.241395 , 0.000196556);
		add: (Triangle3D 
					with: -0.31349 , -0.0520303 , -0.407532
					with: -0.45694 , 0.241395 , 0.000196556
					with: -0.274917 , 0.303558 , -0.315181);
		add: (Triangle3D 
					with: -0.274917 , 0.303558 , -0.315181
					with: -0.45694 , 0.241395 , 0.000196556
					with: -0.204011 , 0.43737 , 0.184805);
		add: (Triangle3D 
					with: -0.274917 , 0.303558 , -0.315181
					with: -0.204011 , 0.43737 , 0.184805
					with: -0.021988 , 0.499533 , -0.130573);
		add: (Triangle3D 
					with: -0.021988 , 0.499533 , -0.130573
					with: -0.204011 , 0.43737 , 0.184805
					with: 0.115112 , 0.358933 , 0.353528);
		add: (Triangle3D 
					with: -0.021988 , 0.499533 , -0.130573
					with: 0.115112 , 0.358933 , 0.353528
					with: 0.297135 , 0.421095 , 0.038151);
		add: (Triangle3D 
					with: 0.297135 , 0.421095 , 0.038151
					with: 0.115112 , 0.358933 , 0.353528
					with: 0.31349 , 0.0520303 , 0.407532);
		add: (Triangle3D 
					with: 0.297135 , 0.421095 , 0.038151
					with: 0.31349 , 0.0520303 , 0.407532
					with: 0.495513 , 0.114193 , 0.0921544);
		add: (Triangle3D 
					with: 0.495513 , 0.114193 , 0.0921544
					with: 0.31349 , 0.0520303 , 0.407532
					with: 0.274917 , -0.303558 , 0.315181);
		add: (Triangle3D 
					with: 0.495513 , 0.114193 , 0.0921544
					with: 0.274917 , -0.303558 , 0.315181
					with: 0.45694 , -0.241395 , -0.000196601);
		add: (Triangle3D 
					with: 0.45694 , -0.241395 , -0.000196601
					with: 0.274917 , -0.303558 , 0.315181
					with: 0.021988 , -0.499533 , 0.130573);
		add: (Triangle3D 
					with: 0.45694 , -0.241395 , -0.000196601
					with: 0.021988 , -0.499533 , 0.130573
					with: 0.204011 , -0.43737 , -0.184805);
		yourself! !

!Polyhedron class methodsFor: 'factory-square' stamp: 'emm 02/09/2012 23:40'!
elongatedSquarePyramid
	"self elongatedSquarePyramid"

	^(Triangle3DComposite new)
		add: (Triangle3D 
					with: -0.432908 , 0.313919 , 0.0433699
					with: -0.245236 , 0.13698 , -0.45709
					with: -0.245236 , -0.393839 , -0.269418);
		add: (Triangle3D 
					with: -0.432908 , 0.313919 , 0.0433699
					with: -0.245236 , -0.393839 , -0.269418
					with: -0.432908 , -0.2169 , 0.231043);
		add: (Triangle3D 
					with: 0.285583 , 0.199537 , -0.280151
					with: -0.245236 , 0.13698 , -0.45709
					with: -0.432908 , 0.313919 , 0.0433699);
		add: (Triangle3D 
					with: 0.285583 , 0.199537 , -0.280151
					with: -0.432908 , 0.313919 , 0.0433699
					with: 0.0979101 , 0.376476 , 0.220309);
		add: (Triangle3D 
					with: 0.567092 , 0.0668324 , 0.189031
					with: 0.285583 , 0.199537 , -0.280151
					with: 0.0979101 , 0.376476 , 0.220309);
		add: (Triangle3D 
					with: 0.0979101 , 0.376476 , 0.220309
					with: -0.432908 , 0.313919 , 0.0433699
					with: -0.432908 , -0.2169 , 0.231043);
		add: (Triangle3D 
					with: 0.0979101 , 0.376476 , 0.220309
					with: -0.432908 , -0.2169 , 0.231043
					with: 0.0979101 , -0.154342 , 0.407982);
		add: (Triangle3D 
					with: 0.567092 , 0.0668324 , 0.189031
					with: 0.0979101 , 0.376476 , 0.220309
					with: 0.0979101 , -0.154342 , 0.407982);
		add: (Triangle3D 
					with: 0.0979101 , -0.154342 , 0.407982
					with: -0.432908 , -0.2169 , 0.231043
					with: -0.245236 , -0.393839 , -0.269418);
		add: (Triangle3D 
					with: 0.0979101 , -0.154342 , 0.407982
					with: -0.245236 , -0.393839 , -0.269418
					with: 0.285583 , -0.331281 , -0.0924784);
		add: (Triangle3D 
					with: 0.567092 , 0.0668324 , 0.189031
					with: 0.0979101 , -0.154342 , 0.407982
					with: 0.285583 , -0.331281 , -0.0924784);
		add: (Triangle3D 
					with: 0.285583 , -0.331281 , -0.0924784
					with: -0.245236 , -0.393839 , -0.269418
					with: -0.245236 , 0.13698 , -0.45709);
		add: (Triangle3D 
					with: 0.285583 , -0.331281 , -0.0924784
					with: -0.245236 , 0.13698 , -0.45709
					with: 0.285583 , 0.199537 , -0.280151);
		add: (Triangle3D 
					with: 0.567092 , 0.0668324 , 0.189031
					with: 0.285583 , -0.331281 , -0.0924784
					with: 0.285583 , 0.199537 , -0.280151);
		yourself! !

!Polyhedron class methodsFor: 'factory-triangular' stamp: 'emm 02/09/2012 23:40'!
elongatedTriangularGyrobicupola
	"self elongatedTriangularGyrobicupola"

	^(Triangle3DComposite new)
		add: (Triangle3D 
					with: -0.259872 , 0.0907844 , -0.446473
					with: 0.0882373 , 0.195222 , -0.478765
					with: 0.00116048 , -0.158469 , -0.5);
		add: (Triangle3D 
					with: 0.0882373 , 0.195222 , -0.478765
					with: -0.259872 , 0.0907844 , -0.446473
					with: -0.282615 , 0.265399 , -0.126906);
		add: (Triangle3D 
					with: 0.0882373 , 0.195222 , -0.478765
					with: -0.282615 , 0.265399 , -0.126906
					with: 0.0654949 , 0.369837 , -0.159199);
		add: (Triangle3D 
					with: 0.0882373 , 0.195222 , -0.478765
					with: 0.0654949 , 0.369837 , -0.159199
					with: 0.326528 , 0.120584 , -0.212725);
		add: (Triangle3D 
					with: 0.00116048 , -0.158469 , -0.5
					with: 0.0882373 , 0.195222 , -0.478765
					with: 0.326528 , 0.120584 , -0.212725);
		add: (Triangle3D 
					with: 0.00116048 , -0.158469 , -0.5
					with: 0.326528 , 0.120584 , -0.212725
					with: 0.239451 , -0.233107 , -0.23396);
		add: (Triangle3D 
					with: 0.00116048 , -0.158469 , -0.5
					with: 0.239451 , -0.233107 , -0.23396
					with: -0.108659 , -0.337545 , -0.201668);
		add: (Triangle3D 
					with: -0.259872 , 0.0907844 , -0.446473
					with: 0.00116048 , -0.158469 , -0.5
					with: -0.108659 , -0.337545 , -0.201668);
		add: (Triangle3D 
					with: -0.259872 , 0.0907844 , -0.446473
					with: -0.108659 , -0.337545 , -0.201668
					with: -0.369692 , -0.0882916 , -0.148141);
		add: (Triangle3D 
					with: -0.259872 , 0.0907844 , -0.446473
					with: -0.369692 , -0.0882916 , -0.148141
					with: -0.282615 , 0.265399 , -0.126906);
		add: (Triangle3D 
					with: 0.259873 , -0.0907844 , 0.446473
					with: -0.0011605 , 0.158469 , 0.5
					with: -0.0882373 , -0.195222 , 0.478765);
		add: (Triangle3D 
					with: -0.0011605 , 0.158469 , 0.5
					with: 0.259873 , -0.0907844 , 0.446473
					with: 0.369692 , 0.0882916 , 0.148141);
		add: (Triangle3D 
					with: -0.0011605 , 0.158469 , 0.5
					with: 0.369692 , 0.0882916 , 0.148141
					with: 0.108659 , 0.337545 , 0.201668);
		add: (Triangle3D 
					with: -0.0011605 , 0.158469 , 0.5
					with: 0.108659 , 0.337545 , 0.201668
					with: -0.239451 , 0.233107 , 0.23396);
		add: (Triangle3D 
					with: -0.0882373 , -0.195222 , 0.478765
					with: -0.0011605 , 0.158469 , 0.5
					with: -0.239451 , 0.233107 , 0.23396);
		add: (Triangle3D 
					with: -0.0882373 , -0.195222 , 0.478765
					with: -0.239451 , 0.233107 , 0.23396
					with: -0.326528 , -0.120584 , 0.212725);
		add: (Triangle3D 
					with: -0.0882373 , -0.195222 , 0.478765
					with: -0.326528 , -0.120584 , 0.212725
					with: -0.0654949 , -0.369837 , 0.159198);
		add: (Triangle3D 
					with: 0.259873 , -0.0907844 , 0.446473
					with: -0.0882373 , -0.195222 , 0.478765
					with: -0.0654949 , -0.369837 , 0.159198);
		add: (Triangle3D 
					with: 0.259873 , -0.0907844 , 0.446473
					with: -0.0654949 , -0.369837 , 0.159198
					with: 0.282615 , -0.265399 , 0.126906);
		add: (Triangle3D 
					with: 0.259873 , -0.0907844 , 0.446473
					with: 0.282615 , -0.265399 , 0.126906
					with: 0.369692 , 0.0882916 , 0.148141);
		add: (Triangle3D 
					with: -0.108659 , -0.337545 , -0.201668
					with: -0.0654949 , -0.369837 , 0.159198
					with: -0.326528 , -0.120584 , 0.212725);
		add: (Triangle3D 
					with: -0.108659 , -0.337545 , -0.201668
					with: -0.326528 , -0.120584 , 0.212725
					with: -0.369692 , -0.0882916 , -0.148141);
		add: (Triangle3D 
					with: -0.369692 , -0.0882916 , -0.148141
					with: -0.326528 , -0.120584 , 0.212725
					with: -0.239451 , 0.233107 , 0.23396);
		add: (Triangle3D 
					with: -0.369692 , -0.0882916 , -0.148141
					with: -0.239451 , 0.233107 , 0.23396
					with: -0.282615 , 0.265399 , -0.126906);
		add: (Triangle3D 
					with: -0.282615 , 0.265399 , -0.126906
					with: -0.239451 , 0.233107 , 0.23396
					with: 0.108659 , 0.337545 , 0.201668);
		add: (Triangle3D 
					with: -0.282615 , 0.265399 , -0.126906
					with: 0.108659 , 0.337545 , 0.201668
					with: 0.0654949 , 0.369837 , -0.159199);
		add: (Triangle3D 
					with: 0.0654949 , 0.369837 , -0.159199
					with: 0.108659 , 0.337545 , 0.201668
					with: 0.369692 , 0.0882916 , 0.148141);
		add: (Triangle3D 
					with: 0.0654949 , 0.369837 , -0.159199
					with: 0.369692 , 0.0882916 , 0.148141
					with: 0.326528 , 0.120584 , -0.212725);
		add: (Triangle3D 
					with: 0.326528 , 0.120584 , -0.212725
					with: 0.369692 , 0.0882916 , 0.148141
					with: 0.282615 , -0.265399 , 0.126906);
		add: (Triangle3D 
					with: 0.326528 , 0.120584 , -0.212725
					with: 0.282615 , -0.265399 , 0.126906
					with: 0.239451 , -0.233107 , -0.23396);
		add: (Triangle3D 
					with: 0.239451 , -0.233107 , -0.23396
					with: 0.282615 , -0.265399 , 0.126906
					with: -0.0654949 , -0.369837 , 0.159198);
		add: (Triangle3D 
					with: 0.239451 , -0.233107 , -0.23396
					with: -0.0654949 , -0.369837 , 0.159198
					with: -0.108659 , -0.337545 , -0.201668);
		yourself! !

!Polyhedron class methodsFor: 'factory-triangular' stamp: 'emm 02/09/2012 23:40'!
elongatedTriangularOrthobicupola
	"self elongatedTriangularOrthobicupola"

	^(Triangle3DComposite new)
		add: (Triangle3D 
					with: 0.0292381 , 0.0337624 , -0.514631
					with: 0.354004 , 0.0793191 , -0.367736
					with: 0.214862 , -0.25067 , -0.39729);
		add: (Triangle3D 
					with: 0.354004 , 0.0793191 , -0.367736
					with: 0.0292381 , 0.0337624 , -0.514631
					with: -0.109904 , 0.267014 , -0.279344);
		add: (Triangle3D 
					with: 0.354004 , 0.0793191 , -0.367736
					with: -0.109904 , 0.267014 , -0.279344
					with: 0.214862 , 0.31257 , -0.132448);
		add: (Triangle3D 
					with: 0.354004 , 0.0793191 , -0.367736
					with: 0.214862 , 0.31257 , -0.132448
					with: 0.400485 , 0.0281381 , -0.0151072);
		add: (Triangle3D 
					with: 0.214862 , -0.25067 , -0.39729
					with: 0.354004 , 0.0793191 , -0.367736
					with: 0.400485 , 0.0281381 , -0.0151072);
		add: (Triangle3D 
					with: 0.214862 , -0.25067 , -0.39729
					with: 0.400485 , 0.0281381 , -0.0151072
					with: 0.261343 , -0.301851 , -0.0446612);
		add: (Triangle3D 
					with: 0.214862 , -0.25067 , -0.39729
					with: 0.261343 , -0.301851 , -0.0446612
					with: -0.0634236 , -0.347407 , -0.191557);
		add: (Triangle3D 
					with: 0.0292381 , 0.0337624 , -0.514631
					with: 0.214862 , -0.25067 , -0.39729
					with: -0.0634236 , -0.347407 , -0.191557);
		add: (Triangle3D 
					with: 0.0292381 , 0.0337624 , -0.514631
					with: -0.0634236 , -0.347407 , -0.191557
					with: -0.249047 , -0.0629751 , -0.308898);
		add: (Triangle3D 
					with: 0.0292381 , 0.0337624 , -0.514631
					with: -0.249047 , -0.0629751 , -0.308898
					with: -0.109904 , 0.267014 , -0.279344);
		add: (Triangle3D 
					with: -0.0447318 , 0.171045 , 0.485369
					with: -0.369498 , 0.125488 , 0.338473
					with: -0.183874 , -0.158944 , 0.455815);
		add: (Triangle3D 
					with: -0.369498 , 0.125488 , 0.338473
					with: -0.0447318 , 0.171045 , 0.485369
					with: 0.0634235 , 0.347407 , 0.191557);
		add: (Triangle3D 
					with: -0.369498 , 0.125488 , 0.338473
					with: 0.0634235 , 0.347407 , 0.191557
					with: -0.261343 , 0.301851 , 0.0446613);
		add: (Triangle3D 
					with: -0.369498 , 0.125488 , 0.338473
					with: -0.261343 , 0.301851 , 0.0446613
					with: -0.400485 , -0.0281382 , 0.0151072);
		add: (Triangle3D 
					with: -0.183874 , -0.158944 , 0.455815
					with: -0.369498 , 0.125488 , 0.338473
					with: -0.400485 , -0.0281382 , 0.0151072);
		add: (Triangle3D 
					with: -0.183874 , -0.158944 , 0.455815
					with: -0.400485 , -0.0281382 , 0.0151072
					with: -0.214862 , -0.31257 , 0.132449);
		add: (Triangle3D 
					with: -0.183874 , -0.158944 , 0.455815
					with: -0.214862 , -0.31257 , 0.132449
					with: 0.109904 , -0.267014 , 0.279344);
		add: (Triangle3D 
					with: -0.0447318 , 0.171045 , 0.485369
					with: -0.183874 , -0.158944 , 0.455815
					with: 0.109904 , -0.267014 , 0.279344);
		add: (Triangle3D 
					with: -0.0447318 , 0.171045 , 0.485369
					with: 0.109904 , -0.267014 , 0.279344
					with: 0.249047 , 0.0629751 , 0.308898);
		add: (Triangle3D 
					with: -0.0447318 , 0.171045 , 0.485369
					with: 0.249047 , 0.0629751 , 0.308898
					with: 0.0634235 , 0.347407 , 0.191557);
		add: (Triangle3D 
					with: -0.0634236 , -0.347407 , -0.191557
					with: -0.214862 , -0.31257 , 0.132449
					with: -0.400485 , -0.0281382 , 0.0151072);
		add: (Triangle3D 
					with: -0.0634236 , -0.347407 , -0.191557
					with: -0.400485 , -0.0281382 , 0.0151072
					with: -0.249047 , -0.0629751 , -0.308898);
		add: (Triangle3D 
					with: -0.249047 , -0.0629751 , -0.308898
					with: -0.400485 , -0.0281382 , 0.0151072
					with: -0.261343 , 0.301851 , 0.0446613);
		add: (Triangle3D 
					with: -0.249047 , -0.0629751 , -0.308898
					with: -0.261343 , 0.301851 , 0.0446613
					with: -0.109904 , 0.267014 , -0.279344);
		add: (Triangle3D 
					with: -0.109904 , 0.267014 , -0.279344
					with: -0.261343 , 0.301851 , 0.0446613
					with: 0.0634235 , 0.347407 , 0.191557);
		add: (Triangle3D 
					with: -0.109904 , 0.267014 , -0.279344
					with: 0.0634235 , 0.347407 , 0.191557
					with: 0.214862 , 0.31257 , -0.132448);
		add: (Triangle3D 
					with: 0.214862 , 0.31257 , -0.132448
					with: 0.0634235 , 0.347407 , 0.191557
					with: 0.249047 , 0.0629751 , 0.308898);
		add: (Triangle3D 
					with: 0.214862 , 0.31257 , -0.132448
					with: 0.249047 , 0.0629751 , 0.308898
					with: 0.400485 , 0.0281381 , -0.0151072);
		add: (Triangle3D 
					with: 0.400485 , 0.0281381 , -0.0151072
					with: 0.249047 , 0.0629751 , 0.308898
					with: 0.109904 , -0.267014 , 0.279344);
		add: (Triangle3D 
					with: 0.400485 , 0.0281381 , -0.0151072
					with: 0.109904 , -0.267014 , 0.279344
					with: 0.261343 , -0.301851 , -0.0446612);
		add: (Triangle3D 
					with: 0.261343 , -0.301851 , -0.0446612
					with: 0.109904 , -0.267014 , 0.279344
					with: -0.214862 , -0.31257 , 0.132449);
		add: (Triangle3D 
					with: 0.261343 , -0.301851 , -0.0446612
					with: -0.214862 , -0.31257 , 0.132449
					with: -0.0634236 , -0.347407 , -0.191557);
		yourself! !

!Polyhedron class methodsFor: 'factory-triangular' stamp: 'emm 02/09/2012 23:40'!
elongatedTriangularPyramid
	"self elongatedTriangularPyramid"

	^(Triangle3DComposite new)
		add: (Triangle3D 
					with: -0.374584 , -0.332237 , 0.00956849
					with: -0.118328 , -0.161678 , -0.45896
					with: 0.161973 , -0.466832 , -0.0813515);
		add: (Triangle3D 
					with: 0.043504 , 0.308136 , -0.199421
					with: -0.118328 , -0.161678 , -0.45896
					with: -0.374584 , -0.332237 , 0.00956849);
		add: (Triangle3D 
					with: 0.043504 , 0.308136 , -0.199421
					with: -0.374584 , -0.332237 , 0.00956849
					with: -0.212752 , 0.137578 , 0.269107);
		add: (Triangle3D 
					with: 0.183655 , 0.533168 , 0.294536
					with: 0.043504 , 0.308136 , -0.199421
					with: -0.212752 , 0.137578 , 0.269107);
		add: (Triangle3D 
					with: -0.212752 , 0.137578 , 0.269107
					with: -0.374584 , -0.332237 , 0.00956849
					with: 0.161973 , -0.466832 , -0.0813515);
		add: (Triangle3D 
					with: -0.212752 , 0.137578 , 0.269107
					with: 0.161973 , -0.466832 , -0.0813515
					with: 0.323805 , 0.00298263 , 0.178187);
		add: (Triangle3D 
					with: 0.183655 , 0.533168 , 0.294536
					with: -0.212752 , 0.137578 , 0.269107
					with: 0.323805 , 0.00298263 , 0.178187);
		add: (Triangle3D 
					with: 0.323805 , 0.00298263 , 0.178187
					with: 0.161973 , -0.466832 , -0.0813515
					with: -0.118328 , -0.161678 , -0.45896);
		add: (Triangle3D 
					with: 0.323805 , 0.00298263 , 0.178187
					with: -0.118328 , -0.161678 , -0.45896
					with: 0.043504 , 0.308136 , -0.199421);
		add: (Triangle3D 
					with: 0.183655 , 0.533168 , 0.294536
					with: 0.323805 , 0.00298263 , 0.178187
					with: 0.043504 , 0.308136 , -0.199421);
		yourself! !

!Polyhedron class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:40'!
fromVertexCount: howMany

	howMany = 4
		ifTrue: [ ^self tetrahedron ].
	howMany = 10
		ifTrue: [ ^self dodecahedron ].
	^self halt! !

!Polyhedron class methodsFor: 'factory-dodecahedron' stamp: 'emm 02/09/2012 23:40'!
greatDodecahedron
	"self greatDodecahedron "

	^(Triangle3DComposite new)
		add: (Triangle3D 
					with: -0.338556 , 0.376598 , -0.145485
					with: 0.185988 , 0.492862 , -0.0103695
					with: 0.5 , 0.0599572 , -0.154974);
		add: (Triangle3D 
					with: -0.338556 , 0.376598 , -0.145485
					with: 0.5 , 0.0599572 , -0.154974
					with: 0.169526 , -0.323856 , -0.37946);
		add: (Triangle3D 
					with: -0.338556 , 0.376598 , -0.145485
					with: 0.169526 , -0.323856 , -0.37946
					with: -0.34873 , -0.128162 , -0.373596);
		add: (Triangle3D 
					with: 0.185988 , 0.492862 , -0.0103695
					with: -0.338556 , 0.376598 , -0.145485
					with: -0.5 , -0.0599572 , 0.154974);
		add: (Triangle3D 
					with: 0.185988 , 0.492862 , -0.0103695
					with: -0.5 , -0.0599572 , 0.154974
					with: -0.0752341 , -0.213499 , 0.475783);
		add: (Triangle3D 
					with: 0.185988 , 0.492862 , -0.0103695
					with: -0.0752341 , -0.213499 , 0.475783
					with: 0.34873 , 0.128162 , 0.373596);
		add: (Triangle3D 
					with: 0.5 , 0.0599572 , -0.154974
					with: 0.185988 , 0.492862 , -0.0103695
					with: -0.169526 , 0.323856 , 0.37946);
		add: (Triangle3D 
					with: 0.5 , 0.0599572 , -0.154974
					with: -0.169526 , 0.323856 , 0.37946
					with: -0.0752341 , -0.213499 , 0.475783);
		add: (Triangle3D 
					with: 0.5 , 0.0599572 , -0.154974
					with: -0.0752341 , -0.213499 , 0.475783
					with: 0.338556 , -0.376598 , 0.145485);
		add: (Triangle3D 
					with: 0.169526 , -0.323856 , -0.37946
					with: 0.5 , 0.0599572 , -0.154974
					with: 0.34873 , 0.128162 , 0.373596);
		add: (Triangle3D 
					with: 0.169526 , -0.323856 , -0.37946
					with: 0.34873 , 0.128162 , 0.373596
					with: -0.0752341 , -0.213499 , 0.475783);
		add: (Triangle3D 
					with: 0.169526 , -0.323856 , -0.37946
					with: -0.0752341 , -0.213499 , 0.475783
					with: -0.185988 , -0.492862 , 0.0103696);
		add: (Triangle3D 
					with: -0.34873 , -0.128162 , -0.373596
					with: 0.169526 , -0.323856 , -0.37946
					with: 0.338556 , -0.376598 , 0.145485);
		add: (Triangle3D 
					with: -0.34873 , -0.128162 , -0.373596
					with: 0.338556 , -0.376598 , 0.145485
					with: -0.0752341 , -0.213499 , 0.475783);
		add: (Triangle3D 
					with: -0.34873 , -0.128162 , -0.373596
					with: -0.0752341 , -0.213499 , 0.475783
					with: -0.5 , -0.0599572 , 0.154974);
		add: (Triangle3D 
					with: -0.338556 , 0.376598 , -0.145485
					with: -0.34873 , -0.128162 , -0.373596
					with: -0.185988 , -0.492862 , 0.0103696);
		add: (Triangle3D 
					with: -0.338556 , 0.376598 , -0.145485
					with: -0.185988 , -0.492862 , 0.0103696
					with: -0.0752341 , -0.213499 , 0.475783);
		add: (Triangle3D 
					with: -0.338556 , 0.376598 , -0.145485
					with: -0.0752341 , -0.213499 , 0.475783
					with: -0.169526 , 0.323856 , 0.37946);
		add: (Triangle3D 
					with: 0.338556 , -0.376598 , 0.145485
					with: 0.34873 , 0.128162 , 0.373596
					with: -0.169526 , 0.323856 , 0.37946);
		add: (Triangle3D 
					with: 0.338556 , -0.376598 , 0.145485
					with: -0.169526 , 0.323856 , 0.37946
					with: -0.5 , -0.0599572 , 0.154974);
		add: (Triangle3D 
					with: 0.338556 , -0.376598 , 0.145485
					with: -0.5 , -0.0599572 , 0.154974
					with: -0.185988 , -0.492862 , 0.0103696);
		add: (Triangle3D 
					with: 0.34873 , 0.128162 , 0.373596
					with: 0.338556 , -0.376598 , 0.145485
					with: 0.169526 , -0.323856 , -0.37946);
		add: (Triangle3D 
					with: 0.34873 , 0.128162 , 0.373596
					with: 0.169526 , -0.323856 , -0.37946
					with: 0.0752341 , 0.213499 , -0.475783);
		add: (Triangle3D 
					with: 0.34873 , 0.128162 , 0.373596
					with: 0.0752341 , 0.213499 , -0.475783
					with: 0.185988 , 0.492862 , -0.0103695);
		add: (Triangle3D 
					with: -0.169526 , 0.323856 , 0.37946
					with: 0.34873 , 0.128162 , 0.373596
					with: 0.5 , 0.0599572 , -0.154974);
		add: (Triangle3D 
					with: -0.169526 , 0.323856 , 0.37946
					with: 0.5 , 0.0599572 , -0.154974
					with: 0.0752341 , 0.213499 , -0.475783);
		add: (Triangle3D 
					with: -0.169526 , 0.323856 , 0.37946
					with: 0.0752341 , 0.213499 , -0.475783
					with: -0.338556 , 0.376598 , -0.145485);
		add: (Triangle3D 
					with: -0.5 , -0.0599572 , 0.154974
					with: -0.169526 , 0.323856 , 0.37946
					with: 0.185988 , 0.492862 , -0.0103695);
		add: (Triangle3D 
					with: -0.5 , -0.0599572 , 0.154974
					with: 0.185988 , 0.492862 , -0.0103695
					with: 0.0752341 , 0.213499 , -0.475783);
		add: (Triangle3D 
					with: -0.5 , -0.0599572 , 0.154974
					with: 0.0752341 , 0.213499 , -0.475783
					with: -0.34873 , -0.128162 , -0.373596);
		add: (Triangle3D 
					with: -0.185988 , -0.492862 , 0.0103696
					with: -0.5 , -0.0599572 , 0.154974
					with: -0.338556 , 0.376598 , -0.145485);
		add: (Triangle3D 
					with: -0.185988 , -0.492862 , 0.0103696
					with: -0.338556 , 0.376598 , -0.145485
					with: 0.0752341 , 0.213499 , -0.475783);
		add: (Triangle3D 
					with: -0.185988 , -0.492862 , 0.0103696
					with: 0.0752341 , 0.213499 , -0.475783
					with: 0.169526 , -0.323856 , -0.37946);
		add: (Triangle3D 
					with: 0.338556 , -0.376598 , 0.145485
					with: -0.185988 , -0.492862 , 0.0103696
					with: -0.34873 , -0.128162 , -0.373596);
		add: (Triangle3D 
					with: 0.338556 , -0.376598 , 0.145485
					with: -0.34873 , -0.128162 , -0.373596
					with: 0.0752341 , 0.213499 , -0.475783);
		add: (Triangle3D 
					with: 0.338556 , -0.376598 , 0.145485
					with: 0.0752341 , 0.213499 , -0.475783
					with: 0.5 , 0.0599572 , -0.154974);
		yourself! !

!Polyhedron class methodsFor: 'factory-dodecahedron' stamp: 'emm 02/09/2012 23:40'!
greatStellatedDodecahedron
	"self greatStellatedDodecahedron "

	^(Triangle3DComposite new)
		add: (Triangle3D 
					with: 0.254448 , -0.500634 , 0.0977546
					with: 0.161237 , 0.403207 , -0.237566
					with: 0.054514 , -0.157018 , 0.545259);
		add: (Triangle3D 
					with: 0.054514 , -0.157018 , 0.545259
					with: 0.320406 , -0.154396 , -0.386058
					with: -0.00309371 , 0.401587 , 0.33802);
		add: (Triangle3D 
					with: 0.254448 , -0.500634 , 0.0977546
					with: 0.054514 , -0.157018 , 0.545259
					with: -0.00309371 , 0.401587 , 0.33802);
		add: (Triangle3D 
					with: 0.161237 , 0.403207 , -0.237566
					with: 0.254448 , -0.500634 , 0.0977546
					with: -0.382344 , 0.206628 , -0.0820591);
		add: (Triangle3D 
					with: -0.382344 , 0.206628 , -0.0820591
					with: 0.554796 , -0.0339046 , -0.126435
					with: -0.324736 , -0.351976 , 0.12518);
		add: (Triangle3D 
					with: 0.161237 , 0.403207 , -0.237566
					with: -0.382344 , 0.206628 , -0.0820591
					with: -0.324736 , -0.351976 , 0.12518);
		add: (Triangle3D 
					with: 0.054514 , -0.157018 , 0.545259
					with: 0.161237 , 0.403207 , -0.237566
					with: -0.324736 , -0.351976 , 0.12518);
		add: (Triangle3D 
					with: -0.324736 , -0.351976 , 0.12518
					with: 0.354862 , 0.309712 , 0.321069
					with: -0.258778 , -0.00573803 , -0.358632);
		add: (Triangle3D 
					with: 0.054514 , -0.157018 , 0.545259
					with: -0.324736 , -0.351976 , 0.12518
					with: -0.258778 , -0.00573803 , -0.358632);
		add: (Triangle3D 
					with: 0.320406 , -0.154396 , -0.386058
					with: 0.054514 , -0.157018 , 0.545259
					with: -0.258778 , -0.00573803 , -0.358632);
		add: (Triangle3D 
					with: -0.258778 , -0.00573803 , -0.358632
					with: 0.514032 , -0.247892 , 0.172578
					with: -0.423109 , -0.00735848 , 0.216953);
		add: (Triangle3D 
					with: 0.320406 , -0.154396 , -0.386058
					with: -0.258778 , -0.00573803 , -0.358632
					with: -0.423109 , -0.00735848 , 0.216953);
		add: (Triangle3D 
					with: -0.00309371 , 0.401587 , 0.33802
					with: 0.320406 , -0.154396 , -0.386058
					with: -0.423109 , -0.00735848 , 0.216953);
		add: (Triangle3D 
					with: -0.423109 , -0.00735848 , 0.216953
					with: 0.456424 , 0.310713 , -0.0346621
					with: -0.223175 , -0.350975 , -0.230551);
		add: (Triangle3D 
					with: -0.00309371 , 0.401587 , 0.33802
					with: -0.423109 , -0.00735848 , 0.216953
					with: -0.223175 , -0.350975 , -0.230551);
		add: (Triangle3D 
					with: 0.254448 , -0.500634 , 0.0977546
					with: -0.00309371 , 0.401587 , 0.33802
					with: -0.223175 , -0.350975 , -0.230551);
		add: (Triangle3D 
					with: -0.223175 , -0.350975 , -0.230551
					with: 0.390466 , -0.035525 , 0.449151
					with: -0.382344 , 0.206628 , -0.0820591);
		add: (Triangle3D 
					with: 0.254448 , -0.500634 , 0.0977546
					with: -0.223175 , -0.350975 , -0.230551
					with: -0.382344 , 0.206628 , -0.0820591);
		add: (Triangle3D 
					with: 0.354862 , 0.309712 , 0.321069
					with: -0.324736 , -0.351976 , 0.12518
					with: 0.554796 , -0.0339046 , -0.126435);
		add: (Triangle3D 
					with: 0.554796 , -0.0339046 , -0.126435
					with: -0.188719 , 0.113133 , 0.476576
					with: 0.134781 , -0.44285 , -0.247501);
		add: (Triangle3D 
					with: 0.354862 , 0.309712 , 0.321069
					with: 0.554796 , -0.0339046 , -0.126435
					with: 0.134781 , -0.44285 , -0.247501);
		add: (Triangle3D 
					with: -0.324736 , -0.351976 , 0.12518
					with: 0.354862 , 0.309712 , 0.321069
					with: -0.258778 , -0.00573803 , -0.358632);
		add: (Triangle3D 
					with: -0.258778 , -0.00573803 , -0.358632
					with: 0.054514 , -0.157018 , 0.545259
					with: 0.161237 , 0.403207 , -0.237566);
		add: (Triangle3D 
					with: -0.324736 , -0.351976 , 0.12518
					with: -0.258778 , -0.00573803 , -0.358632
					with: 0.161237 , 0.403207 , -0.237566);
		add: (Triangle3D 
					with: 0.554796 , -0.0339046 , -0.126435
					with: -0.324736 , -0.351976 , 0.12518
					with: 0.161237 , 0.403207 , -0.237566);
		add: (Triangle3D 
					with: 0.161237 , 0.403207 , -0.237566
					with: 0.254448 , -0.500634 , 0.0977546
					with: -0.382344 , 0.206628 , -0.0820591);
		add: (Triangle3D 
					with: 0.554796 , -0.0339046 , -0.126435
					with: 0.161237 , 0.403207 , -0.237566
					with: -0.382344 , 0.206628 , -0.0820591);
		add: (Triangle3D 
					with: -0.188719 , 0.113133 , 0.476576
					with: 0.554796 , -0.0339046 , -0.126435
					with: -0.382344 , 0.206628 , -0.0820591);
		add: (Triangle3D 
					with: -0.382344 , 0.206628 , -0.0820591
					with: 0.390466 , -0.035525 , 0.449151
					with: 0.0771731 , 0.115754 , -0.454741);
		add: (Triangle3D 
					with: -0.188719 , 0.113133 , 0.476576
					with: -0.382344 , 0.206628 , -0.0820591
					with: 0.0771731 , 0.115754 , -0.454741);
		add: (Triangle3D 
					with: 0.134781 , -0.44285 , -0.247501
					with: -0.188719 , 0.113133 , 0.476576
					with: 0.0771731 , 0.115754 , -0.454741);
		add: (Triangle3D 
					with: 0.0771731 , 0.115754 , -0.454741
					with: -0.0295495 , -0.444471 , 0.328085
					with: -0.122761 , 0.459371 , -0.00723625);
		add: (Triangle3D 
					with: 0.134781 , -0.44285 , -0.247501
					with: 0.0771731 , 0.115754 , -0.454741
					with: -0.122761 , 0.459371 , -0.00723625);
		add: (Triangle3D 
					with: 0.354862 , 0.309712 , 0.321069
					with: 0.134781 , -0.44285 , -0.247501
					with: -0.122761 , 0.459371 , -0.00723625);
		add: (Triangle3D 
					with: -0.122761 , 0.459371 , -0.00723625
					with: 0.514032 , -0.247892 , 0.172578
					with: -0.258778 , -0.00573803 , -0.358632);
		add: (Triangle3D 
					with: 0.354862 , 0.309712 , 0.321069
					with: -0.122761 , 0.459371 , -0.00723625
					with: -0.258778 , -0.00573803 , -0.358632);
		yourself! !

!Polyhedron class methodsFor: 'factory-dodecahedron' stamp: 'emm 02/09/2012 23:40'!
gyrateRhombicosidodecahedron
	"self gyrateRhombicosidodecahedron"

	^(Triangle3DComposite new)
		addTriangleWith: 0.0849164 , 0.218819 , -0.441043
			with: 0.0680313 , 0.393089 , -0.301019
			with: 0.274822 , 0.351912 , -0.224834;
		addTriangleWith: 0.0849164 , 0.218819 , -0.441043
			with: 0.274822 , 0.351912 , -0.224834
			with: 0.291707 , 0.177642 , -0.364859;
		addTriangleWith: 0.291707 , 0.177642 , -0.364859
			with: 0.274822 , 0.351912 , -0.224834
			with: 0.424314 , 0.189779 , -0.184498;
		addTriangleWith: 0.274822 , 0.351912 , -0.224834
			with: 0.282594 , 0.412728 , -0.00918844
			with: 0.432087 , 0.250595 , 0.031148;
		addTriangleWith: 0.274822 , 0.351912 , -0.224834
			with: 0.432087 , 0.250595 , 0.031148
			with: 0.424314 , 0.189779 , -0.184498;
		addTriangleWith: 0.0680313 , 0.393089 , -0.301019
			with: -0.0520003 , 0.479355 , -0.132458
			with: 0.0806068 , 0.491492 , 0.0479034;
		addTriangleWith: 0.0680313 , 0.393089 , -0.301019
			with: 0.0806068 , 0.491492 , 0.0479034
			with: 0.282594 , 0.412728 , -0.00918844;
		addTriangleWith: 0.0680313 , 0.393089 , -0.301019
			with: 0.282594 , 0.412728 , -0.00918844
			with: 0.274822 , 0.351912 , -0.224834;
		addTriangleWith: 0.0806068 , 0.491492 , 0.0479034
			with: 0.214908 , 0.403443 , 0.20434
			with: 0.282594 , 0.412728 , -0.00918844;
		addTriangleWith: 0.282594 , 0.412728 , -0.00918844
			with: 0.214908 , 0.403443 , 0.20434
			with: 0.364401 , 0.24131 , 0.244677;
		addTriangleWith: 0.282594 , 0.412728 , -0.00918844
			with: 0.364401 , 0.24131 , 0.244677
			with: 0.432087 , 0.250595 , 0.031148;
		addTriangleWith: -0.096723 , 0.456802 , 0.180616
			with: 0.0375784 , 0.368752 , 0.337053
			with: 0.214908 , 0.403443 , 0.20434;
		addTriangleWith: -0.096723 , 0.456802 , 0.180616
			with: 0.214908 , 0.403443 , 0.20434
			with: 0.0806068 , 0.491492 , 0.0479034;
		addTriangleWith: -0.096723 , 0.456802 , 0.180616
			with: -0.181662 , 0.321908 , 0.338259
			with: 0.0375784 , 0.368752 , 0.337053;
		addTriangleWith: -0.181662 , 0.321908 , 0.338259
			with: -0.141765 , 0.138335 , 0.460617
			with: 0.0774748 , 0.18518 , 0.459411;
		addTriangleWith: -0.181662 , 0.321908 , 0.338259
			with: 0.0774748 , 0.18518 , 0.459411
			with: 0.0375784 , 0.368752 , 0.337053;
		addTriangleWith: 0.0375784 , 0.368752 , 0.337053
			with: 0.0774748 , 0.18518 , 0.459411
			with: 0.279462 , 0.106416 , 0.402319;
		addTriangleWith: 0.0375784 , 0.368752 , 0.337053
			with: 0.279462 , 0.106416 , 0.402319
			with: 0.364401 , 0.24131 , 0.244677;
		addTriangleWith: 0.0375784 , 0.368752 , 0.337053
			with: 0.364401 , 0.24131 , 0.244677
			with: 0.214908 , 0.403443 , 0.20434;
		addTriangleWith: -0.141765 , 0.138335 , 0.460617
			with: 0.00772699 , -0.0237981 , 0.500953
			with: 0.0774748 , 0.18518 , 0.459411;
		addTriangleWith: 0.0774748 , 0.18518 , 0.459411
			with: 0.00772699 , -0.0237981 , 0.500953
			with: 0.209714 , -0.102562 , 0.443861;
		addTriangleWith: 0.0774748 , 0.18518 , 0.459411
			with: 0.209714 , -0.102562 , 0.443861
			with: 0.279462 , 0.106416 , 0.402319;
		addTriangleWith: 0.291707 , 0.177642 , -0.364859
			with: 0.424314 , 0.189779 , -0.184498
			with: 0.459407 , -0.0313801 , -0.195416;
		addTriangleWith: 0.291707 , 0.177642 , -0.364859
			with: 0.459407 , -0.0313801 , -0.195416
			with: 0.3268 , -0.0435175 , -0.375777;
		addTriangleWith: 0.3268 , -0.0435175 , -0.375777
			with: 0.459407 , -0.0313801 , -0.195416
			with: 0.366697 , -0.22709 , -0.25342;
		addTriangleWith: 0.459407 , -0.0313801 , -0.195416
			with: 0.488868 , -0.107248 , 0.0134812
			with: 0.396157 , -0.302958 , -0.0445221;
		addTriangleWith: 0.459407 , -0.0313801 , -0.195416
			with: 0.396157 , -0.302958 , -0.0445221
			with: 0.366697 , -0.22709 , -0.25342;
		addTriangleWith: 0.424314 , 0.189779 , -0.184498
			with: 0.432087 , 0.250595 , 0.031148
			with: 0.471983 , 0.0670223 , 0.153506;
		addTriangleWith: 0.424314 , 0.189779 , -0.184498
			with: 0.471983 , 0.0670223 , 0.153506
			with: 0.488868 , -0.107248 , 0.0134812;
		addTriangleWith: 0.424314 , 0.189779 , -0.184498
			with: 0.488868 , -0.107248 , 0.0134812
			with: 0.459407 , -0.0313801 , -0.195416;
		addTriangleWith: 0.488868 , -0.107248 , 0.0134812
			with: 0.40393 , -0.242142 , 0.171124
			with: 0.396157 , -0.302958 , -0.0445221;
		addTriangleWith: 0.396157 , -0.302958 , -0.0445221
			with: 0.40393 , -0.242142 , 0.171124
			with: 0.237035 , -0.384537 , 0.217297;
		addTriangleWith: 0.396157 , -0.302958 , -0.0445221
			with: 0.237035 , -0.384537 , 0.217297
			with: 0.229263 , -0.445353 , 0.00165111;
		addTriangleWith: 0.471983 , 0.0670223 , 0.153506
			with: 0.387044 , -0.0678717 , 0.311148
			with: 0.40393 , -0.242142 , 0.171124;
		addTriangleWith: 0.471983 , 0.0670223 , 0.153506
			with: 0.40393 , -0.242142 , 0.171124
			with: 0.488868 , -0.107248 , 0.0134812;
		addTriangleWith: 0.432087 , 0.250595 , 0.031148
			with: 0.364401 , 0.24131 , 0.244677
			with: 0.471983 , 0.0670223 , 0.153506;
		addTriangleWith: 0.364401 , 0.24131 , 0.244677
			with: 0.279462 , 0.106416 , 0.402319
			with: 0.387044 , -0.0678717 , 0.311148;
		addTriangleWith: 0.364401 , 0.24131 , 0.244677
			with: 0.387044 , -0.0678717 , 0.311148
			with: 0.471983 , 0.0670223 , 0.153506;
		addTriangleWith: 0.387044 , -0.0678717 , 0.311148
			with: 0.209714 , -0.102562 , 0.443861
			with: 0.117004 , -0.298272 , 0.385858;
		addTriangleWith: 0.387044 , -0.0678717 , 0.311148
			with: 0.117004 , -0.298272 , 0.385858
			with: 0.237035 , -0.384537 , 0.217297;
		addTriangleWith: 0.387044 , -0.0678717 , 0.311148
			with: 0.237035 , -0.384537 , 0.217297
			with: 0.40393 , -0.242142 , 0.171124;
		addTriangleWith: 0.279462 , 0.106416 , 0.402319
			with: 0.209714 , -0.102562 , 0.443861
			with: 0.387044 , -0.0678717 , 0.311148;
		addTriangleWith: 0.209714 , -0.102562 , 0.443861
			with: 0.00772699 , -0.0237981 , 0.500953
			with: -0.0849838 , -0.219508 , 0.44295;
		addTriangleWith: 0.209714 , -0.102562 , 0.443861
			with: -0.0849838 , -0.219508 , 0.44295
			with: 0.117004 , -0.298272 , 0.385858;
		addTriangleWith: 0.3268 , -0.0435175 , -0.375777
			with: 0.366697 , -0.22709 , -0.25342
			with: 0.181594 , -0.322597 , -0.336352;
		addTriangleWith: 0.3268 , -0.0435175 , -0.375777
			with: 0.181594 , -0.322597 , -0.336352
			with: 0.141698 , -0.139024 , -0.45871;
		addTriangleWith: 0.141698 , -0.139024 , -0.45871
			with: 0.181594 , -0.322597 , -0.336352
			with: -0.0251964 , -0.281419 , -0.412537;
		addTriangleWith: 0.181594 , -0.322597 , -0.336352
			with: 0.0966557 , -0.457491 , -0.17871
			with: -0.110135 , -0.416313 , -0.254895;
		addTriangleWith: 0.181594 , -0.322597 , -0.336352
			with: -0.110135 , -0.416313 , -0.254895
			with: -0.0251964 , -0.281419 , -0.412537;
		addTriangleWith: 0.366697 , -0.22709 , -0.25342
			with: 0.396157 , -0.302958 , -0.0445221
			with: 0.229263 , -0.445353 , 0.00165111;
		addTriangleWith: 0.366697 , -0.22709 , -0.25342
			with: 0.229263 , -0.445353 , 0.00165111
			with: 0.0966557 , -0.457491 , -0.17871;
		addTriangleWith: 0.366697 , -0.22709 , -0.25342
			with: 0.0966557 , -0.457491 , -0.17871
			with: 0.181594 , -0.322597 , -0.336352;
		addTriangleWith: 0.0966557 , -0.457491 , -0.17871
			with: -0.0806742 , -0.492181 , -0.0459969
			with: -0.110135 , -0.416313 , -0.254895;
		addTriangleWith: -0.110135 , -0.416313 , -0.254895
			with: -0.0806742 , -0.492181 , -0.0459969
			with: -0.282662 , -0.413417 , 0.0110949;
		addTriangleWith: -0.110135 , -0.416313 , -0.254895
			with: -0.282662 , -0.413417 , 0.0110949
			with: -0.312122 , -0.337549 , -0.197803;
		addTriangleWith: 0.229263 , -0.445353 , 0.00165111
			with: 0.0519329 , -0.480044 , 0.134364
			with: -0.0806742 , -0.492181 , -0.0459969;
		addTriangleWith: 0.229263 , -0.445353 , 0.00165111
			with: -0.0806742 , -0.492181 , -0.0459969
			with: 0.0966557 , -0.457491 , -0.17871;
		addTriangleWith: 0.229263 , -0.445353 , 0.00165111
			with: 0.237035 , -0.384537 , 0.217297
			with: 0.0519329 , -0.480044 , 0.134364;
		addTriangleWith: 0.237035 , -0.384537 , 0.217297
			with: 0.117004 , -0.298272 , 0.385858
			with: -0.0680986 , -0.393778 , 0.302925;
		addTriangleWith: 0.237035 , -0.384537 , 0.217297
			with: -0.0680986 , -0.393778 , 0.302925
			with: 0.0519329 , -0.480044 , 0.134364;
		addTriangleWith: 0.0519329 , -0.480044 , 0.134364
			with: -0.0680986 , -0.393778 , 0.302925
			with: -0.274889 , -0.352601 , 0.226741;
		addTriangleWith: 0.0519329 , -0.480044 , 0.134364
			with: -0.274889 , -0.352601 , 0.226741
			with: -0.282662 , -0.413417 , 0.0110949;
		addTriangleWith: 0.0519329 , -0.480044 , 0.134364
			with: -0.282662 , -0.413417 , 0.0110949
			with: -0.0806742 , -0.492181 , -0.0459969;
		addTriangleWith: 0.117004 , -0.298272 , 0.385858
			with: -0.0849838 , -0.219508 , 0.44295
			with: -0.0680986 , -0.393778 , 0.302925;
		addTriangleWith: -0.0680986 , -0.393778 , 0.302925
			with: -0.0849838 , -0.219508 , 0.44295
			with: -0.291775 , -0.178331 , 0.366765;
		addTriangleWith: -0.0680986 , -0.393778 , 0.302925
			with: -0.291775 , -0.178331 , 0.366765
			with: -0.274889 , -0.352601 , 0.226741;
		addTriangleWith: 0.141698 , -0.139024 , -0.45871
			with: -0.0251964 , -0.281419 , -0.412537
			with: -0.174689 , -0.119286 , -0.452874;
		addTriangleWith: 0.141698 , -0.139024 , -0.45871
			with: -0.174689 , -0.119286 , -0.452874
			with: -0.00779439 , 0.0231091 , -0.499047;
		addTriangleWith: -0.00779439 , 0.0231091 , -0.499047
			with: -0.174689 , -0.119286 , -0.452874
			with: -0.209782 , 0.101873 , -0.441955;
		addTriangleWith: -0.174689 , -0.119286 , -0.452874
			with: -0.352019 , -0.153976 , -0.32016
			with: -0.387112 , 0.0671827 , -0.309242;
		addTriangleWith: -0.174689 , -0.119286 , -0.452874
			with: -0.387112 , 0.0671827 , -0.309242
			with: -0.209782 , 0.101873 , -0.441955;
		addTriangleWith: -0.0251964 , -0.281419 , -0.412537
			with: -0.110135 , -0.416313 , -0.254895
			with: -0.312122 , -0.337549 , -0.197803;
		addTriangleWith: -0.0251964 , -0.281419 , -0.412537
			with: -0.312122 , -0.337549 , -0.197803
			with: -0.352019 , -0.153976 , -0.32016;
		addTriangleWith: -0.0251964 , -0.281419 , -0.412537
			with: -0.352019 , -0.153976 , -0.32016
			with: -0.174689 , -0.119286 , -0.452874;
		addTriangleWith: -0.352019 , -0.153976 , -0.32016
			with: -0.47205 , -0.0677113 , -0.151599
			with: -0.387112 , 0.0671827 , -0.309242;
		addTriangleWith: -0.387112 , 0.0671827 , -0.309242
			with: -0.47205 , -0.0677113 , -0.151599
			with: -0.488935 , 0.106559 , -0.0115747;
		addTriangleWith: -0.387112 , 0.0671827 , -0.309242
			with: -0.488935 , 0.106559 , -0.0115747
			with: -0.403997 , 0.241453 , -0.169217;
		addTriangleWith: -0.312122 , -0.337549 , -0.197803
			with: -0.432154 , -0.251284 , -0.0292415
			with: -0.47205 , -0.0677113 , -0.151599;
		addTriangleWith: -0.312122 , -0.337549 , -0.197803
			with: -0.47205 , -0.0677113 , -0.151599
			with: -0.352019 , -0.153976 , -0.32016;
		addTriangleWith: -0.312122 , -0.337549 , -0.197803
			with: -0.282662 , -0.413417 , 0.0110949
			with: -0.432154 , -0.251284 , -0.0292415;
		addTriangleWith: -0.282662 , -0.413417 , 0.0110949
			with: -0.274889 , -0.352601 , 0.226741
			with: -0.424382 , -0.190468 , 0.186404;
		addTriangleWith: -0.282662 , -0.413417 , 0.0110949
			with: -0.424382 , -0.190468 , 0.186404
			with: -0.432154 , -0.251284 , -0.0292415;
		addTriangleWith: -0.432154 , -0.251284 , -0.0292415
			with: -0.424382 , -0.190468 , 0.186404
			with: -0.459475 , 0.0306913 , 0.197323;
		addTriangleWith: -0.432154 , -0.251284 , -0.0292415
			with: -0.459475 , 0.0306913 , 0.197323
			with: -0.488935 , 0.106559 , -0.0115747;
		addTriangleWith: -0.432154 , -0.251284 , -0.0292415
			with: -0.488935 , 0.106559 , -0.0115747
			with: -0.47205 , -0.0677113 , -0.151599;
		addTriangleWith: -0.274889 , -0.352601 , 0.226741
			with: -0.291775 , -0.178331 , 0.366765
			with: -0.424382 , -0.190468 , 0.186404;
		addTriangleWith: -0.424382 , -0.190468 , 0.186404
			with: -0.291775 , -0.178331 , 0.366765
			with: -0.326868 , 0.0428286 , 0.377684;
		addTriangleWith: -0.424382 , -0.190468 , 0.186404
			with: -0.326868 , 0.0428286 , 0.377684
			with: -0.459475 , 0.0306913 , 0.197323;
		addTriangleWith: -0.00779439 , 0.0231091 , -0.499047
			with: -0.209782 , 0.101873 , -0.441955
			with: -0.117071 , 0.297583 , -0.383952;
		addTriangleWith: -0.00779439 , 0.0231091 , -0.499047
			with: -0.117071 , 0.297583 , -0.383952
			with: 0.0849164 , 0.218819 , -0.441043;
		addTriangleWith: 0.0849164 , 0.218819 , -0.441043
			with: -0.117071 , 0.297583 , -0.383952
			with: 0.0680313 , 0.393089 , -0.301019;
		addTriangleWith: -0.117071 , 0.297583 , -0.383952
			with: -0.237102 , 0.383848 , -0.21539
			with: -0.0520003 , 0.479355 , -0.132458;
		addTriangleWith: -0.117071 , 0.297583 , -0.383952
			with: -0.0520003 , 0.479355 , -0.132458
			with: 0.0680313 , 0.393089 , -0.301019;
		addTriangleWith: -0.209782 , 0.101873 , -0.441955
			with: -0.387112 , 0.0671827 , -0.309242
			with: -0.403997 , 0.241453 , -0.169217;
		addTriangleWith: -0.209782 , 0.101873 , -0.441955
			with: -0.403997 , 0.241453 , -0.169217
			with: -0.237102 , 0.383848 , -0.21539;
		addTriangleWith: -0.209782 , 0.101873 , -0.441955
			with: -0.237102 , 0.383848 , -0.21539
			with: -0.117071 , 0.297583 , -0.383952;
		addTriangleWith: -0.237102 , 0.383848 , -0.21539
			with: -0.22933 , 0.444664 , 0.000255387
			with: -0.0520003 , 0.479355 , -0.132458;
		addTriangleWith: -0.0520003 , 0.479355 , -0.132458
			with: -0.22933 , 0.444664 , 0.000255387
			with: -0.096723 , 0.456802 , 0.180616;
		addTriangleWith: -0.0520003 , 0.479355 , -0.132458
			with: -0.096723 , 0.456802 , 0.180616
			with: 0.0806068 , 0.491492 , 0.0479034;
		addTriangleWith: -0.403997 , 0.241453 , -0.169217
			with: -0.396225 , 0.302269 , 0.0464286
			with: -0.22933 , 0.444664 , 0.000255387;
		addTriangleWith: -0.403997 , 0.241453 , -0.169217
			with: -0.22933 , 0.444664 , 0.000255387
			with: -0.237102 , 0.383848 , -0.21539;
		addTriangleWith: -0.403997 , 0.241453 , -0.169217
			with: -0.488935 , 0.106559 , -0.0115747
			with: -0.396225 , 0.302269 , 0.0464286;
		addTriangleWith: -0.488935 , 0.106559 , -0.0115747
			with: -0.459475 , 0.0306913 , 0.197323
			with: -0.366764 , 0.226401 , 0.255326;
		addTriangleWith: -0.488935 , 0.106559 , -0.0115747
			with: -0.366764 , 0.226401 , 0.255326
			with: -0.396225 , 0.302269 , 0.0464286;
		addTriangleWith: -0.396225 , 0.302269 , 0.0464286
			with: -0.366764 , 0.226401 , 0.255326
			with: -0.181662 , 0.321908 , 0.338259;
		addTriangleWith: -0.396225 , 0.302269 , 0.0464286
			with: -0.181662 , 0.321908 , 0.338259
			with: -0.096723 , 0.456802 , 0.180616;
		addTriangleWith: -0.396225 , 0.302269 , 0.0464286
			with: -0.096723 , 0.456802 , 0.180616
			with: -0.22933 , 0.444664 , 0.000255387;
		addTriangleWith: -0.459475 , 0.0306913 , 0.197323
			with: -0.326868 , 0.0428286 , 0.377684
			with: -0.366764 , 0.226401 , 0.255326;
		addTriangleWith: -0.366764 , 0.226401 , 0.255326
			with: -0.326868 , 0.0428286 , 0.377684
			with: -0.141765 , 0.138335 , 0.460617;
		addTriangleWith: -0.366764 , 0.226401 , 0.255326
			with: -0.141765 , 0.138335 , 0.460617
			with: -0.181662 , 0.321908 , 0.338259;
		addTriangleWith: 0.0849164 , 0.218819 , -0.441043
			with: 0.291707 , 0.177642 , -0.364859
			with: 0.3268 , -0.0435175 , -0.375777;
		addTriangleWith: 0.0849164 , 0.218819 , -0.441043
			with: 0.3268 , -0.0435175 , -0.375777
			with: 0.141698 , -0.139024 , -0.45871;
		addTriangleWith: 0.0849164 , 0.218819 , -0.441043
			with: 0.141698 , -0.139024 , -0.45871
			with: -0.00779439 , 0.0231091 , -0.499047;
		addTriangleWith: -0.326868 , 0.0428286 , 0.377684
			with: -0.291775 , -0.178331 , 0.366765
			with: -0.0849838 , -0.219508 , 0.44295;
		addTriangleWith: -0.326868 , 0.0428286 , 0.377684
			with: -0.0849838 , -0.219508 , 0.44295
			with: 0.00772699 , -0.0237981 , 0.500953;
		addTriangleWith: -0.326868 , 0.0428286 , 0.377684
			with: 0.00772699 , -0.0237981 , 0.500953
			with: -0.141765 , 0.138335 , 0.460617! !

!Polyhedron class methodsFor: 'factory' stamp: 'emm 02/09/2012 23:40'!
gyrobifastigium
	"self gyrobifastigium"

	^(Triangle3DComposite new)
		add: (Triangle3D 
					with: -0.032075 , -0.561313 , 0.12037
					with: -0.032075 , -0.176413 , -0.546296
					with: 0.352825 , 0.400938 , -0.212963);
		add: (Triangle3D 
					with: -0.032075 , -0.561313 , 0.12037
					with: 0.352825 , 0.400938 , -0.212963
					with: 0.352825 , 0.0160375 , 0.453704);
		add: (Triangle3D 
					with: -0.032075 , -0.561313 , 0.12037
					with: 0.352825 , 0.0160375 , 0.453704
					with: -0.416975 , 0.0160375 , 0.453704);
		add: (Triangle3D 
					with: 0.352825 , 0.0160375 , 0.453704
					with: 0.352825 , 0.400938 , -0.212963
					with: -0.416975 , 0.400938 , -0.212963);
		add: (Triangle3D 
					with: 0.352825 , 0.0160375 , 0.453704
					with: -0.416975 , 0.400938 , -0.212963
					with: -0.416975 , 0.0160375 , 0.453704);
		add: (Triangle3D 
					with: 0.352825 , 0.400938 , -0.212963
					with: -0.032075 , -0.176413 , -0.546296
					with: -0.416975 , 0.400938 , -0.212963);
		add: (Triangle3D 
					with: 0.352825 , 0.0160375 , 0.453704
					with: 0.352825 , -0.368863 , -0.212963
					with: 0.352825 , 0.400938 , -0.212963);
		add: (Triangle3D 
					with: 0.352825 , 0.0160375 , 0.453704
					with: -0.416975 , 0.0160375 , 0.453704
					with: -0.416975 , -0.368863 , -0.212963);
		add: (Triangle3D 
					with: 0.352825 , 0.0160375 , 0.453704
					with: -0.416975 , -0.368863 , -0.212963
					with: 0.352825 , -0.368863 , -0.212963);
		add: (Triangle3D 
					with: -0.416975 , 0.0160375 , 0.453704
					with: -0.416975 , 0.400938 , -0.212963
					with: -0.416975 , -0.368863 , -0.212963);
		add: (Triangle3D 
					with: -0.416975 , -0.368863 , -0.212963
					with: -0.416975 , 0.400938 , -0.212963
					with: 0.352825 , 0.400938 , -0.212963);
		add: (Triangle3D 
					with: -0.416975 , -0.368863 , -0.212963
					with: 0.352825 , 0.400938 , -0.212963
					with: 0.352825 , -0.368863 , -0.212963);
		yourself! !

!Polyhedron class methodsFor: 'factory-pentagonal' stamp: 'emm 02/09/2012 23:40'!
gyroelongatedPentagonalBicupola
	"self gyroelongatedPentagonalBicupola "

	^(Triangle3DComposite new)
		add: (Triangle3D 
					with: -0.347163 , 0.160572 , -0.0647488
					with: -0.122029 , 0.301641 , -0.211048
					with: 0.0267831 , 0.0949101 , -0.375689);
		add: (Triangle3D 
					with: -0.347163 , 0.160572 , -0.0647488
					with: 0.0267831 , 0.0949101 , -0.375689
					with: -0.106381 , -0.173925 , -0.331144);
		add: (Triangle3D 
					with: -0.347163 , 0.160572 , -0.0647488
					with: -0.106381 , -0.173925 , -0.331144
					with: -0.337492 , -0.133344 , -0.138973);
		add: (Triangle3D 
					with: -0.122029 , 0.301641 , -0.211048
					with: -0.347163 , 0.160572 , -0.0647488
					with: -0.320584 , 0.35659 , 0.165163);
		add: (Triangle3D 
					with: -0.122029 , 0.301641 , -0.211048
					with: -0.320584 , 0.35659 , 0.165163
					with: -0.0954501 , 0.497659 , 0.0188645);
		add: (Triangle3D 
					with: -0.122029 , 0.301641 , -0.211048
					with: -0.0954501 , 0.497659 , 0.0188645
					with: 0.135661 , 0.457078 , -0.173307);
		add: (Triangle3D 
					with: 0.0267831 , 0.0949101 , -0.375689
					with: -0.122029 , 0.301641 , -0.211048
					with: 0.135661 , 0.457078 , -0.173307);
		add: (Triangle3D 
					with: 0.0267831 , 0.0949101 , -0.375689
					with: 0.135661 , 0.457078 , -0.173307
					with: 0.284473 , 0.250347 , -0.337949);
		add: (Triangle3D 
					with: 0.0267831 , 0.0949101 , -0.375689
					with: 0.284473 , 0.250347 , -0.337949
					with: 0.294144 , -0.0435684 , -0.412172);
		add: (Triangle3D 
					with: -0.106381 , -0.173925 , -0.331144
					with: 0.0267831 , 0.0949101 , -0.375689
					with: 0.294144 , -0.0435684 , -0.412172);
		add: (Triangle3D 
					with: -0.106381 , -0.173925 , -0.331144
					with: 0.294144 , -0.0435684 , -0.412172
					with: 0.16098 , -0.312404 , -0.367628);
		add: (Triangle3D 
					with: -0.106381 , -0.173925 , -0.331144
					with: 0.16098 , -0.312404 , -0.367628
					with: -0.064154 , -0.453473 , -0.221329);
		add: (Triangle3D 
					with: -0.337492 , -0.133344 , -0.138973
					with: -0.106381 , -0.173925 , -0.331144
					with: -0.064154 , -0.453473 , -0.221329);
		add: (Triangle3D 
					with: -0.337492 , -0.133344 , -0.138973
					with: -0.064154 , -0.453473 , -0.221329
					with: -0.295265 , -0.412891 , -0.0291573);
		add: (Triangle3D 
					with: -0.337492 , -0.133344 , -0.138973
					with: -0.295265 , -0.412891 , -0.0291573
					with: -0.444077 , -0.206161 , 0.135484);
		add: (Triangle3D 
					with: -0.347163 , 0.160572 , -0.0647488
					with: -0.337492 , -0.133344 , -0.138973
					with: -0.444077 , -0.206161 , 0.135484);
		add: (Triangle3D 
					with: -0.347163 , 0.160572 , -0.0647488
					with: -0.444077 , -0.206161 , 0.135484
					with: -0.453748 , 0.0877549 , 0.209708);
		add: (Triangle3D 
					with: -0.347163 , 0.160572 , -0.0647488
					with: -0.453748 , 0.0877549 , 0.209708
					with: -0.320584 , 0.35659 , 0.165163);
		add: (Triangle3D 
					with: 0.29079 , 0.177172 , 0.185875
					with: 0.050927 , 0.124342 , 0.36382
					with: -0.013997 , -0.171514 , 0.348216);
		add: (Triangle3D 
					with: 0.29079 , 0.177172 , 0.185875
					with: -0.013997 , -0.171514 , 0.348216
					with: 0.18574 , -0.301533 , 0.160629);
		add: (Triangle3D 
					with: 0.29079 , 0.177172 , 0.185875
					with: 0.18574 , -0.301533 , 0.160629
					with: 0.374109 , -0.0860338 , 0.0602963);
		add: (Triangle3D 
					with: 0.050927 , 0.124342 , 0.36382
					with: 0.29079 , 0.177172 , 0.185875
					with: 0.185109 , 0.455069 , 0.125925);
		add: (Triangle3D 
					with: 0.050927 , 0.124342 , 0.36382
					with: 0.185109 , 0.455069 , 0.125925
					with: -0.0547539 , 0.402239 , 0.30387);
		add: (Triangle3D 
					with: 0.050927 , 0.124342 , 0.36382
					with: -0.0547539 , 0.402239 , 0.30387
					with: -0.243122 , 0.18674 , 0.404202);
		add: (Triangle3D 
					with: -0.013997 , -0.171514 , 0.348216
					with: 0.050927 , 0.124342 , 0.36382
					with: -0.243122 , 0.18674 , 0.404202);
		add: (Triangle3D 
					with: -0.013997 , -0.171514 , 0.348216
					with: -0.243122 , 0.18674 , 0.404202
					with: -0.308046 , -0.109116 , 0.388599);
		add: (Triangle3D 
					with: -0.013997 , -0.171514 , 0.348216
					with: -0.308046 , -0.109116 , 0.388599
					with: -0.224727 , -0.372321 , 0.26302);
		add: (Triangle3D 
					with: 0.18574 , -0.301533 , 0.160629
					with: -0.013997 , -0.171514 , 0.348216
					with: -0.224727 , -0.372321 , 0.26302);
		add: (Triangle3D 
					with: 0.18574 , -0.301533 , 0.160629
					with: -0.224727 , -0.372321 , 0.26302
					with: -0.0249896 , -0.502341 , 0.0754323);
		add: (Triangle3D 
					with: 0.18574 , -0.301533 , 0.160629
					with: -0.0249896 , -0.502341 , 0.0754323
					with: 0.214873 , -0.449511 , -0.102512);
		add: (Triangle3D 
					with: 0.374109 , -0.0860338 , 0.0602963
					with: 0.18574 , -0.301533 , 0.160629
					with: 0.214873 , -0.449511 , -0.102512);
		add: (Triangle3D 
					with: 0.374109 , -0.0860338 , 0.0602963
					with: 0.214873 , -0.449511 , -0.102512
					with: 0.403241 , -0.234012 , -0.202844);
		add: (Triangle3D 
					with: 0.374109 , -0.0860338 , 0.0602963
					with: 0.403241 , -0.234012 , -0.202844
					with: 0.468165 , 0.0618439 , -0.187241);
		add: (Triangle3D 
					with: 0.29079 , 0.177172 , 0.185875
					with: 0.374109 , -0.0860338 , 0.0602963
					with: 0.468165 , 0.0618439 , -0.187241);
		add: (Triangle3D 
					with: 0.29079 , 0.177172 , 0.185875
					with: 0.468165 , 0.0618439 , -0.187241
					with: 0.384846 , 0.325049 , -0.0616623);
		add: (Triangle3D 
					with: 0.29079 , 0.177172 , 0.185875
					with: 0.384846 , 0.325049 , -0.0616623
					with: 0.185109 , 0.455069 , 0.125925);
		add: (Triangle3D 
					with: 0.16098 , -0.312404 , -0.367628
					with: 0.214873 , -0.449511 , -0.102512
					with: -0.064154 , -0.453473 , -0.221329);
		add: (Triangle3D 
					with: -0.064154 , -0.453473 , -0.221329
					with: 0.214873 , -0.449511 , -0.102512
					with: -0.0249896 , -0.502341 , 0.0754323);
		add: (Triangle3D 
					with: -0.064154 , -0.453473 , -0.221329
					with: -0.0249896 , -0.502341 , 0.0754323
					with: -0.295265 , -0.412891 , -0.0291573);
		add: (Triangle3D 
					with: -0.295265 , -0.412891 , -0.0291573
					with: -0.0249896 , -0.502341 , 0.0754323
					with: -0.224727 , -0.372321 , 0.26302);
		add: (Triangle3D 
					with: -0.295265 , -0.412891 , -0.0291573
					with: -0.224727 , -0.372321 , 0.26302
					with: -0.444077 , -0.206161 , 0.135484);
		add: (Triangle3D 
					with: -0.444077 , -0.206161 , 0.135484
					with: -0.224727 , -0.372321 , 0.26302
					with: -0.308046 , -0.109116 , 0.388599);
		add: (Triangle3D 
					with: -0.444077 , -0.206161 , 0.135484
					with: -0.308046 , -0.109116 , 0.388599
					with: -0.453748 , 0.0877549 , 0.209708);
		add: (Triangle3D 
					with: -0.453748 , 0.0877549 , 0.209708
					with: -0.308046 , -0.109116 , 0.388599
					with: -0.243122 , 0.18674 , 0.404202);
		add: (Triangle3D 
					with: -0.453748 , 0.0877549 , 0.209708
					with: -0.243122 , 0.18674 , 0.404202
					with: -0.320584 , 0.35659 , 0.165163);
		add: (Triangle3D 
					with: -0.320584 , 0.35659 , 0.165163
					with: -0.243122 , 0.18674 , 0.404202
					with: -0.0547539 , 0.402239 , 0.30387);
		add: (Triangle3D 
					with: -0.320584 , 0.35659 , 0.165163
					with: -0.0547539 , 0.402239 , 0.30387
					with: -0.0954501 , 0.497659 , 0.0188645);
		add: (Triangle3D 
					with: -0.0954501 , 0.497659 , 0.0188645
					with: -0.0547539 , 0.402239 , 0.30387
					with: 0.185109 , 0.455069 , 0.125925);
		add: (Triangle3D 
					with: -0.0954501 , 0.497659 , 0.0188645
					with: 0.185109 , 0.455069 , 0.125925
					with: 0.135661 , 0.457078 , -0.173307);
		add: (Triangle3D 
					with: 0.135661 , 0.457078 , -0.173307
					with: 0.185109 , 0.455069 , 0.125925
					with: 0.384846 , 0.325049 , -0.0616623);
		add: (Triangle3D 
					with: 0.135661 , 0.457078 , -0.173307
					with: 0.384846 , 0.325049 , -0.0616623
					with: 0.284473 , 0.250347 , -0.337949);
		add: (Triangle3D 
					with: 0.284473 , 0.250347 , -0.337949
					with: 0.384846 , 0.325049 , -0.0616623
					with: 0.468165 , 0.0618439 , -0.187241);
		add: (Triangle3D 
					with: 0.284473 , 0.250347 , -0.337949
					with: 0.468165 , 0.0618439 , -0.187241
					with: 0.294144 , -0.0435684 , -0.412172);
		add: (Triangle3D 
					with: 0.294144 , -0.0435684 , -0.412172
					with: 0.468165 , 0.0618439 , -0.187241
					with: 0.403241 , -0.234012 , -0.202844);
		add: (Triangle3D 
					with: 0.294144 , -0.0435684 , -0.412172
					with: 0.403241 , -0.234012 , -0.202844
					with: 0.16098 , -0.312404 , -0.367628);
		add: (Triangle3D 
					with: 0.16098 , -0.312404 , -0.367628
					with: 0.403241 , -0.234012 , -0.202844
					with: 0.214873 , -0.449511 , -0.102512);
		yourself! !

!Polyhedron class methodsFor: 'factory-pentagonal' stamp: 'emm 02/09/2012 23:40'!
gyroelongatedPentagonalBirotunda
	"self gyroelongatedPentagonalBirotunda "

	^(Triangle3DComposite new)
		add: (Triangle3D 
					with: -0.498904 , 0.169526 , 0.103088
					with: -0.498415 , 0.118813 , -0.161004
					with: -0.478892 , -0.147297 , -0.194486);
		add: (Triangle3D 
					with: -0.498904 , 0.169526 , 0.103088
					with: -0.478892 , -0.147297 , -0.194486
					with: -0.467315 , -0.261049 , 0.0489133);
		add: (Triangle3D 
					with: -0.498904 , 0.169526 , 0.103088
					with: -0.467315 , -0.261049 , 0.0489133
					with: -0.479683 , -0.0652419 , 0.232824);
		add: (Triangle3D 
					with: -0.498904 , 0.169526 , 0.103088
					with: -0.352974 , 0.151899 , 0.328278
					with: -0.135585 , 0.307433 , 0.298813);
		add: (Triangle3D 
					with: -0.498904 , 0.169526 , 0.103088
					with: -0.135585 , 0.307433 , 0.298813
					with: -0.147162 , 0.421185 , 0.055414);
		add: (Triangle3D 
					with: -0.498904 , 0.169526 , 0.103088
					with: -0.147162 , 0.421185 , 0.055414
					with: -0.371706 , 0.335954 , -0.0655509);
		add: (Triangle3D 
					with: -0.498904 , 0.169526 , 0.103088
					with: -0.371706 , 0.335954 , -0.0655509
					with: -0.498415 , 0.118813 , -0.161004);
		add: (Triangle3D 
					with: -0.371706 , 0.335954 , -0.0655509
					with: -0.147162 , 0.421185 , 0.055414
					with: -0.146672 , 0.370472 , -0.208678);
		add: (Triangle3D 
					with: -0.498415 , 0.118813 , -0.161004
					with: -0.371706 , 0.335954 , -0.0655509
					with: -0.146672 , 0.370472 , -0.208678);
		add: (Triangle3D 
					with: -0.498415 , 0.118813 , -0.161004
					with: -0.146672 , 0.370472 , -0.208678
					with: -0.134304 , 0.174664 , -0.392589);
		add: (Triangle3D 
					with: -0.498415 , 0.118813 , -0.161004
					with: -0.134304 , 0.174664 , -0.392589
					with: -0.351693 , 0.0191304 , -0.363125);
		add: (Triangle3D 
					with: -0.498415 , 0.118813 , -0.161004
					with: -0.351693 , 0.0191304 , -0.363125
					with: -0.478892 , -0.147297 , -0.194486);
		add: (Triangle3D 
					with: -0.351693 , 0.0191304 , -0.363125
					with: -0.134304 , 0.174664 , -0.392589
					with: -0.11478 , -0.0914462 , -0.426071);
		add: (Triangle3D 
					with: -0.478892 , -0.147297 , -0.194486
					with: -0.351693 , 0.0191304 , -0.363125
					with: -0.11478 , -0.0914462 , -0.426071);
		add: (Triangle3D 
					with: -0.478892 , -0.147297 , -0.194486
					with: -0.11478 , -0.0914462 , -0.426071
					with: -0.0955594 , -0.326214 , -0.296335);
		add: (Triangle3D 
					with: -0.478892 , -0.147297 , -0.194486
					with: -0.0955594 , -0.326214 , -0.296335
					with: -0.320593 , -0.360732 , -0.153208);
		add: (Triangle3D 
					with: -0.478892 , -0.147297 , -0.194486
					with: -0.320593 , -0.360732 , -0.153208
					with: -0.467315 , -0.261049 , 0.0489133);
		add: (Triangle3D 
					with: -0.320593 , -0.360732 , -0.153208
					with: -0.0955594 , -0.326214 , -0.296335
					with: -0.0839824 , -0.439966 , -0.0529355);
		add: (Triangle3D 
					with: -0.467315 , -0.261049 , 0.0489133
					with: -0.320593 , -0.360732 , -0.153208
					with: -0.0839824 , -0.439966 , -0.0529355);
		add: (Triangle3D 
					with: -0.467315 , -0.261049 , 0.0489133
					with: -0.0839824 , -0.439966 , -0.0529355
					with: -0.0844715 , -0.389253 , 0.211157);
		add: (Triangle3D 
					with: -0.467315 , -0.261049 , 0.0489133
					with: -0.0844715 , -0.389253 , 0.211157
					with: -0.321384 , -0.278676 , 0.274103);
		add: (Triangle3D 
					with: -0.467315 , -0.261049 , 0.0489133
					with: -0.321384 , -0.278676 , 0.274103
					with: -0.479683 , -0.0652419 , 0.232824);
		add: (Triangle3D 
					with: -0.321384 , -0.278676 , 0.274103
					with: -0.0844715 , -0.389253 , 0.211157
					with: -0.0968399 , -0.193445 , 0.395068);
		add: (Triangle3D 
					with: -0.479683 , -0.0652419 , 0.232824
					with: -0.321384 , -0.278676 , 0.274103
					with: -0.0968399 , -0.193445 , 0.395068);
		add: (Triangle3D 
					with: -0.479683 , -0.0652419 , 0.232824
					with: -0.0968399 , -0.193445 , 0.395068
					with: -0.116363 , 0.0726649 , 0.42855);
		add: (Triangle3D 
					with: -0.479683 , -0.0652419 , 0.232824
					with: -0.116363 , 0.0726649 , 0.42855
					with: -0.352974 , 0.151899 , 0.328278);
		add: (Triangle3D 
					with: -0.479683 , -0.0652419 , 0.232824
					with: -0.352974 , 0.151899 , 0.328278
					with: -0.498904 , 0.169526 , 0.103088);
		add: (Triangle3D 
					with: -0.352974 , 0.151899 , 0.328278
					with: -0.116363 , 0.0726649 , 0.42855
					with: -0.135585 , 0.307433 , 0.298813);
		add: (Triangle3D 
					with: 0.468138 , 0.261966 , 0.0221932
					with: 0.484329 , 0.0787386 , 0.218362
					with: 0.501096 , -0.164106 , 0.104072);
		add: (Triangle3D 
					with: 0.468138 , 0.261966 , 0.0221932
					with: 0.501096 , -0.164106 , 0.104072
					with: 0.495266 , -0.130964 , -0.162732);
		add: (Triangle3D 
					with: 0.468138 , 0.261966 , 0.0221932
					with: 0.495266 , -0.130964 , -0.162732
					with: 0.474897 , 0.132363 , -0.213336);
		add: (Triangle3D 
					with: 0.468138 , 0.261966 , 0.0221932
					with: 0.317317 , 0.348165 , -0.183087
					with: 0.0827173 , 0.434012 , -0.0835393);
		add: (Triangle3D 
					with: 0.468138 , 0.261966 , 0.0221932
					with: 0.0827173 , 0.434012 , -0.0835393
					with: 0.0885465 , 0.400871 , 0.183265);
		add: (Triangle3D 
					with: 0.468138 , 0.261966 , 0.0221932
					with: 0.0885465 , 0.400871 , 0.183265
					with: 0.326749 , 0.29454 , 0.248611);
		add: (Triangle3D 
					with: 0.468138 , 0.261966 , 0.0221932
					with: 0.326749 , 0.29454 , 0.248611
					with: 0.484329 , 0.0787386 , 0.218362);
		add: (Triangle3D 
					with: 0.326749 , 0.29454 , 0.248611
					with: 0.0885465 , 0.400871 , 0.183265
					with: 0.104738 , 0.217643 , 0.379434);
		add: (Triangle3D 
					with: 0.484329 , 0.0787386 , 0.218362
					with: 0.326749 , 0.29454 , 0.248611
					with: 0.104738 , 0.217643 , 0.379434);
		add: (Triangle3D 
					with: 0.484329 , 0.0787386 , 0.218362
					with: 0.104738 , 0.217643 , 0.379434
					with: 0.125107 , -0.0456843 , 0.430038);
		add: (Triangle3D 
					with: 0.484329 , 0.0787386 , 0.218362
					with: 0.125107 , -0.0456843 , 0.430038
					with: 0.359708 , -0.131532 , 0.33049);
		add: (Triangle3D 
					with: 0.484329 , 0.0787386 , 0.218362
					with: 0.359708 , -0.131532 , 0.33049
					with: 0.501096 , -0.164106 , 0.104072);
		add: (Triangle3D 
					with: 0.359708 , -0.131532 , 0.33049
					with: 0.125107 , -0.0456843 , 0.430038
					with: 0.141874 , -0.288529 , 0.315748);
		add: (Triangle3D 
					with: 0.501096 , -0.164106 , 0.104072
					with: 0.359708 , -0.131532 , 0.33049
					with: 0.141874 , -0.288529 , 0.315748);
		add: (Triangle3D 
					with: 0.501096 , -0.164106 , 0.104072
					with: 0.141874 , -0.288529 , 0.315748
					with: 0.148634 , -0.418132 , 0.0802184);
		add: (Triangle3D 
					with: 0.501096 , -0.164106 , 0.104072
					with: 0.148634 , -0.418132 , 0.0802184
					with: 0.370645 , -0.341235 , -0.0506044);
		add: (Triangle3D 
					with: 0.501096 , -0.164106 , 0.104072
					with: 0.370645 , -0.341235 , -0.0506044
					with: 0.495266 , -0.130964 , -0.162732);
		add: (Triangle3D 
					with: 0.370645 , -0.341235 , -0.0506044
					with: 0.148634 , -0.418132 , 0.0802184
					with: 0.142804 , -0.384991 , -0.186586);
		add: (Triangle3D 
					with: 0.495266 , -0.130964 , -0.162732
					with: 0.370645 , -0.341235 , -0.0506044
					with: 0.142804 , -0.384991 , -0.186586);
		add: (Triangle3D 
					with: 0.495266 , -0.130964 , -0.162732
					with: 0.142804 , -0.384991 , -0.186586
					with: 0.126613 , -0.201763 , -0.382755);
		add: (Triangle3D 
					with: 0.495266 , -0.130964 , -0.162732
					with: 0.126613 , -0.201763 , -0.382755
					with: 0.344446 , -0.0447661 , -0.368013);
		add: (Triangle3D 
					with: 0.495266 , -0.130964 , -0.162732
					with: 0.344446 , -0.0447661 , -0.368013
					with: 0.474897 , 0.132363 , -0.213336);
		add: (Triangle3D 
					with: 0.344446 , -0.0447661 , -0.368013
					with: 0.126613 , -0.201763 , -0.382755
					with: 0.106244 , 0.061564 , -0.433359);
		add: (Triangle3D 
					with: 0.474897 , 0.132363 , -0.213336
					with: 0.344446 , -0.0447661 , -0.368013
					with: 0.106244 , 0.061564 , -0.433359);
		add: (Triangle3D 
					with: 0.474897 , 0.132363 , -0.213336
					with: 0.106244 , 0.061564 , -0.433359
					with: 0.0894769 , 0.304409 , -0.319069);
		add: (Triangle3D 
					with: 0.474897 , 0.132363 , -0.213336
					with: 0.0894769 , 0.304409 , -0.319069
					with: 0.317317 , 0.348165 , -0.183087);
		add: (Triangle3D 
					with: 0.474897 , 0.132363 , -0.213336
					with: 0.317317 , 0.348165 , -0.183087
					with: 0.468138 , 0.261966 , 0.0221932);
		add: (Triangle3D 
					with: 0.317317 , 0.348165 , -0.183087
					with: 0.0894769 , 0.304409 , -0.319069
					with: 0.0827173 , 0.434012 , -0.0835393);
		add: (Triangle3D 
					with: -0.0955594 , -0.326214 , -0.296335
					with: 0.142804 , -0.384991 , -0.186586
					with: -0.0839824 , -0.439966 , -0.0529355);
		add: (Triangle3D 
					with: -0.0839824 , -0.439966 , -0.0529355
					with: 0.142804 , -0.384991 , -0.186586
					with: 0.148634 , -0.418132 , 0.0802184);
		add: (Triangle3D 
					with: -0.0839824 , -0.439966 , -0.0529355
					with: 0.148634 , -0.418132 , 0.0802184
					with: -0.0844715 , -0.389253 , 0.211157);
		add: (Triangle3D 
					with: -0.0844715 , -0.389253 , 0.211157
					with: 0.148634 , -0.418132 , 0.0802184
					with: 0.141874 , -0.288529 , 0.315748);
		add: (Triangle3D 
					with: -0.0844715 , -0.389253 , 0.211157
					with: 0.141874 , -0.288529 , 0.315748
					with: -0.0968399 , -0.193445 , 0.395068);
		add: (Triangle3D 
					with: -0.0968399 , -0.193445 , 0.395068
					with: 0.141874 , -0.288529 , 0.315748
					with: 0.125107 , -0.0456843 , 0.430038);
		add: (Triangle3D 
					with: -0.0968399 , -0.193445 , 0.395068
					with: 0.125107 , -0.0456843 , 0.430038
					with: -0.116363 , 0.0726649 , 0.42855);
		add: (Triangle3D 
					with: -0.116363 , 0.0726649 , 0.42855
					with: 0.125107 , -0.0456843 , 0.430038
					with: 0.104738 , 0.217643 , 0.379434);
		add: (Triangle3D 
					with: -0.116363 , 0.0726649 , 0.42855
					with: 0.104738 , 0.217643 , 0.379434
					with: -0.135585 , 0.307433 , 0.298813);
		add: (Triangle3D 
					with: -0.135585 , 0.307433 , 0.298813
					with: 0.104738 , 0.217643 , 0.379434
					with: 0.0885465 , 0.400871 , 0.183265);
		add: (Triangle3D 
					with: -0.135585 , 0.307433 , 0.298813
					with: 0.0885465 , 0.400871 , 0.183265
					with: -0.147162 , 0.421185 , 0.055414);
		add: (Triangle3D 
					with: -0.147162 , 0.421185 , 0.055414
					with: 0.0885465 , 0.400871 , 0.183265
					with: 0.0827173 , 0.434012 , -0.0835393);
		add: (Triangle3D 
					with: -0.147162 , 0.421185 , 0.055414
					with: 0.0827173 , 0.434012 , -0.0835393
					with: -0.146672 , 0.370472 , -0.208678);
		add: (Triangle3D 
					with: -0.146672 , 0.370472 , -0.208678
					with: 0.0827173 , 0.434012 , -0.0835393
					with: 0.0894769 , 0.304409 , -0.319069);
		add: (Triangle3D 
					with: -0.146672 , 0.370472 , -0.208678
					with: 0.0894769 , 0.304409 , -0.319069
					with: -0.134304 , 0.174664 , -0.392589);
		add: (Triangle3D 
					with: -0.134304 , 0.174664 , -0.392589
					with: 0.0894769 , 0.304409 , -0.319069
					with: 0.106244 , 0.061564 , -0.433359);
		add: (Triangle3D 
					with: -0.134304 , 0.174664 , -0.392589
					with: 0.106244 , 0.061564 , -0.433359
					with: -0.11478 , -0.0914462 , -0.426071);
		add: (Triangle3D 
					with: -0.11478 , -0.0914462 , -0.426071
					with: 0.106244 , 0.061564 , -0.433359
					with: 0.126613 , -0.201763 , -0.382755);
		add: (Triangle3D 
					with: -0.11478 , -0.0914462 , -0.426071
					with: 0.126613 , -0.201763 , -0.382755
					with: -0.0955594 , -0.326214 , -0.296335);
		add: (Triangle3D 
					with: -0.0955594 , -0.326214 , -0.296335
					with: 0.126613 , -0.201763 , -0.382755
					with: 0.142804 , -0.384991 , -0.186586);
		yourself! !

!Polyhedron class methodsFor: 'factory-pentagonal' stamp: 'emm 02/09/2012 23:40'!
gyroelongatedPentagonalCupolarotunda
	"self gyroelongatedPentagonalCupolarotunda "

	^(Triangle3DComposite new)
		add: (Triangle3D 
					with: -0.412168 , 0.101117 , 0.132651
					with: -0.243098 , 0.337306 , 0.157828
					with: -0.145304 , 0.406841 , -0.107888);
		add: (Triangle3D 
					with: -0.412168 , 0.101117 , 0.132651
					with: -0.145304 , 0.406841 , -0.107888
					with: -0.253934 , 0.213627 , -0.297286);
		add: (Triangle3D 
					with: -0.412168 , 0.101117 , 0.132651
					with: -0.253934 , 0.213627 , -0.297286
					with: -0.418866 , 0.0246794 , -0.148625);
		add: (Triangle3D 
					with: -0.243098 , 0.337306 , 0.157828
					with: -0.412168 , 0.101117 , 0.132651
					with: -0.330598 , 0.0143588 , 0.398777);
		add: (Triangle3D 
					with: -0.243098 , 0.337306 , 0.157828
					with: -0.330598 , 0.0143588 , 0.398777
					with: -0.161528 , 0.250548 , 0.423953);
		add: (Triangle3D 
					with: -0.243098 , 0.337306 , 0.157828
					with: -0.161528 , 0.250548 , 0.423953
					with: 0.00340359 , 0.439495 , 0.275292);
		add: (Triangle3D 
					with: -0.145304 , 0.406841 , -0.107888
					with: -0.243098 , 0.337306 , 0.157828
					with: 0.00340359 , 0.439495 , 0.275292);
		add: (Triangle3D 
					with: -0.145304 , 0.406841 , -0.107888
					with: 0.00340359 , 0.439495 , 0.275292
					with: 0.101197 , 0.50903 , 0.00957625);
		add: (Triangle3D 
					with: -0.145304 , 0.406841 , -0.107888
					with: 0.101197 , 0.50903 , 0.00957625
					with: 0.0945004 , 0.432592 , -0.2717);
		add: (Triangle3D 
					with: -0.253934 , 0.213627 , -0.297286
					with: -0.145304 , 0.406841 , -0.107888
					with: 0.0945004 , 0.432592 , -0.2717);
		add: (Triangle3D 
					with: -0.253934 , 0.213627 , -0.297286
					with: 0.0945004 , 0.432592 , -0.2717
					with: -0.0141298 , 0.239379 , -0.461098);
		add: (Triangle3D 
					with: -0.253934 , 0.213627 , -0.297286
					with: -0.0141298 , 0.239379 , -0.461098
					with: -0.1832 , 0.00318993 , -0.486274);
		add: (Triangle3D 
					with: -0.418866 , 0.0246794 , -0.148625
					with: -0.253934 , 0.213627 , -0.297286
					with: -0.1832 , 0.00318993 , -0.486274);
		add: (Triangle3D 
					with: -0.418866 , 0.0246794 , -0.148625
					with: -0.1832 , 0.00318993 , -0.486274
					with: -0.348131 , -0.185758 , -0.337613);
		add: (Triangle3D 
					with: -0.418866 , 0.0246794 , -0.148625
					with: -0.348131 , -0.185758 , -0.337613
					with: -0.445925 , -0.255293 , -0.0718972);
		add: (Triangle3D 
					with: -0.412168 , 0.101117 , 0.132651
					with: -0.418866 , 0.0246794 , -0.148625
					with: -0.445925 , -0.255293 , -0.0718972);
		add: (Triangle3D 
					with: -0.412168 , 0.101117 , 0.132651
					with: -0.445925 , -0.255293 , -0.0718972
					with: -0.439228 , -0.178855 , 0.209379);
		add: (Triangle3D 
					with: -0.412168 , 0.101117 , 0.132651
					with: -0.439228 , -0.178855 , 0.209379
					with: -0.330598 , 0.0143588 , 0.398777);
		add: (Triangle3D 
					with: 0.354182 , -0.190708 , 0.299678
					with: 0.208186 , -0.416458 , 0.18687
					with: 0.256078 , -0.420087 , -0.100701);
		add: (Triangle3D 
					with: 0.354182 , -0.190708 , 0.299678
					with: 0.256078 , -0.420087 , -0.100701
					with: 0.431673 , -0.196579 , -0.165621);
		add: (Triangle3D 
					with: 0.354182 , -0.190708 , 0.299678
					with: 0.431673 , -0.196579 , -0.165621
					with: 0.492304 , -0.0548152 , 0.0818272);
		add: (Triangle3D 
					with: 0.354182 , -0.190708 , 0.299678
					with: 0.375691 , 0.100052 , 0.299591
					with: 0.126375 , 0.208868 , 0.404493);
		add: (Triangle3D 
					with: 0.354182 , -0.190708 , 0.299678
					with: 0.126375 , 0.208868 , 0.404493
					with: -0.04922 , -0.0146396 , 0.469412);
		add: (Triangle3D 
					with: 0.354182 , -0.190708 , 0.299678
					with: -0.04922 , -0.0146396 , 0.469412
					with: 0.0915723 , -0.261591 , 0.404633);
		add: (Triangle3D 
					with: 0.354182 , -0.190708 , 0.299678
					with: 0.0915723 , -0.261591 , 0.404633
					with: 0.208186 , -0.416458 , 0.18687);
		add: (Triangle3D 
					with: 0.0915723 , -0.261591 , 0.404633
					with: -0.04922 , -0.0146396 , 0.469412
					with: -0.195216 , -0.24039 , 0.356604);
		add: (Triangle3D 
					with: 0.208186 , -0.416458 , 0.18687
					with: 0.0915723 , -0.261591 , 0.404633
					with: -0.195216 , -0.24039 , 0.356604);
		add: (Triangle3D 
					with: 0.208186 , -0.416458 , 0.18687
					with: -0.195216 , -0.24039 , 0.356604
					with: -0.255847 , -0.382154 , 0.109156);
		add: (Triangle3D 
					with: 0.208186 , -0.416458 , 0.18687
					with: -0.255847 , -0.382154 , 0.109156
					with: -0.00653091 , -0.49097 , 0.00425442);
		add: (Triangle3D 
					with: 0.208186 , -0.416458 , 0.18687
					with: -0.00653091 , -0.49097 , 0.00425442
					with: 0.256078 , -0.420087 , -0.100701);
		add: (Triangle3D 
					with: -0.00653091 , -0.49097 , 0.00425442
					with: -0.255847 , -0.382154 , 0.109156
					with: -0.207954 , -0.385783 , -0.178415);
		add: (Triangle3D 
					with: 0.256078 , -0.420087 , -0.100701
					with: -0.00653091 , -0.49097 , 0.00425442
					with: -0.207954 , -0.385783 , -0.178415);
		add: (Triangle3D 
					with: 0.256078 , -0.420087 , -0.100701
					with: -0.207954 , -0.385783 , -0.178415
					with: -0.0698316 , -0.249891 , -0.396266);
		add: (Triangle3D 
					with: 0.256078 , -0.420087 , -0.100701
					with: -0.0698316 , -0.249891 , -0.396266
					with: 0.216956 , -0.271092 , -0.348236);
		add: (Triangle3D 
					with: 0.256078 , -0.420087 , -0.100701
					with: 0.216956 , -0.271092 , -0.348236
					with: 0.431673 , -0.196579 , -0.165621);
		add: (Triangle3D 
					with: 0.216956 , -0.271092 , -0.348236
					with: -0.0698316 , -0.249891 , -0.396266
					with: 0.105763 , -0.0263832 , -0.461185);
		add: (Triangle3D 
					with: 0.431673 , -0.196579 , -0.165621
					with: 0.216956 , -0.271092 , -0.348236
					with: 0.105763 , -0.0263832 , -0.461185);
		add: (Triangle3D 
					with: 0.431673 , -0.196579 , -0.165621
					with: 0.105763 , -0.0263832 , -0.461185
					with: 0.251759 , 0.199367 , -0.348377);
		add: (Triangle3D 
					with: 0.431673 , -0.196579 , -0.165621
					with: 0.251759 , 0.199367 , -0.348377
					with: 0.453182 , 0.09418 , -0.165708);
		add: (Triangle3D 
					with: 0.431673 , -0.196579 , -0.165621
					with: 0.453182 , 0.09418 , -0.165708
					with: 0.492304 , -0.0548152 , 0.0818272);
		add: (Triangle3D 
					with: 0.453182 , 0.09418 , -0.165708
					with: 0.251759 , 0.199367 , -0.348377
					with: 0.31239 , 0.341131 , -0.100929);
		add: (Triangle3D 
					with: 0.492304 , -0.0548152 , 0.0818272
					with: 0.453182 , 0.09418 , -0.165708
					with: 0.31239 , 0.341131 , -0.100929);
		add: (Triangle3D 
					with: 0.492304 , -0.0548152 , 0.0818272
					with: 0.31239 , 0.341131 , -0.100929
					with: 0.264498 , 0.34476 , 0.186642);
		add: (Triangle3D 
					with: 0.492304 , -0.0548152 , 0.0818272
					with: 0.264498 , 0.34476 , 0.186642
					with: 0.375691 , 0.100052 , 0.299591);
		add: (Triangle3D 
					with: 0.492304 , -0.0548152 , 0.0818272
					with: 0.375691 , 0.100052 , 0.299591
					with: 0.354182 , -0.190708 , 0.299678);
		add: (Triangle3D 
					with: 0.375691 , 0.100052 , 0.299591
					with: 0.264498 , 0.34476 , 0.186642
					with: 0.126375 , 0.208868 , 0.404493);
		add: (Triangle3D 
					with: -0.0141298 , 0.239379 , -0.461098
					with: 0.105763 , -0.0263832 , -0.461185
					with: -0.1832 , 0.00318993 , -0.486274);
		add: (Triangle3D 
					with: -0.1832 , 0.00318993 , -0.486274
					with: 0.105763 , -0.0263832 , -0.461185
					with: -0.0698316 , -0.249891 , -0.396266);
		add: (Triangle3D 
					with: -0.1832 , 0.00318993 , -0.486274
					with: -0.0698316 , -0.249891 , -0.396266
					with: -0.348131 , -0.185758 , -0.337613);
		add: (Triangle3D 
					with: -0.348131 , -0.185758 , -0.337613
					with: -0.0698316 , -0.249891 , -0.396266
					with: -0.207954 , -0.385783 , -0.178415);
		add: (Triangle3D 
					with: -0.348131 , -0.185758 , -0.337613
					with: -0.207954 , -0.385783 , -0.178415
					with: -0.445925 , -0.255293 , -0.0718972);
		add: (Triangle3D 
					with: -0.445925 , -0.255293 , -0.0718972
					with: -0.207954 , -0.385783 , -0.178415
					with: -0.255847 , -0.382154 , 0.109156);
		add: (Triangle3D 
					with: -0.445925 , -0.255293 , -0.0718972
					with: -0.255847 , -0.382154 , 0.109156
					with: -0.439228 , -0.178855 , 0.209379);
		add: (Triangle3D 
					with: -0.439228 , -0.178855 , 0.209379
					with: -0.255847 , -0.382154 , 0.109156
					with: -0.195216 , -0.24039 , 0.356604);
		add: (Triangle3D 
					with: -0.439228 , -0.178855 , 0.209379
					with: -0.195216 , -0.24039 , 0.356604
					with: -0.330598 , 0.0143588 , 0.398777);
		add: (Triangle3D 
					with: -0.330598 , 0.0143588 , 0.398777
					with: -0.195216 , -0.24039 , 0.356604
					with: -0.04922 , -0.0146396 , 0.469412);
		add: (Triangle3D 
					with: -0.330598 , 0.0143588 , 0.398777
					with: -0.04922 , -0.0146396 , 0.469412
					with: -0.161528 , 0.250548 , 0.423953);
		add: (Triangle3D 
					with: -0.161528 , 0.250548 , 0.423953
					with: -0.04922 , -0.0146396 , 0.469412
					with: 0.126375 , 0.208868 , 0.404493);
		add: (Triangle3D 
					with: -0.161528 , 0.250548 , 0.423953
					with: 0.126375 , 0.208868 , 0.404493
					with: 0.00340359 , 0.439495 , 0.275292);
		add: (Triangle3D 
					with: 0.00340359 , 0.439495 , 0.275292
					with: 0.126375 , 0.208868 , 0.404493
					with: 0.264498 , 0.34476 , 0.186642);
		add: (Triangle3D 
					with: 0.00340359 , 0.439495 , 0.275292
					with: 0.264498 , 0.34476 , 0.186642
					with: 0.101197 , 0.50903 , 0.00957625);
		add: (Triangle3D 
					with: 0.101197 , 0.50903 , 0.00957625
					with: 0.264498 , 0.34476 , 0.186642
					with: 0.31239 , 0.341131 , -0.100929);
		add: (Triangle3D 
					with: 0.101197 , 0.50903 , 0.00957625
					with: 0.31239 , 0.341131 , -0.100929
					with: 0.0945004 , 0.432592 , -0.2717);
		add: (Triangle3D 
					with: 0.0945004 , 0.432592 , -0.2717
					with: 0.31239 , 0.341131 , -0.100929
					with: 0.251759 , 0.199367 , -0.348377);
		add: (Triangle3D 
					with: 0.0945004 , 0.432592 , -0.2717
					with: 0.251759 , 0.199367 , -0.348377
					with: -0.0141298 , 0.239379 , -0.461098);
		add: (Triangle3D 
					with: -0.0141298 , 0.239379 , -0.461098
					with: 0.251759 , 0.199367 , -0.348377
					with: 0.105763 , -0.0263832 , -0.461185);
		yourself! !

!Polyhedron class methodsFor: 'factory-square' stamp: 'emm 02/09/2012 23:40'!
gyroelongatedSquareBicupola
	"self gyroelongatedSquareBicupola "

	^(Triangle3DComposite new)
		add: (Triangle3D 
					with: -0.320369 , 0.363299 , -0.130871
					with: 0.0030136 , 0.387673 , -0.318513
					with: -0.0733776 , 0.0645638 , -0.492135);
		add: (Triangle3D 
					with: -0.320369 , 0.363299 , -0.130871
					with: -0.0733776 , 0.0645638 , -0.492135
					with: -0.39676 , 0.0401903 , -0.304493);
		add: (Triangle3D 
					with: 0.0030136 , 0.387673 , -0.318513
					with: -0.320369 , 0.363299 , -0.130871
					with: -0.143943 , 0.458756 , 0.185581);
		add: (Triangle3D 
					with: 0.0030136 , 0.387673 , -0.318513
					with: -0.143943 , 0.458756 , 0.185581
					with: 0.179439 , 0.48313 , -0.00206138);
		add: (Triangle3D 
					with: 0.0030136 , 0.387673 , -0.318513
					with: 0.179439 , 0.48313 , -0.00206138
					with: 0.354089 , 0.271892 , -0.257514);
		add: (Triangle3D 
					with: -0.0733776 , 0.0645638 , -0.492135
					with: 0.0030136 , 0.387673 , -0.318513
					with: 0.354089 , 0.271892 , -0.257514);
		add: (Triangle3D 
					with: -0.0733776 , 0.0645638 , -0.492135
					with: 0.354089 , 0.271892 , -0.257514
					with: 0.277697 , -0.0512171 , -0.431136);
		add: (Triangle3D 
					with: -0.0733776 , 0.0645638 , -0.492135
					with: 0.277697 , -0.0512171 , -0.431136
					with: -0.00498518 , -0.296924 , -0.421223);
		add: (Triangle3D 
					with: -0.39676 , 0.0401903 , -0.304493
					with: -0.0733776 , 0.0645638 , -0.492135
					with: -0.00498518 , -0.296924 , -0.421223);
		add: (Triangle3D 
					with: -0.39676 , 0.0401903 , -0.304493
					with: -0.00498518 , -0.296924 , -0.421223
					with: -0.328367 , -0.321298 , -0.23358);
		add: (Triangle3D 
					with: -0.39676 , 0.0401903 , -0.304493
					with: -0.328367 , -0.321298 , -0.23358
					with: -0.503017 , -0.11006 , 0.021872);
		add: (Triangle3D 
					with: -0.320369 , 0.363299 , -0.130871
					with: -0.39676 , 0.0401903 , -0.304493
					with: -0.503017 , -0.11006 , 0.021872);
		add: (Triangle3D 
					with: -0.320369 , 0.363299 , -0.130871
					with: -0.503017 , -0.11006 , 0.021872
					with: -0.426625 , 0.213049 , 0.195494);
		add: (Triangle3D 
					with: -0.320369 , 0.363299 , -0.130871
					with: -0.426625 , 0.213049 , 0.195494
					with: -0.143943 , 0.458756 , 0.185581);
		add: (Triangle3D 
					with: 0.428804 , -0.110576 , 0.235902
					with: 0.159271 , -0.00944582 , 0.475703
					with: -0.0350579 , -0.317287 , 0.387104);
		add: (Triangle3D 
					with: 0.428804 , -0.110576 , 0.235902
					with: -0.0350579 , -0.317287 , 0.387104
					with: 0.234475 , -0.418417 , 0.147303);
		add: (Triangle3D 
					with: 0.159271 , -0.00944582 , 0.475703
					with: 0.428804 , -0.110576 , 0.235902
					with: 0.443807 , 0.240116 , 0.104868);
		add: (Triangle3D 
					with: 0.159271 , -0.00944582 , 0.475703
					with: 0.443807 , 0.240116 , 0.104868
					with: 0.174274 , 0.341246 , 0.344669);
		add: (Triangle3D 
					with: 0.159271 , -0.00944582 , 0.475703
					with: 0.174274 , 0.341246 , 0.344669
					with: -0.153726 , 0.19508 , 0.451586);
		add: (Triangle3D 
					with: -0.0350579 , -0.317287 , 0.387104
					with: 0.159271 , -0.00944582 , 0.475703
					with: -0.153726 , 0.19508 , 0.451586);
		add: (Triangle3D 
					with: -0.0350579 , -0.317287 , 0.387104
					with: -0.153726 , 0.19508 , 0.451586
					with: -0.348055 , -0.112762 , 0.362987);
		add: (Triangle3D 
					with: -0.0350579 , -0.317287 , 0.387104
					with: -0.348055 , -0.112762 , 0.362987
					with: -0.294879 , -0.401948 , 0.130773);
		add: (Triangle3D 
					with: 0.234475 , -0.418417 , 0.147303
					with: -0.0350579 , -0.317287 , 0.387104
					with: -0.294879 , -0.401948 , 0.130773);
		add: (Triangle3D 
					with: 0.234475 , -0.418417 , 0.147303
					with: -0.294879 , -0.401948 , 0.130773
					with: -0.0253458 , -0.503078 , -0.109027);
		add: (Triangle3D 
					with: 0.234475 , -0.418417 , 0.147303
					with: -0.0253458 , -0.503078 , -0.109027
					with: 0.302654 , -0.356912 , -0.215944);
		add: (Triangle3D 
					with: 0.428804 , -0.110576 , 0.235902
					with: 0.234475 , -0.418417 , 0.147303
					with: 0.302654 , -0.356912 , -0.215944);
		add: (Triangle3D 
					with: 0.428804 , -0.110576 , 0.235902
					with: 0.302654 , -0.356912 , -0.215944
					with: 0.496983 , -0.0490707 , -0.127345);
		add: (Triangle3D 
					with: 0.428804 , -0.110576 , 0.235902
					with: 0.496983 , -0.0490707 , -0.127345
					with: 0.443807 , 0.240116 , 0.104868);
		add: (Triangle3D 
					with: -0.00498518 , -0.296924 , -0.421223
					with: -0.0253458 , -0.503078 , -0.109027
					with: -0.328367 , -0.321298 , -0.23358);
		add: (Triangle3D 
					with: -0.328367 , -0.321298 , -0.23358
					with: -0.0253458 , -0.503078 , -0.109027
					with: -0.294879 , -0.401948 , 0.130773);
		add: (Triangle3D 
					with: -0.328367 , -0.321298 , -0.23358
					with: -0.294879 , -0.401948 , 0.130773
					with: -0.503017 , -0.11006 , 0.021872);
		add: (Triangle3D 
					with: -0.503017 , -0.11006 , 0.021872
					with: -0.294879 , -0.401948 , 0.130773
					with: -0.348055 , -0.112762 , 0.362987);
		add: (Triangle3D 
					with: -0.503017 , -0.11006 , 0.021872
					with: -0.348055 , -0.112762 , 0.362987
					with: -0.426625 , 0.213049 , 0.195494);
		add: (Triangle3D 
					with: -0.426625 , 0.213049 , 0.195494
					with: -0.348055 , -0.112762 , 0.362987
					with: -0.153726 , 0.19508 , 0.451586);
		add: (Triangle3D 
					with: -0.426625 , 0.213049 , 0.195494
					with: -0.153726 , 0.19508 , 0.451586
					with: -0.143943 , 0.458756 , 0.185581);
		add: (Triangle3D 
					with: -0.143943 , 0.458756 , 0.185581
					with: -0.153726 , 0.19508 , 0.451586
					with: 0.174274 , 0.341246 , 0.344669);
		add: (Triangle3D 
					with: -0.143943 , 0.458756 , 0.185581
					with: 0.174274 , 0.341246 , 0.344669
					with: 0.179439 , 0.48313 , -0.00206138);
		add: (Triangle3D 
					with: 0.179439 , 0.48313 , -0.00206138
					with: 0.174274 , 0.341246 , 0.344669
					with: 0.443807 , 0.240116 , 0.104868);
		add: (Triangle3D 
					with: 0.179439 , 0.48313 , -0.00206138
					with: 0.443807 , 0.240116 , 0.104868
					with: 0.354089 , 0.271892 , -0.257514);
		add: (Triangle3D 
					with: 0.354089 , 0.271892 , -0.257514
					with: 0.443807 , 0.240116 , 0.104868
					with: 0.496983 , -0.0490707 , -0.127345);
		add: (Triangle3D 
					with: 0.354089 , 0.271892 , -0.257514
					with: 0.496983 , -0.0490707 , -0.127345
					with: 0.277697 , -0.0512171 , -0.431136);
		add: (Triangle3D 
					with: 0.277697 , -0.0512171 , -0.431136
					with: 0.496983 , -0.0490707 , -0.127345
					with: 0.302654 , -0.356912 , -0.215944);
		add: (Triangle3D 
					with: 0.277697 , -0.0512171 , -0.431136
					with: 0.302654 , -0.356912 , -0.215944
					with: -0.00498518 , -0.296924 , -0.421223);
		add: (Triangle3D 
					with: -0.00498518 , -0.296924 , -0.421223
					with: 0.302654 , -0.356912 , -0.215944
					with: -0.0253458 , -0.503078 , -0.109027);
		yourself! !

!Polyhedron class methodsFor: 'factory-triangular' stamp: 'emm 02/09/2012 23:40'!
gyroelongatedTriangularBicupola
	"self gyroelongatedTriangularBicupola "

	^(Triangle3DComposite new)
		add: (Triangle3D 
					with: 0.0608023 , 0.502304 , -0.0858651
					with: 0.242172 , 0.297402 , -0.341004
					with: -0.129015 , 0.33848 , -0.363546);
		add: (Triangle3D 
					with: 0.242172 , 0.297402 , -0.341004
					with: 0.0608023 , 0.502304 , -0.0858651
					with: 0.209754 , 0.294264 , 0.187097);
		add: (Triangle3D 
					with: 0.242172 , 0.297402 , -0.341004
					with: 0.209754 , 0.294264 , 0.187097
					with: 0.391124 , 0.0893618 , -0.0680418);
		add: (Triangle3D 
					with: 0.242172 , 0.297402 , -0.341004
					with: 0.391124 , 0.0893618 , -0.0680418
					with: 0.201306 , -0.0744624 , -0.345723);
		add: (Triangle3D 
					with: -0.129015 , 0.33848 , -0.363546
					with: 0.242172 , 0.297402 , -0.341004
					with: 0.201306 , -0.0744624 , -0.345723);
		add: (Triangle3D 
					with: -0.129015 , 0.33848 , -0.363546
					with: 0.201306 , -0.0744624 , -0.345723
					with: -0.169881 , -0.0333848 , -0.368265);
		add: (Triangle3D 
					with: -0.129015 , 0.33848 , -0.363546
					with: -0.169881 , -0.0333848 , -0.368265
					with: -0.351251 , 0.171517 , -0.113126);
		add: (Triangle3D 
					with: 0.0608023 , 0.502304 , -0.0858651
					with: -0.129015 , 0.33848 , -0.363546
					with: -0.351251 , 0.171517 , -0.113126);
		add: (Triangle3D 
					with: 0.0608023 , 0.502304 , -0.0858651
					with: -0.351251 , 0.171517 , -0.113126
					with: -0.161434 , 0.335341 , 0.164555);
		add: (Triangle3D 
					with: 0.0608023 , 0.502304 , -0.0858651
					with: -0.161434 , 0.335341 , 0.164555
					with: 0.209754 , 0.294264 , 0.187097);
		add: (Triangle3D 
					with: 0.0467276 , -0.497696 , 0.116167
					with: 0.0516048 , -0.284811 , 0.423791
					with: -0.272292 , -0.355679 , 0.250457);
		add: (Triangle3D 
					with: 0.0516048 , -0.284811 , 0.423791
					with: 0.0467276 , -0.497696 , 0.116167
					with: 0.299083 , -0.272456 , -0.043706);
		add: (Triangle3D 
					with: 0.0516048 , -0.284811 , 0.423791
					with: 0.299083 , -0.272456 , -0.043706
					with: 0.30396 , -0.0595717 , 0.263918);
		add: (Triangle3D 
					with: 0.0516048 , -0.284811 , 0.423791
					with: 0.30396 , -0.0595717 , 0.263918
					with: -0.015059 , 0.0824447 , 0.398207);
		add: (Triangle3D 
					with: -0.272292 , -0.355679 , 0.250457
					with: 0.0516048 , -0.284811 , 0.423791
					with: -0.015059 , 0.0824447 , 0.398207);
		add: (Triangle3D 
					with: -0.272292 , -0.355679 , 0.250457
					with: -0.015059 , 0.0824447 , 0.398207
					with: -0.338955 , 0.011577 , 0.224874);
		add: (Triangle3D 
					with: -0.272292 , -0.355679 , 0.250457
					with: -0.338955 , 0.011577 , 0.224874
					with: -0.343833 , -0.201307 , -0.0827499);
		add: (Triangle3D 
					with: 0.0467276 , -0.497696 , 0.116167
					with: -0.272292 , -0.355679 , 0.250457
					with: -0.343833 , -0.201307 , -0.0827499);
		add: (Triangle3D 
					with: 0.0467276 , -0.497696 , 0.116167
					with: -0.343833 , -0.201307 , -0.0827499
					with: -0.0248134 , -0.343324 , -0.21704);
		add: (Triangle3D 
					with: 0.0467276 , -0.497696 , 0.116167
					with: -0.0248134 , -0.343324 , -0.21704
					with: 0.299083 , -0.272456 , -0.043706);
		add: (Triangle3D 
					with: -0.169881 , -0.0333848 , -0.368265
					with: -0.343833 , -0.201307 , -0.0827499
					with: -0.351251 , 0.171517 , -0.113126);
		add: (Triangle3D 
					with: -0.351251 , 0.171517 , -0.113126
					with: -0.343833 , -0.201307 , -0.0827499
					with: -0.338955 , 0.011577 , 0.224874);
		add: (Triangle3D 
					with: -0.351251 , 0.171517 , -0.113126
					with: -0.338955 , 0.011577 , 0.224874
					with: -0.161434 , 0.335341 , 0.164555);
		add: (Triangle3D 
					with: -0.161434 , 0.335341 , 0.164555
					with: -0.338955 , 0.011577 , 0.224874
					with: -0.015059 , 0.0824447 , 0.398207);
		add: (Triangle3D 
					with: -0.161434 , 0.335341 , 0.164555
					with: -0.015059 , 0.0824447 , 0.398207
					with: 0.209754 , 0.294264 , 0.187097);
		add: (Triangle3D 
					with: 0.209754 , 0.294264 , 0.187097
					with: -0.015059 , 0.0824447 , 0.398207
					with: 0.30396 , -0.0595717 , 0.263918);
		add: (Triangle3D 
					with: 0.209754 , 0.294264 , 0.187097
					with: 0.30396 , -0.0595717 , 0.263918
					with: 0.391124 , 0.0893618 , -0.0680418);
		add: (Triangle3D 
					with: 0.391124 , 0.0893618 , -0.0680418
					with: 0.30396 , -0.0595717 , 0.263918
					with: 0.299083 , -0.272456 , -0.043706);
		add: (Triangle3D 
					with: 0.391124 , 0.0893618 , -0.0680418
					with: 0.299083 , -0.272456 , -0.043706
					with: 0.201306 , -0.0744624 , -0.345723);
		add: (Triangle3D 
					with: 0.201306 , -0.0744624 , -0.345723
					with: 0.299083 , -0.272456 , -0.043706
					with: -0.0248134 , -0.343324 , -0.21704);
		add: (Triangle3D 
					with: 0.201306 , -0.0744624 , -0.345723
					with: -0.0248134 , -0.343324 , -0.21704
					with: -0.169881 , -0.0333848 , -0.368265);
		add: (Triangle3D 
					with: -0.169881 , -0.0333848 , -0.368265
					with: -0.0248134 , -0.343324 , -0.21704
					with: -0.343833 , -0.201307 , -0.0827499);
		yourself! !

!Polyhedron class methodsFor: 'factory-hexagonal' stamp: 'emm 02/09/2012 23:40'!
hexagonalAntiprism
	"self hexagonalAntiprism"

	^(Triangle3DComposite new)
		add: (Triangle3D 
					with: 0.00416668 , -0.48445 , -0.2139
					with: -0.428846 , -0.23445 , -0.2139
					with: -0.428846 , 0.26555 , -0.2139);
		add: (Triangle3D 
					with: 0.00416668 , -0.48445 , -0.2139
					with: -0.428846 , 0.26555 , -0.2139
					with: 0.00416668 , 0.51555 , -0.2139);
		add: (Triangle3D 
					with: 0.00416668 , -0.48445 , -0.2139
					with: 0.00416668 , 0.51555 , -0.2139
					with: 0.437179 , 0.26555 , -0.2139);
		add: (Triangle3D 
					with: 0.00416668 , -0.48445 , -0.2139
					with: 0.437179 , 0.26555 , -0.2139
					with: 0.437179 , -0.23445 , -0.2139);
		add: (Triangle3D 
					with: -0.245833 , -0.417462 , 0.2139
					with: 0.254167 , -0.417462 , 0.2139
					with: 0.504167 , 0.0155502 , 0.2139);
		add: (Triangle3D 
					with: -0.245833 , -0.417462 , 0.2139
					with: 0.504167 , 0.0155502 , 0.2139
					with: 0.254167 , 0.448563 , 0.2139);
		add: (Triangle3D 
					with: -0.245833 , -0.417462 , 0.2139
					with: 0.254167 , 0.448563 , 0.2139
					with: -0.245833 , 0.448563 , 0.2139);
		add: (Triangle3D 
					with: -0.245833 , -0.417462 , 0.2139
					with: -0.245833 , 0.448563 , 0.2139
					with: -0.495833 , 0.0155502 , 0.2139);
		add: (Triangle3D 
					with: 0.254167 , 0.448563 , 0.2139
					with: 0.00416668 , 0.51555 , -0.2139
					with: -0.245833 , 0.448563 , 0.2139);
		add: (Triangle3D 
					with: -0.245833 , 0.448563 , 0.2139
					with: 0.00416668 , 0.51555 , -0.2139
					with: -0.428846 , 0.26555 , -0.2139);
		add: (Triangle3D 
					with: -0.245833 , 0.448563 , 0.2139
					with: -0.428846 , 0.26555 , -0.2139
					with: -0.495833 , 0.0155502 , 0.2139);
		add: (Triangle3D 
					with: -0.495833 , 0.0155502 , 0.2139
					with: -0.428846 , 0.26555 , -0.2139
					with: -0.428846 , -0.23445 , -0.2139);
		add: (Triangle3D 
					with: -0.495833 , 0.0155502 , 0.2139
					with: -0.428846 , -0.23445 , -0.2139
					with: -0.245833 , -0.417462 , 0.2139);
		add: (Triangle3D 
					with: -0.245833 , -0.417462 , 0.2139
					with: -0.428846 , -0.23445 , -0.2139
					with: 0.00416668 , -0.48445 , -0.2139);
		add: (Triangle3D 
					with: -0.245833 , -0.417462 , 0.2139
					with: 0.00416668 , -0.48445 , -0.2139
					with: 0.254167 , -0.417462 , 0.2139);
		add: (Triangle3D 
					with: 0.254167 , -0.417462 , 0.2139
					with: 0.00416668 , -0.48445 , -0.2139
					with: 0.437179 , -0.23445 , -0.2139);
		add: (Triangle3D 
					with: 0.254167 , -0.417462 , 0.2139
					with: 0.437179 , -0.23445 , -0.2139
					with: 0.504167 , 0.0155502 , 0.2139);
		add: (Triangle3D 
					with: 0.504167 , 0.0155502 , 0.2139
					with: 0.437179 , -0.23445 , -0.2139
					with: 0.437179 , 0.26555 , -0.2139);
		add: (Triangle3D 
					with: 0.504167 , 0.0155502 , 0.2139
					with: 0.437179 , 0.26555 , -0.2139
					with: 0.254167 , 0.448563 , 0.2139);
		add: (Triangle3D 
					with: 0.254167 , 0.448563 , 0.2139
					with: 0.437179 , 0.26555 , -0.2139
					with: 0.00416668 , 0.51555 , -0.2139);
		yourself! !

!Polyhedron class methodsFor: 'factory-hexagonal' stamp: 'emm 02/09/2012 23:40'!
hexagonalPrism
	"self hexagonalPrism  "

	^(Triangle3DComposite new)
		add: (Triangle3D 
					with: 0.306002 , -0.375062 , 0.0819931
					with: 0.0819931 , -0.375062 , -0.306002
					with: -0.0300115 , 0.0129332 , -0.5);
		add: (Triangle3D 
					with: 0.306002 , -0.375062 , 0.0819931
					with: -0.0300115 , 0.0129332 , -0.5
					with: 0.0819931 , 0.400929 , -0.306002);
		add: (Triangle3D 
					with: 0.306002 , -0.375062 , 0.0819931
					with: 0.0819931 , 0.400929 , -0.306002
					with: 0.306002 , 0.400929 , 0.0819931);
		add: (Triangle3D 
					with: 0.306002 , -0.375062 , 0.0819931
					with: 0.306002 , 0.400929 , 0.0819931
					with: 0.418007 , 0.0129332 , 0.275991);
		add: (Triangle3D 
					with: -0.306002 , -0.375062 , -0.0819931
					with: -0.0819931 , -0.375062 , 0.306002
					with: 0.0300115 , 0.0129332 , 0.5);
		add: (Triangle3D 
					with: -0.306002 , -0.375062 , -0.0819931
					with: 0.0300115 , 0.0129332 , 0.5
					with: -0.0819931 , 0.400929 , 0.306002);
		add: (Triangle3D 
					with: -0.306002 , -0.375062 , -0.0819931
					with: -0.0819931 , 0.400929 , 0.306002
					with: -0.306002 , 0.400929 , -0.0819931);
		add: (Triangle3D 
					with: -0.306002 , -0.375062 , -0.0819931
					with: -0.306002 , 0.400929 , -0.0819931
					with: -0.418007 , 0.0129332 , -0.275991);
		add: (Triangle3D 
					with: -0.306002 , 0.400929 , -0.0819931
					with: 0.0819931 , 0.400929 , -0.306002
					with: -0.0300115 , 0.0129332 , -0.5);
		add: (Triangle3D 
					with: -0.306002 , 0.400929 , -0.0819931
					with: -0.0300115 , 0.0129332 , -0.5
					with: -0.418007 , 0.0129332 , -0.275991);
		add: (Triangle3D 
					with: -0.418007 , 0.0129332 , -0.275991
					with: -0.0300115 , 0.0129332 , -0.5
					with: 0.0819931 , -0.375062 , -0.306002);
		add: (Triangle3D 
					with: -0.418007 , 0.0129332 , -0.275991
					with: 0.0819931 , -0.375062 , -0.306002
					with: -0.306002 , -0.375062 , -0.0819931);
		add: (Triangle3D 
					with: -0.306002 , -0.375062 , -0.0819931
					with: 0.0819931 , -0.375062 , -0.306002
					with: 0.306002 , -0.375062 , 0.0819931);
		add: (Triangle3D 
					with: -0.306002 , -0.375062 , -0.0819931
					with: 0.306002 , -0.375062 , 0.0819931
					with: -0.0819931 , -0.375062 , 0.306002);
		add: (Triangle3D 
					with: -0.0819931 , -0.375062 , 0.306002
					with: 0.306002 , -0.375062 , 0.0819931
					with: 0.418007 , 0.0129332 , 0.275991);
		add: (Triangle3D 
					with: -0.0819931 , -0.375062 , 0.306002
					with: 0.418007 , 0.0129332 , 0.275991
					with: 0.0300115 , 0.0129332 , 0.5);
		add: (Triangle3D 
					with: 0.0300115 , 0.0129332 , 0.5
					with: 0.418007 , 0.0129332 , 0.275991
					with: 0.306002 , 0.400929 , 0.0819931);
		add: (Triangle3D 
					with: 0.0300115 , 0.0129332 , 0.5
					with: 0.306002 , 0.400929 , 0.0819931
					with: -0.0819931 , 0.400929 , 0.306002);
		add: (Triangle3D 
					with: -0.0819931 , 0.400929 , 0.306002
					with: 0.306002 , 0.400929 , 0.0819931
					with: 0.0819931 , 0.400929 , -0.306002);
		add: (Triangle3D 
					with: -0.0819931 , 0.400929 , 0.306002
					with: 0.0819931 , 0.400929 , -0.306002
					with: -0.306002 , 0.400929 , -0.0819931);
		yourself! !

!Polyhedron class methodsFor: 'factory-hexagonal' stamp: 'emm 02/09/2012 23:40'!
hexakisIcosahedron
	"self hexakisIcosahedron"

	^(Triangle3DComposite new)
		add: (Triangle3D 
					with: 0.0458796 , -0.418919 , 0.21296
					with: -0.209353 , -0.366618 , 0.290853
					with: -0.015363 , -0.476647 , 0.0616811);
		add: (Triangle3D 
					with: 0.10266 , -0.320445 , 0.343525
					with: -0.209353 , -0.366618 , 0.290853
					with: 0.0458796 , -0.418919 , 0.21296);
		add: (Triangle3D 
					with: -0.0179608 , -0.220462 , 0.417162
					with: -0.209353 , -0.366618 , 0.290853
					with: 0.10266 , -0.320445 , 0.343525);
		add: (Triangle3D 
					with: -0.136835 , -0.099036 , 0.450224
					with: -0.209353 , -0.366618 , 0.290853
					with: -0.0179608 , -0.220462 , 0.417162);
		add: (Triangle3D 
					with: -0.283649 , -0.114276 , 0.35977
					with: -0.209353 , -0.366618 , 0.290853
					with: -0.136835 , -0.099036 , 0.450224);
		add: (Triangle3D 
					with: -0.402873 , -0.1184 , 0.234324
					with: -0.209353 , -0.366618 , 0.290853
					with: -0.283649 , -0.114276 , 0.35977);
		add: (Triangle3D 
					with: -0.384012 , -0.247106 , 0.120098
					with: -0.209353 , -0.366618 , 0.290853
					with: -0.402873 , -0.1184 , 0.234324);
		add: (Triangle3D 
					with: -0.3278 , -0.351777 , -0.00580859
					with: -0.209353 , -0.366618 , 0.290853
					with: -0.384012 , -0.247106 , 0.120098);
		add: (Triangle3D 
					with: -0.180352 , -0.435386 , 0.0293643
					with: -0.209353 , -0.366618 , 0.290853
					with: -0.3278 , -0.351777 , -0.00580859);
		add: (Triangle3D 
					with: -0.015363 , -0.476647 , 0.0616811
					with: -0.209353 , -0.366618 , 0.290853
					with: -0.180352 , -0.435386 , 0.0293643);
		add: (Triangle3D 
					with: 0.0458796 , -0.418919 , 0.21296
					with: 0.294102 , -0.407216 , 0.102529
					with: 0.10266 , -0.320445 , 0.343525);
		add: (Triangle3D 
					with: -0.015363 , -0.476647 , 0.0616811
					with: 0.294102 , -0.407216 , 0.102529
					with: 0.0458796 , -0.418919 , 0.21296);
		add: (Triangle3D 
					with: 0.0921957 , -0.457364 , -0.0725859
					with: 0.294102 , -0.407216 , 0.102529
					with: -0.015363 , -0.476647 , 0.0616811);
		add: (Triangle3D 
					with: 0.190787 , -0.393594 , -0.199793
					with: 0.294102 , -0.407216 , 0.102529
					with: 0.0921957 , -0.457364 , -0.0725859);
		add: (Triangle3D 
					with: 0.329528 , -0.304644 , -0.146811
					with: 0.294102 , -0.407216 , 0.102529
					with: 0.190787 , -0.393594 , -0.199793);
		add: (Triangle3D 
					with: 0.436218 , -0.186062 , -0.079549
					with: 0.294102 , -0.407216 , 0.102529
					with: 0.329528 , -0.304644 , -0.146811);
		add: (Triangle3D 
					with: 0.429892 , -0.171814 , 0.0928614
					with: 0.294102 , -0.407216 , 0.102529
					with: 0.436218 , -0.186062 , -0.079549);
		add: (Triangle3D 
					with: 0.381752 , -0.140854 , 0.25624
					with: 0.294102 , -0.407216 , 0.102529
					with: 0.429892 , -0.171814 , 0.0928614);
		add: (Triangle3D 
					with: 0.254587 , -0.24244 , 0.315212
					with: 0.294102 , -0.407216 , 0.102529
					with: 0.381752 , -0.140854 , 0.25624);
		add: (Triangle3D 
					with: 0.10266 , -0.320445 , 0.343525
					with: 0.294102 , -0.407216 , 0.102529
					with: 0.254587 , -0.24244 , 0.315212);
		add: (Triangle3D 
					with: -0.0179608 , -0.220462 , 0.417162
					with: 0.176175 , -0.0406227 , 0.479734
					with: -0.136835 , -0.099036 , 0.450224);
		add: (Triangle3D 
					with: 0.10266 , -0.320445 , 0.343525
					with: 0.176175 , -0.0406227 , 0.479734
					with: -0.0179608 , -0.220462 , 0.417162);
		add: (Triangle3D 
					with: 0.254587 , -0.24244 , 0.315212
					with: 0.176175 , -0.0406227 , 0.479734
					with: 0.10266 , -0.320445 , 0.343525);
		add: (Triangle3D 
					with: 0.381752 , -0.140854 , 0.25624
					with: 0.176175 , -0.0406227 , 0.479734
					with: 0.254587 , -0.24244 , 0.315212);
		add: (Triangle3D 
					with: 0.366051 , 0.0266435 , 0.297064
					with: 0.176175 , -0.0406227 , 0.479734
					with: 0.381752 , -0.140854 , 0.25624);
		add: (Triangle3D 
					with: 0.314746 , 0.191549 , 0.308994
					with: 0.176175 , -0.0406227 , 0.479734
					with: 0.366051 , 0.0266435 , 0.297064);
		add: (Triangle3D 
					with: 0.162392 , 0.214924 , 0.387798
					with: 0.176175 , -0.0406227 , 0.479734
					with: 0.314746 , 0.191549 , 0.308994);
		add: (Triangle3D 
					with: -0.00575809 , 0.217394 , 0.428882
					with: 0.176175 , -0.0406227 , 0.479734
					with: 0.162392 , 0.214924 , 0.387798);
		add: (Triangle3D 
					with: -0.074941 , 0.062204 , 0.462022
					with: 0.176175 , -0.0406227 , 0.479734
					with: -0.00575809 , 0.217394 , 0.428882);
		add: (Triangle3D 
					with: -0.136835 , -0.099036 , 0.450224
					with: 0.176175 , -0.0406227 , 0.479734
					with: -0.074941 , 0.062204 , 0.462022);
		add: (Triangle3D 
					with: -0.283649 , -0.114276 , 0.35977
					with: -0.314607 , 0.155527 , 0.37372
					with: -0.402873 , -0.1184 , 0.234324);
		add: (Triangle3D 
					with: -0.136835 , -0.099036 , 0.450224
					with: -0.314607 , 0.155527 , 0.37372
					with: -0.283649 , -0.114276 , 0.35977);
		add: (Triangle3D 
					with: -0.074941 , 0.062204 , 0.462022
					with: -0.314607 , 0.155527 , 0.37372
					with: -0.136835 , -0.099036 , 0.450224);
		add: (Triangle3D 
					with: -0.00575809 , 0.217394 , 0.428882
					with: -0.314607 , 0.155527 , 0.37372
					with: -0.074941 , 0.062204 , 0.462022);
		add: (Triangle3D 
					with: -0.103296 , 0.32111 , 0.330406
					with: -0.314607 , 0.155527 , 0.37372
					with: -0.00575809 , 0.217394 , 0.428882);
		add: (Triangle3D 
					with: -0.190787 , 0.393594 , 0.199793
					with: -0.314607 , 0.155527 , 0.37372
					with: -0.103296 , 0.32111 , 0.330406);
		add: (Triangle3D 
					with: -0.329529 , 0.304644 , 0.146811
					with: -0.314607 , 0.155527 , 0.37372
					with: -0.190787 , 0.393594 , 0.199793);
		add: (Triangle3D 
					with: -0.436218 , 0.186062 , 0.079549
					with: -0.314607 , 0.155527 , 0.37372
					with: -0.329529 , 0.304644 , 0.146811);
		add: (Triangle3D 
					with: -0.440992 , 0.0355605 , 0.164959
					with: -0.314607 , 0.155527 , 0.37372
					with: -0.436218 , 0.186062 , 0.079549);
		add: (Triangle3D 
					with: -0.402873 , -0.1184 , 0.234324
					with: -0.314607 , 0.155527 , 0.37372
					with: -0.440992 , 0.0355605 , 0.164959);
		add: (Triangle3D 
					with: -0.384012 , -0.247106 , 0.120098
					with: -0.5 , -0.089839 , -0.0690057
					with: -0.3278 , -0.351777 , -0.00580859);
		add: (Triangle3D 
					with: -0.402873 , -0.1184 , 0.234324
					with: -0.5 , -0.089839 , -0.0690057
					with: -0.384012 , -0.247106 , 0.120098);
		add: (Triangle3D 
					with: -0.440992 , 0.0355605 , 0.164959
					with: -0.5 , -0.089839 , -0.0690057
					with: -0.402873 , -0.1184 , 0.234324);
		add: (Triangle3D 
					with: -0.436218 , 0.186062 , 0.079549
					with: -0.5 , -0.089839 , -0.0690057
					with: -0.440992 , 0.0355605 , 0.164959);
		add: (Triangle3D 
					with: -0.429892 , 0.171814 , -0.0928613
					with: -0.5 , -0.089839 , -0.0690057
					with: -0.436218 , 0.186062 , 0.079549);
		add: (Triangle3D 
					with: -0.381752 , 0.140854 , -0.25624
					with: -0.5 , -0.089839 , -0.0690057
					with: -0.429892 , 0.171814 , -0.0928613);
		add: (Triangle3D 
					with: -0.366051 , -0.0266435 , -0.297064
					with: -0.5 , -0.089839 , -0.0690057
					with: -0.381752 , 0.140854 , -0.25624);
		add: (Triangle3D 
					with: -0.314746 , -0.191549 , -0.308994
					with: -0.5 , -0.089839 , -0.0690057
					with: -0.366051 , -0.0266435 , -0.297064);
		add: (Triangle3D 
					with: -0.337696 , -0.28555 , -0.165447
					with: -0.5 , -0.089839 , -0.0690057
					with: -0.314746 , -0.191549 , -0.308994);
		add: (Triangle3D 
					with: -0.3278 , -0.351777 , -0.00580859
					with: -0.5 , -0.089839 , -0.0690057
					with: -0.337696 , -0.28555 , -0.165447);
		add: (Triangle3D 
					with: -0.180352 , -0.435386 , 0.0293643
					with: -0.123797 , -0.437633 , -0.236611
					with: -0.015363 , -0.476647 , 0.0616811);
		add: (Triangle3D 
					with: -0.3278 , -0.351777 , -0.00580859
					with: -0.123797 , -0.437633 , -0.236611
					with: -0.180352 , -0.435386 , 0.0293643);
		add: (Triangle3D 
					with: -0.337696 , -0.28555 , -0.165447
					with: -0.123797 , -0.437633 , -0.236611
					with: -0.3278 , -0.351777 , -0.00580859);
		add: (Triangle3D 
					with: -0.314746 , -0.191549 , -0.308994
					with: -0.123797 , -0.437633 , -0.236611
					with: -0.337696 , -0.28555 , -0.165447);
		add: (Triangle3D 
					with: -0.162392 , -0.214924 , -0.387798
					with: -0.123797 , -0.437633 , -0.236611
					with: -0.314746 , -0.191549 , -0.308994);
		add: (Triangle3D 
					with: 0.00575813 , -0.217394 , -0.428882
					with: -0.123797 , -0.437633 , -0.236611
					with: -0.162392 , -0.214924 , -0.387798);
		add: (Triangle3D 
					with: 0.103296 , -0.32111 , -0.330406
					with: -0.123797 , -0.437633 , -0.236611
					with: 0.00575813 , -0.217394 , -0.428882);
		add: (Triangle3D 
					with: 0.190787 , -0.393594 , -0.199793
					with: -0.123797 , -0.437633 , -0.236611
					with: 0.103296 , -0.32111 , -0.330406);
		add: (Triangle3D 
					with: 0.0921957 , -0.457364 , -0.0725859
					with: -0.123797 , -0.437633 , -0.236611
					with: 0.190787 , -0.393594 , -0.199793);
		add: (Triangle3D 
					with: -0.015363 , -0.476647 , 0.0616811
					with: -0.123797 , -0.437633 , -0.236611
					with: 0.0921957 , -0.457364 , -0.0725859);
		add: (Triangle3D 
					with: 0.283649 , 0.114276 , -0.35977
					with: 0.314607 , -0.155527 , -0.37372
					with: 0.136835 , 0.099036 , -0.450224);
		add: (Triangle3D 
					with: 0.402873 , 0.1184 , -0.234324
					with: 0.314607 , -0.155527 , -0.37372
					with: 0.283649 , 0.114276 , -0.35977);
		add: (Triangle3D 
					with: 0.440992 , -0.0355606 , -0.164959
					with: 0.314607 , -0.155527 , -0.37372
					with: 0.402873 , 0.1184 , -0.234324);
		add: (Triangle3D 
					with: 0.436218 , -0.186062 , -0.079549
					with: 0.314607 , -0.155527 , -0.37372
					with: 0.440992 , -0.0355606 , -0.164959);
		add: (Triangle3D 
					with: 0.329528 , -0.304644 , -0.146811
					with: 0.314607 , -0.155527 , -0.37372
					with: 0.436218 , -0.186062 , -0.079549);
		add: (Triangle3D 
					with: 0.190787 , -0.393594 , -0.199793
					with: 0.314607 , -0.155527 , -0.37372
					with: 0.329528 , -0.304644 , -0.146811);
		add: (Triangle3D 
					with: 0.103296 , -0.32111 , -0.330406
					with: 0.314607 , -0.155527 , -0.37372
					with: 0.190787 , -0.393594 , -0.199793);
		add: (Triangle3D 
					with: 0.00575813 , -0.217394 , -0.428882
					with: 0.314607 , -0.155527 , -0.37372
					with: 0.103296 , -0.32111 , -0.330406);
		add: (Triangle3D 
					with: 0.074941 , -0.062204 , -0.462022
					with: 0.314607 , -0.155527 , -0.37372
					with: 0.00575813 , -0.217394 , -0.428882);
		add: (Triangle3D 
					with: 0.136835 , 0.099036 , -0.450224
					with: 0.314607 , -0.155527 , -0.37372
					with: 0.074941 , -0.062204 , -0.462022);
		add: (Triangle3D 
					with: 0.0179608 , 0.220462 , -0.417162
					with: -0.176175 , 0.0406226 , -0.479734
					with: -0.10266 , 0.320445 , -0.343525);
		add: (Triangle3D 
					with: 0.136835 , 0.099036 , -0.450224
					with: -0.176175 , 0.0406226 , -0.479734
					with: 0.0179608 , 0.220462 , -0.417162);
		add: (Triangle3D 
					with: 0.074941 , -0.062204 , -0.462022
					with: -0.176175 , 0.0406226 , -0.479734
					with: 0.136835 , 0.099036 , -0.450224);
		add: (Triangle3D 
					with: 0.00575813 , -0.217394 , -0.428882
					with: -0.176175 , 0.0406226 , -0.479734
					with: 0.074941 , -0.062204 , -0.462022);
		add: (Triangle3D 
					with: -0.162392 , -0.214924 , -0.387798
					with: -0.176175 , 0.0406226 , -0.479734
					with: 0.00575813 , -0.217394 , -0.428882);
		add: (Triangle3D 
					with: -0.314746 , -0.191549 , -0.308994
					with: -0.176175 , 0.0406226 , -0.479734
					with: -0.162392 , -0.214924 , -0.387798);
		add: (Triangle3D 
					with: -0.366051 , -0.0266435 , -0.297064
					with: -0.176175 , 0.0406226 , -0.479734
					with: -0.314746 , -0.191549 , -0.308994);
		add: (Triangle3D 
					with: -0.381752 , 0.140854 , -0.25624
					with: -0.176175 , 0.0406226 , -0.479734
					with: -0.366051 , -0.0266435 , -0.297064);
		add: (Triangle3D 
					with: -0.254587 , 0.24244 , -0.315212
					with: -0.176175 , 0.0406226 , -0.479734
					with: -0.381752 , 0.140854 , -0.25624);
		add: (Triangle3D 
					with: -0.10266 , 0.320445 , -0.343525
					with: -0.176175 , 0.0406226 , -0.479734
					with: -0.254587 , 0.24244 , -0.315212);
		add: (Triangle3D 
					with: -0.0458798 , 0.418919 , -0.21296
					with: -0.294102 , 0.407215 , -0.102529
					with: 0.0153631 , 0.476647 , -0.0616812);
		add: (Triangle3D 
					with: -0.10266 , 0.320445 , -0.343525
					with: -0.294102 , 0.407215 , -0.102529
					with: -0.0458798 , 0.418919 , -0.21296);
		add: (Triangle3D 
					with: -0.254587 , 0.24244 , -0.315212
					with: -0.294102 , 0.407215 , -0.102529
					with: -0.10266 , 0.320445 , -0.343525);
		add: (Triangle3D 
					with: -0.381752 , 0.140854 , -0.25624
					with: -0.294102 , 0.407215 , -0.102529
					with: -0.254587 , 0.24244 , -0.315212);
		add: (Triangle3D 
					with: -0.429892 , 0.171814 , -0.0928613
					with: -0.294102 , 0.407215 , -0.102529
					with: -0.381752 , 0.140854 , -0.25624);
		add: (Triangle3D 
					with: -0.436218 , 0.186062 , 0.079549
					with: -0.294102 , 0.407215 , -0.102529
					with: -0.429892 , 0.171814 , -0.0928613);
		add: (Triangle3D 
					with: -0.329529 , 0.304644 , 0.146811
					with: -0.294102 , 0.407215 , -0.102529
					with: -0.436218 , 0.186062 , 0.079549);
		add: (Triangle3D 
					with: -0.190787 , 0.393594 , 0.199793
					with: -0.294102 , 0.407215 , -0.102529
					with: -0.329529 , 0.304644 , 0.146811);
		add: (Triangle3D 
					with: -0.0921957 , 0.457364 , 0.0725858
					with: -0.294102 , 0.407215 , -0.102529
					with: -0.190787 , 0.393594 , 0.199793);
		add: (Triangle3D 
					with: 0.0153631 , 0.476647 , -0.0616812
					with: -0.294102 , 0.407215 , -0.102529
					with: -0.0921957 , 0.457364 , 0.0725858);
		add: (Triangle3D 
					with: 0.180352 , 0.435386 , -0.0293644
					with: 0.123797 , 0.437633 , 0.236611
					with: 0.3278 , 0.351777 , 0.00580864);
		add: (Triangle3D 
					with: 0.0153631 , 0.476647 , -0.0616812
					with: 0.123797 , 0.437633 , 0.236611
					with: 0.180352 , 0.435386 , -0.0293644);
		add: (Triangle3D 
					with: -0.0921957 , 0.457364 , 0.0725858
					with: 0.123797 , 0.437633 , 0.236611
					with: 0.0153631 , 0.476647 , -0.0616812);
		add: (Triangle3D 
					with: -0.190787 , 0.393594 , 0.199793
					with: 0.123797 , 0.437633 , 0.236611
					with: -0.0921957 , 0.457364 , 0.0725858);
		add: (Triangle3D 
					with: -0.103296 , 0.32111 , 0.330406
					with: 0.123797 , 0.437633 , 0.236611
					with: -0.190787 , 0.393594 , 0.199793);
		add: (Triangle3D 
					with: -0.00575809 , 0.217394 , 0.428882
					with: 0.123797 , 0.437633 , 0.236611
					with: -0.103296 , 0.32111 , 0.330406);
		add: (Triangle3D 
					with: 0.162392 , 0.214924 , 0.387798
					with: 0.123797 , 0.437633 , 0.236611
					with: -0.00575809 , 0.217394 , 0.428882);
		add: (Triangle3D 
					with: 0.314746 , 0.191549 , 0.308994
					with: 0.123797 , 0.437633 , 0.236611
					with: 0.162392 , 0.214924 , 0.387798);
		add: (Triangle3D 
					with: 0.337696 , 0.28555 , 0.165447
					with: 0.123797 , 0.437633 , 0.236611
					with: 0.314746 , 0.191549 , 0.308994);
		add: (Triangle3D 
					with: 0.3278 , 0.351777 , 0.00580864
					with: 0.123797 , 0.437633 , 0.236611
					with: 0.337696 , 0.28555 , 0.165447);
		add: (Triangle3D 
					with: 0.384012 , 0.247106 , -0.120098
					with: 0.5 , 0.0898389 , 0.0690056
					with: 0.402873 , 0.1184 , -0.234324);
		add: (Triangle3D 
					with: 0.3278 , 0.351777 , 0.00580864
					with: 0.5 , 0.0898389 , 0.0690056
					with: 0.384012 , 0.247106 , -0.120098);
		add: (Triangle3D 
					with: 0.337696 , 0.28555 , 0.165447
					with: 0.5 , 0.0898389 , 0.0690056
					with: 0.3278 , 0.351777 , 0.00580864);
		add: (Triangle3D 
					with: 0.314746 , 0.191549 , 0.308994
					with: 0.5 , 0.0898389 , 0.0690056
					with: 0.337696 , 0.28555 , 0.165447);
		add: (Triangle3D 
					with: 0.366051 , 0.0266435 , 0.297064
					with: 0.5 , 0.0898389 , 0.0690056
					with: 0.314746 , 0.191549 , 0.308994);
		add: (Triangle3D 
					with: 0.381752 , -0.140854 , 0.25624
					with: 0.5 , 0.0898389 , 0.0690056
					with: 0.366051 , 0.0266435 , 0.297064);
		add: (Triangle3D 
					with: 0.429892 , -0.171814 , 0.0928614
					with: 0.5 , 0.0898389 , 0.0690056
					with: 0.381752 , -0.140854 , 0.25624);
		add: (Triangle3D 
					with: 0.436218 , -0.186062 , -0.079549
					with: 0.5 , 0.0898389 , 0.0690056
					with: 0.429892 , -0.171814 , 0.0928614);
		add: (Triangle3D 
					with: 0.440992 , -0.0355606 , -0.164959
					with: 0.5 , 0.0898389 , 0.0690056
					with: 0.436218 , -0.186062 , -0.079549);
		add: (Triangle3D 
					with: 0.402873 , 0.1184 , -0.234324
					with: 0.5 , 0.0898389 , 0.0690056
					with: 0.440992 , -0.0355606 , -0.164959);
		add: (Triangle3D 
					with: 0.283649 , 0.114276 , -0.35977
					with: 0.209353 , 0.366618 , -0.290853
					with: 0.402873 , 0.1184 , -0.234324);
		add: (Triangle3D 
					with: 0.136835 , 0.099036 , -0.450224
					with: 0.209353 , 0.366618 , -0.290853
					with: 0.283649 , 0.114276 , -0.35977);
		add: (Triangle3D 
					with: 0.0179608 , 0.220462 , -0.417162
					with: 0.209353 , 0.366618 , -0.290853
					with: 0.136835 , 0.099036 , -0.450224);
		add: (Triangle3D 
					with: -0.10266 , 0.320445 , -0.343525
					with: 0.209353 , 0.366618 , -0.290853
					with: 0.0179608 , 0.220462 , -0.417162);
		add: (Triangle3D 
					with: -0.0458798 , 0.418919 , -0.21296
					with: 0.209353 , 0.366618 , -0.290853
					with: -0.10266 , 0.320445 , -0.343525);
		add: (Triangle3D 
					with: 0.0153631 , 0.476647 , -0.0616812
					with: 0.209353 , 0.366618 , -0.290853
					with: -0.0458798 , 0.418919 , -0.21296);
		add: (Triangle3D 
					with: 0.180352 , 0.435386 , -0.0293644
					with: 0.209353 , 0.366618 , -0.290853
					with: 0.0153631 , 0.476647 , -0.0616812);
		add: (Triangle3D 
					with: 0.3278 , 0.351777 , 0.00580864
					with: 0.209353 , 0.366618 , -0.290853
					with: 0.180352 , 0.435386 , -0.0293644);
		add: (Triangle3D 
					with: 0.384012 , 0.247106 , -0.120098
					with: 0.209353 , 0.366618 , -0.290853
					with: 0.3278 , 0.351777 , 0.00580864);
		add: (Triangle3D 
					with: 0.402873 , 0.1184 , -0.234324
					with: 0.209353 , 0.366618 , -0.290853
					with: 0.384012 , 0.247106 , -0.120098);
		yourself! !

!Polyhedron class methodsFor: 'factory-hexagonal' stamp: 'emm 02/09/2012 23:40'!
hexakisOctahedron
	"self hexakisOctahedron"

	^(Triangle3DComposite new)
		add: (Triangle3D 
					with: -0.408185 , 0.158408 , 0.19743
					with: -0.275342 , 0.480483 , -0.00214616
					with: -0.5 , 0.0505645 , -0.0671993);
		add: (Triangle3D 
					with: -0.5 , 0.0505645 , -0.0671993
					with: -0.275342 , 0.480483 , -0.00214616
					with: -0.340768 , 0.194923 , -0.27671);
		add: (Triangle3D 
					with: -0.340768 , 0.194923 , -0.27671
					with: -0.280316 , -0.162641 , -0.449057
					with: -0.5 , 0.0505645 , -0.0671993);
		add: (Triangle3D 
					with: -0.5 , 0.0505645 , -0.0671993
					with: -0.280316 , -0.162641 , -0.449057
					with: -0.411235 , -0.236002 , -0.0766478);
		add: (Triangle3D 
					with: -0.411235 , -0.236002 , -0.0766478
					with: -0.390245 , -0.222183 , 0.324075
					with: -0.5 , 0.0505645 , -0.0671993);
		add: (Triangle3D 
					with: -0.5 , 0.0505645 , -0.0671993
					with: -0.390245 , -0.222183 , 0.324075
					with: -0.408185 , 0.158408 , 0.19743);
		add: (Triangle3D 
					with: 0.0704671 , 0.430924 , -0.200062
					with: 0.390245 , 0.222183 , -0.324075
					with: -0.0874362 , 0.285455 , -0.409809);
		add: (Triangle3D 
					with: -0.0874362 , 0.285455 , -0.409809
					with: 0.390245 , 0.222183 , -0.324075
					with: 0.0674164 , 0.0365154 , -0.474139);
		add: (Triangle3D 
					with: 0.0674164 , 0.0365154 , -0.474139
					with: -0.280316 , -0.162641 , -0.449057
					with: -0.0874362 , 0.285455 , -0.409809);
		add: (Triangle3D 
					with: -0.0874362 , 0.285455 , -0.409809
					with: -0.280316 , -0.162641 , -0.449057
					with: -0.340768 , 0.194923 , -0.27671);
		add: (Triangle3D 
					with: -0.340768 , 0.194923 , -0.27671
					with: -0.275342 , 0.480483 , -0.00214616
					with: -0.0874362 , 0.285455 , -0.409809);
		add: (Triangle3D 
					with: -0.0874362 , 0.285455 , -0.409809
					with: -0.275342 , 0.480483 , -0.00214616
					with: 0.0704671 , 0.430924 , -0.200062);
		add: (Triangle3D 
					with: 0.408185 , -0.158408 , -0.19743
					with: 0.275342 , -0.480483 , 0.00214607
					with: 0.203652 , -0.222508 , -0.40754);
		add: (Triangle3D 
					with: 0.203652 , -0.222508 , -0.40754
					with: 0.275342 , -0.480483 , 0.00214607
					with: -0.00305058 , -0.394409 , -0.274077);
		add: (Triangle3D 
					with: -0.00305058 , -0.394409 , -0.274077
					with: -0.280316 , -0.162641 , -0.449057
					with: 0.203652 , -0.222508 , -0.40754);
		add: (Triangle3D 
					with: 0.203652 , -0.222508 , -0.40754
					with: -0.280316 , -0.162641 , -0.449057
					with: 0.0674164 , 0.0365154 , -0.474139);
		add: (Triangle3D 
					with: 0.0674164 , 0.0365154 , -0.474139
					with: 0.390245 , 0.222183 , -0.324075
					with: 0.203652 , -0.222508 , -0.40754);
		add: (Triangle3D 
					with: 0.203652 , -0.222508 , -0.40754
					with: 0.390245 , 0.222183 , -0.324075
					with: 0.408185 , -0.158408 , -0.19743);
		add: (Triangle3D 
					with: -0.070467 , -0.430924 , 0.200062
					with: -0.390245 , -0.222183 , 0.324075
					with: -0.208911 , -0.457398 , -0.0649303);
		add: (Triangle3D 
					with: -0.208911 , -0.457398 , -0.0649303
					with: -0.390245 , -0.222183 , 0.324075
					with: -0.411235 , -0.236002 , -0.0766478);
		add: (Triangle3D 
					with: -0.411235 , -0.236002 , -0.0766478
					with: -0.280316 , -0.162641 , -0.449057
					with: -0.208911 , -0.457398 , -0.0649303);
		add: (Triangle3D 
					with: -0.208911 , -0.457398 , -0.0649303
					with: -0.280316 , -0.162641 , -0.449057
					with: -0.00305058 , -0.394409 , -0.274077);
		add: (Triangle3D 
					with: -0.00305058 , -0.394409 , -0.274077
					with: 0.275342 , -0.480483 , 0.00214607
					with: -0.208911 , -0.457398 , -0.0649303);
		add: (Triangle3D 
					with: -0.208911 , -0.457398 , -0.0649303
					with: 0.275342 , -0.480483 , 0.00214607
					with: -0.070467 , -0.430924 , 0.200062);
		add: (Triangle3D 
					with: -0.070467 , -0.430924 , 0.200062
					with: 0.275342 , -0.480483 , 0.00214607
					with: 0.0874363 , -0.285455 , 0.409809);
		add: (Triangle3D 
					with: 0.0874363 , -0.285455 , 0.409809
					with: 0.275342 , -0.480483 , 0.00214607
					with: 0.340768 , -0.194923 , 0.27671);
		add: (Triangle3D 
					with: 0.340768 , -0.194923 , 0.27671
					with: 0.280316 , 0.162641 , 0.449057
					with: 0.0874363 , -0.285455 , 0.409809);
		add: (Triangle3D 
					with: 0.0874363 , -0.285455 , 0.409809
					with: 0.280316 , 0.162641 , 0.449057
					with: -0.0674164 , -0.0365153 , 0.474139);
		add: (Triangle3D 
					with: -0.0674164 , -0.0365153 , 0.474139
					with: -0.390245 , -0.222183 , 0.324075
					with: 0.0874363 , -0.285455 , 0.409809);
		add: (Triangle3D 
					with: 0.0874363 , -0.285455 , 0.409809
					with: -0.390245 , -0.222183 , 0.324075
					with: -0.070467 , -0.430924 , 0.200062);
		add: (Triangle3D 
					with: 0.408185 , -0.158408 , -0.19743
					with: 0.390245 , 0.222183 , -0.324075
					with: 0.5 , -0.0505645 , 0.0671994);
		add: (Triangle3D 
					with: 0.5 , -0.0505645 , 0.0671994
					with: 0.390245 , 0.222183 , -0.324075
					with: 0.411235 , 0.236002 , 0.0766477);
		add: (Triangle3D 
					with: 0.411235 , 0.236002 , 0.0766477
					with: 0.280316 , 0.162641 , 0.449057
					with: 0.5 , -0.0505645 , 0.0671994);
		add: (Triangle3D 
					with: 0.5 , -0.0505645 , 0.0671994
					with: 0.280316 , 0.162641 , 0.449057
					with: 0.340768 , -0.194923 , 0.27671);
		add: (Triangle3D 
					with: 0.340768 , -0.194923 , 0.27671
					with: 0.275342 , -0.480483 , 0.00214607
					with: 0.5 , -0.0505645 , 0.0671994);
		add: (Triangle3D 
					with: 0.5 , -0.0505645 , 0.0671994
					with: 0.275342 , -0.480483 , 0.00214607
					with: 0.408185 , -0.158408 , -0.19743);
		add: (Triangle3D 
					with: 0.0704671 , 0.430924 , -0.200062
					with: -0.275342 , 0.480483 , -0.00214616
					with: 0.208911 , 0.457398 , 0.0649305);
		add: (Triangle3D 
					with: 0.208911 , 0.457398 , 0.0649305
					with: -0.275342 , 0.480483 , -0.00214616
					with: 0.00305061 , 0.394409 , 0.274077);
		add: (Triangle3D 
					with: 0.00305061 , 0.394409 , 0.274077
					with: 0.280316 , 0.162641 , 0.449057
					with: 0.208911 , 0.457398 , 0.0649305);
		add: (Triangle3D 
					with: 0.208911 , 0.457398 , 0.0649305
					with: 0.280316 , 0.162641 , 0.449057
					with: 0.411235 , 0.236002 , 0.0766477);
		add: (Triangle3D 
					with: 0.411235 , 0.236002 , 0.0766477
					with: 0.390245 , 0.222183 , -0.324075
					with: 0.208911 , 0.457398 , 0.0649305);
		add: (Triangle3D 
					with: 0.208911 , 0.457398 , 0.0649305
					with: 0.390245 , 0.222183 , -0.324075
					with: 0.0704671 , 0.430924 , -0.200062);
		add: (Triangle3D 
					with: -0.408185 , 0.158408 , 0.19743
					with: -0.390245 , -0.222183 , 0.324075
					with: -0.203653 , 0.222507 , 0.40754);
		add: (Triangle3D 
					with: -0.203653 , 0.222507 , 0.40754
					with: -0.390245 , -0.222183 , 0.324075
					with: -0.0674164 , -0.0365153 , 0.474139);
		add: (Triangle3D 
					with: -0.0674164 , -0.0365153 , 0.474139
					with: 0.280316 , 0.162641 , 0.449057
					with: -0.203653 , 0.222507 , 0.40754);
		add: (Triangle3D 
					with: -0.203653 , 0.222507 , 0.40754
					with: 0.280316 , 0.162641 , 0.449057
					with: 0.00305061 , 0.394409 , 0.274077);
		add: (Triangle3D 
					with: 0.00305061 , 0.394409 , 0.274077
					with: -0.275342 , 0.480483 , -0.00214616
					with: -0.203653 , 0.222507 , 0.40754);
		add: (Triangle3D 
					with: -0.203653 , 0.222507 , 0.40754
					with: -0.275342 , 0.480483 , -0.00214616
					with: -0.408185 , 0.158408 , 0.19743);
		yourself! !

!Polyhedron class methodsFor: 'factory-icosahedron' stamp: 'emm 02/09/2012 23:40'!
icosahedron
	"self icosahedron"

	^(FaceComposite on: ((Triangle3DComposite new)
				add: (Triangle3D 
							with: 0.282144 , 0.388461 , -0.1792
							with: 0.319366 , 0.223764 , 0.332498
							with: 0.5 , -0.0911246 , -0.0657002);
				add: (Triangle3D 
							with: 0.319366 , 0.223764 , 0.332498
							with: -0.164026 , 0.0400002 , 0.483855
							with: 0.224252 , -0.306485 , 0.34409);
				add: (Triangle3D 
							with: 0.282144 , 0.388461 , -0.1792
							with: 0.5 , -0.0911246 , -0.0657002
							with: 0.164026 , -0.0400002 , -0.483855);
				add: (Triangle3D 
							with: 0.5 , -0.0911246 , -0.0657002
							with: 0.224252 , -0.306485 , 0.34409
							with: 0.128246 , -0.469501 , -0.160444);
				add: (Triangle3D 
							with: 0.282144 , 0.388461 , -0.1792
							with: 0.164026 , -0.0400002 , -0.483855
							with: -0.224251 , 0.306485 , -0.34409);
				add: (Triangle3D 
							with: 0.164026 , -0.0400002 , -0.483855
							with: 0.128246 , -0.469501 , -0.160444
							with: -0.319366 , -0.223764 , -0.332498);
				add: (Triangle3D 
							with: 0.282144 , 0.388461 , -0.1792
							with: -0.224251 , 0.306485 , -0.34409
							with: -0.128246 , 0.469501 , 0.160444);
				add: (Triangle3D 
							with: -0.224251 , 0.306485 , -0.34409
							with: -0.319366 , -0.223764 , -0.332498
							with: -0.5 , 0.0911246 , 0.0657002);
				add: (Triangle3D 
							with: 0.282144 , 0.388461 , -0.1792
							with: -0.128246 , 0.469501 , 0.160444
							with: 0.319366 , 0.223764 , 0.332498);
				add: (Triangle3D 
							with: -0.128246 , 0.469501 , 0.160444
							with: -0.5 , 0.0911246 , 0.0657002
							with: -0.164026 , 0.0400002 , 0.483855);
				add: (Triangle3D 
							with: 0.224252 , -0.306485 , 0.34409
							with: 0.5 , -0.0911246 , -0.0657002
							with: 0.319366 , 0.223764 , 0.332498);
				add: (Triangle3D 
							with: -0.282144 , -0.388461 , 0.1792
							with: 0.224252 , -0.306485 , 0.34409
							with: -0.164026 , 0.0400002 , 0.483855);
				add: (Triangle3D 
							with: 0.128246 , -0.469501 , -0.160444
							with: 0.164026 , -0.0400002 , -0.483855
							with: 0.5 , -0.0911246 , -0.0657002);
				add: (Triangle3D 
							with: -0.282144 , -0.388461 , 0.1792
							with: 0.128246 , -0.469501 , -0.160444
							with: 0.224252 , -0.306485 , 0.34409);
				add: (Triangle3D 
							with: -0.319366 , -0.223764 , -0.332498
							with: -0.224251 , 0.306485 , -0.34409
							with: 0.164026 , -0.0400002 , -0.483855);
				add: (Triangle3D 
							with: -0.282144 , -0.388461 , 0.1792
							with: -0.319366 , -0.223764 , -0.332498
							with: 0.128246 , -0.469501 , -0.160444);
				add: (Triangle3D 
							with: -0.5 , 0.0911246 , 0.0657002
							with: -0.128246 , 0.469501 , 0.160444
							with: -0.224251 , 0.306485 , -0.34409);
				add: (Triangle3D 
							with: -0.282144 , -0.388461 , 0.1792
							with: -0.5 , 0.0911246 , 0.0657002
							with: -0.319366 , -0.223764 , -0.332498);
				add: (Triangle3D 
							with: -0.164026 , 0.0400002 , 0.483855
							with: 0.319366 , 0.223764 , 0.332498
							with: -0.128246 , 0.469501 , 0.160444);
				add: (Triangle3D 
							with: -0.282144 , -0.388461 , 0.1792
							with: -0.164026 , 0.0400002 , 0.483855
							with: -0.5 , 0.0911246 , 0.0657002);
				yourself)) 
		reverseOriented! !

!Polyhedron class methodsFor: 'class-initialization' stamp: 'emm 02/09/2012 23:40'!
initialize

	GoldenRatio := 5 sqrt - 1 / 2! !

!Polyhedron class methodsFor: 'factory-dodecahedron' stamp: 'emm 02/09/2012 23:40'!
metabiaugmentedDodecahedron
	"self metabiaugmentedDodecahedron"

	^(Triangle3DComposite new)
		add: (Triangle3D 
					with: -0.430781 , -0.129251 , -0.182054
					with: -0.182621 , -0.316859 , -0.348771
					with: -0.00326294 , -0.500245 , -0.106334);
		add: (Triangle3D 
					with: -0.430781 , -0.129251 , -0.182054
					with: -0.00326294 , -0.500245 , -0.106334
					with: -0.140574 , -0.425975 , 0.210217);
		add: (Triangle3D 
					with: -0.430781 , -0.129251 , -0.182054
					with: -0.140574 , -0.425975 , 0.210217
					with: -0.404795 , -0.196688 , 0.163419);
		add: (Triangle3D 
					with: 0.400426 , -0.24312 , 0.205217
					with: 0.108919 , -0.267063 , 0.402766
					with: -0.140574 , -0.425975 , 0.210217);
		add: (Triangle3D 
					with: 0.400426 , -0.24312 , 0.205217
					with: -0.140574 , -0.425975 , 0.210217
					with: -0.00326294 , -0.500245 , -0.106334);
		add: (Triangle3D 
					with: 0.400426 , -0.24312 , 0.205217
					with: -0.00326294 , -0.500245 , -0.106334
					with: 0.331094 , -0.387234 , -0.109424);
		add: (Triangle3D 
					with: -0.291314 , 0.357161 , 0.0826995
					with: -0.360646 , 0.213046 , -0.231942
					with: -0.430781 , -0.129251 , -0.182054);
		add: (Triangle3D 
					with: -0.291314 , 0.357161 , 0.0826995
					with: -0.430781 , -0.129251 , -0.182054
					with: -0.404795 , -0.196688 , 0.163419);
		add: (Triangle3D 
					with: -0.291314 , 0.357161 , 0.0826995
					with: -0.404795 , -0.196688 , 0.163419
					with: -0.318599 , 0.103931 , 0.327046);
		add: (Triangle3D 
					with: -0.0691389 , 0.236989 , -0.429491
					with: 0.0408867 , -0.0905105 , -0.501696
					with: -0.182621 , -0.316859 , -0.348771);
		add: (Triangle3D 
					with: -0.0691389 , 0.236989 , -0.429491
					with: -0.182621 , -0.316859 , -0.348771
					with: -0.430781 , -0.129251 , -0.182054);
		add: (Triangle3D 
					with: -0.0691389 , 0.236989 , -0.429491
					with: -0.430781 , -0.129251 , -0.182054
					with: -0.360646 , 0.213046 , -0.231942);
		add: (Triangle3D 
					with: 0.35838 , -0.134005 , -0.353771
					with: 0.331094 , -0.387234 , -0.109424
					with: -0.00326294 , -0.500245 , -0.106334);
		add: (Triangle3D 
					with: 0.35838 , -0.134005 , -0.353771
					with: -0.00326294 , -0.500245 , -0.106334
					with: -0.182621 , -0.316859 , -0.348771);
		add: (Triangle3D 
					with: 0.35838 , -0.134005 , -0.353771
					with: -0.182621 , -0.316859 , -0.348771
					with: 0.0408867 , -0.0905105 , -0.501696);
		add: (Triangle3D 
					with: 0.0408867 , -0.0905105 , -0.501696
					with: -0.0691389 , 0.236989 , -0.429491
					with: 0.180354 , 0.395901 , -0.236942);
		add: (Triangle3D 
					with: 0.0408867 , -0.0905105 , -0.501696
					with: 0.180354 , 0.395901 , -0.236942
					with: 0.444575 , 0.166614 , -0.190144);
		add: (Triangle3D 
					with: 0.0408867 , -0.0905105 , -0.501696
					with: 0.444575 , 0.166614 , -0.190144
					with: 0.35838 , -0.134005 , -0.353771);
		add: (Triangle3D 
					with: -0.318599 , 0.103931 , 0.327046
					with: -0.00110634 , 0.0604367 , 0.474971
					with: 0.222401 , 0.286786 , 0.322047);
		add: (Triangle3D 
					with: -0.318599 , 0.103931 , 0.327046
					with: 0.222401 , 0.286786 , 0.322047
					with: 0.043043 , 0.470171 , 0.0796094);
		add: (Triangle3D 
					with: -0.318599 , 0.103931 , 0.327046
					with: 0.043043 , 0.470171 , 0.0796094
					with: -0.291314 , 0.357161 , 0.0826995);
		add: (Triangle3D 
					with: 0.108919 , -0.267063 , 0.402766
					with: 0.400426 , -0.24312 , 0.205217
					with: 0.470562 , 0.0991771 , 0.15533);
		add: (Triangle3D 
					with: 0.108919 , -0.267063 , 0.402766
					with: 0.470562 , 0.0991771 , 0.15533
					with: 0.222401 , 0.286786 , 0.322047);
		add: (Triangle3D 
					with: 0.108919 , -0.267063 , 0.402766
					with: 0.222401 , 0.286786 , 0.322047
					with: -0.00110634 , 0.0604367 , 0.474971);
		add: (Triangle3D 
					with: 0.331094 , -0.387234 , -0.109424
					with: 0.35838 , -0.134005 , -0.353771
					with: 0.444575 , 0.166614 , -0.190144);
		add: (Triangle3D 
					with: 0.331094 , -0.387234 , -0.109424
					with: 0.444575 , 0.166614 , -0.190144
					with: 0.470562 , 0.0991771 , 0.15533);
		add: (Triangle3D 
					with: 0.331094 , -0.387234 , -0.109424
					with: 0.470562 , 0.0991771 , 0.15533
					with: 0.400426 , -0.24312 , 0.205217);
		add: (Triangle3D 
					with: 0.470562 , 0.0991771 , 0.15533
					with: 0.444575 , 0.166614 , -0.190144
					with: 0.180354 , 0.395901 , -0.236942);
		add: (Triangle3D 
					with: 0.470562 , 0.0991771 , 0.15533
					with: 0.180354 , 0.395901 , -0.236942
					with: 0.043043 , 0.470171 , 0.0796094);
		add: (Triangle3D 
					with: 0.470562 , 0.0991771 , 0.15533
					with: 0.043043 , 0.470171 , 0.0796094
					with: 0.222401 , 0.286786 , 0.322047);
		add: (Triangle3D 
					with: -0.155927 , 0.499755 , -0.210409
					with: 0.043043 , 0.470171 , 0.0796094
					with: 0.180354 , 0.395901 , -0.236942);
		add: (Triangle3D 
					with: -0.155927 , 0.499755 , -0.210409
					with: 0.180354 , 0.395901 , -0.236942
					with: -0.0691389 , 0.236989 , -0.429491);
		add: (Triangle3D 
					with: -0.155927 , 0.499755 , -0.210409
					with: -0.291314 , 0.357161 , 0.0826995
					with: 0.043043 , 0.470171 , 0.0796094);
		add: (Triangle3D 
					with: -0.155927 , 0.499755 , -0.210409
					with: -0.360646 , 0.213046 , -0.231942
					with: -0.291314 , 0.357161 , 0.0826995);
		add: (Triangle3D 
					with: -0.360646 , 0.213046 , -0.231942
					with: -0.155927 , 0.499755 , -0.210409
					with: -0.0691389 , 0.236989 , -0.429491);
		add: (Triangle3D 
					with: -0.232024 , -0.206466 , 0.471039
					with: -0.404795 , -0.196688 , 0.163419
					with: -0.140574 , -0.425975 , 0.210217);
		add: (Triangle3D 
					with: -0.232024 , -0.206466 , 0.471039
					with: -0.140574 , -0.425975 , 0.210217
					with: 0.108919 , -0.267063 , 0.402766);
		add: (Triangle3D 
					with: -0.232024 , -0.206466 , 0.471039
					with: -0.318599 , 0.103931 , 0.327046
					with: -0.404795 , -0.196688 , 0.163419);
		add: (Triangle3D 
					with: -0.232024 , -0.206466 , 0.471039
					with: -0.00110634 , 0.0604367 , 0.474971
					with: -0.318599 , 0.103931 , 0.327046);
		add: (Triangle3D 
					with: -0.00110634 , 0.0604367 , 0.474971
					with: -0.232024 , -0.206466 , 0.471039
					with: 0.108919 , -0.267063 , 0.402766);
		yourself! !

!Polyhedron class methodsFor: 'factory-hexagonal' stamp: 'emm 02/09/2012 23:40'!
metabiaugmentedHexagonalPrism
	"self metabiaugmentedHexagonalPrism"

	^(Triangle3DComposite new)
		add: (Triangle3D 
					with: 0.40809 , 0.195709 , 0.17997
					with: 0.177955 , 0.457581 , -0.0273973
					with: -0.222801 , 0.399951 , -0.0521547);
		add: (Triangle3D 
					with: 0.40809 , 0.195709 , 0.17997
					with: -0.222801 , 0.399951 , -0.0521547
					with: -0.393424 , 0.0804489 , 0.130456);
		add: (Triangle3D 
					with: 0.40809 , 0.195709 , 0.17997
					with: -0.393424 , 0.0804489 , 0.130456
					with: -0.16329 , -0.181423 , 0.337823);
		add: (Triangle3D 
					with: 0.40809 , 0.195709 , 0.17997
					with: -0.16329 , -0.181423 , 0.337823
					with: 0.237467 , -0.123793 , 0.362581);
		add: (Triangle3D 
					with: -0.110815 , -0.401772 , 0.00132233
					with: -0.340949 , -0.1399 , -0.206045
					with: -0.170327 , 0.179602 , -0.388656);
		add: (Triangle3D 
					with: -0.110815 , -0.401772 , 0.00132233
					with: -0.170327 , 0.179602 , -0.388656
					with: 0.23043 , 0.237232 , -0.363898);
		add: (Triangle3D 
					with: -0.110815 , -0.401772 , 0.00132233
					with: 0.23043 , 0.237232 , -0.363898
					with: 0.460565 , -0.02464 , -0.15653);
		add: (Triangle3D 
					with: -0.110815 , -0.401772 , 0.00132233
					with: 0.460565 , -0.02464 , -0.15653
					with: 0.289942 , -0.344142 , 0.0260798);
		add: (Triangle3D 
					with: 0.177955 , 0.457581 , -0.0273973
					with: 0.40809 , 0.195709 , 0.17997
					with: 0.460565 , -0.02464 , -0.15653);
		add: (Triangle3D 
					with: 0.177955 , 0.457581 , -0.0273973
					with: 0.460565 , -0.02464 , -0.15653
					with: 0.23043 , 0.237232 , -0.363898);
		add: (Triangle3D 
					with: -0.222801 , 0.399951 , -0.0521547
					with: 0.177955 , 0.457581 , -0.0273973
					with: 0.23043 , 0.237232 , -0.363898);
		add: (Triangle3D 
					with: -0.222801 , 0.399951 , -0.0521547
					with: 0.23043 , 0.237232 , -0.363898
					with: -0.170327 , 0.179602 , -0.388656);
		add: (Triangle3D 
					with: -0.16329 , -0.181423 , 0.337823
					with: -0.393424 , 0.0804489 , 0.130456
					with: -0.340949 , -0.1399 , -0.206045);
		add: (Triangle3D 
					with: -0.16329 , -0.181423 , 0.337823
					with: -0.340949 , -0.1399 , -0.206045
					with: -0.110815 , -0.401772 , 0.00132233);
		add: (Triangle3D 
					with: 0.40809 , 0.195709 , 0.17997
					with: 0.237467 , -0.123793 , 0.362581
					with: 0.289942 , -0.344142 , 0.0260798);
		add: (Triangle3D 
					with: 0.40809 , 0.195709 , 0.17997
					with: 0.289942 , -0.344142 , 0.0260798
					with: 0.460565 , -0.02464 , -0.15653);
		add: (Triangle3D 
					with: -0.222801 , 0.399951 , -0.0521547
					with: -0.539435 , 0.213407 , -0.223865
					with: -0.393424 , 0.0804489 , 0.130456);
		add: (Triangle3D 
					with: -0.222801 , 0.399951 , -0.0521547
					with: -0.170327 , 0.179602 , -0.388656
					with: -0.539435 , 0.213407 , -0.223865);
		add: (Triangle3D 
					with: -0.393424 , 0.0804489 , 0.130456
					with: -0.539435 , 0.213407 , -0.223865
					with: -0.340949 , -0.1399 , -0.206045);
		add: (Triangle3D 
					with: -0.340949 , -0.1399 , -0.206045
					with: -0.539435 , 0.213407 , -0.223865
					with: -0.170327 , 0.179602 , -0.388656);
		add: (Triangle3D 
					with: -0.16329 , -0.181423 , 0.337823
					with: 0.0876217 , -0.500128 , 0.341159
					with: 0.237467 , -0.123793 , 0.362581);
		add: (Triangle3D 
					with: -0.16329 , -0.181423 , 0.337823
					with: -0.110815 , -0.401772 , 0.00132233
					with: 0.0876217 , -0.500128 , 0.341159);
		add: (Triangle3D 
					with: 0.237467 , -0.123793 , 0.362581
					with: 0.0876217 , -0.500128 , 0.341159
					with: 0.289942 , -0.344142 , 0.0260798);
		add: (Triangle3D 
					with: 0.289942 , -0.344142 , 0.0260798
					with: 0.0876217 , -0.500128 , 0.341159
					with: -0.110815 , -0.401772 , 0.00132233);
		yourself! !

!Polyhedron class methodsFor: 'factory-dodecahedron' stamp: 'emm 02/09/2012 23:40'!
metabiaugmentedTruncatedDodecahedron
	"self metabiaugmentedTruncatedDodecahedron"

	^(Triangle3DComposite new)
		addTriangleWith: 0.0963834 , -0.373293 , 0.366369
			with: 0.125519 , -0.459913 , 0.224712
			with: 0.222222 , -0.467314 , 0.0868274;
		addTriangleWith: 0.0963834 , -0.373293 , 0.366369
			with: 0.222222 , -0.467314 , 0.0868274
			with: 0.349555 , -0.392672 , 0.00538186;
		addTriangleWith: 0.0963834 , -0.373293 , 0.366369
			with: 0.349555 , -0.392672 , 0.00538186
			with: 0.458881 , -0.264496 , 0.0114852;
		addTriangleWith: 0.0963834 , -0.373293 , 0.366369
			with: 0.458881 , -0.264496 , 0.0114852
			with: 0.508441 , -0.131745 , 0.102806;
		addTriangleWith: 0.0963834 , -0.373293 , 0.366369
			with: 0.508441 , -0.131745 , 0.102806
			with: 0.479305 , -0.0451253 , 0.244463;
		addTriangleWith: 0.0963834 , -0.373293 , 0.366369
			with: 0.479305 , -0.0451253 , 0.244463
			with: 0.382602 , -0.0377235 , 0.382348;
		addTriangleWith: 0.0963834 , -0.373293 , 0.366369
			with: 0.382602 , -0.0377235 , 0.382348
			with: 0.255269 , -0.112366 , 0.463793;
		addTriangleWith: 0.0963834 , -0.373293 , 0.366369
			with: 0.255269 , -0.112366 , 0.463793
			with: 0.145943 , -0.240542 , 0.45769;
		addTriangleWith: 0.0972716 , -0.091071 , 0.518583
			with: 0.145943 , -0.240542 , 0.45769
			with: 0.255269 , -0.112366 , 0.463793;
		addTriangleWith: -0.368404 , -0.152993 , 0.298366
			with: -0.319732 , -0.302465 , 0.237473
			with: -0.19142 , -0.411563 , 0.230268;
		addTriangleWith: -0.368404 , -0.152993 , 0.298366
			with: -0.19142 , -0.411563 , 0.230268
			with: -0.032478 , -0.438617 , 0.279502;
		addTriangleWith: -0.368404 , -0.152993 , 0.298366
			with: -0.032478 , -0.438617 , 0.279502
			with: 0.0963834 , -0.373293 , 0.366369;
		addTriangleWith: -0.368404 , -0.152993 , 0.298366
			with: 0.0963834 , -0.373293 , 0.366369
			with: 0.145943 , -0.240542 , 0.45769;
		addTriangleWith: -0.368404 , -0.152993 , 0.298366
			with: 0.145943 , -0.240542 , 0.45769
			with: 0.0972716 , -0.091071 , 0.518583;
		addTriangleWith: -0.368404 , -0.152993 , 0.298366
			with: 0.0972716 , -0.091071 , 0.518583
			with: -0.0310408 , 0.0180277 , 0.525788;
		addTriangleWith: -0.368404 , -0.152993 , 0.298366
			with: -0.0310408 , 0.0180277 , 0.525788
			with: -0.189983 , 0.0450818 , 0.476554;
		addTriangleWith: -0.368404 , -0.152993 , 0.298366
			with: -0.189983 , 0.0450818 , 0.476554
			with: -0.318844 , -0.0202425 , 0.389686;
		addTriangleWith: -0.0806572 , 0.173258 , 0.482657
			with: -0.189983 , 0.0450818 , 0.476554
			with: -0.0310408 , 0.0180277 , 0.525788;
		addTriangleWith: -0.032478 , -0.438617 , 0.279502
			with: 0.125519 , -0.459913 , 0.224712
			with: 0.0963834 , -0.373293 , 0.366369;
		addTriangleWith: -0.195422 , -0.387168 , -0.210382
			with: -0.0374249 , -0.408463 , -0.265171
			with: 0.121517 , -0.435517 , -0.215937;
		addTriangleWith: -0.195422 , -0.387168 , -0.210382
			with: 0.121517 , -0.435517 , -0.215937
			with: 0.220694 , -0.457996 , -0.0814858;
		addTriangleWith: -0.195422 , -0.387168 , -0.210382
			with: 0.220694 , -0.457996 , -0.0814858
			with: 0.222222 , -0.467314 , 0.0868274;
		addTriangleWith: -0.195422 , -0.387168 , -0.210382
			with: 0.222222 , -0.467314 , 0.0868274
			with: 0.125519 , -0.459913 , 0.224712;
		addTriangleWith: -0.195422 , -0.387168 , -0.210382
			with: 0.125519 , -0.459913 , 0.224712
			with: -0.032478 , -0.438617 , 0.279502;
		addTriangleWith: -0.195422 , -0.387168 , -0.210382
			with: -0.032478 , -0.438617 , 0.279502
			with: -0.19142 , -0.411563 , 0.230268;
		addTriangleWith: -0.195422 , -0.387168 , -0.210382
			with: -0.19142 , -0.411563 , 0.230268
			with: -0.290596 , -0.389084 , 0.095816;
		addTriangleWith: -0.195422 , -0.387168 , -0.210382
			with: -0.290596 , -0.389084 , 0.095816
			with: -0.292125 , -0.379766 , -0.0724972;
		addTriangleWith: -0.319732 , -0.302465 , 0.237473
			with: -0.290596 , -0.389084 , 0.095816
			with: -0.19142 , -0.411563 , 0.230268;
		addTriangleWith: 0.220694 , -0.457996 , -0.0814858
			with: 0.349555 , -0.392672 , 0.00538186
			with: 0.222222 , -0.467314 , 0.0868274;
		addTriangleWith: 0.247265 , -0.0635748 , -0.417506
			with: 0.376126 , 0.00174962 , -0.330638
			with: 0.475302 , -0.0207297 , -0.196187;
		addTriangleWith: 0.247265 , -0.0635748 , -0.417506
			with: 0.475302 , -0.0207297 , -0.196187
			with: 0.506912 , -0.122426 , -0.0655072;
		addTriangleWith: 0.247265 , -0.0635748 , -0.417506
			with: 0.506912 , -0.122426 , -0.0655072
			with: 0.458881 , -0.264496 , 0.0114852;
		addTriangleWith: 0.247265 , -0.0635748 , -0.417506
			with: 0.458881 , -0.264496 , 0.0114852
			with: 0.349555 , -0.392672 , 0.00538186;
		addTriangleWith: 0.247265 , -0.0635748 , -0.417506
			with: 0.349555 , -0.392672 , 0.00538186
			with: 0.220694 , -0.457996 , -0.0814858;
		addTriangleWith: 0.247265 , -0.0635748 , -0.417506
			with: 0.220694 , -0.457996 , -0.0814858
			with: 0.121517 , -0.435517 , -0.215937;
		addTriangleWith: 0.247265 , -0.0635748 , -0.417506
			with: 0.121517 , -0.435517 , -0.215937
			with: 0.0899078 , -0.33382 , -0.346617;
		addTriangleWith: 0.247265 , -0.0635748 , -0.417506
			with: 0.0899078 , -0.33382 , -0.346617
			with: 0.137939 , -0.191751 , -0.423609;
		addTriangleWith: -0.0374249 , -0.408463 , -0.265171
			with: 0.0899078 , -0.33382 , -0.346617
			with: 0.121517 , -0.435517 , -0.215937;
		addTriangleWith: 0.506912 , -0.122426 , -0.0655072
			with: 0.508441 , -0.131745 , 0.102806
			with: 0.458881 , -0.264496 , 0.0114852;
		addTriangleWith: 0.347878 , 0.370591 , -0.0367679
			with: 0.349407 , 0.361273 , 0.131545
			with: 0.381016 , 0.259576 , 0.262225;
		addTriangleWith: 0.347878 , 0.370591 , -0.0367679
			with: 0.381016 , 0.259576 , 0.262225
			with: 0.430633 , 0.104346 , 0.305356;
		addTriangleWith: 0.347878 , 0.370591 , -0.0367679
			with: 0.430633 , 0.104346 , 0.305356
			with: 0.479305 , -0.0451253 , 0.244463;
		addTriangleWith: 0.347878 , 0.370591 , -0.0367679
			with: 0.479305 , -0.0451253 , 0.244463
			with: 0.508441 , -0.131745 , 0.102806;
		addTriangleWith: 0.347878 , 0.370591 , -0.0367679
			with: 0.508441 , -0.131745 , 0.102806
			with: 0.506912 , -0.122426 , -0.0655072;
		addTriangleWith: 0.347878 , 0.370591 , -0.0367679
			with: 0.506912 , -0.122426 , -0.0655072
			with: 0.475302 , -0.0207297 , -0.196187;
		addTriangleWith: 0.347878 , 0.370591 , -0.0367679
			with: 0.475302 , -0.0207297 , -0.196187
			with: 0.425686 , 0.134501 , -0.239317;
		addTriangleWith: 0.347878 , 0.370591 , -0.0367679
			with: 0.425686 , 0.134501 , -0.239317
			with: 0.377014 , 0.283972 , -0.178425;
		addTriangleWith: 0.376126 , 0.00174962 , -0.330638
			with: 0.425686 , 0.134501 , -0.239317
			with: 0.475302 , -0.0207297 , -0.196187;
		addTriangleWith: 0.430633 , 0.104346 , 0.305356
			with: 0.382602 , -0.0377235 , 0.382348
			with: 0.479305 , -0.0451253 , 0.244463;
		addTriangleWith: -0.032626 , 0.315327 , 0.405665
			with: -0.0806572 , 0.173258 , 0.482657
			with: -0.0310408 , 0.0180277 , 0.525788;
		addTriangleWith: -0.032626 , 0.315327 , 0.405665
			with: -0.0310408 , 0.0180277 , 0.525788
			with: 0.0972716 , -0.091071 , 0.518583;
		addTriangleWith: -0.032626 , 0.315327 , 0.405665
			with: 0.0972716 , -0.091071 , 0.518583
			with: 0.255269 , -0.112366 , 0.463793;
		addTriangleWith: -0.032626 , 0.315327 , 0.405665
			with: 0.255269 , -0.112366 , 0.463793
			with: 0.382602 , -0.0377235 , 0.382348;
		addTriangleWith: -0.032626 , 0.315327 , 0.405665
			with: 0.382602 , -0.0377235 , 0.382348
			with: 0.430633 , 0.104346 , 0.305356;
		addTriangleWith: -0.032626 , 0.315327 , 0.405665
			with: 0.430633 , 0.104346 , 0.305356
			with: 0.381016 , 0.259576 , 0.262225;
		addTriangleWith: -0.032626 , 0.315327 , 0.405665
			with: 0.381016 , 0.259576 , 0.262225
			with: 0.252704 , 0.368675 , 0.26943;
		addTriangleWith: -0.032626 , 0.315327 , 0.405665
			with: 0.252704 , 0.368675 , 0.26943
			with: 0.0947067 , 0.38997 , 0.324219;
		addTriangleWith: 0.349407 , 0.361273 , 0.131545
			with: 0.252704 , 0.368675 , 0.26943
			with: 0.381016 , 0.259576 , 0.262225;
		addTriangleWith: -0.292273 , 0.374179 , 0.0536663
			with: -0.16494 , 0.448821 , -0.0277793
			with: -0.0682375 , 0.44142 , -0.165664;
		addTriangleWith: -0.292273 , 0.374179 , 0.0536663
			with: -0.0682375 , 0.44142 , -0.165664
			with: -0.0391015 , 0.3548 , -0.307321;
		addTriangleWith: -0.292273 , 0.374179 , 0.0536663
			with: -0.0391015 , 0.3548 , -0.307321
			with: -0.0886614 , 0.222049 , -0.398642;
		addTriangleWith: -0.292273 , 0.374179 , 0.0536663
			with: -0.0886614 , 0.222049 , -0.398642
			with: -0.197987 , 0.0938731 , -0.404745;
		addTriangleWith: -0.292273 , 0.374179 , 0.0536663
			with: -0.197987 , 0.0938731 , -0.404745
			with: -0.32532 , 0.0192306 , -0.3233;
		addTriangleWith: -0.292273 , 0.374179 , 0.0536663
			with: -0.32532 , 0.0192306 , -0.3233
			with: -0.422023 , 0.0266324 , -0.185415;
		addTriangleWith: -0.292273 , 0.374179 , 0.0536663
			with: -0.422023 , 0.0266324 , -0.185415
			with: -0.451159 , 0.113252 , -0.0437579;
		addTriangleWith: -0.292273 , 0.374179 , 0.0536663
			with: -0.451159 , 0.113252 , -0.0437579
			with: -0.401599 , 0.246003 , 0.047563;
		addTriangleWith: -0.44963 , 0.103933 , 0.124555
			with: -0.401599 , 0.246003 , 0.047563
			with: -0.451159 , 0.113252 , -0.0437579;
		addTriangleWith: -0.0806572 , 0.173258 , 0.482657
			with: -0.032626 , 0.315327 , 0.405665
			with: -0.0642354 , 0.417024 , 0.274985;
		addTriangleWith: -0.0806572 , 0.173258 , 0.482657
			with: -0.0642354 , 0.417024 , 0.274985
			with: -0.163412 , 0.439503 , 0.140534;
		addTriangleWith: -0.0806572 , 0.173258 , 0.482657
			with: -0.163412 , 0.439503 , 0.140534
			with: -0.292273 , 0.374179 , 0.0536663;
		addTriangleWith: -0.0806572 , 0.173258 , 0.482657
			with: -0.292273 , 0.374179 , 0.0536663
			with: -0.401599 , 0.246003 , 0.047563;
		addTriangleWith: -0.0806572 , 0.173258 , 0.482657
			with: -0.401599 , 0.246003 , 0.047563
			with: -0.44963 , 0.103933 , 0.124555;
		addTriangleWith: -0.0806572 , 0.173258 , 0.482657
			with: -0.44963 , 0.103933 , 0.124555
			with: -0.418021 , 0.00223675 , 0.255235;
		addTriangleWith: -0.0806572 , 0.173258 , 0.482657
			with: -0.418021 , 0.00223675 , 0.255235
			with: -0.318844 , -0.0202425 , 0.389686;
		addTriangleWith: -0.0806572 , 0.173258 , 0.482657
			with: -0.318844 , -0.0202425 , 0.389686
			with: -0.189983 , 0.0450818 , 0.476554;
		addTriangleWith: -0.368404 , -0.152993 , 0.298366
			with: -0.318844 , -0.0202425 , 0.389686
			with: -0.418021 , 0.00223675 , 0.255235;
		addTriangleWith: -0.163412 , 0.439503 , 0.140534
			with: -0.16494 , 0.448821 , -0.0277793
			with: -0.292273 , 0.374179 , 0.0536663;
		addTriangleWith: 0.349407 , 0.361273 , 0.131545
			with: 0.347878 , 0.370591 , -0.0367679
			with: 0.248702 , 0.39307 , -0.171219;
		addTriangleWith: 0.349407 , 0.361273 , 0.131545
			with: 0.248702 , 0.39307 , -0.171219
			with: 0.0897598 , 0.420125 , -0.220453;
		addTriangleWith: 0.349407 , 0.361273 , 0.131545
			with: 0.0897598 , 0.420125 , -0.220453
			with: -0.0682375 , 0.44142 , -0.165664;
		addTriangleWith: 0.349407 , 0.361273 , 0.131545
			with: -0.0682375 , 0.44142 , -0.165664
			with: -0.16494 , 0.448821 , -0.0277793;
		addTriangleWith: 0.349407 , 0.361273 , 0.131545
			with: -0.16494 , 0.448821 , -0.0277793
			with: -0.163412 , 0.439503 , 0.140534;
		addTriangleWith: 0.349407 , 0.361273 , 0.131545
			with: -0.163412 , 0.439503 , 0.140534
			with: -0.0642354 , 0.417024 , 0.274985;
		addTriangleWith: 0.349407 , 0.361273 , 0.131545
			with: -0.0642354 , 0.417024 , 0.274985
			with: 0.0947067 , 0.38997 , 0.324219;
		addTriangleWith: 0.349407 , 0.361273 , 0.131545
			with: 0.0947067 , 0.38997 , 0.324219
			with: 0.252704 , 0.368675 , 0.26943;
		addTriangleWith: -0.032626 , 0.315327 , 0.405665
			with: 0.0947067 , 0.38997 , 0.324219
			with: -0.0642354 , 0.417024 , 0.274985;
		addTriangleWith: 0.0897598 , 0.420125 , -0.220453
			with: -0.0391015 , 0.3548 , -0.307321
			with: -0.0682375 , 0.44142 , -0.165664;
		addTriangleWith: 0.377014 , 0.283972 , -0.178425
			with: 0.248702 , 0.39307 , -0.171219
			with: 0.347878 , 0.370591 , -0.0367679;
		addTriangleWith: -0.0399897 , 0.0725781 , -0.459535
			with: -0.197987 , 0.0938731 , -0.404745
			with: -0.0886614 , 0.222049 , -0.398642;
		addTriangleWith: -0.0374249 , -0.408463 , -0.265171
			with: -0.195422 , -0.387168 , -0.210382
			with: -0.323735 , -0.278069 , -0.203177;
		addTriangleWith: -0.0374249 , -0.408463 , -0.265171
			with: -0.323735 , -0.278069 , -0.203177
			with: -0.373351 , -0.122839 , -0.246307;
		addTriangleWith: -0.0374249 , -0.408463 , -0.265171
			with: -0.373351 , -0.122839 , -0.246307
			with: -0.32532 , 0.0192306 , -0.3233;
		addTriangleWith: -0.0374249 , -0.408463 , -0.265171
			with: -0.32532 , 0.0192306 , -0.3233
			with: -0.197987 , 0.0938731 , -0.404745;
		addTriangleWith: -0.0374249 , -0.408463 , -0.265171
			with: -0.197987 , 0.0938731 , -0.404745
			with: -0.0399897 , 0.0725781 , -0.459535;
		addTriangleWith: -0.0374249 , -0.408463 , -0.265171
			with: -0.0399897 , 0.0725781 , -0.459535
			with: 0.0883226 , -0.0365206 , -0.46674;
		addTriangleWith: -0.0374249 , -0.408463 , -0.265171
			with: 0.0883226 , -0.0365206 , -0.46674
			with: 0.137939 , -0.191751 , -0.423609;
		addTriangleWith: -0.0374249 , -0.408463 , -0.265171
			with: 0.137939 , -0.191751 , -0.423609
			with: 0.0899078 , -0.33382 , -0.346617;
		addTriangleWith: 0.247265 , -0.0635748 , -0.417506
			with: 0.137939 , -0.191751 , -0.423609
			with: 0.0883226 , -0.0365206 , -0.46674;
		addTriangleWith: -0.373351 , -0.122839 , -0.246307
			with: -0.422023 , 0.0266324 , -0.185415
			with: -0.32532 , 0.0192306 , -0.3233;
		addTriangleWith: -0.292125 , -0.379766 , -0.0724972
			with: -0.323735 , -0.278069 , -0.203177
			with: -0.195422 , -0.387168 , -0.210382;
		addTriangleWith: -0.491559 , -0.0501831 , -0.0524392
			with: -0.442888 , -0.199654 , -0.113332
			with: -0.411278 , -0.301351 , 0.0173478;
		addTriangleWith: -0.491559 , -0.0501831 , -0.0524392
			with: -0.411278 , -0.301351 , 0.0173478
			with: -0.440414 , -0.214731 , 0.159005;
		addTriangleWith: -0.491559 , -0.0501831 , -0.0524392
			with: -0.440414 , -0.214731 , 0.159005
			with: -0.490031 , -0.0595012 , 0.115874;
		addTriangleWith: -0.442888 , -0.199654 , -0.113332
			with: -0.491559 , -0.0501831 , -0.0524392
			with: -0.422023 , 0.0266324 , -0.185415;
		addTriangleWith: -0.442888 , -0.199654 , -0.113332
			with: -0.422023 , 0.0266324 , -0.185415
			with: -0.373351 , -0.122839 , -0.246307;
		addTriangleWith: -0.442888 , -0.199654 , -0.113332
			with: -0.373351 , -0.122839 , -0.246307
			with: -0.323735 , -0.278069 , -0.203177;
		addTriangleWith: -0.411278 , -0.301351 , 0.0173478
			with: -0.442888 , -0.199654 , -0.113332
			with: -0.323735 , -0.278069 , -0.203177;
		addTriangleWith: -0.411278 , -0.301351 , 0.0173478
			with: -0.323735 , -0.278069 , -0.203177
			with: -0.292125 , -0.379766 , -0.0724972;
		addTriangleWith: -0.411278 , -0.301351 , 0.0173478
			with: -0.292125 , -0.379766 , -0.0724972
			with: -0.290596 , -0.389084 , 0.095816;
		addTriangleWith: -0.440414 , -0.214731 , 0.159005
			with: -0.411278 , -0.301351 , 0.0173478
			with: -0.290596 , -0.389084 , 0.095816;
		addTriangleWith: -0.440414 , -0.214731 , 0.159005
			with: -0.290596 , -0.389084 , 0.095816
			with: -0.319732 , -0.302465 , 0.237473;
		addTriangleWith: -0.440414 , -0.214731 , 0.159005
			with: -0.319732 , -0.302465 , 0.237473
			with: -0.368404 , -0.152993 , 0.298366;
		addTriangleWith: -0.490031 , -0.0595012 , 0.115874
			with: -0.440414 , -0.214731 , 0.159005
			with: -0.368404 , -0.152993 , 0.298366;
		addTriangleWith: -0.490031 , -0.0595012 , 0.115874
			with: -0.368404 , -0.152993 , 0.298366
			with: -0.418021 , 0.00223675 , 0.255235;
		addTriangleWith: -0.44963 , 0.103933 , 0.124555
			with: -0.490031 , -0.0595012 , 0.115874
			with: -0.418021 , 0.00223675 , 0.255235;
		addTriangleWith: -0.491559 , -0.0501831 , -0.0524392
			with: -0.490031 , -0.0595012 , 0.115874
			with: -0.44963 , 0.103933 , 0.124555;
		addTriangleWith: -0.491559 , -0.0501831 , -0.0524392
			with: -0.44963 , 0.103933 , 0.124555
			with: -0.451159 , 0.113252 , -0.0437579;
		addTriangleWith: -0.491559 , -0.0501831 , -0.0524392
			with: -0.451159 , 0.113252 , -0.0437579
			with: -0.422023 , 0.0266324 , -0.185415;
		addTriangleWith: 0.0695814 , 0.278759 , -0.41136
			with: 0.198443 , 0.344083 , -0.324493
			with: 0.326755 , 0.234984 , -0.331698;
		addTriangleWith: 0.0695814 , 0.278759 , -0.41136
			with: 0.326755 , 0.234984 , -0.331698
			with: 0.277195 , 0.102233 , -0.423019;
		addTriangleWith: 0.0695814 , 0.278759 , -0.41136
			with: 0.277195 , 0.102233 , -0.423019
			with: 0.118253 , 0.129288 , -0.472253;
		addTriangleWith: 0.198443 , 0.344083 , -0.324493
			with: 0.0695814 , 0.278759 , -0.41136
			with: -0.0391015 , 0.3548 , -0.307321;
		addTriangleWith: 0.198443 , 0.344083 , -0.324493
			with: -0.0391015 , 0.3548 , -0.307321
			with: 0.0897598 , 0.420125 , -0.220453;
		addTriangleWith: 0.198443 , 0.344083 , -0.324493
			with: 0.0897598 , 0.420125 , -0.220453
			with: 0.248702 , 0.39307 , -0.171219;
		addTriangleWith: 0.326755 , 0.234984 , -0.331698
			with: 0.198443 , 0.344083 , -0.324493
			with: 0.248702 , 0.39307 , -0.171219;
		addTriangleWith: 0.326755 , 0.234984 , -0.331698
			with: 0.248702 , 0.39307 , -0.171219
			with: 0.377014 , 0.283972 , -0.178425;
		addTriangleWith: 0.326755 , 0.234984 , -0.331698
			with: 0.377014 , 0.283972 , -0.178425
			with: 0.425686 , 0.134501 , -0.239317;
		addTriangleWith: 0.277195 , 0.102233 , -0.423019
			with: 0.326755 , 0.234984 , -0.331698
			with: 0.425686 , 0.134501 , -0.239317;
		addTriangleWith: 0.277195 , 0.102233 , -0.423019
			with: 0.425686 , 0.134501 , -0.239317
			with: 0.376126 , 0.00174962 , -0.330638;
		addTriangleWith: 0.277195 , 0.102233 , -0.423019
			with: 0.376126 , 0.00174962 , -0.330638
			with: 0.247265 , -0.0635748 , -0.417506;
		addTriangleWith: 0.118253 , 0.129288 , -0.472253
			with: 0.277195 , 0.102233 , -0.423019
			with: 0.247265 , -0.0635748 , -0.417506;
		addTriangleWith: 0.118253 , 0.129288 , -0.472253
			with: 0.247265 , -0.0635748 , -0.417506
			with: 0.0883226 , -0.0365206 , -0.46674;
		addTriangleWith: -0.0399897 , 0.0725781 , -0.459535
			with: 0.118253 , 0.129288 , -0.472253
			with: 0.0883226 , -0.0365206 , -0.46674;
		addTriangleWith: 0.0695814 , 0.278759 , -0.41136
			with: 0.118253 , 0.129288 , -0.472253
			with: -0.0399897 , 0.0725781 , -0.459535;
		addTriangleWith: 0.0695814 , 0.278759 , -0.41136
			with: -0.0399897 , 0.0725781 , -0.459535
			with: -0.0886614 , 0.222049 , -0.398642;
		addTriangleWith: 0.0695814 , 0.278759 , -0.41136
			with: -0.0886614 , 0.222049 , -0.398642
			with: -0.0391015 , 0.3548 , -0.307321! !

!Polyhedron class methodsFor: 'factory-icosahedron' stamp: 'emm 02/09/2012 23:40'!
metabidiminishedIcosahedron
	"self metabidiminishedIcosahedron"

	^(Triangle3DComposite new)
		addTriangleWith: -0.395449 , -0.405369 , 0.0949912
			with: -0.111866 , -0.308757 , -0.431901
			with: 0.466678 , -0.174181 , -0.3113;
		addTriangleWith: -0.395449 , -0.405369 , 0.0949912
			with: 0.466678 , -0.174181 , -0.3113
			with: 0.540654 , -0.187621 , 0.290128;
		addTriangleWith: -0.395449 , -0.405369 , 0.0949912
			with: 0.540654 , -0.187621 , 0.290128
			with: 0.00783074 , -0.330503 , 0.541229;
		addTriangleWith: -0.385369 , 0.111911 , 0.410724
			with: 0.00783074 , -0.330503 , 0.541229
			with: 0.540654 , -0.187621 , 0.290128;
		addTriangleWith: -0.385369 , 0.111911 , 0.410724
			with: 0.540654 , -0.187621 , 0.290128
			with: 0.476757 , 0.343099 , 0.00443305;
		addTriangleWith: -0.385369 , 0.111911 , 0.410724
			with: 0.476757 , 0.343099 , 0.00443305
			with: -0.0955564 , 0.52822 , 0.0789655;
		addTriangleWith: 0.0734777 , 0.268233 , -0.441805
			with: -0.111866 , -0.308757 , -0.431901
			with: -0.459346 , 0.125351 , -0.190704;
		addTriangleWith: -0.459346 , 0.125351 , -0.190704
			with: -0.111866 , -0.308757 , -0.431901
			with: -0.395449 , -0.405369 , 0.0949912;
		addTriangleWith: -0.395449 , -0.405369 , 0.0949912
			with: 0.00783074 , -0.330503 , 0.541229
			with: -0.385369 , 0.111911 , 0.410724;
		addTriangleWith: -0.395449 , -0.405369 , 0.0949912
			with: -0.385369 , 0.111911 , 0.410724
			with: -0.459346 , 0.125351 , -0.190704;
		addTriangleWith: -0.385369 , 0.111911 , 0.410724
			with: -0.0955564 , 0.52822 , 0.0789655
			with: -0.459346 , 0.125351 , -0.190704;
		addTriangleWith: -0.0955564 , 0.52822 , 0.0789655
			with: 0.476757 , 0.343099 , 0.00443305
			with: 0.0734777 , 0.268233 , -0.441805;
		addTriangleWith: -0.0955564 , 0.52822 , 0.0789655
			with: 0.0734777 , 0.268233 , -0.441805
			with: -0.459346 , 0.125351 , -0.190704;
		addTriangleWith: 0.540654 , -0.187621 , 0.290128
			with: 0.466678 , -0.174181 , -0.3113
			with: 0.476757 , 0.343099 , 0.00443305;
		addTriangleWith: 0.466678 , -0.174181 , -0.3113
			with: 0.0734777 , 0.268233 , -0.441805
			with: 0.476757 , 0.343099 , 0.00443305;
		addTriangleWith: 0.466678 , -0.174181 , -0.3113
			with: -0.111866 , -0.308757 , -0.431901
			with: 0.0734777 , 0.268233 , -0.441805! !

!Polyhedron class methodsFor: 'factory-dodecahedron' stamp: 'emm 02/09/2012 23:40'!
metabidiminishedRhombicosidodecahedron
	"self metabidiminishedRhombicosidodecahedron"

	^(Triangle3DComposite new)
		addTriangleWith: 0.377097 , 0.292422 , -0.166533
			with: 0.274482 , 0.212854 , -0.353934
			with: 0.0957888 , 0.34862 , -0.313733;
		addTriangleWith: 0.377097 , 0.292422 , -0.166533
			with: 0.0957888 , 0.34862 , -0.313733
			with: 0.198403 , 0.428188 , -0.126332;
		addTriangleWith: 0.198403 , 0.428188 , -0.126332
			with: 0.0957888 , 0.34862 , -0.313733
			with: -0.0276194 , 0.447261 , -0.149354;
		addTriangleWith: 0.0957888 , 0.34862 , -0.313733
			with: -0.0912295 , 0.243714 , -0.391186
			with: -0.214638 , 0.342356 , -0.226807;
		addTriangleWith: 0.0957888 , 0.34862 , -0.313733
			with: -0.214638 , 0.342356 , -0.226807
			with: -0.0276194 , 0.447261 , -0.149354;
		addTriangleWith: 0.274482 , 0.212854 , -0.353934
			with: 0.197903 , 0.0240404 , -0.456233
			with: -0.0281196 , 0.0431132 , -0.479256;
		addTriangleWith: 0.274482 , 0.212854 , -0.353934
			with: -0.0281196 , 0.0431132 , -0.479256
			with: -0.0912295 , 0.243714 , -0.391186;
		addTriangleWith: 0.274482 , 0.212854 , -0.353934
			with: -0.0912295 , 0.243714 , -0.391186
			with: 0.0957888 , 0.34862 , -0.313733;
		addTriangleWith: -0.0912295 , 0.243714 , -0.391186
			with: -0.291217 , 0.153542 , -0.329106
			with: -0.214638 , 0.342356 , -0.226807;
		addTriangleWith: -0.214638 , 0.342356 , -0.226807
			with: -0.291217 , 0.153542 , -0.329106
			with: -0.427786 , 0.112547 , -0.151206;
		addTriangleWith: -0.214638 , 0.342356 , -0.226807
			with: -0.427786 , 0.112547 , -0.151206
			with: -0.351206 , 0.30136 , -0.0489074;
		addTriangleWith: -0.0281196 , 0.0431132 , -0.479256
			with: -0.228107 , -0.0470587 , -0.417176
			with: -0.291217 , 0.153542 , -0.329106;
		addTriangleWith: -0.0281196 , 0.0431132 , -0.479256
			with: -0.291217 , 0.153542 , -0.329106
			with: -0.0912295 , 0.243714 , -0.391186;
		addTriangleWith: -0.0281196 , 0.0431132 , -0.479256
			with: -0.0494138 , -0.182825 , -0.457378
			with: -0.228107 , -0.0470587 , -0.417176;
		addTriangleWith: -0.0494138 , -0.182825 , -0.457378
			with: -0.146978 , -0.347799 , -0.333908
			with: -0.325672 , -0.212033 , -0.293707;
		addTriangleWith: -0.0494138 , -0.182825 , -0.457378
			with: -0.325672 , -0.212033 , -0.293707
			with: -0.228107 , -0.0470587 , -0.417176;
		addTriangleWith: -0.228107 , -0.0470587 , -0.417176
			with: -0.325672 , -0.212033 , -0.293707
			with: -0.44908 , -0.113391 , -0.129328;
		addTriangleWith: -0.228107 , -0.0470587 , -0.417176
			with: -0.44908 , -0.113391 , -0.129328
			with: -0.427786 , 0.112547 , -0.151206;
		addTriangleWith: -0.228107 , -0.0470587 , -0.417176
			with: -0.427786 , 0.112547 , -0.151206
			with: -0.291217 , 0.153542 , -0.329106;
		addTriangleWith: -0.146978 , -0.347799 , -0.333908
			with: -0.283547 , -0.388794 , -0.156009
			with: -0.325672 , -0.212033 , -0.293707;
		addTriangleWith: -0.325672 , -0.212033 , -0.293707
			with: -0.283547 , -0.388794 , -0.156009
			with: -0.406955 , -0.290153 , 0.00836989;
		addTriangleWith: -0.325672 , -0.212033 , -0.293707
			with: -0.406955 , -0.290153 , 0.00836989
			with: -0.44908 , -0.113391 , -0.129328;
		addTriangleWith: 0.198403 , 0.428188 , -0.126332
			with: -0.0276194 , 0.447261 , -0.149354
			with: -0.0486043 , 0.4711 , 0.0764139;
		addTriangleWith: 0.198403 , 0.428188 , -0.126332
			with: -0.0486043 , 0.4711 , 0.0764139
			with: 0.177418 , 0.452028 , 0.0994364;
		addTriangleWith: 0.177418 , 0.452028 , 0.0994364
			with: -0.0486043 , 0.4711 , 0.0764139
			with: 0.0408496 , 0.411032 , 0.277336;
		addTriangleWith: -0.0486043 , 0.4711 , 0.0764139
			with: -0.248592 , 0.380929 , 0.138493
			with: -0.159138 , 0.32086 , 0.339416;
		addTriangleWith: -0.0486043 , 0.4711 , 0.0764139
			with: -0.159138 , 0.32086 , 0.339416
			with: 0.0408496 , 0.411032 , 0.277336;
		addTriangleWith: -0.0276194 , 0.447261 , -0.149354
			with: -0.214638 , 0.342356 , -0.226807
			with: -0.351206 , 0.30136 , -0.0489074;
		addTriangleWith: -0.0276194 , 0.447261 , -0.149354
			with: -0.351206 , 0.30136 , -0.0489074
			with: -0.248592 , 0.380929 , 0.138493;
		addTriangleWith: -0.0276194 , 0.447261 , -0.149354
			with: -0.248592 , 0.380929 , 0.138493
			with: -0.0486043 , 0.4711 , 0.0764139;
		addTriangleWith: -0.248592 , 0.380929 , 0.138493
			with: -0.346157 , 0.215955 , 0.261963
			with: -0.159138 , 0.32086 , 0.339416;
		addTriangleWith: -0.159138 , 0.32086 , 0.339416
			with: -0.346157 , 0.215955 , 0.261963
			with: -0.304032 , 0.0391929 , 0.399661;
		addTriangleWith: -0.159138 , 0.32086 , 0.339416
			with: -0.304032 , 0.0391929 , 0.399661
			with: -0.117013 , 0.144098 , 0.477114;
		addTriangleWith: -0.351206 , 0.30136 , -0.0489074
			with: -0.448771 , 0.136386 , 0.074562
			with: -0.346157 , 0.215955 , 0.261963;
		addTriangleWith: -0.351206 , 0.30136 , -0.0489074
			with: -0.346157 , 0.215955 , 0.261963
			with: -0.248592 , 0.380929 , 0.138493;
		addTriangleWith: -0.351206 , 0.30136 , -0.0489074
			with: -0.427786 , 0.112547 , -0.151206
			with: -0.448771 , 0.136386 , 0.074562;
		addTriangleWith: -0.427786 , 0.112547 , -0.151206
			with: -0.44908 , -0.113391 , -0.129328
			with: -0.470065 , -0.0895519 , 0.09644;
		addTriangleWith: -0.427786 , 0.112547 , -0.151206
			with: -0.470065 , -0.0895519 , 0.09644
			with: -0.448771 , 0.136386 , 0.074562;
		addTriangleWith: -0.448771 , 0.136386 , 0.074562
			with: -0.470065 , -0.0895519 , 0.09644
			with: -0.380611 , -0.149621 , 0.297362;
		addTriangleWith: -0.448771 , 0.136386 , 0.074562
			with: -0.380611 , -0.149621 , 0.297362
			with: -0.304032 , 0.0391929 , 0.399661;
		addTriangleWith: -0.448771 , 0.136386 , 0.074562
			with: -0.304032 , 0.0391929 , 0.399661
			with: -0.346157 , 0.215955 , 0.261963;
		addTriangleWith: -0.44908 , -0.113391 , -0.129328
			with: -0.406955 , -0.290153 , 0.00836989
			with: -0.470065 , -0.0895519 , 0.09644;
		addTriangleWith: -0.470065 , -0.0895519 , 0.09644
			with: -0.406955 , -0.290153 , 0.00836989
			with: -0.317501 , -0.350222 , 0.209292;
		addTriangleWith: -0.470065 , -0.0895519 , 0.09644
			with: -0.317501 , -0.350222 , 0.209292
			with: -0.380611 , -0.149621 , 0.297362;
		addTriangleWith: 0.177418 , 0.452028 , 0.0994364
			with: 0.0408496 , 0.411032 , 0.277336
			with: 0.206574 , 0.289999 , 0.376667;
		addTriangleWith: 0.177418 , 0.452028 , 0.0994364
			with: 0.206574 , 0.289999 , 0.376667
			with: 0.343142 , 0.330995 , 0.198767;
		addTriangleWith: 0.343142 , 0.330995 , 0.198767
			with: 0.206574 , 0.289999 , 0.376667
			with: 0.385267 , 0.154234 , 0.336465;
		addTriangleWith: 0.206574 , 0.289999 , 0.376667
			with: 0.109009 , 0.125025 , 0.500136
			with: 0.287703 , -0.0107404 , 0.459935;
		addTriangleWith: 0.206574 , 0.289999 , 0.376667
			with: 0.287703 , -0.0107404 , 0.459935
			with: 0.385267 , 0.154234 , 0.336465;
		addTriangleWith: 0.0408496 , 0.411032 , 0.277336
			with: -0.159138 , 0.32086 , 0.339416
			with: -0.117013 , 0.144098 , 0.477114;
		addTriangleWith: 0.0408496 , 0.411032 , 0.277336
			with: -0.117013 , 0.144098 , 0.477114
			with: 0.109009 , 0.125025 , 0.500136;
		addTriangleWith: 0.0408496 , 0.411032 , 0.277336
			with: 0.109009 , 0.125025 , 0.500136
			with: 0.206574 , 0.289999 , 0.376667;
		addTriangleWith: 0.274233 , -0.400155 , 0.269566
			with: 0.350813 , -0.211341 , 0.371865
			with: 0.287703 , -0.0107404 , 0.459935;
		addTriangleWith: 0.274233 , -0.400155 , 0.269566
			with: 0.287703 , -0.0107404 , 0.459935
			with: 0.109009 , 0.125025 , 0.500136;
		addTriangleWith: 0.274233 , -0.400155 , 0.269566
			with: 0.109009 , 0.125025 , 0.500136
			with: -0.117013 , 0.144098 , 0.477114;
		addTriangleWith: 0.274233 , -0.400155 , 0.269566
			with: -0.117013 , 0.144098 , 0.477114
			with: -0.304032 , 0.0391929 , 0.399661;
		addTriangleWith: 0.274233 , -0.400155 , 0.269566
			with: -0.304032 , 0.0391929 , 0.399661
			with: -0.380611 , -0.149621 , 0.297362;
		addTriangleWith: 0.274233 , -0.400155 , 0.269566
			with: -0.380611 , -0.149621 , 0.297362
			with: -0.317501 , -0.350222 , 0.209292;
		addTriangleWith: 0.274233 , -0.400155 , 0.269566
			with: -0.317501 , -0.350222 , 0.209292
			with: -0.138808 , -0.485987 , 0.169091;
		addTriangleWith: 0.274233 , -0.400155 , 0.269566
			with: -0.138808 , -0.485987 , 0.169091
			with: 0.0872147 , -0.50506 , 0.192113;
		addTriangleWith: 0.343142 , 0.330995 , 0.198767
			with: 0.385267 , 0.154234 , 0.336465
			with: 0.508676 , 0.0555921 , 0.172087;
		addTriangleWith: 0.343142 , 0.330995 , 0.198767
			with: 0.508676 , 0.0555921 , 0.172087
			with: 0.466551 , 0.232354 , 0.0343888;
		addTriangleWith: 0.466551 , 0.232354 , 0.0343888
			with: 0.508676 , 0.0555921 , 0.172087
			with: 0.487381 , -0.170346 , 0.193965;
		addTriangleWith: 0.466551 , 0.232354 , 0.0343888
			with: 0.487381 , -0.170346 , 0.193965
			with: 0.410802 , -0.359159 , 0.0916661;
		addTriangleWith: 0.466551 , 0.232354 , 0.0343888
			with: 0.410802 , -0.359159 , 0.0916661
			with: 0.308187 , -0.438728 , -0.0957348;
		addTriangleWith: 0.466551 , 0.232354 , 0.0343888
			with: 0.308187 , -0.438728 , -0.0957348
			with: 0.218734 , -0.378659 , -0.296657;
		addTriangleWith: 0.466551 , 0.232354 , 0.0343888
			with: 0.218734 , -0.378659 , -0.296657
			with: 0.176609 , -0.201897 , -0.434355;
		addTriangleWith: 0.466551 , 0.232354 , 0.0343888
			with: 0.176609 , -0.201897 , -0.434355
			with: 0.197903 , 0.0240404 , -0.456233;
		addTriangleWith: 0.466551 , 0.232354 , 0.0343888
			with: 0.197903 , 0.0240404 , -0.456233
			with: 0.274482 , 0.212854 , -0.353934;
		addTriangleWith: 0.466551 , 0.232354 , 0.0343888
			with: 0.274482 , 0.212854 , -0.353934
			with: 0.377097 , 0.292422 , -0.166533;
		addTriangleWith: 0.385267 , 0.154234 , 0.336465
			with: 0.287703 , -0.0107404 , 0.459935
			with: 0.350813 , -0.211341 , 0.371865;
		addTriangleWith: 0.385267 , 0.154234 , 0.336465
			with: 0.350813 , -0.211341 , 0.371865
			with: 0.487381 , -0.170346 , 0.193965;
		addTriangleWith: 0.385267 , 0.154234 , 0.336465
			with: 0.487381 , -0.170346 , 0.193965
			with: 0.508676 , 0.0555921 , 0.172087;
		addTriangleWith: 0.350813 , -0.211341 , 0.371865
			with: 0.274233 , -0.400155 , 0.269566
			with: 0.410802 , -0.359159 , 0.0916661;
		addTriangleWith: 0.350813 , -0.211341 , 0.371865
			with: 0.410802 , -0.359159 , 0.0916661
			with: 0.487381 , -0.170346 , 0.193965;
		addTriangleWith: 0.274233 , -0.400155 , 0.269566
			with: 0.0872147 , -0.50506 , 0.192113
			with: 0.1082 , -0.5289 , -0.0336552;
		addTriangleWith: 0.274233 , -0.400155 , 0.269566
			with: 0.1082 , -0.5289 , -0.0336552
			with: 0.308187 , -0.438728 , -0.0957348;
		addTriangleWith: 0.274233 , -0.400155 , 0.269566
			with: 0.308187 , -0.438728 , -0.0957348
			with: 0.410802 , -0.359159 , 0.0916661;
		addTriangleWith: 0.0872147 , -0.50506 , 0.192113
			with: -0.138808 , -0.485987 , 0.169091
			with: -0.117823 , -0.509827 , -0.0566777;
		addTriangleWith: 0.0872147 , -0.50506 , 0.192113
			with: -0.117823 , -0.509827 , -0.0566777
			with: 0.1082 , -0.5289 , -0.0336552;
		addTriangleWith: 0.197903 , 0.0240404 , -0.456233
			with: 0.176609 , -0.201897 , -0.434355
			with: -0.0494138 , -0.182825 , -0.457378;
		addTriangleWith: 0.197903 , 0.0240404 , -0.456233
			with: -0.0494138 , -0.182825 , -0.457378
			with: -0.0281196 , 0.0431132 , -0.479256;
		addTriangleWith: 0.308187 , -0.438728 , -0.0957348
			with: 0.1082 , -0.5289 , -0.0336552
			with: 0.0187459 , -0.468831 , -0.234577;
		addTriangleWith: 0.308187 , -0.438728 , -0.0957348
			with: 0.0187459 , -0.468831 , -0.234577
			with: 0.218734 , -0.378659 , -0.296657;
		addTriangleWith: 0.218734 , -0.378659 , -0.296657
			with: 0.0187459 , -0.468831 , -0.234577
			with: -0.146978 , -0.347799 , -0.333908;
		addTriangleWith: 0.218734 , -0.378659 , -0.296657
			with: -0.146978 , -0.347799 , -0.333908
			with: -0.0494138 , -0.182825 , -0.457378;
		addTriangleWith: 0.218734 , -0.378659 , -0.296657
			with: -0.0494138 , -0.182825 , -0.457378
			with: 0.176609 , -0.201897 , -0.434355;
		addTriangleWith: 0.1082 , -0.5289 , -0.0336552
			with: -0.117823 , -0.509827 , -0.0566777
			with: 0.0187459 , -0.468831 , -0.234577;
		addTriangleWith: 0.0187459 , -0.468831 , -0.234577
			with: -0.117823 , -0.509827 , -0.0566777
			with: -0.283547 , -0.388794 , -0.156009;
		addTriangleWith: 0.0187459 , -0.468831 , -0.234577
			with: -0.283547 , -0.388794 , -0.156009
			with: -0.146978 , -0.347799 , -0.333908;
		addTriangleWith: 0.377097 , 0.292422 , -0.166533
			with: 0.198403 , 0.428188 , -0.126332
			with: 0.177418 , 0.452028 , 0.0994364;
		addTriangleWith: 0.377097 , 0.292422 , -0.166533
			with: 0.177418 , 0.452028 , 0.0994364
			with: 0.343142 , 0.330995 , 0.198767;
		addTriangleWith: 0.377097 , 0.292422 , -0.166533
			with: 0.343142 , 0.330995 , 0.198767
			with: 0.466551 , 0.232354 , 0.0343888;
		addTriangleWith: -0.117823 , -0.509827 , -0.0566777
			with: -0.138808 , -0.485987 , 0.169091
			with: -0.317501 , -0.350222 , 0.209292;
		addTriangleWith: -0.117823 , -0.509827 , -0.0566777
			with: -0.317501 , -0.350222 , 0.209292
			with: -0.406955 , -0.290153 , 0.00836989;
		addTriangleWith: -0.117823 , -0.509827 , -0.0566777
			with: -0.406955 , -0.290153 , 0.00836989
			with: -0.283547 , -0.388794 , -0.156009! !

!Polyhedron class methodsFor: 'factory-dodecahedron' stamp: 'emm 02/09/2012 23:40'!
metabigyrateRhombicosidodecahedron
	"self metabigyrateRhombicosidodecahedron"

	^(Triangle3DComposite new)
		addTriangleWith: -0.153033 , 0.011747 , -0.481443
			with: -0.274303 , 0.177589 , -0.385604
			with: -0.0917242 , 0.311968 , -0.387112;
		addTriangleWith: -0.153033 , 0.011747 , -0.481443
			with: -0.0917242 , 0.311968 , -0.387112
			with: 0.0295454 , 0.146126 , -0.48295;
		addTriangleWith: 0.0295454 , 0.146126 , -0.48295
			with: -0.0917242 , 0.311968 , -0.387112
			with: 0.134515 , 0.31416 , -0.372764;
		addTriangleWith: -0.0917242 , 0.311968 , -0.387112
			with: -0.104458 , 0.449473 , -0.20732
			with: 0.121781 , 0.451665 , -0.192973;
		addTriangleWith: -0.0917242 , 0.311968 , -0.387112
			with: 0.121781 , 0.451665 , -0.192973
			with: 0.134515 , 0.31416 , -0.372764;
		addTriangleWith: -0.274303 , 0.177589 , -0.385604
			with: -0.399876 , 0.232043 , -0.204881
			with: -0.294906 , 0.400077 , -0.0946953;
		addTriangleWith: -0.274303 , 0.177589 , -0.385604
			with: -0.294906 , 0.400077 , -0.0946953
			with: -0.104458 , 0.449473 , -0.20732;
		addTriangleWith: -0.274303 , 0.177589 , -0.385604
			with: -0.104458 , 0.449473 , -0.20732
			with: -0.0917242 , 0.311968 , -0.387112;
		addTriangleWith: -0.294906 , 0.400077 , -0.0946953
			with: -0.118962 , 0.491861 , 0.0149135
			with: -0.104458 , 0.449473 , -0.20732;
		addTriangleWith: -0.104458 , 0.449473 , -0.20732
			with: -0.118962 , 0.491861 , 0.0149135
			with: 0.107278 , 0.494053 , 0.0292606;
		addTriangleWith: -0.104458 , 0.449473 , -0.20732
			with: 0.107278 , 0.494053 , 0.0292606
			with: 0.121781 , 0.451665 , -0.192973;
		addTriangleWith: -0.376819 , 0.322344 , 0.101882
			with: -0.200874 , 0.414128 , 0.211491
			with: -0.118962 , 0.491861 , 0.0149135;
		addTriangleWith: -0.376819 , 0.322344 , 0.101882
			with: -0.118962 , 0.491861 , 0.0149135
			with: -0.294906 , 0.400077 , -0.0946953;
		addTriangleWith: -0.376819 , 0.322344 , 0.101882
			with: -0.318908 , 0.245967 , 0.307327
			with: -0.200874 , 0.414128 , 0.211491;
		addTriangleWith: -0.318908 , 0.245967 , 0.307327
			with: -0.143293 , 0.200117 , 0.443166
			with: -0.0252596 , 0.368279 , 0.34733;
		addTriangleWith: -0.318908 , 0.245967 , 0.307327
			with: -0.0252596 , 0.368279 , 0.34733
			with: -0.200874 , 0.414128 , 0.211491;
		addTriangleWith: -0.200874 , 0.414128 , 0.211491
			with: -0.0252596 , 0.368279 , 0.34733
			with: 0.165189 , 0.417675 , 0.234705;
		addTriangleWith: -0.200874 , 0.414128 , 0.211491
			with: 0.165189 , 0.417675 , 0.234705
			with: 0.107278 , 0.494053 , 0.0292606;
		addTriangleWith: -0.200874 , 0.414128 , 0.211491
			with: 0.107278 , 0.494053 , 0.0292606
			with: -0.118962 , 0.491861 , 0.0149135;
		addTriangleWith: -0.143293 , 0.200117 , 0.443166
			with: 0.0829462 , 0.202309 , 0.457513
			with: -0.0252596 , 0.368279 , 0.34733;
		addTriangleWith: -0.0252596 , 0.368279 , 0.34733
			with: 0.0829462 , 0.202309 , 0.457513
			with: 0.273394 , 0.251705 , 0.344889;
		addTriangleWith: -0.0252596 , 0.368279 , 0.34733
			with: 0.273394 , 0.251705 , 0.344889
			with: 0.165189 , 0.417675 , 0.234705;
		addTriangleWith: 0.0295454 , 0.146126 , -0.48295
			with: 0.134515 , 0.31416 , -0.372764
			with: 0.318 , 0.183327 , -0.348043;
		addTriangleWith: 0.0295454 , 0.146126 , -0.48295
			with: 0.318 , 0.183327 , -0.348043
			with: 0.21303 , 0.0152934 , -0.458229;
		addTriangleWith: 0.318 , 0.183327 , -0.348043
			with: 0.418665 , 0.239974 , -0.152973
			with: 0.445481 , 0.031544 , -0.238019;
		addTriangleWith: 0.418665 , 0.239974 , -0.152973
			with: 0.476577 , 0.163596 , 0.0524722
			with: 0.503392 , -0.044834 , -0.0325742;
		addTriangleWith: 0.418665 , 0.239974 , -0.152973
			with: 0.503392 , -0.044834 , -0.0325742
			with: 0.445481 , 0.031544 , -0.238019;
		addTriangleWith: 0.134515 , 0.31416 , -0.372764
			with: 0.121781 , 0.451665 , -0.192973
			with: 0.297396 , 0.405816 , -0.0571341;
		addTriangleWith: 0.134515 , 0.31416 , -0.372764
			with: 0.297396 , 0.405816 , -0.0571341
			with: 0.418665 , 0.239974 , -0.152973;
		addTriangleWith: 0.134515 , 0.31416 , -0.372764
			with: 0.418665 , 0.239974 , -0.152973
			with: 0.318 , 0.183327 , -0.348043;
		addTriangleWith: 0.476577 , 0.163596 , 0.0524722
			with: 0.469613 , -0.016633 , 0.189819
			with: 0.503392 , -0.044834 , -0.0325742;
		addTriangleWith: 0.503392 , -0.044834 , -0.0325742
			with: 0.469613 , -0.016633 , 0.189819
			with: 0.400434 , -0.231871 , 0.206605;
		addTriangleWith: 0.503392 , -0.044834 , -0.0325742
			with: 0.400434 , -0.231871 , 0.206605
			with: 0.434213 , -0.260072 , -0.0157879;
		addTriangleWith: 0.297396 , 0.405816 , -0.0571341
			with: 0.355307 , 0.329438 , 0.148311
			with: 0.476577 , 0.163596 , 0.0524722;
		addTriangleWith: 0.297396 , 0.405816 , -0.0571341
			with: 0.476577 , 0.163596 , 0.0524722
			with: 0.418665 , 0.239974 , -0.152973;
		addTriangleWith: 0.121781 , 0.451665 , -0.192973
			with: 0.107278 , 0.494053 , 0.0292606
			with: 0.297396 , 0.405816 , -0.0571341;
		addTriangleWith: 0.107278 , 0.494053 , 0.0292606
			with: 0.165189 , 0.417675 , 0.234705
			with: 0.355307 , 0.329438 , 0.148311;
		addTriangleWith: 0.107278 , 0.494053 , 0.0292606
			with: 0.355307 , 0.329438 , 0.148311
			with: 0.297396 , 0.405816 , -0.0571341;
		addTriangleWith: 0.355307 , 0.329438 , 0.148311
			with: 0.273394 , 0.251705 , 0.344889
			with: 0.344039 , 0.0378216 , 0.370542;
		addTriangleWith: 0.355307 , 0.329438 , 0.148311
			with: 0.344039 , 0.0378216 , 0.370542
			with: 0.469613 , -0.016633 , 0.189819;
		addTriangleWith: 0.355307 , 0.329438 , 0.148311
			with: 0.469613 , -0.016633 , 0.189819
			with: 0.476577 , 0.163596 , 0.0524722;
		addTriangleWith: 0.165189 , 0.417675 , 0.234705
			with: 0.273394 , 0.251705 , 0.344889
			with: 0.355307 , 0.329438 , 0.148311;
		addTriangleWith: 0.273394 , 0.251705 , 0.344889
			with: 0.0829462 , 0.202309 , 0.457513
			with: 0.153591 , -0.0115745 , 0.483167;
		addTriangleWith: 0.273394 , 0.251705 , 0.344889
			with: 0.153591 , -0.0115745 , 0.483167
			with: 0.344039 , 0.0378216 , 0.370542;
		addTriangleWith: 0.318 , 0.183327 , -0.348043
			with: 0.445481 , 0.031544 , -0.238019
			with: 0.340511 , -0.13649 , -0.348205;
		addTriangleWith: 0.318 , 0.183327 , -0.348043
			with: 0.340511 , -0.13649 , -0.348205
			with: 0.21303 , 0.0152934 , -0.458229;
		addTriangleWith: 0.21303 , 0.0152934 , -0.458229
			with: 0.340511 , -0.13649 , -0.348205
			with: 0.143851 , -0.199944 , -0.441442;
		addTriangleWith: 0.340511 , -0.13649 , -0.348205
			with: 0.333547 , -0.316718 , -0.210858
			with: 0.136887 , -0.380173 , -0.304096;
		addTriangleWith: 0.340511 , -0.13649 , -0.348205
			with: 0.136887 , -0.380173 , -0.304096
			with: 0.143851 , -0.199944 , -0.441442;
		addTriangleWith: 0.445481 , 0.031544 , -0.238019
			with: 0.503392 , -0.044834 , -0.0325742
			with: 0.434213 , -0.260072 , -0.0157879;
		addTriangleWith: 0.445481 , 0.031544 , -0.238019
			with: 0.434213 , -0.260072 , -0.0157879
			with: 0.333547 , -0.316718 , -0.210858;
		addTriangleWith: 0.445481 , 0.031544 , -0.238019
			with: 0.333547 , -0.316718 , -0.210858
			with: 0.340511 , -0.13649 , -0.348205;
		addTriangleWith: 0.333547 , -0.316718 , -0.210858
			with: 0.194798 , -0.456551 , -0.098651
			with: 0.136887 , -0.380173 , -0.304096;
		addTriangleWith: 0.194798 , -0.456551 , -0.098651
			with: 0.295464 , -0.399905 , 0.0964192
			with: 0.105016 , -0.449301 , 0.209044;
		addTriangleWith: 0.194798 , -0.456551 , -0.098651
			with: 0.105016 , -0.449301 , 0.209044
			with: 0.00435016 , -0.505947 , 0.0139737;
		addTriangleWith: 0.434213 , -0.260072 , -0.0157879
			with: 0.295464 , -0.399905 , 0.0964192
			with: 0.194798 , -0.456551 , -0.098651;
		addTriangleWith: 0.434213 , -0.260072 , -0.0157879
			with: 0.194798 , -0.456551 , -0.098651
			with: 0.333547 , -0.316718 , -0.210858;
		addTriangleWith: 0.434213 , -0.260072 , -0.0157879
			with: 0.400434 , -0.231871 , 0.206605
			with: 0.295464 , -0.399905 , 0.0964192;
		addTriangleWith: 0.469613 , -0.016633 , 0.189819
			with: 0.344039 , 0.0378216 , 0.370542
			with: 0.274861 , -0.177416 , 0.387328;
		addTriangleWith: 0.469613 , -0.016633 , 0.189819
			with: 0.274861 , -0.177416 , 0.387328
			with: 0.400434 , -0.231871 , 0.206605;
		addTriangleWith: 0.400434 , -0.231871 , 0.206605
			with: 0.274861 , -0.177416 , 0.387328
			with: 0.0922823 , -0.311795 , 0.388836;
		addTriangleWith: 0.400434 , -0.231871 , 0.206605
			with: 0.0922823 , -0.311795 , 0.388836
			with: 0.105016 , -0.449301 , 0.209044;
		addTriangleWith: 0.400434 , -0.231871 , 0.206605
			with: 0.105016 , -0.449301 , 0.209044
			with: 0.295464 , -0.399905 , 0.0964192;
		addTriangleWith: 0.344039 , 0.0378216 , 0.370542
			with: 0.153591 , -0.0115745 , 0.483167
			with: 0.274861 , -0.177416 , 0.387328;
		addTriangleWith: 0.274861 , -0.177416 , 0.387328
			with: 0.153591 , -0.0115745 , 0.483167
			with: -0.0289873 , -0.145954 , 0.484674;
		addTriangleWith: 0.274861 , -0.177416 , 0.387328
			with: -0.0289873 , -0.145954 , 0.484674
			with: 0.0922823 , -0.311795 , 0.388836;
		addTriangleWith: 0.143851 , -0.199944 , -0.441442
			with: 0.136887 , -0.380173 , -0.304096
			with: -0.0893519 , -0.382365 , -0.318443;
		addTriangleWith: 0.143851 , -0.199944 , -0.441442
			with: -0.0893519 , -0.382365 , -0.318443
			with: -0.0823882 , -0.202136 , -0.455789;
		addTriangleWith: -0.0823882 , -0.202136 , -0.455789
			with: -0.0893519 , -0.382365 , -0.318443
			with: -0.272836 , -0.251532 , -0.343164;
		addTriangleWith: -0.0893519 , -0.382365 , -0.318443
			with: -0.171264 , -0.460098 , -0.121865
			with: -0.354749 , -0.329265 , -0.146587;
		addTriangleWith: -0.0893519 , -0.382365 , -0.318443
			with: -0.354749 , -0.329265 , -0.146587
			with: -0.272836 , -0.251532 , -0.343164;
		addTriangleWith: 0.136887 , -0.380173 , -0.304096
			with: 0.194798 , -0.456551 , -0.098651
			with: 0.00435016 , -0.505947 , 0.0139737;
		addTriangleWith: 0.136887 , -0.380173 , -0.304096
			with: 0.00435016 , -0.505947 , 0.0139737
			with: -0.171264 , -0.460098 , -0.121865;
		addTriangleWith: 0.136887 , -0.380173 , -0.304096
			with: -0.171264 , -0.460098 , -0.121865
			with: -0.0893519 , -0.382365 , -0.318443;
		addTriangleWith: -0.171264 , -0.460098 , -0.121865
			with: -0.296838 , -0.405643 , 0.0588581
			with: -0.354749 , -0.329265 , -0.146587;
		addTriangleWith: -0.354749 , -0.329265 , -0.146587
			with: -0.296838 , -0.405643 , 0.0588581
			with: -0.418107 , -0.239801 , 0.154697;
		addTriangleWith: -0.354749 , -0.329265 , -0.146587
			with: -0.418107 , -0.239801 , 0.154697
			with: -0.476018 , -0.163423 , -0.0507482;
		addTriangleWith: 0.00435016 , -0.505947 , 0.0139737
			with: -0.121223 , -0.451493 , 0.194697
			with: -0.296838 , -0.405643 , 0.0588581;
		addTriangleWith: 0.00435016 , -0.505947 , 0.0139737
			with: -0.296838 , -0.405643 , 0.0588581
			with: -0.171264 , -0.460098 , -0.121865;
		addTriangleWith: 0.00435016 , -0.505947 , 0.0139737
			with: 0.105016 , -0.449301 , 0.209044
			with: -0.121223 , -0.451493 , 0.194697;
		addTriangleWith: 0.105016 , -0.449301 , 0.209044
			with: 0.0922823 , -0.311795 , 0.388836
			with: -0.133957 , -0.313987 , 0.374488;
		addTriangleWith: 0.105016 , -0.449301 , 0.209044
			with: -0.133957 , -0.313987 , 0.374488
			with: -0.121223 , -0.451493 , 0.194697;
		addTriangleWith: -0.121223 , -0.451493 , 0.194697
			with: -0.133957 , -0.313987 , 0.374488
			with: -0.317441 , -0.183155 , 0.349767;
		addTriangleWith: -0.121223 , -0.451493 , 0.194697
			with: -0.317441 , -0.183155 , 0.349767
			with: -0.418107 , -0.239801 , 0.154697;
		addTriangleWith: -0.121223 , -0.451493 , 0.194697
			with: -0.418107 , -0.239801 , 0.154697
			with: -0.296838 , -0.405643 , 0.0588581;
		addTriangleWith: 0.0922823 , -0.311795 , 0.388836
			with: -0.0289873 , -0.145954 , 0.484674
			with: -0.133957 , -0.313987 , 0.374488;
		addTriangleWith: -0.133957 , -0.313987 , 0.374488
			with: -0.0289873 , -0.145954 , 0.484674
			with: -0.212472 , -0.0151211 , 0.459952;
		addTriangleWith: -0.133957 , -0.313987 , 0.374488
			with: -0.212472 , -0.0151211 , 0.459952
			with: -0.317441 , -0.183155 , 0.349767;
		addTriangleWith: -0.0823882 , -0.202136 , -0.455789
			with: -0.272836 , -0.251532 , -0.343164
			with: -0.343481 , -0.0376491 , -0.368818;
		addTriangleWith: -0.0823882 , -0.202136 , -0.455789
			with: -0.343481 , -0.0376491 , -0.368818
			with: -0.153033 , 0.011747 , -0.481443;
		addTriangleWith: -0.153033 , 0.011747 , -0.481443
			with: -0.343481 , -0.0376491 , -0.368818
			with: -0.274303 , 0.177589 , -0.385604;
		addTriangleWith: -0.343481 , -0.0376491 , -0.368818
			with: -0.469055 , 0.0168053 , -0.188095
			with: -0.399876 , 0.232043 , -0.204881;
		addTriangleWith: -0.343481 , -0.0376491 , -0.368818
			with: -0.399876 , 0.232043 , -0.204881
			with: -0.274303 , 0.177589 , -0.385604;
		addTriangleWith: -0.272836 , -0.251532 , -0.343164
			with: -0.354749 , -0.329265 , -0.146587
			with: -0.476018 , -0.163423 , -0.0507482;
		addTriangleWith: -0.272836 , -0.251532 , -0.343164
			with: -0.476018 , -0.163423 , -0.0507482
			with: -0.469055 , 0.0168053 , -0.188095;
		addTriangleWith: -0.272836 , -0.251532 , -0.343164
			with: -0.469055 , 0.0168053 , -0.188095
			with: -0.343481 , -0.0376491 , -0.368818;
		addTriangleWith: -0.469055 , 0.0168053 , -0.188095
			with: -0.481788 , 0.154311 , -0.0083031
			with: -0.399876 , 0.232043 , -0.204881;
		addTriangleWith: -0.399876 , 0.232043 , -0.204881
			with: -0.481788 , 0.154311 , -0.0083031
			with: -0.376819 , 0.322344 , 0.101882;
		addTriangleWith: -0.399876 , 0.232043 , -0.204881
			with: -0.376819 , 0.322344 , 0.101882
			with: -0.294906 , 0.400077 , -0.0946953;
		addTriangleWith: -0.476018 , -0.163423 , -0.0507482
			with: -0.488752 , -0.0259178 , 0.129043
			with: -0.481788 , 0.154311 , -0.0083031;
		addTriangleWith: -0.476018 , -0.163423 , -0.0507482
			with: -0.481788 , 0.154311 , -0.0083031
			with: -0.469055 , 0.0168053 , -0.188095;
		addTriangleWith: -0.476018 , -0.163423 , -0.0507482
			with: -0.418107 , -0.239801 , 0.154697
			with: -0.488752 , -0.0259178 , 0.129043;
		addTriangleWith: -0.418107 , -0.239801 , 0.154697
			with: -0.317441 , -0.183155 , 0.349767
			with: -0.388086 , 0.0307285 , 0.324114;
		addTriangleWith: -0.418107 , -0.239801 , 0.154697
			with: -0.388086 , 0.0307285 , 0.324114
			with: -0.488752 , -0.0259178 , 0.129043;
		addTriangleWith: -0.488752 , -0.0259178 , 0.129043
			with: -0.388086 , 0.0307285 , 0.324114
			with: -0.318908 , 0.245967 , 0.307327;
		addTriangleWith: -0.488752 , -0.0259178 , 0.129043
			with: -0.318908 , 0.245967 , 0.307327
			with: -0.376819 , 0.322344 , 0.101882;
		addTriangleWith: -0.488752 , -0.0259178 , 0.129043
			with: -0.376819 , 0.322344 , 0.101882
			with: -0.481788 , 0.154311 , -0.0083031;
		addTriangleWith: -0.317441 , -0.183155 , 0.349767
			with: -0.212472 , -0.0151211 , 0.459952
			with: -0.388086 , 0.0307285 , 0.324114;
		addTriangleWith: -0.388086 , 0.0307285 , 0.324114
			with: -0.212472 , -0.0151211 , 0.459952
			with: -0.143293 , 0.200117 , 0.443166;
		addTriangleWith: -0.388086 , 0.0307285 , 0.324114
			with: -0.143293 , 0.200117 , 0.443166
			with: -0.318908 , 0.245967 , 0.307327;
		addTriangleWith: -0.153033 , 0.011747 , -0.481443
			with: 0.0295454 , 0.146126 , -0.48295
			with: 0.21303 , 0.0152934 , -0.458229;
		addTriangleWith: -0.153033 , 0.011747 , -0.481443
			with: 0.21303 , 0.0152934 , -0.458229
			with: 0.143851 , -0.199944 , -0.441442;
		addTriangleWith: -0.153033 , 0.011747 , -0.481443
			with: 0.143851 , -0.199944 , -0.441442
			with: -0.0823882 , -0.202136 , -0.455789;
		addTriangleWith: -0.212472 , -0.0151211 , 0.459952
			with: -0.0289873 , -0.145954 , 0.484674
			with: 0.153591 , -0.0115745 , 0.483167;
		addTriangleWith: -0.212472 , -0.0151211 , 0.459952
			with: 0.153591 , -0.0115745 , 0.483167
			with: 0.0829462 , 0.202309 , 0.457513;
		addTriangleWith: -0.212472 , -0.0151211 , 0.459952
			with: 0.0829462 , 0.202309 , 0.457513
			with: -0.143293 , 0.200117 , 0.443166! !

!Polyhedron class methodsFor: 'factory-octagonal' stamp: 'emm 02/09/2012 23:40'!
octagonalAntiprism
	"self octagonalAntiprism"

	^(Triangle3DComposite new)
		add: (Triangle3D 
					with: 0.00589014 , -0.470388 , -0.16461
					with: -0.347663 , -0.323942 , -0.16461
					with: -0.49411 , 0.0296116 , -0.16461);
		add: (Triangle3D 
					with: 0.00589014 , -0.470388 , -0.16461
					with: -0.49411 , 0.0296116 , -0.16461
					with: -0.347663 , 0.383165 , -0.16461);
		add: (Triangle3D 
					with: 0.00589014 , -0.470388 , -0.16461
					with: -0.347663 , 0.383165 , -0.16461
					with: 0.00589014 , 0.529612 , -0.16461);
		add: (Triangle3D 
					with: 0.00589014 , -0.470388 , -0.16461
					with: 0.00589014 , 0.529612 , -0.16461
					with: 0.359443 , 0.383165 , -0.16461);
		add: (Triangle3D 
					with: 0.00589014 , -0.470388 , -0.16461
					with: 0.359443 , 0.383165 , -0.16461
					with: 0.50589 , 0.0296116 , -0.16461);
		add: (Triangle3D 
					with: 0.00589014 , -0.470388 , -0.16461
					with: 0.50589 , 0.0296116 , -0.16461
					with: 0.359443 , -0.323942 , -0.16461);
		add: (Triangle3D 
					with: -0.185452 , -0.432328 , 0.16461
					with: 0.197232 , -0.432328 , 0.16461
					with: 0.46783 , -0.16173 , 0.16461);
		add: (Triangle3D 
					with: -0.185452 , -0.432328 , 0.16461
					with: 0.46783 , -0.16173 , 0.16461
					with: 0.46783 , 0.220953 , 0.16461);
		add: (Triangle3D 
					with: -0.185452 , -0.432328 , 0.16461
					with: 0.46783 , 0.220953 , 0.16461
					with: 0.197232 , 0.491551 , 0.16461);
		add: (Triangle3D 
					with: -0.185452 , -0.432328 , 0.16461
					with: 0.197232 , 0.491551 , 0.16461
					with: -0.185452 , 0.491551 , 0.16461);
		add: (Triangle3D 
					with: -0.185452 , -0.432328 , 0.16461
					with: -0.185452 , 0.491551 , 0.16461
					with: -0.45605 , 0.220953 , 0.16461);
		add: (Triangle3D 
					with: -0.185452 , -0.432328 , 0.16461
					with: -0.45605 , 0.220953 , 0.16461
					with: -0.45605 , -0.16173 , 0.16461);
		add: (Triangle3D 
					with: 0.197232 , 0.491551 , 0.16461
					with: 0.00589014 , 0.529612 , -0.16461
					with: -0.185452 , 0.491551 , 0.16461);
		add: (Triangle3D 
					with: -0.185452 , 0.491551 , 0.16461
					with: 0.00589014 , 0.529612 , -0.16461
					with: -0.347663 , 0.383165 , -0.16461);
		add: (Triangle3D 
					with: -0.185452 , 0.491551 , 0.16461
					with: -0.347663 , 0.383165 , -0.16461
					with: -0.45605 , 0.220953 , 0.16461);
		add: (Triangle3D 
					with: -0.45605 , 0.220953 , 0.16461
					with: -0.347663 , 0.383165 , -0.16461
					with: -0.49411 , 0.0296116 , -0.16461);
		add: (Triangle3D 
					with: -0.45605 , 0.220953 , 0.16461
					with: -0.49411 , 0.0296116 , -0.16461
					with: -0.45605 , -0.16173 , 0.16461);
		add: (Triangle3D 
					with: -0.45605 , -0.16173 , 0.16461
					with: -0.49411 , 0.0296116 , -0.16461
					with: -0.347663 , -0.323942 , -0.16461);
		add: (Triangle3D 
					with: -0.45605 , -0.16173 , 0.16461
					with: -0.347663 , -0.323942 , -0.16461
					with: -0.185452 , -0.432328 , 0.16461);
		add: (Triangle3D 
					with: -0.185452 , -0.432328 , 0.16461
					with: -0.347663 , -0.323942 , -0.16461
					with: 0.00589014 , -0.470388 , -0.16461);
		add: (Triangle3D 
					with: -0.185452 , -0.432328 , 0.16461
					with: 0.00589014 , -0.470388 , -0.16461
					with: 0.197232 , -0.432328 , 0.16461);
		add: (Triangle3D 
					with: 0.197232 , -0.432328 , 0.16461
					with: 0.00589014 , -0.470388 , -0.16461
					with: 0.359443 , -0.323942 , -0.16461);
		add: (Triangle3D 
					with: 0.197232 , -0.432328 , 0.16461
					with: 0.359443 , -0.323942 , -0.16461
					with: 0.46783 , -0.16173 , 0.16461);
		add: (Triangle3D 
					with: 0.46783 , -0.16173 , 0.16461
					with: 0.359443 , -0.323942 , -0.16461
					with: 0.50589 , 0.0296116 , -0.16461);
		add: (Triangle3D 
					with: 0.46783 , -0.16173 , 0.16461
					with: 0.50589 , 0.0296116 , -0.16461
					with: 0.46783 , 0.220953 , 0.16461);
		add: (Triangle3D 
					with: 0.46783 , 0.220953 , 0.16461
					with: 0.50589 , 0.0296116 , -0.16461
					with: 0.359443 , 0.383165 , -0.16461);
		add: (Triangle3D 
					with: 0.46783 , 0.220953 , 0.16461
					with: 0.359443 , 0.383165 , -0.16461
					with: 0.197232 , 0.491551 , 0.16461);
		add: (Triangle3D 
					with: 0.197232 , 0.491551 , 0.16461
					with: 0.359443 , 0.383165 , -0.16461
					with: 0.00589014 , 0.529612 , -0.16461);
		yourself! !

!Polyhedron class methodsFor: 'factory-octagonal' stamp: 'emm 02/09/2012 23:40'!
octagonalPrism
	"self octagonalPrism  "

	^(Triangle3DComposite new)
		add: (Triangle3D 
					with: 0.292893 , -0.469217 , -0.0000000223377
					with: 0 , -0.469217 , -0.292893
					with: -0.207107 , -0.176324 , -0.5);
		add: (Triangle3D 
					with: 0.292893 , -0.469217 , -0.0000000223377
					with: -0.207107 , -0.176324 , -0.5
					with: -0.207107 , 0.23789 , -0.5);
		add: (Triangle3D 
					with: 0.292893 , -0.469217 , -0.0000000223377
					with: -0.207107 , 0.23789 , -0.5
					with: 0 , 0.530783 , -0.292893);
		add: (Triangle3D 
					with: 0.292893 , -0.469217 , -0.0000000223377
					with: 0 , 0.530783 , -0.292893
					with: 0.292893 , 0.530783 , -0.0000000223377);
		add: (Triangle3D 
					with: 0.292893 , -0.469217 , -0.0000000223377
					with: 0.292893 , 0.530783 , -0.0000000223377
					with: 0.5 , 0.23789 , 0.207107);
		add: (Triangle3D 
					with: 0.292893 , -0.469217 , -0.0000000223377
					with: 0.5 , 0.23789 , 0.207107
					with: 0.5 , -0.176324 , 0.207107);
		add: (Triangle3D 
					with: -0.292893 , -0.469217 , -0.0000000223377
					with: 0 , -0.469217 , 0.292893
					with: 0.207107 , -0.176324 , 0.5);
		add: (Triangle3D 
					with: -0.292893 , -0.469217 , -0.0000000223377
					with: 0.207107 , -0.176324 , 0.5
					with: 0.207107 , 0.23789 , 0.5);
		add: (Triangle3D 
					with: -0.292893 , -0.469217 , -0.0000000223377
					with: 0.207107 , 0.23789 , 0.5
					with: 0 , 0.530783 , 0.292893);
		add: (Triangle3D 
					with: -0.292893 , -0.469217 , -0.0000000223377
					with: 0 , 0.530783 , 0.292893
					with: -0.292893 , 0.530783 , -0.0000000223377);
		add: (Triangle3D 
					with: -0.292893 , -0.469217 , -0.0000000223377
					with: -0.292893 , 0.530783 , -0.0000000223377
					with: -0.5 , 0.23789 , -0.207107);
		add: (Triangle3D 
					with: -0.292893 , -0.469217 , -0.0000000223377
					with: -0.5 , 0.23789 , -0.207107
					with: -0.5 , -0.176324 , -0.207107);
		add: (Triangle3D 
					with: -0.292893 , 0.530783 , -0.0000000223377
					with: 0 , 0.530783 , -0.292893
					with: -0.207107 , 0.23789 , -0.5);
		add: (Triangle3D 
					with: -0.292893 , 0.530783 , -0.0000000223377
					with: -0.207107 , 0.23789 , -0.5
					with: -0.5 , 0.23789 , -0.207107);
		add: (Triangle3D 
					with: -0.5 , 0.23789 , -0.207107
					with: -0.207107 , 0.23789 , -0.5
					with: -0.207107 , -0.176324 , -0.5);
		add: (Triangle3D 
					with: -0.5 , 0.23789 , -0.207107
					with: -0.207107 , -0.176324 , -0.5
					with: -0.5 , -0.176324 , -0.207107);
		add: (Triangle3D 
					with: -0.5 , -0.176324 , -0.207107
					with: -0.207107 , -0.176324 , -0.5
					with: 0 , -0.469217 , -0.292893);
		add: (Triangle3D 
					with: -0.5 , -0.176324 , -0.207107
					with: 0 , -0.469217 , -0.292893
					with: -0.292893 , -0.469217 , -0.0000000223377);
		add: (Triangle3D 
					with: -0.292893 , -0.469217 , -0.0000000223377
					with: 0 , -0.469217 , -0.292893
					with: 0.292893 , -0.469217 , -0.0000000223377);
		add: (Triangle3D 
					with: -0.292893 , -0.469217 , -0.0000000223377
					with: 0.292893 , -0.469217 , -0.0000000223377
					with: 0 , -0.469217 , 0.292893);
		add: (Triangle3D 
					with: 0 , -0.469217 , 0.292893
					with: 0.292893 , -0.469217 , -0.0000000223377
					with: 0.5 , -0.176324 , 0.207107);
		add: (Triangle3D 
					with: 0 , -0.469217 , 0.292893
					with: 0.5 , -0.176324 , 0.207107
					with: 0.207107 , -0.176324 , 0.5);
		add: (Triangle3D 
					with: 0.207107 , -0.176324 , 0.5
					with: 0.5 , -0.176324 , 0.207107
					with: 0.5 , 0.23789 , 0.207107);
		add: (Triangle3D 
					with: 0.207107 , -0.176324 , 0.5
					with: 0.5 , 0.23789 , 0.207107
					with: 0.207107 , 0.23789 , 0.5);
		add: (Triangle3D 
					with: 0.207107 , 0.23789 , 0.5
					with: 0.5 , 0.23789 , 0.207107
					with: 0.292893 , 0.530783 , -0.0000000223377);
		add: (Triangle3D 
					with: 0.207107 , 0.23789 , 0.5
					with: 0.292893 , 0.530783 , -0.0000000223377
					with: 0 , 0.530783 , 0.292893);
		add: (Triangle3D 
					with: 0 , 0.530783 , 0.292893
					with: 0.292893 , 0.530783 , -0.0000000223377
					with: 0 , 0.530783 , -0.292893);
		add: (Triangle3D 
					with: 0 , 0.530783 , 0.292893
					with: 0 , 0.530783 , -0.292893
					with: -0.292893 , 0.530783 , -0.0000000223377);
		yourself! !

!Polyhedron class methodsFor: 'factory' stamp: 'emm 02/09/2012 23:40'!
octahedron
	"self octahedron"

	^(Triangle3DComposite new)
		add: (Triangle3D 
					with: -0.25 , 0.433013 , 0.353553
					with: 0.5 , 0 , 0.353553
					with: 0.25 , 0.433013 , -0.353553);
		add: (Triangle3D 
					with: -0.25 , 0.433013 , 0.353553
					with: 0.25 , 0.433013 , -0.353553
					with: -0.5 , 0 , -0.353553);
		add: (Triangle3D 
					with: -0.5 , 0 , -0.353553
					with: 0.25 , 0.433013 , -0.353553
					with: 0.25 , -0.433013 , -0.353553);
		add: (Triangle3D 
					with: 0.25 , 0.433013 , -0.353553
					with: 0.5 , 0 , 0.353553
					with: 0.25 , -0.433013 , -0.353553);
		add: (Triangle3D 
					with: -0.25 , 0.433013 , 0.353553
					with: -0.5 , 0 , -0.353553
					with: -0.25 , -0.433013 , 0.353553);
		add: (Triangle3D 
					with: -0.5 , 0 , -0.353553
					with: 0.25 , -0.433013 , -0.353553
					with: -0.25 , -0.433013 , 0.353553);
		add: (Triangle3D 
					with: -0.25 , -0.433013 , 0.353553
					with: 0.25 , -0.433013 , -0.353553
					with: 0.5 , 0 , 0.353553);
		add: (Triangle3D 
					with: -0.25 , -0.433013 , 0.353553
					with: 0.5 , 0 , 0.353553
					with: -0.25 , 0.433013 , 0.353553);
		yourself! !

!Polyhedron class methodsFor: 'factory' stamp: 'emm 02/09/2012 23:40'!
octahemioctahedron
	"self octahemioctahedron"

	^(Triangle3DComposite new)
		addTriangleWith: -0.133807 , -0.338478 , 0.371867
			with: -0.354667 , -0.367821 , -0.0983629
			with: 0.145333 , -0.49825 , -0.0371694;
		addTriangleWith: -0.133807 , -0.338478 , 0.371867
			with: -0.279139 , 0.159772 , 0.409036
			with: 0.00000000411916 , -0.0000000387685 , -9.69214e-10;
		addTriangleWith: -0.279139 , 0.159772 , 0.409036
			with: -0.5 , 0.130429 , -0.0611935
			with: 0.00000000411916 , -0.0000000387685 , -9.69214e-10;
		addTriangleWith: 0.00000000411916 , -0.0000000387685 , -9.69214e-10
			with: -0.5 , 0.130429 , -0.0611935
			with: -0.354667 , -0.367821 , -0.0983629;
		addTriangleWith: -0.5 , 0.130429 , -0.0611935
			with: -0.220861 , -0.0293429 , -0.47023
			with: -0.354667 , -0.367821 , -0.0983629;
		addTriangleWith: 0.00000000411916 , -0.0000000387685 , -9.69214e-10
			with: -0.354667 , -0.367821 , -0.0983629
			with: -0.133807 , -0.338478 , 0.371867;
		addTriangleWith: 0.145333 , -0.49825 , -0.0371694
			with: 0.5 , -0.130429 , 0.0611935
			with: 0.00000000411916 , -0.0000000387685 , -9.69214e-10;
		addTriangleWith: 0.5 , -0.130429 , 0.0611935
			with: 0.220861 , 0.029343 , 0.47023
			with: 0.00000000411916 , -0.0000000387685 , -9.69214e-10;
		addTriangleWith: 0.00000000411916 , -0.0000000387685 , -9.69214e-10
			with: 0.220861 , 0.029343 , 0.47023
			with: -0.133807 , -0.338478 , 0.371867;
		addTriangleWith: 0.220861 , 0.029343 , 0.47023
			with: -0.279139 , 0.159772 , 0.409036
			with: -0.133807 , -0.338478 , 0.371867;
		addTriangleWith: 0.00000000411916 , -0.0000000387685 , -9.69214e-10
			with: -0.133807 , -0.338478 , 0.371867
			with: 0.145333 , -0.49825 , -0.0371694;
		addTriangleWith: -0.354667 , -0.367821 , -0.0983629
			with: -0.220861 , -0.0293429 , -0.47023
			with: 0.00000000411916 , -0.0000000387685 , -9.69214e-10;
		addTriangleWith: -0.220861 , -0.0293429 , -0.47023
			with: 0.279139 , -0.159772 , -0.409036
			with: 0.00000000411916 , -0.0000000387685 , -9.69214e-10;
		addTriangleWith: 0.00000000411916 , -0.0000000387685 , -9.69214e-10
			with: 0.279139 , -0.159772 , -0.409036
			with: 0.145333 , -0.49825 , -0.0371694;
		addTriangleWith: 0.279139 , -0.159772 , -0.409036
			with: 0.5 , -0.130429 , 0.0611935
			with: 0.145333 , -0.49825 , -0.0371694;
		addTriangleWith: 0.00000000411916 , -0.0000000387685 , -9.69214e-10
			with: 0.145333 , -0.49825 , -0.0371694
			with: -0.354667 , -0.367821 , -0.0983629;
		addTriangleWith: 0.133807 , 0.338478 , -0.371867
			with: -0.145333 , 0.49825 , 0.0371694
			with: 0.354667 , 0.367821 , 0.098363;
		addTriangleWith: 0.133807 , 0.338478 , -0.371867
			with: -0.220861 , -0.0293429 , -0.47023
			with: 0.00000000411916 , -0.0000000387685 , -9.69214e-10;
		addTriangleWith: -0.220861 , -0.0293429 , -0.47023
			with: -0.5 , 0.130429 , -0.0611935
			with: 0.00000000411916 , -0.0000000387685 , -9.69214e-10;
		addTriangleWith: 0.00000000411916 , -0.0000000387685 , -9.69214e-10
			with: -0.5 , 0.130429 , -0.0611935
			with: -0.145333 , 0.49825 , 0.0371694;
		addTriangleWith: -0.5 , 0.130429 , -0.0611935
			with: -0.279139 , 0.159772 , 0.409036
			with: -0.145333 , 0.49825 , 0.0371694;
		addTriangleWith: 0.00000000411916 , -0.0000000387685 , -9.69214e-10
			with: -0.145333 , 0.49825 , 0.0371694
			with: 0.133807 , 0.338478 , -0.371867;
		addTriangleWith: 0.354667 , 0.367821 , 0.098363
			with: 0.5 , -0.130429 , 0.0611935
			with: 0.00000000411916 , -0.0000000387685 , -9.69214e-10;
		addTriangleWith: 0.5 , -0.130429 , 0.0611935
			with: 0.279139 , -0.159772 , -0.409036
			with: 0.00000000411916 , -0.0000000387685 , -9.69214e-10;
		addTriangleWith: 0.00000000411916 , -0.0000000387685 , -9.69214e-10
			with: 0.279139 , -0.159772 , -0.409036
			with: 0.133807 , 0.338478 , -0.371867;
		addTriangleWith: 0.279139 , -0.159772 , -0.409036
			with: -0.220861 , -0.0293429 , -0.47023
			with: 0.133807 , 0.338478 , -0.371867;
		addTriangleWith: 0.00000000411916 , -0.0000000387685 , -9.69214e-10
			with: 0.133807 , 0.338478 , -0.371867
			with: 0.354667 , 0.367821 , 0.098363;
		addTriangleWith: -0.145333 , 0.49825 , 0.0371694
			with: -0.279139 , 0.159772 , 0.409036
			with: 0.00000000411916 , -0.0000000387685 , -9.69214e-10;
		addTriangleWith: -0.279139 , 0.159772 , 0.409036
			with: 0.220861 , 0.029343 , 0.47023
			with: 0.00000000411916 , -0.0000000387685 , -9.69214e-10;
		addTriangleWith: 0.00000000411916 , -0.0000000387685 , -9.69214e-10
			with: 0.220861 , 0.029343 , 0.47023
			with: 0.354667 , 0.367821 , 0.098363;
		addTriangleWith: 0.220861 , 0.029343 , 0.47023
			with: 0.5 , -0.130429 , 0.0611935
			with: 0.354667 , 0.367821 , 0.098363;
		addTriangleWith: 0.00000000411916 , -0.0000000387685 , -9.69214e-10
			with: 0.354667 , 0.367821 , 0.098363
			with: -0.145333 , 0.49825 , 0.0371694! !

!Polyhedron class methodsFor: 'factory-dodecahedron' stamp: 'emm 02/09/2012 23:40'!
parabiaugmentedTruncatedDodecahedron
	"self parabiaugmentedTruncatedDodecahedron"

	^(Triangle3DComposite new)
		addTriangleWith: -0.265654 , -0.312799 , 0.286016
			with: -0.12301 , -0.402403 , 0.271749
			with: 0.0435737 , -0.399821 , 0.300437;
		addTriangleWith: -0.265654 , -0.312799 , 0.286016
			with: 0.0435737 , -0.399821 , 0.300437
			with: 0.170468 , -0.306039 , 0.361122;
		addTriangleWith: -0.265654 , -0.312799 , 0.286016
			with: 0.170468 , -0.306039 , 0.361122
			with: 0.209202 , -0.156879 , 0.430625;
		addTriangleWith: -0.265654 , -0.312799 , 0.286016
			with: 0.209202 , -0.156879 , 0.430625
			with: 0.144983 , -0.00931465 , 0.482398;
		addTriangleWith: -0.265654 , -0.312799 , 0.286016
			with: 0.144983 , -0.00931465 , 0.482398
			with: 0.00233876 , 0.0802892 , 0.496666;
		addTriangleWith: -0.265654 , -0.312799 , 0.286016
			with: 0.00233876 , 0.0802892 , 0.496666
			with: -0.164245 , 0.0777071 , 0.467978;
		addTriangleWith: -0.265654 , -0.312799 , 0.286016
			with: -0.164245 , 0.0777071 , 0.467978
			with: -0.291139 , -0.0160748 , 0.407292;
		addTriangleWith: -0.265654 , -0.312799 , 0.286016
			with: -0.291139 , -0.0160748 , 0.407292
			with: -0.329874 , -0.165235 , 0.337789;
		addTriangleWith: -0.408981 , -0.0249451 , 0.286402
			with: -0.329874 , -0.165235 , 0.337789
			with: -0.291139 , -0.0160748 , 0.407292;
		addTriangleWith: -0.407826 , -0.203324 , -0.202362
			with: -0.328719 , -0.343614 , -0.150976
			with: -0.264941 , -0.423044 , -0.0160566;
		addTriangleWith: -0.407826 , -0.203324 , -0.202362
			with: -0.264941 , -0.423044 , -0.0160566
			with: -0.240852 , -0.411273 , 0.150859;
		addTriangleWith: -0.407826 , -0.203324 , -0.202362
			with: -0.240852 , -0.411273 , 0.150859
			with: -0.265654 , -0.312799 , 0.286016;
		addTriangleWith: -0.407826 , -0.203324 , -0.202362
			with: -0.265654 , -0.312799 , 0.286016
			with: -0.329874 , -0.165235 , 0.337789;
		addTriangleWith: -0.407826 , -0.203324 , -0.202362
			with: -0.329874 , -0.165235 , 0.337789
			with: -0.408981 , -0.0249451 , 0.286402;
		addTriangleWith: -0.407826 , -0.203324 , -0.202362
			with: -0.408981 , -0.0249451 , 0.286402
			with: -0.472759 , 0.0544843 , 0.151484;
		addTriangleWith: -0.407826 , -0.203324 , -0.202362
			with: -0.472759 , 0.0544843 , 0.151484
			with: -0.496848 , 0.042714 , -0.0154323;
		addTriangleWith: -0.407826 , -0.203324 , -0.202362
			with: -0.496848 , 0.042714 , -0.0154323
			with: -0.472046 , -0.0557601 , -0.15059;
		addTriangleWith: -0.458113 , 0.191874 , 0.0540707
			with: -0.496848 , 0.042714 , -0.0154323
			with: -0.472759 , 0.0544843 , 0.151484;
		addTriangleWith: -0.240852 , -0.411273 , 0.150859
			with: -0.12301 , -0.402403 , 0.271749
			with: -0.265654 , -0.312799 , 0.286016;
		addTriangleWith: 0.132205 , -0.435328 , -0.211027
			with: 0.250047 , -0.426458 , -0.090137
			with: 0.274135 , -0.414688 , 0.0767791;
		addTriangleWith: 0.132205 , -0.435328 , -0.211027
			with: 0.274135 , -0.414688 , 0.0767791
			with: 0.19527 , -0.404513 , 0.225965;
		addTriangleWith: 0.132205 , -0.435328 , -0.211027
			with: 0.19527 , -0.404513 , 0.225965
			with: 0.0435737 , -0.399821 , 0.300437;
		addTriangleWith: 0.132205 , -0.435328 , -0.211027
			with: 0.0435737 , -0.399821 , 0.300437
			with: -0.12301 , -0.402403 , 0.271749;
		addTriangleWith: 0.132205 , -0.435328 , -0.211027
			with: -0.12301 , -0.402403 , 0.271749
			with: -0.240852 , -0.411273 , 0.150859;
		addTriangleWith: 0.132205 , -0.435328 , -0.211027
			with: -0.240852 , -0.411273 , 0.150859
			with: -0.264941 , -0.423044 , -0.0160566;
		addTriangleWith: 0.132205 , -0.435328 , -0.211027
			with: -0.264941 , -0.423044 , -0.0160566
			with: -0.186075 , -0.433218 , -0.165243;
		addTriangleWith: 0.132205 , -0.435328 , -0.211027
			with: -0.186075 , -0.433218 , -0.165243
			with: -0.034379 , -0.43791 , -0.239715;
		addTriangleWith: -0.328719 , -0.343614 , -0.150976
			with: -0.186075 , -0.433218 , -0.165243
			with: -0.264941 , -0.423044 , -0.0160566;
		addTriangleWith: 0.19527 , -0.404513 , 0.225965
			with: 0.170468 , -0.306039 , 0.361122
			with: 0.0435737 , -0.399821 , 0.300437;
		addTriangleWith: 0.503152 , -0.0406441 , 0.017352
			with: 0.47835 , 0.05783 , 0.152509
			with: 0.399484 , 0.0680046 , 0.301695;
		addTriangleWith: 0.503152 , -0.0406441 , 0.017352
			with: 0.399484 , 0.0680046 , 0.301695
			with: 0.296679 , -0.014007 , 0.407926;
		addTriangleWith: 0.503152 , -0.0406441 , 0.017352
			with: 0.296679 , -0.014007 , 0.407926
			with: 0.209202 , -0.156879 , 0.430625;
		addTriangleWith: 0.503152 , -0.0406441 , 0.017352
			with: 0.209202 , -0.156879 , 0.430625
			with: 0.170468 , -0.306039 , 0.361122;
		addTriangleWith: 0.503152 , -0.0406441 , 0.017352
			with: 0.170468 , -0.306039 , 0.361122
			with: 0.19527 , -0.404513 , 0.225965;
		addTriangleWith: 0.503152 , -0.0406441 , 0.017352
			with: 0.19527 , -0.404513 , 0.225965
			with: 0.274135 , -0.414688 , 0.0767791;
		addTriangleWith: 0.503152 , -0.0406441 , 0.017352
			with: 0.274135 , -0.414688 , 0.0767791
			with: 0.376941 , -0.332676 , -0.0294517;
		addTriangleWith: 0.503152 , -0.0406441 , 0.017352
			with: 0.376941 , -0.332676 , -0.0294517
			with: 0.464417 , -0.189804 , -0.052151;
		addTriangleWith: 0.250047 , -0.426458 , -0.090137
			with: 0.376941 , -0.332676 , -0.0294517
			with: 0.274135 , -0.414688 , 0.0767791;
		addTriangleWith: 0.296679 , -0.014007 , 0.407926
			with: 0.144983 , -0.00931465 , 0.482398
			with: 0.209202 , -0.156879 , 0.430625;
		addTriangleWith: 0.47835 , 0.05783 , 0.152509
			with: 0.503152 , -0.0406441 , 0.017352
			with: 0.479063 , -0.0524144 , -0.149564;
		addTriangleWith: 0.47835 , 0.05783 , 0.152509
			with: 0.479063 , -0.0524144 , -0.149564
			with: 0.415285 , 0.027015 , -0.284483;
		addTriangleWith: 0.47835 , 0.05783 , 0.152509
			with: 0.415285 , 0.027015 , -0.284483
			with: 0.336178 , 0.167305 , -0.33587;
		addTriangleWith: 0.47835 , 0.05783 , 0.152509
			with: 0.336178 , 0.167305 , -0.33587
			with: 0.271958 , 0.314869 , -0.284097;
		addTriangleWith: 0.47835 , 0.05783 , 0.152509
			with: 0.271958 , 0.314869 , -0.284097
			with: 0.247156 , 0.413343 , -0.14894;
		addTriangleWith: 0.47835 , 0.05783 , 0.152509
			with: 0.247156 , 0.413343 , -0.14894
			with: 0.271245 , 0.425114 , 0.0179765;
		addTriangleWith: 0.47835 , 0.05783 , 0.152509
			with: 0.271245 , 0.425114 , 0.0179765
			with: 0.335023 , 0.345684 , 0.152895;
		addTriangleWith: 0.47835 , 0.05783 , 0.152509
			with: 0.335023 , 0.345684 , 0.152895
			with: 0.41413 , 0.205394 , 0.204282;
		addTriangleWith: 0.41413 , 0.205394 , 0.204282
			with: 0.399484 , 0.0680046 , 0.301695
			with: 0.47835 , 0.05783 , 0.152509;
		addTriangleWith: -0.0767684 , 0.220579 , 0.445278
			with: -0.164245 , 0.0777071 , 0.467978
			with: 0.00233876 , 0.0802892 , 0.496666;
		addTriangleWith: -0.370637 , 0.334746 , 0.0313717
			with: -0.458113 , 0.191874 , 0.0540707
			with: -0.472759 , 0.0544843 , 0.151484;
		addTriangleWith: -0.370637 , 0.334746 , 0.0313717
			with: -0.472759 , 0.0544843 , 0.151484
			with: -0.408981 , -0.0249451 , 0.286402;
		addTriangleWith: -0.370637 , 0.334746 , 0.0313717
			with: -0.408981 , -0.0249451 , 0.286402
			with: -0.291139 , -0.0160748 , 0.407292;
		addTriangleWith: -0.370637 , 0.334746 , 0.0313717
			with: -0.291139 , -0.0160748 , 0.407292
			with: -0.164245 , 0.0777071 , 0.467978;
		addTriangleWith: -0.370637 , 0.334746 , 0.0313717
			with: -0.164245 , 0.0777071 , 0.467978
			with: -0.0767684 , 0.220579 , 0.445278;
		addTriangleWith: -0.370637 , 0.334746 , 0.0313717
			with: -0.0767684 , 0.220579 , 0.445278
			with: -0.0621222 , 0.357969 , 0.347865;
		addTriangleWith: -0.370637 , 0.334746 , 0.0313717
			with: -0.0621222 , 0.357969 , 0.347865
			with: -0.125901 , 0.437398 , 0.212947;
		addTriangleWith: -0.370637 , 0.334746 , 0.0313717
			with: -0.125901 , 0.437398 , 0.212947
			with: -0.243743 , 0.428528 , 0.0920567;
		addTriangleWith: 0.0406829 , 0.43998 , 0.241634
			with: -0.125901 , 0.437398 , 0.212947
			with: -0.0621222 , 0.357969 , 0.347865;
		addTriangleWith: -0.164164 , 0.308109 , -0.359202
			with: -0.0372698 , 0.401891 , -0.298517
			with: 0.129314 , 0.404473 , -0.269829;
		addTriangleWith: -0.164164 , 0.308109 , -0.359202
			with: 0.129314 , 0.404473 , -0.269829
			with: 0.271958 , 0.314869 , -0.284097;
		addTriangleWith: -0.164164 , 0.308109 , -0.359202
			with: 0.271958 , 0.314869 , -0.284097
			with: 0.336178 , 0.167305 , -0.33587;
		addTriangleWith: -0.164164 , 0.308109 , -0.359202
			with: 0.336178 , 0.167305 , -0.33587
			with: 0.297443 , 0.0181447 , -0.405373;
		addTriangleWith: -0.164164 , 0.308109 , -0.359202
			with: 0.297443 , 0.0181447 , -0.405373
			with: 0.170549 , -0.0756372 , -0.466058;
		addTriangleWith: -0.164164 , 0.308109 , -0.359202
			with: 0.170549 , -0.0756372 , -0.466058
			with: 0.0039652 , -0.0782193 , -0.494746;
		addTriangleWith: -0.164164 , 0.308109 , -0.359202
			with: 0.0039652 , -0.0782193 , -0.494746
			with: -0.138679 , 0.0113846 , -0.480478;
		addTriangleWith: -0.164164 , 0.308109 , -0.359202
			with: -0.138679 , 0.0113846 , -0.480478
			with: -0.202899 , 0.158949 , -0.428705;
		addTriangleWith: -0.290375 , 0.0160769 , -0.406006
			with: -0.202899 , 0.158949 , -0.428705
			with: -0.138679 , 0.0113846 , -0.480478;
		addTriangleWith: -0.458113 , 0.191874 , 0.0540707
			with: -0.370637 , 0.334746 , 0.0313717
			with: -0.267831 , 0.416758 , -0.0748591;
		addTriangleWith: -0.458113 , 0.191874 , 0.0540707
			with: -0.267831 , 0.416758 , -0.0748591
			with: -0.188966 , 0.406583 , -0.224045;
		addTriangleWith: -0.458113 , 0.191874 , 0.0540707
			with: -0.188966 , 0.406583 , -0.224045
			with: -0.164164 , 0.308109 , -0.359202;
		addTriangleWith: -0.458113 , 0.191874 , 0.0540707
			with: -0.164164 , 0.308109 , -0.359202
			with: -0.202899 , 0.158949 , -0.428705;
		addTriangleWith: -0.458113 , 0.191874 , 0.0540707
			with: -0.202899 , 0.158949 , -0.428705
			with: -0.290375 , 0.0160769 , -0.406006;
		addTriangleWith: -0.458113 , 0.191874 , 0.0540707
			with: -0.290375 , 0.0160769 , -0.406006
			with: -0.39318 , -0.0659346 , -0.299776;
		addTriangleWith: -0.458113 , 0.191874 , 0.0540707
			with: -0.39318 , -0.0659346 , -0.299776
			with: -0.472046 , -0.0557601 , -0.15059;
		addTriangleWith: -0.458113 , 0.191874 , 0.0540707
			with: -0.472046 , -0.0557601 , -0.15059
			with: -0.496848 , 0.042714 , -0.0154323;
		addTriangleWith: -0.407826 , -0.203324 , -0.202362
			with: -0.472046 , -0.0557601 , -0.15059
			with: -0.39318 , -0.0659346 , -0.299776;
		addTriangleWith: -0.188966 , 0.406583 , -0.224045
			with: -0.0372698 , 0.401891 , -0.298517
			with: -0.164164 , 0.308109 , -0.359202;
		addTriangleWith: 0.0406829 , 0.43998 , 0.241634
			with: 0.192379 , 0.435288 , 0.167163
			with: 0.271245 , 0.425114 , 0.0179765;
		addTriangleWith: 0.0406829 , 0.43998 , 0.241634
			with: 0.271245 , 0.425114 , 0.0179765
			with: 0.247156 , 0.413343 , -0.14894;
		addTriangleWith: 0.0406829 , 0.43998 , 0.241634
			with: 0.247156 , 0.413343 , -0.14894
			with: 0.129314 , 0.404473 , -0.269829;
		addTriangleWith: 0.0406829 , 0.43998 , 0.241634
			with: 0.129314 , 0.404473 , -0.269829
			with: -0.0372698 , 0.401891 , -0.298517;
		addTriangleWith: 0.0406829 , 0.43998 , 0.241634
			with: -0.0372698 , 0.401891 , -0.298517
			with: -0.188966 , 0.406583 , -0.224045;
		addTriangleWith: 0.0406829 , 0.43998 , 0.241634
			with: -0.188966 , 0.406583 , -0.224045
			with: -0.267831 , 0.416758 , -0.0748591;
		addTriangleWith: 0.0406829 , 0.43998 , 0.241634
			with: -0.267831 , 0.416758 , -0.0748591
			with: -0.243743 , 0.428528 , 0.0920567;
		addTriangleWith: 0.0406829 , 0.43998 , 0.241634
			with: -0.243743 , 0.428528 , 0.0920567
			with: -0.125901 , 0.437398 , 0.212947;
		addTriangleWith: -0.370637 , 0.334746 , 0.0313717
			with: -0.243743 , 0.428528 , 0.0920567
			with: -0.267831 , 0.416758 , -0.0748591;
		addTriangleWith: 0.247156 , 0.413343 , -0.14894
			with: 0.271958 , 0.314869 , -0.284097
			with: 0.129314 , 0.404473 , -0.269829;
		addTriangleWith: 0.335023 , 0.345684 , 0.152895
			with: 0.271245 , 0.425114 , 0.0179765
			with: 0.192379 , 0.435288 , 0.167163;
		addTriangleWith: 0.415285 , 0.027015 , -0.284483
			with: 0.297443 , 0.0181447 , -0.405373
			with: 0.336178 , 0.167305 , -0.33587;
		addTriangleWith: 0.250047 , -0.426458 , -0.090137
			with: 0.132205 , -0.435328 , -0.211027
			with: 0.0684262 , -0.355899 , -0.345946;
		addTriangleWith: 0.250047 , -0.426458 , -0.090137
			with: 0.0684262 , -0.355899 , -0.345946
			with: 0.0830723 , -0.218509 , -0.443359;
		addTriangleWith: 0.250047 , -0.426458 , -0.090137
			with: 0.0830723 , -0.218509 , -0.443359
			with: 0.170549 , -0.0756372 , -0.466058;
		addTriangleWith: 0.250047 , -0.426458 , -0.090137
			with: 0.170549 , -0.0756372 , -0.466058
			with: 0.297443 , 0.0181447 , -0.405373;
		addTriangleWith: 0.250047 , -0.426458 , -0.090137
			with: 0.297443 , 0.0181447 , -0.405373
			with: 0.415285 , 0.027015 , -0.284483;
		addTriangleWith: 0.250047 , -0.426458 , -0.090137
			with: 0.415285 , 0.027015 , -0.284483
			with: 0.479063 , -0.0524144 , -0.149564;
		addTriangleWith: 0.250047 , -0.426458 , -0.090137
			with: 0.479063 , -0.0524144 , -0.149564
			with: 0.464417 , -0.189804 , -0.052151;
		addTriangleWith: 0.250047 , -0.426458 , -0.090137
			with: 0.464417 , -0.189804 , -0.052151
			with: 0.376941 , -0.332676 , -0.0294517;
		addTriangleWith: 0.503152 , -0.0406441 , 0.017352
			with: 0.464417 , -0.189804 , -0.052151
			with: 0.479063 , -0.0524144 , -0.149564;
		addTriangleWith: 0.0830723 , -0.218509 , -0.443359
			with: 0.0039652 , -0.0782193 , -0.494746
			with: 0.170549 , -0.0756372 , -0.466058;
		addTriangleWith: -0.034379 , -0.43791 , -0.239715
			with: 0.0684262 , -0.355899 , -0.345946
			with: 0.132205 , -0.435328 , -0.211027;
		addTriangleWith: -0.144802 , -0.15755 , -0.482306
			with: -0.0656948 , -0.29784 , -0.430919
			with: -0.1685 , -0.379852 , -0.324688;
		addTriangleWith: -0.144802 , -0.15755 , -0.482306
			with: -0.1685 , -0.379852 , -0.324688
			with: -0.311144 , -0.290248 , -0.310421;
		addTriangleWith: -0.144802 , -0.15755 , -0.482306
			with: -0.311144 , -0.290248 , -0.310421
			with: -0.296498 , -0.152858 , -0.407834;
		addTriangleWith: -0.0656948 , -0.29784 , -0.430919
			with: -0.144802 , -0.15755 , -0.482306
			with: 0.0039652 , -0.0782193 , -0.494746;
		addTriangleWith: -0.0656948 , -0.29784 , -0.430919
			with: 0.0039652 , -0.0782193 , -0.494746
			with: 0.0830723 , -0.218509 , -0.443359;
		addTriangleWith: -0.0656948 , -0.29784 , -0.430919
			with: 0.0830723 , -0.218509 , -0.443359
			with: 0.0684262 , -0.355899 , -0.345946;
		addTriangleWith: -0.1685 , -0.379852 , -0.324688
			with: -0.0656948 , -0.29784 , -0.430919
			with: 0.0684262 , -0.355899 , -0.345946;
		addTriangleWith: -0.1685 , -0.379852 , -0.324688
			with: 0.0684262 , -0.355899 , -0.345946
			with: -0.034379 , -0.43791 , -0.239715;
		addTriangleWith: -0.1685 , -0.379852 , -0.324688
			with: -0.034379 , -0.43791 , -0.239715
			with: -0.186075 , -0.433218 , -0.165243;
		addTriangleWith: -0.311144 , -0.290248 , -0.310421
			with: -0.1685 , -0.379852 , -0.324688
			with: -0.186075 , -0.433218 , -0.165243;
		addTriangleWith: -0.311144 , -0.290248 , -0.310421
			with: -0.186075 , -0.433218 , -0.165243
			with: -0.328719 , -0.343614 , -0.150976;
		addTriangleWith: -0.311144 , -0.290248 , -0.310421
			with: -0.328719 , -0.343614 , -0.150976
			with: -0.407826 , -0.203324 , -0.202362;
		addTriangleWith: -0.296498 , -0.152858 , -0.407834
			with: -0.311144 , -0.290248 , -0.310421
			with: -0.407826 , -0.203324 , -0.202362;
		addTriangleWith: -0.296498 , -0.152858 , -0.407834
			with: -0.407826 , -0.203324 , -0.202362
			with: -0.39318 , -0.0659346 , -0.299776;
		addTriangleWith: -0.290375 , 0.0160769 , -0.406006
			with: -0.296498 , -0.152858 , -0.407834
			with: -0.39318 , -0.0659346 , -0.299776;
		addTriangleWith: -0.144802 , -0.15755 , -0.482306
			with: -0.296498 , -0.152858 , -0.407834
			with: -0.290375 , 0.0160769 , -0.406006;
		addTriangleWith: -0.144802 , -0.15755 , -0.482306
			with: -0.290375 , 0.0160769 , -0.406006
			with: -0.138679 , 0.0113846 , -0.480478;
		addTriangleWith: -0.144802 , -0.15755 , -0.482306
			with: -0.138679 , 0.0113846 , -0.480478
			with: 0.0039652 , -0.0782193 , -0.494746;
		addTriangleWith: 0.151106 , 0.15962 , 0.484226
			with: 0.302802 , 0.154928 , 0.409754
			with: 0.317448 , 0.292318 , 0.312341;
		addTriangleWith: 0.151106 , 0.15962 , 0.484226
			with: 0.317448 , 0.292318 , 0.312341
			with: 0.174804 , 0.381921 , 0.326608;
		addTriangleWith: 0.151106 , 0.15962 , 0.484226
			with: 0.174804 , 0.381921 , 0.326608
			with: 0.0719987 , 0.29991 , 0.432839;
		addTriangleWith: 0.302802 , 0.154928 , 0.409754
			with: 0.151106 , 0.15962 , 0.484226
			with: 0.144983 , -0.00931465 , 0.482398;
		addTriangleWith: 0.302802 , 0.154928 , 0.409754
			with: 0.144983 , -0.00931465 , 0.482398
			with: 0.296679 , -0.014007 , 0.407926;
		addTriangleWith: 0.302802 , 0.154928 , 0.409754
			with: 0.296679 , -0.014007 , 0.407926
			with: 0.399484 , 0.0680046 , 0.301695;
		addTriangleWith: 0.317448 , 0.292318 , 0.312341
			with: 0.302802 , 0.154928 , 0.409754
			with: 0.399484 , 0.0680046 , 0.301695;
		addTriangleWith: 0.317448 , 0.292318 , 0.312341
			with: 0.399484 , 0.0680046 , 0.301695
			with: 0.41413 , 0.205394 , 0.204282;
		addTriangleWith: 0.317448 , 0.292318 , 0.312341
			with: 0.41413 , 0.205394 , 0.204282
			with: 0.335023 , 0.345684 , 0.152895;
		addTriangleWith: 0.174804 , 0.381921 , 0.326608
			with: 0.317448 , 0.292318 , 0.312341
			with: 0.335023 , 0.345684 , 0.152895;
		addTriangleWith: 0.174804 , 0.381921 , 0.326608
			with: 0.335023 , 0.345684 , 0.152895
			with: 0.192379 , 0.435288 , 0.167163;
		addTriangleWith: 0.174804 , 0.381921 , 0.326608
			with: 0.192379 , 0.435288 , 0.167163
			with: 0.0406829 , 0.43998 , 0.241634;
		addTriangleWith: 0.0719987 , 0.29991 , 0.432839
			with: 0.174804 , 0.381921 , 0.326608
			with: 0.0406829 , 0.43998 , 0.241634;
		addTriangleWith: 0.0719987 , 0.29991 , 0.432839
			with: 0.0406829 , 0.43998 , 0.241634
			with: -0.0621222 , 0.357969 , 0.347865;
		addTriangleWith: -0.0767684 , 0.220579 , 0.445278
			with: 0.0719987 , 0.29991 , 0.432839
			with: -0.0621222 , 0.357969 , 0.347865;
		addTriangleWith: 0.151106 , 0.15962 , 0.484226
			with: 0.0719987 , 0.29991 , 0.432839
			with: -0.0767684 , 0.220579 , 0.445278;
		addTriangleWith: 0.151106 , 0.15962 , 0.484226
			with: -0.0767684 , 0.220579 , 0.445278
			with: 0.00233876 , 0.0802892 , 0.496666;
		addTriangleWith: 0.151106 , 0.15962 , 0.484226
			with: 0.00233876 , 0.0802892 , 0.496666
			with: 0.144983 , -0.00931465 , 0.482398! !

!Polyhedron class methodsFor: 'factory-dodecahedron' stamp: 'emm 02/09/2012 23:40'!
parabidiminishedRhombicosidodecahedron
	"self parabidiminishedRhombicosidodecahedron"

	^(Triangle3DComposite new)
		addTriangleWith: -0.0576152 , 0.4963 , 0.0115096
			with: -0.0773672 , 0.452242 , -0.208439
			with: -0.286624 , 0.37632 , -0.17444;
		addTriangleWith: -0.0576152 , 0.4963 , 0.0115096
			with: -0.286624 , 0.37632 , -0.17444
			with: -0.266872 , 0.420377 , 0.0455094;
		addTriangleWith: -0.266872 , 0.420377 , 0.0455094
			with: -0.286624 , 0.37632 , -0.17444
			with: -0.421069 , 0.272844 , -0.0263651;
		addTriangleWith: -0.286624 , 0.37632 , -0.17444
			with: -0.326863 , 0.213529 , -0.324735
			with: -0.461309 , 0.110053 , -0.17666;
		addTriangleWith: -0.286624 , 0.37632 , -0.17444
			with: -0.461309 , 0.110053 , -0.17666
			with: -0.421069 , 0.272844 , -0.0263651;
		addTriangleWith: -0.0773672 , 0.452242 , -0.208439
			with: 0.0117215 , 0.336374 , -0.379747
			with: -0.142476 , 0.188841 , -0.451622;
		addTriangleWith: -0.0773672 , 0.452242 , -0.208439
			with: -0.142476 , 0.188841 , -0.451622
			with: -0.326863 , 0.213529 , -0.324735;
		addTriangleWith: -0.0773672 , 0.452242 , -0.208439
			with: -0.326863 , 0.213529 , -0.324735
			with: -0.286624 , 0.37632 , -0.17444;
		addTriangleWith: -0.326863 , 0.213529 , -0.324735
			with: -0.37222 , -0.00581524 , -0.347968
			with: -0.461309 , 0.110053 , -0.17666;
		addTriangleWith: -0.461309 , 0.110053 , -0.17666
			with: -0.37222 , -0.00581524 , -0.347968
			with: -0.405369 , -0.19793 , -0.235266;
		addTriangleWith: -0.461309 , 0.110053 , -0.17666
			with: -0.405369 , -0.19793 , -0.235266
			with: -0.494458 , -0.0820618 , -0.063958;
		addTriangleWith: -0.142476 , 0.188841 , -0.451622
			with: -0.187832 , -0.0305029 , -0.474856
			with: -0.37222 , -0.00581524 , -0.347968;
		addTriangleWith: -0.142476 , 0.188841 , -0.451622
			with: -0.37222 , -0.00581524 , -0.347968
			with: -0.326863 , 0.213529 , -0.324735;
		addTriangleWith: -0.142476 , 0.188841 , -0.451622
			with: 0.021425 , 0.0454197 , -0.508856
			with: -0.187832 , -0.0305029 , -0.474856;
		addTriangleWith: 0.021425 , 0.0454197 , -0.508856
			with: 0.102234 , -0.161953 , -0.474574
			with: -0.107023 , -0.237876 , -0.440574;
		addTriangleWith: 0.021425 , 0.0454197 , -0.508856
			with: -0.107023 , -0.237876 , -0.440574
			with: -0.187832 , -0.0305029 , -0.474856;
		addTriangleWith: -0.187832 , -0.0305029 , -0.474856
			with: -0.107023 , -0.237876 , -0.440574
			with: -0.241468 , -0.341351 , -0.2925;
		addTriangleWith: -0.187832 , -0.0305029 , -0.474856
			with: -0.241468 , -0.341351 , -0.2925
			with: -0.405369 , -0.19793 , -0.235266;
		addTriangleWith: -0.187832 , -0.0305029 , -0.474856
			with: -0.405369 , -0.19793 , -0.235266
			with: -0.37222 , -0.00581524 , -0.347968;
		addTriangleWith: 0.102234 , -0.161953 , -0.474574
			with: 0.069085 , -0.354068 , -0.361872
			with: -0.107023 , -0.237876 , -0.440574;
		addTriangleWith: -0.107023 , -0.237876 , -0.440574
			with: 0.069085 , -0.354068 , -0.361872
			with: -0.0653601 , -0.457543 , -0.213797;
		addTriangleWith: -0.107023 , -0.237876 , -0.440574
			with: -0.0653601 , -0.457543 , -0.213797
			with: -0.241468 , -0.341351 , -0.2925;
		addTriangleWith: -0.266872 , 0.420377 , 0.0455094
			with: -0.421069 , 0.272844 , -0.0263651
			with: -0.429349 , 0.18134 , 0.179225;
		addTriangleWith: -0.266872 , 0.420377 , 0.0455094
			with: -0.429349 , 0.18134 , 0.179225
			with: -0.275152 , 0.328873 , 0.251099;
		addTriangleWith: -0.275152 , 0.328873 , 0.251099
			with: -0.429349 , 0.18134 , 0.179225
			with: -0.308301 , 0.136758 , 0.363801;
		addTriangleWith: -0.429349 , 0.18134 , 0.179225
			with: -0.474705 , -0.0380042 , 0.155991
			with: -0.353657 , -0.0825859 , 0.340568;
		addTriangleWith: -0.429349 , 0.18134 , 0.179225
			with: -0.353657 , -0.0825859 , 0.340568
			with: -0.308301 , 0.136758 , 0.363801;
		addTriangleWith: -0.421069 , 0.272844 , -0.0263651
			with: -0.461309 , 0.110053 , -0.17666
			with: -0.494458 , -0.0820618 , -0.063958;
		addTriangleWith: -0.421069 , 0.272844 , -0.0263651
			with: -0.494458 , -0.0820618 , -0.063958
			with: -0.474705 , -0.0380042 , 0.155991;
		addTriangleWith: -0.421069 , 0.272844 , -0.0263651
			with: -0.474705 , -0.0380042 , 0.155991
			with: -0.429349 , 0.18134 , 0.179225;
		addTriangleWith: -0.0136485 , -0.342199 , 0.362036
			with: -0.177549 , -0.198778 , 0.41927
			with: -0.353657 , -0.0825859 , 0.340568;
		addTriangleWith: -0.0136485 , -0.342199 , 0.362036
			with: -0.353657 , -0.0825859 , 0.340568
			with: -0.474705 , -0.0380042 , 0.155991;
		addTriangleWith: -0.0136485 , -0.342199 , 0.362036
			with: -0.474705 , -0.0380042 , 0.155991
			with: -0.494458 , -0.0820618 , -0.063958;
		addTriangleWith: -0.0136485 , -0.342199 , 0.362036
			with: -0.494458 , -0.0820618 , -0.063958
			with: -0.405369 , -0.19793 , -0.235266;
		addTriangleWith: -0.0136485 , -0.342199 , 0.362036
			with: -0.405369 , -0.19793 , -0.235266
			with: -0.241468 , -0.341351 , -0.2925;
		addTriangleWith: -0.0136485 , -0.342199 , 0.362036
			with: -0.241468 , -0.341351 , -0.2925
			with: -0.0653601 , -0.457543 , -0.213797;
		addTriangleWith: -0.0136485 , -0.342199 , 0.362036
			with: -0.0653601 , -0.457543 , -0.213797
			with: 0.0556882 , -0.502125 , -0.0292206;
		addTriangleWith: -0.0136485 , -0.342199 , 0.362036
			with: 0.0556882 , -0.502125 , -0.0292206
			with: 0.0754402 , -0.458067 , 0.190728;
		addTriangleWith: -0.275152 , 0.328873 , 0.251099
			with: -0.308301 , 0.136758 , 0.363801
			with: -0.104161 , 0.156128 , 0.456863;
		addTriangleWith: -0.275152 , 0.328873 , 0.251099
			with: -0.104161 , 0.156128 , 0.456863
			with: -0.0710121 , 0.348243 , 0.344161;
		addTriangleWith: -0.0710121 , 0.348243 , 0.344161
			with: -0.104161 , 0.156128 , 0.456863
			with: 0.105096 , 0.232051 , 0.422863;
		addTriangleWith: -0.104161 , 0.156128 , 0.456863
			with: -0.023352 , -0.0512449 , 0.491144
			with: 0.185905 , 0.0246778 , 0.457145;
		addTriangleWith: -0.104161 , 0.156128 , 0.456863
			with: 0.185905 , 0.0246778 , 0.457145
			with: 0.105096 , 0.232051 , 0.422863;
		addTriangleWith: -0.308301 , 0.136758 , 0.363801
			with: -0.353657 , -0.0825859 , 0.340568
			with: -0.177549 , -0.198778 , 0.41927;
		addTriangleWith: -0.308301 , 0.136758 , 0.363801
			with: -0.177549 , -0.198778 , 0.41927
			with: -0.023352 , -0.0512449 , 0.491144;
		addTriangleWith: -0.308301 , 0.136758 , 0.363801
			with: -0.023352 , -0.0512449 , 0.491144
			with: -0.104161 , 0.156128 , 0.456863;
		addTriangleWith: -0.023352 , -0.0512449 , 0.491144
			with: 0.140549 , -0.194666 , 0.433911
			with: 0.185905 , 0.0246778 , 0.457145;
		addTriangleWith: 0.185905 , 0.0246778 , 0.457145
			with: 0.140549 , -0.194666 , 0.433911
			with: 0.324936 , -0.219354 , 0.307024;
		addTriangleWith: 0.185905 , 0.0246778 , 0.457145
			with: 0.324936 , -0.219354 , 0.307024
			with: 0.370293 , -0.000009895 , 0.330257;
		addTriangleWith: -0.177549 , -0.198778 , 0.41927
			with: -0.0136485 , -0.342199 , 0.362036
			with: 0.140549 , -0.194666 , 0.433911;
		addTriangleWith: -0.177549 , -0.198778 , 0.41927
			with: 0.140549 , -0.194666 , 0.433911
			with: -0.023352 , -0.0512449 , 0.491144;
		addTriangleWith: -0.0136485 , -0.342199 , 0.362036
			with: 0.0754402 , -0.458067 , 0.190728
			with: 0.284697 , -0.382145 , 0.156728;
		addTriangleWith: -0.0136485 , -0.342199 , 0.362036
			with: 0.284697 , -0.382145 , 0.156728
			with: 0.324936 , -0.219354 , 0.307024;
		addTriangleWith: -0.0136485 , -0.342199 , 0.362036
			with: 0.324936 , -0.219354 , 0.307024
			with: 0.140549 , -0.194666 , 0.433911;
		addTriangleWith: 0.0754402 , -0.458067 , 0.190728
			with: 0.0556882 , -0.502125 , -0.0292206
			with: 0.264945 , -0.426202 , -0.0632204;
		addTriangleWith: 0.0754402 , -0.458067 , 0.190728
			with: 0.264945 , -0.426202 , -0.0632204
			with: 0.284697 , -0.382145 , 0.156728;
		addTriangleWith: -0.0710121 , 0.348243 , 0.344161
			with: 0.105096 , 0.232051 , 0.422863
			with: 0.239541 , 0.335526 , 0.274789;
		addTriangleWith: -0.0710121 , 0.348243 , 0.344161
			with: 0.239541 , 0.335526 , 0.274789
			with: 0.0634331 , 0.451718 , 0.196086;
		addTriangleWith: 0.0634331 , 0.451718 , 0.196086
			with: 0.239541 , 0.335526 , 0.274789
			with: 0.403442 , 0.192105 , 0.217555;
		addTriangleWith: 0.0634331 , 0.451718 , 0.196086
			with: 0.403442 , 0.192105 , 0.217555
			with: 0.492531 , 0.0762367 , 0.0462469;
		addTriangleWith: 0.0634331 , 0.451718 , 0.196086
			with: 0.492531 , 0.0762367 , 0.0462469
			with: 0.472778 , 0.0321791 , -0.173702;
		addTriangleWith: 0.0634331 , 0.451718 , 0.196086
			with: 0.472778 , 0.0321791 , -0.173702
			with: 0.35173 , 0.0767607 , -0.358279;
		addTriangleWith: 0.0634331 , 0.451718 , 0.196086
			with: 0.35173 , 0.0767607 , -0.358279
			with: 0.175622 , 0.192953 , -0.436981;
		addTriangleWith: 0.0634331 , 0.451718 , 0.196086
			with: 0.175622 , 0.192953 , -0.436981
			with: 0.0117215 , 0.336374 , -0.379747;
		addTriangleWith: 0.0634331 , 0.451718 , 0.196086
			with: 0.0117215 , 0.336374 , -0.379747
			with: -0.0773672 , 0.452242 , -0.208439;
		addTriangleWith: 0.0634331 , 0.451718 , 0.196086
			with: -0.0773672 , 0.452242 , -0.208439
			with: -0.0576152 , 0.4963 , 0.0115096;
		addTriangleWith: 0.105096 , 0.232051 , 0.422863
			with: 0.185905 , 0.0246778 , 0.457145
			with: 0.370293 , -0.000009895 , 0.330257;
		addTriangleWith: 0.105096 , 0.232051 , 0.422863
			with: 0.370293 , -0.000009895 , 0.330257
			with: 0.403442 , 0.192105 , 0.217555;
		addTriangleWith: 0.105096 , 0.232051 , 0.422863
			with: 0.403442 , 0.192105 , 0.217555
			with: 0.239541 , 0.335526 , 0.274789;
		addTriangleWith: 0.370293 , -0.000009895 , 0.330257
			with: 0.459382 , -0.115878 , 0.158949
			with: 0.492531 , 0.0762367 , 0.0462469;
		addTriangleWith: 0.370293 , -0.000009895 , 0.330257
			with: 0.492531 , 0.0762367 , 0.0462469
			with: 0.403442 , 0.192105 , 0.217555;
		addTriangleWith: 0.370293 , -0.000009895 , 0.330257
			with: 0.324936 , -0.219354 , 0.307024
			with: 0.459382 , -0.115878 , 0.158949;
		addTriangleWith: 0.324936 , -0.219354 , 0.307024
			with: 0.284697 , -0.382145 , 0.156728
			with: 0.419142 , -0.278669 , 0.00865403;
		addTriangleWith: 0.324936 , -0.219354 , 0.307024
			with: 0.419142 , -0.278669 , 0.00865403
			with: 0.459382 , -0.115878 , 0.158949;
		addTriangleWith: 0.459382 , -0.115878 , 0.158949
			with: 0.419142 , -0.278669 , 0.00865403
			with: 0.427422 , -0.187165 , -0.196936;
		addTriangleWith: 0.459382 , -0.115878 , 0.158949
			with: 0.427422 , -0.187165 , -0.196936
			with: 0.472778 , 0.0321791 , -0.173702;
		addTriangleWith: 0.459382 , -0.115878 , 0.158949
			with: 0.472778 , 0.0321791 , -0.173702
			with: 0.492531 , 0.0762367 , 0.0462469;
		addTriangleWith: 0.284697 , -0.382145 , 0.156728
			with: 0.264945 , -0.426202 , -0.0632204
			with: 0.419142 , -0.278669 , 0.00865403;
		addTriangleWith: 0.419142 , -0.278669 , 0.00865403
			with: 0.264945 , -0.426202 , -0.0632204
			with: 0.273225 , -0.334698 , -0.26881;
		addTriangleWith: 0.419142 , -0.278669 , 0.00865403
			with: 0.273225 , -0.334698 , -0.26881
			with: 0.427422 , -0.187165 , -0.196936;
		addTriangleWith: 0.0117215 , 0.336374 , -0.379747
			with: 0.175622 , 0.192953 , -0.436981
			with: 0.021425 , 0.0454197 , -0.508856;
		addTriangleWith: 0.0117215 , 0.336374 , -0.379747
			with: 0.021425 , 0.0454197 , -0.508856
			with: -0.142476 , 0.188841 , -0.451622;
		addTriangleWith: 0.472778 , 0.0321791 , -0.173702
			with: 0.427422 , -0.187165 , -0.196936
			with: 0.306374 , -0.142583 , -0.381512;
		addTriangleWith: 0.472778 , 0.0321791 , -0.173702
			with: 0.306374 , -0.142583 , -0.381512
			with: 0.35173 , 0.0767607 , -0.358279;
		addTriangleWith: 0.35173 , 0.0767607 , -0.358279
			with: 0.306374 , -0.142583 , -0.381512
			with: 0.102234 , -0.161953 , -0.474574;
		addTriangleWith: 0.35173 , 0.0767607 , -0.358279
			with: 0.102234 , -0.161953 , -0.474574
			with: 0.021425 , 0.0454197 , -0.508856;
		addTriangleWith: 0.35173 , 0.0767607 , -0.358279
			with: 0.021425 , 0.0454197 , -0.508856
			with: 0.175622 , 0.192953 , -0.436981;
		addTriangleWith: 0.427422 , -0.187165 , -0.196936
			with: 0.273225 , -0.334698 , -0.26881
			with: 0.306374 , -0.142583 , -0.381512;
		addTriangleWith: 0.306374 , -0.142583 , -0.381512
			with: 0.273225 , -0.334698 , -0.26881
			with: 0.069085 , -0.354068 , -0.361872;
		addTriangleWith: 0.306374 , -0.142583 , -0.381512
			with: 0.069085 , -0.354068 , -0.361872
			with: 0.102234 , -0.161953 , -0.474574;
		addTriangleWith: -0.0576152 , 0.4963 , 0.0115096
			with: -0.266872 , 0.420377 , 0.0455094
			with: -0.275152 , 0.328873 , 0.251099;
		addTriangleWith: -0.0576152 , 0.4963 , 0.0115096
			with: -0.275152 , 0.328873 , 0.251099
			with: -0.0710121 , 0.348243 , 0.344161;
		addTriangleWith: -0.0576152 , 0.4963 , 0.0115096
			with: -0.0710121 , 0.348243 , 0.344161
			with: 0.0634331 , 0.451718 , 0.196086;
		addTriangleWith: 0.273225 , -0.334698 , -0.26881
			with: 0.264945 , -0.426202 , -0.0632204
			with: 0.0556882 , -0.502125 , -0.0292206;
		addTriangleWith: 0.273225 , -0.334698 , -0.26881
			with: 0.0556882 , -0.502125 , -0.0292206
			with: -0.0653601 , -0.457543 , -0.213797;
		addTriangleWith: 0.273225 , -0.334698 , -0.26881
			with: -0.0653601 , -0.457543 , -0.213797
			with: 0.069085 , -0.354068 , -0.361872! !

!Polyhedron class methodsFor: 'factory-dodecahedron' stamp: 'emm 02/09/2012 23:40'!
parabigyrateRhombicosidodecahedron
	"self parabigyrateRhombicosidodecahedron"

	^(Triangle3DComposite new)
		addTriangleWith: -0.0683144 , 0.134413 , -0.483938
			with: -0.168078 , 0.303753 , -0.369561
			with: 0.0361255 , 0.391148 , -0.320839;
		addTriangleWith: -0.0683144 , 0.134413 , -0.483938
			with: 0.0361255 , 0.391148 , -0.320839
			with: 0.135889 , 0.221808 , -0.435216;
		addTriangleWith: 0.135889 , 0.221808 , -0.435216
			with: 0.0361255 , 0.391148 , -0.320839
			with: 0.253583 , 0.338838 , -0.279772;
		addTriangleWith: 0.0361255 , 0.391148 , -0.320839
			with: 0.0223551 , 0.493112 , -0.118047
			with: 0.239813 , 0.440802 , -0.0769801;
		addTriangleWith: 0.0361255 , 0.391148 , -0.320839
			with: 0.239813 , 0.440802 , -0.0769801
			with: 0.253583 , 0.338838 , -0.279772;
		addTriangleWith: -0.168078 , 0.303753 , -0.369561
			with: -0.308053 , 0.351703 , -0.19688
			with: -0.190359 , 0.468733 , -0.0414363;
		addTriangleWith: -0.168078 , 0.303753 , -0.369561
			with: -0.190359 , 0.468733 , -0.0414363
			with: 0.0223551 , 0.493112 , -0.118047;
		addTriangleWith: -0.168078 , 0.303753 , -0.369561
			with: 0.0223551 , 0.493112 , -0.118047
			with: 0.0361255 , 0.391148 , -0.320839;
		addTriangleWith: -0.190359 , 0.468733 , -0.0414363
			with: -0.0190582 , 0.496472 , 0.105525
			with: 0.0223551 , 0.493112 , -0.118047;
		addTriangleWith: 0.0223551 , 0.493112 , -0.118047
			with: -0.0190582 , 0.496472 , 0.105525
			with: 0.1984 , 0.444162 , 0.146592;
		addTriangleWith: 0.0223551 , 0.493112 , -0.118047
			with: 0.1984 , 0.444162 , 0.146592
			with: 0.239813 , 0.440802 , -0.0769801;
		addTriangleWith: -0.317079 , 0.376978 , 0.12359
			with: -0.145779 , 0.404717 , 0.270551
			with: -0.0190582 , 0.496472 , 0.105525;
		addTriangleWith: -0.317079 , 0.376978 , 0.12359
			with: -0.0190582 , 0.496472 , 0.105525
			with: -0.190359 , 0.468733 , -0.0414363;
		addTriangleWith: -0.317079 , 0.376978 , 0.12359
			with: -0.309403 , 0.252894 , 0.313998
			with: -0.145779 , 0.404717 , 0.270551;
		addTriangleWith: -0.309403 , 0.252894 , 0.313998
			with: -0.170263 , 0.143876 , 0.457057
			with: -0.00663827 , 0.295699 , 0.41361;
		addTriangleWith: -0.309403 , 0.252894 , 0.313998
			with: -0.00663827 , 0.295699 , 0.41361
			with: -0.145779 , 0.404717 , 0.270551;
		addTriangleWith: -0.145779 , 0.404717 , 0.270551
			with: -0.00663827 , 0.295699 , 0.41361
			with: 0.206076 , 0.320078 , 0.336999;
		addTriangleWith: -0.145779 , 0.404717 , 0.270551
			with: 0.206076 , 0.320078 , 0.336999
			with: 0.1984 , 0.444162 , 0.146592;
		addTriangleWith: -0.145779 , 0.404717 , 0.270551
			with: 0.1984 , 0.444162 , 0.146592
			with: -0.0190582 , 0.496472 , 0.105525;
		addTriangleWith: -0.170263 , 0.143876 , 0.457057
			with: 0.0471951 , 0.0915666 , 0.498124
			with: -0.00663827 , 0.295699 , 0.41361;
		addTriangleWith: -0.00663827 , 0.295699 , 0.41361
			with: 0.0471951 , 0.0915666 , 0.498124
			with: 0.259909 , 0.115945 , 0.421513;
		addTriangleWith: -0.00663827 , 0.295699 , 0.41361
			with: 0.259909 , 0.115945 , 0.421513
			with: 0.206076 , 0.320078 , 0.336999;
		addTriangleWith: 0.135889 , 0.221808 , -0.435216
			with: 0.253583 , 0.338838 , -0.279772
			with: 0.401234 , 0.166804 , -0.262046;
		addTriangleWith: 0.135889 , 0.221808 , -0.435216
			with: 0.401234 , 0.166804 , -0.262046
			with: 0.28354 , 0.0497742 , -0.417489;
		addTriangleWith: 0.28354 , 0.0497742 , -0.417489
			with: 0.401234 , 0.166804 , -0.262046
			with: 0.42268 , -0.0592433 , -0.27443;
		addTriangleWith: 0.401234 , 0.166804 , -0.262046
			with: 0.478717 , 0.162445 , -0.0482977
			with: 0.500163 , -0.0636029 , -0.0606825;
		addTriangleWith: 0.401234 , 0.166804 , -0.262046
			with: 0.500163 , -0.0636029 , -0.0606825
			with: 0.42268 , -0.0592433 , -0.27443;
		addTriangleWith: 0.253583 , 0.338838 , -0.279772
			with: 0.239813 , 0.440802 , -0.0769801
			with: 0.378954 , 0.331784 , 0.0660789;
		addTriangleWith: 0.253583 , 0.338838 , -0.279772
			with: 0.378954 , 0.331784 , 0.0660789
			with: 0.478717 , 0.162445 , -0.0482977;
		addTriangleWith: 0.253583 , 0.338838 , -0.279772
			with: 0.478717 , 0.162445 , -0.0482977
			with: 0.401234 , 0.166804 , -0.262046;
		addTriangleWith: 0.478717 , 0.162445 , -0.0482977
			with: 0.486393 , 0.0383604 , 0.14211
			with: 0.500163 , -0.0636029 , -0.0606825;
		addTriangleWith: 0.500163 , -0.0636029 , -0.0606825
			with: 0.486393 , 0.0383604 , 0.14211
			with: 0.42133 , -0.158052 , 0.236447;
		addTriangleWith: 0.500163 , -0.0636029 , -0.0606825
			with: 0.42133 , -0.158052 , 0.236447
			with: 0.4351 , -0.260016 , 0.0336554;
		addTriangleWith: 0.378954 , 0.331784 , 0.0660789
			with: 0.386629 , 0.2077 , 0.256486
			with: 0.486393 , 0.0383604 , 0.14211;
		addTriangleWith: 0.378954 , 0.331784 , 0.0660789
			with: 0.486393 , 0.0383604 , 0.14211
			with: 0.478717 , 0.162445 , -0.0482977;
		addTriangleWith: 0.239813 , 0.440802 , -0.0769801
			with: 0.1984 , 0.444162 , 0.146592
			with: 0.378954 , 0.331784 , 0.0660789;
		addTriangleWith: 0.1984 , 0.444162 , 0.146592
			with: 0.206076 , 0.320078 , 0.336999
			with: 0.386629 , 0.2077 , 0.256486;
		addTriangleWith: 0.1984 , 0.444162 , 0.146592
			with: 0.386629 , 0.2077 , 0.256486
			with: 0.378954 , 0.331784 , 0.0660789;
		addTriangleWith: 0.386629 , 0.2077 , 0.256486
			with: 0.259909 , 0.115945 , 0.421513
			with: 0.281355 , -0.110102 , 0.409128;
		addTriangleWith: 0.386629 , 0.2077 , 0.256486
			with: 0.281355 , -0.110102 , 0.409128
			with: 0.42133 , -0.158052 , 0.236447;
		addTriangleWith: 0.386629 , 0.2077 , 0.256486
			with: 0.42133 , -0.158052 , 0.236447
			with: 0.486393 , 0.0383604 , 0.14211;
		addTriangleWith: 0.206076 , 0.320078 , 0.336999
			with: 0.259909 , 0.115945 , 0.421513
			with: 0.386629 , 0.2077 , 0.256486;
		addTriangleWith: 0.259909 , 0.115945 , 0.421513
			with: 0.0471951 , 0.0915666 , 0.498124
			with: 0.0686412 , -0.134481 , 0.485739;
		addTriangleWith: 0.259909 , 0.115945 , 0.421513
			with: 0.0686412 , -0.134481 , 0.485739
			with: 0.281355 , -0.110102 , 0.409128;
		addTriangleWith: 0.28354 , 0.0497742 , -0.417489
			with: 0.42268 , -0.0592433 , -0.27443
			with: 0.30973 , -0.252961 , -0.312196;
		addTriangleWith: 0.28354 , 0.0497742 , -0.417489
			with: 0.30973 , -0.252961 , -0.312196
			with: 0.170589 , -0.143944 , -0.455255;
		addTriangleWith: 0.30973 , -0.252961 , -0.312196
			with: 0.317406 , -0.377046 , -0.121789
			with: 0.146106 , -0.404785 , -0.268749;
		addTriangleWith: 0.317406 , -0.377046 , -0.121789
			with: 0.190686 , -0.468801 , 0.0432378
			with: 0.0193852 , -0.49654 , -0.103723;
		addTriangleWith: 0.317406 , -0.377046 , -0.121789
			with: 0.0193852 , -0.49654 , -0.103723
			with: 0.146106 , -0.404785 , -0.268749;
		addTriangleWith: 0.42268 , -0.0592433 , -0.27443
			with: 0.500163 , -0.0636029 , -0.0606825
			with: 0.4351 , -0.260016 , 0.0336554;
		addTriangleWith: 0.42268 , -0.0592433 , -0.27443
			with: 0.4351 , -0.260016 , 0.0336554
			with: 0.317406 , -0.377046 , -0.121789;
		addTriangleWith: 0.42268 , -0.0592433 , -0.27443
			with: 0.317406 , -0.377046 , -0.121789
			with: 0.30973 , -0.252961 , -0.312196;
		addTriangleWith: 0.190686 , -0.468801 , 0.0432378
			with: -0.0220284 , -0.493179 , 0.119849
			with: 0.0193852 , -0.49654 , -0.103723;
		addTriangleWith: 0.0193852 , -0.49654 , -0.103723
			with: -0.0220284 , -0.493179 , 0.119849
			with: -0.239486 , -0.440869 , 0.0787818;
		addTriangleWith: 0.0193852 , -0.49654 , -0.103723
			with: -0.239486 , -0.440869 , 0.0787818
			with: -0.198073 , -0.44423 , -0.14479;
		addTriangleWith: 0.4351 , -0.260016 , 0.0336554
			with: 0.30838 , -0.351771 , 0.198682
			with: 0.190686 , -0.468801 , 0.0432378;
		addTriangleWith: 0.4351 , -0.260016 , 0.0336554
			with: 0.190686 , -0.468801 , 0.0432378
			with: 0.317406 , -0.377046 , -0.121789;
		addTriangleWith: 0.4351 , -0.260016 , 0.0336554
			with: 0.42133 , -0.158052 , 0.236447
			with: 0.30838 , -0.351771 , 0.198682;
		addTriangleWith: 0.42133 , -0.158052 , 0.236447
			with: 0.281355 , -0.110102 , 0.409128
			with: 0.168405 , -0.303821 , 0.371362;
		addTriangleWith: 0.42133 , -0.158052 , 0.236447
			with: 0.168405 , -0.303821 , 0.371362
			with: 0.30838 , -0.351771 , 0.198682;
		addTriangleWith: 0.30838 , -0.351771 , 0.198682
			with: 0.168405 , -0.303821 , 0.371362
			with: -0.0357987 , -0.391216 , 0.322641;
		addTriangleWith: 0.30838 , -0.351771 , 0.198682
			with: -0.0357987 , -0.391216 , 0.322641
			with: -0.0220284 , -0.493179 , 0.119849;
		addTriangleWith: 0.30838 , -0.351771 , 0.198682
			with: -0.0220284 , -0.493179 , 0.119849
			with: 0.190686 , -0.468801 , 0.0432378;
		addTriangleWith: 0.281355 , -0.110102 , 0.409128
			with: 0.0686412 , -0.134481 , 0.485739
			with: 0.168405 , -0.303821 , 0.371362;
		addTriangleWith: 0.168405 , -0.303821 , 0.371362
			with: 0.0686412 , -0.134481 , 0.485739
			with: -0.135562 , -0.221876 , 0.437018;
		addTriangleWith: 0.168405 , -0.303821 , 0.371362
			with: -0.135562 , -0.221876 , 0.437018
			with: -0.0357987 , -0.391216 , 0.322641;
		addTriangleWith: 0.30973 , -0.252961 , -0.312196
			with: 0.146106 , -0.404785 , -0.268749
			with: 0.00696505 , -0.295767 , -0.411809;
		addTriangleWith: 0.30973 , -0.252961 , -0.312196
			with: 0.00696505 , -0.295767 , -0.411809
			with: 0.170589 , -0.143944 , -0.455255;
		addTriangleWith: 0.170589 , -0.143944 , -0.455255
			with: 0.00696505 , -0.295767 , -0.411809
			with: -0.0468684 , -0.0916343 , -0.496322;
		addTriangleWith: 0.00696505 , -0.295767 , -0.411809
			with: -0.205749 , -0.320146 , -0.335198
			with: -0.259582 , -0.116013 , -0.419711;
		addTriangleWith: 0.00696505 , -0.295767 , -0.411809
			with: -0.259582 , -0.116013 , -0.419711
			with: -0.0468684 , -0.0916343 , -0.496322;
		addTriangleWith: 0.146106 , -0.404785 , -0.268749
			with: 0.0193852 , -0.49654 , -0.103723
			with: -0.198073 , -0.44423 , -0.14479;
		addTriangleWith: 0.146106 , -0.404785 , -0.268749
			with: -0.198073 , -0.44423 , -0.14479
			with: -0.205749 , -0.320146 , -0.335198;
		addTriangleWith: 0.146106 , -0.404785 , -0.268749
			with: -0.205749 , -0.320146 , -0.335198
			with: 0.00696505 , -0.295767 , -0.411809;
		addTriangleWith: -0.205749 , -0.320146 , -0.335198
			with: -0.386303 , -0.207768 , -0.254685
			with: -0.259582 , -0.116013 , -0.419711;
		addTriangleWith: -0.386303 , -0.207768 , -0.254685
			with: -0.378627 , -0.331852 , -0.0642775
			with: -0.47839 , -0.162512 , 0.0500992;
		addTriangleWith: -0.386303 , -0.207768 , -0.254685
			with: -0.47839 , -0.162512 , 0.0500992
			with: -0.486066 , -0.0384281 , -0.140308;
		addTriangleWith: -0.198073 , -0.44423 , -0.14479
			with: -0.378627 , -0.331852 , -0.0642775
			with: -0.386303 , -0.207768 , -0.254685;
		addTriangleWith: -0.198073 , -0.44423 , -0.14479
			with: -0.386303 , -0.207768 , -0.254685
			with: -0.205749 , -0.320146 , -0.335198;
		addTriangleWith: -0.198073 , -0.44423 , -0.14479
			with: -0.239486 , -0.440869 , 0.0787818
			with: -0.378627 , -0.331852 , -0.0642775;
		addTriangleWith: -0.0220284 , -0.493179 , 0.119849
			with: -0.0357987 , -0.391216 , 0.322641
			with: -0.253257 , -0.338906 , 0.281574;
		addTriangleWith: -0.0220284 , -0.493179 , 0.119849
			with: -0.253257 , -0.338906 , 0.281574
			with: -0.239486 , -0.440869 , 0.0787818;
		addTriangleWith: -0.239486 , -0.440869 , 0.0787818
			with: -0.253257 , -0.338906 , 0.281574
			with: -0.400907 , -0.166872 , 0.263847;
		addTriangleWith: -0.239486 , -0.440869 , 0.0787818
			with: -0.400907 , -0.166872 , 0.263847
			with: -0.47839 , -0.162512 , 0.0500992;
		addTriangleWith: -0.239486 , -0.440869 , 0.0787818
			with: -0.47839 , -0.162512 , 0.0500992
			with: -0.378627 , -0.331852 , -0.0642775;
		addTriangleWith: -0.0357987 , -0.391216 , 0.322641
			with: -0.135562 , -0.221876 , 0.437018
			with: -0.253257 , -0.338906 , 0.281574;
		addTriangleWith: -0.253257 , -0.338906 , 0.281574
			with: -0.135562 , -0.221876 , 0.437018
			with: -0.283213 , -0.0498419 , 0.419291;
		addTriangleWith: -0.253257 , -0.338906 , 0.281574
			with: -0.283213 , -0.0498419 , 0.419291
			with: -0.400907 , -0.166872 , 0.263847;
		addTriangleWith: -0.0468684 , -0.0916343 , -0.496322
			with: -0.259582 , -0.116013 , -0.419711
			with: -0.281028 , 0.110035 , -0.407327;
		addTriangleWith: -0.0468684 , -0.0916343 , -0.496322
			with: -0.281028 , 0.110035 , -0.407327
			with: -0.0683144 , 0.134413 , -0.483938;
		addTriangleWith: -0.0683144 , 0.134413 , -0.483938
			with: -0.281028 , 0.110035 , -0.407327
			with: -0.168078 , 0.303753 , -0.369561;
		addTriangleWith: -0.281028 , 0.110035 , -0.407327
			with: -0.421003 , 0.157985 , -0.234646
			with: -0.308053 , 0.351703 , -0.19688;
		addTriangleWith: -0.281028 , 0.110035 , -0.407327
			with: -0.308053 , 0.351703 , -0.19688
			with: -0.168078 , 0.303753 , -0.369561;
		addTriangleWith: -0.259582 , -0.116013 , -0.419711
			with: -0.386303 , -0.207768 , -0.254685
			with: -0.486066 , -0.0384281 , -0.140308;
		addTriangleWith: -0.259582 , -0.116013 , -0.419711
			with: -0.486066 , -0.0384281 , -0.140308
			with: -0.421003 , 0.157985 , -0.234646;
		addTriangleWith: -0.259582 , -0.116013 , -0.419711
			with: -0.421003 , 0.157985 , -0.234646
			with: -0.281028 , 0.110035 , -0.407327;
		addTriangleWith: -0.421003 , 0.157985 , -0.234646
			with: -0.434773 , 0.259948 , -0.0318537
			with: -0.308053 , 0.351703 , -0.19688;
		addTriangleWith: -0.308053 , 0.351703 , -0.19688
			with: -0.434773 , 0.259948 , -0.0318537
			with: -0.317079 , 0.376978 , 0.12359;
		addTriangleWith: -0.308053 , 0.351703 , -0.19688
			with: -0.317079 , 0.376978 , 0.12359
			with: -0.190359 , 0.468733 , -0.0414363;
		addTriangleWith: -0.486066 , -0.0384281 , -0.140308
			with: -0.499837 , 0.0635352 , 0.062484
			with: -0.434773 , 0.259948 , -0.0318537;
		addTriangleWith: -0.486066 , -0.0384281 , -0.140308
			with: -0.434773 , 0.259948 , -0.0318537
			with: -0.421003 , 0.157985 , -0.234646;
		addTriangleWith: -0.486066 , -0.0384281 , -0.140308
			with: -0.47839 , -0.162512 , 0.0500992
			with: -0.499837 , 0.0635352 , 0.062484;
		addTriangleWith: -0.47839 , -0.162512 , 0.0500992
			with: -0.400907 , -0.166872 , 0.263847
			with: -0.422354 , 0.0591755 , 0.276232;
		addTriangleWith: -0.47839 , -0.162512 , 0.0500992
			with: -0.422354 , 0.0591755 , 0.276232
			with: -0.499837 , 0.0635352 , 0.062484;
		addTriangleWith: -0.499837 , 0.0635352 , 0.062484
			with: -0.422354 , 0.0591755 , 0.276232
			with: -0.309403 , 0.252894 , 0.313998;
		addTriangleWith: -0.499837 , 0.0635352 , 0.062484
			with: -0.309403 , 0.252894 , 0.313998
			with: -0.317079 , 0.376978 , 0.12359;
		addTriangleWith: -0.499837 , 0.0635352 , 0.062484
			with: -0.317079 , 0.376978 , 0.12359
			with: -0.434773 , 0.259948 , -0.0318537;
		addTriangleWith: -0.400907 , -0.166872 , 0.263847
			with: -0.283213 , -0.0498419 , 0.419291
			with: -0.422354 , 0.0591755 , 0.276232;
		addTriangleWith: -0.422354 , 0.0591755 , 0.276232
			with: -0.283213 , -0.0498419 , 0.419291
			with: -0.170263 , 0.143876 , 0.457057;
		addTriangleWith: -0.422354 , 0.0591755 , 0.276232
			with: -0.170263 , 0.143876 , 0.457057
			with: -0.309403 , 0.252894 , 0.313998;
		addTriangleWith: -0.0683144 , 0.134413 , -0.483938
			with: 0.135889 , 0.221808 , -0.435216
			with: 0.28354 , 0.0497742 , -0.417489;
		addTriangleWith: -0.0683144 , 0.134413 , -0.483938
			with: 0.28354 , 0.0497742 , -0.417489
			with: 0.170589 , -0.143944 , -0.455255;
		addTriangleWith: -0.0683144 , 0.134413 , -0.483938
			with: 0.170589 , -0.143944 , -0.455255
			with: -0.0468684 , -0.0916343 , -0.496322;
		addTriangleWith: -0.283213 , -0.0498419 , 0.419291
			with: -0.135562 , -0.221876 , 0.437018
			with: 0.0686412 , -0.134481 , 0.485739;
		addTriangleWith: -0.283213 , -0.0498419 , 0.419291
			with: 0.0686412 , -0.134481 , 0.485739
			with: 0.0471951 , 0.0915666 , 0.498124;
		addTriangleWith: -0.283213 , -0.0498419 , 0.419291
			with: 0.0471951 , 0.0915666 , 0.498124
			with: -0.170263 , 0.143876 , 0.457057! !

!Polyhedron class methodsFor: 'factory-dodecahedron' stamp: 'emm 02/09/2012 23:40'!
paragyrateDiminishedRhombicosidodecahedron
	"self paragyrateDiminishedRhombicosidodecahedron"

	^(Triangle3DComposite new)
		addTriangleWith: 0.0857803 , 0.0703164 , -0.524439
			with: -0.121703 , -0.0236715 , -0.523333
			with: -0.209669 , 0.171435 , -0.445359;
		addTriangleWith: 0.0857803 , 0.0703164 , -0.524439
			with: -0.209669 , 0.171435 , -0.445359
			with: -0.00218517 , 0.265423 , -0.446465;
		addTriangleWith: -0.00218517 , 0.265423 , -0.446465
			with: -0.209669 , 0.171435 , -0.445359
			with: -0.166857 , 0.354457 , -0.316696;
		addTriangleWith: -0.209669 , 0.171435 , -0.445359
			with: -0.388148 , 0.120389 , -0.313361
			with: -0.345337 , 0.303412 , -0.184697;
		addTriangleWith: -0.209669 , 0.171435 , -0.445359
			with: -0.345337 , 0.303412 , -0.184697
			with: -0.166857 , 0.354457 , -0.316696;
		addTriangleWith: -0.121703 , -0.0236715 , -0.523333
			with: -0.245817 , -0.195299 , -0.439524
			with: -0.410489 , -0.106265 , -0.309755;
		addTriangleWith: -0.121703 , -0.0236715 , -0.523333
			with: -0.410489 , -0.106265 , -0.309755
			with: -0.388148 , 0.120389 , -0.313361;
		addTriangleWith: -0.121703 , -0.0236715 , -0.523333
			with: -0.388148 , 0.120389 , -0.313361
			with: -0.209669 , 0.171435 , -0.445359;
		addTriangleWith: -0.388148 , 0.120389 , -0.313361
			with: -0.469451 , 0.131784 , -0.100889
			with: -0.345337 , 0.303412 , -0.184697;
		addTriangleWith: -0.345337 , 0.303412 , -0.184697
			with: -0.469451 , 0.131784 , -0.100889
			with: -0.422523 , 0.201266 , 0.110899;
		addTriangleWith: -0.345337 , 0.303412 , -0.184697
			with: -0.422523 , 0.201266 , 0.110899
			with: -0.298408 , 0.372894 , 0.0270908;
		addTriangleWith: -0.410489 , -0.106265 , -0.309755
			with: -0.491792 , -0.0948704 , -0.097283
			with: -0.469451 , 0.131784 , -0.100889;
		addTriangleWith: -0.410489 , -0.106265 , -0.309755
			with: -0.469451 , 0.131784 , -0.100889
			with: -0.388148 , 0.120389 , -0.313361;
		addTriangleWith: -0.410489 , -0.106265 , -0.309755
			with: -0.403827 , -0.289977 , -0.175256
			with: -0.491792 , -0.0948704 , -0.097283;
		addTriangleWith: -0.403827 , -0.289977 , -0.175256
			with: -0.370706 , -0.360575 , 0.0387605
			with: -0.458671 , -0.165468 , 0.116734;
		addTriangleWith: -0.403827 , -0.289977 , -0.175256
			with: -0.458671 , -0.165468 , 0.116734
			with: -0.491792 , -0.0948704 , -0.097283;
		addTriangleWith: -0.491792 , -0.0948704 , -0.097283
			with: -0.458671 , -0.165468 , 0.116734
			with: -0.41586 , 0.017554 , 0.245397;
		addTriangleWith: -0.491792 , -0.0948704 , -0.097283
			with: -0.41586 , 0.017554 , 0.245397
			with: -0.422523 , 0.201266 , 0.110899;
		addTriangleWith: -0.491792 , -0.0948704 , -0.097283
			with: -0.422523 , 0.201266 , 0.110899
			with: -0.469451 , 0.131784 , -0.100889;
		addTriangleWith: -0.370706 , -0.360575 , 0.0387605
			with: -0.323777 , -0.291093 , 0.250548
			with: -0.458671 , -0.165468 , 0.116734;
		addTriangleWith: -0.458671 , -0.165468 , 0.116734
			with: -0.323777 , -0.291093 , 0.250548
			with: -0.280966 , -0.10807 , 0.379212;
		addTriangleWith: -0.458671 , -0.165468 , 0.116734
			with: -0.280966 , -0.10807 , 0.379212
			with: -0.41586 , 0.017554 , 0.245397;
		addTriangleWith: -0.00218517 , 0.265423 , -0.446465
			with: -0.166857 , 0.354457 , -0.316696
			with: -0.00962212 , 0.455487 , -0.186487;
		addTriangleWith: -0.00218517 , 0.265423 , -0.446465
			with: -0.00962212 , 0.455487 , -0.186487
			with: 0.15505 , 0.366453 , -0.316257;
		addTriangleWith: 0.15505 , 0.366453 , -0.316257
			with: -0.00962212 , 0.455487 , -0.186487
			with: 0.201979 , 0.435935 , -0.104469;
		addTriangleWith: -0.00962212 , 0.455487 , -0.186487
			with: -0.0909252 , 0.466882 , 0.0259846
			with: 0.120676 , 0.447329 , 0.108003;
		addTriangleWith: -0.00962212 , 0.455487 , -0.186487
			with: 0.120676 , 0.447329 , 0.108003
			with: 0.201979 , 0.435935 , -0.104469;
		addTriangleWith: -0.166857 , 0.354457 , -0.316696
			with: -0.345337 , 0.303412 , -0.184697
			with: -0.298408 , 0.372894 , 0.0270908;
		addTriangleWith: -0.166857 , 0.354457 , -0.316696
			with: -0.298408 , 0.372894 , 0.0270908
			with: -0.0909252 , 0.466882 , 0.0259846;
		addTriangleWith: -0.166857 , 0.354457 , -0.316696
			with: -0.0909252 , 0.466882 , 0.0259846
			with: -0.00962212 , 0.455487 , -0.186487;
		addTriangleWith: -0.298408 , 0.372894 , 0.0270908
			with: -0.173636 , 0.37571 , 0.217638
			with: -0.0909252 , 0.466882 , 0.0259846;
		addTriangleWith: -0.0909252 , 0.466882 , 0.0259846
			with: -0.173636 , 0.37571 , 0.217638
			with: 0.0379648 , 0.356158 , 0.299656;
		addTriangleWith: -0.0909252 , 0.466882 , 0.0259846
			with: 0.0379648 , 0.356158 , 0.299656
			with: 0.120676 , 0.447329 , 0.108003;
		addTriangleWith: -0.422523 , 0.201266 , 0.110899
			with: -0.29775 , 0.204082 , 0.301446
			with: -0.173636 , 0.37571 , 0.217638;
		addTriangleWith: -0.422523 , 0.201266 , 0.110899
			with: -0.173636 , 0.37571 , 0.217638
			with: -0.298408 , 0.372894 , 0.0270908;
		addTriangleWith: -0.422523 , 0.201266 , 0.110899
			with: -0.41586 , 0.017554 , 0.245397
			with: -0.29775 , 0.204082 , 0.301446;
		addTriangleWith: -0.41586 , 0.017554 , 0.245397
			with: -0.280966 , -0.10807 , 0.379212
			with: -0.162856 , 0.0784581 , 0.435261;
		addTriangleWith: -0.41586 , 0.017554 , 0.245397
			with: -0.162856 , 0.0784581 , 0.435261
			with: -0.29775 , 0.204082 , 0.301446;
		addTriangleWith: -0.29775 , 0.204082 , 0.301446
			with: -0.162856 , 0.0784581 , 0.435261
			with: 0.0446273 , 0.172446 , 0.434154;
		addTriangleWith: -0.29775 , 0.204082 , 0.301446
			with: 0.0446273 , 0.172446 , 0.434154
			with: 0.0379648 , 0.356158 , 0.299656;
		addTriangleWith: -0.29775 , 0.204082 , 0.301446
			with: 0.0379648 , 0.356158 , 0.299656
			with: -0.173636 , 0.37571 , 0.217638;
		addTriangleWith: -0.280966 , -0.10807 , 0.379212
			with: -0.0693651 , -0.127623 , 0.46123
			with: -0.162856 , 0.0784581 , 0.435261;
		addTriangleWith: -0.162856 , 0.0784581 , 0.435261
			with: -0.0693651 , -0.127623 , 0.46123
			with: 0.138118 , -0.0336348 , 0.460124;
		addTriangleWith: -0.162856 , 0.0784581 , 0.435261
			with: 0.138118 , -0.0336348 , 0.460124
			with: 0.0446273 , 0.172446 , 0.434154;
		addTriangleWith: 0.15505 , 0.366453 , -0.316257
			with: 0.201979 , 0.435935 , -0.104469
			with: 0.387121 , 0.303268 , -0.101969;
		addTriangleWith: 0.15505 , 0.366453 , -0.316257
			with: 0.387121 , 0.303268 , -0.101969
			with: 0.340192 , 0.233786 , -0.313757;
		addTriangleWith: 0.340192 , 0.233786 , -0.313757
			with: 0.387121 , 0.303268 , -0.101969
			with: 0.475086 , 0.108162 , -0.179942;
		addTriangleWith: 0.387121 , 0.303268 , -0.101969
			with: 0.420242 , 0.232671 , 0.112048
			with: 0.508208 , 0.0375642 , 0.0340745;
		addTriangleWith: 0.387121 , 0.303268 , -0.101969
			with: 0.508208 , 0.0375642 , 0.0340745
			with: 0.475086 , 0.108162 , -0.179942;
		addTriangleWith: 0.201979 , 0.435935 , -0.104469
			with: 0.120676 , 0.447329 , 0.108003
			with: 0.25557 , 0.321705 , 0.241818;
		addTriangleWith: 0.201979 , 0.435935 , -0.104469
			with: 0.25557 , 0.321705 , 0.241818
			with: 0.420242 , 0.232671 , 0.112048;
		addTriangleWith: 0.201979 , 0.435935 , -0.104469
			with: 0.420242 , 0.232671 , 0.112048
			with: 0.387121 , 0.303268 , -0.101969;
		addTriangleWith: 0.420242 , 0.232671 , 0.112048
			with: 0.426905 , 0.0489586 , 0.246546
			with: 0.508208 , 0.0375642 , 0.0340745;
		addTriangleWith: 0.508208 , 0.0375642 , 0.0340745
			with: 0.426905 , 0.0489586 , 0.246546
			with: 0.404564 , -0.177696 , 0.250152;
		addTriangleWith: 0.508208 , 0.0375642 , 0.0340745
			with: 0.404564 , -0.177696 , 0.250152
			with: 0.485867 , -0.18909 , 0.0376806;
		addTriangleWith: 0.25557 , 0.321705 , 0.241818
			with: 0.262232 , 0.137993 , 0.376316
			with: 0.426905 , 0.0489586 , 0.246546;
		addTriangleWith: 0.25557 , 0.321705 , 0.241818
			with: 0.426905 , 0.0489586 , 0.246546
			with: 0.420242 , 0.232671 , 0.112048;
		addTriangleWith: 0.120676 , 0.447329 , 0.108003
			with: 0.0379648 , 0.356158 , 0.299656
			with: 0.25557 , 0.321705 , 0.241818;
		addTriangleWith: 0.0379648 , 0.356158 , 0.299656
			with: 0.0446273 , 0.172446 , 0.434154
			with: 0.262232 , 0.137993 , 0.376316;
		addTriangleWith: 0.0379648 , 0.356158 , 0.299656
			with: 0.262232 , 0.137993 , 0.376316
			with: 0.25557 , 0.321705 , 0.241818;
		addTriangleWith: 0.262232 , 0.137993 , 0.376316
			with: 0.138118 , -0.0336348 , 0.460124
			with: 0.226084 , -0.228741 , 0.382151;
		addTriangleWith: 0.262232 , 0.137993 , 0.376316
			with: 0.226084 , -0.228741 , 0.382151
			with: 0.404564 , -0.177696 , 0.250152;
		addTriangleWith: 0.262232 , 0.137993 , 0.376316
			with: 0.404564 , -0.177696 , 0.250152
			with: 0.426905 , 0.0489586 , 0.246546;
		addTriangleWith: 0.0446273 , 0.172446 , 0.434154
			with: 0.138118 , -0.0336348 , 0.460124
			with: 0.262232 , 0.137993 , 0.376316;
		addTriangleWith: 0.138118 , -0.0336348 , 0.460124
			with: -0.0693651 , -0.127623 , 0.46123
			with: 0.0186004 , -0.322729 , 0.383257;
		addTriangleWith: 0.138118 , -0.0336348 , 0.460124
			with: 0.0186004 , -0.322729 , 0.383257
			with: 0.226084 , -0.228741 , 0.382151;
		addTriangleWith: 0.340192 , 0.233786 , -0.313757
			with: 0.475086 , 0.108162 , -0.179942
			with: 0.432275 , -0.0748602 , -0.308606;
		addTriangleWith: 0.340192 , 0.233786 , -0.313757
			with: 0.432275 , -0.0748602 , -0.308606
			with: 0.297381 , 0.050764 , -0.442421;
		addTriangleWith: 0.297381 , 0.050764 , -0.442421
			with: 0.432275 , -0.0748602 , -0.308606
			with: 0.438938 , -0.258572 , -0.174107;
		addTriangleWith: 0.297381 , 0.050764 , -0.442421
			with: 0.438938 , -0.258572 , -0.174107
			with: 0.314824 , -0.4302 , -0.0902992;
		addTriangleWith: 0.297381 , 0.050764 , -0.442421
			with: 0.314824 , -0.4302 , -0.0902992
			with: 0.10734 , -0.524188 , -0.0891931;
		addTriangleWith: 0.297381 , 0.050764 , -0.442421
			with: 0.10734 , -0.524188 , -0.0891931
			with: -0.104261 , -0.504635 , -0.171211;
		addTriangleWith: 0.297381 , 0.050764 , -0.442421
			with: -0.104261 , -0.504635 , -0.171211
			with: -0.239155 , -0.379011 , -0.305026;
		addTriangleWith: 0.297381 , 0.050764 , -0.442421
			with: -0.239155 , -0.379011 , -0.305026
			with: -0.245817 , -0.195299 , -0.439524;
		addTriangleWith: 0.297381 , 0.050764 , -0.442421
			with: -0.245817 , -0.195299 , -0.439524
			with: -0.121703 , -0.0236715 , -0.523333;
		addTriangleWith: 0.297381 , 0.050764 , -0.442421
			with: -0.121703 , -0.0236715 , -0.523333
			with: 0.0857803 , 0.0703164 , -0.524439;
		addTriangleWith: 0.475086 , 0.108162 , -0.179942
			with: 0.508208 , 0.0375642 , 0.0340745
			with: 0.485867 , -0.18909 , 0.0376806;
		addTriangleWith: 0.475086 , 0.108162 , -0.179942
			with: 0.485867 , -0.18909 , 0.0376806
			with: 0.438938 , -0.258572 , -0.174107;
		addTriangleWith: 0.475086 , 0.108162 , -0.179942
			with: 0.438938 , -0.258572 , -0.174107
			with: 0.432275 , -0.0748602 , -0.308606;
		addTriangleWith: 0.485867 , -0.18909 , 0.0376806
			with: 0.361752 , -0.360718 , 0.121489
			with: 0.314824 , -0.4302 , -0.0902992;
		addTriangleWith: 0.485867 , -0.18909 , 0.0376806
			with: 0.314824 , -0.4302 , -0.0902992
			with: 0.438938 , -0.258572 , -0.174107;
		addTriangleWith: 0.485867 , -0.18909 , 0.0376806
			with: 0.404564 , -0.177696 , 0.250152
			with: 0.361752 , -0.360718 , 0.121489;
		addTriangleWith: 0.404564 , -0.177696 , 0.250152
			with: 0.226084 , -0.228741 , 0.382151
			with: 0.183273 , -0.411763 , 0.253487;
		addTriangleWith: 0.404564 , -0.177696 , 0.250152
			with: 0.183273 , -0.411763 , 0.253487
			with: 0.361752 , -0.360718 , 0.121489;
		addTriangleWith: 0.361752 , -0.360718 , 0.121489
			with: 0.183273 , -0.411763 , 0.253487
			with: 0.0260374 , -0.512793 , 0.123279;
		addTriangleWith: 0.361752 , -0.360718 , 0.121489
			with: 0.0260374 , -0.512793 , 0.123279
			with: 0.10734 , -0.524188 , -0.0891931;
		addTriangleWith: 0.361752 , -0.360718 , 0.121489
			with: 0.10734 , -0.524188 , -0.0891931
			with: 0.314824 , -0.4302 , -0.0902992;
		addTriangleWith: 0.226084 , -0.228741 , 0.382151
			with: 0.0186004 , -0.322729 , 0.383257
			with: 0.183273 , -0.411763 , 0.253487;
		addTriangleWith: 0.183273 , -0.411763 , 0.253487
			with: 0.0186004 , -0.322729 , 0.383257
			with: -0.138635 , -0.423759 , 0.253048;
		addTriangleWith: 0.183273 , -0.411763 , 0.253487
			with: -0.138635 , -0.423759 , 0.253048
			with: 0.0260374 , -0.512793 , 0.123279;
		addTriangleWith: -0.245817 , -0.195299 , -0.439524
			with: -0.239155 , -0.379011 , -0.305026
			with: -0.403827 , -0.289977 , -0.175256;
		addTriangleWith: -0.245817 , -0.195299 , -0.439524
			with: -0.403827 , -0.289977 , -0.175256
			with: -0.410489 , -0.106265 , -0.309755;
		addTriangleWith: 0.10734 , -0.524188 , -0.0891931
			with: 0.0260374 , -0.512793 , 0.123279
			with: -0.185564 , -0.493241 , 0.0412603;
		addTriangleWith: 0.10734 , -0.524188 , -0.0891931
			with: -0.185564 , -0.493241 , 0.0412603
			with: -0.104261 , -0.504635 , -0.171211;
		addTriangleWith: -0.104261 , -0.504635 , -0.171211
			with: -0.185564 , -0.493241 , 0.0412603
			with: -0.370706 , -0.360575 , 0.0387605;
		addTriangleWith: -0.104261 , -0.504635 , -0.171211
			with: -0.370706 , -0.360575 , 0.0387605
			with: -0.403827 , -0.289977 , -0.175256;
		addTriangleWith: -0.104261 , -0.504635 , -0.171211
			with: -0.403827 , -0.289977 , -0.175256
			with: -0.239155 , -0.379011 , -0.305026;
		addTriangleWith: 0.0260374 , -0.512793 , 0.123279
			with: -0.138635 , -0.423759 , 0.253048
			with: -0.185564 , -0.493241 , 0.0412603;
		addTriangleWith: -0.185564 , -0.493241 , 0.0412603
			with: -0.138635 , -0.423759 , 0.253048
			with: -0.323777 , -0.291093 , 0.250548;
		addTriangleWith: -0.185564 , -0.493241 , 0.0412603
			with: -0.323777 , -0.291093 , 0.250548
			with: -0.370706 , -0.360575 , 0.0387605;
		addTriangleWith: 0.0857803 , 0.0703164 , -0.524439
			with: -0.00218517 , 0.265423 , -0.446465
			with: 0.15505 , 0.366453 , -0.316257;
		addTriangleWith: 0.0857803 , 0.0703164 , -0.524439
			with: 0.15505 , 0.366453 , -0.316257
			with: 0.340192 , 0.233786 , -0.313757;
		addTriangleWith: 0.0857803 , 0.0703164 , -0.524439
			with: 0.340192 , 0.233786 , -0.313757
			with: 0.297381 , 0.050764 , -0.442421;
		addTriangleWith: -0.138635 , -0.423759 , 0.253048
			with: 0.0186004 , -0.322729 , 0.383257
			with: -0.0693651 , -0.127623 , 0.46123;
		addTriangleWith: -0.138635 , -0.423759 , 0.253048
			with: -0.0693651 , -0.127623 , 0.46123
			with: -0.280966 , -0.10807 , 0.379212;
		addTriangleWith: -0.138635 , -0.423759 , 0.253048
			with: -0.280966 , -0.10807 , 0.379212
			with: -0.323777 , -0.291093 , 0.250548! !

!Polyhedron class methodsFor: 'factory-pentagonal' stamp: 'emm 02/09/2012 23:40'!
pentagonalAntiprism
	"self pentagonalAntiprism"

	^(Triangle3DComposite new)
		add: (Triangle3D 
					with: 0.474083 , -0.15006 , -0.25
					with: -0.00144539 , -0.495552 , -0.25
					with: -0.476974 , -0.15006 , -0.25);
		add: (Triangle3D 
					with: 0.474083 , -0.15006 , -0.25
					with: -0.476974 , -0.15006 , -0.25
					with: -0.295338 , 0.408957 , -0.25);
		add: (Triangle3D 
					with: 0.474083 , -0.15006 , -0.25
					with: -0.295338 , 0.408957 , -0.25
					with: 0.292447 , 0.408957 , -0.25);
		add: (Triangle3D 
					with: -0.295338 , -0.40006 , 0.25
					with: 0.292447 , -0.40006 , 0.25
					with: 0.474083 , 0.158957 , 0.25);
		add: (Triangle3D 
					with: -0.295338 , -0.40006 , 0.25
					with: 0.474083 , 0.158957 , 0.25
					with: -0.00144539 , 0.504448 , 0.25);
		add: (Triangle3D 
					with: -0.295338 , -0.40006 , 0.25
					with: -0.00144539 , 0.504448 , 0.25
					with: -0.476974 , 0.158957 , 0.25);
		add: (Triangle3D 
					with: -0.00144539 , 0.504448 , 0.25
					with: -0.295338 , 0.408957 , -0.25
					with: -0.476974 , 0.158957 , 0.25);
		add: (Triangle3D 
					with: -0.476974 , 0.158957 , 0.25
					with: -0.295338 , 0.408957 , -0.25
					with: -0.476974 , -0.15006 , -0.25);
		add: (Triangle3D 
					with: -0.476974 , 0.158957 , 0.25
					with: -0.476974 , -0.15006 , -0.25
					with: -0.295338 , -0.40006 , 0.25);
		add: (Triangle3D 
					with: -0.295338 , -0.40006 , 0.25
					with: -0.476974 , -0.15006 , -0.25
					with: -0.00144539 , -0.495552 , -0.25);
		add: (Triangle3D 
					with: -0.295338 , -0.40006 , 0.25
					with: -0.00144539 , -0.495552 , -0.25
					with: 0.292447 , -0.40006 , 0.25);
		add: (Triangle3D 
					with: 0.292447 , -0.40006 , 0.25
					with: -0.00144539 , -0.495552 , -0.25
					with: 0.474083 , -0.15006 , -0.25);
		add: (Triangle3D 
					with: 0.292447 , -0.40006 , 0.25
					with: 0.474083 , -0.15006 , -0.25
					with: 0.474083 , 0.158957 , 0.25);
		add: (Triangle3D 
					with: 0.474083 , 0.158957 , 0.25
					with: 0.474083 , -0.15006 , -0.25
					with: 0.292447 , 0.408957 , -0.25);
		add: (Triangle3D 
					with: 0.474083 , 0.158957 , 0.25
					with: 0.292447 , 0.408957 , -0.25
					with: -0.00144539 , 0.504448 , 0.25);
		add: (Triangle3D 
					with: -0.00144539 , 0.504448 , 0.25
					with: 0.292447 , 0.408957 , -0.25
					with: -0.295338 , 0.408957 , -0.25);
		yourself! !

!Polyhedron class methodsFor: 'factory-pentagonal' stamp: 'emm 02/09/2012 23:40'!
pentagonalCupola
	"self pentagonalCupola"

	^(Triangle3DComposite new)
		add: (Triangle3D 
					with: -0.298242 , 0.322607 , -0.205196
					with: -0.0483685 , 0.479798 , -0.0931306
					with: 0.23751 , 0.446006 , 0.0366231);
		add: (Triangle3D 
					with: -0.298242 , 0.322607 , -0.205196
					with: 0.23751 , 0.446006 , 0.0366231
					with: 0.450198 , 0.234138 , 0.134503);
		add: (Triangle3D 
					with: -0.298242 , 0.322607 , -0.205196
					with: 0.450198 , 0.234138 , 0.134503
					with: 0.508455 , -0.0748791 , 0.163123);
		add: (Triangle3D 
					with: -0.298242 , 0.322607 , -0.205196
					with: 0.508455 , -0.0748791 , 0.163123
					with: 0.390029 , -0.363011 , 0.111551);
		add: (Triangle3D 
					with: -0.298242 , 0.322607 , -0.205196
					with: 0.390029 , -0.363011 , 0.111551
					with: 0.140156 , -0.520202 , -0.00051502);
		add: (Triangle3D 
					with: -0.298242 , 0.322607 , -0.205196
					with: 0.140156 , -0.520202 , -0.00051502
					with: -0.145723 , -0.48641 , -0.130269);
		add: (Triangle3D 
					with: -0.298242 , 0.322607 , -0.205196
					with: -0.145723 , -0.48641 , -0.130269
					with: -0.358411 , -0.274542 , -0.228149);
		add: (Triangle3D 
					with: -0.298242 , 0.322607 , -0.205196
					with: -0.358411 , -0.274542 , -0.228149
					with: -0.416668 , 0.0344751 , -0.256769);
		add: (Triangle3D 
					with: -0.245573 , 0.0907506 , 0.00258487
					with: -0.187316 , -0.218266 , 0.0312046
					with: 0.0985624 , -0.252059 , 0.160958);
		add: (Triangle3D 
					with: -0.245573 , 0.0907506 , 0.00258487
					with: 0.0985624 , -0.252059 , 0.160958
					with: 0.216988 , 0.0360736 , 0.212531);
		add: (Triangle3D 
					with: -0.245573 , 0.0907506 , 0.00258487
					with: 0.216988 , 0.0360736 , 0.212531
					with: 0.00430041 , 0.247941 , 0.114651);
		add: (Triangle3D 
					with: -0.187316 , -0.218266 , 0.0312046
					with: -0.245573 , 0.0907506 , 0.00258487
					with: -0.416668 , 0.0344751 , -0.256769);
		add: (Triangle3D 
					with: -0.187316 , -0.218266 , 0.0312046
					with: -0.416668 , 0.0344751 , -0.256769
					with: -0.358411 , -0.274542 , -0.228149);
		add: (Triangle3D 
					with: -0.187316 , -0.218266 , 0.0312046
					with: -0.358411 , -0.274542 , -0.228149
					with: -0.145723 , -0.48641 , -0.130269);
		add: (Triangle3D 
					with: 0.0985624 , -0.252059 , 0.160958
					with: -0.187316 , -0.218266 , 0.0312046
					with: -0.145723 , -0.48641 , -0.130269);
		add: (Triangle3D 
					with: 0.0985624 , -0.252059 , 0.160958
					with: -0.145723 , -0.48641 , -0.130269
					with: 0.140156 , -0.520202 , -0.00051502);
		add: (Triangle3D 
					with: 0.0985624 , -0.252059 , 0.160958
					with: 0.140156 , -0.520202 , -0.00051502
					with: 0.390029 , -0.363011 , 0.111551);
		add: (Triangle3D 
					with: 0.216988 , 0.0360736 , 0.212531
					with: 0.0985624 , -0.252059 , 0.160958
					with: 0.390029 , -0.363011 , 0.111551);
		add: (Triangle3D 
					with: 0.216988 , 0.0360736 , 0.212531
					with: 0.390029 , -0.363011 , 0.111551
					with: 0.508455 , -0.0748791 , 0.163123);
		add: (Triangle3D 
					with: 0.216988 , 0.0360736 , 0.212531
					with: 0.508455 , -0.0748791 , 0.163123
					with: 0.450198 , 0.234138 , 0.134503);
		add: (Triangle3D 
					with: 0.00430041 , 0.247941 , 0.114651
					with: 0.216988 , 0.0360736 , 0.212531
					with: 0.450198 , 0.234138 , 0.134503);
		add: (Triangle3D 
					with: 0.00430041 , 0.247941 , 0.114651
					with: 0.450198 , 0.234138 , 0.134503
					with: 0.23751 , 0.446006 , 0.0366231);
		add: (Triangle3D 
					with: 0.00430041 , 0.247941 , 0.114651
					with: 0.23751 , 0.446006 , 0.0366231
					with: -0.0483685 , 0.479798 , -0.0931306);
		add: (Triangle3D 
					with: -0.245573 , 0.0907506 , 0.00258487
					with: 0.00430041 , 0.247941 , 0.114651
					with: -0.0483685 , 0.479798 , -0.0931306);
		add: (Triangle3D 
					with: -0.245573 , 0.0907506 , 0.00258487
					with: -0.0483685 , 0.479798 , -0.0931306
					with: -0.298242 , 0.322607 , -0.205196);
		add: (Triangle3D 
					with: -0.245573 , 0.0907506 , 0.00258487
					with: -0.298242 , 0.322607 , -0.205196
					with: -0.416668 , 0.0344751 , -0.256769);
		yourself! !

!Polyhedron class methodsFor: 'factory-pentagonal' stamp: 'emm 02/09/2012 23:40'!
pentagonalGyrobicupola
	"self pentagonalGyrobicupola"

	^(Triangle3DComposite new)
		add: (Triangle3D 
					with: -0.0683132 , -0.230422 , -0.196456
					with: -0.249228 , 0.0221438 , -0.183139
					with: -0.0658129 , 0.269578 , -0.140337);
		add: (Triangle3D 
					with: -0.0683132 , -0.230422 , -0.196456
					with: -0.0658129 , 0.269578 , -0.140337
					with: 0.228458 , 0.169935 , -0.127201);
		add: (Triangle3D 
					with: -0.0683132 , -0.230422 , -0.196456
					with: 0.228458 , 0.169935 , -0.127201
					with: 0.226913 , -0.139082 , -0.161885);
		add: (Triangle3D 
					with: -0.249228 , 0.0221438 , -0.183139
					with: -0.0683132 , -0.230422 , -0.196456
					with: -0.295728 , -0.400034 , -0.0691331);
		add: (Triangle3D 
					with: -0.249228 , 0.0221438 , -0.183139
					with: -0.295728 , -0.400034 , -0.0691331
					with: -0.476642 , -0.147469 , -0.0558155);
		add: (Triangle3D 
					with: -0.249228 , 0.0221438 , -0.183139
					with: -0.476642 , -0.147469 , -0.0558155
					with: -0.475097 , 0.161548 , -0.0211315);
		add: (Triangle3D 
					with: -0.0658129 , 0.269578 , -0.140337
					with: -0.249228 , 0.0221438 , -0.183139
					with: -0.475097 , 0.161548 , -0.0211315);
		add: (Triangle3D 
					with: -0.0658129 , 0.269578 , -0.140337
					with: -0.475097 , 0.161548 , -0.0211315
					with: -0.291682 , 0.408983 , 0.0216707);
		add: (Triangle3D 
					with: -0.0658129 , 0.269578 , -0.140337
					with: -0.291682 , 0.408983 , 0.0216707
					with: 0.0035445 , 0.500323 , 0.0562421);
		add: (Triangle3D 
					with: 0.228458 , 0.169935 , -0.127201
					with: -0.0658129 , 0.269578 , -0.140337
					with: 0.0035445 , 0.500323 , 0.0562421);
		add: (Triangle3D 
					with: 0.228458 , 0.169935 , -0.127201
					with: 0.0035445 , 0.500323 , 0.0562421
					with: 0.297816 , 0.40068 , 0.0693776);
		add: (Triangle3D 
					with: 0.228458 , 0.169935 , -0.127201
					with: 0.297816 , 0.40068 , 0.0693776
					with: 0.478731 , 0.148115 , 0.05606);
		add: (Triangle3D 
					with: 0.226913 , -0.139082 , -0.161885
					with: 0.228458 , 0.169935 , -0.127201
					with: 0.478731 , 0.148115 , 0.05606);
		add: (Triangle3D 
					with: 0.226913 , -0.139082 , -0.161885
					with: 0.478731 , 0.148115 , 0.05606
					with: 0.477185 , -0.160902 , 0.021376);
		add: (Triangle3D 
					with: 0.226913 , -0.139082 , -0.161885
					with: 0.477185 , -0.160902 , 0.021376
					with: 0.29377 , -0.408337 , -0.021426);
		add: (Triangle3D 
					with: -0.0683132 , -0.230422 , -0.196456
					with: 0.226913 , -0.139082 , -0.161885
					with: 0.29377 , -0.408337 , -0.021426);
		add: (Triangle3D 
					with: -0.0683132 , -0.230422 , -0.196456
					with: 0.29377 , -0.408337 , -0.021426
					with: -0.00145625 , -0.499677 , -0.0559974);
		add: (Triangle3D 
					with: -0.0683132 , -0.230422 , -0.196456
					with: -0.00145625 , -0.499677 , -0.0559974
					with: -0.295728 , -0.400034 , -0.0691331);
		add: (Triangle3D 
					with: -0.224825 , 0.139728 , 0.16213
					with: -0.22637 , -0.169289 , 0.127446
					with: 0.0679012 , -0.268932 , 0.140581);
		add: (Triangle3D 
					with: -0.224825 , 0.139728 , 0.16213
					with: 0.0679012 , -0.268932 , 0.140581
					with: 0.251316 , -0.0214977 , 0.183383);
		add: (Triangle3D 
					with: -0.224825 , 0.139728 , 0.16213
					with: 0.251316 , -0.0214977 , 0.183383
					with: 0.0704015 , 0.231068 , 0.196701);
		add: (Triangle3D 
					with: -0.22637 , -0.169289 , 0.127446
					with: -0.224825 , 0.139728 , 0.16213
					with: -0.475097 , 0.161548 , -0.0211315);
		add: (Triangle3D 
					with: -0.22637 , -0.169289 , 0.127446
					with: -0.475097 , 0.161548 , -0.0211315
					with: -0.476642 , -0.147469 , -0.0558155);
		add: (Triangle3D 
					with: -0.22637 , -0.169289 , 0.127446
					with: -0.476642 , -0.147469 , -0.0558155
					with: -0.295728 , -0.400034 , -0.0691331);
		add: (Triangle3D 
					with: 0.0679012 , -0.268932 , 0.140581
					with: -0.22637 , -0.169289 , 0.127446
					with: -0.295728 , -0.400034 , -0.0691331);
		add: (Triangle3D 
					with: 0.0679012 , -0.268932 , 0.140581
					with: -0.295728 , -0.400034 , -0.0691331
					with: -0.00145625 , -0.499677 , -0.0559974);
		add: (Triangle3D 
					with: 0.0679012 , -0.268932 , 0.140581
					with: -0.00145625 , -0.499677 , -0.0559974
					with: 0.29377 , -0.408337 , -0.021426);
		add: (Triangle3D 
					with: 0.251316 , -0.0214977 , 0.183383
					with: 0.0679012 , -0.268932 , 0.140581
					with: 0.29377 , -0.408337 , -0.021426);
		add: (Triangle3D 
					with: 0.251316 , -0.0214977 , 0.183383
					with: 0.29377 , -0.408337 , -0.021426
					with: 0.477185 , -0.160902 , 0.021376);
		add: (Triangle3D 
					with: 0.251316 , -0.0214977 , 0.183383
					with: 0.477185 , -0.160902 , 0.021376
					with: 0.478731 , 0.148115 , 0.05606);
		add: (Triangle3D 
					with: 0.0704015 , 0.231068 , 0.196701
					with: 0.251316 , -0.0214977 , 0.183383
					with: 0.478731 , 0.148115 , 0.05606);
		add: (Triangle3D 
					with: 0.0704015 , 0.231068 , 0.196701
					with: 0.478731 , 0.148115 , 0.05606
					with: 0.297816 , 0.40068 , 0.0693776);
		add: (Triangle3D 
					with: 0.0704015 , 0.231068 , 0.196701
					with: 0.297816 , 0.40068 , 0.0693776
					with: 0.0035445 , 0.500323 , 0.0562421);
		add: (Triangle3D 
					with: -0.224825 , 0.139728 , 0.16213
					with: 0.0704015 , 0.231068 , 0.196701
					with: 0.0035445 , 0.500323 , 0.0562421);
		add: (Triangle3D 
					with: -0.224825 , 0.139728 , 0.16213
					with: 0.0035445 , 0.500323 , 0.0562421
					with: -0.291682 , 0.408983 , 0.0216707);
		add: (Triangle3D 
					with: -0.224825 , 0.139728 , 0.16213
					with: -0.291682 , 0.408983 , 0.0216707
					with: -0.475097 , 0.161548 , -0.0211315);
		yourself! !

!Polyhedron class methodsFor: 'factory-pentagonal' stamp: 'emm 02/09/2012 23:40'!
pentagonalGyrocupolarotunda
	"self pentagonalGyrocupolarotunda"

	^(Triangle3DComposite new)
		add: (Triangle3D 
					with: -0.391052 , 0.0916759 , -0.00115011
					with: -0.264231 , 0.0420645 , -0.300564
					with: -0.10857 , -0.24769 , -0.298284);
		add: (Triangle3D 
					with: -0.391052 , 0.0916759 , -0.00115011
					with: -0.10857 , -0.24769 , -0.298284
					with: -0.139187 , -0.377157 , 0.00253856);
		add: (Triangle3D 
					with: -0.391052 , 0.0916759 , -0.00115011
					with: -0.139187 , -0.377157 , 0.00253856
					with: -0.31377 , -0.167417 , 0.186177);
		add: (Triangle3D 
					with: -0.264231 , 0.0420645 , -0.300564
					with: -0.391052 , 0.0916759 , -0.00115011
					with: -0.349236 , 0.415941 , -0.0371678);
		add: (Triangle3D 
					with: -0.264231 , 0.0420645 , -0.300564
					with: -0.349236 , 0.415941 , -0.0371678
					with: -0.222416 , 0.366329 , -0.336582);
		add: (Triangle3D 
					with: -0.264231 , 0.0420645 , -0.300564
					with: -0.222416 , 0.366329 , -0.336582
					with: -0.0478328 , 0.156589 , -0.520221);
		add: (Triangle3D 
					with: -0.10857 , -0.24769 , -0.298284
					with: -0.264231 , 0.0420645 , -0.300564
					with: -0.0478328 , 0.156589 , -0.520221);
		add: (Triangle3D 
					with: -0.10857 , -0.24769 , -0.298284
					with: -0.0478328 , 0.156589 , -0.520221
					with: 0.107828 , -0.133166 , -0.517941);
		add: (Triangle3D 
					with: -0.10857 , -0.24769 , -0.298284
					with: 0.107828 , -0.133166 , -0.517941
					with: 0.18511 , -0.392259 , -0.330613);
		add: (Triangle3D 
					with: -0.139187 , -0.377157 , 0.00253856
					with: -0.10857 , -0.24769 , -0.298284
					with: 0.18511 , -0.392259 , -0.330613);
		add: (Triangle3D 
					with: -0.139187 , -0.377157 , 0.00253856
					with: 0.18511 , -0.392259 , -0.330613
					with: 0.154493 , -0.521725 , -0.0297903);
		add: (Triangle3D 
					with: -0.139187 , -0.377157 , 0.00253856
					with: 0.154493 , -0.521725 , -0.0297903
					with: 0.0276727 , -0.472114 , 0.269623);
		add: (Triangle3D 
					with: -0.31377 , -0.167417 , 0.186177
					with: -0.139187 , -0.377157 , 0.00253856
					with: 0.0276727 , -0.472114 , 0.269623);
		add: (Triangle3D 
					with: -0.31377 , -0.167417 , 0.186177
					with: 0.0276727 , -0.472114 , 0.269623
					with: -0.14691 , -0.262374 , 0.453262);
		add: (Triangle3D 
					with: -0.31377 , -0.167417 , 0.186177
					with: -0.14691 , -0.262374 , 0.453262
					with: -0.302571 , 0.0273808 , 0.450983);
		add: (Triangle3D 
					with: -0.391052 , 0.0916759 , -0.00115011
					with: -0.31377 , -0.167417 , 0.186177
					with: -0.302571 , 0.0273808 , 0.450983);
		add: (Triangle3D 
					with: -0.391052 , 0.0916759 , -0.00115011
					with: -0.302571 , 0.0273808 , 0.450983
					with: -0.379853 , 0.286474 , 0.263655);
		add: (Triangle3D 
					with: -0.391052 , 0.0916759 , -0.00115011
					with: -0.379853 , 0.286474 , 0.263655
					with: -0.349236 , 0.415941 , -0.0371678);
		add: (Triangle3D 
					with: 0.305706 , -0.0203281 , 0.312529
					with: 0.432527 , -0.0699397 , 0.0131154
					with: 0.355245 , 0.189153 , -0.174212);
		add: (Triangle3D 
					with: 0.305706 , -0.0203281 , 0.312529
					with: 0.355245 , 0.189153 , -0.174212
					with: 0.180662 , 0.398893 , 0.00942656);
		add: (Triangle3D 
					with: 0.305706 , -0.0203281 , 0.312529
					with: 0.180662 , 0.398893 , 0.00942656
					with: 0.150045 , 0.269427 , 0.310249);
		add: (Triangle3D 
					with: 0.305706 , -0.0203281 , 0.312529
					with: 0.0249237 , 0.0168449 , 0.479779
					with: -0.14691 , -0.262374 , 0.453262);
		add: (Triangle3D 
					with: 0.305706 , -0.0203281 , 0.312529
					with: -0.14691 , -0.262374 , 0.453262
					with: 0.0276727 , -0.472114 , 0.269623);
		add: (Triangle3D 
					with: 0.305706 , -0.0203281 , 0.312529
					with: 0.0276727 , -0.472114 , 0.269623
					with: 0.307405 , -0.322521 , 0.182646);
		add: (Triangle3D 
					with: 0.305706 , -0.0203281 , 0.312529
					with: 0.307405 , -0.322521 , 0.182646
					with: 0.432527 , -0.0699397 , 0.0131154);
		add: (Triangle3D 
					with: 0.307405 , -0.322521 , 0.182646
					with: 0.0276727 , -0.472114 , 0.269623
					with: 0.154493 , -0.521725 , -0.0297903);
		add: (Triangle3D 
					with: 0.432527 , -0.0699397 , 0.0131154
					with: 0.307405 , -0.322521 , 0.182646
					with: 0.154493 , -0.521725 , -0.0297903);
		add: (Triangle3D 
					with: 0.432527 , -0.0699397 , 0.0131154
					with: 0.154493 , -0.521725 , -0.0297903
					with: 0.18511 , -0.392259 , -0.330613);
		add: (Triangle3D 
					with: 0.432527 , -0.0699397 , 0.0131154
					with: 0.18511 , -0.392259 , -0.330613
					with: 0.356944 , -0.11304 , -0.304096);
		add: (Triangle3D 
					with: 0.432527 , -0.0699397 , 0.0131154
					with: 0.356944 , -0.11304 , -0.304096
					with: 0.355245 , 0.189153 , -0.174212);
		add: (Triangle3D 
					with: 0.356944 , -0.11304 , -0.304096
					with: 0.18511 , -0.392259 , -0.330613
					with: 0.107828 , -0.133166 , -0.517941);
		add: (Triangle3D 
					with: 0.355245 , 0.189153 , -0.174212
					with: 0.356944 , -0.11304 , -0.304096
					with: 0.107828 , -0.133166 , -0.517941);
		add: (Triangle3D 
					with: 0.355245 , 0.189153 , -0.174212
					with: 0.107828 , -0.133166 , -0.517941
					with: -0.0478328 , 0.156589 , -0.520221);
		add: (Triangle3D 
					with: 0.355245 , 0.189153 , -0.174212
					with: -0.0478328 , 0.156589 , -0.520221
					with: 0.105079 , 0.355793 , -0.307785);
		add: (Triangle3D 
					with: 0.355245 , 0.189153 , -0.174212
					with: 0.105079 , 0.355793 , -0.307785
					with: 0.180662 , 0.398893 , 0.00942656);
		add: (Triangle3D 
					with: 0.105079 , 0.355793 , -0.307785
					with: -0.0478328 , 0.156589 , -0.520221
					with: -0.222416 , 0.366329 , -0.336582);
		add: (Triangle3D 
					with: 0.180662 , 0.398893 , 0.00942656
					with: 0.105079 , 0.355793 , -0.307785
					with: -0.222416 , 0.366329 , -0.336582);
		add: (Triangle3D 
					with: 0.180662 , 0.398893 , 0.00942656
					with: -0.222416 , 0.366329 , -0.336582
					with: -0.349236 , 0.415941 , -0.0371678);
		add: (Triangle3D 
					with: 0.180662 , 0.398893 , 0.00942656
					with: -0.349236 , 0.415941 , -0.0371678
					with: -0.100121 , 0.436066 , 0.176677);
		add: (Triangle3D 
					with: 0.180662 , 0.398893 , 0.00942656
					with: -0.100121 , 0.436066 , 0.176677
					with: 0.150045 , 0.269427 , 0.310249);
		add: (Triangle3D 
					with: -0.100121 , 0.436066 , 0.176677
					with: -0.349236 , 0.415941 , -0.0371678
					with: -0.379853 , 0.286474 , 0.263655);
		add: (Triangle3D 
					with: 0.150045 , 0.269427 , 0.310249
					with: -0.100121 , 0.436066 , 0.176677
					with: -0.379853 , 0.286474 , 0.263655);
		add: (Triangle3D 
					with: 0.150045 , 0.269427 , 0.310249
					with: -0.379853 , 0.286474 , 0.263655
					with: -0.302571 , 0.0273808 , 0.450983);
		add: (Triangle3D 
					with: 0.150045 , 0.269427 , 0.310249
					with: -0.302571 , 0.0273808 , 0.450983
					with: 0.0249237 , 0.0168449 , 0.479779);
		add: (Triangle3D 
					with: 0.150045 , 0.269427 , 0.310249
					with: 0.0249237 , 0.0168449 , 0.479779
					with: 0.305706 , -0.0203281 , 0.312529);
		add: (Triangle3D 
					with: 0.0249237 , 0.0168449 , 0.479779
					with: -0.302571 , 0.0273808 , 0.450983
					with: -0.14691 , -0.262374 , 0.453262);
		yourself! !

!Polyhedron class methodsFor: 'factory-pentagonal' stamp: 'emm 9/22/2012 19:44'!
pentagonalHexecontahedron

	"self pentagonalHexecontahedron"

"
	^(Triangle3DComposite new)

		add: (Triangle3D 

					with: 0.173775 , -0.337776 , 0.343134

					with: 0.356443 , -0.238908 , 0.232806

					with: 0.391762 , -0.114097 , 0.268015);

		add: (Triangle3D 

					with: 0.173775 , -0.337776 , 0.343134

					with: 0.391762 , -0.114097 , 0.268015

					with: 0.320682 , -0.0528823 , 0.364271);

		add: (Triangle3D 

					with: 0.173775 , -0.337776 , 0.343134

					with: 0.320682 , -0.0528823 , 0.364271

					with: 0.218325 , -0.119958 , 0.419847);

		add: (Triangle3D 

					with: 0.173775 , -0.337776 , 0.343134

					with: 0.218325 , -0.119958 , 0.419847

					with: 0.116604 , -0.0489171 , 0.471527);

		add: (Triangle3D 

					with: 0.173775 , -0.337776 , 0.343134

					with: 0.116604 , -0.0489171 , 0.471527

					with: -0.00479335 , -0.106392 , 0.47643);

		add: (Triangle3D 

					with: 0.173775 , -0.337776 , 0.343134

					with: -0.00479335 , -0.106392 , 0.47643

					with: -0.0175686 , -0.231641 , 0.429373);

		add: (Triangle3D 

					with: 0.173775 , -0.337776 , 0.343134

					with: -0.0175686 , -0.231641 , 0.429373

					with: -0.137695 , -0.2699 , 0.382781);

		add: (Triangle3D 

					with: 0.173775 , -0.337776 , 0.343134

					with: -0.137695 , -0.2699 , 0.382781

					with: -0.141644 , -0.366637 , 0.289555);

		add: (Triangle3D 

					with: 0.173775 , -0.337776 , 0.343134

					with: -0.141644 , -0.366637 , 0.289555

					with: -0.0252415 , -0.419616 , 0.248219);

		add: (Triangle3D 

					with: 0.173775 , -0.337776 , 0.343134

					with: -0.0252415 , -0.419616 , 0.248219

					with: -0.019703 , -0.471655 , 0.124421);

		add: (Triangle3D 

					with: 0.173775 , -0.337776 , 0.343134

					with: -0.019703 , -0.471655 , 0.124421

					with: 0.0992541 , -0.473967 , 0.0619016);

		add: (Triangle3D 

					with: 0.173775 , -0.337776 , 0.343134

					with: 0.0992541 , -0.473967 , 0.0619016

					with: 0.20591 , -0.424107 , 0.126735);

		add: (Triangle3D 

					with: 0.173775 , -0.337776 , 0.343134

					with: 0.20591 , -0.424107 , 0.126735

					with: 0.307519 , -0.375364 , 0.0534916);

		add: (Triangle3D 

					with: 0.173775 , -0.337776 , 0.343134

					with: 0.307519 , -0.375364 , 0.0534916

					with: 0.384987 , -0.280056 , 0.108079);

		add: (Triangle3D 

					with: 0.173775 , -0.337776 , 0.343134

					with: 0.384987 , -0.280056 , 0.108079

					with: 0.356443 , -0.238908 , 0.232806);

		add: (Triangle3D 

					with: 0.127836 , 0.1857 , 0.45957

					with: 0.3155 , 0.0814212 , 0.363535

					with: 0.381691 , 0.146874 , 0.266585);

		add: (Triangle3D 

					with: 0.127836 , 0.1857 , 0.45957

					with: 0.381691 , 0.146874 , 0.266585

					with: 0.336874 , 0.2682 , 0.230027);

		add: (Triangle3D 

					with: 0.127836 , 0.1857 , 0.45957

					with: 0.336874 , 0.2682 , 0.230027

					with: 0.228413 , 0.317174 , 0.292498);

		add: (Triangle3D 

					with: 0.127836 , 0.1857 , 0.45957

					with: 0.228413 , 0.317174 , 0.292498

					with: 0.151461 , 0.405222 , 0.226236);

		add: (Triangle3D 

					with: 0.127836 , 0.1857 , 0.45957

					with: 0.151461 , 0.405222 , 0.226236

					with: 0.0214048 , 0.413129 , 0.259218);

		add: (Triangle3D 

					with: 0.127836 , 0.1857 , 0.45957

					with: 0.0214048 , 0.413129 , 0.259218

					with: -0.0243044 , 0.332539 , 0.356587);

		add: (Triangle3D 

					with: 0.127836 , 0.1857 , 0.45957

					with: -0.0243044 , 0.332539 , 0.356587

					with: -0.154195 , 0.298056 , 0.354561);

		add: (Triangle3D 

					with: 0.127836 , 0.1857 , 0.45957

					with: -0.154195 , 0.298056 , 0.354561

					with: -0.189757 , 0.181618 , 0.411503);

		add: (Triangle3D 

					with: 0.127836 , 0.1857 , 0.45957

					with: -0.189757 , 0.181618 , 0.411503

					with: -0.0934064 , 0.106283 , 0.467233);

		add: (Triangle3D 

					with: 0.127836 , 0.1857 , 0.45957

					with: -0.0934064 , 0.106283 , 0.467233

					with: -0.112871 , -0.0265225 , 0.47422);

		add: (Triangle3D 

					with: 0.127836 , 0.1857 , 0.45957

					with: -0.112871 , -0.0265225 , 0.47422

					with: -0.00479335 , -0.106392 , 0.47643);

		add: (Triangle3D 

					with: 0.127836 , 0.1857 , 0.45957

					with: -0.00479335 , -0.106392 , 0.47643

					with: 0.116604 , -0.0489171 , 0.471527);

		add: (Triangle3D 

					with: 0.127836 , 0.1857 , 0.45957

					with: 0.116604 , -0.0489171 , 0.471527

					with: 0.218325 , -0.119958 , 0.419847);

		add: (Triangle3D 

					with: 0.127836 , 0.1857 , 0.45957

					with: 0.218325 , -0.119958 , 0.419847

					with: 0.320682 , -0.0528823 , 0.364271);

		add: (Triangle3D 

					with: 0.127836 , 0.1857 , 0.45957

					with: 0.320682 , -0.0528823 , 0.364271

					with: 0.3155 , 0.0814212 , 0.363535);

		add: (Triangle3D 

					with: -0.313594 , -0.113874 , 0.38823

					with: -0.112871 , -0.0265225 , 0.47422

					with: -0.0934064 , 0.106283 , 0.467233);

		add: (Triangle3D 

					with: -0.313594 , -0.113874 , 0.38823

					with: -0.0934064 , 0.106283 , 0.467233

					with: -0.189757 , 0.181618 , 0.411503);

		add: (Triangle3D 

					with: -0.313594 , -0.113874 , 0.38823

					with: -0.189757 , 0.181618 , 0.411503

					with: -0.300095 , 0.119866 , 0.365927);

		add: (Triangle3D 

					with: -0.313594 , -0.113874 , 0.38823

					with: -0.300095 , 0.119866 , 0.365927

					with: -0.368598 , 0.178063 , 0.266001);

		add: (Triangle3D 

					with: -0.313594 , -0.113874 , 0.38823

					with: -0.368598 , 0.178063 , 0.266001

					with: -0.440921 , 0.0993744 , 0.184501);

		add: (Triangle3D 

					with: -0.313594 , -0.113874 , 0.38823

					with: -0.440921 , 0.0993744 , 0.184501

					with: -0.44063 , -0.0330378 , 0.20756);

		add: (Triangle3D 

					with: -0.313594 , -0.113874 , 0.38823

					with: -0.44063 , -0.0330378 , 0.20756

					with: -0.462838 , -0.115498 , 0.103772);

		add: (Triangle3D 

					with: -0.313594 , -0.113874 , 0.38823

					with: -0.462838 , -0.115498 , 0.103772

					with: -0.411185 , -0.239466 , 0.109133);

		add: (Triangle3D 

					with: -0.313594 , -0.113874 , 0.38823

					with: -0.411185 , -0.239466 , 0.109133

					with: -0.340261 , -0.273927 , 0.217977);

		add: (Triangle3D 

					with: -0.313594 , -0.113874 , 0.38823

					with: -0.340261 , -0.273927 , 0.217977

					with: -0.24589 , -0.368709 , 0.204742);

		add: (Triangle3D 

					with: -0.313594 , -0.113874 , 0.38823

					with: -0.24589 , -0.368709 , 0.204742

					with: -0.141644 , -0.366637 , 0.289555);

		add: (Triangle3D 

					with: -0.313594 , -0.113874 , 0.38823

					with: -0.141644 , -0.366637 , 0.289555

					with: -0.137695 , -0.2699 , 0.382781);

		add: (Triangle3D 

					with: -0.313594 , -0.113874 , 0.38823

					with: -0.137695 , -0.2699 , 0.382781

					with: -0.0175686 , -0.231641 , 0.429373);

		add: (Triangle3D 

					with: -0.313594 , -0.113874 , 0.38823

					with: -0.0175686 , -0.231641 , 0.429373

					with: -0.00479335 , -0.106392 , 0.47643);

		add: (Triangle3D 

					with: -0.313594 , -0.113874 , 0.38823

					with: -0.00479335 , -0.106392 , 0.47643

					with: -0.112871 , -0.0265225 , 0.47422);

		add: (Triangle3D 

					with: -0.214249 , -0.464834 , -0.00756216

					with: -0.24589 , -0.368709 , 0.204742

					with: -0.340261 , -0.273927 , 0.217977);

		add: (Triangle3D 

					with: -0.214249 , -0.464834 , -0.00756216

					with: -0.340261 , -0.273927 , 0.217977

					with: -0.411185 , -0.239466 , 0.109133);

		add: (Triangle3D 

					with: -0.214249 , -0.464834 , -0.00756216

					with: -0.411185 , -0.239466 , 0.109133

					with: -0.383707 , -0.301747 , -0.00675861);

		add: (Triangle3D 

					with: -0.214249 , -0.464834 , -0.00756216

					with: -0.383707 , -0.301747 , -0.00675861

					with: -0.409442 , -0.236519 , -0.121422);

		add: (Triangle3D 

					with: -0.214249 , -0.464834 , -0.00756216

					with: -0.409442 , -0.236519 , -0.121422

					with: -0.336874 , -0.2682 , -0.230027);

		add: (Triangle3D 

					with: -0.214249 , -0.464834 , -0.00756216

					with: -0.336874 , -0.2682 , -0.230027

					with: -0.242695 , -0.363308 , -0.217794);

		add: (Triangle3D 

					with: -0.214249 , -0.464834 , -0.00756216

					with: -0.242695 , -0.363308 , -0.217794

					with: -0.137179 , -0.359088 , -0.30094);

		add: (Triangle3D 

					with: -0.214249 , -0.464834 , -0.00756216

					with: -0.137179 , -0.359088 , -0.30094

					with: -0.0214048 , -0.413129 , -0.259218);

		add: (Triangle3D 

					with: -0.214249 , -0.464834 , -0.00756216

					with: -0.0214048 , -0.413129 , -0.259218

					with: -0.0177285 , -0.468317 , -0.13672);

		add: (Triangle3D 

					with: -0.214249 , -0.464834 , -0.00756216

					with: -0.0177285 , -0.468317 , -0.13672

					with: 0.10027 , -0.472249 , -0.0724891);

		add: (Triangle3D 

					with: -0.214249 , -0.464834 , -0.00756216

					with: 0.10027 , -0.472249 , -0.0724891

					with: 0.0992541 , -0.473967 , 0.0619016);

		add: (Triangle3D 

					with: -0.214249 , -0.464834 , -0.00756216

					with: 0.0992541 , -0.473967 , 0.0619016

					with: -0.019703 , -0.471655 , 0.124421);

		add: (Triangle3D 

					with: -0.214249 , -0.464834 , -0.00756216

					with: -0.019703 , -0.471655 , 0.124421

					with: -0.0252415 , -0.419616 , 0.248219);

		add: (Triangle3D 

					with: -0.214249 , -0.464834 , -0.00756216

					with: -0.0252415 , -0.419616 , 0.248219

					with: -0.141644 , -0.366637 , 0.289555);

		add: (Triangle3D 

					with: -0.214249 , -0.464834 , -0.00756216

					with: -0.141644 , -0.366637 , 0.289555

					with: -0.24589 , -0.368709 , 0.204742);

		add: (Triangle3D 

					with: 0.28858 , -0.382166 , -0.180836

					with: 0.10027 , -0.472249 , -0.0724891

					with: -0.0177285 , -0.468317 , -0.13672);

		add: (Triangle3D 

					with: 0.28858 , -0.382166 , -0.180836

					with: -0.0177285 , -0.468317 , -0.13672

					with: -0.0214048 , -0.413129 , -0.259218);

		add: (Triangle3D 

					with: 0.28858 , -0.382166 , -0.180836

					with: -0.0214048 , -0.413129 , -0.259218

					with: 0.0931266 , -0.36501 , -0.31052);

		add: (Triangle3D 

					with: 0.28858 , -0.382166 , -0.180836

					with: 0.0931266 , -0.36501 , -0.31052

					with: 0.0853731 , -0.265586 , -0.400628);

		add: (Triangle3D 

					with: 0.28858 , -0.382166 , -0.180836

					with: 0.0853731 , -0.265586 , -0.400628

					with: 0.189757 , -0.181618 , -0.411503);

		add: (Triangle3D 

					with: 0.28858 , -0.382166 , -0.180836

					with: 0.189757 , -0.181618 , -0.411503

					with: 0.295961 , -0.201848 , -0.33165);

		add: (Triangle3D 

					with: 0.28858 , -0.382166 , -0.180836

					with: 0.295961 , -0.201848 , -0.33165

					with: 0.372732 , -0.0960813 , -0.300278);

		add: (Triangle3D 

					with: 0.28858 , -0.382166 , -0.180836

					with: 0.372732 , -0.0960813 , -0.300278

					with: 0.440921 , -0.0993744 , -0.184501);

		add: (Triangle3D 

					with: 0.28858 , -0.382166 , -0.180836

					with: 0.440921 , -0.0993744 , -0.184501

					with: 0.428462 , -0.208247 , -0.106679);

		add: (Triangle3D 

					with: 0.28858 , -0.382166 , -0.180836

					with: 0.428462 , -0.208247 , -0.106679

					with: 0.447228 , -0.194053 , 0.0256508);

		add: (Triangle3D 

					with: 0.28858 , -0.382166 , -0.180836

					with: 0.447228 , -0.194053 , 0.0256508

					with: 0.384987 , -0.280056 , 0.108079);

		add: (Triangle3D 

					with: 0.28858 , -0.382166 , -0.180836

					with: 0.384987 , -0.280056 , 0.108079

					with: 0.307519 , -0.375364 , 0.0534916);

		add: (Triangle3D 

					with: 0.28858 , -0.382166 , -0.180836

					with: 0.307519 , -0.375364 , 0.0534916

					with: 0.20591 , -0.424107 , 0.126735);

		add: (Triangle3D 

					with: 0.28858 , -0.382166 , -0.180836

					with: 0.20591 , -0.424107 , 0.126735

					with: 0.0992541 , -0.473967 , 0.0619016);

		add: (Triangle3D 

					with: 0.28858 , -0.382166 , -0.180836

					with: 0.0992541 , -0.473967 , 0.0619016

					with: 0.10027 , -0.472249 , -0.0724891);

		add: (Triangle3D 

					with: 0.5 , 0.0198858 , 0.107868

					with: 0.447228 , -0.194053 , 0.0256508

					with: 0.428462 , -0.208247 , -0.106679);

		add: (Triangle3D 

					with: 0.5 , 0.0198858 , 0.107868

					with: 0.428462 , -0.208247 , -0.106679

					with: 0.440921 , -0.0993744 , -0.184501);

		add: (Triangle3D 

					with: 0.5 , 0.0198858 , 0.107868

					with: 0.440921 , -0.0993744 , -0.184501

					with: 0.471438 , 0.0175042 , -0.125569);

		add: (Triangle3D 

					with: 0.5 , 0.0198858 , 0.107868

					with: 0.471438 , 0.0175042 , -0.125569

					with: 0.43203 , 0.131031 , -0.185764);

		add: (Triangle3D 

					with: 0.5 , 0.0198858 , 0.107868

					with: 0.43203 , 0.131031 , -0.185764

					with: 0.411186 , 0.239466 , -0.109133);

		add: (Triangle3D 

					with: 0.5 , 0.0198858 , 0.107868

					with: 0.411186 , 0.239466 , -0.109133

					with: 0.430933 , 0.228209 , 0.0233364);

		add: (Triangle3D 

					with: 0.5 , 0.0198858 , 0.107868

					with: 0.430933 , 0.228209 , 0.0233364

					with: 0.362215 , 0.310057 , 0.104845);

		add: (Triangle3D 

					with: 0.5 , 0.0198858 , 0.107868

					with: 0.362215 , 0.310057 , 0.104845

					with: 0.336874 , 0.2682 , 0.230027);

		add: (Triangle3D 

					with: 0.5 , 0.0198858 , 0.107868

					with: 0.336874 , 0.2682 , 0.230027

					with: 0.381691 , 0.146874 , 0.266585);

		add: (Triangle3D 

					with: 0.5 , 0.0198858 , 0.107868

					with: 0.381691 , 0.146874 , 0.266585

					with: 0.3155 , 0.0814212 , 0.363535);

		add: (Triangle3D 

					with: 0.5 , 0.0198858 , 0.107868

					with: 0.3155 , 0.0814212 , 0.363535

					with: 0.320682 , -0.0528823 , 0.364271);

		add: (Triangle3D 

					with: 0.5 , 0.0198858 , 0.107868

					with: 0.320682 , -0.0528823 , 0.364271

					with: 0.391762 , -0.114097 , 0.268015);

		add: (Triangle3D 

					with: 0.5 , 0.0198858 , 0.107868

					with: 0.391762 , -0.114097 , 0.268015

					with: 0.356443 , -0.238908 , 0.232806);

		add: (Triangle3D 

					with: 0.5 , 0.0198858 , 0.107868

					with: 0.356443 , -0.238908 , 0.232806

					with: 0.384987 , -0.280056 , 0.108079);

		add: (Triangle3D 

					with: 0.5 , 0.0198858 , 0.107868

					with: 0.384987 , -0.280056 , 0.108079

					with: 0.447228 , -0.194053 , 0.0256508);

		add: (Triangle3D 

					with: -0.173775 , 0.337776 , -0.343134

					with: -0.0444268 , 0.450656 , -0.182382

					with: 0.0893714 , 0.440615 , -0.190259);

		add: (Triangle3D 

					with: -0.173775 , 0.337776 , -0.343134

					with: 0.0893714 , 0.440615 , -0.190259

					with: 0.141644 , 0.366637 , -0.289555);

		add: (Triangle3D 

					with: -0.173775 , 0.337776 , -0.343134

					with: 0.141644 , 0.366637 , -0.289555

					with: 0.057146 , 0.306905 , -0.375328);

		add: (Triangle3D 

					with: -0.173775 , 0.337776 , -0.343134

					with: 0.057146 , 0.306905 , -0.375328

					with: 0.0981174 , 0.194637 , -0.436826);

		add: (Triangle3D 

					with: -0.173775 , 0.337776 , -0.343134

					with: 0.0981174 , 0.194637 , -0.436826

					with: 0.00479336 , 0.106392 , -0.47643);

		add: (Triangle3D 

					with: -0.173775 , 0.337776 , -0.343134

					with: 0.00479336 , 0.106392 , -0.47643

					with: -0.124197 , 0.135433 , -0.452284);

		add: (Triangle3D 

					with: -0.173775 , 0.337776 , -0.343134

					with: -0.124197 , 0.135433 , -0.452284

					with: -0.210733 , 0.0334418 , -0.439091);

		add: (Triangle3D 

					with: -0.173775 , 0.337776 , -0.343134

					with: -0.210733 , 0.0334418 , -0.439091

					with: -0.320683 , 0.0528823 , -0.364271);

		add: (Triangle3D 

					with: -0.173775 , 0.337776 , -0.343134

					with: -0.320683 , 0.0528823 , -0.364271

					with: -0.337846 , 0.173209 , -0.306898);

		add: (Triangle3D 

					with: -0.173775 , 0.337776 , -0.343134

					with: -0.337846 , 0.173209 , -0.306898

					with: -0.410359 , 0.179797 , -0.193923);

		add: (Triangle3D 

					with: -0.173775 , 0.337776 , -0.343134

					with: -0.410359 , 0.179797 , -0.193923

					with: -0.384987 , 0.280056 , -0.108079);

		add: (Triangle3D 

					with: -0.173775 , 0.337776 , -0.343134

					with: -0.384987 , 0.280056 , -0.108079

					with: -0.288545 , 0.368027 , -0.140089);

		add: (Triangle3D 

					with: -0.173775 , 0.337776 , -0.343134

					with: -0.288545 , 0.368027 , -0.140089

					with: -0.224884 , 0.431444 , -0.0401369);

		add: (Triangle3D 

					with: -0.173775 , 0.337776 , -0.343134

					with: -0.224884 , 0.431444 , -0.0401369

					with: -0.0992541 , 0.473967 , -0.0619016);

		add: (Triangle3D 

					with: -0.173775 , 0.337776 , -0.343134

					with: -0.0992541 , 0.473967 , -0.0619016

					with: -0.0444268 , 0.450656 , -0.182382);

		add: (Triangle3D 

					with: 0.313594 , 0.113874 , -0.38823

					with: 0.262309 , 0.310705 , -0.270155

					with: 0.323842 , 0.331931 , -0.152563);

		add: (Triangle3D 

					with: 0.313594 , 0.113874 , -0.38823

					with: 0.323842 , 0.331931 , -0.152563

					with: 0.411186 , 0.239466 , -0.109133);

		add: (Triangle3D 

					with: 0.313594 , 0.113874 , -0.38823

					with: 0.411186 , 0.239466 , -0.109133

					with: 0.43203 , 0.131031 , -0.185764);

		add: (Triangle3D 

					with: 0.313594 , 0.113874 , -0.38823

					with: 0.43203 , 0.131031 , -0.185764

					with: 0.471438 , 0.0175042 , -0.125569);

		add: (Triangle3D 

					with: 0.313594 , 0.113874 , -0.38823

					with: 0.471438 , 0.0175042 , -0.125569

					with: 0.440921 , -0.0993744 , -0.184501);

		add: (Triangle3D 

					with: 0.313594 , 0.113874 , -0.38823

					with: 0.440921 , -0.0993744 , -0.184501

					with: 0.372732 , -0.0960813 , -0.300278);

		add: (Triangle3D 

					with: 0.313594 , 0.113874 , -0.38823

					with: 0.372732 , -0.0960813 , -0.300278

					with: 0.295961 , -0.201848 , -0.33165);

		add: (Triangle3D 

					with: 0.313594 , 0.113874 , -0.38823

					with: 0.295961 , -0.201848 , -0.33165

					with: 0.189757 , -0.181618 , -0.411503);

		add: (Triangle3D 

					with: 0.313594 , 0.113874 , -0.38823

					with: 0.189757 , -0.181618 , -0.411503

					with: 0.166363 , -0.0567711 , -0.455443);

		add: (Triangle3D 

					with: 0.313594 , 0.113874 , -0.38823

					with: 0.166363 , -0.0567711 , -0.455443

					with: 0.0399143 , -0.0229889 , -0.48601);

		add: (Triangle3D 

					with: 0.313594 , 0.113874 , -0.38823

					with: 0.0399143 , -0.0229889 , -0.48601

					with: 0.00479336 , 0.106392 , -0.47643);

		add: (Triangle3D 

					with: 0.313594 , 0.113874 , -0.38823

					with: 0.00479336 , 0.106392 , -0.47643

					with: 0.0981174 , 0.194637 , -0.436826);

		add: (Triangle3D 

					with: 0.313594 , 0.113874 , -0.38823

					with: 0.0981174 , 0.194637 , -0.436826

					with: 0.057146 , 0.306905 , -0.375328);

		add: (Triangle3D 

					with: 0.313594 , 0.113874 , -0.38823

					with: 0.057146 , 0.306905 , -0.375328

					with: 0.141644 , 0.366637 , -0.289555);

		add: (Triangle3D 

					with: 0.313594 , 0.113874 , -0.38823

					with: 0.141644 , 0.366637 , -0.289555

					with: 0.262309 , 0.310705 , -0.270155);

		add: (Triangle3D 

					with: -0.127836 , -0.1857 , -0.45957

					with: 0.0399143 , -0.0229889 , -0.48601

					with: 0.166363 , -0.0567711 , -0.455443);

		add: (Triangle3D 

					with: -0.127836 , -0.1857 , -0.45957

					with: 0.166363 , -0.0567711 , -0.455443

					with: 0.189757 , -0.181618 , -0.411503);

		add: (Triangle3D 

					with: -0.127836 , -0.1857 , -0.45957

					with: 0.189757 , -0.181618 , -0.411503

					with: 0.0853731 , -0.265586 , -0.400628);

		add: (Triangle3D 

					with: -0.127836 , -0.1857 , -0.45957

					with: 0.0853731 , -0.265586 , -0.400628

					with: 0.0931266 , -0.36501 , -0.31052);

		add: (Triangle3D 

					with: -0.127836 , -0.1857 , -0.45957

					with: 0.0931266 , -0.36501 , -0.31052

					with: -0.0214048 , -0.413129 , -0.259218);

		add: (Triangle3D 

					with: -0.127836 , -0.1857 , -0.45957

					with: -0.0214048 , -0.413129 , -0.259218

					with: -0.137179 , -0.359088 , -0.30094);

		add: (Triangle3D 

					with: -0.127836 , -0.1857 , -0.45957

					with: -0.137179 , -0.359088 , -0.30094

					with: -0.242695 , -0.363308 , -0.217794);

		add: (Triangle3D 

					with: -0.127836 , -0.1857 , -0.45957

					with: -0.242695 , -0.363308 , -0.217794

					with: -0.336874 , -0.2682 , -0.230027);

		add: (Triangle3D 

					with: -0.127836 , -0.1857 , -0.45957

					with: -0.336874 , -0.2682 , -0.230027

					with: -0.320182 , -0.174279 , -0.324711);

		add: (Triangle3D 

					with: -0.127836 , -0.1857 , -0.45957

					with: -0.320182 , -0.174279 , -0.324711

					with: -0.377008 , -0.0540166 , -0.305409);

		add: (Triangle3D 

					with: -0.127836 , -0.1857 , -0.45957

					with: -0.377008 , -0.0540166 , -0.305409

					with: -0.320683 , 0.0528823 , -0.364271);

		add: (Triangle3D 

					with: -0.127836 , -0.1857 , -0.45957

					with: -0.320683 , 0.0528823 , -0.364271

					with: -0.210733 , 0.0334418 , -0.439091);

		add: (Triangle3D 

					with: -0.127836 , -0.1857 , -0.45957

					with: -0.210733 , 0.0334418 , -0.439091

					with: -0.124197 , 0.135433 , -0.452284);

		add: (Triangle3D 

					with: -0.127836 , -0.1857 , -0.45957

					with: -0.124197 , 0.135433 , -0.452284

					with: 0.00479336 , 0.106392 , -0.47643);

		add: (Triangle3D 

					with: -0.127836 , -0.1857 , -0.45957

					with: 0.00479336 , 0.106392 , -0.47643

					with: 0.0399143 , -0.0229889 , -0.48601);

		add: (Triangle3D 

					with: -0.5 , -0.0198858 , -0.107868

					with: -0.377008 , -0.0540166 , -0.305409

					with: -0.320182 , -0.174279 , -0.324711);

		add: (Triangle3D 

					with: -0.5 , -0.0198858 , -0.107868

					with: -0.320182 , -0.174279 , -0.324711

					with: -0.336874 , -0.2682 , -0.230027);

		add: (Triangle3D 

					with: -0.5 , -0.0198858 , -0.107868

					with: -0.336874 , -0.2682 , -0.230027

					with: -0.409442 , -0.236519 , -0.121422);

		add: (Triangle3D 

					with: -0.5 , -0.0198858 , -0.107868

					with: -0.409442 , -0.236519 , -0.121422

					with: -0.383707 , -0.301747 , -0.00675861);

		add: (Triangle3D 

					with: -0.5 , -0.0198858 , -0.107868

					with: -0.383707 , -0.301747 , -0.00675861

					with: -0.411185 , -0.239466 , 0.109133);

		add: (Triangle3D 

					with: -0.5 , -0.0198858 , -0.107868

					with: -0.411185 , -0.239466 , 0.109133

					with: -0.462838 , -0.115498 , 0.103772);

		add: (Triangle3D 

					with: -0.5 , -0.0198858 , -0.107868

					with: -0.462838 , -0.115498 , 0.103772

					with: -0.44063 , -0.0330378 , 0.20756);

		add: (Triangle3D 

					with: -0.5 , -0.0198858 , -0.107868

					with: -0.44063 , -0.0330378 , 0.20756

					with: -0.440921 , 0.0993744 , 0.184501);

		add: (Triangle3D 

					with: -0.5 , -0.0198858 , -0.107868

					with: -0.440921 , 0.0993744 , 0.184501

					with: -0.463404 , 0.141799 , 0.0589642);

		add: (Triangle3D 

					with: -0.5 , -0.0198858 , -0.107868

					with: -0.463404 , 0.141799 , 0.0589642

					with: -0.412286 , 0.260501 , 0.022064);

		add: (Triangle3D 

					with: -0.5 , -0.0198858 , -0.107868

					with: -0.412286 , 0.260501 , 0.022064

					with: -0.384987 , 0.280056 , -0.108079);

		add: (Triangle3D 

					with: -0.5 , -0.0198858 , -0.107868

					with: -0.384987 , 0.280056 , -0.108079

					with: -0.410359 , 0.179797 , -0.193923);

		add: (Triangle3D 

					with: -0.5 , -0.0198858 , -0.107868

					with: -0.410359 , 0.179797 , -0.193923

					with: -0.337846 , 0.173209 , -0.306898);

		add: (Triangle3D 

					with: -0.5 , -0.0198858 , -0.107868

					with: -0.337846 , 0.173209 , -0.306898

					with: -0.320683 , 0.0528823 , -0.364271);

		add: (Triangle3D 

					with: -0.5 , -0.0198858 , -0.107868

					with: -0.320683 , 0.0528823 , -0.364271

					with: -0.377008 , -0.0540166 , -0.305409);

		add: (Triangle3D 

					with: -0.28858 , 0.382166 , 0.180836

					with: -0.412286 , 0.260501 , 0.022064

					with: -0.463404 , 0.141799 , 0.0589642);

		add: (Triangle3D 

					with: -0.28858 , 0.382166 , 0.180836

					with: -0.463404 , 0.141799 , 0.0589642

					with: -0.440921 , 0.0993744 , 0.184501);

		add: (Triangle3D 

					with: -0.28858 , 0.382166 , 0.180836

					with: -0.440921 , 0.0993744 , 0.184501

					with: -0.368598 , 0.178063 , 0.266001);

		add: (Triangle3D 

					with: -0.28858 , 0.382166 , 0.180836

					with: -0.368598 , 0.178063 , 0.266001

					with: -0.300095 , 0.119866 , 0.365927);

		add: (Triangle3D 

					with: -0.28858 , 0.382166 , 0.180836

					with: -0.300095 , 0.119866 , 0.365927

					with: -0.189757 , 0.181618 , 0.411503);

		add: (Triangle3D 

					with: -0.28858 , 0.382166 , 0.180836

					with: -0.189757 , 0.181618 , 0.411503

					with: -0.154195 , 0.298056 , 0.354561);

		add: (Triangle3D 

					with: -0.28858 , 0.382166 , 0.180836

					with: -0.154195 , 0.298056 , 0.354561

					with: -0.0243044 , 0.332539 , 0.356587);

		add: (Triangle3D 

					with: -0.28858 , 0.382166 , 0.180836

					with: -0.0243044 , 0.332539 , 0.356587

					with: 0.0214048 , 0.413129 , 0.259218);

		add: (Triangle3D 

					with: -0.28858 , 0.382166 , 0.180836

					with: 0.0214048 , 0.413129 , 0.259218

					with: -0.0653753 , 0.454654 , 0.165358);

		add: (Triangle3D 

					with: -0.28858 , 0.382166 , 0.180836

					with: -0.0653753 , 0.454654 , 0.165358

					with: -0.0171664 , 0.485911 , 0.0438516);

		add: (Triangle3D 

					with: -0.28858 , 0.382166 , 0.180836

					with: -0.0171664 , 0.485911 , 0.0438516

					with: -0.0992541 , 0.473967 , -0.0619016);

		add: (Triangle3D 

					with: -0.28858 , 0.382166 , 0.180836

					with: -0.0992541 , 0.473967 , -0.0619016

					with: -0.224884 , 0.431444 , -0.0401369);

		add: (Triangle3D 

					with: -0.28858 , 0.382166 , 0.180836

					with: -0.224884 , 0.431444 , -0.0401369

					with: -0.288545 , 0.368027 , -0.140089);

		add: (Triangle3D 

					with: -0.28858 , 0.382166 , 0.180836

					with: -0.288545 , 0.368027 , -0.140089

					with: -0.384987 , 0.280056 , -0.108079);

		add: (Triangle3D 

					with: -0.28858 , 0.382166 , 0.180836

					with: -0.384987 , 0.280056 , -0.108079

					with: -0.412286 , 0.260501 , 0.022064);

		add: (Triangle3D 

					with: 0.214249 , 0.464834 , 0.00756219

					with: -0.0171664 , 0.485911 , 0.0438516

					with: -0.0653753 , 0.454654 , 0.165358);

		add: (Triangle3D 

					with: 0.214249 , 0.464834 , 0.00756219

					with: -0.0653753 , 0.454654 , 0.165358

					with: 0.0214048 , 0.413129 , 0.259218);

		add: (Triangle3D 

					with: 0.214249 , 0.464834 , 0.00756219

					with: 0.0214048 , 0.413129 , 0.259218

					with: 0.151461 , 0.405222 , 0.226236);

		add: (Triangle3D 

					with: 0.214249 , 0.464834 , 0.00756219

					with: 0.151461 , 0.405222 , 0.226236

					with: 0.228413 , 0.317174 , 0.292498);

		add: (Triangle3D 

					with: 0.214249 , 0.464834 , 0.00756219

					with: 0.228413 , 0.317174 , 0.292498

					with: 0.336874 , 0.2682 , 0.230027);

		add: (Triangle3D 

					with: 0.214249 , 0.464834 , 0.00756219

					with: 0.336874 , 0.2682 , 0.230027

					with: 0.362215 , 0.310057 , 0.104845);

		add: (Triangle3D 

					with: 0.214249 , 0.464834 , 0.00756219

					with: 0.362215 , 0.310057 , 0.104845

					with: 0.430933 , 0.228209 , 0.0233364);

		add: (Triangle3D 

					with: 0.214249 , 0.464834 , 0.00756219

					with: 0.430933 , 0.228209 , 0.0233364

					with: 0.411186 , 0.239466 , -0.109133);

		add: (Triangle3D 

					with: 0.214249 , 0.464834 , 0.00756219

					with: 0.411186 , 0.239466 , -0.109133

					with: 0.323842 , 0.331931 , -0.152563);

		add: (Triangle3D 

					with: 0.214249 , 0.464834 , 0.00756219

					with: 0.323842 , 0.331931 , -0.152563

					with: 0.262309 , 0.310705 , -0.270155);

		add: (Triangle3D 

					with: 0.214249 , 0.464834 , 0.00756219

					with: 0.262309 , 0.310705 , -0.270155

					with: 0.141644 , 0.366637 , -0.289555);

		add: (Triangle3D 

					with: 0.214249 , 0.464834 , 0.00756219

					with: 0.141644 , 0.366637 , -0.289555

					with: 0.0893714 , 0.440615 , -0.190259);

		add: (Triangle3D 

					with: 0.214249 , 0.464834 , 0.00756219

					with: 0.0893714 , 0.440615 , -0.190259

					with: -0.0444268 , 0.450656 , -0.182382);

		add: (Triangle3D 

					with: 0.214249 , 0.464834 , 0.00756219

					with: -0.0444268 , 0.450656 , -0.182382

					with: -0.0992541 , 0.473967 , -0.0619016);

		add: (Triangle3D 

					with: 0.214249 , 0.464834 , 0.00756219

					with: -0.0992541 , 0.473967 , -0.0619016

					with: -0.0171664 , 0.485911 , 0.0438516);

		yourself"! !

!Polyhedron class methodsFor: 'factory-pentagonal' stamp: 'emm 02/09/2012 23:40'!
pentagonalIcositetrahedron
	"self pentagonalIcositetrahedron"

	^(Triangle3DComposite new)
		add: (Triangle3D 
					with: -0.0454249 , 0.452241 , -0.217969
					with: -0.0900011 , 0.213823 , -0.414138
					with: -0.272031 , 0.0965225 , -0.376846);
		add: (Triangle3D 
					with: -0.0454249 , 0.452241 , -0.217969
					with: -0.272031 , 0.0965225 , -0.376846
					with: -0.393406 , 0.166016 , -0.207366);
		add: (Triangle3D 
					with: -0.0454249 , 0.452241 , -0.217969
					with: -0.393406 , 0.166016 , -0.207366
					with: -0.313245 , 0.341642 , -0.102416);
		add: (Triangle3D 
					with: -0.5 , -0.0604084 , -0.0211347
					with: -0.407766 , 0.143772 , 0.195927
					with: -0.321052 , 0.329548 , 0.116851);
		add: (Triangle3D 
					with: -0.5 , -0.0604084 , -0.0211347
					with: -0.321052 , 0.329548 , 0.116851
					with: -0.313245 , 0.341642 , -0.102416);
		add: (Triangle3D 
					with: -0.5 , -0.0604084 , -0.0211347
					with: -0.313245 , 0.341642 , -0.102416
					with: -0.393406 , 0.166016 , -0.207366);
		add: (Triangle3D 
					with: -0.0454249 , 0.452241 , -0.217969
					with: -0.313245 , 0.341642 , -0.102416
					with: -0.321052 , 0.329548 , 0.116851);
		add: (Triangle3D 
					with: -0.0454249 , 0.452241 , -0.217969
					with: -0.321052 , 0.329548 , 0.116851
					with: -0.138952 , 0.397304 , 0.219482);
		add: (Triangle3D 
					with: -0.0454249 , 0.452241 , -0.217969
					with: -0.138952 , 0.397304 , 0.219482
					with: 0.0216904 , 0.466265 , 0.0863524);
		add: (Triangle3D 
					with: -0.0454249 , 0.452241 , -0.217969
					with: 0.0216904 , 0.466265 , 0.0863524
					with: 0.222637 , 0.395235 , 0.139832);
		add: (Triangle3D 
					with: -0.0454249 , 0.452241 , -0.217969
					with: 0.222637 , 0.395235 , 0.139832
					with: 0.344012 , 0.325741 , -0.029648);
		add: (Triangle3D 
					with: -0.0454249 , 0.452241 , -0.217969
					with: 0.344012 , 0.325741 , -0.029648
					with: 0.244934 , 0.338447 , -0.22537);
		add: (Triangle3D 
					with: 0.5 , 0.0604084 , 0.0211347
					with: 0.393165 , 0.00158999 , -0.265987
					with: 0.271658 , 0.162209 , -0.353865);
		add: (Triangle3D 
					with: 0.5 , 0.0604084 , 0.0211347
					with: 0.271658 , 0.162209 , -0.353865
					with: 0.244934 , 0.338447 , -0.22537);
		add: (Triangle3D 
					with: 0.5 , 0.0604084 , 0.0211347
					with: 0.244934 , 0.338447 , -0.22537
					with: 0.344012 , 0.325741 , -0.029648);
		add: (Triangle3D 
					with: -0.0454249 , 0.452241 , -0.217969
					with: 0.244934 , 0.338447 , -0.22537
					with: 0.271658 , 0.162209 , -0.353865);
		add: (Triangle3D 
					with: -0.0454249 , 0.452241 , -0.217969
					with: 0.271658 , 0.162209 , -0.353865
					with: 0.0895575 , 0.0944527 , -0.456496);
		add: (Triangle3D 
					with: -0.0454249 , 0.452241 , -0.217969
					with: 0.0895575 , 0.0944527 , -0.456496
					with: -0.0900011 , 0.213823 , -0.414138);
		add: (Triangle3D 
					with: 0.0450825 , -0.2143 , -0.454025
					with: -0.0217617 , -0.416721 , -0.226275
					with: -0.222637 , -0.395235 , -0.139832);
		add: (Triangle3D 
					with: 0.0450825 , -0.2143 , -0.454025
					with: -0.222637 , -0.395235 , -0.139832
					with: -0.344143 , -0.234615 , -0.22771);
		add: (Triangle3D 
					with: 0.0450825 , -0.2143 , -0.454025
					with: -0.344143 , -0.234615 , -0.22771
					with: -0.245247 , -0.121296 , -0.387907);
		add: (Triangle3D 
					with: -0.5 , -0.0604084 , -0.0211347
					with: -0.393406 , 0.166016 , -0.207366
					with: -0.272031 , 0.0965225 , -0.376846);
		add: (Triangle3D 
					with: -0.5 , -0.0604084 , -0.0211347
					with: -0.272031 , 0.0965225 , -0.376846
					with: -0.245247 , -0.121296 , -0.387907);
		add: (Triangle3D 
					with: -0.5 , -0.0604084 , -0.0211347
					with: -0.245247 , -0.121296 , -0.387907
					with: -0.344143 , -0.234615 , -0.22771);
		add: (Triangle3D 
					with: 0.0450825 , -0.2143 , -0.454025
					with: -0.245247 , -0.121296 , -0.387907
					with: -0.272031 , 0.0965225 , -0.376846);
		add: (Triangle3D 
					with: 0.0450825 , -0.2143 , -0.454025
					with: -0.272031 , 0.0965225 , -0.376846
					with: -0.0900011 , 0.213823 , -0.414138);
		add: (Triangle3D 
					with: 0.0450825 , -0.2143 , -0.454025
					with: -0.0900011 , 0.213823 , -0.414138
					with: 0.0895575 , 0.0944527 , -0.456496);
		add: (Triangle3D 
					with: 0.0450825 , -0.2143 , -0.454025
					with: 0.0895575 , 0.0944527 , -0.456496
					with: 0.271658 , 0.162209 , -0.353865);
		add: (Triangle3D 
					with: 0.0450825 , -0.2143 , -0.454025
					with: 0.271658 , 0.162209 , -0.353865
					with: 0.393165 , 0.00158999 , -0.265987);
		add: (Triangle3D 
					with: 0.0450825 , -0.2143 , -0.454025
					with: 0.393165 , 0.00158999 , -0.265987
					with: 0.313043 , -0.200972 , -0.294864);
		add: (Triangle3D 
					with: 0.5 , 0.0604084 , 0.0211347
					with: 0.407897 , -0.234898 , 0.0614307
					with: 0.321052 , -0.329548 , -0.116851);
		add: (Triangle3D 
					with: 0.5 , 0.0604084 , 0.0211347
					with: 0.321052 , -0.329548 , -0.116851
					with: 0.313043 , -0.200972 , -0.294864);
		add: (Triangle3D 
					with: 0.5 , 0.0604084 , 0.0211347
					with: 0.313043 , -0.200972 , -0.294864
					with: 0.393165 , 0.00158999 , -0.265987);
		add: (Triangle3D 
					with: 0.0450825 , -0.2143 , -0.454025
					with: 0.313043 , -0.200972 , -0.294864
					with: 0.321052 , -0.329548 , -0.116851);
		add: (Triangle3D 
					with: 0.0450825 , -0.2143 , -0.454025
					with: 0.321052 , -0.329548 , -0.116851
					with: 0.139023 , -0.446848 , -0.0795592);
		add: (Triangle3D 
					with: 0.0450825 , -0.2143 , -0.454025
					with: 0.139023 , -0.446848 , -0.0795592
					with: -0.0217617 , -0.416721 , -0.226275);
		add: (Triangle3D 
					with: 0.0454249 , -0.452241 , 0.217969
					with: -0.0707121 , -0.23324 , 0.407344
					with: -0.271658 , -0.162209 , 0.353865);
		add: (Triangle3D 
					with: 0.0454249 , -0.452241 , 0.217969
					with: -0.271658 , -0.162209 , 0.353865
					with: -0.358503 , -0.256859 , 0.175584);
		add: (Triangle3D 
					with: 0.0454249 , -0.452241 , 0.217969
					with: -0.358503 , -0.256859 , 0.175584
					with: -0.230444 , -0.407328 , 0.0794341);
		add: (Triangle3D 
					with: -0.5 , -0.0604084 , -0.0211347
					with: -0.344143 , -0.234615 , -0.22771
					with: -0.222637 , -0.395235 , -0.139832);
		add: (Triangle3D 
					with: -0.5 , -0.0604084 , -0.0211347
					with: -0.222637 , -0.395235 , -0.139832
					with: -0.230444 , -0.407328 , 0.0794341);
		add: (Triangle3D 
					with: -0.5 , -0.0604084 , -0.0211347
					with: -0.230444 , -0.407328 , 0.0794341
					with: -0.358503 , -0.256859 , 0.175584);
		add: (Triangle3D 
					with: 0.0454249 , -0.452241 , 0.217969
					with: -0.230444 , -0.407328 , 0.0794341
					with: -0.222637 , -0.395235 , -0.139832);
		add: (Triangle3D 
					with: 0.0454249 , -0.452241 , 0.217969
					with: -0.222637 , -0.395235 , -0.139832
					with: -0.0217617 , -0.416721 , -0.226275);
		add: (Triangle3D 
					with: 0.0454249 , -0.452241 , 0.217969
					with: -0.0217617 , -0.416721 , -0.226275
					with: 0.139023 , -0.446848 , -0.0795592);
		add: (Triangle3D 
					with: 0.0454249 , -0.452241 , 0.217969
					with: 0.139023 , -0.446848 , -0.0795592
					with: 0.321052 , -0.329548 , -0.116851);
		add: (Triangle3D 
					with: 0.0454249 , -0.452241 , 0.217969
					with: 0.321052 , -0.329548 , -0.116851
					with: 0.407897 , -0.234898 , 0.0614307);
		add: (Triangle3D 
					with: 0.0454249 , -0.452241 , 0.217969
					with: 0.407897 , -0.234898 , 0.0614307
					with: 0.298755 , -0.27276 , 0.248351);
		add: (Triangle3D 
					with: 0.5 , 0.0604084 , 0.0211347
					with: 0.358744 , 0.0892532 , 0.29777
					with: 0.272031 , -0.0965225 , 0.376846);
		add: (Triangle3D 
					with: 0.5 , 0.0604084 , 0.0211347
					with: 0.272031 , -0.0965225 , 0.376846
					with: 0.298755 , -0.27276 , 0.248351);
		add: (Triangle3D 
					with: 0.5 , 0.0604084 , 0.0211347
					with: 0.298755 , -0.27276 , 0.248351
					with: 0.407897 , -0.234898 , 0.0614307);
		add: (Triangle3D 
					with: 0.0454249 , -0.452241 , 0.217969
					with: 0.298755 , -0.27276 , 0.248351
					with: 0.272031 , -0.0965225 , 0.376846);
		add: (Triangle3D 
					with: 0.0454249 , -0.452241 , 0.217969
					with: 0.272031 , -0.0965225 , 0.376846
					with: 0.0711557 , -0.0750358 , 0.463289);
		add: (Triangle3D 
					with: 0.0454249 , -0.452241 , 0.217969
					with: 0.0711557 , -0.0750358 , 0.463289
					with: -0.0707121 , -0.23324 , 0.407344);
		add: (Triangle3D 
					with: -0.0450825 , 0.2143 , 0.454025
					with: -0.138952 , 0.397304 , 0.219482
					with: -0.321052 , 0.329548 , 0.116851);
		add: (Triangle3D 
					with: -0.0450825 , 0.2143 , 0.454025
					with: -0.321052 , 0.329548 , 0.116851
					with: -0.407766 , 0.143772 , 0.195927);
		add: (Triangle3D 
					with: -0.0450825 , 0.2143 , 0.454025
					with: -0.407766 , 0.143772 , 0.195927
					with: -0.298442 , 0.0556098 , 0.364925);
		add: (Triangle3D 
					with: -0.5 , -0.0604084 , -0.0211347
					with: -0.358503 , -0.256859 , 0.175584
					with: -0.271658 , -0.162209 , 0.353865);
		add: (Triangle3D 
					with: -0.5 , -0.0604084 , -0.0211347
					with: -0.271658 , -0.162209 , 0.353865
					with: -0.298442 , 0.0556098 , 0.364925);
		add: (Triangle3D 
					with: -0.5 , -0.0604084 , -0.0211347
					with: -0.298442 , 0.0556098 , 0.364925
					with: -0.407766 , 0.143772 , 0.195927);
		add: (Triangle3D 
					with: -0.0450825 , 0.2143 , 0.454025
					with: -0.298442 , 0.0556098 , 0.364925
					with: -0.271658 , -0.162209 , 0.353865);
		add: (Triangle3D 
					with: -0.0450825 , 0.2143 , 0.454025
					with: -0.271658 , -0.162209 , 0.353865
					with: -0.0707121 , -0.23324 , 0.407344);
		add: (Triangle3D 
					with: -0.0450825 , 0.2143 , 0.454025
					with: -0.0707121 , -0.23324 , 0.407344
					with: 0.0711557 , -0.0750358 , 0.463289);
		add: (Triangle3D 
					with: -0.0450825 , 0.2143 , 0.454025
					with: 0.0711557 , -0.0750358 , 0.463289
					with: 0.272031 , -0.0965225 , 0.376846);
		add: (Triangle3D 
					with: -0.0450825 , 0.2143 , 0.454025
					with: 0.272031 , -0.0965225 , 0.376846
					with: 0.358744 , 0.0892532 , 0.29777);
		add: (Triangle3D 
					with: -0.0450825 , 0.2143 , 0.454025
					with: 0.358744 , 0.0892532 , 0.29777
					with: 0.230646 , 0.266659 , 0.317846);
		add: (Triangle3D 
					with: 0.5 , 0.0604084 , 0.0211347
					with: 0.344012 , 0.325741 , -0.029648
					with: 0.222637 , 0.395235 , 0.139832);
		add: (Triangle3D 
					with: 0.5 , 0.0604084 , 0.0211347
					with: 0.222637 , 0.395235 , 0.139832
					with: 0.230646 , 0.266659 , 0.317846);
		add: (Triangle3D 
					with: 0.5 , 0.0604084 , 0.0211347
					with: 0.230646 , 0.266659 , 0.317846
					with: 0.358744 , 0.0892532 , 0.29777);
		add: (Triangle3D 
					with: -0.0450825 , 0.2143 , 0.454025
					with: 0.230646 , 0.266659 , 0.317846
					with: 0.222637 , 0.395235 , 0.139832);
		add: (Triangle3D 
					with: -0.0450825 , 0.2143 , 0.454025
					with: 0.222637 , 0.395235 , 0.139832
					with: 0.0216904 , 0.466265 , 0.0863524);
		add: (Triangle3D 
					with: -0.0450825 , 0.2143 , 0.454025
					with: 0.0216904 , 0.466265 , 0.0863524
					with: -0.138952 , 0.397304 , 0.219482);
		yourself! !

!Polyhedron class methodsFor: 'factory-pentagonal' stamp: 'emm 02/09/2012 23:40'!
pentagonalOrthobicupola
	"self pentagonalOrthobicupola"

	^(Triangle3DComposite new)
		add: (Triangle3D 
					with: -0.13138 , -0.231584 , -0.157784
					with: -0.256003 , 0.0527346 , -0.165738
					with: -0.0240077 , 0.259107 , -0.170199);
		add: (Triangle3D 
					with: -0.13138 , -0.231584 , -0.157784
					with: -0.0240077 , 0.259107 , -0.170199
					with: 0.243997 , 0.102334 , -0.165002);
		add: (Triangle3D 
					with: -0.13138 , -0.231584 , -0.157784
					with: 0.243997 , 0.102334 , -0.165002
					with: 0.177637 , -0.20093 , -0.157329);
		add: (Triangle3D 
					with: -0.256003 , 0.0527346 , -0.165738
					with: -0.13138 , -0.231584 , -0.157784
					with: -0.373992 , -0.333311 , 0.00720787);
		add: (Triangle3D 
					with: -0.256003 , 0.0527346 , -0.165738
					with: -0.373992 , -0.333311 , 0.00720787
					with: -0.498615 , -0.0489924 , -0.00074593);
		add: (Triangle3D 
					with: -0.256003 , 0.0527346 , -0.165738
					with: -0.498615 , -0.0489924 , -0.00074593
					with: -0.432256 , 0.254271 , -0.00841884);
		add: (Triangle3D 
					with: -0.0240077 , 0.259107 , -0.170199
					with: -0.256003 , 0.0527346 , -0.165738
					with: -0.432256 , 0.254271 , -0.00841884);
		add: (Triangle3D 
					with: -0.0240077 , 0.259107 , -0.170199
					with: -0.432256 , 0.254271 , -0.00841884
					with: -0.20026 , 0.460644 , -0.0128799);
		add: (Triangle3D 
					with: -0.0240077 , 0.259107 , -0.170199
					with: -0.20026 , 0.460644 , -0.0128799
					with: 0.108757 , 0.491298 , -0.0124251);
		add: (Triangle3D 
					with: 0.243997 , 0.102334 , -0.165002
					with: -0.0240077 , 0.259107 , -0.170199
					with: 0.108757 , 0.491298 , -0.0124251);
		add: (Triangle3D 
					with: 0.243997 , 0.102334 , -0.165002
					with: 0.108757 , 0.491298 , -0.0124251
					with: 0.376761 , 0.334524 , -0.00722832);
		add: (Triangle3D 
					with: 0.243997 , 0.102334 , -0.165002
					with: 0.376761 , 0.334524 , -0.00722832
					with: 0.501385 , 0.0502056 , 0.000725482);
		add: (Triangle3D 
					with: 0.177637 , -0.20093 , -0.157329
					with: 0.243997 , 0.102334 , -0.165002
					with: 0.501385 , 0.0502056 , 0.000725482);
		add: (Triangle3D 
					with: 0.177637 , -0.20093 , -0.157329
					with: 0.501385 , 0.0502056 , 0.000725482
					with: 0.435025 , -0.253058 , 0.00839824);
		add: (Triangle3D 
					with: 0.177637 , -0.20093 , -0.157329
					with: 0.435025 , -0.253058 , 0.00839824
					with: 0.20303 , -0.459431 , 0.0128593);
		add: (Triangle3D 
					with: -0.13138 , -0.231584 , -0.157784
					with: 0.177637 , -0.20093 , -0.157329
					with: 0.20303 , -0.459431 , 0.0128593);
		add: (Triangle3D 
					with: -0.13138 , -0.231584 , -0.157784
					with: 0.20303 , -0.459431 , 0.0128593
					with: -0.105987 , -0.490084 , 0.0124045);
		add: (Triangle3D 
					with: -0.13138 , -0.231584 , -0.157784
					with: -0.105987 , -0.490084 , 0.0124045
					with: -0.373992 , -0.333311 , 0.00720787);
		add: (Triangle3D 
					with: -0.257331 , 0.0612834 , 0.160662
					with: -0.132708 , -0.223035 , 0.168616
					with: 0.176309 , -0.192381 , 0.169071);
		add: (Triangle3D 
					with: -0.257331 , 0.0612834 , 0.160662
					with: 0.176309 , -0.192381 , 0.169071
					with: 0.242669 , 0.110882 , 0.161398);
		add: (Triangle3D 
					with: -0.257331 , 0.0612834 , 0.160662
					with: 0.242669 , 0.110882 , 0.161398
					with: -0.025336 , 0.267656 , 0.156201);
		add: (Triangle3D 
					with: -0.132708 , -0.223035 , 0.168616
					with: -0.257331 , 0.0612834 , 0.160662
					with: -0.498615 , -0.0489924 , -0.00074593);
		add: (Triangle3D 
					with: -0.132708 , -0.223035 , 0.168616
					with: -0.498615 , -0.0489924 , -0.00074593
					with: -0.373992 , -0.333311 , 0.00720787);
		add: (Triangle3D 
					with: -0.132708 , -0.223035 , 0.168616
					with: -0.373992 , -0.333311 , 0.00720787
					with: -0.105987 , -0.490084 , 0.0124045);
		add: (Triangle3D 
					with: 0.176309 , -0.192381 , 0.169071
					with: -0.132708 , -0.223035 , 0.168616
					with: -0.105987 , -0.490084 , 0.0124045);
		add: (Triangle3D 
					with: 0.176309 , -0.192381 , 0.169071
					with: -0.105987 , -0.490084 , 0.0124045
					with: 0.20303 , -0.459431 , 0.0128593);
		add: (Triangle3D 
					with: 0.176309 , -0.192381 , 0.169071
					with: 0.20303 , -0.459431 , 0.0128593
					with: 0.435025 , -0.253058 , 0.00839824);
		add: (Triangle3D 
					with: 0.242669 , 0.110882 , 0.161398
					with: 0.176309 , -0.192381 , 0.169071
					with: 0.435025 , -0.253058 , 0.00839824);
		add: (Triangle3D 
					with: 0.242669 , 0.110882 , 0.161398
					with: 0.435025 , -0.253058 , 0.00839824
					with: 0.501385 , 0.0502056 , 0.000725482);
		add: (Triangle3D 
					with: 0.242669 , 0.110882 , 0.161398
					with: 0.501385 , 0.0502056 , 0.000725482
					with: 0.376761 , 0.334524 , -0.00722832);
		add: (Triangle3D 
					with: -0.025336 , 0.267656 , 0.156201
					with: 0.242669 , 0.110882 , 0.161398
					with: 0.376761 , 0.334524 , -0.00722832);
		add: (Triangle3D 
					with: -0.025336 , 0.267656 , 0.156201
					with: 0.376761 , 0.334524 , -0.00722832
					with: 0.108757 , 0.491298 , -0.0124251);
		add: (Triangle3D 
					with: -0.025336 , 0.267656 , 0.156201
					with: 0.108757 , 0.491298 , -0.0124251
					with: -0.20026 , 0.460644 , -0.0128799);
		add: (Triangle3D 
					with: -0.257331 , 0.0612834 , 0.160662
					with: -0.025336 , 0.267656 , 0.156201
					with: -0.20026 , 0.460644 , -0.0128799);
		add: (Triangle3D 
					with: -0.257331 , 0.0612834 , 0.160662
					with: -0.20026 , 0.460644 , -0.0128799
					with: -0.432256 , 0.254271 , -0.00841884);
		add: (Triangle3D 
					with: -0.257331 , 0.0612834 , 0.160662
					with: -0.432256 , 0.254271 , -0.00841884
					with: -0.498615 , -0.0489924 , -0.00074593);
		yourself! !

!Polyhedron class methodsFor: 'factory-pentagonal' stamp: 'emm 02/09/2012 23:40'!
pentagonalOrthobirotunda
	"self pentagonalOrthobirotunda"

	^(Triangle3DComposite new)
		add: (Triangle3D 
					with: 0.0269692 , -0.513422 , -0.0356324
					with: -0.0350432 , -0.397907 , -0.326348
					with: 0.213205 , -0.219089 , -0.416357);
		add: (Triangle3D 
					with: 0.0269692 , -0.513422 , -0.0356324
					with: 0.213205 , -0.219089 , -0.416357
					with: 0.428644 , -0.224088 , -0.181269);
		add: (Triangle3D 
					with: 0.0269692 , -0.513422 , -0.0356324
					with: 0.428644 , -0.224088 , -0.181269
					with: 0.313543 , -0.405995 , 0.0540313);
		add: (Triangle3D 
					with: 0.0269692 , -0.513422 , -0.0356324
					with: 0.0789623 , -0.432546 , 0.268441
					with: -0.185497 , -0.293599 , 0.380063);
		add: (Triangle3D 
					with: 0.0269692 , -0.513422 , -0.0356324
					with: -0.185497 , -0.293599 , 0.380063
					with: -0.400936 , -0.2886 , 0.144975);
		add: (Triangle3D 
					with: 0.0269692 , -0.513422 , -0.0356324
					with: -0.400936 , -0.2886 , 0.144975
					with: -0.269624 , -0.424458 , -0.111938);
		add: (Triangle3D 
					with: 0.0269692 , -0.513422 , -0.0356324
					with: -0.269624 , -0.424458 , -0.111938
					with: -0.0350432 , -0.397907 , -0.326348);
		add: (Triangle3D 
					with: -0.269624 , -0.424458 , -0.111938
					with: -0.400936 , -0.2886 , 0.144975
					with: -0.462948 , -0.173085 , -0.14574);
		add: (Triangle3D 
					with: -0.0350432 , -0.397907 , -0.326348
					with: -0.269624 , -0.424458 , -0.111938
					with: -0.462948 , -0.173085 , -0.14574);
		add: (Triangle3D 
					with: -0.0350432 , -0.397907 , -0.326348
					with: -0.462948 , -0.173085 , -0.14574
					with: -0.347848 , 0.00882196 , -0.381041);
		add: (Triangle3D 
					with: -0.0350432 , -0.397907 , -0.326348
					with: -0.347848 , 0.00882196 , -0.381041
					with: -0.0833879 , -0.130125 , -0.492663);
		add: (Triangle3D 
					with: -0.0350432 , -0.397907 , -0.326348
					with: -0.0833879 , -0.130125 , -0.492663
					with: 0.213205 , -0.219089 , -0.416357);
		add: (Triangle3D 
					with: -0.0833879 , -0.130125 , -0.492663
					with: -0.347848 , 0.00882196 , -0.381041
					with: -0.0995991 , 0.18764 , -0.471049);
		add: (Triangle3D 
					with: 0.213205 , -0.219089 , -0.416357
					with: -0.0833879 , -0.130125 , -0.492663
					with: -0.0995991 , 0.18764 , -0.471049);
		add: (Triangle3D 
					with: 0.213205 , -0.219089 , -0.416357
					with: -0.0995991 , 0.18764 , -0.471049
					with: 0.186975 , 0.295066 , -0.381386);
		add: (Triangle3D 
					with: 0.213205 , -0.219089 , -0.416357
					with: 0.186975 , 0.295066 , -0.381386
					with: 0.380299 , 0.0436935 , -0.347584);
		add: (Triangle3D 
					with: 0.213205 , -0.219089 , -0.416357
					with: 0.380299 , 0.0436935 , -0.347584
					with: 0.428644 , -0.224088 , -0.181269);
		add: (Triangle3D 
					with: 0.380299 , 0.0436935 , -0.347584
					with: 0.186975 , 0.295066 , -0.381386
					with: 0.402413 , 0.290067 , -0.146298);
		add: (Triangle3D 
					with: 0.428644 , -0.224088 , -0.181269
					with: 0.380299 , 0.0436935 , -0.347584
					with: 0.402413 , 0.290067 , -0.146298);
		add: (Triangle3D 
					with: 0.428644 , -0.224088 , -0.181269
					with: 0.402413 , 0.290067 , -0.146298
					with: 0.464426 , 0.174553 , 0.144417);
		add: (Triangle3D 
					with: 0.428644 , -0.224088 , -0.181269
					with: 0.464426 , 0.174553 , 0.144417
					with: 0.480637 , -0.143213 , 0.122804);
		add: (Triangle3D 
					with: 0.428644 , -0.224088 , -0.181269
					with: 0.480637 , -0.143213 , 0.122804
					with: 0.313543 , -0.405995 , 0.0540313);
		add: (Triangle3D 
					with: 0.480637 , -0.143213 , 0.122804
					with: 0.464426 , 0.174553 , 0.144417
					with: 0.349325 , -0.00735483 , 0.379718);
		add: (Triangle3D 
					with: 0.313543 , -0.405995 , 0.0540313
					with: 0.480637 , -0.143213 , 0.122804
					with: 0.349325 , -0.00735483 , 0.379718);
		add: (Triangle3D 
					with: 0.313543 , -0.405995 , 0.0540313
					with: 0.349325 , -0.00735483 , 0.379718
					with: 0.101077 , -0.186173 , 0.469726);
		add: (Triangle3D 
					with: 0.313543 , -0.405995 , 0.0540313
					with: 0.101077 , -0.186173 , 0.469726
					with: 0.0789623 , -0.432546 , 0.268441);
		add: (Triangle3D 
					with: 0.313543 , -0.405995 , 0.0540313
					with: 0.0789623 , -0.432546 , 0.268441
					with: 0.0269692 , -0.513422 , -0.0356324);
		add: (Triangle3D 
					with: 0.0789623 , -0.432546 , 0.268441
					with: 0.101077 , -0.186173 , 0.469726
					with: -0.185497 , -0.293599 , 0.380063);
		add: (Triangle3D 
					with: -0.350481 , 0.192246 , 0.325275
					with: -0.0639062 , 0.299672 , 0.414938
					with: 0.0511941 , 0.48158 , 0.179638);
		add: (Triangle3D 
					with: -0.350481 , 0.192246 , 0.325275
					with: 0.0511941 , 0.48158 , 0.179638
					with: -0.164244 , 0.486578 , -0.0554497);
		add: (Triangle3D 
					with: -0.350481 , 0.192246 , 0.325275
					with: -0.164244 , 0.486578 , -0.0554497
					with: -0.412493 , 0.307761 , 0.0345589);
		add: (Triangle3D 
					with: -0.350481 , 0.192246 , 0.325275
					with: -0.502901 , 0.0116687 , 0.111114
					with: -0.400936 , -0.2886 , 0.144975);
		add: (Triangle3D 
					with: -0.350481 , 0.192246 , 0.325275
					with: -0.400936 , -0.2886 , 0.144975
					with: -0.185497 , -0.293599 , 0.380063);
		add: (Triangle3D 
					with: -0.350481 , 0.192246 , 0.325275
					with: -0.185497 , -0.293599 , 0.380063
					with: -0.154314 , 0.00358045 , 0.491494);
		add: (Triangle3D 
					with: -0.350481 , 0.192246 , 0.325275
					with: -0.154314 , 0.00358045 , 0.491494
					with: -0.0639062 , 0.299672 , 0.414938);
		add: (Triangle3D 
					with: -0.154314 , 0.00358045 , 0.491494
					with: -0.185497 , -0.293599 , 0.380063
					with: 0.101077 , -0.186173 , 0.469726);
		add: (Triangle3D 
					with: -0.0639062 , 0.299672 , 0.414938
					with: -0.154314 , 0.00358045 , 0.491494
					with: 0.101077 , -0.186173 , 0.469726);
		add: (Triangle3D 
					with: -0.0639062 , 0.299672 , 0.414938
					with: 0.101077 , -0.186173 , 0.469726
					with: 0.349325 , -0.00735483 , 0.379718);
		add: (Triangle3D 
					with: -0.0639062 , 0.299672 , 0.414938
					with: 0.349325 , -0.00735483 , 0.379718
					with: 0.24736 , 0.292914 , 0.345857);
		add: (Triangle3D 
					with: -0.0639062 , 0.299672 , 0.414938
					with: 0.24736 , 0.292914 , 0.345857
					with: 0.0511941 , 0.48158 , 0.179638);
		add: (Triangle3D 
					with: 0.24736 , 0.292914 , 0.345857
					with: 0.349325 , -0.00735483 , 0.379718
					with: 0.464426 , 0.174553 , 0.144417);
		add: (Triangle3D 
					with: 0.0511941 , 0.48158 , 0.179638
					with: 0.24736 , 0.292914 , 0.345857
					with: 0.464426 , 0.174553 , 0.144417);
		add: (Triangle3D 
					with: 0.0511941 , 0.48158 , 0.179638
					with: 0.464426 , 0.174553 , 0.144417
					with: 0.402413 , 0.290067 , -0.146298);
		add: (Triangle3D 
					with: 0.0511941 , 0.48158 , 0.179638
					with: 0.402413 , 0.290067 , -0.146298
					with: 0.147022 , 0.47982 , -0.124531);
		add: (Triangle3D 
					with: 0.0511941 , 0.48158 , 0.179638
					with: 0.147022 , 0.47982 , -0.124531
					with: -0.164244 , 0.486578 , -0.0554497);
		add: (Triangle3D 
					with: 0.147022 , 0.47982 , -0.124531
					with: 0.402413 , 0.290067 , -0.146298
					with: 0.186975 , 0.295066 , -0.381386);
		add: (Triangle3D 
					with: -0.164244 , 0.486578 , -0.0554497
					with: 0.147022 , 0.47982 , -0.124531
					with: 0.186975 , 0.295066 , -0.381386);
		add: (Triangle3D 
					with: -0.164244 , 0.486578 , -0.0554497
					with: 0.186975 , 0.295066 , -0.381386
					with: -0.0995991 , 0.18764 , -0.471049);
		add: (Triangle3D 
					with: -0.164244 , 0.486578 , -0.0554497
					with: -0.0995991 , 0.18764 , -0.471049
					with: -0.316665 , 0.306001 , -0.26961);
		add: (Triangle3D 
					with: -0.164244 , 0.486578 , -0.0554497
					with: -0.316665 , 0.306001 , -0.26961
					with: -0.412493 , 0.307761 , 0.0345589);
		add: (Triangle3D 
					with: -0.316665 , 0.306001 , -0.26961
					with: -0.0995991 , 0.18764 , -0.471049
					with: -0.347848 , 0.00882196 , -0.381041);
		add: (Triangle3D 
					with: -0.412493 , 0.307761 , 0.0345589
					with: -0.316665 , 0.306001 , -0.26961
					with: -0.347848 , 0.00882196 , -0.381041);
		add: (Triangle3D 
					with: -0.412493 , 0.307761 , 0.0345589
					with: -0.347848 , 0.00882196 , -0.381041
					with: -0.462948 , -0.173085 , -0.14574);
		add: (Triangle3D 
					with: -0.412493 , 0.307761 , 0.0345589
					with: -0.462948 , -0.173085 , -0.14574
					with: -0.502901 , 0.0116687 , 0.111114);
		add: (Triangle3D 
					with: -0.412493 , 0.307761 , 0.0345589
					with: -0.502901 , 0.0116687 , 0.111114
					with: -0.350481 , 0.192246 , 0.325275);
		add: (Triangle3D 
					with: -0.502901 , 0.0116687 , 0.111114
					with: -0.462948 , -0.173085 , -0.14574
					with: -0.400936 , -0.2886 , 0.144975);
		yourself! !

!Polyhedron class methodsFor: 'factory-pentagonal' stamp: 'emm 02/09/2012 23:40'!
pentagonalOrthocupolarontunda
	"self pentagonalOrthocupolarontunda"

	^(Triangle3DComposite new)
		add: (Triangle3D 
					with: -0.287997 , -0.236069 , 0.145262
					with: -0.353407 , -0.113044 , -0.151241
					with: -0.0981583 , -0.177604 , -0.346196);
		add: (Triangle3D 
					with: -0.287997 , -0.236069 , 0.145262
					with: -0.0981583 , -0.177604 , -0.346196
					with: 0.125005 , -0.340531 , -0.170183);
		add: (Triangle3D 
					with: -0.287997 , -0.236069 , 0.145262
					with: 0.125005 , -0.340531 , -0.170183
					with: 0.00767868 , -0.376664 , 0.133555);
		add: (Triangle3D 
					with: -0.353407 , -0.113044 , -0.151241
					with: -0.287997 , -0.236069 , 0.145262
					with: -0.461608 , 0.00489695 , 0.283544);
		add: (Triangle3D 
					with: -0.353407 , -0.113044 , -0.151241
					with: -0.461608 , 0.00489695 , 0.283544
					with: -0.527019 , 0.127923 , -0.0129585);
		add: (Triangle3D 
					with: -0.353407 , -0.113044 , -0.151241
					with: -0.527019 , 0.127923 , -0.0129585
					with: -0.409692 , 0.164056 , -0.316696);
		add: (Triangle3D 
					with: -0.0981583 , -0.177604 , -0.346196
					with: -0.353407 , -0.113044 , -0.151241
					with: -0.409692 , 0.164056 , -0.316696);
		add: (Triangle3D 
					with: -0.0981583 , -0.177604 , -0.346196
					with: -0.409692 , 0.164056 , -0.316696
					with: -0.154443 , 0.0994956 , -0.511652);
		add: (Triangle3D 
					with: -0.0981583 , -0.177604 , -0.346196
					with: -0.154443 , 0.0994956 , -0.511652
					with: 0.141232 , -0.0410991 , -0.523358);
		add: (Triangle3D 
					with: 0.125005 , -0.340531 , -0.170183
					with: -0.0981583 , -0.177604 , -0.346196
					with: 0.141232 , -0.0410991 , -0.523358);
		add: (Triangle3D 
					with: 0.125005 , -0.340531 , -0.170183
					with: 0.141232 , -0.0410991 , -0.523358
					with: 0.364396 , -0.204025 , -0.347344);
		add: (Triangle3D 
					with: 0.125005 , -0.340531 , -0.170183
					with: 0.364396 , -0.204025 , -0.347344
					with: 0.429806 , -0.327051 , -0.0508415);
		add: (Triangle3D 
					with: 0.00767868 , -0.376664 , 0.133555
					with: 0.125005 , -0.340531 , -0.170183
					with: 0.429806 , -0.327051 , -0.0508415);
		add: (Triangle3D 
					with: 0.00767868 , -0.376664 , 0.133555
					with: 0.429806 , -0.327051 , -0.0508415
					with: 0.31248 , -0.363185 , 0.252896);
		add: (Triangle3D 
					with: 0.00767868 , -0.376664 , 0.133555
					with: 0.31248 , -0.363185 , 0.252896
					with: 0.0572308 , -0.298624 , 0.447851);
		add: (Triangle3D 
					with: -0.287997 , -0.236069 , 0.145262
					with: 0.00767868 , -0.376664 , 0.133555
					with: 0.0572308 , -0.298624 , 0.447851);
		add: (Triangle3D 
					with: -0.287997 , -0.236069 , 0.145262
					with: 0.0572308 , -0.298624 , 0.447851
					with: -0.238445 , -0.158029 , 0.459558);
		add: (Triangle3D 
					with: -0.287997 , -0.236069 , 0.145262
					with: -0.238445 , -0.158029 , 0.459558
					with: -0.461608 , 0.00489695 , 0.283544);
		add: (Triangle3D 
					with: 0.270961 , 0.163212 , 0.29948
					with: 0.388288 , 0.199346 , -0.00425771
					with: 0.165124 , 0.362272 , -0.180271);
		add: (Triangle3D 
					with: 0.270961 , 0.163212 , 0.29948
					with: 0.165124 , 0.362272 , -0.180271
					with: -0.0901248 , 0.426833 , 0.0146838);
		add: (Triangle3D 
					with: 0.270961 , 0.163212 , 0.29948
					with: -0.0901248 , 0.426833 , 0.0146838
					with: -0.024714 , 0.303807 , 0.311187);
		add: (Triangle3D 
					with: 0.270961 , 0.163212 , 0.29948
					with: 0.0315709 , 0.0267072 , 0.476642
					with: 0.0572308 , -0.298624 , 0.447851);
		add: (Triangle3D 
					with: 0.270961 , 0.163212 , 0.29948
					with: 0.0572308 , -0.298624 , 0.447851
					with: 0.31248 , -0.363185 , 0.252896);
		add: (Triangle3D 
					with: 0.270961 , 0.163212 , 0.29948
					with: 0.31248 , -0.363185 , 0.252896
					with: 0.444573 , -0.077754 , 0.161198);
		add: (Triangle3D 
					with: 0.270961 , 0.163212 , 0.29948
					with: 0.444573 , -0.077754 , 0.161198
					with: 0.388288 , 0.199346 , -0.00425771);
		add: (Triangle3D 
					with: 0.444573 , -0.077754 , 0.161198
					with: 0.31248 , -0.363185 , 0.252896
					with: 0.429806 , -0.327051 , -0.0508415);
		add: (Triangle3D 
					with: 0.388288 , 0.199346 , -0.00425771
					with: 0.444573 , -0.077754 , 0.161198
					with: 0.429806 , -0.327051 , -0.0508415);
		add: (Triangle3D 
					with: 0.388288 , 0.199346 , -0.00425771
					with: 0.429806 , -0.327051 , -0.0508415
					with: 0.364396 , -0.204025 , -0.347344);
		add: (Triangle3D 
					with: 0.388288 , 0.199346 , -0.00425771
					with: 0.364396 , -0.204025 , -0.347344
					with: 0.338736 , 0.121306 , -0.318554);
		add: (Triangle3D 
					with: 0.388288 , 0.199346 , -0.00425771
					with: 0.338736 , 0.121306 , -0.318554
					with: 0.165124 , 0.362272 , -0.180271);
		add: (Triangle3D 
					with: 0.338736 , 0.121306 , -0.318554
					with: 0.364396 , -0.204025 , -0.347344
					with: 0.141232 , -0.0410991 , -0.523358);
		add: (Triangle3D 
					with: 0.165124 , 0.362272 , -0.180271
					with: 0.338736 , 0.121306 , -0.318554
					with: 0.141232 , -0.0410991 , -0.523358);
		add: (Triangle3D 
					with: 0.165124 , 0.362272 , -0.180271
					with: 0.141232 , -0.0410991 , -0.523358
					with: -0.154443 , 0.0994956 , -0.511652);
		add: (Triangle3D 
					with: 0.165124 , 0.362272 , -0.180271
					with: -0.154443 , 0.0994956 , -0.511652
					with: -0.139677 , 0.348793 , -0.299612);
		add: (Triangle3D 
					with: 0.165124 , 0.362272 , -0.180271
					with: -0.139677 , 0.348793 , -0.299612
					with: -0.0901248 , 0.426833 , 0.0146838);
		add: (Triangle3D 
					with: -0.139677 , 0.348793 , -0.299612
					with: -0.154443 , 0.0994956 , -0.511652
					with: -0.409692 , 0.164056 , -0.316696);
		add: (Triangle3D 
					with: -0.0901248 , 0.426833 , 0.0146838
					with: -0.139677 , 0.348793 , -0.299612
					with: -0.409692 , 0.164056 , -0.316696);
		add: (Triangle3D 
					with: -0.0901248 , 0.426833 , 0.0146838
					with: -0.409692 , 0.164056 , -0.316696
					with: -0.527019 , 0.127923 , -0.0129585);
		add: (Triangle3D 
					with: -0.0901248 , 0.426833 , 0.0146838
					with: -0.527019 , 0.127923 , -0.0129585
					with: -0.329515 , 0.290328 , 0.191846);
		add: (Triangle3D 
					with: -0.0901248 , 0.426833 , 0.0146838
					with: -0.329515 , 0.290328 , 0.191846
					with: -0.024714 , 0.303807 , 0.311187);
		add: (Triangle3D 
					with: -0.329515 , 0.290328 , 0.191846
					with: -0.527019 , 0.127923 , -0.0129585
					with: -0.461608 , 0.00489695 , 0.283544);
		add: (Triangle3D 
					with: -0.024714 , 0.303807 , 0.311187
					with: -0.329515 , 0.290328 , 0.191846
					with: -0.461608 , 0.00489695 , 0.283544);
		add: (Triangle3D 
					with: -0.024714 , 0.303807 , 0.311187
					with: -0.461608 , 0.00489695 , 0.283544
					with: -0.238445 , -0.158029 , 0.459558);
		add: (Triangle3D 
					with: -0.024714 , 0.303807 , 0.311187
					with: -0.238445 , -0.158029 , 0.459558
					with: 0.0315709 , 0.0267072 , 0.476642);
		add: (Triangle3D 
					with: -0.024714 , 0.303807 , 0.311187
					with: 0.0315709 , 0.0267072 , 0.476642
					with: 0.270961 , 0.163212 , 0.29948);
		add: (Triangle3D 
					with: 0.0315709 , 0.0267072 , 0.476642
					with: -0.238445 , -0.158029 , 0.459558
					with: 0.0572308 , -0.298624 , 0.447851);
		yourself! !

!Polyhedron class methodsFor: 'factory-pentagonal' stamp: 'emm 02/09/2012 23:40'!
pentagonalPrism
	"self pentagonalPrism  "

	^(Triangle3DComposite new)
		add: (Triangle3D 
					with: 0.309017 , -0.418556 , -0.309017
					with: -0.309017 , -0.418556 , -0.309017
					with: -0.5 , 0.169229 , -0.309017);
		add: (Triangle3D 
					with: 0.309017 , -0.418556 , -0.309017
					with: -0.5 , 0.169229 , -0.309017
					with: -0.00000000844197 , 0.5325 , -0.309017);
		add: (Triangle3D 
					with: 0.309017 , -0.418556 , -0.309017
					with: -0.00000000844197 , 0.5325 , -0.309017
					with: 0.5 , 0.169229 , -0.309017);
		add: (Triangle3D 
					with: -0.309017 , -0.418556 , 0.309017
					with: 0.309017 , -0.418556 , 0.309017
					with: 0.5 , 0.169229 , 0.309017);
		add: (Triangle3D 
					with: -0.309017 , -0.418556 , 0.309017
					with: 0.5 , 0.169229 , 0.309017
					with: -0.00000000844197 , 0.5325 , 0.309017);
		add: (Triangle3D 
					with: -0.309017 , -0.418556 , 0.309017
					with: -0.00000000844197 , 0.5325 , 0.309017
					with: -0.5 , 0.169229 , 0.309017);
		add: (Triangle3D 
					with: -0.00000000844197 , 0.5325 , 0.309017
					with: -0.00000000844197 , 0.5325 , -0.309017
					with: -0.5 , 0.169229 , -0.309017);
		add: (Triangle3D 
					with: -0.00000000844197 , 0.5325 , 0.309017
					with: -0.5 , 0.169229 , -0.309017
					with: -0.5 , 0.169229 , 0.309017);
		add: (Triangle3D 
					with: -0.5 , 0.169229 , 0.309017
					with: -0.5 , 0.169229 , -0.309017
					with: -0.309017 , -0.418556 , -0.309017);
		add: (Triangle3D 
					with: -0.5 , 0.169229 , 0.309017
					with: -0.309017 , -0.418556 , -0.309017
					with: -0.309017 , -0.418556 , 0.309017);
		add: (Triangle3D 
					with: -0.309017 , -0.418556 , 0.309017
					with: -0.309017 , -0.418556 , -0.309017
					with: 0.309017 , -0.418556 , -0.309017);
		add: (Triangle3D 
					with: -0.309017 , -0.418556 , 0.309017
					with: 0.309017 , -0.418556 , -0.309017
					with: 0.309017 , -0.418556 , 0.309017);
		add: (Triangle3D 
					with: 0.309017 , -0.418556 , 0.309017
					with: 0.309017 , -0.418556 , -0.309017
					with: 0.5 , 0.169229 , -0.309017);
		add: (Triangle3D 
					with: 0.309017 , -0.418556 , 0.309017
					with: 0.5 , 0.169229 , -0.309017
					with: 0.5 , 0.169229 , 0.309017);
		add: (Triangle3D 
					with: 0.5 , 0.169229 , 0.309017
					with: 0.5 , 0.169229 , -0.309017
					with: -0.00000000844197 , 0.5325 , -0.309017);
		add: (Triangle3D 
					with: 0.5 , 0.169229 , 0.309017
					with: -0.00000000844197 , 0.5325 , -0.309017
					with: -0.00000000844197 , 0.5325 , 0.309017);
		yourself! !

!Polyhedron class methodsFor: 'factory-pentagonal' stamp: 'emm 02/09/2012 23:40'!
pentagonalPyramid
	"self pentagonalPyramid"

	^(Triangle3DComposite new)
		add: (Triangle3D 
					with: -0.418293 , -0.0486095 , 0.312516
					with: -0.0526957 , -0.513273 , 0.122118
					with: 0.441581 , -0.265115 , -0.160607);
		add: (Triangle3D 
					with: -0.418293 , -0.0486095 , 0.312516
					with: 0.441581 , -0.265115 , -0.160607
					with: 0.381464 , 0.352919 , -0.144942);
		add: (Triangle3D 
					with: -0.418293 , -0.0486095 , 0.312516
					with: 0.381464 , 0.352919 , -0.144942
					with: -0.149968 , 0.486727 , 0.147464);
		add: (Triangle3D 
					with: -0.0526957 , -0.513273 , 0.122118
					with: -0.418293 , -0.0486095 , 0.312516
					with: -0.118545 , -0.00570581 , -0.229826);
		add: (Triangle3D 
					with: 0.441581 , -0.265115 , -0.160607
					with: -0.0526957 , -0.513273 , 0.122118
					with: -0.118545 , -0.00570581 , -0.229826);
		add: (Triangle3D 
					with: 0.381464 , 0.352919 , -0.144942
					with: 0.441581 , -0.265115 , -0.160607
					with: -0.118545 , -0.00570581 , -0.229826);
		add: (Triangle3D 
					with: -0.149968 , 0.486727 , 0.147464
					with: 0.381464 , 0.352919 , -0.144942
					with: -0.118545 , -0.00570581 , -0.229826);
		add: (Triangle3D 
					with: -0.418293 , -0.0486095 , 0.312516
					with: -0.149968 , 0.486727 , 0.147464
					with: -0.118545 , -0.00570581 , -0.229826);
		yourself! !

!Polyhedron class methodsFor: 'factory-pentagonal' stamp: 'emm 02/09/2012 23:40'!
pentagonalRotunda
	"self pentagonalRotunda"

	^(Triangle3DComposite new)
		add: (Triangle3D 
					with: -0.334929 , -0.415933 , -0.06679
					with: -0.426464 , -0.187948 , -0.278034
					with: -0.327015 , 0.0745068 , -0.439922);
		add: (Triangle3D 
					with: -0.334929 , -0.415933 , -0.06679
					with: -0.327015 , 0.0745068 , -0.439922
					with: -0.07457 , 0.271182 , -0.490617);
		add: (Triangle3D 
					with: -0.334929 , -0.415933 , -0.06679
					with: -0.07457 , 0.271182 , -0.490617
					with: 0.234447 , 0.326955 , -0.410756);
		add: (Triangle3D 
					with: -0.334929 , -0.415933 , -0.06679
					with: 0.234447 , 0.326955 , -0.410756
					with: 0.482002 , 0.220522 , -0.230843);
		add: (Triangle3D 
					with: -0.334929 , -0.415933 , -0.06679
					with: 0.482002 , 0.220522 , -0.230843
					with: 0.573536 , -0.00746285 , -0.0195983);
		add: (Triangle3D 
					with: -0.334929 , -0.415933 , -0.06679
					with: 0.573536 , -0.00746285 , -0.0195983
					with: 0.474088 , -0.269917 , 0.142289);
		add: (Triangle3D 
					with: -0.334929 , -0.415933 , -0.06679
					with: 0.474088 , -0.269917 , 0.142289
					with: 0.221643 , -0.466593 , 0.192984);
		add: (Triangle3D 
					with: -0.334929 , -0.415933 , -0.06679
					with: 0.221643 , -0.466593 , 0.192984
					with: -0.0873743 , -0.522366 , 0.113123);
		add: (Triangle3D 
					with: 0.0912327 , 0.0116597 , 0.363597
					with: 0.190681 , 0.274114 , 0.201709
					with: -0.0568736 , 0.380547 , 0.0217964);
		add: (Triangle3D 
					with: 0.0912327 , 0.0116597 , 0.363597
					with: -0.0568736 , 0.380547 , 0.0217964
					with: -0.309319 , 0.183872 , 0.0724914);
		add: (Triangle3D 
					with: 0.0912327 , 0.0116597 , 0.363597
					with: -0.309319 , 0.183872 , 0.0724914
					with: -0.217784 , -0.0441134 , 0.283736);
		add: (Triangle3D 
					with: 0.0912327 , 0.0116597 , 0.363597
					with: -0.014975 , -0.292569 , 0.32976
					with: 0.221643 , -0.466593 , 0.192984);
		add: (Triangle3D 
					with: 0.0912327 , 0.0116597 , 0.363597
					with: 0.221643 , -0.466593 , 0.192984
					with: 0.474088 , -0.269917 , 0.142289);
		add: (Triangle3D 
					with: 0.0912327 , 0.0116597 , 0.363597
					with: 0.474088 , -0.269917 , 0.142289
					with: 0.39349 , 0.0256589 , 0.247733);
		add: (Triangle3D 
					with: 0.0912327 , 0.0116597 , 0.363597
					with: 0.39349 , 0.0256589 , 0.247733
					with: 0.190681 , 0.274114 , 0.201709);
		add: (Triangle3D 
					with: 0.39349 , 0.0256589 , 0.247733
					with: 0.474088 , -0.269917 , 0.142289
					with: 0.573536 , -0.00746285 , -0.0195983);
		add: (Triangle3D 
					with: 0.190681 , 0.274114 , 0.201709
					with: 0.39349 , 0.0256589 , 0.247733
					with: 0.573536 , -0.00746285 , -0.0195983);
		add: (Triangle3D 
					with: 0.190681 , 0.274114 , 0.201709
					with: 0.573536 , -0.00746285 , -0.0195983
					with: 0.482002 , 0.220522 , -0.230843);
		add: (Triangle3D 
					with: 0.190681 , 0.274114 , 0.201709
					with: 0.482002 , 0.220522 , -0.230843
					with: 0.245384 , 0.394547 , -0.0940669);
		add: (Triangle3D 
					with: 0.190681 , 0.274114 , 0.201709
					with: 0.245384 , 0.394547 , -0.0940669
					with: -0.0568736 , 0.380547 , 0.0217964);
		add: (Triangle3D 
					with: 0.245384 , 0.394547 , -0.0940669
					with: 0.482002 , 0.220522 , -0.230843
					with: 0.234447 , 0.326955 , -0.410756);
		add: (Triangle3D 
					with: -0.0568736 , 0.380547 , 0.0217964
					with: 0.245384 , 0.394547 , -0.0940669
					with: 0.234447 , 0.326955 , -0.410756);
		add: (Triangle3D 
					with: -0.0568736 , 0.380547 , 0.0217964
					with: 0.234447 , 0.326955 , -0.410756
					with: -0.07457 , 0.271182 , -0.490617);
		add: (Triangle3D 
					with: -0.0568736 , 0.380547 , 0.0217964
					with: -0.07457 , 0.271182 , -0.490617
					with: -0.254616 , 0.304304 , -0.223285);
		add: (Triangle3D 
					with: -0.0568736 , 0.380547 , 0.0217964
					with: -0.254616 , 0.304304 , -0.223285
					with: -0.309319 , 0.183872 , 0.0724914);
		add: (Triangle3D 
					with: -0.254616 , 0.304304 , -0.223285
					with: -0.07457 , 0.271182 , -0.490617
					with: -0.327015 , 0.0745068 , -0.439922);
		add: (Triangle3D 
					with: -0.309319 , 0.183872 , 0.0724914
					with: -0.254616 , 0.304304 , -0.223285
					with: -0.327015 , 0.0745068 , -0.439922);
		add: (Triangle3D 
					with: -0.309319 , 0.183872 , 0.0724914
					with: -0.327015 , 0.0745068 , -0.439922
					with: -0.426464 , -0.187948 , -0.278034);
		add: (Triangle3D 
					with: -0.309319 , 0.183872 , 0.0724914
					with: -0.426464 , -0.187948 , -0.278034
					with: -0.415527 , -0.120357 , 0.0386544);
		add: (Triangle3D 
					with: -0.309319 , 0.183872 , 0.0724914
					with: -0.415527 , -0.120357 , 0.0386544
					with: -0.217784 , -0.0441134 , 0.283736);
		add: (Triangle3D 
					with: -0.415527 , -0.120357 , 0.0386544
					with: -0.426464 , -0.187948 , -0.278034
					with: -0.334929 , -0.415933 , -0.06679);
		add: (Triangle3D 
					with: -0.217784 , -0.0441134 , 0.283736
					with: -0.415527 , -0.120357 , 0.0386544
					with: -0.334929 , -0.415933 , -0.06679);
		add: (Triangle3D 
					with: -0.217784 , -0.0441134 , 0.283736
					with: -0.334929 , -0.415933 , -0.06679
					with: -0.0873743 , -0.522366 , 0.113123);
		add: (Triangle3D 
					with: -0.217784 , -0.0441134 , 0.283736
					with: -0.0873743 , -0.522366 , 0.113123
					with: -0.014975 , -0.292569 , 0.32976);
		add: (Triangle3D 
					with: -0.217784 , -0.0441134 , 0.283736
					with: -0.014975 , -0.292569 , 0.32976
					with: 0.0912327 , 0.0116597 , 0.363597);
		add: (Triangle3D 
					with: -0.014975 , -0.292569 , 0.32976
					with: -0.0873743 , -0.522366 , 0.113123
					with: 0.221643 , -0.466593 , 0.192984);
		yourself! !

!Polyhedron class methodsFor: 'factory-pentagonal' stamp: 'emm 02/09/2012 23:40'!
pentakisDodecahedron
	"self pentakisDodecahedron"

	^(Triangle3DComposite new)
		add: (Triangle3D 
					with: 0.0660019 , -0.241343 , -0.432308
					with: 0.340714 , -0.278277 , -0.263406
					with: 0.0344727 , -0.469379 , -0.203475);
		add: (Triangle3D 
					with: 0.0660019 , -0.241343 , -0.432308
					with: 0.0344727 , -0.469379 , -0.203475
					with: -0.245003 , -0.283887 , -0.349698);
		add: (Triangle3D 
					with: 0.0660019 , -0.241343 , -0.432308
					with: -0.245003 , -0.283887 , -0.349698
					with: -0.111488 , 0.0218557 , -0.5);
		add: (Triangle3D 
					with: 0.0660019 , -0.241343 , -0.432308
					with: -0.111488 , 0.0218557 , -0.5
					with: 0.250506 , 0.0253225 , -0.446669);
		add: (Triangle3D 
					with: 0.0660019 , -0.241343 , -0.432308
					with: 0.250506 , 0.0253225 , -0.446669
					with: 0.340714 , -0.278277 , -0.263406);
		add: (Triangle3D 
					with: 0.266811 , -0.421871 , 0.0181567
					with: 0.0344727 , -0.469379 , -0.203475
					with: 0.340714 , -0.278277 , -0.263406);
		add: (Triangle3D 
					with: 0.266811 , -0.421871 , 0.0181567
					with: 0.340714 , -0.278277 , -0.263406
					with: 0.476882 , -0.17819 , 0.0611497);
		add: (Triangle3D 
					with: 0.266811 , -0.421871 , 0.0181567
					with: 0.476882 , -0.17819 , 0.0611497
					with: 0.254796 , -0.307435 , 0.321667);
		add: (Triangle3D 
					with: 0.266811 , -0.421871 , 0.0181567
					with: 0.254796 , -0.307435 , 0.321667
					with: -0.0186274 , -0.487399 , 0.15812);
		add: (Triangle3D 
					with: 0.266811 , -0.421871 , 0.0181567
					with: -0.0186274 , -0.487399 , 0.15812
					with: 0.0344727 , -0.469379 , -0.203475);
		add: (Triangle3D 
					with: -0.252755 , -0.426847 , -0.0583895
					with: -0.245003 , -0.283887 , -0.349698
					with: 0.0344727 , -0.469379 , -0.203475);
		add: (Triangle3D 
					with: -0.252755 , -0.426847 , -0.0583895
					with: 0.0344727 , -0.469379 , -0.203475
					with: -0.0186274 , -0.487399 , 0.15812);
		add: (Triangle3D 
					with: -0.252755 , -0.426847 , -0.0583895
					with: -0.0186274 , -0.487399 , 0.15812
					with: -0.330921 , -0.313044 , 0.235375);
		add: (Triangle3D 
					with: -0.252755 , -0.426847 , -0.0583895
					with: -0.330921 , -0.313044 , 0.235375
					with: -0.470829 , -0.187267 , -0.0784739);
		add: (Triangle3D 
					with: -0.252755 , -0.426847 , -0.0583895
					with: -0.470829 , -0.187267 , -0.0784739
					with: -0.245003 , -0.283887 , -0.349698);
		add: (Triangle3D 
					with: -0.38223 , 0.00890663 , -0.321424
					with: -0.111488 , 0.0218557 , -0.5
					with: -0.245003 , -0.283887 , -0.349698);
		add: (Triangle3D 
					with: -0.38223 , 0.00890663 , -0.321424
					with: -0.245003 , -0.283887 , -0.349698
					with: -0.470829 , -0.187267 , -0.0784739);
		add: (Triangle3D 
					with: -0.38223 , 0.00890663 , -0.321424
					with: -0.470829 , -0.187267 , -0.0784739
					with: -0.476882 , 0.17819 , -0.0611495);
		add: (Triangle3D 
					with: -0.38223 , 0.00890663 , -0.321424
					with: -0.476882 , 0.17819 , -0.0611495
					with: -0.254796 , 0.307435 , -0.321667);
		add: (Triangle3D 
					with: -0.38223 , 0.00890663 , -0.321424
					with: -0.254796 , 0.307435 , -0.321667
					with: -0.111488 , 0.0218557 , -0.5);
		add: (Triangle3D 
					with: 0.057315 , 0.283193 , -0.407442
					with: 0.250506 , 0.0253225 , -0.446669
					with: -0.111488 , 0.0218557 , -0.5);
		add: (Triangle3D 
					with: 0.057315 , 0.283193 , -0.407442
					with: -0.111488 , 0.0218557 , -0.5
					with: -0.254796 , 0.307435 , -0.321667);
		add: (Triangle3D 
					with: 0.057315 , 0.283193 , -0.407442
					with: -0.254796 , 0.307435 , -0.321667
					with: 0.0186274 , 0.4874 , -0.15812);
		add: (Triangle3D 
					with: 0.057315 , 0.283193 , -0.407442
					with: 0.0186274 , 0.4874 , -0.15812
					with: 0.330921 , 0.313044 , -0.235375);
		add: (Triangle3D 
					with: 0.057315 , 0.283193 , -0.407442
					with: 0.330921 , 0.313044 , -0.235375
					with: 0.250506 , 0.0253225 , -0.446669);
		add: (Triangle3D 
					with: 0.458444 , 0.016958 , -0.19757
					with: 0.340714 , -0.278277 , -0.263406
					with: 0.250506 , 0.0253225 , -0.446669);
		add: (Triangle3D 
					with: 0.458444 , 0.016958 , -0.19757
					with: 0.250506 , 0.0253225 , -0.446669
					with: 0.330921 , 0.313044 , -0.235375);
		add: (Triangle3D 
					with: 0.458444 , 0.016958 , -0.19757
					with: 0.330921 , 0.313044 , -0.235375
					with: 0.470829 , 0.187267 , 0.0784737);
		add: (Triangle3D 
					with: 0.458444 , 0.016958 , -0.19757
					with: 0.470829 , 0.187267 , 0.0784737
					with: 0.476882 , -0.17819 , 0.0611497);
		add: (Triangle3D 
					with: 0.458444 , 0.016958 , -0.19757
					with: 0.476882 , -0.17819 , 0.0611497
					with: 0.340714 , -0.278277 , -0.263406);
		add: (Triangle3D 
					with: 0.252755 , 0.426847 , 0.0583893
					with: -0.0344727 , 0.469379 , 0.203475
					with: 0.245003 , 0.283887 , 0.349698);
		add: (Triangle3D 
					with: 0.252755 , 0.426847 , 0.0583893
					with: 0.245003 , 0.283887 , 0.349698
					with: 0.470829 , 0.187267 , 0.0784737);
		add: (Triangle3D 
					with: 0.252755 , 0.426847 , 0.0583893
					with: 0.470829 , 0.187267 , 0.0784737
					with: 0.330921 , 0.313044 , -0.235375);
		add: (Triangle3D 
					with: 0.252755 , 0.426847 , 0.0583893
					with: 0.330921 , 0.313044 , -0.235375
					with: 0.0186274 , 0.4874 , -0.15812);
		add: (Triangle3D 
					with: 0.252755 , 0.426847 , 0.0583893
					with: 0.0186274 , 0.4874 , -0.15812
					with: -0.0344727 , 0.469379 , 0.203475);
		add: (Triangle3D 
					with: -0.266811 , 0.421871 , -0.0181565
					with: -0.340714 , 0.278277 , 0.263406
					with: -0.0344727 , 0.469379 , 0.203475);
		add: (Triangle3D 
					with: -0.266811 , 0.421871 , -0.0181565
					with: -0.0344727 , 0.469379 , 0.203475
					with: 0.0186274 , 0.4874 , -0.15812);
		add: (Triangle3D 
					with: -0.266811 , 0.421871 , -0.0181565
					with: 0.0186274 , 0.4874 , -0.15812
					with: -0.254796 , 0.307435 , -0.321667);
		add: (Triangle3D 
					with: -0.266811 , 0.421871 , -0.0181565
					with: -0.254796 , 0.307435 , -0.321667
					with: -0.476882 , 0.17819 , -0.0611495);
		add: (Triangle3D 
					with: -0.266811 , 0.421871 , -0.0181565
					with: -0.476882 , 0.17819 , -0.0611495
					with: -0.340714 , 0.278277 , 0.263406);
		add: (Triangle3D 
					with: -0.458444 , -0.016958 , 0.19757
					with: -0.250506 , -0.0253226 , 0.446669
					with: -0.340714 , 0.278277 , 0.263406);
		add: (Triangle3D 
					with: -0.458444 , -0.016958 , 0.19757
					with: -0.340714 , 0.278277 , 0.263406
					with: -0.476882 , 0.17819 , -0.0611495);
		add: (Triangle3D 
					with: -0.458444 , -0.016958 , 0.19757
					with: -0.476882 , 0.17819 , -0.0611495
					with: -0.470829 , -0.187267 , -0.0784739);
		add: (Triangle3D 
					with: -0.458444 , -0.016958 , 0.19757
					with: -0.470829 , -0.187267 , -0.0784739
					with: -0.330921 , -0.313044 , 0.235375);
		add: (Triangle3D 
					with: -0.458444 , -0.016958 , 0.19757
					with: -0.330921 , -0.313044 , 0.235375
					with: -0.250506 , -0.0253226 , 0.446669);
		add: (Triangle3D 
					with: -0.057315 , -0.283193 , 0.407442
					with: 0.111488 , -0.0218556 , 0.5
					with: -0.250506 , -0.0253226 , 0.446669);
		add: (Triangle3D 
					with: -0.057315 , -0.283193 , 0.407442
					with: -0.250506 , -0.0253226 , 0.446669
					with: -0.330921 , -0.313044 , 0.235375);
		add: (Triangle3D 
					with: -0.057315 , -0.283193 , 0.407442
					with: -0.330921 , -0.313044 , 0.235375
					with: -0.0186274 , -0.487399 , 0.15812);
		add: (Triangle3D 
					with: -0.057315 , -0.283193 , 0.407442
					with: -0.0186274 , -0.487399 , 0.15812
					with: 0.254796 , -0.307435 , 0.321667);
		add: (Triangle3D 
					with: -0.057315 , -0.283193 , 0.407442
					with: 0.254796 , -0.307435 , 0.321667
					with: 0.111488 , -0.0218556 , 0.5);
		add: (Triangle3D 
					with: 0.38223 , -0.00890669 , 0.321424
					with: 0.245003 , 0.283887 , 0.349698
					with: 0.111488 , -0.0218556 , 0.5);
		add: (Triangle3D 
					with: 0.38223 , -0.00890669 , 0.321424
					with: 0.111488 , -0.0218556 , 0.5
					with: 0.254796 , -0.307435 , 0.321667);
		add: (Triangle3D 
					with: 0.38223 , -0.00890669 , 0.321424
					with: 0.254796 , -0.307435 , 0.321667
					with: 0.476882 , -0.17819 , 0.0611497);
		add: (Triangle3D 
					with: 0.38223 , -0.00890669 , 0.321424
					with: 0.476882 , -0.17819 , 0.0611497
					with: 0.470829 , 0.187267 , 0.0784737);
		add: (Triangle3D 
					with: 0.38223 , -0.00890669 , 0.321424
					with: 0.470829 , 0.187267 , 0.0784737
					with: 0.245003 , 0.283887 , 0.349698);
		add: (Triangle3D 
					with: -0.0660019 , 0.241343 , 0.432308
					with: 0.245003 , 0.283887 , 0.349698
					with: -0.0344727 , 0.469379 , 0.203475);
		add: (Triangle3D 
					with: -0.0660019 , 0.241343 , 0.432308
					with: -0.0344727 , 0.469379 , 0.203475
					with: -0.340714 , 0.278277 , 0.263406);
		add: (Triangle3D 
					with: -0.0660019 , 0.241343 , 0.432308
					with: -0.340714 , 0.278277 , 0.263406
					with: -0.250506 , -0.0253226 , 0.446669);
		add: (Triangle3D 
					with: -0.0660019 , 0.241343 , 0.432308
					with: -0.250506 , -0.0253226 , 0.446669
					with: 0.111488 , -0.0218556 , 0.5);
		add: (Triangle3D 
					with: -0.0660019 , 0.241343 , 0.432308
					with: 0.111488 , -0.0218556 , 0.5
					with: 0.245003 , 0.283887 , 0.349698);
		yourself! !

!Polyhedron class methodsFor: 'factory-dodecahedron' stamp: 'emm 02/09/2012 23:40'!
rhombicDodecahedron
	"self rhombicDodecahedron"

	^(Triangle3DComposite new)
		add: (Triangle3D 
					with: 0.353553 , 0.0049678 , 0.353588
					with: 0.350041 , 0.254968 , -3.97516e-13
					with: -0.00702544 , 0.5 , -3.97516e-13);
		add: (Triangle3D 
					with: 0.353553 , 0.0049678 , 0.353588
					with: -0.00702544 , 0.5 , -3.97516e-13
					with: -0.00351272 , 0.25 , 0.353588);
		add: (Triangle3D 
					with: 0.353553 , 0.0049678 , -0.353588
					with: -0.00351272 , 0.25 , -0.353588
					with: -0.00702544 , 0.5 , -3.97516e-13);
		add: (Triangle3D 
					with: 0.353553 , 0.0049678 , -0.353588
					with: -0.00702544 , 0.5 , -3.97516e-13
					with: 0.350041 , 0.254968 , -3.97516e-13);
		add: (Triangle3D 
					with: 0.353553 , 0.0049678 , -0.353588
					with: 0.350041 , 0.254968 , -3.97516e-13
					with: 0.353553 , 0.0049678 , 0.353588);
		add: (Triangle3D 
					with: 0.353553 , 0.0049678 , -0.353588
					with: 0.353553 , 0.0049678 , 0.353588
					with: 0.357066 , -0.245032 , -3.97516e-13);
		add: (Triangle3D 
					with: 0.00702544 , -0.5 , -3.97516e-13
					with: 0.357066 , -0.245032 , -3.97516e-13
					with: 0.353553 , 0.0049678 , 0.353588);
		add: (Triangle3D 
					with: 0.00702544 , -0.5 , -3.97516e-13
					with: 0.353553 , 0.0049678 , 0.353588
					with: 0.00351272 , -0.25 , 0.353588);
		add: (Triangle3D 
					with: 0.353553 , 0.0049678 , -0.353588
					with: 0.357066 , -0.245032 , -3.97516e-13
					with: 0.00702544 , -0.5 , -3.97516e-13);
		add: (Triangle3D 
					with: 0.353553 , 0.0049678 , -0.353588
					with: 0.00702544 , -0.5 , -3.97516e-13
					with: 0.00351272 , -0.25 , -0.353588);
		add: (Triangle3D 
					with: -0.353553 , -0.0049678 , -0.353588
					with: -0.00351272 , 0.25 , -0.353588
					with: 0.353553 , 0.0049678 , -0.353588);
		add: (Triangle3D 
					with: -0.353553 , -0.0049678 , -0.353588
					with: 0.353553 , 0.0049678 , -0.353588
					with: 0.00351272 , -0.25 , -0.353588);
		add: (Triangle3D 
					with: -0.353553 , -0.0049678 , -0.353588
					with: 0.00351272 , -0.25 , -0.353588
					with: 0.00702544 , -0.5 , -3.97516e-13);
		add: (Triangle3D 
					with: -0.353553 , -0.0049678 , -0.353588
					with: 0.00702544 , -0.5 , -3.97516e-13
					with: -0.350041 , -0.254968 , -3.97516e-13);
		add: (Triangle3D 
					with: -0.353553 , -0.0049678 , 0.353588
					with: -0.350041 , -0.254968 , -3.97516e-13
					with: 0.00702544 , -0.5 , -3.97516e-13);
		add: (Triangle3D 
					with: -0.353553 , -0.0049678 , 0.353588
					with: 0.00702544 , -0.5 , -3.97516e-13
					with: 0.00351272 , -0.25 , 0.353588);
		add: (Triangle3D 
					with: -0.353553 , -0.0049678 , -0.353588
					with: -0.350041 , -0.254968 , -3.97516e-13
					with: -0.353553 , -0.0049678 , 0.353588);
		add: (Triangle3D 
					with: -0.353553 , -0.0049678 , -0.353588
					with: -0.353553 , -0.0049678 , 0.353588
					with: -0.357066 , 0.245032 , -3.97516e-13);
		add: (Triangle3D 
					with: -0.00702544 , 0.5 , -3.97516e-13
					with: -0.00351272 , 0.25 , -0.353588
					with: -0.353553 , -0.0049678 , -0.353588);
		add: (Triangle3D 
					with: -0.00702544 , 0.5 , -3.97516e-13
					with: -0.353553 , -0.0049678 , -0.353588
					with: -0.357066 , 0.245032 , -3.97516e-13);
		add: (Triangle3D 
					with: -0.00702544 , 0.5 , -3.97516e-13
					with: -0.357066 , 0.245032 , -3.97516e-13
					with: -0.353553 , -0.0049678 , 0.353588);
		add: (Triangle3D 
					with: -0.00702544 , 0.5 , -3.97516e-13
					with: -0.353553 , -0.0049678 , 0.353588
					with: -0.00351272 , 0.25 , 0.353588);
		add: (Triangle3D 
					with: 0.353553 , 0.0049678 , 0.353588
					with: -0.00351272 , 0.25 , 0.353588
					with: -0.353553 , -0.0049678 , 0.353588);
		add: (Triangle3D 
					with: 0.353553 , 0.0049678 , 0.353588
					with: -0.353553 , -0.0049678 , 0.353588
					with: 0.00351272 , -0.25 , 0.353588);
		yourself! !

!Polyhedron class methodsFor: 'factory' stamp: 'emm 02/09/2012 23:40'!
rhombicTriacontahedron
	"self rhombicTriacontahedron"

	^(Triangle3DComposite new)
		add: (Triangle3D 
					with: -0.029744 , 0.5 , 0.0181012
					with: 0.0997207 , 0.378016 , -0.235499
					with: -0.0910079 , 0.234963 , -0.433269);
		add: (Triangle3D 
					with: -0.029744 , 0.5 , 0.0181012
					with: -0.0910079 , 0.234963 , -0.433269
					with: -0.220473 , 0.356947 , -0.179669);
		add: (Triangle3D 
					with: -0.0910079 , 0.234963 , -0.433269
					with: -0.326988 , 0.0775522 , -0.308811
					with: -0.456453 , 0.199536 , -0.0552108);
		add: (Triangle3D 
					with: -0.0910079 , 0.234963 , -0.433269
					with: -0.456453 , 0.199536 , -0.0552108
					with: -0.220473 , 0.356947 , -0.179669);
		add: (Triangle3D 
					with: -0.0910079 , 0.234963 , -0.433269
					with: -0.072625 , -0.0740544 , -0.444457
					with: -0.308605 , -0.231465 , -0.319999);
		add: (Triangle3D 
					with: -0.0910079 , 0.234963 , -0.433269
					with: -0.308605 , -0.231465 , -0.319999
					with: -0.326988 , 0.0775522 , -0.308811);
		add: (Triangle3D 
					with: -0.456453 , 0.199536 , -0.0552108
					with: -0.326988 , 0.0775522 , -0.308811
					with: -0.308605 , -0.231465 , -0.319999);
		add: (Triangle3D 
					with: -0.456453 , 0.199536 , -0.0552108
					with: -0.308605 , -0.231465 , -0.319999
					with: -0.43807 , -0.109481 , -0.066398);
		add: (Triangle3D 
					with: -0.308605 , -0.231465 , -0.319999
					with: -0.252359 , -0.37668 , -0.0522234
					with: -0.381824 , -0.254695 , 0.201377);
		add: (Triangle3D 
					with: -0.308605 , -0.231465 , -0.319999
					with: -0.381824 , -0.254695 , 0.201377
					with: -0.43807 , -0.109481 , -0.066398);
		add: (Triangle3D 
					with: -0.308605 , -0.231465 , -0.319999
					with: -0.0265019 , -0.354785 , -0.285876
					with: 0.029744 , -0.5 , -0.0181012);
		add: (Triangle3D 
					with: -0.308605 , -0.231465 , -0.319999
					with: 0.029744 , -0.5 , -0.0181012
					with: -0.252359 , -0.37668 , -0.0522234);
		add: (Triangle3D 
					with: -0.029744 , 0.5 , 0.0181012
					with: -0.220473 , 0.356947 , -0.179669
					with: -0.456453 , 0.199536 , -0.0552108);
		add: (Triangle3D 
					with: -0.029744 , 0.5 , 0.0181012
					with: -0.456453 , 0.199536 , -0.0552108
					with: -0.265724 , 0.342589 , 0.142559);
		add: (Triangle3D 
					with: -0.456453 , 0.199536 , -0.0552108
					with: -0.400207 , 0.0543215 , 0.212564
					with: -0.209478 , 0.197375 , 0.410334);
		add: (Triangle3D 
					with: -0.456453 , 0.199536 , -0.0552108
					with: -0.209478 , 0.197375 , 0.410334
					with: -0.265724 , 0.342589 , 0.142559);
		add: (Triangle3D 
					with: -0.456453 , 0.199536 , -0.0552108
					with: -0.43807 , -0.109481 , -0.066398
					with: -0.381824 , -0.254695 , 0.201377);
		add: (Triangle3D 
					with: -0.456453 , 0.199536 , -0.0552108
					with: -0.381824 , -0.254695 , 0.201377
					with: -0.400207 , 0.0543215 , 0.212564);
		add: (Triangle3D 
					with: -0.209478 , 0.197375 , 0.410334
					with: -0.400207 , 0.0543215 , 0.212564
					with: -0.381824 , -0.254695 , 0.201377);
		add: (Triangle3D 
					with: -0.209478 , 0.197375 , 0.410334
					with: -0.381824 , -0.254695 , 0.201377
					with: -0.191096 , -0.111642 , 0.399147);
		add: (Triangle3D 
					with: -0.381824 , -0.254695 , 0.201377
					with: -0.0997207 , -0.378016 , 0.235499
					with: 0.0910078 , -0.234963 , 0.433269);
		add: (Triangle3D 
					with: -0.381824 , -0.254695 , 0.201377
					with: 0.0910078 , -0.234963 , 0.433269
					with: -0.191096 , -0.111642 , 0.399147);
		add: (Triangle3D 
					with: -0.381824 , -0.254695 , 0.201377
					with: -0.252359 , -0.37668 , -0.0522234
					with: 0.029744 , -0.5 , -0.0181012);
		add: (Triangle3D 
					with: -0.381824 , -0.254695 , 0.201377
					with: 0.029744 , -0.5 , -0.0181012
					with: -0.0997207 , -0.378016 , 0.235499);
		add: (Triangle3D 
					with: -0.029744 , 0.5 , 0.0181012
					with: -0.265724 , 0.342589 , 0.142559
					with: -0.209478 , 0.197375 , 0.410334);
		add: (Triangle3D 
					with: -0.029744 , 0.5 , 0.0181012
					with: -0.209478 , 0.197375 , 0.410334
					with: 0.0265019 , 0.354785 , 0.285876);
		add: (Triangle3D 
					with: -0.209478 , 0.197375 , 0.410334
					with: 0.072625 , 0.0740543 , 0.444457
					with: 0.308605 , 0.231465 , 0.319999);
		add: (Triangle3D 
					with: -0.209478 , 0.197375 , 0.410334
					with: 0.308605 , 0.231465 , 0.319999
					with: 0.0265019 , 0.354785 , 0.285876);
		add: (Triangle3D 
					with: -0.209478 , 0.197375 , 0.410334
					with: -0.191096 , -0.111642 , 0.399147
					with: 0.0910078 , -0.234963 , 0.433269);
		add: (Triangle3D 
					with: -0.209478 , 0.197375 , 0.410334
					with: 0.0910078 , -0.234963 , 0.433269
					with: 0.072625 , 0.0740543 , 0.444457);
		add: (Triangle3D 
					with: 0.308605 , 0.231465 , 0.319999
					with: 0.072625 , 0.0740543 , 0.444457
					with: 0.0910078 , -0.234963 , 0.433269);
		add: (Triangle3D 
					with: 0.308605 , 0.231465 , 0.319999
					with: 0.0910078 , -0.234963 , 0.433269
					with: 0.326988 , -0.0775522 , 0.308811);
		add: (Triangle3D 
					with: 0.0910078 , -0.234963 , 0.433269
					with: 0.220473 , -0.356947 , 0.179669
					with: 0.456453 , -0.199536 , 0.0552108);
		add: (Triangle3D 
					with: 0.0910078 , -0.234963 , 0.433269
					with: 0.456453 , -0.199536 , 0.0552108
					with: 0.326988 , -0.0775522 , 0.308811);
		add: (Triangle3D 
					with: 0.0910078 , -0.234963 , 0.433269
					with: -0.0997207 , -0.378016 , 0.235499
					with: 0.029744 , -0.5 , -0.0181012);
		add: (Triangle3D 
					with: 0.0910078 , -0.234963 , 0.433269
					with: 0.029744 , -0.5 , -0.0181012
					with: 0.220473 , -0.356947 , 0.179669);
		add: (Triangle3D 
					with: -0.029744 , 0.5 , 0.0181012
					with: 0.0265019 , 0.354785 , 0.285876
					with: 0.308605 , 0.231465 , 0.319999);
		add: (Triangle3D 
					with: -0.029744 , 0.5 , 0.0181012
					with: 0.308605 , 0.231465 , 0.319999
					with: 0.252359 , 0.37668 , 0.0522233);
		add: (Triangle3D 
					with: 0.308605 , 0.231465 , 0.319999
					with: 0.43807 , 0.109481 , 0.066398
					with: 0.381824 , 0.254696 , -0.201377);
		add: (Triangle3D 
					with: 0.308605 , 0.231465 , 0.319999
					with: 0.381824 , 0.254696 , -0.201377
					with: 0.252359 , 0.37668 , 0.0522233);
		add: (Triangle3D 
					with: 0.308605 , 0.231465 , 0.319999
					with: 0.326988 , -0.0775522 , 0.308811
					with: 0.456453 , -0.199536 , 0.0552108);
		add: (Triangle3D 
					with: 0.308605 , 0.231465 , 0.319999
					with: 0.456453 , -0.199536 , 0.0552108
					with: 0.43807 , 0.109481 , 0.066398);
		add: (Triangle3D 
					with: 0.381824 , 0.254696 , -0.201377
					with: 0.43807 , 0.109481 , 0.066398
					with: 0.456453 , -0.199536 , 0.0552108);
		add: (Triangle3D 
					with: 0.381824 , 0.254696 , -0.201377
					with: 0.456453 , -0.199536 , 0.0552108
					with: 0.400207 , -0.0543215 , -0.212565);
		add: (Triangle3D 
					with: 0.456453 , -0.199536 , 0.0552108
					with: 0.265724 , -0.342589 , -0.142559
					with: 0.209478 , -0.197375 , -0.410334);
		add: (Triangle3D 
					with: 0.456453 , -0.199536 , 0.0552108
					with: 0.209478 , -0.197375 , -0.410334
					with: 0.400207 , -0.0543215 , -0.212565);
		add: (Triangle3D 
					with: 0.456453 , -0.199536 , 0.0552108
					with: 0.220473 , -0.356947 , 0.179669
					with: 0.029744 , -0.5 , -0.0181012);
		add: (Triangle3D 
					with: 0.456453 , -0.199536 , 0.0552108
					with: 0.029744 , -0.5 , -0.0181012
					with: 0.265724 , -0.342589 , -0.142559);
		add: (Triangle3D 
					with: -0.029744 , 0.5 , 0.0181012
					with: 0.252359 , 0.37668 , 0.0522233
					with: 0.381824 , 0.254696 , -0.201377);
		add: (Triangle3D 
					with: -0.029744 , 0.5 , 0.0181012
					with: 0.381824 , 0.254696 , -0.201377
					with: 0.0997207 , 0.378016 , -0.235499);
		add: (Triangle3D 
					with: 0.381824 , 0.254696 , -0.201377
					with: 0.191096 , 0.111642 , -0.399147
					with: -0.0910079 , 0.234963 , -0.433269);
		add: (Triangle3D 
					with: 0.381824 , 0.254696 , -0.201377
					with: -0.0910079 , 0.234963 , -0.433269
					with: 0.0997207 , 0.378016 , -0.235499);
		add: (Triangle3D 
					with: 0.381824 , 0.254696 , -0.201377
					with: 0.400207 , -0.0543215 , -0.212565
					with: 0.209478 , -0.197375 , -0.410334);
		add: (Triangle3D 
					with: 0.381824 , 0.254696 , -0.201377
					with: 0.209478 , -0.197375 , -0.410334
					with: 0.191096 , 0.111642 , -0.399147);
		add: (Triangle3D 
					with: -0.0910079 , 0.234963 , -0.433269
					with: 0.191096 , 0.111642 , -0.399147
					with: 0.209478 , -0.197375 , -0.410334);
		add: (Triangle3D 
					with: -0.0910079 , 0.234963 , -0.433269
					with: 0.209478 , -0.197375 , -0.410334
					with: -0.072625 , -0.0740544 , -0.444457);
		add: (Triangle3D 
					with: 0.209478 , -0.197375 , -0.410334
					with: -0.0265019 , -0.354785 , -0.285876
					with: -0.308605 , -0.231465 , -0.319999);
		add: (Triangle3D 
					with: 0.209478 , -0.197375 , -0.410334
					with: -0.308605 , -0.231465 , -0.319999
					with: -0.072625 , -0.0740544 , -0.444457);
		add: (Triangle3D 
					with: 0.209478 , -0.197375 , -0.410334
					with: 0.265724 , -0.342589 , -0.142559
					with: 0.029744 , -0.5 , -0.0181012);
		add: (Triangle3D 
					with: 0.209478 , -0.197375 , -0.410334
					with: 0.029744 , -0.5 , -0.0181012
					with: -0.0265019 , -0.354785 , -0.285876);
		yourself! !

!Polyhedron class methodsFor: 'factory-dodecahedron' stamp: 'emm 02/09/2012 23:40'!
smallDitrigonalIcosidodecahedron
	"self smallDitrigonalIcosidodecahedron"

	^(Triangle3DComposite new)
		addTriangleWith: 0.367797 , 0.177896 , 0.0979039
			with: 0.501538 , 0.0664585 , -0.0415585
			with: 0.351011 , 0.23054 , -0.0283944;
		addTriangleWith: 0.394958 , 0.0927142 , 0.302259
			with: 0.367797 , 0.177896 , 0.0979039
			with: 0.351011 , 0.23054 , -0.0283944;
		addTriangleWith: 0.394958 , 0.0927142 , 0.302259
			with: 0.351011 , 0.23054 , -0.0283944
			with: 0.32385 , 0.315722 , -0.232749;
		addTriangleWith: 0.394958 , 0.0927142 , 0.302259
			with: 0.32385 , 0.315722 , -0.232749
			with: 0.25798 , 0.331949 , -0.0202585;
		addTriangleWith: 0.394958 , 0.0927142 , 0.302259
			with: 0.25798 , 0.331949 , -0.0202585
			with: 0.107454 , 0.496031 , -0.0070943;
		addTriangleWith: 0.217271 , 0.341978 , 0.111068
			with: 0.151401 , 0.358205 , 0.323559
			with: 0.285141 , 0.246767 , 0.184096;
		addTriangleWith: 0.107454 , 0.496031 , -0.0070943
			with: 0.217271 , 0.341978 , 0.111068
			with: 0.285141 , 0.246767 , 0.184096;
		addTriangleWith: 0.394958 , 0.0927142 , 0.302259
			with: 0.107454 , 0.496031 , -0.0070943
			with: 0.285141 , 0.246767 , 0.184096;
		addTriangleWith: 0.367797 , 0.177896 , 0.0979039
			with: 0.394958 , 0.0927142 , 0.302259
			with: 0.39835 , -0.0414973 , 0.124129;
		addTriangleWith: 0.351011 , 0.23054 , -0.0283944
			with: 0.501538 , 0.0664585 , -0.0415585
			with: 0.354403 , 0.0963289 , -0.206524;
		addTriangleWith: 0.25798 , 0.331949 , -0.0202585
			with: 0.32385 , 0.315722 , -0.232749
			with: 0.110846 , 0.361819 , -0.185224;
		addTriangleWith: 0.217271 , 0.341978 , 0.111068
			with: 0.107454 , 0.496031 , -0.0070943
			with: 0.00426627 , 0.388075 , 0.158593;
		addTriangleWith: 0.285141 , 0.246767 , 0.184096
			with: 0.151401 , 0.358205 , 0.323559
			with: 0.181954 , 0.138812 , 0.349784;
		addTriangleWith: 0.39835 , -0.0414973 , 0.124129
			with: 0.394958 , 0.0927142 , 0.302259
			with: 0.334577 , -0.108218 , 0.226529;
		addTriangleWith: 0.501538 , 0.0664585 , -0.0415585
			with: 0.39835 , -0.0414973 , 0.124129
			with: 0.334577 , -0.108218 , 0.226529;
		addTriangleWith: 0.334577 , -0.108218 , 0.226529
			with: 0.231389 , -0.216174 , 0.392217
			with: 0.297259 , -0.2324 , 0.179726;
		addTriangleWith: 0.501538 , 0.0664585 , -0.0415585
			with: 0.334577 , -0.108218 , 0.226529
			with: 0.297259 , -0.2324 , 0.179726;
		addTriangleWith: 0.297259 , -0.2324 , 0.179726
			with: 0.236878 , -0.433332 , 0.103997
			with: 0.337969 , -0.242429 , 0.0483997;
		addTriangleWith: 0.337969 , -0.242429 , 0.0483997
			with: 0.403839 , -0.258656 , -0.164091
			with: 0.400446 , -0.124445 , 0.0140387;
		addTriangleWith: 0.297259 , -0.2324 , 0.179726
			with: 0.337969 , -0.242429 , 0.0483997
			with: 0.400446 , -0.124445 , 0.0140387;
		addTriangleWith: 0.501538 , 0.0664585 , -0.0415585
			with: 0.297259 , -0.2324 , 0.179726
			with: 0.400446 , -0.124445 , 0.0140387;
		addTriangleWith: 0.39835 , -0.0414973 , 0.124129
			with: 0.501538 , 0.0664585 , -0.0415585
			with: 0.367797 , 0.177896 , 0.0979039;
		addTriangleWith: 0.334577 , -0.108218 , 0.226529
			with: 0.394958 , 0.0927142 , 0.302259
			with: 0.200836 , 0.00321938 , 0.365992;
		addTriangleWith: 0.297259 , -0.2324 , 0.179726
			with: 0.231389 , -0.216174 , 0.392217
			with: 0.103137 , -0.321895 , 0.243459;
		addTriangleWith: 0.337969 , -0.242429 , 0.0483997
			with: 0.236878 , -0.433332 , 0.103997
			with: 0.209717 , -0.348151 , -0.100358;
		addTriangleWith: 0.400446 , -0.124445 , 0.0140387
			with: 0.403839 , -0.258656 , -0.164091
			with: 0.373286 , -0.0392634 , -0.190316;
		addTriangleWith: 0.354403 , 0.0963289 , -0.206524
			with: 0.501538 , 0.0664585 , -0.0415585
			with: 0.373286 , -0.0392634 , -0.190316;
		addTriangleWith: 0.32385 , 0.315722 , -0.232749
			with: 0.354403 , 0.0963289 , -0.206524
			with: 0.373286 , -0.0392634 , -0.190316;
		addTriangleWith: 0.32385 , 0.315722 , -0.232749
			with: 0.373286 , -0.0392634 , -0.190316
			with: 0.403839 , -0.258656 , -0.164091;
		addTriangleWith: 0.32385 , 0.315722 , -0.232749
			with: 0.403839 , -0.258656 , -0.164091
			with: 0.294022 , -0.104603 , -0.282253;
		addTriangleWith: 0.294022 , -0.104603 , -0.282253
			with: 0.16577 , -0.210325 , -0.431011
			with: 0.226151 , -0.00939291 , -0.355282;
		addTriangleWith: 0.32385 , 0.315722 , -0.232749
			with: 0.294022 , -0.104603 , -0.282253
			with: 0.226151 , -0.00939291 , -0.355282;
		addTriangleWith: 0.226151 , -0.00939291 , -0.355282
			with: 0.116334 , 0.14466 , -0.473444
			with: 0.263469 , 0.11479 , -0.308478;
		addTriangleWith: 0.32385 , 0.315722 , -0.232749
			with: 0.226151 , -0.00939291 , -0.355282
			with: 0.263469 , 0.11479 , -0.308478;
		addTriangleWith: 0.354403 , 0.0963289 , -0.206524
			with: 0.32385 , 0.315722 , -0.232749
			with: 0.351011 , 0.23054 , -0.0283944;
		addTriangleWith: 0.373286 , -0.0392634 , -0.190316
			with: 0.501538 , 0.0664585 , -0.0415585
			with: 0.400446 , -0.124445 , 0.0140387;
		addTriangleWith: 0.294022 , -0.104603 , -0.282253
			with: 0.403839 , -0.258656 , -0.164091
			with: 0.192931 , -0.295506 , -0.226656;
		addTriangleWith: 0.226151 , -0.00939291 , -0.355282
			with: 0.16577 , -0.210325 , -0.431011
			with: 0.0152432 , -0.0462428 , -0.417847;
		addTriangleWith: 0.263469 , 0.11479 , -0.308478
			with: 0.116334 , 0.14466 , -0.473444
			with: 0.112942 , 0.278872 , -0.295314;
		addTriangleWith: 0.110846 , 0.361819 , -0.185224
			with: 0.32385 , 0.315722 , -0.232749
			with: 0.112942 , 0.278872 , -0.295314;
		addTriangleWith: 0.112942 , 0.278872 , -0.295314
			with: 0.116334 , 0.14466 , -0.473444
			with: -0.017406 , 0.256097 , -0.333982;
		addTriangleWith: 0.110846 , 0.361819 , -0.185224
			with: 0.112942 , 0.278872 , -0.295314
			with: -0.017406 , 0.256097 , -0.333982;
		addTriangleWith: 0.107454 , 0.496031 , -0.0070943
			with: 0.110846 , 0.361819 , -0.185224
			with: -0.017406 , 0.256097 , -0.333982;
		addTriangleWith: 0.107454 , 0.496031 , -0.0070943
			with: -0.017406 , 0.256097 , -0.333982
			with: -0.228314 , 0.219247 , -0.396547;
		addTriangleWith: 0.107454 , 0.496031 , -0.0070943
			with: -0.228314 , 0.219247 , -0.396547
			with: -0.100062 , 0.324969 , -0.247789;
		addTriangleWith: -0.100062 , 0.324969 , -0.247789
			with: -0.233802 , 0.436406 , -0.108327
			with: -0.0207981 , 0.390309 , -0.155852;
		addTriangleWith: 0.107454 , 0.496031 , -0.0070943
			with: -0.100062 , 0.324969 , -0.247789
			with: -0.0207981 , 0.390309 , -0.155852;
		addTriangleWith: 0.110846 , 0.361819 , -0.185224
			with: 0.107454 , 0.496031 , -0.0070943
			with: 0.25798 , 0.331949 , -0.0202585;
		addTriangleWith: 0.112942 , 0.278872 , -0.295314
			with: 0.32385 , 0.315722 , -0.232749
			with: 0.263469 , 0.11479 , -0.308478;
		addTriangleWith: -0.017406 , 0.256097 , -0.333982
			with: 0.116334 , 0.14466 , -0.473444
			with: -0.0777874 , 0.0551654 , -0.409711;
		addTriangleWith: -0.100062 , 0.324969 , -0.247789
			with: -0.228314 , 0.219247 , -0.396547
			with: -0.294184 , 0.235474 , -0.184056;
		addTriangleWith: -0.0207981 , 0.390309 , -0.155852
			with: -0.233802 , 0.436406 , -0.108327
			with: -0.086668 , 0.406536 , 0.0566389;
		addTriangleWith: 0.00426627 , 0.388075 , 0.158593
			with: 0.107454 , 0.496031 , -0.0070943
			with: -0.086668 , 0.406536 , 0.0566389;
		addTriangleWith: 0.151401 , 0.358205 , 0.323559
			with: 0.00426627 , 0.388075 , 0.158593
			with: -0.086668 , 0.406536 , 0.0566389;
		addTriangleWith: -0.086668 , 0.406536 , 0.0566389
			with: -0.233802 , 0.436406 , -0.108327
			with: -0.206642 , 0.351225 , 0.0960281;
		addTriangleWith: 0.151401 , 0.358205 , 0.323559
			with: -0.086668 , 0.406536 , 0.0566389
			with: -0.206642 , 0.351225 , 0.0960281;
		addTriangleWith: -0.206642 , 0.351225 , 0.0960281
			with: -0.400763 , 0.26173 , 0.159761
			with: -0.189855 , 0.29858 , 0.222326;
		addTriangleWith: -0.206642 , 0.351225 , 0.0960281
			with: -0.189855 , 0.29858 , 0.222326
			with: -0.162695 , 0.213399 , 0.426681;
		addTriangleWith: -0.206642 , 0.351225 , 0.0960281
			with: -0.162695 , 0.213399 , 0.426681
			with: -0.0595072 , 0.321355 , 0.260994;
		addTriangleWith: 0.151401 , 0.358205 , 0.323559
			with: -0.206642 , 0.351225 , 0.0960281
			with: -0.0595072 , 0.321355 , 0.260994;
		addTriangleWith: 0.00426627 , 0.388075 , 0.158593
			with: 0.151401 , 0.358205 , 0.323559
			with: 0.217271 , 0.341978 , 0.111068;
		addTriangleWith: -0.086668 , 0.406536 , 0.0566389
			with: 0.107454 , 0.496031 , -0.0070943
			with: -0.0207981 , 0.390309 , -0.155852;
		addTriangleWith: -0.206642 , 0.351225 , 0.0960281
			with: -0.233802 , 0.436406 , -0.108327
			with: -0.334894 , 0.245503 , -0.0527295;
		addTriangleWith: -0.189855 , 0.29858 , 0.222326
			with: -0.400763 , 0.26173 , 0.159761
			with: -0.290947 , 0.107677 , 0.277924;
		addTriangleWith: -0.0595072 , 0.321355 , 0.260994
			with: -0.162695 , 0.213399 , 0.426681
			with: 0.0503097 , 0.167301 , 0.379156;
		addTriangleWith: 0.181954 , 0.138812 , 0.349784
			with: 0.151401 , 0.358205 , 0.323559
			with: 0.0503097 , 0.167301 , 0.379156;
		addTriangleWith: 0.181954 , 0.138812 , 0.349784
			with: 0.0503097 , 0.167301 , 0.379156
			with: -0.162695 , 0.213399 , 0.426681;
		addTriangleWith: 0.181954 , 0.138812 , 0.349784
			with: -0.162695 , 0.213399 , 0.426681
			with: -0.012168 , 0.0493168 , 0.413517;
		addTriangleWith: 0.394958 , 0.0927142 , 0.302259
			with: 0.181954 , 0.138812 , 0.349784
			with: -0.012168 , 0.0493168 , 0.413517;
		addTriangleWith: -0.012168 , 0.0493168 , 0.413517
			with: -0.113259 , -0.141586 , 0.469114
			with: 0.0808625 , -0.0520915 , 0.405381;
		addTriangleWith: -0.012168 , 0.0493168 , 0.413517
			with: 0.0808625 , -0.0520915 , 0.405381
			with: 0.231389 , -0.216174 , 0.392217;
		addTriangleWith: -0.012168 , 0.0493168 , 0.413517
			with: 0.231389 , -0.216174 , 0.392217
			with: 0.200836 , 0.00321938 , 0.365992;
		addTriangleWith: 0.394958 , 0.0927142 , 0.302259
			with: -0.012168 , 0.0493168 , 0.413517
			with: 0.200836 , 0.00321938 , 0.365992;
		addTriangleWith: 0.181954 , 0.138812 , 0.349784
			with: 0.394958 , 0.0927142 , 0.302259
			with: 0.285141 , 0.246767 , 0.184096;
		addTriangleWith: 0.0503097 , 0.167301 , 0.379156
			with: 0.151401 , 0.358205 , 0.323559
			with: -0.0595072 , 0.321355 , 0.260994;
		addTriangleWith: -0.012168 , 0.0493168 , 0.413517
			with: -0.162695 , 0.213399 , 0.426681
			with: -0.223076 , 0.0124669 , 0.350952;
		addTriangleWith: 0.0808625 , -0.0520915 , 0.405381
			with: -0.113259 , -0.141586 , 0.469114
			with: 0.0204812 , -0.253023 , 0.329652;
		addTriangleWith: 0.200836 , 0.00321938 , 0.365992
			with: 0.231389 , -0.216174 , 0.392217
			with: 0.334577 , -0.108218 , 0.226529;
		addTriangleWith: -0.254905 , -0.328875 , 0.0159287
			with: -0.320775 , -0.312648 , 0.228419
			with: -0.347936 , -0.227467 , 0.0240646;
		addTriangleWith: -0.104379 , -0.492957 , 0.00276452
			with: -0.254905 , -0.328875 , 0.0159287
			with: -0.347936 , -0.227467 , 0.0240646;
		addTriangleWith: -0.104379 , -0.492957 , 0.00276452
			with: -0.347936 , -0.227467 , 0.0240646
			with: -0.498462 , -0.0633845 , 0.0372288;
		addTriangleWith: -0.104379 , -0.492957 , 0.00276452
			with: -0.498462 , -0.0633845 , 0.0372288
			with: -0.364722 , -0.174822 , -0.102234;
		addTriangleWith: -0.364722 , -0.174822 , -0.102234
			with: -0.391883 , -0.0896403 , -0.306589
			with: -0.282066 , -0.243694 , -0.188426;
		addTriangleWith: -0.282066 , -0.243694 , -0.188426
			with: -0.148326 , -0.355131 , -0.327889
			with: -0.214195 , -0.338904 , -0.115398;
		addTriangleWith: -0.364722 , -0.174822 , -0.102234
			with: -0.282066 , -0.243694 , -0.188426
			with: -0.214195 , -0.338904 , -0.115398;
		addTriangleWith: -0.104379 , -0.492957 , 0.00276452
			with: -0.364722 , -0.174822 , -0.102234
			with: -0.214195 , -0.338904 , -0.115398;
		addTriangleWith: -0.254905 , -0.328875 , 0.0159287
			with: -0.104379 , -0.492957 , 0.00276452
			with: -0.107771 , -0.358745 , 0.180894;
		addTriangleWith: -0.347936 , -0.227467 , 0.0240646
			with: -0.320775 , -0.312648 , 0.228419
			with: -0.351328 , -0.093255 , 0.202194;
		addTriangleWith: -0.364722 , -0.174822 , -0.102234
			with: -0.498462 , -0.0633845 , 0.0372288
			with: -0.395275 , 0.0445713 , -0.128459;
		addTriangleWith: -0.282066 , -0.243694 , -0.188426
			with: -0.391883 , -0.0896403 , -0.306589
			with: -0.178878 , -0.135738 , -0.354114;
		addTriangleWith: -0.214195 , -0.338904 , -0.115398
			with: -0.148326 , -0.355131 , -0.327889
			with: -0.00119106 , -0.385001 , -0.162923;
		addTriangleWith: -0.107771 , -0.358745 , 0.180894
			with: -0.104379 , -0.492957 , 0.00276452
			with: 0.0238732 , -0.387235 , 0.151522;
		addTriangleWith: -0.320775 , -0.312648 , 0.228419
			with: -0.107771 , -0.358745 , 0.180894
			with: 0.0238732 , -0.387235 , 0.151522;
		addTriangleWith: 0.0238732 , -0.387235 , 0.151522
			with: 0.236878 , -0.433332 , 0.103997
			with: 0.103137 , -0.321895 , 0.243459;
		addTriangleWith: -0.320775 , -0.312648 , 0.228419
			with: 0.0238732 , -0.387235 , 0.151522
			with: 0.103137 , -0.321895 , 0.243459;
		addTriangleWith: 0.103137 , -0.321895 , 0.243459
			with: 0.231389 , -0.216174 , 0.392217
			with: 0.0204812 , -0.253023 , 0.329652;
		addTriangleWith: -0.320775 , -0.312648 , 0.228419
			with: 0.103137 , -0.321895 , 0.243459
			with: 0.0204812 , -0.253023 , 0.329652;
		addTriangleWith: 0.0204812 , -0.253023 , 0.329652
			with: -0.113259 , -0.141586 , 0.469114
			with: -0.109867 , -0.275798 , 0.290985;
		addTriangleWith: -0.320775 , -0.312648 , 0.228419
			with: 0.0204812 , -0.253023 , 0.329652
			with: -0.109867 , -0.275798 , 0.290985;
		addTriangleWith: -0.107771 , -0.358745 , 0.180894
			with: -0.320775 , -0.312648 , 0.228419
			with: -0.254905 , -0.328875 , 0.0159287;
		addTriangleWith: 0.0238732 , -0.387235 , 0.151522
			with: -0.104379 , -0.492957 , 0.00276452
			with: 0.0897431 , -0.403462 , -0.0609686;
		addTriangleWith: 0.103137 , -0.321895 , 0.243459
			with: 0.236878 , -0.433332 , 0.103997
			with: 0.297259 , -0.2324 , 0.179726;
		addTriangleWith: 0.0204812 , -0.253023 , 0.329652
			with: 0.231389 , -0.216174 , 0.392217
			with: 0.0808625 , -0.0520915 , 0.405381;
		addTriangleWith: -0.109867 , -0.275798 , 0.290985
			with: -0.113259 , -0.141586 , 0.469114
			with: -0.260394 , -0.111716 , 0.304149;
		addTriangleWith: -0.351328 , -0.093255 , 0.202194
			with: -0.320775 , -0.312648 , 0.228419
			with: -0.260394 , -0.111716 , 0.304149;
		addTriangleWith: -0.498462 , -0.0633845 , 0.0372288
			with: -0.351328 , -0.093255 , 0.202194
			with: -0.260394 , -0.111716 , 0.304149;
		addTriangleWith: -0.498462 , -0.0633845 , 0.0372288
			with: -0.260394 , -0.111716 , 0.304149
			with: -0.113259 , -0.141586 , 0.469114;
		addTriangleWith: -0.498462 , -0.0633845 , 0.0372288
			with: -0.113259 , -0.141586 , 0.469114
			with: -0.223076 , 0.0124669 , 0.350952;
		addTriangleWith: -0.223076 , 0.0124669 , 0.350952
			with: -0.162695 , 0.213399 , 0.426681
			with: -0.290947 , 0.107677 , 0.277924;
		addTriangleWith: -0.223076 , 0.0124669 , 0.350952
			with: -0.290947 , 0.107677 , 0.277924
			with: -0.400763 , 0.26173 , 0.159761;
		addTriangleWith: -0.223076 , 0.0124669 , 0.350952
			with: -0.400763 , 0.26173 , 0.159761
			with: -0.370211 , 0.0423373 , 0.185986;
		addTriangleWith: -0.498462 , -0.0633845 , 0.0372288
			with: -0.223076 , 0.0124669 , 0.350952
			with: -0.370211 , 0.0423373 , 0.185986;
		addTriangleWith: -0.351328 , -0.093255 , 0.202194
			with: -0.498462 , -0.0633845 , 0.0372288
			with: -0.347936 , -0.227467 , 0.0240646;
		addTriangleWith: -0.260394 , -0.111716 , 0.304149
			with: -0.320775 , -0.312648 , 0.228419
			with: -0.109867 , -0.275798 , 0.290985;
		addTriangleWith: -0.223076 , 0.0124669 , 0.350952
			with: -0.113259 , -0.141586 , 0.469114
			with: -0.012168 , 0.0493168 , 0.413517;
		addTriangleWith: -0.290947 , 0.107677 , 0.277924
			with: -0.162695 , 0.213399 , 0.426681
			with: -0.189855 , 0.29858 , 0.222326;
		addTriangleWith: -0.370211 , 0.0423373 , 0.185986
			with: -0.400763 , 0.26173 , 0.159761
			with: -0.397371 , 0.127519 , -0.0183685;
		addTriangleWith: -0.395275 , 0.0445713 , -0.128459
			with: -0.498462 , -0.0633845 , 0.0372288
			with: -0.397371 , 0.127519 , -0.0183685;
		addTriangleWith: -0.391883 , -0.0896403 , -0.306589
			with: -0.395275 , 0.0445713 , -0.128459
			with: -0.397371 , 0.127519 , -0.0183685;
		addTriangleWith: -0.397371 , 0.127519 , -0.0183685
			with: -0.400763 , 0.26173 , 0.159761
			with: -0.334894 , 0.245503 , -0.0527295;
		addTriangleWith: -0.391883 , -0.0896403 , -0.306589
			with: -0.397371 , 0.127519 , -0.0183685
			with: -0.334894 , 0.245503 , -0.0527295;
		addTriangleWith: -0.391883 , -0.0896403 , -0.306589
			with: -0.334894 , 0.245503 , -0.0527295
			with: -0.233802 , 0.436406 , -0.108327;
		addTriangleWith: -0.294184 , 0.235474 , -0.184056
			with: -0.228314 , 0.219247 , -0.396547
			with: -0.331501 , 0.111292 , -0.230859;
		addTriangleWith: -0.331501 , 0.111292 , -0.230859
			with: -0.391883 , -0.0896403 , -0.306589
			with: -0.233802 , 0.436406 , -0.108327;
		addTriangleWith: -0.233802 , 0.436406 , -0.108327
			with: -0.294184 , 0.235474 , -0.184056
			with: -0.331501 , 0.111292 , -0.230859;
		addTriangleWith: -0.395275 , 0.0445713 , -0.128459
			with: -0.391883 , -0.0896403 , -0.306589
			with: -0.364722 , -0.174822 , -0.102234;
		addTriangleWith: -0.397371 , 0.127519 , -0.0183685
			with: -0.498462 , -0.0633845 , 0.0372288
			with: -0.370211 , 0.0423373 , 0.185986;
		addTriangleWith: -0.334894 , 0.245503 , -0.0527295
			with: -0.400763 , 0.26173 , 0.159761
			with: -0.206642 , 0.351225 , 0.0960281;
		addTriangleWith: -0.294184 , 0.235474 , -0.184056
			with: -0.233802 , 0.436406 , -0.108327
			with: -0.100062 , 0.324969 , -0.247789;
		addTriangleWith: -0.331501 , 0.111292 , -0.230859
			with: -0.228314 , 0.219247 , -0.396547
			with: -0.197761 , -0.000145435 , -0.370322;
		addTriangleWith: -0.178878 , -0.135738 , -0.354114
			with: -0.391883 , -0.0896403 , -0.306589
			with: -0.197761 , -0.000145435 , -0.370322;
		addTriangleWith: -0.148326 , -0.355131 , -0.327889
			with: -0.178878 , -0.135738 , -0.354114
			with: -0.197761 , -0.000145435 , -0.370322;
		addTriangleWith: -0.148326 , -0.355131 , -0.327889
			with: -0.197761 , -0.000145435 , -0.370322
			with: -0.228314 , 0.219247 , -0.396547;
		addTriangleWith: -0.148326 , -0.355131 , -0.327889
			with: -0.228314 , 0.219247 , -0.396547
			with: -0.0777874 , 0.0551654 , -0.409711;
		addTriangleWith: -0.148326 , -0.355131 , -0.327889
			with: -0.0777874 , 0.0551654 , -0.409711
			with: 0.116334 , 0.14466 , -0.473444;
		addTriangleWith: -0.148326 , -0.355131 , -0.327889
			with: 0.116334 , 0.14466 , -0.473444
			with: 0.0152432 , -0.0462428 , -0.417847;
		addTriangleWith: 0.0152432 , -0.0462428 , -0.417847
			with: 0.16577 , -0.210325 , -0.431011
			with: -0.0472345 , -0.164227 , -0.383486;
		addTriangleWith: -0.148326 , -0.355131 , -0.327889
			with: 0.0152432 , -0.0462428 , -0.417847
			with: -0.0472345 , -0.164227 , -0.383486;
		addTriangleWith: -0.178878 , -0.135738 , -0.354114
			with: -0.148326 , -0.355131 , -0.327889
			with: -0.282066 , -0.243694 , -0.188426;
		addTriangleWith: -0.197761 , -0.000145435 , -0.370322
			with: -0.391883 , -0.0896403 , -0.306589
			with: -0.331501 , 0.111292 , -0.230859;
		addTriangleWith: -0.0777874 , 0.0551654 , -0.409711
			with: -0.228314 , 0.219247 , -0.396547
			with: -0.017406 , 0.256097 , -0.333982;
		addTriangleWith: 0.0152432 , -0.0462428 , -0.417847
			with: 0.116334 , 0.14466 , -0.473444
			with: 0.226151 , -0.00939291 , -0.355282;
		addTriangleWith: -0.0472345 , -0.164227 , -0.383486
			with: 0.16577 , -0.210325 , -0.431011
			with: 0.0625823 , -0.318281 , -0.265324;
		addTriangleWith: -0.00119106 , -0.385001 , -0.162923
			with: -0.148326 , -0.355131 , -0.327889
			with: 0.0625823 , -0.318281 , -0.265324;
		addTriangleWith: -0.104379 , -0.492957 , 0.00276452
			with: -0.00119106 , -0.385001 , -0.162923
			with: 0.0625823 , -0.318281 , -0.265324;
		addTriangleWith: -0.104379 , -0.492957 , 0.00276452
			with: 0.0625823 , -0.318281 , -0.265324
			with: 0.16577 , -0.210325 , -0.431011;
		addTriangleWith: -0.104379 , -0.492957 , 0.00276452
			with: 0.16577 , -0.210325 , -0.431011
			with: 0.192931 , -0.295506 , -0.226656;
		addTriangleWith: 0.192931 , -0.295506 , -0.226656
			with: 0.403839 , -0.258656 , -0.164091
			with: 0.209717 , -0.348151 , -0.100358;
		addTriangleWith: 0.209717 , -0.348151 , -0.100358
			with: 0.236878 , -0.433332 , 0.103997
			with: 0.0897431 , -0.403462 , -0.0609686;
		addTriangleWith: 0.192931 , -0.295506 , -0.226656
			with: 0.209717 , -0.348151 , -0.100358
			with: 0.0897431 , -0.403462 , -0.0609686;
		addTriangleWith: -0.104379 , -0.492957 , 0.00276452
			with: 0.192931 , -0.295506 , -0.226656
			with: 0.0897431 , -0.403462 , -0.0609686;
		addTriangleWith: -0.00119106 , -0.385001 , -0.162923
			with: -0.104379 , -0.492957 , 0.00276452
			with: -0.214195 , -0.338904 , -0.115398;
		addTriangleWith: 0.0625823 , -0.318281 , -0.265324
			with: -0.148326 , -0.355131 , -0.327889
			with: -0.0472345 , -0.164227 , -0.383486;
		addTriangleWith: 0.192931 , -0.295506 , -0.226656
			with: 0.16577 , -0.210325 , -0.431011
			with: 0.294022 , -0.104603 , -0.282253;
		addTriangleWith: 0.209717 , -0.348151 , -0.100358
			with: 0.403839 , -0.258656 , -0.164091
			with: 0.337969 , -0.242429 , 0.0483997;
		addTriangleWith: 0.0897431 , -0.403462 , -0.0609686
			with: 0.236878 , -0.433332 , 0.103997
			with: 0.0238732 , -0.387235 , 0.151522! !

!Polyhedron class methodsFor: 'factory' stamp: 'emm 02/09/2012 23:40'!
snubDisphenoid
	"self snubDisphenoid"

	^(Triangle3DComposite new)
		addTriangleWith: 0.186826 , 0.0352089 , 0.398014
			with: 0.59282 , 0.0603682 , -0.111413
			with: 0.0522154 , 0.424618 , -0.107389;
		addTriangleWith: 0.0522154 , 0.424618 , -0.107389
			with: 0.59282 , 0.0603682 , -0.111413
			with: 0.151599 , -0.00564663 , -0.587057;
		addTriangleWith: 0.0522154 , 0.424618 , -0.107389
			with: 0.151599 , -0.00564663 , -0.587057
			with: -0.382099 , -0.0496343 , -0.214896;
		addTriangleWith: 0.142932 , -0.410434 , -0.0758819
			with: 0.59282 , 0.0603682 , -0.111413
			with: 0.186826 , 0.0352089 , 0.398014;
		addTriangleWith: 0.59282 , 0.0603682 , -0.111413
			with: 0.142932 , -0.410434 , -0.0758819
			with: 0.151599 , -0.00564663 , -0.587057;
		addTriangleWith: 0.151599 , -0.00564663 , -0.587057
			with: 0.142932 , -0.410434 , -0.0758819
			with: -0.382099 , -0.0496343 , -0.214896;
		addTriangleWith: 0.142932 , -0.410434 , -0.0758819
			with: -0.337082 , -0.351155 , 0.361547
			with: -0.382099 , -0.0496343 , -0.214896;
		addTriangleWith: -0.382099 , -0.0496343 , -0.214896
			with: -0.337082 , -0.351155 , 0.361547
			with: -0.40718 , 0.296735 , 0.337114;
		addTriangleWith: -0.382099 , -0.0496343 , -0.214896
			with: -0.40718 , 0.296735 , 0.337114
			with: 0.0522154 , 0.424618 , -0.107389;
		addTriangleWith: 0.186826 , 0.0352089 , 0.398014
			with: -0.337082 , -0.351155 , 0.361547
			with: 0.142932 , -0.410434 , -0.0758819;
		addTriangleWith: -0.337082 , -0.351155 , 0.361547
			with: 0.186826 , 0.0352089 , 0.398014
			with: -0.40718 , 0.296735 , 0.337114;
		addTriangleWith: -0.40718 , 0.296735 , 0.337114
			with: 0.186826 , 0.0352089 , 0.398014
			with: 0.0522154 , 0.424618 , -0.107389! !

!Polyhedron class methodsFor: 'factory' stamp: 'emm 02/09/2012 23:40'!
sphenocorona
	"self sphenocorona"

	^(Triangle3DComposite new)
		addTriangleWith: -0.296232 , 0.380207 , 0.171389
			with: -0.508907 , -0.0519056 , -0.00209241
			with: -0.146994 , -0.325305 , 0.235223;
		addTriangleWith: -0.296232 , 0.380207 , 0.171389
			with: -0.146994 , -0.325305 , 0.235223
			with: 0.0656808 , 0.106807 , 0.408703;
		addTriangleWith: 0.0656808 , 0.106807 , 0.408703
			with: -0.146994 , -0.325305 , 0.235223
			with: 0.278418 , -0.428076 , -0.0303142;
		addTriangleWith: 0.0656808 , 0.106807 , 0.408703
			with: 0.278418 , -0.428076 , -0.0303142
			with: 0.491093 , 0.00403577 , 0.143167;
		addTriangleWith: 0.269992 , -0.00503952 , -0.318438
			with: -0.150369 , -0.294036 , -0.275716
			with: -0.191659 , 0.21553 , -0.30189;
		addTriangleWith: -0.191659 , 0.21553 , -0.30189
			with: -0.296232 , 0.380207 , 0.171389
			with: 0.185414 , 0.388208 , -0.00181476;
		addTriangleWith: -0.191659 , 0.21553 , -0.30189
			with: -0.150369 , -0.294036 , -0.275716
			with: -0.508907 , -0.0519056 , -0.00209241;
		addTriangleWith: -0.191659 , 0.21553 , -0.30189
			with: -0.508907 , -0.0519056 , -0.00209241
			with: -0.296232 , 0.380207 , 0.171389;
		addTriangleWith: -0.296232 , 0.380207 , 0.171389
			with: 0.0656808 , 0.106807 , 0.408703
			with: 0.185414 , 0.388208 , -0.00181476;
		addTriangleWith: 0.185414 , 0.388208 , -0.00181476
			with: 0.0656808 , 0.106807 , 0.408703
			with: 0.491093 , 0.00403577 , 0.143167;
		addTriangleWith: -0.150369 , -0.294036 , -0.275716
			with: -0.146994 , -0.325305 , 0.235223
			with: -0.508907 , -0.0519056 , -0.00209241;
		addTriangleWith: -0.146994 , -0.325305 , 0.235223
			with: -0.150369 , -0.294036 , -0.275716
			with: 0.278418 , -0.428076 , -0.0303142;
		addTriangleWith: 0.491093 , 0.00403577 , 0.143167
			with: 0.269992 , -0.00503952 , -0.318438
			with: 0.185414 , 0.388208 , -0.00181476;
		addTriangleWith: 0.491093 , 0.00403577 , 0.143167
			with: 0.278418 , -0.428076 , -0.0303142
			with: 0.269992 , -0.00503952 , -0.318438;
		addTriangleWith: 0.269992 , -0.00503952 , -0.318438
			with: 0.278418 , -0.428076 , -0.0303142
			with: -0.150369 , -0.294036 , -0.275716;
		addTriangleWith: 0.185414 , 0.388208 , -0.00181476
			with: 0.269992 , -0.00503952 , -0.318438
			with: -0.191659 , 0.21553 , -0.30189! !

!Polyhedron class methodsFor: 'factory' stamp: 'emm 02/09/2012 23:40'!
sphenomegacorona
	"self sphenomegacorona"

	^(Triangle3DComposite new)
		addTriangleWith: 0.109821 , -0.246941 , 0.266124
			with: -0.000117426 , -0.481447 , -0.142473
			with: 0.262433 , -0.163567 , -0.395556;
		addTriangleWith: 0.109821 , -0.246941 , 0.266124
			with: 0.262433 , -0.163567 , -0.395556
			with: 0.372371 , 0.0709384 , 0.0130412;
		addTriangleWith: 0.080929 , 0.225495 , 0.367185
			with: 0.109821 , -0.246941 , 0.266124
			with: 0.372371 , 0.0709384 , 0.0130412;
		addTriangleWith: -0.295405 , -0.509853 , 0.239665
			with: 0.109821 , -0.246941 , 0.266124
			with: -0.313249 , -0.0532637 , 0.398531;
		addTriangleWith: -0.295405 , -0.509853 , 0.239665
			with: -0.000117426 , -0.481447 , -0.142473
			with: 0.109821 , -0.246941 , 0.266124;
		addTriangleWith: 0.372371 , 0.0709384 , 0.0130412
			with: 0.378352 , 0.305891 , -0.409797
			with: 0.135576 , 0.490147 , -0.0341107;
		addTriangleWith: 0.372371 , 0.0709384 , 0.0130412
			with: 0.262433 , -0.163567 , -0.395556
			with: 0.378352 , 0.305891 , -0.409797;
		addTriangleWith: -0.313249 , -0.0532637 , 0.398531
			with: 0.109821 , -0.246941 , 0.266124
			with: 0.080929 , 0.225495 , 0.367185;
		addTriangleWith: 0.080929 , 0.225495 , 0.367185
			with: 0.372371 , 0.0709384 , 0.0130412
			with: 0.135576 , 0.490147 , -0.0341107;
		addTriangleWith: -0.0793964 , 0.172128 , -0.328528
			with: 0.262433 , -0.163567 , -0.395556
			with: -0.000117426 , -0.481447 , -0.142473;
		addTriangleWith: -0.0793964 , 0.172128 , -0.328528
			with: -0.000117426 , -0.481447 , -0.142473
			with: -0.341946 , -0.145751 , -0.0754455;
		addTriangleWith: -0.298865 , 0.310393 , 0.0798187
			with: -0.0793964 , 0.172128 , -0.328528
			with: -0.341946 , -0.145751 , -0.0754455;
		addTriangleWith: 0.378352 , 0.305891 , -0.409797
			with: -0.0793964 , 0.172128 , -0.328528
			with: 0.135576 , 0.490147 , -0.0341107;
		addTriangleWith: 0.378352 , 0.305891 , -0.409797
			with: 0.262433 , -0.163567 , -0.395556
			with: -0.0793964 , 0.172128 , -0.328528;
		addTriangleWith: -0.341946 , -0.145751 , -0.0754455
			with: -0.295405 , -0.509853 , 0.239665
			with: -0.313249 , -0.0532637 , 0.398531;
		addTriangleWith: -0.341946 , -0.145751 , -0.0754455
			with: -0.000117426 , -0.481447 , -0.142473
			with: -0.295405 , -0.509853 , 0.239665;
		addTriangleWith: 0.135576 , 0.490147 , -0.0341107
			with: -0.298865 , 0.310393 , 0.0798187
			with: 0.080929 , 0.225495 , 0.367185;
		addTriangleWith: 0.135576 , 0.490147 , -0.0341107
			with: -0.0793964 , 0.172128 , -0.328528
			with: -0.298865 , 0.310393 , 0.0798187;
		addTriangleWith: -0.298865 , 0.310393 , 0.0798187
			with: -0.313249 , -0.0532637 , 0.398531
			with: 0.080929 , 0.225495 , 0.367185;
		addTriangleWith: -0.298865 , 0.310393 , 0.0798187
			with: -0.341946 , -0.145751 , -0.0754455
			with: -0.313249 , -0.0532637 , 0.398531! !

!Polyhedron class methodsFor: 'factory-square' stamp: 'emm 02/09/2012 23:40'!
squareAntiprism
	"self squareAntiprism"

	^(Triangle3DComposite new)
		add: (Triangle3D 
					with: -0.00000000468298 , -0.5 , -0.297302
					with: -0.5 , -0.00000000292686 , -0.297302
					with: -0.00000000468298 , 0.5 , -0.297302);
		add: (Triangle3D 
					with: -0.00000000468298 , -0.5 , -0.297302
					with: -0.00000000468298 , 0.5 , -0.297302
					with: 0.5 , -0.00000000292686 , -0.297302);
		add: (Triangle3D 
					with: -0.353553 , -0.353553 , 0.297302
					with: 0.353553 , -0.353553 , 0.297302
					with: 0.353553 , 0.353553 , 0.297302);
		add: (Triangle3D 
					with: -0.353553 , -0.353553 , 0.297302
					with: 0.353553 , 0.353553 , 0.297302
					with: -0.353553 , 0.353553 , 0.297302);
		add: (Triangle3D 
					with: 0.353553 , 0.353553 , 0.297302
					with: -0.00000000468298 , 0.5 , -0.297302
					with: -0.353553 , 0.353553 , 0.297302);
		add: (Triangle3D 
					with: -0.353553 , 0.353553 , 0.297302
					with: -0.00000000468298 , 0.5 , -0.297302
					with: -0.5 , -0.00000000292686 , -0.297302);
		add: (Triangle3D 
					with: -0.353553 , 0.353553 , 0.297302
					with: -0.5 , -0.00000000292686 , -0.297302
					with: -0.353553 , -0.353553 , 0.297302);
		add: (Triangle3D 
					with: -0.353553 , -0.353553 , 0.297302
					with: -0.5 , -0.00000000292686 , -0.297302
					with: -0.00000000468298 , -0.5 , -0.297302);
		add: (Triangle3D 
					with: -0.353553 , -0.353553 , 0.297302
					with: -0.00000000468298 , -0.5 , -0.297302
					with: 0.353553 , -0.353553 , 0.297302);
		add: (Triangle3D 
					with: 0.353553 , -0.353553 , 0.297302
					with: -0.00000000468298 , -0.5 , -0.297302
					with: 0.5 , -0.00000000292686 , -0.297302);
		add: (Triangle3D 
					with: 0.353553 , -0.353553 , 0.297302
					with: 0.5 , -0.00000000292686 , -0.297302
					with: 0.353553 , 0.353553 , 0.297302);
		add: (Triangle3D 
					with: 0.353553 , 0.353553 , 0.297302
					with: 0.5 , -0.00000000292686 , -0.297302
					with: -0.00000000468298 , 0.5 , -0.297302);
		yourself! !

!Polyhedron class methodsFor: 'factory-square' stamp: 'emm 02/09/2012 23:40'!
squareCupola
	"self squareCupola"

	^(Triangle3DComposite new)
		add: (Triangle3D 
					with: -0.075783 , 0.470061 , -0.219402
					with: 0.219782 , 0.479078 , 0.0654393
					with: 0.43382 , 0.195202 , 0.27081);
		add: (Triangle3D 
					with: -0.075783 , 0.470061 , -0.219402
					with: 0.43382 , 0.195202 , 0.27081
					with: 0.440949 , -0.215276 , 0.276407);
		add: (Triangle3D 
					with: -0.075783 , 0.470061 , -0.219402
					with: 0.440949 , -0.215276 , 0.276407
					with: 0.236993 , -0.511905 , 0.0789521);
		add: (Triangle3D 
					with: -0.075783 , 0.470061 , -0.219402
					with: 0.236993 , -0.511905 , 0.0789521
					with: -0.0585721 , -0.520922 , -0.205889);
		add: (Triangle3D 
					with: -0.075783 , 0.470061 , -0.219402
					with: -0.0585721 , -0.520922 , -0.205889
					with: -0.272609 , -0.237046 , -0.41126);
		add: (Triangle3D 
					with: -0.075783 , 0.470061 , -0.219402
					with: -0.272609 , -0.237046 , -0.41126
					with: -0.279738 , 0.173432 , -0.416857);
		add: (Triangle3D 
					with: -0.272193 , 0.179161 , -0.00638804
					with: -0.265064 , -0.231318 , -0.000790809
					with: 0.0305013 , -0.222301 , 0.28405);
		add: (Triangle3D 
					with: -0.272193 , 0.179161 , -0.00638804
					with: 0.0305013 , -0.222301 , 0.28405
					with: 0.0233723 , 0.188178 , 0.278453);
		add: (Triangle3D 
					with: -0.265064 , -0.231318 , -0.000790809
					with: -0.272193 , 0.179161 , -0.00638804
					with: -0.279738 , 0.173432 , -0.416857);
		add: (Triangle3D 
					with: -0.265064 , -0.231318 , -0.000790809
					with: -0.279738 , 0.173432 , -0.416857
					with: -0.272609 , -0.237046 , -0.41126);
		add: (Triangle3D 
					with: -0.265064 , -0.231318 , -0.000790809
					with: -0.272609 , -0.237046 , -0.41126
					with: -0.0585721 , -0.520922 , -0.205889);
		add: (Triangle3D 
					with: 0.0305013 , -0.222301 , 0.28405
					with: -0.265064 , -0.231318 , -0.000790809
					with: -0.0585721 , -0.520922 , -0.205889);
		add: (Triangle3D 
					with: 0.0305013 , -0.222301 , 0.28405
					with: -0.0585721 , -0.520922 , -0.205889
					with: 0.236993 , -0.511905 , 0.0789521);
		add: (Triangle3D 
					with: 0.0305013 , -0.222301 , 0.28405
					with: 0.236993 , -0.511905 , 0.0789521
					with: 0.440949 , -0.215276 , 0.276407);
		add: (Triangle3D 
					with: 0.0233723 , 0.188178 , 0.278453
					with: 0.0305013 , -0.222301 , 0.28405
					with: 0.440949 , -0.215276 , 0.276407);
		add: (Triangle3D 
					with: 0.0233723 , 0.188178 , 0.278453
					with: 0.440949 , -0.215276 , 0.276407
					with: 0.43382 , 0.195202 , 0.27081);
		add: (Triangle3D 
					with: 0.0233723 , 0.188178 , 0.278453
					with: 0.43382 , 0.195202 , 0.27081
					with: 0.219782 , 0.479078 , 0.0654393);
		add: (Triangle3D 
					with: -0.272193 , 0.179161 , -0.00638804
					with: 0.0233723 , 0.188178 , 0.278453
					with: 0.219782 , 0.479078 , 0.0654393);
		add: (Triangle3D 
					with: -0.272193 , 0.179161 , -0.00638804
					with: 0.219782 , 0.479078 , 0.0654393
					with: -0.075783 , 0.470061 , -0.219402);
		add: (Triangle3D 
					with: -0.272193 , 0.179161 , -0.00638804
					with: -0.075783 , 0.470061 , -0.219402
					with: -0.279738 , 0.173432 , -0.416857);
		yourself! !

!Polyhedron class methodsFor: 'factory-square' stamp: 'emm 02/09/2012 23:40'!
squareGyrobicupola
	"self squareGyrobicupola"

	^(Triangle3DComposite new)
		add: (Triangle3D 
					with: -0.037305 , -0.193799 , -0.335135
					with: -0.220704 , 0.145528 , -0.285266
					with: 0.117543 , 0.315123 , -0.195311);
		add: (Triangle3D 
					with: -0.037305 , -0.193799 , -0.335135
					with: 0.117543 , 0.315123 , -0.195311
					with: 0.300942 , -0.0242042 , -0.24518);
		add: (Triangle3D 
					with: -0.220704 , 0.145528 , -0.285266
					with: -0.037305 , -0.193799 , -0.335135
					with: -0.316601 , -0.374383 , -0.13352);
		add: (Triangle3D 
					with: -0.220704 , 0.145528 , -0.285266
					with: -0.316601 , -0.374383 , -0.13352
					with: -0.5 , -0.0350557 , -0.0836503);
		add: (Triangle3D 
					with: -0.220704 , 0.145528 , -0.285266
					with: -0.5 , -0.0350557 , -0.0836503
					with: -0.390506 , 0.324807 , 0.0152203);
		add: (Triangle3D 
					with: 0.117543 , 0.315123 , -0.195311
					with: -0.220704 , 0.145528 , -0.285266
					with: -0.390506 , 0.324807 , 0.0152203);
		add: (Triangle3D 
					with: 0.117543 , 0.315123 , -0.195311
					with: -0.390506 , 0.324807 , 0.0152203
					with: -0.052259 , 0.494402 , 0.105175);
		add: (Triangle3D 
					with: 0.117543 , 0.315123 , -0.195311
					with: -0.052259 , 0.494402 , 0.105175
					with: 0.316601 , 0.374383 , 0.13352);
		add: (Triangle3D 
					with: 0.300942 , -0.0242042 , -0.24518
					with: 0.117543 , 0.315123 , -0.195311
					with: 0.316601 , 0.374383 , 0.13352);
		add: (Triangle3D 
					with: 0.300942 , -0.0242042 , -0.24518
					with: 0.316601 , 0.374383 , 0.13352
					with: 0.5 , 0.0350557 , 0.0836503);
		add: (Triangle3D 
					with: 0.300942 , -0.0242042 , -0.24518
					with: 0.5 , 0.0350557 , 0.0836503
					with: 0.390506 , -0.324807 , -0.0152202);
		add: (Triangle3D 
					with: -0.037305 , -0.193799 , -0.335135
					with: 0.300942 , -0.0242042 , -0.24518
					with: 0.390506 , -0.324807 , -0.0152202);
		add: (Triangle3D 
					with: -0.037305 , -0.193799 , -0.335135
					with: 0.390506 , -0.324807 , -0.0152202
					with: 0.052259 , -0.494402 , -0.105175);
		add: (Triangle3D 
					with: -0.037305 , -0.193799 , -0.335135
					with: 0.052259 , -0.494402 , -0.105175
					with: -0.316601 , -0.374383 , -0.13352);
		add: (Triangle3D 
					with: -0.169802 , 0.179279 , 0.300486
					with: -0.279296 , -0.180584 , 0.201616
					with: 0.089564 , -0.300603 , 0.22996);
		add: (Triangle3D 
					with: -0.169802 , 0.179279 , 0.300486
					with: 0.089564 , -0.300603 , 0.22996
					with: 0.199058 , 0.0592599 , 0.328831);
		add: (Triangle3D 
					with: -0.279296 , -0.180584 , 0.201616
					with: -0.169802 , 0.179279 , 0.300486
					with: -0.390506 , 0.324807 , 0.0152203);
		add: (Triangle3D 
					with: -0.279296 , -0.180584 , 0.201616
					with: -0.390506 , 0.324807 , 0.0152203
					with: -0.5 , -0.0350557 , -0.0836503);
		add: (Triangle3D 
					with: -0.279296 , -0.180584 , 0.201616
					with: -0.5 , -0.0350557 , -0.0836503
					with: -0.316601 , -0.374383 , -0.13352);
		add: (Triangle3D 
					with: 0.089564 , -0.300603 , 0.22996
					with: -0.279296 , -0.180584 , 0.201616
					with: -0.316601 , -0.374383 , -0.13352);
		add: (Triangle3D 
					with: 0.089564 , -0.300603 , 0.22996
					with: -0.316601 , -0.374383 , -0.13352
					with: 0.052259 , -0.494402 , -0.105175);
		add: (Triangle3D 
					with: 0.089564 , -0.300603 , 0.22996
					with: 0.052259 , -0.494402 , -0.105175
					with: 0.390506 , -0.324807 , -0.0152202);
		add: (Triangle3D 
					with: 0.199058 , 0.0592599 , 0.328831
					with: 0.089564 , -0.300603 , 0.22996
					with: 0.390506 , -0.324807 , -0.0152202);
		add: (Triangle3D 
					with: 0.199058 , 0.0592599 , 0.328831
					with: 0.390506 , -0.324807 , -0.0152202
					with: 0.5 , 0.0350557 , 0.0836503);
		add: (Triangle3D 
					with: 0.199058 , 0.0592599 , 0.328831
					with: 0.5 , 0.0350557 , 0.0836503
					with: 0.316601 , 0.374383 , 0.13352);
		add: (Triangle3D 
					with: -0.169802 , 0.179279 , 0.300486
					with: 0.199058 , 0.0592599 , 0.328831
					with: 0.316601 , 0.374383 , 0.13352);
		add: (Triangle3D 
					with: -0.169802 , 0.179279 , 0.300486
					with: 0.316601 , 0.374383 , 0.13352
					with: -0.052259 , 0.494402 , 0.105175);
		add: (Triangle3D 
					with: -0.169802 , 0.179279 , 0.300486
					with: -0.052259 , 0.494402 , 0.105175
					with: -0.390506 , 0.324807 , 0.0152203);
		yourself! !

!Polyhedron class methodsFor: 'factory-square' stamp: 'emm 02/09/2012 23:40'!
squareOrthobicupola
	"self squareOrthobicupola"

	^(Triangle3DComposite new)
		add: (Triangle3D 
					with: -0.194488 , -0.212456 , -0.287843
					with: -0.212352 , 0.194358 , -0.288008
					with: 0.194462 , 0.212222 , -0.288033);
		add: (Triangle3D 
					with: -0.194488 , -0.212456 , -0.287843
					with: 0.194462 , 0.212222 , -0.288033
					with: 0.212326 , -0.194592 , -0.287869);
		add: (Triangle3D 
					with: -0.212352 , 0.194358 , -0.288008
					with: -0.194488 , -0.212456 , -0.287843
					with: -0.482136 , -0.224971 , 0.000112931);
		add: (Triangle3D 
					with: -0.212352 , 0.194358 , -0.288008
					with: -0.482136 , -0.224971 , 0.000112931
					with: -0.5 , 0.181844 , -0.0000517258);
		add: (Triangle3D 
					with: -0.212352 , 0.194358 , -0.288008
					with: -0.5 , 0.181844 , -0.0000517258
					with: -0.224971 , 0.482136 , -0.000186286);
		add: (Triangle3D 
					with: 0.194462 , 0.212222 , -0.288033
					with: -0.212352 , 0.194358 , -0.288008
					with: -0.224971 , 0.482136 , -0.000186286);
		add: (Triangle3D 
					with: 0.194462 , 0.212222 , -0.288033
					with: -0.224971 , 0.482136 , -0.000186286
					with: 0.181844 , 0.5 , -0.000211529);
		add: (Triangle3D 
					with: 0.194462 , 0.212222 , -0.288033
					with: 0.181844 , 0.5 , -0.000211529
					with: 0.482136 , 0.224971 , -0.000113084);
		add: (Triangle3D 
					with: 0.212326 , -0.194592 , -0.287869
					with: 0.194462 , 0.212222 , -0.288033
					with: 0.482136 , 0.224971 , -0.000113084);
		add: (Triangle3D 
					with: 0.212326 , -0.194592 , -0.287869
					with: 0.482136 , 0.224971 , -0.000113084
					with: 0.5 , -0.181844 , 0.0000517674);
		add: (Triangle3D 
					with: 0.212326 , -0.194592 , -0.287869
					with: 0.5 , -0.181844 , 0.0000517674
					with: 0.22497 , -0.482136 , 0.000186134);
		add: (Triangle3D 
					with: -0.194488 , -0.212456 , -0.287843
					with: 0.212326 , -0.194592 , -0.287869
					with: 0.22497 , -0.482136 , 0.000186134);
		add: (Triangle3D 
					with: -0.194488 , -0.212456 , -0.287843
					with: 0.22497 , -0.482136 , 0.000186134
					with: -0.181844 , -0.5 , 0.00021157);
		add: (Triangle3D 
					with: -0.194488 , -0.212456 , -0.287843
					with: -0.181844 , -0.5 , 0.00021157
					with: -0.482136 , -0.224971 , 0.000112931);
		add: (Triangle3D 
					with: -0.212326 , 0.194592 , 0.287869
					with: -0.194462 , -0.212222 , 0.288033
					with: 0.212352 , -0.194358 , 0.288008);
		add: (Triangle3D 
					with: -0.212326 , 0.194592 , 0.287869
					with: 0.212352 , -0.194358 , 0.288008
					with: 0.194488 , 0.212456 , 0.287843);
		add: (Triangle3D 
					with: -0.194462 , -0.212222 , 0.288033
					with: -0.212326 , 0.194592 , 0.287869
					with: -0.5 , 0.181844 , -0.0000517258);
		add: (Triangle3D 
					with: -0.194462 , -0.212222 , 0.288033
					with: -0.5 , 0.181844 , -0.0000517258
					with: -0.482136 , -0.224971 , 0.000112931);
		add: (Triangle3D 
					with: -0.194462 , -0.212222 , 0.288033
					with: -0.482136 , -0.224971 , 0.000112931
					with: -0.181844 , -0.5 , 0.00021157);
		add: (Triangle3D 
					with: 0.212352 , -0.194358 , 0.288008
					with: -0.194462 , -0.212222 , 0.288033
					with: -0.181844 , -0.5 , 0.00021157);
		add: (Triangle3D 
					with: 0.212352 , -0.194358 , 0.288008
					with: -0.181844 , -0.5 , 0.00021157
					with: 0.22497 , -0.482136 , 0.000186134);
		add: (Triangle3D 
					with: 0.212352 , -0.194358 , 0.288008
					with: 0.22497 , -0.482136 , 0.000186134
					with: 0.5 , -0.181844 , 0.0000517674);
		add: (Triangle3D 
					with: 0.194488 , 0.212456 , 0.287843
					with: 0.212352 , -0.194358 , 0.288008
					with: 0.5 , -0.181844 , 0.0000517674);
		add: (Triangle3D 
					with: 0.194488 , 0.212456 , 0.287843
					with: 0.5 , -0.181844 , 0.0000517674
					with: 0.482136 , 0.224971 , -0.000113084);
		add: (Triangle3D 
					with: 0.194488 , 0.212456 , 0.287843
					with: 0.482136 , 0.224971 , -0.000113084
					with: 0.181844 , 0.5 , -0.000211529);
		add: (Triangle3D 
					with: -0.212326 , 0.194592 , 0.287869
					with: 0.194488 , 0.212456 , 0.287843
					with: 0.181844 , 0.5 , -0.000211529);
		add: (Triangle3D 
					with: -0.212326 , 0.194592 , 0.287869
					with: 0.181844 , 0.5 , -0.000211529
					with: -0.224971 , 0.482136 , -0.000186286);
		add: (Triangle3D 
					with: -0.212326 , 0.194592 , 0.287869
					with: -0.224971 , 0.482136 , -0.000186286
					with: -0.5 , 0.181844 , -0.0000517258);
		yourself! !

!Polyhedron class methodsFor: 'factory-square' stamp: 'emm 02/09/2012 23:40'!
squarePyramid
	"self squarePyramid"

	^(Triangle3DComposite new)
		add: (Triangle3D 
					with: 0.51732 , -0.232156 , -0.400323
					with: -0.433267 , -0.182743 , -0.510549
					with: -0.48268 , 0.456077 , 0.201963);
		add: (Triangle3D 
					with: 0.51732 , -0.232156 , -0.400323
					with: -0.48268 , 0.456077 , 0.201963
					with: 0.467907 , 0.406664 , 0.312189);
		add: (Triangle3D 
					with: -0.433267 , -0.182743 , -0.510549
					with: 0.51732 , -0.232156 , -0.400323
					with: -0.0606212 , -0.391862 , 0.347129);
		add: (Triangle3D 
					with: -0.48268 , 0.456077 , 0.201963
					with: -0.433267 , -0.182743 , -0.510549
					with: -0.0606212 , -0.391862 , 0.347129);
		add: (Triangle3D 
					with: 0.467907 , 0.406664 , 0.312189
					with: -0.48268 , 0.456077 , 0.201963
					with: -0.0606212 , -0.391862 , 0.347129);
		add: (Triangle3D 
					with: 0.51732 , -0.232156 , -0.400323
					with: 0.467907 , 0.406664 , 0.312189
					with: -0.0606212 , -0.391862 , 0.347129);
		yourself! !

!Polyhedron class methodsFor: 'factory-tetrahedron' stamp: 'emm 02/09/2012 23:40'!
tetrahedron
	"self tetrahedron"

	^(Triangle3DComposite new)
		add: (Triangle3D 
					with: -0.0597259 , -0.241379 , 0.609575
					with: 0.358355 , -0.413793 , -0.365745
					with: 0.298629 , 0.586207 , 0.024383);
		add: (Triangle3D 
					with: -0.597259 , 0.0689655 , -0.268213
					with: -0.0597259 , -0.241379 , 0.609575
					with: 0.298629 , 0.586207 , 0.024383);
		add: (Triangle3D 
					with: -0.0597259 , -0.241379 , 0.609575
					with: -0.597259 , 0.0689655 , -0.268213
					with: 0.358355 , -0.413793 , -0.365745);
		add: (Triangle3D 
					with: 0.298629 , 0.586207 , 0.024383
					with: 0.358355 , -0.413793 , -0.365745
					with: -0.597259 , 0.0689655 , -0.268213);
		yourself! !

!Polyhedron class methodsFor: 'factory-hexagonal' stamp: 'emm 02/09/2012 23:40'!
tetrahemihexahedron
	"self tetrahemihexahedron"

	^(Triangle3DComposite new)
		addTriangleWith: 0.374839 , 0.325737 , 0.379426
			with: 0.0598502 , -0.5 , 0.370123
			with: 0.496475 , -0.185657 , -0.331086;
		addTriangleWith: -0.496475 , 0.185657 , 0.331086
			with: 0 , -0.00000000823148 , -0.0000000395101
			with: 0.374839 , 0.325737 , 0.379426;
		addTriangleWith: 0.374839 , 0.325737 , 0.379426
			with: 0 , -0.00000000823148 , -0.0000000395101
			with: 0.0598502 , -0.5 , 0.370123;
		addTriangleWith: 0.0598502 , -0.5 , 0.370123
			with: 0 , -0.00000000823148 , -0.0000000395101
			with: -0.496475 , 0.185657 , 0.331086;
		addTriangleWith: -0.374839 , -0.325737 , -0.379426
			with: 0.0598502 , -0.5 , 0.370123
			with: -0.496475 , 0.185657 , 0.331086;
		addTriangleWith: 0.496475 , -0.185657 , -0.331086
			with: 0 , -0.00000000823148 , -0.0000000395101
			with: -0.374839 , -0.325737 , -0.379426;
		addTriangleWith: -0.374839 , -0.325737 , -0.379426
			with: 0 , -0.00000000823148 , -0.0000000395101
			with: 0.0598502 , -0.5 , 0.370123;
		addTriangleWith: 0.0598502 , -0.5 , 0.370123
			with: 0 , -0.00000000823148 , -0.0000000395101
			with: 0.496475 , -0.185657 , -0.331086;
		addTriangleWith: 0.374839 , 0.325737 , 0.379426
			with: -0.0598502 , 0.5 , -0.370123
			with: -0.496475 , 0.185657 , 0.331086;
		addTriangleWith: 0.496475 , -0.185657 , -0.331086
			with: 0 , -0.00000000823148 , -0.0000000395101
			with: 0.374839 , 0.325737 , 0.379426;
		addTriangleWith: 0.374839 , 0.325737 , 0.379426
			with: 0 , -0.00000000823148 , -0.0000000395101
			with: -0.0598502 , 0.5 , -0.370123;
		addTriangleWith: -0.0598502 , 0.5 , -0.370123
			with: 0 , -0.00000000823148 , -0.0000000395101
			with: 0.496475 , -0.185657 , -0.331086;
		addTriangleWith: -0.374839 , -0.325737 , -0.379426
			with: -0.0598502 , 0.5 , -0.370123
			with: 0.496475 , -0.185657 , -0.331086;
		addTriangleWith: -0.496475 , 0.185657 , 0.331086
			with: 0 , -0.00000000823148 , -0.0000000395101
			with: -0.374839 , -0.325737 , -0.379426;
		addTriangleWith: -0.374839 , -0.325737 , -0.379426
			with: 0 , -0.00000000823148 , -0.0000000395101
			with: -0.0598502 , 0.5 , -0.370123;
		addTriangleWith: -0.0598502 , 0.5 , -0.370123
			with: 0 , -0.00000000823148 , -0.0000000395101
			with: -0.496475 , 0.185657 , 0.331086! !

!Polyhedron class methodsFor: 'factory-hexagonal' stamp: 'emm 02/09/2012 23:40'!
tetrakisHexahedron
	"self tetrakisHexahedron"

	^(Triangle3DComposite new)
		add: (Triangle3D 
					with: -0.10371 , -0.319697 , 0.285784
					with: -0.437685 , -0.0327183 , 0.258601
					with: -0.235341 , -0.435864 , -0.118954);
		add: (Triangle3D 
					with: -0.10371 , -0.319697 , 0.285784
					with: -0.235341 , -0.435864 , -0.118954
					with: 0.299404 , -0.393544 , 0.122445);
		add: (Triangle3D 
					with: -0.10371 , -0.319697 , 0.285784
					with: 0.299404 , -0.393544 , 0.122445
					with: 0.0970604 , 0.00960165 , 0.5);
		add: (Triangle3D 
					with: -0.10371 , -0.319697 , 0.285784
					with: 0.0970604 , 0.00960165 , 0.5
					with: -0.437685 , -0.0327183 , 0.258601);
		add: (Triangle3D 
					with: 0.151758 , -0.302359 , -0.283166
					with: -0.235341 , -0.435864 , -0.118954
					with: -0.0970605 , -0.00960161 , -0.5);
		add: (Triangle3D 
					with: 0.151758 , -0.302359 , -0.283166
					with: -0.0970605 , -0.00960161 , -0.5
					with: 0.437685 , 0.0327183 , -0.258601);
		add: (Triangle3D 
					with: 0.151758 , -0.302359 , -0.283166
					with: 0.437685 , 0.0327183 , -0.258601
					with: 0.299404 , -0.393544 , 0.122445);
		add: (Triangle3D 
					with: 0.151758 , -0.302359 , -0.283166
					with: 0.299404 , -0.393544 , 0.122445
					with: -0.235341 , -0.435864 , -0.118954);
		add: (Triangle3D 
					with: 0.401059 , 0.03174 , 0.18105
					with: 0.0970604 , 0.00960165 , 0.5
					with: 0.299404 , -0.393544 , 0.122445);
		add: (Triangle3D 
					with: 0.401059 , 0.03174 , 0.18105
					with: 0.299404 , -0.393544 , 0.122445
					with: 0.437685 , 0.0327183 , -0.258601);
		add: (Triangle3D 
					with: 0.401059 , 0.03174 , 0.18105
					with: 0.437685 , 0.0327183 , -0.258601
					with: 0.235341 , 0.435864 , 0.118954);
		add: (Triangle3D 
					with: 0.401059 , 0.03174 , 0.18105
					with: 0.235341 , 0.435864 , 0.118954
					with: 0.0970604 , 0.00960165 , 0.5);
		add: (Triangle3D 
					with: -0.151758 , 0.302359 , 0.283166
					with: -0.299405 , 0.393544 , -0.122445
					with: -0.437685 , -0.0327183 , 0.258601);
		add: (Triangle3D 
					with: -0.151758 , 0.302359 , 0.283166
					with: -0.437685 , -0.0327183 , 0.258601
					with: 0.0970604 , 0.00960165 , 0.5);
		add: (Triangle3D 
					with: -0.151758 , 0.302359 , 0.283166
					with: 0.0970604 , 0.00960165 , 0.5
					with: 0.235341 , 0.435864 , 0.118954);
		add: (Triangle3D 
					with: -0.151758 , 0.302359 , 0.283166
					with: 0.235341 , 0.435864 , 0.118954
					with: -0.299405 , 0.393544 , -0.122445);
		add: (Triangle3D 
					with: -0.401059 , -0.0317399 , -0.18105
					with: -0.299405 , 0.393544 , -0.122445
					with: -0.0970605 , -0.00960161 , -0.5);
		add: (Triangle3D 
					with: -0.401059 , -0.0317399 , -0.18105
					with: -0.0970605 , -0.00960161 , -0.5
					with: -0.235341 , -0.435864 , -0.118954);
		add: (Triangle3D 
					with: -0.401059 , -0.0317399 , -0.18105
					with: -0.235341 , -0.435864 , -0.118954
					with: -0.437685 , -0.0327183 , 0.258601);
		add: (Triangle3D 
					with: -0.401059 , -0.0317399 , -0.18105
					with: -0.437685 , -0.0327183 , 0.258601
					with: -0.299405 , 0.393544 , -0.122445);
		add: (Triangle3D 
					with: 0.10371 , 0.319697 , -0.285785
					with: 0.235341 , 0.435864 , 0.118954
					with: 0.437685 , 0.0327183 , -0.258601);
		add: (Triangle3D 
					with: 0.10371 , 0.319697 , -0.285785
					with: 0.437685 , 0.0327183 , -0.258601
					with: -0.0970605 , -0.00960161 , -0.5);
		add: (Triangle3D 
					with: 0.10371 , 0.319697 , -0.285785
					with: -0.0970605 , -0.00960161 , -0.5
					with: -0.299405 , 0.393544 , -0.122445);
		add: (Triangle3D 
					with: 0.10371 , 0.319697 , -0.285785
					with: -0.299405 , 0.393544 , -0.122445
					with: 0.235341 , 0.435864 , 0.118954);
		yourself! !

!Polyhedron class methodsFor: 'factory' stamp: 'emm 02/09/2012 23:40'!
trapezoidalHexecontahedron
	"self trapezoidalHexecontahedron"

	^(Triangle3DComposite new)
		add: (Triangle3D 
					with: -0.232657 , -0.128917 , -0.42972
					with: 0.0125612 , -0.0262251 , -0.491764
					with: 0.0802633 , -0.182051 , -0.440908);
		add: (Triangle3D 
					with: -0.232657 , -0.128917 , -0.42972
					with: 0.0802633 , -0.182051 , -0.440908
					with: -0.031322 , -0.307434 , -0.383642);
		add: (Triangle3D 
					with: -0.232657 , -0.128917 , -0.42972
					with: -0.031322 , -0.307434 , -0.383642
					with: -0.137726 , -0.38196 , -0.262912);
		add: (Triangle3D 
					with: -0.232657 , -0.128917 , -0.42972
					with: -0.137726 , -0.38196 , -0.262912
					with: -0.298521 , -0.311506 , -0.237755);
		add: (Triangle3D 
					with: -0.232657 , -0.128917 , -0.42972
					with: -0.298521 , -0.311506 , -0.237755
					with: -0.409933 , -0.189521 , -0.173268);
		add: (Triangle3D 
					with: -0.232657 , -0.128917 , -0.42972
					with: -0.409933 , -0.189521 , -0.173268
					with: -0.419775 , -0.0328133 , -0.255714);
		add: (Triangle3D 
					with: -0.232657 , -0.128917 , -0.42972
					with: -0.419775 , -0.0328133 , -0.255714
					with: -0.360177 , 0.129322 , -0.29586);
		add: (Triangle3D 
					with: -0.232657 , -0.128917 , -0.42972
					with: -0.360177 , 0.129322 , -0.29586
					with: -0.227516 , 0.1435 , -0.412701);
		add: (Triangle3D 
					with: -0.232657 , -0.128917 , -0.42972
					with: -0.227516 , 0.1435 , -0.412701
					with: -0.0572188 , 0.133939 , -0.461271);
		add: (Triangle3D 
					with: -0.232657 , -0.128917 , -0.42972
					with: -0.0572188 , 0.133939 , -0.461271
					with: 0.0125612 , -0.0262251 , -0.491764);
		add: (Triangle3D 
					with: 0.254581 , 0.0831453 , -0.428584
					with: 0.247841 , -0.185933 , -0.382991
					with: 0.0802633 , -0.182051 , -0.440908);
		add: (Triangle3D 
					with: 0.254581 , 0.0831453 , -0.428584
					with: 0.0802633 , -0.182051 , -0.440908
					with: 0.0125612 , -0.0262251 , -0.491764);
		add: (Triangle3D 
					with: 0.254581 , 0.0831453 , -0.428584
					with: 0.0125612 , -0.0262251 , -0.491764
					with: -0.0572188 , 0.133939 , -0.461271);
		add: (Triangle3D 
					with: 0.254581 , 0.0831453 , -0.428584
					with: -0.0572188 , 0.133939 , -0.461271
					with: 0.0516466 , 0.265001 , -0.41205);
		add: (Triangle3D 
					with: 0.254581 , 0.0831453 , -0.428584
					with: 0.0516466 , 0.265001 , -0.41205
					with: 0.151968 , 0.352225 , -0.294665);
		add: (Triangle3D 
					with: 0.254581 , 0.0831453 , -0.428584
					with: 0.151968 , 0.352225 , -0.294665
					with: 0.311082 , 0.285281 , -0.254009);
		add: (Triangle3D 
					with: 0.254581 , 0.0831453 , -0.428584
					with: 0.311082 , 0.285281 , -0.254009
					with: 0.418735 , 0.171144 , -0.171334);
		add: (Triangle3D 
					with: 0.254581 , 0.0831453 , -0.428584
					with: 0.418735 , 0.171144 , -0.171334
					with: 0.432336 , 0.00658823 , -0.23605);
		add: (Triangle3D 
					with: 0.254581 , 0.0831453 , -0.428584
					with: 0.432336 , 0.00658823 , -0.23605
					with: 0.374419 , -0.159057 , -0.261717);
		add: (Triangle3D 
					with: 0.254581 , 0.0831453 , -0.428584
					with: 0.374419 , -0.159057 , -0.261717
					with: 0.247841 , -0.185933 , -0.382991);
		add: (Triangle3D 
					with: 0.177989 , -0.407664 , -0.239871
					with: -0.0632414 , -0.471214 , -0.128981
					with: -0.137726 , -0.38196 , -0.262912);
		add: (Triangle3D 
					with: 0.177989 , -0.407664 , -0.239871
					with: -0.137726 , -0.38196 , -0.262912
					with: -0.031322 , -0.307434 , -0.383642);
		add: (Triangle3D 
					with: 0.177989 , -0.407664 , -0.239871
					with: -0.031322 , -0.307434 , -0.383642
					with: 0.0802633 , -0.182051 , -0.440908);
		add: (Triangle3D 
					with: 0.177989 , -0.407664 , -0.239871
					with: 0.0802633 , -0.182051 , -0.440908
					with: 0.247841 , -0.185933 , -0.382991);
		add: (Triangle3D 
					with: 0.177989 , -0.407664 , -0.239871
					with: 0.247841 , -0.185933 , -0.382991
					with: 0.374419 , -0.159057 , -0.261717);
		add: (Triangle3D 
					with: 0.177989 , -0.407664 , -0.239871
					with: 0.374419 , -0.159057 , -0.261717
					with: 0.388453 , -0.274621 , -0.127927);
		add: (Triangle3D 
					with: 0.177989 , -0.407664 , -0.239871
					with: 0.388453 , -0.274621 , -0.127927
					with: 0.338228 , -0.344755 , 0.0270246);
		add: (Triangle3D 
					with: 0.177989 , -0.407664 , -0.239871
					with: 0.338228 , -0.344755 , 0.0270246
					with: 0.196194 , -0.450934 , 0.029059);
		add: (Triangle3D 
					with: 0.177989 , -0.407664 , -0.239871
					with: 0.196194 , -0.450934 , 0.029059
					with: 0.0217049 , -0.482517 , 0.0262863);
		add: (Triangle3D 
					with: 0.177989 , -0.407664 , -0.239871
					with: 0.0217049 , -0.482517 , 0.0262863
					with: -0.0632414 , -0.471214 , -0.128981);
		add: (Triangle3D 
					with: -0.288368 , -0.414771 , 0.0147533
					with: -0.451695 , -0.196593 , -0.00105361
					with: -0.409933 , -0.189521 , -0.173268);
		add: (Triangle3D 
					with: -0.288368 , -0.414771 , 0.0147533
					with: -0.409933 , -0.189521 , -0.173268
					with: -0.298521 , -0.311506 , -0.237755);
		add: (Triangle3D 
					with: -0.288368 , -0.414771 , 0.0147533
					with: -0.298521 , -0.311506 , -0.237755
					with: -0.137726 , -0.38196 , -0.262912);
		add: (Triangle3D 
					with: -0.288368 , -0.414771 , 0.0147533
					with: -0.137726 , -0.38196 , -0.262912
					with: -0.0632414 , -0.471214 , -0.128981);
		add: (Triangle3D 
					with: -0.288368 , -0.414771 , 0.0147533
					with: -0.0632414 , -0.471214 , -0.128981
					with: 0.0217049 , -0.482517 , 0.0262863);
		add: (Triangle3D 
					with: -0.288368 , -0.414771 , 0.0147533
					with: 0.0217049 , -0.482517 , 0.0262863
					with: -0.0710047 , -0.455005 , 0.174946);
		add: (Triangle3D 
					with: -0.288368 , -0.414771 , 0.0147533
					with: -0.0710047 , -0.455005 , 0.174946
					with: -0.151968 , -0.352225 , 0.294665);
		add: (Triangle3D 
					with: -0.288368 , -0.414771 , 0.0147533
					with: -0.151968 , -0.352225 , 0.294665
					with: -0.311082 , -0.285281 , 0.254009);
		add: (Triangle3D 
					with: -0.288368 , -0.414771 , 0.0147533
					with: -0.311082 , -0.285281 , 0.254009
					with: -0.418735 , -0.171144 , 0.171334);
		add: (Triangle3D 
					with: -0.288368 , -0.414771 , 0.0147533
					with: -0.418735 , -0.171144 , 0.171334
					with: -0.451695 , -0.196593 , -0.00105361);
		add: (Triangle3D 
					with: -0.5 , 0.0716466 , -0.0165923
					with: -0.38069 , 0.258413 , -0.176
					with: -0.360177 , 0.129322 , -0.29586);
		add: (Triangle3D 
					with: -0.5 , 0.0716466 , -0.0165923
					with: -0.360177 , 0.129322 , -0.29586
					with: -0.419775 , -0.0328133 , -0.255714);
		add: (Triangle3D 
					with: -0.5 , 0.0716466 , -0.0165923
					with: -0.419775 , -0.0328133 , -0.255714
					with: -0.409933 , -0.189521 , -0.173268);
		add: (Triangle3D 
					with: -0.5 , 0.0716466 , -0.0165923
					with: -0.409933 , -0.189521 , -0.173268
					with: -0.451695 , -0.196593 , -0.00105361);
		add: (Triangle3D 
					with: -0.5 , 0.0716466 , -0.0165923
					with: -0.451695 , -0.196593 , -0.00105361
					with: -0.418735 , -0.171144 , 0.171334);
		add: (Triangle3D 
					with: -0.5 , 0.0716466 , -0.0165923
					with: -0.418735 , -0.171144 , 0.171334
					with: -0.432336 , -0.00658822 , 0.23605);
		add: (Triangle3D 
					with: -0.5 , 0.0716466 , -0.0165923
					with: -0.432336 , -0.00658822 , 0.23605
					with: -0.374419 , 0.159057 , 0.261717);
		add: (Triangle3D 
					with: -0.5 , 0.0716466 , -0.0165923
					with: -0.374419 , 0.159057 , 0.261717
					with: -0.388453 , 0.274621 , 0.127927);
		add: (Triangle3D 
					with: -0.5 , 0.0716466 , -0.0165923
					with: -0.388453 , 0.274621 , 0.127927
					with: -0.338228 , 0.344755 , -0.0270248);
		add: (Triangle3D 
					with: -0.5 , 0.0716466 , -0.0165923
					with: -0.338228 , 0.344755 , -0.0270248
					with: -0.38069 , 0.258413 , -0.176);
		add: (Triangle3D 
					with: -0.164439 , 0.379376 , -0.29059
					with: 0.0516466 , 0.265001 , -0.41205
					with: -0.0572188 , 0.133939 , -0.461271);
		add: (Triangle3D 
					with: -0.164439 , 0.379376 , -0.29059
					with: -0.0572188 , 0.133939 , -0.461271
					with: -0.227516 , 0.1435 , -0.412701);
		add: (Triangle3D 
					with: -0.164439 , 0.379376 , -0.29059
					with: -0.227516 , 0.1435 , -0.412701
					with: -0.360177 , 0.129322 , -0.29586);
		add: (Triangle3D 
					with: -0.164439 , 0.379376 , -0.29059
					with: -0.360177 , 0.129322 , -0.29586
					with: -0.38069 , 0.258413 , -0.176);
		add: (Triangle3D 
					with: -0.164439 , 0.379376 , -0.29059
					with: -0.38069 , 0.258413 , -0.176
					with: -0.338228 , 0.344755 , -0.0270248);
		add: (Triangle3D 
					with: -0.164439 , 0.379376 , -0.29059
					with: -0.338228 , 0.344755 , -0.0270248
					with: -0.196194 , 0.450934 , -0.0290589);
		add: (Triangle3D 
					with: -0.164439 , 0.379376 , -0.29059
					with: -0.196194 , 0.450934 , -0.0290589
					with: -0.0217049 , 0.482517 , -0.0262862);
		add: (Triangle3D 
					with: -0.164439 , 0.379376 , -0.29059
					with: -0.0217049 , 0.482517 , -0.0262862
					with: 0.0710047 , 0.455005 , -0.174946);
		add: (Triangle3D 
					with: -0.164439 , 0.379376 , -0.29059
					with: 0.0710047 , 0.455005 , -0.174946
					with: 0.151968 , 0.352225 , -0.294665);
		add: (Triangle3D 
					with: -0.164439 , 0.379376 , -0.29059
					with: 0.151968 , 0.352225 , -0.294665
					with: 0.0516466 , 0.265001 , -0.41205);
		add: (Triangle3D 
					with: -0.177989 , 0.407664 , 0.239871
					with: -0.24784 , 0.185933 , 0.382991
					with: -0.0802633 , 0.182051 , 0.440908);
		add: (Triangle3D 
					with: -0.177989 , 0.407664 , 0.239871
					with: -0.0802633 , 0.182051 , 0.440908
					with: 0.031322 , 0.307434 , 0.383642);
		add: (Triangle3D 
					with: -0.177989 , 0.407664 , 0.239871
					with: 0.031322 , 0.307434 , 0.383642
					with: 0.137726 , 0.38196 , 0.262912);
		add: (Triangle3D 
					with: -0.177989 , 0.407664 , 0.239871
					with: 0.137726 , 0.38196 , 0.262912
					with: 0.0632414 , 0.471214 , 0.128981);
		add: (Triangle3D 
					with: -0.177989 , 0.407664 , 0.239871
					with: 0.0632414 , 0.471214 , 0.128981
					with: -0.0217049 , 0.482517 , -0.0262862);
		add: (Triangle3D 
					with: -0.177989 , 0.407664 , 0.239871
					with: -0.0217049 , 0.482517 , -0.0262862
					with: -0.196194 , 0.450934 , -0.0290589);
		add: (Triangle3D 
					with: -0.177989 , 0.407664 , 0.239871
					with: -0.196194 , 0.450934 , -0.0290589
					with: -0.338228 , 0.344755 , -0.0270248);
		add: (Triangle3D 
					with: -0.177989 , 0.407664 , 0.239871
					with: -0.338228 , 0.344755 , -0.0270248
					with: -0.388453 , 0.274621 , 0.127927);
		add: (Triangle3D 
					with: -0.177989 , 0.407664 , 0.239871
					with: -0.388453 , 0.274621 , 0.127927
					with: -0.374419 , 0.159057 , 0.261717);
		add: (Triangle3D 
					with: -0.177989 , 0.407664 , 0.239871
					with: -0.374419 , 0.159057 , 0.261717
					with: -0.24784 , 0.185933 , 0.382991);
		add: (Triangle3D 
					with: -0.254581 , -0.0831453 , 0.428584
					with: -0.0516466 , -0.265001 , 0.41205
					with: 0.0572188 , -0.133939 , 0.461271);
		add: (Triangle3D 
					with: -0.254581 , -0.0831453 , 0.428584
					with: 0.0572188 , -0.133939 , 0.461271
					with: -0.0125612 , 0.0262251 , 0.491764);
		add: (Triangle3D 
					with: -0.254581 , -0.0831453 , 0.428584
					with: -0.0125612 , 0.0262251 , 0.491764
					with: -0.0802633 , 0.182051 , 0.440908);
		add: (Triangle3D 
					with: -0.254581 , -0.0831453 , 0.428584
					with: -0.0802633 , 0.182051 , 0.440908
					with: -0.24784 , 0.185933 , 0.382991);
		add: (Triangle3D 
					with: -0.254581 , -0.0831453 , 0.428584
					with: -0.24784 , 0.185933 , 0.382991
					with: -0.374419 , 0.159057 , 0.261717);
		add: (Triangle3D 
					with: -0.254581 , -0.0831453 , 0.428584
					with: -0.374419 , 0.159057 , 0.261717
					with: -0.432336 , -0.00658822 , 0.23605);
		add: (Triangle3D 
					with: -0.254581 , -0.0831453 , 0.428584
					with: -0.432336 , -0.00658822 , 0.23605
					with: -0.418735 , -0.171144 , 0.171334);
		add: (Triangle3D 
					with: -0.254581 , -0.0831453 , 0.428584
					with: -0.418735 , -0.171144 , 0.171334
					with: -0.311082 , -0.285281 , 0.254009);
		add: (Triangle3D 
					with: -0.254581 , -0.0831453 , 0.428584
					with: -0.311082 , -0.285281 , 0.254009
					with: -0.151968 , -0.352225 , 0.294665);
		add: (Triangle3D 
					with: -0.254581 , -0.0831453 , 0.428584
					with: -0.151968 , -0.352225 , 0.294665
					with: -0.0516466 , -0.265001 , 0.41205);
		add: (Triangle3D 
					with: 0.164439 , -0.379376 , 0.29059
					with: 0.38069 , -0.258413 , 0.176
					with: 0.360177 , -0.129322 , 0.29586);
		add: (Triangle3D 
					with: 0.164439 , -0.379376 , 0.29059
					with: 0.360177 , -0.129322 , 0.29586
					with: 0.227516 , -0.1435 , 0.412701);
		add: (Triangle3D 
					with: 0.164439 , -0.379376 , 0.29059
					with: 0.227516 , -0.1435 , 0.412701
					with: 0.0572188 , -0.133939 , 0.461271);
		add: (Triangle3D 
					with: 0.164439 , -0.379376 , 0.29059
					with: 0.0572188 , -0.133939 , 0.461271
					with: -0.0516466 , -0.265001 , 0.41205);
		add: (Triangle3D 
					with: 0.164439 , -0.379376 , 0.29059
					with: -0.0516466 , -0.265001 , 0.41205
					with: -0.151968 , -0.352225 , 0.294665);
		add: (Triangle3D 
					with: 0.164439 , -0.379376 , 0.29059
					with: -0.151968 , -0.352225 , 0.294665
					with: -0.0710047 , -0.455005 , 0.174946);
		add: (Triangle3D 
					with: 0.164439 , -0.379376 , 0.29059
					with: -0.0710047 , -0.455005 , 0.174946
					with: 0.0217049 , -0.482517 , 0.0262863);
		add: (Triangle3D 
					with: 0.164439 , -0.379376 , 0.29059
					with: 0.0217049 , -0.482517 , 0.0262863
					with: 0.196194 , -0.450934 , 0.029059);
		add: (Triangle3D 
					with: 0.164439 , -0.379376 , 0.29059
					with: 0.196194 , -0.450934 , 0.029059
					with: 0.338228 , -0.344755 , 0.0270246);
		add: (Triangle3D 
					with: 0.164439 , -0.379376 , 0.29059
					with: 0.338228 , -0.344755 , 0.0270246
					with: 0.38069 , -0.258413 , 0.176);
		add: (Triangle3D 
					with: 0.5 , -0.0716465 , 0.0165924
					with: 0.451695 , 0.196593 , 0.00105366
					with: 0.409933 , 0.189521 , 0.173268);
		add: (Triangle3D 
					with: 0.5 , -0.0716465 , 0.0165924
					with: 0.409933 , 0.189521 , 0.173268
					with: 0.419775 , 0.0328133 , 0.255714);
		add: (Triangle3D 
					with: 0.5 , -0.0716465 , 0.0165924
					with: 0.419775 , 0.0328133 , 0.255714
					with: 0.360177 , -0.129322 , 0.29586);
		add: (Triangle3D 
					with: 0.5 , -0.0716465 , 0.0165924
					with: 0.360177 , -0.129322 , 0.29586
					with: 0.38069 , -0.258413 , 0.176);
		add: (Triangle3D 
					with: 0.5 , -0.0716465 , 0.0165924
					with: 0.38069 , -0.258413 , 0.176
					with: 0.338228 , -0.344755 , 0.0270246);
		add: (Triangle3D 
					with: 0.5 , -0.0716465 , 0.0165924
					with: 0.338228 , -0.344755 , 0.0270246
					with: 0.388453 , -0.274621 , -0.127927);
		add: (Triangle3D 
					with: 0.5 , -0.0716465 , 0.0165924
					with: 0.388453 , -0.274621 , -0.127927
					with: 0.374419 , -0.159057 , -0.261717);
		add: (Triangle3D 
					with: 0.5 , -0.0716465 , 0.0165924
					with: 0.374419 , -0.159057 , -0.261717
					with: 0.432336 , 0.00658823 , -0.23605);
		add: (Triangle3D 
					with: 0.5 , -0.0716465 , 0.0165924
					with: 0.432336 , 0.00658823 , -0.23605
					with: 0.418735 , 0.171144 , -0.171334);
		add: (Triangle3D 
					with: 0.5 , -0.0716465 , 0.0165924
					with: 0.418735 , 0.171144 , -0.171334
					with: 0.451695 , 0.196593 , 0.00105366);
		add: (Triangle3D 
					with: 0.288368 , 0.414771 , -0.0147532
					with: 0.0632414 , 0.471214 , 0.128981
					with: 0.137726 , 0.38196 , 0.262912);
		add: (Triangle3D 
					with: 0.288368 , 0.414771 , -0.0147532
					with: 0.137726 , 0.38196 , 0.262912
					with: 0.298521 , 0.311506 , 0.237755);
		add: (Triangle3D 
					with: 0.288368 , 0.414771 , -0.0147532
					with: 0.298521 , 0.311506 , 0.237755
					with: 0.409933 , 0.189521 , 0.173268);
		add: (Triangle3D 
					with: 0.288368 , 0.414771 , -0.0147532
					with: 0.409933 , 0.189521 , 0.173268
					with: 0.451695 , 0.196593 , 0.00105366);
		add: (Triangle3D 
					with: 0.288368 , 0.414771 , -0.0147532
					with: 0.451695 , 0.196593 , 0.00105366
					with: 0.418735 , 0.171144 , -0.171334);
		add: (Triangle3D 
					with: 0.288368 , 0.414771 , -0.0147532
					with: 0.418735 , 0.171144 , -0.171334
					with: 0.311082 , 0.285281 , -0.254009);
		add: (Triangle3D 
					with: 0.288368 , 0.414771 , -0.0147532
					with: 0.311082 , 0.285281 , -0.254009
					with: 0.151968 , 0.352225 , -0.294665);
		add: (Triangle3D 
					with: 0.288368 , 0.414771 , -0.0147532
					with: 0.151968 , 0.352225 , -0.294665
					with: 0.0710047 , 0.455005 , -0.174946);
		add: (Triangle3D 
					with: 0.288368 , 0.414771 , -0.0147532
					with: 0.0710047 , 0.455005 , -0.174946
					with: -0.0217049 , 0.482517 , -0.0262862);
		add: (Triangle3D 
					with: 0.288368 , 0.414771 , -0.0147532
					with: -0.0217049 , 0.482517 , -0.0262862
					with: 0.0632414 , 0.471214 , 0.128981);
		add: (Triangle3D 
					with: 0.232657 , 0.128917 , 0.42972
					with: 0.031322 , 0.307434 , 0.383642
					with: -0.0802633 , 0.182051 , 0.440908);
		add: (Triangle3D 
					with: 0.232657 , 0.128917 , 0.42972
					with: -0.0802633 , 0.182051 , 0.440908
					with: -0.0125612 , 0.0262251 , 0.491764);
		add: (Triangle3D 
					with: 0.232657 , 0.128917 , 0.42972
					with: -0.0125612 , 0.0262251 , 0.491764
					with: 0.0572188 , -0.133939 , 0.461271);
		add: (Triangle3D 
					with: 0.232657 , 0.128917 , 0.42972
					with: 0.0572188 , -0.133939 , 0.461271
					with: 0.227516 , -0.1435 , 0.412701);
		add: (Triangle3D 
					with: 0.232657 , 0.128917 , 0.42972
					with: 0.227516 , -0.1435 , 0.412701
					with: 0.360177 , -0.129322 , 0.29586);
		add: (Triangle3D 
					with: 0.232657 , 0.128917 , 0.42972
					with: 0.360177 , -0.129322 , 0.29586
					with: 0.419775 , 0.0328133 , 0.255714);
		add: (Triangle3D 
					with: 0.232657 , 0.128917 , 0.42972
					with: 0.419775 , 0.0328133 , 0.255714
					with: 0.409933 , 0.189521 , 0.173268);
		add: (Triangle3D 
					with: 0.232657 , 0.128917 , 0.42972
					with: 0.409933 , 0.189521 , 0.173268
					with: 0.298521 , 0.311506 , 0.237755);
		add: (Triangle3D 
					with: 0.232657 , 0.128917 , 0.42972
					with: 0.298521 , 0.311506 , 0.237755
					with: 0.137726 , 0.38196 , 0.262912);
		add: (Triangle3D 
					with: 0.232657 , 0.128917 , 0.42972
					with: 0.137726 , 0.38196 , 0.262912
					with: 0.031322 , 0.307434 , 0.383642);
		yourself! !

!Polyhedron class methodsFor: 'factory-icosahedron' stamp: 'emm 02/09/2012 23:40'!
triakisIcosahedron
	"self triakisIcosahedron"

	^(Triangle3DComposite new)
		add: (Triangle3D 
					with: 0.163842 , -0.343589 , -0.227888
					with: -0.0902238 , -0.302164 , -0.412218
					with: 0.415635 , -0.156055 , -0.268816);
		add: (Triangle3D 
					with: 0.163842 , -0.343589 , -0.227888
					with: 0.415635 , -0.156055 , -0.268816
					with: 0.131522 , -0.5 , 0.0454877);
		add: (Triangle3D 
					with: 0.163842 , -0.343589 , -0.227888
					with: 0.131522 , -0.5 , 0.0454877
					with: -0.0902238 , -0.302164 , -0.412218);
		add: (Triangle3D 
					with: 0.141637 , -0.0865637 , -0.411432
					with: -0.0902238 , -0.302164 , -0.412218
					with: 0.0695933 , 0.216805 , -0.46639);
		add: (Triangle3D 
					with: 0.141637 , -0.0865637 , -0.411432
					with: 0.0695933 , 0.216805 , -0.46639
					with: 0.415635 , -0.156055 , -0.268816);
		add: (Triangle3D 
					with: 0.141637 , -0.0865637 , -0.411432
					with: 0.415635 , -0.156055 , -0.268816
					with: -0.0902238 , -0.302164 , -0.412218);
		add: (Triangle3D 
					with: -0.161004 , 0.00643334 , -0.41336
					with: -0.0902238 , -0.302164 , -0.412218
					with: -0.428385 , 0.1033 , -0.274194);
		add: (Triangle3D 
					with: -0.161004 , 0.00643334 , -0.41336
					with: -0.428385 , 0.1033 , -0.274194
					with: 0.0695933 , 0.216805 , -0.46639);
		add: (Triangle3D 
					with: -0.161004 , 0.00643334 , -0.41336
					with: 0.0695933 , 0.216805 , -0.46639
					with: -0.0902238 , -0.302164 , -0.412218);
		add: (Triangle3D 
					with: -0.32584 , -0.193116 , -0.231008
					with: -0.0902238 , -0.302164 , -0.412218
					with: -0.390111 , -0.33971 , 0.0421637);
		add: (Triangle3D 
					with: -0.32584 , -0.193116 , -0.231008
					with: -0.390111 , -0.33971 , 0.0421637
					with: -0.428385 , 0.1033 , -0.274194);
		add: (Triangle3D 
					with: -0.32584 , -0.193116 , -0.231008
					with: -0.428385 , 0.1033 , -0.274194
					with: -0.0902238 , -0.302164 , -0.412218);
		add: (Triangle3D 
					with: -0.125074 , -0.409442 , -0.11638
					with: -0.0902238 , -0.302164 , -0.412218
					with: 0.131522 , -0.5 , 0.0454877);
		add: (Triangle3D 
					with: -0.125074 , -0.409442 , -0.11638
					with: 0.131522 , -0.5 , 0.0454877
					with: -0.390111 , -0.33971 , 0.0421637);
		add: (Triangle3D 
					with: -0.125074 , -0.409442 , -0.11638
					with: -0.390111 , -0.33971 , 0.0421637
					with: -0.0902238 , -0.302164 , -0.412218);
		add: (Triangle3D 
					with: 0.32584 , 0.193116 , 0.231008
					with: 0.0902238 , 0.302164 , 0.412218
					with: 0.428385 , -0.1033 , 0.274194);
		add: (Triangle3D 
					with: 0.32584 , 0.193116 , 0.231008
					with: 0.428385 , -0.1033 , 0.274194
					with: 0.390111 , 0.33971 , -0.0421637);
		add: (Triangle3D 
					with: 0.32584 , 0.193116 , 0.231008
					with: 0.390111 , 0.33971 , -0.0421637
					with: 0.0902238 , 0.302164 , 0.412218);
		add: (Triangle3D 
					with: 0.125074 , 0.409442 , 0.11638
					with: 0.0902238 , 0.302164 , 0.412218
					with: 0.390111 , 0.33971 , -0.0421637);
		add: (Triangle3D 
					with: 0.125074 , 0.409442 , 0.11638
					with: 0.390111 , 0.33971 , -0.0421637
					with: -0.131522 , 0.5 , -0.0454878);
		add: (Triangle3D 
					with: 0.125074 , 0.409442 , 0.11638
					with: -0.131522 , 0.5 , -0.0454878
					with: 0.0902238 , 0.302164 , 0.412218);
		add: (Triangle3D 
					with: -0.163842 , 0.343589 , 0.227888
					with: 0.0902238 , 0.302164 , 0.412218
					with: -0.131522 , 0.5 , -0.0454878);
		add: (Triangle3D 
					with: -0.163842 , 0.343589 , 0.227888
					with: -0.131522 , 0.5 , -0.0454878
					with: -0.415635 , 0.156055 , 0.268816);
		add: (Triangle3D 
					with: -0.163842 , 0.343589 , 0.227888
					with: -0.415635 , 0.156055 , 0.268816
					with: 0.0902238 , 0.302164 , 0.412218);
		add: (Triangle3D 
					with: -0.141637 , 0.0865637 , 0.411432
					with: 0.0902238 , 0.302164 , 0.412218
					with: -0.415635 , 0.156055 , 0.268816);
		add: (Triangle3D 
					with: -0.141637 , 0.0865637 , 0.411432
					with: -0.415635 , 0.156055 , 0.268816
					with: -0.0695933 , -0.216805 , 0.46639);
		add: (Triangle3D 
					with: -0.141637 , 0.0865637 , 0.411432
					with: -0.0695933 , -0.216805 , 0.46639
					with: 0.0902238 , 0.302164 , 0.412218);
		add: (Triangle3D 
					with: 0.161004 , -0.00643336 , 0.41336
					with: 0.0902238 , 0.302164 , 0.412218
					with: -0.0695933 , -0.216805 , 0.46639);
		add: (Triangle3D 
					with: 0.161004 , -0.00643336 , 0.41336
					with: -0.0695933 , -0.216805 , 0.46639
					with: 0.428385 , -0.1033 , 0.274194);
		add: (Triangle3D 
					with: 0.161004 , -0.00643336 , 0.41336
					with: 0.428385 , -0.1033 , 0.274194
					with: 0.0902238 , 0.302164 , 0.412218);
		add: (Triangle3D 
					with: 0.3498 , -0.272282 , 0.0182391
					with: 0.428385 , -0.1033 , 0.274194
					with: 0.131522 , -0.5 , 0.0454877);
		add: (Triangle3D 
					with: 0.3498 , -0.272282 , 0.0182391
					with: 0.131522 , -0.5 , 0.0454877
					with: 0.415635 , -0.156055 , -0.268816);
		add: (Triangle3D 
					with: 0.3498 , -0.272282 , 0.0182391
					with: 0.415635 , -0.156055 , -0.268816
					with: 0.428385 , -0.1033 , 0.274194);
		add: (Triangle3D 
					with: 0.442523 , 0.0288127 , -0.0131901
					with: 0.415635 , -0.156055 , -0.268816
					with: 0.390111 , 0.33971 , -0.0421637);
		add: (Triangle3D 
					with: 0.442523 , 0.0288127 , -0.0131901
					with: 0.390111 , 0.33971 , -0.0421637
					with: 0.428385 , -0.1033 , 0.274194);
		add: (Triangle3D 
					with: 0.442523 , 0.0288127 , -0.0131901
					with: 0.428385 , -0.1033 , 0.274194
					with: 0.415635 , -0.156055 , -0.268816);
		add: (Triangle3D 
					with: 0.31387 , 0.143593 , -0.278741
					with: 0.390111 , 0.33971 , -0.0421637
					with: 0.415635 , -0.156055 , -0.268816);
		add: (Triangle3D 
					with: 0.31387 , 0.143593 , -0.278741
					with: 0.415635 , -0.156055 , -0.268816
					with: 0.0695933 , 0.216805 , -0.46639);
		add: (Triangle3D 
					with: 0.31387 , 0.143593 , -0.278741
					with: 0.0695933 , 0.216805 , -0.46639
					with: 0.390111 , 0.33971 , -0.0421637);
		add: (Triangle3D 
					with: 0.117676 , 0.378835 , -0.198663
					with: 0.0695933 , 0.216805 , -0.46639
					with: -0.131522 , 0.5 , -0.0454878);
		add: (Triangle3D 
					with: 0.117676 , 0.378835 , -0.198663
					with: -0.131522 , 0.5 , -0.0454878
					with: 0.390111 , 0.33971 , -0.0421637);
		add: (Triangle3D 
					with: 0.117676 , 0.378835 , -0.198663
					with: 0.390111 , 0.33971 , -0.0421637
					with: 0.0695933 , 0.216805 , -0.46639);
		add: (Triangle3D 
					with: -0.175812 , 0.294065 , -0.281862
					with: -0.131522 , 0.5 , -0.0454878
					with: 0.0695933 , 0.216805 , -0.46639);
		add: (Triangle3D 
					with: -0.175812 , 0.294065 , -0.281862
					with: 0.0695933 , 0.216805 , -0.46639
					with: -0.428385 , 0.1033 , -0.274194);
		add: (Triangle3D 
					with: -0.175812 , 0.294065 , -0.281862
					with: -0.428385 , 0.1033 , -0.274194
					with: -0.131522 , 0.5 , -0.0454878);
		add: (Triangle3D 
					with: -0.3498 , 0.272282 , -0.0182391
					with: -0.428385 , 0.1033 , -0.274194
					with: -0.415635 , 0.156055 , 0.268816);
		add: (Triangle3D 
					with: -0.3498 , 0.272282 , -0.0182391
					with: -0.415635 , 0.156055 , 0.268816
					with: -0.131522 , 0.5 , -0.0454878);
		add: (Triangle3D 
					with: -0.3498 , 0.272282 , -0.0182391
					with: -0.131522 , 0.5 , -0.0454878
					with: -0.428385 , 0.1033 , -0.274194);
		add: (Triangle3D 
					with: -0.442523 , -0.0288126 , 0.0131901
					with: -0.415635 , 0.156055 , 0.268816
					with: -0.428385 , 0.1033 , -0.274194);
		add: (Triangle3D 
					with: -0.442523 , -0.0288126 , 0.0131901
					with: -0.428385 , 0.1033 , -0.274194
					with: -0.390111 , -0.33971 , 0.0421637);
		add: (Triangle3D 
					with: -0.442523 , -0.0288126 , 0.0131901
					with: -0.390111 , -0.33971 , 0.0421637
					with: -0.415635 , 0.156055 , 0.268816);
		add: (Triangle3D 
					with: -0.31387 , -0.143593 , 0.278741
					with: -0.390111 , -0.33971 , 0.0421637
					with: -0.0695933 , -0.216805 , 0.46639);
		add: (Triangle3D 
					with: -0.31387 , -0.143593 , 0.278741
					with: -0.0695933 , -0.216805 , 0.46639
					with: -0.415635 , 0.156055 , 0.268816);
		add: (Triangle3D 
					with: -0.31387 , -0.143593 , 0.278741
					with: -0.415635 , 0.156055 , 0.268816
					with: -0.390111 , -0.33971 , 0.0421637);
		add: (Triangle3D 
					with: -0.117677 , -0.378835 , 0.198663
					with: -0.0695933 , -0.216805 , 0.46639
					with: -0.390111 , -0.33971 , 0.0421637);
		add: (Triangle3D 
					with: -0.117677 , -0.378835 , 0.198663
					with: -0.390111 , -0.33971 , 0.0421637
					with: 0.131522 , -0.5 , 0.0454877);
		add: (Triangle3D 
					with: -0.117677 , -0.378835 , 0.198663
					with: 0.131522 , -0.5 , 0.0454877
					with: -0.0695933 , -0.216805 , 0.46639);
		add: (Triangle3D 
					with: 0.175812 , -0.294065 , 0.281862
					with: 0.131522 , -0.5 , 0.0454877
					with: 0.428385 , -0.1033 , 0.274194);
		add: (Triangle3D 
					with: 0.175812 , -0.294065 , 0.281862
					with: 0.428385 , -0.1033 , 0.274194
					with: -0.0695933 , -0.216805 , 0.46639);
		add: (Triangle3D 
					with: 0.175812 , -0.294065 , 0.281862
					with: -0.0695933 , -0.216805 , 0.46639
					with: 0.131522 , -0.5 , 0.0454877);
		yourself! !

!Polyhedron class methodsFor: 'factory-octagonal' stamp: 'emm 02/09/2012 23:40'!
triakisOctahedron
	"self triakisOctahedron"

	^(Triangle3DComposite new)
		add: (Triangle3D 
					with: -0.102981 , 0.314993 , 0.217033
					with: -0.233423 , -0.0198995 , 0.5
					with: 0.346154 , 0.391994 , 0.177202);
		add: (Triangle3D 
					with: -0.102981 , 0.314993 , 0.217033
					with: 0.346154 , 0.391994 , 0.177202
					with: -0.361349 , 0.388365 , -0.153238);
		add: (Triangle3D 
					with: -0.102981 , 0.314993 , 0.217033
					with: -0.361349 , 0.388365 , -0.153238
					with: -0.233423 , -0.0198995 , 0.5);
		add: (Triangle3D 
					with: -0.389745 , -0.00974558 , 0.0702341
					with: -0.361349 , 0.388365 , -0.153238
					with: -0.346154 , -0.391994 , -0.177202);
		add: (Triangle3D 
					with: -0.389745 , -0.00974558 , 0.0702341
					with: -0.346154 , -0.391994 , -0.177202
					with: -0.233423 , -0.0198995 , 0.5);
		add: (Triangle3D 
					with: -0.389745 , -0.00974558 , 0.0702341
					with: -0.233423 , -0.0198995 , 0.5
					with: -0.361349 , 0.388365 , -0.153238);
		add: (Triangle3D 
					with: -0.19637 , 0.00673966 , -0.34398
					with: -0.346154 , -0.391994 , -0.177202
					with: -0.361349 , 0.388365 , -0.153238);
		add: (Triangle3D 
					with: -0.19637 , 0.00673966 , -0.34398
					with: -0.361349 , 0.388365 , -0.153238
					with: 0.233423 , 0.0198994 , -0.5);
		add: (Triangle3D 
					with: -0.19637 , 0.00673966 , -0.34398
					with: 0.233423 , 0.0198994 , -0.5
					with: -0.346154 , -0.391994 , -0.177202);
		add: (Triangle3D 
					with: 0.0903933 , 0.331478 , -0.197181
					with: 0.346154 , 0.391994 , 0.177202
					with: 0.233423 , 0.0198994 , -0.5);
		add: (Triangle3D 
					with: 0.0903933 , 0.331478 , -0.197181
					with: 0.233423 , 0.0198994 , -0.5
					with: -0.361349 , 0.388365 , -0.153238);
		add: (Triangle3D 
					with: 0.0903933 , 0.331478 , -0.197181
					with: -0.361349 , 0.388365 , -0.153238
					with: 0.346154 , 0.391994 , 0.177202);
		add: (Triangle3D 
					with: -0.0903934 , -0.331478 , 0.197181
					with: -0.233423 , -0.0198995 , 0.5
					with: -0.346154 , -0.391994 , -0.177202);
		add: (Triangle3D 
					with: -0.0903934 , -0.331478 , 0.197181
					with: -0.346154 , -0.391994 , -0.177202
					with: 0.361349 , -0.388365 , 0.153238);
		add: (Triangle3D 
					with: -0.0903934 , -0.331478 , 0.197181
					with: 0.361349 , -0.388365 , 0.153238
					with: -0.233423 , -0.0198995 , 0.5);
		add: (Triangle3D 
					with: 0.102981 , -0.314993 , -0.217033
					with: 0.233423 , 0.0198994 , -0.5
					with: 0.361349 , -0.388365 , 0.153238);
		add: (Triangle3D 
					with: 0.102981 , -0.314993 , -0.217033
					with: 0.361349 , -0.388365 , 0.153238
					with: -0.346154 , -0.391994 , -0.177202);
		add: (Triangle3D 
					with: 0.102981 , -0.314993 , -0.217033
					with: -0.346154 , -0.391994 , -0.177202
					with: 0.233423 , 0.0198994 , -0.5);
		add: (Triangle3D 
					with: 0.389745 , 0.00974554 , -0.0702341
					with: 0.361349 , -0.388365 , 0.153238
					with: 0.233423 , 0.0198994 , -0.5);
		add: (Triangle3D 
					with: 0.389745 , 0.00974554 , -0.0702341
					with: 0.233423 , 0.0198994 , -0.5
					with: 0.346154 , 0.391994 , 0.177202);
		add: (Triangle3D 
					with: 0.389745 , 0.00974554 , -0.0702341
					with: 0.346154 , 0.391994 , 0.177202
					with: 0.361349 , -0.388365 , 0.153238);
		add: (Triangle3D 
					with: 0.19637 , -0.00673969 , 0.34398
					with: 0.346154 , 0.391994 , 0.177202
					with: -0.233423 , -0.0198995 , 0.5);
		add: (Triangle3D 
					with: 0.19637 , -0.00673969 , 0.34398
					with: -0.233423 , -0.0198995 , 0.5
					with: 0.361349 , -0.388365 , 0.153238);
		add: (Triangle3D 
					with: 0.19637 , -0.00673969 , 0.34398
					with: 0.361349 , -0.388365 , 0.153238
					with: 0.346154 , 0.391994 , 0.177202);
		yourself! !

!Polyhedron class methodsFor: 'factory-triangular' stamp: 'emm 02/09/2012 23:40'!
triangularCupola
	"self triangularCupola"

	^(Triangle3DComposite new)
		add: (Triangle3D 
					with: -0.449344 , 0.272717 , 0.116795
					with: -0.0449356 , 0.293696 , 0.456398
					with: 0.441798 , 0.164544 , 0.296002);
		add: (Triangle3D 
					with: -0.449344 , 0.272717 , 0.116795
					with: 0.441798 , 0.164544 , 0.296002
					with: 0.524123 , 0.0144121 , -0.203998);
		add: (Triangle3D 
					with: -0.449344 , 0.272717 , 0.116795
					with: 0.524123 , 0.0144121 , -0.203998
					with: 0.119714 , -0.00656743 , -0.543602);
		add: (Triangle3D 
					with: -0.449344 , 0.272717 , 0.116795
					with: 0.119714 , -0.00656743 , -0.543602
					with: -0.36702 , 0.122585 , -0.383205);
		add: (Triangle3D 
					with: -0.331899 , -0.230969 , 0.0080541
					with: 0.154835 , -0.360121 , -0.152343
					with: 0.0725098 , -0.209989 , 0.347657);
		add: (Triangle3D 
					with: 0.154835 , -0.360121 , -0.152343
					with: -0.331899 , -0.230969 , 0.0080541
					with: -0.36702 , 0.122585 , -0.383205);
		add: (Triangle3D 
					with: 0.154835 , -0.360121 , -0.152343
					with: -0.36702 , 0.122585 , -0.383205
					with: 0.119714 , -0.00656743 , -0.543602);
		add: (Triangle3D 
					with: 0.154835 , -0.360121 , -0.152343
					with: 0.119714 , -0.00656743 , -0.543602
					with: 0.524123 , 0.0144121 , -0.203998);
		add: (Triangle3D 
					with: 0.0725098 , -0.209989 , 0.347657
					with: 0.154835 , -0.360121 , -0.152343
					with: 0.524123 , 0.0144121 , -0.203998);
		add: (Triangle3D 
					with: 0.0725098 , -0.209989 , 0.347657
					with: 0.524123 , 0.0144121 , -0.203998
					with: 0.441798 , 0.164544 , 0.296002);
		add: (Triangle3D 
					with: 0.0725098 , -0.209989 , 0.347657
					with: 0.441798 , 0.164544 , 0.296002
					with: -0.0449356 , 0.293696 , 0.456398);
		add: (Triangle3D 
					with: -0.331899 , -0.230969 , 0.0080541
					with: 0.0725098 , -0.209989 , 0.347657
					with: -0.0449356 , 0.293696 , 0.456398);
		add: (Triangle3D 
					with: -0.331899 , -0.230969 , 0.0080541
					with: -0.0449356 , 0.293696 , 0.456398
					with: -0.449344 , 0.272717 , 0.116795);
		add: (Triangle3D 
					with: -0.331899 , -0.230969 , 0.0080541
					with: -0.449344 , 0.272717 , 0.116795
					with: -0.36702 , 0.122585 , -0.383205);
		yourself! !

!Polyhedron class methodsFor: 'factory-triangular' stamp: 'emm 02/09/2012 23:40'!
triangularOrthobicupola
	"self triangularOrthobicupola"

	^(Triangle3DComposite new)
		add: (Triangle3D 
					with: -0.321393 , -0.131794 , -0.381301
					with: 0.0309667 , 0.237219 , -0.456971
					with: 0.178607 , -0.254891 , -0.41132);
		add: (Triangle3D 
					with: 0.0309667 , 0.237219 , -0.456971
					with: -0.321393 , -0.131794 , -0.381301
					with: -0.5 , 0.123097 , 0.0300187);
		add: (Triangle3D 
					with: 0.0309667 , 0.237219 , -0.456971
					with: -0.5 , 0.123097 , 0.0300187
					with: -0.14764 , 0.49211 , -0.0456504);
		add: (Triangle3D 
					with: 0.0309667 , 0.237219 , -0.456971
					with: -0.14764 , 0.49211 , -0.0456504
					with: 0.35236 , 0.369013 , -0.0756692);
		add: (Triangle3D 
					with: 0.178607 , -0.254891 , -0.41132
					with: 0.0309667 , 0.237219 , -0.456971
					with: 0.35236 , 0.369013 , -0.0756692);
		add: (Triangle3D 
					with: 0.178607 , -0.254891 , -0.41132
					with: 0.35236 , 0.369013 , -0.0756692
					with: 0.5 , -0.123097 , -0.0300188);
		add: (Triangle3D 
					with: 0.178607 , -0.254891 , -0.41132
					with: 0.5 , -0.123097 , -0.0300188
					with: 0.14764 , -0.49211 , 0.0456504);
		add: (Triangle3D 
					with: -0.321393 , -0.131794 , -0.381301
					with: 0.178607 , -0.254891 , -0.41132
					with: 0.14764 , -0.49211 , 0.0456504);
		add: (Triangle3D 
					with: -0.321393 , -0.131794 , -0.381301
					with: 0.14764 , -0.49211 , 0.0456504
					with: -0.35236 , -0.369013 , 0.0756692);
		add: (Triangle3D 
					with: -0.321393 , -0.131794 , -0.381301
					with: -0.35236 , -0.369013 , 0.0756692
					with: -0.5 , 0.123097 , 0.0300187);
		add: (Triangle3D 
					with: 0.105514 , 0.336863 , 0.376091
					with: -0.246847 , -0.03215 , 0.45176
					with: 0.253153 , -0.155247 , 0.421741);
		add: (Triangle3D 
					with: -0.246847 , -0.03215 , 0.45176
					with: 0.105514 , 0.336863 , 0.376091
					with: -0.14764 , 0.49211 , -0.0456504);
		add: (Triangle3D 
					with: -0.246847 , -0.03215 , 0.45176
					with: -0.14764 , 0.49211 , -0.0456504
					with: -0.5 , 0.123097 , 0.0300187);
		add: (Triangle3D 
					with: -0.246847 , -0.03215 , 0.45176
					with: -0.5 , 0.123097 , 0.0300187
					with: -0.35236 , -0.369013 , 0.0756692);
		add: (Triangle3D 
					with: 0.253153 , -0.155247 , 0.421741
					with: -0.246847 , -0.03215 , 0.45176
					with: -0.35236 , -0.369013 , 0.0756692);
		add: (Triangle3D 
					with: 0.253153 , -0.155247 , 0.421741
					with: -0.35236 , -0.369013 , 0.0756692
					with: 0.14764 , -0.49211 , 0.0456504);
		add: (Triangle3D 
					with: 0.253153 , -0.155247 , 0.421741
					with: 0.14764 , -0.49211 , 0.0456504
					with: 0.5 , -0.123097 , -0.0300188);
		add: (Triangle3D 
					with: 0.105514 , 0.336863 , 0.376091
					with: 0.253153 , -0.155247 , 0.421741
					with: 0.5 , -0.123097 , -0.0300188);
		add: (Triangle3D 
					with: 0.105514 , 0.336863 , 0.376091
					with: 0.5 , -0.123097 , -0.0300188
					with: 0.35236 , 0.369013 , -0.0756692);
		add: (Triangle3D 
					with: 0.105514 , 0.336863 , 0.376091
					with: 0.35236 , 0.369013 , -0.0756692
					with: -0.14764 , 0.49211 , -0.0456504);
		yourself! !

!Polyhedron class methodsFor: 'factory-triangular' stamp: 'emm 02/09/2012 23:40'!
triangularPrism
	"self triangularPrism "

	^(Triangle3DComposite new)
		add: (Triangle3D 
					with: 0.5 , -0.288675 , -0.5
					with: -0.5 , -0.288675 , -0.5
					with: 0 , 0.57735 , -0.5);
		add: (Triangle3D 
					with: -0.5 , -0.288675 , 0.5
					with: 0.5 , -0.288675 , 0.5
					with: 0 , 0.57735 , 0.5);
		add: (Triangle3D 
					with: 0 , 0.57735 , 0.5
					with: 0 , 0.57735 , -0.5
					with: -0.5 , -0.288675 , -0.5);
		add: (Triangle3D 
					with: 0 , 0.57735 , 0.5
					with: -0.5 , -0.288675 , -0.5
					with: -0.5 , -0.288675 , 0.5);
		add: (Triangle3D 
					with: -0.5 , -0.288675 , 0.5
					with: -0.5 , -0.288675 , -0.5
					with: 0.5 , -0.288675 , -0.5);
		add: (Triangle3D 
					with: -0.5 , -0.288675 , 0.5
					with: 0.5 , -0.288675 , -0.5
					with: 0.5 , -0.288675 , 0.5);
		add: (Triangle3D 
					with: 0.5 , -0.288675 , 0.5
					with: 0.5 , -0.288675 , -0.5
					with: 0 , 0.57735 , -0.5);
		add: (Triangle3D 
					with: 0.5 , -0.288675 , 0.5
					with: 0 , 0.57735 , -0.5
					with: 0 , 0.57735 , 0.5);
		yourself! !

!Polyhedron class methodsFor: 'factory-dodecahedron' stamp: 'emm 02/09/2012 23:40'!
triaugmentedDodecahedron
	"self triaugmentedDodecahedron"

	^(Triangle3DComposite new)
		addTriangleWith: 0.395603 , -0.260867 , 0.198241
			with: 0.323631 , -0.38165 , -0.131141
			with: 0.35204 , -0.106473 , -0.358586;
		addTriangleWith: 0.395603 , -0.260867 , 0.198241
			with: 0.35204 , -0.106473 , -0.358586
			with: 0.441569 , 0.184379 , -0.169773;
		addTriangleWith: 0.395603 , -0.260867 , 0.198241
			with: 0.441569 , 0.184379 , -0.169773
			with: 0.468492 , 0.0889586 , 0.174365;
		addTriangleWith: -0.079937 , 0.276998 , -0.404815
			with: 0.174592 , 0.421378 , -0.198344
			with: 0.441569 , 0.184379 , -0.169773;
		addTriangleWith: -0.079937 , 0.276998 , -0.404815
			with: 0.441569 , 0.184379 , -0.169773
			with: 0.35204 , -0.106473 , -0.358586;
		addTriangleWith: -0.079937 , 0.276998 , -0.404815
			with: 0.35204 , -0.106473 , -0.358586
			with: 0.0297319 , -0.0492313 , -0.50385;
		addTriangleWith: -0.00945145 , 0.0271831 , 0.49615
			with: 0.100217 , -0.299046 , 0.397115
			with: 0.395603 , -0.260867 , 0.198241;
		addTriangleWith: -0.00945145 , 0.0271831 , 0.49615
			with: 0.395603 , -0.260867 , 0.198241
			with: 0.468492 , 0.0889586 , 0.174365;
		addTriangleWith: -0.00945145 , 0.0271831 , 0.49615
			with: 0.468492 , 0.0889586 , 0.174365
			with: 0.218155 , 0.266983 , 0.358483;
		addTriangleWith: -0.154312 , -0.443426 , 0.190644
			with: -0.0162345 , -0.494478 , -0.135836
			with: 0.323631 , -0.38165 , -0.131141;
		addTriangleWith: -0.154312 , -0.443426 , 0.190644
			with: 0.323631 , -0.38165 , -0.131141
			with: 0.395603 , -0.260867 , 0.198241;
		addTriangleWith: -0.154312 , -0.443426 , 0.190644
			with: 0.395603 , -0.260867 , 0.198241
			with: 0.100217 , -0.299046 , 0.397115;
		addTriangleWith: -0.197874 , -0.289032 , -0.366183
			with: 0.0297319 , -0.0492313 , -0.50385
			with: 0.35204 , -0.106473 , -0.358586;
		addTriangleWith: -0.197874 , -0.289032 , -0.366183
			with: 0.35204 , -0.106473 , -0.358586
			with: 0.323631 , -0.38165 , -0.131141;
		addTriangleWith: -0.197874 , -0.289032 , -0.366183
			with: 0.323631 , -0.38165 , -0.131141
			with: -0.0162345 , -0.494478 , -0.135836;
		addTriangleWith: -0.0162345 , -0.494478 , -0.135836
			with: -0.154312 , -0.443426 , 0.190644
			with: -0.421289 , -0.206428 , 0.162073;
		addTriangleWith: -0.0162345 , -0.494478 , -0.135836
			with: -0.421289 , -0.206428 , 0.162073
			with: -0.448212 , -0.111007 , -0.182065;
		addTriangleWith: -0.0162345 , -0.494478 , -0.135836
			with: -0.448212 , -0.111007 , -0.182065
			with: -0.197874 , -0.289032 , -0.366183;
		addTriangleWith: 0.218155 , 0.266983 , 0.358483
			with: 0.036515 , 0.47243 , 0.128136
			with: -0.303351 , 0.359602 , 0.123441;
		addTriangleWith: 0.218155 , 0.266983 , 0.358483
			with: -0.303351 , 0.359602 , 0.123441
			with: -0.33176 , 0.0844248 , 0.350886;
		addTriangleWith: 0.218155 , 0.266983 , 0.358483
			with: -0.33176 , 0.0844248 , 0.350886
			with: -0.00945145 , 0.0271831 , 0.49615;
		addTriangleWith: 0.174592 , 0.421378 , -0.198344
			with: -0.079937 , 0.276998 , -0.404815
			with: -0.375322 , 0.238819 , -0.205941;
		addTriangleWith: 0.174592 , 0.421378 , -0.198344
			with: -0.375322 , 0.238819 , -0.205941
			with: -0.303351 , 0.359602 , 0.123441;
		addTriangleWith: 0.174592 , 0.421378 , -0.198344
			with: -0.303351 , 0.359602 , 0.123441
			with: 0.036515 , 0.47243 , 0.128136;
		addTriangleWith: -0.375322 , 0.238819 , -0.205941
			with: -0.448212 , -0.111007 , -0.182065
			with: -0.421289 , -0.206428 , 0.162073;
		addTriangleWith: -0.375322 , 0.238819 , -0.205941
			with: -0.421289 , -0.206428 , 0.162073
			with: -0.33176 , 0.0844248 , 0.350886;
		addTriangleWith: -0.375322 , 0.238819 , -0.205941
			with: -0.33176 , 0.0844248 , 0.350886
			with: -0.303351 , 0.359602 , 0.123441;
		addTriangleWith: -0.245215 , -0.241317 , 0.471979
			with: -0.33176 , 0.0844248 , 0.350886
			with: -0.421289 , -0.206428 , 0.162073;
		addTriangleWith: -0.245215 , -0.241317 , 0.471979
			with: -0.421289 , -0.206428 , 0.162073
			with: -0.154312 , -0.443426 , 0.190644;
		addTriangleWith: -0.245215 , -0.241317 , 0.471979
			with: -0.00945145 , 0.0271831 , 0.49615
			with: -0.33176 , 0.0844248 , 0.350886;
		addTriangleWith: -0.245215 , -0.241317 , 0.471979
			with: 0.100217 , -0.299046 , 0.397115
			with: -0.00945145 , 0.0271831 , 0.49615;
		addTriangleWith: 0.100217 , -0.299046 , 0.397115
			with: -0.245215 , -0.241317 , 0.471979
			with: -0.154312 , -0.443426 , 0.190644;
		addTriangleWith: 0.389546 , 0.427451 , 0.0880462
			with: 0.468492 , 0.0889586 , 0.174365
			with: 0.441569 , 0.184379 , -0.169773;
		addTriangleWith: 0.389546 , 0.427451 , 0.0880462
			with: 0.441569 , 0.184379 , -0.169773
			with: 0.174592 , 0.421378 , -0.198344;
		addTriangleWith: 0.389546 , 0.427451 , 0.0880462
			with: 0.218155 , 0.266983 , 0.358483
			with: 0.468492 , 0.0889586 , 0.174365;
		addTriangleWith: 0.389546 , 0.427451 , 0.0880462
			with: 0.036515 , 0.47243 , 0.128136
			with: 0.218155 , 0.266983 , 0.358483;
		addTriangleWith: 0.036515 , 0.47243 , 0.128136
			with: 0.389546 , 0.427451 , 0.0880462
			with: 0.174592 , 0.421378 , -0.198344;
		addTriangleWith: -0.3203 , 0.0247984 , -0.487772
			with: -0.448212 , -0.111007 , -0.182065
			with: -0.375322 , 0.238819 , -0.205941;
		addTriangleWith: -0.3203 , 0.0247984 , -0.487772
			with: -0.375322 , 0.238819 , -0.205941
			with: -0.079937 , 0.276998 , -0.404815;
		addTriangleWith: -0.3203 , 0.0247984 , -0.487772
			with: -0.197874 , -0.289032 , -0.366183
			with: -0.448212 , -0.111007 , -0.182065;
		addTriangleWith: -0.3203 , 0.0247984 , -0.487772
			with: 0.0297319 , -0.0492313 , -0.50385
			with: -0.197874 , -0.289032 , -0.366183;
		addTriangleWith: 0.0297319 , -0.0492313 , -0.50385
			with: -0.3203 , 0.0247984 , -0.487772
			with: -0.079937 , 0.276998 , -0.404815! !

!Polyhedron class methodsFor: 'factory-hexagonal' stamp: 'emm 02/09/2012 23:40'!
triaugmentedHexagonalPrism
	"self triaugmentedHexagonalPrism"

	^(Triangle3DComposite new)
		add: (Triangle3D 
					with: -0.462439 , -0.0268676 , -0.0754305
					with: -0.23139 , -0.344757 , -0.228969
					with: 0.126166 , -0.458156 , -0.0358218);
		add: (Triangle3D 
					with: -0.462439 , -0.0268676 , -0.0754305
					with: 0.126166 , -0.458156 , -0.0358218
					with: 0.252673 , -0.253665 , 0.310863);
		add: (Triangle3D 
					with: -0.462439 , -0.0268676 , -0.0754305
					with: 0.252673 , -0.253665 , 0.310863
					with: 0.0216249 , 0.0642251 , 0.464401);
		add: (Triangle3D 
					with: -0.462439 , -0.0268676 , -0.0754305
					with: 0.0216249 , 0.0642251 , 0.464401
					with: -0.335931 , 0.177624 , 0.271255);
		add: (Triangle3D 
					with: 0.237314 , 0.336606 , 0.225032
					with: 0.468363 , 0.0187166 , 0.0714936
					with: 0.341856 , -0.185775 , -0.275191);
		add: (Triangle3D 
					with: 0.237314 , 0.336606 , 0.225032
					with: 0.341856 , -0.185775 , -0.275191
					with: -0.0157005 , -0.0723761 , -0.468338);
		add: (Triangle3D 
					with: 0.237314 , 0.336606 , 0.225032
					with: -0.0157005 , -0.0723761 , -0.468338
					with: -0.246749 , 0.245514 , -0.3148);
		add: (Triangle3D 
					with: 0.237314 , 0.336606 , 0.225032
					with: -0.246749 , 0.245514 , -0.3148
					with: -0.120242 , 0.450005 , 0.031885);
		add: (Triangle3D 
					with: 0.126166 , -0.458156 , -0.0358218
					with: -0.23139 , -0.344757 , -0.228969
					with: -0.0157005 , -0.0723761 , -0.468338);
		add: (Triangle3D 
					with: 0.126166 , -0.458156 , -0.0358218
					with: -0.0157005 , -0.0723761 , -0.468338
					with: 0.341856 , -0.185775 , -0.275191);
		add: (Triangle3D 
					with: 0.0216249 , 0.0642251 , 0.464401
					with: 0.252673 , -0.253665 , 0.310863
					with: 0.468363 , 0.0187166 , 0.0714936);
		add: (Triangle3D 
					with: 0.0216249 , 0.0642251 , 0.464401
					with: 0.468363 , 0.0187166 , 0.0714936
					with: 0.237314 , 0.336606 , 0.225032);
		add: (Triangle3D 
					with: -0.462439 , -0.0268676 , -0.0754305
					with: -0.335931 , 0.177624 , 0.271255
					with: -0.120242 , 0.450005 , 0.031885);
		add: (Triangle3D 
					with: -0.462439 , -0.0268676 , -0.0754305
					with: -0.120242 , 0.450005 , 0.031885
					with: -0.246749 , 0.245514 , -0.3148);
		add: (Triangle3D 
					with: 0.126166 , -0.458156 , -0.0358218
					with: 0.537561 , -0.395792 , 0.0340061
					with: 0.252673 , -0.253665 , 0.310863);
		add: (Triangle3D 
					with: 0.126166 , -0.458156 , -0.0358218
					with: 0.341856 , -0.185775 , -0.275191
					with: 0.537561 , -0.395792 , 0.0340061);
		add: (Triangle3D 
					with: 0.252673 , -0.253665 , 0.310863
					with: 0.537561 , -0.395792 , 0.0340061
					with: 0.468363 , 0.0187166 , 0.0714936);
		add: (Triangle3D 
					with: 0.468363 , 0.0187166 , 0.0714936
					with: 0.537561 , -0.395792 , 0.0340061
					with: 0.341856 , -0.185775 , -0.275191);
		add: (Triangle3D 
					with: 0.0216249 , 0.0642251 , 0.464401
					with: -0.0919872 , 0.470376 , 0.452358
					with: -0.335931 , 0.177624 , 0.271255);
		add: (Triangle3D 
					with: 0.0216249 , 0.0642251 , 0.464401
					with: 0.237314 , 0.336606 , 0.225032
					with: -0.0919872 , 0.470376 , 0.452358);
		add: (Triangle3D 
					with: -0.335931 , 0.177624 , 0.271255
					with: -0.0919872 , 0.470376 , 0.452358
					with: -0.120242 , 0.450005 , 0.031885);
		add: (Triangle3D 
					with: -0.120242 , 0.450005 , 0.031885
					with: -0.0919872 , 0.470376 , 0.452358
					with: 0.237314 , 0.336606 , 0.225032);
		add: (Triangle3D 
					with: -0.462439 , -0.0268676 , -0.0754305
					with: -0.436688 , -0.0868103 , -0.49227
					with: -0.23139 , -0.344757 , -0.228969);
		add: (Triangle3D 
					with: -0.462439 , -0.0268676 , -0.0754305
					with: -0.246749 , 0.245514 , -0.3148
					with: -0.436688 , -0.0868103 , -0.49227);
		add: (Triangle3D 
					with: -0.23139 , -0.344757 , -0.228969
					with: -0.436688 , -0.0868103 , -0.49227
					with: -0.0157005 , -0.0723761 , -0.468338);
		add: (Triangle3D 
					with: -0.0157005 , -0.0723761 , -0.468338
					with: -0.436688 , -0.0868103 , -0.49227
					with: -0.246749 , 0.245514 , -0.3148);
		yourself! !

!Polyhedron class methodsFor: 'factory-triangular' stamp: 'emm 02/09/2012 23:40'!
triaugmentedTriangularPrism
	"self triaugmentedTriangularPrism"

	^(Triangle3DComposite new)
		add: (Triangle3D 
					with: -0.359831 , 0.5048 , 0.0619163
					with: 0.0167789 , 0.282119 , -0.385306
					with: -0.444553 , -0.0745347 , -0.158591);
		add: (Triangle3D 
					with: 0.439294 , -0.114354 , -0.149257
					with: -0.00907 , -0.325784 , -0.530958
					with: 0.0167789 , 0.282119 , -0.385306);
		add: (Triangle3D 
					with: -0.00907 , -0.325784 , -0.530958
					with: -0.444553 , -0.0745347 , -0.158591
					with: 0.0167789 , 0.282119 , -0.385306);
		add: (Triangle3D 
					with: -0.00907 , -0.325784 , -0.530958
					with: -0.0220378 , -0.471008 , 0.0774591
					with: -0.444553 , -0.0745347 , -0.158591);
		add: (Triangle3D 
					with: 0.439294 , -0.114354 , -0.149257
					with: -0.0220378 , -0.471008 , 0.0774591
					with: -0.00907 , -0.325784 , -0.530958);
		add: (Triangle3D 
					with: 0.0167789 , 0.282119 , -0.385306
					with: 0.235925 , 0.367215 , 0.194489
					with: 0.439294 , -0.114354 , -0.149257);
		add: (Triangle3D 
					with: 0.439294 , -0.114354 , -0.149257
					with: 0.235925 , 0.367215 , 0.194489
					with: 0.368901 , -0.179015 , 0.469042);
		add: (Triangle3D 
					with: 0.439294 , -0.114354 , -0.149257
					with: 0.368901 , -0.179015 , 0.469042
					with: -0.0220378 , -0.471008 , 0.0774591);
		add: (Triangle3D 
					with: -0.0220378 , -0.471008 , 0.0774591
					with: 0.368901 , -0.179015 , 0.469042
					with: -0.225407 , 0.0105615 , 0.421205);
		add: (Triangle3D 
					with: 0.368901 , -0.179015 , 0.469042
					with: 0.235925 , 0.367215 , 0.194489
					with: -0.225407 , 0.0105615 , 0.421205);
		add: (Triangle3D 
					with: -0.0220378 , -0.471008 , 0.0774591
					with: -0.225407 , 0.0105615 , 0.421205
					with: -0.444553 , -0.0745347 , -0.158591);
		add: (Triangle3D 
					with: -0.444553 , -0.0745347 , -0.158591
					with: -0.225407 , 0.0105615 , 0.421205
					with: -0.359831 , 0.5048 , 0.0619163);
		add: (Triangle3D 
					with: -0.225407 , 0.0105615 , 0.421205
					with: 0.235925 , 0.367215 , 0.194489
					with: -0.359831 , 0.5048 , 0.0619163);
		add: (Triangle3D 
					with: -0.359831 , 0.5048 , 0.0619163
					with: 0.235925 , 0.367215 , 0.194489
					with: 0.0167789 , 0.282119 , -0.385306);
		yourself! !

!Polyhedron class methodsFor: 'factory-dodecahedron' stamp: 'emm 02/09/2012 23:40'!
triaugmentedTruncatedDodecahedron
	"self triaugmentedTruncatedDodecahedron"

	^(Triangle3DComposite new)
		addTriangleWith: 0.426863 , -0.197717 , -0.231701
			with: 0.359622 , -0.135666 , -0.374397
			with: 0.30365 , 0.0056202 , -0.449492;
		addTriangleWith: 0.426863 , -0.197717 , -0.231701
			with: 0.30365 , 0.0056202 , -0.449492
			with: 0.280325 , 0.172176 , -0.4283;
		addTriangleWith: 0.426863 , -0.197717 , -0.231701
			with: 0.280325 , 0.172176 , -0.4283
			with: 0.298558 , 0.300382 , -0.318917;
		addTriangleWith: 0.426863 , -0.197717 , -0.231701
			with: 0.298558 , 0.300382 , -0.318917
			with: 0.351383 , 0.341269 , -0.163123;
		addTriangleWith: 0.426863 , -0.197717 , -0.231701
			with: 0.351383 , 0.341269 , -0.163123
			with: 0.418624 , 0.279218 , -0.0204266;
		addTriangleWith: 0.426863 , -0.197717 , -0.231701
			with: 0.418624 , 0.279218 , -0.0204266
			with: 0.474597 , 0.137932 , 0.0546678;
		addTriangleWith: 0.426863 , -0.197717 , -0.231701
			with: 0.474597 , 0.137932 , 0.0546678
			with: 0.497921 , -0.0286241 , 0.033476;
		addTriangleWith: 0.426863 , -0.197717 , -0.231701
			with: 0.497921 , -0.0286241 , 0.033476
			with: 0.479688 , -0.15683 , -0.0759071;
		addTriangleWith: 0.45159 , -0.181796 , 0.0893842
			with: 0.479688 , -0.15683 , -0.0759071
			with: 0.497921 , -0.0286241 , 0.033476;
		addTriangleWith: 0.055965 , -0.501636 , -0.0261784
			with: 0.0840634 , -0.476671 , -0.191469
			with: 0.182353 , -0.395389 , -0.303122;
		addTriangleWith: 0.055965 , -0.501636 , -0.0261784
			with: 0.182353 , -0.395389 , -0.303122
			with: 0.313291 , -0.288838 , -0.318489;
		addTriangleWith: 0.055965 , -0.501636 , -0.0261784
			with: 0.313291 , -0.288838 , -0.318489
			with: 0.426863 , -0.197717 , -0.231701;
		addTriangleWith: 0.055965 , -0.501636 , -0.0261784
			with: 0.426863 , -0.197717 , -0.231701
			with: 0.479688 , -0.15683 , -0.0759071;
		addTriangleWith: 0.055965 , -0.501636 , -0.0261784
			with: 0.479688 , -0.15683 , -0.0759071
			with: 0.45159 , -0.181796 , 0.0893842;
		addTriangleWith: 0.055965 , -0.501636 , -0.0261784
			with: 0.45159 , -0.181796 , 0.0893842
			with: 0.3533 , -0.263078 , 0.201037;
		addTriangleWith: 0.055965 , -0.501636 , -0.0261784
			with: 0.3533 , -0.263078 , 0.201037
			with: 0.222362 , -0.369629 , 0.216404;
		addTriangleWith: 0.055965 , -0.501636 , -0.0261784
			with: 0.222362 , -0.369629 , 0.216404
			with: 0.10879 , -0.46075 , 0.129615;
		addTriangleWith: 0.240595 , -0.241422 , 0.325787
			with: 0.222362 , -0.369629 , 0.216404
			with: 0.3533 , -0.263078 , 0.201037;
		addTriangleWith: 0.313291 , -0.288838 , -0.318489
			with: 0.359622 , -0.135666 , -0.374397
			with: 0.426863 , -0.197717 , -0.231701;
		addTriangleWith: -0.176046 , -0.197899 , -0.474857
			with: -0.129715 , -0.0447273 , -0.530765
			with: 0.00122266 , 0.0618236 , -0.546132;
		addTriangleWith: -0.176046 , -0.197899 , -0.474857
			with: 0.00122266 , 0.0618236 , -0.546132
			with: 0.166753 , 0.0810546 , -0.515088;
		addTriangleWith: -0.176046 , -0.197899 , -0.474857
			with: 0.166753 , 0.0810546 , -0.515088
			with: 0.30365 , 0.0056202 , -0.449492;
		addTriangleWith: -0.176046 , -0.197899 , -0.474857
			with: 0.30365 , 0.0056202 , -0.449492
			with: 0.359622 , -0.135666 , -0.374397;
		addTriangleWith: -0.176046 , -0.197899 , -0.474857
			with: 0.359622 , -0.135666 , -0.374397
			with: 0.313291 , -0.288838 , -0.318489;
		addTriangleWith: -0.176046 , -0.197899 , -0.474857
			with: 0.313291 , -0.288838 , -0.318489
			with: 0.182353 , -0.395389 , -0.303122;
		addTriangleWith: -0.176046 , -0.197899 , -0.474857
			with: 0.182353 , -0.395389 , -0.303122
			with: 0.0168226 , -0.41462 , -0.334166;
		addTriangleWith: -0.176046 , -0.197899 , -0.474857
			with: 0.0168226 , -0.41462 , -0.334166
			with: -0.120074 , -0.339186 , -0.399763;
		addTriangleWith: 0.0840634 , -0.476671 , -0.191469
			with: 0.0168226 , -0.41462 , -0.334166
			with: 0.182353 , -0.395389 , -0.303122;
		addTriangleWith: 0.166753 , 0.0810546 , -0.515088
			with: 0.280325 , 0.172176 , -0.4283
			with: 0.30365 , 0.0056202 , -0.449492;
		addTriangleWith: -0.218878 , 0.366356 , -0.309994
			with: -0.105306 , 0.457477 , -0.223205
			with: 0.0602248 , 0.476708 , -0.192162;
		addTriangleWith: -0.218878 , 0.366356 , -0.309994
			with: 0.0602248 , 0.476708 , -0.192162
			with: 0.214487 , 0.416703 , -0.22872;
		addTriangleWith: -0.218878 , 0.366356 , -0.309994
			with: 0.214487 , 0.416703 , -0.22872
			with: 0.298558 , 0.300382 , -0.318917;
		addTriangleWith: -0.218878 , 0.366356 , -0.309994
			with: 0.298558 , 0.300382 , -0.318917
			with: 0.280325 , 0.172176 , -0.4283;
		addTriangleWith: -0.218878 , 0.366356 , -0.309994
			with: 0.280325 , 0.172176 , -0.4283
			with: 0.166753 , 0.0810546 , -0.515088;
		addTriangleWith: -0.218878 , 0.366356 , -0.309994
			with: 0.166753 , 0.0810546 , -0.515088
			with: 0.00122266 , 0.0618236 , -0.546132;
		addTriangleWith: -0.218878 , 0.366356 , -0.309994
			with: 0.00122266 , 0.0618236 , -0.546132
			with: -0.15304 , 0.121828 , -0.509574;
		addTriangleWith: -0.218878 , 0.366356 , -0.309994
			with: -0.15304 , 0.121828 , -0.509574
			with: -0.23711 , 0.238149 , -0.419377;
		addTriangleWith: -0.129715 , -0.0447273 , -0.530765
			with: -0.15304 , 0.121828 , -0.509574
			with: 0.00122266 , 0.0618236 , -0.546132;
		addTriangleWith: 0.214487 , 0.416703 , -0.22872
			with: 0.351383 , 0.341269 , -0.163123
			with: 0.298558 , 0.300382 , -0.318917;
		addTriangleWith: -0.0133379 , 0.411347 , 0.240576
			with: 0.123559 , 0.335913 , 0.306173
			with: 0.277821 , 0.275908 , 0.269614;
		addTriangleWith: -0.0133379 , 0.411347 , 0.240576
			with: 0.277821 , 0.275908 , 0.269614
			with: 0.390526 , 0.254253 , 0.144864;
		addTriangleWith: -0.0133379 , 0.411347 , 0.240576
			with: 0.390526 , 0.254253 , 0.144864
			with: 0.418624 , 0.279218 , -0.0204266;
		addTriangleWith: -0.0133379 , 0.411347 , 0.240576
			with: 0.418624 , 0.279218 , -0.0204266
			with: 0.351383 , 0.341269 , -0.163123;
		addTriangleWith: -0.0133379 , 0.411347 , 0.240576
			with: 0.351383 , 0.341269 , -0.163123
			with: 0.214487 , 0.416703 , -0.22872;
		addTriangleWith: -0.0133379 , 0.411347 , 0.240576
			with: 0.214487 , 0.416703 , -0.22872
			with: 0.0602248 , 0.476708 , -0.192162;
		addTriangleWith: -0.0133379 , 0.411347 , 0.240576
			with: 0.0602248 , 0.476708 , -0.192162
			with: -0.0524803 , 0.498364 , -0.0674116;
		addTriangleWith: -0.0133379 , 0.411347 , 0.240576
			with: -0.0524803 , 0.498364 , -0.0674116
			with: -0.0805787 , 0.473398 , 0.0978793;
		addTriangleWith: -0.105306 , 0.457477 , -0.223205
			with: -0.0524803 , 0.498364 , -0.0674116
			with: 0.0602248 , 0.476708 , -0.192162;
		addTriangleWith: 0.390526 , 0.254253 , 0.144864
			with: 0.474597 , 0.137932 , 0.0546678
			with: 0.418624 , 0.279218 , -0.0204266;
		addTriangleWith: 0.179531 , 0.194626 , 0.381267
			with: 0.277821 , 0.275908 , 0.269614
			with: 0.123559 , 0.335913 , 0.306173;
		addTriangleWith: -0.471112 , -0.141205 , -0.148258
			with: -0.41514 , -0.282491 , -0.0731634
			with: -0.347899 , -0.344542 , 0.0695332;
		addTriangleWith: -0.471112 , -0.141205 , -0.148258
			with: -0.347899 , -0.344542 , 0.0695332
			with: -0.295073 , -0.303655 , 0.225327;
		addTriangleWith: -0.471112 , -0.141205 , -0.148258
			with: -0.295073 , -0.303655 , 0.225327
			with: -0.27684 , -0.175449 , 0.33471;
		addTriangleWith: -0.471112 , -0.141205 , -0.148258
			with: -0.27684 , -0.175449 , 0.33471
			with: -0.300165 , -0.00889307 , 0.355902;
		addTriangleWith: -0.471112 , -0.141205 , -0.148258
			with: -0.300165 , -0.00889307 , 0.355902
			with: -0.356137 , 0.132393 , 0.280807;
		addTriangleWith: -0.471112 , -0.141205 , -0.148258
			with: -0.356137 , 0.132393 , 0.280807
			with: -0.423378 , 0.194444 , 0.138111;
		addTriangleWith: -0.471112 , -0.141205 , -0.148258
			with: -0.423378 , 0.194444 , 0.138111
			with: -0.476204 , 0.153558 , -0.0176833;
		addTriangleWith: -0.471112 , -0.141205 , -0.148258
			with: -0.476204 , 0.153558 , -0.0176833
			with: -0.494436 , 0.0253512 , -0.127066;
		addTriangleWith: -0.448105 , 0.178523 , -0.182974
			with: -0.494436 , 0.0253512 , -0.127066
			with: -0.476204 , 0.153558 , -0.0176833;
		addTriangleWith: -0.129715 , -0.0447273 , -0.530765
			with: -0.176046 , -0.197899 , -0.474857
			with: -0.274336 , -0.279181 , -0.363204;
		addTriangleWith: -0.129715 , -0.0447273 , -0.530765
			with: -0.274336 , -0.279181 , -0.363204
			with: -0.387041 , -0.257525 , -0.238455;
		addTriangleWith: -0.129715 , -0.0447273 , -0.530765
			with: -0.387041 , -0.257525 , -0.238455
			with: -0.471112 , -0.141205 , -0.148258;
		addTriangleWith: -0.129715 , -0.0447273 , -0.530765
			with: -0.471112 , -0.141205 , -0.148258
			with: -0.494436 , 0.0253512 , -0.127066;
		addTriangleWith: -0.129715 , -0.0447273 , -0.530765
			with: -0.494436 , 0.0253512 , -0.127066
			with: -0.448105 , 0.178523 , -0.182974;
		addTriangleWith: -0.129715 , -0.0447273 , -0.530765
			with: -0.448105 , 0.178523 , -0.182974
			with: -0.349815 , 0.259805 , -0.294627;
		addTriangleWith: -0.129715 , -0.0447273 , -0.530765
			with: -0.349815 , 0.259805 , -0.294627
			with: -0.23711 , 0.238149 , -0.419377;
		addTriangleWith: -0.129715 , -0.0447273 , -0.530765
			with: -0.23711 , 0.238149 , -0.419377
			with: -0.15304 , 0.121828 , -0.509574;
		addTriangleWith: -0.218878 , 0.366356 , -0.309994
			with: -0.23711 , 0.238149 , -0.419377
			with: -0.349815 , 0.259805 , -0.294627;
		addTriangleWith: -0.387041 , -0.257525 , -0.238455
			with: -0.41514 , -0.282491 , -0.0731634
			with: -0.471112 , -0.141205 , -0.148258;
		addTriangleWith: 0.0840634 , -0.476671 , -0.191469
			with: 0.055965 , -0.501636 , -0.0261784
			with: -0.0567401 , -0.479981 , 0.0985715;
		addTriangleWith: 0.0840634 , -0.476671 , -0.191469
			with: -0.0567401 , -0.479981 , 0.0985715
			with: -0.211002 , -0.419976 , 0.13513;
		addTriangleWith: 0.0840634 , -0.476671 , -0.191469
			with: -0.211002 , -0.419976 , 0.13513
			with: -0.347899 , -0.344542 , 0.0695332;
		addTriangleWith: 0.0840634 , -0.476671 , -0.191469
			with: -0.347899 , -0.344542 , 0.0695332
			with: -0.41514 , -0.282491 , -0.0731634;
		addTriangleWith: 0.0840634 , -0.476671 , -0.191469
			with: -0.41514 , -0.282491 , -0.0731634
			with: -0.387041 , -0.257525 , -0.238455;
		addTriangleWith: 0.0840634 , -0.476671 , -0.191469
			with: -0.387041 , -0.257525 , -0.238455
			with: -0.274336 , -0.279181 , -0.363204;
		addTriangleWith: 0.0840634 , -0.476671 , -0.191469
			with: -0.274336 , -0.279181 , -0.363204
			with: -0.120074 , -0.339186 , -0.399763;
		addTriangleWith: 0.0840634 , -0.476671 , -0.191469
			with: -0.120074 , -0.339186 , -0.399763
			with: 0.0168226 , -0.41462 , -0.334166;
		addTriangleWith: -0.176046 , -0.197899 , -0.474857
			with: -0.120074 , -0.339186 , -0.399763
			with: -0.274336 , -0.279181 , -0.363204;
		addTriangleWith: -0.211002 , -0.419976 , 0.13513
			with: -0.295073 , -0.303655 , 0.225327
			with: -0.347899 , -0.344542 , 0.0695332;
		addTriangleWith: 0.10879 , -0.46075 , 0.129615
			with: -0.0567401 , -0.479981 , 0.0985715
			with: 0.055965 , -0.501636 , -0.0261784;
		addTriangleWith: -0.163269 , -0.0843275 , 0.421498
			with: -0.300165 , -0.00889307 , 0.355902
			with: -0.27684 , -0.175449 , 0.33471;
		addTriangleWith: 0.123559 , 0.335913 , 0.306173
			with: -0.0133379 , 0.411347 , 0.240576
			with: -0.178868 , 0.392116 , 0.209532;
		addTriangleWith: 0.123559 , 0.335913 , 0.306173
			with: -0.178868 , 0.392116 , 0.209532
			with: -0.309806 , 0.285565 , 0.224899;
		addTriangleWith: 0.123559 , 0.335913 , 0.306173
			with: -0.309806 , 0.285565 , 0.224899
			with: -0.356137 , 0.132393 , 0.280807;
		addTriangleWith: 0.123559 , 0.335913 , 0.306173
			with: -0.356137 , 0.132393 , 0.280807
			with: -0.300165 , -0.00889307 , 0.355902;
		addTriangleWith: 0.123559 , 0.335913 , 0.306173
			with: -0.300165 , -0.00889307 , 0.355902
			with: -0.163269 , -0.0843275 , 0.421498;
		addTriangleWith: 0.123559 , 0.335913 , 0.306173
			with: -0.163269 , -0.0843275 , 0.421498
			with: 0.00226204 , -0.0650965 , 0.452542;
		addTriangleWith: 0.123559 , 0.335913 , 0.306173
			with: 0.00226204 , -0.0650965 , 0.452542
			with: 0.1332 , 0.0414544 , 0.437175;
		addTriangleWith: 0.123559 , 0.335913 , 0.306173
			with: 0.1332 , 0.0414544 , 0.437175
			with: 0.179531 , 0.194626 , 0.381267;
		addTriangleWith: 0.156524 , -0.125101 , 0.415984
			with: 0.1332 , 0.0414544 , 0.437175
			with: 0.00226204 , -0.0650965 , 0.452542;
		addTriangleWith: -0.309806 , 0.285565 , 0.224899
			with: -0.423378 , 0.194444 , 0.138111
			with: -0.356137 , 0.132393 , 0.280807;
		addTriangleWith: -0.0805787 , 0.473398 , 0.0978793
			with: -0.178868 , 0.392116 , 0.209532
			with: -0.0133379 , 0.411347 , 0.240576;
		addTriangleWith: -0.423038 , 0.31113 , 0.0151543
			with: -0.309466 , 0.402251 , 0.101943
			with: -0.211176 , 0.483533 , -0.00971;
		addTriangleWith: -0.423038 , 0.31113 , 0.0151543
			with: -0.211176 , 0.483533 , -0.00971
			with: -0.264002 , 0.442646 , -0.165504;
		addTriangleWith: -0.423038 , 0.31113 , 0.0151543
			with: -0.264002 , 0.442646 , -0.165504
			with: -0.39494 , 0.336096 , -0.150137;
		addTriangleWith: -0.309466 , 0.402251 , 0.101943
			with: -0.423038 , 0.31113 , 0.0151543
			with: -0.423378 , 0.194444 , 0.138111;
		addTriangleWith: -0.309466 , 0.402251 , 0.101943
			with: -0.423378 , 0.194444 , 0.138111
			with: -0.309806 , 0.285565 , 0.224899;
		addTriangleWith: -0.309466 , 0.402251 , 0.101943
			with: -0.309806 , 0.285565 , 0.224899
			with: -0.178868 , 0.392116 , 0.209532;
		addTriangleWith: -0.211176 , 0.483533 , -0.00971
			with: -0.309466 , 0.402251 , 0.101943
			with: -0.178868 , 0.392116 , 0.209532;
		addTriangleWith: -0.211176 , 0.483533 , -0.00971
			with: -0.178868 , 0.392116 , 0.209532
			with: -0.0805787 , 0.473398 , 0.0978793;
		addTriangleWith: -0.211176 , 0.483533 , -0.00971
			with: -0.0805787 , 0.473398 , 0.0978793
			with: -0.0524803 , 0.498364 , -0.0674116;
		addTriangleWith: -0.264002 , 0.442646 , -0.165504
			with: -0.211176 , 0.483533 , -0.00971
			with: -0.0524803 , 0.498364 , -0.0674116;
		addTriangleWith: -0.264002 , 0.442646 , -0.165504
			with: -0.0524803 , 0.498364 , -0.0674116
			with: -0.105306 , 0.457477 , -0.223205;
		addTriangleWith: -0.264002 , 0.442646 , -0.165504
			with: -0.105306 , 0.457477 , -0.223205
			with: -0.218878 , 0.366356 , -0.309994;
		addTriangleWith: -0.39494 , 0.336096 , -0.150137
			with: -0.264002 , 0.442646 , -0.165504
			with: -0.218878 , 0.366356 , -0.309994;
		addTriangleWith: -0.39494 , 0.336096 , -0.150137
			with: -0.218878 , 0.366356 , -0.309994
			with: -0.349815 , 0.259805 , -0.294627;
		addTriangleWith: -0.448105 , 0.178523 , -0.182974
			with: -0.39494 , 0.336096 , -0.150137
			with: -0.349815 , 0.259805 , -0.294627;
		addTriangleWith: -0.423038 , 0.31113 , 0.0151543
			with: -0.39494 , 0.336096 , -0.150137
			with: -0.448105 , 0.178523 , -0.182974;
		addTriangleWith: -0.423038 , 0.31113 , 0.0151543
			with: -0.448105 , 0.178523 , -0.182974
			with: -0.476204 , 0.153558 , -0.0176833;
		addTriangleWith: -0.423038 , 0.31113 , 0.0151543
			with: -0.476204 , 0.153558 , -0.0176833
			with: -0.423378 , 0.194444 , 0.138111;
		addTriangleWith: -0.176374 , -0.311504 , 0.346086
			with: -0.0923031 , -0.427825 , 0.25589
			with: 0.0732275 , -0.408594 , 0.286933;
		addTriangleWith: -0.176374 , -0.311504 , 0.346086
			with: 0.0732275 , -0.408594 , 0.286933
			with: 0.0914602 , -0.280387 , 0.396316;
		addTriangleWith: -0.176374 , -0.311504 , 0.346086
			with: 0.0914602 , -0.280387 , 0.396316
			with: -0.0628021 , -0.220383 , 0.432875;
		addTriangleWith: -0.0923031 , -0.427825 , 0.25589
			with: -0.176374 , -0.311504 , 0.346086
			with: -0.295073 , -0.303655 , 0.225327;
		addTriangleWith: -0.0923031 , -0.427825 , 0.25589
			with: -0.295073 , -0.303655 , 0.225327
			with: -0.211002 , -0.419976 , 0.13513;
		addTriangleWith: -0.0923031 , -0.427825 , 0.25589
			with: -0.211002 , -0.419976 , 0.13513
			with: -0.0567401 , -0.479981 , 0.0985715;
		addTriangleWith: 0.0732275 , -0.408594 , 0.286933
			with: -0.0923031 , -0.427825 , 0.25589
			with: -0.0567401 , -0.479981 , 0.0985715;
		addTriangleWith: 0.0732275 , -0.408594 , 0.286933
			with: -0.0567401 , -0.479981 , 0.0985715
			with: 0.10879 , -0.46075 , 0.129615;
		addTriangleWith: 0.0732275 , -0.408594 , 0.286933
			with: 0.10879 , -0.46075 , 0.129615
			with: 0.222362 , -0.369629 , 0.216404;
		addTriangleWith: 0.0914602 , -0.280387 , 0.396316
			with: 0.0732275 , -0.408594 , 0.286933
			with: 0.222362 , -0.369629 , 0.216404;
		addTriangleWith: 0.0914602 , -0.280387 , 0.396316
			with: 0.222362 , -0.369629 , 0.216404
			with: 0.240595 , -0.241422 , 0.325787;
		addTriangleWith: 0.0914602 , -0.280387 , 0.396316
			with: 0.240595 , -0.241422 , 0.325787
			with: 0.156524 , -0.125101 , 0.415984;
		addTriangleWith: -0.0628021 , -0.220383 , 0.432875
			with: 0.0914602 , -0.280387 , 0.396316
			with: 0.156524 , -0.125101 , 0.415984;
		addTriangleWith: -0.0628021 , -0.220383 , 0.432875
			with: 0.156524 , -0.125101 , 0.415984
			with: 0.00226204 , -0.0650965 , 0.452542;
		addTriangleWith: -0.163269 , -0.0843275 , 0.421498
			with: -0.0628021 , -0.220383 , 0.432875
			with: 0.00226204 , -0.0650965 , 0.452542;
		addTriangleWith: -0.176374 , -0.311504 , 0.346086
			with: -0.0628021 , -0.220383 , 0.432875
			with: -0.163269 , -0.0843275 , 0.421498;
		addTriangleWith: -0.176374 , -0.311504 , 0.346086
			with: -0.163269 , -0.0843275 , 0.421498
			with: -0.27684 , -0.175449 , 0.33471;
		addTriangleWith: -0.176374 , -0.311504 , 0.346086
			with: -0.27684 , -0.175449 , 0.33471
			with: -0.295073 , -0.303655 , 0.225327;
		addTriangleWith: 0.476182 , 0.0347809 , 0.189172
			with: 0.392111 , 0.151102 , 0.279368
			with: 0.293821 , 0.0698202 , 0.391021;
		addTriangleWith: 0.476182 , 0.0347809 , 0.189172
			with: 0.293821 , 0.0698202 , 0.391021
			with: 0.317145 , -0.0967356 , 0.36983;
		addTriangleWith: 0.476182 , 0.0347809 , 0.189172
			with: 0.317145 , -0.0967356 , 0.36983
			with: 0.42985 , -0.118391 , 0.24508;
		addTriangleWith: 0.392111 , 0.151102 , 0.279368
			with: 0.476182 , 0.0347809 , 0.189172
			with: 0.474597 , 0.137932 , 0.0546678;
		addTriangleWith: 0.392111 , 0.151102 , 0.279368
			with: 0.474597 , 0.137932 , 0.0546678
			with: 0.390526 , 0.254253 , 0.144864;
		addTriangleWith: 0.392111 , 0.151102 , 0.279368
			with: 0.390526 , 0.254253 , 0.144864
			with: 0.277821 , 0.275908 , 0.269614;
		addTriangleWith: 0.293821 , 0.0698202 , 0.391021
			with: 0.392111 , 0.151102 , 0.279368
			with: 0.277821 , 0.275908 , 0.269614;
		addTriangleWith: 0.293821 , 0.0698202 , 0.391021
			with: 0.277821 , 0.275908 , 0.269614
			with: 0.179531 , 0.194626 , 0.381267;
		addTriangleWith: 0.293821 , 0.0698202 , 0.391021
			with: 0.179531 , 0.194626 , 0.381267
			with: 0.1332 , 0.0414544 , 0.437175;
		addTriangleWith: 0.317145 , -0.0967356 , 0.36983
			with: 0.293821 , 0.0698202 , 0.391021
			with: 0.1332 , 0.0414544 , 0.437175;
		addTriangleWith: 0.317145 , -0.0967356 , 0.36983
			with: 0.1332 , 0.0414544 , 0.437175
			with: 0.156524 , -0.125101 , 0.415984;
		addTriangleWith: 0.317145 , -0.0967356 , 0.36983
			with: 0.156524 , -0.125101 , 0.415984
			with: 0.240595 , -0.241422 , 0.325787;
		addTriangleWith: 0.42985 , -0.118391 , 0.24508
			with: 0.317145 , -0.0967356 , 0.36983
			with: 0.240595 , -0.241422 , 0.325787;
		addTriangleWith: 0.42985 , -0.118391 , 0.24508
			with: 0.240595 , -0.241422 , 0.325787
			with: 0.3533 , -0.263078 , 0.201037;
		addTriangleWith: 0.45159 , -0.181796 , 0.0893842
			with: 0.42985 , -0.118391 , 0.24508
			with: 0.3533 , -0.263078 , 0.201037;
		addTriangleWith: 0.476182 , 0.0347809 , 0.189172
			with: 0.42985 , -0.118391 , 0.24508
			with: 0.45159 , -0.181796 , 0.0893842;
		addTriangleWith: 0.476182 , 0.0347809 , 0.189172
			with: 0.45159 , -0.181796 , 0.0893842
			with: 0.497921 , -0.0286241 , 0.033476;
		addTriangleWith: 0.476182 , 0.0347809 , 0.189172
			with: 0.497921 , -0.0286241 , 0.033476
			with: 0.474597 , 0.137932 , 0.0546678! !

!Polyhedron class methodsFor: 'factory-icosahedron' stamp: 'emm 02/09/2012 23:40'!
tridiminishedIcosahedron
	"self tridiminishedIcosahedron"

	^(Triangle3DComposite new)
		addTriangleWith: 0.0892527 , 0.454907 , -0.260627
			with: 0.492974 , 0.238337 , 0.126586
			with: 0.480605 , -0.360379 , 0.0917784;
		addTriangleWith: 0.0892527 , 0.454907 , -0.260627
			with: 0.480605 , -0.360379 , 0.0917784
			with: 0.0692401 , -0.513838 , -0.316946;
		addTriangleWith: 0.0892527 , 0.454907 , -0.260627
			with: 0.0692401 , -0.513838 , -0.316946
			with: -0.172629 , -0.00996309 , -0.534745;
		addTriangleWith: -0.453744 , 0.270193 , -0.084952
			with: -0.172629 , -0.00996309 , -0.534745
			with: 0.0692401 , -0.513838 , -0.316946;
		addTriangleWith: -0.453744 , 0.270193 , -0.084952
			with: 0.0692401 , -0.513838 , -0.316946
			with: -0.0623916 , -0.545093 , 0.267453;
		addTriangleWith: -0.453744 , 0.270193 , -0.084952
			with: -0.0623916 , -0.545093 , 0.267453
			with: -0.385614 , -0.0605355 , 0.410834;
		addTriangleWith: -0.453744 , 0.270193 , -0.084952
			with: -0.0423791 , 0.423651 , 0.323773
			with: 0.0892527 , 0.454907 , -0.260627;
		addTriangleWith: -0.0423791 , 0.423651 , 0.323773
			with: 0.492974 , 0.238337 , 0.126586
			with: 0.0892527 , 0.454907 , -0.260627;
		addTriangleWith: 0.0892527 , 0.454907 , -0.260627
			with: -0.172629 , -0.00996309 , -0.534745
			with: -0.453744 , 0.270193 , -0.084952;
		addTriangleWith: -0.453744 , 0.270193 , -0.084952
			with: -0.385614 , -0.0605355 , 0.410834
			with: -0.0423791 , 0.423651 , 0.323773;
		addTriangleWith: 0.480605 , -0.360379 , 0.0917784
			with: 0.492974 , 0.238337 , 0.126586
			with: -0.0423791 , 0.423651 , 0.323773;
		addTriangleWith: 0.480605 , -0.360379 , 0.0917784
			with: -0.0423791 , 0.423651 , 0.323773
			with: -0.385614 , -0.0605355 , 0.410834;
		addTriangleWith: 0.480605 , -0.360379 , 0.0917784
			with: -0.385614 , -0.0605355 , 0.410834
			with: -0.0623916 , -0.545093 , 0.267453;
		addTriangleWith: 0.0692401 , -0.513838 , -0.316946
			with: 0.480605 , -0.360379 , 0.0917784
			with: -0.0623916 , -0.545093 , 0.267453! !

!Polyhedron class methodsFor: 'factory-dodecahedron' stamp: 'emm 02/09/2012 23:40'!
tridiminishedRhombicosidodecahedron
	"self tridiminishedRhombicosidodecahedron"

	^(Triangle3DComposite new)
		addTriangleWith: 0.333318 , 0.329663 , 0.134723
			with: 0.338657 , 0.356076 , -0.0909465
			with: 0.138915 , 0.464211 , -0.0830157;
		addTriangleWith: 0.333318 , 0.329663 , 0.134723
			with: 0.138915 , 0.464211 , -0.0830157
			with: 0.133576 , 0.437797 , 0.142653;
		addTriangleWith: 0.133576 , 0.437797 , 0.142653
			with: 0.138915 , 0.464211 , -0.0830157
			with: -0.0588133 , 0.477256 , 0.0282766;
		addTriangleWith: 0.138915 , 0.464211 , -0.0830157
			with: 0.0273644 , 0.419922 , -0.276012
			with: -0.170364 , 0.432967 , -0.16472;
		addTriangleWith: 0.138915 , 0.464211 , -0.0830157
			with: -0.170364 , 0.432967 , -0.16472
			with: -0.0588133 , 0.477256 , 0.0282766;
		addTriangleWith: 0.338657 , 0.356076 , -0.0909465
			with: 0.350553 , 0.244956 , -0.288844
			with: 0.158164 , 0.284415 , -0.403221;
		addTriangleWith: 0.338657 , 0.356076 , -0.0909465
			with: 0.158164 , 0.284415 , -0.403221
			with: 0.0273644 , 0.419922 , -0.276012;
		addTriangleWith: 0.338657 , 0.356076 , -0.0909465
			with: 0.0273644 , 0.419922 , -0.276012
			with: 0.138915 , 0.464211 , -0.0830157;
		addTriangleWith: -0.46779 , 0.120423 , -0.137608
			with: -0.359496 , 0.318569 , -0.111854
			with: -0.170364 , 0.432967 , -0.16472;
		addTriangleWith: -0.46779 , 0.120423 , -0.137608
			with: -0.170364 , 0.432967 , -0.16472
			with: 0.0273644 , 0.419922 , -0.276012;
		addTriangleWith: -0.46779 , 0.120423 , -0.137608
			with: 0.0273644 , 0.419922 , -0.276012
			with: 0.158164 , 0.284415 , -0.403221;
		addTriangleWith: -0.46779 , 0.120423 , -0.137608
			with: 0.158164 , 0.284415 , -0.403221
			with: 0.172073 , 0.0782065 , -0.497758;
		addTriangleWith: -0.46779 , 0.120423 , -0.137608
			with: 0.172073 , 0.0782065 , -0.497758
			with: 0.0637795 , -0.11994 , -0.523512;
		addTriangleWith: -0.46779 , 0.120423 , -0.137608
			with: 0.0637795 , -0.11994 , -0.523512
			with: -0.125352 , -0.234338 , -0.470646;
		addTriangleWith: -0.46779 , 0.120423 , -0.137608
			with: -0.125352 , -0.234338 , -0.470646
			with: -0.323081 , -0.221293 , -0.359354;
		addTriangleWith: -0.46779 , 0.120423 , -0.137608
			with: -0.323081 , -0.221293 , -0.359354
			with: -0.45388 , -0.0857861 , -0.232145;
		addTriangleWith: 0.133576 , 0.437797 , 0.142653
			with: -0.0588133 , 0.477256 , 0.0282766
			with: -0.179003 , 0.39023 , 0.20042;
		addTriangleWith: 0.133576 , 0.437797 , 0.142653
			with: -0.179003 , 0.39023 , 0.20042
			with: 0.0133862 , 0.350771 , 0.314797;
		addTriangleWith: 0.0133862 , 0.350771 , 0.314797
			with: -0.179003 , 0.39023 , 0.20042
			with: -0.175746 , 0.236372 , 0.367663;
		addTriangleWith: -0.179003 , 0.39023 , 0.20042
			with: -0.364835 , 0.292156 , 0.113815
			with: -0.361578 , 0.138298 , 0.281057;
		addTriangleWith: -0.179003 , 0.39023 , 0.20042
			with: -0.361578 , 0.138298 , 0.281057
			with: -0.175746 , 0.236372 , 0.367663;
		addTriangleWith: -0.0588133 , 0.477256 , 0.0282766
			with: -0.170364 , 0.432967 , -0.16472
			with: -0.359496 , 0.318569 , -0.111854;
		addTriangleWith: -0.0588133 , 0.477256 , 0.0282766
			with: -0.359496 , 0.318569 , -0.111854
			with: -0.364835 , 0.292156 , 0.113815;
		addTriangleWith: -0.0588133 , 0.477256 , 0.0282766
			with: -0.364835 , 0.292156 , 0.113815
			with: -0.179003 , 0.39023 , 0.20042;
		addTriangleWith: -0.364835 , 0.292156 , 0.113815
			with: -0.473129 , 0.0940093 , 0.0880606
			with: -0.361578 , 0.138298 , 0.281057;
		addTriangleWith: -0.361578 , 0.138298 , 0.281057
			with: -0.473129 , 0.0940093 , 0.0880606
			with: -0.462519 , -0.128524 , 0.132995;
		addTriangleWith: -0.361578 , 0.138298 , 0.281057
			with: -0.462519 , -0.128524 , 0.132995
			with: -0.350968 , -0.0842351 , 0.325992;
		addTriangleWith: -0.359496 , 0.318569 , -0.111854
			with: -0.46779 , 0.120423 , -0.137608
			with: -0.473129 , 0.0940093 , 0.0880606;
		addTriangleWith: -0.359496 , 0.318569 , -0.111854
			with: -0.473129 , 0.0940093 , 0.0880606
			with: -0.364835 , 0.292156 , 0.113815;
		addTriangleWith: -0.46779 , 0.120423 , -0.137608
			with: -0.45388 , -0.0857861 , -0.232145
			with: -0.450623 , -0.239644 , -0.0649027;
		addTriangleWith: -0.46779 , 0.120423 , -0.137608
			with: -0.450623 , -0.239644 , -0.0649027
			with: -0.462519 , -0.128524 , 0.132995;
		addTriangleWith: -0.46779 , 0.120423 , -0.137608
			with: -0.462519 , -0.128524 , 0.132995
			with: -0.473129 , 0.0940093 , 0.0880606;
		addTriangleWith: -0.45388 , -0.0857861 , -0.232145
			with: -0.323081 , -0.221293 , -0.359354
			with: -0.319824 , -0.37515 , -0.192112;
		addTriangleWith: -0.45388 , -0.0857861 , -0.232145
			with: -0.319824 , -0.37515 , -0.192112
			with: -0.450623 , -0.239644 , -0.0649027;
		addTriangleWith: 0.0133862 , 0.350771 , 0.314797
			with: -0.175746 , 0.236372 , 0.367663
			with: -0.0502856 , 0.0744523 , 0.466123;
		addTriangleWith: 0.0133862 , 0.350771 , 0.314797
			with: -0.0502856 , 0.0744523 , 0.466123
			with: 0.138846 , 0.188851 , 0.413257;
		addTriangleWith: 0.138846 , 0.188851 , 0.413257
			with: -0.0502856 , 0.0744523 , 0.466123
			with: 0.149456 , -0.0336824 , 0.458192;
		addTriangleWith: -0.0502856 , 0.0744523 , 0.466123
			with: -0.158579 , -0.123694 , 0.440368
			with: 0.0411624 , -0.231829 , 0.432438;
		addTriangleWith: -0.0502856 , 0.0744523 , 0.466123
			with: 0.0411624 , -0.231829 , 0.432438
			with: 0.149456 , -0.0336824 , 0.458192;
		addTriangleWith: -0.175746 , 0.236372 , 0.367663
			with: -0.361578 , 0.138298 , 0.281057
			with: -0.350968 , -0.0842351 , 0.325992;
		addTriangleWith: -0.175746 , 0.236372 , 0.367663
			with: -0.350968 , -0.0842351 , 0.325992
			with: -0.158579 , -0.123694 , 0.440368;
		addTriangleWith: -0.175746 , 0.236372 , 0.367663
			with: -0.158579 , -0.123694 , 0.440368
			with: -0.0502856 , 0.0744523 , 0.466123;
		addTriangleWith: 0.183858 , -0.478455 , 0.10733
			with: 0.171962 , -0.367335 , 0.305228
			with: 0.0411624 , -0.231829 , 0.432438;
		addTriangleWith: 0.183858 , -0.478455 , 0.10733
			with: 0.0411624 , -0.231829 , 0.432438
			with: -0.158579 , -0.123694 , 0.440368;
		addTriangleWith: 0.183858 , -0.478455 , 0.10733
			with: -0.158579 , -0.123694 , 0.440368
			with: -0.350968 , -0.0842351 , 0.325992;
		addTriangleWith: 0.183858 , -0.478455 , 0.10733
			with: -0.350968 , -0.0842351 , 0.325992
			with: -0.462519 , -0.128524 , 0.132995;
		addTriangleWith: 0.183858 , -0.478455 , 0.10733
			with: -0.462519 , -0.128524 , 0.132995
			with: -0.450623 , -0.239644 , -0.0649027;
		addTriangleWith: 0.183858 , -0.478455 , 0.10733
			with: -0.450623 , -0.239644 , -0.0649027
			with: -0.319824 , -0.37515 , -0.192112;
		addTriangleWith: 0.183858 , -0.478455 , 0.10733
			with: -0.319824 , -0.37515 , -0.192112
			with: -0.120082 , -0.483285 , -0.200043;
		addTriangleWith: 0.183858 , -0.478455 , 0.10733
			with: -0.120082 , -0.483285 , -0.200043
			with: 0.0723072 , -0.522744 , -0.0856659;
		addTriangleWith: 0.138846 , 0.188851 , 0.413257
			with: 0.149456 , -0.0336824 , 0.458192
			with: 0.347184 , -0.0467279 , 0.346899;
		addTriangleWith: 0.138846 , 0.188851 , 0.413257
			with: 0.347184 , -0.0467279 , 0.346899
			with: 0.336575 , 0.175805 , 0.301965;
		addTriangleWith: 0.336575 , 0.175805 , 0.301965
			with: 0.347184 , -0.0467279 , 0.346899
			with: 0.361094 , -0.252937 , 0.252363;
		addTriangleWith: 0.336575 , 0.175805 , 0.301965
			with: 0.361094 , -0.252937 , 0.252363
			with: 0.37299 , -0.364056 , 0.054465;
		addTriangleWith: 0.336575 , 0.175805 , 0.301965
			with: 0.37299 , -0.364056 , 0.054465
			with: 0.378329 , -0.337643 , -0.171204;
		addTriangleWith: 0.336575 , 0.175805 , 0.301965
			with: 0.378329 , -0.337643 , -0.171204
			with: 0.375072 , -0.183786 , -0.338446;
		addTriangleWith: 0.336575 , 0.175805 , 0.301965
			with: 0.375072 , -0.183786 , -0.338446
			with: 0.364462 , 0.0387476 , -0.383381;
		addTriangleWith: 0.336575 , 0.175805 , 0.301965
			with: 0.364462 , 0.0387476 , -0.383381
			with: 0.350553 , 0.244956 , -0.288844;
		addTriangleWith: 0.336575 , 0.175805 , 0.301965
			with: 0.350553 , 0.244956 , -0.288844
			with: 0.338657 , 0.356076 , -0.0909465;
		addTriangleWith: 0.336575 , 0.175805 , 0.301965
			with: 0.338657 , 0.356076 , -0.0909465
			with: 0.333318 , 0.329663 , 0.134723;
		addTriangleWith: 0.149456 , -0.0336824 , 0.458192
			with: 0.0411624 , -0.231829 , 0.432438
			with: 0.171962 , -0.367335 , 0.305228;
		addTriangleWith: 0.149456 , -0.0336824 , 0.458192
			with: 0.171962 , -0.367335 , 0.305228
			with: 0.361094 , -0.252937 , 0.252363;
		addTriangleWith: 0.149456 , -0.0336824 , 0.458192
			with: 0.361094 , -0.252937 , 0.252363
			with: 0.347184 , -0.0467279 , 0.346899;
		addTriangleWith: 0.171962 , -0.367335 , 0.305228
			with: 0.183858 , -0.478455 , 0.10733
			with: 0.37299 , -0.364056 , 0.054465;
		addTriangleWith: 0.171962 , -0.367335 , 0.305228
			with: 0.37299 , -0.364056 , 0.054465
			with: 0.361094 , -0.252937 , 0.252363;
		addTriangleWith: 0.183858 , -0.478455 , 0.10733
			with: 0.0723072 , -0.522744 , -0.0856659
			with: 0.192497 , -0.435717 , -0.25781;
		addTriangleWith: 0.183858 , -0.478455 , 0.10733
			with: 0.192497 , -0.435717 , -0.25781
			with: 0.378329 , -0.337643 , -0.171204;
		addTriangleWith: 0.183858 , -0.478455 , 0.10733
			with: 0.378329 , -0.337643 , -0.171204
			with: 0.37299 , -0.364056 , 0.054465;
		addTriangleWith: 0.0723072 , -0.522744 , -0.0856659
			with: -0.120082 , -0.483285 , -0.200043
			with: 0.000107719 , -0.396258 , -0.372187;
		addTriangleWith: 0.0723072 , -0.522744 , -0.0856659
			with: 0.000107719 , -0.396258 , -0.372187
			with: 0.192497 , -0.435717 , -0.25781;
		addTriangleWith: 0.350553 , 0.244956 , -0.288844
			with: 0.364462 , 0.0387476 , -0.383381
			with: 0.172073 , 0.0782065 , -0.497758;
		addTriangleWith: 0.350553 , 0.244956 , -0.288844
			with: 0.172073 , 0.0782065 , -0.497758
			with: 0.158164 , 0.284415 , -0.403221;
		addTriangleWith: 0.378329 , -0.337643 , -0.171204
			with: 0.192497 , -0.435717 , -0.25781
			with: 0.18924 , -0.28186 , -0.425052;
		addTriangleWith: 0.378329 , -0.337643 , -0.171204
			with: 0.18924 , -0.28186 , -0.425052
			with: 0.375072 , -0.183786 , -0.338446;
		addTriangleWith: 0.375072 , -0.183786 , -0.338446
			with: 0.18924 , -0.28186 , -0.425052
			with: 0.0637795 , -0.11994 , -0.523512;
		addTriangleWith: 0.375072 , -0.183786 , -0.338446
			with: 0.0637795 , -0.11994 , -0.523512
			with: 0.172073 , 0.0782065 , -0.497758;
		addTriangleWith: 0.375072 , -0.183786 , -0.338446
			with: 0.172073 , 0.0782065 , -0.497758
			with: 0.364462 , 0.0387476 , -0.383381;
		addTriangleWith: 0.192497 , -0.435717 , -0.25781
			with: 0.000107719 , -0.396258 , -0.372187
			with: 0.18924 , -0.28186 , -0.425052;
		addTriangleWith: 0.18924 , -0.28186 , -0.425052
			with: 0.000107719 , -0.396258 , -0.372187
			with: -0.125352 , -0.234338 , -0.470646;
		addTriangleWith: 0.18924 , -0.28186 , -0.425052
			with: -0.125352 , -0.234338 , -0.470646
			with: 0.0637795 , -0.11994 , -0.523512;
		addTriangleWith: 0.333318 , 0.329663 , 0.134723
			with: 0.133576 , 0.437797 , 0.142653
			with: 0.0133862 , 0.350771 , 0.314797;
		addTriangleWith: 0.333318 , 0.329663 , 0.134723
			with: 0.0133862 , 0.350771 , 0.314797
			with: 0.138846 , 0.188851 , 0.413257;
		addTriangleWith: 0.333318 , 0.329663 , 0.134723
			with: 0.138846 , 0.188851 , 0.413257
			with: 0.336575 , 0.175805 , 0.301965;
		addTriangleWith: 0.000107719 , -0.396258 , -0.372187
			with: -0.120082 , -0.483285 , -0.200043
			with: -0.319824 , -0.37515 , -0.192112;
		addTriangleWith: 0.000107719 , -0.396258 , -0.372187
			with: -0.319824 , -0.37515 , -0.192112
			with: -0.323081 , -0.221293 , -0.359354;
		addTriangleWith: 0.000107719 , -0.396258 , -0.372187
			with: -0.323081 , -0.221293 , -0.359354
			with: -0.125352 , -0.234338 , -0.470646! !

!Polyhedron class methodsFor: 'factory-dodecahedron' stamp: 'emm 02/09/2012 23:40'!
trigyrateRhombicosidodecahedron
	"self trigyrateRhombicosidodecahedron"

	^(Triangle3DComposite new)
		addTriangleWith: -0.194558 , 0.0259618 , -0.462872
			with: -0.28297 , 0.20654 , -0.360745
			with: -0.0864575 , 0.315018 , -0.38243;
		addTriangleWith: -0.194558 , 0.0259618 , -0.462872
			with: -0.0864575 , 0.315018 , -0.38243
			with: 0.00195447 , 0.13444 , -0.484557;
		addTriangleWith: 0.00195447 , 0.13444 , -0.484557
			with: -0.0864575 , 0.315018 , -0.38243
			with: 0.137278 , 0.287616 , -0.389269;
		addTriangleWith: -0.0864575 , 0.315018 , -0.38243
			with: -0.0640128 , 0.454383 , -0.206565
			with: 0.159722 , 0.426981 , -0.213404;
		addTriangleWith: -0.0864575 , 0.315018 , -0.38243
			with: 0.159722 , 0.426981 , -0.213404
			with: 0.137278 , 0.287616 , -0.389269;
		addTriangleWith: -0.28297 , 0.20654 , -0.360745
			with: -0.381977 , 0.278862 , -0.171477
			with: -0.246654 , 0.432038 , -0.0761889;
		addTriangleWith: -0.28297 , 0.20654 , -0.360745
			with: -0.246654 , 0.432038 , -0.0761889
			with: -0.0640128 , 0.454383 , -0.206565;
		addTriangleWith: -0.28297 , 0.20654 , -0.360745
			with: -0.0640128 , 0.454383 , -0.206565
			with: -0.0864575 , 0.315018 , -0.38243;
		addTriangleWith: -0.246654 , 0.432038 , -0.0761889
			with: -0.0516045 , 0.500701 , 0.0137888
			with: -0.0640128 , 0.454383 , -0.206565;
		addTriangleWith: -0.0640128 , 0.454383 , -0.206565
			with: -0.0516045 , 0.500701 , 0.0137888
			with: 0.172131 , 0.473299 , 0.00694984;
		addTriangleWith: -0.0640128 , 0.454383 , -0.206565
			with: 0.172131 , 0.473299 , 0.00694984
			with: 0.159722 , 0.426981 , -0.213404;
		addTriangleWith: -0.318439 , 0.368481 , 0.127925
			with: -0.123389 , 0.437144 , 0.217902
			with: -0.0516045 , 0.500701 , 0.0137888;
		addTriangleWith: -0.318439 , 0.368481 , 0.127925
			with: -0.0516045 , 0.500701 , 0.0137888
			with: -0.246654 , 0.432038 , -0.0761889;
		addTriangleWith: -0.318439 , 0.368481 , 0.127925
			with: -0.251948 , 0.287987 , 0.327812
			with: -0.123389 , 0.437144 , 0.217902;
		addTriangleWith: -0.251948 , 0.287987 , 0.327812
			with: -0.0725782 , 0.221304 , 0.447122
			with: 0.0559804 , 0.370461 , 0.337213;
		addTriangleWith: -0.251948 , 0.287987 , 0.327812
			with: 0.0559804 , 0.370461 , 0.337213
			with: -0.123389 , 0.437144 , 0.217902;
		addTriangleWith: -0.123389 , 0.437144 , 0.217902
			with: 0.0559804 , 0.370461 , 0.337213
			with: 0.238622 , 0.392806 , 0.206837;
		addTriangleWith: -0.123389 , 0.437144 , 0.217902
			with: 0.238622 , 0.392806 , 0.206837
			with: 0.172131 , 0.473299 , 0.00694984;
		addTriangleWith: -0.123389 , 0.437144 , 0.217902
			with: 0.172131 , 0.473299 , 0.00694984
			with: -0.0516045 , 0.500701 , 0.0137888;
		addTriangleWith: -0.0725782 , 0.221304 , 0.447122
			with: 0.151157 , 0.193902 , 0.440283
			with: 0.0559804 , 0.370461 , 0.337213;
		addTriangleWith: 0.0559804 , 0.370461 , 0.337213
			with: 0.151157 , 0.193902 , 0.440283
			with: 0.333798 , 0.216247 , 0.309907;
		addTriangleWith: 0.0559804 , 0.370461 , 0.337213
			with: 0.333798 , 0.216247 , 0.309907
			with: 0.238622 , 0.392806 , 0.206837;
		addTriangleWith: 0.00195447 , 0.13444 , -0.484557
			with: 0.137278 , 0.287616 , -0.389269
			with: 0.302776 , 0.1348 , -0.378649;
		addTriangleWith: 0.00195447 , 0.13444 , -0.484557
			with: 0.302776 , 0.1348 , -0.378649
			with: 0.167453 , -0.018376 , -0.473937;
		addTriangleWith: 0.302776 , 0.1348 , -0.378649
			with: 0.427504 , 0.17972 , -0.196221
			with: 0.418699 , -0.0303064 , -0.277868;
		addTriangleWith: 0.427504 , 0.17972 , -0.196221
			with: 0.493995 , 0.0992271 , 0.00366646
			with: 0.48519 , -0.1108 , -0.077981;
		addTriangleWith: 0.427504 , 0.17972 , -0.196221
			with: 0.48519 , -0.1108 , -0.077981
			with: 0.418699 , -0.0303064 , -0.277868;
		addTriangleWith: 0.137278 , 0.287616 , -0.389269
			with: 0.159722 , 0.426981 , -0.213404
			with: 0.339092 , 0.360298 , -0.0940934;
		addTriangleWith: 0.137278 , 0.287616 , -0.389269
			with: 0.339092 , 0.360298 , -0.0940934
			with: 0.427504 , 0.17972 , -0.196221;
		addTriangleWith: 0.137278 , 0.287616 , -0.389269
			with: 0.427504 , 0.17972 , -0.196221
			with: 0.302776 , 0.1348 , -0.378649;
		addTriangleWith: 0.493995 , 0.0992271 , 0.00366646
			with: 0.476852 , -0.0759339 , 0.144662
			with: 0.48519 , -0.1108 , -0.077981;
		addTriangleWith: 0.48519 , -0.1108 , -0.077981
			with: 0.476852 , -0.0759339 , 0.144662
			with: 0.382622 , -0.278857 , 0.172911;
		addTriangleWith: 0.48519 , -0.1108 , -0.077981
			with: 0.382622 , -0.278857 , 0.172911
			with: 0.39096 , -0.313723 , -0.0497322;
		addTriangleWith: 0.339092 , 0.360298 , -0.0940934
			with: 0.405583 , 0.279805 , 0.105794
			with: 0.493995 , 0.0992271 , 0.00366646;
		addTriangleWith: 0.339092 , 0.360298 , -0.0940934
			with: 0.493995 , 0.0992271 , 0.00366646
			with: 0.427504 , 0.17972 , -0.196221;
		addTriangleWith: 0.159722 , 0.426981 , -0.213404
			with: 0.172131 , 0.473299 , 0.00694984
			with: 0.339092 , 0.360298 , -0.0940934;
		addTriangleWith: 0.172131 , 0.473299 , 0.00694984
			with: 0.238622 , 0.392806 , 0.206837
			with: 0.405583 , 0.279805 , 0.105794;
		addTriangleWith: 0.172131 , 0.473299 , 0.00694984
			with: 0.405583 , 0.279805 , 0.105794
			with: 0.339092 , 0.360298 , -0.0940934;
		addTriangleWith: 0.405583 , 0.279805 , 0.105794
			with: 0.333798 , 0.216247 , 0.309907
			with: 0.377845 , -0.00361142 , 0.333929;
		addTriangleWith: 0.405583 , 0.279805 , 0.105794
			with: 0.377845 , -0.00361142 , 0.333929
			with: 0.476852 , -0.0759339 , 0.144662;
		addTriangleWith: 0.405583 , 0.279805 , 0.105794
			with: 0.476852 , -0.0759339 , 0.144662
			with: 0.493995 , 0.0992271 , 0.00366646;
		addTriangleWith: 0.238622 , 0.392806 , 0.206837
			with: 0.333798 , 0.216247 , 0.309907
			with: 0.405583 , 0.279805 , 0.105794;
		addTriangleWith: 0.333798 , 0.216247 , 0.309907
			with: 0.151157 , 0.193902 , 0.440283
			with: 0.195203 , -0.0259568 , 0.464305;
		addTriangleWith: 0.333798 , 0.216247 , 0.309907
			with: 0.195203 , -0.0259568 , 0.464305
			with: 0.377845 , -0.00361142 , 0.333929;
		addTriangleWith: 0.302776 , 0.1348 , -0.378649
			with: 0.418699 , -0.0303064 , -0.277868
			with: 0.283375 , -0.183482 , -0.373156;
		addTriangleWith: 0.302776 , 0.1348 , -0.378649
			with: 0.283375 , -0.183482 , -0.373156
			with: 0.167453 , -0.018376 , -0.473937;
		addTriangleWith: 0.167453 , -0.018376 , -0.473937
			with: 0.283375 , -0.183482 , -0.373156
			with: 0.0732231 , -0.221299 , -0.445688;
		addTriangleWith: 0.283375 , -0.183482 , -0.373156
			with: 0.266232 , -0.358643 , -0.232161
			with: 0.0560799 , -0.39646 , -0.304693;
		addTriangleWith: 0.283375 , -0.183482 , -0.373156
			with: 0.0560799 , -0.39646 , -0.304693
			with: 0.0732231 , -0.221299 , -0.445688;
		addTriangleWith: 0.418699 , -0.0303064 , -0.277868
			with: 0.48519 , -0.1108 , -0.077981
			with: 0.39096 , -0.313723 , -0.0497322;
		addTriangleWith: 0.418699 , -0.0303064 , -0.277868
			with: 0.39096 , -0.313723 , -0.0497322
			with: 0.266232 , -0.358643 , -0.232161;
		addTriangleWith: 0.418699 , -0.0303064 , -0.277868
			with: 0.266232 , -0.358643 , -0.232161
			with: 0.283375 , -0.183482 , -0.373156;
		addTriangleWith: 0.266232 , -0.358643 , -0.232161
			with: 0.122571 , -0.476953 , -0.104806
			with: 0.0560799 , -0.39646 , -0.304693;
		addTriangleWith: 0.122571 , -0.476953 , -0.104806
			with: 0.247299 , -0.432033 , 0.0776226
			with: 0.0646578 , -0.454378 , 0.207998;
		addTriangleWith: 0.122571 , -0.476953 , -0.104806
			with: 0.0646578 , -0.454378 , 0.207998
			with: -0.0600703 , -0.499299 , 0.02557;
		addTriangleWith: 0.39096 , -0.313723 , -0.0497322
			with: 0.247299 , -0.432033 , 0.0776226
			with: 0.122571 , -0.476953 , -0.104806;
		addTriangleWith: 0.39096 , -0.313723 , -0.0497322
			with: 0.122571 , -0.476953 , -0.104806
			with: 0.266232 , -0.358643 , -0.232161;
		addTriangleWith: 0.39096 , -0.313723 , -0.0497322
			with: 0.382622 , -0.278857 , 0.172911
			with: 0.247299 , -0.432033 , 0.0776226;
		addTriangleWith: 0.476852 , -0.0759339 , 0.144662
			with: 0.377845 , -0.00361142 , 0.333929
			with: 0.283615 , -0.206535 , 0.362178;
		addTriangleWith: 0.476852 , -0.0759339 , 0.144662
			with: 0.283615 , -0.206535 , 0.362178
			with: 0.382622 , -0.278857 , 0.172911;
		addTriangleWith: 0.382622 , -0.278857 , 0.172911
			with: 0.283615 , -0.206535 , 0.362178
			with: 0.0871024 , -0.315013 , 0.383863;
		addTriangleWith: 0.382622 , -0.278857 , 0.172911
			with: 0.0871024 , -0.315013 , 0.383863
			with: 0.0646578 , -0.454378 , 0.207998;
		addTriangleWith: 0.382622 , -0.278857 , 0.172911
			with: 0.0646578 , -0.454378 , 0.207998
			with: 0.247299 , -0.432033 , 0.0776226;
		addTriangleWith: 0.377845 , -0.00361142 , 0.333929
			with: 0.195203 , -0.0259568 , 0.464305
			with: 0.283615 , -0.206535 , 0.362178;
		addTriangleWith: 0.283615 , -0.206535 , 0.362178
			with: 0.195203 , -0.0259568 , 0.464305
			with: -0.00130956 , -0.134435 , 0.48599;
		addTriangleWith: 0.283615 , -0.206535 , 0.362178
			with: -0.00130956 , -0.134435 , 0.48599
			with: 0.0871024 , -0.315013 , 0.383863;
		addTriangleWith: 0.0732231 , -0.221299 , -0.445688
			with: 0.0560799 , -0.39646 , -0.304693
			with: -0.167655 , -0.369058 , -0.297854;
		addTriangleWith: 0.0732231 , -0.221299 , -0.445688
			with: -0.167655 , -0.369058 , -0.297854
			with: -0.150512 , -0.193897 , -0.43885;
		addTriangleWith: -0.150512 , -0.193897 , -0.43885
			with: -0.167655 , -0.369058 , -0.297854
			with: -0.333153 , -0.216242 , -0.308474;
		addTriangleWith: -0.167655 , -0.369058 , -0.297854
			with: -0.23944 , -0.432616 , -0.0937403
			with: -0.404938 , -0.2798 , -0.10436;
		addTriangleWith: -0.167655 , -0.369058 , -0.297854
			with: -0.404938 , -0.2798 , -0.10436
			with: -0.333153 , -0.216242 , -0.308474;
		addTriangleWith: 0.0560799 , -0.39646 , -0.304693
			with: 0.122571 , -0.476953 , -0.104806
			with: -0.0600703 , -0.499299 , 0.02557;
		addTriangleWith: 0.0560799 , -0.39646 , -0.304693
			with: -0.0600703 , -0.499299 , 0.02557
			with: -0.23944 , -0.432616 , -0.0937403;
		addTriangleWith: 0.0560799 , -0.39646 , -0.304693
			with: -0.23944 , -0.432616 , -0.0937403
			with: -0.167655 , -0.369058 , -0.297854;
		addTriangleWith: -0.0600703 , -0.499299 , 0.02557
			with: -0.243128 , -0.420961 , 0.131439
			with: -0.23944 , -0.432616 , -0.0937403;
		addTriangleWith: -0.23944 , -0.432616 , -0.0937403
			with: -0.243128 , -0.420961 , 0.131439
			with: -0.408626 , -0.268145 , 0.120819;
		addTriangleWith: -0.23944 , -0.432616 , -0.0937403
			with: -0.408626 , -0.268145 , 0.120819
			with: -0.404938 , -0.2798 , -0.10436;
		addTriangleWith: 0.0646578 , -0.454378 , 0.207998
			with: -0.1184 , -0.376041 , 0.313867
			with: -0.243128 , -0.420961 , 0.131439;
		addTriangleWith: 0.0646578 , -0.454378 , 0.207998
			with: -0.243128 , -0.420961 , 0.131439
			with: -0.0600703 , -0.499299 , 0.02557;
		addTriangleWith: 0.0646578 , -0.454378 , 0.207998
			with: 0.0871024 , -0.315013 , 0.383863
			with: -0.1184 , -0.376041 , 0.313867;
		addTriangleWith: 0.0871024 , -0.315013 , 0.383863
			with: -0.00130956 , -0.134435 , 0.48599
			with: -0.206812 , -0.195463 , 0.415994;
		addTriangleWith: 0.0871024 , -0.315013 , 0.383863
			with: -0.206812 , -0.195463 , 0.415994
			with: -0.1184 , -0.376041 , 0.313867;
		addTriangleWith: -0.1184 , -0.376041 , 0.313867
			with: -0.206812 , -0.195463 , 0.415994
			with: -0.386181 , -0.12878 , 0.296684;
		addTriangleWith: -0.1184 , -0.376041 , 0.313867
			with: -0.386181 , -0.12878 , 0.296684
			with: -0.408626 , -0.268145 , 0.120819;
		addTriangleWith: -0.1184 , -0.376041 , 0.313867
			with: -0.408626 , -0.268145 , 0.120819
			with: -0.243128 , -0.420961 , 0.131439;
		addTriangleWith: -0.00130956 , -0.134435 , 0.48599
			with: -0.166808 , 0.018381 , 0.475371
			with: -0.206812 , -0.195463 , 0.415994;
		addTriangleWith: -0.206812 , -0.195463 , 0.415994
			with: -0.166808 , 0.018381 , 0.475371
			with: -0.346177 , 0.0850641 , 0.35606;
		addTriangleWith: -0.206812 , -0.195463 , 0.415994
			with: -0.346177 , 0.0850641 , 0.35606
			with: -0.386181 , -0.12878 , 0.296684;
		addTriangleWith: -0.150512 , -0.193897 , -0.43885
			with: -0.333153 , -0.216242 , -0.308474
			with: -0.3772 , 0.00361644 , -0.332496;
		addTriangleWith: -0.150512 , -0.193897 , -0.43885
			with: -0.3772 , 0.00361644 , -0.332496
			with: -0.194558 , 0.0259618 , -0.462872;
		addTriangleWith: -0.194558 , 0.0259618 , -0.462872
			with: -0.3772 , 0.00361644 , -0.332496
			with: -0.28297 , 0.20654 , -0.360745;
		addTriangleWith: -0.3772 , 0.00361644 , -0.332496
			with: -0.476207 , 0.0759391 , -0.143228
			with: -0.381977 , 0.278862 , -0.171477;
		addTriangleWith: -0.3772 , 0.00361644 , -0.332496
			with: -0.381977 , 0.278862 , -0.171477
			with: -0.28297 , 0.20654 , -0.360745;
		addTriangleWith: -0.333153 , -0.216242 , -0.308474
			with: -0.404938 , -0.2798 , -0.10436
			with: -0.49335 , -0.0992218 , -0.00223284;
		addTriangleWith: -0.333153 , -0.216242 , -0.308474
			with: -0.49335 , -0.0992218 , -0.00223284
			with: -0.476207 , 0.0759391 , -0.143228;
		addTriangleWith: -0.333153 , -0.216242 , -0.308474
			with: -0.476207 , 0.0759391 , -0.143228
			with: -0.3772 , 0.00361644 , -0.332496;
		addTriangleWith: -0.476207 , 0.0759391 , -0.143228
			with: -0.453762 , 0.215305 , 0.0326365
			with: -0.381977 , 0.278862 , -0.171477;
		addTriangleWith: -0.381977 , 0.278862 , -0.171477
			with: -0.453762 , 0.215305 , 0.0326365
			with: -0.318439 , 0.368481 , 0.127925;
		addTriangleWith: -0.381977 , 0.278862 , -0.171477
			with: -0.318439 , 0.368481 , 0.127925
			with: -0.246654 , 0.432038 , -0.0761889;
		addTriangleWith: -0.49335 , -0.0992218 , -0.00223284
			with: -0.470905 , 0.0401437 , 0.173632
			with: -0.453762 , 0.215305 , 0.0326365;
		addTriangleWith: -0.49335 , -0.0992218 , -0.00223284
			with: -0.453762 , 0.215305 , 0.0326365
			with: -0.476207 , 0.0759391 , -0.143228;
		addTriangleWith: -0.404938 , -0.2798 , -0.10436
			with: -0.408626 , -0.268145 , 0.120819
			with: -0.49335 , -0.0992218 , -0.00223284;
		addTriangleWith: -0.408626 , -0.268145 , 0.120819
			with: -0.386181 , -0.12878 , 0.296684
			with: -0.470905 , 0.0401437 , 0.173632;
		addTriangleWith: -0.408626 , -0.268145 , 0.120819
			with: -0.470905 , 0.0401437 , 0.173632
			with: -0.49335 , -0.0992218 , -0.00223284;
		addTriangleWith: -0.470905 , 0.0401437 , 0.173632
			with: -0.346177 , 0.0850641 , 0.35606
			with: -0.251948 , 0.287987 , 0.327812;
		addTriangleWith: -0.470905 , 0.0401437 , 0.173632
			with: -0.251948 , 0.287987 , 0.327812
			with: -0.318439 , 0.368481 , 0.127925;
		addTriangleWith: -0.470905 , 0.0401437 , 0.173632
			with: -0.318439 , 0.368481 , 0.127925
			with: -0.453762 , 0.215305 , 0.0326365;
		addTriangleWith: -0.386181 , -0.12878 , 0.296684
			with: -0.346177 , 0.0850641 , 0.35606
			with: -0.470905 , 0.0401437 , 0.173632;
		addTriangleWith: -0.346177 , 0.0850641 , 0.35606
			with: -0.166808 , 0.018381 , 0.475371
			with: -0.0725782 , 0.221304 , 0.447122;
		addTriangleWith: -0.346177 , 0.0850641 , 0.35606
			with: -0.0725782 , 0.221304 , 0.447122
			with: -0.251948 , 0.287987 , 0.327812;
		addTriangleWith: -0.194558 , 0.0259618 , -0.462872
			with: 0.00195447 , 0.13444 , -0.484557
			with: 0.167453 , -0.018376 , -0.473937;
		addTriangleWith: -0.194558 , 0.0259618 , -0.462872
			with: 0.167453 , -0.018376 , -0.473937
			with: 0.0732231 , -0.221299 , -0.445688;
		addTriangleWith: -0.194558 , 0.0259618 , -0.462872
			with: 0.0732231 , -0.221299 , -0.445688
			with: -0.150512 , -0.193897 , -0.43885;
		addTriangleWith: -0.166808 , 0.018381 , 0.475371
			with: -0.00130956 , -0.134435 , 0.48599
			with: 0.195203 , -0.0259568 , 0.464305;
		addTriangleWith: -0.166808 , 0.018381 , 0.475371
			with: 0.195203 , -0.0259568 , 0.464305
			with: 0.151157 , 0.193902 , 0.440283;
		addTriangleWith: -0.166808 , 0.018381 , 0.475371
			with: 0.151157 , 0.193902 , 0.440283
			with: -0.0725782 , 0.221304 , 0.447122! !

Geometric3D subclass: #SpatialNode
	instanceVariableNames: 'parent children'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-ShapeGallery'!

!SpatialNode methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:18'!
add: aNode
	
	children isNil
		ifTrue: [ children := OrderedCollection new ].
	aNode parent: self.
	^children add: aNode! !

!SpatialNode methodsFor: 'dispatching' stamp: 'emm 03/09/2012 20:18'!
addCenteredAt: aPoint using: aBuilder 
	
	| offsetPoint circle interpolator |
	aBuilder add: ( Sphere center: aPoint radius: 1 ).
	self children isEmpty 
		ifTrue:[ ^ self ].
	offsetPoint := 0 , 0 , -5.
	self children size = 1 
		ifTrue:
			[ ^ self children last 
				addCenteredAt: aPoint + offsetPoint 
				using: aBuilder ].
	circle := Circle3D center: aPoint + offsetPoint radius: 6.
	interpolator := circle interpolatorUsingAngleIncrement: 360 rad / self children size.
	interpolator vertices 
		with: self children 
		do: [ :center :child |  
			| cylinder | 
			cylinder := ( Cylinder radius: 0.1 height: ( center dist: aPoint ) ) zAlignWith: center - aPoint.
			aBuilder add: cylinder.
			child 
				addCenteredAt: center 
				using: aBuilder ]! !

!SpatialNode methodsFor: 'dispatching' stamp: 'emm 03/09/2012 20:18'!
addTo: aBuilder

	aBuilder beginGroup.
	self addCenteredAt: 0,0,0 using: aBuilder.
	^aBuilder add: aBuilder endGroup! !

!SpatialNode methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:18'!
children

	"Answer the value of children"

	^children ifNil:[#()]! !

!SpatialNode methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:18'!
children: aValue

	"Set the value of children"

	children := aValue! !

!SpatialNode methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:18'!
parent

	"Answer the value of parent"

	^parent! !

!SpatialNode methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:18'!
parent: aValue

	"Set the value of parent"

	parent := aValue! !

SpatialNode subclass: #WebNavigationNode
	instanceVariableNames: 'label url shape target'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-ShapeGallery'!

!WebNavigationNode methodsFor: 'dispatching' stamp: 'emm 03/09/2012 20:18'!
addCenteredAt: aPoint using: aBuilder 
	
	| offsetPoint circle interpolator anchor localAnchor |
	aBuilder color: Color white.
	aBuilder add: ( aBuilder 
		newLabel: self label 
		at: aPoint + ( 0 , -2 , 1 ) 
		axis: 0 , 0 , 0 ). 
	
	anchor := aBuilder anchor: [ 
		aBuilder add: (self shape translatedBy: aPoint)].
	anchor url: self url. 
	anchor parameter: 'target=' , self target.
	
	self children isEmpty 
		ifTrue:[ ^ self ].
	offsetPoint := 0 , 0 , -5.
	self children size = 1 
		ifTrue:
			[aBuilder add:((Cylinder radius: 0.1 height: 5) translateBy: aPoint + offsetPoint).
			^ self children last addCenteredAt: aPoint + offsetPoint using: aBuilder ].
	circle := Circle3D center: aPoint + offsetPoint radius: 6.
	interpolator := circle interpolatorUsingAll: ( 90 rad to: 450 rad steps: self children size ).
	interpolator vertices 
		with: self children 
		do: [ :center :child |  | cylinder | 
			cylinder := ( Cylinder radius: 0.1 height: ( center dist: aPoint ) ) zAlignWith: center - aPoint.
			aBuilder add: ( cylinder translatedBy: aPoint ).
			child addCenteredAt: center using: aBuilder ]! !

!WebNavigationNode methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:18'!
label

	"Answer the value of label"

	^label! !

!WebNavigationNode methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:18'!
label: aValue

	"Set the value of label"

	label := aValue! !

!WebNavigationNode methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:18'!
shape

	"Answer the value of shape"

	^shape! !

!WebNavigationNode methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:18'!
shape: aValue

	"Set the value of shape"

	shape := aValue! !

!WebNavigationNode methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:18'!
target

	"Answer the value of target"

	^target! !

!WebNavigationNode methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:18'!
target: aValue

	"Set the value of target"

	target := aValue! !

!WebNavigationNode methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:18'!
url

	"Answer the value of url"

	^url! !

!WebNavigationNode methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:18'!
url: aValue

	"Set the value of url"

	url := aValue! !

Geometric3D subclass: #Text3D
	instanceVariableNames: 'string fontName thickness size'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Primitives3D'!

!Text3D class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:36'!
fromString: aString

	^self new string:  aString! !

!Text3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:36'!
fontName

	"Answer the value of fontName"

	^fontName! !

!Text3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:36'!
fontName: aValue

	"Set the value of fontName"

	fontName := aValue! !

!Text3D methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:36'!
kindDo: aRequestor

	^aRequestor doText3D: self! !

!Text3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:36'!
size

	^size ifNil:[10]! !

!Text3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:36'!
size: anObject
	size := anObject! !

!Text3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:36'!
string

	"Answer the value of string"

	^string! !

!Text3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:36'!
string: aValue

	"Set the value of string"

	string := aValue! !

!Text3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:36'!
thickness
	^thickness ifNil:[1]! !

!Text3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:36'!
thickness: anObject
	thickness := anObject! !

Geometric3D subclass: #TileShape1
	instanceVariableNames: 'zSize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-ShapeGallery'!

!TileShape1 class methodsFor: 'instance-creation' stamp: 'emm 03/09/2012 20:21'!
new

	"Answer a new instance of the receiver and initialize it"

	^super new initialize! !

!TileShape1 methodsFor: 'solid-accessing' stamp: 'emm 03/09/2012 20:21'!
backSolid

	^self solidFromIndices: (13 to: 18) , #(1 2 12)! !

!TileShape1 methodsFor: 'computing' stamp: 'emm 03/09/2012 20:21'!
bounds

	^BoundingBox new! !

!TileShape1 methodsFor: 'computing' stamp: 'emm 03/09/2012 20:21'!
contourPoints
	"self new contourPoints"

	| pen |
	pen := DotPen new initializeFor2D.
	pen up ;dx: 1 ;down.
	pen dx: 2 ;dx: 3 dy: 3 ;dx: 1 ;dy: -2 ;dx: 1 ;dy: 3.
	pen dx: -1/3 ;dx: -2/3 dy: 2/3 ;dy: 1/3 ;dx: -2 ;dx: -3 dy: -3 ;dx: -1 ; dy: 2.
	pen dx: -1 ;dy: -3 ;dx: 1/3 ;dx: 2/3 dy: -2/3.
	^pen objects! !

!TileShape1 methodsFor: 'solid-accessing' stamp: 'emm 03/09/2012 20:21'!
frontSolid

	^self solidFromIndices: (4 to: 11) , #( 3 )! !

!TileShape1 methodsFor: 'initialize-release' stamp: 'emm 03/09/2012 20:21'!
initialize

	self zSize: 1! !

!TileShape1 methodsFor: 'inspecting' stamp: 'emm 03/09/2012 20:21'!
inspectActions

	^#( contourPoints solids )! !

!TileShape1 methodsFor: 'dispatching' stamp: 'emm 03/09/2012 20:21'!
kindDo: aRequestor

		^aRequestor doPrism: self! !

!TileShape1 methodsFor: 'solid-accessing' stamp: 'emm 03/09/2012 20:21'!
middleSolid

	^self solidFromIndices: #(2 3 11 12)! !

!TileShape1 methodsFor: 'computing' stamp: 'emm 03/09/2012 20:21'!
solidFromIndices: indices

	^self solidFromPoints: ( indices collect:[ :i | self contourPoints at: i ] )! !

!TileShape1 methodsFor: 'computing' stamp: 'emm 03/09/2012 20:21'!
solidFromPoints: aPoint2DCollection				

	| top |
	top := ( Polygon3D withAll: ( aPoint2DCollection collect: [ :each | each , self zSize ] ) ) reverseOriented.
	^ExtrudedPolygon top: top translation: 0 , 0 , self zSize negated! !

!TileShape1 methodsFor: 'solid-accessing' stamp: 'emm 03/09/2012 20:21'!
solidsDo: aBlock

	"Evaluate @aBlock for the solid parts of the receiver"

	"Internal: Break up the receiver in three ( minimal!!) faces for which
	the starting point is such that when constructing triangles to each other point
	on that triangle , no triangle will cover area outside the face of that solid"

	aBlock value: self frontSolid.
	aBlock value: self middleSolid.
	aBlock value: self backSolid.! !

!TileShape1 methodsFor: 'solid-accessing' stamp: 'emm 03/09/2012 20:21'!
solidsForRingDo: aBlock

	self solidsDo:[ :eachSolid | 
		self transformationsForRing 	do: [ :transBlock | 
			aBlock value: ( transBlock value: eachSolid ) ] ]


	! !

!TileShape1 methodsFor: 'solid-accessing' stamp: 'emm 03/09/2012 20:21'!
solidsForStar

	| solids |
	solids := OrderedCollection new.
	self solidsForStarDo: [ :each |
		solids add: each ].
	^solids! !

!TileShape1 methodsFor: 'solid-accessing' stamp: 'emm 03/09/2012 20:21'!
solidsForStarDo: aBlock

	self solidsDo:[ :eachSolid | 
		self transformationsForStar do: [ :transBlock | 
			aBlock value: ( transBlock value: eachSolid ) ] ]


	! !

!TileShape1 methodsFor: 'tilings' stamp: 'emm 03/09/2012 20:21'!
transformationsForRing
	
	^Array 
		with: [ :object | object wrapTranslateBy: -2 , -7 , 0 ] 
		with: [ :object | object wrapTranslateBy: -6 , 2 , 0 ] 
		with: [ :object | ( object wrapRotateBy: 0 , 0 , 90 rad ) wrapTranslateBy: -2 , -6 , 0 ] 
		with: [ :object | ( object wrapRotateBy: 0 , 0 , 90 rad ) wrapTranslateBy: 7 , -2 , 0 ]! !

!TileShape1 methodsFor: 'tilings' stamp: 'emm 03/09/2012 20:21'!
transformationsForStar
	
	^Array 
		with: [ :object | object ] 
		with: [ :object | object wrapTranslateBy: -8 , -5 , 0 ] 
		with: [ :object | ( object wrapRotateBy: 0 , 0 , 90 rad ) wrapTranslateBy: 5 , -8 , 0 ] 
		with: [ :object | object wrapRotateBy: 0 , 0 , 90 rad ]! !

!TileShape1 methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:21'!
zSize

	"Answer the value of zSize"

	^zSize! !

!TileShape1 methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:21'!
zSize: aValue

	"Set the value of zSize"

	zSize := aValue! !

Geometric3D subclass: #TranslatedGeometric3D
	instanceVariableNames: 'origin'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Primitives3D'!

TranslatedGeometric3D subclass: #Camera
	instanceVariableNames: 'focusPoint label rollAngle'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Appearance3D'!

!Camera class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:44'!
at: positionPoint lookingAt: focusPoint

	^( self new )
		origin: positionPoint
		; focusPoint: focusPoint! !

!Camera methodsFor: 'testing' stamp: 'emm 02/09/2012 23:44'!
canBeTextureWrapped

	^false! !

!Camera methodsFor: 'initialize-release' stamp: 'emm 02/09/2012 23:44'!
ensureNamed
	"ignore"! !

!Camera methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:44'!
focusPoint

	"Answer the value of focusPoint"

	^focusPoint! !

!Camera methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:44'!
focusPoint: aValue

	"Set the value of focusPoint"

	focusPoint := aValue! !

!Camera methodsFor: 'initialize-release' stamp: 'emm 02/09/2012 23:44'!
initialize

	super initialize.
	self focusPoint: 0,0,0.
	self rollAngle: 0	"This means Z-up, Y-right, looking towards zero from the positive X-axis"! !

!Camera methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:44'!
kindDo: aRequestor

	^ aRequestor doCamera: self! !

!Camera methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:44'!
label

	"Answer the value of label"

	^label! !

!Camera methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:44'!
label: aValue

	"Set the value of label"

	label := aValue! !

!Camera methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:44'!
labelString

	"Answer the value of label"

	^label isNil 
		ifTrue: [ self name ]
		ifFalse: [ label ]! !

!Camera methodsFor: 'initialize-release' stamp: 'emm 02/09/2012 23:44'!
name
	^self label! !

!Camera methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:44'!
name: aString
	self label: aString! !

!Camera methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:44'!
rollAngle

	"Answer the value of rollAngle"

	^rollAngle! !

!Camera methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:44'!
rollAngle: aValue

	"Set the value of rollAngle"

	rollAngle := aValue! !

TranslatedGeometric3D subclass: #ChainLink
	instanceVariableNames: 'xSize majorRadius minorRadius'
	classVariableNames: ''
	poolDictionaries: 'Math3DConstants'
	category: 'Zenna-Shapes3D'!

!ChainLink methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:40'!
bottomSolid
	
	| lc bc tc |
	lc := self leftCenter.
	bc := lc - ( 0 @ 0 @  self majorRadius ).
	tc := bc + ( 0 @ self centerLength @ 0 ).
	^( bc to: tc ) asCylinderWithRadius: self minorRadius! !

!ChainLink methodsFor: 'computing' stamp: 'emm 02/09/2012 23:40'!
bounds

	^self origin corner: self xSize @ self ySize @ self zSize! !

!ChainLink methodsFor: 'computing' stamp: 'emm 02/09/2012 23:40'!
centerLength
	"Answer the length between the two torussegment centers"

	^self rightCenter x - self leftCenter x! !

!ChainLink methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:40'!
extent

	^self xSize @ self ySize @ self zSize! !

!ChainLink methodsFor: 'initialize-release' stamp: 'emm 02/09/2012 23:40'!
initialize

	super initialize.
	self xSize: 2.
	self minorRadius: 0.1.
	self majorRadius: 0.4! !

!ChainLink methodsFor: 'computing' stamp: 'emm 02/09/2012 23:40'!
leftCenter
	"Answer the center point of the torussegment on the left side"

	^( ( self majorRadius + self minorRadius )
		@ ( self majorRadius + self minorRadius )
		@ self minorRadius ) + self origin! !

!ChainLink methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:40'!
leftSolid

	^Torus new
		startAngle: HalfPi
		; sweepAngle: Pi
		; origin: self leftCenter
		; minorRadius: self minorRadius
		; majorRadius: self majorRadius! !

!ChainLink methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:40'!
length

	"Answer the value of length"

	^self xSize! !

!ChainLink methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:40'!
length: aValue

	"Set the value of length"

	self xSize: aValue! !

!ChainLink methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:40'!
majorRadius

	"Answer the value of majorRadius"

	^majorRadius! !

!ChainLink methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:40'!
majorRadius: aValue

	"Set the value of majorRadius"

	majorRadius := aValue! !

!ChainLink methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:40'!
minorRadius

	"Answer the value of minorRadius"

	^minorRadius! !

!ChainLink methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:40'!
minorRadius: aValue

	"Set the value of minorRadius"

	minorRadius := aValue! !

!ChainLink methodsFor: 'printing' stamp: 'emm 02/09/2012 23:40'!
printOn: aStream indent: level

	super printOn: aStream indent: level.
	aStream 
		crtab: level + 1
		; nextPutAll: '; xSize: ' ; print: self xSize
		; crtab: level + 1
		; nextPutAll: '; majorRadius: ' ; print: self majorRadius
		; crtab: level + 1
		; nextPutAll: '; minorRadius: ' ; print: self minorRadius! !

!ChainLink methodsFor: 'computing' stamp: 'emm 02/09/2012 23:40'!
rightCenter
	"Answer the center point of the torussegment on the right side"

	^( ( self xSize - self majorRadius - self minorRadius )
		@ ( self majorRadius + self minorRadius )
		@ self minorRadius ) + self origin! !

!ChainLink methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:40'!
rightSolid

	^Torus new
		startAngle: 3 * HalfPi
		; sweepAngle: Pi
		; origin: self rightCenter
		; minorRadius: self minorRadius
		; majorRadius: self majorRadius! !

!ChainLink methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:40'!
size: sizePoint

	self xSize: sizePoint x.
	self ySize: sizePoint y.
	self zSize: sizePoint z! !

!ChainLink methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:40'!
solidsDo: aBlock

	aBlock value: self leftSolid.
	aBlock value: self rightSolid.
	aBlock value: self topSolid.
	aBlock value: self bottomSolid! !

!ChainLink methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:40'!
topSolid
	
	| lc bc tc |
	lc := self leftCenter.
	bc := lc + ( 0 @ 0 @ self majorRadius ).
	tc := bc + ( 0 @ self centerLength @ 0 ).
	^( bc to: tc ) asCylinderWithRadius: self minorRadius! !

!ChainLink methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:40'!
xSize

	"Answer the value of xSize"

	^xSize! !

!ChainLink methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:40'!
xSize: aValue

	"Set the value of xSize"

	xSize := aValue! !

!ChainLink methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:40'!
ySize

	^(self majorRadius + self minorRadius ) * 2! !

!ChainLink methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:40'!
ySize: aValue

	self majorRadius: aValue / 2 - self minorRadius! !

!ChainLink methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:40'!
zSize

	^self minorRadius * 2! !

!ChainLink methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:40'!
zSize: aValue

	self minorRadius: aValue / 2! !

TranslatedGeometric3D subclass: #Cylinder
	instanceVariableNames: 'radius zSize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Primitives3D'!

Cylinder subclass: #Cone
	instanceVariableNames: 'topRadius topThickness'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Primitives3D'!

!Cone class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:35'!
center: aPoint topRadius: r1 bottomRadius: r2 height: otherNumber 
	
	^( self 
		center: aPoint 
		radius: r2 
		height: otherNumber)
		topRadius: r1! !

!Cone methodsFor: '*Zenna-Collections3D' stamp: 'emm 02/09/2012 23:43'!
computeHollowSolidBetween: startAngle and: stopAngle

	| bottom top innerCone |
	innerCone := self innerCone.
	bottom := ( Polygon3D new )
		add:  ( self computeBottomVertexAt: startAngle )
		; add: ( self computeBottomVertexAt: stopAngle )
		; add: ( innerCone computeBottomVertexAt: stopAngle )
		; add: ( innerCone computeBottomVertexAt: startAngle )
		; yourself.
	top := ( Polygon3D new )  "must be in exact opposite reverse order"
		add:  ( self computeTopVertexAt: startAngle )
		; add: ( innerCone computeTopVertexAt: startAngle )
		; add: ( innerCone computeTopVertexAt: stopAngle )
		; add: ( self computeTopVertexAt: stopAngle )
		; yourself.
	^top extrudedTo: bottom  "order is important"! !

!Cone methodsFor: 'initialize-release' stamp: 'emm 02/09/2012 23:35'!
initialize
	
	super initialize.
	self topRadius: 1.	! !

!Cone methodsFor: 'computing ( IHollow )' stamp: 'emm 02/09/2012 23:35'!
innerGeometricApplyingThickness: amount

	^self class new 
		origin: self origin
		; radius: self radius - amount
		; topRadius: self topRadius - amount
		; zSize: self zSize! !

!Cone methodsFor: 'reflection' stamp: 'emm 02/09/2012 23:35'!
kindDo: aRequestor

	^aRequestor doCone: self! !

!Cone methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:35'!
topRadius

	^topRadius! !

!Cone methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:35'!
topRadius: aValue

	topRadius := aValue! !

!Cylinder class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:35'!
between: thisPoint and: thatPoint radius: radius! !

!Cylinder class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:35'!
center: aPoint radius: aNumber height: otherNumber

	^(super new) 
		center: aPoint
		; radius: aNumber
		; zSize: otherNumber! !

!Cylinder class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:35'!
radius: aNumber height: otherNumber

	^self center: Point3D zero radius: aNumber height: otherNumber! !

!Cylinder methodsFor: 'computing' stamp: 'emm 02/09/2012 23:35'!
bottom

	^Circle3D new
		origin: self bottomCenter
		; radius: self bottomRadius! !

!Cylinder methodsFor: 'computing' stamp: 'emm 02/09/2012 23:35'!
bottomCenter

	^self origin! !

!Cylinder methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:35'!
bottomRadius

	^self radius! !

!Cylinder methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:35'!
bottomRadius: aValue
	"Adaptor message"
	^self radius: aValue! !

!Cylinder methodsFor: 'computing' stamp: 'emm 02/09/2012 23:35'!
bounds
	"Answer the bounding box for the receiver"

	| maxRadius |
	maxRadius := self bottomRadius max: self topRadius.
	^self origin - (maxRadius @ maxRadius @ 0) 
		corner: self origin + (maxRadius @ maxRadius @ self zSize)! !

!Cylinder methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:35'!
center

	^self origin + ( 0,0, self zSize / 2 )! !

!Cylinder methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:35'!
center: aValue

	origin := aValue! !

!Cylinder methodsFor: 'computing' stamp: 'emm 02/09/2012 23:35'!
computeBottomVertexAt: aParameter 
	"<aParameter> is an angle in radians, answer the cartesianPoint"

	| where |
	where := self origin.
	^Point3D
		x: aParameter cos * self bottomRadius + where x
		y: aParameter sin * self bottomRadius + where y
		z: where z! !

!Cylinder methodsFor: '*Zenna-Collections3D' stamp: 'emm 02/09/2012 23:43'!
computeFaceBetween: startAngle and: stopAngle
	"Note: vertex order is important for texture mapping"

	^( Polygon3D new )
		add: ( self computeBottomVertexAt: startAngle)
		; add: ( self computeTopVertexAt: startAngle)
		; add: ( self computeTopVertexAt: stopAngle)
		; add: ( self computeBottomVertexAt: stopAngle)
		; yourself! !

!Cylinder methodsFor: '*Zenna-Collections3D' stamp: 'emm 02/09/2012 23:43'!
computeHollowSolidBetween: startAngle and: stopAngle thickness: thickness

	| top innerCylinder |
	innerCylinder := Cylinder new 
		origin: self origin
		; radius: self radius - thickness
		; zSize: self zSize.
	top := ( Polygon3D new )
		add:  ( self computeBottomVertexAt: startAngle )
		; add: ( self computeBottomVertexAt: stopAngle )
		; add: ( innerCylinder computeBottomVertexAt: stopAngle )
		; add: ( innerCylinder computeBottomVertexAt: startAngle )
		; yourself.
	^top extrudedBy: 0@0@self zSize! !

!Cylinder methodsFor: '*Zenna-Collections3D' stamp: 'emm 02/09/2012 23:43'!
computeSolidBetween: startAngle and: stopAngle

	| top |
	top := ( Polygon3D new )
		add: self topCenter
		; add: ( self computeTopVertexAt: startAngle)
		; add: ( self computeTopVertexAt: stopAngle)
		; yourself.
	^top extrudedBy: 0@0@self zSize negated! !

!Cylinder methodsFor: 'computing' stamp: 'emm 02/09/2012 23:35'!
computeTopVertexAt: aParameter 
	"<aParameter> is an angle in radians, answer the cartesianPoint"

	| where |
	where := self origin.
	^Point3D
		x: aParameter cos * self topRadius + where x
		y: aParameter sin * self topRadius + where y
		z: where z + self zSize! !

!Cylinder methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:35'!
height

	^zSize! !

!Cylinder methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:35'!
height: aNumber

	" Enter comment here "

	self zSize: aNumber
	! !

!Cylinder methodsFor: 'initialize-release' stamp: 'emm 02/09/2012 23:35'!
initialize
	
	super initialize.
	self radius: 1.
	self zSize: 1.! !

!Cylinder methodsFor: 'computing ( IHollow )' stamp: 'emm 02/09/2012 23:35'!
innerGeometricApplyingThickness: amount

	^Cylinder new 
		origin: self origin
		; radius: self radius - amount
		; zSize: self zSize! !

!Cylinder methodsFor: '*Zenna-Operators3D' stamp: 'emm 02/09/2012 23:47'!
interpolatorUsingAll: aParamterCollection
	
	^ ( CollectionBasedInterpolator on: self ) 
			collection: aParamterCollection! !

!Cylinder methodsFor: '*Zenna-Operators3D' stamp: 'emm 02/09/2012 23:47'!
interpolatorUsingAngleIncrement: stepAngle

		^(CollectionBasedInterpolator on: self)
				collection: (0 to: TwoPi by: stepAngle)! !

!Cylinder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:35'!
kindDo: aRequestor

	^aRequestor doCylinder: self! !

!Cylinder methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:35'!
radius

	^radius! !

!Cylinder methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:35'!
radius: aValue

	radius := aValue! !

!Cylinder methodsFor: 'computing' stamp: 'emm 02/09/2012 23:35'!
top

	^Circle3D new
		origin: self topCenter
		; radius: self topRadius! !

!Cylinder methodsFor: 'computing' stamp: 'emm 02/09/2012 23:35'!
topCenter

	^self origin + (0@0@zSize)! !

!Cylinder methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:35'!
topRadius

	^self radius! !

!Cylinder methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:35'!
zSize

	^zSize! !

!Cylinder methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:35'!
zSize: aValue

	zSize := aValue! !

Cylinder subclass: #CylinderSector
	instanceVariableNames: 'startAngle sweepAngle'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Primitives3D'!

!CylinderSector methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:37'!
startAngle
	^startAngle! !

!CylinderSector methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:37'!
startAngle: anObject
	startAngle := anObject! !

!CylinderSector methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:37'!
sweepAngle
	^sweepAngle! !

!CylinderSector methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:37'!
sweepAngle: anObject
	sweepAngle := anObject! !

Cylinder subclass: #Tube
	instanceVariableNames: 'thickness startAngle sweepAngle'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Shapes3D'!

!Tube class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:40'!
center: aPoint3D radius: aNumber height: aPositiveNumber thickness: anotherPositiveNumber 
	
	^ ( super 
		center: aPoint3D 
		radius: aNumber 
		height: aPositiveNumber ) thickness: anotherPositiveNumber! !

!Tube methodsFor: 'initialize-release' stamp: 'emm 02/09/2012 23:40'!
initialize

	super initialize.
	self thickness: 0.1.
	self startAngle: 0.
	self sweepAngle: TwoPi rad! !

!Tube methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:40'!
kindDo: aRequestor

	^aRequestor doTube: self! !

!Tube methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:40'!
startAngle

	"Answer the value of startAngle"

	^startAngle! !

!Tube methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:40'!
startAngle: aValue

	"Set the value of startAngle"

	startAngle := aValue! !

!Tube methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:40'!
sweepAngle

	"Answer the value of sweepAngle"

	^sweepAngle! !

!Tube methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:40'!
sweepAngle: aValue

	"Set the value of sweepAngle"

	sweepAngle := aValue! !

!Tube methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:40'!
thickness

	"Answer the value of thickness"

	^thickness! !

!Tube methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:40'!
thickness: aValue

	"Set the value of thickness"

	thickness := aValue! !

TranslatedGeometric3D subclass: #DivergingGrid3D
	instanceVariableNames: 'delta layers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Shapes3D'!

!DivergingGrid3D methodsFor: 'private' stamp: 'emm 02/09/2012 23:39'!
addVerticesForLayer: layer to: aPointCollection 

	| where |
	where := self origin.	
	aPointCollection 
		addX: delta x * ( 1 - layer ) + where x y: where y z: where z.
	(2 - layer) to: 0 do: [ :index | 
		self 
			downRightFromX: delta x * index + where x
			y: where y
			z: delta z * ( layer - 1+ index ) + where z
			addTo: aPointCollection ].
	1 to: layer - 2 do: [ :index | 
		self 
			downRightFromX: delta x * index + where z
			y: where y
			z: delta z * ( layer - 1 - index ) + where z
			addTo: aPointCollection ].
	layer = 1 
		ifFalse: 
			[ aPointCollection 
				addX: delta x * ( layer - 1 ) + where z y: where y z: where z ]! !

!DivergingGrid3D methodsFor: 'private' stamp: 'emm 02/09/2012 23:39'!
addVerticesForLayer: layer to: aPointCollection startingAt: start
	
	aPointCollection 
		addX: delta x * ( 1 - layer ) + start x y: start y z: start z.
	(2 - layer) to: 0 do: [ :index | 
		self 
			downRightFromX: delta x * index + start x
			y: start y
			z: delta z * ( layer - 1+ index ) + start z
			addTo: aPointCollection ].
	1 to: layer - 2 do: [ :index | 
		self 
			downRightFromX: delta x * index + start z
			y: start y
			z: delta z * ( layer - 1 - index ) + start z
			addTo: aPointCollection ].
	layer = 1 
		ifFalse: 
			[ aPointCollection 
				addX: delta x * ( layer - 1 ) + start z y: start y z: start z ]! !

!DivergingGrid3D methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:39'!
addVerticesTo: aPointCollection

	layers do:[ :each | self addVerticesForLayer: each to: aPointCollection ]! !

!DivergingGrid3D methodsFor: 'private-plane-XY' stamp: 'emm 02/09/2012 23:39'!
backLeftFromX: x y: y z: z addTo: aCollection 
	
	| hereY  hereX  lastX |
	hereY := y.
	hereX := x.
	lastX := self origin x.
	[ hereX = lastX ]
		whileFalse: 
			[ aCollection 
				addX: ( hereX := hereX - delta x ) 
				y: ( hereY := hereY - delta y ) 
				z: z ].
	^self 
		backRightFromX: hereX
		y: hereY 
		z: z 
		addTo: aCollection! !

!DivergingGrid3D methodsFor: 'private-plane-XY' stamp: 'emm 02/09/2012 23:39'!
backRightFromX: x y: y z: z addTo: aCollection 
	
	| hereY  hereX  lastY |
	hereY := y.
	hereX := x.
	lastY := self origin y.
	[ hereY = lastY ]
		whileFalse: 
			[ aCollection 
				addX: ( hereX := hereX - delta x ) 
				y: ( hereY := hereY + delta y ) 
				z: z ].! !

!DivergingGrid3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:39'!
delta

	"Answer the value of delta"

	^delta! !

!DivergingGrid3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:39'!
delta: aValue 
	"Set the value of delta"

	delta := aValue asPoint3D! !

!DivergingGrid3D methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:39'!
do: aBlock
	self verticesDo: aBlock! !

!DivergingGrid3D methodsFor: 'private-plane-XZ' stamp: 'emm 02/09/2012 23:39'!
downBackFromX: x y: y z: z addTo: aCollection 
	
	|  hereZ hereX lastZ |
	hereX := x.
	hereZ := z.
	lastZ := self origin z.
	[ hereZ = lastZ ]
		whileFalse: 
			[ aCollection 
				addX:  ( hereX := hereX - delta x )
				y: y 
				z: ( hereZ := hereZ - delta z ) ].
	^self 
		downFrontFromX: hereX
		y: y 
		z: hereZ 
		addTo: aCollection! !

!DivergingGrid3D methodsFor: 'private-plane-XZ' stamp: 'emm 02/09/2012 23:39'!
downFrontFromX: x y: y z: z addTo: aCollection 
	
	|  hereZ hereX  lastX |
	hereX := x.
	hereZ := z.
	lastX := self origin x.
	[ hereX = lastX ]
		whileFalse: 
			[ aCollection 
				addX:  ( hereX := hereX + delta x )
				y: y 
				z: ( hereZ := hereZ - delta z ) ].
	^self 
		upFrontFromX: hereX
		y: y 
		z: hereZ 
		addTo: aCollection! !

!DivergingGrid3D methodsFor: 'private-plane-ZY' stamp: 'emm 02/09/2012 23:39'!
downLeftFromX: x y: y z: z addTo: aCollection 
	
	| hereY hereZ lastY |
	hereY := y.
	hereZ := z.
	lastY := self origin y.
	[ hereY = lastY ]
		whileFalse: 
			[ aCollection 
				addX: x 
				y: ( hereY := hereY - delta y ) 
				z: ( hereZ := hereZ - delta z ) ].
	^self 
		upLeftFromX: x 
		y: hereY 
		z: hereZ 
		addTo: aCollection! !

!DivergingGrid3D methodsFor: 'private-plane-ZY' stamp: 'emm 02/09/2012 23:39'!
downRightFromX: x y: y z: z addTo: aCollection 
	
	| hereY hereZ lastZ |
	hereY := y.
	hereZ := z.
	lastZ := self origin z.
	[ hereZ = lastZ ]
		whileFalse: 
			[ aCollection 
				addX: x 
				y: ( hereY := hereY + delta y ) 
				z: ( hereZ := hereZ - delta z ) ].
	^self 
		downLeftFromX: x 
		y: hereY 
		z: hereZ 
		addTo: aCollection! !

!DivergingGrid3D methodsFor: 'private-plane-XY' stamp: 'emm 02/09/2012 23:39'!
frontLeftFromX: x y: y z: z addTo: aCollection 
	
	| hereY  hereX  lastY |
	hereY := y.
	hereX := x.
	lastY := self origin y.
	[ hereY = lastY ]
		whileFalse: 
			[ aCollection 
				addX: ( hereX := hereX + delta x ) 
				y: ( hereY := hereY - delta y ) 
				z: z ].
	^self 
		backLeftFromX: hereX
		y: hereY 
		z: z 
		addTo: aCollection! !

!DivergingGrid3D methodsFor: 'private-plane-XY' stamp: 'emm 02/09/2012 23:39'!
frontRightFromX: x y: y z: z addTo: aCollection 
	
	| hereY  hereX  lastX|
	hereY := y.
	hereX := x.
	lastX := self origin x.
	[ hereX = lastX ]
		whileFalse: 
			[ aCollection 
				addX: ( hereX := hereX + delta x ) 
				y: ( hereY := hereY + delta y ) 
				z: z ].
	^self 
		frontLeftFromX: hereX
		y: hereY 
		z: z 
		addTo: aCollection! !

!DivergingGrid3D methodsFor: 'initialize-release' stamp: 'emm 02/09/2012 23:39'!
initialize

	super initialize.
	layers := #().
	delta := Point3D unity! !

!DivergingGrid3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:39'!
layers

	"Answer the value of layers"

	^layers! !

!DivergingGrid3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:39'!
layers: aValue

	"Set the value of layers"

	layers := aValue! !

!DivergingGrid3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:39'!
layersTo: maxLayers 

	self layers: (1 to: maxLayers)! !

!DivergingGrid3D methodsFor: 'testing' stamp: 'emm 02/09/2012 23:39'!
test2
	"
	|v|
	v := OrderedPoint3DCollection new.
	v := OctantsContainmentFilter on: v.
	v rejectAll.
	v passOctant: (0@0@0) octantName.
	(self new initialize) 
		layers: (1 to: 10)
		; delta: 1,1,1
		; addVerticesTo: v.
	v"! !

!DivergingGrid3D methodsFor: 'private-plane-XZ' stamp: 'emm 02/09/2012 23:39'!
upBackFromX: x y: y z: z addTo: aCollection 
	
	|  hereZ hereX lastX |
	hereX := x.
	hereZ := z.
	lastX := self origin x.
	[ hereX = lastX ]
		whileFalse: 
			[ aCollection 
				addX:  ( hereX := hereX - delta x )
				y: y 
				z: ( hereZ := hereZ + delta z ) ].! !

!DivergingGrid3D methodsFor: 'private-plane-XZ' stamp: 'emm 02/09/2012 23:39'!
upFrontFromX: x y: y z: z addTo: aCollection 
	
	|  hereZ hereX lastZ |
	hereX := x.
	hereZ := z.
	lastZ := self origin z.
	[ hereZ = lastZ ]
		whileFalse: 
			[ aCollection 
				addX:  ( hereX := hereX + delta x )
				y: y 
				z: ( hereZ := hereZ + delta z ) ].
	^self 
		upBackFromX: hereX
		y: y 
		z: hereZ 
		addTo: aCollection! !

!DivergingGrid3D methodsFor: 'private-plane-ZY' stamp: 'emm 02/09/2012 23:39'!
upLeftFromX: x y: y z: z addTo: aCollection 
	
	| hereY hereZ lastZ |
	hereY := y.
	hereZ := z.
	lastZ := self origin z.
	[ hereZ = lastZ ]
		whileFalse: 
			[ aCollection 
				addX: x 
				y: ( hereY := hereY - delta y ) 
				z: ( hereZ := hereZ + delta z ) ].
	^self 
		upRightFromX: x 
		y: hereY 
		z: hereZ 
		addTo: aCollection! !

!DivergingGrid3D methodsFor: 'private-plane-ZY' stamp: 'emm 02/09/2012 23:39'!
upRightFromX: x y: y z: z addTo: aCollection 
	
	| hereY hereZ lastY |
	hereY := y.
	hereZ := z.
	lastY := self origin y.
	[ hereY = lastY ]
		whileFalse: 
			[ aCollection 
				addX: x 
				y: ( hereY := hereY + delta y ) 
				z: ( hereZ := hereZ + delta z ) ].! !

!DivergingGrid3D methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:39'!
verticesDo: aBlock 

	self addVerticesTo: (AdditionToEvaluationAdaptor on: aBlock)! !

TranslatedGeometric3D subclass: #ExtendedGeometric3D
	instanceVariableNames: 'extent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Primitives3D'!

ExtendedGeometric3D subclass: #Box
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Primitives3D'!

Box subclass: #BoundingBox
	instanceVariableNames: 'corner'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Primitives3D'!

!BoundingBox methodsFor: 'adding' stamp: 'emm 02/09/2012 23:34'!
addTo: aCollection
	^aCollection addBoundingBox: self! !

!BoundingBox methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:34'!
center

	^corner + self origin / 2! !

!BoundingBox methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:34'!
corner

	^corner! !

!BoundingBox methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:34'!
corner: aValue

	corner := aValue.
	extent := aValue - self origin.! !

!BoundingBox methodsFor: 'transforming' stamp: 'emm 02/09/2012 23:34'!
expandBy: aPointOrScalar

	| deltaPoint |
	deltaPoint := aPointOrScalar asPoint3D.
	origin := self origin - deltaPoint.
	corner := corner + deltaPoint.! !

!BoundingBox methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:34'!
extent: aValue

	extent := aValue.
	corner := aValue + self origin.! !

!BoundingBox methodsFor: 'testing' stamp: 'emm 02/09/2012 23:34'!
hasVolume
	^false! !

!BoundingBox methodsFor: 'initialize-release' stamp: 'emm 02/09/2012 23:34'!
initialize

	"Initialize to a empty space"

	super initialize.
	self extent: Point3D zero! !

!BoundingBox methodsFor: 'testing' stamp: 'emm 02/09/2012 23:34'!
intersects: anArgument

	^anArgument intersectsBoundingBox: self! !

!BoundingBox methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:34'!
kindDo: aRequestor

	^aRequestor doBoundingBox: self! !

!BoundingBox methodsFor: 'transforming' stamp: 'emm 02/09/2012 23:34'!
mirrorInXY

	| oz |
	1 halt.
	oz := origin z.
	origin z: corner z negated.
	corner z: oz negated! !

!BoundingBox methodsFor: 'transforming' stamp: 'emm 02/09/2012 23:34'!
mirrorInYZ

	| ox |
	1 halt.
	ox := origin x.
	origin x: corner x negated.
	corner x: ox negated! !

!BoundingBox methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:34'!
origin: originPoint corner: cornerPoint

	self origin: originPoint.	
	self corner: cornerPoint! !

!BoundingBox methodsFor: 'copying' stamp: 'emm 02/09/2012 23:34'!
postCopy

	super postCopy.
	corner := corner copy! !

!BoundingBox methodsFor: 'printing' stamp: 'emm 02/09/2012 23:34'!
printOn: aStream indent: level 

	aStream
		print: self origin
		; nextPutAll: ' corner: '
		; print: self corner! !

!BoundingBox methodsFor: 'transforming' stamp: 'emm 02/09/2012 23:34'!
rotateBy: aPoint 
	
	self corner: ( self corner rotatedBy: aPoint ).
	self origin: ( self origin rotatedBy: aPoint )! !

!BoundingBox methodsFor: 'transforming' stamp: 'emm 02/09/2012 23:34'!
scaleBy: aPoint

	super scaleBy: aPoint.
	corner rotateBy: aPoint.! !

!BoundingBox methodsFor: 'transforming' stamp: 'emm 02/09/2012 23:34'!
translateBy: aPoint 

	super translateBy: aPoint.
	corner := corner + aPoint! !

!Box methodsFor: 'face-accessing' stamp: 'emm 02/09/2012 23:34'!
back

	^Rectangle3D origin: self origin + (0,self extent y,0) extent: 0, self extent y negated, self extent z! !

!Box methodsFor: 'face-accessing' stamp: 'emm 02/09/2012 23:34'!
bottom
	
	^Rectangle3D origin: self origin extent: self extent x, self extent y , 0! !

!Box methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:34'!
faceCentersDo: aBlock

	| hsp org |
	hsp := extent / 2.
	org := self origin.
	aBlock value: org + (hsp x @ hsp y @ extent z). "top"
	aBlock value: org + (hsp x @ hsp y @ 0). "bottom"
	aBlock value: org + (extent x @ hsp y @ hsp z). "front"
	aBlock value: org + (0 @ hsp y @ hsp z). "back"
	aBlock value: org + (hsp x @ 0 @ hsp z). "left"
	aBlock value: org + (hsp x @ extent y @ hsp z). "right"! !

!Box methodsFor: 'face-accessing' stamp: 'emm 02/09/2012 23:34'!
faceNames
	
	^#(top bottom front back left right)! !

!Box methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:34'!
facesDo: aBlock 

	aBlock value: self front.
	aBlock value: self right.
	aBlock value: self back.
	aBlock value: self left.
	aBlock value: self top.
	aBlock value: self bottom.! !

!Box methodsFor: 'face-accessing' stamp: 'emm 02/09/2012 23:34'!
front
	
	^Rectangle3D origin: self origin + (self extent x,0,0) extent: 0, self extent y, self extent z! !

!Box methodsFor: 'computing' stamp: 'emm 02/09/2012 23:34'!
intersect: otherBox
	"Answer a BoundingBox that is the box in which the receiver overlaps with 
	otherBox. Note, if the receiver and the argument do not intersect, then
	the resulting box will be degenerate"! !

!Box methodsFor: 'testing' stamp: 'emm 02/09/2012 23:34'!
intersects: anArgument

	^anArgument intersectsBoundingBox: self! !

!Box methodsFor: 'testing' stamp: 'emm 02/09/2012 23:34'!
intersectsBoundingBox: aBox 

	aBox verticesDo: [ :each | 
		( self includesPoint: each ) 
			ifTrue: [ ^true ] ].
	self verticesDo: [ :each | 
		( aBox includesPoint: each ) 
			ifTrue: [ ^true ] ].
	^false! !

!Box methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:34'!
kindDo: aRequestor

	^aRequestor doBox: self! !

!Box methodsFor: 'face-accessing' stamp: 'emm 02/09/2012 23:34'!
left

	^Rectangle3D origin: self origin extent: self extent x, 0 , self extent z! !

!Box methodsFor: 'computing' stamp: 'emm 02/09/2012 23:34'!
merge: aBoundingBox 

	^(self origin min: aBoundingBox origin)
		corner: (self corner max: aBoundingBox corner)! !

!Box methodsFor: 'transforming' stamp: 'emm 02/09/2012 23:34'!
mirrorInXZAt: y
	
	| oy cy |
	oy := 2 * y - self corner y.
	cy := 2 * y - self origin y.
	self 
		origin: ( self origin x , oy , self origin z )
		corner: ( self corner x, cy , self corner z )! !

!Box methodsFor: 'printing' stamp: 'emm 02/09/2012 23:34'!
printOn: aStream indent: level 

	aStream
		 nextPutAll: self class name
		; nextPutAll: ' origin: '
		; print: self origin
		; nextPutAll: ' corner: '
		; print: self corner! !

!Box methodsFor: 'face-accessing' stamp: 'emm 02/09/2012 23:34'!
right

	^Rectangle3D origin: self origin + (self extent x, self extent y, 0) extent: self extent x negated, 0 , self extent z! !

!Box methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:34'!
segmentsDo: aBlock! !

!Box methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:34'!
solidsDo: aBlock 

	aBlock value: self! !

!Box methodsFor: 'computing' stamp: 'emm 02/09/2012 23:34'!
subtract: otherSolid

	| results |
	results := OrderedCollection new.
	otherSolid subtractFromCube: self addResultsTo: results.
	^results.! !

!Box methodsFor: 'computing' stamp: 'emm 02/09/2012 23:34'!
subtractCube: aCube addResultsTo: solidCollection

	| separated source |
	(self intersects: aCube)
		ifFalse: [ ^solidCollection add: self ].

	source := self.
	aCube origin z > source origin z
		ifTrue: 
			[ "separate bottom"
			separated := self class origin: source origin corner: ( source corner copy z: aCube origin z ).
			solidCollection add: separated.
			"continue with top"
			source := self class origin: ( source origin copy z: separated corner z ) corner: source corner].      

	"no bottom"
	aCube corner z < source corner z
		ifTrue: 
			[ "separate top"
			separated := self class origin: ( source origin copy z: aCube corner z ) corner: source corner.
			solidCollection add: separated.
			"continue with bottom"
			source := self class origin: source origin corner: ( source corner copy z: separated origin z ) ].

	"no bottom, no top"
	aCube origin y > source origin y
		ifTrue: 
			[ "separate left"
			separated := self class origin: source origin corner: ( source corner copy y: aCube origin y ).
			solidCollection add: separated.
			"continue with right"
			source := self class origin: ( source origin copy  y: aCube origin y ) corner: source corner ].
	
	"no bottom, no top, no left"
	aCube corner y < source corner y
		ifTrue: 
			[ "separate right"
			separated := self class origin: ( source origin copy y: aCube corner y ) corner: source corner.
			solidCollection add: separated.
			"continue with left"
			source := self class origin: source origin corner: ( source corner copy y: separated origin y ) ].

	"no bottom, no top, no left, no right"
	aCube origin x > source origin x
		ifTrue:
			[ "separate back"
			separated := self class origin: source origin corner: ( source corner copy x: aCube origin x ).
			solidCollection add: separated.
			"continue with front"
			source := self class origin: (source origin copy x: aCube origin x ) corner: source corner ].

	"no bottom, no top, no left, no right, no back"
	aCube corner x < source corner x
		ifTrue: 
			[ "separate front"
			solidCollection add: ( self class origin: ( source origin copy x: aCube corner x ) corner: source corner ) ].! !

!Box methodsFor: 'computing' stamp: 'emm 02/09/2012 23:34'!
subtractFromCube: aCube addResultsTo: solidCollection

	aCube subtractCube: self addResultsTo: solidCollection! !

!Box methodsFor: 'face-accessing' stamp: 'emm 02/09/2012 23:34'!
top

	^Rectangle3D origin: self origin + (self extent x,0,self extent z) extent: self extent x negated, self extent y , 0! !

!Box methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:34'!
verticesDo: aBlock
	
	"Optimized version"
	"
	^( Grid3D
		origin: origin
		corner: self corner
		delta: self corner - self origin )
		verticesDo: aBlock
	"

	| ox oy oz c cx cy cz where |
	where := self origin.
	ox := where x.
	oy := where y.
	oz := where z.
	c := self corner.
	cx := c x.
	cy := c y.
	cz := c z.
	aBlock value: origin copy.
	aBlock value: (Point3D x: ox y: cy z: oz). 
	aBlock value: (Point3D x: ox y: cy z: cz). 
	aBlock value: (Point3D x: ox y: oy z: cz). 
	aBlock value: (Point3D x: cx y: oy z: oz). 
	aBlock value: (Point3D x: cx y: oy z: cz). 
	aBlock value: (Point3D x: cx y: cy z: oz). 
	aBlock value: c copy.! !

!Box methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:34'!
verticesXYZDo: aBlock
	
	| ox oy oz c cx cy cz where |
	where := self origin.
	ox := where x.
	oy := where y.
	oz := where z.
	c := self corner.
	cx := c x.
	cy := c y.
	cz := c z.
	aBlock value: origin x value: origin y value: origin z.
	aBlock value: ox value: cy value: oz. 
	aBlock value: ox value: cy value: cz. 
	aBlock value: ox value: oy value: cz. 
	aBlock value: cx value: oy value: oz. 
	aBlock value: cx value: oy value: cz. 
	aBlock value: cx value: cy value: oz. 
	aBlock value: c x value: c y value: c z.! !

Box subclass: #Grid3D
	instanceVariableNames: 'delta'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Shapes3D'!

!Grid3D class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:39'!
new

	^super new delta: Point3D unity! !

!Grid3D class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:39'!
origin: originPoint corner: cornerPoint delta: deltaPoint 

	^( super origin: originPoint corner: cornerPoint )
		delta: deltaPoint! !

!Grid3D class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:39'!
xInterval: xInterval yInterval: yInterval zInterval: zInterval

	^self 
		origin: (Point3D x: xInterval first y: yInterval first z: zInterval first )
		corner:  (Point3D x: xInterval last y: yInterval last z: zInterval last )
		delta:  (Point3D x: xInterval increment y: yInterval increment z: zInterval increment )! !

!Grid3D methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:39'!
addVerticesTo: aCollection 

	self addXYZTo: aCollection! !

!Grid3D methodsFor: 'private' stamp: 'emm 02/09/2012 23:39'!
addXYZTo: aCollection 

	| where |
	where := self origin.
	delta x = 0
		ifTrue: [^self x: where x yzDo: [:px :py :pz | 
				aCollection
					addX: px
					y: py
					z: pz]].
	where x to: self corner x by: self delta x do: [:x | 
		self x: x yzDo: [:px :py :pz | 
			aCollection
				addX: px
				y: py
				z: pz]]! !

!Grid3D methodsFor: 'converting' stamp: 'emm 02/09/2012 23:39'!
asGrid
	^self! !

!Grid3D methodsFor: 'face-accessing' stamp: 'emm 02/09/2012 23:39'!
back
	"Answer a new grid specifying the vertices on back of the receiver"

	^self class
		origin: self origin
		corner: self origin x @ self corner y @ self corner z
		delta: 0 @ delta y @ delta z! !

!Grid3D methodsFor: 'face-accessing' stamp: 'emm 02/09/2012 23:39'!
bottom
	"Answer a new grid specifying the vertices on bottom of the receiver"

	^self class
		origin: self origin
		corner: self corner x @ self corner y @ 0
		delta: delta x @ delta y @ 0! !

!Grid3D methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:39'!
boundaryVerticesDo: aBlock 
	
	self isYZGrid "delta x = 0" 
		ifTrue: [ 
			super front verticesDo: aBlock.
			self yInsideBoundaryVerticesDo: aBlock.
			^self zInsideBoundaryVerticesDo: aBlock ]. 
	
	self isXYGrid 
		ifTrue: [ 
			super top verticesDo: aBlock.
			self xInsideBoundaryVerticesDo: aBlock.
			^self yInsideBoundaryVerticesDo: aBlock ] 

"ifFalse: [ self delta y = 0 ifTrue: [ super right verticesDo: aBlock ] ifFalse: [ self delta z = 0 ifTrue: [ ] ifFalse: [ super verticesDo: aBlock ] ] ].
	 self isYZGrid ifFalse: [ self xInsideBoundaryVerticesDo: aBlock ].
	 self isXZGrid ifFalse: [ ].
	 self isXYGrid ifFalse: [ ]"! !

!Grid3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:39'!
delta

	^delta! !

!Grid3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:39'!
delta: aValue 

	delta := aValue asPoint3D! !

!Grid3D methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:39'!
do: oneArgBlock
	self verticesDo: oneArgBlock! !

!Grid3D methodsFor: 'face-accessing' stamp: 'emm 02/09/2012 23:39'!
front
	"Answer a new grid specifying the vertices on front of the receiver"

	| where |
	where := self origin.
	^self class
		origin: self corner x @ where y @ where z
		corner: self corner
		delta: 0 @ delta y @ delta z! !

!Grid3D methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:39'!
insideSurfaceVerticesDo: aBlock 

	self isXYGrid
		ifTrue: [ ^( self insetBy: delta x @ delta y @ 0 )
				verticesDo: aBlock ].
	self isXZGrid
		ifTrue: [ ^( self insetBy: delta x @ 0 @ delta z )
				verticesDo: aBlock ].
	self isYZGrid
		ifTrue: [ ^( self insetBy: 0 @ delta y @ delta z )
				verticesDo: aBlock ].
	( self front insetBy: 0 @ delta y @ delta z )
		verticesDo: aBlock.
	( self back insetBy: 0 @ delta y @ delta z )
		verticesDo: aBlock.
	( self right insetBy: delta x @ 0 @ delta z )
		verticesDo: aBlock.
	( self left insetBy: delta x @ 0 @ delta z )
		verticesDo: aBlock.
	( self bottom insetBy: 0 @ delta y @ delta z )
		verticesDo: aBlock.
	( self top insetBy: 0 @ delta y @ delta z )
		verticesDo: aBlock! !

!Grid3D methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:39'!
insideVerticesDo: aBlock 

	( self insetBy: delta )
		verticesDo: aBlock! !

!Grid3D methodsFor: 'inspecting' stamp: 'emm 02/09/2012 23:39'!
inspectActions

	^#(size)! !

!Grid3D methodsFor: 'testing' stamp: 'emm 02/09/2012 23:39'!
isXYGrid

	^delta z = 0! !

!Grid3D methodsFor: 'testing' stamp: 'emm 02/09/2012 23:39'!
isXZGrid

	^delta y = 0! !

!Grid3D methodsFor: 'testing' stamp: 'emm 02/09/2012 23:39'!
isYZGrid

	^delta x = 0! !

!Grid3D methodsFor: 'face-accessing' stamp: 'emm 02/09/2012 23:39'!
left
	"Answer a new grid specifying the vertices on left of the receiver"

	^self class
		origin: self origin
		corner: self corner x @ self origin y @ self corner z
		delta: delta x @ 0 @ delta z! !

!Grid3D methodsFor: 'face-accessing' stamp: 'emm 02/09/2012 23:39'!
right
	"Answer a new grid specifying the vertices on right of the receiver"

	^self class
		origin: self origin x @ self corner y @ self origin z
		corner: self corner
		delta: delta x @ 0 @ delta z! !

!Grid3D methodsFor: 'computing' stamp: 'emm 02/09/2012 23:39'!
size

	^self vertices size! !

!Grid3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:39'!
size: howMany
	"Compute delta such that the receiver can create
	<howMany> vertices"! !

!Grid3D methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:39'!
surfaceVerticesDo: aBlock 

	self insideSurfaceVerticesDo: aBlock.
	self boundaryVerticesDo: aBlock! !

!Grid3D methodsFor: 'face-accessing' stamp: 'emm 02/09/2012 23:39'!
top
	"Answer a new grid specifying the vertices on top of the receiver"

	^self class
		origin: self origin x @ self origin y @ self corner z
		corner: self corner
		delta: delta x @ delta y @ 0! !

!Grid3D methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:39'!
verticesDo: aBlock 

	self xyzDo: aBlock! !

!Grid3D methodsFor: 'private' stamp: 'emm 02/09/2012 23:39'!
x: x y: y zDo: aBlock 

	| where |
	where := self origin.
	delta z = 0
		ifTrue: [ ^aBlock
				value: x
				value: y
				value: origin z ].
	where z to: self corner z by: self delta z do: [:z | 
		aBlock
			value: x
			value: y
			value: z]! !

!Grid3D methodsFor: 'private' stamp: 'emm 02/09/2012 23:39'!
x: x yzDo: aBlock 

	| where |
	where := self origin.
	delta y = 0
		ifTrue: [ ^self x: x y: where y zDo: aBlock ].
	where y to: self corner y by: self delta y do: [:y | 
		self
			x: x
			y: y
			zDo: aBlock]! !

!Grid3D methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:39'!
xInsideBoundaryVerticesDo: aBlock 

	| xBlock where startX stopX |
	where := self origin.
	startX := where x + delta x.
	stopX := self corner x - delta x.
	startX = stopX
		ifTrue: [ xBlock := [ :y :z | aBlock value: startX @ y @ z ] ]
		ifFalse: [ xBlock := [ :y :z | ( startX @ y @ z to:  stopX@ y @ z by: delta x @ 0 @ 0 )	do: aBlock ] ].
	xBlock value: where y value: where z.
	self isXYGrid
		ifFalse:[ xBlock value: where y value: self corner z ].
	xBlock value: self corner y value: where z.
	self isXYGrid
		ifFalse: [ xBlock value: self corner y value: self corner z ]! !

!Grid3D methodsFor: 'private' stamp: 'emm 02/09/2012 23:39'!
xyzDo: aBlock 

	| where |
	where := self origin.
	delta x = 0
		ifTrue: [ ^self x: where x yzDo: [:px :py :pz | 
				aBlock value: ( Point3D
						x: px
						y: py
						z: pz )] ].
	where x to: self corner x by: self delta x do: [:x | 
		self x: x yzDo: [:px :py :pz | 
			aBlock value: ( Point3D
					x: px
					y: py
					z: pz )]]! !

!Grid3D methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:39'!
yInsideBoundaryVerticesDo: aBlock 

	| yBlock where startY stopY |
	where := self origin.
	startY := where y + delta y.
	stopY := self corner y - delta y.
	startY = stopY
		ifTrue: [ yBlock := [ :x :z |  aBlock value: x @ startY @ z ]]
		ifFalse: [ yBlock := [:x :z | (x @ startY @ z to: x @ stopY @ z by: 0 @ delta y @ 0) do: aBlock]].
	yBlock value: where x value: where z.
	self isYZGrid
		ifFalse: [ yBlock value: where x value: self corner z ].
	yBlock value: self corner x value: where z.
	self isYZGrid
		ifFalse: [ yBlock value: self corner x value: self corner z ]! !

!Grid3D methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:39'!
zInsideBoundaryVerticesDo: aBlock 

	| zBlock where |
	where := self origin.
	zBlock := [:x :y | (x @ y @ (where z + delta z) to: x @ y @ (self corner z - delta z) by: 0 @ 0 @ delta z)
				do: aBlock].
	zBlock value: where x value: where y.
	zBlock value: where x value: self corner y.
	zBlock value: self corner x value: where y.
	zBlock value: self corner x value: self corner y! !

Box subclass: #HollowBox
	instanceVariableNames: 'thickness'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Shapes3D'!

HollowBox subclass: #BoxFrame
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Shapes3D'!

!BoxFrame methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:40'!
bottomBackBarDo: aBlock 

	aBlock value: (Box origin: (Point3D
			x: self origin x
			y: self origin y + self thickness y
			z: self origin z)
			corner: (Point3D
					x: self origin x + self thickness x
					y: self corner y - self thickness y
					z: self origin z + self thickness z))! !

!BoxFrame methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:40'!
bottomFrontBarDo: aBlock 

	aBlock value: (Box origin: (Point3D
			x: self corner x - self thickness x
			y: self origin y + self thickness y
			z: self origin z)
			corner: (Point3D
					x: self corner x
					y: self corner y - self thickness y
					z: self origin z + self thickness z))! !

!BoxFrame methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:40'!
bottomLeftBarDo: aBlock 

	aBlock value: (Box origin: (Point3D
			x: self origin x + self thickness x
			y: self origin y
			z: self origin z)
			corner: (Point3D
					x: self corner x - self thickness x
					y: self origin y + self thickness y
					z: self origin z + self thickness z))! !

!BoxFrame methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:40'!
bottomRightBarDo: aBlock 

	aBlock value: (Box origin: (Point3D
			x: self origin x + self thickness x
			y: self corner y - self thickness y
			z: self origin z)
			corner: (Point3D
					x: self corner x - self thickness x
					y: self corner y
					z: self origin z + self thickness z))! !

!BoxFrame methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:40'!
kindDo: aRequestor

	^aRequestor doSolidComposite: self! !

!BoxFrame methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:40'!
leftBackBarDo: aBlock 

	aBlock value: (Box origin: self origin copy corner: (Point3D
				x: self origin x + self thickness x
				y: self origin y + self thickness y
				z: self corner z))! !

!BoxFrame methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:40'!
leftFrontBarDo: aBlock 

	aBlock value: (Box origin: (Point3D
			x: self corner x - self thickness x
			y: self origin y
			z: self origin z)
			corner: (Point3D
					x: self corner x
					y: self origin y + self thickness y
					z: self corner z))! !

!BoxFrame methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:40'!
rightBackBarDo: aBlock 

	aBlock value: (Box origin: (Point3D
			x: self origin x
			y: self corner y - self thickness y
			z: self origin z)
			corner: (Point3D
					x: self origin x + self thickness x
					y: self corner y
					z: self corner z))! !

!BoxFrame methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:40'!
rightFrontBarDo: aBlock 

	aBlock value: (Box origin: (Point3D
			x: self corner x - self thickness x
			y: self corner y - self thickness y
			z: self origin z)
			corner: self corner copy)! !

!BoxFrame methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:40'!
solidsDo: aBlock 
	self topFrontBarDo: aBlock.
	self topBackBarDo: aBlock.
	self topLeftBarDo: aBlock.
	self topRightBarDo: aBlock.
	self bottomFrontBarDo: aBlock.
	self bottomBackBarDo: aBlock.
	self bottomLeftBarDo: aBlock.
	self bottomRightBarDo: aBlock.
	self leftFrontBarDo: aBlock.
	self rightFrontBarDo: aBlock.
	self leftBackBarDo: aBlock.
	self rightBackBarDo: aBlock! !

!BoxFrame methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:40'!
topBackBarDo: aBlock 

	aBlock value: (Box origin: (Point3D
			x: self origin x
			y: self origin y + self thickness y
			z: self corner z - self thickness z)
			corner: (Point3D
					x: self origin x + self thickness x
					y: self corner y - self thickness y
					z: self corner z))! !

!BoxFrame methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:40'!
topFrontBarDo: aBlock 

	aBlock value: (Box origin: (Point3D
			x: self corner x - self thickness x
			y: self origin y + self thickness y
			z: self corner z - self thickness z)
			corner: (Point3D
					x: self corner x
					y: self corner y - self thickness y
					z: self corner z))! !

!BoxFrame methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:40'!
topLeftBarDo: aBlock 

	aBlock value: (Box origin: (Point3D
			x: self origin x + self thickness x
			y: self origin y
			z: self corner z - self thickness z)
			corner: (Point3D
					x: self corner x - self thickness x
					y: self origin y + self thickness y
					z: self corner z))! !

!BoxFrame methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:40'!
topRightBarDo: aBlock 

	aBlock value: (Box origin: (Point3D
			x: self origin x + self thickness x
			y: self corner y - self thickness y
			z: self corner z - self thickness z)
			corner: (Point3D
					x: self corner x - self thickness x
					y: self corner y
					z: self corner z))! !

!HollowBox class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:40'!
innerCube: aCube  thickness: aNumber
	
	| thickPoint |
	thickPoint := aNumber asPoint3D.
	^( self origin: aCube origin - thickPoint corner: aCube corner + thickPoint )
		thickness: thickPoint! !

!HollowBox methodsFor: 'solid-accessing' stamp: 'emm 02/09/2012 23:40'!
backSolid

	self backSolidDo:[ :each | ^each ]! !

!HollowBox methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:40'!
backSolidDo: aBlock 

	aBlock value: ((Box origin:(Point3D
			x: self origin x
			y: self origin y + self thickness y
			z: self origin z + self thickness z)
			corner: (Point3D
					x: self origin x + self thickness x
					y: self corner y - self thickness y
					z: self corner z - self thickness z)))! !

!HollowBox methodsFor: 'solid-accessing' stamp: 'emm 02/09/2012 23:40'!
bottomSolid

	self bottomSolidDo:[ :each | ^each ]! !

!HollowBox methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:40'!
bottomSolidDo: aBlock 

	aBlock value: (Box origin: self origin corner: (Point3D
				x: self corner x
				y: self corner y
				z: self origin z + self thickness z))! !

!HollowBox methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:40'!
facesDo: aBlock 

	self solidsDo:[:each | each facesDo: aBlock ]! !

!HollowBox methodsFor: 'solid-accessing' stamp: 'emm 02/09/2012 23:40'!
frontSolid

	self frontSolidDo:[ :each | ^each ]! !

!HollowBox methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:40'!
frontSolidDo: aBlock 

	aBlock value: ((Box origin:(Point3D
			x: self corner x - self thickness x
			y: self origin y + self thickness y
			z: self origin z + self thickness z)
			corner: (Point3D
					x: self corner x
					y: self corner y - self thickness y
					z: self corner z - self thickness z)))! !

!HollowBox methodsFor: 'initialize-release' stamp: 'emm 02/09/2012 23:40'!
initialize

	super initialize.
	thickness := 0.1 asPoint3D! !

!HollowBox methodsFor: 'solid-accessing' stamp: 'emm 02/09/2012 23:40'!
insideBack

	"Answer the face from inside the receiver on the back.
	Its normal will point into the receiver so its face name is front"

	^(( self origin x + self thickness x,
	  (self origin y +self thickness y),
	  (self origin z + self thickness z))
			corner: (
				self origin x + self thickness x,
				(self corner y - self thickness y),
			 	(self corner z - self thickness z) ))
				! !

!HollowBox methodsFor: 'solid-accessing' stamp: 'emm 02/09/2012 23:40'!
insideBounds

	^BoundingBox
			origin: self origin + self thickness
			corner: self corner - self thickness! !

!HollowBox methodsFor: 'solid-accessing' stamp: 'emm 02/09/2012 23:40'!
insideLeft

	"Answer the face from inside the receiver on the left.
	Its normal will point into the receiver so its face name is right"

	^(( self origin x + self thickness x,
	  (self origin y +self thickness y),
	  (self origin z + self thickness z))
			corner: (
				self corner x - self thickness x,
				(self origin y + self thickness y),
			 	(self corner z - self thickness z) )) reverseOriented
				! !

!HollowBox methodsFor: 'inspecting' stamp: 'emm 02/09/2012 23:40'!
inspectActions

	^#( insideBounds )! !

!HollowBox methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:40'!
kindDo: aRequestor

	^aRequestor doSolidComposite: self! !

!HollowBox methodsFor: 'solid-accessing' stamp: 'emm 02/09/2012 23:40'!
leftSolid

	self leftSolidDo:[ :each | ^each ]! !

!HollowBox methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:40'!
leftSolidDo: aBlock 

	aBlock value: (((Box origin:(Point3D
			x: self origin x
			y: self origin y
			z: self origin z + self thickness z)
			corner: (Point3D
					x: self corner x
					y: self origin y + self thickness y
					z: self corner z - self thickness z))))! !

!HollowBox methodsFor: 'solid-accessing' stamp: 'emm 02/09/2012 23:40'!
rightSolid

	self rightSolidDo:[ :each | ^each ]! !

!HollowBox methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:40'!
rightSolidDo: aBlock 

	aBlock value: ((Box origin:(Point3D
			x: self origin x
			y: self corner y - self thickness y
			z: self origin z + self thickness z)
			corner: (Point3D
					x: self corner x
					y: self corner y
					z: self corner z - self thickness z)))! !

!HollowBox methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:40'!
solidsDo: aBlock 

	self topSolidDo: aBlock.
	self frontSolidDo: aBlock.
	self leftSolidDo: aBlock.
	self rightSolidDo: aBlock.
	self backSolidDo: aBlock.
	self bottomSolidDo: aBlock! !

!HollowBox methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:40'!
thickness

	^thickness! !

!HollowBox methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:40'!
thickness: aValue

	thickness := aValue asPoint3D! !

!HollowBox methodsFor: 'solid-accessing' stamp: 'emm 02/09/2012 23:40'!
topSolid

	self topSolidDo:[ :each | ^each ]! !

!HollowBox methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:40'!
topSolidDo: aBlock 

	aBlock value: (((Box origin:(Point3D
			x: self origin x
			y: self origin y
			z: self corner z - self thickness z)
			corner: self corner)))! !

HollowBox subclass: #HollowBoxSection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Shapes3D'!

!HollowBoxSection class methodsFor: 'to super' stamp: 'emm 02/09/2012 23:40'!
origin: oPoint corner: cPoint thickness: tPointOrNumber

	^(self origin: oPoint corner: cPoint) thickness: tPointOrNumber! !

!HollowBoxSection class methodsFor: 'to super' stamp: 'emm 02/09/2012 23:40'!
origin: oPoint extent: ePoint thickness: tPointOrNumber

	^(self origin: oPoint extent: ePoint) thickness: tPointOrNumber! !

!HollowBoxSection methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:40'!
bottomSolidDo: aBlock
	"do nothing"! !

!HollowBoxSection methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:40'!
thickness: aValue

	super thickness: (aValue asPoint3D copy z: 0)! !

!HollowBoxSection methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:40'!
topSolidDo: aBlock 
	"do nothing"! !

HollowBox subclass: #RectangularFrame
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Shapes3D'!

!RectangularFrame methodsFor: 'solid-accessing' stamp: 'emm 02/09/2012 23:40'!
bottomSolid
	1 halt! !

!RectangularFrame methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:40'!
kindDo: aRequestor

	^aRequestor doSolidComposite: self! !

!RectangularFrame methodsFor: 'solid-accessing' stamp: 'emm 02/09/2012 23:40'!
leftSolid
	1 halt! !

!RectangularFrame methodsFor: 'solid-accessing' stamp: 'emm 02/09/2012 23:40'!
rightSolid
	1 halt! !

!RectangularFrame methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:40'!
solidsDo: aBlock 

	| bottom top left right |
	bottom := Box
		origin: self origin
		corner: self thickness x , self extent y , self thickness z.
	top := bottom translatedBy: 0,0,(self extent z - (2 * self thickness z)).
	left := Box
		origin: self origin x, self origin y, self thickness z
		corner: self thickness x , self thickness y , ( self extent z - ( 2 * self thickness z )).
	right := left translatedBy: 0,(self extent y - self thickness y),0.
	aBlock value: top.
	aBlock value: left.
	aBlock value: right.
	aBlock value: bottom.! !

!RectangularFrame methodsFor: 'solid-accessing' stamp: 'emm 02/09/2012 23:40'!
topSolid
	1 halt! !

ExtendedGeometric3D subclass: #CubicSpaceDivider
	instanceVariableNames: 'barExtent centerOffset'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Shapes3D'!

!CubicSpaceDivider methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:40'!
barExtent

	^barExtent! !

!CubicSpaceDivider methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:40'!
barExtent: aValue

	barExtent := aValue! !

!CubicSpaceDivider methodsFor: 'face-accessing' stamp: 'emm 02/09/2012 23:40'!
bottom
	"Answer the bottom (XY plane facing positive Z) face"

	| hx hy neghz ox oy oz where |
	hx := barExtent x / 2.
	hy := barExtent y / 2.
	neghz := extent z / -2.
	where := self origin.
	ox := where x.
	oy := where y.
	oz := where z.
	^(Polygon3D new)
		addX: centerOffset x + hx + ox y: centerOffset y + hy + oy z: neghz + oz
		;addX: centerOffset x - hx + ox y: centerOffset y + hy + oy z: neghz + oz
		;addX: centerOffset x - hx + ox y: centerOffset y - hy + oy z: neghz + oz
		;addX: centerOffset x + hx + ox y: centerOffset y - hy + oy z: neghz + oz! !

!CubicSpaceDivider methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:40'!
centerOffset

	^centerOffset! !

!CubicSpaceDivider methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:40'!
centerOffset: aValue

	centerOffset := aValue! !

!CubicSpaceDivider methodsFor: 'face-accessing' stamp: 'emm 02/09/2012 23:40'!
east
	"Answer the east (XZ plane facing negative y) face"

	| hx hz hy ox oy oz where |
	hx := barExtent x / 2.
	hz := barExtent z / 2.
	hy := extent y / 2.
	where := self origin.
	ox := where x.
	oy := where y.
	oz := where z.
	^(Polygon3D new)
		addX: centerOffset x + hx + ox y: hy + oy z: centerOffset z - hz + oz
		;addX: centerOffset x + hx + ox y: hy + oy z: centerOffset z + hz + oz
		;addX: centerOffset x - hx +ox y: hy + oy z: centerOffset z + hz + oz
		;addX: centerOffset x - hx + ox y: hy + oy z: centerOffset z - hz + oz! !

!CubicSpaceDivider methodsFor: 'initialize-release' stamp: 'emm 02/09/2012 23:40'!
initialize

	super initialize.
	barExtent := 0.1 @ 0.1 @ 0.1.
	centerOffset := 0 @ 0 @ 0! !

!CubicSpaceDivider methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:40'!
kindDo: aRequestor

	^aRequestor doSolidComposite: self! !

!CubicSpaceDivider methodsFor: 'face-accessing' stamp: 'emm 02/09/2012 23:40'!
north
	"Answer the north (YZ plane facing positive X) face"

	| hy hz neghx ox oy oz where |
	hy := barExtent y / 2.
	hz := barExtent z / 2.
	neghx := extent x / -2.
	where := self origin.
	ox := where x.
	oy := where y.
	oz := where z.
	^(Polygon3D new)
		addX: neghx + ox y: centerOffset y - hy +oy z: centerOffset z - hz+oz 
		;addX: neghx + ox y: centerOffset y + hy +oy z: centerOffset z -  hz+oz 
		;addX: neghx + ox y: centerOffset y + hy +oy z: centerOffset z + hz+oz 
		;addX: neghx + ox y: centerOffset y - hy +oy z: centerOffset z + hz+oz! !

!CubicSpaceDivider methodsFor: 'copying' stamp: 'emm 02/09/2012 23:40'!
postCopy

	super postCopy.
	barExtent := barExtent copy.
	centerOffset := centerOffset copy! !

!CubicSpaceDivider methodsFor: 'printing' stamp: 'emm 02/09/2012 23:40'!
printOn: aStream indent: level

	super printOn: aStream indent: level.
	aStream 
		crtab: level + 1
		; nextPutAll: '; barExtent: ' ; print: self barExtent
		; crtab: level + 1
		; nextPutAll: '; centerOffset: ' ; print: self centerOffset! !

!CubicSpaceDivider methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:40'!
solidsDo: aBlock

	aBlock value: (ExtrudedPolygon
		base: self top
		translation:  0 @ 0 @ (barExtent z - extent z / 2)).
	aBlock value: (ExtrudedPolygon
		base: self bottom
		translation: 0 @ 0 @ (extent z - barExtent z / 2)).
	aBlock value: (ExtrudedPolygon
		base: self north
		translation: (extent x - barExtent x / 2) @ 0 @ 0).
	aBlock value: (ExtrudedPolygon
		base: self south
		translation: (barExtent x - extent x / 2) @ 0 @ 0).
	aBlock value: (ExtrudedPolygon
		base: self west
		translation: 0 @ ( extent y - barExtent y / 2 ) @0).
	aBlock value: (ExtrudedPolygon
		base: self east
		translation:  0 @ ( barExtent y - extent y / 2 ) @ 0)! !

!CubicSpaceDivider methodsFor: 'face-accessing' stamp: 'emm 02/09/2012 23:40'!
south
	"Answer the south (YZ plane facing negative X) face"

	| hy hz hx ox oy oz where |
	hy := barExtent y / 2.
	hz := barExtent z / 2.
	hx := extent x / 2.
	where := self origin.
	ox := where x.
	oy := where y.
	oz := where z.
	^(Polygon3D new)
		addX: hx + ox y: centerOffset y + hy + oy z: centerOffset z - hz+ oz 
		;addX: hx + ox y: centerOffset y - hy + oy z: centerOffset z -  hz+ oz 
		;addX: hx + ox y: centerOffset y - hy + oy z: centerOffset z + hz+ oz 
		;addX: hx + ox y: centerOffset y + hy + oy z: centerOffset z + hz+ oz! !

!CubicSpaceDivider methodsFor: 'face-accessing' stamp: 'emm 02/09/2012 23:40'!
top
	"Answer the top (XY plane facing negative Z) face"

	| hx hy hz ox oz oy where|
	hx := barExtent x / 2.
	hy := barExtent y / 2.
	hz := extent z / 2.
	where := self origin.
	ox := where x.
	oy := where y.
	oz := where z.
	^(Polygon3D new)
		addX: centerOffset x + hx + ox y: centerOffset y + hy + oy z: hz + oz 
		;addX: centerOffset x + hx + ox y: centerOffset y - hy + oy z: hz + oz 
		;addX: centerOffset x - hx + ox y: centerOffset y - hy + oy z: hz + oz 
		;addX: centerOffset x - hx + ox y: centerOffset y + hy + oy z: hz + oz! !

!CubicSpaceDivider methodsFor: 'face-accessing' stamp: 'emm 02/09/2012 23:40'!
west
	"Answer the west (XZ plane facing positive y) face"

	| hx hz neghy ox oy oz where |
	hx := barExtent x / 2.
	hz := barExtent z / 2.
	neghy := extent y / -2.
	where := self origin.
	ox := where x.
	oy := where y.
	oz := where z.
	^(Polygon3D new)
		addX: centerOffset x + hx + ox y: neghy + oy  z: centerOffset z - hz + oz 
		;addX: centerOffset x - hx + ox y: neghy + oy  z: centerOffset z - hz + oz 
		;addX: centerOffset x - hx + ox y: neghy + oy  z: centerOffset z + hz + oz 
		;addX: centerOffset x + hx + ox y: neghy + oy  z: centerOffset z + hz + oz! !

!ExtendedGeometric3D class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:33'!
boundedBy: aBoundingBox

	^self origin: aBoundingBox origin corner: aBoundingBox corner! !

!ExtendedGeometric3D class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:33'!
boundedBySphere: aSphere 
	"Answer a new maximum sized cube that lies inside <aSphere>"! !

!ExtendedGeometric3D class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:33'!
center: center extent: extent 

	| centerPoint extentPoint |
	centerPoint := center asPoint3D.
	extentPoint := extent asPoint3D.
	^self origin: centerPoint - (extentPoint / 2) extent: extentPoint! !

!ExtendedGeometric3D class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:33'!
centerExtent: aPoint 

	^self origin: aPoint / 2 negated corner: aPoint / 2! !

!ExtendedGeometric3D class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:33'!
origin: originPoint centerExtent: extentPoint

	| halfExtent |
	halfExtent := extentPoint / 2.
	^self new
		origin: originPoint - halfExtent
		; corner: originPoint + halfExtent! !

!ExtendedGeometric3D class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:33'!
origin: originPoint corner: cornerPoint 

	^originPoint isZero
		ifTrue: [ self size: cornerPoint ]
		ifFalse: [ ( self size: cornerPoint - originPoint )
				translateBy: originPoint ]! !

!ExtendedGeometric3D class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:33'!
origin: originPoint extent: extentPoint 

	^( self new ) origin: originPoint; extent: extentPoint! !

!ExtendedGeometric3D class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:33'!
size: aPoint 

	^self new extent: aPoint asPoint3D! !

!ExtendedGeometric3D class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:33'!
zero

	^self origin: Point3D zero extent: Point3D zero! !

!ExtendedGeometric3D methodsFor: 'converting' stamp: 'emm 02/09/2012 23:33'!
asBox

	^Box origin: self origin corner: self corner! !

!ExtendedGeometric3D methodsFor: '*Zenna-Shapes3D' stamp: 'emm 02/09/2012 23:39'!
asGrid

	^Grid3D
		origin: self origin
		corner: self corner
		delta: self xSize @ self ySize @ self zSize "vertices will be grid points"! !

!ExtendedGeometric3D methodsFor: '*Zenna-Shapes3D' stamp: 'emm 02/09/2012 23:39'!
asGrid: gridSize 

	^( Grid3D origin: self origin corner: self corner )
		delta: gridSize! !

!ExtendedGeometric3D methodsFor: 'converting' stamp: 'emm 02/09/2012 23:33'!
asWrapperOnDefault
	
	| newWrapper |
	^self extent isUnity
		ifTrue: 
			[ super asWrapperOnDefault ]
		ifFalse: 
			[ newWrapper := self wrapScaleBy: self extent.
			self extent: Point3D unity.
			self origin isZero
				ifFalse: 
					[ newWrapper := newWrapper wrapTranslateBy: self origin.
					self origin: Point3D zero].
			newWrapper]! !

!ExtendedGeometric3D methodsFor: 'accessing-vertices' stamp: 'emm 02/09/2012 23:33'!
backCenterBottom

	"Pre: normalized
	Answer a new point that can be found on the back (x)  face, its center (y) on bottom (z)
	Note: selector follows x-y-z convention
	"

	^Point3D x: self origin x y: (self origin y + self corner y) / 2 z: self origin z! !

!ExtendedGeometric3D methodsFor: 'accessing-vertices' stamp: 'emm 02/09/2012 23:33'!
backLeftBottom

	"Pre: normalized
	Answer a new point that can be found on the back (x)  face, its right (y) edge on bottom (z)
	Note: selector follows x-y-z convention
	"

	^self origin copy! !

!ExtendedGeometric3D methodsFor: 'accessing-vertices' stamp: 'emm 02/09/2012 23:33'!
backLeftTop

	"Answer the point that can be found on the back (x)  face, its left (y) edge on top (z)
	Note: selector follows x-y-z convention
	"

	| o |
	o := self origin.
	^Point3D x: o x y: o y z: self corner z! !

!ExtendedGeometric3D methodsFor: 'accessing-vertices' stamp: 'emm 02/09/2012 23:33'!
backLeftTop: aPoint

	"Set the point that can be found on the back (x)  face, its left (y) edge on top (z)
	Note: selector follows x-y-z convention
	"

	self origin x: aPoint x.
	self origin y: aPoint y.
	self cornerZ: aPoint z.! !

!ExtendedGeometric3D methodsFor: 'accessing-vertices' stamp: 'emm 02/09/2012 23:33'!
backRightBottom

	"Pre: normalized
	Answer a new point that can be found on the back (x)  face, its right (y) edge on bottom (z)
	Note: selector follows x-y-z convention
	"

	^Point3D x: self origin x y: self corner y z: self origin z! !

!ExtendedGeometric3D methodsFor: 'accessing-vertices' stamp: 'emm 02/09/2012 23:33'!
backRightBottom: aPoint

	"Set the point that can be found on the back (x)  face, its right (y) edge on bottom (z)
	Note: selector follows x-y-z convention
	"
	self origin x: aPoint x.
	self cornerY: aPoint y.
	self origin z: aPoint z! !

!ExtendedGeometric3D methodsFor: 'accessing-vertices' stamp: 'emm 02/09/2012 23:33'!
backRightTop

	"Answer the point that can be found on the back (x)  face, its right (y) edge on top (z)
	Note: selector follows x-y-z convention
	"

	| o |
	o := self origin.
	^Point3D x: o x y: self corner y z: self corner z! !

!ExtendedGeometric3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:33'!
bottomCenter: aPoint3D

	| hExtent |
	hExtent := self extent / 2.
	self origin: aPoint3D x - hExtent x @ ( aPoint3D y - hExtent y) @ aPoint3D z! !

!ExtendedGeometric3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:33'!
bounds
	"Answer the bounding box for the receiver"

	^BoundingBox origin: self origin corner: self corner! !

!ExtendedGeometric3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:33'!
bounds: aBoundingBox
	"Set the new bounding box for the receiver"

	self origin: aBoundingBox origin.
	self extent: aBoundingBox extent! !

!ExtendedGeometric3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:33'!
center

	^self origin + (self extent / 2)! !

!ExtendedGeometric3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:33'!
center: aValue

	self origin: aValue - (self extent / 2)! !

!ExtendedGeometric3D methodsFor: 'accessing-vertices' stamp: 'emm 02/09/2012 23:33'!
centerLeftBottom

	"Pre: normalized
	Answer a new point that can be found on the center (x) , its left (y) edge on bottom (z)
	Note: selector follows x-y-z convention
	"

	^Point3D x: (self origin x + self corner x ) / 2 y: self origin y z: self origin z! !

!ExtendedGeometric3D methodsFor: 'accessing-vertices' stamp: 'emm 02/09/2012 23:33'!
centerLeftTop

	^Point3D 
			x: self center x
			y: self origin y
			z: self corner z! !

!ExtendedGeometric3D methodsFor: 'accessing-vertices' stamp: 'emm 02/09/2012 23:33'!
centerRightBottom

	"Pre: normalized
	Answer a new point that can be found on the center (x) , its right (y) edge on bottom (z)
	Note: selector follows x-y-z convention
	"

	^Point3D x: (self origin x + self corner x ) / 2 y: self corner y z: self origin z! !

!ExtendedGeometric3D methodsFor: 'accessing-vertices' stamp: 'emm 02/09/2012 23:33'!
centerRightTop

	^self corner copy x: self center x! !

!ExtendedGeometric3D methodsFor: 'transforming' stamp: 'emm 02/09/2012 23:33'!
centered

	^self copy translateBy: self center negated! !

!ExtendedGeometric3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:33'!
corner

	^self origin + self extent! !

!ExtendedGeometric3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:33'!
corner: aValue

	self extent: aValue - self origin! !

!ExtendedGeometric3D methodsFor: 'accessing-xyz' stamp: 'emm 02/09/2012 23:33'!
cornerX: x
	
	extent x: x - self origin x! !

!ExtendedGeometric3D methodsFor: 'accessing-xyz' stamp: 'emm 02/09/2012 23:33'!
cornerY: y

	extent y: y - self origin y! !

!ExtendedGeometric3D methodsFor: 'accessing-xyz' stamp: 'emm 02/09/2012 23:33'!
cornerZ: z

	extent z: z - self origin z! !

!ExtendedGeometric3D methodsFor: 'initialize-release' stamp: 'emm 02/09/2012 23:33'!
defaultExtent

	^Point3D unity! !

!ExtendedGeometric3D methodsFor: 'transforming' stamp: 'emm 02/09/2012 23:33'!
expandBy: delta 
	"Modify the receiver"

	| deltaPoint oldOrigin oldCorner |
	deltaPoint := delta asPoint3D.
	oldOrigin := self origin.
	oldCorner := self corner.
	self origin: oldOrigin - deltaPoint.
	self corner: oldCorner + deltaPoint.! !

!ExtendedGeometric3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:33'!
extent

	^extent! !

!ExtendedGeometric3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:33'!
extent: aValue

	extent := aValue! !

!ExtendedGeometric3D methodsFor: 'accessing-vertices' stamp: 'emm 02/09/2012 23:33'!
frontCenterBottom

	"Pre: normalized
	Answer a new point that can be found on the front (x)  face, its center (y) on bottom (z)
	Note: selector follows x-y-z convention
	"

	^Point3D x: self corner x y: (self origin y + self corner y) / 2 z: self origin z! !

!ExtendedGeometric3D methodsFor: 'accessing-vertices' stamp: 'emm 02/09/2012 23:33'!
frontCenterTop

	"Answer the point that can be found on the front (x)  face, its center (y) edge on top (z)
	Note: selector follows x-y-z convention
	"

	^Point3D x: self corner x y: ( self origin y + self corner y ) / 2 z: self corner z! !

!ExtendedGeometric3D methodsFor: 'accessing-vertices' stamp: 'emm 02/09/2012 23:33'!
frontLeftBottom

	"Answer the point that can be found on the front (x)  face, its left (y) edge on bottom (z)
	Note: selector follows x-y-z convention
	"

	^Point3D x: self corner x y: self origin y z: self origin z! !

!ExtendedGeometric3D methodsFor: 'accessing-vertices' stamp: 'emm 02/09/2012 23:33'!
frontLeftBottom: aPoint

	"Set the point that can be found on the front (x)  face, its left (y) edge on bottom (z)
	Note: selector follows x-y-z convention
	"

	self cornerX: aPoint x.
	self origin y: aPoint y.
	self origin z: aPoint z.! !

!ExtendedGeometric3D methodsFor: 'accessing-vertices' stamp: 'emm 02/09/2012 23:33'!
frontLeftTop

	"Answer the point that can be found on the front (x)  face, its left (y) edge on top (z)
	Note: selector follows x-y-z convention
	"

	^Point3D x: self corner x y: self origin y z: self corner z! !

!ExtendedGeometric3D methodsFor: 'accessing-vertices' stamp: 'emm 02/09/2012 23:33'!
frontLeftTop: aPoint

	"Set the point that can be found on the front (x)  face, its left (y) edge on top (z)
	Note: selector follows x-y-z convention
	"

	self cornerX: aPoint x.
	self origin y: aPoint y.
	self cornerZ: aPoint z. ! !

!ExtendedGeometric3D methodsFor: 'accessing-vertices' stamp: 'emm 02/09/2012 23:33'!
frontRightBottom

	"Pre: normalized
	Answer a new point that can be found on the front (x)  face, its right (y) edge on bottom (z)
	Note: selector follows x-y-z convention
	"

	^Point3D x: self corner x y: self corner y z: self origin z! !

!ExtendedGeometric3D methodsFor: 'accessing-vertices' stamp: 'emm 02/09/2012 23:33'!
frontRightTop

	"Pre: normalized
	Answer a new point that can be found on the front (x)  face, its right (y) edge on top (z)
	Note: selector follows x-y-z convention
	"

	^Point3D x: self corner x y: self corner y z: self corner z! !

!ExtendedGeometric3D methodsFor: 'real-accessing' stamp: 'emm 02/09/2012 23:33'!
height

	^extent z! !

!ExtendedGeometric3D methodsFor: 'real-accessing' stamp: 'emm 02/09/2012 23:33'!
height: aNumber

	extent z: aNumber! !

!ExtendedGeometric3D methodsFor: 'testing' stamp: 'emm 9/23/2012 22:45'!
includesPoint: aPoint3D 
	
	^self origin <= aPoint3D
		and: [ aPoint3D <= self corner ]! !

!ExtendedGeometric3D methodsFor: 'initialize-release' stamp: 'emm 02/09/2012 23:33'!
initialize

	super initialize.
	self extent: self defaultExtent! !

!ExtendedGeometric3D methodsFor: 'transforming' stamp: 'emm 02/09/2012 23:33'!
insetBy: delta 
	"Answer a new instance"

	| deltaPoint copy oldOrigin oldCorner |
	deltaPoint := delta asPoint3D.
	copy := self copy.
	oldOrigin := self origin.
	oldCorner := self corner.
	copy origin: oldOrigin + deltaPoint.
	copy corner: oldCorner - deltaPoint.
	^copy! !

!ExtendedGeometric3D methodsFor: 'inspecting' stamp: 'emm 02/09/2012 23:33'!
inspectActions
	
	^#(corner length height width)! !

!ExtendedGeometric3D methodsFor: 'testing' stamp: 'emm 02/09/2012 23:33'!
intersectsBoundingBox: aBox! !

!ExtendedGeometric3D methodsFor: 'real-accessing' stamp: 'emm 02/09/2012 23:33'!
length

	^extent x! !

!ExtendedGeometric3D methodsFor: 'real-accessing' stamp: 'emm 02/09/2012 23:33'!
length: aNumber

	extent x: aNumber! !

!ExtendedGeometric3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:33'!
maximum

	^self corner! !

!ExtendedGeometric3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:33'!
minimum

	^self origin! !

!ExtendedGeometric3D methodsFor: 'transforming' stamp: 'emm 02/09/2012 23:33'!
mirrorInYZ

	origin := (origin x negated - self length) , origin y , origin z! !

!ExtendedGeometric3D methodsFor: 'transforming' stamp: 'emm 02/09/2012 23:33'!
normalize
	
	"Make sure the origin is closest to Point zero and corner the most farest"
	
	| o c |
	o := self origin.
	c := self corner.
	self 
		origin: ( Point3D 
			x: ( o x min: c x ) 
			y: ( o y min: c y ) 
			z: ( o z min: c z ) ) 	
		corner: ( Point3D 
			x: ( o x max: c x ) 
			y: ( o y max: c y ) 
			z: ( o z max: c z ) )! !

!ExtendedGeometric3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:33'!
origin: originPoint corner: cornerPoint

	self origin: originPoint.
	self corner: cornerPoint! !

!ExtendedGeometric3D methodsFor: 'copying' stamp: 'emm 02/09/2012 23:33'!
postCopy

	super postCopy.
	extent := extent copy! !

!ExtendedGeometric3D methodsFor: 'transforming' stamp: 'emm 02/09/2012 23:33'!
scaleBy: aPoint

	super scaleBy: aPoint.
	self extent scaleBy: aPoint! !

!ExtendedGeometric3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:33'!
size: aNumberOrPoint

	self extent: aNumberOrPoint asPoint3D! !

!ExtendedGeometric3D methodsFor: '*Zenna-Collections3D' stamp: 'emm 02/09/2012 23:43'!
subdividedBy: countPoint

	"Answer a composite containing
	subdivision of the receiver by @count"

	| subExtent composite|
	subExtent := self length / countPoint x ,(self width / countPoint y), (self height / countPoint z).
	composite := CompositeGeometric3D new.
	(self origin x to: self corner x steps: countPoint x) do:[ :x |
		(self origin y to: self corner y steps: countPoint y) do:[ :y |
			(self origin z to: self corner z steps: countPoint z) do:[ :z |
				composite add: (self class origin: x,y,z extent: subExtent) ]]].
	^composite
! !

!ExtendedGeometric3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:33'!
topCenter: aPoint3D

	| hExtent |
	hExtent := self extent / 2.
	self corner: aPoint3D x + hExtent x @ ( aPoint3D y + hExtent y) @ aPoint3D z! !

!ExtendedGeometric3D methodsFor: 'real-accessing' stamp: 'emm 02/09/2012 23:33'!
width

	^extent y! !

!ExtendedGeometric3D methodsFor: 'real-accessing' stamp: 'emm 02/09/2012 23:33'!
width: aNumber

	extent y: aNumber! !

!ExtendedGeometric3D methodsFor: 'accessing-xyz' stamp: 'emm 02/09/2012 23:33'!
xSize

	^extent x! !

!ExtendedGeometric3D methodsFor: 'accessing-xyz' stamp: 'emm 02/09/2012 23:33'!
xSize: aValue

	extent x: aValue! !

!ExtendedGeometric3D methodsFor: 'accessing-xyz' stamp: 'emm 02/09/2012 23:33'!
ySize

	^extent y! !

!ExtendedGeometric3D methodsFor: 'accessing-xyz' stamp: 'emm 02/09/2012 23:33'!
ySize: aValue

	extent y: aValue! !

!ExtendedGeometric3D methodsFor: 'accessing-xyz' stamp: 'emm 02/09/2012 23:33'!
zSize

	^extent z! !

!ExtendedGeometric3D methodsFor: 'accessing-xyz' stamp: 'emm 02/09/2012 23:33'!
zSize: aValue

	extent z: aValue! !

ExtendedGeometric3D subclass: #Pyramid
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Shapes3D'!

!Pyramid methodsFor: 'face-accessing' stamp: 'emm 02/09/2012 23:40'!
back

	| corner where |
	where := self origin.
	corner := self corner.
	^Triangle3D
		with: (self center z: corner z) "top"
		with: where "back left"
		with: where x @ corner y @ where z "back right"! !

!Pyramid methodsFor: 'face-accessing' stamp: 'emm 02/09/2012 23:40'!
bottom

	| corner where |
	where := self origin.
	corner := self corner.
	^Polygon3D new
		addX: corner x y: corner y z: where z "front right"
		; addX: where x y: corner y z: where z "back right"
		; add: where "back left"
		; addX: corner x y: where y z: where z "front left"! !

!Pyramid methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:40'!
facesDo: aBlock

	aBlock value: self front.
	aBlock value: self left.
	aBlock value: self back.
	aBlock value: self right.
	aBlock value: self bottom! !

!Pyramid methodsFor: 'face-accessing' stamp: 'emm 02/09/2012 23:40'!
front

	| corner where |
	where := self origin.
	corner := self corner.
	^Triangle3D
		with: (self center z: corner z) "top"
		with: corner x @ corner y @ where z "front right"
		with: corner x @ where y @ where z "front left"! !

!Pyramid methodsFor: 'writing' stamp: 'emm 02/09/2012 23:40'!
kindDo: aRequestor

	^aRequestor doFaceComposite: self! !

!Pyramid methodsFor: 'face-accessing' stamp: 'emm 02/09/2012 23:40'!
left

	| corner where |
	where := self origin.
	corner := self corner.
	^Triangle3D
		with: (self center z: corner z) "top"
		with: corner x @ where y @ where z "front left"
		with: where "back left"! !

!Pyramid methodsFor: 'face-accessing' stamp: 'emm 02/09/2012 23:40'!
right

	| corner where |
	where := self origin.
	corner := self corner.
	^Triangle3D
		with: (self center z: corner z) "top"
		with: where x @ corner y @ where z "back right"
		with: corner x @ corner y @ where z "front right"! !

!Pyramid methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:40'!
trianglesDo: aBlock

	aBlock value: self front.
	aBlock value: self right.
	aBlock value: self back.
	aBlock value: self left.
	self bottom trianglesDo: aBlock.! !

!Pyramid methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:40'!
verticesDo: aBlock

	| corner where |
	corner := self corner.
	where := self origin.
	aBlock value: (self center z: corner y). "top"
	aBlock value: corner x @ corner y @ where z. "front right"
	aBlock value: where x @ corner y @ where z. "back right"
	aBlock value: where. "back left"
	aBlock value: corner x @ where y @ where z. "front left"! !

ExtendedGeometric3D subclass: #Rectangle3D
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Primitives3D'!

!Rectangle3D methodsFor: '*Zenna-Collections3D' stamp: 'emm 02/09/2012 23:43'!
asBackPolygon3D

	^self asFrontPolygon3D! !

!Rectangle3D methodsFor: '*Zenna-Collections3D' stamp: 'emm 02/09/2012 23:43'!
asBottomPolygon3D

	| face cx cy cz where |
	where := self origin.
	face := Polygon3D new.
	cx := self corner x.
	cy := self corner y.
	cz := self corner z.
	face add: where.
	face
		addX: cx
		y: where y
		z: cz.
	face
		addX: cx
		y: cy
		z: cz.
	face
		addX: where x
		y: cy
		z: cz.
	^face! !

!Rectangle3D methodsFor: '*Zenna-Collections3D' stamp: 'emm 02/09/2012 23:43'!
asFrontPolygon3D

	| face x |
	face := Polygon3D new.
	face
		addX: (x := self corner x)
		y: self origin y
		z: self origin z.
	face
		addX: x
		y: self origin y
		z: self corner z.
	face
		addX: x
		y: self corner y
		z: self corner z.
	face
		addX: x
		y: self corner y
		z: self origin z.
	^face! !

!Rectangle3D methodsFor: '*Zenna-Collections3D' stamp: 'emm 02/09/2012 23:43'!
asLeftPolygon3D

	| o |
	o := self origin.
	^(Polygon3D new)
		add: o
		; addX: o x y: o y z: self corner z
		; addX: self corner x y: o y z: self corner z
		; addX: self corner x y: o y z: o z! !

!Rectangle3D methodsFor: 'converting' stamp: 'emm 02/09/2012 23:36'!
asPlane

	^self asPolygon3D asPlane! !

!Rectangle3D methodsFor: '*Zenna-Collections3D' stamp: 'emm 02/09/2012 23:43'!
asPolygon3D
	
	self isFront 
		ifTrue:[ ^ self asFrontPolygon3D ].
	self isBack 
		ifTrue:[ ^ self asBackPolygon3D ].
	self isTop 
		ifTrue:[ ^ self asTopPolygon3D ].
	self isBottom 
		ifTrue:[ ^ self asBottomPolygon3D ].
	self isLeft 
		ifTrue:[ ^ self asLeftPolygon3D ].
	self isRight 
		ifTrue:[ ^ self asRightPolygon3D ].
	^ self error: 'illegal rectangle definition'! !

!Rectangle3D methodsFor: '*Zenna-Collections3D' stamp: 'emm 02/09/2012 23:43'!
asRightPolygon3D

	| face cx cy cz where |
	where := self origin.
	face := Polygon3D new.
	cx := self corner x.
	cy := self corner y.
	cz := self corner z.
	face add: where.
	face
		addX: where x
		y: cy
		z: cz.
	face
		addX: cx
		y: cy
		z: cz.
	face
		addX: cx
		y: where y
		z: where z.
	^face! !

!Rectangle3D methodsFor: 'computing' stamp: 'emm 02/09/2012 23:36'!
asSegments

	^self asPolygon3D asSegments! !

!Rectangle3D methodsFor: '*Zenna-Collections3D' stamp: 'emm 02/09/2012 23:43'!
asTopPolygon3D

	| face cx cy cz where |
	where := self origin.
	face := Polygon3D new.
	cx := self corner x.
	cy := self corner y.
	cz := self corner z.
	face add: where.
	face
		addX: cx
		y: where y
		z: cz.
	face
		addX: cx
		y: cy
		z: cz.
	face
		addX: where x
		y: cy
		z: cz.
	^face! !

!Rectangle3D methodsFor: 'private' stamp: 'emm 02/09/2012 23:36'!
checkInvariance

	( extent x = 0
		or:[ extent y = 0
			or:[ extent z = 0]] )
		ifFalse: [ self error: 'illegal Rectangle3D definition, not a regular plane' ]! !

!Rectangle3D methodsFor: 'redefined' stamp: 'emm 02/09/2012 23:36'!
defaultExtent

	^1,1,0! !

!Rectangle3D methodsFor: 'redefined' stamp: 'emm 02/09/2012 23:36'!
extent: aValue
	"check assertion"

	super extent: aValue.
	self checkInvariance! !

!Rectangle3D methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:36'!
facesDo: aBlock

	"Assume the points of the receiver are all on the same plane"
	
	^aBlock value: self! !

!Rectangle3D methodsFor: 'inspecting' stamp: 'emm 02/09/2012 23:36'!
inspectActions

	^super inspectActions , #(#normal #asPolygon3D)! !

!Rectangle3D methodsFor: 'testing' stamp: 'emm 02/09/2012 23:36'!
isBack

	^self origin x = self corner x and:[self origin y > self corner y]! !

!Rectangle3D methodsFor: 'testing' stamp: 'emm 02/09/2012 23:36'!
isBottom

	^self origin z = self corner z and:[self origin y > self corner y]! !

!Rectangle3D methodsFor: 'testing' stamp: 'emm 02/09/2012 23:36'!
isFront

	^self origin x = self corner x and:[self origin y < self corner y]! !

!Rectangle3D methodsFor: 'testing' stamp: 'emm 02/09/2012 23:36'!
isLeft

	^self origin y = self corner y and:[self origin x < self corner x]! !

!Rectangle3D methodsFor: 'testing' stamp: 'emm 02/09/2012 23:36'!
isRight

	^self origin y = self corner y and:[self origin x > self corner x]! !

!Rectangle3D methodsFor: 'testing' stamp: 'emm 02/09/2012 23:36'!
isTop

	^self origin z = self corner z and:[self origin y < self corner y]! !

!Rectangle3D methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:36'!
kindDo: aRequestor

	^aRequestor doRectangle3D: self! !

!Rectangle3D methodsFor: 'converting' stamp: 'emm 02/09/2012 23:36'!
mirroredInYZ

	^(self isFront or:[self isBack])
		ifTrue: [ self reverseOriented mirrorInYZ ]
		ifFalse:[ super mirroredInYZ]! !

!Rectangle3D methodsFor: 'computing' stamp: 'emm 02/09/2012 23:36'!
normal

	"Can be optimized"

	^self asPolygon3D normal! !

!Rectangle3D methodsFor: 'printing' stamp: 'emm 02/09/2012 23:36'!
printClassCreationOn: aStream indent: level

	super printClassCreationOn: aStream indent: level.
	aStream nextPut: $".
	#(#isTop #isBottom #isFront #isBack #isLeft #isRight) do:[ :sel |
		(self perform: sel) ifTrue: [ ^aStream nextPutAll: (sel copyFrom: 3 to: sel size) asLowercase ;nextPut: $"]]! !

!Rectangle3D methodsFor: 'converting' stamp: 'emm 02/09/2012 23:36'!
reverseOriented
		
	( self isFront
		or: [ self isBack ] ) 
		ifTrue:[ ^ self class origin: self origin + ( 0 , self extent y , 0 ) extent: 0 , self extent y negated , self extent z ].
	( self isLeft
		or: [ self isRight ] ) 
		ifTrue:[ ^ self class origin: self origin + ( self extent x , 0 , 0 ) extent: self extent x negated , 0 , self extent z ].
	( self isTop
		or: [ self isBottom ] ) 
		ifTrue:[ ^ self class origin: self origin + ( self extent x , 0 , 0 ) extent: self extent x negated , self extent y , 0 ]! !

!Rectangle3D methodsFor: '*Zenna-Collections3D' stamp: 'emm 02/09/2012 23:43'!
subdividedBy: p23 
	
	"Answer a composite containing subdivision of the receiver by @count"
	
	| point3D |
	p23 class == Point
		ifTrue:
			[ self extent x = 0 
				ifTrue:[ point3D := 1 , p23 x , p23 y ].
			self extent y =0 
				ifTrue:[ point3D := p23 x , 1 , p23 y ].
			self extent z = 0 
				ifTrue:[ point3D := p23 , 1 ] ]
		ifFalse:
			[ point3D := p23 ].
	^self subdividedByPoint3D: point3D! !

!Rectangle3D methodsFor: '*Zenna-Collections3D' stamp: 'emm 02/09/2012 23:43'!
subdividedByPoint3D: countPoint

	"Answer a composite containing
	subdivision of the receiver by @count"

	| subExtent composite xcol ycol zcol|
	subExtent := self length / countPoint x ,(self width / countPoint y), (self height / countPoint z).
	composite := CompositeGeometric3D new.
	xcol := self origin x = self corner x
		ifTrue: [ Array with: self origin x ]
		ifFalse: [ self origin x to: self corner x - subExtent x by: subExtent x ].
	ycol := self origin y = self corner y
		ifTrue: [ Array with: self origin y ]
		ifFalse: [ self origin y to: self corner y - subExtent y by: subExtent y ].	
	zcol := self origin z = self corner z
		ifTrue: [ Array with: self origin z ]
		ifFalse: [ self origin z to: self corner z - subExtent z by: subExtent z ].	
	xcol do:[ :x |
		ycol do:[ :y |
			zcol do:[ :z |
				composite add: (self class origin: x,y,z extent: subExtent) ]]].
	^composite
! !

!Rectangle3D methodsFor: 'computing' stamp: 'emm 02/09/2012 23:36'!
subdividedTo: howMany

	"Answer a subdivision of the receiver such that
	howMany rectangles are created with equal size"

	"Pre: xy plane for now"


	"(Rectangle3D origin: 0,0,0 corner: 2,3,0) subdividedTo: 6 "

	| ratio a b |
	ratio := self length / self width.
	a := howMany / ratio asFloat.
	b := howMany / a.
	^self subdividedBy: b rounded ,a rounded ,1! !

!Rectangle3D methodsFor: 'converting' stamp: 'emm 02/09/2012 23:36'!
subtract: anObject

	| results |
	results := OrderedCollection new.
	anObject subtractFromRectangle3D: self addResultsTo: results.
	^results! !

!Rectangle3D methodsFor: 'converting' stamp: 'emm 02/09/2012 23:36'!
subtractFromRectangle3D: sourceRect addResultsTo: aCollection
	"Compute sourceRect - self.
	Cases:
		argument is complete outside receiver
		argument intersects with receiver
		argument complete inside receiver
		receiver complete inside argument
	"
	
	"check for front,right,top"
	
	self origin > sourceRect corner
		ifTrue: ["outside"].
	self corner < sourceRect origin
		ifTrue: ["outside"].
	(sourceRect includesPoint: self origin)
		ifTrue: 
			[(sourceRect includesPoint: self corner)
				ifTrue: ["inside"]
			"partly inside"].! !

!Rectangle3D methodsFor: 'enumerating' stamp: 'emm 10/7/2012 22:54'!
trianglesDo: aBlock
	| via corner via1 via2 |
	corner := self corner.
	(self isFront or: [ self isBack ])
		ifTrue: [ 
			via1 := Point3D x: origin x y: origin y z: corner z.
			via2 := Point3D x: origin x y: corner y z: origin z ]
		ifFalse: [ 
			(self isLeft or: [ self isRight ])
				ifTrue: [ 
					via1 := Point3D x: origin x y: origin y z: corner z.
					via2 := Point3D x: corner x y: origin y z: origin z ]
				ifFalse: [ 
					"top or bottom"
					via1 := Point3D x: corner x y: origin y z: origin z.
					via2 := Point3D x: origin x y: corner y z: origin z ] ].
	aBlock value: (Triangle3D with: origin with: via1 with: corner).
	aBlock value: (Triangle3D with: origin with: corner with: via2)! !

!Rectangle3D methodsFor: 'computing' stamp: 'emm 02/09/2012 23:36'!
vertices

	^self asPolygon3D vertices! !

!Rectangle3D methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:36'!
verticesDo: aBlock

	^self asPolygon3D verticesDo: aBlock! !

ExtendedGeometric3D subclass: #Stairway
	instanceVariableNames: 'stairHeight closed interStairHeight stairEdgeLength'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Shapes3D'!

Stairway subclass: #SpiralStairway
	instanceVariableNames: 'innerRadius startAngle stepAngle sweepAngle'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Shapes3D'!

!SpiralStairway class methodsFor: 'examples' stamp: 'emm 02/09/2012 23:40'!
example
	"self example"

	| csc |
	csc := self new.
	^csc 
		outerRadius: 500
		; innerRadius: 300
		; stepAngle: 15 degreesToRadians
		; sweepAngle: 360 degreesToRadians
		; closed: false
		; stairHeight: 360 / 15.0! !

!SpiralStairway methodsFor: 'computing' stamp: 'emm 02/09/2012 23:40'!
computeStairHeight
	"based on angles and the receiver's bounds"

	self stairHeight: (self extent z / (self sweepAngle / self stepAngle)) - self interStairHeight! !

!SpiralStairway methodsFor: 'computing' stamp: 'emm 02/09/2012 23:40'!
initialStairTop

	| ir or sin cos |
	ir := self innerRadius.
	or := self outerRadius.
	sin := self stepAngle sin.
	cos := self stepAngle cos.
	^self stepAngle > 0
		ifTrue: ["counter clockwise ordered = top"
			(Polygon3D new)
				addX: 0 y: or z: 0;
				addX: 0 y: ir z: 0; 
				addX: sin * ir negated y: cos * ir z: 0; 
				addX: sin * or negated y: cos * or z: 0; yourself]
		ifFalse: [(Polygon3D new)
				addX: sin * or negated y: cos * or z: 0;
				addX: sin * ir negated y: cos * ir z: 0;
				addX: 0 y: ir z: 0;
				addX: 0 y: or z: 0; yourself]! !

!SpiralStairway methodsFor: 'initialize-release' stamp: 'emm 02/09/2012 23:40'!
initialize

	super initialize.
	self startAngle: 0.
	self sweepAngle: 180 degreesToRadians.
	self stepAngle: 15 degreesToRadians.! !

!SpiralStairway methodsFor: 'solid-accessing' stamp: 'emm 02/09/2012 23:40'!
innerCyclinder! !

!SpiralStairway methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:40'!
innerRadius

	^innerRadius isNil
		ifTrue: [self stairHeight]
		ifFalse: [innerRadius]! !

!SpiralStairway methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:40'!
innerRadius: aValue

	innerRadius := aValue.
	aValue > 0
		ifTrue: [self closed: false]! !

!SpiralStairway methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:40'!
outerRadius

	^(self extent x min: self extent y)  / 2! !

!SpiralStairway methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:40'!
outerRadius: aNumber

	self extent x: aNumber * 2.
	self extent y: aNumber * 2.! !

!SpiralStairway methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:40'!
solidsDo: aBlock 

	| rotMatrix top stairTranslation stairBottomOffset |
	(self closed and: [self sweepAngle abs > Float pi])
		ifTrue: [^self error: 'sweep angle too large for closed cyclic stair'].
	rotMatrix := Matrix3x3 rotationZ: self stepAngle.
	top := self initialStairTop.
	top rotateBy: 0 @ 0 @ self startAngle.
	stairTranslation := 0 @ 0 @ self stairHeight.
	self closed 
		ifFalse: [stairTranslation := stairTranslation + (0@0@self interStairHeight)].
	top translateBy: stairTranslation.
	stairBottomOffset := 0 @ 0 @ self stairHeight negated.
	(self sweepAngle / self stepAngle) rounded
		timesRepeat: 
			[aBlock value: ((ExtrudedPolygon top: top translation: stairBottomOffset) 
				translateBy: self origin).
			self closed
				ifTrue: [stairBottomOffset := stairBottomOffset - stairTranslation].
			top := top translatedBy: stairTranslation.
			top := rotMatrix * top]! !

!SpiralStairway methodsFor: 'properties' stamp: 'emm 02/09/2012 23:40'!
stairWidth

	^self outerRadius - self innerRadius! !

!SpiralStairway methodsFor: 'properties' stamp: 'emm 02/09/2012 23:40'!
stairWidth: aNumber 

	self innerRadius: self outerRadius - aNumber! !

!SpiralStairway methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:40'!
start: angleStart step: angleStep stop: angleStop

	startAngle := angleStart.
	stepAngle := angleStep.
	sweepAngle := angleStop - angleStart! !

!SpiralStairway methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:40'!
startAngle

	^startAngle! !

!SpiralStairway methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:40'!
startAngle: aValue

	startAngle := aValue! !

!SpiralStairway methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:40'!
stepAngle

	^stepAngle! !

!SpiralStairway methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:40'!
stepAngle: aValue

	stepAngle := aValue! !

!SpiralStairway methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:40'!
sweepAngle

	^sweepAngle! !

!SpiralStairway methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:40'!
sweepAngle: aValue

	sweepAngle := aValue! !

!SpiralStairway methodsFor: 'computing' stamp: 'emm 02/09/2012 23:40'!
topBoxPen

	"Answer a BoxPen at the top of the receiver such
	that top of the receiver is at the same height as
	the top of the boxes written by the BoxPen"! !

!Stairway class methodsFor: 'examples' stamp: 'emm 02/09/2012 23:40'!
example
	"self example"

	^self new
		width: 100
		; height: 800
		; length: 800
		; stairHeight: 25! !

!Stairway class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:40'!
new
	^super new initialize! !

!Stairway methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:40'!
closed

	^closed! !

!Stairway methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:40'!
closed: aValue 

	closed := aValue.
	aValue
		ifTrue: 
			[self interStairHeight: 0.
			self stairEdgeLength: 0]! !

!Stairway methodsFor: 'computing' stamp: 'emm 02/09/2012 23:40'!
computeStairHeight
	"fix to 25 if not specified"

	^self stairHeight: 25! !

!Stairway methodsFor: 'computing' stamp: 'emm 02/09/2012 23:40'!
frontLeftBottom

	"Answer the point that can be found on the front (x)  face, its left (y) edge on bottom (z)
	Note: selector follows x-y-z convention
	"

	^Point3D x: self corner x y: self origin y z: self origin z! !

!Stairway methodsFor: 'properties' stamp: 'emm 02/09/2012 23:40'!
howManyStairs

	^self height + self interStairHeight // (self stairHeight + self interStairHeight)! !

!Stairway methodsFor: 'initialize-release' stamp: 'emm 02/09/2012 23:40'!
initialize

	super initialize.
	self extent: 25 @ 25 @ 25.
	self closed: true.
	self interStairHeight: 0.
	self stairEdgeLength: 0! !

!Stairway methodsFor: 'inspecting' stamp: 'emm 02/09/2012 23:40'!
inspectActions

	^super inspectActions , #( stairWidth stairHeight stairLength howManyStairs )! !

!Stairway methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:40'!
interStairHeight

	^interStairHeight! !

!Stairway methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:40'!
interStairHeight: aValue

	interStairHeight := aValue! !

!Stairway methodsFor: 'double-dispatching' stamp: 'emm 02/09/2012 23:40'!
kindDo: aRequestor

	^aRequestor doSolidComposite: self! !

!Stairway methodsFor: 'properties' stamp: 'emm 02/09/2012 23:40'!
numberOfStairs: stairSize 
	"Stairheight and height are fixed.
	Compute a new interStairHeight"

	| ish |
	ish := self height - ( self stairHeight * stairSize ) / ( stairSize - 1 ).
	ish < 0
		ifTrue: [ self error: 'space between stairs cannot be < 0' ].
	self interStairHeight: ish! !

!Stairway methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:40'!
solidsDo: aBlock 

	| stairOrigin stairCorner cornerStep originStep |
	stairOrigin := self closed
		ifTrue:[ self origin ]
		ifFalse:[ self frontLeftBottom decX: self stairLength ].
	stairCorner := self corner z: (self origin z + self stairHeight).
	cornerStep := ( self stairEdgeLength - self stairLength ) @ 0 @ ( self stairHeight + self interStairHeight ).
	originStep := self closed
		ifTrue:[ 0@0@( self stairHeight + self interStairHeight ) ]
		ifFalse:[ cornerStep ].

	self howManyStairs
		timesRepeat: 
			[ aBlock value: ( Box origin: stairOrigin corner: stairCorner ) normalize.
			stairOrigin := stairOrigin + originStep.
			stairCorner := stairCorner + cornerStep ]! !

!Stairway methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:40'!
stairEdgeLength

	^stairEdgeLength! !

!Stairway methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:40'!
stairEdgeLength: aValue

	stairEdgeLength := aValue! !

!Stairway methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:40'!
stairHeight

	stairHeight isNil
		ifTrue: [self computeStairHeight].
	^stairHeight! !

!Stairway methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:40'!
stairHeight: aValue

	stairHeight := aValue! !

!Stairway methodsFor: 'properties' stamp: 'emm 02/09/2012 23:40'!
stairLength

	| size |
	size := self howManyStairs.
	^self length + ( size - 1 * self stairEdgeLength ) / size! !

!Stairway methodsFor: 'properties' stamp: 'emm 02/09/2012 23:40'!
stairLength: aNumber 
	"Height and width of the receiver are fixed.
	Compute the new length"

	| size |
	size := self howManyStairs.
	self length: size * aNumber - ( size - 1 * self stairEdgeLength )! !

!Stairway methodsFor: 'properties' stamp: 'emm 02/09/2012 23:40'!
stairWidth

	^self width! !

!Stairway methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:40'!
stairsWithOutsideBarsDo: aBlock! !

TranslatedGeometric3D subclass: #ICubePiece
	instanceVariableNames: 'id color front back left right'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-ShapeGallery'!

!ICubePiece class methodsFor: 'building' stamp: 'emm 03/09/2012 20:20'!
cubeFromPieces: pieces
	
	|  faces piece |
	faces := CompositeGeometric3D new.

	piece := pieces at: 1.
	piece := (( piece 
		wrapTranslateBy: piece origin negated ) 
		wrapRotateBy: 270 rad,0,0 ) 
		wrapTranslateBy: 0,0,5.
	faces add: piece.

	piece := pieces at: 2.
	piece := (( piece 
		wrapTranslateBy: piece origin negated ) 
		wrapRotateBy: 180 rad,0,0 ) 
		wrapTranslateBy: 0,5,5.
	faces add: piece.	

	piece := pieces at: 3.
	piece := (piece 
		wrapTranslateBy: piece origin negated ) 
		wrapRotateBy: 90 rad ,0 , 90 rad.
	faces add: piece.

	piece := pieces at: 4.
	piece := (( piece 
		wrapTranslateBy: piece origin negated ) 
		wrapRotateBy: 90 rad ,0 , 0) 
		wrapTranslateBy: 0,5,0.
	faces add: piece.

	piece := pieces at: 5.
	piece := (( piece 
		wrapTranslateBy: piece origin negated ) 
		wrapRotateBy:  90 rad ,0 , -90 rad)
		wrapTranslateBy: 5,5,0.
	faces add: piece.

	piece := pieces at: 6.
	piece := (piece 
		wrapTranslateBy: piece origin negated ).
	faces add: piece.
	^faces
	
	
	! !

!ICubePiece class methodsFor: 'all colors' stamp: 'emm 03/09/2012 20:20'!
cyanCube
	"self cyanCube"
	
	^self cubeFromPieces: self cyanPieces! !

!ICubePiece class methodsFor: 'all colors' stamp: 'emm 03/09/2012 20:20'!
cyanPieces
	"self cyanPieces"

	^self piecesFromData: self cyanPiecesData color: Color cyan! !

!ICubePiece class methodsFor: 'all colors' stamp: 'emm 03/09/2012 20:20'!
cyanPiecesData

	"left-front-right-back-left[1]"

	^#( 
		'00100010001000100'
		'01010010110101010'
		'10101101101011011'
		'01010010001000100'
		'10100101010111011'
		'01011101101001010'
		)! !

!ICubePiece class methodsFor: 'instance-creation' stamp: 'emm 03/09/2012 20:20'!
fromData: bitString

	^(self new)
		left: (bitString copyFrom: 1 to: 5)
		;front: (bitString copyFrom: 5 to: 9)
		;right: (bitString copyFrom: 9 to: 13) reverse
		;back: (bitString copyFrom: 13 to: 17) reverse
			! !

!ICubePiece class methodsFor: 'all colors' stamp: 'emm 03/09/2012 20:20'!
greenCube
	"self greenCube"
	
	^self cubeFromPieces: self greenPieces! !

!ICubePiece class methodsFor: 'all colors' stamp: 'emm 03/09/2012 20:20'!
greenPieces
	"self greenPieces"

	^self piecesFromData: self greenPiecesData color: Color green! !

!ICubePiece class methodsFor: 'all colors' stamp: 'emm 03/09/2012 20:20'!
greenPiecesData

	"left-front-right-back-left[1]"

	^#( 
		'00100101001001010'
		'00100101110110101'
		'01010101010100100'
		'11010101110110101'
		'11011010001000101'
		'11010010001000101'
		)! !

!ICubePiece class methodsFor: 'all colors' stamp: 'emm 03/09/2012 20:20'!
magentaCube
	"self magentaCube"
	
	^self cubeFromPieces: self magentaPieces! !

!ICubePiece class methodsFor: 'all colors' stamp: 'emm 03/09/2012 20:20'!
magentaPieces
	"self magentaPieces"

	^self piecesFromData: self magentaPiecesData color: Color magenta! !

!ICubePiece class methodsFor: 'all colors' stamp: 'emm 03/09/2012 20:20'!
magentaPiecesData

	"left-front-right-back-left[1]"

	^#( 
		'01010010110001100'
		'01010100001000100'
		'01010010110111000'
		'11000101101001011'
		'01000101111000100'
		'11100110111000101'
		)! !

!ICubePiece class methodsFor: 'all colors' stamp: 'emm 03/09/2012 20:20'!
orangeCube
	"self orangeCube"
	
	^self cubeFromPieces: self orangePieces! !

!ICubePiece class methodsFor: 'all colors' stamp: 'emm 03/09/2012 20:20'!
orangePieces
	"self orangePieces"

	^self piecesFromData: self orangePiecesData color: Color orange! !

!ICubePiece class methodsFor: 'all colors' stamp: 'emm 03/09/2012 20:20'!
orangePiecesData

	"left-front-right-back-left[1]"

	^#( 
		'11000101010110101'
		'00110010011000100'
		'01100010110101010'
		'10101101100101011'
		'01011010110100100'
		'00100010010101000'
		)! !

!ICubePiece class methodsFor: 'instance-creation' stamp: 'emm 03/09/2012 20:20'!
piecesFromData: aDataCollection color: aColor

	| id origins |
	id := 0.
	origins := self piecesPositions.
	^aDataCollection collect:[ :each |
		(self fromData: each )
			id:( id := id + 1)
			;color: aColor
			;origin: ( origins at: id ) * 4 ]! !

!ICubePiece class methodsFor: 'resources' stamp: 'emm 03/09/2012 20:20'!
piecesPositions

	"right-left
		back-front"

	^Point3DCollection fromBitString: 
'010
010
111
010'! !

!ICubePiece class methodsFor: 'all colors' stamp: 'emm 03/09/2012 20:20'!
redCube
	"self redCube"
	
	^self cubeFromPieces: self redPieces! !

!ICubePiece class methodsFor: 'all colors' stamp: 'emm 03/09/2012 20:20'!
redPieces
	"self redPieces"

	^self piecesFromData: self redPiecesData color: Color red! !

!ICubePiece class methodsFor: 'all colors' stamp: 'emm 03/09/2012 20:20'!
redPiecesData

	"left-front-right-back-left[1]"

	^#( 
		'01011010010101100'
		'01010100001001010'
		'00100101101011000'
		'01010010001000100'
		'11001101011011011'
		'10100110001011011'
		)! !

!ICubePiece class methodsFor: 'all colors' stamp: 'emm 03/09/2012 20:20'!
yellowCube
	"self yellowCube"
	
	^self cubeFromPieces: self yellowPieces! !

!ICubePiece class methodsFor: 'all colors' stamp: 'emm 03/09/2012 20:20'!
yellowPieces
	"self yellowPieces"

	^self piecesFromData: self yellowPiecesData color: Color yellow! !

!ICubePiece class methodsFor: 'all colors' stamp: 'emm 03/09/2012 20:20'!
yellowPiecesData

	"left-front-right-back-left[1]"

	^#( 
		'00100010010101010'
		'11011010110100101'
		'00111010010110100'
		'00101101001001010'
		'00101101010100100'
		'10100101010100011'
		)! !

!ICubePiece methodsFor: 'converting' stamp: 'emm 03/09/2012 20:20'!
asBitString

	| outStream |
	outStream := WriteStream on: (String new: 25).
	outStream nextPutAll: self right ;cr.
	4 to: 2 by: -1 do:[ :index |
		outStream nextPut: ( self back at: index) ;nextPutAll: '111' ;nextPut: ( self front at: index) ;cr].
	outStream nextPutAll: self left.
	^outStream contents! !

!ICubePiece methodsFor: 'converting' stamp: 'emm 03/09/2012 20:20'!
asContourPoints! !

!ICubePiece methodsFor: 'converting' stamp: 'emm 03/09/2012 20:20'!
asCubes

	^self asCubesWithSize: 1 asPoint3D! !

!ICubePiece methodsFor: 'converting' stamp: 'emm 03/09/2012 20:20'!
asCubesWithSize: sizePoint

	^self asGridPoints collect:[ :each | Box origin: each + self origin extent: sizePoint ].! !

!ICubePiece methodsFor: 'converting' stamp: 'emm 03/09/2012 20:20'!
asGridPoints

	^Point3DCollection fromBitString: self asBitString! !

!ICubePiece methodsFor: 'converting' stamp: 'emm 03/09/2012 20:20'!
asSolid

	^CompositeGeometric3D on: self asCubes! !

!ICubePiece methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:20'!
back

	"Answer the value of back"

	^back! !

!ICubePiece methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:20'!
back: aValue

	"Set the value of back"

	back := aValue! !

!ICubePiece methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:20'!
color

	"Answer the value of color"

	^color! !

!ICubePiece methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:20'!
color: aValue

	"Set the value of color"

	color := aValue! !

!ICubePiece methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:20'!
front

	"Answer the value of front"

	^front! !

!ICubePiece methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:20'!
front: aValue

	"Set the value of front"

	front := aValue! !

!ICubePiece methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:20'!
id

	"Answer the value of id"

	^id! !

!ICubePiece methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:20'!
id: aValue

	"Set the value of id"

	id := aValue! !

!ICubePiece methodsFor: 'double-dispatching' stamp: 'emm 03/09/2012 20:20'!
kindDo: aRequestor

	aRequestor doSolidComposite: self! !

!ICubePiece methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:20'!
left

	"Answer the value of left"

	^left! !

!ICubePiece methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:20'!
left: aValue

	"Set the value of left"

	left := aValue! !

!ICubePiece methodsFor: 'printing' stamp: 'emm 03/09/2012 20:20'!
printOn: aStream indent: level

	super printOn: aStream indent: level.
	#( id color left front right back ) do:[ :each |
		aStream
			crtab: level + 1 ;nextPut: $; ;nextPutAll: each ;nextPut: $: ;print: (self perform: each) ].
			! !

!ICubePiece methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:20'!
right

	"Answer the value of right"

	^right! !

!ICubePiece methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:20'!
right: aValue

	"Set the value of right"

	right := aValue! !

!ICubePiece methodsFor: 'enumerating' stamp: 'emm 03/09/2012 20:20'!
solidsDo: aBlock 

	^self asCubes do: aBlock! !

TranslatedGeometric3D subclass: #Light
	instanceVariableNames: 'color'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Appearance3D'!

!Light class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:44'!
at: aPoint3D

	^( PointLight new )
		origin: aPoint3D
		; color: Color white! !

!Light class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:44'!
at: aPoint3D lookingAt: focusPoint

	^( SpotLight new )
		origin: aPoint3D
		; color: Color white
		; focusPoint: focusPoint! !

!Light methodsFor: 'testing' stamp: 'emm 02/09/2012 23:44'!
canBeTextureWrapped

	^false! !

!Light methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:44'!
color

	"Answer the value of color"

	^color! !

!Light methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:44'!
color: aValue

	"Set the value of color"

	color := aValue! !

!Light methodsFor: 'initialize' stamp: 'emm 02/09/2012 23:44'!
initialize

	color := Color white! !

Light subclass: #PointLight
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Appearance3D'!

!PointLight methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:44'!
kindDo: aRequestor

	^aRequestor doPointLight: self! !

Light subclass: #SpotLight
	instanceVariableNames: 'focusPoint radius'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Appearance3D'!

!SpotLight methodsFor: 'computing' stamp: 'emm 02/09/2012 23:44'!
estimatedRadius

	"Assume a spot angle of 30 degrees"

	^(self origin dist: self focusPoint) / 30 rad cos! !

!SpotLight methodsFor: 'computing' stamp: 'emm 02/09/2012 23:44'!
falloff

	^self radius + 5! !

!SpotLight methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:44'!
focusPoint

	"Answer the value of focusPoint"

	focusPoint isNil
		ifTrue: [ focusPoint := self origin - (0,0,10) ].
	^focusPoint! !

!SpotLight methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:44'!
focusPoint: aValue

	"Set the value of focusPoint"

	focusPoint := aValue! !

!SpotLight methodsFor: 'testing' stamp: 'emm 02/09/2012 23:44'!
isSpot

	^focusPoint notNil! !

!SpotLight methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:44'!
kindDo: aRequestor

	^aRequestor doSpotLight: self! !

!SpotLight methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:44'!
radius

	"Answer the value of radius"

	radius isNil
		ifTrue: [ radius := self estimatedRadius ].
	^radius! !

!SpotLight methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:44'!
radius: aValue

	"Set the value of radius"

	radius := aValue! !

TranslatedGeometric3D subclass: #Line3D
	instanceVariableNames: 'direction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Primitives3D'!

!Line3D class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:36'!
origin: originPoint direction: directionPoint 

	^( self new ) origin: originPoint; direction: directionPoint! !

!Line3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:36'!
computeVertexAt: parameter 

	^self direction * parameter + self origin! !

!Line3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:36'!
direction

	"Answer the value of direction"

	^direction! !

!Line3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:36'!
direction: aValue

	"Set the value of direction"

	direction := aValue! !

!Line3D methodsFor: 'initialize-release' stamp: 'emm 02/09/2012 23:36'!
initialize

	super initialize.
	self direction: 1@0@0.! !

TranslatedGeometric3D subclass: #Mandala
	instanceVariableNames: 'circleRadius arcRadius wireRadius arcCount topArcAngle bottomArcAngle insideArcAngle'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-ShapeGallery'!

!Mandala class methodsFor: 'instance-creation' stamp: 'emm 03/09/2012 20:15'!
boundedBySphere: aSphere

	"Answer a new Mandala that approximates @aSphere
	by computing estimates for the angles and radii"

	^self new! !

!Mandala methodsFor: 'computing' stamp: 'emm 03/09/2012 20:15'!
anglesForFlat

	^Array
		with: 0
		with: 0
		with: 0! !

!Mandala methodsFor: 'computing' stamp: 'emm 03/09/2012 20:15'!
anglesForJojo

	^Array
		with: 240 rad  	"top"
		with: 120 rad
		with: -240 rad! !

!Mandala methodsFor: 'computing' stamp: 'emm 03/09/2012 20:15'!
anglesForSourcer

	^Array
		with: 135 rad  	"top"
		with: 0
		with: -135 rad! !

!Mandala methodsFor: 'computing' stamp: 'emm 03/09/2012 20:15'!
anglesForSphere

	| beta r1 r2 r3 p1 p2 p3 |
	r1 := self arcRadius.
	r2 :=self circleRadius.
	r3 := ( self arcAngle / 2 ) cos * r2.

	"this formula took me a few hours to derive... validate yourself"
	p1 := ((4 * r1 * r1 * r3 * r3) - ((8 * r1 * r1) * ( r3 * r3 - (r1 * r1) - (r2 * r2)))) sqrt.
	p2 := -2 * r1 * r3.
	p3 := 4 * r1 * r1.
	beta := (( p2 / p3 ) + ( p1 / p3 )) arcSin.

	^Array
		with: beta + HalfPi   	"top"		"The angle is really a bit larger, needs formula (again)"
		with: ( HalfPi - beta )
		with: HalfPi negated - ( beta )! !

!Mandala methodsFor: 'computing' stamp: 'emm 03/09/2012 20:15'!
anglesForStraight

	^Array
		with: HalfPi
		with: HalfPi
		with: HalfPi negated! !

!Mandala methodsFor: 'computing' stamp: 'emm 03/09/2012 20:15'!
anglesForWheel

	^Array
		with: 0  	"top"
		with: HalfPi
		with: 0! !

!Mandala methodsFor: 'computing' stamp: 'emm 03/09/2012 20:15'!
arcAngle

	"Answer the sweep angle that the arc makes on the circle.
	E.g. if the arcRadius equals circleRadius than the angle is 180 deg"

	^(self arcRadius / ( self circleRadius ) ) arcSin * 2! !

!Mandala methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:15'!
arcCount

	"Answer the value of arcCount"

	^arcCount! !

!Mandala methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:15'!
arcCount: aValue

	"Set the value of arcCount"

	arcCount := aValue! !

!Mandala methodsFor: 'computing' stamp: 'emm 03/09/2012 20:15'!
arcPoints

	"Answer with the collection of points on the circle at which the arcs will intersect"

	| vertices vertex iAngle dAngle start |
	vertices := OrderedCollection new.
	vertex := self circleRadius , 0 , 0.
	iAngle := self interArcAngle.
	dAngle := ( self arcAngle - iAngle ) / 2.
	start := iAngle / 2.
	self arcCount timesRepeat:[
		vertices add: ( vertex rotatedByZ: start ).
		start := start + dAngle.
		vertices add: ( vertex rotatedByZ: start ).
		start := start + iAngle ].
	^vertices
	
	
	
	

	! !

!Mandala methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:15'!
arcRadius

	"Answer the value of arcRadius"

	^arcRadius! !

!Mandala methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:15'!
arcRadius: aValue

	"Set the value of arcRadius"

	arcRadius := aValue! !

!Mandala methodsFor: 'angle-accessing' stamp: 'emm 03/09/2012 20:15'!
bottomArcAngle

	"Answer the value of bottomArcAngle"

	^bottomArcAngle! !

!Mandala methodsFor: 'angle-accessing' stamp: 'emm 03/09/2012 20:15'!
bottomArcAngle: aValue

	"Set the value of bottomArcAngle"

	bottomArcAngle := aValue! !

!Mandala methodsFor: 'computing' stamp: 'emm 03/09/2012 20:15'!
bottomArcPoints

	| offset |
	offset := self bottomOffset.
	^self arcPoints collect:[ :each | each + offset ]! !

!Mandala methodsFor: 'solid-enumerating' stamp: 'emm 03/09/2012 20:15'!
bottomInsideTorusSegmentsDo: aBlock 
	
	| iterator |
	iterator := self bottomArcPoints pairIterator.
	iterator isCycle: true.
	iterator fromStep: 1.
	iterator toStep: 3.
	iterator do: [ :one :two |  
		| aux zAngle | 
		aux := Circle3D through: one and: two.
		zAngle := ( two - one ) theta.
		aBlock value: ( ( ( TorusArc
			center: 0,0,0
			majorRadius: aux radius 
			minorRadius: self wireRadius 
			startAngle: 0
			stopAngle: Pi ) 
				rotateBy: self insideArcAngle , 0 , zAngle )
				translateBy: aux center + self origin)]! !

!Mandala methodsFor: 'computing' stamp: 'emm 03/09/2012 20:15'!
bottomInterArcPoints

	| offset |
	offset := self bottomOffset.
	^self interArcPoints collect:[ :each | each + offset ]! !

!Mandala methodsFor: 'computing' stamp: 'emm 03/09/2012 20:15'!
bottomOffset

	^self topOffset negated! !

!Mandala methodsFor: 'solid-enumerating' stamp: 'emm 03/09/2012 20:15'!
bottomTorusDo: aBlock

	^aBlock value: ( Torus
			center: self origin + self bottomOffset
			majorRadius: self circleRadius
			minorRadius: self wireRadius )! !

!Mandala methodsFor: 'solid-enumerating' stamp: 'emm 03/09/2012 20:15'!
bottomTorusSegmentsDo: aBlock 
	
	| iterator |
	iterator := self bottomArcPoints pairIterator.
	iterator isCycle: true.
	iterator fromStep: 1.
	iterator toStep: 3.
	iterator do: [ :one :two |  
		| aux zAngle | 
		aux := Circle3D through: one and: two.
		zAngle := ( two - one ) theta.
		aBlock value: ( ( ( TorusArc
			center: 0,0,0
			majorRadius: aux radius 
			minorRadius: self wireRadius 
			startAngle: 0
			stopAngle: Pi ) 
				rotateBy: self bottomArcAngle , 0 , zAngle )
				translateBy: aux center + self origin)]! !

!Mandala methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:15'!
circleRadius

	"Answer the value of circleRadius"

	^circleRadius! !

!Mandala methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:15'!
circleRadius: aValue

	"Set the value of circleRadius"

	circleRadius := aValue! !

!Mandala methodsFor: 'initialize-release' stamp: 'emm 03/09/2012 20:15'!
initialize

	super initialize.
	self circleRadius: 10.
	self arcRadius: 0.5 * self circleRadius.
	self wireRadius: 0.2.
	self arcCount: 9.
	self topArcAngle: 0.
	self bottomArcAngle: 0.
	self insideArcAngle: 0.! !

!Mandala methodsFor: 'angle-accessing' stamp: 'emm 03/09/2012 20:15'!
insideArcAngle

	"Answer the value of insideArcAngle"

	^insideArcAngle! !

!Mandala methodsFor: 'angle-accessing' stamp: 'emm 03/09/2012 20:15'!
insideArcAngle: aValue

	"Set the value of insideArcAngle"

	insideArcAngle := aValue! !

!Mandala methodsFor: 'editing' stamp: 'emm 03/09/2012 20:15'!
inspectActions

	^#( arcAngle interArcAngle arcPoints topOffset  )! !

!Mandala methodsFor: 'computing' stamp: 'emm 03/09/2012 20:15'!
interArcAngle

	"Answer the sweep angle of the space between the arcs on the circle"

	| arcAngle arcSweep |
	arcAngle := self arcAngle.
	arcSweep := self arcCount * arcAngle.
	^arcSweep > TwoPi
		ifTrue: 
			[ "arcs do cross" 
			( self revolutions * TwoPi - arcSweep ) / self arcCount ]
		ifFalse: 
			[ "arcs do not cross" 
			^(TwoPi - arcSweep ) / self arcCount ]! !

!Mandala methodsFor: 'computing' stamp: 'emm 03/09/2012 20:15'!
interArcPoints

	"Answer with the collection of points on the circle in between two non-overlapping
	arcs. The angle space is computed by >>interArcAngle"

	| vertices vertex iAngle dAngle start |
	vertices := OrderedCollection new.
	vertex := self circleRadius , 0 , 0.
	iAngle := self interArcAngle.
	dAngle := ( self arcAngle + iAngle ) / 2.
	start := dAngle / 2.
	self arcCount timesRepeat:[
		vertices add: ( vertex rotatedByZ: start ).
		start := start + dAngle ].
	^vertices
	
	
	
	

	! !

!Mandala methodsFor: 'dispatching' stamp: 'emm 03/09/2012 20:15'!
kindDo: aRequestor

	^aRequestor doSolidComposite: self! !

!Mandala methodsFor: 'computing' stamp: 'emm 03/09/2012 20:15'!
revolutions

	^2! !

!Mandala methodsFor: 'angle-accessing' stamp: 'emm 03/09/2012 20:15'!
setAngles: threeElementArray

	self topArcAngle: threeElementArray first.
	self insideArcAngle: (threeElementArray at: 2).
	self bottomArcAngle: threeElementArray last! !

!Mandala methodsFor: 'solid-enumerating' stamp: 'emm 03/09/2012 20:15'!
solidsDo: aBlock

	self topTorusSegmentsDo: aBlock.
	self topTorusDo: aBlock.
	(self insideArcAngle = 0
		and:[ self topArcAngle = 0 
			and:[ self bottomArcAngle = 0]])
		ifTrue: [ ^self ].

	self topInsideTorusSegmentsDo: aBlock.
	self bottomInsideTorusSegmentsDo: aBlock.
	self bottomTorusDo: aBlock.
	self bottomTorusSegmentsDo: aBlock.
! !

!Mandala methodsFor: 'angle-accessing' stamp: 'emm 03/09/2012 20:15'!
topArcAngle

	"Answer the value of topArcAngle"

	^topArcAngle! !

!Mandala methodsFor: 'angle-accessing' stamp: 'emm 03/09/2012 20:15'!
topArcAngle: aValue

	"Set the value of topArcAngle"

	topArcAngle := aValue! !

!Mandala methodsFor: 'computing' stamp: 'emm 03/09/2012 20:15'!
topArcPoints

	| offset |
	offset := self topOffset.
	^self arcPoints collect:[ :each | each + offset ]! !

!Mandala methodsFor: 'solid-enumerating' stamp: 'emm 03/09/2012 20:15'!
topInsideTorusSegmentsDo: aBlock 
	
	| iterator |
	iterator := self topArcPoints pairIterator.
	iterator isCycle: true.
	iterator fromStep: 1.
	iterator toStep: 3.
	iterator do: [ :one :two |  
		| aux zAngle | 
		aux := Circle3D through: one and: two.
		zAngle := ( two - one ) theta.
		aBlock value: ( ( ( TorusArc
			center: 0,0,0
			majorRadius: aux radius 
			minorRadius: self wireRadius 
			startAngle: 0
			stopAngle: Pi ) 
				rotateBy: self insideArcAngle negated , 0 , zAngle )
				translateBy: aux center + self origin)]! !

!Mandala methodsFor: 'computing' stamp: 'emm 03/09/2012 20:15'!
topInterArcPoints

	| offset |
	offset := self topOffset.
	^self interArcPoints collect:[ :each | each + offset ]! !

!Mandala methodsFor: 'computing' stamp: 'emm 03/09/2012 20:15'!
topOffset

	^0 , 0 , ( self insideArcAngle sin * self arcRadius )! !

!Mandala methodsFor: 'solid-enumerating' stamp: 'emm 03/09/2012 20:15'!
topTorusDo: aBlock

	^aBlock value: ( Torus
			center: self origin + self topOffset
			majorRadius: self circleRadius
			minorRadius: self wireRadius )! !

!Mandala methodsFor: 'solid-enumerating' stamp: 'emm 03/09/2012 20:15'!
topTorusSegmentsDo: aBlock 
	
	| iterator |
	iterator := self topArcPoints pairIterator.
	iterator isCycle: true.
	iterator fromStep: 1.
	iterator toStep: 3.
	iterator do: [ :one :two |  
		| aux zAngle | 
		aux := Circle3D through: one and: two.
		zAngle := ( two - one ) theta.
		aBlock value: ( ( ( TorusArc
			center: 0,0,0
			majorRadius: aux radius 
			minorRadius: self wireRadius 
			startAngle: 0
			stopAngle: Pi ) 
				rotateBy: self topArcAngle , 0 , zAngle )
				translateBy: aux center + self origin )]! !

!Mandala methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:15'!
wireRadius

	"Answer the value of wireRadius"

	^wireRadius! !

!Mandala methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:15'!
wireRadius: aValue

	"Set the value of wireRadius"

	wireRadius := aValue! !

TranslatedGeometric3D subclass: #PlanarGeometric3D
	instanceVariableNames: 'plane'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Primitives3D'!

PlanarGeometric3D subclass: #Circle3D
	instanceVariableNames: 'radius startAngle sweepAngle'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Primitives3D'!

!Circle3D class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:35'!
center: aPoint
	^super new origin: aPoint! !

!Circle3D class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:35'!
center: aPoint radius: aNumber

	^(super new) 
		center: aPoint
		; radius: aNumber! !

!Circle3D class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:35'!
center: aPoint radius: aNumber startAngle: startAngle stopAngle: stopAngle 

	^(super new) 
		center: aPoint
		; radius: aNumber
		; startAngle: startAngle
		; sweepAngle: stopAngle - startAngle! !

!Circle3D class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:35'!
new
	^super new radius: 1! !

!Circle3D class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:35'!
radius: aNumber
	^super new radius: aNumber! !

!Circle3D class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:35'!
through: onePoint and: otherPoint

	"Only for circles on the xy-plane"

	^self
		center: ( onePoint + otherPoint / 2 )
		radius: ( ( onePoint dist: otherPoint ) / 2)! !

!Circle3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:35'!
bounds

	^self center centerExtent: self plane unity * self radius! !

!Circle3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:35'!
center

	^self origin! !

!Circle3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:35'!
center: aValue

	self origin: aValue! !

!Circle3D methodsFor: 'vertex-accessing' stamp: 'emm 02/09/2012 23:35'!
computeAngleFor: aPoint3D

	"Pre: aPoint3D is on the receiver"

	^ ( aPoint3D - self center ) xy theta! !

!Circle3D methodsFor: 'vertex-accessing' stamp: 'emm 02/09/2012 23:35'!
computeVertexAt: aParameter 
	"<aParameter> is an angle in radians, answer the cartesianPoint"

	^(super plane baseRotatedBy: aParameter) * radius + self origin! !

!Circle3D methodsFor: 'computing' stamp: 'emm 02/09/2012 23:35'!
computeVertexAtFraction: fraction

	"fraction = [ 0..1 ]"

	^( (self radius , 0, 0 ) rotatedBy: 0,0,(self sweepAngle * fraction + self startAngle)) + self center! !

!Circle3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:35'!
first
	^self computeVertexAt: self startAngle! !

!Circle3D methodsFor: 'initialize-release' stamp: 'emm 02/09/2012 23:35'!
initialize

	super initialize.
	radius := 1.
	startAngle := 0.
	sweepAngle := 360 rad.! !

!Circle3D methodsFor: '*Zenna-Operators3D' stamp: 'emm 02/09/2012 23:47'!
interpolatorUsingAll: aParamterCollection
	
	^ ( CollectionBasedInterpolator on: self ) 
			collection: aParamterCollection! !

!Circle3D methodsFor: '*Zenna-Operators3D' stamp: 'emm 02/09/2012 23:47'!
interpolatorUsingAngleIncrement: stepAngle 
	
	^ ( CollectionBasedInterpolator on: self ) 
			collection: ( self startAngle to: self stopAngle - stepAngle by: stepAngle )! !

!Circle3D methodsFor: '*Zenna-Operators3D' stamp: 'emm 02/09/2012 23:47'!
interpolatorUsingEquidistance: distanceBetweenVertices 
	
	| angle delta interpolator stop |
	interpolator := CollectionBasedInterpolator on: self.
	interpolator collection: OrderedCollection new.
	angle := self startAngle.
	stop := self stopAngle.
	delta := (distanceBetweenVertices / radius ) arcTan.
	[ angle <= stop ]
		whileTrue: 
			[ interpolator collection add: angle.
			angle := angle + delta ].
	^ interpolator! !

!Circle3D methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:35'!
kindDo: aRequestor

	^aRequestor doCircle3D: self! !

!Circle3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:35'!
last
	^self computeVertexAt: self stopAngle! !

!Circle3D methodsFor: 'computing' stamp: 'emm 02/09/2012 23:35'!
length

	^2 * Pi * radius! !

!Circle3D methodsFor: 'vertex-accessing' stamp: 'emm 02/09/2012 23:35'!
normalAt: aParameter

	"Answer a Point3D representing the normal located 
	on the receiver at <aParameter>"

	^((self computeVertexAt: aParameter) - self origin ) normalized! !

!Circle3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:35'!
radius

	^radius! !

!Circle3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:35'!
radius: aValue

	radius := aValue! !

!Circle3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:35'!
startAngle

	^startAngle! !

!Circle3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:35'!
startAngle: aValue

	startAngle := aValue! !

!Circle3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:35'!
stopAngle

	^self startAngle + self sweepAngle! !

!Circle3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:35'!
stopAngle: angle

	self sweepAngle: angle - self startAngle! !

!Circle3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:35'!
sweepAngle

	^sweepAngle! !

!Circle3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:35'!
sweepAngle: aValue

	sweepAngle := aValue! !

!Circle3D methodsFor: 'vertex-accessing' stamp: 'emm 02/09/2012 23:35'!
tangentAt: angle 
	
	| translation |
	translation := self computeVertexAt: angle.
	^Line3D 
		origin: translation 
		direction: (super plane baseTangentAt: angle) normalized! !

Circle3D subclass: #EllipticalArc3D
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'Math3DConstants'
	category: 'Zenna-Primitives3D'!

!EllipticalArc3D class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:36'!
from: startPoint to: endPoint 
	"default center is 0,0,0.
	default rotation is counter-clockwise"

	^self from: startPoint to: endPoint center: Point3D zero clockwise: false! !

!EllipticalArc3D class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:36'!
from: startPoint to: endPoint center: centerPoint
	"default rotation is counter-clockwise"

	^self from: startPoint to: endPoint center: centerPoint clockwise: false! !

!EllipticalArc3D class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:36'!
from: startPoint to: endPoint center: centerPoint clockwise: aBoolean

	"TEMP: EM"

	^self new
		setFrom: startPoint to: endPoint center: centerPoint asPoint3D clockwise: aBoolean! !

!EllipticalArc3D methodsFor: 'converting' stamp: 'emm 02/09/2012 23:36'!
asTorusSegmentWithRadius: aNumber! !

!EllipticalArc3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:36'!
end

	^self to! !

!EllipticalArc3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:36'!
from
	"Answer the start point"

	^(self plane baseRotatedBy: self startAngle) * self radius + self origin! !

!EllipticalArc3D methodsFor: 'inspecting' stamp: 'emm 02/09/2012 23:36'!
inspectActions
	
	^super inspectActions , #(from to)! !

!EllipticalArc3D methodsFor: 'reflection' stamp: 'emm 02/09/2012 23:36'!
kindDo: requestor
	requestor doEllipticalArc3D: self! !

!EllipticalArc3D methodsFor: 'computing' stamp: 'emm 02/09/2012 23:36'!
length

	^ self sweepAngle abs * self radius! !

!EllipticalArc3D methodsFor: 'private' stamp: 'emm 02/09/2012 23:36'!
setFrom: startPoint to: endPoint center: centerPoint clockwise: isCW 
	
	"Compute the start- and sweep angle such that <startPoint> and <endPoint> are 
	the start and end of the receiver.
	if <aBoolean> then the sweep angle is negative"
	
	| toEnd | 
	self origin: centerPoint.
	radius := ( endPoint dist: centerPoint ) + ( startPoint dist: centerPoint ) / 2.
	startAngle := self plane thetaFrom: centerPoint to: startPoint.
	toEnd := self plane thetaFrom: centerPoint to: endPoint.
	startAngle < toEnd
		ifTrue: [ sweepAngle := toEnd - startAngle ]
		ifFalse: [ sweepAngle := ( Pi * 2 ) - startAngle + toEnd ].
	isCW 
		ifTrue: [ sweepAngle := sweepAngle - ( Pi * 2 ) ]! !

!EllipticalArc3D methodsFor: 'private' stamp: 'emm 02/09/2012 23:36'!
setFrom: startPoint to: endPoint  direction: startDirection

	"self old."
	self setFrom: startPoint to: endPoint directionAtStart: startDirection! !

!EllipticalArc3D methodsFor: 'private' stamp: 'emm 02/09/2012 23:36'!
setFrom: startPoint to: endPoint directionAtStart: startDirection
"	
	startPoint is aPoint3D 
	endPoint is aPoint3D
	startDirection is a vector represented by aPoint3D
	startDirection represents the direction in startPoint 
	assumption: lines are not parallel
"
	| se midPoint rc1 b1 rc2 b2 xc yc stopAngle clockWise | 
	se := endPoint - startPoint.
	midPoint := se / 2.0 + startPoint. 
	startDirection y = 0 "direction is along x-axis"
		ifTrue: 
			[rc2 := se x negated / se y.												"direction of the line perpendicular to 'endPoint - startPoint' "
			b2 := midPoint y - ( rc2 * midPoint x).								"define a line y = rc2*x + b2 "
			xc := startPoint x.															"determine center point"
			yc := rc2 * xc + b2]
		ifFalse: 
			[rc1 := startDirection x negated / startDirection y.				"direction of the line perpendicular to startDirection "
			b1 := startPoint y - ( rc1 * startPoint x ).							"define a line y = rc1*x + b1 "
			se y = 0 
				ifTrue:
					[xc := midPoint x.											"determine center point"
					yc := rc1 * xc + b1]
				ifFalse:
					[rc2 := se x negated / se y.								"direction of the line perpendicular to 'endPoint - startPoint' "
					b2 := midPoint y - ( rc2 * midPoint x).				"define a line y = rc2*x + b2 "
					xc := ( b2 - b1 ) / (rc1 - rc2 ).							"determine center point"
					yc := rc1 * xc + b1]].

	self origin: (xc, yc, self origin z).
	radius := endPoint dist: self origin.														"determine radius"
	clockWise := ((startPoint - self origin) x * startDirection y) - 			"determine revolving direction"
			(startDirection x * (startPoint - self origin) y) < 0.
	(startPoint x - xc) = 0 																		"determine startAngle"
		ifTrue:
			[startPoint y - yc < 0 
				ifTrue: [ startAngle := Float pi / 2.0 negated]
				ifFalse: [ startAngle := Float pi / 2.0]]
		ifFalse:
			[startAngle := (( startPoint y - yc ) / ( startPoint x - xc ) ) arcTanWithDenominator: startPoint x - xc].

	sweepAngle := (startDirection angleTo: se) * 2.										"determine sweepAngle"	
	clockWise 
		ifTrue: [sweepAngle := sweepAngle negated]! !

!EllipticalArc3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:36'!
start

	^self from! !

!EllipticalArc3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:36'!
to
	"Answer the to point"

	^(self plane baseRotatedBy: self stopAngle) * self radius + self origin! !

Circle3D subclass: #Spiral3D
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Primitives3D'!

!Spiral3D methodsFor: 'computing' stamp: 'emm 02/09/2012 23:35'!
computeVertexAt: aParameter 

	"<aParameter> is an angle in radians, answer the cartesianPoint"
	
	| currentRadius |
	currentRadius := aParameter * ( self radius / self sweepAngle ). 
	^ ( super plane baseRotatedBy: aParameter ) * currentRadius + self origin! !

!Spiral3D methodsFor: '*Zenna-Operators3D' stamp: 'emm 02/09/2012 23:46'!
interpolatorUsingAngleIncrement: stepAngle

		^(CollectionBasedInterpolator on: self)
				collection: (self startAngle to: self stopAngle by: stepAngle)! !

!Spiral3D methodsFor: '*Zenna-Operators3D' stamp: 'emm 02/09/2012 23:46'!
interpolatorUsingEquidistance: distanceBetweenVertices 
	
	| angle delta interpolator stop |
	interpolator := CollectionBasedInterpolator on: self.
	interpolator collection: OrderedCollection new.
	angle := self startAngle.
	stop := self stopAngle.
	[ angle <= stop ]
		whileTrue: 
			[ | currentRadius |
			interpolator collection add: angle.
			currentRadius := angle * ( self radius / self sweepAngle ). 
			delta := (distanceBetweenVertices / currentRadius ) arcTan.	
			angle := angle + delta ].
	^ interpolator! !

!PlanarGeometric3D methodsFor: 'initialize-release' stamp: 'emm 02/09/2012 23:33'!
initialize
	"On default, the receiver is on the XY plane
	so set the normal to the positive Z-axis"

	super initialize.
	plane := Plane3D xy! !

!PlanarGeometric3D methodsFor: 'computing' stamp: 'emm 02/09/2012 23:33'!
normal

	^plane normal! !

!PlanarGeometric3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:33'!
plane

	^plane! !

!PlanarGeometric3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:33'!
plane: aValue

	plane := aValue! !

TranslatedGeometric3D subclass: #PyramidGrid3D
	instanceVariableNames: 'delta layers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Shapes3D'!

!PyramidGrid3D methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:39'!
do: aBlock
	self verticesDo: aBlock! !

TranslatedGeometric3D subclass: #Sphere
	instanceVariableNames: 'radius'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Primitives3D'!

!Sphere class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:35'!
center: aPoint
	^super new origin: aPoint! !

!Sphere class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:35'!
center: aPoint radius: aNumber

	^(super new) 	
		center: aPoint
		; radius: aNumber! !

!Sphere class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:35'!
center: aPoint radius: aNumber hemi: aBoolean

	self error: 'must answer correct instance of SphereSegment'! !

!Sphere class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:35'!
radius: aNumber

	^super new radius: aNumber! !

!Sphere methodsFor: 'computing' stamp: 'emm 02/09/2012 23:35'!
addVertexAt: parameter1 at: parameter2 to: aPointCollection 
	"Both parameters are angles in radians, add a new cartesian point"

	| rcosp1 |
	rcosp1 := parameter1 cos * self radius.
	^aPointCollection
		addX: rcosp1 * parameter2 cos + self center x
		y: rcosp1 * parameter2 sin + self center y
		z: parameter1 sin * self radius + self center z! !

!Sphere methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:35'!
bounds

	^self origin centerExtent: self radius * 2! !

!Sphere methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:35'!
center

	^self origin! !

!Sphere methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:35'!
center: aValue

	self origin: aValue! !

!Sphere methodsFor: 'computing' stamp: 'emm 02/09/2012 23:35'!
computeVertexAt: parameter1 at: parameter2 
	"Both parameters are angles in radians, answer a new cartesian point"

	| rcosp1 |
	rcosp1 := parameter1 cos * self radius.
	^Point3D
		x: rcosp1 * parameter2 cos + self center x
		y: rcosp1 * parameter2 sin + self center y
		z: parameter1 sin * self radius + self center z! !

!Sphere methodsFor: 'initialize-release' stamp: 'emm 02/09/2012 23:35'!
initialize

	super initialize.
	self radius: 1! !

!Sphere methodsFor: 'computing' stamp: 'emm 02/09/2012 23:35'!
innerCube
	"Answer a new maximum sized Cube that lies inside the receiver"

	^Box center: self center extent: self radius! !

!Sphere methodsFor: 'computing ( IHollow )' stamp: 'emm 02/09/2012 23:35'!
innerGeometricApplyingThickness: amount

	"Answer a new geometric like the receiver that is the result
	of substracting the hollow version of the receiver for which the
	thickness equals @amount"

	^self copy radius: self radius - amount! !

!Sphere methodsFor: 'testing' stamp: 'emm 02/09/2012 23:35'!
intersects: anArgument

	^anArgument intersectsSphere: self! !

!Sphere methodsFor: 'testing' stamp: 'emm 02/09/2012 23:35'!
intersectsSphere: aSphere

	"Two sphere intersect if the distance between their centers
	is less than the sum of the two radii"

	^(aSphere center dist: self center ) < ( aSphere radius + self radius )! !

!Sphere methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:35'!
kindDo: aRequestor

	^aRequestor doSphere: self! !

!Sphere methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:35'!
radius

	^radius! !

!Sphere methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:35'!
radius: aValue

	radius := aValue! !

TranslatedGeometric3D subclass: #Tetrahedron
	instanceVariableNames: 'edgeSize'
	classVariableNames: ''
	poolDictionaries: 'Math3DConstants'
	category: 'Zenna-Shapes3D'!

!Tetrahedron class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:40'!
edgeSize: aNumber 

	^self new edgeSize: aNumber! !

!Tetrahedron class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:40'!
size: aNumber 
  
	"@aNumber is NOT the edge size, needs computation"

	^self new edgeSize: aNumber! !

!Tetrahedron methodsFor: 'vertex-accessing' stamp: 'emm 02/09/2012 23:40'!
backDown

	| negZ negX where |
	where := self origin.
	negZ := self edgeSize * Sqrt6 / 3 negated.
	negX := self edgeSize * Sqrt3 / 3 negated.
	^(where x + negX) @ where y @ (where z + negZ).! !

!Tetrahedron methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:40'!
bounds
	
	^BoundingBox 
		origin: self backDown x @ self frontLeft y @ self backDown z
		corner: self frontRight x @ self frontRight y @ self top z! !

!Tetrahedron methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:40'!
center
	
	^self origin - (0@0@self edgeSize * Sqrt3 / 3)! !

!Tetrahedron methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:40'!
center: aPoint
	
	^self origin: aPoint + (0@0@self edgeSize * Sqrt3 / 3)! !

!Tetrahedron methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:40'!
edgeSize

	^edgeSize! !

!Tetrahedron methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:40'!
edgeSize: aValue

	edgeSize := aValue! !

!Tetrahedron methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:40'!
facesDo: aBlock 
	self trianglesDo: aBlock ! !

!Tetrahedron methodsFor: 'vertex-accessing' stamp: 'emm 02/09/2012 23:40'!
frontLeft

	| negZ posX posY where |
	where := self origin.
	negZ := self edgeSize * Sqrt6 / 3 negated.
	posX := self edgeSize * Sqrt3 / 6.
	posY := self edgeSize / 2.0.
	^(where x + posX) @ (where y - posY) @ (where z + negZ).! !

!Tetrahedron methodsFor: 'vertex-accessing' stamp: 'emm 02/09/2012 23:40'!
frontRight

	| negZ posX posY where |
	where := self origin.
	negZ := self edgeSize * Sqrt6 / 3 negated.
	posX := self edgeSize * Sqrt3 / 6.
	posY := self edgeSize / 2.0.
	^(where x + posX) @ (where y + posY) @ (where z + negZ).! !

!Tetrahedron methodsFor: 'initialize-release' stamp: 'emm 02/09/2012 23:40'!
initialize

	super initialize.
	edgeSize := 1! !

!Tetrahedron methodsFor: 'double-dispatching' stamp: 'emm 02/09/2012 23:40'!
kindDo: aRequestor

	^ aRequestor doFaceComposite: self! !

!Tetrahedron methodsFor: 'vertex-accessing' stamp: 'emm 02/09/2012 23:40'!
top

	^self origin! !

!Tetrahedron methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:40'!
trianglesDo: aBlock 

	| vertices top frontRight frontLeft backDown |
	vertices := self vertices.
	aBlock value: (Triangle3D with: (top := vertices at: 1) with: (frontRight := vertices at: 4)
		with: (frontLeft := vertices at: 3)).
	aBlock value: (Triangle3D
			with: top
			with: (backDown := vertices at: 2)
			with: frontRight).
	aBlock value: (Triangle3D
			with: top
			with: frontLeft
			with: backDown).
	aBlock value: (Triangle3D
			with: backDown
			with: frontLeft
			with: frontRight)! !

!Tetrahedron methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:40'!
verticesDo: aBlock 

	| negZ negX posX posY where |
	where := self origin.
	negZ := self edgeSize * Sqrt6 / 3 negated.
	negX := self edgeSize * Sqrt3 / 3 negated.
	posX := self edgeSize * Sqrt3 / 6.
	posY := self edgeSize / 2.0.
	aBlock value: where. "top"
	aBlock value: (where x + negX) @ where y @ (where z + negZ). "backDown"
	aBlock value: (where x + posX) @ (where y - posY) @ (where z + negZ). "frontLeft"
	aBlock value: (where x + posX) @ (where y + posY) @ (where z + negZ). "frontRight"! !

TranslatedGeometric3D subclass: #TetrahedronGrid3D
	instanceVariableNames: 'delta layers'
	classVariableNames: ''
	poolDictionaries: 'Math3DConstants'
	category: 'Zenna-Shapes3D'!

!TetrahedronGrid3D methodsFor: 'private' stamp: 'emm 02/09/2012 23:39'!
addVerticesForLayer: layer to: aPointCollection 

	| where |
	where := self origin.
	self
		leftFrontFromX: where x - (layer - 1 * delta * Sqrt3 / 3)
		y: where y
		z: where z - (layer - 1 * delta * Sqrt6 / 3)
		size: layer - 1
		addTo: aPointCollection! !

!TetrahedronGrid3D methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:39'!
addVerticesTo: aPointCollection

	layers do:[ :each | self addVerticesForLayer: each to: aPointCollection ]! !

!TetrahedronGrid3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:39'!
bounds

	^BoundingBox halt
		origin: 0@0@0
		corner: 0@0@0! !

!TetrahedronGrid3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:39'!
delta

	^delta! !

!TetrahedronGrid3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:39'!
delta: aValue

	delta := aValue! !

!TetrahedronGrid3D methodsFor: 'initialize-release' stamp: 'emm 02/09/2012 23:39'!
initialize

	super initialize.
	delta := 1.
	layers := 1 to: 2.! !

!TetrahedronGrid3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:39'!
layers

	^layers! !

!TetrahedronGrid3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:39'!
layers: aValue

	layers := aValue! !

!TetrahedronGrid3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:39'!
layersTo: maxLayers 

	self layers: (1 to: maxLayers)! !

!TetrahedronGrid3D methodsFor: 'private' stamp: 'emm 02/09/2012 23:39'!
leftFrontFromX: x y: y z: z size: howMany addTo: aPointCollection

	0 to: howMany do:[ :leftIndex |
		self 
			rightFromX: x + (leftIndex * delta * Sqrt3 / 2)
			y: y - (leftIndex * delta / 2.0)
			z: z
			size: leftIndex
			addTo: aPointCollection]! !

!TetrahedronGrid3D methodsFor: 'private' stamp: 'emm 02/09/2012 23:39'!
rightFromX: x y: y z: z size: howMany addTo: aPointCollection

	0 to: howMany do:[:rightIndex | 
		aPointCollection
			addX: x
			y:y + (rightIndex * delta)
			z: z]! !

!TetrahedronGrid3D methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:39'!
verticesDo: aBlock 

	self addVerticesTo: (AdditionToEvaluationAdaptor on: aBlock)! !

TranslatedGeometric3D subclass: #Torus
	instanceVariableNames: 'majorRadius minorRadius'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Primitives3D'!

!Torus class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:36'!
center: aPoint majorRadius: majorRadius minorRadius: minorRadius 

	^( self origin: aPoint )
		majorRadius: majorRadius;
		minorRadius: minorRadius! !

!Torus methodsFor: 'computing' stamp: 'emm 02/09/2012 23:36'!
addVertexAt: param1 at: param2 to: aCollection! !

!Torus methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:36'!
bounds

	| outerRadius |
	outerRadius := self outerRadius.
	^self translation centerExtent: outerRadius @ outerRadius @ self minorRadius! !

!Torus methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:36'!
center

	^self translation! !

!Torus methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:36'!
center: aValue

	self translation: aValue! !

!Torus methodsFor: 'computing' stamp: 'emm 02/09/2012 23:36'!
centerCircle

	^Circle3D center: self center radius: self majorRadius! !

!Torus methodsFor: 'computing' stamp: 'emm 02/09/2012 23:36'!
computeInnerVertexAt: majorParameter

	"Both <majorParameter> is an angle in radians, answer the cartesianPoint"! !

!Torus methodsFor: 'computing' stamp: 'emm 02/09/2012 23:36'!
computeOuterVertexAt: majorParameter

	"Both <majorParameter> is an angle in radians, answer the cartesianPoint"! !

!Torus methodsFor: 'computing' stamp: 'emm 02/09/2012 23:36'!
computeVertexAt: majorParameter at: minorParameter

	"Both <majorParameter> and <minorParameter> is an angle in radians, answer the cartesianPoint"! !

!Torus methodsFor: 'reflection' stamp: 'emm 02/09/2012 23:36'!
initialize
	super initialize.
	self minorRadius: 0.1.
	self majorRadius: 1.! !

!Torus methodsFor: 'reflection' stamp: 'emm 02/09/2012 23:36'!
kindDo: aRequestor

	^aRequestor doTorus: self! !

!Torus methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:36'!
majorRadius

	^majorRadius! !

!Torus methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:36'!
majorRadius: aValue

	majorRadius := aValue! !

!Torus methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:36'!
minorRadius

	^minorRadius! !

!Torus methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:36'!
minorRadius: aValue

	minorRadius := aValue! !

!Torus methodsFor: 'computing' stamp: 'emm 02/09/2012 23:36'!
openQuadrants

	"Answer with a collection of quadrant indices (2D) which completely unvisited by the receiver"

	| indices start stop |
	indices := OrderedCollection new.
	start := self startAngle.
	stop := self stopAngle.
	[ start < stop ]
		whileTrue:
			[ indices add: start quadrantIndex.
			start := start + HalfPi ]
	! !

!Torus methodsFor: 'computing' stamp: 'emm 02/09/2012 23:36'!
outerRadius

	^self majorRadius + self minorRadius! !

!Torus methodsFor: 'angle-accessing' stamp: 'emm 02/09/2012 23:36'!
startAngle

	"Answer the value of startAngle"

	^0! !

!Torus methodsFor: 'computing' stamp: 'emm 02/09/2012 23:36'!
startSphere

	"Answer with a new sphere that can be used to give the receiver a rounded cap"

	^Sphere 
		center: ( ( self majorRadius, 0 ,0 ) rotatedBy: 0,0, self startAngle )
		radius: self minorRadius! !

!Torus methodsFor: 'angle-accessing' stamp: 'emm 02/09/2012 23:36'!
stopAngle

	^self sweepAngle + self startAngle! !

!Torus methodsFor: 'computing' stamp: 'emm 02/09/2012 23:36'!
stopSphere

	"Answer with a new sphere that can be used to give the receiver a rounded cap"

	^Sphere 
		center: ( ( self majorRadius, 0 ,0 ) rotatedBy: 0,0, self stopAngle )
		radius: self minorRadius! !

!Torus methodsFor: 'angle-accessing' stamp: 'emm 02/09/2012 23:36'!
sweepAngle

	^360 rad! !

Torus subclass: #TorusArc
	instanceVariableNames: 'startAngle sweepAngle'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Primitives3D'!

!TorusArc class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:37'!
center: aPoint majorRadius: majorRadius minorRadius: minorRadius startAngle: start stopAngle: stop
	^(self center: aPoint majorRadius: majorRadius minorRadius: minorRadius) startAngle: start ;stopAngle: stop
			! !

!TorusArc methodsFor: 'initialize-release' stamp: 'emm 02/09/2012 23:37'!
initialize

	super initialize.
	startAngle := 0.
	sweepAngle := TwoPi! !

!TorusArc methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:37'!
kindDo: aRequestor
	^aRequestor doTorusArc: self! !

!TorusArc methodsFor: 'accessing' stamp: 'emm 9/23/2012 22:07'!
startAngle 
	^startAngle ! !

!TorusArc methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:37'!
startAngle: aValue

	"Set the value of startAngle"

	startAngle := aValue! !

!TorusArc methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:37'!
stopAngle: aScalar

	self sweepAngle: aScalar - self startAngle! !

!TorusArc methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:37'!
sweepAngle

	"Answer the value of sweepAngle"

	^sweepAngle! !

!TorusArc methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:37'!
sweepAngle: aValue

	"Set the value of sweepAngle"

	sweepAngle := aValue! !

!TranslatedGeometric3D class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:33'!
new
	^super new initialize! !

!TranslatedGeometric3D class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:33'!
origin: aPoint3D

	^self new origin: aPoint3D! !

!TranslatedGeometric3D methodsFor: 'converting' stamp: 'emm 02/09/2012 23:33'!
asWrapperOnDefault
	
	| newWrapper |
	^self origin isZero
		ifTrue: 
			[ self ]
		ifFalse: 
			[ newWrapper := self wrapTranslateBy: self origin.
			self origin: Point3D zero.
			newWrapper ]! !

!TranslatedGeometric3D methodsFor: 'initialize-release' stamp: 'emm 02/09/2012 23:33'!
initialize

	self origin: Point3D zero! !

!TranslatedGeometric3D methodsFor: 'transforming' stamp: 'emm 02/09/2012 23:33'!
mirrorInYZ

	origin := origin x negated, origin y, origin z! !

!TranslatedGeometric3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:33'!
origin

	^origin value! !

!TranslatedGeometric3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:33'!
origin: aValue

	origin := aValue! !

!TranslatedGeometric3D methodsFor: 'copying' stamp: 'emm 02/09/2012 23:33'!
postCopy

	origin := origin copy! !

!TranslatedGeometric3D methodsFor: 'transforming' stamp: 'emm 02/09/2012 23:33'!
scaleBy: aPoint

	self origin scaleBy: aPoint! !

!TranslatedGeometric3D methodsFor: 'transforming' stamp: 'emm 02/09/2012 23:33'!
translateBy: aPoint 

	self origin: self origin + aPoint! !

!TranslatedGeometric3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:33'!
translation
	"Adaptor"

	^self origin! !

!TranslatedGeometric3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:33'!
translation: aPoint3D
	"Adaptor"

	self origin: aPoint3D! !

TranslatedGeometric3D subclass: #TriangularFrame
	instanceVariableNames: 'width height thickness'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Shapes3D'!

!TriangularFrame methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:40'!
height

	"Answer the value of height"

	^height! !

!TriangularFrame methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:40'!
height: aValue

	"Set the value of height"

	height := aValue! !

!TriangularFrame methodsFor: 'initialize-release' stamp: 'emm 02/09/2012 23:40'!
initialize

	super initialize.
	self width: 1.
	self height: 1.
	self thickness: 0.1! !

!TriangularFrame methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:40'!
kindDo: aRequestor

	^aRequestor doSolidComposite: self! !

!TriangularFrame methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:40'!
solidsDo: aBlock ! !

!TriangularFrame methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:40'!
thickness

	"Answer the value of thickness"

	^thickness! !

!TriangularFrame methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:40'!
thickness: aValue

	"Set the value of thickness"

	thickness := aValue! !

!TriangularFrame methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:40'!
width

	"Answer the value of width"

	^width! !

!TriangularFrame methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:40'!
width: aValue

	"Set the value of width"

	width := aValue! !

TranslatedGeometric3D subclass: #YasumiPiece
	instanceVariableNames: 'id patterns patternIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-ShapeGallery'!

!YasumiPiece class methodsFor: 'resources' stamp: 'emm 03/09/2012 20:21'!
addTo: boxPattern from: pieces startingAtX: x y: y

	boxPattern 
		unsetPositionsXYDo: [ :unsetX :unsetY | 
			| offset |
			offset := unsetX @ unsetY.
			pieces do:[ :eachPiece |
				eachPiece patterns doWithIndex:[ :eachPattern :index |
					( boxPattern coversPattern: eachPattern offset: offset )
						ifTrue: 
							[ ( boxPattern intersects: eachPattern offset: offset )
								ifFalse: 
									[ 'merge' echo.
									boxPattern merge: eachPattern offset: offset.
									eachPiece patternIndex: index.
									pieces remove: eachPiece.
									self 
										addTo: boxPattern
										from: pieces
										startingAtX: unsetX 
										y: unsetY.
									pieces add: eachPiece.
									'substract' echo.
									boxPattern insideSubstract: eachPattern offset: offset ] ] ] ] ]					
		startingAtX: x 
		y: y! !

!YasumiPiece class methodsFor: 'resources' stamp: 'emm 03/09/2012 20:21'!
boxPattern	

	| pattern points |
	pattern := BitPattern2D new.
	points := Point2DSet new.
	0 to: 11 do:[ :i |
		points add: (i @0 ).
		points add: (i @ 7) ].
	1 to: 6 do:[ :i |
		points add: ( 0 @ i ).
		points add: ( 11 @ i ) ].
	pattern points: points.
	^pattern! !

!YasumiPiece class methodsFor: 'resources' stamp: 'emm 03/09/2012 20:21'!
doit
	"self doit"

	| box available |
	box := self boxPattern.
	available := self pieces asSet.
	self
		addTo: box
		from: available
		startingAtX: 1
		y: 1! !

!YasumiPiece class methodsFor: 'resources' stamp: 'emm 03/09/2012 20:21'!
pieces

	| pieces  pattern inStream outStream |
	pieces := OrderedCollection new.
	self piecesData doWithIndex:[ :each :index |
		inStream := ReadStream on: each.
		outStream := WriteStream on: ''.
		[ inStream atEnd ]
			whileFalse:
				[ inStream peek == $/
					ifTrue: 
						[ inStream next.
						outStream cr]
					ifFalse: 
						[ outStream nextPut: inStream next ]].
		pattern := BitPattern2D fromBitString: outStream contents.
		pieces add: ( ( self new)
			 id: index
			; patterns: ( Array 
				with: pattern
				with: ( pattern rotatedBy: 90 )
				with: ( pattern rotatedBy: 180 )
				with:( pattern rotatedBy: 270 ) ) )].
	^pieces! !

!YasumiPiece class methodsFor: 'resources' stamp: 'emm 03/09/2012 20:21'!
piecesData

	^#( 
	'001/001/111'
	'101/111'
	'0010/1111'
	'0011/1110'
	'010/111/010'
	'010/110/011'
	'0001/1111'
	'100/111/001'
	'011/111'
	'010/010/111'
	'11111'
	'001/011/110'
)! !

!YasumiPiece methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:21'!
id

	"Answer the value of id"

	^id! !

!YasumiPiece methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:21'!
id: aValue

	"Set the value of id"

	id := aValue! !

!YasumiPiece methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:21'!
patternIndex

	"Answer the value of patternIndex"

	^patternIndex! !

!YasumiPiece methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:21'!
patternIndex: aValue

	"Set the value of patternIndex"

	patternIndex := aValue! !

!YasumiPiece methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:21'!
patterns

	"Answer the value of patterns"

	^patterns! !

!YasumiPiece methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:21'!
patterns: aValue

	"Set the value of patterns"

	patterns := aValue! !

!YasumiPiece methodsFor: 'printing' stamp: 'emm 03/09/2012 20:21'!
printOn: aStream indent: level

	aStream nextPut: ${ ;print: self id ;nextPut: $}.
	self patterns 	
		do:[ :each | each printOn: aStream ]
		separatedBy:[ aStream crtab ]
		! !

Geometric3D subclass: #Triangle3D
	instanceVariableNames: 'point1 point2 point3'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Primitives3D'!

!Triangle3D class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:36'!
with: aPoint with: otherPoint with: yetAnotherPoint

	^self new
		point1: aPoint
		; point2: otherPoint
		; point3: yetAnotherPoint! !

!Triangle3D methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:36'!
asFourTrianglesDo: aBlock 

	| m12 m23 m13 |
	m12 := point1 + point2 / 2.
	m23 := point2 + point3 / 2.
	m13 := point1 + point3 / 2.
	aBlock value: (self class
			with: point1
			with: m12
			with: m13).
	aBlock value: (self class
			with: m12
			with: point2
			with: m23).
	aBlock value: (self class
			with: m13
			with: m23
			with: point3).
	aBlock value: (self class
			with: m13
			with: m12
			with: m23)! !

!Triangle3D methodsFor: 'converting' stamp: 'emm 10/7/2012 22:51'!
asPolygon3D
	^Polygon3D with: point1 with: point2 with: point3
	! !

!Triangle3D methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:36'!
asThreeTrianglesDo: aBlock 

	| m123 |
	m123 := self center.
	aBlock value: (self class
			with: point1
			with: m123
			with: point3).
	aBlock value: (self class
			with: point1
			with: point2
			with: m123).
	aBlock value: (self class
			with: point2
			with: point3
			with: m123)! !

!Triangle3D methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:36'!
asTwoTrianglesDo: aBlock! !

!Triangle3D methodsFor: 'computing' stamp: 'emm 02/09/2012 23:36'!
bounds

	^( ( point1 min: point2 )
		min: point3 )
		corner: ( ( point1 max: point2 )
				max: point3 )! !

!Triangle3D methodsFor: 'computing' stamp: 'emm 02/09/2012 23:36'!
center

	"Answer the center point for the receiver"

	^Helper3D
		existingIntersectionBetweenLineSegment3D: ( point1 + point2 / 2.0 lineSegmentTo: point3 ) 
		and: ( point1 + point3 / 2.0 lineSegmentTo: point2 )
! !

!Triangle3D methodsFor: 'computing' stamp: 'emm 02/09/2012 23:36'!
edges

	^Array 
		with: (LineSegment3D from: self point1 to: self point2)
		with: (LineSegment3D from: self point1 to: self point3)
		with: (LineSegment3D from: self point2 to: self point3)! !

!Triangle3D methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:36'!
kindDo: aRequestor

	^aRequestor doTriangle3D: self! !

!Triangle3D methodsFor: 'computing' stamp: 'emm 02/09/2012 23:36'!
normal

	| one2two one2three cross |
	one2two := point2 - point1.
	one2three := point3 - point1.
	cross := one2two crossProduct: one2three.
	^cross isZero
		ifTrue:[ ( point3 - point2 crossProduct: one2two negated ) normalized ]
		ifFalse:[ cross normalized ]! !

!Triangle3D methodsFor: 'private' stamp: 'emm 02/09/2012 23:36'!
point1

	^point1! !

!Triangle3D methodsFor: 'private' stamp: 'emm 02/09/2012 23:36'!
point1: aValue

	point1 := aValue! !

!Triangle3D methodsFor: 'private' stamp: 'emm 02/09/2012 23:36'!
point2

	^point2! !

!Triangle3D methodsFor: 'private' stamp: 'emm 02/09/2012 23:36'!
point2: aValue

	point2 := aValue! !

!Triangle3D methodsFor: 'private' stamp: 'emm 02/09/2012 23:36'!
point3

	^point3! !

!Triangle3D methodsFor: 'private' stamp: 'emm 02/09/2012 23:36'!
point3: aValue

	point3 := aValue! !

!Triangle3D methodsFor: 'printing' stamp: 'emm 02/09/2012 23:36'!
printOn: aStream indent: level 

	self storeOn: aStream! !

!Triangle3D methodsFor: 'generating' stamp: 'emm 02/09/2012 23:36'!
randomPointUsing: aRandom 
	"Answer a random point that lies within the receiver"
	"compute barycentric coordinates a,b,c"

	| a b c |
	a := aRandom next.
	b := aRandom next.
	a + b > 1
		ifTrue: 
			[a := 1 - a.
			b := 1 - b].
	c := 1 - a - b.	"P = aA + bB + cC"
	^point1 * a + (point2 * b) + (point3 * c)! !

!Triangle3D methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:36'!
reverseDo: aBlock

	aBlock value: point3.
	aBlock value: point2.
	aBlock value: point1.

! !

!Triangle3D methodsFor: 'converting' stamp: 'emm 02/09/2012 23:36'!
reverseOriented

	^self class with: point1 with: point3 with: point2! !

!Triangle3D methodsFor: 'converting' stamp: 'emm 02/09/2012 23:36'!
scaleBy: scalar

	point1 := point1 * scalar.
	point2 := point2 * scalar.
	point3 := point3 * scalar.! !

!Triangle3D methodsFor: 'printing' stamp: 'emm 02/09/2012 23:36'!
storeOn: aStream
	aStream 
		nextPutAll: '(Triangle3D with: '
		; print: point1
		; nextPutAll: ' with: '
		; print: point2
		; nextPutAll: ' with: '
		; print: point3
		; nextPut: $)! !

!Triangle3D methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:36'!
subdividedTo: howMany do: aBlock 
	"Subdivide the receiver into <howMany> triangles and 
	evaluate <aBlock> for each subdivision"

	howMany < 1
		ifTrue: [self error: 'cannot subdivide into' , howMany printString].
	howMany = 1
		ifTrue: [^aBlock value: self].
	howMany = 2
		ifTrue: [^self asTwoTrianglesDo: aBlock].
	howMany = 3
		ifTrue: [^self asThreeTrianglesDo: aBlock].
	howMany = 4
		ifTrue: [^self asFourTrianglesDo: aBlock].
	^self error: 'not yet implemented'! !

!Triangle3D methodsFor: 'converting' stamp: 'emm 02/09/2012 23:36'!
translateBy: aPoint

	point1 := point1 + aPoint.
	point2:= point2 + aPoint.
	point3 := point3 + aPoint.
	! !

!Triangle3D methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:36'!
trianglesDo: aBlock
	aBlock value: self! !

!Triangle3D methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:36'!
verticesDo: aBlock

	aBlock value: point1.
	aBlock value: point2.
	aBlock value: point3! !

Object subclass: #Geometric3DScenes
	instanceVariableNames: 'builder'
	classVariableNames: ''
	poolDictionaries: 'Math3DConstants'
	category: 'Zenna-SceneBuilding3D'!

!Geometric3DScenes methodsFor: '*Zenna-ZennaTests' stamp: 'emm 03/09/2012 20:58'!
circle
	"This method was generated by Graphics2DViewer"
	"(Graphics3DViewer on: self new circle ) open"

	^(Curve3D	expression:'[ :angle | angle cos @ angle sin @ 0 ]' )
		interpolatedWithAll: (0 to: 360 rad by: 5 rad)! !

!Geometric3DScenes methodsFor: '*Zenna-ZennaTests' stamp: 'emm 03/09/2012 20:58'!
fiveEarBells
	"This method was generated by Graphics2DViewer"
	"(Graphics3DViewer on: self new fiveEarBells ) open"

	^(Curve3D
	expression: '[ :angle |  | phased |
	phased := angle  + (Float pi /  6).

	(5 * angle ) sin *
	(angle cos @ angle sin @ 0) +

	(phased cos @ phased sin @ 0)
]')
	interpolatedWithAll: (0 to: 360 rad by: 2 rad)! !

!Geometric3DScenes methodsFor: '*Zenna-ZennaTests' stamp: 'emm 03/09/2012 20:58'!
fourEarBells
	"This method was generated by Graphics2DViewer"
	"(Graphics3DViewer on: self new fourEarBells ) open"

	^(Curve3D
	expression: '[ :angle |  | phased |
	phased := angle  + (Float pi /  6).

	(4 * angle ) sin *
	(angle cos @ angle sin @ 0) +

	(phased cos @ phased sin @ 0)
]')
	interpolatedWithAll: (0 to: 360 rad by: 2 rad)! !

!Geometric3DScenes methodsFor: '*Zenna-ZennaTests' stamp: 'emm 03/09/2012 20:58'!
knot4
	"This method was generated by Graphics2DViewer"
	"(Graphics3DViewer on: self new knot4 ) open"

	^(Curve3D
	expression: '[ :angle |  | phased z |
	phased := angle  + (Float pi / 6).
	z := (45 degreesToRadians + (4 * angle)) sin.

	(4 * angle ) sin *
	(angle cos @ angle sin @ z ) -

	((4 * phased ) sin *
	(phased cos @ phased sin @ z))
]')
	interpolatedWithAll: (0 to: 180 rad by: 2 rad)! !

!Geometric3DScenes methodsFor: '*Zenna-ZennaTests' stamp: 'emm 03/09/2012 20:58'!
knot8
	"This method was generated by Graphics2DViewer"
	"(Graphics3DViewer on: self new knot8 ) open"

	^(Curve3D
	expression: '[ :angle |  | phased z |
	phased := angle  + (Float pi / 6).
	z := (45 degreesToRadians + (4 * angle)) sin.

	(4 * angle ) sin *
	(angle cos @ angle sin @ z ) -

	((4 * phased ) sin *
	(phased cos @ phased sin @ z))
]')
	interpolatedWithAll: (0 to: 360 rad by: 2 rad)! !

!Geometric3DScenes methodsFor: '*Zenna-ZennaTests' stamp: 'emm 03/09/2012 20:58'!
makeKnot4
	"VRMLScenes new makeKnot4"

	| b |
	b := self builder.
	self knot4 verticesDo:[ :each |
		b add: ((Sphere center: each) radius: 0.1)].
	self writeTo: 'makeKnot4'! !

!Geometric3DScenes methodsFor: '*Zenna-ZennaTests' stamp: 'emm 03/09/2012 20:58'!
makeKnot8
	"VRMLScenes new makeKnot8"

	| b |
	b := self builder.
	self knot8 verticesDo:[ :each |
		b add: ((Sphere center: each) radius: 0.1)].
	self writeTo: 'makeKnot8'! !

!Geometric3DScenes methodsFor: '*Zenna-ZennaTests' stamp: 'emm 03/09/2012 20:58'!
makeThreeEarBells
	"VRMLScenes new makeThreeEarBells"

	| b |
	b := self builder.
	self threeEarBells verticesDo:[ :each |
		b add: ((Sphere center: each) radius: 0.1)].
	self writeTo: 'makeThreeEarBells'! !

!Geometric3DScenes methodsFor: '*Zenna-ZennaTests' stamp: 'emm 03/09/2012 20:58'!
makeThreeEarBells2
	"VRMLScenes new makeThreeEarBells2"

	| b |
	b := self builder.
	self threeEarBells verticesDo:[ :each |
		b color: Color random.
		b add: (Box center: each extent: 0.1)].
	self writeToFile: 'makeThreeEarBells2'! !

!Geometric3DScenes methodsFor: '*Zenna-ZennaTests' stamp: 'emm 03/09/2012 20:58'!
sixEarBells
	"This method was generated by Graphics2DViewer"
	"(Graphics3DViewer on: self new sixEarBells ) open"

	^(Curve3D
	expression: '[ :angle |  | phased |
	phased := angle  + (Float pi /  6).

	(6 * angle ) sin *
	(angle cos @ angle sin @ 0) +

	(phased cos @ phased sin @ 0)
]')
	interpolatedWithAll: (0 to: 360 rad by: 2 rad)! !

!Geometric3DScenes methodsFor: '*Zenna-ZennaTests' stamp: 'emm 03/09/2012 20:58'!
testAxis0
	"MayaScenes new testAxis0"

		"X-axis in Green
		 Y-axis in Red
		 Z-axis in Blue"

	| b c |
	b := self builder.
	c := (Cylinder new) radius: 2 ;height: 10.
	b color: Color blue ;add: c.         
	b color: Color red ;add: (c rotatedBy: -90 rad,0,0).
	b color: Color green ;add: (c rotatedBy: 0,90 rad,0).
	self writeTo: 'testAxis0'! !

!Geometric3DScenes methodsFor: '*Zenna-ZennaTests' stamp: 'emm 03/09/2012 20:58'!
testAxis1
	"self testAxis1"

		"X-axis in Green
		 Y-axis in Red
		 Z-axis in Blue"

	| b c |
	b := self builder.
	b color: Color blue ;add: (Box origin: 0,0,1 corner: 1,1,10).
	b color: Color red ;add: (Box origin: 0,1,0 corner: 1,10,1).
	b color: Color green ;add: (Box origin: 1,0,0 corner: 10,1,1).
	b writeToFile: 'testAxis1' ! !

!Geometric3DScenes methodsFor: '*Zenna-ZennaTests' stamp: 'emm 03/09/2012 20:58'!
testCone
	"VRMLScenes new testCone"

	| b cone |
	b := self builderClass new.
	b addAxis.
	b color: Color green.
	cone := (Cone  new)  topRadius: 1 ;bottomRadius: 2 ;height: 3.
	b add: ( cone wrapScaleBy: 0.5 asPoint3D ).

	b writeToFile: 'testCone'! !

!Geometric3DScenes methodsFor: '*Zenna-ZennaTests' stamp: 'emm 03/09/2012 20:58'!
testCube
	"MayaScenes new testCube"

	| b |
	b := self builderClass new.
	b add: (Box origin: 1,2,3 corner: 3,4,5).

	self  writeToFile: 'test0'! !

!Geometric3DScenes methodsFor: '*Zenna-ZennaTests' stamp: 'emm 03/09/2012 20:58'!
testCubeFaces
	"self new testCubeFaces"

	| b |
	b := self builder.
	Box new facesDo:[ :e | b add: e ].
	self writeToFile: 'testCubeFaces'! !

!Geometric3DScenes methodsFor: '*Zenna-ZennaTests' stamp: 'emm 03/09/2012 20:58'!
testCubicSpaceDivider
	"MayaScenes new testCubicSpaceDivider"

	| b |
	b := SceneBuilder vrml.
	b 
		texture: 'doit.jpg'
		; halt ;add:  ( ( CubicSpaceDivider size: 10 ) barExtent: 1 asPoint3D).
	b  writeToFile: 'CubicSpaceDivider'! !

!Geometric3DScenes methodsFor: '*Zenna-ZennaTests' stamp: 'emm 03/09/2012 20:58'!
testCylinder
	
	"self new testCylinder"
	
	self builder add: ( Cylinder 
		center: 1 , 2 , 3 
		radius: 2 
		height: 5 ).
	self writeToFile: 'testCylinder'! !

!Geometric3DScenes methodsFor: '*Zenna-ZennaTests' stamp: 'emm 03/09/2012 20:58'!
testDodecahedron
	"self new testDodecahedron"

	| b |
	b := self builder.
	b add: Polyhedron dodecahedron.
	b writeToFile: 'testDodecahedron'


	! !

!Geometric3DScenes methodsFor: '*Zenna-ZennaTests' stamp: 'emm 03/09/2012 20:58'!
testEmpty
	"self new testEmpty"

	| b |
	b := self builder.
	b writeToFile: 'test'! !

!Geometric3DScenes methodsFor: '*Zenna-ZennaTests' stamp: 'emm 03/09/2012 20:58'!
testHexahedronNode

	"VRMLScenes new testHexahedronNode"

	| b start |
	b := self builderClass new.
	b color: Color green.

	start := HexahedronNode
		ringFromBottom: (0@4@0 centerExtent: 1@1@0)
		rotatingBy: 5 rad @ 0 @ 0.

	b add: start.
	b writeToFile: 'testHexahedronNode'! !

!Geometric3DScenes methodsFor: '*Zenna-ZennaTests' stamp: 'emm 03/09/2012 20:58'!
testHollow0

	"POVRayScenes new testHollow0"

	| b |
	b := self builder.
	b add: ( ( Cylinder new 
		radius: 20
		; height: 10 )
			hollowWithThickness: 2 ).
	b add: ( ( Cone new
		radius: 15
		; topRadius: 6
		; height: 20 )
			hollowWithThickness: 2 ).
	b writeToFile: 'testHollow'.! !

!Geometric3DScenes methodsFor: '*Zenna-ZennaTests' stamp: 'emm 03/09/2012 20:58'!
testPolygon0
	"self new testPolygon0"

	| b |
	b := self builder.
	b add: Box new front.
	b writeToFile: 'testPolygon0'
	! !

!Geometric3DScenes methodsFor: '*Zenna-ZennaTests' stamp: 'emm 03/09/2012 20:58'!
testPolyhedron: aSelector
	"self new testPolyhedron: #bigyrateDiminishedRhombicosidodecahedron"

	| b upperName  |
	b := self builder.
	b red.
	b add: ( (Polyhedron perform: aSelector) reverseVertexOrder scaledBy: 2 ).
	upperName := (String with: aSelector first asUppercase) , aSelector copyFrom: 2 to: aSelector size.
	builder writeToFile: upperName ! !

!Geometric3DScenes methodsFor: '*Zenna-ZennaTests' stamp: 'emm 03/09/2012 20:58'!
testPyramid

	| b |
	b := self builder.
	b add: (Pyramid size: 4).

	self  writeToFile: 'testPyramid'! !

!Geometric3DScenes methodsFor: '*Zenna-ZennaTests' stamp: 'emm 03/09/2012 20:58'!
testRGBCube
	"self new testRGBCube"

	| b cube |
	b := self builder.

	cube := Box size: 1.
	b color: Color red.
	#( top bottom ) do:[ :faceName |
		b add: ( cube perform: faceName ) ].
	b color: Color blue.
	#( left right ) do:[ :faceName |
		b add: ( cube perform: faceName ) ].
	b color: Color green.
	#( front back ) do:[ :faceName |
		b add: ( cube perform: faceName ) ].

	self writeToFile: 'RGBBox'! !

!Geometric3DScenes methodsFor: '*Zenna-ZennaTests' stamp: 'emm 03/09/2012 20:58'!
testRGBPrimitives0
	
	"self new testRGBPrimitives0"
	
	| b |
	b := self builder.

	b add: ( ( Box new wrapTranslateBy: 0 , 0 , 1 ) wrapColoredWith: Color blue ).
	b add: ( ( Cylinder new wrapColoredWith: Color red ) wrapTranslateBy: 0 , 1 , 1 ).
	b add: ( ( Cone new wrapColoredWith: Color green ) wrapTranslateBy: 0 , 2 , 1 ).

	self writeToFile: 'testRGBPrimitives0'! !

!Geometric3DScenes methodsFor: '*Zenna-ZennaTests' stamp: 'emm 03/09/2012 20:58'!
testSS3D

	"self new testSS3D"
	
	| b  |
	b := self builder. 
	b add: 'SmallScript3D' asText3D.
	b writeToFile:  'testSS3D'! !

!Geometric3DScenes methodsFor: '*Zenna-ZennaTests' stamp: 'emm 03/09/2012 20:58'!
testSphere
	"MayaScenes new testSphere"

	| b |
	b := self builder.
	b add: (Sphere center: 1,2,3 radius: 4).	
	b writeToFile: 'test0'! !

!Geometric3DScenes methodsFor: '*Zenna-ZennaTests' stamp: 'emm 03/09/2012 20:58'!
testSphereApprox
	"D3DMeshes new testSphereApprox"
	"VRMLScenes new testSphereApprox"

	| b |
	b := self builder.
	b color: Color cyan.
	b add: (SphereApproximator on: (Sphere center: 1,2,3 radius: 4)).	

	self  writeToFile: 'testSphereApprox'! !

!Geometric3DScenes methodsFor: '*Zenna-ZennaTests' stamp: 'emm 03/09/2012 20:58'!
testTorus
	"POVRayScenes new testTorus"
	"VRMLScenes new testTorus"

	| b |
	b := self builderClass new.
	b color: Color yellow.
	b add: (Torus center: 0,0,0 majorRadius: 2 minorRadius: 1).

	b add: (Camera at: 10,0,0 lookingAt: 0,0,0).
	b writeToFile: 'testTorus'! !

!Geometric3DScenes methodsFor: '*Zenna-ZennaTests' stamp: 'emm 03/09/2012 20:58'!
testTorusSegment
	"POVRayScenes new testTorusSegment"
	"VRMLScenes new testTorusSegment"

	| b |
	b := self builderClass new.
	b color: Color yellow.
	b add: (
		(Torus center: 0,0,0 majorRadius: 4 minorRadius: 1)
			startAngle: 0
			;sweepAngle: 45 rad).

	b add: (Camera at: 10,0,0 lookingAt: 0,0,0).
	b writeToFile: 'testTorus'! !

!Geometric3DScenes methodsFor: '*Zenna-ZennaTests' stamp: 'emm 03/09/2012 20:58'!
testTorusSegment2
	"POVRayScenes new testTorusSegment2"
	"VRMLScenes new testTorusSegment2"

	| b |
	b := self builderClass new.
	b color: Color green.

	b addAxis.
	b add: ( ( Torus center: 0,0,0 
			majorRadius: 1 
			minorRadius: 0.1 )
				startAngle: 0 rad
				; stopAngle: 180 rad ).

	b add: (Camera at: 10,0,0 lookingAt: 0,0,0).
	b writeToFile: 'testTorusSegment2'! !

!Geometric3DScenes methodsFor: '*Zenna-ZennaTests' stamp: 'emm 03/09/2012 20:58'!
testTorusSegment3
	"self new testTorusSegment3"

	| b |
	b := self builderClass new.
	b texture: 'wood2'.
	b add: ( ( ( Torus  center: 0,0,0 
			majorRadius: 1 
			minorRadius: 0.1 )
				startAngle: -15 rad
				; stopAngle: 195 rad ) rotatedBy: 90 rad , 0 , 0).

	self  writeToFile: 'test'! !

!Geometric3DScenes methodsFor: '*Zenna-ZennaTests' stamp: 'emm 03/09/2012 20:58'!
testTorusSegment4
	"self new testTorusSegment4"

	| b |
	b := self builderClass new.
	b texture: 'wood2'.
	b add: ( ( ( Torus  center: 0,0,0 
			majorRadius: 1 
			minorRadius: 0.1 )
				startAngle: 15 rad
				; stopAngle: 295 rad ) rotatedBy: 90 rad , 0 , 0 ).

	self  writeToFile: 'test'! !

!Geometric3DScenes methodsFor: '*Zenna-ZennaTests' stamp: 'emm 03/09/2012 20:58'!
testTorusSegment5
	"self new testTorusSegment5"

	| b |
	b := self builderClass new.
	b texture: 'wood2'.
	b add: ( ( ( Torus  center: 0,0,0 
			majorRadius: 1 
			minorRadius: 0.1 )
				center: 0.5,0,0
				; startAngle: 15 rad
				; stopAngle: 295 rad ) centerRotateBy: 45 rad , 0 , 0 ).
	b writeToFile: 'test'! !

!Geometric3DScenes methodsFor: '*Zenna-ZennaTests' stamp: 'emm 03/09/2012 20:58'!
testTriakisOctahedron
	"self new testTriakisOctahedron"

	| b |
	b := self builder.
	b add: Polyhedron triakisOctahedron.
	self writeToFile: 'testTriakisOctahedron'


	! !

!Geometric3DScenes methodsFor: '*Zenna-ZennaTests' stamp: 'emm 03/09/2012 20:58'!
testTrueType1
	"self new testTrueType1"

	| b arial char zPoints |
	b := SceneBuilder vrml.

	arial := TTFontReader parseFileNamed:'c:\winnt\fonts\arial.ttf'.
	char := arial at: $P.
	 b color: Color red.
	char contours do: [ :each |
		| poly |
		poly := Polyline3D new.
		1 to: each size by: 3 do:[ :other |
			| pt |
			pt := ( each at: other ) // 10.
			poly add: 0 , pt x , pt y.
			pt := ( each at: other + 2 ) // 10.
			poly add: 0 , pt x , pt y ].
		b add: poly ].

	b add: (Camera at: 100,0,0 lookingAt: 0,0,0).
	b writeToFile: 'testTrueType1'! !

!Geometric3DScenes methodsFor: '*Zenna-ZennaTests' stamp: 'emm 03/09/2012 20:58'!
testWallPen
	"self new testWallPen"

	| p |
	p := WallPen new.
	p height: 10.
	p width: 2.
	p down.
	p texture: 'top.jpg' scale: 2,1.
	p colorLeft: Color yellow.
	p colorFront: Color red.
	p colorRight: Color green.
	p colorBack: Color white.
	p colorTop: Color cyan.
	p colorBottom: Color brown.
	p dx: 50.
	p dy: 25.
	p dx: 25 dy: 25.

"	builder := SceneBuilder m3d."
	builder addAxis.
	builder addAll: p objects.
	builder writeToFile: 'testWallPen'! !

!Geometric3DScenes methodsFor: '*Zenna-ZennaTests' stamp: 'emm 03/09/2012 20:58'!
testWallPen2
	"self new testWallPen2"

	| p |
	p := WallPen new.
	p height: 10.
	p width: 2.
	p down.
	p texture: 'top.jpg' scale: 2,1.
	p colorLeft: Color yellow.
	p colorFront: Color red.
	p colorRight: Color green.
	p colorBack: Color white.
	p colorTop: Color cyan.
	p colorBottom: Color brown.
	p dx: -50.
	p dy: -25.
	p dx: -25 dy: -25.

"	builder := SceneBuilder m3d."
	builder addAxis.
	builder addAll: p objects.
	builder writeToFile: 'testWallPen2'! !

!Geometric3DScenes methodsFor: '*Zenna-ZennaTests' stamp: 'emm 03/09/2012 20:58'!
testWallPen3
	"self new testWallPen3"

	| p |
	p := WallPen new.
	p height: 10.
	p down.
	p textureLeft: 'top.jpg' scale: 2,1.
	p textureRight: 'top.jpg' scale: 2,1.
	p dx: -50.
	p dy: -50.
	
	builder addAxis.
	builder addAll: p objects.
	builder writeToFile: 'testWallPen3'! !

!Geometric3DScenes methodsFor: '*Zenna-ZennaTests' stamp: 'emm 03/09/2012 20:58'!
testWrappers0
	
	"self testWrappers0"
	
	| b |
	b := self builder.
	b add: ( ( ( ( Box new ) wrapTranslateBy: 1 , 2 , 3 ) wrapRotateBy: 10 asPoint3D  ) wrapScaleBy: 2 asPoint3D ).
	b writeToFile: 'testWrappers0'! !

!Geometric3DScenes methodsFor: '*Zenna-ZennaTests' stamp: 'emm 03/09/2012 20:58'!
testWrappers1
	
	"self testWrappers1"
	
	| b |
	b := self builder.
	b add: ( ( ( ( Torus 
		center: -1 , -2 , -3 
		majorRadius: 3
		minorRadius: 2 ) wrapTranslateBy: 1 , 2 , 3 ) wrapRotateBy: 10,0,0 ) wrapScaleBy: 2,1,1 ).

	self  writeToFile: 'testWrappers1'! !

!Geometric3DScenes methodsFor: '*Zenna-ZennaTests' stamp: 'emm 03/09/2012 20:58'!
threeEarBells
	"This method was generated by Graphics2DViewer"
	"(Graphics3DViewer on: self new threeEarBells ) open"

	^(Curve3D
	expression:'[ :angle |  | phased |
	phased := angle  + (Float pi /  6).

	(3 * angle ) sin *
	(angle cos @ angle sin @ 0) +

	(phased cos @ phased sin @ 0)
]')
	interpolatedWithAll: (0 to: 360 rad by: 2 rad)! !

Object subclass: #GraphicsFileAccessor
	instanceVariableNames: 'stream fileName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-FileIO'!

GraphicsFileAccessor class
	instanceVariableNames: 'workingDirectoryName'!

GraphicsFileAccessor class
	instanceVariableNames: 'workingDirectoryName'!

!GraphicsFileAccessor class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 22:56'!
new

	"Answer a new instance of the receiver and initialize it"

	^super new initialize! !

!GraphicsFileAccessor class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 22:56'!
on: aStream
	^self new stream: aStream! !

!GraphicsFileAccessor class methodsFor: 'resources' stamp: 'emm 02/09/2012 22:56'!
path
	
	^workingDirectoryName ifNil: [ 
		self superclass = Object
			ifTrue: [ '' ]
			ifFalse: [ self superclass workingDirectoryName ] ]! !

!GraphicsFileAccessor class methodsFor: 'resources' stamp: 'emm 02/09/2012 22:56'!
path: aString

	workingDirectoryName := aString! !

!GraphicsFileAccessor class methodsFor: 'resources' stamp: 'emm 02/09/2012 22:56'!
workingDirectoryName
	"Adaptor"
	^self path! !

!GraphicsFileAccessor class methodsFor: 'resources' stamp: 'emm 02/09/2012 22:56'!
workingDirectoryName: aString
	"Adaptor"
	
	self path: aString! !

!GraphicsFileAccessor methodsFor: 'utilities' stamp: 'emm 02/09/2012 22:56'!
assert: aBlock

	aBlock value
		ifFalse:[ self error: 'assertion failed' ]! !

!GraphicsFileAccessor methodsFor: 'utilities' stamp: 'emm 02/09/2012 22:56'!
binary

	stream binary! !

!GraphicsFileAccessor methodsFor: 'utilities' stamp: 'emm 02/09/2012 22:56'!
close

	stream close! !

!GraphicsFileAccessor methodsFor: 'accessing' stamp: 'emm 02/09/2012 22:56'!
contents

	^stream contents! !

!GraphicsFileAccessor methodsFor: 'accessing' stamp: 'emm 02/09/2012 22:56'!
fileName
	^fileName ifNil:[ 'unnamed stream']! !

!GraphicsFileAccessor methodsFor: 'accessing' stamp: 'emm 02/09/2012 22:56'!
fileName: anObject
	fileName := anObject! !

!GraphicsFileAccessor methodsFor: 'initialize-release' stamp: 'emm 02/09/2012 22:56'!
initialize! !

!GraphicsFileAccessor methodsFor: 'inspecting' stamp: 'emm 02/09/2012 22:56'!
inspectActions

	^#( reset close )! !

!GraphicsFileAccessor methodsFor: 'testing' stamp: 'emm 02/09/2012 22:56'!
isBigEndian
	"On default, receiver (reads & writes) data in PC-style format = low byte - high byte"

	^false! !

!GraphicsFileAccessor methodsFor: 'testing' stamp: 'emm 02/09/2012 22:56'!
isBinary
	"On default, files are in readable ASCII format"

	^false! !

!GraphicsFileAccessor methodsFor: 'accessing' stamp: 'emm 02/09/2012 22:56'!
position

	^stream position! !

!GraphicsFileAccessor methodsFor: 'accessing' stamp: 'emm 02/09/2012 22:56'!
position: offset

	stream position: offset! !

!GraphicsFileAccessor methodsFor: 'utilities' stamp: 'emm 02/09/2012 22:56'!
reset

	stream reset! !

!GraphicsFileAccessor methodsFor: 'accessing' stamp: 'emm 02/09/2012 22:56'!
stream

	^stream! !

!GraphicsFileAccessor methodsFor: 'accessing' stamp: 'emm 02/09/2012 22:56'!
stream: aStream 

	self isBinary ifTrue: [ aStream binary ].
	stream := aStream! !

GraphicsFileAccessor subclass: #GraphicsFileReader
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-FileIO'!

GraphicsFileReader subclass: #DominoDesignerFormatReader
	instanceVariableNames: 'matrix where end colorManager name email noOfStones'
	classVariableNames: ''
	poolDictionaries: 'Math3DConstants'
	category: 'Zenna-Dominos'!

!DominoDesignerFormatReader class methodsFor: 'instance-creation' stamp: 'emm 03/09/2012 20:19'!
new

	^super new initialize! !

!DominoDesignerFormatReader methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
colorManager

	"Answer the value of colorManager"

	^colorManager! !

!DominoDesignerFormatReader methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
colorManager: aValue

	"Set the value of colorManager"

	colorManager := aValue! !

!DominoDesignerFormatReader methodsFor: 'API' stamp: 'emm 03/09/2012 20:19'!
colorMap

	"Return  the value of colorMap"

	^(colorManager colorMap)! !

!DominoDesignerFormatReader methodsFor: 'reading' stamp: 'emm 03/09/2012 20:19'!
determineDDFSize
	
	"determines the DDF-scene-size and fills colorMap also assing where and end"
	
	| x y xMax yMax el |
	name := self readLineDDF.
	email := self readLineDDF. 
	
	x := 1.
	y := 1.
	xMax := 1.
	yMax := 1. 
	
	[ stream atEnd ]
		whileFalse: 
			[ el := self readDDFElement.
			xMax := xMax max: el size y + el x - 1.
			yMax := yMax max: el size x + el y - 1.
			el id = 20 
				ifTrue:[ self where: el x , el y ].
			el id = 18 
				ifTrue:[ self end: el x , el y ] ]. 
	
	matrix := MatrixNxM new: xMax by: yMax.
	stream reset! !

!DominoDesignerFormatReader methodsFor: 'API' stamp: 'emm 03/09/2012 20:19'!
dominoMap

	"return the value of matrix"

	^matrix! !

!DominoDesignerFormatReader methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
email

	"Answer the value of email"

	^email! !

!DominoDesignerFormatReader methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
email: aValue

	"Set the value of email"

	email := aValue! !

!DominoDesignerFormatReader methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
end

	"Answer the value of end"

	^end! !

!DominoDesignerFormatReader methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
end: aValue

	"Set the value of end"

	end := aValue! !

!DominoDesignerFormatReader methodsFor: 'API' stamp: 'emm 03/09/2012 20:19'!
endPoint

	"return the value of where"

	^end! !

!DominoDesignerFormatReader methodsFor: 'initialize-release' stamp: 'emm 03/09/2012 20:19'!
initialize

	colorManager :=  DominoColorManager new! !

!DominoDesignerFormatReader methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
matrix

	"Answer the value of matrix"

	^matrix! !

!DominoDesignerFormatReader methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
matrix: aValue

	"Set the value of matrix"

	matrix := aValue! !

!DominoDesignerFormatReader methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
name

	"Answer the value of name"

	^name! !

!DominoDesignerFormatReader methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
name: aValue

	"Set the value of name"

	name := aValue! !

!DominoDesignerFormatReader methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
noOfStones

	"Answer the value of noOfStones"

	^noOfStones! !

!DominoDesignerFormatReader methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
noOfStones: aValue

	"Set the value of noOfStones"

	noOfStones := aValue! !

!DominoDesignerFormatReader methodsFor: 'reading' stamp: 'emm 03/09/2012 20:19'!
readDDF

	self readDDFForColorManager: self colorManager
! !

!DominoDesignerFormatReader methodsFor: 'reading' stamp: 'emm 03/09/2012 20:19'!
readDDFElement
	
	| dde r g b col |
	dde := DominoDesignerElement new.
	dde id: self readNumber.
	dde y: self readNumber.
	dde x: self readNumber.
	dde transformId: self readNumber.
	r := self readNumber.
	g := self readNumber.
	b := self readNumber.
	self skipSeparators.
	col := self colorManager
		returnColorKeyFromR: r 
		g: g 
		b: b.
	dde colorKey: col.
	dde fillMatrix. 
	
	^ dde 
	! !

!DominoDesignerFormatReader methodsFor: 'reading' stamp: 'emm 03/09/2012 20:19'!
readDDFElementForColorManager: aColorManager

	"writes the DDFElements on self matrix"

	| x y xMax yMax el |	

	name := self readLineDDF.
	email := self readLineDDF.

	(name size = 0) ifTrue: [name := 'Stranger'].
	(name size > 30) ifTrue: [name := name copyFrom: 1 to: 30].

	[ stream atEnd ]
		whileFalse: 
			[ el := self readDDFElementFromFileForColorManager: aColorManager .
				self writeOnMatrix: el ].
	stream reset! !

!DominoDesignerFormatReader methodsFor: 'reading' stamp: 'emm 03/09/2012 20:19'!
readDDFElementFromFileForColorManager: aColorManager
	
	| dde r g b |
	dde := DominoDesignerElement new.
	dde id: self readNumber.
	dde y: self readNumber.
	dde x: self readNumber.
	dde transformId: self readNumber.
	r := self readNumber.
	g := self readNumber.
	b := self readNumber.
	self skipSeparators.
	dde colorKey: (aColorManager returnColorKeyFromR: r g: g b: b).
	dde fillMatrix. 
	
	^ dde 
	! !

!DominoDesignerFormatReader methodsFor: 'reading' stamp: 'emm 03/09/2012 20:19'!
readDDFForColorManager: aColorManager
	"Domino Designer Format
	
	First line reserved for name of contributor
	Second line reserved for email adress of contributor
	Third line and further reserved for ddf-items
		Id no. (0-24)
		x position
		y position
		transform id
			0 	=	normal
			1	=	rotated 90 degrees clockwise
			2	=	rotated 180 degrees
			3	=	rotated 90 degrees conterclockwise
		rgb red
		rgb green
		rgb blue"

	| el |

	self determineDDFSize.
	self readDDFElementForColorManager: aColorManager.
	! !

!DominoDesignerFormatReader methodsFor: 'reading' stamp: 'emm 03/09/2012 20:19'!
readLineDDF
	
	^super nextLine! !

!DominoDesignerFormatReader methodsFor: 'API' stamp: 'emm 03/09/2012 20:19'!
startPoint

	"return the value of where"

	^where! !

!DominoDesignerFormatReader methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
stream: aStream 
	
	| delimiter |
	super stream: aStream. "find out what line delimiter is used"
	delimiter := nil.
	[ aStream atEnd
		or: [ delimiter ~= nil ] ]
		whileFalse: 
			[  | ch | ch := aStream next.
			ch == Character lf
				ifTrue:[ delimiter := String with: Character lf ]
				ifFalse:[ ch == Character cr 
					ifTrue:
						[ aStream atEnd
							ifTrue:[ delimiter := String with: Character cr ]
							ifFalse:[ aStream next == Character lf 
								ifTrue:[ delimiter := String with: Character cr with: Character lf ] 
								ifFalse: [ delimiter := String with: Character cr ]] ] ] ].
	aStream lineDelimiter: delimiter.
	stream reset! !

!DominoDesignerFormatReader methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
where

	"Answer the value of where"

	^where! !

!DominoDesignerFormatReader methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
where: aValue

	"Set the value of where"

	where := aValue! !

!DominoDesignerFormatReader methodsFor: 'writing' stamp: 'emm 03/09/2012 20:19'!
writeOnMatrix: anElement

	"writes the DDFElements on self matrix"

	| a el b x y  temp|

	a := anElement matrix xSize.
	b := anElement matrix ySize.

	x := anElement x.
	y := anElement y.

	1 to: b do: [ :i |
		1 to: a do: [ :j |
			temp := anElement matrix atRow: i column: j.
			(temp notNil)
			ifTrue: [	self matrix atRow:  x-1+i column: y-1+j put: temp ]]].! !

GraphicsFileReader subclass: #DominoSloganFormatReader
	instanceVariableNames: 'textBuilder colorManager name email noOfStones'
	classVariableNames: ''
	poolDictionaries: 'Math3DConstants'
	category: 'Zenna-Dominos'!

!DominoSloganFormatReader methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
colorManager

	"Answer the value of colorManager"

	^colorManager! !

!DominoSloganFormatReader methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
colorManager: aValue

	"Set the value of colorManager"

	colorManager := aValue! !

!DominoSloganFormatReader methodsFor: 'API' stamp: 'emm 03/09/2012 20:19'!
colorMap

	^colorManager colorMap! !

!DominoSloganFormatReader methodsFor: 'API' stamp: 'emm 03/09/2012 20:19'!
dominoMap
	
	^textBuilder dominoMap! !

!DominoSloganFormatReader methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
email

	"Answer the value of email"

	^email! !

!DominoSloganFormatReader methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
email: aValue

	"Set the value of email"

	email := aValue! !

!DominoSloganFormatReader methodsFor: 'API' stamp: 'emm 03/09/2012 20:19'!
endPoint
	
	^textBuilder endPoint! !

!DominoSloganFormatReader methodsFor: 'initialize-release' stamp: 'emm 03/09/2012 20:19'!
initialize

	super initialize.
	textBuilder := DominoMapFromTextBuilder new.
	colorManager :=  DominoColorManager new! !

!DominoSloganFormatReader methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
name

	"Answer the value of name"

	^name! !

!DominoSloganFormatReader methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
name: aValue

	"Set the value of name"

	name := aValue! !

!DominoSloganFormatReader methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
noOfStones

	"Answer the value of noOfStones"

	^noOfStones! !

!DominoSloganFormatReader methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
noOfStones: aValue

	"Set the value of noOfStones"

	noOfStones := aValue! !

!DominoSloganFormatReader methodsFor: 'reading' stamp: 'emm 03/09/2012 20:19'!
readColorForManager: aColorManager
	
	| color  r g b|

	color := self readLineDSF.
	(color = 'Rood') ifTrue: [^aColorManager returnColorKeyFromR: 255 g: 0 b: 0].
	(color = 'Groen') ifTrue: [^aColorManager returnColorKeyFromR: 0 g: 255 b: 0].
	(color = 'Blauw') ifTrue: [^aColorManager returnColorKeyFromR: 0 g: 0 b: 255].
	(color = 'Geel') ifTrue: [^aColorManager returnColorKeyFromR: 255 g: 255 b: 0].
	(Color respondsTo: color asSymbol)
		ifTrue: 
			[ | c |
			c := Color perform: color asSymbol.
			 ^aColorManager returnColorKeyFromR: c redByte g: c greenByte b: c blueByte ].
	" else: always return black "
	^aColorManager returnColorKeyFromR: 0 g: 0 b: 0.! !

!DominoSloganFormatReader methodsFor: 'reading' stamp: 'emm 03/09/2012 20:19'!
readDSF
	self readDSFForColorManager: self colorManager! !

!DominoSloganFormatReader methodsFor: 'reading' stamp: 'emm 03/09/2012 20:19'!
readDSFForColorManager: aColorManager

	"Domino Slogan Format
	
	First line reserved for name of contributor
	Second line reserved for email adress of contributor
	Third line reserved for slogan
	Fourth line reserved for r g b value of text
	Fifth line reserved for r g b value of background"

	| slogan textChar backChar index|

	name := self readLineDSF.
	(name size > 20)  
		ifTrue: [name := name copyFrom: 1 to: 20].
	(name size < 8)
		ifTrue: 
			[ | diff |  
			diff := 8 - name size.
			name := (String new: (diff / 2) rounded withAll: $ ),name,(String new: (diff / 2) rounded withAll: $ )].
	email := self readLineDSF.
	slogan := name asUppercase.
	textChar := self readColorForManager: aColorManager.
	backChar := self readColorForManager: aColorManager.
	textBuilder buildFromText: slogan withText: textChar withBack: backChar.
	! !

!DominoSloganFormatReader methodsFor: 'reading' stamp: 'emm 03/09/2012 20:19'!
readLineDSF
	
	| in  out ch|
	in := super nextLine readStream.
	out := '' writeStream.
	[in atEnd]
		whileFalse:
			[ ch := in next.
			ch == $%
				ifTrue: [ out nextPut: (Character value: (Integer fromHex: (in next: 2)))]
				ifFalse: [ 
					ch == $+
						ifTrue: [ out space ]
						ifFalse: [ out nextPut: ch ]]].
	^out contents
				! !

!DominoSloganFormatReader methodsFor: 'API' stamp: 'emm 03/09/2012 20:19'!
startPoint
	
	^textBuilder startPoint! !

!DominoSloganFormatReader methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
stream: aStream

	super stream: aStream.
	aStream lineDelimiter: (String with: Character lf).! !

GraphicsFileReader subclass: #DominoTextFormatReader
	instanceVariableNames: 'matrix where colorMap'
	classVariableNames: ''
	poolDictionaries: 'Math3DConstants'
	category: 'Zenna-Dominos'!

!DominoTextFormatReader methodsFor: 'API' stamp: 'emm 03/09/2012 20:19'!
colorMap

	"Answer the value of colorMap"

	^colorMap! !

!DominoTextFormatReader methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
colorMap: aValue

	"Set the value of colorMap"

	colorMap := aValue! !

!DominoTextFormatReader methodsFor: 'API' stamp: 'emm 03/09/2012 20:19'!
dominoMap

	^matrix! !

!DominoTextFormatReader methodsFor: 'initialize-release' stamp: 'emm 03/09/2012 20:19'!
initialize

	colorMap := Dictionary new.! !

!DominoTextFormatReader methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
matrix

	"Answer the value of matrix"

	^matrix! !

!DominoTextFormatReader methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
matrix: aValue

	"Set the value of matrix"

	matrix := aValue! !

!DominoTextFormatReader methodsFor: 'reading' stamp: 'emm 03/09/2012 20:19'!
readDCF

	"Domino Color Format"
	
	"Syntax: <separators><character><separators><colorname|red green blue> 
	Example:
	 	a orange 
		b 255 0 32"

	| char charColor |
	[ self skipSeparators.
	stream atEnd ]
		whileFalse: 
			[char := stream next.
			self skipSeparators.
			charColor := stream peek isDigit
				ifTrue:
					[ Color 
						redByte: self readNumber 
						greenByte: self readNumber 
						blueByte: self readNumber ]
				ifFalse:
					[ Color named: self readUpToSeparator ].
			colorMap at: char put: charColor ].
	self close! !

!DominoTextFormatReader methodsFor: 'reading' stamp: 'emm 03/09/2012 20:19'!
readDTF
	"Domino Text Format"

	| r c ch |
	self readDTFSize.
	r := 1.
	c := 1.
	[stream atEnd]
		whileFalse:
			[ ch := stream next.
			ch isSeparator
				ifTrue:[ ch asInteger = 10
					ifTrue:[ r := r + 1. c := 0 ] ]
				ifFalse:
					[ ch = $@
						ifTrue:[ where := r , c].
					matrix atRow: r column: c put: ch].
			c := c + 1 ].
	self close.! !

!DominoTextFormatReader methodsFor: 'reading' stamp: 'emm 03/09/2012 20:19'!
readDTFSize
	
	| r c ch maxC |
	r := 1.
	c := maxC := 1.
	[ stream atEnd ]
		whileFalse: 
			[ ch := stream next.
			ch isSeparator 
				ifTrue:[ ch asInteger = 10 
					ifTrue:
						[ r := r + 1.
						maxC := maxC max: c - 2.
						c := 0 ] ].
			c := c + 1 ].
	matrix := MatrixNxM new: r by: maxC.
	stream reset! !

!DominoTextFormatReader methodsFor: 'API' stamp: 'emm 03/09/2012 20:19'!
startPoint

	^where! !

!DominoTextFormatReader methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
where

	"Answer the value of where"

	^where! !

!DominoTextFormatReader methodsFor: 'accessing' stamp: 'emm 03/09/2012 20:19'!
where: aValue

	"Set the value of where"

	where := aValue! !

!GraphicsFileReader methodsFor: 'reading-strings' stamp: 'emm 02/09/2012 22:56'!
linesDo: aBlock 

	[ stream atEnd ]
		whileFalse: [ aBlock value: stream nextLine ].
	self close! !

!GraphicsFileReader methodsFor: 'reading-integers' stamp: 'emm 02/09/2012 22:56'!
nextByte

	^stream next! !

!GraphicsFileReader methodsFor: 'reading-floats' stamp: 'emm 02/09/2012 22:56'!
nextFloat
	"Only valid if written using nextPutFloat: 
	"
	| newFloat |
	newFloat := Float basicNew: 0.0 basicSize.
	1 to: newFloat basicSize do:[ :i | newFloat basicAt: i put: self readByte ].
	^newFloat! !

!GraphicsFileReader methodsFor: 'reading-integers' stamp: 'emm 02/09/2012 22:56'!
nextLSBLong
	"Answer the integer stored (least-significant-bit first) in the next four bytes of 
	the input stream."

	| word highByte |
	"Minimize LargeInteger arithmetic."
	word := stream next + (stream next bitShift: 8) + (stream next bitShift: 16).

	^(highByte := stream next) = 0
		ifTrue:	[word]
		ifFalse:	[(((highByte bitAnd: 16r7F) - (highByte bitAnd: 16r80)) bitShift: 24) + word]! !

!GraphicsFileReader methodsFor: 'reading-integers' stamp: 'emm 02/09/2012 22:56'!
nextLSBShort
	"Answer the integer stored (least-significant-bit first) in the next two bytes of 
	the input stream."

	| word |
	word := self nextLSBUnsignedShort.
	^(word bitAnd: 16r7FFF) - (word bitAnd: 16r8000)! !

!GraphicsFileReader methodsFor: 'reading-integers' stamp: 'emm 02/09/2012 22:56'!
nextLSBUnsignedLong
	"Answer the unsigned integer stored (least-significant-bit first) in the next four 
	bytes of the input stream."

	^stream next + (stream next bitShift: 8) + (stream next bitShift: 16) + (stream next bitShift: 24)! !

!GraphicsFileReader methodsFor: 'reading-integers' stamp: 'emm 02/09/2012 22:56'!
nextLSBUnsignedShort
	"Answer the unsigned integer stored (least-significant-bit first) in the next two 
	bytes of the input stream."

	^stream next + (stream next bitShift: 8)! !

!GraphicsFileReader methodsFor: 'reading-strings' stamp: 'emm 02/09/2012 22:56'!
nextLine

	^stream atEnd
		ifTrue: [ self error: 'no more lines available' ]
		ifFalse: [ stream nextLine ]! !

!GraphicsFileReader methodsFor: 'reading-strings' stamp: 'emm 02/09/2012 22:56'!
nonEmptyLinesDo: aBlock 

	self linesDo: [:each | 
		each isEmpty
			ifFalse: [ aBlock value: each ]]! !

!GraphicsFileReader methodsFor: 'reading-integers' stamp: 'emm 02/09/2012 22:56'!
readByte
	
	^stream next! !

!GraphicsFileReader methodsFor: 'reading-integers' stamp: 'emm 02/09/2012 22:56'!
readDWord
	"read 4 bytes"

	"^self nextLSBUnsignedLong"

	^self readLong
	! !

!GraphicsFileReader methodsFor: 'reading-numbers' stamp: 'emm 02/09/2012 22:56'!
readExtendedFloatFromString: aString 
	
	"self new readExtendedFloatFromString: '-3.3213e-002'
	"

	| dotIndex beforeDot eIndex betweenDotAndE afterSign number |
	dotIndex := aString indexOf: $. .
	beforeDot := ( aString copyFrom: 1 to: dotIndex - 1 ) asNumber.
	eIndex := aString indexOf: $e .
	betweenDotAndE := ( aString copyFrom: dotIndex + 1 to: eIndex - 1 ) asNumber.
	afterSign := ( aString copyFrom: eIndex + 2 to: aString size ) asNumber power: 10.
	(aString at: eIndex + 1) = $-
		ifTrue: [ afterSign := afterSign reciprocal ].
	[betweenDotAndE < 1]
		whileFalse:
			[betweenDotAndE := betweenDotAndE / 10.0].
	beforeDot < 0
		ifTrue: [ number := beforeDot - betweenDotAndE ]
		ifFalse: [ number := beforeDot + betweenDotAndE ].
	^number * afterSign! !

!GraphicsFileReader methodsFor: 'reading-floats' stamp: 'emm 02/09/2012 22:56'!
readFloat

	^self nextFloat! !

!GraphicsFileReader methodsFor: 'reading-floats' stamp: 'emm 02/09/2012 22:56'!
readFloat32

	"Read IEEE representation of a float"
	
	| b1 b2 b3 b4 exponent mantissa newFloat sign |
	b1 := stream next.
	b2 := stream next.
	b3 := stream next.
	b4 := stream next.
	
	sign := b4 bitAnd: 128.
	exponent := ( ( b4 bitAnd: 127 ) * 2 ) + ( ( b3 bitAnd: 128 ) bitShift: -7 ) + 896.
	mantissa := ( b1 + ( b2 bitShift: 8 ) + ( ( ( b3 bitAnd: 127 ) + 128 ) bitShift: 16 ) ) bitShift: 5. 
	
	newFloat := Float basicNew: 8.
	1 to: 3 by: 1 do: [ :i | newFloat basicAt: i put: 0 ].
	4 to: 6 by: 1 do: [ :i | 
		newFloat basicAt: i put: ( mantissa bitAnd: 255 ).
		mantissa := mantissa bitShift: -8 ].
	newFloat basicAt: 7 put: ( mantissa bitAnd: 15 ) + ( ( exponent bitAnd: 15 ) bitShift: 4 ).
	newFloat basicAt: 8 put: sign + ( exponent bitShift: -4 ).
	^newFloat! !

!GraphicsFileReader methodsFor: 'reading-integers' stamp: 'emm 02/09/2012 22:56'!
readInt16
	"little-endian"

	^self readInt8 + (self readInt8 bitShift: 8)! !

!GraphicsFileReader methodsFor: 'reading-integers' stamp: 'emm 02/09/2012 22:56'!
readInt32
	"little-endian"

	^self readInt16 + (self readInt16 bitShift:16)! !

!GraphicsFileReader methodsFor: 'reading-integers' stamp: 'emm 02/09/2012 22:56'!
readInt8
	
	^stream next! !

!GraphicsFileReader methodsFor: 'reading-integers' stamp: 'emm 02/09/2012 22:56'!
readLong

	^self isBigEndian
		ifFalse:[ self readShort + (self readShort bitShift:16) ]! !

!GraphicsFileReader methodsFor: 'reading-numbers' stamp: 'emm 02/09/2012 22:56'!
readNumber

	| numberStream |
	self skipSeparators.
	numberStream := WriteStream on: String new.
	[stream atEnd]
		whileFalse:
			[ stream peek isSeparator
				ifTrue:[ ^self readNumberFromString: numberStream contents ].
			numberStream nextPut: stream next].
	^ self readNumberFromString: numberStream contents
	! !

!GraphicsFileReader methodsFor: 'reading-numbers' stamp: 'emm 02/09/2012 22:56'!
readNumberFromString: aString 
	
	"self new readNumberFromString: '-3.3213'
	"
	
	| dotIndex integerPart fractionPart |
	^( dotIndex := aString indexOf: $. ) > 0
		ifTrue: 
			[ integerPart := ( aString copyFrom: 1 to: dotIndex - 1 ) asNumber.
			fractionPart := ( aString copyFrom: dotIndex + 1 to: aString size ) asNumber.
			[ fractionPart < 1 ]
				whileFalse: [ fractionPart := fractionPart / 10.0 ].
			integerPart < 0
				ifTrue: [ integerPart - fractionPart ]
				ifFalse: [ integerPart + fractionPart ]]
		ifFalse: 
			[ aString asNumber ]! !

!GraphicsFileReader methodsFor: 'reading-integers' stamp: 'emm 02/09/2012 22:56'!
readShort

	^self isBigEndian
		ifFalse:[ self readByte + (self readByte bitShift: 8) ].
	"^(word bitAnd: 16r7FFF) - (word bitAnd: 16r8000)"! !

!GraphicsFileReader methodsFor: 'reading-strings' stamp: 'emm 02/09/2012 22:56'!
readString: howManyChars

	^String fromBytes: ( stream next: howManyChars )! !

!GraphicsFileReader methodsFor: 'reading-strings' stamp: 'emm 02/09/2012 22:56'!
readToken

	self skipSeparators.
	^self readUpToSeparator! !

!GraphicsFileReader methodsFor: 'reading-strings' stamp: 'emm 02/09/2012 22:56'!
readUpToSeparator

	| outStream |
	outStream := WriteStream on: String new.
	[stream atEnd or:[stream peek isSeparator]]
		whileFalse:[ outStream nextPut: stream next].
	^outStream contents! !

!GraphicsFileReader methodsFor: 'reading-integers' stamp: 'emm 02/09/2012 22:56'!
readWord
	"read 2 bytes"

	^self nextLSBUnsignedShort
	! !

!GraphicsFileReader methodsFor: 'position-control' stamp: 'emm 02/09/2012 22:56'!
skip: howMany

	stream skip: howMany! !

!GraphicsFileReader methodsFor: 'position-control' stamp: 'emm 02/09/2012 22:56'!
skipLinesStartingWith: aString 

	| skipped lineStart nextLine |
	skipped := false.
	[ stream atEnd or: [ skipped ] ]
		whileFalse: 
			[ lineStart := stream position.
			nextLine := stream nextLine.
			skipped := (nextLine size >= aString size and:[ (nextLine copyFrom: 1 to: aString size) = aString]) not ].
	skipped
		ifTrue: [ stream position: lineStart ]! !

!GraphicsFileReader methodsFor: 'position-control' stamp: 'emm 02/09/2012 22:56'!
skipSeparators

	[stream atEnd or:[stream peek isSeparator not ]]
		whileFalse:[stream next]! !

GraphicsFileReader subclass: #GraphicsFormatReaderWithStack
	instanceVariableNames: 'stack'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-FileIO'!

GraphicsFormatReaderWithStack subclass: #DirectXFileReader
	instanceVariableNames: ''
	classVariableNames: 'Tokens'
	poolDictionaries: ''
	category: 'Zenna-FormatDirectX'!

!DirectXFileReader class methodsFor: 'class-initialization' stamp: 'emm 02/09/2012 23:26'!
compileTokenReaders
	"Note: VisualAge-specific"
	"self compileTokenReaders"

	| inStream |
	inStream  := self tokenEntries readStream.
	[inStream atEnd]
		whileFalse:
			[ | token id |
			token := inStream next.
			id := inStream next.
			self 
				compile: ( 'read%1
	"%2"' bindWith: token with: id printString )
				notifying: nil
				ifNewAddTo: self applications first
				categorizeIn: #( 'reading-tokens' ) ]! !

!DirectXFileReader class methodsFor: 'examples' stamp: 'emm 02/09/2012 23:26'!
exampleCubeMesh
	"self exampleCubeMesh"

	| r |
	r := self on: 'directx\CubeMesh.x' asFilename readStream.
	r readHeader.
	r readContents.
	r close.
	^r! !

!DirectXFileReader class methodsFor: 'examples' stamp: 'emm 02/09/2012 23:26'!
exampleSphereMesh
	"self exampleSphereMesh"

	| r |
	r := self on: 'directx\SphereMesh.x' asFilename readStream.
	r readHeader.
	33 timesRepeat:[ r dispatchNextToken ].
	r close.
	^r! !

!DirectXFileReader class methodsFor: 'class-initialization' stamp: 'emm 02/09/2012 23:26'!
initialize
	
	self initializeTokens! !

!DirectXFileReader class methodsFor: 'class-initialization' stamp: 'emm 02/09/2012 23:26'!
initializeTokens

	| inStream |
	Tokens := Array new: 256.
	inStream  := self tokenEntries readStream.
	[inStream atEnd]
		whileFalse:
			[ | token id |
			token := inStream next.
			id := inStream next.
			Tokens at: id put: ('read' , token ) asSymbol ]! !

!DirectXFileReader class methodsFor: 'class-initialization' stamp: 'emm 02/09/2012 23:26'!
tokenEntries
	
	"From DirectX-SDK"

		^#( TOKEN_NAME 1
	   TOKEN_STRING 2
	   TOKEN_INTEGER 3
	   TOKEN_GUID 5
	   TOKEN_INTEGER_LIST 6
	   TOKEN_REALNUM_LIST 7
	   TOKEN_OBRACE 10
	   TOKEN_CBRACE 11
	   TOKEN_OPAREN 12
	   TOKEN_CPAREN 13
	   TOKEN_OBRACKET 14
	   TOKEN_CBRACKET 15
	   TOKEN_OANGLE 16
	   TOKEN_CANGLE 17
	   TOKEN_DOT 18
	   TOKEN_COMMA 19
	   TOKEN_SEMICOLON 20
	   TOKEN_TEMPLATE 31
	   TOKEN_WORD 40
	   TOKEN_DWORD 41
	   TOKEN_FLOAT 42
	   TOKEN_DOUBLE 43
	   TOKEN_CHAR 44
	   TOKEN_UCHAR 45
	   TOKEN_SWORD 46
	   TOKEN_SDWORD 47
	   TOKEN_VOID 48
	   TOKEN_LPSTR 49
	   TOKEN_UNICODE 50
	   TOKEN_CSTRING 51
	   TOKEN_ARRAY 52 )! !

!DirectXFileReader methodsFor: 'reading' stamp: 'emm 02/09/2012 23:26'!
dispatchNextToken

	| tokenID selector |
	tokenID := self readWord.
	(( tokenID < 1 
		or:[ tokenID > 255 ] )
		or: [ ( selector := Tokens at: tokenID ) isNil ] )
			ifTrue:[ self error: 'unknown token id:' , tokenID printString ]
		ifFalse:
			[ Transcript cr 
				;nextPutAll: tokenID printString
				;nextPut: $=
				;nextPutAll: selector 
				;nextPut: $@ 
				;nextPutAll: stream position printString. 
			self push: ( self perform: selector ) ]! !

!DirectXFileReader methodsFor: 'testing' stamp: 'emm 02/09/2012 23:26'!
isBinary

	^true! !

!DirectXFileReader methodsFor: 'reading' stamp: 'emm 02/09/2012 23:26'!
readContents

	[stream atEnd]
		whileFalse:[ self dispatchNextToken ]! !

!DirectXFileReader methodsFor: 'overriding' stamp: 'emm 02/09/2012 23:26'!
readFloat
	"Read a float based on the size specified in the header"

	"For now assume 32"

	^self readFloat32! !

!DirectXFileReader methodsFor: 'reading' stamp: 'emm 02/09/2012 23:26'!
readHeader

	| magic major minor formatType compressionType floatSize |
	magic := self readString: 4.
	major := (self readString: 2) asNumber.
	minor := (self readString: 2) asNumber.
	formatType := self readString: 4.
	formatType = 'com '
		ifTrue:[ compressionType := self readString: 4 ].
	floatSize := (self readString: 4) asNumber.! !

!DirectXFileReader methodsFor: 'reading' stamp: 'emm 02/09/2012 23:26'!
readMagic

	self assert: [ (self readString: 4) = 'xof ' ]! !

!DirectXFileReader methodsFor: 'reading-tokens' stamp: 'emm 02/09/2012 23:26'!
readTOKEN_ARRAY
	"52"! !

!DirectXFileReader methodsFor: 'reading-tokens' stamp: 'emm 02/09/2012 23:26'!
readTOKEN_CANGLE
	"17"! !

!DirectXFileReader methodsFor: 'reading-tokens' stamp: 'emm 02/09/2012 23:26'!
readTOKEN_CBRACE
	"11"

	^$)! !

!DirectXFileReader methodsFor: 'reading-tokens' stamp: 'emm 02/09/2012 23:26'!
readTOKEN_CBRACKET
	"15"! !

!DirectXFileReader methodsFor: 'reading-tokens' stamp: 'emm 02/09/2012 23:26'!
readTOKEN_CHAR
	"44"! !

!DirectXFileReader methodsFor: 'reading-tokens' stamp: 'emm 02/09/2012 23:26'!
readTOKEN_COMMA
	"19"! !

!DirectXFileReader methodsFor: 'reading-tokens' stamp: 'emm 02/09/2012 23:26'!
readTOKEN_CPAREN
	"13"! !

!DirectXFileReader methodsFor: 'reading-tokens' stamp: 'emm 02/09/2012 23:26'!
readTOKEN_CSTRING
	"51"! !

!DirectXFileReader methodsFor: 'reading-tokens' stamp: 'emm 02/09/2012 23:26'!
readTOKEN_DOT
	"18"! !

!DirectXFileReader methodsFor: 'reading-tokens' stamp: 'emm 02/09/2012 23:26'!
readTOKEN_DOUBLE
	"43"! !

!DirectXFileReader methodsFor: 'reading-tokens' stamp: 'emm 02/09/2012 23:26'!
readTOKEN_DWORD
	"41"! !

!DirectXFileReader methodsFor: 'reading-tokens' stamp: 'emm 02/09/2012 23:26'!
readTOKEN_FLOAT
	"42"! !

!DirectXFileReader methodsFor: 'reading-tokens' stamp: 'emm 02/09/2012 23:26'!
readTOKEN_GUID
	"5"! !

!DirectXFileReader methodsFor: 'reading-tokens' stamp: 'emm 02/09/2012 23:26'!
readTOKEN_INTEGER
	"3"

	^self readDWord! !

!DirectXFileReader methodsFor: 'reading-tokens' stamp: 'emm 02/09/2012 23:26'!
readTOKEN_INTEGER_LIST
	"6"

	^(1 to: self readDWord ) collect:[ :i | self readDWord ]! !

!DirectXFileReader methodsFor: 'reading-tokens' stamp: 'emm 02/09/2012 23:26'!
readTOKEN_LPSTR
	"49"! !

!DirectXFileReader methodsFor: 'reading-tokens' stamp: 'emm 02/09/2012 23:26'!
readTOKEN_NAME
	"1"

	| name |
	^name := self readString: self readDWord.! !

!DirectXFileReader methodsFor: 'reading-tokens' stamp: 'emm 02/09/2012 23:26'!
readTOKEN_OANGLE
	"16"! !

!DirectXFileReader methodsFor: 'reading-tokens' stamp: 'emm 02/09/2012 23:26'!
readTOKEN_OBRACE
	"10"

	^$(! !

!DirectXFileReader methodsFor: 'reading-tokens' stamp: 'emm 02/09/2012 23:26'!
readTOKEN_OBRACKET
	"14"! !

!DirectXFileReader methodsFor: 'reading-tokens' stamp: 'emm 02/09/2012 23:26'!
readTOKEN_OPAREN
	"12"! !

!DirectXFileReader methodsFor: 'reading-tokens' stamp: 'emm 02/09/2012 23:26'!
readTOKEN_REALNUM_LIST
	"7"

	^(1 to: self readDWord ) collect:[ :i | self readFloat ]! !

!DirectXFileReader methodsFor: 'reading-tokens' stamp: 'emm 02/09/2012 23:26'!
readTOKEN_SDWORD
	"47"! !

!DirectXFileReader methodsFor: 'reading-tokens' stamp: 'emm 02/09/2012 23:26'!
readTOKEN_SEMICOLON
	"20"! !

!DirectXFileReader methodsFor: 'reading-tokens' stamp: 'emm 02/09/2012 23:26'!
readTOKEN_STRING
	"2"! !

!DirectXFileReader methodsFor: 'reading-tokens' stamp: 'emm 02/09/2012 23:26'!
readTOKEN_SWORD
	"46"! !

!DirectXFileReader methodsFor: 'reading-tokens' stamp: 'emm 02/09/2012 23:26'!
readTOKEN_TEMPLATE
	"31"! !

!DirectXFileReader methodsFor: 'reading-tokens' stamp: 'emm 02/09/2012 23:26'!
readTOKEN_UCHAR
	"45"! !

!DirectXFileReader methodsFor: 'reading-tokens' stamp: 'emm 02/09/2012 23:26'!
readTOKEN_UNICODE
	"50"! !

!DirectXFileReader methodsFor: 'reading-tokens' stamp: 'emm 02/09/2012 23:26'!
readTOKEN_VOID
	"48"! !

!DirectXFileReader methodsFor: 'reading-tokens' stamp: 'emm 02/09/2012 23:26'!
readTOKEN_WORD
	"40"! !

!DirectXFileReader methodsFor: 'reading-templates' stamp: 'emm 02/09/2012 23:26'!
readTemplateCoords2d

	^Point
		x: self readFloat
		y: self readFloat! !

!DirectXFileReader methodsFor: 'reading-templates' stamp: 'emm 02/09/2012 23:26'!
readTemplateHeader

	| major minor flags |
	major := self readWord.
	minor := self readWord.
	flags := self readDWord.! !

!DirectXFileReader methodsFor: 'reading-templates' stamp: 'emm 02/09/2012 23:26'!
readTemplateVector

	^Point3D
		x: self readFloat
		y: self readFloat
		z: self readFloat! !

!GraphicsFormatReaderWithStack class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 22:56'!
new

	"Answer a new instance of the receiver and initialize it"

	^super new initialize! !

!GraphicsFormatReaderWithStack methodsFor: 'initialize' stamp: 'emm 02/09/2012 22:56'!
initialize

	super initialize.
	stack := OrderedCollection new! !

!GraphicsFormatReaderWithStack methodsFor: 'stack-accessing' stamp: 'emm 02/09/2012 22:56'!
pop
	
	^stack removeLast! !

!GraphicsFormatReaderWithStack methodsFor: 'stack-accessing' stamp: 'emm 02/09/2012 22:56'!
push: anObject
	stack add: anObject! !

!GraphicsFormatReaderWithStack methodsFor: 'stack-accessing' stamp: 'emm 02/09/2012 22:56'!
top
	
	^stack last! !

GraphicsFormatReaderWithStack subclass: #LSParser
	instanceVariableNames: 'builder random'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Lindenmayer'!

!LSParser class methodsFor: 'instance-creation' stamp: 'emm 03/09/2012 22:05'!
new

	"Answer a new instance of the receiver and initialize it"

	^super new initialize! !

!LSParser methodsFor: 'commands-special' stamp: 'emm 03/09/2012 22:05'!
applyGravityCorrection! !

!LSParser methodsFor: 'testing' stamp: 'emm 03/09/2012 22:05'!
assert: aBlock 

	aBlock value
		ifFalse: [ self error: 'assertion failed' ]! !

!LSParser methodsFor: 'accessing' stamp: 'emm 03/09/2012 22:05'!
builder

	"Answer the value of builder"

	^builder! !

!LSParser methodsFor: 'accessing' stamp: 'emm 03/09/2012 22:05'!
builder: aValue

	"Set the value of builder"

	builder := aValue! !

!LSParser methodsFor: 'accessing' stamp: 'emm 03/09/2012 22:05'!
currentState

	^stack last! !

!LSParser methodsFor: 'commands-inc-dec' stamp: 'emm 03/09/2012 22:05'!
decrementAngle

	self currentState scaleAngleBy: ( self readArgumentIfMissing: [ 0.9 ] )! !

!LSParser methodsFor: 'commands-inc-dec' stamp: 'emm 03/09/2012 22:05'!
decrementLength

	self currentState scaleLengthBy: ( self readArgumentIfMissing: [ 0.9 ] )! !

!LSParser methodsFor: 'commands-inc-dec' stamp: 'emm 03/09/2012 22:05'!
decrementThickness

	self currentState scaleThicknessBy: ( self readArgumentIfMissing: [ 0.7 ] )! !

!LSParser methodsFor: 'parsing' stamp: 'emm 03/09/2012 22:05'!
dispatchToken: aChar

	"turtle"
	aChar == $+	ifTrue: [ ^self turnLeftAroundUp ].
	aChar == $-	ifTrue: [ ^self turnRightAroundUp ].
	aChar == $& ifTrue: [ ^self pitchDownAroundUp ].
	aChar == $^ ifTrue: [ ^self pitchUpAroundUp ].
	aChar == $<	ifTrue: [ ^self rollLeftAroundForward ].
	aChar == $>	ifTrue: [ ^self rollRightAroundForward ].

	"special"
	aChar == $|	ifTrue: [ ^self turnRightAroundUpBy: 180 ].	
	aChar == $% ifTrue: [ ^self rollRightAroundForwardBy: 180 ].	
	aChar == $$ ifTrue: [ ^self missing: $$ ].	
	aChar == $~ ifTrue: [ ^self turnRandom ].	
	aChar == $t ifTrue: [ ^self applyGravityCorrection ].	

	"movement"
	aChar == $F ifTrue: [ ^self moveDrawForwardFull ].
	aChar == $Z ifTrue: [ ^self moveDrawForwardHalf ].
	aChar == $f ifTrue: [ ^self moveForwardFull ].
	aChar == $z ifTrue: [ ^self moveForwardHalf ].
	aChar == $g ifTrue: [ ^self moveForwardFullNoRecord ].
	aChar == $. ifTrue: [ ^self recordVertex ].

	"strucuture"
	aChar == $] ifTrue: [ ^self popCurrentState ].
	aChar == $[ ifTrue: [ ^self pushCurrentState ].
	aChar == $} ifTrue: [ ^self stopPolygonShape ].
	aChar == ${ ifTrue: [ ^self startPolygonShape ].

	"inc/dec"
	aChar == $" ifTrue: [ ^self incrementLength].
	aChar == $' ifTrue: [ ^self decrementLength ].
	aChar == $; ifTrue: [ ^self incrementAngle ].
	aChar == $: ifTrue: [ ^self decrementAngle ].
	aChar == $? ifTrue: [ ^self incrementThickness ].
	aChar == $!! ifTrue: [ ^self decrementThickness ].

	"additional"
	aChar == $c ifTrue: [ ^self incrementColorIndex ].
	aChar == $@ ifTrue: [ ^self ].

	"error handling"	
	self error: 'unkown token: ' , ( String with: aChar )! !

!LSParser methodsFor: 'commands-inc-dec' stamp: 'emm 03/09/2012 22:05'!
incrementAngle

	self currentState scaleAngleBy: ( self readArgumentIfMissing: [ 1.1 ] )! !

!LSParser methodsFor: 'commands-additional' stamp: 'emm 03/09/2012 22:05'!
incrementColorIndex

	self currentState colorIndex: ( self readArgumentIfMissing: [ self currentState colorIndex + 1 ])! !

!LSParser methodsFor: 'commands-inc-dec' stamp: 'emm 03/09/2012 22:05'!
incrementLength

	self currentState scaleLengthBy: ( self readArgumentIfMissing: [ 1.1 ] )! !

!LSParser methodsFor: 'commands-inc-dec' stamp: 'emm 03/09/2012 22:05'!
incrementThickness

	self currentState scaleThicknessBy: ( self readArgumentIfMissing: [ 1.4 ] )! !

!LSParser methodsFor: 'initialize-release' stamp: 'emm 03/09/2012 22:05'!
initialize

	super initialize.
	self random: Random new! !

!LSParser methodsFor: 'initialize-release' stamp: 'emm 03/09/2012 22:05'!
initializeFromSystem: aLSSystem geometric: aGeometric builder: aBuilder

	self push: ( LSContext new
		thickness: aLSSystem thickness
		; angle: aLSSystem angle
		; colorIndex: 1
		; geometric: aGeometric).
	self builder: aBuilder! !

!LSParser methodsFor: 'parsing' stamp: 'emm 03/09/2012 22:05'!
missing: aChar

	aChar echo: ' needs implementation in LSParser'.
	self readArgumentIfMissing: []! !

!LSParser methodsFor: 'commands-movement' stamp: 'emm 03/09/2012 22:05'!
moveDrawForwardFull

	"F | F(x)"
	
	self 
		moveForwardBy: ( self readArgumentIfMissing: [ 0 ] ) 
		mustDraw: true! !

!LSParser methodsFor: 'commands-movement' stamp: 'emm 03/09/2012 22:05'!
moveDrawForwardHalf
	"F | F(x)"
	
	self currentState scaleLengthBy: 0.5.
	self 
		moveForwardBy: ( self readArgumentIfMissing: [ 0 ] ) 
		mustDraw: true.
	self currentState scaleLengthBy: 2.! !

!LSParser methodsFor: 'commands-movement' stamp: 'emm 03/09/2012 22:05'!
moveForwardBy: amount mustDraw: mustDraw
	
	| translation rotation scale |
	translation := self currentState position.
	rotation := self currentState rotation.
	scale := self currentState scale.
	mustDraw 
		ifTrue: [ self builder add: ( ( ( self currentState geometric 
			wrapScaleBy: scale)
			wrapRotateBy: rotation )
			wrapTranslateBy: translation ) ].
	self currentState position: translation + ( self currentState vector rotatedBy: rotation )! !

!LSParser methodsFor: 'commands-movement' stamp: 'emm 03/09/2012 22:05'!
moveForwardFull

	"F | F(x)"
	
	self 
		moveForwardBy: ( self readArgumentIfMissing: [ 0 ] ) 
		mustDraw: false! !

!LSParser methodsFor: 'commands-movement' stamp: 'emm 03/09/2012 22:05'!
moveForwardFullNoRecord

	"F | F(x)"
	
	self 
		moveForwardBy: ( self readArgumentIfMissing: [ 0 ] ) 
		mustDraw: false! !

!LSParser methodsFor: 'commands-movement' stamp: 'emm 03/09/2012 22:05'!
moveForwardHalf
	"F | F(x)"
	
	self currentState scaleLengthBy: 0.5.
	self 
		moveForwardBy: ( self readArgumentIfMissing: [ 0 ] ) 
		mustDraw: false.
	self currentState scaleLengthBy: 2.! !

!LSParser methodsFor: 'parsing' stamp: 'emm 03/09/2012 22:05'!
parse: aString 
	
	self parseStream: ( ReadStream on: aString )! !

!LSParser methodsFor: 'parsing' stamp: 'emm 03/09/2012 22:05'!
parseStream: aStream
	
	stream := aStream.
	[ stream atEnd ]
		whileFalse: [ self dispatchToken: stream next ]! !

!LSParser methodsFor: 'commands-turtle' stamp: 'emm 03/09/2012 22:05'!
pitchDownAroundUp
	
	"& :Turn using the current angle or the angle read between parenthesis"
	
	self pitchDownAroundUpBy: ( self readArgumentIfMissing: [ self currentState angle ] )! !

!LSParser methodsFor: 'commands-turtle' stamp: 'emm 03/09/2012 22:05'!
pitchDownAroundUpBy: degrees

	self currentState rotation: self currentState rotation +  (0 , degrees rad , 0)! !

!LSParser methodsFor: 'commands-turtle' stamp: 'emm 03/09/2012 22:05'!
pitchUpAroundUp
	
	"^ :Turn using the current angle or the angle read between parenthesis"
	
	self pitchUpAroundUpBy: ( self readArgumentIfMissing: [ self currentState angle ] )! !

!LSParser methodsFor: 'commands-turtle' stamp: 'emm 03/09/2012 22:05'!
pitchUpAroundUpBy: degrees

	self currentState rotation: self currentState rotation +  (0 , degrees rad negated, 0)! !

!LSParser methodsFor: 'commands-structure' stamp: 'emm 03/09/2012 22:05'!
popCurrentState

	self pop! !

!LSParser methodsFor: 'commands-structure' stamp: 'emm 03/09/2012 22:05'!
pushCurrentState

	self push: self currentState copy! !

!LSParser methodsFor: 'accessing' stamp: 'emm 03/09/2012 22:05'!
random

	"Answer the value of random"

	^random! !

!LSParser methodsFor: 'accessing' stamp: 'emm 03/09/2012 22:05'!
random: aValue

	"Set the value of random"

	random := aValue! !

!LSParser methodsFor: 'parsing' stamp: 'emm 03/09/2012 22:05'!
readArgumentIfMissing: aBlock

	^( stream peekFor: $( )
		ifTrue: [ self readNumberFromString: ( stream upTo: $)  )]
		ifFalse: [ aBlock value ]
	! !

!LSParser methodsFor: 'commands-movement' stamp: 'emm 03/09/2012 22:05'!
recordVertex! !

!LSParser methodsFor: 'commands-turtle' stamp: 'emm 03/09/2012 22:05'!
rollLeftAroundForward
	
	"< :Turn using the current angle or the angle read between parenthesis"
	
	self rollLeftAroundForwardBy: ( self readArgumentIfMissing: [ self currentState angle ] )! !

!LSParser methodsFor: 'commands-turtle' stamp: 'emm 03/09/2012 22:05'!
rollLeftAroundForwardBy: degrees

	self currentState rotation: self currentState rotation +  (0,0,degrees rad negated)! !

!LSParser methodsFor: 'commands-turtle' stamp: 'emm 03/09/2012 22:05'!
rollRightAroundForward
	
	"> :Turn using the current angle or the angle read between parenthesis"
	
	self rollRightAroundForwardBy: ( self readArgumentIfMissing: [ self currentState angle ] )! !

!LSParser methodsFor: 'commands-turtle' stamp: 'emm 03/09/2012 22:05'!
rollRightAroundForwardBy: degrees

	self currentState rotation: self currentState rotation +  (0,0,degrees rad )! !

!LSParser methodsFor: 'commands-structure' stamp: 'emm 03/09/2012 22:05'!
startPolygonShape! !

!LSParser methodsFor: 'commands-structure' stamp: 'emm 03/09/2012 22:05'!
stopPolygonShape! !

!LSParser methodsFor: 'commands-turtle' stamp: 'emm 03/09/2012 22:05'!
turnLeftAroundUp
	
	"+ :Turn using the current angle or the angle read between parenthesis"
	
	self turnLeftAroundUpBy: ( self readArgumentIfMissing: [ self currentState angle ] )! !

!LSParser methodsFor: 'commands-turtle' stamp: 'emm 03/09/2012 22:05'!
turnLeftAroundUpBy: degrees

	self currentState rotation: self currentState rotation +  (degrees rad negated, 0 , 0)! !

!LSParser methodsFor: 'commands-special' stamp: 'emm 03/09/2012 22:05'!
turnRandom

	| maxDegrees xr yr zr |
	maxDegrees := self readArgumentIfMissing: [360].
	xr := self random next * maxDegrees.
	yr := self random next * maxDegrees.
	zr := self random next * maxDegrees.
	self currentState rotation: ( self currentState rotation +  ( xr, yr, zr ) deg )! !

!LSParser methodsFor: 'commands-turtle' stamp: 'emm 03/09/2012 22:05'!
turnRightAroundUp
	
	"- :Turn using the current angle or the angle read between parenthesis"
	
	self turnRightAroundUpBy: ( self readArgumentIfMissing: [ self currentState angle ] )! !

!LSParser methodsFor: 'commands-turtle' stamp: 'emm 03/09/2012 22:05'!
turnRightAroundUpBy: degrees

	self currentState rotation: self currentState rotation +  (degrees rad , 0 , 0)! !

GraphicsFileReader subclass: #LSReader
	instanceVariableNames: 'system'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Lindenmayer'!

!LSReader methodsFor: 'initialize-release' stamp: 'emm 03/09/2012 22:05'!
initialize

	super initialize.
	system := LindenmayerSystem new! !

!LSReader methodsFor: 'reading' stamp: 'emm 03/09/2012 22:05'!
parseLine: aLine 
	
	aLine first == $# 
		ifTrue: [ ^self ].
	aLine first == $@ 
		ifTrue: [ ^self ].
	self system addRule: aLine! !

!LSReader methodsFor: 'reading' stamp: 'emm 03/09/2012 22:05'!
readAxiomAndRules

	self skipLinesStartingWith: '#'.
	self system axiom: self nextLine.
	self nonEmptyLinesDo: [:each | 
		self parseLine: each].! !

!LSReader methodsFor: 'reading' stamp: 'emm 03/09/2012 22:05'!
readSystem

	self skipLinesStartingWith: '#'.
	self system recursionDepth: ( self readNumberFromString: self nextLine ).
	self skipLinesStartingWith: '#'.
	self system angle: ( self readNumberFromString: self nextLine ).
	self skipLinesStartingWith: '#'.
	self system thickness: ( self readNumberFromString: self nextLine ).
	self readAxiomAndRules.
	^system! !

!LSReader methodsFor: 'accessing' stamp: 'emm 03/09/2012 22:05'!
system

	^system! !

!LSReader methodsFor: 'accessing' stamp: 'emm 03/09/2012 22:05'!
system: aSystem

	system := aSystem! !

GraphicsFileAccessor subclass: #GraphicsFileWriter
	instanceVariableNames: 'level useIndentation statistics'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-FileIO'!

GraphicsFileWriter subclass: #DirectXFileWriter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-FormatDirectX'!

!DirectXFileWriter class methodsFor: 'properties' stamp: 'emm 02/09/2012 23:26'!
fileExtension

	^'.x'! !

!DirectXFileWriter methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:26'!
doColor: aColor 
	
	"Components of @aColor are in range [0..65535] 
	and should be converted to the range [0..1]"
	
	aColor red01 printOn: stream.
	stream nextPut: $;.
	aColor green01 printOn: stream.
	stream nextPut: $;.
	aColor blue01 printOn: stream.! !

!DirectXFileWriter methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:26'!
doD3DMesh: aMesh
	
	| meshData |
	meshData := MeshData new initializeFromFaces: aMesh faces.
	self writeMaterialDefinitionsFor: aMesh.
	stream 
		nextPutAll: 'Mesh '
		; nextPutAll: ' {' ; cr.
	stream
		print: meshData vertices size
		; nextPut: $;.
	meshData vertices do:[ :each |
		stream cr.
		self write: each.
		stream nextPut: $, ].
	stream skip: -1 ;nextPut: $; ;cr.
	stream print: meshData faces size ; nextPut: $;.
	1 to: meshData faces size do:[ :i |
		| faceVertices |
		faceVertices := meshData verticesPerFace at: i.
		stream cr
			; print: faceVertices size
			; nextPut: $;.
		faceVertices do:[ :vertexIndex |
			stream print: vertexIndex - 1.		"numbering is zero-based"
			stream nextPut: $, ].
		stream skip: -1.
		stream nextPut: $; ;nextPut: $, ].
	stream skip: -1 ;nextPut: $; ; cr.
	self writeMeshMaterialListFor: aMesh.
	self writeMeshNormalsWithData: meshData.
	self writeMeshTextureCoordsFor: aMesh vertices: meshData vertices.
	stream nextPut: $}
		
		



		! !

!DirectXFileWriter methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:26'!
doD3DMeshMaterial: aMaterial

	stream nextPutAll: 'Material '.
	aMaterial name isNil
		ifFalse: [ stream nextPutAll: aMaterial name ].
	stream nextPutAll:' {' ;cr.
	self write: aMaterial faceColor.
	stream nextPut: $;.
	aMaterial faceColor alpha printOn: stream.
	stream nextPutAll:';;'  ;cr.
	aMaterial power printOn: stream.
	stream nextPut: $; ;cr.
	self write: aMaterial specularColor.
	stream nextPutAll:';;'  ;cr.
	self write: aMaterial emissiveColor.
	stream nextPutAll:';;'  ;cr.
	aMaterial textureFilename isNil
		ifFalse: 
			[ stream 
				nextPutAll: 'TextureFilename {'
				; cr ;nextPut: $" ;nextPutAll: aMaterial textureFilename ;nextPutAll: '";'
				; cr ; nextPut: $} ;cr ].
	stream nextPut: $} ;cr! !

!DirectXFileWriter methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:26'!
doPoint3D: aPoint3D

	"The D3DViewer has
		positive x -> right
		positive y -> up
		positive z -> into screen
"
	stream print: aPoint3D y asFloat.
	stream nextPut: $;.
	stream print: aPoint3D z asFloat.
	stream nextPut: $;.
	stream print: aPoint3D x negated asFloat.
	stream nextPut: $;.

"	stream print: aPoint3D x asFloat.
	stream nextPut: $;.
	stream print: aPoint3D y asFloat.
	stream nextPut: $;.
	stream print: aPoint3D z asFloat.
	stream nextPut: $;.
"! !

!DirectXFileWriter methodsFor: 'writing-overriding' stamp: 'emm 02/09/2012 23:26'!
writeComment: aString

	stream nextPutAll:  '// ' ;nextPutAll: aString! !

!DirectXFileWriter methodsFor: 'writing' stamp: 'emm 02/09/2012 23:26'!
writeHeaderForText

	stream nextPutAll: 'xof 0302txt 0032' ;cr
! !

!DirectXFileWriter methodsFor: 'writing' stamp: 'emm 02/09/2012 23:26'!
writeHeaderTemplate

	stream nextPutAll: 'Header {
 1;
 0;
 1;
}' ;cr ;cr! !

!DirectXFileWriter methodsFor: 'writing' stamp: 'emm 02/09/2012 23:26'!
writeMaterialDefinitionsFor: aMesh

	aMesh materials asSet do:[ :each | self write: each ]! !

!DirectXFileWriter methodsFor: 'writing' stamp: 'emm 02/09/2012 23:26'!
writeMeshMaterialListFor: aMesh

	| materials index |
	stream nextPutAll: 'MeshMaterialList {' ;cr.
	materials := aMesh materials asSet asArray.
	stream
		print: materials size
		; nextPut: $; ;cr
		; print: aMesh faces size	"there exists a material for each face"
		; nextPut: $;.
	aMesh materials do:[ :each |
		stream cr ;print: ( materials indexOf: each ) - 1 ;nextPut: $,].
	stream skip: -1 ;nextPut: $; ;cr.
	materials do:[ :each | 
		each name isNil
			ifTrue: [ self write: each ]
			ifFalse: [ stream nextPutAll: '{ ' ;nextPutAll: each name; nextPutAll: ' }' ;cr] ].
	stream nextPut: $} ;cr
		
		
	! !

!DirectXFileWriter methodsFor: 'writing' stamp: 'emm 02/09/2012 23:26'!
writeMeshNormalsWithData: aData
	
	"Compute normals for each vertex in @Data and list these normals per face"
	
	| normals |
	stream nextPutAll: 'MeshNormals {' ;cr.
	normals := aData vertexNormals.
	stream print: normals size ;nextPut: $;.
	normals do:[ :each |
		stream cr.
		self write: each.
		stream nextPut: $, ].
	stream skip: -1 ; nextPut: $; ;cr.
	stream print: aData faces size ;nextPut: $;.
	aData verticesPerFace do:[ :each |
		stream cr.
		stream print: each size ;nextPut: $;.
		each do:[ :vertexIndex | 
				stream 
					print: vertexIndex - 1			"numbering is zero-based"
					 ;nextPut: $, ].
		stream skip: -1 ;nextPut: $; ;nextPut: $, ].
	stream skip: -1 ; nextPut: $; ;cr.
	stream nextPut: $} ;cr! !

!DirectXFileWriter methodsFor: 'writing' stamp: 'emm 02/09/2012 23:26'!
writeMeshTextureCoordsFor: aMesh vertices: vertices

	aMesh hasTexture
		ifFalse: [ ^self ].
	stream nextPutAll: 'MeshTextureCoords {' ;cr.
	stream print: vertices size ; nextPut: $;.
	vertices size timesRepeat:[
		stream cr ;print: 0.0 ;nextPut: $; ;print: 1.0 ;nextPut: $; ].
	stream nextPut: $; ;cr.
	stream nextPut: $} ;cr! !

!DirectXFileWriter methodsFor: 'writing-overriding' stamp: 'emm 02/09/2012 23:26'!
writeSignature

	self writeHeaderForText.
	super writeSignature.
	self writeHeaderTemplate.! !

!GraphicsFileWriter methodsFor: 'convenience' stamp: 'emm 02/09/2012 22:56'!
backCr

	self backIndent.
	stream cr.
	self useIndentation
		ifTrue:[ level timesRepeat:[ stream tab ] ]! !

!GraphicsFileWriter methodsFor: 'convenience' stamp: 'emm 02/09/2012 22:56'!
backIndent

	level := level - 1.! !

!GraphicsFileWriter methodsFor: 'accessing' stamp: 'emm 02/09/2012 22:56'!
byteAt: byteIndex put: aByte
	
	| old |
	old := stream position.
	stream position: byteIndex.
	stream nextPut: aByte.
	stream position: old! !

!GraphicsFileWriter methodsFor: 'convenience' stamp: 'emm 02/09/2012 22:56'!
cr

	stream cr.
	self useIndentation
		ifTrue:[ level timesRepeat:[ stream tab ] ]! !

!GraphicsFileWriter methodsFor: 'convenience' stamp: 'emm 02/09/2012 22:56'!
crIndent

	self cr ;indent! !

!GraphicsFileWriter methodsFor: '*Zenna-SceneBuilding3D' stamp: 'emm 02/09/2012 23:27'!
doAutoRotationWrapper: aWrapper
	
	aWrapper component kindDo: self! !

!GraphicsFileWriter methodsFor: 'dispatching' stamp: 'emm 02/09/2012 22:56'!
doBlock: aBlock

	"Evaluate @aBlock and dispatch to its result"

	^ aBlock value kindDo: self! !

!GraphicsFileWriter methodsFor: 'dispatching' stamp: 'emm 02/09/2012 22:56'!
doBoolean: aBoolean

	aBoolean
		ifTrue: [ stream nextPutAll: 'TRUE' ]
		ifFalse: [  stream nextPutAll: 'FALSE'  ]! !

!GraphicsFileWriter methodsFor: 'dispatching' stamp: 'emm 02/09/2012 22:56'!
doCharacter: aChar

	stream nextPut: aChar! !

!GraphicsFileWriter methodsFor: 'dispatching ( INumberVisitor )' stamp: 'emm 02/09/2012 22:56'!
doFloat: aFloat

	"Default: aFloat printOn: stream.
	Use local defined optimized version"

	self printFloat: aFloat on: stream! !

!GraphicsFileWriter methodsFor: 'dispatching ( INumberVisitor )' stamp: 'emm 02/09/2012 22:56'!
doFraction: aFraction
	self doFloat: aFraction asFloat! !

!GraphicsFileWriter methodsFor: 'dispatching-wrappers' stamp: 'emm 02/09/2012 22:56'!
doGeometric3DWrapper: aWrapper 

	aWrapper solidsDo: [:each | 
		each kindDo: self]! !

!GraphicsFileWriter methodsFor: 'dispatching' stamp: 'emm 02/09/2012 22:56'!
doIdentifier: anIdentifier
	stream nextPut: $" ;nextPutAll: anIdentifier name ;nextPut: $"! !

!GraphicsFileWriter methodsFor: 'dispatching ( INumberVisitor )' stamp: 'emm 02/09/2012 22:56'!
doInteger: anInt

	anInt printOn: stream! !

!GraphicsFileWriter methodsFor: 'dispatching' stamp: 'emm 02/09/2012 22:56'!
doNoElement: aNOE! !

!GraphicsFileWriter methodsFor: 'dispatching ( INumberVisitor )' stamp: 'emm 02/09/2012 22:56'!
doNumber: aNumber

	self error: 'not yet implemented'! !

!GraphicsFileWriter methodsFor: 'dispatching' stamp: 'emm 02/09/2012 22:56'!
doPoint3D: aPoint 

	aPoint x kindDo: self.
	stream space.
	aPoint y kindDo: self.
	stream space.
	aPoint z kindDo: self.! !

!GraphicsFileWriter methodsFor: 'dispatching' stamp: 'emm 02/09/2012 22:56'!
doPoint4D: aPoint

	aPoint x kindDo: self.
	stream space.
	aPoint y kindDo: self.
	stream space.
	aPoint z kindDo: self.
	stream space.
	aPoint d kindDo: self.! !

!GraphicsFileWriter methodsFor: 'dispatching' stamp: 'emm 02/09/2012 22:56'!
doPoint: aPoint

	aPoint x kindDo: self.
	stream space.
	aPoint y kindDo: self.! !

!GraphicsFileWriter methodsFor: 'dispatching-wrappers' stamp: 'emm 02/09/2012 22:56'!
doScaling3DWrapper: aWrapper 

	aWrapper solidsDo: [:each | 
		each kindDo: self]! !

!GraphicsFileWriter methodsFor: 'dispatching' stamp: 'emm 02/09/2012 22:56'!
doSceneElementCollection: aCollection
	aCollection collection do:[ :each | each kindDo: self ] separatedBy:[ self cr ]! !

!GraphicsFileWriter methodsFor: 'dispatching' stamp: 'emm 02/09/2012 22:56'!
doSceneElementWithSource: anElement

	statistics inc: 'source objects'.
	stream nextPutAll: anElement source! !

!GraphicsFileWriter methodsFor: 'dispatching' stamp: 'emm 02/09/2012 22:56'!
doString: aString

	stream nextPut: $".
	stream nextPutAll: aString.
	stream nextPut: $"! !

!GraphicsFileWriter methodsFor: 'dispatching' stamp: 'emm 02/09/2012 22:56'!
doSymbol: aSymbol

	stream nextPutAll: aSymbol! !

!GraphicsFileWriter methodsFor: 'dispatching-wrappers' stamp: 'emm 02/09/2012 22:56'!
doTranslating3DWrapper: aWrapper 

	aWrapper solidsDo: [:each | 
		each kindDo: self]! !

!GraphicsFileWriter methodsFor: 'dispatching' stamp: 'emm 02/09/2012 22:56'!
doTransparentColor: aTColor

	^self doColor: aTColor! !

!GraphicsFileWriter methodsFor: 'dispatching' stamp: 'emm 02/09/2012 22:56'!
doUndefinedObject: aNil
	"do nothing"! !

!GraphicsFileWriter methodsFor: 'dispatching' stamp: 'emm 02/09/2012 22:56'!
doVariable: aVar

	stream nextPutAll: aVar name! !

!GraphicsFileWriter methodsFor: 'convenience' stamp: 'emm 10/7/2012 20:47'!
homeCr

	level := 0.
	self cr.! !

!GraphicsFileWriter methodsFor: 'convenience' stamp: 'emm 02/09/2012 22:56'!
indent

	level := level + 1.
	self useIndentation
		ifTrue:[ stream tab ]! !

!GraphicsFileWriter methodsFor: 'convenience' stamp: 'emm 02/09/2012 22:56'!
indentWhile: aBlock

	level := level + 1.
	aBlock value.
	level := level - 1! !

!GraphicsFileWriter methodsFor: 'initialize-release' stamp: 'emm 02/09/2012 22:56'!
initialize

	super initialize.
	level := 0.
	useIndentation := true.
	statistics := GraphicsFileStatistics new! !

!GraphicsFileWriter methodsFor: 'properties' stamp: 'emm 02/09/2012 22:56'!
invertedFloatPrecision

	"maximum of eight digits"
	
	^100000000! !

!GraphicsFileWriter methodsFor: 'writing-numbers' stamp: 'emm 02/09/2012 22:56'!
longAt: byteIndex put: aLong bigEndian: isBE
	"Store a signed long (32 bit) quantity starting at the given byteIndex."

	| b0 b1 b2 b3 |
	b0 := aLong bitShift: -24.
	  b0 := (b0 bitAnd: 16r7F) - (b0 bitAnd: -16r80).
	b1 := (aLong bitShift: -16) bitAnd: 16rFF.
	b2 := (aLong bitShift: -8) bitAnd: 16rFF.
	b3 := aLong bitAnd: 16rFF.
	isBE
		ifTrue:
			["Only the first store can fail."
			self byteAt: byteIndex put: b0.  
			self byteAt: byteIndex+1 put: b1.
			self byteAt: byteIndex+2 put: b2.  
			self byteAt: byteIndex+3 put: b3]
		ifFalse:
			["Only the first store can fail."
			self byteAt: byteIndex+3 put: b0.  
			self byteAt: byteIndex+2 put: b1.
			self byteAt: byteIndex+1 put: b2.  
			self byteAt: byteIndex put: b3].
	^aLong! !

!GraphicsFileWriter methodsFor: 'Not categorized' stamp: 'emm 02/09/2012 22:56'!
negativePowerOfTenOf: anInteger 

	"Pre: anInteger < 0"

	| result abs |
	abs := 0 - anInteger.
	result := #(1 10 100 1e3 1e4 1e5 1e6 1e7 1e8) at: (abs \\ 9) + 1.
	abs // 9 timesRepeat: [result := result * 1e9].
	^1.0 / result! !

!GraphicsFileWriter methodsFor: 'convenience' stamp: 'emm 02/09/2012 22:56'!
nextPut: aChar

	stream nextPut: aChar! !

!GraphicsFileWriter methodsFor: 'convenience' stamp: 'emm 02/09/2012 22:56'!
nextPutAll: aString

	stream nextPutAll: aString! !

!GraphicsFileWriter methodsFor: 'Not categorized' stamp: 'emm 02/09/2012 22:56'!
positivePowerOfTenOf: anInteger 

	"Pre: anInteger > 0"

	| result  |
	result := #(1 10 100 1e3 1e4 1e5 1e6 1e7 1e8) at: (anInteger \\ 9) + 1.
	anInteger // 9 timesRepeat: [result := result * 1e9].
	^result! !

!GraphicsFileWriter methodsFor: 'printing' stamp: 'emm 10/7/2012 19:04'!
postWriteScene

	Transcript cr ;show: 'Statistics:' ;cr.
	statistics at: 'file (Kb)' put: stream position // 1024.
	statistics printOn: Transcript.
	Transcript cr ;flush
	! !

!GraphicsFileWriter methodsFor: 'printing' stamp: 'emm 02/09/2012 22:56'!
preWriteScene

	[statistics at: 'exportfile' put: self fileName]
		whenErrorDo:[ :sig | sig exitWith: nil ]! !

!GraphicsFileWriter methodsFor: 'convenience' stamp: 'emm 02/09/2012 22:56'!
print: anObject

	anObject printOn: stream! !

!GraphicsFileWriter methodsFor: 'Not categorized' stamp: 'emm 10/7/2012 19:13'!
printFloat: numberToPrint on: aStream 
		"TODO check printFloat_opti"
		numberToPrint printOn: aStream! !

!GraphicsFileWriter methodsFor: 'Not categorized' stamp: 'emm 10/7/2012 19:13'!
printFloat_opti: numberToPrint on: aStream 
	
	"Optimized version"
	"self new printFloat: -0.154325432 on: Transcript"
	
	| digits roundValue scale x integerPart temp y savedZeros requireZero |
	digits := 14.
	roundValue := 5.0e-15.
	( ( scale := (self scaleFor: numberToPrint )) between: 0 and: digits )
		ifTrue:
			[ x := numberToPrint truncated.
			x = numberToPrint 
				ifTrue:
					[  x printOn: aStream.
					^ aStream nextPutAll: '.0' ].
			scale > 0
				ifTrue: 
					[ digits := digits - scale.
					roundValue := digits == 0
						ifTrue: [ 0.5 ]
						ifFalse: [ 0.5 / ( self positivePowerOfTenOf: digits ) ].
					scale := 0 ].
			x := numberToPrint < 0 ifTrue:[roundValue - numberToPrint] ifFalse:[roundValue + numberToPrint].
			y := x - ( integerPart := x truncated ) ]
		ifFalse:
			[ "scale < 0"
			x := numberToPrint / (self negativePowerOfTenOf: scale ).
			x := x < 0
				ifTrue: [ roundValue - x ]
				ifFalse: [ x + roundValue ].	
			( scale between: 0 - digits and: -1 ) 
				ifTrue:
					[ temp := x.
					y := temp - temp truncated.
					digits + scale + 1 timesRepeat: [ 
						temp := y * 10.0.
						y := temp - temp truncated ].
					savedZeros := -1.
					[ savedZeros > scale
						and: [ temp truncated == 0 ] ]
						whileTrue: 
							[ temp := y * 10.0.
							y := temp - temp truncated.
							savedZeros := savedZeros - 1 ].
					temp truncated == 0 
						ifTrue:
							[ scale := 0.
							x := numberToPrint < 0
								ifTrue:[ roundValue - numberToPrint ]
								ifFalse:[ numberToPrint + roundValue ] ] ].
			y := x - ( integerPart := x truncated ) ]. 
	 "Print the sign"
	numberToPrint < 0 
		ifTrue:[ aStream nextPut: $- ].
	integerPart printOn: aStream.
	aStream nextPut: $.. 
	 "Print the fraction part with a precision of digits after the decimal point.
	"
	savedZeros := 0.
	requireZero := true.
	digits timesRepeat: [ 
		x := y * 10.0.
		y := x - ( x := x truncated ).
		x == 0
			ifTrue:
				[ savedZeros := savedZeros + 1 ]
			ifFalse:
				[ savedZeros timesRepeat: [ aStream nextPut: $0 ].
				savedZeros := 0.
				requireZero := false.
				aStream nextPut: ( Character digitValue: x ) ] ].
	requireZero 
		ifTrue:[ aStream nextPut: $0 ]. 
	 "Print the scale if it is non-zero.
	"
	scale ~~ 0 
		ifTrue:
			[ aStream nextPut: $e.
			scale printOn: aStream ]! !

!GraphicsFileWriter methodsFor: 'Not categorized' stamp: 'emm 02/09/2012 22:56'!
scaleFor: aFloat
	"Answer an integer indicating the scale factor for the
	 receiver, a type of Float. For example 0.00045 scale has a scale
	 factor of -4 which means that the float can be expressed
	 as 4.5e-4."

	| scale x |

	aFloat = 0.0 ifTrue: [^0].

	x := aFloat < 0
		ifTrue: [ 0 - aFloat ]
		ifFalse: [ aFloat ].
	x < 1
		ifTrue: [
			scale := 1.
			[x < 10.0] whileTrue: [
				x := x * 10.0 .
				scale := scale - 1]]
		ifFalse: [
			scale := 0.
			[x < 10.0] whileFalse: [
				x := x / 10.0 .
				scale := scale + 1]]. 
	^scale! !

!GraphicsFileWriter methodsFor: 'accessing' stamp: 'emm 02/09/2012 22:56'!
statistics
	^statistics! !

!GraphicsFileWriter methodsFor: 'writing-numbers' stamp: 'emm 02/09/2012 22:56'!
store16Int: anInteger
	"Store a signed short (16 bit) quantity"
	"BigEndian = false"

	self storeU16Int: ( anInteger bitAnd: 32767 )
			- ( anInteger bitAnd: -32768 )! !

!GraphicsFileWriter methodsFor: 'writing-numbers' stamp: 'emm 02/09/2012 22:56'!
store32Int: anInteger	
	"Store a signed long (32 bit) quantity"
	"BigEndian = false"

	| b0 b1 b2 b3 |
	b0 := anInteger bitShift: -24.
	b0 := ( b0 bitAnd: 127 )
				- ( b0 bitAnd: -128 ).
	b1 := ( anInteger bitShift: -16 )
				bitAnd: 255.
	b2 := ( anInteger bitShift: -8 )
				bitAnd: 255.
	b3 := anInteger bitAnd: 255.
	stream nextPut: b0.
	stream nextPut: b1.
	stream nextPut: b2.
	stream nextPut: b3! !

!GraphicsFileWriter methodsFor: 'writing-numbers' stamp: 'emm 02/09/2012 22:56'!
storeByte: anInteger 

	stream nextPut: anInteger! !

!GraphicsFileWriter methodsFor: 'writing-numbers' stamp: 'emm 02/09/2012 22:56'!
storeByteArray: anArray

	stream nextPutAll: anArray! !

!GraphicsFileWriter methodsFor: 'writing-numbers' stamp: 'emm 02/09/2012 22:56'!
storeDouble: aDouble 
	"Store a single-precision (64 bit) floating point quantity "

	"Assume that basicSize = 8"
	1 to: aDouble basicSize do: [:i | 
		stream nextPut: ( aDouble basicAt: i )]! !

!GraphicsFileWriter methodsFor: 'writing-numbers' stamp: 'emm 02/09/2012 22:56'!
storeFloat: aFloat 
	"Store a single-precision (32 bit) floating point quantity "

	"Assume that basicSize = 4"
	1 to: aFloat basicSize do: [:i | 
		stream nextPut: ( aFloat basicAt: i )]! !

!GraphicsFileWriter methodsFor: 'writing-numbers' stamp: 'emm 02/09/2012 22:56'!
storeLong: anInteger

	self storeLong: anInteger bigEndian: self isBigEndian! !

!GraphicsFileWriter methodsFor: 'writing-numbers' stamp: 'emm 02/09/2012 22:56'!
storeLong: aLong bigEndian: isBE
	"Store a signed long (32 bit) quantity starting at the given byteIndex."

	| b0 b1 b2 b3 |
	b0 := aLong bitShift: -24.
	b0 := (b0 bitAnd: 16r7F) - (b0 bitAnd: -16r80).
	b1 := (aLong bitShift: -16) bitAnd: 16rFF.
	b2 := (aLong bitShift: -8) bitAnd: 16rFF.
	b3 := aLong bitAnd: 16rFF.
	isBE
		ifTrue:
			["Only the first store can fail."
			stream nextPut: b0.  
			stream nextPut: b1.
			stream nextPut: b2.  
			stream nextPut: b3]
		ifFalse:
			["Only the first store can fail."
			stream nextPut: b3.  
			stream nextPut: b2.
			stream nextPut: b1.  
			stream nextPut: b0].
	^aLong! !

!GraphicsFileWriter methodsFor: 'writing-numbers' stamp: 'emm 02/09/2012 22:56'!
storeShort: anInteger

	self storeShort: anInteger bigEndian: self isBigEndian! !

!GraphicsFileWriter methodsFor: 'writing-numbers' stamp: 'emm 02/09/2012 22:56'!
storeShort: aShort bigEndian: isBE
	"temp"
	self store16Int: aShort! !

!GraphicsFileWriter methodsFor: 'writing-convenience' stamp: 'emm 02/09/2012 22:56'!
storeString: aString 

	self isBinary
		ifTrue: [aString do: [:eachChar | stream nextPut: eachChar asInteger]]
		ifFalse: [stream nextPutAll: aString]! !

!GraphicsFileWriter methodsFor: 'writing-numbers' stamp: 'emm 02/09/2012 22:56'!
storeU16Int: anInteger
	"BigEndian = false"

	stream nextPut: ( anInteger bitAnd: 255 ).
	stream nextPut: ( anInteger bitShift: -8 )! !

!GraphicsFileWriter methodsFor: 'writing-numbers' stamp: 'emm 02/09/2012 22:56'!
storeU32Int: anInteger
	"BigEndian = false"

	| b0 b1 b2 b3 |
	b0 := anInteger bitShift: -24.
	b0 := ( b0 bitAnd: 127 )
				- ( b0 bitAnd: -128 ).
	b1 := ( anInteger bitShift: -16 )
				bitAnd: 255.
	b2 := ( anInteger bitShift: -8 )
				bitAnd: 255.
	b3 := anInteger bitAnd: 255.
	stream nextPut: b0.
	stream nextPut: b1.
	stream nextPut: b2.
	stream nextPut: b3! !

!GraphicsFileWriter methodsFor: 'writing-numbers' stamp: 'emm 02/09/2012 22:56'!
storeU8Int: anInteger

	stream nextPut: anInteger! !

!GraphicsFileWriter methodsFor: 'writing-numbers' stamp: 'emm 02/09/2012 22:56'!
storeZeros: howMany

	howMany timesRepeat:[stream nextPut: 0]! !

!GraphicsFileWriter methodsFor: 'accessing' stamp: 'emm 9/23/2012 23:41'!
systemName

	^'Zenna'! !

!GraphicsFileWriter methodsFor: 'convenience' stamp: 'emm 10/7/2012 20:49'!
undoCr

	self useIndentation
		ifTrue:[ stream skip: level negated "remove tabs"].
	stream skip: -1 "cr lf"  "Unix = -1, WIndows = -2"! !

!GraphicsFileWriter methodsFor: 'accessing' stamp: 'emm 02/09/2012 22:56'!
useIndentation

	"Answer the value of useIndentation"

	^useIndentation! !

!GraphicsFileWriter methodsFor: 'accessing' stamp: 'emm 02/09/2012 22:56'!
useIndentation: aValue

	"Set the value of useIndentation"

	useIndentation := aValue! !

!GraphicsFileWriter methodsFor: 'writing-convenience' stamp: 'emm 02/09/2012 22:56'!
write: anObject
	anObject kindDo: self! !

!GraphicsFileWriter methodsFor: 'writing-convenience' stamp: 'emm 02/09/2012 22:56'!
writeComment: aString! !

!GraphicsFileWriter methodsFor: 'writing-numbers' stamp: 'emm 02/09/2012 22:56'!
writeFixedPrecisionFloat: aFloat

	"Write limited number of decimals at maximum
	using the invertedFloatPrecision value of the receiver"

	"(self on: Transcript) writeFixedPrecisionFloat: -123.445"

	"Time millisecondsToRun:[
		| w |
		w := self on: (String new: 7000) writeStream.
		1000 timesRepeat:[w writeFixedPrecisionFloat:-123.128]]"

	"Time millisecondsToRun:[
		| w |
		w := self on: (String new: 7000) writeStream.
		1000 timesRepeat:[-123.128 printOn: w]]"

	| integerPart decimalPart decimalIntegerPart |
	integerPart := aFloat truncated.
	decimalPart := aFloat < 0
		ifTrue:[ integerPart - aFloat ]
		ifFalse:[ aFloat - integerPart ].
	decimalIntegerPart := (decimalPart * self invertedFloatPrecision) rounded.
	integerPart printOn: stream.
	decimalIntegerPart = 0
		ifFalse:
			[ stream nextPut: $. .
			decimalIntegerPart printOn: stream]
	! !

!GraphicsFileWriter methodsFor: '*Zenna-SceneBuilding2D' stamp: 'emm 02/09/2012 23:02'!
writePropertiesEnd
	
	self undoCr.
	self backIndent.! !

!GraphicsFileWriter methodsFor: '*Zenna-SceneBuilding2D' stamp: 'emm 02/09/2012 23:02'!
writePropertiesFromGenericSceneElement: anElement 
	
	anElement hasProperties
		ifFalse: [ ^self ].
	self writePropertiesStart.
	anElement keysAndValuesDo: [ :k :v |
			stream nextPutAll: k.
			self writePropertySeparator.
			v kindDo: self.
			self writePropertyEnd ].
	self writePropertiesEnd! !

!GraphicsFileWriter methodsFor: '*Zenna-SceneBuilding2D' stamp: 'emm 02/09/2012 23:02'!
writePropertiesStart
	
	self cr.
	self indent.! !

!GraphicsFileWriter methodsFor: '*Zenna-SceneBuilding2D' stamp: 'emm 02/09/2012 23:02'!
writePropertyEnd

	"On default do a line feed"

	self cr! !

!GraphicsFileWriter methodsFor: '*Zenna-SceneBuilding2D' stamp: 'emm 02/09/2012 23:02'!
writePropertySeparator

	"On default write nothing"

	stream space! !

!GraphicsFileWriter methodsFor: 'writing-convenience' stamp: 'emm 10/7/2012 20:04'!
writeSignature	

	self writeComment: 'From ' , self systemName ,' on '
		 , Date today printString , ' at '
		 , Time now printString.
	self cr ;writeComment: 'Copyright (c) 1997,', Date today year asString, ' ernestmicklei.com'.
	self cr ;cr! !

!GraphicsFileWriter methodsFor: 'writing-convenience' stamp: 'emm 02/09/2012 22:56'!
writeSpaces: howMany

	howMany timesRepeat:[stream space]! !

!GraphicsFileWriter methodsFor: 'writing-convenience' stamp: 'emm 02/09/2012 22:56'!
writeString: aString 

	self isBinary
		ifTrue: [aString do: [:eachChar | stream nextPut: eachChar asInteger]]
		ifFalse: [stream nextPutAll: aString]! !

GraphicsFileWriter subclass: #M3DBoxWriter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-FormatM3D'!

!M3DBoxWriter class methodsFor: 'properties ( ISceneWriter class )' stamp: 'emm 02/09/2012 23:56'!
fileExtension

	"Answer the default file extension when writing a scene
	defined by the receiver using the default writer"

	self error: 'missing'! !

!M3DBoxWriter methodsFor: 'converting' stamp: 'emm 02/09/2012 23:56'!
longFromString: aString
	"self new longFromString: 'FFFF8000' "

	| num bits14 fractionpart intpart |
	num := Integer fromHex: aString.
	bits14 := 16r3FFF.
	fractionpart := num bitAnd: bits14.
	fractionpart = 0
		ifFalse: [ [ fractionpart > 1 ] whileTrue:[ fractionpart := fractionpart / 10.0]].
	intpart := num bitShift: -14.
	(intpart bitAnd: 16r20000) = 16r20000
		ifTrue: [ intpart := intpart - 16r40000].
	^intpart + fractionpart! !

!M3DBoxWriter methodsFor: 'converting' stamp: 'emm 02/09/2012 23:56'!
radiusFromBox: aBox
	"self new radiusFromBox: (0,1,2 corner: 2,3,4)"

	^((aBox extent x min: (aBox extent y min: aBox extent y)) / 2.0) truncated! !

!M3DBoxWriter methodsFor: 'converting' stamp: 'emm 02/09/2012 23:56'!
shortFromString: aString
	"self new shortFromString: '4005' "
	"(self new shortFromString: 'c000') = -2"

	| num bits14 fractionpart intpart |
	num := Integer fromHex: aString.
	bits14 := 16r3FFF.
	fractionpart := num bitAnd: bits14.
	fractionpart = 0
		ifFalse: [ [ fractionpart > 1 ] whileTrue:[ fractionpart := fractionpart / 10.0]].
	intpart := num bitShift: -14.
	(intpart bitAnd: 2r10) = 2r10
		ifTrue: [ intpart := 1 - intpart ].
	^intpart + fractionpart! !

!M3DBoxWriter methodsFor: 'converting' stamp: 'emm 02/09/2012 23:56'!
stringFromLong: long
	"self new longFromString: (self new stringFromLong: -2)"

	stream := '' writeStream.
	self writeLong: long asFloat.
	^stream contents! !

!M3DBoxWriter methodsFor: 'converting' stamp: 'emm 02/09/2012 23:56'!
stringFromShort: short
	"self new shortFromString: (self new stringFromShort: -2)"

	stream := '' writeStream.
	self writeShort: short asFloat.
	^stream contents! !

!M3DBoxWriter methodsFor: 'writing' stamp: 'emm 02/09/2012 23:56'!
writeBoxes: aBoxCollection

	self write: aBoxCollection size.
	self cr.
	aBoxCollection doWithIndex:[ :each :index |
		self indent.
		self write: index.
		stream space.
		self write: (self radiusFromBox: each) rounded. 
		self cr.
		self writePoint3D: each center.
		self cr.
		self writePlaneParametersFrom: each top.
		self writePlaneParametersFrom: each right.
		self writePlaneParametersFrom: each back.
		self writePlaneParametersFrom: each left.
		self writePlaneParametersFrom: each front.
		self writePlaneParametersFrom: each bottom.
		self backCr].
	aBoxCollection doWithIndex:[ :each :i |
		aBoxCollection doWithIndex:[ :other :j |
			(i < j and:[each intersects: other])
				ifTrue: 
					[ self write: i.
					stream space.
					self write: j.
					self cr ]]].				
	stream nextPutAll:'-1 -1'.
		
		
		

		! !

!M3DBoxWriter methodsFor: 'writing' stamp: 'emm 02/09/2012 23:56'!
writeLong: float

	| fractionpart  bits14 intpart bitStream num|
	float = 0 ifTrue: [ ^stream nextPut: $0 ].

	fractionpart := float abs fractionPart.
	bits14 := 16r3FFF.
	[fractionpart fractionPart > 1 and:[fractionpart < bits14]]
		whileTrue:[fractionpart := fractionpart * 10.0].
	intpart := float truncated.
	intpart < 0 
		ifTrue: [intpart := 16r40000 + intpart].
	
	num := (intpart bitShift: 14) bitOr: fractionpart truncated.
	stream nextPutAll: (num printStringRadix: 16 showRadix: false) asLowercase
		! !

!M3DBoxWriter methodsFor: 'writing' stamp: 'emm 02/09/2012 23:56'!
writePlaneParametersFrom: aPolygon

	| normal  any d l|
	normal := aPolygon normal negated.
	any := aPolygon first.
	d := normal x * any x + (normal y * any y) + (normal z * any z).
	self writeShort: normal y asFloat.
	stream space.
	self writeShort: normal z asFloat.
	stream space.
	self writeShort: normal x negated asFloat.
	stream space.
	self writeLong: d asFloat.
	self cr.
		

		! !

!M3DBoxWriter methodsFor: 'writing' stamp: 'emm 02/09/2012 23:56'!
writePoint3D: aPoint3D

	self writeLong: aPoint3D x rounded "negated?" asFloat.
	stream space.
	self writeLong: aPoint3D z rounded asFloat.
	stream space.
	self writeLong: aPoint3D y rounded asFloat.


		! !

!M3DBoxWriter methodsFor: 'writing' stamp: 'emm 02/09/2012 23:56'!
writeShort: float

	| fractionpart  bits14 intpart bitStream num|
	float = 0 ifTrue: [ ^stream nextPut: $0 ].

	fractionpart := float abs fractionPart.
	bits14 := 16r3FFF.
	[fractionpart fractionPart > 1 and:[fractionpart < bits14]]
		whileTrue:[fractionpart := fractionpart * 10.0].
	intpart := float truncated.
	intpart < 0 
		ifTrue: [intpart := 2 - intpart].
	
	num := (intpart bitShift: 14) bitOr: fractionpart truncated.
	stream nextPutAll: (num printStringRadix: 16 showRadix: false) asLowercase
		! !

!M3DBoxWriter methodsFor: 'writing' stamp: 'emm 02/09/2012 23:56'!
writeSignature
	"skip any cr"! !

GraphicsFileWriter subclass: #M3DWriter
	instanceVariableNames: 'polygonCount'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-FormatM3D'!

!M3DWriter class methodsFor: 'properties ( ISceneWriter class )' stamp: 'emm 02/09/2012 23:56'!
fileExtension

	"Answer the default file extension when writing a scene
	defined by the receiver using the default writer"

	^'.m3d'! !

!M3DWriter methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:56'!
doCamera: aCamera

	stream nextPutAll: 'camera '.
	stream nextPutAll: aCamera name.
	stream nextPutAll: ' {'.
	self cr.
	aCamera origin kindDo: self.
	self cr.
	"temp"
	Point3D zero kindDo: self.
	self cr.
	"no scale"
	stream nextPut: $}.
	! !

!M3DWriter methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:56'!
doColor: aColor

	| writeBlock |
	writeBlock := [ :byte |
		byte < 16
			ifTrue: [ stream nextPut: $0 ].
		stream nextPutAll: (byte printStringRadix: 16 showRadix: false) asLowercase ].
	writeBlock value: aColor redByte.
	writeBlock value: aColor greenByte.
	writeBlock value: aColor blueByte.! !

!M3DWriter methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:56'!
doComposite: aComposite

	aComposite do:[:each| each kindDo: self]! !

!M3DWriter methodsFor: 'private' stamp: 'emm 02/09/2012 23:56'!
doM3DCommon: anM3D

	self cr.
	anM3D position rounded kindDo: self.
	stream space.
	anM3D angle kindDo: self.
	stream space.
	anM3D scale isNil 
		ifFalse:[ stream print: anM3D scale].
	self cr.! !

!M3DWriter methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:56'!
doM3DMaterial: aMaterial

	stream nextPutAll: 'material '.
	stream nextPutAll: aMaterial name.
	stream nextPutAll: ' {'.
	self cr.
	aMaterial color isNil
		ifFalse: 
			[ stream nextPutAll: 'color '.
			aMaterial color kindDo: self.
			self cr].
	aMaterial texture isNil
		ifFalse: 
			[ stream nextPutAll: 'texture '.
			aMaterial texture kindDo: self.
			self cr].	
	(aMaterial color notNil and:[aMaterial color transparency > 0])
		ifTrue: 
			[ | tp |
			stream nextPutAll: 'type TRANSPARENCY'. 
			tp := aMaterial color transparency.
			 (tp < 1 ifTrue: [ tp * 100 ] ifFalse: [ tp ]) rounded printOn: stream.
			self cr].
	stream nextPut: $}.

	statistics incTextures.! !

!M3DWriter methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:56'!
doM3DMesh: aMesh 
	
	stream nextPutAll: 'mesh ' ; nextPutAll: aMesh name ; nextPutAll: ' { '.
	self doM3DCommon: aMesh.
	aMesh vertices do: [ :each | 
		each rounded kindDo: self.
		self cr ].
	aMesh light isNil 
		ifFalse:
			[ stream nextPutAll: 'light '.
			aMesh light kindDo: self.
			self cr ].
	aMesh materials notNil
		ifTrue: [ self writeMaterialsForMesh: aMesh  ].
	stream nextPut: $}.
	self cr. 
	statistics incMeshes! !

!M3DWriter methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:56'!
doM3DShell: aShell

	stream nextPutAll: 'shell ' ; nextPutAll: aShell name ; nextPutAll: ' { '.
	self doM3DCommon: aShell.
	aShell meshes do:[ :each | each kindDo: self ].
	stream nextPut: $}.
	self cr! !

!M3DWriter methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:56'!
doPoint3D: aPoint3D

	stream print: aPoint3D x.
	stream space.
	stream print: aPoint3D z.
	stream space.
	stream print: aPoint3D y.
	stream space.! !

!M3DWriter methodsFor: 'redefined' stamp: 'emm 02/09/2012 23:56'!
doString: aString
	stream nextPutAll: aString! !

!M3DWriter methodsFor: 'initialize-release' stamp: 'emm 02/09/2012 23:56'!
initialize

	| meshCount |
	super initialize.
	polygonCount := 0! !

!M3DWriter methodsFor: 'redefined' stamp: 'emm 02/09/2012 23:56'!
writeComment: aString

	stream nextPut: $# ;space ;nextPutAll: aString! !

!M3DWriter methodsFor: 'redefined' stamp: 'emm 02/09/2012 23:56'!
writeMaterialsForMesh: aMesh 
	
	| polyIndex material vertexCollection textureCoords writeCoords |
	polyIndex := 1.
	material := nil. 
	textureCoords := Array 
		with: 255 @ 0 
		with: 255 @ 255 
		with: 0 @ 255 
		with: 0 @ 0. 
	[ polyIndex <= aMesh polygons size ]
		whileTrue: 
			[ ( material ~= ( aMesh materials at: polyIndex ) ) 
				ifTrue:
					[ material := aMesh materials at: polyIndex.
					stream nextPutAll: material name.
					self cr ].
			vertexCollection := aMesh polygons at: polyIndex.
			vertexCollection size = 4 
				ifTrue:[ vertexCollection reversed doWithIndex: [ :each :index | 
					( each - 1 ) kindDo: self. "numbering is zero based"
					stream space. "TEMP HACK"
					material texture isNil
						ifFalse: 
							[ ( textureCoords at: index ) kindDo: self.
							stream space ] ] ]
				ifFalse: [ vertexCollection reversed doWithIndex: [ :each :index | 
					( each - 1 ) kindDo: self. "numbering is zero based"
					stream space.] ].
			self cr.
			polyIndex := polyIndex + 1.
			statistics incPolygons ].! !

GraphicsFileWriter subclass: #MaxScriptWriter
	instanceVariableNames: 'definedObjects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-FormatMaxScript'!

!MaxScriptWriter class methodsFor: 'properties ( ISceneWriter class )' stamp: 'emm 02/09/2012 23:55'!
fileExtension

	"Answer the default file extension when writing a scene
	defined by the receiver using the default writer"

	^'.ms'! !

!MaxScriptWriter methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:55'!
addDefined: anObject
	definedObjects add: anObject! !

!MaxScriptWriter methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:55'!
doAccessingField: aField
	
	aField receiver kindDo: self.
	stream nextPut: $. .
	aField field kindDo: self.! !

!MaxScriptWriter methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:55'!
doColor: aColor

	stream 
		nextPutAll: 'color '
		;print: aColor redByte
		;space
		;print: aColor greenByte
		;space
		;print: aColor blueByte! !

!MaxScriptWriter methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:55'!
doGenericSceneElement: anElement 
	
	( self isDefined: anElement) 
		ifTrue:
			[ stream nextPut: $$.
			stream nextPutAll: anElement name.
			^ self ].
	self addDefined: anElement.
	stream nextPutAll: anElement className. "add its name as one of his properties"
	anElement at: 'name' put: anElement name.
	self writePropertiesFromGenericSceneElement: anElement.
	"to apply appearances..."
	self select.! !

!MaxScriptWriter methodsFor: 'dispatching-max' stamp: 'emm 02/09/2012 23:55'!
doMaxMaterial: aMaterial 


	stream nextPutAll: aMaterial name.
	(self isDefined: aMaterial)
		ifTrue: [^self].
	stream 
		nextPutAll: ' = standardMaterial()' 
		;cr
		;nextPutAll: aMaterial name 
		;nextPutAll: '.name = "'
		;nextPutAll: aMaterial name
		;nextPutAll: '"'
		;cr
		;nextPutAll: 'currentMaterialLibrary["'
		;nextPutAll: aMaterial name
		;nextPutAll: '"] = '
		;nextPutAll: aMaterial name.
	aMaterial diffuseColor isNil 
		ifFalse: 
			[ stream cr ;nextPutAll: aMaterial name ;nextPutAll: '.Diffuse = '.
			self write: aMaterial diffuseColor].
	aMaterial bitmapFilename isNil 
		ifFalse: 
			[ | textureName |
			stream cr ;nextPutAll: aMaterial name ;nextPutAll: '.diffuseMapEnable = on'.
			stream cr ;nextPutAll: aMaterial name ;nextPutAll: '.diffuseMap = Bitmaptexture fileName: '.
			aMaterial bitmapFilename kindDo: self.
			textureName := self textureNameForBitmapFilename: aMaterial bitmapFilename.
			stream cr ;nextPutAll: aMaterial name ;nextPutAll: '.diffuseMap.name = "' ;nextPutAll: textureName ;nextPut: $"].
	self addDefined: aMaterial.
	statistics incTextures.! !

!MaxScriptWriter methodsFor: 'dispatching-max' stamp: 'emm 02/09/2012 23:55'!
doMaxModifier: aMaxModifier 

	stream nextPutAll: 'addModifier $ (' ; nextPutAll: aMaxModifier className ; nextPutAll: '())'.
	aMaxModifier properties keysAndValuesDo: [ :key :value | value notNil 
		ifTrue: 
			[ stream 
				cr
				; nextPutAll: '$.modifiers[#'
				; nextPutAll: aMaxModifier keySymbol
				; nextPutAll: '].'.
			stream nextPutAll: key ; nextPut: $=.
			value kindDo: self ] ]! !

!MaxScriptWriter methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:55'!
doMaxObject: aMaxObject

	| element |
	element := self doGenericSceneElement: aMaxObject.
	aMaxObject modifiers do:[ :each | self cr ;write: each ].
	statistics incMeshes.
	^element! !

!MaxScriptWriter methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:55'!
doPoint3D: aPoint3D

	stream nextPut: $[.
	aPoint3D x kindDo: self.
	stream nextPut: $,.
	aPoint3D y kindDo: self.
	stream nextPut: $,.
	aPoint3D z kindDo: self.
	stream nextPut: $].! !

!MaxScriptWriter methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:55'!
doPoint4D: aPoint4D

	stream nextPutAll: 'quat '.
	super doPoint4D: aPoint4D.! !

!MaxScriptWriter methodsFor: 'dispatching-wrappers' stamp: 'emm 02/09/2012 23:55'!
doRotating3DWrapper: aWrapper
	"$.rotation = quat 0 0 -0.177944 0.984041"
	
	stream nextPutAll: '$.rotation = '.
	self write: aWrapper rotation asQuaternion! !

!MaxScriptWriter methodsFor: 'dispatching-wrappers' stamp: 'emm 02/09/2012 23:55'!
doScaling3DWrapper: aWrapper
	"$.scale = [1.97,1.97,1.97]"
	
	stream nextPutAll: '$.scale = '.
	self write: aWrapper scale.! !

!MaxScriptWriter methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:55'!
doSendingMessage: aMessage 
	
	| arg |
	aMessage receiver notNil 
		ifTrue:[ aMessage receiver kindDo: self ].
	stream space.
	arg := 1.
	aMessage selector do:[ :ch |
		stream nextPut: ch.
		ch = $:
			ifTrue: 
				[ stream space.
				(aMessage arguments at: arg) kindDo: self.
				stream space.
				arg := arg + 1 ]].
	(arg > aMessage arguments size) "binary selector?"
		ifFalse: 
			[stream space.
			(aMessage arguments at:1) kindDo: self]! !

!MaxScriptWriter methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:55'!
doSequenceableCollection: aCollection

	stream nextPutAll: '#('.
	aCollection 
		do:[ :each | each kindDo: self ]
		separatedBy:[ stream nextPut: $, ].
	stream nextPut: $)! !

!MaxScriptWriter methodsFor: 'dispatching-wrappers' stamp: 'emm 02/09/2012 23:55'!
doTranslating3DWrapper: aWrapper
	"$.translate = [1.97,1.97,1.97]"
	
	stream nextPutAll: 'move $ '.
	self write: aWrapper translation.! !

!MaxScriptWriter methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:55'!
doVariableAssignment: aStatement 
	
	aStatement variable notNil 
		ifTrue:
			[ aStatement variable kindDo: self.
			stream nextPutAll: ' = ' ].
	aStatement expression kindDo: self! !

!MaxScriptWriter methodsFor: 'intialize-release' stamp: 'emm 02/09/2012 23:55'!
initialize
	
	super initialize.
	definedObjects := Set new! !

!MaxScriptWriter methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:55'!
isDefined: anObject
	^ definedObjects includes: anObject! !

!MaxScriptWriter methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:55'!
select

	stream nextPutAll: ' isSelected: on'! !

!MaxScriptWriter methodsFor: 'dispatching-max' stamp: 'emm 02/09/2012 23:55'!
textureNameForBitmapFilename: aString

	| name |
	name := aString copyFrom: (((aString lastIndexOf: $\) max: (aString lastIndexOf: $/))+1) to: ( aString indexOf: $. ) - 1.
	^name! !

!MaxScriptWriter methodsFor: 'redefined' stamp: 'emm 02/09/2012 23:55'!
writeComment: aString
	
	stream nextPutAll: '-- ' ;nextPutAll: aString.! !

!MaxScriptWriter methodsFor: 'redefined' stamp: 'emm 02/09/2012 23:55'!
writePropertiesEnd! !

!MaxScriptWriter methodsFor: 'redefined' stamp: 'emm 02/09/2012 23:55'!
writePropertiesStart
	stream space! !

!MaxScriptWriter methodsFor: 'redefined' stamp: 'emm 02/09/2012 23:55'!
writePropertyEnd

	stream space! !

!MaxScriptWriter methodsFor: 'redefined' stamp: 'emm 02/09/2012 23:55'!
writePropertySeparator

	stream nextPut: $: ;space! !

GraphicsFileWriter subclass: #POVWriter
	instanceVariableNames: 'isDeclarationWriting changeCoordinateSystem'
	classVariableNames: ''
	poolDictionaries: 'Math3DConstants'
	category: 'Zenna-FormatPOVRay'!

!POVWriter class methodsFor: 'properties' stamp: 'emm 02/09/2012 23:55'!
fileExtension

	^'.inc'! !

!POVWriter methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:55'!
changeCoordinateSystem

	^changeCoordinateSystem ~~ false! !

!POVWriter methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:55'!
changeCoordinateSystem: aValue 

	changeCoordinateSystem := aValue! !

!POVWriter methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:55'!
doCSGDifference: anDifference 

	self doCSGObject: anDifference! !

!POVWriter methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:55'!
doCSGIntersection: anIntersection 

	self doCSGObject: anIntersection! !

!POVWriter methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:55'!
doCSGObject: anObject

	anObject components 
		do: [:each | each kindDo: self]
		separatedBy: [self cr]! !

!POVWriter methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:55'!
doCSGUnion: anUnion 

	self doCSGObject: anUnion! !

!POVWriter methodsFor: 'overriding' stamp: 'emm 02/09/2012 23:55'!
doCallbackTo: anObject

	"Dispatch the request back to @anObject.
	The method name should include a description (kind) of  the receiver"

	^anObject doPOVWriter: self! !

!POVWriter methodsFor: 'overriding' stamp: 'emm 02/09/2012 23:55'!
doColor: aColor

	stream nextPutAll: 'rgb '.	
	stream nextPutAll: '<'.
	aColor red01 kindDo: self.
	stream nextPut: $,.
	aColor green01 kindDo: self.
	stream nextPut: $,.
	aColor blue01 kindDo: self.
	stream nextPut: $>! !

!POVWriter methodsFor: 'writing' stamp: 'emm 02/09/2012 23:55'!
doFloat: aFloat

	"Write short versions of common values"

	aFloat = 0.0
		ifTrue: [ ^stream nextPut: $0 ].
	aFloat = 1.0
		ifTrue: [ ^stream nextPut: $1 ].
	super doFloat: aFloat! !

!POVWriter methodsFor: 'dispatching-POV' stamp: 'emm 02/09/2012 23:55'!
doPOVElement: anElement
	
	( self isDeclarationWriting not
		and: [ anElement hasName ] ) 
		ifTrue:[ ^ stream nextPut: ${ ; nextPutAll: anElement name ; nextPut: $} ].
	stream nextPutAll: anElement className ; nextPutAll: ' {'.
	self cr.
	anElement constructorParameters do:[ :each | self write: each ] separatedBy:[ stream nextPut: $, ].
	self cr.
	anElement modifiers do:[ :each | self write: each ;cr ].
	
	anElement hasElements 
		ifTrue:[ anElement elements do: [ :each | 
			self indent.
			self write: each.
			self backCr ] ].
	anElement keysAndValuesDo: [ :k :v | 
		self indent.
		stream nextPutAll: k.
		stream space.
		self write: v.
		self backCr ].
	stream nextPut: $}.
	
	statistics inc: 'objects'.! !

!POVWriter methodsFor: 'todo' stamp: 'emm 02/09/2012 23:55'!
doPOVPrism: aPOVPrism

	| contour |
 	self nextPutAll: aPOVPrism sweepType.
	self cr.
	self nextPutAll: aPOVPrism splineType.
	self cr.
	self write: aPOVPrism fromY.
	self nextPut: $, ;cr.
	self write: aPOVPrism toY.
	self nextPut: $, ;cr.
	contour := aPOVPrism contourPoints.
	self write: contour size.
	self nextPut: $, ;cr.
	contour 	
		do:[ :each | self write: each ]
		separatedBy:[ self nextPut: $, ].
	self cr.
	self writePropertiesOf: aPOVPrism.! !

!POVWriter methodsFor: 'todo' stamp: 'emm 02/09/2012 23:55'!
doPOVText: aPOVTextOrText 

	| povText |
	povText := aPOVTextOrText asPOVObject.
	stream nextPutAll: 'text {'.
	self
		indentWhile: 
			[self cr.
			stream nextPutAll: 'ttf'.
			self cr.
			stream nextPut: $";nextPutAll: povText fontName; nextPutAll: '", '.
			self cr.
			stream nextPut: $"; nextPutAll: povText string; nextPutAll: '", '.
			self cr.
			stream print: povText depth; nextPut: $,.
			self cr.
			stream print: povText offset.
			self cr.
			self writePropertiesOf: povText].
	self cr.
	stream nextPut: $}! !

!POVWriter methodsFor: 'overriding' stamp: 'emm 02/09/2012 23:55'!
doPoint3D: aPoint 
	"Accomodate for coordinate-system change: <aPoint> is specified for a 
	system which has: 
		z=up, y=right, x=out of screen 
	POVRay default uses: 
		y=up, x=right, z=into screen 
	using camera-settings: 
		location x,y,z // z > 0
		up z
		right -4/3 * y 
	POVRay will use: 
		y=up, x = right, z = out of screen"

	| povPoint |
	changeCoordinateSystem
		ifTrue: [povPoint := Point3D
						x: aPoint x
						y: aPoint z 
						z: aPoint y negated]
		ifFalse:[ povPoint := aPoint ].
	self primWritePoint3D: povPoint! !

!POVWriter methodsFor: 'overriding' stamp: 'emm 02/09/2012 23:55'!
doPoint: aPoint

	stream nextPutAll: '<'.
	aPoint x kindDo: self.
	stream nextPut: $, ;space.
	aPoint y kindDo: self.
	stream nextPutAll: '>'! !

!POVWriter methodsFor: 'todo' stamp: 'emm 02/09/2012 23:55'!
doPrism: aPrism

	| contour |
	self nextPutAll: 'linear_sweep'.
	self cr.
	self nextPutAll: 'linear_spline'.
	self cr.
	self write: aPrism origin z.
	self nextPut: $, ;cr.
	self write: aPrism origin z + aPrism zSize.
	self nextPut: $, ;cr.
	contour := aPrism contourPoints.
	self write: contour size + 1. 	"closing"
	self nextPut: $, ;cr.
	contour 	do:[ :each | 
		self write: each.
		self nextPut: $, ].
	self write: contour first.
	self cr ;write: 'rotate <-90.0, 0 , 0>'
! !

!POVWriter methodsFor: 'dispatching-wrappers ( IGeometric3DVisitor )' stamp: 'emm 02/09/2012 23:55'!
doRotating3DWrapper: aWrapper
	
	aWrapper rotation isZero
		ifFalse: 
			[stream nextPutAll: 'rotate '.
			self write: aWrapper rotation radiansToDegrees ].! !

!POVWriter methodsFor: 'dispatching-wrappers ( IGeometric3DVisitor )' stamp: 'emm 02/09/2012 23:55'!
doScaling3DWrapper: aWrapper 
	
	aWrapper scale isUnity
		ifFalse: 
			[ | povPoint |
			stream nextPutAll: 'scale '.
			self changeCoordinateSystem
				ifTrue: [povPoint := Point3D
						x: aWrapper scale x
						y: aWrapper scale z 
						z: aWrapper scale y]
				ifFalse:[ povPoint := aWrapper scale  ].
			self primWritePoint3D: povPoint ]! !

!POVWriter methodsFor: 'todo' stamp: 'emm 02/09/2012 23:55'!
doSpotLight: aLight
	
	self write: aLight origin.
	self cr ;nextPutAll: 'color '.
	self write: aLight color.
	self cr ;nextPutAll: 'spotlight'.
	self cr ;nextPutAll: 'point_at '.
	self write: aLight focusPoint.
	aLight radius isNil
		ifTrue: [ ^self ].
	self cr ;nextPutAll: 'radius '.
	self write: aLight radius.
	self cr ;nextPutAll: 'falloff '.
	self write: aLight falloff.
	self cr ;nextPutAll: 'tightness 1'.! !

!POVWriter methodsFor: 'overriding' stamp: 'emm 02/09/2012 23:55'!
doString: aString
	"In future, this must become default implementation in my super"
	
	stream nextPutAll: aString! !

!POVWriter methodsFor: 'todo' stamp: 'emm 02/09/2012 23:55'!
doText3D: aText3D 

	"TEMP fix ABL"

	self write: 'text { ttf "timrom" "'.
	self write: aText3D string.
	self write: '" 0.01 , 0 }';cr.
	self write: 'scale 8';cr.
	self write: 'rotate <0,90,0>'.
! !

!POVWriter methodsFor: 'dispatching-wrappers ( IGeometric3DVisitor )' stamp: 'emm 02/09/2012 23:55'!
doTextureWrapper: aWrapper

	aWrapper texture isNil
		ifFalse: 
			[ self nextPutAll: 'texture { pigment {'.
			self write: aWrapper texture.
			self nextPutAll: ' } }' ]! !

!POVWriter methodsFor: 'dispatching-wrappers ( IGeometric3DVisitor )' stamp: 'emm 02/09/2012 23:55'!
doTransformation3D: aTransformation3D

	stream nextPutAll: 'transform {'.
	aTransformation3D scale notNil 
		ifTrue:
			[ stream nextPutAll: ' scale '.
			aTransformation3D scale kindDo: self ].
	aTransformation3D rotation notNil 
		ifTrue:
			[ stream nextPutAll: ' rotate '.
			aTransformation3D rotation radiansToDegrees kindDo: self ].
	aTransformation3D translation notNil 
		ifTrue:
			[ stream nextPutAll: ' translate '.
			aTransformation3D translation kindDo: self ].
	stream nextPutAll: ' }'! !

!POVWriter methodsFor: 'dispatching-wrappers ( IGeometric3DVisitor )' stamp: 'emm 02/09/2012 23:55'!
doTransforming3DWrapper: aWrapper 
	
	aWrapper component kindDo: self.
	self cr. 
	stream nextPutAll: 'transform {'.
	aWrapper scale notNil 
		ifTrue:
			[ stream nextPutAll: ' scale '.
			aWrapper scale kindDo: self ].
	aWrapper rotation notNil 
		ifTrue:
			[ stream nextPutAll: ' rotate '.
			aWrapper rotation radiansToDegrees kindDo: self ].
	aWrapper translation notNil 
		ifTrue:
			[ stream nextPutAll: ' translate '.
			aWrapper translation kindDo: self ].
	stream nextPutAll: ' }'! !

!POVWriter methodsFor: 'dispatching-wrappers ( IGeometric3DVisitor )' stamp: 'emm 02/09/2012 23:55'!
doTransformingElementWrapper: aWrapper

	self doTransforming3DWrapper: aWrapper ! !

!POVWriter methodsFor: 'dispatching-wrappers ( IGeometric3DVisitor )' stamp: 'emm 02/09/2012 23:55'!
doTranslating3DWrapper: aWrapper 
	
	| t |
	( t := aWrapper translation ) isZero 
		ifFalse: 
			[stream nextPutAll: 'translate '.
			self write: t ]! !

!POVWriter methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:55'!
doTransparentColor: aTColor

	stream nextPutAll: 'rgbf '.	
	stream nextPutAll: '<'.
	aTColor red01 kindDo: self.
	stream nextPut: $,.
	aTColor green01 kindDo: self.
	stream nextPut: $,.
	aTColor blue01 kindDo: self.
	stream nextPut: $,.
	aTColor transparency kindDo: self.	
	stream nextPut: $>! !

!POVWriter methodsFor: 'initialize-release' stamp: 'emm 02/09/2012 23:55'!
initialize

	super initialize.
	self changeCoordinateSystem: true.
	self isDeclarationWriting: false.! !

!POVWriter methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:55'!
isDeclarationWriting

	"Answer the value of isDeclarationWriting"

	^isDeclarationWriting! !

!POVWriter methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:55'!
isDeclarationWriting: aValue

	"Set the value of isDeclarationWriting"

	isDeclarationWriting := aValue! !

!POVWriter methodsFor: 'writing' stamp: 'emm 02/09/2012 23:55'!
primWritePoint3D: aPoint 
	
	"try shortcuts"
	aPoint x = 0
		ifTrue:
			[ aPoint y = 0
				ifTrue:
					[ aPoint z kindDo: self.
					^ stream nextPutAll: '*z' ]
				ifFalse:
					[ aPoint z = 0 
						ifTrue:
							[ aPoint y kindDo: self.
							^ stream nextPutAll: '*y' ] ] ]
		ifFalse:
			[ ( aPoint y = 0
				and: [ aPoint z = 0 ] ) 
				ifTrue:
					[ aPoint x kindDo: self.
					^ stream nextPutAll: '*x' ] ]. 
	
	stream nextPutAll: '<'.
	aPoint x kindDo: self.
	stream nextPut: $,.
	aPoint y kindDo: self.
	stream nextPut: $,.
	aPoint z kindDo: self.
	stream nextPutAll: '>'! !

!POVWriter methodsFor: 'writing' stamp: 'emm 02/09/2012 23:55'!
writeComment: aString
	
	stream nextPutAll: '//	' ;tab ; nextPutAll: aString! !

!POVWriter methodsFor: 'writing' stamp: 'emm 02/09/2012 23:55'!
writePropertiesOf: aPOVObject 
	
	| value |
	aPOVObject hasProperties 
		ifFalse: [ ^self ].
	aPOVObject keys asArray
		do: [ :key | 
			value := aPOVObject atKey: key.
			stream nextPutAll: key.
			stream tab.
			self write: value ] 
		separatedBy: [ self cr ]! !

GraphicsFileWriter subclass: #SVGWriter
	instanceVariableNames: 'taggedDataWriter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-FormatSVG'!

!SVGWriter class methodsFor: 'resources' stamp: 'emm 02/09/2012 23:06'!
fileExtension
	^'.svg'! !

!SVGWriter methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:06'!
doGenericSceneElement: aGenericSceneElement 

	aGenericSceneElement hasElements
		ifTrue: 
			[ taggedDataWriter 
				withTag: aGenericSceneElement className 
				attributes: aGenericSceneElement properties 
				print: [ aGenericSceneElement elements do: [ :each | each kindDo: self ] separatedBy:[ taggedDataWriter cr] ] ]
		ifFalse: 
			[ taggedDataWriter printTag: aGenericSceneElement className attributes: aGenericSceneElement properties isEnd: false isEmpty: true]
		! !

!SVGWriter methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:06'!
doSVGMarker: aMarker! !

!SVGWriter methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:06'!
doTaggedData: aData
	aData printTaggedWith: taggedDataWriter! !

!SVGWriter methodsFor: 'initialize-release' stamp: 'emm 02/09/2012 23:06'!
stream: aStream
	taggedDataWriter := TaggedDataWriter on: aStream.
	super stream: aStream.! !

!SVGWriter methodsFor: 'initialize-release' stamp: 'emm 02/09/2012 23:06'!
writeComment: aString
	taggedDataWriter printComment: aString! !

!SVGWriter methodsFor: 'initialize-release' stamp: 'emm 02/09/2012 23:06'!
writeSignature	
	stream nextPutAll: '<?xml version="1.0"?>' ;cr.
	super writeSignature.! !

GraphicsFileWriter subclass: #ThreeJSWriter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-FormatThreeJS'!

!ThreeJSWriter class methodsFor: 'accessing' stamp: 'emm 10/7/2012 22:57'!
fileExtension
	^'.js'! !

GraphicsFileWriter subclass: #WRLWriter
	instanceVariableNames: 'definedNames'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-FormatVRML'!

!WRLWriter class methodsFor: 'properties' stamp: 'emm 02/09/2012 23:54'!
fileExtension
	^'.wrl'! !

!WRLWriter methodsFor: 'overriding' stamp: 'emm 10/7/2012 20:48'!
cr
	"Because InstantPlayer cannot handle CR line end convention"

	stream
		nextPut: Character cr;
		nextPut: Character lf.
	self useIndentation
		ifTrue: [ level timesRepeat: [ stream tab ] ]! !

!WRLWriter methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:54'!
doCallbackTo: anObject

	^anObject doWRLWriter: self! !

!WRLWriter methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:54'!
doColor: aColor

	aColor red01 kindDo: self.
	stream space.
	aColor green01 kindDo: self.
	stream space.
	aColor blue01 kindDo: self.! !

!WRLWriter methodsFor: 'overriding' stamp: 'emm 02/09/2012 23:54'!
doFloat: aFloat

	"Write short versions of common values"

	aFloat = 0.0
		ifTrue: [ ^stream nextPut: $0 ].
	aFloat = 1.0
		ifTrue: [ ^stream nextPut: $1 ].
	super printFloat: aFloat on: stream! !

!WRLWriter methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:54'!
doGenericSceneElement: anElement 
	
	self 
		writeDEFFor: anElement 
		ifUse: [ ^self ].
	stream nextPutAll: anElement className ; nextPutAll: '{'.
	self writePropertiesFromGenericSceneElement: anElement.
	anElement hasElements 
		ifTrue: 
			[ anElement elements 
				do: [ :each | 
					self indent.
					each kindDo: self ] 
				separatedBy: [ self cr ] ].
	stream nextPut: $}! !

!WRLWriter methodsFor: 'overriding' stamp: 'emm 10/7/2012 19:16'!
doPoint3D: aPoint 
	
	"Zenna uses Z-up, Y-right, X-out of screen"
	"VRML20 uses Y-up, X-right, Y-out of screen"

	aPoint y kindDo: self.
	stream space.
	aPoint z kindDo: self.
	stream space.
	aPoint x kindDo: self.! !

!WRLWriter methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:54'!
doPoint3DCollection: aPoint3DCollection

	stream nextPut: $[.
	aPoint3DCollection 
		do:[ :each | each kindDo: self ]
		separatedBy: [stream nextPut: $, ].
	stream nextPut: $].
	! !

!WRLWriter methodsFor: 'overriding' stamp: 'emm 10/7/2012 19:16'!
doPoint4D: aPoint 
	
	"Zenna uses Z-up, Y-right, X-out of screen"
	"VRML20 uses Y-up, X-right, Y-out of screen"

	aPoint y kindDo: self.
	stream space.
	aPoint z kindDo: self.
	stream space.
	aPoint x kindDo: self.
	stream space.
	aPoint d kindDo: self.! !

!WRLWriter methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:54'!
doPoint: aPoint

	aPoint x kindDo: self.
	stream space.
	aPoint y kindDo: self! !

!WRLWriter methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:54'!
doPolygon3D: aPolygon3D

	self doPoint3DCollection: aPolygon3D.
	! !

!WRLWriter methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:54'!
doSequenceableCollection: aCollection

	stream nextPut: $[.
	aCollection 
		do:[ :each | each kindDo: self ]
		separatedBy:[ stream nextPut: $ ].
	stream nextPut: $].
	! !

!WRLWriter methodsFor: 'overriding' stamp: 'emm 02/09/2012 23:54'!
doString: aString

	stream 
		nextPut: $"
		; nextPutAll: aString
		; nextPut: $"! !

!WRLWriter methodsFor: 'proto-support' stamp: 'emm 02/09/2012 23:54'!
doUndefinedObject: aNil

	stream nextPutAll: 'NULL'! !

!WRLWriter methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:54'!
doVRMLBackground: aBackground

	self doGenericSceneElement: aBackground ! !

!WRLWriter methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:54'!
doVRMLComposite: aComposite

	self writeDEFFor: aComposite ifUse:[^self].
	stream 
		nextPutAll: aComposite className
		; nextPutAll: '{'.
	self writePropertiesFromGenericSceneElement: aComposite.
	self crIndent.
	stream nextPutAll: aComposite childrenFieldName ;nextPutAll: '['.
	self crIndent.
	aComposite children 
		do: [ :each | 	self write: each ]
		separatedBy: [ self cr ].
	stream nextPutAll: ']}'.
	self backIndent.
	self backIndent.! !

!WRLWriter methodsFor: 'proto-support' stamp: 'emm 02/09/2012 23:54'!
doVRMLProto: aProto 
	
	"Collect all variables used by its components"
	
	| vars recurs |
	vars := Set new.
	recurs := [ :here | here allElementsDo: [ :each | 
		each class == Variable 
			ifTrue:[ vars add: each ].
		each keysAndValuesDo: [ :key :value | 
			value class == Variable
				ifTrue:[ vars add: value ]
				ifFalse:[ ( value isKindOf: GenericSceneElement ) 
					ifTrue:[ recurs value: value ] ] ] ] ].
	recurs value: aProto. 
	
	stream nextPutAll: 'PROTO '.
	stream nextPutAll: aProto name.
	stream space ; nextPut: $[ ; cr.
	vars do: [ :each | 
		stream tab
			; nextPutAll: 'exposedField '
			; nextPutAll: each type
			; space
			; nextPutAll: each name
			; space.
		each value kindDo: self.
		stream cr ].
	stream nextPutAll: '] {' ; cr.
	aProto elements 
		do: [ :each | each kindDo: self ] 
		separatedBy: [ self cr ].
	aProto routes 
		do: [ :each | each kindDo: self ] 
		separatedBy: [ self cr ].
	stream nextPut: $}! !

!WRLWriter methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:54'!
doVRMLRoute: aRoute

	stream 
		nextPutAll: 'ROUTE '
		;nextPutAll: aRoute source name
		;nextPut: $.
		;nextPutAll: aRoute sourceAspect
		;nextPutAll: ' TO '
		;nextPutAll: aRoute target name
		;nextPut: $.
		;nextPutAll: aRoute targetAspect.

	statistics inc: 'routes'! !

!WRLWriter methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:54'!
doVRMLScript: aScript

	self doGenericSceneElement: aScript.

	statistics inc: 'scripts'! !

!WRLWriter methodsFor: 'proto-support' stamp: 'emm 02/09/2012 23:54'!
doVariable: aVariable

	stream 
		nextPutAll: 'IS '
		; nextPutAll: aVariable name! !

!WRLWriter methodsFor: 'private' stamp: 'emm 02/09/2012 23:54'!
hasWrittenName: aName

	^ definedNames includes: aName! !

!WRLWriter methodsFor: 'initialize-release' stamp: 'emm 02/09/2012 23:54'!
initialize

	super initialize.
	definedNames := Set new! !

!WRLWriter methodsFor: 'properties' stamp: 'emm 02/09/2012 23:54'!
invertedFloatPrecision

	"maximum of four digits"
	
	^10000! !

!WRLWriter methodsFor: 'overriding' stamp: 'emm 10/7/2012 20:49'!
undoCr
	self useIndentation
		ifTrue: [ stream skip: level negated	"remove tabs" ].
	stream skip: -2	"cr lf"	"Unix = -1, WIndows = -2"! !

!WRLWriter methodsFor: 'overriding' stamp: 'emm 02/09/2012 23:54'!
writeComment: aString

	stream nextPut: $# ;nextPutAll: aString! !

!WRLWriter methodsFor: 'private' stamp: 'emm 02/09/2012 23:54'!
writeDEFFor: anElement ifUse: aBlock

	| shortName |
	anElement hasName
		ifTrue: 
			[ ( self hasWrittenName: anElement name )
				ifTrue: 
					[ stream 
						nextPutAll: 'USE '  
						; nextPutAll: anElement name
						; space.
					aBlock value ]
				ifFalse: 	
					[ stream 
						nextPutAll: 'DEF ' 
						; nextPutAll: anElement name
						; space.
					self wroteName: anElement name.
					statistics inc: 'defined objects' ] ].
! !

!WRLWriter methodsFor: 'overriding' stamp: 'emm 02/09/2012 23:54'!
writeSignature

	self writeString: '#VRML V2.0 utf8' ;cr.
	super writeSignature.! !

!WRLWriter methodsFor: 'private' stamp: 'emm 02/09/2012 23:54'!
wroteName: aName

	^ definedNames add: aName! !

Object subclass: #GraphicsFileStatistics
	instanceVariableNames: 'polyCount meshCount textureCount countTable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-FileIO'!

!GraphicsFileStatistics class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 22:56'!
new

	"Answer a new instance of the receiver and initialize it"

	^super new initialize! !

!GraphicsFileStatistics methodsFor: 'API' stamp: 'emm 02/09/2012 22:56'!
at: aName put: aValue

	countTable at: aName put: aValue! !

!GraphicsFileStatistics methodsFor: 'API' stamp: 'emm 02/09/2012 22:56'!
inc: aName

	| count |
	count := countTable at: aName ifAbsent:[0].
	countTable at: aName put: count + 1.! !

!GraphicsFileStatistics methodsFor: 'API' stamp: 'emm 02/09/2012 22:56'!
incMeshes
	meshCount := meshCount+1! !

!GraphicsFileStatistics methodsFor: 'API' stamp: 'emm 02/09/2012 22:56'!
incPolygons
	polyCount := polyCount+1! !

!GraphicsFileStatistics methodsFor: 'API' stamp: 'emm 02/09/2012 22:56'!
incTextures
	textureCount := textureCount+1! !

!GraphicsFileStatistics methodsFor: 'initialize-release' stamp: 'emm 02/09/2012 22:56'!
initialize

	polyCount := 0.
	meshCount := 0.
	textureCount := 0.
	countTable := Dictionary new! !

!GraphicsFileStatistics methodsFor: 'printing' stamp: 'emm 02/09/2012 22:56'!
printOn: aStream 
	
	meshCount > 0 
		ifTrue:[ aStream tab ;nextPutAll: 'meshes:' ; nextPutAll: meshCount printString ;cr].
	polyCount > 0 
		ifTrue:[ aStream tab ;nextPutAll: 'polygons:' ; nextPutAll: polyCount printString;cr ].
	textureCount > 0 
		ifTrue:[ aStream tab ;nextPutAll: 'textures:' ; nextPutAll: textureCount printString;cr ].
	countTable keysAndValuesDo: [ :k :v | 
		aStream tab ;nextPutAll: k.
		aStream nextPut: $:.
		v printOn: aStream.
		aStream cr ]! !

Object subclass: #Helper3D
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Primitives3D'!

!Helper3D class methodsFor: 'points' stamp: 'emm 02/09/2012 23:36'!
addNearestPointTo: target fromAll: sourceCollection to: aPointCollection

	| dist newNearest newDist nearest |
	aPointCollection isEmpty
		ifTrue: [ ^self ].
	dist := SmallInteger maxVal.
	sourceCollection do:[ :each |
		newNearest := each bottomCenter.
		newDist := target dist: newNearest.
		(newDist < dist and:[newNearest ~= target])
			ifTrue: 
				[ dist := newDist.
				nearest := newNearest]].
	nearest isNil
		ifTrue: [ aPointCollection add: target ]
		ifFalse: [ aPointCollection add: nearest ]! !

!Helper3D class methodsFor: 'points' stamp: 'emm 02/09/2012 23:36'!
existingIntersectionBetweenLineSegment3D: aSegment3D and: otherSegment3D

	"( Triangle3D with: 1,0,0 with: 0,0,0 with: 0,1,0 ) center
	"

	"Needs attention"

	| normal planeConstant lineParameter vector |
	vector := aSegment3D end - aSegment3D start.
	normal := vector normalized.
	planeConstant := ( normal dotProduct: otherSegment3D end ) +
		( normal dotProduct: otherSegment3D start ) / 2 negated.
	lineParameter :=
		( vector dotProduct: aSegment3D start) + planeConstant /
			( normal dotProduct: normal ) negated.
	^lineParameter * normal + aSegment3D start.
	! !

!Helper3D class methodsFor: '*Zenna-Collections3D' stamp: 'emm 02/09/2012 23:43'!
facesForSolidBetween: topFace and: bottomFace do: aBlock 

	"Answer the collection of faces describing each face of a solid
	that is between the top (first) and bottom face (second).
	
	- Top and bottom are NOT included.
	- Sizes of both faces must match.
	- The points from the top must be in the opposite (clockwise) order 	with respect to those of the bottom"

	| topIndex topSize bottomIndex |

	topSize := topFace size.
	topIndex := topSize.
	bottomIndex := 1.
	[topIndex > 0]
		whileTrue: 
			[aBlock value: ((Polygon3D new)
					  addFrom: bottomFace at: bottomIndex
					; addFrom: topFace at: topIndex \\ topSize +1
					; addFrom: topFace at:  topIndex
					; yourself).
			topIndex := topIndex - 1.
			bottomIndex := bottomIndex + 1].

	topSize := topFace size.
	topIndex := topSize.
	bottomIndex := 1.
	[topIndex > 0]
		whileTrue: 
			[aBlock value: ((Polygon3D new)
					  addFrom: bottomFace at: bottomIndex
					; addFrom: topFace at:  topIndex
					; addFrom: bottomFace at: bottomIndex \\ topSize +1
					; yourself).
			topIndex := topIndex - 1.
			bottomIndex := bottomIndex + 1]

! !

!Helper3D class methodsFor: '*Zenna-Operators3D' stamp: 'emm 02/09/2012 23:46'!
lineSegmentsFromPoints: points

	| segments iterator |
	segments := OrderedCollection new.
	iterator := PairwiseCollectionIterator on: points.
	iterator fromStep: 0.
	iterator do:[ :each :other |
		segments add: (each lineSegmentTo: other) ].
	^segments
		! !

!Helper3D class methodsFor: '*Zenna-Collections3D' stamp: 'emm 02/09/2012 23:43'!
polygonsForSolidBetween: topPolygon and: bottomPolygon do: aBlock
	"Answer the collection of polygons describing each face of a solid
	that is composed from the top (first) and bottom polygon (second).
	Sizes of both polygons must match.
	The points from the top must be in the opposite (clockwise) order 
	with respect to those of the bottom"
	
	| topIndex topSize bottomIndex |
	aBlock value: topPolygon copy.
	aBlock value: bottomPolygon copy.
	topIndex := 1.
	topSize := topPolygon size.
	bottomIndex := topSize.
	[bottomIndex > 0]
		whileTrue:
			[aBlock value:( ( Polygon3D new )
				addFrom: topPolygon at: topIndex
				; addFrom: bottomPolygon at: bottomIndex \\ topSize + 1
				; addFrom: bottomPolygon at: bottomIndex - 1 \\ topSize + 1
				; addFrom: topPolygon at: topIndex \\ topSize + 1
				; yourself ).
			topIndex := topIndex + 1.
			bottomIndex := bottomIndex - 1].! !

!Helper3D class methodsFor: '*Zenna-Collections3D' stamp: 'emm 02/09/2012 23:43'!
polygonsForTwistedSolidBetween: topPolygon 
		and: bottomPolygon 
		do: aBlock

	"Answer the collection of polygons describing each face of a solid
	that is composed from the top (first) and bottom polygon (second).
	Sizes of both polygons must match.
	The points from the top must be in the opposite (clockwise) order 
	with respect to those of the bottom"
	
	| topIndex topSize bottomIndex |
	aBlock value: topPolygon copy.
	aBlock value: bottomPolygon copy.
	topIndex := 1.
	topSize := topPolygon size.
	bottomIndex := topSize.
	[bottomIndex > 0]
		whileTrue:
			[aBlock value:( ( Polygon3D new )
				addFrom: topPolygon at: topIndex
				; addFrom: bottomPolygon at: bottomIndex \\ topSize + 1
				; addFrom: bottomPolygon at: bottomIndex - 1 \\ topSize + 1
				; yourself ).
			aBlock value:( ( Polygon3D new )
				addFrom: topPolygon at: topIndex
				; addFrom: bottomPolygon at: bottomIndex - 1 \\ topSize + 1
				; addFrom: topPolygon at: topIndex \\ topSize + 1
				; yourself ).
			topIndex := topIndex + 1.
			bottomIndex := bottomIndex - 1].! !

!Helper3D class methodsFor: '*Zenna-Collections3D' stamp: 'emm 02/09/2012 23:43'!
simpleFacesForSolidBetween: topFace and: bottomFace do: aBlock 

	"Answer the collection of faces describing each face of a solid
	that is composed from the top (first) and bottom face (second).

	- Sizes of both faces must match.
	- Top and bottom are NOT included.
	- The points from the top must be in the opposite (clockwise) order with respect to those of the bottom"

	| topIndex topSize bottomIndex |

	topIndex := 1.
	topSize := topFace size.
	bottomIndex := topSize.
	[bottomIndex > 0]
		whileTrue: 
			[aBlock value: ((Polygon3D new)
					 addFrom: topFace at: topIndex
					; addFrom: bottomFace at: bottomIndex \\ topSize + 1
					; addFrom: bottomFace at: bottomIndex - 1 \\ topSize + 1
					; addFrom: topFace at: topIndex \\ topSize + 1
					; yourself).
			topIndex := topIndex + 1.
			bottomIndex := bottomIndex - 1]! !

Object subclass: #KeyedValueInterpolator
	instanceVariableNames: 'keys values'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Animation3D'!

!KeyedValueInterpolator methodsFor: 'computing' stamp: 'emm 02/09/2012 23:29'!
computeValueAtFraction: fraction

	"fraction = [0..1]"

	| high keyHigh valueLow valueHigh |
	high := 1.
	"find high index"
	[ high ~= keys size 
		and:
			[ keyHigh := keys at: high.
			keyHigh = fraction
				ifTrue: [ ^values at: high ].
			keyHigh < fraction] ]
		whileTrue:
			[ high := high + 1 ].
	keyHigh := keys at: high.
	keyHigh = fraction
		ifTrue: [ ^values at: high ].
	"interpolate"
	valueHigh := values at: high.
	valueLow := values at: high - 1.
	^( ( valueHigh - valueLow ) / ( keyHigh - ( keys at: high - 1)) ) * ( fraction - (keys at: high - 1)) + valueLow
! !

!KeyedValueInterpolator methodsFor: 'computing' stamp: 'emm 02/09/2012 23:29'!
computeValueAtFractionOne

	^self values last! !

!KeyedValueInterpolator methodsFor: 'computing' stamp: 'emm 02/09/2012 23:29'!
computeValueAtFractionZero

	^self values first! !

!KeyedValueInterpolator methodsFor: 'VRML' stamp: 'emm 02/09/2012 23:29'!
key
	^keys! !

!KeyedValueInterpolator methodsFor: 'VRML' stamp: 'emm 02/09/2012 23:29'!
key: anArray
	keys := anArray! !

!KeyedValueInterpolator methodsFor: 'VRML' stamp: 'emm 02/09/2012 23:29'!
keyValue
	^values! !

!KeyedValueInterpolator methodsFor: 'VRML' stamp: 'emm 02/09/2012 23:29'!
keyValue: anArray
	values := anArray! !

!KeyedValueInterpolator methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:29'!
keys

	"Answer the value of keys"

	^keys! !

!KeyedValueInterpolator methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:29'!
keys: aValue

	"Set the value of keys"

	keys := aValue! !

!KeyedValueInterpolator methodsFor: 'events' stamp: 'emm 02/09/2012 23:29'!
set_fraction: newValue

	newValue <= self keys first
		ifTrue: [ self changed: #value_changed with: self computeValueAtFractionZero ].
	newValue >= self keys last
		ifTrue: [  self changed: #value_changed with: self computeValueAtFractionOne ].	
	 self changed: #value_changed with: (self computeValueAtFraction: newValue )
	! !

!KeyedValueInterpolator methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:29'!
values

	"Answer the value of values"

	^values! !

!KeyedValueInterpolator methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:29'!
values: aValue

	"Set the value of values"

	values := aValue! !

KeyedValueInterpolator subclass: #RotationInterpolator
	instanceVariableNames: 'axis'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Animation3D'!

!RotationInterpolator methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:29'!
axis

	"Answer the value of axis"

	^axis! !

!RotationInterpolator methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:29'!
axis: aValue

	"Set the value of axis"

	axis := aValue! !

!RotationInterpolator methodsFor: 'computing' stamp: 'emm 02/09/2012 23:29'!
computeValueAtFraction: fraction

	^(super computeValueAtFraction: fraction) * self axis! !

!RotationInterpolator methodsFor: 'computing' stamp: 'emm 02/09/2012 23:29'!
computeValueAtFractionOne

	^(super computeValueAtFractionOne) * self axis! !

!RotationInterpolator methodsFor: 'computing' stamp: 'emm 02/09/2012 23:29'!
computeValueAtFractionZero

	^(super computeValueAtFractionZero) * self axis! !

Object subclass: #LSContext
	instanceVariableNames: 'position angle color gravity geometric vector rotation scale'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Lindenmayer'!

!LSContext class methodsFor: 'instance-creation' stamp: 'emm 03/09/2012 22:05'!
new

	"Answer a new instance of the receiver and initialize it"

	^super new initialize! !

!LSContext methodsFor: 'accessing' stamp: 'emm 03/09/2012 22:05'!
angle

	"Answer the value of angle"

	^angle! !

!LSContext methodsFor: 'accessing' stamp: 'emm 03/09/2012 22:05'!
angle: aValue

	"Set the value of angle"

	angle := aValue! !

!LSContext methodsFor: 'accessing' stamp: 'emm 03/09/2012 22:05'!
color

	"Answer the value of color"

	^color! !

!LSContext methodsFor: 'accessing' stamp: 'emm 03/09/2012 22:05'!
color: aValue

	"Set the value of color"

	color := aValue! !

!LSContext methodsFor: 'modification' stamp: 'emm 03/09/2012 22:05'!
colorIndex
	"for now"

	^color! !

!LSContext methodsFor: 'modification' stamp: 'emm 03/09/2012 22:05'!
colorIndex: index
	"for now"

	color := index.! !

!LSContext methodsFor: 'accessing' stamp: 'emm 03/09/2012 22:05'!
geometric

	"Answer the value of geometric"

	^geometric! !

!LSContext methodsFor: 'accessing' stamp: 'emm 03/09/2012 22:05'!
geometric: aValue

	"Set the value of geometric"

	geometric := aValue.
	self vector: 0,0, aValue bounds extent z! !

!LSContext methodsFor: 'accessing' stamp: 'emm 03/09/2012 22:05'!
gravity

	"Answer the value of gravity"

	^gravity! !

!LSContext methodsFor: 'accessing' stamp: 'emm 03/09/2012 22:05'!
gravity: aValue

	"Set the value of gravity"

	gravity := aValue! !

!LSContext methodsFor: 'initialize-release' stamp: 'emm 03/09/2012 22:05'!
initialize

	self scale: 1,1,1.
	self	position: 0,0,0.
	self rotation: 0,0,0.! !

!LSContext methodsFor: 'modification' stamp: 'emm 03/09/2012 22:05'!
length

	^self scale z! !

!LSContext methodsFor: 'modification' stamp: 'emm 03/09/2012 22:05'!
length: amount

	^self scale: ( self scale x , self scale y , amount )! !

!LSContext methodsFor: 'accessing' stamp: 'emm 03/09/2012 22:05'!
position

	"Answer the value of position"

	^position! !

!LSContext methodsFor: 'accessing' stamp: 'emm 03/09/2012 22:05'!
position: aValue

	"Set the value of position"

	position := aValue! !

!LSContext methodsFor: 'accessing' stamp: 'emm 03/09/2012 22:05'!
rotation

	"Answer the value of rotation"

	^rotation! !

!LSContext methodsFor: 'accessing' stamp: 'emm 03/09/2012 22:05'!
rotation: aValue

	"Set the value of rotation"

	rotation := aValue! !

!LSContext methodsFor: 'accessing' stamp: 'emm 03/09/2012 22:05'!
scale

	^scale
	! !

!LSContext methodsFor: 'accessing' stamp: 'emm 03/09/2012 22:05'!
scale: aValue

	"Set the value of scale"

	(aValue x = 0 or:[ aValue y = 0 or:[ aValue z = 0]]) ifTrue: [ 1 halt ].
	scale := aValue! !

!LSContext methodsFor: 'modification' stamp: 'emm 03/09/2012 22:05'!
scaleAngleBy: amount

	self angle: self angle * amount! !

!LSContext methodsFor: 'modification' stamp: 'emm 03/09/2012 22:05'!
scaleLengthBy: amount

	self length: self length * amount.
	self vector: self vector * amount.! !

!LSContext methodsFor: 'modification' stamp: 'emm 03/09/2012 22:05'!
scaleThicknessBy: amount 
	
	self thickness: self thickness * amount! !

!LSContext methodsFor: 'modification' stamp: 'emm 03/09/2012 22:05'!
thickness

	^self scale x * 100! !

!LSContext methodsFor: 'modification' stamp: 'emm 03/09/2012 22:05'!
thickness: percentage 
	
	self scale: ( ( percentage / 100.0 ) , ( percentage / 100.0 ) , self scale z )! !

!LSContext methodsFor: 'accessing' stamp: 'emm 03/09/2012 22:05'!
vector

	"Answer the value of vector"

	^vector! !

!LSContext methodsFor: 'accessing' stamp: 'emm 03/09/2012 22:05'!
vector: aValue

	"Set the value of vector"

	vector := aValue! !

Object subclass: #LindenmayerSystem
	instanceVariableNames: 'rules axiom recursionDepth angle thickness'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Lindenmayer'!

!LindenmayerSystem class methodsFor: 'examples' stamp: 'emm 03/09/2012 22:05'!
example0
	"self example2"

	^self readFromString:

'5	# recursion
30	# angle
10	# thickness
A
A=F+Z
@	# end of file'! !

!LindenmayerSystem class methodsFor: 'examples' stamp: 'emm 03/09/2012 22:05'!
example1

	| s |
	s := LindenmayerSystem new.
	s axiom: 'AB'.
	s addRule: 'A=+FA[B]'.
	s addRule: 'B=-FAF'.

	s recursionDepth: 8.
	s angle: 15.
	s thickness: 10.
	^s! !

!LindenmayerSystem class methodsFor: 'examples' stamp: 'emm 03/09/2012 22:05'!
example2
	"self example2"

	^self readFromString:

'5	# recursion
30	# angle
10	# thickness
A
A=F+Z
@	# end of file'! !

!LindenmayerSystem class methodsFor: 'inspecting' stamp: 'emm 03/09/2012 22:05'!
inspectActions
	"self inspect"

	^#(example0 example1)! !

!LindenmayerSystem class methodsFor: 'API-instance-creation' stamp: 'emm 03/09/2012 22:05'!
new

	^super new initialize! !

!LindenmayerSystem class methodsFor: 'API-instance-creation' stamp: 'emm 03/09/2012 22:05'!
readFromFileNamed: aString

	^self readFromStream: aString asFilename readStream! !

!LindenmayerSystem class methodsFor: 'API-instance-creation' stamp: 'emm 03/09/2012 22:05'!
readFromStream: aStream

	^( LSReader on: aStream ) readSystem

	! !

!LindenmayerSystem class methodsFor: 'API-instance-creation' stamp: 'emm 03/09/2012 22:05'!
readFromString: aString

	^self readFromStream: (ReadStream on: aString)

	! !

!LindenmayerSystem methodsFor: 'rules-accessing' stamp: 'emm 03/09/2012 22:05'!
addRule: aString 
	"Format:
		<ch>=<string> , | string | > 0"

	| name definition |
	name := aString first.
	definition := aString copyFrom: 3 to: aString size.
	self atRule: name put: definition! !

!LindenmayerSystem methodsFor: 'accessing' stamp: 'emm 03/09/2012 22:05'!
angle

	"Answer the value of angle"

	^angle! !

!LindenmayerSystem methodsFor: 'accessing' stamp: 'emm 03/09/2012 22:05'!
angle: aValue

	"Set the value of angle"

	angle := aValue! !

!LindenmayerSystem methodsFor: 'rules-accessing' stamp: 'emm 03/09/2012 22:05'!
atRule: aChar put: aDefinitionStringOrChar 

	rules at: aChar asInteger put: aDefinitionStringOrChar! !

!LindenmayerSystem methodsFor: 'accessing' stamp: 'emm 03/09/2012 22:05'!
axiom

	^axiom! !

!LindenmayerSystem methodsFor: 'accessing' stamp: 'emm 03/09/2012 22:05'!
axiom: aString 

	axiom := aString! !

!LindenmayerSystem methodsFor: 'API' stamp: 'emm 03/09/2012 22:05'!
composeUsing: aGeometric addingTo: aBuilder

	| parser |
	parser := LSParser new.
	parser
		initializeFromSystem: self
		geometric: aGeometric 
		builder: aBuilder.
	parser parse: self expandedAxiom! !

!LindenmayerSystem methodsFor: 'rules-accessing' stamp: 'emm 03/09/2012 22:05'!
definedRules

	| defined outStream |
	defined := SortedCollection new.
	rules keysAndValuesDo: [:key :value | 
		( value isCharacter or: [ value isEmpty ] )
			ifFalse: 
				[ outStream := '' writeStream.
				outStream
					 nextPut: ( Character value: key )
					; nextPut: $=
					; nextPutAll: value.
				defined add: outStream contents ]].
	^defined! !

!LindenmayerSystem methodsFor: 'rules-accessing' stamp: 'emm 03/09/2012 22:05'!
expandedAxiom

	| inStream outStream ch rule expandedRule |
	expandedRule := axiom.
	recursionDepth
		timesRepeat: 
			[ inStream := expandedRule readStream.
			outStream := ( String new: expandedRule size * 2 ) writeStream.
			[ inStream atEnd ]
				whileFalse: 
					[ ch := inStream next.
					rule := rules at: ch asInteger.
					rule isString not
						ifTrue: [ outStream nextPut: rule ]
						ifFalse: [ outStream nextPutAll: rule ] ].
			expandedRule := outStream contents ].
	^self withoutDefinedRuleReferencesIn: expandedRule! !

!LindenmayerSystem methodsFor: 'initialize-release' stamp: 'emm 03/09/2012 22:05'!
initialize

	rules := Array new: 256 withAll: ''.
	self nonExpandingCharactersString do: [:ch | 
		self atRule: ch put: ch].

	"default settings"
	recursionDepth := 1.
	angle := 30. "degrees"
	thickness := 10. "percentage of length"! !

!LindenmayerSystem methodsFor: 'inspecting' stamp: 'emm 03/09/2012 22:05'!
inspectActions

	^#(expandedAxiom)! !

!LindenmayerSystem methodsFor: 'rules-accessing' stamp: 'emm 03/09/2012 22:05'!
nonExpandingCharactersString

	^'+-&^<>%|!!?:;c[]{}FftgZz*$~.1234567890()_''"'! !

!LindenmayerSystem methodsFor: 'printing' stamp: 'emm 03/09/2012 22:05'!
printOn: aStream 

	aStream
		 nextPutAll: 'recursion:'
		; print: self recursionDepth
		; cr; nextPutAll: 'angle [deg]:'
		; print: self angle
		; cr; nextPutAll: 'thickness [%]:'
		; print: self thickness
		; cr; nextPutAll: 'axiom:'
		; nextPutAll: self axiom
		; cr.
	self definedRules do: [:each | aStream nextPutAll: each; cr]! !

!LindenmayerSystem methodsFor: 'reading' stamp: 'emm 03/09/2012 22:05'!
readAxiomAndRulesFromString: aString

	| reader |
	reader := LSReader new.
	reader system: self.
	reader stream: (ReadStream on: aString).
	reader readAxiomAndRules! !

!LindenmayerSystem methodsFor: 'accessing' stamp: 'emm 03/09/2012 22:05'!
recursionDepth

	^recursionDepth! !

!LindenmayerSystem methodsFor: 'accessing' stamp: 'emm 03/09/2012 22:05'!
recursionDepth: aValue

	recursionDepth := aValue! !

!LindenmayerSystem methodsFor: 'accessing' stamp: 'emm 03/09/2012 22:05'!
thickness

	"Answer the value of thickness"

	^thickness! !

!LindenmayerSystem methodsFor: 'accessing' stamp: 'emm 03/09/2012 22:05'!
thickness: aValue

	"Set the value of thickness"

	thickness := aValue! !

!LindenmayerSystem methodsFor: 'rules-accessing' stamp: 'emm 03/09/2012 22:05'!
withoutDefinedRuleReferencesIn: aString

	| inStream reserved outStream |
	reserved := self nonExpandingCharactersString.
	inStream := ReadStream on: aString.
	outStream := WriteStream on:  ( String new: aString size).
	[inStream atEnd]
		whileFalse:
			[ | ch |
			ch := inStream next.
			( reserved includes: ch )
				ifTrue: [ outStream nextPut: ch ]].
	^outStream contents
			! !

Object subclass: #LineSegmentsExpander
	instanceVariableNames: 'point1 point2 width startAngle stopAngle offset'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Modelling3D'!

!LineSegmentsExpander methodsFor: 'API' stamp: 'emm 02/09/2012 23:50'!
expandAll: aLineSegmentCollection

	| start_right  segment start_left end_right end_left polygons| 
	polygons := OrderedCollection new.

	self la: (segment := aLineSegmentCollection first).
	start_right := segment from + point1.
	start_left := segment from + point2.

	1 to: aLineSegmentCollection size - 1 do:[ :index |
		self la: (aLineSegmentCollection at: index) lb: (aLineSegmentCollection at: index+1).
		end_right := start_right + point1.
		end_left := start_left + point2.
		polygons add: ((Polygon3D new)
			add: start_right
			;add: start_left
			;add: end_left
			;add: end_right
			;yourself).
		start_right := end_right.
		start_left := end_left].

	self lb: aLineSegmentCollection last.
	end_right := start_right + point1.
	end_left := start_left + point2.
	polygons add: ((Polygon3D new)
		add: start_right
		;add: start_left
		;add: end_left
		;add: end_right
		;yourself).

	^polygons
	! !

!LineSegmentsExpander methodsFor: 'private' stamp: 'emm 02/09/2012 23:50'!
la: la

	"va is de start line segment
	beta is de hoek van het vlak loodrecht op het segment"

	| va cp l |
	va := la to - la from.
	l := self startAngle tan * width / 2. 
	
	cp := ( va crossProduct: 0 , 0 , 1 ) normalized.
	point1 := ( cp * width / 2 ) + ( va normalized * l ).
	point2 := ( cp * width / 2 ) negated - ( va normalized * l ).
	offset := l negated! !

!LineSegmentsExpander methodsFor: 'private' stamp: 'emm 02/09/2012 23:50'!
la: la lb: lb

	| va vb cp alfa l |
	va := la to - la from.
	vb := lb to - lb from.
	cp := ( va crossProduct: 0 , 0 , 1 ) normalized.
	alfa := va angleTo: vb.
	alfa := alfa * ( va crossProduct: vb ) z sign.
	l := ( alfa / 2 ) tan * width / 2.
	point1 := va normalized * ( va r + l + offset ).
	point2 := va normalized * ( va r - l - offset ).
	offset := l! !

!LineSegmentsExpander methodsFor: 'private' stamp: 'emm 02/09/2012 23:50'!
lb: lb
	"
	lb is het eind line segment
	beta is de hoek van het vlak loodrecht op het segment
	"

	| va  vb cp alfa l a1 a2|
	vb := lb to - lb from.
	l := self stopAngle tan * width / 2.
	point1 :=  vb normalized * (vb r + l + offset).
	point2 :=  vb normalized * (vb r - l - offset).
	offset := l.
! !

!LineSegmentsExpander methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:50'!
point1

	"Answer the value of point1"

	^point1! !

!LineSegmentsExpander methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:50'!
point1: aValue

	"Set the value of point1"

	point1 := aValue! !

!LineSegmentsExpander methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:50'!
point2

	"Answer the value of point2"

	^point2! !

!LineSegmentsExpander methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:50'!
point2: aValue

	"Set the value of point2"

	point2 := aValue! !

!LineSegmentsExpander methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:50'!
startAngle

	"Answer the value of startAngle"

	^startAngle ifNil:[0]! !

!LineSegmentsExpander methodsFor: 'API' stamp: 'emm 02/09/2012 23:50'!
startAngle: aValue

	"Set the value of startAngle"

	startAngle := aValue! !

!LineSegmentsExpander methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:50'!
stopAngle

	"Answer the value of stopAngle"

	^stopAngle ifNil:[0]! !

!LineSegmentsExpander methodsFor: 'API' stamp: 'emm 02/09/2012 23:50'!
stopAngle: aValue

	"Set the value of stopAngle"

	stopAngle := aValue! !

!LineSegmentsExpander methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:50'!
width

	"Answer the value of width"

	^width! !

!LineSegmentsExpander methodsFor: 'API' stamp: 'emm 02/09/2012 23:50'!
width: aValue

	"Set the value of width"

	width := aValue! !

Object subclass: #Matrix3x3
	instanceVariableNames: 'e11 e12 e13 e21 e22 e23 e31 e32 e33'
	classVariableNames: ''
	poolDictionaries: 'Math3DConstants'
	category: 'Zenna-Structures3D'!

!Matrix3x3 class methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:16'!
dimension
	^3@3! !

!Matrix3x3 class methodsFor: 'instance creation' stamp: 'emm 02/09/2012 23:16'!
identity

	^self new setUnity! !

!Matrix3x3 class methodsFor: 'instance creation' stamp: 'emm 02/09/2012 23:16'!
rotation: aPointOfAngles 
	"should be optimized"

	| composed |
	^aPointOfAngles x = 0
		ifTrue: [aPointOfAngles y = 0
				ifTrue: [aPointOfAngles z = 0
						ifTrue: [self identity]
						ifFalse: [self rotationZ: aPointOfAngles z]]
				ifFalse: 
					[composed := self rotationY: aPointOfAngles y.
					aPointOfAngles z = 0
						ifTrue: [composed]
						ifFalse: [composed * (self rotationZ: aPointOfAngles z)]]]
		ifFalse: 
			[composed := self rotationX: aPointOfAngles x.
			aPointOfAngles y = 0
				ifTrue: [aPointOfAngles z = 0
						ifTrue: [composed]
						ifFalse: [composed * (self rotationZ: aPointOfAngles z)]]
				ifFalse: 
					[composed := composed * (self rotationY: aPointOfAngles y).
					aPointOfAngles z = 0
						ifTrue: [composed]
						ifFalse: [composed * (self rotationZ: aPointOfAngles z)]]]! !

!Matrix3x3 class methodsFor: 'instance creation' stamp: 'emm 02/09/2012 23:16'!
rotation: angle aboutLine: aLine 
	"Answer a rotation matrix about an arbitrary line"

	^self new setRotation: angle aboutLine: aLine! !

!Matrix3x3 class methodsFor: 'instance creation' stamp: 'emm 02/09/2012 23:16'!
rotationX: angle 
	"Answer a rotation matrix about the x-axis by < angle >"

	^self new setRotationX: angle! !

!Matrix3x3 class methodsFor: 'instance creation' stamp: 'emm 02/09/2012 23:16'!
rotationY: angle 
	"Answer a rotation matrix about the y-axis by < angle >"

	^self new setRotationY: angle! !

!Matrix3x3 class methodsFor: 'instance creation' stamp: 'emm 02/09/2012 23:16'!
rotationZ: angle 
	"Answer a rotation matrix about the z-axis by < angle >"

	^self new setRotationZ: angle! !

!Matrix3x3 class methodsFor: 'instance creation' stamp: 'emm 02/09/2012 23:16'!
scale: aNumberOrPoint 
	
	| scalePoint |
	scalePoint := aNumberOrPoint asPoint3D.
	^( self identity ) e11: scalePoint x ; e22: scalePoint y ; e33: scalePoint z! !

!Matrix3x3 methodsFor: 'arithmetic' stamp: 'emm 02/09/2012 23:16'!
* anArgument

	^anArgument productFromMatrix3x3: self! !

!Matrix3x3 methodsFor: 'converting' stamp: 'emm 02/09/2012 23:16'!
asMatrix4x4

	self error: 'not yet implemented'! !

!Matrix3x3 methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:16'!
dimension
	^self class dimension! !

!Matrix3x3 methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:16'!
e11

	^e11! !

!Matrix3x3 methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:16'!
e11: aValue

	e11 := aValue! !

!Matrix3x3 methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:16'!
e12

	^e12! !

!Matrix3x3 methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:16'!
e12: aValue

	e12 := aValue! !

!Matrix3x3 methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:16'!
e13

	^e13! !

!Matrix3x3 methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:16'!
e13: aValue

	e13 := aValue! !

!Matrix3x3 methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:16'!
e21

	^e21! !

!Matrix3x3 methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:16'!
e21: aValue

	e21 := aValue! !

!Matrix3x3 methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:16'!
e22

	^e22! !

!Matrix3x3 methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:16'!
e22: aValue

	e22 := aValue! !

!Matrix3x3 methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:16'!
e23

	^e23! !

!Matrix3x3 methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:16'!
e23: aValue

	e23 := aValue! !

!Matrix3x3 methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:16'!
e31

	^e31! !

!Matrix3x3 methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:16'!
e31: aValue

	e31 := aValue! !

!Matrix3x3 methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:16'!
e32

	^e32! !

!Matrix3x3 methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:16'!
e32: aValue

	e32 := aValue! !

!Matrix3x3 methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:16'!
e33

	^e33! !

!Matrix3x3 methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:16'!
e33: aValue

	e33 := aValue! !

!Matrix3x3 methodsFor: 'printing' stamp: 'emm 02/09/2012 23:16'!
printOn: aStream 

	aStream
		 nextPutAll: '( '
		; print: e11
		; space
		; print: e12
		; space
		; print: e13
		; nextPutAll: ' | '
		; print: e21
		; space
		; print: e22
		; space
		; print: e23
		; nextPutAll: ' | '
		; print: e31
		; space
		; print: e32
		; space
		; print: e33
		; nextPutAll: ' | '
		; nextPutAll: ' )'! !

!Matrix3x3 methodsFor: 'double dispatching' stamp: 'emm 02/09/2012 23:16'!
productFromMatrix3x3: argMatrix 
	"Answer the result of multiplying the argument aMatrix by the receiver.

	Usage:	newMatrix3x3 := thisMatrix3x3 * argMatrix3x3"

	^(self class new)
		 e11: e11 * argMatrix e11 + (e12 * argMatrix e21) + (e13 * argMatrix e31)
		; e12: e11 * argMatrix e12 + (e12 * argMatrix e22) + (e13 * argMatrix e32)
		; e13: e11 * argMatrix e13 + (e12 * argMatrix e23) + (e13 * argMatrix e33)
		; e21: e21 * argMatrix e11 + (e22 * argMatrix e21) + (e23 * argMatrix e31)
		; e22: e21 * argMatrix e12 + (e22 * argMatrix e22) + (e23 * argMatrix e32)
		; e23: e21 * argMatrix e13 + (e22 * argMatrix e23) + (e23 * argMatrix e33)
		; e31: e31 * argMatrix e11 + (e32 * argMatrix e21) + (e33 * argMatrix e31)
		; e32: e31 * argMatrix e12 + (e32 * argMatrix e22) + (e33 * argMatrix e32)
		; e33: e31 * argMatrix e13 + (e32 * argMatrix e23) + (e33 * argMatrix e33)! !

!Matrix3x3 methodsFor: 'double dispatching' stamp: 'emm 02/09/2012 23:16'!
productFromOrderedPoint3DCollection: aPointCollection 

	| result collection x y z |
	result := (collection := aPointCollection collection) copy.
	1 to: collection size by: 3 do: [:i | 
		x := collection at: i.
		y := collection at: i + 1.
		z := collection at: i + 2.
		result at: i       put: e11 * x + (e12 * y) + (e13 * z).
		result at: i + 1 put: e21 * x + (e22 * y) + (e23 * z).
		result at: i + 2 put: e31 * x + (e32 * y) + (e33 * z)].
	^aPointCollection class new collection: result! !

!Matrix3x3 methodsFor: 'double dispatching' stamp: 'emm 02/09/2012 23:16'!
productFromPoint3D: aPoint3D 
	"Answer a new Point3D that is the result 
	of the multiplication of the argument by the receiver"

	| x y z |
	^aPoint3D class
		x: e11 * (x := aPoint3D x) 
			+ (e12 * (y := aPoint3D y)) 
			+ (e13 * (z := aPoint3D z))
		y: e21 * x
			+ (e22 * y) 
			+ (e23 * z)
		z: e31 * x 
			+ (e32 * y) 
			+ (e33 * z)! !

!Matrix3x3 methodsFor: 'private' stamp: 'emm 02/09/2012 23:16'!
setRotation: angle aboutLine: aLine 
	"Answer a rotation matrix about an arbitrary line. 
	Lit: 	Ellzey, M., Kreinovich, V. and Pena, J. 
	Computers and Graphics, Vol. 17, no. 2, pp.121-126, 1993"

	| p1 p2 a b c aa bb cc ll cosA d s sa sb sc da dab dac dbc |
	p1 := aLine start.	"extract p1 and p2"
	p2 := aLine end.	"step 1"
	cosA := angle cos.
	a := p2 x - p1 x.
	b := p2 y - p1 y.
	c := p2 z - p1 z.	"step 2"
	aa := a * a.
	bb := b * b.
	cc := c * c.
	ll := aa + bb + cc.	"step 3"
	d := 1 - cosA / ll.
	s := angle sin / ll sqrt.	"step 4"
	sa := s * a.
	sb := s * b.
	sc := s * c.	"step 5"
	da := d * a.
	dab := da * b.
	dac := da * c.
	dbc := d * b * c.	"step 6"
	e11 := d * aa + cosA.
	e21 := dab + sc.
	e31 := dac - sb.
	e12 := dab - sc.
	e22 := d * bb + cosA.
	e32 := dbc + sa.
	e13 := dac + sb.
	e23 := dbc - sa.
	e33 := d * cc + cosA! !

!Matrix3x3 methodsFor: 'private' stamp: 'emm 02/09/2012 23:16'!
setRotationX: angle 

	| cosA sinA |
	e11 := 1.
	e12 := e13 := e21 := e31 := 0.
	e22 := cosA := angle abs = HalfPi
						ifTrue: [0]
						ifFalse: [angle cos].
	e23 := (sinA := angle sin) negated.
	e32 := sinA.
	e33 := cosA! !

!Matrix3x3 methodsFor: 'private' stamp: 'emm 02/09/2012 23:16'!
setRotationY: angle 

	| cosA sinA |
	e11 := cosA := angle abs = HalfPi
						ifTrue: [0]
						ifFalse: [angle cos].
	e12 := e21 := e23 := e32 := 0.
	e13 := sinA := angle sin.
	e22 := 1.
	e31 := sinA negated.
	e33 := cosA! !

!Matrix3x3 methodsFor: 'private' stamp: 'emm 02/09/2012 23:16'!
setRotationZ: angle 

	| cosA sinA |
	e11 := cosA := angle abs = HalfPi
						ifTrue: [0]
						ifFalse: [angle cos].
	e12 := (sinA := angle sin) negated.
	e13 := e23 := e31 := e32 := 0.
	e21 := sinA.
	e22 := cosA.
	e33 := 1! !

!Matrix3x3 methodsFor: 'private' stamp: 'emm 02/09/2012 23:16'!
setUnity

	e11 := e22 := e33 := 1.
	e12 := e13 := e21 := e23 := e31 := e32 := 0! !

Matrix3x3 subclass: #Matrix4x4
	instanceVariableNames: 'e14 e24 e34 e44 e41 e42 e43'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Structures3D'!

!Matrix4x4 class methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:16'!
dimension
	^4@4! !

!Matrix4x4 methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:16'!
e14

	"Answer the value of e14"

	^e14! !

!Matrix4x4 methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:16'!
e14: aValue

	"Set the value of e14"

	e14 := aValue! !

!Matrix4x4 methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:16'!
e24

	"Answer the value of e24"

	^e24! !

!Matrix4x4 methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:16'!
e24: aValue

	"Set the value of e24"

	e24 := aValue! !

!Matrix4x4 methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:16'!
e34

	"Answer the value of e34"

	^e34! !

!Matrix4x4 methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:16'!
e34: aValue

	"Set the value of e34"

	e34 := aValue! !

!Matrix4x4 methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:16'!
e41

	"Answer the value of e41"

	^e41! !

!Matrix4x4 methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:16'!
e41: aValue

	"Set the value of e41"

	e41 := aValue! !

!Matrix4x4 methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:16'!
e42

	"Answer the value of e42"

	^e42! !

!Matrix4x4 methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:16'!
e42: aValue

	"Set the value of e42"

	e42 := aValue! !

!Matrix4x4 methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:16'!
e43

	"Answer the value of e43"

	^e43! !

!Matrix4x4 methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:16'!
e43: aValue

	"Set the value of e43"

	e43 := aValue! !

!Matrix4x4 methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:16'!
e44

	"Answer the value of e44"

	^e44! !

!Matrix4x4 methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:16'!
e44: aValue

	"Set the value of e44"

	e44 := aValue! !

Object subclass: #Mesh
	instanceVariableNames: 'vertices indexedFaces textureCoordinates materials'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-SceneBuilding3D'!

!Mesh class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:28'!
fromTriangle3DCollection: aCollection

	! !

!Mesh methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:28'!
indexedFaces
	^indexedFaces! !

!Mesh methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:28'!
indexedFaces: anObject
	indexedFaces := anObject! !

!Mesh methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:28'!
kindDo: aRequestor
	^aRequestor doMesh: self! !

!Mesh methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:28'!
materials
	^materials! !

!Mesh methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:28'!
materials: anObject
	materials := anObject! !

!Mesh methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:28'!
textureCoordinates
	^textureCoordinates ifNil:[#()]! !

!Mesh methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:28'!
textureCoordinates: anObject
	textureCoordinates := anObject! !

!Mesh methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:28'!
vertices
	^vertices! !

!Mesh methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:28'!
vertices: anObject
	vertices := anObject! !

Object subclass: #MeshData
	instanceVariableNames: 'vertices faces verticesPerFace facesPerVertex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-SceneBuilding3D'!

!MeshData methodsFor: 'computing' stamp: 'emm 02/09/2012 23:27'!
computeVertexNormals

	^facesPerVertex collect:[ :faceCollection | 
			( faceCollection inject: 0,0,0 into:[ :normal :each | 
				normal + each normal ] ) normalized ].! !

!MeshData methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:27'!
faces

	"Answer the value of faces"

	^faces! !

!MeshData methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:27'!
facesPerVertex

	"Answer the value of facesPerVertex"

	^facesPerVertex! !

!MeshData methodsFor: 'initialize-release' stamp: 'emm 02/09/2012 23:27'!
initializeFromFaces: aFaceCollection

	faces := aFaceCollection.
	verticesPerFace := Array new: faces size.
	facesPerVertex := OrderedCollection new.
	vertices := OrderedCollection new.
	faces doWithIndex: [ :eachFace :faceIndex |
		verticesPerFace 
			at: faceIndex 
			put: ( eachFace vertices collect:[ :eachVertex | 
						| vertexIndex |
						( vertexIndex := vertices indexOf: eachVertex ) = 0
							ifTrue: 	
								[ vertices add: eachVertex.
								facesPerVertex add: (OrderedCollection with: eachFace ).
								vertexIndex := vertices size ]
							ifFalse: 
								[ ( facesPerVertex at: vertexIndex) add: eachFace.
								vertexIndex ] ] ) ].

	! !

!MeshData methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:27'!
kindDo: aRequestor
	^aRequestor doMeshData: self! !

!MeshData methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:27'!
vertexNormals

	^self computeVertexNormals! !

!MeshData methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:27'!
vertices

	"Answer the value of vertices"

	^vertices! !

!MeshData methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:27'!
verticesPerFace

	"Answer the value of verticesPerFace"

	^verticesPerFace! !

!Object class methodsFor: '*Zenna-TaggedData' stamp: 'emm 24/10/2002 12:04'!
readFromTagValueString: aString
	"Use default method"
	
	^self fromString: aString
	! !

!Object class methodsFor: '*Zenna-TaggedData' stamp: 'emm 10/03/2003 13:05'!
readXMLFrom: aStream 

	^self readXMLFrom: aStream using: self tagClassMap! !

!Object class methodsFor: '*Zenna-TaggedData' stamp: 'emm 10/03/2003 13:05'!
readXMLFrom: aStream using: tagClassMap

	| parser result |
	parser := TaggedDataParser new.
	parser classMap: tagClassMap.
	result := parser parseStream: aStream.
	result isNil ifTrue: [self error: 'parse error'].
	^result! !

!Object class methodsFor: '*Zenna-TaggedData' stamp: 'emm 22/10/2003 20:54'!
readXMLFromFile: aFilename
	"Pre: the file named aFilename exists"
	
	| xmlStream result|
	xmlStream := aFilename asFilename readStream.
	[result := self readXMLFrom: xmlStream]
		ensure:[xmlStream close].
	^result
		! !

!Object class methodsFor: '*Zenna-TaggedData' stamp: 'emm 10/03/2003 11:52'!
tagClassMap
	"Answer a map associating tag names to reader classes"
	
	^Dictionary new! !

!Object methodsFor: '*Zenna-SceneBuilding2D' stamp: 'emm 02/09/2012 23:02'!
addTo: aCollection
	^aCollection addObject: self! !

!Object methodsFor: '*Zenna-TaggedData' stamp: 'emm 22/10/2003 21:09'!
asXML
	"Answer a string representation of the receiver in XML format"
	
	| writer |
	writer := TaggedDataWriter on: (String new:256) writeStream.
	self printHeaderWith: writer.
	self printTaggedWith: writer.
	^writer stream contents! !

!Object methodsFor: '*Zenna-Extensions' stamp: 'emm 9/22/2012 22:09'!
isSequenceable 
	^false! !

!Object methodsFor: '*Zenna-TaggedData' stamp: 'emm 03/07/2003 12:07'!
printHeaderWith: aTaggedDataWriter
	"The default header is <?xml version=''1.0''?>
	Subclasses may extend this to add comment"
	
	aTaggedDataWriter printHeader! !

!Object methodsFor: '*Zenna-TaggedData' stamp: 'emm 13/09/2003 20:10'!
printTaggedWith: aWriter
	"On default, print the receiver on the stream of @aWriter"
	
	aWriter printStringData: (self isString ifTrue:[self] ifFalse:[self printString])! !

!Object methodsFor: '*Zenna-Animation3D' stamp: 'emm 02/09/2012 23:29'!
receiverForEventIn: aProp2
	^self! !

!Object methodsFor: '*Zenna-Animation3D' stamp: 'emm 02/09/2012 23:29'!
selectorForEventIn: aSymbol

	^(aSymbol copyWith: $: ) asSymbol! !

!Object methodsFor: '*Zenna-TaggedData' stamp: 'emm 07/05/2003 14:54'!
tagContents: aString
	"Subclasse may override this method to store the argument @aString"! !

!Object methodsFor: '*Zenna-TaggedData' stamp: 'emm 24/10/2002 14:05'!
tagValueReaderClass
	"Answer the class that can read the string representation of the receiver
	using the method MyClass class>>readFromTagValueString: .
	On default, answer my class"
	
	^self class! !

!Object methodsFor: '*Zenna-TaggedData' stamp: 'emm 22/10/2003 21:21'!
writeXMLToFile: fileName

	| xmlStream |
	xmlStream := fileName asFilename writeStream.
	[xmlStream nextPutAll: self asXML]
		ensure:[xmlStream close]! !

!Object methodsFor: '*Zenna-TaggedData' stamp: 'emm 22/10/2003 21:12'!
xmlCopy
	"Answer a copy of the receiver by parsing the XML representation of the receiver"
	^self class readXMLFrom: self asXML readStream! !

Object subclass: #Point2DCollection
	instanceVariableNames: 'collection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Core2D'!

Point2DCollection subclass: #Point2DArray
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Core2D'!

Point2DArray subclass: #OrderedPoint2DCollection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Core2D'!

!OrderedPoint2DCollection class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 22:51'!
new

	"Answer a new instance of the receiver and initialize it"

	^super new initialize! !

!OrderedPoint2DCollection class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 22:51'!
new: howMany

	"Answer a new instance of the receiver and initialize it"

	^super new collection: (OrderedCollection new: howMany * 2)! !

!OrderedPoint2DCollection methodsFor: 'adding-removing' stamp: 'emm 02/09/2012 22:51'!
add: aPoint

	self addX: aPoint x y: aPoint y.
	^aPoint! !

!OrderedPoint2DCollection methodsFor: 'adding-removing' stamp: 'emm 02/09/2012 22:51'!
addAll: aCollection

	aCollection do:[ :each | self add: each ].
	^aCollection
! !

!OrderedPoint2DCollection methodsFor: 'accessing' stamp: 'emm 02/09/2012 22:51'!
addX: x y: y

	collection add: x ;add: y! !

!OrderedPoint2DCollection methodsFor: 'converting' stamp: 'emm 02/09/2012 22:51'!
asArray

	| array |
	array := Array new: self size.
	1 to: array size do:[ :i |
		array at: i put: ( self at: i ) ].
	^array! !

!OrderedPoint2DCollection methodsFor: 'enumerating' stamp: 'emm 02/09/2012 22:51'!
do: aBlock

	1 to: collection size by: 2 do:[ :i |
		aBlock value: ( Point x: (collection at: i) y: (collection at: i + 1) ) ]! !

!OrderedPoint2DCollection methodsFor: 'accessing' stamp: 'emm 02/09/2012 22:51'!
first

	^self at: 1! !

!OrderedPoint2DCollection methodsFor: 'testing' stamp: 'emm 02/09/2012 22:51'!
includes: aPoint

	^self includesX: aPoint x y: aPoint y! !

!OrderedPoint2DCollection methodsFor: 'testing' stamp: 'emm 02/09/2012 22:51'!
includesX: x y: y

	1 to: collection size by: 2 do:[ :i |
		( ( collection at: i ) = x
			and:[ ( collection at: i + 1) = y ] )
				ifTrue: [ ^true ] ].
	^false! !

!OrderedPoint2DCollection methodsFor: 'testing' stamp: 'emm 02/09/2012 22:51'!
indexOfX: x y: y

	1 to: collection size by: 2 do:[ :i |
		( ( collection at: i ) = x
			and:[ ( collection at: i + 1) = y ] )
				ifTrue: [ ^i + 1 // 2 ] ].
	^0! !

!OrderedPoint2DCollection methodsFor: 'initialize-release' stamp: 'emm 02/09/2012 22:51'!
initialize
	
	collection := OrderedCollection new! !

!OrderedPoint2DCollection methodsFor: 'enumerating' stamp: 'emm 02/09/2012 22:51'!
inject: thisValue into: aBlock

	| injectValue  |
	injectValue := thisValue.
	self do: [:element |
		injectValue := aBlock value: injectValue value: element].
	^injectValue
	! !

!OrderedPoint2DCollection methodsFor: 'computing' stamp: 'emm 02/09/2012 22:51'!
intersect: otherPointCollection! !

!OrderedPoint2DCollection methodsFor: 'testing' stamp: 'emm 02/09/2012 22:51'!
intersects: otherCollection

	self size < otherCollection size
		ifTrue: [ ^otherCollection intersects: self ].

	otherCollection xyDo:[ :x :y |
		( self includesX: x y: y )
			ifTrue: [ ^true ]].
	^false! !

!OrderedPoint2DCollection methodsFor: 'testing' stamp: 'emm 02/09/2012 22:51'!
intersects: otherCollection offsetX: offsetx y: offsety

	self size < otherCollection size
		ifTrue: [ ^otherCollection intersects: self offsetX: offsetx y: offsety ].

	otherCollection xyDo:[ :x :y |
		( self includesX: x + offsetx y: y + offsety )
			ifTrue: [ ^true ]].
	^false! !

!OrderedPoint2DCollection methodsFor: 'accessing' stamp: 'emm 02/09/2012 22:51'!
last

	^self at: self size! !

!OrderedPoint2DCollection methodsFor: 'printing' stamp: 'emm 02/09/2012 22:51'!
printOn: aStream indent: level

	self printClassCreationOn: aStream indent: level.
	1 to: collection size by: 2 do: [:i | 
		aStream crtab: level + 1.
		i > 1
			ifTrue: [ aStream nextPutAll: '; ' ].
		aStream
			 nextPutAll: 'add: ('
			; print: ( collection at: i )
			; nextPut: $,
			; print: ( collection at: i + 1 )
			; nextPut: $)].
	collection size > 0
		ifTrue: [ aStream crtab: level + 1; nextPutAll: '; yourself' ].! !

!OrderedPoint2DCollection methodsFor: 'adding-removing' stamp: 'emm 02/09/2012 22:51'!
remove: aPoint

	self removeAtIndex: ( self indexOfX: aPoint x y: aPoint y ).
	^aPoint! !

!OrderedPoint2DCollection methodsFor: 'adding-removing' stamp: 'emm 02/09/2012 22:51'!
removeAll: aCollection

	aCollection do:[ :each | self remove: each ].
	^aCollection
! !

!OrderedPoint2DCollection methodsFor: 'adding-removing' stamp: 'emm 02/09/2012 22:51'!
removeAt: index

	collection removeAtIndex: index * 2 - 1.
	collection removeAtIndex: index * 2 - 1 ! !

!OrderedPoint2DCollection methodsFor: 'adding-removing' stamp: 'emm 02/09/2012 22:51'!
removeAtIndex: index

	collection removeAtIndex: index * 2 - 1.
	collection removeAtIndex: index * 2 - 1 ! !

!OrderedPoint2DCollection methodsFor: 'adding-removing' stamp: 'emm 02/09/2012 22:51'!
removeX: x y: y

	| index |
	index := self indexOfX: x y: y.
	collection removeAtIndex: index * 2 - 1.
	collection removeAtIndex: index * 2 - 1 ! !

!OrderedPoint2DCollection methodsFor: 'enumerating' stamp: 'emm 02/09/2012 22:51'!
xyDo: aBlock

	1 to: collection size by: 2 do:[ :i |
		aBlock value: ( collection at: i ) value: ( collection at: i + 1) ]! !

!Point2DArray methodsFor: 'accessing' stamp: 'emm 02/09/2012 22:51'!
at: index

	^( collection at: index * 2 - 1 ) @ ( collection at: index  * 2 )! !

!Point2DArray methodsFor: 'accessing' stamp: 'emm 02/09/2012 22:51'!
at: index put: aPoint

	collection at: index * 2 - 1 put: aPoint x.
	collection at: index  * 2 put: aPoint y! !

!Point2DArray methodsFor: 'enumerating' stamp: 'emm 02/09/2012 22:51'!
do: aBlock
	
	1 to: self size by: 2 do:[ :i |
		aBlock value: ( Point x: (collection at: i) y: (collection at: i + 1) ) ]! !

!Point2DArray methodsFor: 'accessing' stamp: 'emm 02/09/2012 22:51'!
points

	| points |
	points := Array new: self size.
	1 to: self size do:[ :i |
		points at: i put: ( self at: i ) ].
	^points! !

!Point2DCollection class methodsFor: 'instance-creation' stamp: 'emm 10/18/2012 16:24'!
new: size

	^super new collection: (Array new: size * 2)! !

!Point2DCollection methodsFor: 'accessing' stamp: 'emm 10/18/2012 16:18'!
add: aPoint 
	collection add: aPoint x ;add: aPoint y.
	^aPoint ! !

!Point2DCollection methodsFor: 'enumerating' stamp: 'emm 02/09/2012 22:51'!
collect: aBlock
	
	| result |
	result := OrderedCollection new: self size.
	self do:[ :each | result add: ( aBlock value: each ) ].
	^result! !

!Point2DCollection methodsFor: 'private' stamp: 'emm 02/09/2012 22:51'!
collection

	"Answer the value of collection"

	^collection! !

!Point2DCollection methodsFor: 'private' stamp: 'emm 02/09/2012 22:51'!
collection: aValue

	"Set the value of collection"

	collection := aValue! !

!Point2DCollection methodsFor: 'copying' stamp: 'emm 02/09/2012 22:51'!
copy

	^super copy collection: collection copy! !

!Point2DCollection methodsFor: 'copying' stamp: 'emm 02/09/2012 22:51'!
copyAndGrow

	^super copy collection: collection copyAndGrow! !

!Point2DCollection methodsFor: 'copying' stamp: 'emm 02/09/2012 22:51'!
copyFrom: start to: end

	^self class new collection: ( collection copyFrom: start * 2  to: end * 2)! !

!Point2DCollection methodsFor: 'printing' stamp: 'emm 02/09/2012 22:51'!
printClassCreationOn: aStream indent: level

	aStream
		 nextPutAll: '('
		; nextPutAll: self class name
		; nextPutAll: ' new: '
		; print: self size
		; nextPut: $).! !

!Point2DCollection methodsFor: 'printing' stamp: 'emm 02/09/2012 22:51'!
printOn: aStream 

	self printOn: aStream indent: 0! !

!Point2DCollection methodsFor: 'printing' stamp: 'emm 02/09/2012 22:51'!
printOn: aStream  indent: level

	self do:[ :each | 
		each printOn: aStream.
		aStream cr ]! !

!Point2DCollection methodsFor: 'accessing' stamp: 'emm 02/09/2012 22:51'!
size

	^collection size // 2! !

Point2DCollection subclass: #Point2DSet
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Core2D'!

!Point2DSet class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 22:51'!
new

	^super new initialize! !

!Point2DSet methodsFor: 'adding-removing' stamp: 'emm 02/09/2012 22:51'!
add: aPoint

	self addX: aPoint x y: aPoint y.
	^aPoint! !

!Point2DSet methodsFor: 'adding-removing' stamp: 'emm 02/09/2012 22:51'!
addX: x y: y

	( self collection at: x ifAbsentPutUsing: [ Set new ] ) add: y! !

!Point2DSet methodsFor: 'enumerating' stamp: 'emm 02/09/2012 22:51'!
do: aBlock

	self collection keysAndValuesDo:[ :x :ySet |
		ySet do:[ :y | aBlock value: x @ y ] ].
		! !

!Point2DSet methodsFor: 'testing' stamp: 'emm 02/09/2012 22:51'!
includes: aPoint

	^self includesX: aPoint x y: aPoint y! !

!Point2DSet methodsFor: 'testing' stamp: 'emm 02/09/2012 22:51'!
includesX: x y: y

	^( self collection 
		at: x 
		ifAbsent:[ ^false ] ) includes: y! !

!Point2DSet methodsFor: 'initialize-release' stamp: 'emm 02/09/2012 22:51'!
initialize

	self collection: Dictionary new! !

!Point2DSet methodsFor: 'adding-removing' stamp: 'emm 02/09/2012 22:51'!
remove: aPoint

	self removeX: aPoint x y: aPoint y.
	^aPoint! !

!Point2DSet methodsFor: 'adding-removing' stamp: 'emm 02/09/2012 22:51'!
removeX: x y:  y

	(self collection at: x ) remove: y
! !

Object subclass: #Point3D
	instanceVariableNames: 'x y z'
	classVariableNames: 'Unity Zero'
	poolDictionaries: ''
	category: 'Zenna-Structures3D'!

!Point3D class methodsFor: 'class-initialization' stamp: 'emm 10/2/2012 21:22'!
initializeAfterLoad

	Unity := self
				x: 1
				y: 1
				z: 1.
	Zero := self
				x: 0
				y: 0
				z: 0! !

!Point3D class methodsFor: 'properties' stamp: 'emm 02/09/2012 23:16'!
octantNameForX: x y: y z: z 

	^x >= 0
		ifTrue: [y >= 0
				ifTrue: [z >= 0
						ifTrue: [#frontRightTop]
						ifFalse: [#frontRightBottom]]
				ifFalse: [z >= 0
						ifTrue: [#frontLeftTop]
						ifFalse: [#frontLeftBottom]]]
		ifFalse: [y >= 0
				ifTrue: [z >= 0
						ifTrue: [#backRightTop]
						ifFalse: [#backRightBottom]]
				ifFalse: [z >= 0
						ifTrue: [#backLeftTop]
						ifFalse: [#backLeftBottom]]]! !

!Point3D class methodsFor: 'utilities' stamp: 'emm 02/09/2012 23:16'!
quadrantNameForX: x y: y

	^x < 0
		ifTrue: [ y < 0
			ifTrue: [ #backLeft ]
			ifFalse: [ #backRight ]] 
		ifFalse: [ y < 0
			ifTrue: [ #frontLeft ] 
			ifFalse: [ #frontRight ]]! !

!Point3D class methodsFor: 'instance creation' stamp: 'emm 02/09/2012 23:16'!
r: rho theta: theta phi: phi 
	"Answer a CartesianPoint defined by polar coordinates.
	 where:
	 < rho >		:distance from the receiver to the point 0,0,0.
	 < theta > 	:angle to the positive z-axis.
	 < phi > 		:angle between the projected CartesianPoint on the (x,y)-plane
				 and the positive x-axis

	Note: angles must be in radians"
		
	| p |
	p := rho * theta sin.
	^self basicNew
		setX: p * phi cos
		setY: p * phi sin
		setZ: rho * theta cos! !

!Point3D class methodsFor: 'class-initialization' stamp: 'emm 02/09/2012 23:16'!
release

	Unity := Zero := nil! !

!Point3D class methodsFor: 'instance creation' stamp: 'emm 02/09/2012 23:16'!
unity

	^Unity copy! !

!Point3D class methodsFor: 'instance creation' stamp: 'emm 02/09/2012 23:16'!
x: xPoint y: yPoint z: zPoint 
	"Answer a CartesianPoint whose coordinates will be the arguments"

	^self basicNew
		setX: xPoint
		setY: yPoint
		setZ: zPoint! !

!Point3D class methodsFor: 'instance creation' stamp: 'emm 02/09/2012 23:16'!
zero

	^Zero copy! !

!Point3D methodsFor: 'arithmetic' stamp: 'emm 02/09/2012 23:16'!
* anArgument 
	"Answer the result of multiplying the receiver by the argument anArgument."

	^anArgument productFromPoint3D: self! !

!Point3D methodsFor: 'arithmetic' stamp: 'emm 02/09/2012 23:16'!
+ aCartesianPoint
	"Answer a new CartesianPoint that is the sum of the receiver and aCartesianPoint"

	^self class
		x: x + aCartesianPoint x
		y: y + aCartesianPoint y
		z: z + aCartesianPoint z! !

!Point3D methodsFor: 'converting' stamp: 'emm 02/09/2012 23:16'!
, aNumber

	^self @ aNumber! !

!Point3D methodsFor: 'arithmetic' stamp: 'emm 02/09/2012 23:16'!
- aCartesianPoint
	"Answer a new CartesianPoint that is the differene of the receiver and aCartesianPoint"

	^self class
		x: x - aCartesianPoint x
		y: y - aCartesianPoint y
		z: z - aCartesianPoint z! !

!Point3D methodsFor: 'arithmetic' stamp: 'emm 02/09/2012 23:16'!
/ scale
	"Answer a new Point that is the quotient of the receiver and 
	scale (which is Number or a Point)."

	| scalePoint |
	scalePoint := scale asPoint3D.
	^self class
		x: x / scalePoint x
		y: y / scalePoint y
		z: z / scalePoint z! !

!Point3D methodsFor: 'arithmetic' stamp: 'emm 02/09/2012 23:16'!
// scale

	"Answer a new Point that is the quotient of the receiver and scale
	(which is Number or a Point).
	"
	
	| scalePoint |
	scalePoint := scale asPoint3D.
	^self class 
		x: x // scalePoint x 
		y: y // scalePoint y 
		z: z // scalePoint z! !

!Point3D methodsFor: 'comparing' stamp: 'emm 02/09/2012 23:16'!
< operand

	"Answer true if the receiver is .. . Otherwise
	 answer false."

	^x < operand x 
		and: [y < operand y
			and: [z < operand z]]! !

!Point3D methodsFor: 'comparing' stamp: 'emm 02/09/2012 23:16'!
<= operand

	"Answer true if the receiver is .. . Otherwise
	 answer false."

	^x <= operand x 
		and: [y <= operand y
			and: [z <= operand z]]! !

!Point3D methodsFor: 'comparing' stamp: 'emm 02/09/2012 23:16'!
= aCartesianPoint 
	"Answer if the receiver has the same coordinates"
	
	aCartesianPoint species == self species
		ifFalse: [^false].
	aCartesianPoint x = x 
		ifTrue:[ aCartesianPoint y = y 
				ifTrue: [^aCartesianPoint z = z].
			^false].
	^false! !

!Point3D methodsFor: 'comparing' stamp: 'emm 02/09/2012 23:16'!
> operand

	"Answer true if the receiver is .. . Otherwise
	 answer false."

	^x > operand x 
		and: [y > operand y
			and: [z > operand z]]! !

!Point3D methodsFor: 'comparing' stamp: 'emm 02/09/2012 23:16'!
>= operand

	"Answer true if the receiver is .. . Otherwise
	 answer false."

	^x >= operand x 
		and: [y >= operand y
			and: [z >= operand z]]! !

!Point3D methodsFor: 'converting' stamp: 'emm 02/09/2012 23:16'!
@ dPoint 
	"Answer a new HomogeneousPoint with the elements of the receiver"

	^Point4D
		x: x
		y: y
		z: z
		d: dPoint! !

!Point3D methodsFor: 'converting' stamp: 'emm 02/09/2012 23:16'!
abs

	^self class x: x abs y: y abs z: z abs! !

!Point3D methodsFor: 'Pharo' stamp: 'emm 9/23/2012 00:18'!
adaptToFloat: aFloat andSend: selector
	selector == #* ifTrue:[^ self productFromFloat: aFloat].
	1 halt.! !

!Point3D methodsFor: '*Zenna-Extensions' stamp: 'emm 9/28/2012 00:15'!
adaptToNumber: aSmallInteger andSend: aByteSymbol 
	^Point3D
		x: (x perform: aByteSymbol with: aSmallInteger)
		y: (y perform: aByteSymbol with: aSmallInteger)
		z: (z perform: aByteSymbol with: aSmallInteger)! !

!Point3D methodsFor: 'computing' stamp: 'emm 02/09/2012 23:16'!
angleTo: aCartesianPoint 
	"Answer the angle between the receiver, the origin and < anCartesianPoint >"

	^((self dotProduct: aCartesianPoint)
		/ (self r * aCartesianPoint r)) arcCos! !

!Point3D methodsFor: 'converting' stamp: 'emm 02/09/2012 23:16'!
asArray

	^Array with: x with: y with: z! !

!Point3D methodsFor: 'converting' stamp: 'emm 02/09/2012 23:16'!
asPoint3D

	^self! !

!Point3D methodsFor: 'converting' stamp: 'emm 02/09/2012 23:16'!
asPoint4D
	"Answer a new HomogeneousPoint with the elements of the receiver and d = 
	1"

	^Point4D
		x: x
		y: y
		z: z
		d: 1! !

!Point3D methodsFor: 'converting' stamp: 'emm 02/09/2012 23:16'!
asQuaternion
	"a + bi +cj + dk where
	a = cos phi / 2,
	b = x * (sin phi / 2)
	c = y * (sin phi / 2)
	d = z * (sin phi / 2)"

	| hAngle unitVector |
	hAngle := self r / 2.
	unitVector := self normalized.
	^Point4D
		x: hAngle sin * unitVector x
		y: hAngle sin * unitVector y
		z: hAngle sin * unitVector z
		d: hAngle cos! !

!Point3D methodsFor: 'testing' stamp: 'emm 02/09/2012 23:16'!
between: onePoint and: otherPoint 
	
	^( x between: onePoint x and: otherPoint x )
		and: [ ( y between: onePoint y and: otherPoint y )
			and: [ z between: onePoint z and: otherPoint z ] ]! !

!Point3D methodsFor: '*Zenna-Modelling3D' stamp: 'emm 02/09/2012 23:50'!
canBeLabeled
	^false! !

!Point3D methodsFor: '*Zenna-Primitives3D' stamp: 'emm 02/09/2012 23:36'!
centerExtent: aPoint 

	| extent |
	aPoint isZero
		ifTrue: [^BoundingBox origin: self corner: self].
	extent := aPoint asPoint3D.
	^extent x = 0
		ifTrue: [extent y = 0
				ifTrue: [LineSegment3D between: self - (extent / 2) and: self + (extent / 2)]
				ifFalse: [extent z = 0
						ifTrue: [LineSegment3D between: self - (extent / 2) and: self + (extent / 2)]
						ifFalse: ["0 , y , z"
							self centerExtentY: extent y z: extent z]]]
		ifFalse: [extent y = 0
				ifTrue: [extent z = 0
						ifTrue: [LineSegment3D between: self - (extent / 2) and: self + (extent / 2)]
						ifFalse: ["x , 0 , z"
							self centerExtentX: extent x z: extent z]]
				ifFalse: [extent z = 0
						ifTrue: ["x , y , 0"
							self centerExtentX: extent x y: extent y]
						ifFalse: ["x , y , z"
							BoundingBox origin: self centerExtent: extent]]]! !

!Point3D methodsFor: '*Zenna-Collections3D' stamp: 'emm 02/09/2012 23:43'!
centerExtentX: xNumber y: yNumber 

	| halfX halfY |
	halfX := xNumber / 2.
	halfY := yNumber / 2.
	^(Polygon3D new)
		 addX: x + halfX y: y + halfY z: z
		; addX: x + halfX y: y - halfY z: z
		; addX: x - halfX y: y - halfY z: z
		; addX: x - halfX y: y + halfY z: z
		; yourself! !

!Point3D methodsFor: '*Zenna-Collections3D' stamp: 'emm 02/09/2012 23:43'!
centerExtentX: xNumber z: zNumber 

	| halfX halfZ |
	halfX := xNumber / 2.
	halfZ := zNumber / 2.
	^(Polygon3D new)
		 addX: x + halfX y: y z: z + halfZ
		; addX: x + halfX y: y z: z - halfZ
		; addX: x - halfX y: y z: z - halfZ
		; addX: x - halfX y: y z: z + halfZ
		; yourself! !

!Point3D methodsFor: '*Zenna-Collections3D' stamp: 'emm 02/09/2012 23:43'!
centerExtentY: yNumber z: zNumber 

	| halfY halfZ |
	halfY := yNumber / 2.
	halfZ := zNumber / 2.
	^(Polygon3D new)
		 addX: x y: y + halfY z: z + halfZ
		; addX: x y: y + halfY z: z - halfZ
		; addX: x y: y - halfY z: z - halfZ
		; addX: x y: y - halfY z: z + halfZ
		; yourself! !

!Point3D methodsFor: 'coercing' stamp: 'emm 02/09/2012 23:16'!
coerce: aNumber 
	"Answer a new Point whose coordinates are the argument, aNumber."

	^aNumber asPoint3D! !

!Point3D methodsFor: 'testing' stamp: 'emm 02/09/2012 23:16'!
coincidesWith: otherPoint3D 

	^(self r - otherPoint3D r) abs < 1.0e8! !

!Point3D methodsFor: '*Zenna-Primitives3D' stamp: 'emm 02/09/2012 23:36'!
corner: aPoint 

	^self + aPoint / 2 centerExtent: aPoint - self! !

!Point3D methodsFor: 'vector functions' stamp: 'emm 02/09/2012 23:16'!
crossProduct: aPoint 

	"Answer a new CartesianPoint that is perpendicular to both the receiver and < aPoint >"
	
	^ self class 
		x: y * aPoint z - ( z * aPoint y ) 
		y: z * aPoint x - ( x * aPoint z ) 
		z: x * aPoint y - ( y * aPoint x )! !

!Point3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:16'!
decX: delta

	x := x - delta! !

!Point3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:16'!
decY: delta

	y := y - delta! !

!Point3D methodsFor: 'transforming-shortcuts' stamp: 'emm 02/09/2012 23:16'!
decZ: amount 

	z := z - amount! !

!Point3D methodsFor: 'converting' stamp: 'emm 02/09/2012 23:16'!
deg

	^self radiansToDegrees! !

!Point3D methodsFor: 'converting' stamp: 'emm 02/09/2012 23:16'!
degreesToRadians

	^self species
		x: x degreesToRadians
		y: y degreesToRadians
		z: z degreesToRadians! !

!Point3D methodsFor: 'computing' stamp: 'emm 02/09/2012 23:16'!
dist: aPoint3D

	"Answer the distance between the receiver and operand in cartesian space."

	^(
	(x - aPoint3D x) squared +
	(y - aPoint3D y) squared +
	(z - aPoint3D z) squared
	) sqrt! !

!Point3D methodsFor: 'vector functions' stamp: 'emm 02/09/2012 23:16'!
dotProduct: aCartesianPoint
	"Answer a Number that is the dot product of the receiver and the argument,
	 < aCartesianPoint >. That is, the two points are multiplied and the coordinates 
	of the result are summed."

	^x* aCartesianPoint x +  (y * aCartesianPoint y) + (z* aCartesianPoint z)! !

!Point3D methodsFor: '*Zenna-Primitives3D' stamp: 'emm 02/09/2012 23:36'!
downTo: otherPoint 

	^self to: otherPoint by: (otherPoint - self) normalized! !

!Point3D methodsFor: '*Zenna-Primitives3D' stamp: 'emm 02/09/2012 23:36'!
extent: aPoint 

	^self + (aPoint / 2) centerExtent: aPoint! !

!Point3D methodsFor: 'converting' stamp: 'emm 02/09/2012 23:16'!
floating

	x := x asFloat.
	y := y asFloat.
	z := z asFloat! !

!Point3D methodsFor: 'comparing' stamp: 'emm 02/09/2012 23:16'!
hash
	"Answer a unique SmallInteger to the receiver"

	^(((x hash bitShift: 2) bitXor: y hash) bitShift: 2) bitXor: z hash! !

!Point3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:16'!
incX: delta

	x := x + delta! !

!Point3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:16'!
incY: delta

	y := y + delta! !

!Point3D methodsFor: 'transforming-shortcuts' stamp: 'emm 02/09/2012 23:16'!
incZ: amount 

	z := z + amount! !

!Point3D methodsFor: 'printing' stamp: 'emm 02/09/2012 23:16'!
inspectActions

	^#( r normalized octantName)! !

!Point3D methodsFor: 'computing' stamp: 'emm 02/09/2012 23:16'!
interpolateTo: aCartesianPoint ratio: ratio 
	"Linearly interpolate between the receiver and the argument < aCartesianPoint> 
	by an amount < ratio > and return the resulting CartesianPoint"

	ratio = 1 ifTrue: [^aCartesianPoint].
	ratio = 0 ifTrue: [^self].
	^self + (aCartesianPoint - self) * ratio! !

!Point3D methodsFor: 'testing' stamp: 'emm 02/09/2012 23:16'!
isCollineairTo: aCartesianPoint 
	"Answer if the receiver is in line with aCartesianPoint.
	 For true,  the cosine of the angle between the two CartesianPoints will be 1 or -1"

	^(self dotProduct: aCartesianPoint)
		/ (self r * aCartesianPoint r) abs = 1! !

!Point3D methodsFor: 'testing' stamp: 'emm 02/09/2012 23:16'!
isOrigin
	"Answer if the receiver has the coordinates (0,0,0)"

	^self isZero! !

!Point3D methodsFor: 'testing' stamp: 'emm 02/09/2012 23:16'!
isUnity
	"Answer whether the receiver has coordinates (1,1,1)"

	x = 1
		ifTrue: 
			[y = 1 ifTrue: [^z = 1].
			^false].
	^false! !

!Point3D methodsFor: 'testing' stamp: 'emm 02/09/2012 23:16'!
isXRotation

	^x ~= 0 and:[y = 0 and:[z = 0]]! !

!Point3D methodsFor: 'testing' stamp: 'emm 02/09/2012 23:16'!
isYRotation

	^x = 0 and:[y ~= 0 and:[z = 0]]! !

!Point3D methodsFor: 'testing' stamp: 'emm 02/09/2012 23:16'!
isZRotation

	^x = 0 and:[y = 0 and:[z ~= 0]]! !

!Point3D methodsFor: 'testing' stamp: 'emm 02/09/2012 23:16'!
isZero
	"Answer whether the receiver has coordinates (0,0,0)"

	x = 0
		ifTrue: 
			[y = 0 ifTrue: [^z = 0].
			^false].
	^false! !

!Point3D methodsFor: 'double dispatching' stamp: 'emm 02/09/2012 23:16'!
kindDo: aRequestor

	^aRequestor doPoint3D: self! !

!Point3D methodsFor: '*Zenna-Primitives3D' stamp: 'emm 02/09/2012 23:36'!
lineSegmentTo: otherPoint3D

	^LineSegment3D from: self to: otherPoint3D! !

!Point3D methodsFor: 'arithmetic' stamp: 'emm 02/09/2012 23:16'!
max: otherPoint 

	| p |
	p := otherPoint asPoint3D.
	^self class
		x: (x max: p x)
		y: (y max: p y)
		z: (z max: p z)! !

!Point3D methodsFor: 'arithmetic' stamp: 'emm 02/09/2012 23:16'!
min: otherPoint 

	| p |
	p := otherPoint asPoint3D.
	^self class
		x: (x min: p x)
		y: (y min: p y)
		z: (z min: p z)! !

!Point3D methodsFor: 'arithmetic' stamp: 'emm 02/09/2012 23:16'!
negated
	"Answer a new CartesianPoint that is the negated version of the receiver"

	^self class
		x: x negated
		y: y negated
		z: z negated! !

!Point3D methodsFor: 'converting' stamp: 'emm 02/09/2012 23:16'!
normalized
	"Answer the receiver scaled to unit length"

	| r |
	^(r := self r) = 1
		ifTrue: [self copy]
		ifFalse: 
			[r = 0
				ifTrue:[ self class zero ]
				ifFalse:[ self / r]]! !

!Point3D methodsFor: 'computing' stamp: 'emm 02/09/2012 23:16'!
octantName

	^self class
		octantNameForX: x
		y: y
		z: z! !

!Point3D methodsFor: 'polar coordinates' stamp: 'emm 02/09/2012 23:16'!
phi
	"Answer the angle <phi>"

	^(z / self rho) arcCos! !

!Point3D methodsFor: 'printing' stamp: 'emm 10/7/2012 21:40'!
printOn: aStream 
	"Append to the argument aStream in terms of infix notation."

	x printOn: aStream.
	aStream nextPut: $,.
	y printOn: aStream space.
	aStream nextPut: $,.
	z printOn: aStream space! !

!Point3D methodsFor: 'printing' stamp: 'emm 02/09/2012 23:16'!
printOn: aStream delimitedBy: separator 

	aStream
		 print: x
		; nextPutAll: separator
		; print: y
		; nextPutAll: separator
		; print: z! !

!Point3D methodsFor: 'printing' stamp: 'emm 02/09/2012 23:16'!
printOn: aStream indent: level 

	self printOn: aStream! !

!Point3D methodsFor: 'double dispatching' stamp: 'emm 02/09/2012 23:16'!
productFromFloat: aFloat

	^self copy scaleBy: aFloat! !

!Point3D methodsFor: 'arithmetic' stamp: 'emm 02/09/2012 23:16'!
productFromInteger: anInteger

	^self copy scaleBy: anInteger! !

!Point3D methodsFor: 'double dispatching' stamp: 'emm 02/09/2012 23:16'!
productFromMatrix3x3: aMatrix 
	"Answer a new CartesianPoint that is the result 
	of the multiplication of the argument by the receiver

	Usage:  newPoint := aMatrix * oldPoint"

	^aMatrix productFromPoint3D: self! !

!Point3D methodsFor: 'double dispatching' stamp: 'emm 02/09/2012 23:16'!
productFromPoint3D: aPoint 
	"Answer the dotProduct of the receiver with <aPoint>"

	^self dotProduct: aPoint! !

!Point3D methodsFor: 'computing' stamp: 'emm 02/09/2012 23:16'!
quadrantName

	^self class quadrantNameForX: x y: y! !

!Point3D methodsFor: 'polar coordinates' stamp: 'emm 02/09/2012 23:16'!
r

	^self rho! !

!Point3D methodsFor: 'converting' stamp: 'emm 02/09/2012 23:16'!
rad

	self degreesToRadians! !

!Point3D methodsFor: 'converting' stamp: 'emm 02/09/2012 23:16'!
radiansToDegrees

	^self species
		x: x radiansToDegrees
		y: y radiansToDegrees
		z: z radiansToDegrees! !

!Point3D methodsFor: 'computing' stamp: 'emm 02/09/2012 23:16'!
ratioTo: otherPoint 
	
	"Answer the ratio for linear interpolating the receiver to <otherPoint>"
	
	| xr yr zr |
	xr := self xRatioTo: otherPoint.
	yr := self yRatioTo: otherPoint.
	zr := self zRatioTo: otherPoint.
	^xr = 0
		ifTrue: 
			[ yr = 0
				ifTrue: 
					[ zr ]
				ifFalse: 
					[ zr = 0
						ifTrue: 
							[ yr ]
						ifFalse: 
							[ yr = zr
								ifTrue: [ yr ]
								ifFalse: [ self error: 'points not on same line' ] ] ] ]
		ifFalse: 
			[ yr = 0 
				ifTrue: 
					[ zr = 0
						ifTrue: 
							[ xr ]
						ifFalse: 
							[ xr = zr
								ifTrue: [ xr ]
								ifFalse: [ self error: 'points not on same line' ] ] ]
				ifFalse: [ zr = 0
					ifTrue: [ xr = yr
						ifTrue: [ xr = zr
							ifTrue: [ xr ] 
							ifFalse: [ self error: 'points not on same line' ]]
						ifFalse: [ self error: 'points not on same line' ]]
					ifFalse: [ 1 halt ]]]! !

!Point3D methodsFor: 'polar coordinates' stamp: 'emm 02/09/2012 23:16'!
rho
	"Answer the distance from the receiver to the cartesian point 0,0,0"

	^(x * x + (y * y) + (z * z)) sqrt! !

!Point3D methodsFor: 'transforming' stamp: 'emm 02/09/2012 23:16'!
rotateBy: aPoint

	| newPoint |
	newPoint := (Matrix3x3 rotation: aPoint) * self.
	x := newPoint x.
	y := newPoint y.
	z := newPoint z! !

!Point3D methodsFor: 'transforming' stamp: 'emm 02/09/2012 23:16'!
rotatedBy: aPoint

	^self copy rotateBy: aPoint! !

!Point3D methodsFor: 'transforming' stamp: 'emm 02/09/2012 23:16'!
rotatedByZ: radians

	| sinVal cosVal |
	sinVal := radians sin.
	cosVal := radians cos.
	^self class
		x: cosVal * x + (sinVal * y) 
		y: (cosVal * y - (sinVal * x))
		z: z! !

!Point3D methodsFor: 'computing' stamp: 'emm 02/09/2012 23:16'!
rotationPointsFromNegativeX
	"Answer with rotation points to transform a vector along the negative X-axis to the receiver"

	| angle angleZ xySize |
	x = 0
		ifTrue: [y = 0
			ifTrue: [ z < 0
				ifTrue:[ ^Array with: (self class x: 0 y: Float pi / -2 z: 0) ]
				ifFalse:[ ^Array with: self class zero ] ]
			ifFalse:  "x=0,y<>0"
				[ angle := (z / y ) arcTan + (y > 0 ifTrue: [0] ifFalse: [Float pi]).
				^Array with: (self class x: 0 y: 0 z: Float pi / -2 ) with: (self class x: angle y: 0 z: 0 ) ]].
	"x<>0"
	y = 0
		ifTrue: [z = 0
			ifTrue: [^Array with: (self class x: 0 y: (x < 0 ifTrue: [ 0 ] ifFalse: [ Float pi ]) z: 0)]
			ifFalse: "x<>0, y=0, z<>0"
				[angle := (x > 0 ifTrue: [Float pi] ifFalse: [0]) - (z / x ) arcTan.
				^Array with: (self class x: 0 y: angle z: 0)]].
	"x<>0, y<>0"
	z = 0
		ifTrue:
			[angle := (y / x ) arcTan - (x > 0 ifTrue: [Float pi] ifFalse: [0]).
			^Array with: (self class x: 0 y: 0 z: angle) ].
	"x<>0, y<>0, z<>0"
	angleZ := (y / x ) arcTan - (x > 0 ifTrue: [Float pi] ifFalse: [0]).
	xySize := (x * x + ( y * y )) sqrt.
	angle := ( z / xySize ) arcTan.
	^Array with: (self class x: 0 y: angle z: 0) with: (self class x: 0 y: 0 z: angleZ)
	! !

!Point3D methodsFor: 'computing' stamp: 'emm 02/09/2012 23:16'!
rotationPointsFromX

	^(Array with: (self class x:  0 y: Float pi / 2 z: 0)) , self rotationPointsFromZ! !

!Point3D methodsFor: 'computing' stamp: 'emm 02/09/2012 23:16'!
rotationPointsFromY

	^(Array with: (self class x: Float pi / 2 y: 0 z: 0)) , self rotationPointsFromZ! !

!Point3D methodsFor: 'computing' stamp: 'emm 02/09/2012 23:16'!
rotationPointsFromZ
	"Answer with rotation points to transform 
	an equally sized vector along the positive Z-axis to the receiver"

	| angle angleZ xySize |
	x = 0
		ifTrue: [y = 0
			ifTrue: [ z < 0
				ifTrue:[ ^Array with: (self class x: Float pi y: 0 z: 0) ]
				ifFalse:[ ^Array with: self class zero ] ]
			ifFalse:  "x=0,y<>0"
				[angle := (z / y ) arcTan + (y > 0 ifTrue: [0] ifFalse: [Float pi]) - (Float pi / 2).
				^Array with: (self class x: angle y: 0 z:0)]].
	"x<>0"
	y = 0
		ifTrue: [z = 0
			ifTrue: [^Array with: (self class x: 0 y: Float pi / 2 * (x sign) z: 0)]
			ifFalse: "x<>0, y=0, z<>0"
				[angle := (x / z ) arcTan + (z > 0 ifTrue: [0] ifFalse: [Float pi]).
				^Array with: (self class x: 0 y: angle z: 0)]].
	"x<>0, y<>0"
	z = 0
		ifTrue: 
			[angle := (y / x ) arcTan + (x > 0 ifTrue: [0] ifFalse: [Float pi]).
			^Array with: (self class x: 0 y: Float pi / 2 z: 0) with: (self class x: 0 y: 0 z: angle) ].
	"x<>0, y<>0, z<>0"
	angleZ := (y / x) arcTan + (x > 0 ifTrue: [0] ifFalse: [Float pi]).
	xySize :=  (x * x + ( y * y )) sqrt.
	angle := ( xySize / z ) arcTan + (z > 0 ifTrue: [0] ifFalse: [Float pi]).
	^Array with: (self class x: 0 y: angle z:0) with: (self class x: 0 y: 0 z: angleZ)! !

!Point3D methodsFor: 'truncation and round off' stamp: 'emm 02/09/2012 23:16'!
rounded
	"Answer a new CartesianPoint with the coordinates of the receiver rounded"

	^self class
		x: x rounded
		y: y rounded
		z: z rounded! !

!Point3D methodsFor: 'transforming' stamp: 'emm 02/09/2012 23:16'!
scaleBy: factor 
	"Scale the receiver by factor (an instance of CartesianPoint)."

	| factorPoint |
	factorPoint := factor asPoint3D.
	x := factorPoint x * x.
	y := factorPoint y * y.
	z := factorPoint z * z! !

!Point3D methodsFor: 'transforming' stamp: 'emm 02/09/2012 23:16'!
scaledBy: factor 
	
	^self copy scaleBy: factor! !

!Point3D methodsFor: 'transforming' stamp: 'emm 02/09/2012 23:16'!
scaledToLength: aNumber 
	"Answer a new point such that its length equals <aNumber> and is parallel to the receiver"

	^self normalized scaleBy: aNumber! !

!Point3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:16'!
setX: xPoint setY: yPoint setZ: zPoint
	"Initialize the instance variables."

	x := xPoint.
	y := yPoint.
	z := zPoint! !

!Point3D methodsFor: 'polar coordinates' stamp: 'emm 02/09/2012 23:16'!
theta

	^self xy theta! !

!Point3D methodsFor: '*Zenna-Collections3D' stamp: 'emm 02/09/2012 23:43'!
to: otherPoint 

	^otherPoint <= self
		ifTrue: [ #() ]
		ifFalse: [ self to: otherPoint by: (otherPoint - self) normalized ]! !

!Point3D methodsFor: '*Zenna-Collections3D' stamp: 'emm 02/09/2012 23:43'!
to: endPoint by: stepPoint 

	^Point3DInterval
		from: self
		to: endPoint
		by: stepPoint! !

!Point3D methodsFor: '*Zenna-Collections3D' stamp: 'emm 02/09/2012 23:43'!
to: endPoint steps: howMany

	howMany = 1
		ifTrue: [ ^Array with: endPoint ].
	^Point3DInterval
		from: self
		to: endPoint
		by: endPoint - self / ( howMany - 1)! !

!Point3D methodsFor: 'computing' stamp: 'emm 02/09/2012 23:16'!
transformationFromZ
	"Answer with a rotation matrix to transform 
	a normal along the Z-axis to the receiver"

	^self rotationPointsFromZ 
		inject: Matrix3x3 identity 
		into:[ :product :each | product * (Matrix3x3 rotation: each)]! !

!Point3D methodsFor: 'transforming' stamp: 'emm 02/09/2012 23:16'!
translateBy: delta 
	"Translate the receiver by delta (an instance of CartesianPoint)."

	x := delta x + x.
	y := delta y + y.
	z := delta z + z! !

!Point3D methodsFor: 'transforming' stamp: 'emm 02/09/2012 23:16'!
translatedBy: delta 
	
	^self copy translateBy: delta! !

!Point3D methodsFor: 'transforming' stamp: 'emm 02/09/2012 23:16'!
translatedByX: delta 

	^self copy x: x + delta! !

!Point3D methodsFor: 'transforming' stamp: 'emm 02/09/2012 23:16'!
translatedByY: delta 

	^self copy y: y + delta! !

!Point3D methodsFor: 'transforming' stamp: 'emm 02/09/2012 23:16'!
translatedByZ: delta 

	^self copy z: z + delta! !

!Point3D methodsFor: 'transforming' stamp: 'emm 02/09/2012 23:16'!
transposedInXY

	^self class x: y y: x z: z! !

!Point3D methodsFor: 'truncation and round off' stamp: 'emm 02/09/2012 23:16'!
truncated
	"Answer a new CartesianPoint with the coordinates of the receiver truncated"

	^self class
		x: x truncated
		y: y truncated
		z: z truncated! !

!Point3D methodsFor: 'coercing' stamp: 'emm 02/09/2012 23:16'!
value
	"Answer the receiver; useful for unifying uses of Blocks with Points."
	
	^self! !

!Point3D methodsFor: 'coercing' stamp: 'emm 02/09/2012 23:16'!
value: aPoint3D
	"The receiver acts as a value holder on itself"

	x := aPoint3D x.
	y := aPoint3D y.
	z := aPoint3D z! !

!Point3D methodsFor: 'computing' stamp: 'emm 02/09/2012 23:16'!
verticesDo: aBlock
	aBlock value: self! !

!Point3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:16'!
x

	"Answer the value of x"

	^x! !

!Point3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:16'!
x: aValue

	"Set the value of x"

	x := aValue! !

!Point3D methodsFor: 'computing' stamp: 'emm 02/09/2012 23:16'!
xRatioTo: otherPoint

	^x = 0
		ifTrue: [ otherPoint x = 0
			ifTrue: [ 0 ]
			ifFalse: [ self error: 'points not on same line'  ] ]
		ifFalse: [ otherPoint x = 0
			ifTrue: [ self error: 'points not on same line'  ] 
			ifFalse: [ otherPoint x / x ] ]! !

!Point3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:16'!
xy
	"Answer a (2D) Point for which 
	the x-value is the receiver's x and
	the y-value is the receiver's y
	"
	^x @ y! !

!Point3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:16'!
y

	"Answer the value of y"

	^y! !

!Point3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:16'!
y: aValue

	"Set the value of y"

	y := aValue! !

!Point3D methodsFor: 'computing' stamp: 'emm 02/09/2012 23:16'!
yRatioTo: otherPoint

	^y = 0
		ifTrue: [ otherPoint y = 0
			ifTrue: [ 0 ]
			ifFalse: [ self error: 'points not on same line'  ] ]
		ifFalse: [ otherPoint y = 0
			ifTrue: [ self error: 'points not on same line'  ] 
			ifFalse: [ otherPoint y / y ]]! !

!Point3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:16'!
yz
	"Answer a (2D) Point for which 
	the x-value is the receiver's y and
	the y-value is the receiver's z
	"
	^y @ z! !

!Point3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:16'!
z
	"Answer the z coordinate."

	^z! !

!Point3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:16'!
z: zInteger 
	"Set the z coordinate."

	z := zInteger! !

!Point3D methodsFor: 'computing' stamp: 'emm 02/09/2012 23:16'!
zRatioTo: otherPoint

	^z = 0
		ifTrue: [ otherPoint z = 0
			ifTrue: [ 0 ]
			ifFalse: [ self error: 'points not on same line'  ] ]
		ifFalse: [ otherPoint z = 0
			ifTrue: [ self error: 'points not on same line'  ] 
			ifFalse: [ otherPoint z / z ]]! !

Point3D subclass: #Point4D
	instanceVariableNames: 'd'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Structures3D'!

!Point4D class methodsFor: 'instance creation' stamp: 'emm 02/09/2012 23:16'!
unity

	^self x: 1 y: 1 z: 1 d: 1! !

!Point4D class methodsFor: 'instance creation' stamp: 'emm 02/09/2012 23:16'!
x: xPoint y: yPoint z: zPoint d: dPoint
	"Answer a new HomogeneousPoint"

	^self basicNew setX: xPoint setY: yPoint setZ: zPoint setD: dPoint! !

!Point4D class methodsFor: 'instance creation' stamp: 'emm 02/09/2012 23:16'!
zero

	^self x: 0 y: 0 z: 0 d: 0! !

!Point4D methodsFor: 'arithmetic' stamp: 'emm 02/09/2012 23:16'!
+ aPoint4D

	"Answer a new Point4D"
	
	^self class 
		x: x + aPoint4D x 
		y: y + aPoint4D y 
		z: z + aPoint4D z 
		d: d + aPoint4D d! !

!Point4D methodsFor: 'arithmetic' stamp: 'emm 02/09/2012 23:16'!
- aPoint4D

	"Answer a new Point4D"
	
	^self class 
		x: x - aPoint4D x 
		y: y - aPoint4D y 
		z: z - aPoint4D z 
		d: d - aPoint4D d! !

!Point4D methodsFor: 'quaternion-accessing' stamp: 'emm 02/09/2012 23:16'!
a
	^x! !

!Point4D methodsFor: 'converting' stamp: 'emm 02/09/2012 23:16'!
asArray

	^Array with: x with: y with: z with: d! !

!Point4D methodsFor: 'quaternion-accessing' stamp: 'emm 02/09/2012 23:16'!
b
	^y! !

!Point4D methodsFor: 'quaternion-accessing' stamp: 'emm 02/09/2012 23:16'!
c
	^z! !

!Point4D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:16'!
d
	^d! !

!Point4D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:16'!
d: aValue
	
	d := aValue! !

!Point4D methodsFor: 'printing' stamp: 'emm 02/09/2012 23:16'!
kindDo: aRequestor
	aRequestor doPoint4D: self! !

!Point4D methodsFor: 'printing' stamp: 'emm 02/09/2012 23:16'!
printOn: aStream
	"Append to the argument aStream in terms of infix notation."

	super printOn: aStream.
	aStream nextPut: $,.
	d printOn: aStream! !

!Point4D methodsFor: 'printing' stamp: 'emm 02/09/2012 23:16'!
printOn: aStream delimitedBy: separator

	super printOn: aStream delimitedBy: separator.
	aStream nextPutAll: separator.
	d printOn: aStream! !

!Point4D methodsFor: 'private' stamp: 'emm 02/09/2012 23:16'!
setX: xPoint setY: yPoint setZ: zPoint setD: dPoint

	x := xPoint.
	y := yPoint.
	z := zPoint.
	d := dPoint.! !

Object subclass: #Point3DCollection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Collections3D'!

Point3DCollection subclass: #OrderedPoint3DCollection
	instanceVariableNames: 'collection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Collections3D'!

!OrderedPoint3DCollection methodsFor: 'comparing' stamp: 'emm 02/09/2012 23:42'!
= otherCollection

	^self class == otherCollection class
		and:[ collection = otherCollection collection ]! !

!OrderedPoint3DCollection methodsFor: 'adding-removing' stamp: 'emm 02/09/2012 23:42'!
add: aCPoint
	"Answer the point"

	collection 
		add: aCPoint x
		; add: aCPoint y
		; add: aCPoint z.
	^aCPoint! !

!OrderedPoint3DCollection methodsFor: 'adding-removing' stamp: 'emm 02/09/2012 23:42'!
add: aPoint1 add: aPoint2 
	"Don't answer any point"

	collection
		add: aPoint1 x
		add: aPoint1 y
		add: aPoint1 z.
	collection
		add: aPoint2 x
		add: aPoint2 y
		add: aPoint2 z! !

!OrderedPoint3DCollection methodsFor: 'adding-removing' stamp: 'emm 02/09/2012 23:42'!
add: aPoint1 add: aPoint2 add: aPoint3 
	"Don't answer any point"

	collection
		add: aPoint1 x
		add: aPoint1 y
		add: aPoint1 z.
	collection
		add: aPoint2 x
		add: aPoint2 y
		add: aPoint2 z.
	collection
		add: aPoint3 x
		add: aPoint3 y
		add: aPoint3 z! !

!OrderedPoint3DCollection methodsFor: 'adding-removing' stamp: 'emm 02/09/2012 23:42'!
addAll: aCollection
	aCollection do:[ :each | self add: each ]! !

!OrderedPoint3DCollection methodsFor: 'adding-removing' stamp: 'emm 02/09/2012 23:42'!
addFrom: otherPointCollection at: otherIndex 
	"Add the coordinates of the point at <otherIndex> from <otherPointCollection> 
	to the receiver. Do not answer that point"

	| offset |
	offset := otherIndex - 1 * 3 + 1.
	collection
		addNext: 3
		from: otherPointCollection collection
		startingAt: offset! !

!OrderedPoint3DCollection methodsFor: 'adding-removing' stamp: 'emm 02/09/2012 23:42'!
addX: xNumber y: yNumber z: zNumber 
	"Do not answer that point"

	collection
		add: xNumber
		add: yNumber
		add: zNumber! !

!OrderedPoint3DCollection methodsFor: 'converting' stamp: 'emm 02/09/2012 23:42'!
asMatrix
	"Answer a new Matrix with (collection size // 3) columns and 3 rows"

	| elements columnSize j |
	elements := collection copy.
	columnSize := collection size // 3.
	j := 1.
	1 to: collection size by: 3 do: [:i | 
		elements at: j put: (collection at: i).
		elements at: j + columnSize put: (collection at: i + 1).
		elements at: j + columnSize + columnSize put: (collection at: i + 2).
		j := j + 1].
	^self matrixClass new: 3 @ columnSize elements: elements! !

!OrderedPoint3DCollection methodsFor: 'converting' stamp: 'emm 02/09/2012 23:42'!
asPlane
	"Answer a new Plane by three noncolineair points from the receiver"

	^Plane3D fromColineairPoints: (Array
			with: (self at: 2)
			with: (self at: 3)
			with: (self at: 1))! !

!OrderedPoint3DCollection methodsFor: 'converting' stamp: 'emm 02/09/2012 23:42'!
asSegments
	| points |
	points := OrderedPoint3DCollection new.
	self do: 
			[:each | 
			points
				add: each;
				add: each].
	points add: points removeFirst.
	^LineSegment3DComposite fromPoints: points! !

!OrderedPoint3DCollection methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:42'!
at: anInteger 
	"Answer the point at <anInteger>"

	| offset |
	offset := anInteger - 1 * 3 + 1.
	^Point3D
		x: (collection noCheckAt: offset)
		y: (collection noCheckAt: offset + 1)
		z: (collection noCheckAt: offset + 2)! !

!OrderedPoint3DCollection methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:42'!
at: index put: aPoint3D 

	self at: index putX: aPoint3D x y: aPoint3D y z: aPoint3D z! !

!OrderedPoint3DCollection methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:42'!
at: anInteger putX: x y: y z: z
	"Set the point at <anInteger>"

	| offset |
	offset := anInteger - 1 * 3 + 1.
	collection noCheckAt: offset put: x.
	collection noCheckAt: offset + 1 put: y.
	collection noCheckAt: offset + 2 put: z.! !

!OrderedPoint3DCollection methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:42'!
center
	"Answer the center point"

	| xSum ySum zSum mySize |
	xSum := ySum := zSum := 0.
	1 to: collection size by: 3 do: [:i | 
		xSum := xSum + (collection at: i).
		ySum := ySum + (collection at: i + 1).
		zSum := zSum + (collection at: i + 2)].
	mySize := self size.
	^Point3D
		x: xSum / mySize
		y: ySum / mySize
		z: zSum / mySize! !

!OrderedPoint3DCollection methodsFor: 'transforming' stamp: 'emm 02/09/2012 23:42'!
centered
	"Can be more effficient"	

	| myCenter |
	myCenter := self center.
	^self class new addAll: ( self collect: [ :each | each - myCenter ] ) ;yourself! !

!OrderedPoint3DCollection methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:42'!
collect: aBlock 

	| result value |
	result := OrderedCollection new: self size.
	1 to: collection size by: 3 do: [:i | 
		value := aBlock value: (collection at: i)
						@ (collection at: i + 1) @ (collection at: i + 2).
		result add: value].
	^result! !

!OrderedPoint3DCollection methodsFor: 'private' stamp: 'emm 02/09/2012 23:42'!
collection

	^collection! !

!OrderedPoint3DCollection methodsFor: 'private' stamp: 'emm 02/09/2012 23:42'!
collection: aCollection 

	collection := aCollection! !

!OrderedPoint3DCollection methodsFor: 'computing' stamp: 'emm 02/09/2012 23:42'!
computeNormal
	"Newell's method"

	| a b c x1 y1 z1 x2 y2 z2 m j |
	a := b := c := 0.
	m := collection size.
	1 to: m // 3 by: 3 do: [:i | 
		j := i + 2 \\ m + 1.
		x1 := collection at: i.
		y1 := collection at: i + 1.
		z1 := collection at: i + 2.
		x2 := collection at: j.
		y2 := collection at: j + 1.
		z2 := collection at: j + 2.
		a := y1 - y2 * (z1 + z2) + a.
		b := z1 - z2 * (x1 + x2) + b.
		c := x1 - x2 * (y1 + y2) + c].
	^(Point3D
		x: a
		y: b
		z: c) normalized! !

!OrderedPoint3DCollection methodsFor: 'computing' stamp: 'emm 02/09/2012 23:42'!
computeVertexAtFraction: fraction

	"fraction [0..1]"

	fraction = 0
		ifTrue: [ ^self first ].
	fraction = 1
		ifTrue: [ ^self last ].
	"fraction = <0..1>"
	^self at: ((self size - 1) * fraction + 1) rounded! !

!OrderedPoint3DCollection methodsFor: 'private' stamp: 'emm 02/09/2012 23:42'!
copyAndGrow
	"VA specific"

	(collection growFactor * 3) timesRepeat:[collection add: nil].
	^self copy collection: collection! !

!OrderedPoint3DCollection methodsFor: 'copying' stamp: 'emm 02/09/2012 23:42'!
copyFrom: startIndex to: stopIndex 

	^self shallowCopy collection: (collection copyFrom: startIndex - 1 * 3 + 1 to: stopIndex * 3)! !

!OrderedPoint3DCollection methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:42'!
do: aBlock 

	1 to: collection size by: 3 do: [:i | 
		aBlock value: (collection at: i)
				@ (collection at: i + 1) @ (collection at: i + 2)]! !

!OrderedPoint3DCollection methodsFor: 'transforming' stamp: 'emm 02/09/2012 23:42'!
expandBy: aPoint

	| center x y z cx cy cz |
	center := self center.
	cx := center x.
	cy := center y.
	cz := center z.
	1 to: collection size by: 3 do:[ :i |
		x := collection at: i.
		x < cx
			ifTrue: [collection at: i put: x - aPoint x]
			ifFalse: [x > cx
				ifTrue: [collection at: i put: x + aPoint x]].
		y := collection at: i + 1.
		y < cy
			ifTrue: [collection at: i + 1 put: y - aPoint y]
				ifFalse: [y > cy
				ifTrue: [collection at: i + 1 put: y + aPoint y]].
		z := collection at: i + 2.
		z < cz
			ifTrue: [collection at: i + 2 put: z - aPoint z]
			ifFalse: [z > cz
				ifTrue: [collection at: i + 2 put: z + aPoint z]]].! !

!OrderedPoint3DCollection methodsFor: '*Zenna-Modelling3D' stamp: 'emm 02/09/2012 23:50'!
extrudedBy: aPoint

	^SimpleExtrudedPolygon base: self translation: aPoint! !

!OrderedPoint3DCollection methodsFor: '*Zenna-Modelling3D' stamp: 'emm 02/09/2012 23:50'!
extrudedTo: otherPolygon
	"Which one is top and bottom ?"

	^TwoFacedExtrudedPolygon
		between: self
		and: otherPolygon! !

!OrderedPoint3DCollection methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:42'!
first
	^self at: 1! !

!OrderedPoint3DCollection methodsFor: 'private' stamp: 'emm 02/09/2012 23:42'!
growToAtLeast: newSize 
	"VW specific"

	collection growToAtLeast: newSize * 3! !

!OrderedPoint3DCollection methodsFor: 'comparing' stamp: 'emm 02/09/2012 23:42'!
hash

	^collection hash! !

!OrderedPoint3DCollection methodsFor: 'testing' stamp: 'emm 02/09/2012 23:42'!
indexOfX: x y: y z: z 

	| xIndex xEnd |
	xIndex := 1.
	xEnd := collection size - 2.
	[ xIndex <= xEnd ]
		whileTrue: 
			[ ( ( collection at: xIndex )
				= x and: [ ( collection at: xIndex + 1 )
					= y and: [ ( collection at: xIndex + 2 )
						= z ] ] )
				ifTrue: [ ^xIndex // 3 + 1].
			xIndex := xIndex + 3 ].
	^0! !

!OrderedPoint3DCollection methodsFor: 'initialize-release' stamp: 'emm 02/09/2012 23:42'!
initialize

	
		"at least room for 4 points"collection := OrderedCollection new: 12! !

!OrderedPoint3DCollection methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:42'!
inject: thisValue into: binaryBlock

	| nextValue |
	nextValue := thisValue.
	self do: [:each | nextValue := binaryBlock value: nextValue value: each].
	^nextValue! !

!OrderedPoint3DCollection methodsFor: 'transforming' stamp: 'emm 02/09/2012 23:42'!
interpolatedBy: howMany

	"Answer a new collection containing all points of the receiver
	with for each succeeding pair of points an interpolating point (the middle).
	I'm not sure about the method name"
	
	| newCollection lastX lastY lastZ newIndex x y z |
	newCollection := Array new: 2 * collection size  - 3.
	collection size <=3 
		ifTrue: [^self copy].
	newIndex := 0.
	lastX := newCollection at: (newIndex := newIndex + 1) put: (collection at: 1).
	lastY := newCollection at: (newIndex := newIndex + 1) put: (collection at: 2).
	lastZ := newCollection at: (newIndex := newIndex + 1) put: (collection at: 3).
	4 to: collection size by: 3 do:[ :i |
		x := collection at: i.
		y := collection at: i + 1.
		z := collection at: i + 2.
		newCollection at: (newIndex := newIndex + 1) put: x + lastX / 2.
		newCollection at: (newIndex := newIndex + 1) put: y + lastY / 2.
		newCollection at: (newIndex := newIndex + 1) put: z + lastZ / 2.
		newCollection at: (newIndex := newIndex + 1) put: (lastX := x).
		newCollection at: (newIndex := newIndex + 1) put: (lastY := y).
		newCollection at: (newIndex := newIndex + 1) put: (lastZ := z)].
	^self class new collection: newCollection asOrderedCollection! !

!OrderedPoint3DCollection methodsFor: 'testing' stamp: 'emm 02/09/2012 23:42'!
isEmpty

	^collection isEmpty! !

!OrderedPoint3DCollection methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:42'!
last
	^self at: self size! !

!OrderedPoint3DCollection methodsFor: 'private' stamp: 'emm 02/09/2012 23:42'!
leftShiftCoordinates
	"Remove the first point and append it again"

	collection addLast: collection removeFirst. "x"
	collection addLast: collection removeFirst. "y"
	collection addLast: collection removeFirst. "z"! !

!OrderedPoint3DCollection methodsFor: 'converting' stamp: 'emm 02/09/2012 23:42'!
merge: otherPointCollection! !

!OrderedPoint3DCollection methodsFor: 'transforming' stamp: 'emm 02/09/2012 23:42'!
mirrorInYZ

	1 to: collection size by: 3 do:[ :i | collection noCheckAt: i put: (collection noCheckAt: i) negated ].
	self reverse.! !

!OrderedPoint3DCollection methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:42'!
normal

	^self computeNormal
! !

!OrderedPoint3DCollection methodsFor: 'copying' stamp: 'emm 02/09/2012 23:42'!
postCopy

	collection := collection copy! !

!OrderedPoint3DCollection methodsFor: 'printing' stamp: 'emm 02/09/2012 23:42'!
printClassCreationOn: aStream indent: level

	aStream
		 nextPutAll: '('
		; nextPutAll: self class name
		; nextPutAll: ' new: '
		; print: self size
		; nextPut: $).! !

!OrderedPoint3DCollection methodsFor: 'printing' stamp: 'emm 02/09/2012 23:42'!
printOn: aStream 

	self printOn: aStream indent: 0! !

!OrderedPoint3DCollection methodsFor: 'printing' stamp: 'emm 02/09/2012 23:42'!
printOn: aStream indent: level

	self printClassCreationOn: aStream indent: level.
	1 to: collection size by: 3 do: [:i | 
		aStream crtab: level + 1.
		i > 1
			ifTrue: [ aStream nextPutAll: '; ' ].
		aStream
			 nextPutAll: 'add: ('
			; print: ( collection at: i )
			; nextPut: $,
			; print: ( collection at: i + 1 )
			; nextPut: $,
			; print: ( collection at: i + 2 )
			; nextPut: $)].
	collection size > 0
		ifTrue: [ aStream crtab: level + 1; nextPutAll: '; yourself' ].! !

!OrderedPoint3DCollection methodsFor: 'double dispatching' stamp: 'emm 02/09/2012 23:42'!
productFromMatrix3x3: aMatrix3x3 

	^aMatrix3x3 productFromOrderedPoint3DCollection: self! !

!OrderedPoint3DCollection methodsFor: 'computing' stamp: 'emm 02/09/2012 23:42'!
quickNormal
	"only take the first three points to determine the normal"

	| i n |
	i := 1.
	[ n := ( self at: i + 1 )
				- ( self at: i ) crossProduct: ( self at: i + 2 )
					- ( self at: i + 1 ).
	n isZero and: [ i < ( self size - 2 ) ] ]
		whileTrue: [ i := i + 1 ].
	^n normalized! !

!OrderedPoint3DCollection methodsFor: 'adding-removing' stamp: 'emm 02/09/2012 23:42'!
removeFirst

	| first |
	first := self at: 1.
	collection removeFirst.
	collection removeFirst.
	collection removeFirst.
	^first! !

!OrderedPoint3DCollection methodsFor: 'adding-removing' stamp: 'emm 02/09/2012 23:42'!
removeLast

	| last |
	last := self at: self size.
	collection removeLast.
	collection removeLast.
	collection removeLast.
	^last! !

!OrderedPoint3DCollection methodsFor: 'transforming' stamp: 'emm 02/09/2012 23:42'!
reverse
	"Reverse the order of points for the receiver"

	| mySize tail head temp |
	((mySize := self size) = 0 or: [mySize = 1])
		ifTrue: [^self].
	tail := 1.
	head := collection size - 2.
	[tail < head]
		whileTrue: 
			[3
				timesRepeat: 
					[temp := collection at: tail.
					collection at: tail put: (collection at: head).
					collection at: head put: temp.
					head := head + 1.
					tail := tail + 1].
			head := head - 6]! !

!OrderedPoint3DCollection methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:42'!
reverseDo: aBlock

	collection size to: 1 by: -3 do: [:i | 
		aBlock value: (collection at: i - 2)
				@ (collection at: i - 1) @ (collection at: i )]! !

!OrderedPoint3DCollection methodsFor: 'transforming' stamp: 'emm 02/09/2012 23:42'!
reverseOriented

	^self reversed "rightShiftCoordinates rightShiftCoordinates"! !

!OrderedPoint3DCollection methodsFor: 'private' stamp: 'emm 02/09/2012 23:42'!
rightShiftCoordinates
	"Remove the last point and prepend it again"

	| size x y z |
	size := collection size.
	z := collection at: size.
	y := collection at: size - 1.
	x := collection at: size - 2.
	size to: 4 by: -1 do:[ :index |
		collection at: index put: (collection at: index - 3) ].
	collection at: 1 put: x.
	collection at: 2 put: y.
	collection at: 3 put: z.
"
	collection addFirst: collection removeLast. 
	collection addFirst: collection removeLast. 
	collection addFirst: collection removeLast.
"! !

!OrderedPoint3DCollection methodsFor: 'transforming' stamp: 'emm 02/09/2012 23:42'!
rotateBy: aPoint 
	"Rotate the receiver using <aPoint> that contains angles for each axis: x, y ,z"

	| rotation matrix |
	aPoint isZero ifTrue: [ ^self ].
	matrix := self matrixClass rotation: aPoint.
	collection := (matrix * self) collection! !

!OrderedPoint3DCollection methodsFor: 'transforming' stamp: 'emm 02/09/2012 23:42'!
scaleBy: factor 
	"Scale the receiver by factor (an instance of Point3D or scalar)." 

	| scale |
	factor isNumber
		ifTrue:
			[ 1 to: collection size do:[ :i | collection at: i put: (collection at: i) * factor].
			^self ].
	scale := factor x.
	scale ~= 1
		ifTrue: [ 1 to: collection size by: 3 do: [:i | collection at: i put: (collection at: i) *  scale ] ].
	scale := factor y.
	scale ~= 1
		ifTrue: [ 2 to: collection size by: 3 do: [:i | collection at: i put: (collection at: i) *  scale ] ].
	scale := factor z.
	scale ~= 1
		ifTrue: [ 3 to: collection size by: 3 do: [:i | collection at: i put: (collection at: i) *  scale ] ].! !

!OrderedPoint3DCollection methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:42'!
sharedPointsFrom: otherPoint3DCollection 
	"Answer the collection of points which are shared between the receiver and 
	<otherPolygon>"

	| shared |
	shared := OrderedPoint3DCollection new.
	self xyzDo: [:x :y :z | 
		(otherPoint3DCollection
			includesX: x
			y: y
			z: z)
			ifTrue: [shared
					addX: x
					y: y
					z: z]].
	^shared! !

!OrderedPoint3DCollection methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:42'!
size

	^collection size / 3! !

!OrderedPoint3DCollection methodsFor: 'private' stamp: 'emm 02/09/2012 23:42'!
swap: firstIndex with: secondIndex

	"Swap point info @firstIndex with that of @secondIndex"

	| x firstOffset y z secondOffset |
	firstOffset := firstIndex - 1 * 3 + 1.
	x := collection noCheckAt: firstOffset.
	y := collection noCheckAt: firstOffset + 1.
	z := collection noCheckAt: firstOffset + 2.
	secondOffset := secondIndex - 1 * 3 + 1.
	collection noCheckAt: firstOffset put: (collection noCheckAt: secondOffset).
	collection noCheckAt: firstOffset + 1 put: (collection noCheckAt: secondOffset + 1).
	collection noCheckAt: firstOffset + 2 put: (collection noCheckAt: secondOffset + 2).
	collection noCheckAt: secondOffset put: x.
	collection noCheckAt: secondOffset + 1 put: y.
	collection noCheckAt: secondOffset + 2 put: z

	! !

!OrderedPoint3DCollection methodsFor: 'transforming' stamp: 'emm 02/09/2012 23:42'!
translateBy: aPoint 

	| translation |
	translation := aPoint x.
	translation ~= 0
		ifTrue: [ 1 to: collection size by: 3 do: [:i | collection at: i put: (collection at: i) +  translation ] ].
	translation := aPoint y.
	translation ~= 0
		ifTrue: [ 2 to: collection size by: 3 do: [:i | collection at: i put: (collection at: i) +  translation ] ].
	translation := aPoint z.
	translation ~= 0
		ifTrue: [ 3 to: collection size by: 3 do: [:i | collection at: i put: (collection at: i) +  translation ] ].! !

!OrderedPoint3DCollection methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:42'!
triangles

	self size = 3
		ifTrue: [^Array with: (Triangle3D
					with: (self at: 1)
					with: (self at: 2)
					with: (self at: 3))].
	^self trianglesTo: self center! !

!OrderedPoint3DCollection methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:42'!
trianglesDo: aBlock 

	| first third |
	self size = 3
		ifTrue: [^aBlock value: (Triangle3D
					with: (self at: 1)
					with: (self at: 2)
					with: (self at: 3))].
	self size = 4
		ifTrue: 
			[first := self at: 1.
			third := self at: 3.
			aBlock value: (Triangle3D
					with: first
					with: (self at: 2)
					with: third).
			^aBlock value: (Triangle3D
					with: first
					with: third
					with: (self at: 4))].
	self trianglesTo: self center do: aBlock! !

!OrderedPoint3DCollection methodsFor: 'computing' stamp: 'emm 02/09/2012 23:42'!
trianglesTo: aCenterPoint 
	"Preserve the vertex-order"

	| triangles |
	self size < 3 ifTrue: [^#()].
	triangles := Triangle3DComposite new.
	1 to: self size - 1
		do: 
			[:i | 
			triangles 
				addTriangleWith: (self at: i)
				with: (self at: i + 1)
				with: aCenterPoint].
	triangles 
		addTriangleWith: (self at: self size)
		with: (self at: 1)
		with: aCenterPoint.
	^triangles! !

!OrderedPoint3DCollection methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:42'!
trianglesTo: centerPoint do: aBlock 
	"Preserve the vertex-order"

	self size < 3
		ifTrue: [^self].
	1 to: self size - 1 do: [:i | 
		aBlock value: (Triangle3D
				with: (self at: i)
				with: (self at: i + 1)
				with: centerPoint)].
	aBlock value: (Triangle3D
			with: (self at: self size)
			with: (self at: 1)
			with: centerPoint)! !

!OrderedPoint3DCollection methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:42'!
verticesDo: aBlock 

	self do: aBlock! !

!OrderedPoint3DCollection methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:42'!
with: otherCollection do: twoArgBlock

	self size < otherCollection size
		ifTrue: [ self error: 'size mismatch' ].
	1 to: otherCollection size do:[:i |
		twoArgBlock value: (self at: i ) value: (otherCollection at: i) ]! !

!OrderedPoint3DCollection methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:42'!
xyzDo: aBlock 

	1 to: collection size by: 3 do: [:i | 
		aBlock
			value: (collection at: i)
			value: (collection at: i + 1)
			value: (collection at: i + 2)]! !

OrderedPoint3DCollection subclass: #Polygon3D
	instanceVariableNames: 'normal'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Collections3D'!

Polygon3D subclass: #ColoredPolygon3D
	instanceVariableNames: 'color'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Appearance3D'!

!ColoredPolygon3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:44'!
color

	"Answer the value of color"

	^color! !

!ColoredPolygon3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:44'!
color: aValue

	"Set the value of color"

	color := aValue! !

!ColoredPolygon3D methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:44'!
kindDo: aRequestor

	^ aRequestor doColoredPolygon3D: self

! !

!Polygon3D methodsFor: 'overriding' stamp: 'emm 02/09/2012 23:43'!
add: aPoint

	normal := nil.
	^super add: aPoint! !

!Polygon3D methodsFor: 'overriding' stamp: 'emm 02/09/2012 23:43'!
addFrom: otherPointCollection at: otherIndex

	normal := nil.
	^super addFrom: otherPointCollection at: otherIndex! !

!Polygon3D methodsFor: 'overriding' stamp: 'emm 02/09/2012 23:43'!
addX: xNumber y: yNumber z: zNumber

	normal := nil.
	^super addX: xNumber y: yNumber z: zNumber! !

!Polygon3D methodsFor: 'computing' stamp: 'emm 02/09/2012 23:43'!
asPolygon3D

	^self! !

!Polygon3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:43'!
backLeft

	"Answer the point with the smallest y and smallest x coordinates"

	| minY index y minX |
	minY := SmallInteger maxVal .
	minX := SmallInteger maxVal.
	1 to: collection size by: 3 do:[ :i | minX := minX min: (collection at: i) ].
	index := nil.
	2 to: collection size by: 3 do:[ :i | 
		((collection at: i - 1) = minX and:[ (y := collection at: i) < minY ])
			ifTrue: [ minY := y. index := i ]].
	^minX @ minY @ (collection at: index + 1)! !

!Polygon3D methodsFor: '*Zenna-Appearance3D' stamp: 'emm 02/09/2012 23:44'!
coloredWith: aColor

	^(ColoredPolygon3D withAll: self) color: aColor! !

!Polygon3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:43'!
faces
	"Adaptor"

	^Array with: self! !

!Polygon3D methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:43'!
facesDo: aBlock

	"Assume the points of the receiver are all on the same plane"
	
	^aBlock value: self! !

!Polygon3D methodsFor: 'initialize-release' stamp: 'emm 02/09/2012 23:43'!
flush

	normal := nil! !

!Polygon3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:43'!
frontLeft

	"Answer the point with the smallest y and largest x coordinates"

	| minY maxX index y |
	minY := SmallInteger maxVal .
	maxX := minY negated.
	1 to: collection size by: 3 do:[ :i | maxX := maxX max: (collection at: i) ].
	index := nil.
	2 to: collection size by: 3 do:[ :i | 
		((collection at: i - 1) = maxX and:[ (y := collection at: i) < minY ])
			ifTrue: [ minY := y. index := i - 1]].
	^(collection at: index) @ minY @ (collection at: index + 2)! !

!Polygon3D methodsFor: 'testing' stamp: 'emm 02/09/2012 23:43'!
isBack
	"All points must have same x + normal is pointing to positive x"

	| firstX norm |
	firstX := (self at: 1) x.
	4 to: collection size by: 3 do:[ :xIndex |
		(collection at: xIndex) = firstX "same X-plane"
			ifFalse: [^false]].
	norm := self normal.
	^norm x > 0
		and:[ norm y = 0
			and:[ norm z = 0 ]]! !

!Polygon3D methodsFor: 'testing' stamp: 'emm 02/09/2012 23:43'!
isBottom
	"All points must have same z + normal is pointing to positive z"

	| firstZ norm |
	firstZ := (self at: 1) z.
	6 to: collection size by: 3 do:[ :zIndex |
		(collection at: zIndex) = firstZ "same Z-plane"
			ifFalse: [^false]].
	norm := self normal.
	^norm x = 0
		and:[ norm y = 0
			and:[ norm z > 0 ]]! !

!Polygon3D methodsFor: 'testing' stamp: 'emm 02/09/2012 23:43'!
isFront
	"All points must have same x + normal is pointing to negative x"

	| firstX norm |
	firstX := collection at: 1.
	4 to: collection size by: 3 do: [:xIndex | 
		( collection at: xIndex )
			= firstX
			ifFalse: [ "same X-plane"
				^false ]].
	norm := self normal.
	^norm x < 0 and: [ norm y = 0 and: [ norm z = 0 ] ]! !

!Polygon3D methodsFor: 'testing' stamp: 'emm 02/09/2012 23:43'!
isLeft
	"All points must have same y + normal is pointing to positive y"

	| firstY norm |
	firstY := (self at: 1) y.
	5 to: collection size by: 3 do:[ :yIndex |
		(collection at: yIndex) = firstY "same Z-plane"
			ifFalse: [^false]].
	norm := self normal.
	^norm x = 0
		and:[ norm y > 0
			and:[ norm z = 0 ]]! !

!Polygon3D methodsFor: 'testing' stamp: 'emm 02/09/2012 23:43'!
isRight
	"All points must have same y + normal is pointing to negative y"

	| firstY norm |
	firstY := (self at: 1) y.
	5 to: collection size by: 3 do:[ :yIndex |
		(collection at: yIndex) = firstY "same Z-plane"
			ifFalse: [^false]].
	norm := self normal.
	^norm x = 0
		and:[ norm y < 0
			and:[ norm z = 0 ]]! !

!Polygon3D methodsFor: 'testing' stamp: 'emm 02/09/2012 23:43'!
isTop
	"All points must have same z + normal is pointing to negative z"

	| firstZ norm |
	firstZ := (self at: 1) z.
	6 to: collection size by: 3 do:[ :zIndex |
		(collection at: zIndex) = firstZ "same Z-plane"
			ifFalse: [^false]].
	norm := self normal.
	^norm x = 0
		and:[ norm y = 0
			and:[ norm z < 0 ]]! !

!Polygon3D methodsFor: 'reflection' stamp: 'emm 02/09/2012 23:43'!
kindDo: aRequestor

	^aRequestor doPolygon3D: self! !

!Polygon3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:43'!
leftBack

	self deprecated: #leftBack.
	^self backLeft! !

!Polygon3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:43'!
leftFront

	self deprecated: #leftFront.
	^self frontLeft! !

!Polygon3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:43'!
normal

	^normal isNil
		ifTrue: [normal := self quickNormal]
		ifFalse: [normal]! !

!Polygon3D methodsFor: 'copying' stamp: 'emm 02/09/2012 23:43'!
postCopy

	normal := nil.
	super postCopy! !

!Polygon3D methodsFor: 'printing' stamp: 'emm 02/09/2012 23:43'!
printClassCreationOn: aStream indent: level

	| side |
	super printClassCreationOn: aStream indent: level.
	side := self whichSide.
	side = #unknown
		ifFalse: [ aStream space ; nextPut: $" ;nextPutAll: side ;nextPut: $" ].! !

!Polygon3D methodsFor: 'overriding' stamp: 'emm 02/09/2012 23:43'!
reverse

	normal := nil.
	super reverse! !

!Polygon3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:43'!
rightBack

	"Answer the point with the largest y and smallest x coordinates"

	| maxY index x minX |
	maxY := SmallInteger maxVal negated.
	minX := SmallInteger maxVal.
	1 to: collection size by: 3 do:[ :i | maxY := maxY max: (collection at: i + 1) ].
	index := nil.
	2 to: collection size by: 3 do:[ :i | 
		((collection at: i ) = maxY and:[ (x := collection at: i - 1) < minX ])
			ifTrue: [ minX := x. index := i]].
	^minX @ maxY @ (collection at: index + 1)! !

!Polygon3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:43'!
rightFront

	"Answer the point with the largest y and largest x coordinates"

	| maxY maxX index x |
	maxY := SmallInteger maxVal negated.
	maxX := SmallInteger maxVal negated.
	1 to: collection size by: 3 do:[ :i | maxY := maxY max: (collection at: i + 1) ].
	index := nil.
	2 to: collection size by: 3 do:[ :i | 
		((collection at: i ) = maxY and:[ (x := collection at: i - 1) > maxX ])
			ifTrue: [ maxX := x. index := i]].
	^maxX @ maxY @ (collection at: index + 1)! !

!Polygon3D methodsFor: 'computing' stamp: 'emm 02/09/2012 23:43'!
subdividedBy: xyPoint
	"Only implemented for 4 sided faces"

	| faces  segments ds dt s t ls12 ls23 ls34 ls41 face|
	self size ~= 4 ifTrue: [ ^Array with: self ].
	faces := FaceComposite new.
	segments := self asSegments. 
	ds := 1 / xyPoint x.
	dt := 1 / xyPoint y.
	t := 0.
	xyPoint y timesRepeat:[
		s := 0.
		xyPoint x timesRepeat:[
			ls12 := ((segments at: 4) computeVertexAtFraction: 1-t)
				lineSegmentTo:
						((segments at: 2) computeVertexAtFraction: t).		
			ls23 := ((segments at: 1) computeVertexAtFraction: s+ds)
				lineSegmentTo:
						((segments at: 3) computeVertexAtFraction: 1-s-ds).		
			ls34 := ((segments at: 2) computeVertexAtFraction: t+dt)
				lineSegmentTo:
						((segments at: 4) computeVertexAtFraction: 1-t-dt).
			ls41 := ((segments at: 3) computeVertexAtFraction: 1-s)
				lineSegmentTo:
						((segments at: 1) computeVertexAtFraction: s).		
			face := Polygon3D new.
			face add: (ls12 computeVertexAtFraction: s).
			face add: (ls23 computeVertexAtFraction: t).
			face add: (ls34 computeVertexAtFraction: 1-s-ds).
			face add: (ls41 computeVertexAtFraction: 1-t-dt).
			faces add: face.
			s := s + ds].
		t := t + dt].
	^faces

		
			
			! !

!Polygon3D methodsFor: 'testing' stamp: 'emm 02/09/2012 23:43'!
substractPolygon3D: aPolygon3D addResultsTo: aCollection

	"Pre: aPolygon3D is completely inside the receiver.
	@aPolygon3D has fewer points
	Invariant: the order of vertices
	"
	| insiders  outsiders thisDist firstInside outsideIndex insideIndex in out newPoly distance |
	insiders := aPolygon3D vertices.
	outsiders := self vertices.
	thisDist := SmallInteger maxVal.
	firstInside := insiders first.
	outsiders doWithIndex:[ :each :i |
		| eachDist |
		eachDist := each dist: firstInside.
		eachDist < thisDist
			ifTrue:
				[ thisDist := eachDist.
				outsideIndex := i ]].
	insideIndex := 1.
	in := insiders at: insideIndex.
	out := outsiders at: outsideIndex.

	newPoly := self class new.
	newPoly add: in.
	newPoly add: out.

	insideIndex := insideIndex + 1.
	in := insiders at: insideIndex.
	thisDist := out dist: in.

	outsideIndex := outsideIndex + 1.
	out := outsiders at: outsideIndex.
	newPoly add: out.

	out := outsiders at: outsideIndex + 1.
	distance := out dist: in.

	distance <= thisDist 
		whileTrue:
			[ thisDist := distance.
			newPoly add: out.
			out := outsiders at: outsideIndex + 1.
			distance := out dist: in ].

	newPoly add: in.
	aCollection add: newPoly.

	newPoly := self class new.	
	newPoly add: in.
	newPoly add: out.

	insideIndex := insideIndex + 1.
	in := insiders at: insideIndex.
	thisDist := out dist: in.
			
	
		! !

!Polygon3D methodsFor: '*Zenna-Appearance3D' stamp: 'emm 02/09/2012 23:44'!
texturedWith: aTexture

	^self wrapTexturedWith: aTexture! !

!Polygon3D methodsFor: 'testing' stamp: 'emm 02/09/2012 23:43'!
whichSide

	self size < 3
		ifTrue: [ ^#undefined ].
	self isTop
		ifTrue: [ ^#top ].
	self isBottom
		ifTrue: [ ^#bottom ].
	self isFront
		ifTrue: [ ^#front ].
	self isBack
		ifTrue: [ ^#back ].
	self isLeft
		ifTrue: [ ^#left ].
	self isRight
		ifTrue: [ ^#right ].
	^#unknown! !

!Polygon3D methodsFor: '*Zenna-Wrappers3D' stamp: 'emm 02/09/2012 23:45'!
wrapRotateBy: p

	^Geometric3DWrapper on: self rotateBy: p! !

!Polygon3D methodsFor: '*Zenna-Wrappers3D' stamp: 'emm 02/09/2012 23:45'!
wrapTexturedWith: aTexture

	^( TextureWrapper on: self ) texture: aTexture! !

!Polygon3D methodsFor: '*Zenna-Wrappers3D' stamp: 'emm 02/09/2012 23:45'!
wrapTranslateBy: p

	^Geometric3DWrapper on: self translateBy: p! !

OrderedPoint3DCollection subclass: #Polyline3D
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Collections3D'!

!Polyline3D methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:43'!
kindDo: aRequestor

	^aRequestor doPolyline3D: self! !

!Point3DCollection class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:42'!
from: startPoint to: endPoint
	
	^Point3DInterval new
		start: startPoint
		;stop: endPoint
		;step: (endPoint - startPoint) normalized! !

!Point3DCollection class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:42'!
from: startPoint to: endPoint by: stepPoint
	
	^Point3DInterval  basicNew initialize
		start: startPoint
		;stop: endPoint
		;step: stepPoint! !

!Point3DCollection class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:41'!
fromBitString: aStringWithSeparators

	| strings inStream |
	strings := OrderedCollection new.
	inStream := ReadStream on: aStringWithSeparators.
	[inStream atEnd]
		whileFalse:
			[strings add: inStream nextLine].
	^self fromBitStrings: strings
	
			! !

!Point3DCollection class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:42'!
fromBitStrings: aZeroOneStringCollection

	"self fromBitStrings: #( '1001' '' '' '1001' )"

	| points zeroOneString |
	points := OrderedPoint3DCollection  basicNew initialize.
	0 to: aZeroOneStringCollection size - 1 do:[ :y |
		zeroOneString :=  aZeroOneStringCollection at: y + 1.
		0 to: zeroOneString size - 1 do:[ :x |
			 ( zeroOneString at: x + 1) == $1
					ifTrue: [ points addX: x y: aZeroOneStringCollection size - y - 1 z: 0 ]]].
	^points
			! !

!Point3DCollection class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:42'!
fromRectangle: aRectangle

	^(self new)
			add: aRectangle corner @ 0
			; add: aRectangle topRight @ 0
			; add: aRectangle origin	 @ 0
			; add: aRectangle bottomLeft @ 0
			; yourself! !

!Point3DCollection class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:42'!
new

	^ self == Point3DCollection
		ifTrue: [ OrderedPoint3DCollection  basicNew initialize ]
		ifFalse: [ super new initialize ]! !

!Point3DCollection class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:42'!
new: verticesSize 

	^self basicNew collection: ( OrderedCollection new: verticesSize * 3 )! !

!Point3DCollection class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:42'!
with: p1

	^(self new)
			add: p1
			; yourself! !

!Point3DCollection class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:42'!
with: p1 with: p2

	^(self new)
			add: p1
			; add: p2
			; yourself! !

!Point3DCollection class methodsFor: 'instance-creation' stamp: 'emm 10/7/2012 22:52'!
with: p1 with: p2 with: p3

	^(self new)
			add: p1
			; add: p2
			; add: p3
			; yourself! !

!Point3DCollection class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:42'!
with: p1 with: p2 with: p3 with: p4

	^(self new)
			add: p1
			; add: p2
			; add: p3
			; add: p4
			; yourself! !

!Point3DCollection class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:42'!
withAll: aPoint3DCollection 

	^( self new ) addAll: aPoint3DCollection ; yourself! !

!Point3DCollection methodsFor: 'arithmetic' stamp: 'emm 02/09/2012 23:41'!
* anArgument 

	^anArgument productFromOrderedPoint3DCollection: self! !

!Point3DCollection methodsFor: 'converting' stamp: 'emm 02/09/2012 23:41'!
, otherPoint3DCollection

	| result |
	result := OrderedPoint3DCollection new.
	result addAll: self.
	result addAll: otherPoint3DCollection.
	^result! !

!Point3DCollection methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:41'!
addVerticesTo: aCollection

	self do:[ :each | aCollection add: each ]! !

!Point3DCollection methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:41'!
asArray

	| newArray mySize |
	newArray := Array new: (mySize := self size).
	1 to: mySize do:[ :i |
		newArray at: i put: (self at: i) ].
	^newArray! !

!Point3DCollection methodsFor: '*Zenna-Modelling3D' stamp: 'emm 02/09/2012 23:50'!
asLabeledCollection

	| labeled |
	labeled := OrderedCollection new: self size.
	1 to: self size do:[ :i |
		labeled add: ((self at:i) asLabeledPoint label: i printString)].
	^labeled! !

!Point3DCollection methodsFor: 'converting' stamp: 'emm 02/09/2012 23:41'!
asMatrix
	"Answer a new Matrix with (collection size // 3) columns and 3 rows"

	self subclassResponsibility! !

!Point3DCollection methodsFor: 'converting' stamp: 'emm 02/09/2012 23:41'!
asPlane
	"Answer a new Plane by three noncolineair points from the receiver"

	self subclassResponsibility! !

!Point3DCollection methodsFor: 'converting' stamp: 'emm 02/09/2012 23:41'!
asSet

	| set |
	set := Set new: self size.
	self do:[ :each | set add: each ].
	^set! !

!Point3DCollection methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:41'!
at: anInteger 
	"Answer the point at <anInteger>"

	self subclassResponsibility! !

!Point3DCollection methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:41'!
bounds

	| bbOrigin bbCorner |
	^self isEmpty
		ifTrue: [ 0@0@0 corner: 0@0@0 ]
		ifFalse: 
			[ bbOrigin := self first.
			bbCorner := self first.
			self do:[ :each | 
				bbOrigin := bbOrigin  min: each.
				bbCorner := bbCorner max: each ].
			BoundingBox origin: bbOrigin corner: bbCorner ]! !

!Point3DCollection methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:41'!
center
	"Answer the center point"

	self subclassResponsibility! !

!Point3DCollection methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:41'!
collect: aBlock  
	"Evaluate aBlock with each of the values of the receiver as the  
	argument.  Collect the resulting values into a collection that is like 
	the receiver.  Answer the new collection."

	| newCollection |
	newCollection := self species new.
	self do: [:each | newCollection add: (aBlock value: each)].
	^newCollection! !

!Point3DCollection methodsFor: 'copying' stamp: 'emm 02/09/2012 23:41'!
copy
	"Non-ANSI Smalltalk"
	" Answer another instance just like the receiver.
	Subclasses normally override the postCopy
	message, but some objects that should not be
	copied override copy. "

	^self shallowCopy postCopy! !

!Point3DCollection methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:41'!
detect: aBlock 
	"Evaluate aBlock with each of the receiver's elements as the argument.
	Answer the first element for which aBlock evaluates to true."

	^self collection detect: aBlock! !

!Point3DCollection methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:41'!
detect: aBlock ifNone: exceptionBlock 
	"Evaluate aBlock with each of the receiver's elements as the argument.
	Answer the first element for which aBlock evaluates to true."

	self do: [:each | (aBlock value: each) ifTrue: [^each]].
	^exceptionBlock value! !

!Point3DCollection methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:41'!
do: aBlock 

	self subclassResponsibility! !

!Point3DCollection methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:41'!
do: elementBlock separatedBy: separatorBlock 
	"Evaluate elementBlock for each element in the collection.
	Between each pair of elements, but not before the first or
	after the last, evaluate the separatorBlock."

	self isEmpty
		ifTrue: [ ^self ].
	elementBlock value: ( self at: 1 ).
	2 to: self size do: [:i | 
		separatorBlock value.
		elementBlock value: ( self at: i )]! !

!Point3DCollection methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:41'!
doWithIndex: aBlock

	"Iteratively evaluate the two argument block, aBlock using
	 each element of the receiver, in order, and the element
	 index.

	 Fail if aBlock is not a two argument block."

	1
		to: self size
		do: [:index | aBlock value: (self at: index) value: index].! !

!Point3DCollection methodsFor: 'transforming' stamp: 'emm 02/09/2012 23:41'!
expandBy: aPoint

	self subclassResponsibility! !

!Point3DCollection methodsFor: 'transforming' stamp: 'emm 02/09/2012 23:41'!
expandedBy: aPointOrScalar

	^self copy expandBy: aPointOrScalar! !

!Point3DCollection methodsFor: '*Zenna-Modelling3D' stamp: 'emm 02/09/2012 23:50'!
extrudedTo: otherPolygon
	"Which one is top and bottom ?"

	^TwoFacedExtrudedPolygon
		between: self
		and: otherPolygon! !

!Point3DCollection methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:41'!
first
	^self at: 1! !

!Point3DCollection methodsFor: 'testing' stamp: 'emm 02/09/2012 23:41'!
includes: aPoint 

	^self includesX: aPoint x y: aPoint y z: aPoint z! !

!Point3DCollection methodsFor: 'testing' stamp: 'emm 02/09/2012 23:41'!
includesX: x y: y z: z 

	^(self indexOfX: x y: y z: z ) ~= 0! !

!Point3DCollection methodsFor: 'testing' stamp: 'emm 02/09/2012 23:41'!
indexOf: aPoint

	^self indexOfX: aPoint x y: aPoint y z: aPoint z ! !

!Point3DCollection methodsFor: 'testing' stamp: 'emm 02/09/2012 23:41'!
indexOfX: x y: y z: z 

	^self subclassResponsibility! !

!Point3DCollection methodsFor: 'initialize-release' stamp: 'emm 02/09/2012 23:41'!
initialize
	"Subclasses may use this to initialize instance variables"! !

!Point3DCollection methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:41'!
inject: thisValue into: binaryBlock 
	"Accumulate a running value associated with evaluating the argument,
	binaryBlock, with the current value and the receiver as block arguments. 
	The initial value is the value of the argument, thisValue."

	"For example, to sum a collection, use: 
		collection inject: 0 into: [:subTotal :next | subTotal + next]."

	| nextValue |
	nextValue := thisValue.
	self do: [:each | nextValue := binaryBlock value: nextValue value: each].
	^nextValue! !

!Point3DCollection methodsFor: 'transforming' stamp: 'emm 02/09/2012 23:41'!
interpolatedBy: howMany

	"Answer a new collection containing all points of the receiver
	with for each succeeding pair of points an interpolating point (the middle).
	I'm not sure about the method name"
	
	self subclassResponsibility! !

!Point3DCollection methodsFor: 'testing' stamp: 'emm 02/09/2012 23:41'!
isEmpty

	^self subclassResponsibility! !

!Point3DCollection methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:41'!
keysAndValuesDo: binaryBlock 

	1 to: self size do: [:i | 
		binaryBlock value: i value: ( self at: i )]! !

!Point3DCollection methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:41'!
kindDo: aRequestor

	^aRequestor doPoint3DCollection: self! !

!Point3DCollection methodsFor: 'resources' stamp: 'emm 02/09/2012 23:41'!
matrixClass

	^Matrix3x3! !

!Point3DCollection methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:41'!
maximum
	"Answer the point which is farest from zero"

	| zero dist max maxDist |
	zero := Point3D zero.
	max := self first.
	maxDist := max dist: zero.
	self do: [:each | 
		(dist := each dist: zero) > maxDist
			ifTrue: 
				[max := each.
				maxDist := dist]].
	^max! !

!Point3DCollection methodsFor: 'converting' stamp: 'emm 02/09/2012 23:41'!
merge: otherPointCollection! !

!Point3DCollection methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:41'!
minimum
	"Answer the point which is closest to zero"

	| zero dist min minDist |
	zero := Point3D zero.
	min := self first.
	minDist := min dist: zero.
	self do: [:each | 
		(dist := each dist: zero) < minDist
			ifTrue: 
				[min := each.
				minDist := dist]].
	^min! !

!Point3DCollection methodsFor: 'transforming' stamp: 'emm 02/09/2012 23:41'!
mirrorInYZ

	self subclassResponsibility! !

!Point3DCollection methodsFor: 'transforming' stamp: 'emm 02/09/2012 23:41'!
mirroredInYZ
	
	^ ( self normal dotProduct: ( 1 , 0 , 0 ) ) = 0
		ifTrue:[ self copy mirrorInYZ ]
		ifFalse:[ self reverseOriented mirrorInYZ ]! !

!Point3DCollection methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:41'!
normal
	self subclassResponsibility! !

!Point3DCollection methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:41'!
pairIterator
	
	^PairwiseCollectionIterator on: self! !

!Point3DCollection methodsFor: 'copying' stamp: 'emm 02/09/2012 23:41'!
postCopy
	" Finish doing whatever is required,
	beyond a shallowCopy, to implement 'copy'.
	Answer the receiver.
	This message is only intended to be sent
	to the newly created instance.
	Subclasses may add functionality,
	but they should always do super postCopy first. "
	" Note that any subclass that 'mixes in Modelness'
	(i.e., implements dependents with an instance
	variable) must include the equivalent of
	'self breakDependents' in its implementation
	of postCopy. "

	^self! !

!Point3DCollection methodsFor: 'arithmetic' stamp: 'emm 02/09/2012 23:41'!
projectionWithMatrix: aMatrix width: aWidth height: aHeight distance: aDistance
	"First rough implementation to compute the screen coordinates for a given Point and 	projection matrix"
	"See: L.Ammeraal"

	| xe ye ze x y z px py points |
	points := OrderedCollection new.
	self xyzDo:[ :xp :yp :zp |
		x := yp negated.
		y := xp.
		z := zp negated.
		xe := (aMatrix at: 1@1) * x + ((aMatrix at: 2@1)*y).
		ye := (aMatrix at: 1@2) * x + ((aMatrix at: 2@2)*y) + ((aMatrix at: 3@2) * z).
		ze := (aMatrix at: 1@3) * x + ((aMatrix at: 2@3)*y) + ((aMatrix at: 3@3) * z) + (aMatrix at: 4@3).
		px := aDistance * xe / ze + (aWidth/2).
		py := aDistance * ye / ze + (aHeight/4). "/2"
		points add: px@py].
	^points! !

!Point3DCollection methodsFor: 'streams' stamp: 'emm 02/09/2012 23:41'!
readStream

	^ReadStream on: self! !

!Point3DCollection methodsFor: 'transforming' stamp: 'emm 02/09/2012 23:41'!
reverse
	"Reverse the order of points for the receiver"

	self subclassResponsibility! !

!Point3DCollection methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:41'!
reverseDo: aBlock

	self subclassResponsibility! !

!Point3DCollection methodsFor: 'transforming' stamp: 'emm 02/09/2012 23:41'!
reverseOriented

	self subclassResponsibility! !

!Point3DCollection methodsFor: 'transforming' stamp: 'emm 02/09/2012 23:41'!
reversed
	"Answer a copy of the receiver for which the points are in reverse order"

	^self copy reverse! !

!Point3DCollection methodsFor: 'transforming' stamp: 'emm 02/09/2012 23:41'!
rotateBy: aPoint 
	"Rotate the receiver using <aPoint> that contains angles for each axis: x, y ,z"

	self subclassResponsibility! !

!Point3DCollection methodsFor: 'transforming' stamp: 'emm 02/09/2012 23:41'!
rotatedBy: aPoint 
	"Answer a new collection which is the result of  rotating the receiver using <aPoint> 
	that contains angles for each axis: x, y ,z"

	^self copy rotateBy: aPoint! !

!Point3DCollection methodsFor: 'transforming' stamp: 'emm 02/09/2012 23:41'!
scaleBy: aPoint 

	self subclassResponsibility! !

!Point3DCollection methodsFor: 'transforming' stamp: 'emm 02/09/2012 23:41'!
scaledBy: aPoint 

	^self copy scaleBy: aPoint! !

!Point3DCollection methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:41'!
segmentsDo: aBlock 

	| segments begin end |
	segments := OrderedCollection new: self size - 1.
	self isEmpty
		ifTrue: [^segments].
	begin := self at: 1.
	2 to: self size do: [:i | 
		end := self at: i.
		aBlock value: (LineSegment3D from: begin to: end).
		begin := end].
	^segments! !

!Point3DCollection methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:41'!
select: aBlock 
	"Evaluate aBlock with each of the receiver's elements as the argument. 
	Collect into a new collection like the receiver, only those elements for which
	aBlock evaluates to true.  Answer the new collection."

	| newCollection |
	newCollection := self species new.
	self do: [:each | (aBlock value: each) ifTrue: [newCollection add: each]].
	^newCollection! !

!Point3DCollection methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:41'!
size

	self subclassResponsibility! !

!Point3DCollection methodsFor: 'transforming' stamp: 'emm 02/09/2012 23:41'!
translateBy: aPoint 

	self subclassResponsibility! !

!Point3DCollection methodsFor: 'transforming' stamp: 'emm 02/09/2012 23:41'!
translatedBy: aPoint 

	^self copy translateBy: aPoint! !

!Point3DCollection methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:41'!
vertices

	| vertices |
	vertices := OrderedCollection new: self size.
	self verticesDo:[ :each |
		vertices add: each ].
	^vertices! !

!Point3DCollection methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:41'!
verticesDo: aBlock 

	self do: aBlock! !

!Point3DCollection methodsFor: 'streams' stamp: 'emm 02/09/2012 23:41'!
writeStream

	^WriteStream on: self! !

!Point3DCollection methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:41'!
xyzDo: aBlock 

	self subclassResponsibility! !

Point3DCollection subclass: #Point3DInterval
	instanceVariableNames: 'start stop step'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Collections3D'!

!Point3DInterval methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:42'!
at: anIndex

	^anIndex - 1 * self step + self start! !

!Point3DInterval methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:42'!
by
	^step! !

!Point3DInterval methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:42'!
by: aValue
	step := aValue! !

!Point3DInterval methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:42'!
do: aBlock 
	"Evaluate <aBlock> for the receiver's elements: [start, stop]"

	| where |
	where := start.
	self size timesRepeat:[
		aBlock value: where.
		where := where + step ]! !

!Point3DInterval methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:42'!
first

	^self start! !

!Point3DInterval methodsFor: 'testing' stamp: 'emm 02/09/2012 23:42'!
includes: aPoint

	self detect:[ :each | each = aPoint ] ifNone:[^false].
	^true! !

!Point3DInterval methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:42'!
increment

	^self by! !

!Point3DInterval methodsFor: 'testing' stamp: 'emm 02/09/2012 23:42'!
isEmpty

	^self size = 0! !

!Point3DInterval methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:42'!
last

	^self stop! !

!Point3DInterval methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:42'!
openDo: aBlock 
	"Do not evaluate <aBlock> for the receiver's start or stop: <start, stop>"

	| n end |
	n := 1.
	end := self size - 2.
	[ n <= end ]
		whileTrue: 
			[ aBlock value: start + ( step * n ).
			n := n + 1 ]! !

!Point3DInterval methodsFor: 'printing' stamp: 'emm 02/09/2012 23:42'!
printOn: aStream

	aStream 
		print: self start
		; nextPutAll: ' to: '
		; print: self stop.
	(start isNil or:[stop isNil or:[step = (stop - start) normalized]])
		ifFalse: 
			[aStream 
				nextPutAll: ' by: ' 
				; print: self step].! !

!Point3DInterval methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:42'!
reverseDo: aBlock 
	"Evaluate <aBlock> for the receiver's elements: [start, stop]"

	| where |
	where := start + (self size - 1 * step ).
	self size timesRepeat:[
		aBlock value: where.
		where := where - step ]! !

!Point3DInterval methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:42'!
size
	"Pre: step > 0,0,0 , stop >= start"

	| delta |
	delta := stop - start + step.
	step x = 0
		ifTrue: [ step y = 0
				ifTrue: [ step z = 0
						ifTrue: [ ^0 ]
						ifFalse: [ ^delta z / step z ] ]
				ifFalse: [ "x=0, y>0"
					step z = 0
						ifTrue: [ ^delta y / step y ]
						ifFalse: [ ^delta y / step y max: delta z / step z ] ] ]
		ifFalse: [ step y = 0
				ifTrue: [ step z = 0
						ifTrue: [ ^delta x / step x ]
						ifFalse: [ ^delta x / step x max: delta z / step z ] ]
				ifFalse: [ "x,y>0"
					step z = 0
						ifTrue: [ ^delta x / step x max: delta y / step y ]
						ifFalse: [ ^( delta x / step x max: delta y / step y )
								max: delta z / step z ] ] ]! !

!Point3DInterval methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:42'!
start

	^start! !

!Point3DInterval methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:42'!
start: aValue

	start := aValue! !

!Point3DInterval methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:42'!
step

	^step! !

!Point3DInterval methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:42'!
step: aValue

	step := aValue asPoint3D! !

!Point3DInterval methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:42'!
stop

	^stop! !

!Point3DInterval methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:42'!
stop: aValue

	stop := aValue! !

Point3DCollection subclass: #SortedPoint3DCollection
	instanceVariableNames: 'xCollection yCollection zCollection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Collections3D'!

!SortedPoint3DCollection class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:43'!
new

	"Answer a new instance of the receiver and initialize it"

	^super new initialize! !

!SortedPoint3DCollection class methodsFor: 'tests' stamp: 'emm 02/09/2012 23:43'!
test0
	"self test0"

	| p |
	p := OrderedCollection new.
	1 to: 100000 do:[ :i | p add: ( i,i,i ) ].
	^Time millisecondsToRun:[100 timesRepeat:[p indexOf: 999,999,999]]! !

!SortedPoint3DCollection class methodsFor: 'tests' stamp: 'emm 02/09/2012 23:43'!
test1
	"(EsbSampler spyOn:[self test1]) browse"

	| p |
	p := SortedPoint3DCollection new.
	1 to: 100000 do:[ :i | p add: ( i,i,i ) ].
	^Time millisecondsToRun:[100 timesRepeat:[p indexOf: 999,999,999]]! !

!SortedPoint3DCollection class methodsFor: 'tests' stamp: 'emm 02/09/2012 23:43'!
test2
	"self test2"
"
	| p |
	p := SortedPoint3DCollection new.
	1 to: 100000 do:[ :i | p add: ( i,i,i ) ].
	(EsbSampler spyOn:[100 timesRepeat:[p indexOf: 999,999,999]]) browse
"
! !

!SortedPoint3DCollection methodsFor: 'adding' stamp: 'emm 02/09/2012 23:43'!
add: aPoint3D

	| index |
	index := xCollection defaultBinarySearchAdding: aPoint3D x.
	xCollection defaultInsert: aPoint3D x atIndex: index.
	yCollection insert: aPoint3D y atIndex: index.
	zCollection insert: aPoint3D z atIndex: index.
	^aPoint3D! !

!SortedPoint3DCollection methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:43'!
do: aBlock

	xCollection doWithIndex:[ :x :i | 
		aBlock value: (Point3D x: x y: (yCollection at:i) z: (zCollection at:i)) ]! !

!SortedPoint3DCollection methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:43'!
indexOf: aPoint3D

	^self indexOf: aPoint3D startingAt: 1! !

!SortedPoint3DCollection methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:43'!
indexOf: aPoint3D startingAt: index

	| x y z mySize firstIndex |
	x := aPoint3D x.
	firstIndex := xCollection indexOf: x startingAt: index.
	firstIndex = 0 
		ifTrue: [ ^0 ].
		
	y := aPoint3D y.
	z := aPoint3D z.
	mySize := self size.		
	[ firstIndex <= mySize and:[ ( xCollection noCheckAt: firstIndex ) = x ]]
		whileTrue:
			[ (( yCollection noCheckAt: firstIndex ) = y
				and:[ ( zCollection noCheckAt: firstIndex ) = z ])
					ifTrue: [ ^firstIndex ].
			firstIndex := firstIndex + 1].
	^0! !

!SortedPoint3DCollection methodsFor: 'initialize-release' stamp: 'emm 02/09/2012 23:43'!
initialize

	xCollection := SortedCollection new.
	yCollection := OrderedCollection new.
	zCollection := OrderedCollection new.! !

!SortedPoint3DCollection methodsFor: 'printing' stamp: 'emm 02/09/2012 23:43'!
printOn: aStream

	xCollection doWithIndex:[ :x :index |
		x printOn: aStream.
		aStream nextPut: $, .
		(yCollection at: index) printOn: aStream.
		aStream nextPut: $, .
		(zCollection at: index) printOn: aStream.
		aStream cr]! !

!SortedPoint3DCollection methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:43'!
size

	^xCollection size! !

!SortedPoint3DCollection methodsFor: 'private' stamp: 'emm 02/09/2012 23:43'!
xCollection

	"Answer the value of xCollection"

	^xCollection! !

!SortedPoint3DCollection methodsFor: 'private' stamp: 'emm 02/09/2012 23:43'!
xCollection: aValue

	"Set the value of xCollection"

	xCollection := aValue! !

!SortedPoint3DCollection methodsFor: 'private' stamp: 'emm 02/09/2012 23:43'!
yCollection

	"Answer the value of yCollection"

	^yCollection! !

!SortedPoint3DCollection methodsFor: 'private' stamp: 'emm 02/09/2012 23:43'!
yCollection: aValue

	"Set the value of yCollection"

	yCollection := aValue! !

!SortedPoint3DCollection methodsFor: 'private' stamp: 'emm 02/09/2012 23:43'!
zCollection

	"Answer the value of zCollection"

	^zCollection! !

!SortedPoint3DCollection methodsFor: 'private' stamp: 'emm 02/09/2012 23:43'!
zCollection: aValue

	"Set the value of zCollection"

	zCollection := aValue! !

Object subclass: #RandomColor
	instanceVariableNames: 'random'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Appearance3D'!

!RandomColor class methodsFor: 'instance-creation' stamp: 'emm 26/11/2001 15:31'!
new

	"Answer a new instance of the receiver and initialize it"

	^super new initialize! !

!RandomColor methodsFor: 'accessing' stamp: 'emm 26/11/2001 15:31'!
blue01

	^self nextColorComponent01! !

!RandomColor methodsFor: 'accessing' stamp: 'emm 26/11/2001 15:31'!
blueByte

	^self nextColorComponent255! !

!RandomColor methodsFor: 'accessing' stamp: 'emm 26/11/2001 15:31'!
green01

	^self nextColorComponent01! !

!RandomColor methodsFor: 'accessing' stamp: 'emm 26/11/2001 15:31'!
greenByte

	^self nextColorComponent255! !

!RandomColor methodsFor: 'initialize-release' stamp: 'emm 03/10/2002 17:25'!
initialize
	random := Random new! !

!RandomColor methodsFor: 'dispatching' stamp: 'emm 27/11/2002 21:05'!
kindDo: aRequestor
	^aRequestor doColor: self! !

!RandomColor methodsFor: 'accessing' stamp: 'emm 27/11/2002 21:08'!
name

	^self uniqueName! !

!RandomColor methodsFor: 'accessing' stamp: 'emm 28/09/2002 16:49'!
next

	^Color
		redByte: self nextColorComponent255
		greenByte: self nextColorComponent255
		blueByte: self nextColorComponent255! !

!RandomColor methodsFor: 'private' stamp: 'emm 26/11/2001 15:31'!
nextColorComponent01

	^random next! !

!RandomColor methodsFor: 'private' stamp: 'emm 26/11/2001 15:31'!
nextColorComponent255

	^(random next * 255) rounded! !

!RandomColor methodsFor: 'accessing' stamp: 'emm 26/11/2001 15:31'!
red01

	^self nextColorComponent01! !

!RandomColor methodsFor: 'accessing' stamp: 'emm 26/11/2001 15:31'!
redByte

	^self nextColorComponent255! !

!RandomColor methodsFor: 'accessing' stamp: 'emm 26/11/2001 15:31'!
transparency
	^0! !

Object subclass: #SVGMarker
	instanceVariableNames: 'id viewBox markerUnits markerWidth orient path'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-FormatSVG'!

!SVGMarker methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:06'!
id
	^id! !

!SVGMarker methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:06'!
id: anObject
	id := anObject! !

!SVGMarker methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:06'!
kindDo: aRequestor
	^ aRequestor doSVGMarker: self! !

!SVGMarker methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:06'!
markerUnits
	^markerUnits! !

!SVGMarker methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:06'!
markerUnits: anObject
	markerUnits := anObject! !

!SVGMarker methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:06'!
markerWidth
	^markerWidth! !

!SVGMarker methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:06'!
markerWidth: anObject
	markerWidth := anObject! !

!SVGMarker methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:06'!
orient
	^orient! !

!SVGMarker methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:06'!
orient: anObject
	orient := anObject! !

!SVGMarker methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:06'!
path
	^path! !

!SVGMarker methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:06'!
path: anObject
	path := anObject! !

!SVGMarker methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:06'!
viewBox
	^viewBox! !

!SVGMarker methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:06'!
viewBox: anObject
	viewBox := anObject! !

Object subclass: #SVGPaintProperties
	instanceVariableNames: 'fill stroke strokeWidth strokeDashArray'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-FormatSVG'!

!SVGPaintProperties methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:06'!
addAttributesTo: element 

	stroke notNil 
		ifTrue: [ element at: 'stroke' put: stroke asHTML ].
	fill notNil 
		ifTrue: [ element at: 'fill' put: (fill isString ifTrue: [fill] ifFalse:[fill asHTML])].
	strokeWidth notNil 
		ifTrue: [ element at: 'stroke-width' put: strokeWidth printString ].
	strokeDashArray notNil 
		ifTrue: [ element 
			at: 'stroke-dasharray' 
			put: (strokeDashArray inject: '' into:[ :concat :each | concat , ' ' , each printString]) ].	! !

!SVGPaintProperties methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:06'!
addAttributesToText: element 

	(fill notNil and:[fill ~= 'none' ])
		ifTrue: [ element at: 'fill' put: fill asHTML].! !

!SVGPaintProperties methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:06'!
fill: aColorOrNil
	
	aColorOrNil isNil ifTrue: [^fill := 'none'].
	fill := aColorOrNil 
	! !

!SVGPaintProperties methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:06'!
stroke: aColorOrNil
	
	aColorOrNil isNil ifTrue: [^stroke := nil].
	stroke := aColorOrNil 
	! !

!SVGPaintProperties methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:06'!
strokeDashArray: anArray

	strokeDashArray := anArray! !

!SVGPaintProperties methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:06'!
strokeWidth: anObject

	anObject = 1
		ifTrue: [strokeWidth := nil]
		ifFalse: [strokeWidth := anObject]! !

!SVGPaintProperties methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:06'!
writeAttributesOn: aStream 

	fill ifNotNil: [ :c | aStream nextPutAll: 'fill="' ; nextPutAll: (c isString ifTrue:[c] ifFalse:[c asHTML]) ; nextPutAll: '" ' ].
	stroke ifNotNil: [ :c | aStream nextPutAll: 'stroke="' ; nextPutAll: c asHTML ; nextPutAll: '" ' ].
	strokeWidth ifNotNil: [ :w | aStream nextPutAll: 'stroke-width="' ; print: w ; nextPutAll: '" ' ]! !

Object subclass: #SceneBuilder
	instanceVariableNames: 'stack elements approximator scale colorIndex'
	classVariableNames: ''
	poolDictionaries: 'Math3DConstants'
	category: 'Zenna-SceneBuilding2D'!

SceneBuilder subclass: #SVGSceneBuilder
	instanceVariableNames: 'paintProperties sceneExtent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-FormatSVG'!

!SVGSceneBuilder methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:06'!
approximatorClass
	"Not yet supported"
	^String! !

!SVGSceneBuilder methodsFor: 'appearance' stamp: 'emm 02/09/2012 23:06'!
color: aColor
	self fillColor: aColor.
	self strokeColor: aColor.! !

!SVGSceneBuilder methodsFor: 'subclass responsibility' stamp: 'emm 02/09/2012 23:06'!
defaultWriterClass

	^SVGWriter! !

!SVGSceneBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:06'!
doCircle2D: aCircle2D
	| elm  cx cy r|
	aCircle2D sweepAngle deg = 360
		ifFalse:[^self doCircle2DArc: aCircle2D].
	elm := GenericSceneElement new className: 'circle'.
	elm at: 'cx' put: (cx := aCircle2D center x).
	elm at: 'cy' put: (cy := aCircle2D center y).
	elm at: 'r' put: (r := aCircle2D radius).		
	paintProperties addAttributesTo: elm.
	sceneExtent := sceneExtent max: cx+r@(cy+r).
	^elm! !

!SVGSceneBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:06'!
doCircle2DArc: aCircle2D
	| elm  cx cy r path lx ly|
	cx := aCircle2D center x.
	cy := aCircle2D center y.
	r := aCircle2D radius.
	elm := GenericSceneElement new className: 'path'.
	path := WriteStream on: String new.
	path 
		nextPutAll: 'M'
		;nextPutAll: cx rounded printString
		;nextPut: $,
		;nextPutAll: cy rounded printString

		;nextPutAll: ' L'
		;nextPutAll: (lx  := aCircle2D startPoint x rounded) printString
		;nextPut: $,
		;nextPutAll: (ly := aCircle2D startPoint y rounded) printString

		;nextPutAll: ' a'
		;nextPutAll: r printString
		;nextPut: $,
		;nextPutAll: r printString
		;space
		;nextPutAll: '0 0,1 '
		;nextPutAll: (aCircle2D endPoint x - lx) rounded printString
		;nextPut: $,
		;nextPutAll: (aCircle2D endPoint y - ly) rounded printString
		;nextPutAll: ' z'.
	elm at: 'd' put: path contents.
	paintProperties addAttributesTo: elm.
	sceneExtent := sceneExtent max: cx+r@(cy+r).
	^elm! !

!SVGSceneBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:06'!
doCurvedArrow: anArrow

	| elm  path|
	anArrow via isNil
		ifTrue: [^(LineSegment2D from: anArrow start to: anArrow end) kindDo: self].
	path := WriteStream on: String new.
	path 
		nextPutAll: 'M'
		;nextPutAll: anArrow start x printString
		;nextPut: $,
		;nextPutAll: anArrow start y printString

		;nextPutAll: ' Q'
		;nextPutAll: anArrow via x printString
		;nextPut: $,
		;nextPutAll: anArrow via y printString
		;space
		;nextPutAll: anArrow end x printString
		;nextPut: $,
		;nextPutAll: anArrow end y printString.
		
	elm := GenericSceneElement new className: 'path'.
	elm style: 'fill:none'.
	elm at: 'd' put: path contents.
	paintProperties addAttributesTo: elm.	
	^elm		
	! !

!SVGSceneBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:06'!
doEllipticalArc2D: anEllipticalArc
	| elm |
	elm := GenericSceneElement new className: 'ellipse'.
	elm at: 'cx' put: anEllipticalArc center x.
	elm at: 'cy' put: anEllipticalArc center y.
	elm at: 'rx' put: anEllipticalArc radiusAsPoint x.
	elm at: 'ry' put: anEllipticalArc radiusAsPoint y.		
	paintProperties addAttributesTo: elm.		
	^elm! !

!SVGSceneBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:06'!
doLineSegment2D: aLineSegment
	| elm |
	elm := GenericSceneElement new className: 'line'.
	elm at: 'x1' put: aLineSegment start x.
	elm at: 'y1' put: aLineSegment start y.
	elm at: 'x2' put: aLineSegment end x.
	elm at: 'y2' put: aLineSegment end y.
	paintProperties addAttributesTo: elm.	
	sceneExtent := sceneExtent max: aLineSegment from.
	sceneExtent := sceneExtent max: aLineSegment to.	
	^elm! !

!SVGSceneBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:06'!
doPainting2DWrapper: aPainting2DWrapper 

	| element |
	element := aPainting2DWrapper component kindDo: self.
	aPainting2DWrapper stroke notNil ifTrue:[element at: 'stroke' put: aPainting2DWrapper stroke asHTML].
	aPainting2DWrapper fill notNil ifTrue:[element at: 'fill' put: aPainting2DWrapper fill asHTML].
	aPainting2DWrapper strokeWidth notNil ifTrue:[element at: 'stroke-width' put: aPainting2DWrapper strokeWidth printString].
	^element! !

!SVGSceneBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:06'!
doPolygon2D: aPolygon
	| elm |
	elm := self doPolyline2D:  aPolygon.
	elm at: 'style' put: nil.
	elm className: 'polygon'.
	paintProperties addAttributesTo: elm.	
	^elm! !

!SVGSceneBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:06'!
doPolyline2D: aPolyline 
	| elm pointStream |
	elm := GenericSceneElement new className: 'polyline'.
	pointStream := WriteStream on: ( String new: aPolyline size * 6 ).
	aPolyline vertices 
		do: [ :each | 
			each x printOn: pointStream.
			pointStream nextPut: $,.
			each y printOn: pointStream ] 
		separatedBy: [ pointStream nextPut: $, ].
	elm at: 'points' put: pointStream contents.
	paintProperties addAttributesTo: elm.	
	^elm! !

!SVGSceneBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:06'!
doRectangle: aRectangle
	| elm |
	elm := GenericSceneElement new className: 'rect'.
	elm at: 'x' put: aRectangle origin x.
	elm at: 'y' put: aRectangle origin y.
	elm at: 'width' put: aRectangle width.
	elm at: 'height' put: aRectangle height.		
	paintProperties addAttributesTo: elm.		
	sceneExtent := sceneExtent max: aRectangle origin.	
	sceneExtent := sceneExtent max: aRectangle corner.		
	^elm! !

!SVGSceneBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:06'!
doRoundedRectangle2D: aRRect2D

	| elm |
	elm := self doRectangle: aRRect2D.
	elm at: 'rx' put: aRRect2D xRadius.
	elm at: 'ry' put: aRRect2D yRadius.
	paintProperties addAttributesTo: elm.	
	^elm! !

!SVGSceneBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:06'!
doSVGMarker: aMarker
	^aMarker! !

!SVGSceneBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:06'!
doTranslating2DWrapper: aWrapper

	^ aWrapper component kindDo: self! !

!SVGSceneBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:06'!
doVisualText: aVisualText
	| elm  textExtent|
	elm := SceneElementGroup new className: 'text'.
	elm at: 'x' put: aVisualText origin x.
	elm at: 'y' put: aVisualText origin y.
	elm at: 'textLength' put: aVisualText text size.
	elm at: 'style' put: aVisualText style.
	paintProperties addAttributesToText: elm.
	
	"check for XML inside"
	( #( $< $> ) inject: false into:[ :pred :each | pred | (aVisualText string includes: each) ])
		ifTrue:[elm add: (SceneElement source: '<!![CDATA[' , aVisualText string , ']]>') ]
		ifFalse:[elm add: (SceneElement source: aVisualText string) ].
	"update extent TEMP"	
	textExtent := aVisualText pixelExtent.
	sceneExtent := sceneExtent max: aVisualText origin + (textExtent x @ textExtent y negated).
	^elm! !

!SVGSceneBuilder methodsFor: 'appearance' stamp: 'emm 02/09/2012 23:06'!
fillColor: aColor
	paintProperties fill: aColor! !

!SVGSceneBuilder methodsFor: 'subclass responsibility' stamp: 'emm 02/09/2012 23:06'!
initialize
	super initialize.
	paintProperties := SVGPaintProperties new.
	sceneExtent := 100@100.
	self push: (SceneElementGroup new className: 'svg')! !

!SVGSceneBuilder methodsFor: 'factory' stamp: 'emm 02/09/2012 23:06'!
newLink
	^ SceneElementGroup new className: 'a'! !

!SVGSceneBuilder methodsFor: 'factory' stamp: 'emm 02/09/2012 23:06'!
newText
	^VisualText new! !

!SVGSceneBuilder methodsFor: 'appearance' stamp: 'emm 02/09/2012 23:06'!
restoreAppearanceAfter: zeroBlock

	| old |
	old := paintProperties copy.
	zeroBlock value.
	paintProperties := old.! !

!SVGSceneBuilder methodsFor: 'appearance' stamp: 'emm 02/09/2012 23:06'!
sceneColor: aColor
	
	|backgroundRect|
	backgroundRect := 0@0 corner: (self stack first width@self stack first height).
	self fillColor: aColor.
	self strokeColor: aColor.
	self stack first addFirst: (backgroundRect kindDo: self)! !

!SVGSceneBuilder methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:06'!
sceneExtent
	^sceneExtent! !

!SVGSceneBuilder methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:06'!
sceneExtent: aPoint
	sceneExtent := aPoint! !

!SVGSceneBuilder methodsFor: 'appearance' stamp: 'emm 02/09/2012 23:06'!
sceneHeight: h
	self stack first height: h! !

!SVGSceneBuilder methodsFor: 'appearance' stamp: 'emm 02/09/2012 23:06'!
sceneWidth: w
	self stack first width: w! !

!SVGSceneBuilder methodsFor: 'appearance' stamp: 'emm 02/09/2012 23:06'!
strokeColor: aColor
	paintProperties stroke: aColor! !

!SVGSceneBuilder methodsFor: 'appearance' stamp: 'emm 02/09/2012 23:06'!
strokeDashArray: anArray
	paintProperties strokeDashArray: anArray! !

!SVGSceneBuilder methodsFor: 'appearance' stamp: 'emm 02/09/2012 23:06'!
strokeWidth: width
	paintProperties strokeWidth: width! !

!SVGSceneBuilder methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:06'!
viewBox: aRectangle
	self stack first viewBox: aRectangle! !

!SVGSceneBuilder methodsFor: 'appearance' stamp: 'emm 02/09/2012 23:06'!
writeAttributesOn: aStream 	
	paintProperties writeAttributesOn: aStream! !

!SVGSceneBuilder methodsFor: 'subclass responsibility' stamp: 'emm 02/09/2012 23:06'!
writeSceneUsing: aWriter

	self sceneWidth: self sceneExtent x.
	self sceneHeight: self sceneExtent y.	
	aWriter statistics at: 'width' put: self sceneExtent x.
	aWriter statistics at: 'height' put: self sceneExtent y.	
	self add: self pop.
	self elements 
		do: [ :each | each kindDo: aWriter ] 
		separatedBy: [ aWriter cr ]. ! !

SceneBuilder subclass: #Scene3DBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-SceneBuilding3D'!

Scene3DBuilder subclass: #D3DMeshBuilder
	instanceVariableNames: 'material mesh'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-FormatDirectX'!

!D3DMeshBuilder class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:56'!
new
	^super new initialize! !

!D3DMeshBuilder methodsFor: 'building' stamp: 'emm 02/09/2012 23:56'!
add: aGeometric3D withMaterial: aMaterial

	aGeometric3D facesDo:[ :each |
		mesh addFace: each withMaterial: aMaterial ]! !

!D3DMeshBuilder methodsFor: 'building' stamp: 'emm 02/09/2012 23:56'!
addFace: aFace withMaterial: aMaterial

	^mesh addFace: aFace withMaterial: aMaterial! !

!D3DMeshBuilder methodsFor: 'building-adding ( ISceneBuilder )' stamp: 'emm 02/09/2012 23:56'!
addObject: aGeometric3D

"
	aGeometric3D facesDo:[ :each |
		mesh addFace: each withMaterial: material ]
"
	aGeometric3D kindDo: self! !

!D3DMeshBuilder methodsFor: 'building-appearance ( ISceneBuilder )' stamp: 'emm 02/09/2012 23:56'!
color: aColor

	"Only create new material if appearance changed"

	( material notNil and:[ material faceColor = aColor ] )
		ifTrue:[ ^self ].
	material := D3DMeshMaterial colored: aColor! !

!D3DMeshBuilder methodsFor: 'writing ( ISceneBuilder )' stamp: 'emm 02/09/2012 23:56'!
defaultWriterClass

	^DirectXFileWriter! !

!D3DMeshBuilder methodsFor: 'dispatching-wrappers ( IWrapper3DVisitor )' stamp: 'emm 02/09/2012 23:56'!
doColorWrapper: aColoringWrapper

	"Handle the request from @aColoringWrapper"

	self color: aColoringWrapper color.
	aColoringWrapper component kindDo:self! !

!D3DMeshBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:56'!
doGeometric3D: aGeometric

	"On default, handle @aGeometric as an empty solid"

	^self doFaceComposite: aGeometric! !

!D3DMeshBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:56'!
doGeometric3DWrapper: aWrapper

	"Handle the request from @aTranslating3DWrapper"

	aWrapper facesDo:[ :each | each kindDo: self ]! !

!D3DMeshBuilder methodsFor: 'dispatching-wrappers ( IWrapper3DVisitor )' stamp: 'emm 02/09/2012 23:56'!
doHollowing3DWrapper: aHollowingWrapper

	"Handle the request from @aHollowingWrapper"

	self doGeometric3DWrapper: aHollowingWrapper! !

!D3DMeshBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:56'!
doPolygon3D: aPolygon3D

	mesh addFace: aPolygon3D withMaterial: material! !

!D3DMeshBuilder methodsFor: 'dispatching-wrappers ( IWrapper3DVisitor )' stamp: 'emm 02/09/2012 23:56'!
doRotating3DWrapper: aRotating3DWrapper

	"Handle the request from @aRotating3DWrapper"

	self doGeometric3DWrapper: aRotating3DWrapper! !

!D3DMeshBuilder methodsFor: 'dispatching-wrappers ( IWrapper3DVisitor )' stamp: 'emm 02/09/2012 23:56'!
doScaling3DWrapper: aScaling3DWrapper

	"Handle the request from @aScaling3DWrapper"

	self doGeometric3DWrapper: aScaling3DWrapper! !

!D3DMeshBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:56'!
doSolidComposite: aSolidComposite

	aSolidComposite do:[ :each | self add: each ]! !

!D3DMeshBuilder methodsFor: 'dispatching-wrappers ( IWrapper3DVisitor )' stamp: 'emm 02/09/2012 23:56'!
doTranslating3DWrapper: aTranslating3DWrapper

	"Handle the request from @aTranslating3DWrapper"

	self doGeometric3DWrapper: aTranslating3DWrapper! !

!D3DMeshBuilder methodsFor: 'initialize-release' stamp: 'emm 02/09/2012 23:56'!
initialize

	super initialize.
	mesh := D3DMesh new.	
	material := D3DMeshMaterial colored: Color white.! !

!D3DMeshBuilder methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:56'!
material

	"Answer the value of material"

	^material! !

!D3DMeshBuilder methodsFor: 'building' stamp: 'emm 02/09/2012 23:56'!
material: aMaterial

	material := aMaterial! !

!D3DMeshBuilder methodsFor: 'building-appearance ( ISceneBuilder )' stamp: 'emm 02/09/2012 23:56'!
texture: aString! !

!D3DMeshBuilder methodsFor: 'building' stamp: 'emm 02/09/2012 23:56'!
textureFilename: aString

	material textureFilename: aString! !

!D3DMeshBuilder methodsFor: 'writing ( ISceneBuilder )' stamp: 'emm 02/09/2012 23:56'!
writeSceneUsing: aWriter

	"Write the scene defined by the receiver using @aWriter"

	^ mesh kindDo: aWriter! !

Scene3DBuilder subclass: #M3DSceneBuilder
	instanceVariableNames: 'appearance materials exclusionBoxes inclusionBoxes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-FormatM3D'!

!M3DSceneBuilder methodsFor: 'API-building' stamp: 'emm 02/09/2012 23:56'!
addBoxFramesWithThickness: thickness

	self color: Color red.
	self inclusionBoxes do:[ :each |
		self add:((BoxFrame origin: each origin corner: each corner) thickness: thickness)].

	self color: Color yellow.
	self exclusionBoxes do:[ :each |
		self add:((BoxFrame origin: each origin corner: each corner) thickness:thickness)].! !

!M3DSceneBuilder methodsFor: 'API-building' stamp: 'emm 02/09/2012 23:56'!
addExclusionBox: aSixFacedSolid

	| mesh |
	mesh := aSixFacedSolid kindDo: self.
	mesh prefixNameWith: 'obb_'.
	"exclusion boxes do not need materials"
	mesh materials: nil.
	exclusionBoxes add: mesh! !

!M3DSceneBuilder methodsFor: 'API-building' stamp: 'emm 02/09/2012 23:56'!
addInclusionBox: aSixFacedSolid

	inclusionBoxes add: aSixFacedSolid! !

!M3DSceneBuilder methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:56'!
appearance

	^appearance! !

!M3DSceneBuilder methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:56'!
appearance: aValue

	"Set the value of appearance"

	appearance := aValue! !

!M3DSceneBuilder methodsFor: 'building-appearance ( ISceneBuilder )' stamp: 'emm 02/09/2012 23:56'!
color: aColor 
	
	"Apply the appearance using @aColor"
	
	self texture: nil color: aColor.! !

!M3DSceneBuilder methodsFor: 'writing ( ISceneBuilder )' stamp: 'emm 02/09/2012 23:56'!
defaultWriterClass

	^M3DWriter! !

!M3DSceneBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:56'!
doCamera: aCamera

	^aCamera! !

!M3DSceneBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:56'!
doExternalGeometric3D: anEG

	self include: anEG resourceName , M3DWriter fileExtension.
	^nil! !

!M3DSceneBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:56'!
doFaceComposite: aComposite

	| mesh data |
	mesh := M3DMesh new.
	mesh position: Point3D zero.
	mesh angle: Point3D zero.
	data := MeshData new initializeFromFaces: (aComposite faces collect:[ :each | each scaledBy: self scale]).
	mesh materials: (Array new: data verticesPerFace size withAll: self appearance).
	mesh polygons: data verticesPerFace.
	mesh vertices: data vertices.
	^mesh! !

!M3DSceneBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:56'!
doM3DMaterial: aMaterial

	^ aMaterial! !

!M3DSceneBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:56'!
doM3DShell: aShell

	^aShell! !

!M3DSceneBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:56'!
doPolygon3D: aPolygon

	^self doFaceComposite: (FaceComposite on: (Array with: aPolygon)).
! !

!M3DSceneBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:56'!
doReversing3DWrapper: aWrapper

	^(aWrapper component kindDo: self) reverseOriented! !

!M3DSceneBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:56'!
doTextureWrapper: aWrapper
	"Pre: rectangles only for now"

	| mesh data composite faces|
	composite := CompositeGeometric3D new.
	(aWrapper component kindDo: self approximator) facesDo:[ :each |
		mesh := M3DMesh new.
		mesh position: Point3D zero.
		mesh angle: Point3D zero.
		faces := OrderedCollection new.
		aWrapper scale = (1@1)
			ifTrue: 
				[ faces add: (each scaledBy: self scale asPoint3D) ]
			ifFalse: 
				[ (each subdividedBy: aWrapper scale) do:[ :face |
					faces add: (face scaledBy: self scale asPoint3D) ]].
		data := MeshData new initializeFromFaces: faces.
		mesh materials: (Array new: data verticesPerFace size withAll: (self materialForTexture: aWrapper texture color: aWrapper color)).
		mesh polygons: data verticesPerFace.
		mesh vertices: data vertices.
		composite add: mesh ].
	^composite size = 1
		ifTrue: [ composite at: 1 ]
		ifFalse: [ composite ]! !

!M3DSceneBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:56'!
doTranslating3DWrapper: aWrapper

	^(aWrapper component kindDo: self) translateBy: aWrapper translation * scale! !

!M3DSceneBuilder methodsFor: 'private' stamp: 'emm 02/09/2012 23:56'!
exclusionBoxes

	"Answer the value of exclusionBoxes"

	^exclusionBoxes! !

!M3DSceneBuilder methodsFor: 'private' stamp: 'emm 02/09/2012 23:56'!
exclusionBoxes: aValue

	"Set the value of exclusionBoxes"

	exclusionBoxes := aValue! !

!M3DSceneBuilder methodsFor: 'API-building' stamp: 'emm 02/09/2012 23:56'!
include: anM3DFileName

	self addElement: (SceneElementWithSource new
		source: 'include ' , anM3DFileName)! !

!M3DSceneBuilder methodsFor: 'private' stamp: 'emm 02/09/2012 23:56'!
inclusionBoxes

	"Answer the value of inclusionBoxes"

	^inclusionBoxes! !

!M3DSceneBuilder methodsFor: 'private' stamp: 'emm 02/09/2012 23:56'!
inclusionBoxes: aValue

	"Set the value of inclusionBoxes"

	inclusionBoxes := aValue! !

!M3DSceneBuilder methodsFor: 'initialize-release' stamp: 'emm 02/09/2012 23:56'!
initialize

	super initialize.
	materials := OrderedCollection new.
	scale := 50.
	self approximator segmentCount: 12.
	exclusionBoxes := OrderedCollection new.
	inclusionBoxes := OrderedCollection new.! !

!M3DSceneBuilder methodsFor: 'testing' stamp: 'emm 02/09/2012 23:56'!
isM3D
	^true! !

!M3DSceneBuilder methodsFor: 'private' stamp: 'emm 02/09/2012 23:56'!
materialForTexture: aString color: aColor 
	
	| app index |
	app := ( self newAppearance ) texture: aString ; color: aColor.
	index := self materials indexOf: app.
	^ index = 0
		ifTrue:[ self materials add: app ]
		ifFalse:[ self materials at: index ]! !

!M3DSceneBuilder methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:56'!
materials

	"Answer the value of materials"

	^materials! !

!M3DSceneBuilder methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:56'!
materials: aValue

	"Set the value of materials"

	materials := aValue! !

!M3DSceneBuilder methodsFor: 'factory' stamp: 'emm 02/09/2012 23:56'!
newAppearance

	^M3DMaterial new! !

!M3DSceneBuilder methodsFor: 'private' stamp: 'emm 02/09/2012 23:56'!
newGroup

	^M3DShell new! !

!M3DSceneBuilder methodsFor: 'factory' stamp: 'emm 02/09/2012 23:56'!
newTransformOn: anElement

	^(M3DShell new) add: anElement ;yourself! !

!M3DSceneBuilder methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:56'!
scale

	"Answer the value of scale"

	^scale! !

!M3DSceneBuilder methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:56'!
scale: aValue

	"Set the value of scale"

	scale := aValue! !

!M3DSceneBuilder methodsFor: 'building-appearance ( ISceneBuilder )' stamp: 'emm 02/09/2012 23:56'!
texture: aString color: aColor

	"Apply a texture identified by @aString. Can be a filename or url or some id.
	In case the file cannot be found, default to the color @aColor"

	self appearance: (self materialForTexture: aString color: aColor)! !

!M3DSceneBuilder methodsFor: 'writing ( ISceneBuilder )' stamp: 'emm 02/09/2012 23:56'!
writeSceneUsing: aWriter 
	
	"Write the scene defined by the receiver using @aWriter"
	
	| bbWriter itsName maxBuilder |
	self materials 
		do: [ :each | each kindDo: aWriter ] 
		separatedBy: [ aWriter cr ].
	aWriter cr.
	self elements 
		do: [ :each | each kindDo: aWriter ] 
		separatedBy: [ aWriter cr ]. 

 	"write exclusion boxes"
	exclusionBoxes isEmpty 
		ifFalse:
			[ exclusionBoxes 
				do: [ :each | each kindDo: aWriter ] 
				separatedBy: [ aWriter cr ] ]. 

	"write inclusion boxes"
	inclusionBoxes isEmpty 
		ifFalse:
			[ itsName := aWriter fileName copyFrom: 1 to: aWriter fileName size - 4.
			maxBuilder := SceneBuilder max.
			maxBuilder scale: self scale.
			maxBuilder addAll: inclusionBoxes.
			maxBuilder writeToFile: itsName ]! !

Scene3DBuilder subclass: #MaxSceneBuilder
	instanceVariableNames: 'material materials'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-FormatMaxScript'!

!MaxSceneBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:55'!
addBoundingBox: aBoundingBox
	
	| elem |
	elem := self doBoundingBox: aBoundingBox.
	self addElement: elem.
	^aBoundingBox
	! !

!MaxSceneBuilder methodsFor: 'writing ( ISceneBuilder )' stamp: 'emm 02/09/2012 23:55'!
addSceneRedrawCalls
	elements addFirst: (SceneElementWithSource new source: 'disableSceneRedraw()').
	elements addLast: (SceneElementWithSource new source: 'enableSceneRedraw()')	! !

!MaxSceneBuilder methodsFor: 'building-appearance ( ISceneBuilder )' stamp: 'emm 02/09/2012 23:55'!
appearance
	^self material! !

!MaxSceneBuilder methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:55'!
approximatorClass
	"Redefined from SceneBuilder"

	^Triangle3DApproximator! !

!MaxSceneBuilder methodsFor: 'building-appearance ( ISceneBuilder )' stamp: 'emm 02/09/2012 23:55'!
color: aColor

	"Apply the appearance using @aColor"

	self material: (self materialForColor: aColor)! !

!MaxSceneBuilder methodsFor: 'writing ( ISceneBuilder )' stamp: 'emm 02/09/2012 23:55'!
defaultWriterClass

	^MaxScriptWriter! !

!MaxSceneBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:55'!
doBoundingBox: aBox
	"Really a SCOL-Max name convention"

	^(self doBox: aBox) prefixNameWith: 'box_'! !

!MaxSceneBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:55'!
doBox: aBox 

	| mob |
	mob := ( MaxObject new className: 'Box' ) 
		lengthsegs: 1
		; widthsegs: 1
		; heightsegs: 1
		; length: aBox width * scale
		; height: aBox height * scale
		; width: aBox length * scale
		; pos: ( aBox center xy , aBox origin z ) * scale
		; material: self material.
	self hasTexture
		ifTrue: [ mob addModifier: (self newUVWMapping maptype: 4) ].
	^mob! !

!MaxSceneBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:55'!
doCone: aCone
	"example: Cone 
		smooth:on 
		heightsegs:5 
		capsegs:1 
		sides:24 
		height:42.1866 
		radius1:49.8656 
		radius2:10.9806 
		pos:[-0.218046,1.68022,0]"

	| mob |
	mob := ( MaxObject new className: 'Cone' ) 
		smooth: #on
		;heightsegs: 24
		;capsegs: 1
		;sides: 24
		;height: aCone height * scale
		;radius1: aCone bottomRadius * scale
		;radius2: aCone topRadius * scale
		;pos: aCone origin * scale
		;material: self material.
	self hasTexture
		ifTrue: [ mob addModifier: (self newUVWMapping maptype: 4) ].
	^mob

		! !

!MaxSceneBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:55'!
doCylinder: aCylinder

	| mob |
	mob := (MaxObject new className: 'Cylinder')
			smooth: #on
			;heightsegs: 1
			;capsegs: 1
			;sides: self approximator segmentCount
			;height: aCylinder height * scale
			;radius: aCylinder radius * scale
			;pos: aCylinder center * scale
			; material: self material.
	self hasTexture
		ifTrue: [ mob addModifier: (self newUVWMapping maptype: 0) ].
	^mob! !

!MaxSceneBuilder methodsFor: 'dispatching-wrappers' stamp: 'emm 02/09/2012 23:55'!
doGeometric3DWrapper: aWrapper
	^(aWrapper component kindDo: self) addModifier: aWrapper ;yourself
! !

!MaxSceneBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:55'!
doMaxMaterial: aMaterial
	^aMaterial! !

!MaxSceneBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:55'!
doMesh: aMesh
	
	"Beware: change orientation of triangles"

	^(MaxObject new className: 'mesh')
		vertices: (aMesh vertices collect:[ :each | each * scale ])
		;faces: (aMesh indexedFaces collect:[ :array | Point3D x: array first y: array last z: (array at: 2)])
		;material: self material! !

!MaxSceneBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:55'!
doPolygon3D: aPolygon3D 

	^(aPolygon3D kindDo: self approximator ) kindDo: self! !

!MaxSceneBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:55'!
doRectangle3D: aRect
	
	| poly  mesh elm|
	poly := aRect asPolygon3D.	
	mesh := Mesh new.
	mesh vertices: poly vertices.
	mesh indexedFaces: #( #(1 2 3) #(3 4 1) ).
	elm := self doMesh: mesh.
	self hasTexture
		ifTrue: [ elm addModifier: (self newUVWMapping maptype: 4) ].
	^elm! !

!MaxSceneBuilder methodsFor: 'dispatching-wrappers' stamp: 'emm 02/09/2012 23:55'!
doRotating3DWrapper: aWrapper
	^self doGeometric3DWrapper: aWrapper! !

!MaxSceneBuilder methodsFor: 'dispatching-wrappers' stamp: 'emm 02/09/2012 23:55'!
doScaling3DWrapper: aWrapper

	aWrapper scale: aWrapper scale.
	^(aWrapper component kindDo: self) addModifier: aWrapper ;yourself! !

!MaxSceneBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:55'!
doSphere: aSphere
	"example: Sphere 
		radius:0 
		smooth:on 
		segs:32 
		chop:0 
		slice:off 
		sliceFrom:0 
		sliceTo:0"

	| mob |
	mob := (MaxObject new className: 'Sphere')
			radius: aSphere radius * self scale
			;smooth: #on
			;segs: 32
			;chop: 0
			;slice: false
			;sliceFrom: 0
			;sliceTo: 0
			;pos: aSphere center * self scale
		  	;material: self material.
	self hasTexture
		ifTrue: [ mob addModifier: (self newUVWMapping maptype:2) ].
	^mob! !

!MaxSceneBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:55'!
doText3D: aText
"
text name: ""mytext""
addModifier $mytext (Extrude())
$mytext.modifiers[#Extrude].amount = 4
rotate $mytext (angleaxis 90 [1,0,0])
"
	| mob  extrude|
	mob := MaxObject new className: 'text'.
	mob size: aText size.
	mob text: aText string.
	extrude := self newExtrude.
	extrude amount: aText thickness.
	mob addModifier: extrude.
	self hasTexture
		ifTrue: [ mob addModifier: (self newUVWMapping maptype: 4) ].	
	^mob! !

!MaxSceneBuilder methodsFor: 'dispatching-wrappers' stamp: 'emm 02/09/2012 23:55'!
doTextureWrapper: aWrapper

	| maxObject |
	self texture: aWrapper texture.
	maxObject := aWrapper component kindDo: self.
	aWrapper uvw = Point3D unity
		ifTrue: [^maxObject].
	(maxObject modifierAt: 'Uvwmap' ifNone:[^maxObject])
		utile: aWrapper uv x
		;vtile: aWrapper uv y.
	^maxObject! !

!MaxSceneBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:55'!
doTorus: aTorus
	"example: Torus 
		smooth:2 
		segs:24 
		sides:12 
		radius1:81.1363 
		radius2:14.4776 
		pos:[-41.9633,-25.6397,0]"

	| mob |
	mob := (MaxObject new className: 'Torus')
		smooth: 2
		;segs: 24
		;sides: 12
		;radius1: aTorus majorRadius * scale
		;radius2: aTorus minorRadius * scale
		;pos: aTorus center * scale.
	self hasTexture
		ifTrue: [ mob addModifier: (self newUVWMapping maptype: 4) ].
	^mob
		! !

!MaxSceneBuilder methodsFor: 'dispatching-wrappers' stamp: 'emm 02/09/2012 23:55'!
doTranslating3DWrapper: aWrapper

	aWrapper translation: aWrapper translation * scale.
	^self doGeometric3DWrapper: aWrapper! !

!MaxSceneBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:55'!
doTriangle3DCollection: aTriangleCollection
	
	"should make more efficient"

	| m  indexed index elm|
	m := Mesh new.
	m vertices: aTriangleCollection vertices asArray.
	indexed := Array new: aTriangleCollection size.
	index := 1.
	aTriangleCollection do:[ :each |
		indexed at: index put: (
			Array 
				with: (m vertices indexOf: each point1)
				with: (m vertices indexOf: each point2)
				with: (m vertices indexOf: each point3)).
		index := index + 1].
	m indexedFaces: indexed.
	elm := self doMesh: m.
	self hasTexture
		ifTrue: [ elm addModifier: (self newUVWMapping maptype: 4) ].
	^elm! !

!MaxSceneBuilder methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:55'!
hasTexture
	^self material notNil and:[self material bitmapFilename notNil]! !

!MaxSceneBuilder methodsFor: 'initialize-release' stamp: 'emm 02/09/2012 23:55'!
initialize

	super initialize.
	materials := OrderedCollection new.! !

!MaxSceneBuilder methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:55'!
material
	^material! !

!MaxSceneBuilder methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:55'!
material: anObject
	material := anObject! !

!MaxSceneBuilder methodsFor: 'building-appearance' stamp: 'emm 02/09/2012 23:55'!
materialForColor: aColor

	| mat |
	materials do:[ :each | (each bitmapFilename isNil and:[each diffuseColor = aColor]) ifTrue:[^each ]].
	materials add:(mat := MaxMaterial new index: materials size + 1).
	mat diffuseColor: aColor.
	^mat! !

!MaxSceneBuilder methodsFor: 'building-appearance' stamp: 'emm 02/09/2012 23:55'!
materialForTexture: fileName

	| mat |
	materials do:[ :each | each bitmapFilename = fileName ifTrue:[^each ]].
	materials add:(mat := MaxMaterial new index: materials size + 1).
	mat bitmapFilename: fileName.
	^mat! !

!MaxSceneBuilder methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:55'!
materials
	^materials! !

!MaxSceneBuilder methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:55'!
materials: anObject
	materials := anObject! !

!MaxSceneBuilder methodsFor: 'private' stamp: 'emm 02/09/2012 23:55'!
newExtrude
	^MaxModifier new className: 'Extrude'! !

!MaxSceneBuilder methodsFor: 'private' stamp: 'emm 02/09/2012 23:55'!
newMaterial
	^MaxMaterial new! !

!MaxSceneBuilder methodsFor: 'private' stamp: 'emm 02/09/2012 23:55'!
newUVWMapping
	^(MaxModifier new className: 'Uvwmap') keySymbol: #UVW_Mapping! !

!MaxSceneBuilder methodsFor: 'building-appearance ( ISceneBuilder )' stamp: 'emm 02/09/2012 23:55'!
texture: aString
	self material: (self materialForTexture: aString)! !

!MaxSceneBuilder methodsFor: 'writing ( ISceneBuilder )' stamp: 'emm 02/09/2012 23:55'!
writeSceneUsing: aWriter

	"Write the scene defined by the receiver using @aWriter"

	self addSceneRedrawCalls.
	self materials do:[ :each | aWriter cr. each kindDo: aWriter ].
	self elements do: [ :each | aWriter cr. each kindDo:aWriter ].! !

Scene3DBuilder subclass: #POVRaySceneBuilder
	instanceVariableNames: 'inclusions declarations texture changeCoordinateSystem animationEngine fontStyle cameras interior'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-FormatPOVRay'!

!POVRaySceneBuilder class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:55'!
new

	^super new initialize! !

!POVRaySceneBuilder methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:55'!
animationEngine

	"Answer the value of animationEngine"

	^animationEngine isNil
		ifTrue: [ animationEngine := self animationEngineClass new ]
		ifFalse: [ animationEngine ]! !

!POVRaySceneBuilder methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:55'!
animationEngine: aValue

	"Set the value of animationEngine"

	animationEngine := aValue! !

!POVRaySceneBuilder methodsFor: 'resources' stamp: 'emm 02/09/2012 23:55'!
animationEngineClass

	^AnimationEngine! !

!POVRaySceneBuilder methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:55'!
cameras
	^cameras! !

!POVRaySceneBuilder methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:55'!
changeCoordinateSystem

	^changeCoordinateSystem! !

!POVRaySceneBuilder methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:55'!
changeCoordinateSystem: aBool 

	changeCoordinateSystem := aBool! !

!POVRaySceneBuilder methodsFor: 'building-appearance' stamp: 'emm 02/09/2012 23:55'!
color: aColor

	| declarationName declaredElement |
	declarationName := 'Color' , aColor name.
	declaredElement := self declarations 
		at: declarationName 
		ifAbsentPutUsing:
			[ (self newTexture)
				add:(self newPigment color:aColor)
				;name: declarationName ].
	self texture: declaredElement! !

!POVRaySceneBuilder methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:55'!
declarations

	^declarations! !

!POVRaySceneBuilder methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:55'!
declarations: aValue

	declarations := aValue! !

!POVRaySceneBuilder methodsFor: 'building' stamp: 'emm 02/09/2012 23:55'!
declare: anObject 

	| prefix count |
	prefix := anObject class name.
	prefix := prefix first isVowel
				ifTrue: ['an' , prefix]
				ifFalse: ['a' , prefix].
	count := 1.
	[declarations includesKey: prefix , count printString]
		whileTrue: [count := count + 1].
	self declare: prefix , count printString is: anObject! !

!POVRaySceneBuilder methodsFor: 'building' stamp: 'emm 02/09/2012 23:55'!
declare: aString is: anObject 

	declarations at: aString put: anObject! !

!POVRaySceneBuilder methodsFor: 'writing ( ISceneBuilder )' stamp: 'emm 02/09/2012 23:55'!
defaultWriterClass

	^POVWriter! !

!POVRaySceneBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:55'!
doBox: aBox
	^(self newElementWithClassName: 'box')
		addConstructorParameter: aBox origin
		; addConstructorParameter: aBox corner
		; texture: self texture! !

!POVRaySceneBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:55'!
doCSGDifference: aCSGD
	
	| diff |
	diff := self newElementWithClassName: 'difference'.
	diff addAll: (aCSGD components collect:[ :each | each kindDo: self ]).
	^diff! !

!POVRaySceneBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:55'!
doCSGIntersection: aCSGI
	^self newElementWithClassName: 'intersection'! !

!POVRaySceneBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:55'!
doCSGUnion: aCSGUnion
	
	| union |
	union := self newElementWithClassName: 'union'.
	union addAll: (aCSGUnion components collect:[ :each | each kindDo: self ]).
	^union! !

!POVRaySceneBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:55'!
doCamera: aCamera

	cameras add: ((self newElementWithClassName: 'camera')
			name: aCamera label
			;at: 'up' put: 'z'
			;at: 'right' put: '-4/3*y'
			;at: 'location ' put: aCamera origin
			;at: 'focal_point ' put: aCamera focusPoint
			;at: 'look_at ' put: aCamera focusPoint
			;yourself).
	^nil
			
	! !

!POVRaySceneBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:55'!
doColorWrapper: aWrapper

	| oldTexture  element|
	oldTexture := texture.
	self color: aWrapper color.
	element := aWrapper component kindDo: self.
	texture := oldTexture.
	^element
	! !

!POVRaySceneBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:55'!
doCone: aCone 
	
	^(self newElementWithClassName: 'cone')
		addConstructorParameter: aCone bottomCenter
		; addConstructorParameter: aCone bottomRadius
		; addConstructorParameter: aCone topCenter
		; addConstructorParameter: aCone topRadius	
		; texture: self texture! !

!POVRaySceneBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:55'!
doCylinder: aCylinder
	^(self newElementWithClassName: 'cylinder')
		addConstructorParameter: aCylinder bottomCenter
		;addConstructorParameter: aCylinder topCenter		
		; addConstructorParameter: aCylinder radius
		; texture: self texture		! !

!POVRaySceneBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:55'!
doFaceComposite: aFaceComposite 

	| mesh |
	mesh := self newElementWithClassName: 'mesh'.
	self withoutTextureDo:[
		aFaceComposite facesDo: [ :eachFace | 
			eachFace trianglesDo: [ :eachTriangle | 
				mesh add: ( eachTriangle kindDo: self ) ] ] ].
	mesh texture: self texture.
	^mesh! !

!POVRaySceneBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:55'!
doGeometric3DWrapper: aWrapper

	| element |
	element := aWrapper component kindDo: self.
	element addModifier: aWrapper.
	^element! !

!POVRaySceneBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:55'!
doMeshData: aMeshData
	| mesh  vectors indices|
	mesh := self newElementWithClassName: 'mesh2'.
	vectors := self newElementWithClassName: 'vertex_vectors'.
	vectors addConstructorParameter: aMeshData vertices size.
	aMeshData vertices do:[ :each | vectors addConstructorParameter: each ].
	indices := self newElementWithClassName: 'face_indices'.
	indices addConstructorParameter: aMeshData vertices size.
	aMeshData verticesPerFace do:[ :indicesPerFace | 
		indicesPerFace do:[ :each | indices addConstructorParameter: each ]].
	mesh add: vectors.
	mesh add: indices.
	^mesh! !

!POVRaySceneBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:55'!
doPOVElement: anElement
	^anElement! !

!POVRaySceneBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:55'!
doPlane3D: aPlane3D
	^(self newElementWithClassName: 'plane') texture: self texture.! !

!POVRaySceneBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:55'!
doPointLight: aPLight
	^(self newElementWithClassName: 'light_source')
		addConstructorParameter: aPLight origin
		;color: aPLight color! !

!POVRaySceneBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:55'!
doPolygon3D: aPolygon3D

	| union element|
	union := CSGUnion new.
	aPolygon3D trianglesDo: [:each | 
		union add: (each kindDo: self) ].
	element := union kindDo: self.
	element texture: self texture.
	^element! !

!POVRaySceneBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:55'!
doRotating3DWrapper: aWrapper
	^self doGeometric3DWrapper: aWrapper! !

!POVRaySceneBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:55'!
doScaling3DWrapper: aWrapper
	^self doGeometric3DWrapper: aWrapper! !

!POVRaySceneBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:55'!
doSolidComposite: aComposite 

	| union |
	union := CSGUnion new.
	aComposite solidsDo: [ :each | union add: ( each kindDo: self ) ].
	union kindDo: self.
	^union! !

!POVRaySceneBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:55'!
doSphere: aSphere
	^(self newElementWithClassName: 'sphere')
		addConstructorParameter: aSphere center
		; addConstructorParameter: aSphere radius
		; texture: self texture	
		; interior: self interior	! !

!POVRaySceneBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:55'!
doSpotLight: aPLight
	^(self newElementWithClassName: 'light_source')
		addConstructorParameter: aPLight origin
		;color: aPLight color! !

!POVRaySceneBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:55'!
doText3D: aText3D
	^nil! !

!POVRaySceneBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:55'!
doTextureWrapper: aWrapper
	^self doGeometric3DWrapper: aWrapper! !

!POVRaySceneBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:55'!
doTorus: aTorus 

	| element |
	element := (self newElementWithClassName: 'torus')
		addConstructorParameter: aTorus majorRadius
		; addConstructorParameter: aTorus minorRadius.
	aTorus center isZero
		ifFalse: 
			[ element addModifier: (Translating3DWrapper new translation: aTorus center) ].
	element texture: self texture.
	^element
		! !

!POVRaySceneBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:55'!
doTorusArc: aTorusArc

	| angleInterval quadrantIndices cutterWidth cutterHeight cutter cutters torus union diff1 cutters1 diff2 cutters2 diff3 cutters3 |
	aTorusArc center isZero
		ifFalse: 
			[ | oldCenter |
			oldCenter := aTorusArc center.
			aTorusArc center: Point3D zero.
			self write: ( aTorusArc wrapTranslateBy: oldCenter ).
			^aTorusArc center: oldCenter ].

	angleInterval := aTorusArc startAngle deg to: aTorusArc stopAngle deg.
	quadrantIndices := angleInterval quadrantIndices.

	cutterWidth := aTorusArc outerRadius + aTorusArc minorRadius.
	cutterHeight := aTorusArc minorRadius * 4. "to be safe"
	cutter := ( Box 
		origin:  0,0, cutterHeight / -2
		corner:  cutterWidth , cutterWidth , cutterHeight ) expandedBy: 0.01.
	
	cutters := Array 
		with: cutter												 "xy = quadrant 1"
		with: ( cutter rotatedBy: 0,0,HalfPi )   "-xy = quadrant 2"
		with: ( cutter rotatedBy: 0,0,Pi ) "-x-y = quadrant 3"
		with: ( cutter rotatedBy: 0,0,(HalfPi negated )). "x-y = quadrant 4"

	torus :=  Torus 
		center: aTorusArc center 
		majorRadius: aTorusArc majorRadius
		minorRadius: aTorusArc minorRadius.

	union := CSGUnion new.
	union add: aTorusArc startSphere.
	union add: aTorusArc stopSphere.

	diff1 := CSGDifference new.
	diff1 add: torus.
	cutters1 := cutters copy.
 	1 to: 4 do:[ :index |	
		( quadrantIndices includes: index ) 
			ifTrue: [ cutters1 at: index put: nil ] ]. "means do not cut quadrant @index"
	cutters1 do:[ :each |
		each isNil ifFalse: [ diff1 add: each ]].
	union add: diff1.

	diff2 := CSGDifference new.
	diff2 add: torus.
	cutters2 := cutters copy.
	cutters2 at: angleInterval first quadrantIndex put: nil.
	cutters2 do:[ :each |
		each isNil ifFalse: [ diff2 add: each ]].
 	diff2 add: ( cutter rotatedBy: 0,0, (aTorusArc startAngle - HalfPi)).
	union add: diff2.

	angleInterval last quadrantIndex ~= angleInterval first quadrantIndex
		ifTrue: 
			[ diff3 := CSGDifference new.
			diff3 add: torus.
			cutters3 := cutters copy.
			cutters3 at: angleInterval last quadrantIndex put: nil.
			cutters3 do:[ :each |
				each isNil ifFalse: [ diff3 add: each ]].
		 	diff3 add: ( cutter rotatedBy: 0,0, (aTorusArc stopAngle - TwoPi)).
			union add: diff3]
		ifFalse: 
			[ diff2 add: ( cutter rotatedBy: 0,0, (aTorusArc stopAngle - TwoPi)) ].

	^self doCSGUnion: union
	! !

!POVRaySceneBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:55'!
doTransformingElementWrapper: aWrapper

	^(self newElementWithClassName: 'transform')
! !

!POVRaySceneBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:55'!
doTranslating3DWrapper: aWrapper
	^self doGeometric3DWrapper: aWrapper! !

!POVRaySceneBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:55'!
doTriangle3D: aTriangle 

	^(self newElementWithClassName: 'triangle')
		addConstructorParameter: aTriangle point1
		; addConstructorParameter: aTriangle point2
		; addConstructorParameter: aTriangle point3		
		; texture: self texture! !

!POVRaySceneBuilder methodsFor: 'overriding' stamp: 'emm 02/09/2012 23:55'!
elementClasss
	^POVElement! !

!POVRaySceneBuilder methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:55'!
fontStyle

	"Answer the value of fontStyle"

	^fontStyle! !

!POVRaySceneBuilder methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:55'!
fontStyle: aValue

	"Set the value of fontStyle"

	fontStyle := aValue! !

!POVRaySceneBuilder methodsFor: 'building' stamp: 'emm 02/09/2012 23:55'!
include: includeFileName 

	(inclusions includes: includeFileName)
		ifFalse: [inclusions add: includeFileName]! !

!POVRaySceneBuilder methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:55'!
inclusions

	^inclusions! !

!POVRaySceneBuilder methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:55'!
inclusions: aValue

	inclusions := aValue! !

!POVRaySceneBuilder methodsFor: 'initialize-release' stamp: 'emm 02/09/2012 23:55'!
initialize

	super initialize.
	declarations := Dictionary new.
	inclusions := OrderedCollection new.
	changeCoordinateSystem := true.
	fontStyle := self newFontStyle.
	cameras := OrderedCollection new.! !

!POVRaySceneBuilder methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:55'!
interior
	^interior! !

!POVRaySceneBuilder methodsFor: 'building-appearance' stamp: 'emm 02/09/2012 23:55'!
interior: interiorID
	interior := interiorID! !

!POVRaySceneBuilder methodsFor: 'building-appearance' stamp: 'emm 02/09/2012 23:55'!
interior: interiorID from: includeFileName 

	interior := interiorID.
	self include: includeFileName	! !

!POVRaySceneBuilder methodsFor: 'testing' stamp: 'emm 02/09/2012 23:55'!
isPOVRay

	^true! !

!POVRaySceneBuilder methodsFor: 'factory' stamp: 'emm 02/09/2012 23:55'!
newFontStyle

	^POVElement new className: 'FontStyle'! !

!POVRaySceneBuilder methodsFor: 'factory' stamp: 'emm 02/09/2012 23:55'!
newImageMap
	^POVElement new className: 'image_map'! !

!POVRaySceneBuilder methodsFor: 'factory' stamp: 'emm 02/09/2012 23:55'!
newLightArray
"
// An area light (creates soft shadows)
// WARNING: This special light can significantly slow down rendering times!!
light_source
{
  0*x // light's position (translated below)
  color rgb 1.0  // light's color
  // <widthVector> <heightVector> nLightsWide mLightsHigh
  area_light
  <8, 0, 0> <0, 0, 8> // lights spread out across this distance (x * z)
  4, 4                // total number of lights in grid (4x*4z = 16 lights)
  adaptive 0          // 0,1,2,3... 
  jitter              // adds random softening of light
  translate <40, 80, -40>   // <x y z> position of light
}
"	
	^POVElement new className: 'light_source'! !

!POVRaySceneBuilder methodsFor: 'factory' stamp: 'emm 02/09/2012 23:55'!
newMaterialMap
	^POVElement new className: 'material_map'! !

!POVRaySceneBuilder methodsFor: 'factory' stamp: 'emm 02/09/2012 23:55'!
newPigment
	^POVElement new className: 'pigment'! !

!POVRaySceneBuilder methodsFor: 'factory' stamp: 'emm 02/09/2012 23:55'!
newTexture
	^POVElement new className: 'texture'! !

!POVRaySceneBuilder methodsFor: 'building-appearance' stamp: 'emm 02/09/2012 23:55'!
texture

	^texture! !

!POVRaySceneBuilder methodsFor: 'building-appearance' stamp: 'emm 02/09/2012 23:55'!
texture: aValue 
	
	| immap |
	( aValue isString
		and: [ aValue includes: $. ] )
		ifTrue:
			[ | prefix  extension declaredElement declarationName postfix |
			prefix := aValue hash printString.
			declarationName := 'Texture' , prefix.
			declaredElement := self declarations 
				at: declarationName 
				ifAbsentPutUsing:	
					[ declaredElement := self newTexture.
					declaredElement name: declarationName.
					declaredElement add: (self newPigment add:( immap := self newImageMap ) ;yourself).
					postfix := aValue copyFrom: ( aValue indexOf: $. ) + 1 to: aValue size.
					immap at: postfix put: '"' , aValue ,'"'.
					declaredElement ].
			texture := declaredElement ]
		ifFalse:
			[ texture := aValue ]! !

!POVRaySceneBuilder methodsFor: 'building-appearance' stamp: 'emm 02/09/2012 23:55'!
texture: aValue from: includeFileName 

	self texture: aValue.
	self include: includeFileName! !

!POVRaySceneBuilder methodsFor: 'building-appearance' stamp: 'emm 02/09/2012 23:55'!
withoutTextureDo: zeroBlock
	"Evaluate @zeroBlock while disabling texture apply"
	
	| old |
	old := texture.
	texture := nil.
	zeroBlock value.
	texture := old.! !

!POVRaySceneBuilder methodsFor: 'writing - private' stamp: 'emm 02/09/2012 23:55'!
writeDeclarationsWith: aWriter 

	aWriter isDeclarationWriting: true.
	self declarations keysAndValuesDo: [:key :value | 
		aWriter
			 write: '#declare '
			; write: key
			; write: ' = '.
		aWriter indentWhile: [aWriter write: value].
		aWriter cr].
	aWriter isDeclarationWriting: false! !

!POVRaySceneBuilder methodsFor: 'writing - private' stamp: 'emm 02/09/2012 23:55'!
writeInclusions: aCollection with: aWriter 

	aCollection do: [:includeFile | aWriter
			 write: '#include "'
			; write: includeFile
			; write: '"'
			; cr]! !

!POVRaySceneBuilder methodsFor: 'writing ( ISceneBuilder )' stamp: 'emm 02/09/2012 23:55'!
writeSceneUsing: aWriter

	"Write the scene defined by the receiver using @aWriter"

	| mainPrefix mainWriter incPath variables |
	"Write the include file"
	aWriter changeCoordinateSystem: self changeCoordinateSystem.
	self writeInclusions: self inclusions with: aWriter.
	self writeDeclarationsWith: aWriter.
	self elements do: [:each | 
		aWriter cr.
		each kindDo: aWriter ].

	"Write main files for each camera used"
	incPath := aWriter fileName.
	mainPrefix := incPath
		copyFrom: 1
		to: incPath size - aWriter class fileExtension size.
	self cameras do:[ :each |
		mainWriter := aWriter class on: ( mainPrefix , '_' , each name , '.pov' ) asFilename writeStream.
		mainWriter changeCoordinateSystem: self changeCoordinateSystem.
		mainWriter isDeclarationWriting: true.
		self writeInclusions: (Array with: (incPath copyFrom: (incPath lastIndexOf: $\) + 1 	to: (incPath size)))  with: mainWriter. 
		mainWriter write: each.
		mainWriter close  ]! !

!Scene3DBuilder methodsFor: 'API-building' stamp: 'emm 02/09/2012 23:27'!
addAxis
	"For testing purposes only"

	self addAxis: 2.5,0.5,0.5! !

!Scene3DBuilder methodsFor: 'API-building' stamp: 'emm 02/09/2012 23:27'!
addAxis: extent
	"For testing purposes only"

	self color: Color blue ;add: (Box origin: 0,0,0 corner: extent y,extent z,extent x).
	self color: Color green ;add: (Box origin: 0,0,0 corner: extent y,extent x,extent z).
	self color: Color red ;add: (Box origin: 0,0,0 corner: extent).! !

!Scene3DBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:27'!
addGeometric3DWrapper: aWrapper

	^self addElement: ( aWrapper kindDo: self )! !

!Scene3DBuilder methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:27'!
approximatorClass

	^FaceApproximator! !

!Scene3DBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:27'!
doBoundingBox: aBox

	"On default do nothing"

	^nil! !

!Scene3DBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:27'!
doBox: aBox

	"Handle the request send from @aBox"

	^ self doFaceComposite: aBox! !

!Scene3DBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:27'!
doCircle3D: aCircle3D
	
	"Approximate @aCircle3D by one polygon"

	^self approximate: aCircle3D! !

!Scene3DBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:27'!
doColoredPolygon3D: aColoredPolygon3D

	self color: aColoredPolygon3D color.
	^self doPolygon3D: aColoredPolygon3D! !

!Scene3DBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:27'!
doCone: aCone

	"Handle the request from @aCone"

	^self approximate: aCone! !

!Scene3DBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:27'!
doCylinder: aCylinder
	
	"Approximate @aCylinder by faces"

	^self approximate: aCylinder! !

!Scene3DBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:27'!
doGeometric3D: aGeometric

	"On default, handle @aGeometric as an empty solid"

	^aGeometric bounds kindDo: self! !

!Scene3DBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:27'!
doPlane3D: aPlane3D! !

!Scene3DBuilder methodsFor: 'dispatching' stamp: 'emm 10/7/2012 21:45'!
doPolygon3D: aPolygon3D
	aPolygon3D trianglesDo: [:each | each kindDo: self] ! !

!Scene3DBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:27'!
doPrism: aPrism

	"On default, handle as a geometric"

	^self doGeometric3D: aPrism! !

!Scene3DBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:27'!
doRectangle3D: aRect3D
	^self doPolygon3D: aRect3D asPolygon3D! !

!Scene3DBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:27'!
doReversing3DWrapper: aWrapper
	"On default, ignore the reversing operation"

	^aWrapper component kindDo: self! !

!Scene3DBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:27'!
doRotating3DWrapper: aWrapper

	^(aWrapper component kindDo: self) rotateBy: aWrapper rotation! !

!Scene3DBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:27'!
doScaling3DWrapper: aWrapper

	^(aWrapper component kindDo: self) scaleBy: aWrapper scale! !

!Scene3DBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:27'!
doSimpleExtrudedPolygon: aSEP

	^self doFaceComposite: aSEP! !

!Scene3DBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:27'!
doSolidComposite: aComposite

	| group |
	group := CompositeGeometric3D new.
	aComposite solidsDo:[ :each | group add: (each kindDo: self) ].
	^group! !

!Scene3DBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:27'!
doSphere: aSphere 
	
	"Approximate @aSphere by faces"

	^self approximate: aSphere! !

!Scene3DBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:27'!
doText3D: aText3D

	"On default, handle as a geometric"

	^ self doGeometric3D: aText3D! !

!Scene3DBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:27'!
doTorus: aTorus 
	
	"Approximate @aTorus by faces"

	^self approximate: aTorus! !

!Scene3DBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:27'!
doTranslating3DWrapper: aWrapper

	^(aWrapper component kindDo: self) translateBy: aWrapper translation! !

!Scene3DBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:27'!
doTriangle3D: aTriangle

	"On default, handle @aTriangle as a polygon"

	^ self doPolygon3D: aTriangle! !

!Scene3DBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:27'!
doTriangle3DCollection: aCollection 

	^self doFaceComposite: aCollection! !

!Scene3DBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:27'!
doTube: aTube

	^self approximate: aTube! !

!Scene3DBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:27'!
doTubeSegment: aTubeSegment

	^self approximate: aTubeSegment! !

!Scene3DBuilder methodsFor: 'API-factory' stamp: 'emm 02/09/2012 23:27'!
newGroup

	^Group3D new! !

!Scene3DBuilder methodsFor: 'VRML' stamp: 'emm 02/09/2012 23:27'!
newTouchSensor

	^NoElement new! !

Scene3DBuilder subclass: #ThreeJSSceneBuilder
	instanceVariableNames: 'color'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-FormatThreeJS'!

!ThreeJSSceneBuilder methodsFor: 'as yet unclassified' stamp: 'emm 10/7/2012 21:59'!
color: aColor! !

!ThreeJSSceneBuilder methodsFor: 'as yet unclassified' stamp: 'emm 10/7/2012 22:56'!
defaultWriterClass
	^ThreeJSWriter! !

!ThreeJSSceneBuilder methodsFor: 'as yet unclassified' stamp: 'emm 10/7/2012 22:08'!
doPolygon3D: aPolygon3D
	aPolygon3D size = 3
		ifTrue:[^self doTriangle: aPolygon3D ].
	aPolygon3D trianglesDo: [ :each | self doTriangle: each].
	^nil! !

!ThreeJSSceneBuilder methodsFor: 'as yet unclassified' stamp: 'emm 10/7/2012 22:08'!
doRectangle3D: aRectangle3D
	aRectangle3D trianglesDo: [ :each | self doTriangle: each].
	^nil! !

!ThreeJSSceneBuilder methodsFor: 'as yet unclassified' stamp: 'emm 10/7/2012 22:06'!
doTriangle: aPolygon3D
	| e normal |
	normal := aPolygon3D normal.
	^ThreeJSElement new: 'THREE.Vector3' withAll: {0,1,2,normal,color,0}. ! !

!ThreeJSSceneBuilder methodsFor: 'as yet unclassified' stamp: 'emm 10/7/2012 23:00'!
writeSceneUsing: aWriter
	! !

Scene3DBuilder subclass: #VRMLSceneBuilder
	instanceVariableNames: 'appearance fontStyle routes navigationInfo currentProto'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-FormatVRML'!

!VRMLSceneBuilder methodsFor: 'API-building' stamp: 'emm 02/09/2012 23:54'!
addAxis
	"Overide from super to add nice labels"

	self beginGroup.
	self color: Color blue ;add: (Box origin: 0,0,0.5 corner: 0.5,0.5,2.5).
	self color: Color green ;add: (Box origin: 0,0.5,0 corner: 0.5,2.5,0.5).
	self color: Color red ;add: (Box origin: 0.5,0,0 corner: 2.5,0.5,0.5).
	self color: Color white.
	self add: ( self newLabel: 'X' at: 3,0,0 axis: 0,0,0).
	self add: ( self newLabel: 'Y' at: 0,3,0 axis: 0,0,0).
	self add: ( self newLabel: 'Z' at: 0,0,3 axis: 0,0,0).
	^self add: self endGroup! !

!VRMLSceneBuilder methodsFor: 'private' stamp: 'emm 02/09/2012 23:54'!
addRoute: aRoute
	
	"Do not include duplicate routes"

	| routesHolder |
	routesHolder := self currentProto isNil
		ifTrue: [ self ]
		ifFalse: [ self currentProto ].
	routesHolder routes do:[ :each |
		( each source = aRoute source
			and:[ each sourceAspect = aRoute sourceAspect
				and:[ each target = aRoute target
					and:[ each targetAspect = aRoute targetAspect ] ] ])
						ifTrue: [ ^self ]].
	routesHolder routes add: aRoute! !

!VRMLSceneBuilder methodsFor: 'API-events' stamp: 'emm 9/29/2012 17:38'!
addWhenTouching: aGeometric3DOrElement load: aString

	| newScript |
	"'needs testing' echo: '!!!!!!!!!!'.
	
	"
	self beginGroup.
	newScript := self add: ( self  newScriptForLoadingURL: aString parameterString: '').
"	self addWhenTouching: aGeometric3DOrElement send: #load to: newScript."
	^self add: self endGroup! !

!VRMLSceneBuilder methodsFor: 'API-events' stamp: 'emm 02/09/2012 23:54'!
addWhenTouchingLoad: aString

	| newScript |
	newScript := self add: ( self newScriptForLoadingURL: aString parameterString: '').
	self whenTouching: ( self add: self newTouchSensor ) send: #load to: newScript.! !

!VRMLSceneBuilder methodsFor: 'API-events' stamp: 'emm 02/09/2012 23:54'!
addWhenTouchingReplaceWorldBy: aString

	| newScript |
	newScript := self add: ( self newScriptForReplacingWorldByURL: aString ).
	self whenTouching: ( self add: self newTouchSensor ) send: #replace to: newScript.! !

!VRMLSceneBuilder methodsFor: 'API-building' stamp: 'emm 02/09/2012 23:54'!
anchor: oneArgBlock

	self beginAnchor.
	oneArgBlock value.
	^self add: self endAnchor! !

!VRMLSceneBuilder methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:54'!
appearance

	"Answer the value of appearance"

	^appearance! !

!VRMLSceneBuilder methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:54'!
appearance: aValue

	"Set the value of appearance"

	appearance := aValue! !

!VRMLSceneBuilder methodsFor: 'private' stamp: 'emm 02/09/2012 23:54'!
asJavaString: aString

	^'"' , aString , '"'! !

!VRMLSceneBuilder methodsFor: 'API-building' stamp: 'emm 02/09/2012 23:54'!
beginAnchor

	^self push: self newAnchor! !

!VRMLSceneBuilder methodsFor: 'API-building' stamp: 'emm 02/09/2012 23:54'!
beginCollision

	^self push: self newCollision! !

!VRMLSceneBuilder methodsFor: 'API-building' stamp: 'emm 02/09/2012 23:54'!
beginLOD

	^self push: self newLOD! !

!VRMLSceneBuilder methodsFor: 'building-protos' stamp: 'emm 02/09/2012 23:54'!
beginProto

	^self push: (currentProto := self newProto)! !

!VRMLSceneBuilder methodsFor: 'building-protos' stamp: 'emm 02/09/2012 23:54'!
beginProto: aName

	^self push: (currentProto := self newProto: aName )! !

!VRMLSceneBuilder methodsFor: 'API-building' stamp: 'emm 02/09/2012 23:54'!
beginSwitch

	^self push: self newSwitch.! !

!VRMLSceneBuilder methodsFor: 'API-building' stamp: 'emm 02/09/2012 23:54'!
beginTransform

	^self push: self newTransform! !

!VRMLSceneBuilder methodsFor: 'API-building' stamp: 'emm 02/09/2012 23:54'!
collision: oneArgBlock
	
	self beginCollision.
	oneArgBlock value.
	^self add: self endCollision! !

!VRMLSceneBuilder methodsFor: 'building-appearance ( ISceneBuilder )' stamp: 'emm 10/7/2012 20:25'!
color: aColor 
	
	"Apply the appearance using @aColor"
	
	| mat |
	mat := self newMaterial at: 'diffuseColor' put: aColor ; yourself.
	aColor transparency > 0 
		ifTrue: [ mat at: 'transparency' put: aColor transparency ].
	self appearance: ( self newAppearance at: 'material' put: mat ; yourself ).
	^self appearance! !

!VRMLSceneBuilder methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:54'!
currentProto

	"Answer the value of currentProto"

	^currentProto! !

!VRMLSceneBuilder methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:54'!
currentProto: aValue

	"Set the value of currentProto"

	currentProto := aValue! !

!VRMLSceneBuilder methodsFor: 'writing ( ISceneBuilder )' stamp: 'emm 02/09/2012 23:54'!
defaultWriterClass

	^WRLWriter! !

!VRMLSceneBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:54'!
doAutoRotationWrapper: aWrapper

	| transform timer interpolator |
	transform := self newTransformOn: ( self newElementFrom: aWrapper component ).
	self add: ( timer := self newTimeSensor ).
	timer loop: true.
	timer cycleInterval: 1 / aWrapper speed.
	self add: ( interpolator := self newRotationInterpolatorFrom: (0 to: 360 rad steps: 3) axis: aWrapper rotation ).
	self whenFractionChanging: timer rotate: transform using: interpolator.
	^transform! !

!VRMLSceneBuilder methodsFor: 'dispatching-primitives ( IGeometric3DVisitor )' stamp: 'emm 02/09/2012 23:54'!
doBox: aBox



	| shape |
	"check invariance"
	(aBox extent x > 0 and:[aBox extent y > 0 and:[aBox extent z > 0]])
		ifFalse: [self error: 'illegal box' ].
	
	shape := self 
		newShapeOn: (( GenericSceneElement new className: 'Box')
			at: 'size' put: aBox extent * scale
			;yourself).
	^aBox center isZero
		ifTrue: [ shape ]
		ifFalse: [ shape asVRMLTransform translation: aBox center * scale]! !

!VRMLSceneBuilder methodsFor: 'dispatching ( IGeometric3DVisitor )' stamp: 'emm 02/09/2012 23:54'!
doCallbackTo: anObject

	"Dispatch the request back to @anObject.
	The method name should include a description (kind) of  the receiver"

	^anObject doVRMLSceneBuilder: self! !

!VRMLSceneBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:54'!
doCamera: aCamera

	|viewPoint localLookPoint |
	viewPoint := self newViewpoint description: aCamera label.
	viewPoint position: 0,0,0.
	
	localLookPoint := aCamera focusPoint - aCamera origin.
	localLookPoint rotationPointsFromNegativeX do:[ :rotation |
		viewPoint := self newTransformOn: viewPoint.
		viewPoint rotation: ( self orientationFromPoint: rotation ) ].

	viewPoint := self newTransformOn: viewPoint.
	viewPoint translation: aCamera origin * scale.
	^viewPoint kindDo: self! !

!VRMLSceneBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:54'!
doCameraPath: aPath

	| camera camElement yTransform zTransform moveTransform fractions 
	yRotations zRotations origin focus viewvector rotationpoints rotation mover yRotator zRotator gogo xTransform xRotations xRotator |

	camera := (Camera at: 0,0,0 lookingAt: -10,0,0) label: aPath label.
	camElement := self newElementFrom: camera.
	xTransform := self newTransformOn: camElement.
	yTransform := self newTransformOn: xTransform.
	zTransform := self newTransformOn: yTransform.
	self add: (moveTransform := self newTransformOn: zTransform).
	fractions := 0 to: 1 steps: aPath frameCount.
	
	xRotations := OrderedCollection new.
	yRotations := OrderedCollection new.
	zRotations := OrderedCollection new.
	fractions do:[ :f |
		origin := (aPath originAtFraction: f) * scale.
		focus := (aPath focusPointAtFraction: f) * scale.
		viewvector := focus - origin.
		rotationpoints := viewvector rotationPointsFromNegativeX.
		rotationpoints size = 1
			ifTrue: 
				[ rotation := rotationpoints first.
				rotation y = 0
					ifTrue: 
						[ yRotations add: 0.
						zRotations add: rotation z ]
					ifFalse: 
						[ zRotations add: 0.
						yRotations add: rotation y ]]
			ifFalse: 
				[ yRotations add: (rotationpoints first y).		
				zRotations add: (rotationpoints last z) ]].

	self add: ( mover := self newPositionInterpolatorFrom: ( aPath originsFromFractions: fractions )).
	self add: ( xRotator := self newRotationInterpolatorFrom: ( aPath rollAnglesFromFractions: fractions ) axis: 1,0,0).
	self add: ( yRotator := self newRotationInterpolatorFrom: yRotations axis: 0,1,0).
	self add: ( zRotator := self newRotationInterpolatorFrom: zRotations axis: 0,0,1).
	self add: ( gogo := (self newTimeSensor) cycleInterval: aPath duration).
	self whenFractionChanging: gogo rotate: xTransform using: xRotator.
	self whenFractionChanging: gogo rotate: yTransform using: yRotator.
	self whenFractionChanging: gogo rotate: zTransform using: zRotator.
	self whenFractionChanging: gogo translate: moveTransform using: mover.
	self route: 'bindTime' of: (camElement leafElement ensureNamed) to: 'startTime' of: gogo.

	^nil! !

!VRMLSceneBuilder methodsFor: 'dispatching-wrappers' stamp: 'emm 02/09/2012 23:54'!
doColorWrapper: aColorWrapper

	"Handle the request from @aColorWrapper"

	| oldAppearance result |
	oldAppearance := self appearance.
	self color: aColorWrapper color.
	result := aColorWrapper component kindDo: self.
	self appearance: oldAppearance.
	^result

	! !

!VRMLSceneBuilder methodsFor: 'dispatching ( IGeometric3DVisitor )' stamp: 'emm 02/09/2012 23:54'!
doComposite: aComposite

	"Handle the request from @aComposite"

	^ self doSolidComposite: aComposite! !

!VRMLSceneBuilder methodsFor: 'dispatching-primitives ( IGeometric3DVisitor )' stamp: 'emm 02/09/2012 23:54'!
doCone: aCone
"
Cone { 
  field     SFFloat   bottomRadius 1        # (0,)
  field     SFFloat   height       2        # (0,)
  field     SFBool    side         TRUE
  field     SFBool    bottom       TRUE
}
"
	| shape |
	shape := self 
		newShapeOn: (( GenericSceneElement new className: 'Cone')
			at: 'bottomRadius' put: aCone bottomRadius * scale
			;at: 'height' put: aCone height * scale
			;yourself ).
	^ aCone center isZero
		ifTrue: [ shape ]
		ifFalse: [ shape asVRMLTransform translateBy: aCone center * scale]! !

!VRMLSceneBuilder methodsFor: 'dispatching-primitives ( IGeometric3DVisitor )' stamp: 'emm 02/09/2012 23:54'!
doCylinder: aCylinder

"Cylinder { 
  field    SFBool    bottom  TRUE
  field    SFFloat   height  2         # (0,)
  field    SFFloat   radius  1         # (0,)
  field    SFBool    side    TRUE
  field    SFBool    top     TRUE
}
"
	| shape |
	shape := self 
		newShapeOn: (( GenericSceneElement new className: 'Cylinder')
			at: #radius put: aCylinder radius * scale
			;at: #height put: aCylinder height * scale
			;yourself).
	^aCylinder center isZero
		ifTrue: [ shape ]
		ifFalse: [ shape asVRMLTransform translateBy: aCylinder center * scale]! !

!VRMLSceneBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:54'!
doExternalGeometric3D: anEG

	^self newInline: anEG resourceName! !

!VRMLSceneBuilder methodsFor: 'dispatching ( IGeometric3DVisitor )' stamp: 'emm 02/09/2012 23:54'!
doExtrusion: anExtrusion

	| cross spine |
	cross := anExtrusion contourPoints collect:[:p|p*scale].
	spine := Array with: 0,0,0 with: 0,0,1.
	^self newShapeOn: ( ( self newExtrusion )
		crossSection: cross
		;spine: spine 
		; convex: false 
		; ccw: false ).! !

!VRMLSceneBuilder methodsFor: 'dispatching ( IGeometric3DVisitor )' stamp: 'emm 02/09/2012 23:54'!
doFaceComposite: aFaceComposite

	^self newShapeOn: (self newIndexedFaceSetFrom: (aFaceComposite scaledBy: self scale))! !

!VRMLSceneBuilder methodsFor: 'dispatching-wrappers' stamp: 'emm 02/09/2012 23:54'!
doHollowing3DWrapper: aHollowingWrapper

	"Handle the request from @aHollowingWrapper"
	
	^ self doSolidComposite: aHollowingWrapper ! !

!VRMLSceneBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:54'!
doLineSegment3D: aLS

	^(Polyline3D with: aLS from with: aLS to) kindDo: self! !

!VRMLSceneBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:54'!
doPoint3DCollection: aPoint3DCollection
	"See >>newPointSet"

	^(self newPointSet)
			at: #color put: (self newColorFromAll: (OrderedPoint3DCollection withAll: (aPoint3DCollection collect:[ :e | Color green asPoint3D ] )))
			;at: #coord put: ((self newCoordinate) 
				at: #point put: (aPoint3DCollection collect:[:p|p*scale])
				;yourself)
			; yourself! !

!VRMLSceneBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:54'!
doPointLight: aLight

	^( self newPointLight )
		color: aLight color
		;location: aLight origin * scale! !

!VRMLSceneBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:54'!
doPolygon3D: aPolygon3D 
	
	^self doFaceComposite: (FaceComposite new add: aPolygon3D ;yourself)! !

!VRMLSceneBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:54'!
doPolyline3D: aPolyline3D

	| lineSet color |
	lineSet := self newIndexedLineSetFrom: (aPolyline3D scaledBy: self scale).
	"assume appearance is a color"
	color := self appearance material diffuseColor.
	lineSet color: ( self newColorFromAll: (Array with: color ) ).
	lineSet colorIndex: #( 0 ).
	lineSet colorPerVertex: false.
	^self newShape geometry: lineSet! !

!VRMLSceneBuilder methodsFor: 'dispatching ( IGeometric3DVisitor )' stamp: 'emm 02/09/2012 23:54'!
doPrism: aPrism

	^self doExtrusion: aPrism! !

!VRMLSceneBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:54'!
doRectangle3D: aRect3D 
	
	| result ttf tc old rotation |
	( self appearance hasProperty: 'texture' ) 
		ifFalse:[ ^ super doRectangle3D: aRect3D ].
 	result := super doRectangle3D: aRect3D.
	tc := self newTextureCoordinate.
	tc point: (Array with:  1,0 with: 1,1 with: 0,1 with:0,0).
	result geometry texCoord: tc.
	^result! !

!VRMLSceneBuilder methodsFor: 'dispatching-wrappers' stamp: 'emm 02/09/2012 23:54'!
doRotating3DWrapper: aWrapper 
	
	| element |
	element := self newElementFrom: aWrapper component.
	^ aWrapper rotation isZero
		ifTrue:
			[ element ]
		ifFalse:
			[  | newRotation transformedElement  | 
			newRotation := self orientationFromPoint: aWrapper rotation.
			transformedElement := self newTransform add: element ; yourself.
			transformedElement at: 'rotation' put: newRotation.
			transformedElement ]! !

!VRMLSceneBuilder methodsFor: 'dispatching-wrappers' stamp: 'emm 02/09/2012 23:54'!
doScaling3DWrapper: aWrapper

	| element |
	element := self newElementFrom: aWrapper component.
	^aWrapper scale isZero
		ifTrue: [ element ]
		ifFalse: [ element asVRMLTransform scaleBy: aWrapper scale ]! !

!VRMLSceneBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:54'!
doSimpleExtrudedPolygon: aSEPolygon

	^self doFaceComposite: aSEPolygon! !

!VRMLSceneBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:54'!
doSolidComposite: aComposite

	self beginGroup.
	aComposite solidsDo:[ :each | self add: each].
	^self endGroup.! !

!VRMLSceneBuilder methodsFor: 'dispatching-primitives ( IGeometric3DVisitor )' stamp: 'emm 02/09/2012 23:54'!
doSphere: aSphere
"
Sphere { 
  field SFFloat radius  1    # (0,)
}
"
	| shape |
	shape := self 
		newShapeOn: (( GenericSceneElement new className: 'Sphere')
			at: #radius put: aSphere radius * scale
			;yourself).
	^aSphere center isZero
		ifTrue: [ shape ]
		ifFalse: [ shape asVRMLTransform translateBy: aSphere center * scale]! !

!VRMLSceneBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:54'!
doSpotLight: aLight

	| spot |
	spot := self newSpotLight.
	spot color: aLight color.
	spot direction: aLight focusPoint - aLight origin. "what about coordinate transformation?"
	spot location: aLight origin *scale.
	spot radius: aLight radius * scale.

	"defaults ?
	spot beamWidth: 60 rad.
	spot cutOffAngle: 90 rad.
"
	^spot
	! !

!VRMLSceneBuilder methodsFor: 'dispatching ( IGeometric3DVisitor )' stamp: 'emm 02/09/2012 23:54'!
doText3D: aText3D 
	"See >>newText"

	^self newShapeOn:(self newText: (self linesFromString: aText3D string))! !

!VRMLSceneBuilder methodsFor: 'dispatching-wrappers' stamp: 'emm 02/09/2012 23:54'!
doTextureWrapper: aTexturingWrapper

	"Handle the request from @aTexturingWrapper"

	| oldAppearance result  ttf|
	oldAppearance := self appearance.
	self texture:  aTexturingWrapper texture.
	(aTexturingWrapper uv ~= (1,1))
		ifTrue: 
			[ttf := self newTextureTransform.
			ttf scale: aTexturingWrapper uvw x , aTexturingWrapper uvw y.
			self appearance textureTransform: ttf].
	result := aTexturingWrapper component kindDo: self.
	self appearance: oldAppearance.
	^result! !

!VRMLSceneBuilder methodsFor: 'dispatching-primitives ( IGeometric3DVisitor )' stamp: 'emm 02/09/2012 23:54'!
doTorus: aTorus

	"Handle the request send from @aTorus"

	^self doTorusArc: aTorus! !

!VRMLSceneBuilder methodsFor: 'dispatching ( IGeometric3DVisitor )' stamp: 'emm 02/09/2012 23:54'!
doTorusArc: aTS

	| intersection vertices interpolator stepAngle |
	intersection := Circle3D center: 0,0,0 radius: aTS minorRadius.
	vertices := Polygon3D new.
	interpolator := intersection interpolatorUsingAngleIncrement: 30 rad.
	interpolator verticesDo:[ :each |
		vertices add: ( each rotateBy: 90 rad,0,0) + (aTS majorRadius,0,0) + aTS center].
	stepAngle := 10 rad.
	^(BeveledPolygon 
			base: (vertices collect:[:p|p*scale]) reverseOriented
			interval: (0,0,aTS startAngle to: 0,0,(aTS startAngle + aTS sweepAngle - stepAngle) by: 0,0,stepAngle ))
		kindDo: self
! !

!VRMLSceneBuilder methodsFor: 'dispatching-wrappers' stamp: 'emm 02/09/2012 23:54'!
doTranslating3DWrapper: aWrapper 
	
	| element |
	element := self newElementFrom: aWrapper component.
	^aWrapper translation isZero
		ifTrue: [ element ]
		ifFalse: [ ( self newTransformOn: element) translation: aWrapper translation * scale ]! !

!VRMLSceneBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:54'!
doVRMLComposite: aComposite

	^aComposite! !

!VRMLSceneBuilder methodsFor: 'building-protos' stamp: 'emm 02/09/2012 23:54'!
doVRMLProto: aProto

	^self addElement: aProto! !

!VRMLSceneBuilder methodsFor: 'building-protos' stamp: 'emm 02/09/2012 23:54'!
doVariable: aVar

	^aVar! !

!VRMLSceneBuilder methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:54'!
elementClass
	^VRMLElement! !

!VRMLSceneBuilder methodsFor: 'API-building' stamp: 'emm 02/09/2012 23:54'!
endAnchor

	^self endGroup! !

!VRMLSceneBuilder methodsFor: 'API-building' stamp: 'emm 02/09/2012 23:54'!
endCollision

	^self endGroup! !

!VRMLSceneBuilder methodsFor: 'API-building' stamp: 'emm 02/09/2012 23:54'!
endLOD

	^self endGroup! !

!VRMLSceneBuilder methodsFor: 'building-protos' stamp: 'emm 02/09/2012 23:54'!
endProto

	currentProto := nil.
	^self endGroup! !

!VRMLSceneBuilder methodsFor: 'API-building' stamp: 'emm 02/09/2012 23:54'!
endSwitch

	^self endGroup! !

!VRMLSceneBuilder methodsFor: 'API-factory-fonts' stamp: 'emm 02/09/2012 23:54'!
fontDefault

	self fontStyle: nil! !

!VRMLSceneBuilder methodsFor: 'API-factory-fonts' stamp: 'emm 02/09/2012 23:54'!
fontSize: aSize

	self fontStyle: (self fontStyle copy at: #size put: aSize)! !

!VRMLSceneBuilder methodsFor: 'API-factory-fonts' stamp: 'emm 02/09/2012 23:54'!
fontStyle

	"Answer the value of fontStyle"

	^fontStyle! !

!VRMLSceneBuilder methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:54'!
fontStyle: aValue

	"Set the value of fontStyle"

	fontStyle := aValue! !

!VRMLSceneBuilder methodsFor: 'initialize-release' stamp: 'emm 02/09/2012 23:54'!
initialize

	super initialize.
	routes := OrderedCollection new.
	self navigationInfo: self newNavigationInfo.	
	self navigationInfo speed: 25.
	self fontStyle: self newFontStyle.	! !

!VRMLSceneBuilder methodsFor: 'testing' stamp: 'emm 02/09/2012 23:54'!
isVRML
	^true! !

!VRMLSceneBuilder methodsFor: 'API-building' stamp: 'emm 02/09/2012 23:54'!
lod: oneArgBlock
	
	self beginLOD.
	oneArgBlock value.
	^self add: self endLOD! !

!VRMLSceneBuilder methodsFor: 'API-building' stamp: 'emm 02/09/2012 23:54'!
material: aMaterial

	self appearance: ( self newAppearance
		at: #material put: aMaterial ).
	^aMaterial! !

!VRMLSceneBuilder methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:54'!
navigationInfo

	"Answer the value of navigationInfo"

	^navigationInfo! !

!VRMLSceneBuilder methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:54'!
navigationInfo: aValue

	"Set the value of navigationInfo"

	navigationInfo := aValue! !

!VRMLSceneBuilder methodsFor: 'factory' stamp: 'emm 02/09/2012 23:54'!
newAnchor
"
Anchor { 
  eventIn      MFNode   addChildren
  eventIn      MFNode   removeChildren
  exposedField MFNode   children      []
  exposedField SFString description   "" 
  exposedField MFString parameter     []
  exposedField MFString url           []
  field        SFVec3f  bboxCenter    0 0 0    # (-,)
  field        SFVec3f  bboxSize      -1 -1 -1 # (0,) or -1,-1,-1
}
"
	^VRMLComposite new className: 'Anchor'! !

!VRMLSceneBuilder methodsFor: 'factory' stamp: 'emm 02/09/2012 23:54'!
newAppearance
"
Appearance { 
  exposedField SFNode material          NULL
  exposedField SFNode texture           NULL
  exposedField SFNode textureTransform  NULL
}
"
	"Always initialize the element's name. Most likely it will be shared"

	^( self elementClass new className: 'Appearance' ) initializeName! !

!VRMLSceneBuilder methodsFor: 'factory' stamp: 'emm 02/09/2012 23:54'!
newAudioClip: url
"
AudioClip { 
  exposedField   SFString description      ''''
  exposedField   SFBool   loop             FALSE
  exposedField   SFFloat  pitch            1.0        # (0,)
  exposedField   SFTime   startTime        0          # (-,)
  exposedField   SFTime   stopTime         0          # (-,)
  exposedField   MFString url              []
  eventOut       SFTime   duration_changed
  eventOut       SFBool   isActive
}

An AudioClip node specifies audio data that can be referenced by
other nodes that require an audio source.
"

	^(self elementClass new className: 'AudioClip')
		url: url! !

!VRMLSceneBuilder methodsFor: 'factory' stamp: 'emm 02/09/2012 23:54'!
newBackground
"
Background { 
  eventIn      SFBool   set_bind
  exposedField MFFloat  groundAngle  []            # [0,/2]
  exposedfield MFColor  groundColor  []            # [0,1]
  exposedField MFString backUrl      []
  exposedField MFString bottomUrl    []
  exposedField MFString frontUrl     []
  exposedField MFString leftUrl      []
  exposedField MFString rightUrl     []
  exposedField MFString topUrl       []
  exposedField MFFloat  skyAngle     []            # [0,]
  exposedField MFColor  skyColor     [ 0 0 0 ]     # [0,1]
  eventOut     SFBool   isBound
}
"
	^( VRMLBackground new className: 'Background' )! !

!VRMLSceneBuilder methodsFor: 'factory' stamp: 'emm 02/09/2012 23:54'!
newBillboard
"
Billboard { 
  eventIn      MFNode   addChildren
  eventIn      MFNode   removeChildren
  exposedField SFVec3f  axisOfRotation  0 1 0      # (-,)
  exposedField MFNode   children        []
  field        SFVec3f  bboxCenter      0 0 0      # (-,)
  field        SFVec3f  bboxSize        -1 -1 -1   # (0,) or -1,-1,-1
}
"
	^VRMLComposite new className: 'Billboard'! !

!VRMLSceneBuilder methodsFor: 'factory' stamp: 'emm 02/09/2012 23:54'!
newCamera

	^( self elementClass new className: 'PerspectiveCamera' )
			at: #position put: ( -0.360 , 1.174 , 4.488 )
			;at: #orientation put: ( -0.005 , 0.000 , 0.017 , 0.035 )
			;at: #focalDistance put: 5
			;at: #heightAngle put: 0.785
			;yourself! !

!VRMLSceneBuilder methodsFor: 'factory' stamp: 'emm 02/09/2012 23:54'!
newCollision

"Collision { 
  eventIn      MFNode   addChildren
  eventIn      MFNode   removeChildren
  exposedField MFNode   children        []
  exposedField SFBool   collide         TRUE
  field        SFVec3f  bboxCenter      0 0 0      # (-,)
  field        SFVec3f  bboxSize        -1 -1 -1   # (0,) or -1,-1,-1
  field        SFNode   proxy           NULL
  eventOut     SFTime   collideTime
}
"

	^( VRMLComposite new )
			className: 'Collision'
			; childrenFieldName: 'children'! !

!VRMLSceneBuilder methodsFor: 'factory' stamp: 'emm 02/09/2012 23:54'!
newColorFromAll: aColorCollection
"
Color { 
  exposedField MFColor color  []         # [0,1]
}
"
	^( self elementClass new className: 'Color' )
			at: #color put: aColorCollection
			;yourself! !

!VRMLSceneBuilder methodsFor: 'factory' stamp: 'emm 02/09/2012 23:54'!
newColorInterpolator
"
ColorInterpolator { 
  eventIn      SFFloat set_fraction        # (-,)
  exposedField MFFloat key           []    # (-,)
  exposedField MFVec3f keyValue      []    # (-,)
  eventOut     SFVec3f value_changed
}
"
	^( self elementClass new className: 'ColorInterpolator' )! !

!VRMLSceneBuilder methodsFor: 'factory' stamp: 'emm 02/09/2012 23:54'!
newCoordinate
"
Coordinate { 
  exposedField MFVec3f point  []      # (-,)
}
"
	^( self elementClass new className: 'Coordinate' )! !

!VRMLSceneBuilder methodsFor: 'factory' stamp: 'emm 02/09/2012 23:54'!
newCylinderSensor
"
CylinderSensor { 
  exposedField SFBool     autoOffset TRUE
  exposedField SFFloat    diskAngle  0.262       # (0,/2)
  exposedField SFBool     enabled    TRUE
  exposedField SFFloat    maxAngle   -1          # [-2,2]
  exposedField SFFloat    minAngle   0           # [-2,2]
  exposedField SFFloat    offset     0           # (-,)
  eventOut     SFBool     isActive
  eventOut     SFRotation rotation_changed
  eventOut     SFVec3f    trackPoint_changed
}
"
	^( self elementClass new className: 'CylinderSensor' )! !

!VRMLSceneBuilder methodsFor: 'factory' stamp: 'emm 02/09/2012 23:54'!
newDirectionalLight
"
DirectionalLight { 
  exposedField SFFloat ambientIntensity  0        # [0,1]
  exposedField SFColor color             1 1 1    # [0,1]
  exposedField SFVec3f direction         0 0 -1   # (-,)
  exposedField SFFloat intensity         1        # [0,1]
  exposedField SFBool  on                TRUE 
}
"
	^self elementClass new className: 'DirectionalLight'! !

!VRMLSceneBuilder methodsFor: 'factory' stamp: 'emm 02/09/2012 23:54'!
newExtrusion
"
The Extrusion node specifies geometric shapes based on a two dimensional cross-section extruded
along a three dimensional spine in the local coordinate system. The cross-section can be scaled and
rotated at each spine point to produce a wide variety of shapes. 

Extrusion { 
  eventIn MFVec2f    set_crossSection
  eventIn MFRotation set_orientation
  eventIn MFVec2f    set_scale
  eventIn MFVec3f    set_spine
  field   SFBool     beginCap         TRUE
  field   SFBool     ccw              TRUE
  field   SFBool     convex           TRUE
  field   SFFloat    creaseAngle      0                # [0,)
  field   MFVec2f    crossSection     [ 1 1, 1 -1, -1 -1,
									   -1 1, 1  1 ]    # (-,)
  field   SFBool     endCap           TRUE
  field   MFRotation orientation      0 0 1 0          # [-1,1],(-,)
  field   MFVec2f    scale            1 1              # (0,)
  field   SFBool     solid            TRUE
  field   MFVec3f    spine            [ 0 0 0, 0 1 0 ] # (-,)
}
"
	^( self elementClass new className: 'Extrusion' )! !

!VRMLSceneBuilder methodsFor: 'API-factory-fonts' stamp: 'emm 02/09/2012 23:54'!
newFontBold

	^self newFontStyle style: 'BOLD'! !

!VRMLSceneBuilder methodsFor: 'API-factory-fonts' stamp: 'emm 02/09/2012 23:54'!
newFontItalic

	^self newFontStyle style: 'Italic'! !

!VRMLSceneBuilder methodsFor: 'factory' stamp: 'emm 02/09/2012 23:54'!
newFontStyle
"
FontStyle { 
  field MFString family       [''SERIF'']
  field SFBool   horizontal   TRUE
  field MFString justify      ''BEGIN''
  field SFString language     ''''
  field SFBool   leftToRight  TRUE
  field SFFloat  size         1.0          # (0,)
  field SFFloat  spacing      1.0          # [0,)
  field SFString style       ''PLAIN''
  field SFBool   topToBottom  TRUE
}

All browsers shall support at least SERIF
(the default) for a serif font such as Times Roman; 
SANS for a sans-serif font such as Helvetica;
and TYPEWRITER for a fixed-pitch font such as Courier. 
"
	^( self elementClass new className: 'FontStyle' )! !

!VRMLSceneBuilder methodsFor: 'factory' stamp: 'emm 02/09/2012 23:54'!
newGroup
"
Group { 
  eventIn      MFNode  addChildren
  eventIn      MFNode  removeChildren
  exposedField MFNode  children       []
  field        SFVec3f bboxCenter     0 0 0     # (-,)
  field        SFVec3f bboxSize       -1 -1 -1  # (0,) or -1,-1,-1
}
"
	^VRMLComposite new className: 'Group'! !

!VRMLSceneBuilder methodsFor: 'factory' stamp: 'emm 02/09/2012 23:54'!
newImageTextureFrom: anURL
"
ImageTexture { 
  exposedField MFString url     []
  field        SFBool   repeatS TRUE
  field        SFBool   repeatT TRUE
}
"
	^( self elementClass new className: 'ImageTexture' ) url: anURL! !

!VRMLSceneBuilder methodsFor: 'factory' stamp: 'emm 02/09/2012 23:54'!
newIndexedFaceSet
"
IndexedFaceSet { 
  eventIn       MFInt32 set_colorIndex
  eventIn       MFInt32 set_coordIndex
  eventIn       MFInt32 set_normalIndex
  eventIn       MFInt32 set_texCoordIndex
  exposedField  SFNode  color             NULL
  exposedField  SFNode  coord             NULL
  exposedField  SFNode  normal            NULL
  exposedField  SFNode  texCoord          NULL
  field         SFBool  ccw               TRUE
  field         MFInt32 colorIndex        []        # [-1,)
  field         SFBool  colorPerVertex    TRUE
  field         SFBool  convex            TRUE
  field         MFInt32 coordIndex        []        # [-1,)
  field         SFFloat creaseAngle       0         # [0,)
  field         MFInt32 normalIndex       []        # [-1,)
  field         SFBool  normalPerVertex   TRUE
  field         SFBool  solid             TRUE
  field         MFInt32 texCoordIndex     []        # [-1,)
}
"
	^( self elementClass new className: 'IndexedFaceSet' )! !

!VRMLSceneBuilder methodsFor: 'API-factory' stamp: 'emm 02/09/2012 23:54'!
newIndexedFaceSetFrom: aPolygonComposite
	
	| includeNormals |
	includeNormals := self appearance isNil
		or:[ (self appearance hasProperty: 'texture') not ].
	^self newIndexedFaceSetFrom: aPolygonComposite includeNormals:includeNormals! !

!VRMLSceneBuilder methodsFor: 'API-factory' stamp: 'emm 02/09/2012 23:54'!
newIndexedFaceSetFrom: aPolygonComposite includeNormals: aBoolean
	
	"Indices are zero-based"

	| vertices vertexIndices normals normalIndices  polysPerVertex ifSet |
	ifSet := self newIndexedFaceSet.
	vertices := OrderedPoint3DCollection new.
	vertexIndices := OrderedCollection new.
	polysPerVertex := OrderedCollection new.
	aPolygonComposite facesDo:[ :eachFace |
		eachFace asPolygon3D reverseDo:[ :eachPoint |
			| index |
			index := vertices indexOf: eachPoint.
			index = 0
				ifTrue: 
					[ vertices add: eachPoint.
					polysPerVertex add: OrderedCollection new.
					index := vertices size ].
			vertexIndices add: index - 1.
			( polysPerVertex at: index) add: eachFace ].
		vertexIndices add: -1].
	ifSet at: #coord put: ((self newCoordinate) at: #point put: vertices ;yourself).
	ifSet at: #coordIndex put: vertexIndices.

	aBoolean ifFalse: [ ^ifSet ].
	normals := polysPerVertex collect:[ :eachFaceCollection | 
		( eachFaceCollection inject: Point3D zero into: [ :vertex :each | vertex + each normal ] ) normalized negated].
	ifSet at: #normal put: (self newNormalFromAll: normals).	
	ifSet at: #normalPerVertex put: true.
	^ifSet! !

!VRMLSceneBuilder methodsFor: 'factory' stamp: 'emm 02/09/2012 23:54'!
newIndexedLineSet
"
IndexedLineSet { 
  eventIn       MFInt32 set_colorIndex
  eventIn       MFInt32 set_coordIndex
  exposedField  SFNode  color             NULL
  exposedField  SFNode  coord             NULL
  field         MFInt32 colorIndex        []     # [-1,)
  field         SFBool  colorPerVertex    TRUE
  field         MFInt32 coordIndex        []     # [-1,)
}
"
	^( self elementClass new className: 'IndexedLineSet' )! !

!VRMLSceneBuilder methodsFor: 'API-factory' stamp: 'emm 02/09/2012 23:54'!
newIndexedLineSetFrom: aPolyline
	
	"Indices are zero-based"

	| lineSet vertices vertexIndices  |
	lineSet := self newIndexedLineSet.
	vertices := OrderedPoint3DCollection new.
	vertexIndices := OrderedCollection new.
	aPolyline do:[ :eachPoint |
			| index |
			index := vertices indexOf: eachPoint.
			index = 0
				ifTrue: 
					[ vertices add: eachPoint.
					index := vertices size ].
			vertexIndices add: index - 1 ].
	lineSet at: #coord put: ((self newCoordinate) at: #point put: vertices ;yourself).
	lineSet at: #coordIndex put: vertexIndices.
	^lineSet
! !

!VRMLSceneBuilder methodsFor: 'factory' stamp: 'emm 02/09/2012 23:54'!
newInline: url
"
Inline { 
  exposedField MFString url        []
  field        SFVec3f  bboxCenter 0 0 0     # (-,)
  field        SFVec3f  bboxSize   -1 -1 -1  # (0,) or -1,-1,-1
}
"
	^( self elementClass new className: 'Inline' )
		url: url! !

!VRMLSceneBuilder methodsFor: 'API-factory' stamp: 'emm 02/09/2012 23:54'!
newInlineURL: aString

	^self newInline: aString! !

!VRMLSceneBuilder methodsFor: 'building-protos' stamp: 'emm 02/09/2012 23:54'!
newInstanceOfProto: aString
	
	^GenericSceneElement new className: aString! !

!VRMLSceneBuilder methodsFor: 'factory' stamp: 'emm 02/09/2012 23:54'!
newLOD
"
LOD { 
  exposedField MFNode  level    [] 
  field        SFVec3f center   0 0 0    # (-,)
  field        MFFloat range    []       # (0,)
}
"
	^( VRMLComposite new )
			className: 'LOD'
			; childrenFieldName: 'level'! !

!VRMLSceneBuilder methodsFor: 'API-factory-labels' stamp: 'emm 02/09/2012 23:54'!
newLabel: aString at: aPoint3D

	| text  |
	text := self newText: aString.
	^(( self newShapeOn: text ) asVRMLTransform translation: aPoint3D)! !

!VRMLSceneBuilder methodsFor: 'API-factory-labels' stamp: 'emm 02/09/2012 23:54'!
newLabel: aString at: aPoint3D axis: otherPoint3D

	| text bill |
	text := self newText: aString.
	bill := self newBillboard axisOfRotation: otherPoint3D.
	bill add: (self newShapeOn: text ).
	^bill asVRMLTransform translation: aPoint3D! !

!VRMLSceneBuilder methodsFor: 'API-factory-labels' stamp: 'emm 02/09/2012 23:54'!
newLabel: aString on: aPolygon

	^( aPolygon normal negated rotationPointsFromZ
		inject: ( ( self newTransform )
			add: ( self newShapeOn: (self newText: aString ) )
			; yourself )
		into:[ :rootTransform :eachPoint |
			| rot |
			rot := self orientationFromPoint: eachPoint.
			rot isZero
				ifTrue: [ rootTransform ]
				ifFalse: [ (self newTransform)
					add: ( rootTransform rotation: rot )
					;yourself ] ] ) 
			translation: aPolygon center
			! !

!VRMLSceneBuilder methodsFor: 'API-factory-labels' stamp: 'emm 02/09/2012 23:54'!
newLabel: aString on: aPolygon axis: aPoint

	^self newLabel: aString at: aPolygon center axis: aPoint
			! !

!VRMLSceneBuilder methodsFor: 'factory' stamp: 'emm 02/09/2012 23:54'!
newMovieTexture
"
MovieTexture

  exposedField SFBool       loop             FALSE
  exposedField SFFloat      speed            1.0
  exposedField SFTime       startTime        0
  exposedField SFTime       stopTime         0
  exposedField MFString    url              []
  field                                  SFBool   repeatS          TRUE
  field                                   SFBool   repeatT          TRUE
  eventOut                           SFTime   duration_changed
  eventOut                           SFBool   isActive
}
"
	^self elementClass new className: 'MovieTexture'! !

!VRMLSceneBuilder methodsFor: 'factory' stamp: 'emm 02/09/2012 23:54'!
newNavigationInfo
"
NavigationInfo { 
  eventIn      SFBool   set_bind
  exposedField MFFloat  avatarSize      [0.25, 1.6, 0.75] # [0,)
  exposedField SFBool   headlight       TRUE
  exposedField SFFloat  speed           1.0               # [0,)
  exposedField MFString type            ['WALK', 'ANY']
  exposedField SFFloat  visibilityLimit 0.0               # [0,)
  eventOut     SFBool   isBound
}

The NavigationInfo node contains information describing the physical 
characteristics of the viewer's avatar and viewing model.
"
	^( self elementClass new className: 'NavigationInfo' )! !

!VRMLSceneBuilder methodsFor: 'factory' stamp: 'emm 02/09/2012 23:54'!
newNormalFromAll: aPointCollection

	^( self elementClass new className: 'Normal' )
			at: 'vector' put: aPointCollection
			;yourself! !

!VRMLSceneBuilder methodsFor: 'factory' stamp: 'emm 02/09/2012 23:54'!
newOrientationInterpolator
"
OrientationInterpolator { 
  eventIn      SFFloat    set_fraction      # (-,)
  exposedField MFFloat    key           []  # (-,)
  exposedField MFRotation keyValue      []  # [-1,1],(-,)
  eventOut     SFRotation value_changed
}
"
	^( self elementClass new className: 'OrientationInterpolator' )! !

!VRMLSceneBuilder methodsFor: 'factory' stamp: 'emm 02/09/2012 23:54'!
newPlaneSensor
"
PlaneSensor { 
  exposedField SFBool  autoOffset          TRUE
  exposedField SFBool  enabled             TRUE
  exposedField SFVec2f maxPosition         -1 -1     # (-,)
  exposedField SFVec2f minPosition         0 0       # (-,)
  exposedField SFVec3f offset              0 0 0     # (-,)
  eventOut     SFBool  isActive
  eventOut     SFVec3f trackPoint_changed
  eventOut     SFVec3f translation_changed
}
"
	^( self elementClass new className: 'PlaneSensor' )! !

!VRMLSceneBuilder methodsFor: 'factory' stamp: 'emm 02/09/2012 23:54'!
newPointLight
"
PointLight { 
  exposedField SFFloat ambientIntensity  0       # [0,1]
  exposedField SFVec3f attenuation       1 0 0   # [0,)
  exposedField SFColor color             1 1 1   # [0,1]
  exposedField SFFloat intensity         1       # [0,1]
  exposedField SFVec3f location          0 0 0   # (-,)
  exposedField SFBool  on                TRUE 
  exposedField SFFloat radius            100     # [0,)
}
"
	^self elementClass new className: 'PointLight'! !

!VRMLSceneBuilder methodsFor: 'factory' stamp: 'emm 02/09/2012 23:54'!
newPointSet
"
PointSet { 
  exposedField  SFNode  color      NULL
  exposedField  SFNode  coord      NULL
}
"
	^( self elementClass new className: 'PointSet' )! !

!VRMLSceneBuilder methodsFor: 'factory' stamp: 'emm 02/09/2012 23:54'!
newPositionInterpolator
"
PositionInterpolator { 
  eventIn      SFFloat set_fraction        # (-,)
  exposedField MFFloat key           []    # (-,)
  exposedField MFVec3f keyValue      []    # (-,)
  eventOut     SFVec3f value_changed
}
"
	^( self elementClass new className: 'PositionInterpolator' )! !

!VRMLSceneBuilder methodsFor: 'building-protos' stamp: 'emm 02/09/2012 23:54'!
newProto
	
	^VRMLProto new className: 'PROTO'! !

!VRMLSceneBuilder methodsFor: 'building-protos' stamp: 'emm 02/09/2012 23:54'!
newProto: aName
	
	^( VRMLProto new className: 'PROTO' ) name: aName! !

!VRMLSceneBuilder methodsFor: 'factory' stamp: 'emm 02/09/2012 23:54'!
newProximitySensor
"
ProximitySensor { 
  exposedField SFVec3f    center      0 0 0    # (-,)
  exposedField SFVec3f    size        0 0 0    # [0,)
  exposedField SFBool     enabled     TRUE
  eventOut     SFBool     isActive
  eventOut     SFVec3f    position_changed
  eventOut     SFRotation orientation_changed
  eventOut     SFTime     enterTime
  eventOut     SFTime     exitTime
}
The ProximitySensor node generates events when the viewer enters, exits, 
and moves within a region in space (defined by a box).
"
	^( self elementClass new className: 'ProximitySensor' )! !

!VRMLSceneBuilder methodsFor: 'factory' stamp: 'emm 02/09/2012 23:54'!
newScalarInterpolator
"
ScalarInterpolator { 
  eventIn      SFFloat set_fraction         # (-,)
  exposedField MFFloat key           []     # (-,)
  exposedField MFFloat keyValue      []     # (-,)
  eventOut     SFFloat value_changed
}
"
	^( self elementClass new className: 'ScalarInterpolator' )! !

!VRMLSceneBuilder methodsFor: 'factory' stamp: 'emm 02/09/2012 23:54'!
newScheduler

	^VRMLScheduler new! !

!VRMLSceneBuilder methodsFor: 'factory' stamp: 'emm 02/09/2012 23:54'!
newScript
"
Script { 
  exposedField MFString url           [] 
  field        SFBool   directOutput  FALSE
  field        SFBool   mustEvaluate  FALSE
  # And any number of:
  eventIn      eventType eventName
  field        fieldType fieldName initialValue
  eventOut     eventType eventName
}
"
	^VRMLScript new className: 'Script'! !

!VRMLSceneBuilder methodsFor: 'API-factory' stamp: 'emm 02/09/2012 23:54'!
newScriptForChoice: anInteger

	"Answer a script node that trigger the event @whichChoice by assigning it to @anInteger"

	^self newScript
		at: 'eventIn SFTime' put: #touchTime
		;at:'eventOut SFInt32' put: #whichChoice
		;at: 'url' put: ( 'vrmlscript: function touchTime( value, time) { whichChoice = %1}'
			bindWith: anInteger printString )
		;yourself! !

!VRMLSceneBuilder methodsFor: 'API-factory' stamp: 'emm 02/09/2012 23:54'!
newScriptForLoadingURL: aString parameterString: otherString

	"Answer a script node that will make the browser load
	a file referenced by @aString"


	^self newScript
		declare: #anURL as: 'field MFString' value: ( self asJavaString: aString )
		;declare: #param as: 'field MFString' value: ( self asJavaString: otherString )
		;declare: #startTime as: 'eventIn SFTime'
		;source: 'function startTime(value,time) { Browser.loadURL(anURL,param) }'! !

!VRMLSceneBuilder methodsFor: 'API-factory' stamp: 'emm 02/09/2012 23:54'!
newScriptForNavigatingChoiceBetween: start and: stop

	"Answer a script node that trigger the event @whichChoice 
	by calling either increase or decrease the choice"

	^self newScript
		at:'eventOut SFInt32' put: #whichChoice
		;at: 'eventIn SFTime increaseChoice' put: nil
		;at: 'eventIn SFTime decreaseChoice' put: nil
		;at: 'eventIn SFTime homeChoice' put: nil
		;at: 'eventIn SFTime endChoice' put: nil
		;at: 'eventIn SFTime noChoice' put: nil
		;at: 'url' put: (( 'vrmlscript: 
		function initialize() { whichChoice = %1}
		function increaseChoice( value, time) { if (whichChoice < %2) whichChoice++ }
		function decreaseChoice( value, time) { if (whichChoice > %1) whichChoice-- }
		function homeChoice( value, time) { whichChoice = %1 }
		function endChoice( value, time) { whichChoice = %2 }
		function noChoice( value, time) { whichChoice = -1 }' 
		) bindWith: start printString with: stop printString)
		;yourself! !

!VRMLSceneBuilder methodsFor: 'API-factory' stamp: 'emm 02/09/2012 23:54'!
newScriptForNavigatingChoiceIn: aSwitch

	"Events:	
			homeChoice
			increaseChoice
			decreaseChoice
			endChoice
			noChoice"

	| navigator |
	navigator := self 
		newScriptForNavigatingChoiceBetween: 0 
		and: aSwitch children size - 1.
	self route: #whichChoice of: navigator to: #whichChoice of: aSwitch.
	^navigator! !

!VRMLSceneBuilder methodsFor: 'API-factory' stamp: 'emm 02/09/2012 23:54'!
newScriptForReplacingWorldByURL: aString

	"Answer a script node that will make the browser replace
	the current world by the one read from @aString"

	| replaceScript |
	^( replaceScript := self newScript )
		at: 'field SFNode theRoot USE' put: replaceScript name asSymbol
		;at:'field MFString theURL' put: aString
		;at: 'eventIn MFNode' put: #nodesCreated
		;at: 'eventIn SFTime' put: #replace
		;at: 'url' put: 'javascript:
function replace (value, timestamp) {Browser.createVrmlFromURL( theURL,theRoot,''nodesCreated'' );}
function nodesCreated(value, timestamp) {Browser.replaceWorld ( value );}'
		; yourself
! !

!VRMLSceneBuilder methodsFor: 'API-factory' stamp: 'emm 02/09/2012 23:54'!
newScriptForToggleTimer: aTimeSensor

	^(self newScript )
		at: 'eventIn SFTime' put: #startOrStop
		;at: 'eventOut SFTime' put: #set_startTime
		;at: 'eventOut SFTime' put: #set_stopTime
		;at: 'eventOut SFTime' put: #estfraction_changed
		;at: 'eventIn SFBool' put: #isActive
		;at: 'field SFBool' put: #hasToppled
		;at: 'url' put: 'javascript:
function initialize() { hasToppled = false }
function startOrStop (value, timestamp) {
	if (hasToppled)
		set_startTime = 0
}'
		! !

!VRMLSceneBuilder methodsFor: 'API-factory' stamp: 'emm 02/09/2012 23:54'!
newShape

	^( self elementClass new className: 'Shape' ) ! !

!VRMLSceneBuilder methodsFor: 'API-factory' stamp: 'emm 02/09/2012 23:54'!
newShapeOn: anElement 
	
	^( self elementClass new className: 'Shape' ) 
		at: #geometry put: anElement 
		; at: #appearance put: self appearance 
		; yourself! !

!VRMLSceneBuilder methodsFor: 'factory' stamp: 'emm 02/09/2012 23:54'!
newSound: source
"
Sound { 
  exposedField SFVec3f  direction     0 0 1   # (-,)
  exposedField SFFloat  intensity     1       # [0,1]
  exposedField SFVec3f  location      0 0 0   # (-,)
  exposedField SFFloat  maxBack       10      # [0,)
  exposedField SFFloat  maxFront      10      # [0,)
  exposedField SFFloat  minBack       1       # [0,)
  exposedField SFFloat  minFront      1       # [0,)
  exposedField SFFloat  priority      0       # [0,1]
  exposedField SFNode   source        NULL
  field        SFBool   spatialize    TRUE
}

The Sound node specifies the spatial presentation of a sound in
a VRML scene. 
"

	^(self elementClass new className: 'Sound')
			source: source! !

!VRMLSceneBuilder methodsFor: 'factory' stamp: 'emm 02/09/2012 23:54'!
newSpotLight
"
SpotLight { 
  exposedField SFFloat ambientIntensity  0         # [0,1]
  exposedField SFVec3f attenuation       1 0 0     # [0,)
  exposedField SFFloat beamWidth         1.570796  # (0,/2]
  exposedField SFColor color             1 1 1     # [0,1]
  exposedField SFFloat cutOffAngle       0.785398  # (0,/2]
  exposedField SFVec3f direction         0 0 -1    # (-,)
  exposedField SFFloat intensity         1         # [0,1]
  exposedField SFVec3f location          0 0 0     # (-,)
  exposedField SFBool  on                TRUE
  exposedField SFFloat radius            100       # [0,)
}
"
	^self elementClass new className: 'SpotLight'! !

!VRMLSceneBuilder methodsFor: 'factory' stamp: 'emm 02/09/2012 23:54'!
newSwitch
"
Switch { 
  exposedField    MFNode  choice      []
  exposedField    SFInt32 whichChoice -1    # [-1,)
}
"
	^( VRMLComposite new className: 'Switch' ) childrenFieldName: 'choice'! !

!VRMLSceneBuilder methodsFor: 'factory' stamp: 'emm 02/09/2012 23:54'!
newText: aString
"
Text { 
  exposedField  MFString string    []
  exposedField  SFNode   fontStyle NULL
  exposedField  MFFloat  length    []      # [0,)
  exposedField  SFFloat  maxExtent 0.0     # [0,)
}
"
	| text |
	text := ( self elementClass new className: 'Text' ).
	text string: aString.
	self fontStyle isNil
		ifFalse:[ text fontStyle: self fontStyle ].
	^text! !

!VRMLSceneBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:54'!
newTextureCoordinate
"
TextureCoordinate { 
  exposedField MFVec2f point  []      # (-,)
}
"
	^GenericSceneElement new className: 'TextureCoordinate'
! !

!VRMLSceneBuilder methodsFor: 'factory' stamp: 'emm 02/09/2012 23:54'!
newTextureTransform
"
TextureTransform { 
  exposedField SFVec2f center      0 0     # (-,)
  exposedField SFFloat rotation    0       # (-,)
  exposedField SFVec2f scale       1 1     # (-,)
  exposedField SFVec2f translation 0 0     # (-,)
}
"
	^( self elementClass new className: 'TextureTransform' )! !

!VRMLSceneBuilder methodsFor: 'factory' stamp: 'emm 02/09/2012 23:54'!
newTimeSensor
"
TimeSensor { 
  exposedField SFTime   cycleInterval 1       # (0,)
  exposedField SFBool   enabled       TRUE
  exposedField SFBool   loop          FALSE
  exposedField SFTime   startTime     0       # (-,)
  exposedField SFTime   stopTime      0       # (-,)
  eventOut     SFTime   cycleTime
  eventOut     SFFloat  fraction_changed
  eventOut     SFBool   isActive
  eventOut     SFTime   time
}
"
	^self elementClass new className: 'TimeSensor'! !

!VRMLSceneBuilder methodsFor: 'factory' stamp: 'emm 02/09/2012 23:54'!
newTouchSensor
"
TouchSensor { 
  exposedField SFBool  enabled TRUE
  eventOut     SFVec3f hitNormal_changed
  eventOut     SFVec3f hitPoint_changed
  eventOut     SFVec2f hitTexCoord_changed
  eventOut     SFBool  isActive
  eventOut     SFBool  isOver
  eventOut     SFTime  touchTime
}
"
	^self elementClass new className: 'TouchSensor'! !

!VRMLSceneBuilder methodsFor: 'factory' stamp: 'emm 02/09/2012 23:54'!
newTransform

	^VRMLComposite new className: 'Transform'! !

!VRMLSceneBuilder methodsFor: 'API-factory' stamp: 'emm 02/09/2012 23:54'!
newTransformOn: anElement

	^self newTransform add: anElement ;yourself! !

!VRMLSceneBuilder methodsFor: 'building-protos' stamp: 'emm 02/09/2012 23:54'!
newVariable: name type: typeSource default: value

	^(Variable new)
			name: name
			;type: typeSource
			;value: value! !

!VRMLSceneBuilder methodsFor: 'factory' stamp: 'emm 02/09/2012 23:54'!
newViewpoint
"
Viewpoint { 
  eventIn      SFBool     set_bind
  exposedField SFFloat    fieldOfView    0.785398  # (0,)
  exposedField SFBool     jump           TRUE
  exposedField SFRotation orientation    0 0 1 0   # [-1,1],(-,)
  exposedField SFVec3f    position       0 0 10    # (-,)
  field        SFString   description    ""
  eventOut     SFTime     bindTime
  eventOut     SFBool     isBound
}
"
	^self elementClass new className: 'Viewpoint'! !

!VRMLSceneBuilder methodsFor: 'API-factory-viewpoints' stamp: 'emm 02/09/2012 23:54'!
newViewpointBack: howFar

	^self newTransform
		rotation: 0,1,0,HalfPi negated
		; add: ( self newViewpoint
			position: 0,0,howFar
			; orientation: 0,0,1,HalfPi negated
			; description: 'back' )
		; yourself! !

!VRMLSceneBuilder methodsFor: 'API-factory-viewpoints' stamp: 'emm 02/09/2012 23:54'!
newViewpointFront: howFar

	^self newTransform
		rotation: 0,1,0,HalfPi
		; add: ( self newViewpoint
			position: 0,0,howFar
			; orientation: 0,0,1,HalfPi
			; description: 'front' )
		; yourself! !

!VRMLSceneBuilder methodsFor: 'API-factory-viewpoints' stamp: 'emm 02/09/2012 23:54'!
newViewpointLeft: howFar

	^self newViewpoint
			position: 0,howFar negated,0
			; orientation: 1,0,0,HalfPi
			; description: 'left'! !

!VRMLSceneBuilder methodsFor: 'API-factory-viewpoints' stamp: 'emm 02/09/2012 23:54'!
newViewpointTop: howFar

	^self newViewpoint
		position: 0,0, howFar
		; orientation: 0,0,1,HalfPi
		; description: 'top' ! !

!VRMLSceneBuilder methodsFor: 'API-events' stamp: 'emm 02/09/2012 23:54'!
route: aProp1 of: anElement1 to: aProp2 of: anElement2
	
	self addRoute: ( VRMLRoute
			from: aProp1
			of: anElement1
			to: aProp2
			of: anElement2 )! !

!VRMLSceneBuilder methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:54'!
routes

	"Answer the value of routes"

	^routes! !

!VRMLSceneBuilder methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:54'!
routes: aValue

	"Set the value of routes"

	routes := aValue! !

!VRMLSceneBuilder methodsFor: 'API-building' stamp: 'emm 02/09/2012 23:54'!
switch: oneArgBlock

	self beginSwitch.
	oneArgBlock value.
	^self add: self endSwitch! !

!VRMLSceneBuilder methodsFor: 'building-appearance ( ISceneBuilder )' stamp: 'emm 02/09/2012 23:54'!
texture: anURL color: aColor 
	
	| outStream name |
	self appearance: ( self newAppearance texture: ( self newImageTextureFrom: anURL ) ). 
	
	aColor notNil 
		ifTrue:[ self appearance material: ( self newMaterial diffuseColor: aColor ) ]. 
	
	name := anURL copyFrom: 1 to: ( anURL indexOf: $. ) - 1.
	name := name copyReplaceAll: '/' with: '_'.
	name := name copyReplaceAll: '\' with: '_'.
	self appearance name: name! !

!VRMLSceneBuilder methodsFor: 'API-events' stamp: 'emm 02/09/2012 23:54'!
whenPointingAt: anElement choose: anInteger in: aSwitch

	| aTouchSensor |
	^self group:[
	self add: ( aTouchSensor := self newTouchSensor ).
	self whenTouching: aTouchSensor choose: anInteger in: aSwitch.
	]! !

!VRMLSceneBuilder methodsFor: 'API-events' stamp: 'emm 02/09/2012 23:54'!
whenPointingAt: anElement send: anEvent to: aScript

	self whenTouching: (self add: self newTouchSensor) send: anEvent to: aScript
! !

!VRMLSceneBuilder methodsFor: 'API-events' stamp: 'emm 02/09/2012 23:54'!
whenPointingAt: anElement 
	translate: anObject 
	along: aPoint3Collection 
	within: seconds

	"Pre: @anElement has been added, anObject has not"

	| transE transI touchS timeS  |
	^self group:[
	self add: ( transE := self newTransformOn: ( self newElementFrom: anObject )).
	self add: ( transI := self newPositionInterpolatorFrom: aPoint3Collection ).
	self add: ( touchS := self newTouchSensor ).
	self add: ( timeS := self newTimeSensor cycleInterval: seconds ).
	self whenTouching: touchS start: timeS.
	self whenFractionChanging: timeS translate: transE using: transI.
	]
	
	
	! !

!VRMLSceneBuilder methodsFor: 'API-events' stamp: 'emm 02/09/2012 23:54'!
whenStopped: aTimeSensor start: otherTimeSensor
	"The easiest way to have one TimeSensor start when another has stopped is to write a little
	 Script that sends the second TimeSensor a startTime event when it receives an isActive
	 FALSE event from the first TimeSensor, like this: "

	| script |
	script := self newScript
		declare: 'isActive' as: 'eventIn SFBool'
		;declare: 'startTime_changed' as: 'eventOut SFTime'
		; source: '
function isActive(value,timestamp){
	if(value == false) startTime_changed=timestamp;
}'.
	self add: script.
	self route: #isActive of: aTimeSensor to: #isActive of: script.
	self route: #startTime_changed of: script to: #set_startTime of: otherTimeSensor.! !

!VRMLSceneBuilder methodsFor: 'API-events' stamp: 'emm 02/09/2012 23:54'!
whenTouching: aTouchSensor choose: anInteger in: aSwitch

	| newScript  |
	self add: ( newScript := self newScriptForChoice: anInteger ).
	self route: #touchTime of: aTouchSensor to: #touchTime of: newScript.
	self route: #whichChoice of: newScript to: #whichChoice of: aSwitch.! !

!VRMLSceneBuilder methodsFor: 'API-events' stamp: 'emm 02/09/2012 23:54'!
whenTouching: touchS
	rotate: otherElement 
	along: aPoint3Collection 
	axis: axisPoint
	within: seconds

	"Pre: @anElement has been added, @otherElement has not"

	| transE  timeS rotI |
	^self group:[
	self add: ( transE := self newTransformOn: otherElement ensureNamed).
	self add: ( rotI := self newRotationInterpolatorFrom: aPoint3Collection axis: axisPoint).
	self add: ( timeS := self newTimeSensor cycleInterval: seconds ).
	self whenTouching: touchS start: timeS.
	self whenFractionChanging: timeS rotate: transE using: rotI.
	]
	
	
	! !

!VRMLSceneBuilder methodsFor: 'API-events' stamp: 'emm 02/09/2012 23:54'!
whenTouching: aTouchSensor send: anEvent to: aScript

	self route: #touchTime of: aTouchSensor to: anEvent of: aScript.! !

!VRMLSceneBuilder methodsFor: 'API-events' stamp: 'emm 02/09/2012 23:54'!
whenTouching: aTouchSensor send: anEvent with: aValue to: anElement

	"Convertion of @aValue to a string is not correct for points. Needs attention"

	| assignScript |
	assignScript := self add: ( self newScript ).
	assignScript declare: #receiver as: 'field SFNode' value: 'USE ' , anElement name.
	assignScript declare: #touchTime as: 'eventIn SFTime'.
	assignScript source: '
	function touchTime(value,time) {
		receiver.' , anEvent , ' = ' , aValue printString , ';
	}'.
	self whenTouching: aTouchSensor send: #touchTime to: assignScript.! !

!VRMLSceneBuilder methodsFor: 'API-events' stamp: 'emm 02/09/2012 23:54'!
whenTouching: aTouchSensor start: aTimeSensor 

	self 
		route: #touchTime 
		of: aTouchSensor 
		to: #startTime 
		of: aTimeSensor.! !

!VRMLSceneBuilder methodsFor: 'API-events' stamp: 'emm 02/09/2012 23:54'!
whenTouching: aTouchSensor stop: aTimeSensor 

	self 
		route: #touchTime 
		of: aTouchSensor 
		to: #stopTime 
		of: aTimeSensor.! !

!VRMLSceneBuilder methodsFor: 'API-events' stamp: 'emm 04/09/2012 21:52'!
whenTouching: aTouchSensor switchBetween: aCollection 
	
	| newSwitch newScript |
	self beginGroup.
	newSwitch := self beginSwitch.
	aCollection addTo: self.
	self endSwitch.
	self add: ( ( newScript := self newScript ) 
		  at: 'eventIn SFTime' put: #touchTime 
		; at: 'eventOut SFInt32' put: #whichChoice
		; at: 'url' 	put: (( 'javascript:
	  function initialize() {
		whichChoice = 0;
	  }
	  function touchTime( value, time) {
		if ( whichChoice == %1 ) whichChoice = 0;
		else ++whichChoice;
	  }' ) bindWith: ( aCollection size - 1 ) printString )
		; yourself).
	self 
		route: #touchTime 
		of: aTouchSensor 
		to: #touchTime 
		of: newScript.
	self 
		route: #whichChoice 
		of: newScript 
		to: #whichChoice 
		of: newSwitch.
	^self add: self endGroup.
! !

!VRMLSceneBuilder methodsFor: 'writing ( ISceneBuilder )' stamp: 'emm 02/09/2012 23:54'!
writeSceneUsing: aWriter
	
	| writer |
	self elements isEmpty 
		ifTrue: [ ^self ].
	self navigationInfo hasProperties
		ifTrue: [ self add: self navigationInfo].
	self elements 
		do: [ :each | each kindDo: aWriter ] 
		separatedBy: [ aWriter cr ].
	aWriter cr.
	self routes 
		do: [ :each | each kindDo: aWriter] 
		separatedBy: [ aWriter cr ].! !

!SceneBuilder class methodsFor: '*Zenna-FormatDirectX' stamp: 'emm 02/09/2012 23:05'!
d3d

	^D3DMeshBuilder new! !

!SceneBuilder class methodsFor: '*Zenna-FormatM3D' stamp: 'emm 02/09/2012 23:56'!
m3d

	^M3DSceneBuilder new! !

!SceneBuilder class methodsFor: '*Zenna-FormatMaxScript' stamp: 'emm 02/09/2012 23:07'!
max

	^MaxSceneBuilder new! !

!SceneBuilder class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:04'!
new

	"Answer a new instance of the receiver and initialize it"

	^super new initialize! !

!SceneBuilder class methodsFor: '*Zenna-FormatPOVRay' stamp: 'emm 02/09/2012 23:55'!
povray

	^POVRaySceneBuilder new! !

!SceneBuilder class methodsFor: '*zenna-formatthreejs' stamp: 'emm 9/29/2012 19:43'!
threeJS
	^ThreeJSSceneBuilder new! !

!SceneBuilder class methodsFor: '*Zenna-FormatVRML' stamp: 'emm 02/09/2012 23:54'!
vrml

	^VRMLSceneBuilder new! !

!SceneBuilder methodsFor: 'API-building' stamp: 'emm 02/09/2012 23:04'!
add: anObject 
	
	"Dispatch the request to @anObject"

	^anObject addTo: self! !

!SceneBuilder methodsFor: 'API-building' stamp: 'emm 02/09/2012 23:04'!
addAll: aCollection

	"Handle the addition of @aCollection"

	aCollection do: [ :each | self add: each ].
	^ aCollection! !

!SceneBuilder methodsFor: 'private' stamp: 'emm 02/09/2012 23:04'!
addBoundingBox: aBoundingBox
	
	"This represent an invisible object"! !

!SceneBuilder methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:04'!
addElement: anElement
	
	"If there is a group on the stack, then add @anElement to that
	group. Otherwise add @anElement to the receiver's elements.
	Answer the argument"

	"Check error conditon"
	anElement == self ifTrue: [self error: 'dispatch error'].
	anElement == nil ifTrue: [^self].
	^self stack isEmpty
		ifTrue: [ self elements add: anElement ]
		ifFalse:[ self top add: anElement ]! !

!SceneBuilder methodsFor: 'API-building' stamp: 'emm 02/09/2012 23:04'!
addFirst: anObject

	| element |
	self add: anObject.
	element := stack isEmpty
		ifTrue: [ self elements removeLast ]
		ifFalse: [ self top elements removeLast "assume it is a composite"].
	self elements addFirst: element.
	^anObject! !

!SceneBuilder methodsFor: 'private' stamp: 'emm 02/09/2012 23:04'!
addObject: anObject

	| elementOrNil |
	elementOrNil := self newElementOrNilFrom: anObject.
	"The receiver may choose to ignore this object as an element"
	elementOrNil == nil
		ifTrue: [ ^anObject ].
	^ elementOrNil isSequenceable
		ifTrue: [elementOrNil do:[ :each | self addElement: each ]. elementOrNil]
		ifFalse: [self addElement: elementOrNil]! !

!SceneBuilder methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:04'!
allElementsDo: aBlock

	self elements do:[ :each | self allElementsOf: each do: aBlock visited: Set new ]! !

!SceneBuilder methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:04'!
allElementsOf: anElement do: aBlock visited: aSet 
	
	anElement allElementsDo: [ :each | 
		( aSet includes: each ) 
			ifFalse:
				[ aSet add: each.
				aBlock value: each.
				self 
					allElementsOf: each 
					do: aBlock
					visited: aSet ] ]! !

!SceneBuilder methodsFor: '*Zenna-FormatVRML' stamp: 'emm 02/09/2012 23:54'!
appearance
	"ignoreForNow"

	^self newAppearance! !

!SceneBuilder methodsFor: '*Zenna-FormatVRML' stamp: 'emm 02/09/2012 23:54'!
appearance: ignoreForNow! !

!SceneBuilder methodsFor: 'private' stamp: 'emm 02/09/2012 23:04'!
approximate: anObject

	"First create an approximation for @anObject.
	Then redispatch the result to compose the element"	

	^(anObject kindDo: self approximator) kindDo: self! !

!SceneBuilder methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:04'!
approximator

	"Answer the value of approximator"

	^approximator! !

!SceneBuilder methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:04'!
approximator: aValue

	"Set the value of approximator"

	approximator := aValue! !

!SceneBuilder methodsFor: 'API-building' stamp: 'emm 02/09/2012 23:04'!
beginGroup

	"Create a element group. Each element added to the receiver
	will be added to this group until >>endGroup has been send.
	Answer the group"

	^ self push: self newGroup! !

!SceneBuilder methodsFor: '*Zenna-FormatVRML' stamp: 'emm 02/09/2012 23:54'!
beginLOD
	^self beginGroup! !

!SceneBuilder methodsFor: '*Zenna-FormatVRML' stamp: 'emm 02/09/2012 23:54'!
beginTransform
	^self beginGroup! !

!SceneBuilder methodsFor: 'API-appearance' stamp: 'emm 02/09/2012 23:04'!
color: aColor
	self subclassResponsibility! !

!SceneBuilder methodsFor: 'writing' stamp: 'emm 02/09/2012 23:04'!
defaultWriterClass

	^self subclassResponsibility! !

!SceneBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:04'!
doBlock: aBlock

	"Evaluate @aBlock and dispatch to its result"

	^ aBlock value kindDo: self! !

!SceneBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:04'!
doColorWrapper: aWrapper

	| oldAppearance  result|
	oldAppearance := self appearance.
	self color: aWrapper color.
	result := aWrapper component kindDo: self.
	self appearance: oldAppearance.
	^result! !

!SceneBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:04'!
doComposite: aComposite

	aComposite do:[ :each | self add: each ].
	^nil! !

!SceneBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:04'!
doFaceComposite: aComposite

	aComposite facesDo:[ :each | self add: each].
	^nil! !

!SceneBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:04'!
doGenericSceneElement: anElement

	"On default return the argument"
	
	^anElement! !

!SceneBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:04'!
doNamingWrapper: aWrapper

	| element |
	element := aWrapper component kindDo: self.
	element name: aWrapper name.
	^element! !

!SceneBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:04'!
doNoElement: aNoElement

	"Do nothing, its not an element"

	^nil! !

!SceneBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:04'!
doSequenceableCollection: aCollection
	
	| elementOrNil |
	aCollection do:[ :each | 
		elementOrNil := each kindDo: self.
		elementOrNil notNil
			ifTrue: [self addElement: elementOrNil]].
	^nil! !

!SceneBuilder methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:04'!
doUndefinedObject: aNil

	^aNil! !

!SceneBuilder methodsFor: 'API-factory' stamp: 'emm 02/09/2012 23:04'!
elementClasss
	^GenericSceneElement! !

!SceneBuilder methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:04'!
elements

	"Answer the value of elements"

	^elements! !

!SceneBuilder methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:04'!
elements: aValue

	"Set the value of elements"

	elements := aValue! !

!SceneBuilder methodsFor: 'API-building' stamp: 'emm 02/09/2012 23:04'!
endGroup

	"Complete the current element group
	but do NOT add this group to the elements.
	Answer the group. See >>beginGroup"

	^self pop! !

!SceneBuilder methodsFor: '*Zenna-FormatVRML' stamp: 'emm 02/09/2012 23:54'!
endLOD
	^self endGroup! !

!SceneBuilder methodsFor: '*Zenna-FormatVRML' stamp: 'emm 02/09/2012 23:54'!
endTransform
	^self endGroup! !

!SceneBuilder methodsFor: 'API-building' stamp: 'emm 02/09/2012 23:04'!
group: oneArgBlock
	
	self beginGroup.
	oneArgBlock value.
	^self add: self endGroup! !

!SceneBuilder methodsFor: 'writing' stamp: 'emm 02/09/2012 23:04'!
indexPartOfNameSize

	^3! !

!SceneBuilder methodsFor: 'initialize-release' stamp: 'emm 02/09/2012 23:04'!
initialize

	stack := OrderedCollection new.
	elements := OrderedCollection new.
	approximator := self approximatorClass new.
	scale := 1.
	colorIndex := 0.! !

!SceneBuilder methodsFor: '*Zenna-FormatM3D' stamp: 'emm 02/09/2012 23:56'!
isM3D
	^false! !

!SceneBuilder methodsFor: '*Zenna-FormatPOVRay' stamp: 'emm 02/09/2012 23:55'!
isPOVRay

	^false! !

!SceneBuilder methodsFor: '*Zenna-FormatVRML' stamp: 'emm 02/09/2012 23:54'!
isVRML
	^false! !

!SceneBuilder methodsFor: 'API-building' stamp: 'emm 02/09/2012 23:04'!
linesFromString: aString

	"self new linesFromString: 'Help
me
today'
	"
	| lines outStream inStream ch |
	lines := OrderedCollection new.
	outStream := WriteStream on: ''.
	inStream := ReadStream on: aString.
	[inStream atEnd]
		whileFalse:
			[ ch := inStream next.
			ch asInteger = 13	"CR"
				ifTrue: 
					[ lines add: outStream contents.
					outStream reset.
					inStream next]
				ifFalse:
					[ ch asInteger = 9	"TAB -> 3 spaces"
						ifTrue: [ outStream nextPutAll: '   ' ]
						ifFalse: [ outStream nextPut: ch ]]].
	lines add: outStream contents.
	^lines
	! !

!SceneBuilder methodsFor: '*Zenna-FormatVRML' stamp: 'emm 02/09/2012 23:54'!
newAppearance
"
Appearance { 
  exposedField SFNode material          NULL
  exposedField SFNode texture           NULL
  exposedField SFNode textureTransform  NULL
}
"
	"Always initialize the element's name. Most likely it will be shared"

	^( GenericSceneElement new className: 'Appearance' ) initializeName! !

!SceneBuilder methodsFor: '*Zenna-FormatVRML' stamp: 'emm 02/09/2012 23:54'!
newBackground

	^NoElement new! !

!SceneBuilder methodsFor: '*Zenna-Animation3D' stamp: 'emm 02/09/2012 23:29'!
newColorInterpolator

	^KeyedValueInterpolator new! !

!SceneBuilder methodsFor: '*Zenna-Animation3D' stamp: 'emm 02/09/2012 23:29'!
newColorInterpolatorFrom: aCollection

	| pi |
	pi := self newColorInterpolator.
	pi key: ( 0 to: 1 by: (1 / ( aCollection size - 1 ))).
	pi keyValue: (OrderedPoint3DCollection withAll: ( aCollection collect:[ :each | each asPoint3D ] )).
	^pi
! !

!SceneBuilder methodsFor: '*Zenna-FormatVRML' stamp: 'emm 02/09/2012 23:54'!
newDirectionalLight

	^NoElement new! !

!SceneBuilder methodsFor: 'factory' stamp: 'emm 02/09/2012 23:04'!
newElementFrom: aGeometric3D

	"Backward compatibility"
	
	^self newElementOrNilFrom: aGeometric3D! !

!SceneBuilder methodsFor: 'API-factory' stamp: 'emm 02/09/2012 23:04'!
newElementGroupWithClassName: aString
	^SceneElementGroup new className: aString! !

!SceneBuilder methodsFor: 'factory' stamp: 'emm 02/09/2012 23:04'!
newElementOrNilFrom: anObject
	
	"Let the receiver build a new element by dispatching the request to the argument.
	Answer the result"

	^anObject kindDo: self! !

!SceneBuilder methodsFor: 'API-factory' stamp: 'emm 02/09/2012 23:04'!
newElementWithClassName: aString
	^self elementClasss new className: aString! !

!SceneBuilder methodsFor: 'API-building' stamp: 'emm 02/09/2012 23:04'!
newGroup

	^OrderedCollection new! !

!SceneBuilder methodsFor: '*Zenna-FormatVRML' stamp: 'emm 02/09/2012 23:54'!
newMaterial

	^( GenericSceneElement new className: 'Material' ) initializeName! !

!SceneBuilder methodsFor: '*Zenna-Animation3D' stamp: 'emm 02/09/2012 23:29'!
newOrientationInterpolator

	^KeyedValueInterpolator new! !

!SceneBuilder methodsFor: '*Zenna-Animation3D' stamp: 'emm 02/09/2012 23:29'!
newOrientationInterpolatorFrom: aCollection axis: axisPoint

	| oi howMany |
	oi := self newOrientationInterpolator.
	howMany := aCollection size.
	howMany = 1
		ifTrue: 
			[ oi key: #(0 1).
			oi keyValue: (Array with: axisPoint @ aCollection first with: axisPoint @ aCollection first) ]
		ifFalse: 
			[ oi key: ( 0 to: 1 by: (1 / ( howMany - 1 ))).
			oi keyValue: ( aCollection collect:[ :e | axisPoint @ e ] ) ].
	^oi! !

!SceneBuilder methodsFor: '*Zenna-Animation3D' stamp: 'emm 02/09/2012 23:29'!
newPositionInterpolator

	^KeyedValueInterpolator new! !

!SceneBuilder methodsFor: '*Zenna-Animation3D' stamp: 'emm 02/09/2012 23:29'!
newPositionInterpolatorFrom: aCollection

	| pi |
	pi := self newPositionInterpolator.
	pi key: ( 0 to: 1 by: (1 / ( aCollection size - 1 ))).
	pi keyValue: aCollection.
	^pi! !

!SceneBuilder methodsFor: '*Zenna-Animation3D' stamp: 'emm 02/09/2012 23:29'!
newRotationInterpolatorFrom: aCollection axis: axisPoint

	^self newOrientationInterpolatorFrom: aCollection axis: axisPoint! !

!SceneBuilder methodsFor: '*Zenna-Animation3D' stamp: 'emm 02/09/2012 23:29'!
newScalarInterpolator

	^KeyedValueInterpolator new! !

!SceneBuilder methodsFor: '*Zenna-Animation3D' stamp: 'emm 02/09/2012 23:29'!
newScalarInterpolatorFrom: aCollection

	| si |
	si := self newScalarInterpolator.
	si key: ( 0 to: 1 by: (1 / ( aCollection size - 1 ))).
	si keyValue: aCollection.
	^si
! !

!SceneBuilder methodsFor: '*Zenna-Animation3D' stamp: 'emm 02/09/2012 23:29'!
newScheduler

	^AnimationTaskScheduler new! !

!SceneBuilder methodsFor: '*Zenna-FormatVRML' stamp: 'emm 02/09/2012 23:54'!
newTextureTransform

	^NoElement new! !

!SceneBuilder methodsFor: '*Zenna-Animation3D' stamp: 'emm 02/09/2012 23:29'!
newTimeSensor

	^TimeSensor new! !

!SceneBuilder methodsFor: '*Zenna-FormatVRML' stamp: 'emm 02/09/2012 23:54'!
newTransformOn: anObject

	^TransformingElementWrapper on: anObject! !

!SceneBuilder methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:04'!
orientationFromPoint: aPoint3D

	^aPoint3D normalized @ aPoint3D r! !

!SceneBuilder methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:04'!
pop
	^stack removeLast! !

!SceneBuilder methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:04'!
push: anObject
	^stack add: anObject! !

!SceneBuilder methodsFor: '*Zenna-Animation3D' stamp: 'emm 02/09/2012 23:29'!
route: aProp1 of: anElement1 to: aProp2 of: anElement2 
	
	| route |
	route := SceneEventRoute new.
	route eventOut: aProp1.
	route receiver: ( anElement2 receiverForEventIn: aProp2 ).
	route selector: ( anElement2 selectorForEventIn: aProp2 ).
	anElement1 addDependent: route! !

!SceneBuilder methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:04'!
scale

	"Answer the value of scale"

	^scale! !

!SceneBuilder methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:04'!
scale: aValue

	"Set the value of scale"

	scale := aValue! !

!SceneBuilder methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:04'!
stack

	"Answer the value of stack"

	^stack! !

!SceneBuilder methodsFor: 'API-appearance' stamp: 'emm 02/09/2012 23:04'!
texture: aString

	"Apply a texture identified by @aString. Can be a filename or url or some id"

	self texture: aString color: (Color modulo16At: (colorIndex := colorIndex + 1))! !

!SceneBuilder methodsFor: 'API-appearance' stamp: 'emm 02/09/2012 23:04'!
texture: aResourceName color: aColor

	^self color: aColor! !

!SceneBuilder methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:04'!
top
	^stack last! !

!SceneBuilder methodsFor: 'API-building' stamp: 'emm 02/09/2012 23:04'!
transform: oneArgBlock
	
	self beginTransform.
	oneArgBlock value.
	^self add:  self endTransform! !

!SceneBuilder methodsFor: '*Zenna-Animation3D' stamp: 'emm 02/09/2012 23:29'!
whenFractionChanging: aTimeSensor diffuse: aMaterial using: aColorInterpolator
	
	self 
		route: #value_changed 
		of: aColorInterpolator
		to: #set_diffuseColor 
		of: aMaterial.
	self 
		route: #fraction_changed 
		of: aTimeSensor 
		to: #set_fraction 
		of: aColorInterpolator! !

!SceneBuilder methodsFor: '*Zenna-Animation3D' stamp: 'emm 02/09/2012 23:29'!
whenFractionChanging: aTimeSensor rotate: aTransform using: aOrientationInterpolator
	
	self 
		route: #value_changed 
		of: aOrientationInterpolator 
		to: #rotation
		of: aTransform.
	self 
		route: #fraction_changed 
		of: aTimeSensor 
		to: #set_fraction 
		of: aOrientationInterpolator! !

!SceneBuilder methodsFor: '*Zenna-Animation3D' stamp: 'emm 02/09/2012 23:29'!
whenFractionChanging: aTimeSensor scale: aTransform using: aPositionInterpolator
	
	self 
		route: #value_changed 
		of: aPositionInterpolator 
		to: #scale 
		of: aTransform.
	self 
		route: #fraction_changed 
		of: aTimeSensor 
		to: #set_fraction 
		of: aPositionInterpolator! !

!SceneBuilder methodsFor: '*Zenna-Animation3D' stamp: 'emm 02/09/2012 23:29'!
whenFractionChanging: aTimeSensor send: anAspect to: aNode using: aScalarInterpolator
	
	self 
		route: #value_changed 
		of: aScalarInterpolator 
		to: anAspect 
		of: aNode.
	self 
		route: #fraction_changed 
		of: aTimeSensor 
		to: #set_fraction 
		of: aScalarInterpolator! !

!SceneBuilder methodsFor: '*Zenna-Animation3D' stamp: 'emm 02/09/2012 23:29'!
whenFractionChanging: aTimeSensor translate: aTransform using: aPositionInterpolator
	
	self 
		route: #value_changed 
		of: aPositionInterpolator 
		to: #translation 
		of: aTransform.
	self 
		route: #fraction_changed 
		of: aTimeSensor 
		to: #set_fraction 
		of: aPositionInterpolator! !

!SceneBuilder methodsFor: 'writing' stamp: 'emm 02/09/2012 23:04'!
writeSceneUsing: aWriter
	self subclassResponsibility! !

!SceneBuilder methodsFor: 'API-writing' stamp: 'emm 02/09/2012 23:04'!
writeToFile: aString 
	
	self 
		writeToFile: aString 
		index: nil 
		useIndentation: false 
		! !

!SceneBuilder methodsFor: 'API-writing' stamp: 'emm 02/09/2012 23:04'!
writeToFile: aString index: index 
	
	self 
		writeToFile: aString 
		index: index 
		useIndentation: true! !

!SceneBuilder methodsFor: 'writing' stamp: 'emm 10/18/2012 19:38'!
writeToFile: aString index: indexOrNil padTo: indexPartOfNameSize useIndentation: aBoolean

	"If @aString does not contain an absolute pathname
	(by detecting a colon) then use the working directory"

	| destination exIndex |
	destination := aString.
	indexOrNil isNil
		ifFalse:
			[ destination := destination , 
				( indexOrNil printStringRadix: 10 padTo: indexPartOfNameSize ) ].
	exIndex := destination 
		indexOfSubCollection: self defaultWriterClass fileExtension
		startingAt: (destination size - self defaultWriterClass fileExtension size - 1 max: 1).
	exIndex = 0
		ifTrue: [destination := destination , self defaultWriterClass fileExtension].
	((aString includes: $:) or:[aString first = $/])
		ifFalse:
			[ destination := self defaultWriterClass workingDirectoryName , 
				OSFilename separatorString , destination ].
	self writeToFullFile: destination useIndentation: aBoolean! !

!SceneBuilder methodsFor: 'writing' stamp: 'emm 02/09/2012 23:04'!
writeToFile: aString index: indexOrNil useIndentation: aBoolean 
	
	self 
		writeToFile: aString 
		index: indexOrNil 
		padTo: self indexPartOfNameSize 
		useIndentation: aBoolean! !

!SceneBuilder methodsFor: 'API-writing' stamp: 'emm 10/7/2012 19:57'!
writeToFile: aFilename useIndentation: aBoolean 
	
	^self writeToFile: aFilename index: nil useIndentation: aBoolean ! !

!SceneBuilder methodsFor: 'API-writing' stamp: 'emm 10/7/2012 19:57'!
writeToFullFile: absoluteFilename useIndentation: aBoolean 
	
	| writer outStream|
	GenericSceneElement resetID. 
	[outStream := absoluteFilename asFilename writeStream.
	writer := (self defaultWriterClass on: outStream) useIndentation: aBoolean.
	writer writeSignature.
	writer fileName: outStream fullName.
	writer preWriteScene.
	self writeSceneUsing: writer.
	writer postWriteScene.
	] ensure:[outStream close]! !

Object subclass: #SceneElement
	instanceVariableNames: 'name'
	classVariableNames: 'LastID'
	poolDictionaries: ''
	category: 'Zenna-SceneBuilding2D'!

SceneElement subclass: #GenericSceneElement
	instanceVariableNames: 'className properties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-SceneBuilding2D'!

!GenericSceneElement methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:02'!
addTo: aBuilder

	^ aBuilder addElement: self! !

!GenericSceneElement methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:02'!
allElementsDo: oneArgBlock

	oneArgBlock value: self.! !

!GenericSceneElement methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:02'!
allElementsDo: aBlock visited: aSet 
	
	self allElementsDo: [ :each | 
		( aSet includes: each ) 
			ifFalse:
				[ aSet add: each.
				aBlock value: each.
				each 
					allElementsDo: aBlock
					visited: aSet ] ]! !

!GenericSceneElement methodsFor: '*Zenna-FormatVRML' stamp: 'emm 02/09/2012 23:54'!
asVRMLTransform

	^self className = 'Transform'
			ifTrue: [ self ]
			ifFalse: 
				[ | newTransform |
				newTransform := VRMLComposite new.
				newTransform className: 'Transform'.
				newTransform add: self.
				newTransform ]! !

!GenericSceneElement methodsFor: 'property-accessing' stamp: 'emm 02/09/2012 23:02'!
at: key

	"Answer the value of property @key or answer nil if unspecified"
	
	^self properties at: key! !

!GenericSceneElement methodsFor: 'property-accessing' stamp: 'emm 02/09/2012 23:02'!
at: key ifAbsent: missingBlock

	"Answer the value of property @key or answer nil if unspecified"
	
	properties isNil
		ifTrue: [ ^missingBlock value ].
	^self properties at: key ifAbsent: missingBlock! !

!GenericSceneElement methodsFor: 'property-accessing' stamp: 'emm 02/09/2012 23:02'!
at: key put: value 
	
	value isNil 
		ifTrue: 
			[ ( self properties includesKey: key ) 
				ifTrue: [ self properties removeKey: key ].
			^self ].
	^self properties at: key put: value! !

!GenericSceneElement methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:02'!
className

	"Answer the value of className"

	^className! !

!GenericSceneElement methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:02'!
className: aValue

	"Set the value of className"

	className := aValue! !

!GenericSceneElement methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:02'!
doesNotRespondTo: aSymbol withArguments: anArray
	
	 ( aSymbol occurrencesOf: $: ) ~= 1
		ifTrue:
			[ ( self properties includesKey: aSymbol asString )
				ifTrue:[ ^self at: aSymbol asString ]
				ifFalse:[ super doesNotRespondTo: aSymbol withArguments: anArray ]]
		ifFalse:
			[ self at: ( aSymbol copyWithout: $: ) put: anArray first ]! !

!GenericSceneElement methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:02'!
doesNotUnderstand: aMessage 
	
	 ( aMessage selector occurrencesOf: $: ) ~= 1
		ifTrue:
			[ ( self properties includesKey: aMessage selector asString )
				ifTrue:[ ^self at: aMessage selector asString ]
				ifFalse:[ super doesNotUnderstand: aMessage ] ]
		ifFalse:
			[ self at: ( aMessage selector copyWithout: $: ) put: aMessage arguments first ]! !

!GenericSceneElement methodsFor: 'testing' stamp: 'emm 02/09/2012 23:02'!
hasElements

	^false! !

!GenericSceneElement methodsFor: 'testing' stamp: 'emm 02/09/2012 23:02'!
hasProperties

	^properties notNil and:[ properties notEmpty ]! !

!GenericSceneElement methodsFor: 'testing' stamp: 'emm 02/09/2012 23:02'!
hasProperty: aName

	^properties notNil and:[ properties includesKey: aName]! !

!GenericSceneElement methodsFor: 'property-accessing' stamp: 'emm 02/09/2012 23:02'!
keysAndValuesDo: twoArgBlock

	properties isNil
		ifTrue: [ ^self ].
	self properties keysAndValuesDo: twoArgBlock
! !

!GenericSceneElement methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:02'!
kindDo: aRequestor 

	^ aRequestor doGenericSceneElement: self! !

!GenericSceneElement methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:02'!
leafElement

	^self! !

!GenericSceneElement methodsFor: 'accessing' stamp: 'emm 9/29/2012 17:33'!
messages

	| mgs |
	properties isNil
		ifTrue: [ ^#() ].
	mgs := OrderedCollection new.
	self properties keysAndValuesDo:[ :k :v |
		mgs add: ( MessageSend new selector: k ;arguments: (Array with: v ) ) ].
	^mgs! !

!GenericSceneElement methodsFor: 'copying' stamp: 'emm 02/09/2012 23:02'!
postCopy

	super postCopy.
	properties := properties copy.! !

!GenericSceneElement methodsFor: 'printing' stamp: 'emm 02/09/2012 23:02'!
printOn: aStream

	self printOn: aStream indent: 0! !

!GenericSceneElement methodsFor: 'printing' stamp: 'emm 02/09/2012 23:02'!
printOn: aStream indent: level

	| cascade |
	aStream nextPut: $(.
	aStream nextPutAll: self class name.
	aStream nextPutAll: ' new className: '.
	self className printOn: aStream.
	aStream nextPut: $).
	self hasName 
		ifTrue: 
			[aStream
				nextPutAll: 'name:';
				nextPutAll: self name.
			cascade := true]
		ifFalse: 
			[cascade := false].
	self properties keysAndValuesDo: 
			[:k :v | 
			aStream cr.
			level + 1 timesRepeat: [aStream tab].
			cascade ifTrue: [aStream nextPut: $;] ifFalse: [cascade := true].
			aStream
				nextPutAll: k;
				nextPut: $:.
			v printOn: aStream indent: level + 1].! !

!GenericSceneElement methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:02'!
properties

	^properties isNil
		ifTrue: [ properties := Dictionary new ]
		ifFalse: [ properties ]! !

!GenericSceneElement methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:02'!
propertyValuesDo: aBlock
	^self properties do: aBlock! !

!GenericSceneElement methodsFor: '*Zenna-FormatVRML' stamp: 'emm 02/09/2012 23:54'!
scaleBy: aPoint3D

	| oldScale |
	oldScale := self at: 'scale' ifAbsent:[0@0@0].
	self at: 'scale' put: oldScale + aPoint3D! !

!GenericSceneElement methodsFor: 'messages' stamp: 'emm 02/09/2012 23:02'!
send: aFunctionName with: anArgument
	"Adaptor, order is lost"

	self at: aFunctionName put: anArgument! !

!GenericSceneElement methodsFor: 'messages' stamp: 'emm 02/09/2012 23:02'!
send: aFunctionName withArguments: anArgumentArray
	"Adaptor, order is lost"

	self at: aFunctionName put: anArgumentArray! !

!GenericSceneElement methodsFor: 'VRML' stamp: 'emm 02/09/2012 23:02'!
size

	^self at: 'size'! !

!GenericSceneElement methodsFor: '*Zenna-FormatVRML' stamp: 'emm 02/09/2012 23:54'!
translateBy: aPoint3D

	| oldTranslation |
	oldTranslation := self at: 'translation' ifAbsent:[0@0@0].
	self at: 'translation' put: oldTranslation + aPoint3D! !

GenericSceneElement subclass: #MaxModifier
	instanceVariableNames: 'keySymbol'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-FormatMaxScript'!

!MaxModifier methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:55'!
keySymbol
	^keySymbol ifNil:[self className asSymbol]! !

!MaxModifier methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:55'!
keySymbol: anObject
	keySymbol := anObject! !

!MaxModifier methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:55'!
kindDo: aRequestor
	^aRequestor doMaxModifier: self! !

GenericSceneElement subclass: #MaxObject
	instanceVariableNames: 'modifiers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-FormatMaxScript'!

!MaxObject methodsFor: 'initialize-release' stamp: 'emm 02/09/2012 23:55'!
addModifier: aModifier
	modifiers isNil
		ifTrue: [modifiers := OrderedCollection new].
	modifiers add: aModifier.! !

!MaxObject methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:55'!
kindDo: aRequestor
	^aRequestor doMaxObject: self! !

!MaxObject methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:55'!
modifierAt: aSymbol ifNone: absentBlock
	^self modifiers detect:[ :each | each className = aSymbol ] ifNone: absentBlock! !

!MaxObject methodsFor: 'initialize-release' stamp: 'emm 02/09/2012 23:55'!
modifiers	
	^modifiers ifNil:[#()]! !

!MaxObject methodsFor: 'printing' stamp: 'emm 02/09/2012 23:55'!
printOn: aStream indent: level 

	super printOn: aStream indent: level.
	self modifiers do: [ :each | 
		each printOn: aStream indent: level + 1.
		aStream cr.
		level + 1 timesRepeat: [aStream tab]]! !

!MaxObject methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:55'!
translation: aPoint
	aPoint isZero ifFalse: [super translation: aPoint]! !

GenericSceneElement subclass: #NoElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-SceneBuilding2D'!

!NoElement methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:04'!
kindDo: aRequestor

	^aRequestor doNoElement: self! !

GenericSceneElement subclass: #SceneElementGroup
	instanceVariableNames: 'elements'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-SceneBuilding2D'!

SceneElementGroup subclass: #POVElement
	instanceVariableNames: 'constructorParameters modifiers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-FormatPOVRay'!

!POVElement methodsFor: 'adding' stamp: 'emm 02/09/2012 23:55'!
addConstructorParameter: anObject
	constructorParameters isNil ifTrue: [constructorParameters := OrderedCollection new].
	self constructorParameters add: anObject! !

!POVElement methodsFor: 'adding' stamp: 'emm 02/09/2012 23:55'!
addModifier: anObject
	modifiers isNil ifTrue: [modifiers := OrderedCollection new].
	self modifiers add: anObject! !

!POVElement methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:55'!
constructorParameters
	^constructorParameters ifNil:[#()]! !

!POVElement methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:55'!
constructorParameters: anObject
	constructorParameters := anObject! !

!POVElement methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:55'!
kindDo: aRequestor
	^aRequestor doPOVElement: self! !

!POVElement methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:55'!
modifiers
	^modifiers ifNil:[#()]! !

!POVElement methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:55'!
modifiers: anObject
	modifiers := anObject! !

!POVElement methodsFor: 'printing' stamp: 'emm 02/09/2012 23:55'!
printOn: aStream
	self kindDo: (POVWriter on: aStream)! !

!SceneElementGroup methodsFor: 'elements-accessing' stamp: 'emm 02/09/2012 23:04'!
add: anElement

	^ self initializedElements add: anElement! !

!SceneElementGroup methodsFor: 'elements-accessing' stamp: 'emm 02/09/2012 23:04'!
addAll: aCollection
	
	^ self initializedElements addAll: aCollection! !

!SceneElementGroup methodsFor: 'elements-accessing' stamp: 'emm 02/09/2012 23:04'!
addFirst: anElement

	^ self initializedElements addFirst: anElement! !

!SceneElementGroup methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:04'!
allElementsDo: oneArgBlock

	super allElementsDo: oneArgBlock.
	self hasElements
		ifTrue: [ self elements do:[ :each | each allElementsDo: oneArgBlock] ]! !

!SceneElementGroup methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:04'!
elements

	"Answer the value of elements"

	^elements ifNil:[#()]! !

!SceneElementGroup methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:04'!
elements: aValue

	"Set the value of elements"

	elements := aValue! !

!SceneElementGroup methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:04'!
elementsDo: oneArgBlock separatedBy: zeroArgBlock

	self hasElements
		ifTrue: [ self elements do: oneArgBlock separatedBy: zeroArgBlock]! !

!SceneElementGroup methodsFor: 'testing' stamp: 'emm 02/09/2012 23:04'!
hasElements

	^self elements notEmpty! !

!SceneElementGroup methodsFor: 'private' stamp: 'emm 02/09/2012 23:04'!
initializedElements

	^elements isNil
		ifTrue:[ elements := OrderedCollection new ]
		ifFalse:[ elements ]! !

!SceneElementGroup methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:04'!
leafElement

	"Assume only one element"

	^self elements first leafElement! !

!SceneElementGroup methodsFor: 'transforming' stamp: 'emm 02/09/2012 23:04'!
mirrorInYZ

	elements := elements collect:[:each | each mirrorInYZ ]! !

!SceneElementGroup methodsFor: 'copying' stamp: 'emm 02/09/2012 23:04'!
postCopy

	super postCopy.
	elements := elements copy.! !

!SceneElementGroup methodsFor: 'printing' stamp: 'emm 02/09/2012 23:04'!
printOn: aStream indent: level

	super printOn: aStream indent: level.
	self hasElements 
		ifTrue: 
			[self elements do: 
					[:each | 
					aStream cr.
					level + 1 timesRepeat: [aStream tab].
					each printOn: aStream indent: level + 1]].! !

SceneElementGroup subclass: #VRMLComposite
	instanceVariableNames: 'childrenFieldName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-FormatVRML'!

!VRMLComposite methodsFor: 'transform' stamp: 'emm 02/09/2012 23:54'!
asVRMLTransform
	^self! !

!VRMLComposite methodsFor: 'overriding' stamp: 'emm 02/09/2012 23:54'!
children
	
	^super elements! !

!VRMLComposite methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:54'!
childrenFieldName

	"Answer the value of childrenFieldName"

	^childrenFieldName ifNil:[ 'children' ]! !

!VRMLComposite methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:54'!
childrenFieldName: aValue

	"Set the value of childrenFieldName"

	childrenFieldName := aValue! !

!VRMLComposite methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:54'!
kindDo: aRequestor

	^aRequestor doVRMLComposite: self! !

!VRMLComposite methodsFor: 'overriding' stamp: 'emm 02/09/2012 23:54'!
rotateBy: rotationPoint

	^self className = 'Group'
		ifTrue: 
			[ self className: 'Transform'.
			self rotation: rotationPoint normalized @ rotationPoint r "can be optimized" ]
		ifFalse:
			 [ super rotateBy: rotationPoint ]! !

!VRMLComposite methodsFor: 'overriding' stamp: 'emm 02/09/2012 23:54'!
translateBy: translationPoint

	^self className = 'Group'
		ifTrue: 
			[ self className: 'Transform'.
			self translation: translationPoint ]
		ifFalse:
			 [ super translateBy: translationPoint ]! !

SceneElementGroup subclass: #VRMLProto
	instanceVariableNames: 'routes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-FormatVRML'!

!VRMLProto methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:54'!
kindDo: aRequestor

	^ aRequestor doVRMLProto: self! !

!VRMLProto methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:54'!
routes

	"Answer the value of routes"

	^routes isNil
		ifTrue: [ routes := OrderedCollection new ]
		ifFalse: [ routes ]! !

!VRMLProto methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:54'!
routes: aValue

	"Set the value of routes"

	routes := aValue! !

GenericSceneElement subclass: #VRMLBackground
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-FormatVRML'!

!VRMLBackground methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:54'!
kindDo: aRequestor 

	^ aRequestor doVRMLBackground: self! !

GenericSceneElement subclass: #VRMLElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-FormatVRML'!

!VRMLElement methodsFor: 'transform' stamp: 'emm 02/09/2012 23:54'!
asVRMLTransform

	^self className = 'Transform'
			ifTrue: [ self ]
			ifFalse: 
				[ | newTransform |
				newTransform := VRMLComposite new.
				newTransform className: 'Transform'.
				newTransform add: self.
				newTransform ]! !

!VRMLElement methodsFor: 'convenience' stamp: 'emm 02/09/2012 23:54'!
cycleInterval: aValue

	self at: 'cycleInterval' put: aValue! !

!VRMLElement methodsFor: 'convenience' stamp: 'emm 02/09/2012 23:54'!
examine

	self type: 'EXAMINE'! !

!VRMLElement methodsFor: 'convenience' stamp: 'emm 02/09/2012 23:54'!
geometry

	"BROKEN"
	
	| messageOrNil |
	messageOrNil := self messages detect:[ :each | each selector == #geometry ] ifNone:[].
	^ messageOrNil isNil
		ifTrue: [ self elements isEmpty
			ifTrue: [ nil ]
			ifFalse: [ self elements first geometry ] ]
		ifFalse: [ messageOrNil arguments first ]! !

!VRMLElement methodsFor: 'convenience' stamp: 'emm 02/09/2012 23:54'!
orientation: aValue

	self at: 'orientation' put: aValue! !

!VRMLElement methodsFor: 'transform' stamp: 'emm 02/09/2012 23:54'!
scaleBy: aPoint3D

	| oldScale |
	oldScale := self at: 'scale' ifAbsent:[0@0@0].
	self at: 'scale' put: oldScale + aPoint3D! !

!VRMLElement methodsFor: 'convenience' stamp: 'emm 02/09/2012 23:54'!
size: aValue

	self at: 'size' put: aValue! !

!VRMLElement methodsFor: 'convenience' stamp: 'emm 02/09/2012 23:54'!
startTime: aValue

	self at: 'startTime' put: aValue! !

!VRMLElement methodsFor: 'convenience' stamp: 'emm 02/09/2012 23:54'!
stopTime: aValue

	self at: 'stopTime' put: aValue! !

!VRMLElement methodsFor: 'transform' stamp: 'emm 02/09/2012 23:54'!
translateBy: aPoint3D

	| oldTranslation |
	oldTranslation := self at: 'translation' ifAbsent:[0@0@0].
	self at: 'translation' put: oldTranslation + aPoint3D! !

!VRMLElement methodsFor: 'transform' stamp: 'emm 02/09/2012 23:54'!
translation: aValue

	self at: 'translation' put: aValue! !

!VRMLElement methodsFor: 'convenience' stamp: 'emm 02/09/2012 23:54'!
type: aValue

	self at: 'type' put: aValue! !

!VRMLElement methodsFor: 'convenience' stamp: 'emm 02/09/2012 23:54'!
walk

	self type: 'WALK'! !

GenericSceneElement subclass: #VRMLScript
	instanceVariableNames: 'declarations source'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-FormatVRML'!

!VRMLScript methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:54'!
declarations

	"Answer the value of declarations"

	^declarations isNil
		ifTrue: [ declarations := OrderedCollection new ]
		ifFalse: [ declarations ]! !

!VRMLScript methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:54'!
declarations: aValue

	"Set the value of declarations"

	declarations := aValue! !

!VRMLScript methodsFor: 'declaring' stamp: 'emm 02/09/2012 23:54'!
declare: variableOrElement as: type 
	
	self declarations add: ( Array with: type with: ( variableOrElement isString
		ifTrue: [ variableOrElement asSymbol ]
		ifFalse: [ variableOrElement ensureNamed] ) )! !

!VRMLScript methodsFor: 'declaring' stamp: 'emm 02/09/2012 23:54'!
declare: variableOrElement as: type value: initialValue
		
	self declarations add: ( Array with: type with: ( variableOrElement isString
		ifTrue: [ variableOrElement asSymbol ]
		ifFalse: [ variableOrElement ensureNamed] ) with: initialValue)! !

!VRMLScript methodsFor: 'declaring' stamp: 'emm 02/09/2012 23:54'!
ensureDeclare: variableOrElement as: type
	
	| fieldName |
	fieldName :=  variableOrElement isString
		ifTrue: [ variableOrElement asSymbol ]
		ifFalse: [ variableOrElement ensureNamed].
	( self declarations contains:[ :each | (each at: 2) = fieldName ] )
		ifTrue: [ ^self ].
		
	self declarations add: ( Array with: type with: fieldName )! !

!VRMLScript methodsFor: 'declaring' stamp: 'emm 02/09/2012 23:54'!
ensureDeclare: variableOrElement as: type value: aValue
	
	| fieldName |
	fieldName :=  variableOrElement isString
		ifTrue: [ variableOrElement asSymbol ]
		ifFalse: [ variableOrElement ensureNamed].
	( self declarations contains:[ :each | ( each at: 2 )  = fieldName ] )
		ifTrue: [ ^self ].
		
	self declarations add: ( Array with: type with: fieldName with: aValue )! !

!VRMLScript methodsFor: 'testing' stamp: 'emm 02/09/2012 23:54'!
hasProperties
	"declarations and source are handled as properties"

	^true! !

!VRMLScript methodsFor: 'enumerating' stamp: 'emm 9/27/2012 23:58'!
keysAndValuesDo: twoArgBlock

	super keysAndValuesDo: twoArgBlock.
	self declarations do:[ :each |
		| var valueString |
		valueString := each last isString
			ifTrue: [ each last ]
			ifFalse: [ each last printString ].
		each size = 3
			 ifTrue: [ var := ((each at: 2) , ' ' , valueString) asSymbol ]
			ifFalse: [ var := each last ].	
		twoArgBlock value: each first value: var ].
	self source notNil ifTrue: [ twoArgBlock value: 'url' value: 'javascript:' , self source ]! !

!VRMLScript methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:54'!
kindDo: aRequestor

	^aRequestor doVRMLScript: self! !

!VRMLScript methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:54'!
source

	"Answer the value of source"

	^source! !

!VRMLScript methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:54'!
source: aValue

	"Set the value of source"

	source := aValue! !

SceneElement subclass: #M3DMaterial
	instanceVariableNames: 'color texture'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-FormatM3D'!

!M3DMaterial methodsFor: 'comparing' stamp: 'emm 02/09/2012 23:56'!
= otherMaterial
	
	self class == otherMaterial class
		ifFalse: [ ^false ].
	^self texture isNil
		ifTrue: [ otherMaterial texture isNil and:[ self color = otherMaterial color ] ]
		ifFalse: [ self texture = otherMaterial texture and:[ self color = otherMaterial color ]]! !

!M3DMaterial methodsFor: 'private' stamp: 'emm 02/09/2012 23:56'!
className
	^self class name! !

!M3DMaterial methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:56'!
color

	"Answer the value of color"

	^color! !

!M3DMaterial methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:56'!
color: aValue

	"Set the value of color"

	color := aValue! !

!M3DMaterial methodsFor: 'comparing' stamp: 'emm 02/09/2012 23:56'!
hash

	^(super hash bitOr: self texture hash) bitOr: self color! !

!M3DMaterial methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:56'!
kindDo: aRequestor
	
	^aRequestor doM3DMaterial: self! !

!M3DMaterial methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:56'!
texture

	"Answer the value of texture"

	^texture! !

!M3DMaterial methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:56'!
texture: aValue

	"Set the value of texture"

	texture := aValue! !

SceneElement subclass: #M3DMesh
	instanceVariableNames: 'position angle scale vertices light polygons materials'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-FormatM3D'!

!M3DMesh methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:56'!
addTo: aCollector

	^aCollector addElement: self! !

!M3DMesh methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:56'!
angle

	"Answer the value of angle"

	^angle! !

!M3DMesh methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:56'!
angle: aValue

	"Set the value of angle"

	angle := aValue! !

!M3DMesh methodsFor: 'private' stamp: 'emm 02/09/2012 23:56'!
className
	^self class name! !

!M3DMesh methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:56'!
kindDo: aRequestor

	^aRequestor doM3DMesh: self! !

!M3DMesh methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:56'!
light

	"Answer the value of light"

	^light! !

!M3DMesh methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:56'!
light: aValue

	"Set the value of light"

	light := aValue! !

!M3DMesh methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:56'!
materials

	"Answer the value of materials"

	^materials! !

!M3DMesh methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:56'!
materials: aValue

	"Set the value of materials"

	materials := aValue! !

!M3DMesh methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:56'!
polygons

	"Answer the value of polygons"

	^polygons! !

!M3DMesh methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:56'!
polygons: aValue

	"Set the value of polygons"

	polygons := aValue! !

!M3DMesh methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:56'!
position

	"Answer the value of position"

	^position! !

!M3DMesh methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:56'!
position: aValue

	"Set the value of position"

	position := aValue! !

!M3DMesh methodsFor: 'copying' stamp: 'emm 02/09/2012 23:56'!
postCopy

	super postCopy.
	vertices := vertices copy.
	polygons := polygons copy.
	materials := materials copy.! !

!M3DMesh methodsFor: 'transforming' stamp: 'emm 02/09/2012 23:56'!
reverseOriented

	polygons := polygons collect:[ :each | each reverse ]! !

!M3DMesh methodsFor: 'transforming' stamp: 'emm 02/09/2012 23:56'!
rotateBy: aPoint
	"TEMP"

	position := position rotatedBy: aPoint.
	vertices := vertices collect:[ :each | each rotatedBy: aPoint ]! !

!M3DMesh methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:56'!
scale

	"Answer the value of scale"

	^scale! !

!M3DMesh methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:56'!
scale: aValue

	"Set the value of scale"

	scale := aValue! !

!M3DMesh methodsFor: 'transforming' stamp: 'emm 02/09/2012 23:56'!
scaleBy: aPoint
	"TEMP"

	position := position scaleBy: aPoint.
	vertices := vertices collect:[ :each | each scaleBy: aPoint ]! !

!M3DMesh methodsFor: 'transforming' stamp: 'emm 02/09/2012 23:56'!
translateBy: aPoint
	"TEMP"

	position := position + aPoint.! !

!M3DMesh methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:56'!
vertices

	"Answer the value of vertices"

	^vertices! !

!M3DMesh methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:56'!
vertices: aValue

	"Set the value of vertices"

	vertices := aValue! !

SceneElement subclass: #M3DShell
	instanceVariableNames: 'position angle scale meshes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-FormatM3D'!

!M3DShell class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:56'!
new

	"Answer a new instance of the receiver and initialize it"

	^super new initialize! !

!M3DShell methodsFor: 'adding' stamp: 'emm 02/09/2012 23:56'!
add: aMesh

	^meshes add: aMesh! !

!M3DShell methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:56'!
angle

	"Answer the value of angle"

	^angle! !

!M3DShell methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:56'!
angle: aValue

	"Set the value of angle"

	angle := aValue! !

!M3DShell methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:56'!
className

	^'shell'! !

!M3DShell methodsFor: 'initialize-release' stamp: 'emm 02/09/2012 23:56'!
initialize

	meshes := OrderedCollection new.
	position := 0,0,0.
	angle := 0,0,0.
	scale := 100.! !

!M3DShell methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:56'!
kindDo: aRequestor
	
	^aRequestor doM3DShell: self! !

!M3DShell methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:56'!
meshes

	"Answer the value of meshes"

	^meshes! !

!M3DShell methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:56'!
position

	"Answer the value of position"

	^position! !

!M3DShell methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:56'!
position: aValue

	"Set the value of position"

	position := aValue! !

!M3DShell methodsFor: 'transforming' stamp: 'emm 02/09/2012 23:56'!
rotateBy: aPoint3D

	self position: (self position rotatedBy: aPoint3D).
	meshes := (meshes collect:[:each | each rotateBy: aPoint3D])! !

!M3DShell methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:56'!
scale

	"Answer the value of scale"

	^scale! !

!M3DShell methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:56'!
scale: aValue

	"Set the value of scale"

	scale := aValue! !

!M3DShell methodsFor: 'transforming' stamp: 'emm 02/09/2012 23:56'!
translateBy: aPoint3D

	self position: self position + aPoint3D! !

SceneElement subclass: #MaxMaterial
	instanceVariableNames: 'index bitmapFilename diffuseColor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-FormatMaxScript'!

!MaxMaterial methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:55'!
bitmapFilename
	^bitmapFilename! !

!MaxMaterial methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:55'!
bitmapFilename: anObject
	bitmapFilename := anObject! !

!MaxMaterial methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:55'!
diffuseColor
	^diffuseColor! !

!MaxMaterial methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:55'!
diffuseColor: anObject
	diffuseColor := anObject! !

!MaxMaterial methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:55'!
index
	^index! !

!MaxMaterial methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:55'!
index: anObject
	index := anObject! !

!MaxMaterial methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:55'!
kindDo: aRequestor

	^aRequestor doMaxMaterial: self! !

!SceneElement class methodsFor: 'properties' stamp: 'emm 02/09/2012 23:02'!
newID

	LastID isNil
		ifTrue: [ LastID := -1 ].
	^LastID := LastID + 1! !

!SceneElement class methodsFor: 'properties' stamp: 'emm 02/09/2012 23:02'!
resetID

	LastID := -1! !

!SceneElement class methodsFor: 'properties' stamp: 'emm 02/09/2012 23:02'!
source: aString
	^SceneElementWithSource new source: aString! !

!SceneElement methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:02'!
className
	^self class name! !

!SceneElement methodsFor: 'initialize-release' stamp: 'emm 02/09/2012 23:02'!
ensureNamed

	name isNil ifTrue:[ self initializeName ]! !

!SceneElement methodsFor: 'testing' stamp: 'emm 02/09/2012 23:02'!
hasName

	^name notNil! !

!SceneElement methodsFor: 'initialize-release' stamp: 'emm 02/09/2012 23:02'!
initializeName

	| shortName |
	shortName := ((self className select:[ :each | each isUppercase ])
		inject: '' into:[ :short :capital | short copyWith: capital ]) asLowercase.
	shortName isEmpty
		ifTrue: [ shortName := self className ].
	self name: shortName , self class newID printString! !

!SceneElement methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:02'!
name

	^name ifNil:[ self initializeName. name]! !

!SceneElement methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:02'!
name: aValue

	"Set the value of name"

	name := aValue! !

!SceneElement methodsFor: 'copying' stamp: 'emm 02/09/2012 23:02'!
postCopy

	"rename the copy"
	self hasName
		ifTrue: [ self initializeName ]! !

!SceneElement methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:02'!
prefixNameWith: aString

	self name: aString , self hash printString! !

Object subclass: #SceneElementCollection
	instanceVariableNames: 'collection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-SceneBuilding2D'!

!SceneElementCollection methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:03'!
collection
	^collection! !

!SceneElementCollection methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:03'!
collection: aCollection
	collection := aCollection! !

!SceneElementCollection methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:03'!
kindDo: aRequestor
	^aRequestor doSceneElementCollection: self! !

Object subclass: #SceneElementWithSource
	instanceVariableNames: 'source'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-SceneBuilding2D'!

!SceneElementWithSource methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:01'!
addTo: aContainer

	^aContainer addElement: self! !

!SceneElementWithSource methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:01'!
kindDo: aRequestor

	^aRequestor doSceneElementWithSource: self! !

!SceneElementWithSource methodsFor: 'printing' stamp: 'emm 02/09/2012 23:01'!
printOn: aStream indent: level
	aStream nextPutAll: self source! !

!SceneElementWithSource methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:01'!
propertyValuesDo: ignore! !

!SceneElementWithSource methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:01'!
source

	"Answer the value of source"

	^source! !

!SceneElementWithSource methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:01'!
source: aValue

	"Set the value of source"

	source := aValue! !

Object subclass: #SceneEventRoute
	instanceVariableNames: 'eventOut receiver selector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Animation3D'!

!SceneEventRoute methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:29'!
eventOut

	"Answer the value of eventOut"

	^eventOut! !

!SceneEventRoute methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:29'!
eventOut: aValue

	"Set the value of eventOut"

	eventOut := aValue! !

!SceneEventRoute methodsFor: 'handling' stamp: 'emm 02/09/2012 23:29'!
handle: anEventName with: aValue from: anObject
	
	eventOut == anEventName
		ifFalse: [ ^self ].
	selector echo: aValue.
	receiver perform: selector with: aValue! !

!SceneEventRoute methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:29'!
receiver

	"Answer the value of receiver"

	^receiver! !

!SceneEventRoute methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:29'!
receiver: aValue

	"Set the value of receiver"

	receiver := aValue! !

!SceneEventRoute methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:29'!
selector

	"Answer the value of selector"

	^selector! !

!SceneEventRoute methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:29'!
selector: aValue

	"Set the value of selector"

	selector := aValue! !

Object subclass: #SolidComposer
	instanceVariableNames: 'solids position extent scale'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Operators3D'!

SolidComposer subclass: #CubicSolidComposer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Operators3D'!

!CubicSolidComposer methodsFor: 'double-dispatching' stamp: 'emm 02/09/2012 23:48'!
doCharacter3DDescription: char3D

	char3D segmentsDo: [:segment | segment kindDo: self].! !

!CubicSolidComposer methodsFor: 'double-dispatching' stamp: 'emm 02/09/2012 23:48'!
doCharacter: aCharacter ! !

!CubicSolidComposer methodsFor: 'double-dispatching' stamp: 'emm 02/09/2012 23:48'!
doEllipticalArc2D: anArc

	| bigArc |
	bigArc := anArc scaledBy: 100.
	self doLineSegment3D: ( ( bigArc start / 100) @ self position z to: (bigArc end / 100) @ self position z)! !

!CubicSolidComposer methodsFor: 'double-dispatching' stamp: 'emm 02/09/2012 23:48'!
doEllipticalArc3D: anArc

	self doLineSegment3D: ( anArc start to: anArc end )! !

!CubicSolidComposer methodsFor: 'double-dispatching' stamp: 'emm 02/09/2012 23:48'!
doLineSegment2D: aSegment

	self doLineSegment3D: (aSegment start @ self position z 
														to: aSegment end @ self position z )! !

!CubicSolidComposer methodsFor: 'double-dispatching' stamp: 'emm 02/09/2012 23:48'!
doLineSegment3D: aSegment
	"A character segment is defined in the XY-plane where Y is up and X is right"

	| scaled solid translated |
	scaled := aSegment scaledBy: self scale.
	solid := scaled asSolidWithCenterExtentX: self extent x y: self extent y.
	translated := solid translateBy: self position.
	solids add: translated! !

!CubicSolidComposer methodsFor: 'double-dispatching' stamp: 'emm 02/09/2012 23:48'!
newDoEllipticalArc3D: anArc

	| angleDelta rotationMatrix top bottom |
	angleDelta := 0,0,10 rad.
	rotationMatrix := Matrix3x3 rotation: angleDelta.
	anArc sweepAngle > 0
		ifTrue: 
			[ bottom := ((0,0,0) centerExtent: self extent x @ self extent y @ 0) reverseOriented.
			bottom := (Matrix3x3 rotation: 0@0@anArc startAngle) * bottom.
			top := (rotationMatrix * bottom) reverseOriented.
			solids add: ((ExtrudedPolygon between: top and: bottom ) translateBy: self position).
			bottom := top reverseOriented]! !

!SolidComposer class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:48'!
new
	^super new initialize! !

!SolidComposer methodsFor: 'composing' stamp: 'emm 02/09/2012 23:48'!
compose: anObject
	self reset.
	anObject kindDo: self! !

!SolidComposer methodsFor: 'composing' stamp: 'emm 02/09/2012 23:48'!
compose: anObject at: aPoint3D

	self position: aPoint3D.
	self compose: anObject.! !

!SolidComposer methodsFor: 'double-dispatching' stamp: 'emm 02/09/2012 23:48'!
doEllipticalArc: anArc! !

!SolidComposer methodsFor: 'double-dispatching' stamp: 'emm 02/09/2012 23:48'!
doLine2D: aLine2D! !

!SolidComposer methodsFor: 'double-dispatching' stamp: 'emm 02/09/2012 23:48'!
doSequenceableCollection: aCollection
	aCollection do: [:each | each kindDo: self ]! !

!SolidComposer methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:48'!
extent

	^extent! !

!SolidComposer methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:48'!
extent: aValue

	extent := aValue! !

!SolidComposer methodsFor: 'initialize-release' stamp: 'emm 02/09/2012 23:48'!
initialize

	self reset.
	self position: 0 , 0 , 0.
	self extent: 0.1 , 0.1, 0.1.
	self scale: 1! !

!SolidComposer methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:48'!
position

	^position! !

!SolidComposer methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:48'!
position: aValue

	position := aValue! !

!SolidComposer methodsFor: 'initialize-release' stamp: 'emm 02/09/2012 23:48'!
reset
	
	solids := OrderedCollection new.! !

!SolidComposer methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:48'!
scale

	^scale! !

!SolidComposer methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:48'!
scale: aValue

	scale := aValue! !

!SolidComposer methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:48'!
shareStateWith: otherComposer

	otherComposer extent: self extent.
	otherComposer position: self position.
	otherComposer scale: self scale.! !

!SolidComposer methodsFor: 'enumerating' stamp: 'emm 02/09/2012 23:48'!
solidsDo: aBlock
	solids do: aBlock! !

SolidComposer subclass: #SphericalSolidComposer
	instanceVariableNames: 'radius knots'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Operators3D'!

!SphericalSolidComposer methodsFor: 'double-dispatching' stamp: 'emm 02/09/2012 23:48'!
composeSegments: aSegment3DCollection

	self reset.
	aSegment3DCollection do: [:segment | 
		segment kindDo: self].
	aSegment3DCollection do: [:segment | 
		solids add: ((Sphere radius: self radius) origin: segment first).
		solids add: ((Sphere radius: self radius) origin: segment last)]! !

!SphericalSolidComposer methodsFor: 'double-dispatching' stamp: 'emm 02/09/2012 23:48'!
doCharacter3DDescription: character3D

	character3D segments kindDo: self! !

!SphericalSolidComposer methodsFor: 'double-dispatching' stamp: 'emm 02/09/2012 23:48'!
doCharacter: aChar! !

!SphericalSolidComposer methodsFor: 'double-dispatching' stamp: 'emm 02/09/2012 23:48'!
doEllipticalArc2D: anArc

	| pointStream head tail z |
	pointStream := ReadStream on: ( anArc scaledBy: 100 ) vertices.
	pointStream atEnd ifTrue:[^self].
	head := pointStream next / 100.0.
	z := self position z.
	[pointStream atEnd]
		whileFalse:
			[ tail := head.
			head := pointStream next / 100.
			self doLineSegment3D: (LineSegment3D from: tail @ z to: head @ z ) ]! !

!SphericalSolidComposer methodsFor: 'double-dispatching' stamp: 'emm 02/09/2012 23:48'!
doEllipticalArc3D: aSegment

	| interpolator |
	interpolator := aSegment interpolator.
	interpolator collection: (
		Interval 
			from: interpolator collection first
			to: interpolator collection last
			by: interpolator collection increment sign * self radius / 40 "?").
	interpolator verticesDo:[ :vertex |
		solids add: ((Sphere radius: self radius) origin: vertex + self position )].! !

!SphericalSolidComposer methodsFor: 'double-dispatching' stamp: 'emm 02/09/2012 23:48'!
doLineSegment2D: aLine2D

	^self doLineSegment3D: (LineSegment3D 
		from: aLine2D start @ self position z
		to: aLine2D end @ self position z )! !

!SphericalSolidComposer methodsFor: 'double-dispatching' stamp: 'emm 02/09/2012 23:48'!
doLineSegment3D: aSegment

	self ensureKnotAt: aSegment start + position.
	self ensureKnotAt: aSegment end + position.
	solids add: ( (aSegment asCylinderWithRadius: self radius) translateBy: self position )! !

!SphericalSolidComposer methodsFor: 'double-dispatching' stamp: 'emm 02/09/2012 23:48'!
doLineSegment3DCollection: aSegment3DCollection

	aSegment3DCollection do: [:segment | 
		segment kindDo: self].! !

!SphericalSolidComposer methodsFor: 'private' stamp: 'emm 02/09/2012 23:48'!
ensureKnotAt: knotCenter

	(knots includes: knotCenter)
		ifTrue:[^self].
	solids add: ((Sphere radius: self radius) origin: knotCenter).
	"Remember the positions such that knots are included once"
	knots add: knotCenter! !

!SphericalSolidComposer methodsFor: 'initialize-release' stamp: 'emm 02/09/2012 23:48'!
initialize

	super initialize.
	knots := Set new.
	radius := 0.1! !

!SphericalSolidComposer methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:48'!
radius

	^radius! !

!SphericalSolidComposer methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:48'!
radius: aValue

	radius := aValue! !

Object subclass: #TaggedData
	instanceVariableNames: 'className attributes elements contents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-TaggedData'!

!TaggedData class methodsFor: 'instance-creation' stamp: 'emm 08/05/2001 12:00'!
new

	"Answer a new instance of the receiver and initialize it"

	^super new initialize! !

!TaggedData methodsFor: 'Tagged-API' stamp: 'emm 11/08/2003 15:07'!
addElementNamed: tag with: aValue
	^elements add: (Association key: tag value: aValue)! !

!TaggedData methodsFor: 'Tagged-API' stamp: 'emm 04/09/2001 15:30'!
attributeValueAt: option

	^ attributes at: option ifAbsent:[nil]! !

!TaggedData methodsFor: 'Tagged-API' stamp: 'emm 04/09/2001 15:30'!
attributeValueAt: option put: anObject 

	attributes at: option put: anObject! !

!TaggedData methodsFor: 'accessing' stamp: 'emm 04/03/2003 10:51'!
attributes
	"Answer the dictionary of attributes"
	
	^attributes! !

!TaggedData methodsFor: 'accessing' stamp: 'emm 08/05/2001 13:55'!
className

	"Answer the value of className"

	^className! !

!TaggedData methodsFor: 'accessing' stamp: 'emm 08/05/2001 13:55'!
className: aValue

	"Set the value of className"

	className := aValue! !

!TaggedData methodsFor: 'accessing' stamp: 'emm 07/05/2003 14:31'!
contents
	^contents! !

!TaggedData methodsFor: 'accessing' stamp: 'emm 03/12/2008 16:35'!
doesNotUnderstand: aMessage 

	^self lookup: aMessage selector asString ifAbsent: [super doesNotUnderstand: aMessage]! !

!TaggedData methodsFor: 'Tagged-API' stamp: 'emm 11/08/2003 15:01'!
elementNamed: tag

	| entry |
	entry := elements detect:[:each|each key = tag] ifNone:[].
	^entry isNil
		ifTrue: [nil]
		ifFalse: [entry value]! !

!TaggedData methodsFor: 'accessing' stamp: 'emm 23/10/2002 15:50'!
elements
	^elements! !

!TaggedData methodsFor: 'accessing' stamp: 'emm 23/10/2002 15:50'!
elements: anObject
	elements := anObject! !

!TaggedData methodsFor: 'Tagged-API' stamp: 'emm 11/08/2003 15:01'!
elementsNamed: tag
	^(elements select:[:each| each key = tag ]) collect: #value! !

!TaggedData methodsFor: 'initialize-release' stamp: 'emm 11/08/2003 14:50'!
initialize

	className := 'data'.
	attributes := Dictionary new.
	elements := OrderedCollection new.
	contents := ''! !

!TaggedData methodsFor: 'dispatching' stamp: 'emm 05/03/2002 08:51'!
kindDo: aRequestor
	^ aRequestor doTaggedData: self! !

!TaggedData methodsFor: 'dispatching' stamp: 'emm 03/12/2008 16:34'!
lookup: key ifAbsent: aBlock

	^( attributes includesKey: key )
		ifTrue: 
			[ attributes at: key ]
		ifFalse: 
			[ elements 
				detect:[:each| each key = key] 
				ifNone: aBlock ]! !

!TaggedData methodsFor: 'optimization' stamp: 'emm 03/12/2008 16:36'!
name
	^self lookup: 'name' ifAbsent: [self error: 'unkown property "name"' ]! !

!TaggedData methodsFor: 'printing' stamp: 'emm 15/05/2001 10:46'!
printOn: aStream

	self printTaggedWith: (TaggedDataWriter on: aStream)! !

!TaggedData methodsFor: 'printing' stamp: 'emm 11/08/2003 14:58'!
printTaggedWith: aWriter 

	elements isEmpty 
		ifTrue: 
			[ ^aWriter 
				withTag: self className 
				attributes: attributes 
				print: (contents isEmpty ifTrue:[nil] ifFalse:[contents])].
	aWriter 
		withTag: self className 
		attributes: attributes 
		print: [ 
			elements 
				do: [ :assoc | aWriter withTag: assoc key print: assoc value ] 
				separatedBy: [ aWriter cr ] ]! !

!TaggedData methodsFor: 'Tagged-API' stamp: 'emm 12/08/2003 11:13'!
setElementNamed: tag to: aValue

	| entry |
	entry := elements detect:[:each|each key = tag] ifNone:[].
	entry isNil
		ifTrue: [self addElementNamed: tag with: aValue]
		ifFalse: [entry value: aValue]! !

!TaggedData methodsFor: 'Tagged-API' stamp: 'emm 07/05/2003 14:39'!
tagContents: aString
	contents := aString! !

!TaggedData methodsFor: 'optimization' stamp: 'emm 03/12/2008 16:36'!
value
	^self lookup: 'value' ifAbsent: [self error: 'unkown property "name"' ]! !

Object subclass: #TaggedDataParser
	instanceVariableNames: 'classMap stack reader objects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-TaggedData'!

!TaggedDataParser class methodsFor: 'utils' stamp: 'emm 13/09/2001 16:01'!
mergeStrings: aStringCollection

	"Answer a string containing each element separated by a comma"
	
	| out |
	out := WriteStream on: String new.
	aStringCollection
		do:[ :each | out nextPutAll: each ]
		separatedBy:[ out nextPut: $, ].
	^out contents! !

!TaggedDataParser class methodsFor: 'utils' stamp: 'emm 29/04/2003 09:16'!
splitString: aString
	
	"Answer a collection of elements read from the receiver that are separated by a comma.
	Delimiters (spaces,tabs and crs) are ignored"

	| inStream tokenStream tokens next lastChar |
	aString isEmpty ifTrue: [^#()].
	inStream := ReadStream on: aString.
	tokenStream := WriteStream on: String new.
	tokens := OrderedCollection new.
	lastChar := nil.
	[ inStream atEnd ]
		whileFalse: 
			[ next := inStream next.
			next == $,
				ifTrue: 
					[ lastChar == $,
						ifFalse: 
								[tokens add: tokenStream contents trimBlanks.
								tokenStream reset ]]
				ifFalse: [ tokenStream nextPut: next].
			lastChar := next ].
	lastChar == $,
		ifFalse: [tokens add: tokenStream contents trimBlanks].
	^tokens

! !

!TaggedDataParser methodsFor: 'private' stamp: 'emm 09/10/2003 09:09'!
checkStack
	stack isEmpty
		ifTrue: [ self error: self objects printString ]! !

!TaggedDataParser methodsFor: 'accessing' stamp: 'emm 17/01/2002 22:43'!
classMap

	"Answer the value of classMap"

	^classMap isNil ifTrue:[classMap := Dictionary new].! !

!TaggedDataParser methodsFor: 'API' stamp: 'emm 02/05/2001 16:46'!
classMap: aValue

	"Set the value of classMap"

	classMap := aValue! !

!TaggedDataParser methodsFor: 'private' stamp: 'emm 08/05/2001 13:56'!
defaultDataClass

	^TaggedData! !

!TaggedDataParser methodsFor: 'API' stamp: 'emm 02/05/2001 16:46'!
objects

	"Answer the value of objects"

	^objects! !

!TaggedDataParser methodsFor: 'accessing' stamp: 'emm 02/05/2001 16:46'!
objects: aValue

	"Set the value of objects"

	objects := aValue! !

!TaggedDataParser methodsFor: 'API' stamp: 'emm 01/11/2002 14:43'!
parse: aString
	
	"Parse @aString containing an XML definition.
	Use >>classMap: to set the mapping for tags.
	Answer the result (also available with >>objects)"

	^self parseStream: aString readStream! !

!TaggedDataParser methodsFor: 'private' stamp: 'emm 09/10/2003 09:09'!
parseStep

	| tag  objectClass data|
	tag := reader readTag.
	reader isEndTag
		ifTrue: 
			[ reader tagContents isEmpty 
				ifFalse: [self checkStack. stack last tagContents: reader tagContents].
			 ^self setValueFromStackTop: tag ].
	objectClass := classMap at: tag asLowercase ifAbsent:[nil].
	objectClass isNil
		ifTrue: 
			[ "unmapped field or class tag"
			stack isEmpty
				ifTrue: 
					["unmapped class tag"
					^reader isEmptyTag ifFalse: [ self skipUntil: tag ]]
				ifFalse: 
					["field for containing object"
					data := reader readData.
					stack last addElementNamed: tag asLowercase with: (reader isEmptyTag ifTrue:[nil] ifFalse:[data]).
					reader isEmptyTag ifFalse: [ reader readTag ]]]
		ifFalse: [ 
			stack add: objectClass new.
			(stack last isKindOf: self defaultDataClass)
				ifTrue: [ stack last className: tag ].
			reader hasAttributes
				ifTrue: [ self setValuesFromAttributes ].
			reader isEmptyTag
				ifTrue: [ self setValueFromStackTop: tag asLowercase ]].
	! !

!TaggedDataParser methodsFor: 'API' stamp: 'emm 01/11/2002 14:43'!
parseStream: aStream
	
	"Parse @aString containing an XML definition.
	Use >>classMap: to set the mapping for tags.
	Answer the result (also available with >>objects)"

	reader := TaggedDataReader on: aStream.
	stack := OrderedCollection new.
	objects := OrderedCollection new.
	[reader hasMoreTags]
		whileTrue:
			[self parseStep].
	^self objects isEmpty
		ifTrue: [nil]
		ifFalse: [self objects first] "root"! !

!TaggedDataParser methodsFor: 'accessing' stamp: 'emm 02/05/2001 16:46'!
reader

	"Answer the value of reader"

	^reader! !

!TaggedDataParser methodsFor: 'accessing' stamp: 'emm 02/05/2001 16:46'!
reader: aValue

	"Set the value of reader"

	reader := aValue! !

!TaggedDataParser methodsFor: 'private' stamp: 'emm 09/10/2003 09:08'!
setValueFromStackTop: tag

	| last |
	self checkStack.
	last := stack removeLast.
	stack isEmpty
		ifTrue: [ objects add: last ]
		ifFalse: [ stack last addElementNamed: tag with: last ]! !

!TaggedDataParser methodsFor: 'private' stamp: 'emm 25/06/2003 15:17'!
setValuesFromAttributes

	| tags data |
	tags := reader attributes keys.
	tags do: [ :each | stack last attributeValueAt: each asLowercase put: ( reader attributes at: each ) ]! !

!TaggedDataParser methodsFor: 'private' stamp: 'emm 02/05/2001 17:10'!
skipUntil: tag

	| next |
	[reader hasMoreTags]
		whileTrue:
			[next := reader readTag asLowercase.
			next = tag ifTrue: [ ^self] ]! !

!TaggedDataParser methodsFor: 'accessing' stamp: 'emm 02/05/2001 16:46'!
stack

	"Answer the value of stack"

	^stack! !

!TaggedDataParser methodsFor: 'accessing' stamp: 'emm 02/05/2001 16:46'!
stack: aValue

	"Set the value of stack"

	stack := aValue! !

Object subclass: #TaggedDataReader
	instanceVariableNames: 'attributes isEmptyTag isEndTag stream comments tagContents'
	classVariableNames: 'CharacterEntityTable SpecialMap'
	poolDictionaries: ''
	category: 'Zenna-TaggedData'!

!TaggedDataReader class methodsFor: 'initialization' stamp: 'emm 16/09/2001 23:05'!
characterEntityTable

	^CharacterEntityTable! !

!TaggedDataReader class methodsFor: 'initialization' stamp: 'emm 10/2/2012 21:24'!
initializeAfterLoad

	self initializeCharacterEntityTable.
	SpecialMap := Dictionary new.
	self characterEntityTable keysAndValuesDo:[ :k :v |
		SpecialMap at: (v copyFrom: 2 to: v size - 1) put: (String with: k)].
	SpecialMap at: 'rsquo' put: ''''.
	SpecialMap at: 'lsquo' put: ''''.! !

!TaggedDataReader class methodsFor: 'initialization' stamp: 'emm 23/09/2003 09:52'!
initializeCharacterEntityTable
	"Initialize a Dictionary that associates non-ASCII characters with
	their HTML character entities"
	
	CharacterEntityTable := (IdentityDictionary new)
				at: $" put: '&quot;'
				; at: $& put: '&amp;'
				; at: $< put: '&lt;'
				; at: $> put: '&gt;'
				; at: $' put: '&apos;'			
				; at: (Character value: 161)
					put: '&iquest;'
				; at: (Character value: 162)
					put: '&cent;'
				; at: (Character value: 163)
					put: '&pound;'
				; at: (Character value: 165)
					put: '&yen;'
				; at: (Character value: 167)
					put: '&sect;'
				; at: (Character value: 171)
					put: '&laquo;'
				; at: (Character value: 176)
					put: '&deg;'
				; at: (Character value: 177)
					put: '&plusmn;'
				; at: (Character value: 181)
					put: '&micro;'
				; at: (Character value: 182)
					put: '&para;'
				; at: (Character value: 183)
					put: '&middot;'
				; at: (Character value: 187)
					put: '&raquo;'
				; at: (Character value: 210)
					put: '&reg;'
				; at: (Character value: 211)
					put: '&copy;'
				; at: (Character value: 225)
					put: '&AElig;'
				; at: (Character value: 233)
					put: '&Oslash;'
				; at: (Character value: 241)
					put: '&aelig;'
				; at: (Character value: 249)
					put: '&oslash;'
				; at: (Character value: 251)
					put: '&szlig;'
				; yourself! !

!TaggedDataReader class methodsFor: 'instance-creation' stamp: 'emm 02/05/2001 16:28'!
on: aStream

	^self new stream: aStream! !

!TaggedDataReader class methodsFor: 'accessing' stamp: 'emm 29/05/2001 09:47'!
specialMap
	
	^SpecialMap! !

!TaggedDataReader methodsFor: 'private' stamp: 'emm 04/09/2003 19:39'!
addAttribute: aString 

	| ampersand input name value special |
	aString isEmpty 
		ifTrue: [ ^self ].
	ampersand := false.
	special := WriteStream on: String new.
	input := aString readStream.
	name := WriteStream on: ( String new: aString size ).
	value := WriteStream on: ( String new: aString size ). 	"get name"
	[ input atEnd
		or: [ input peekFor: $= ] ]
		whileFalse: [ name nextPut: input next ]. 	"skip separators"
	[ input atEnd
		or: [ input peek isSeparator not ] ]
		whileFalse: [ input next ]. 	"check empty"
	input atEnd 
		ifTrue: [ ^attributes at: name contents put: '' ]. 	"peek for quotes"
	( input peekFor: $" ) 
		ifFalse: [ ( input peekFor: $' ) 
			ifFalse: [ self error: 'attribute value terminator expected' ] ].
	[ input atEnd
		or: [ ( input peekFor: $" )
			or: [ input peekFor: $' ] ] ]
		whileFalse: 
			[  | char | 
			char := input next.
			char == $&
				ifTrue: 
					[ ampersand 
						ifTrue: [ value nextPut: $& ].
					ampersand := true ]
				ifFalse: 
					[ char == $;
						ifTrue: 
							[ ampersand 
								ifTrue: 
									[  | replacement | 
									replacement := SpecialMap 
										at: special contents 
										ifAbsent: [ nil ].
									replacement isNil
										ifTrue: [ value nextPutAll: special contents ]
										ifFalse: [ value nextPutAll: replacement ].
									special reset.
									ampersand := false ] ]
						ifFalse: 
							[ ampersand
								ifTrue: [ special nextPut: char ]
								ifFalse: [ value nextPut: char ] ] ] ].
	attributes at: name contents put: value contents! !

!TaggedDataReader methodsFor: 'accessing' stamp: 'emm 04/09/2001 15:35'!
attributes

	"Answer the value of attributes"

	^attributes! !

!TaggedDataReader methodsFor: 'accessing' stamp: 'emm 04/09/2001 15:35'!
attributes: aValue

	"Set the value of attributes"

	attributes := aValue! !

!TaggedDataReader methodsFor: 'API' stamp: 'emm 13/05/2004 16:40'!
decodedFromString: aString

	| ampersand  special output input|
	ampersand := false.
	special := WriteStream on: String new.
	output := WriteStream on: (String new: aString size).
	input := aString readStream.
	[ input atEnd]
		whileFalse: 
			[  | char | 
			char := input next.
			char == $&
				ifTrue: 
					[ ampersand 
						ifTrue: [ output nextPut: $& ].
					ampersand := true ]
				ifFalse: 
					[ char == $;
						ifTrue: 
							[ ampersand 
								ifTrue: 
									[  | replacement | 
									replacement := SpecialMap 
										at: special contents 
										ifAbsent: [ nil ].
									replacement isNil
										ifTrue: [ output nextPutAll: special contents ]
										ifFalse: [ output nextPutAll: replacement ].
									special reset.
									ampersand := false ] ifFalse: [ output nextPut: char ]. ]
						ifFalse: 
							[ ampersand
								ifTrue: [ special nextPut: char ]
								ifFalse: [ output nextPut: char ] ] ] ].
	^output contents! !

!TaggedDataReader methodsFor: 'API' stamp: 'emm 04/09/2001 15:36'!
hasAttributes

	^attributes notEmpty! !

!TaggedDataReader methodsFor: 'API' stamp: 'emm 17/01/2002 22:45'!
hasComments

	^comments isEmpty not! !

!TaggedDataReader methodsFor: 'API' stamp: 'emm 02/11/2003 13:20'!
hasMoreTags
	"Shoud decode directly from stream..."
	
	tagContents := self decodedFromString: (self upToNotIncluding: $<).
	^stream atEnd not
	! !

!TaggedDataReader methodsFor: 'accessing' stamp: 'emm 02/05/2001 14:00'!
isEmptyTag

	"Answer the value of isEmptyTag"

	^isEmptyTag! !

!TaggedDataReader methodsFor: 'accessing' stamp: 'emm 02/05/2001 14:00'!
isEmptyTag: aValue

	"Set the value of isEmptyTag"

	isEmptyTag := aValue! !

!TaggedDataReader methodsFor: 'accessing' stamp: 'emm 02/05/2001 14:00'!
isEndTag

	"Answer the value of isEndTag"

	^isEndTag! !

!TaggedDataReader methodsFor: 'accessing' stamp: 'emm 02/05/2001 14:00'!
isEndTag: aValue

	"Set the value of isEndTag"

	isEndTag := aValue! !

!TaggedDataReader methodsFor: 'API' stamp: 'emm 21/01/2002 21:24'!
readCDATA
	"comment:		<!!--comment-->
	CDATA:			<!![CDATA[cdata]]>
	"
	"Exclamation mark has been read"
	| char  tag|
	stream atEnd ifTrue: [^''].
	char := stream next.
	(stream atEnd not and:[ char == $[ ])
		ifTrue: 
			[ tag := stream upToAll: 'CDATA['.
			^stream upToAll: ']]>' ]! !

!TaggedDataReader methodsFor: 'API' stamp: 'emm 21/01/2002 21:24'!
readData
	" Answer all data until a tag is encountered
 	Replace any special character entity read
	"
	| buffer special done ampersand inString char replacement |
	buffer := WriteStream on: String new.
	special := WriteStream on: String new.
	done := false.
	ampersand := false.
	inString := false. 
	
	[ stream atEnd
		or: [ done ] ]
		whileFalse: 
			[ char := stream next.
			char == $" 
				ifTrue: [ inString := inString not ].
			inString
				ifTrue: 
					[ buffer nextPut: char ]
				ifFalse: 
					[ char == $<
						ifTrue: 
							[ stream peek = $!!
								ifTrue: 
									[stream next.
									^self readCDATA].
							done := true.
							stream skip: -1.
							ampersand 
								ifTrue: [ buffer nextPut: $&.
			    							   buffer nextPutAll: special contents ]]
						ifFalse: 
							[ char == $&
								ifTrue: 
									[ ampersand 
										ifTrue: 
											[ buffer nextPut: $&.
											buffer nextPutAll: special contents.
											special reset ].
									ampersand := true ]
								ifFalse: 
									[ char == $;
										ifTrue: 
											[ replacement := nil.
											ampersand 
												ifTrue: 
													[ replacement := SpecialMap 
														at: special contents 
														ifAbsent: [ nil ] ].
											replacement isNil
												ifTrue: 
													[ buffer nextPutAll: special contents.
													buffer nextPut: $; ]
												ifFalse: 
													[ buffer nextPutAll: replacement ].
											special reset.
											ampersand := false ]
										ifFalse: 
											[ ampersand
												ifTrue: [ special nextPut: char ]
												ifFalse: [ buffer nextPut: char ] ] ] ] ] ].
		^buffer contents! !

!TaggedDataReader methodsFor: 'API' stamp: 'emm 25/06/2003 15:07'!
readTag
	"Answer the name of the tag. After returning the name, the receiver can be requested for:
	-  hasAttributes
	- attributes
	- isEndTag
 	- isEmptyTag
	"
	| buffer done inString char attribute option comment lastChar |
	isEndTag := false.
	isEmptyTag := false.
	attributes := Dictionary new.
	buffer := WriteStream on: String new.
	attribute := WriteStream on: String new.
	done := false.
	option := false.
	comment := false.
	inString := false.
	lastChar := nil. 
	
	self skipUntil: $<.
	[ stream atEnd
		or: [ done ] ]
		whileFalse: 
			[ char := stream next.
			(char == $" or:[char == $'])
				ifTrue: [ inString := inString not ].
			inString
				ifTrue: 
					[ option
						ifTrue: [ attribute nextPut: char ]
						ifFalse: [ buffer nextPut: char ] ]
				ifFalse: 
					[ char == $!!
						ifTrue: 
							[ isEmptyTag := true.
							stream next ;next. "consume -- "
							comments add: (stream upToAll: '-->').
							done := true. ]
						ifFalse: 
							[ char == $?
								ifTrue: 
									[ isEmptyTag := true ]
								ifFalse: 
									[ char == $>
										ifTrue: 
											[ option 
												ifTrue: 
													[ self addAttribute: attribute contents.
													attribute reset ].
											isEmptyTag := lastChar = $/ or:[lastChar = $?].
											done := true ]
										ifFalse: 
											[ char == $/
												ifTrue: 
													[ isEndTag := buffer position = 0 ]
												ifFalse: 
													[ char == $ 
														ifTrue: 
															[ option
																ifTrue: 
																	[ self addAttribute: attribute contents.
																	attribute reset]
																ifFalse: 
																	[ option := true ] ]
														ifFalse: 
															[ char == Character tab
																ifTrue: 
																	[ option
																		ifTrue: 
																			[ self addAttribute: attribute contents.
																			attribute reset]
																		ifFalse: 
																			[ option := true ] ]
																ifFalse: 
																	[ char asInteger == 13
																		ifTrue: 
																			[ option
																				ifTrue: 
																					[ self addAttribute: attribute contents.
																					attribute reset]
																				ifFalse: 
																					[ option := true ] ]
																		ifFalse: 
																			[ char asInteger == 10
																				ifTrue: 
																					[ option
																						ifTrue: 
																							[ self addAttribute: attribute contents.
																							attribute reset]
																						ifFalse: 
																							[ option := true ] ]
																				ifFalse: 
																					[ option
																						ifTrue: [ attribute nextPut: char ]
																						ifFalse: [ buffer nextPut: char ] ] ] ] ] ] ] ] ] ].
			lastChar := char ].
	^buffer contents! !

!TaggedDataReader methodsFor: 'private' stamp: 'emm 17/01/2002 23:32'!
skipUntil: char
"
consume all characters until #ch is read
"
	[stream atEnd not and:[stream next ~~ char]]
		whileTrue:[]
	! !

!TaggedDataReader methodsFor: 'private' stamp: 'emm 17/01/2002 23:35'!
skipUpTo: char 
"
consume all characters until #ch is reached (but not read)
"
	[stream atEnd not and:[stream peek ~~ char]]
		whileTrue:[stream next]! !

!TaggedDataReader methodsFor: 'accessing' stamp: 'emm 02/05/2001 14:00'!
stream

	"Answer the value of stream"

	^stream! !

!TaggedDataReader methodsFor: 'accessing' stamp: 'emm 07/05/2003 14:27'!
stream: aValue

	"Set the value of stream"

	stream := aValue.
	comments := OrderedCollection new.
	tagContents := ''! !

!TaggedDataReader methodsFor: 'API' stamp: 'emm 25/06/2003 15:19'!
strippedQuotes: aString
	"self new strippedQuotes: '""help""'
	"
	"self new strippedQuotes: '''help'''
	"	
	| from  to|
	from := 1.
	to := aString size.
	aString isEmpty ifTrue: [ ^aString ].
	(aString first == $" or:[aString first=$']) ifTrue: [ from := from + 1].
	(aString first == $" or:[aString last=$']) ifTrue: [ to := to - 1].
	^aString copyFrom: from to: to! !

!TaggedDataReader methodsFor: 'accessing' stamp: 'emm 07/05/2003 14:30'!
tagContents
	^tagContents! !

!TaggedDataReader methodsFor: 'API' stamp: 'emm 14/09/2001 11:50'!
takeComments

	| lastComments |
	lastComments := comments.
	comments := OrderedCollection new.
	^lastComments! !

!TaggedDataReader methodsFor: 'private' stamp: 'emm 07/05/2003 14:16'!
upToNotIncluding: char 
	"consume all characters until #ch is reached (but not read)"
	
	| buffer |
	buffer := WriteStream on: String new.
	[stream atEnd not and:[stream peek ~~ char]]
		whileTrue:[buffer nextPut: stream next].
	^buffer contents! !

Object subclass: #TaggedDataWriter
	instanceVariableNames: 'stream indent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-TaggedData'!

!TaggedDataWriter class methodsFor: 'instance-creation' stamp: 'emm 04/05/2001 10:10'!
on: aStream

	^self new stream: aStream! !

!TaggedDataWriter methodsFor: 'API' stamp: 'emm 22/08/2001 11:13'!
cr

	stream cr.
	indent timesRepeat:[stream tab]! !

!TaggedDataWriter methodsFor: 'API' stamp: 'emm 20/01/2002 19:00'!
printCData: aString 

	stream nextPutAll: '<!![CDATA[' ; nextPutAll: aString ; nextPutAll: ']]>'! !

!TaggedDataWriter methodsFor: 'API' stamp: 'emm 30/03/2003 18:35'!
printComment: aString

	stream 
		nextPutAll: '<!!--'
		;nextPutAll: aString
		;nextPutAll: '-->'.
	self cr! !

!TaggedDataWriter methodsFor: 'API' stamp: 'emm 13/09/2003 20:05'!
printData: anObject 

	anObject isString 
		ifTrue: [ ^self printStringData: anObject ].
	anObject isSequenceable 
		ifTrue: 
			[ ^anObject 
				do: [ :each | self printData: each ] 
				separatedBy: [ self cr ] ].
	anObject printTaggedWith: self! !

!TaggedDataWriter methodsFor: 'API' stamp: 'emm 18/05/2004 12:22'!
printHeader
	stream nextPutAll: '<?xml version="1.0" encoding="UTF-8"?>' ;cr! !

!TaggedDataWriter methodsFor: 'API' stamp: 'emm 16/09/2001 23:09'!
printStringData: aString 

	| replacement |
	aString do: [ :ch | 
		replacement := TaggedDataReader characterEntityTable
			at: ch 
			ifAbsent: [ nil ].
		replacement isNil
			ifTrue: [ stream nextPut: ch ]
			ifFalse: [ stream nextPutAll: replacement ] ]! !

!TaggedDataWriter methodsFor: 'API' stamp: 'emm 12/03/2002 23:05'!
printTabs
	indent timesRepeat:[stream tab].! !

!TaggedDataWriter methodsFor: 'API' stamp: 'emm 09/10/2002 13:53'!
printTag: tag attributes: aDictionaryOrNil isEnd: isEnd 

	^self printTag: tag attributes: aDictionaryOrNil isEnd: isEnd isEmpty: false! !

!TaggedDataWriter methodsFor: 'API' stamp: 'emm 07/10/2003 15:46'!
printTag: tag attributes: aDictionaryOrNil isEnd: isEnd isEmpty: isEmpty

	stream nextPut: $<.
	isEnd 
		ifTrue: [ stream nextPut: $/ ].
	stream nextPutAll: tag.
	aDictionaryOrNil notNil 
		ifTrue: [ aDictionaryOrNil keysAndValuesDo: [ :k :v | 
			v notNil ifTrue:[
			stream space ; nextPutAll: k ; nextPutAll: '="'.
			v isString
				ifTrue: [ self printStringData:  v "encode" ]
				ifFalse: [ v printTaggedWith: self ].
			stream nextPut: $" ]] ].
	isEmpty		
		ifTrue: [ stream nextPut: $/ ].
	stream nextPut: $>.! !

!TaggedDataWriter methodsFor: 'accessing' stamp: 'emm 04/05/2001 10:10'!
stream

	"Answer the value of stream"

	^stream! !

!TaggedDataWriter methodsFor: 'accessing' stamp: 'emm 14/05/2001 10:04'!
stream: aValue

	"Set the value of stream"

	stream := aValue.
	indent := 0.! !

!TaggedDataWriter methodsFor: 'API' stamp: 'emm 12/10/2003 23:11'!
withTag: tag attributes: aDictionary print: aStringOrBlock

	| isBlock |
	aStringOrBlock isNil
		ifTrue: [ ^self printTag: tag attributes: aDictionary isEnd: false isEmpty: true ].
	( aStringOrBlock isKindOf: TaggedData )
		ifTrue: [ ^aStringOrBlock printTaggedWith: self ].
	(aStringOrBlock isSequenceable and:[aStringOrBlock isString not])
		ifTrue: [
			self printTag: tag attributes: aDictionary isEnd: false.
			aStringOrBlock do:[ :each | each printTaggedWith: self] separatedBy:[stream cr].
			self printTag: tag attributes: nil  isEnd: true.
			^self ].
	self printTag: tag attributes: aDictionary isEnd: false.
	isBlock := aStringOrBlock class == [self] class.
	isBlock ifTrue: [ indent := indent + 1].
	isBlock
		ifTrue: [ self cr. aStringOrBlock value ]
		ifFalse: [ self printData: aStringOrBlock].
	isBlock ifTrue: [ indent := indent - 1. self cr].		
	self printTag: tag attributes: nil  isEnd: true.! !

!TaggedDataWriter methodsFor: 'API' stamp: 'emm 04/09/2001 15:33'!
withTag: tag print: aStringOrBlock

	^self withTag: tag attributes: nil print: aStringOrBlock! !

!TaggedDataWriter methodsFor: 'API' stamp: 'emm 20/01/2002 19:00'!
withTag: tag printCData: aString 

	stream 
		nextPut: $<
		; nextPutAll: tag
		; nextPut: $>.
	self printCData: aString.
	stream
		nextPut: $<
		; nextPut: $/
		; nextPutAll: tag
		; nextPut: $>! !

Object subclass: #ThreeJSElement
	instanceVariableNames: 'constructorParameters messages'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-FormatThreeJS'!

!ThreeJSElement class methodsFor: 'as yet unclassified' stamp: 'emm 10/7/2012 21:56'!
new: className withAll: args
	^self new constructorParameters: args! !

!ThreeJSElement methodsFor: 'accessing' stamp: 'emm 10/7/2012 21:51'!
constructorParameters
	^ constructorParameters! !

!ThreeJSElement methodsFor: 'accessing' stamp: 'emm 10/7/2012 21:51'!
constructorParameters: anObject
	constructorParameters := anObject! !

!ThreeJSElement methodsFor: 'accessing' stamp: 'emm 10/7/2012 21:51'!
messages
	^ messages! !

!ThreeJSElement methodsFor: 'accessing' stamp: 'emm 10/7/2012 21:51'!
messages: anObject
	messages := anObject! !

!ThreeJSElement methodsFor: 'as yet unclassified' stamp: 'emm 10/7/2012 21:55'!
printOn: aStream! !

Object subclass: #TimeSensor
	instanceVariableNames: 'cycleInterval enabled loop startTime stopTime'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Animation3D'!

!TimeSensor class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:29'!
new

	"Answer a new instance of the receiver and initialize it"

	^super new initialize! !

!TimeSensor methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:29'!
cycleInterval

	"Answer the value of cycleInterval"

	^cycleInterval! !

!TimeSensor methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:29'!
cycleInterval: aValue

	"Set the value of cycleInterval"

	cycleInterval := aValue! !

!TimeSensor methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:29'!
enabled

	"Answer the value of enabled"

	^enabled! !

!TimeSensor methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:29'!
enabled: aValue

	"Set the value of enabled"

	enabled := aValue! !

!TimeSensor methodsFor: 'control' stamp: 'emm 02/09/2012 23:29'!
handleTickAt: absoluteTime

	"Handle the simulation tick at @absoluteTime"

	| fraction |
	fraction := (( absoluteTime - self startTime ) / self cycleInterval * 1.0) fractionPart.
	( fraction = 0 and:[ absoluteTime > self startTime ] )
		ifTrue: [ self changed: #fraction_changed with: 1 ]
		ifFalse: [ self changed: #fraction_changed with: fraction ]
	! !

!TimeSensor methodsFor: 'intialize-release' stamp: 'emm 02/09/2012 23:29'!
initialize

	self cycleInterval: 1.
	self enabled: true.
	self loop: false.
	self startTime: 0.
	self stopTime: 0.! !

!TimeSensor methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:29'!
loop

	"Answer the value of loop"

	^loop! !

!TimeSensor methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:29'!
loop: aValue

	"Set the value of loop"

	loop := aValue! !

!TimeSensor methodsFor: 'computed' stamp: 'emm 02/09/2012 23:29'!
name

	^'Timer' , self hash printString! !

!TimeSensor methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:29'!
startTime

	"Answer the value of startTime"

	^startTime! !

!TimeSensor methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:29'!
startTime: aValue

	"Set the value of startTime"

	startTime := aValue! !

!TimeSensor methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:29'!
stopTime

	"Answer the value of stopTime"

	^stopTime! !

!TimeSensor methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:29'!
stopTime: aValue

	"Set the value of stopTime"

	stopTime := aValue! !

Object subclass: #Transformation3D
	instanceVariableNames: 'translation rotation scale'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-Wrappers3D'!

!Transformation3D methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:45'!
kindDo: aRequestor

	^aRequestor doTransformation3D: self! !

!Transformation3D methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:45'!
propertyValuesDo: aBlock

	aBlock value: self translation.
	aBlock value: self rotation.
	aBlock value: self scale! !

!Transformation3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:45'!
rotation

	"Answer the value of rotation"

	^rotation! !

!Transformation3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:45'!
rotation: aValue

	"Set the value of rotation"

	rotation := aValue! !

!Transformation3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:45'!
scale

	"Answer the value of scale"

	^scale! !

!Transformation3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:45'!
scale: aValue

	"Set the value of scale"

	scale := aValue! !

!Transformation3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:45'!
translation

	"Answer the value of translation"

	^translation! !

!Transformation3D methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:45'!
translation: aValue

	"Set the value of translation"

	translation := aValue! !

Object subclass: #VRMLRoute
	instanceVariableNames: 'source sourceAspect target targetAspect'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-FormatVRML'!

!VRMLRoute class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:54'!
from: sourceAspect of: source to: targetAspect of: target

	source ensureNamed.
	target ensureNamed.
	^self new
			sourceAspect: sourceAspect
			; source: source
			; target: target
			; targetAspect: targetAspect! !

!VRMLRoute class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:54'!
routing: sourceAspect of: source to: targetAspect of: target

	^self from: sourceAspect of: source to: targetAspect of: target! !

!VRMLRoute methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:54'!
allElementsDo: aBlock
	"ignore"! !

!VRMLRoute methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:54'!
kindDo: aReq

	^aReq doVRMLRoute: self! !

!VRMLRoute methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:54'!
source

	"Answer the value of source"

	^source! !

!VRMLRoute methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:54'!
source: aValue

	"Set the value of source"

	source := aValue! !

!VRMLRoute methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:54'!
sourceAspect

	"Answer the value of sourceAspect"

	^sourceAspect! !

!VRMLRoute methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:54'!
sourceAspect: aValue

	"Set the value of sourceAspect"

	sourceAspect := aValue! !

!VRMLRoute methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:54'!
target

	"Answer the value of target"

	^target! !

!VRMLRoute methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:54'!
target: aValue

	"Set the value of target"

	target := aValue! !

!VRMLRoute methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:54'!
targetAspect

	"Answer the value of targetAspect"

	^targetAspect! !

!VRMLRoute methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:54'!
targetAspect: aValue

	"Set the value of targetAspect"

	targetAspect := aValue! !

Object subclass: #VRMLScheduler
	instanceVariableNames: 'routes tasks script clock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-FormatVRML'!

!VRMLScheduler class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:54'!
new

	"Answer a new instance of the receiver and initialize it"

	^super new initialize! !

!VRMLScheduler methodsFor: 'private' stamp: 'emm 02/09/2012 23:54'!
addDisablingTask

	"Disable the clock and reset the number of ticks to -1"

	| lastTask |
	lastTask := self tasks last.
	tasks add: ( ( VRMLTask new )
		startTime: lastTask startTime
		; actionSource: 'stopTime(value,time)' )! !

!VRMLScheduler methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:54'!
addTo: aVRMLBuilder
	
	self addDisablingTask.
	self generateSource.
	aVRMLBuilder add: clock.
	aVRMLBuilder add: self script.
	self routes do:[ :each |
		aVRMLBuilder addRoute: each ]
	
! !

!VRMLScheduler methodsFor: 'scheduling' stamp: 'emm 02/09/2012 23:54'!
at: startTime send: selector with: argument to: receiver

	| fieldName rhs |
	fieldName := ( 'n_' , receiver name ) asSymbol.
	self script ensureDeclare: fieldName as: 'field SFNode'  value:  'USE ' , receiver name.
	rhs := self rightHandSideFrom: argument.
	self tasks add: (
		(VRMLTask new)
			startTime: startTime
			; actionSource: fieldName , '.' , selector , ' = ' , rhs ).	! !

!VRMLScheduler methodsFor: 'scheduling' stamp: 'emm 02/09/2012 23:54'!
at: startTime start: aTimer

	| fieldName |
	fieldName := ( 'n_' , aTimer name ) asSymbol.
	self script ensureDeclare: fieldName as: 'field SFNode'  value:  'USE ' , aTimer name.
	self tasks add: (
		(VRMLTask new)
			startTime: startTime
			; actionSource: fieldName , '.startTime = time' ).	! !

!VRMLScheduler methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:54'!
clock

	"Answer the value of clock"

	^clock! !

!VRMLScheduler methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:54'!
clock: aValue

	"Set the value of clock"

	clock := aValue! !

!VRMLScheduler methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:54'!
cycleInterval

	^self clock at: 'cycleInterval'! !

!VRMLScheduler methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:54'!
cycleInterval: aValue

	self clock at: 'cycleInterval' put: aValue! !

!VRMLScheduler methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:54'!
ensureNamed

	^self script ensureNamed! !

!VRMLScheduler methodsFor: 'private' stamp: 'emm 02/09/2012 23:54'!
generateSource
	
	| sourceStream thisTask nextTask now tasksNow nextInterval ticks case key todo |
	sourceStream := WriteStream on: ( String new: 128 ).
"	self writeInitializeOn: sourceStream.
"	self writeStartTimeOn: sourceStream.
	self writeStopTimeOn: sourceStream.
	self writeHandleTickHeaderOn: sourceStream.

	ticks := self tasks collect:[ :each | ( each startTime / self cycleInterval ) rounded ].
	case := VRMLTaskControlNode withAll: ticks.
	self tasks do:[ :each |
		key := ( each startTime / self cycleInterval ) rounded.
		todo := case at: key.
		todo isNil
			ifTrue: [ case at: key put: ( todo := OrderedCollection new ) ].
		todo add: each ].	
	case printSourceOn: sourceStream indent: 1.
	sourceStream nextPut: $} ; cr.
	self script source: sourceStream contents! !

!VRMLScheduler methodsFor: 'initialize-release' stamp: 'emm 02/09/2012 23:54'!
initialize

	tasks := SortedCollection new sortBlock: [ :t1 :t2 | t1 startTime < t2 startTime ].
	routes := OrderedCollection new.	
	clock := SceneBuilder vrml newTimeSensor.
	script := SceneBuilder vrml newScript.
	self initializeClock.
	self initializeScript.! !

!VRMLScheduler methodsFor: 'initialize-release' stamp: 'emm 02/09/2012 23:54'!
initializeClock

	self cycleInterval: 0.1.
	self clock loop: true.
	self clock enabled: false.
	self routes add: (VRMLRoute
		from: #cycleTime
		of: self clock
		to: #handleTick
		of: self script ).! !

!VRMLScheduler methodsFor: 'initialize-release' stamp: 'emm 02/09/2012 23:54'!
initializeScript

	script at: 'directOutput' put: true.
	script at: 'mustEvaluate' put: true.
	script declare: #ticks as: 'eventOut SFInt32'.
	script declare: #handleTick as: 'eventIn SFTime'.
	script declare: #clock as: 'field SFNode' value:  'USE ' , self clock name.
	script declare: #startTime as: 'eventIn SFTime'.
	script declare: #stopTime as: 'eventIn SFTime'.! !

!VRMLScheduler methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:54'!
name

	^self script name! !

!VRMLScheduler methodsFor: 'private' stamp: 'emm 02/09/2012 23:54'!
rightHandSideFrom: argument

	^ argument isString
		ifTrue: [ 'new MFString(' , argument printString , ')' ]
		ifFalse: [ argument printString ]! !

!VRMLScheduler methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:54'!
routes

	"Answer the value of routes"

	^routes! !

!VRMLScheduler methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:54'!
routes: aValue

	"Set the value of routes"

	routes := aValue! !

!VRMLScheduler methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:54'!
script

	"Answer the value of script"

	^script! !

!VRMLScheduler methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:54'!
script: aValue

	"Set the value of script"

	script := aValue! !

!VRMLScheduler methodsFor: 'private' stamp: 'emm 02/09/2012 23:54'!
sftypeFor: aValue

	aValue isNumber
		ifTrue: [ ^'SFFloat' ].
	aValue class == Point3D
		ifTrue: [ ^'SFVec3f' ].
	^self error: 'bummer'! !

!VRMLScheduler methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:54'!
taskAfter: aTask 
	
	"Answer the next task scheduled by the receiver with a different start time"
	
	| where afterTask |
	where := ( self tasks indexOf: aTask ) + 1.
	[ where <= self tasks size
		and: [ 
			afterTask := self tasks at: where.
			afterTask startTime = aTask startTime ] ]
		whileTrue: 
			[ where := where + 1.
			afterTask := nil ].
	^afterTask! !

!VRMLScheduler methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:54'!
tasks

	"Answer the value of tasks"

	^tasks! !

!VRMLScheduler methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:54'!
tasks: aValue

	"Set the value of tasks"

	tasks := aValue! !

!VRMLScheduler methodsFor: 'dispatching' stamp: 'emm 02/09/2012 23:54'!
tasksAt: startTime

	^self tasks select:[ :each | each startTime = startTime ]! !

!VRMLScheduler methodsFor: 'private' stamp: 'emm 02/09/2012 23:54'!
writeHandleTickHeaderOn: sourceStream
	
	sourceStream nextPutAll: 'function handleTick (value,time) {' ; cr. 
	sourceStream tab ;nextPutAll: 'ticks++;' ;cr.! !

!VRMLScheduler methodsFor: 'private' stamp: 'emm 02/09/2012 23:54'!
writeInitializeOn: sourceStream
	
	sourceStream 
		cr ; nextPutAll: 'function initialize() {' ;cr
		;tab ;nextPutAll: 'ticks = -1;' ;cr
		;nextPut: $} ;cr.! !

!VRMLScheduler methodsFor: 'private' stamp: 'emm 02/09/2012 23:54'!
writeStartTimeOn: sourceStream
	
	sourceStream nextPutAll: 'function startTime (value,time) {' ;cr.
	sourceStream tab ;nextPutAll: 'ticks = -1;' ;cr.	
	sourceStream tab ;nextPutAll: 'clock.enabled = true;' ;cr.	
	sourceStream tab ;nextPutAll: 'clock.startTime = value;' ;cr.
	sourceStream nextPut: $} ;cr.! !

!VRMLScheduler methodsFor: 'private' stamp: 'emm 02/09/2012 23:54'!
writeStopTimeOn: sourceStream
	
	sourceStream nextPutAll: 'function stopTime (value,time) {' ;cr.
	sourceStream tab ;nextPutAll: 'clock.enabled = false;' ;cr.	
	sourceStream nextPut: $} ;cr.! !

Object subclass: #VRMLTask
	instanceVariableNames: 'startTime stopTime actionSource'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-FormatVRML'!

!VRMLTask methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:54'!
actionSource

	"Answer the value of actionSource"

	^actionSource! !

!VRMLTask methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:54'!
actionSource: aValue

	"Set the value of actionSource"

	actionSource := aValue! !

!VRMLTask methodsFor: 'printing' stamp: 'emm 02/09/2012 23:54'!
printOn: aStream

	aStream print: self startTime.
	aStream nextPut: $-.
	aStream print: (self stopTime ifNil: ['?'] ).
	aStream nextPut: $:.
	aStream nextPutAll: actionSource! !

!VRMLTask methodsFor: 'printing' stamp: 'emm 02/09/2012 23:54'!
printSourceOn: aStream

	aStream nextPutAll: actionSource! !

!VRMLTask methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:54'!
startTime

	"Answer the value of startTime"

	^startTime! !

!VRMLTask methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:54'!
startTime: aValue

	"Set the value of startTime"

	startTime := aValue! !

!VRMLTask methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:54'!
stopTime

	"Answer the value of stopTime"

	^stopTime! !

!VRMLTask methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:54'!
stopTime: aValue

	"Set the value of stopTime"

	stopTime := aValue! !

Object subclass: #VRMLTransformAnimationBuilder
	instanceVariableNames: 'steps targetWrapper sceneBuilder timeSensor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zenna-FormatVRML'!

!VRMLTransformAnimationBuilder class methodsFor: 'examples' stamp: 'emm 02/09/2012 23:54'!
example0
	"self example0"

^VRMLTransformAnimationBuilder new
	buildForInterpolating: ((Box origin: 1,2,3 corner: 4,5,8) asWrapperOnDefault collectWrappersInto: OrderedCollection new)
	into: ((Box origin: 7,2,3 corner: 4,5,6) asWrapperOnDefault collectWrappersInto: OrderedCollection new)! !

!VRMLTransformAnimationBuilder class methodsFor: 'instance-creation' stamp: 'emm 02/09/2012 23:54'!
new

	"Answer a new instance of the receiver and initialize it"

	^super new initialize! !

!VRMLTransformAnimationBuilder methodsFor: 'API' stamp: 'emm 02/09/2012 23:54'!
addInterpolatorsToTransform: sourceWrappers into: targetWrappers
	
	"Pre: same size, same structure, different parameter values"

	sourceWrappers doWithIndex:[ :sourceWrapper :i |
		targetWrapper := targetWrappers at: i.
		sourceWrapper kindDo: self ].
! !

!VRMLTransformAnimationBuilder methodsFor: 'dispatching-wrappers ( IWrapper3DVisitor )' stamp: 'emm 02/09/2012 23:54'!
doColorWrapper: aColoringWrapper

	"Handle the request from @aColoringWrapper"! !

!VRMLTransformAnimationBuilder methodsFor: 'dispatching-wrappers ( IWrapper3DVisitor )' stamp: 'emm 02/09/2012 23:54'!
doHollowing3DWrapper: aHollowingWrapper

	"Handle the request from @aHollowingWrapper"! !

!VRMLTransformAnimationBuilder methodsFor: 'dispatching-wrappers ( IWrapperVisitor )' stamp: 'emm 02/09/2012 23:54'!
doHollowingWrapper: aHollowingWrapper

	"Handle the request from @aHollowingWrapper"! !

!VRMLTransformAnimationBuilder methodsFor: 'dispatching-wrappers ( IWrapper3DVisitor )' stamp: 'emm 02/09/2012 23:54'!
doRotating3DWrapper: aRotating3DWrapper

	"Handle the request from @aRotating3DWrapper"! !

!VRMLTransformAnimationBuilder methodsFor: 'dispatching-wrappers ( IWrapper3DVisitor )' stamp: 'emm 02/09/2012 23:54'!
doScaling3DWrapper: aScaling3DWrapper

	"Handle the request from @aScaling3DWrapper"

	| interpolator |
	self sceneBuilder add: ( interpolator := ( self sceneBuilder newScalarInterpolator )
		key: ( 0 to: 1 steps: self steps )
		;keyValue: ( aScaling3DWrapper scale to: targetWrapper scale steps: self steps )
	)
	self sceneBuilder
		whenFractionChanging: self timeSensor 
		send: #scale
		to: 1
		using: interpolator! !

!VRMLTransformAnimationBuilder methodsFor: 'dispatching-wrappers ( IWrapper3DVisitor )' stamp: 'emm 02/09/2012 23:54'!
doTranslating3DWrapper: aTranslating3DWrapper 
	
	"Handle the request from @aTranslating3DWrapper"
	
	| interpolator |
	self sceneBuilder add: ( interpolator := ( self sceneBuilder 
		newPositionInterpolatorFrom: ( aTranslating3DWrapper translation 
		to: targetWrapper translation 
		steps: self steps ) ) ).
	self sceneBuilder! !

!VRMLTransformAnimationBuilder methodsFor: 'initialize-release' stamp: 'emm 02/09/2012 23:54'!
initialize

	steps := 10.! !

!VRMLTransformAnimationBuilder methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:54'!
sceneBuilder

	"Answer the value of sceneBuilder"

	^sceneBuilder! !

!VRMLTransformAnimationBuilder methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:54'!
sceneBuilder: aValue

	"Set the value of sceneBuilder"

	sceneBuilder := aValue! !

!VRMLTransformAnimationBuilder methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:54'!
steps

	"Answer the value of steps"

	^steps! !

!VRMLTransformAnimationBuilder methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:54'!
steps: aValue

	"Set the value of steps"

	steps := aValue! !

!VRMLTransformAnimationBuilder methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:54'!
timeSensor

	"Answer the value of timeSensor"

	^timeSensor! !

!VRMLTransformAnimationBuilder methodsFor: 'accessing' stamp: 'emm 02/09/2012 23:54'!
timeSensor: aValue

	"Set the value of timeSensor"

	timeSensor := aValue! !

!Symbol class methodsFor: '*Zenna-TaggedData' stamp: 'emm 15/12/2002 14:35'!
readFromTagValueString: aString
	^aString asSymbol! !

!SortedCollection methodsFor: '*Zenna-Extensions' stamp: 'emm 9/22/2012 21:51'!
defaultInsert: newObject atIndex: index
	"
	Pre: no sortblock & sorted
	Pre: @index is answer >>defaultBinarySearchAdding:
	Post @newObject inserted & sorted
	"
	1 halt! !

!Color class methodsFor: '*Zenna-Extensions' stamp: 'emm 9/28/2012 00:09'!
darkgreen
	^self redByte: 0 greenByte: 16r64 blueByte: 0
	! !

!Color class methodsFor: '*Zenna-Extensions' stamp: 'emm 9/23/2012 22:57'!
grey: percentage
	"0 <= percentage <= 100"

	| byte |
	byte := (percentage / 100 * 255) rounded.
	^self redByte: byte  greenByte: byte  blueByte: byte ! !

!Color class methodsFor: '*Zenna-Extensions' stamp: 'emm 9/23/2012 22:56'!
modulo16At: aSmallInteger 
	"Rotate through a palette of 16 colors"
	
	#TODO.
	^Color green.! !

!Color class methodsFor: '*Zenna-Extensions' stamp: 'emm 9/28/2012 00:08'!
navy
	^self redByte: 0 greenByte: 0 blueByte: 128
	! !

!Color class methodsFor: '*Zenna-Extensions' stamp: 'emm 9/23/2012 22:59'!
pink
	^self r: 65535 / 65536.0 g:49344 / 65536.0 b:52171 / 65536.0! !

!Color class methodsFor: '*Zenna-Extensions' stamp: 'emm 9/23/2012 22:49'!
purple
	^self redByte: 160 greenByte: 32  blueByte: 240! !

!Color class methodsFor: '*Zenna-Extensions' stamp: 'emm 9/28/2012 00:13'!
red01: redFloat green01: greenFloat blue01: blueFloat 
	^self redByte: (redFloat * 255) rounded greenByte: (greenFloat  * 255) blueByte: (blueFloat  * 255)
	! !

!Color class methodsFor: '*Zenna-Extensions' stamp: 'emm 9/23/2012 22:51'!
redByte: rByte greenByte: gByte  blueByte: bByte
	^self r: rByte / 255.0 g: gByte / 255.0 b: bByte / 255.0! !

!Color methodsFor: '*Zenna-Extensions' stamp: 'emm 9/23/2012 22:23'!
asHTML
	^'#' , self asHexString! !

!Color methodsFor: '*Zenna-Extensions' stamp: 'emm 9/23/2012 22:31'!
asHexString
	| hexStream |
	hexStream := WriteStream on: (String new: 6).
	self redByte printOn: hexStream base: 16 length: 2 padded: true.
	self greenByte printOn: hexStream base: 16 length: 2 padded: true.
	self blueByte printOn: hexStream base: 16 length: 2 padded: true.
	^hexStream contents! !

!Color methodsFor: '*Zenna-Appearance3D' stamp: 'emm 02/09/2012 23:44'!
asPoint3D
	
	^Point3D 
		x: self red01 
		y: self green01 
		z: self blue01! !

!Color methodsFor: '*Zenna-Extensions' stamp: 'emm 9/23/2012 00:06'!
blue01
	^self blue! !

!Color methodsFor: '*Zenna-Extensions' stamp: 'emm 9/23/2012 22:31'!
blueByte
	^(self blue * 255) rounded! !

!Color methodsFor: '*Zenna-Extensions' stamp: 'emm 9/23/2012 00:06'!
green01
	^self green! !

!Color methodsFor: '*Zenna-Extensions' stamp: 'emm 9/23/2012 22:31'!
greenByte
	^(self green * 255) rounded! !

!Color methodsFor: '*Zenna-Extensions' stamp: 'emm 10/18/2012 19:18'!
name
	"TODO match with constant"
	^self asHexString
	! !

!Color methodsFor: '*Zenna-Extensions' stamp: 'emm 9/23/2012 00:05'!
red01
	^self red! !

!Color methodsFor: '*Zenna-Extensions' stamp: 'emm 9/23/2012 22:31'!
redByte
	^(self red * 255) rounded 
	! !

!Color methodsFor: '*Zenna-Extensions' stamp: 'emm 9/23/2012 22:46'!
transparency
	"For colors, the transparency is none so answer 0"
	
	^0! !

!Color methodsFor: '*Zenna-Extensions' stamp: 'emm 9/23/2012 23:00'!
withTransparency: aFloat 
	^TranslucentColor new alpha: aFloat! !
SingleOccurrencePoint3DFilter initialize!
Polyhedron initialize!
DirectXFileReader initialize!
